main.html

Next Page
Mac OS X Leopard: The Missing Manual
Mac OS X Leopard: The Missing Manual
by David Pogue
Publisher: O'Reilly
Pub Date: December 15, 2007
Print ISBN-13: 978-0-59-652952-9
Pages: 912
Table of Contents
| Index
Overview

With Leopard, Apple has unleashed the greatest version of Mac OS X yet, and David Pogue is back with another meticulous Missing Manual to cover the operating system with a wealth of detail. The new Mac OS X 10.5, better known as Leopard, is faster than its predecessors, but nothing's too fast for Pogue and this Missing Manual. It's just one of reasons this is the most popular computer book of all time. Mac OS X: The Missing Manual, Leopard Edition is the authoritative book for Mac users of all technical levels and experience. If you're new to the Mac, this book gives you a crystal-clear, jargon-free introduction to the Dock, the Mac OS X folder structure, and the Mail application. There are also mini-manuals on iLife applications such as iMovie, iDVD, and iPhoto, and a tutorial for Safari, Mac's web browser. This Missing Manual book is amusing and fun to read, but Pogue doesn't take his subject lightly. Which new Leopard features work well and which do not? What should you look for? What should you avoid? Mac OS X: The Missing Manual, Leopard Edition offers an objective and straightforward instruction for using:

  • Leopard's totally revamped Finder

  • Spaces to group your windows and organize your Mac tasks

  • Quick Look to view files before you open them

  • The Time Machine, Leopard's new backup feature

  • Spotlight to search for and find anything in your Mac

  • Front Row, a new way to enjoy music, photos, and videos

  • Enhanced Parental Controls that come with Leopard

  • Quick tips for setting up and configuring your Mac to make it your own

There's something new on practically every page of this new edition, and David Pogue brings his celebrated wit and expertise to every one of them. Mac's brought a new cat to town and Mac OS X: The Missing Manual, Leopard Edition is a great new way to tame it.

Next Page


toc.html

Mac OS X Leopard: The Missing Manual
Mac OS X Leopard: The Missing Manual
by David Pogue
Publisher: O'Reilly
Pub Date: December 15, 2007
Print ISBN-13: 978-0-59-652952-9
Pages: 912
Table of Contents
| Index
Mac OS X Leopard: The Missing Manual
The Missing Credits
Introduction
Part I: The Mac OS X Desktop
Chapter 1. Folders and Windows
Section 1.1. Getting into Mac OS X
Section 1.2. Windows and How to Work Them
Section 1.3. The Four Window Views
Section 1.4. Icon View
Section 1.5. List View
Section 1.6. Column View
Section 1.7. Cover Flow View
Section 1.8. Quick Look
Section 1.9. Logging Out, Shutting Down
Section 1.10. Getting Help in Mac OS X
Chapter 2. Organizing Your Stuff
Section 2.1. The Mac OS X Folder Structure
Section 2.2. Icon Names
Section 2.3. Selecting Icons
Section 2.4. Moving and Copying Icons
Section 2.5. Color Labels
Section 2.6. The Trash
Section 2.7. Get Info
Chapter 3. Spotlight
Section 3.1. The Spotlight Menu
Section 3.2. The Spotlight Window
Section 3.3. Customizing Spotlight
Section 3.4. Smart Folders
Chapter 4. Dock, Desktop, and Toolbars
Section 4.1. The Dock
Section 4.2. Setting Up the Dock
Section 4.3. Using the Dock
Section 4.4. The Finder Toolbar
Section 4.5. Designing Your Desktop
Section 4.6. Menulets: The Missing Manual
Part II: Programs in Mac OS X
Chapter 5. Documents, Programs, and Spaces
Section 5.1. Opening Mac OS X Programs
Section 5.2. The "Heads-Up" Program Switcher
Section 5.3. Exposé: Death to Window Clutter
Section 5.4. Spaces: Your Free Quad-Display Mac
Section 5.5. Hiding Programs the Old-Fashioned Way
Section 5.6. How Documents Know Their Parents
Section 5.7. Keyboard Control
Section 5.8. The Save and Open Dialog Boxes
Section 5.9. Two Kinds of Programs: Cocoa and Carbon
Section 5.10. The Cocoa Difference
Section 5.11. Universal Apps (Intel Macs)
Section 5.12. Installing Mac OS X Programs
Section 5.13. Dashboard
Section 5.14. Web Clips: Make Your Own Widgets
Chapter 6. Time Machine, Syncing, and Moving Data
Section 6.1. Moving Data Between Documents
Section 6.2. Exchanging Data with Other Macs
Section 6.3. Exchanging Data with Windows PCs
Section 6.4. Time Machine
Section 6.5. iSync
Section 6.6. .Mac Sync
Chapter 7. Automator and AppleScript
Section 7.1. Introducing Automator
Section 7.2. Building Your Own Workflow
Section 7.3. Doing More with Automator
Section 7.4. Workflows as Programs and Plug-ins
Section 7.5. Getting Started with AppleScript
Chapter 8. Windows on Macintosh
Section 8.1. Boot Camp
Section 8.2. Windows in a Window
Part III: The Components of Mac OS X
Chapter 9. System Preferences
Section 9.1. The System Preferences Window
Section 9.2. .Mac
Section 9.3. Accounts
Section 9.4. Appearance
Section 9.5. Bluetooth
Section 9.6. CDs & DVDs
Section 9.7. Date & Time
Section 9.8. Desktop & Screen Saver
Section 9.9. Displays
Section 9.10. Dock
Section 9.11. Energy Saver
Section 9.12. Exposé & Spaces
Section 9.13. International
Section 9.14. Keyboard & Mouse
Section 9.15. Network
Section 9.16. Parental Controls
Section 9.17. Print & Fax
Section 9.18. QuickTime
Section 9.19. Security
Section 9.20. Sharing
Section 9.21. Software Update
Section 9.22. Sound
Section 9.23. Speech
Section 9.24. Spotlight
Section 9.25. Startup Disk
Section 9.26. Time Machine
Section 9.27. Universal Access
Chapter 10. The Free Programs
Section 10.1. Your Free Mac OS X Programs
Section 10.2. Address Book
Section 10.3. AppleScript
Section 10.4. Automator
Section 10.5. Calculator
Section 10.6. Chess
Section 10.7. Dashboard
Section 10.8. Dictionary
Section 10.9. DVD Player
Section 10.10. Exposé
Section 10.11. Font Book
Section 10.12. Front Row
Section 10.13. GarageBand
Section 10.14. iCal
Section 10.15. iChat
Section 10.16. iDVD
Section 10.17. Image Capture
Section 10.18. iMovie, iPhoto
Section 10.19. iSync
Section 10.20. iTunes
Section 10.21. Mail
Section 10.22. Photo Booth
Section 10.23. Preview
Section 10.24. QuickTime Player
Section 10.25. Safari
Section 10.26. Stickies
Section 10.27. System Preferences
Section 10.28. TextEdit
Section 10.29. Time Machine
Section 10.30. Utilities: Your Mac OS X Toolbox
Chapter 11. CDs, DVDs, and iTunes
Section 11.1. How the Mac Does Disks
Section 11.2. Burning CDs and DVDs
Section 11.3. iTunes: The Digital Jukebox
Section 11.4. DVD Movies
Part IV: The Technologies of Mac OS X
Chapter 12. Accounts, Parental Controls, and Security
Section 12.1. Introducing Accounts
Section 12.2. Creating an Account
Section 12.3. Parental Controls
Section 12.4. Editing Accounts
Section 12.5. Setting Up the Login Process
Section 12.6. Signing In, Logging Out
Section 12.7. Sharing Across Accounts
Section 12.8. Fast User Switching
Section 12.9. Six Mac OS X Security Shields
Chapter 13. Networking, File Sharing, and Screen Sharing
Section 13.1. Wiring the Network
Section 13.2. File Sharing
Section 13.3. Accessing Shared Files
Section 13.4. Networking with Windows
Section 13.5. Screen Sharing
Section 13.6. More Dialing In from the Road
Chapter 14. Printing, Faxing, Fonts, and Graphics
Section 14.1. Mac Meets Printer
Section 14.2. Making the Printout
Section 14.3. Managing Printouts
Section 14.4. Printer Sharing
Section 14.5. Faxing
Section 14.6. PDF Files
Section 14.7. Fonts—and Font Book
Section 14.8. ColorSync
Section 14.9. Graphics in Mac OS X
Section 14.10. Screen-Capture Keystrokes
Chapter 15. Sound, Movies, and Speech
Section 15.1. Playing Sounds
Section 15.2. Recording Sound
Section 15.3. QuickTime Movies
Section 15.4. Speech Recognition
Section 15.5. The Mac Reads to You
Section 15.6. VoiceOver
Section 15.7. Ink: Handwriting Recognition
Section 15.8. Front Row
Chapter 16. The Unix Crash Course
Section 16.1. Terminal
Section 16.2. Navigating in Unix
Section 16.3. Working with Files and Directories
Section 16.4. Online Help
Section 16.5. Terminal Preferences
Section 16.6. Terminal Tips and Tricks
Section 16.7. Changing Permissions with Terminal
Section 16.8. 20 Useful Unix Utilities
Section 16.9. Putting It Together
Chapter 17. Hacking Mac OS X
Section 17.1. TinkerTool: Customization 101
Section 17.2. Redoing Mac OS X's Graphics
Section 17.3. Replacing the Finder Icons
Section 17.4. Rewriting the Words
Section 17.5. Your Bright Hacking Future
Part V: Mac OS Online
Chapter 18. Internet Setup
Section 18.1. The Best News You've Heard All Day
Section 18.2. Network Central—and Multihoming
Section 18.3. Broadband Connections
Section 18.4. Dial-up Modem Connections
Section 18.5. Switching Locations
Section 18.6. .Mac Services
Section 18.7. Internet Location Files
Chapter 19. Mail and Address Book
Section 19.1. Setting Up Mail
Section 19.2. Checking Your Mail
Section 19.3. Writing Messages
Section 19.4. Stationery
Section 19.5. Reading Email
Section 19.6. The Anti-Spam Toolkit
Section 19.7. RSS Feeds
Section 19.8. Notes
Section 19.9. To Dos
Section 19.10. Address Book
Chapter 20. Safari
Section 20.1. Safari
Section 20.2. RSS: The Missing Manual
Chapter 21. iChat
Section 21.1. Welcome to iChat
Section 21.2. Three Chat Networks
Section 21.3. Signing Up
Section 21.4. The Buddy Lists
Section 21.5. Making a List
Section 21.6. Let the Chat Begin
Section 21.7. Text Chatting
Section 21.8. Audio Chats
Section 21.9. Video Chats
Section 21.10. Sharing Your Screen
Section 21.11. iChat Theater
Section 21.12. iChat Tweaks
Chapter 22. SSH, FTP, VPN, and Web Sharing
Section 22.1. Web Sharing
Section 22.2. FTP
Section 22.3. Connecting from the Road
Section 22.4. Remote Access with SSH
Section 22.5. Virtual Private Networking
Part VI: Appendixes
Appendix A. Installing Mac OS X 10.5
Section A.1. Getting Ready to Install
Section A.2. Four Kinds of Installation
Section A.3. The Basic Installation
Section A.4. The Upgrade Installation
Section A.5. The Clean Install ("Archive and Install")
Section A.6. Erase & Install
Section A.7. The Setup Assistant
Section A.8. Uninstalling Mac OS X 10.5
Appendix B. Troubleshooting
Section B.1. Minor Eccentric Behavior
Section B.2. Frozen Programs (Force Quitting)
Section B.3. Can't Move or Rename an Icon
Section B.4. Application Won't Open
Section B.5. Startup Problems
Section B.6. Fixing the Disk
Section B.7. Where to Get Troubleshooting Help
Appendix C. The Windows-to-Mac Dictionary
Section C.1. About [This Program]
Section C.2. Accessibility Options control panel
Section C.3. Active Desktop
Section C.4. Add Hardware control panel
Section C.5. Add or Remove Programs control panel
Section C.6. All Programs
Section C.7. Alt key
Section C.8. Automatic Update
Section C.9. Backspace key
Section C.10. Battery Level
Section C.11. BIOS
Section C.12. Briefcase
Section C.13. Calculator
Section C.14. Camera and Scanner Wizard
Section C.15. CDs
Section C.16. Character Map
Section C.17. Clean Install
Section C.18. Clipboard
Section C.19. Command line
Section C.20. Control Panel
Section C.21. Copy, Cut, Paste
Section C.22. Ctrl key
Section C.23. Date and Time
Section C.24. Delete Key (Forward Delete)
Section C.25. Desktop
Section C.26. Directories
Section C.27. Disk Defragmenter
Section C.28. Disks
Section C.29. Display control panel
Section C.30. DLL files
Section C.31. DOS prompt
Section C.32. Drivers
Section C.33. End Task dialog box
Section C.34. Exiting programs
Section C.35. Explorer
Section C.36. Favorites
Section C.37. Faxing
Section C.38. File Sharing
Section C.39. Floppy disks
Section C.40. Folder Options
Section C.41. Fonts
Section C.42. Help and Support
Section C.43. Hibernation
Section C.44. Internet Explorer
Section C.45. Internet Options
Section C.46. IRQs
Section C.47. Java
Section C.48. Keyboard control panel
Section C.49. Logging in
Section C.50. Mail control panel
Section C.51. Maximize button
Section C.52. Menus
Section C.53. Minimize button
Section C.54. Mouse control panel
Section C.55. My Computer
Section C.56. My Documents, My Pictures, My Music
Section C.57. My Network Places
Section C.58. Network Neighborhood
Section C.59. Notepad
Section C.60. Personal Web Server
Section C.61. Phone and Modem Options control panel
Section C.62. Power Options
Section C.63. Printer Sharing
Section C.64. Printers and Faxes
Section C.65. PrntScrn key
Section C.66. Program Files folder
Section C.67. Properties dialog box
Section C.68. Recycle Bin
Section C.69. Regional and Language Options control panel
Section C.70. Registry
Section C.71. Run command
Section C.72. Safe Mode
Section C.73. ScanDisk
Section C.74. Scheduled Tasks
Section C.75. Scrap files
Section C.76. Screen saver
Section C.77. Search
Section C.78. Shortcut menus
Section C.79. Shortcuts
Section C.80. Sounds and Audio Devices
Section C.81. Speech control panel
Section C.82. Standby mode
Section C.83. Start menu
Section C.84. StartUp folder
Section C.85. System control panel
Section C.86. System Tray
Section C.87. Taskbar
Section C.88. Taskbar and Start Menu control panel
Section C.89. "Three-fingered salute"
Section C.90. ToolTips
Section C.91. TweakUI
Section C.92. User Accounts control panel
Section C.93. Window edges
Section C.94. Windows (or WINNT) folder
Section C.95. Windows logo key
Section C.96. Windows Media Player
Section C.97. Windows Messenger
Section C.98. WordPad
Section C.99. Zip files
Appendix D. Where to Go From Here
Section D.1. Web Sites
Section D.2. Free Email Newsletters
Section D.3. Advanced Books, Programming Books
Appendix E. The Master Mac OS X Secret Keystroke List
Colophon
Index


mac_os_x_leopard_the_missing_manual.html

Mac OS X Leopard: The Missing Manual

by David Pogue

Copyright © 2007 David Pogue. All rights reserved.

Printed in the United States of America.

Published by O'Reilly Media, Inc.,

1005 Gravenstein Highway North, Sebastopol, CA 95472.

O'Reilly Media books may be purchased for educational, business, or sales promotional use. Online editions are also available for most titles: safari@oreilly.com. For more information, contact our corporate/institutional sales department: 800-998-9938 or corporate@oreilly.com.

December 2007: | First Edition.
January 2008: | Second Printing.

The Missing Manual is a registered trademark of O'Reilly Media, Inc. The Missing Manual logo, and "The book that should have been in the box" are trademarks of O'Reilly Media, Inc. Many of the designations used by manufacturers and sellers to distinguish their products are claimed as trademarks. Where those designations appear in this book, and O'Reilly Media is aware of a trademark claim, the designations are capitalized.

While every precaution has been taken in the preparation of this book, the publisher assumes no responsibility for errors or omissions, or for damages resulting from the use of the information contained in it.

ISBN-10: 0-596-52952-X

ISBN-13: 978-0-596-52952-9


the_missing_credits.html

The Missing Credits

P2.1. About the Author

David Pogue is the weekly tech columnist for the New York Times, an Emmy-winning correspondent for CBS News Sunday Morning, the 2006 winner of the Online News Association's award for commentary, and the creator of the Missing Manual series. He's the author or co-author of 45 books, including 20 in this series and six in the "For Dummies" line (includingMacs, Magic, Opera, and Classical Music). In his other life, David is a former Broadway show conductor, a magician, and a pianist. News, photos, links to his columns, blog, and weekly videos await at www.davidpogue.com.

He welcomes feedback about his books by email at david@pogueman.com. (If you're seeking technical help, however, please refer to the sources in Appendix D.)

P2.2. About the Creative Team

J.D.Biersdorfer(updater of Chapters Chapter 19, Section 10.25, and Section 7.5.1.8) wrote iPod: The Missing Manual and co-wrote The Internet: The Missing Manual and Google: The Missing Manual, 2nd Edition. She has written the weekly computer Q&A column for The New York Times since 1998. Her work has appeared in Rolling Stone, The New York Times Book Review, and the AIGA Journal of Graphic Design, and she often writes about the collision of technology and popular culture. She lives in New York City and is equally obsessed with the BBC and the banjo. E-mail: jd.biersdorfer@gmail.com.

Dennis Cohen (technical reviewer) has served as the technical editor for many bestselling Mac and Photoshop books, including several editions of Macworld Mac Secrets and many Missing Manual titles. He is the author or co-author of The Xcode 2 Book, FileMaker Pro 9 Bible, and numerous other books. Email: drcohen@mac.com.

Adam Goldstein(original author of Chapter 7) is the founder of GoldfishSoft, a Macintosh software company specializing in games and utilities. He is the author of AppleScript: The Missing Manual, and has contributed to several other Missing Manual titles as well. In his spare time, Adam attends M.I.T. Email: mail@goldfishsoft.com. Web site: www.goldfishsoft.com.

Brian Jepson (technical consultant) is Executive Editor for Make Magazine's Make:Books series. He co-wrote Mac OS X Tiger for Unix Geeks, and has written or edited a number of other tech books. He's also a volunteer system administrator and all-around geek for AS220, a non-profit arts center that gives Rhode Island artists uncensored and unjuried forums for their work. Email: bjepson@oreilly.com.

Dan Pourhadi (updater of Chapter 7) is a professional wannabe-author whose writings have mysteriously appeared in a number of publications, including MacAddict and MacDirectory magazines, TidBITS, TUAW, and others. He blogs for MacUser.com, and writes for anyone crazy enough to publish his stuff. Web site: www.pourhadi.com.

Teresa Noelle Roberts (copy editor, proofreading coordinator) is a freelance copy editor and proofreader, as well as a published fiction writer and poet. When she can tear herself away from the computer, she may be found gardening, belly dancing, or enjoying the beautiful beaches of New England.

Phil Simpson (design and layout) works out of his office in Southbury, Connecticut, where he has had his graphic design business since 1982. He is experienced in many facets of graphic design, including corporate identity/branding, publication design, and corporate and medical communications. Email: pmsimpson@earthlink.net.

Lesa Snider King(graphics and index production) is on a mission to teach the world to create—and use!—better graphics. She's a stock photographer and chief evangelist for iStockphoto.com, founder of the creative tutorial site GraphicReporter.com, and author of "Graphic Secrets for Business Professionals" (2007, Lynda.com). She writes for the NAPP,Macworld and Layers magazines, and teaches yearly at Photoshop World and Macworld Expo. Lesa co-hosts the YourMacLifeShow.com radio show and hosts her own podcast, "Graphic Secrets." Web site: www.GraphicReporter.com.

Chris Stone (Chapter 16) is a senior systems administrator at O'Reilly Media and coauthor of Mac OS X Tiger in a Nutshell, published by O'Reilly. A San Francisco native, he got his English degree from Humboldt State University and spent ten years hidden away in the Japanese countryside before returning to the North Bay area, where he lives with his wife Miho and sons Andrew and Jonathan.

Zachary Brass (teenage screenshot machine) started out as David Pogue's summer intern, and wound up working with him on many videos and columns for the New York Times. He's the founder of iPod Rehab, an iPod repair business. He lives in Connecticut with his mother, brother, and two amazing cats. E-mail:ZHBrass@gmail.com.

P2.3. Acknowledgments

Man was this book a lot of work. Apple just could not leave well enough alone. It had to go in there and rejigger, reword, or shuffle around every last feature. For that reason, I relied upon more hand-picked editors, expert contributors, and "beta readers" for this edition than ever before. Each collaborator contributed fantastic amounts of new insight, corrections, and suggestions—and they've made this book, in my opinion, the best edition yet.

In addition to the dream members identified above, these guardian angels included Lynn Fox, Shawn King, Rory Gillespie, Nan Barber, Bill Briggs, O'Reilly's Matt Silver, Adobe's Denise Styerwalt and Whitney McCleary, and proofreaders Sohaila Abdulali, Kate Briggs, John Cacciatore, Genevieve d'Entremont, Lorne Lehrer, Sada Preisch, Ellen Keyne Seebacher, and Teresa Noelle Roberts.

Apple's Ken Bereskin heroically answered my floods of tweaky question, usually within nanoseconds. And thanks, as always, to David Rogelberg for believing in the idea.

Above all, this book owes its existence to the patience and affection of Jennifer, Kelly, Tia, and Jeffrey. They make these books—and everything else—possible.

—David Pogue

P2.4. The Missing Manual Series

Missing Manuals are witty, superbly written guides to computer products that don't come with printed manuals (which is just about all of them). Each book features a handcrafted index; cross-references to specific page numbers (not just "see Chapter 14"); and an ironclad promise never to put an apostrophe in the possessive word its.

Here's a list of current and upcoming titles.

P2.4.1. For Macintosh:

  • iMovie '08 & iDVD: The Missing Manual by David Pogue

  • iPhoto '08: The Missing Manual by David Pogue and Derrick Story

  • Switching to the Mac: The Missing Manual, Leopard Edition by David Pogue

  • iPhone: The Missing Manual by David Pogue

  • AppleScript: The Missing Manual by Adam Goldstein

  • iMovie 6 & iDVD: The Missing Manual by David Pogue

  • iPhoto 6: The Missing Manualby David Pogue and Derrick Story

  • iPod: The Missing Manual, 6th Edition by J.D. Biersdorfer

  • AppleWorks 6: The Missing Manual by Jim Elferdink and David Reynolds

  • GarageBand 2: The Missing Manual by David Pogue

  • iLife '05: The Missing Manual by David Pogue

  • iWork '05: The Missing Manual by Jim Elferdink

  • Office 2008 for Macintosh: The Missing Manual by Jim Elferdink et al.

  • FileMaker Pro 9: The Missing Manual by Geoff Coffey and Susan Prosser

  • CSS: The Missing Manual by David Sawyer McFarland

  • Creating Web Sites: The Missing Manual by Matthew MacDonald

  • Digital Photography: The Missing Manual by Chris Grover, Barbara Brundage

  • The Internet: The Missing Manual by David Pogue and J.D. Biersdorfer

  • Dreamweaver CS3: The Missing Manual by David Sawyer McFarland

  • Flash CS3: The Missing Manual by E. A. Vander Veer and Chris Grover

  • eBay: The Missing Manual by Nancy Conner

  • Wikipedia: The Missing Manual by John Broughton

  • Google: The Missing Manual, 2nd Edition by Sarah Milstein and Rael Dornfest

  • Home Networking: The Missing Manual by Scott Lowe

P2.4.2. For Windows:

  • Windows Vista: The Missing Manual, by David Pogue

  • FrontPage 2003: The Missing Manual by Jessica Mantaro

  • Office 2007: The Missing Manual by Chris Grover, Matthew MacDonald, and E. A. Vander Veer

  • Word 2007: The Missing Manual by Chris Grover

  • Excel 2007: The Missing Manual by Matthew MacDonald

  • PowerPoint 2007: The Missing Manual by Emily A. Vander Veer

  • Access 2007: The Missing Manual by Matthew MacDonald

  • Microsoft Project 2007: The Missing Manual by Bonnie Biafore

  • PCs: The Missing Manual by Andy Rathbone

  • Photoshop Elements 6: The Missing Manual by Barbara Brundage

  • QuickBooks 2008: The Missing Manual by Bonnie Biafore

  • QuickBase: The Missing Manual by Nancy Conner

  • Windows XP Home Edition: The Missing Manual, 2nd Edition by David Pogue

  • Windows XP Pro: The Missing Manual, 2nd Edition by David Pogue, Craig Zacker, and L.J. Zacker

  • Windows XP Power Hound by Preston Gralla

P2.5. For Starters

The "For Starters" books contain only the most essential information from their larger counterparts—in larger type, with a more spacious layout, and none of those advanced sidebars. Recent titles include:

  • Windows Vista for Starters: The Missing Manual by David Pogue

  • Windows XP for Starters: The Missing Manual by David Pogue

  • Access 2007 for Starters: The Missing Manual by Matthew MacDonald

  • Excel 2007 for Starters: The Missing Manual by Matthew MacDonald

  • Quicken 2006 for Starters: The Missing Manual by Bonnie Biafore

  • Word 2007 for Starters: The Missing Manual by Chris Grover

  • PowerPoint 2007 for Starters: The Missing Manual by Emily A. Vander Veer


introduction.html

Introduction

Without a doubt, Mac OS X is a stunning technical achievement. In fact, many tech reviewers and experts call it the best personal-computer operating system on earth. But beware its name.

The X is meant to be a Roman numeral, pronounced "ten." Don't say "oh ess sex." You'll get funny looks in public.

In any case, Mac OS X Leopard is the sixth major version of Apple' s Unix-based operating system. It is not, however, the Mac operating system that saw Apple through the 1980s and 1990s, the one that was finally retired when it was called Mac OS 9. Apple dumped that one in 2001; in Leopard, even fewer traces of it remain.

Why did Apple throw out the operating system that made it famous to begin with? Well, through the years, as Apple piled new features onto a software foundation originally poured in 1984, the original foundation was beginning to creak. Programmers and customers complained of the "spaghetti code" that the Mac OS had become.

Apple CEO Steve Jobs, of course, believes in swift, decisive action and letting the chips fall where they may. In his view, starting from scratch—and jettisoning the system software the world had come to know—was the only way to go.

P3.1. What's New in Leopard

Mac OS X 10.5, affectionately known as Leopard, only builds on the successes of previous Mac OS X versions. You still don't have to worry about viruses, spyware, or service pack releases that take up a Saturday afternoon to install and fine-tune. And you'll still enjoy stability that would make the you of 1999 positively drool; your Mac may go for months or years without a system crash.

That's because underneath the gorgeous, translucent desktop of Mac OS X is Unix, the industrial-strength, rock-solid OS that drives many a Web site and university. It's not new by any means; in fact, it's decades old, and has been polished by generations of programmers. That's the very reason Steve Jobs and his team chose it as the basis for the NeXT operating system (which Jobs worked on during his twelve years away from Apple), which Apple bought in 1997 to turn into Mac OS X.

So what is new in Leopard? Apple says it added over 300 new features; there's even a Web page that lists them. They are not, however, all equally breathtaking; Apple counts among them a new Braille font, a Russian spelling checker, and a Word of the Day screen saver.

Apple also took some things away, rejiggered others, and generally fine-tuned the whole affair. For example:

  • Time Machine is a real breakthrough. It's not a feature that fills a need we never knew we had; it fills a need we know we have. It keeps your entire Mac backed up, 24 hours a day. Everything: files, folders, settings, photos, email, programs, even Mac OS X itself. It's completely, totally automatic. Chapter 6 has the details.

  • Quick Look lets you tap the Space bar to view a highlighted document at full size, right at the desktop, without having to open the program that created it. You'll use it several times a day, and you'll love it.

  • Spaces gives you two, four, eight, or 16 full-size virtual monitors. You can park the windows of a different program, activity or project on each one—email and chat on Screen 1, Web browser on Screen 2—and switch between all these "external monitors" with a keystroke or a menu choice.

  • The enhanced Parental Controls let you set time limits for your children's computer use (different for weekdays and weekends), and even make the Mac lock itself at bedtime. A log tracks their activities, including what email they send and what Web sites they visit.

    FREQUENTLY ASKED QUESTION
    All About "Leopard"

    What's this business about Leopard?

    Most software companies develop their wares in secret, using code names for new products to throw outsiders off the scent. Apple's code names for Mac OS X and its descendants have been named after big cats: Mac OS X was Cheetah, 10.1 was Puma, 10.2 was Jaguar, 10.3 was Panther, and 10.4 was Tiger. So 10.5 is called Leopard.

    Usually, the code name is dropped as soon as the product is complete, whereupon the marketing department gives it a new name. In Mac OS X's case, though, Apple thinks that its cat names are cool enough to retain for the finished product.

    You do have to wonder what Apple plans to call future versions. Apple increases only the decimal point with each major upgrade, which means it has five big cats to go before it hits Mac OS XI.

    Let's see: Bobcat, Cougar, Lion…um…Ocelot?

  • Screen Sharing, over the network or Internet, lets gurus assist newbies from afar.

  • The iChat text/voice/video chat program has had a huge overhaul. How huge? In this edition of this book, it gets its own chapter now. For example, you can now use a photo or a movie as a backdrop when you're videoconferencing—like a bluescreen effect but without the bluescreen. It also lets you display documents, presentations, or movies to your videoconferenced buddies. And here, too, screen sharing is available, so that you can assist a friend across the globe (or be assisted).

  • The Safari Web browser offers resizable text boxes on Web pages; a handy PDF viewer right in the browser window; a vastly improved Find command; and more flexibility with tabbed windows.

  • Mail now offers To Do lists and Notes (which also appear in the iCal calendar), stationery templates, RSS feeds, and Data Detectors, which find phone numbers, addresses, and dates in your email and offer to put them into your Address Book and calendar.

  • The other Mac OS X programs have all been revamped, too. Humble little Preview can now cut pieces out of one photograph and paste them into another, just like Photoshop. TextEdit has autosave, auto curly quotes, and auto Web links.

Not everything in Leopard is sunshine and dancing bunnies, however. For example:

  • Stacks are arcs or grids of icons that spring out of a Dock folder when you click it, making it easy for you to see what's inside. Unfortunately, only a relatively small number of icons appear; when you click a full folder, you don't get to see everything inside it. And the pop-up hierarchical listings of what's in a Dock folder are gone.

  • The see-through menus are problematic, too. It's hard to read the menu commands when they're superimposed on whatever text is in your open document or Web page.

  • Classic is gone. You can no longer run Mac OS 9 programs in Leopard. You can't restart a G5 or Intel Mac in Mac OS 9, either; so if you want to run one of the old pre–Mac OS X programs, let's hope you have one of the handful of G4 models that are capable of both (a) restarting in Mac OS 9, and (b) running Leopard.

There's a long list of smaller goodies, too. Boot Camp has been polished up, making it easier for you to restart your Mac (if it's an Intel-based model) in Windows. The Dictionary program can now search Wikipedia. A dozen new keyboard shortcuts in the Finder make navigating without the mouse even faster and easier. When you edit an icon's name, the highlighting doesn't extend to the suffix (like .jpg or .doc), so it's much quicker to change just the name. Redesigned panels of System Preferences incorporate the functions of what used to be confusing little add-on programs (like Internet Connect and Printer Setup Utility).

The complete list of changes in Mac OS X 10.5 would fill a book—in fact, you're holding it. But it's safe to say that practically ever nook and cranny has been dusted off, rethought, and—usually—improved.

P3.2. About This Book

By way of a printed guide to Mac OS X, Apple provides only a flimsy "getting started" booklet. To find your way around, you're expected to use Apple's online help system. And as you'll quickly discover, these help pages are tersely written, offer very little technical depth, lack useful examples, and provide no tutorials whatsoever. You can't even mark your place, underline, or read it in the bathroom.

UP TO SPEED
Mac OS X: The Buzzword-Compliant Operating System

You can't read an article about Mac OS X without hearing certain technical buzzwords that were once exclusively the domain of computer engineers. Apple is understandably proud that Mac OS X offers all of these sophisticated, state-of-the-art operating system features. Unfortunately, publicizing them means exposing the rest of us to a lot of fairly unnecessary geek terms. Here's what they mean:

Preemptive multitasking. Most people know that multitasking means "doing more than one thing at once." For years, Macs have been capable of making a printout, downloading a file, and letting you type away in a word processor, all at the same time.

Unfortunately, the Mac OS 7/8/9 (and Windows 95/98/Me) version of multitasking works by the rule of the playground: The bully gets what he wants. If one of your programs insists on hogging the attention of your Mac's processor (because it's crashing, for example), it leaves the other programs gasping for breath. This arrangement is called cooperative multitasking. Clearly, it works only if your programs are in fact cooperating with each other.

Mac OS X's preemptive multitasking system brings a teacher to the playground to make sure that every program gets a fair amount of time from the Mac's processor. The result is that the programs get along much better, and a poorly written or crashing program isn't permitted to send the other ones home crying.

Multithreading. Multithreading means "doing more than one thing at once," too, but in this case it's referring to a single program. Even while iMovie is rendering (processing) a special effect, for example, it lets you continue editing at the same time. Not all Mac OS 9 programs offered this feature, but all programs written especially for Mac OS X do. (Note, however, that programs that are simply adapted for Mac OS X— "Carbonized" software, as described on Section 5.6—don't necessarily offer this feature.)

Symmetrical multiprocessing. Macs containing more than one processor chip are nothing new. But before Mac OS X, only specially written software—Adobe Photoshop filters, for example—benefited from the speed boost.

No more. Mac OS X automatically capitalizes on multiple processors, sharing the workload of multiple programs (or even multithreaded tasks within a single program). That means that every Mac OS X program gets accelerated. Mac OS X is smart enough to dole out processing tasks evenly, so that both (or all) of your processors are being put to productive use.

Dynamic memory allocation. Mac OS X programs don't have fixed RAM allotments. The operating system giveth and taketh away your programs' memory in real time, so that no RAM is wasted. For you, this system means better stability, less hassle.

Memory protection. In Mac OS X, every program runs in its own indestructible memory bubble—another reason Mac OS X is so much more stable than its predecessors. If one program crashes, it isn't allowed to poison the well of RAM that other programs might want to use. Programs may still freeze or quit unexpectedly; the world will never be entirely free of sloppy programmers. But instead of encountering a message that says, "Save open documents and restart," you'll be delighted to find that you can go right on working. You can even open up the program that just died and get back to work.

The purpose of this book, then, is to serve as the manual that should have accompanied Mac OS X—version 10.5 in particular.

Mac OS X: The Missing Manual is designed to accommodate readers at every technical level. The primary discussions are written for advanced-beginner or intermediate Mac fans. But if you're a Mac first-timer, miniature sidebar articles called Up to Speed provide the introductory information you need to understand the topic at hand. If you're a Mac veteran, on the other hand, keep your eye out for similar shaded boxes called Power Users' Clinic. They offer more technical tips, tricks, and shortcuts.

You won't find a single page that hasn't changed since the last edition. Not only are the new Leopard features covered in depth, but the standard Mac features are described here with more tips and tricks, clever uses for old ideas, and greater context born of the passage of time.

There's one more thing you'll notice: This book is even thicker than the last edition. That's a matter of some soul-searching for a computer-book author. Of course, a thinner book, or at least a thinner-looking one, would be preferable; plenty of readers are intimidated by a book that dwarfs the Tokyo White Pages.

On the other hand, Apple keeps adding features, and rarely takes them away. So if this book is to remain true to its goal—serving as the best possible source of information about every aspect of Mac OS X—this book must put on weight.

Even so, some of this book's chapters come with free downloadable appendixes: PDF documents, available on this book's "Missing CD" page at www.missingmanuals.com, that go into further detail on some of the tweakiest features. (You'll see references to them sprinkled throughout the book.)

Maybe this idea will save a few trees—and a few back muscles when you try to pick this book up.

P3.2.1. About the Outline

Mac OS X: The Missing Manual is divided into six parts, each containing several chapters:

  • Part 1, The Mac OS X Desktop, covers everything you see on the screen when you turn on a Mac OS X computer: the Dock, the Sidebar, Spotlight, Dashboard, Spaces, Exposé, Time Machine, icons, windows, menus, scroll bars, the Trash, aliases, the [image] menu, and so on.

  • Part2, Applications in Mac OS X, is dedicated to the proposition that an operating system is little more than a launch pad for programs —the actual applications you use in your everyday work, such as email programs, Web browsers, word processors, graphics suites, and so on. These chapters describe how to work with applications in Mac OS X: how to launch them, switch among them, swap data between them, use them to create and open files, and control them using the AppleScript and Automat or automation tools.

  • Part 3, The Components of Mac OS X, is an item-by-item discussion of the individual software nuggets that make up this operating system—the 26 panels of System Preferences, and the 50 programs in your Applications and Utilities folders.

  • Part 4,The Technologies of Mac OS X, treads in more advanced topics. Networking, file sharing, and screen sharing, are, of course, tasks Mac OS X was born to do. These chapters cover all of the above, plus the prodigious visual talents of Mac OS X (fonts, printing, graphics, handwriting recognition), its multimedia gifts (sound, speech, movies, VoiceOver), and the Unix that lies beneath.

  • Part 5,Mac OS X Online, covers all the special Internet-related features of Mac OS X, including the built-in Mail email program and the Safari Web browser/ RSS reader; iChat for instant-messaging and audio or video chats; Web sharing; Internet sharing; and Apple's online .Mac services (which include email accounts, secure file-backup features, Web hosting, and so on). If you're feeling particularly advanced, you'll also find instructions on using Mac OS X's Unix under pinnings for connecting to, and controlling, your Mac from across the wires—FTP, SSH, VPN, and so on.

    NOSTALGIA CORNER
    What Mac OS X Takes Away

    If you're coming to Mac OS X from Mac OS 9, you don't just have to learn about new features; you also have to unlearn a good deal of what you worked so hard to master in the older system.

    Fortunately, most of the obsolete practices are troubleshooting rituals. For example:

    Extension conflicts. The number one destabilizing factor of the traditional Macintosh has been banished forever: Mac OS X doesn't use system extensions and control panels. You will never again perform an extension conflict test, trying to figure out which extension is making your Mac freeze. None of those habitual routines has any meaning in Mac OS X.

    Memory controls. There's no Memory control panel in Mac OS X. Nor does the Get Info window for Mac OS X programs include a place to change its memory allotment. This is great news.

    Mac OS X manages memory quickly, intelligently, and constantly. The reason you don't allot a certain amount of your Mac's memory to a program, as you had to do in Mac OS 9, is that Mac OS X simply gives each running program as much memory as it needs. And if you undertake some task that requires more memory, Mac OS X instantly gives that program more memory on the fly.

    Rebuilding the desktop. Mac OS X doesn't have the unfortunate habit of holding onto the icons (in its internal database) of programs long since deleted from your hard drive. As are sult, you never have to rebuild the desktop, and you'll never see the symptoms that suggest that it's time for desktop rebuilding (a general slowdown and generic icons replacing the usual custom ones).

    The [image] menu. You'll still find an [image] menu in Mac OS X, but it's no longer a place to store aliases of your favorite files and folders. Instead, it lists commands like Restart and Shut Down, which are relevant no matter what program you're using.

    The Control Strip. This handy floating strip of tiles is gone, too. Its replacement is the set of menulets in the upper-right corner of the screen, on the menu bar. This is now where you make quick control panel settings, like adjusting the volume, checking your laptop battery charge, and so on.

    Finally, some features aren't gone—they've just been moved. Before you panic, consult the downloadable Appendix F (at www.missingmanuals.com) for list of every traditional Mac feature and its status in the new operating system.

At the end of the book, you'll find several appendixes. They include a Windows-to-Mac dictionary (to help Windows refugees find the new locations of familiar features in Mac OS X); guidance in installing this operating system; a troubleshooting handbook; a list of resources for further study; and an extremely thorough master list of all the keyboard shortcuts in Mac OS X Leopard.

P3.2.2. About rightwards double arrow These rightwards double arrow Arrows

Throughout this book, and throughout the Missing Manual series, you'll find sentences like this one: "Open the System folder rightwards double arrow Libraries rightwards double arrow Fonts folder. "That's shorthand for a much longer instruction that directs you to open three nested folders in sequence, like this: "On your hard drive, you'll find a folder called System. Open that. Inside the System folder window is a folder called Libraries; double-click it to open it. Inside that folder is yet another one called Fonts. Double-click to open it, too."

Similarly, this kind of arrow shorthand helps to simplify the business of choosing commands in menus, such as [image] rightwards double arrow Dock rightwards double arrow Position on Left.

P3.2.3. About MissingManuals.com

To get the most out of this book, visit www.missingmanuals.com. Click the "Missing CD-ROM" link—and then this book's title—to reveal a neat, organized, chapter-by chapter list of the shareware and freeware mentioned in this book.

The Web site also offers corrections and updates to the book. (To see them, click the book's title, then click View/Submit Errata.) Infact, please submit such corrections and updates yourself! In an effort to keep the book as up-to-date and accurate as possible, each time we print more copies of this book, we'll make any confirmed corrections you've suggested. We'll also note such changes on the Web site, so that you can mark important corrections into your own copy of the book, if you like. And we'll keep the book current as Apple releases more Mac OS X 10.5 updates.

VERSION ALERT
Version 10.5.1 and Beyond

Only a few weeks after the debut of Mac OS X 10.5, Apple began its traditional flood of system updates. These multimegabyte installers patch holes, fix bugs, improve compatibility with external gadgets, and make the whole system work more smoothly.

Version 10.5.1, for example, delivered a long list of bug fixes in several broad categories, including file sharing over networks, iCal, Mail, Time Machine, AirPort networks, and so on.

It's only a matter of time before Apple descends again to deliver updates called 10.5.2, then 10.5.3, and so on.

You don't have to go out of your way to get these updates:

One day you'll be online with your Mac, and a Software Update dialog box will appear before you, offering you the chance to download and install the patch. Almost always, doing so is a good idea.

As for the differences between the "first decimal point" versions of Mac OS X: You'll find this book useful no matter which version you have, but it describes and illustrates version 10.5 and later.

If you're still working with 10.1 through 10.4, you'll probably feel most comfortable if you seek out the first, second, third, or fourth edition of this book.

Or, better yet, upgrade to Leopard.

P3.3. The Very Basics

To use this book, and indeed to use a Macintosh computer, you need to know a few basics. This book assumes that you're familiar with a few terms and concepts:

  • Clicking. This book gives you three kinds of instructions that require you to use the Mac's mouse. To click means to point the arrow cursor at something on the screen and then—without moving the cursor—press and release the clicker button on the mouse (or your laptop trackpad). To double-click, of course, means to click twice in rapid succession, again without moving the cursor at all. And to drag means to move the cursor while holding down the button.

    When you're told to [image] -click something, you click while pressing the [image] key (which is next to the Space bar). Shift-clicking, Option-clicking, and Control-clicking work the same way—just click while pressing the corresponding key.

  • Menus. The menus. are the words at the top of your screen: , File, Edit, and so on. Click one to make a list of commands appear.

    Some people click and release to open a menu and then, after reading the choices, click again on the one they want. Other people like to press the mouse button continuously after the initial click on the menu title, drag down the list to the desired command, and only then release the mouse button. Either method works fine.

  • Keyboard shortcuts.If you're typing along in a burst of creative energy, it's disruptive to have to grab the mouse to use a menu. That's why many Mac fans prefer to trigger menu commands by pressing certain combinations on the keyboard. For example, in word processors, you can press [image] -B to produce a boldface word. When you read an instruction like "press [image] -B," start by pressing the [image] key, then, while it's down, type the letter B, and finally release both keys.

    Tip: You know what's really nice? The keystroke to open the Preferences dialog box in every Apple program— Mail, Safari, iMovie, iPhoto, TextEdit, Preview, and on and on—is always the same: -comma. Better yet, that standard is catching on with other software companies, too; Word, Excel, Entourage, and PowerPoint use the same keystroke, for example.

  • Icons. The colorful inch-tall pictures that appear in your various desktop folders are the graphic symbols that represent each program, disk, and document on your computer. If you click an icon one time, it darkens, indicating that you've just highlighted or selected it. Now you're ready to manipulate it by using, for example, a menu command.

  • Checkboxes, radio buttons, tabs. See Figure P3-1 for a quick visual reference to the onscreen controls you're most often asked to use.

P3.3.1. Notes on the Keyboard

All through this book, you'll find references to certain keys on Apple's keyboards. "Hold down the [image] key," you might read, or "Press Control-F2." If you' re coming from Mac OS 9, from Windows, or even from a typewriter, you might be a bit befuddled. (The reader email from previous editions of this book make that quite clear. "The alphabet has 26 letters," one went. "Why do I need 101 keys?")

To make any attempt at an explanation even more complicated, Apple's keyboards keep changing. The one you're using right now is probably one of four models:

  • The standard white desktop keyboard, made of plastic.

  • The new, superthin aluminum keyboard that comes with the iMac (Figure P3-2).

  • The new, superthin aluminum wireless Bluetooth keyboard that you can buy as an option. It has no separate block of number keys, so it's almost exactly like the Apple laptop keyboard. In the following discussion, in fact, any references to the Mac laptop keyboards also include this Bluetooth wireless one.

  • The Apple laptop keyboard, which has no numeric keypad, either.

    Figure P3-1. Mastering Mac OS X involves knowing what things are called, especially the kinds of controls you find in dialog boxes.
    Note, by the way, that the dialog-box subdivisions once called tabs are still called tabs, even though they no longer resemble file-folder tabs.

Here, then, is a guided tour of the non-typewriter keys on modern Mac keyboard.

  • Fn. How are you supposed to pronounce Fn? Not "function," certainly; after all, the F-keys on the top row are already known as function keys. And not "fun"; goodness knows, the Fn key isn't particularly hilarious to press.

    What it does, though, is quite clear: It changes the purpose of certain keys. That's a big deal on laptops, which don't have nearly as many keys as desktop keyboards. So for some of the less commonly used functions, you're supposed to press Fn and a regular key. (For example, Fn turns the upwards arrow key into a Home key, which scrolls to the top of a window or a list.)

    You'll find many more Fn examples in the following paragraphs.

    Figure P3-2. The aluminum Mac keyboards turn the F-keys on the top row into completely different buttons—according to a scheme that's different from most Mac laptops.
    Here, you can see that tapping the F1 through F4 keys correspond to Screen Dimmer, Screen Brighter, Exposé, and Dashboard.
    (The Exposé key works three different ways, depending on what modifier key you're pressing. See Section 5.3.1.)

  • Numeric keypad. The number-pad keys do exactly the same thing as the numbers at the top of the keyboard. But with practice, typing things like phone numbers and prices is much faster with the number pad, since you don't have to look down at what you're doing.

    Now, at first glance, only desktop keyboards appear to have these blocks of number keys. But if you look at a Mac laptop closely, you'll see that the numbers 0 through 9 have actually been painted onto a block of letter keys near the right side. (1, 2, and 3 are J, K, and L, for example.)

You can turn those letter keys into their numeric alter egos in either of two ways. First, you can press the NumLock key at the top of the keyboard, which turns on the numbers and keeps them on until you press NumLock again. Or, for just a couple of quick numbers, you can hold down the Fn key with your left hand.

  • , [image],and [image] ). These three buttons control your speaker volume. The [image] key represents the Mute button; tap it once to cut off the sound completely, and again to bring it back to its previous level. Tap the [image] repeatedly to make the sound level lower, the [image] key to make it louder.

    With each tap, you see a big white version of each key's symbol on your screen, your Mac's little nod to let you know that it understands your efforts.

  • . This is the Eject key. When there's a CD or DVD in your Mac, tap this key to make the computer spit it out. If your Mac has a sliding CD/DVD tray (rather than just a slot), hold down this button for about a second to make the tray slide open.

  • Home, End."Home" and "End" mean "jump to the top or bottom of the window." If you're looking at a list of files, the Home and End keys jump to the top or bottom of the list. In iPhoto, they jump to the first or last photo in your collection. In iMovie, the Home key rewinds your movie to the very beginning. In Safari, it's the top or bottom of the Web page.

    (In Word, they jump to the beginning or end of the line. But then again, Microsoft has always had its own ways of doing things.

    On laptops, you get these functions by holding down Fn as you tap the leftwards double arrow and rightwards double arrow keys.

  • Pg Up, Pg Down. These keys scroll up or down by one screenful. The idea is to let you scroll through word processing documents, Web pages, and lists without having to use the mouse.

    On laptops, you get these functions by holding down Fn as you tap the upwards arrow and downwards arrow keys.

  • Clear. Clear gets rid of the you've highlighted, but without putting a copy on the invisible Clipboard, as the Cut command would do.

  • Esc. Esc stands for Escape, and it means "Cancel." It's fantastically useful. It closes dialog boxes, closes menus, and exits special modes like Quick Look, Front Row, slideshows, screen savers, and so on. Get to know it.

  • Delete. The backspace key.

  • . Many a Mac fan goes for years without discovering the handiness of this delightful little key: the Forward Delete key.

    Whereas Delete backspaces over whatever letter is just before the insertion point, this one (labeled Del on some keyboards) deletes whatever is just to the right of the insertion point. It really comes in handy when, for example, you've clicked into some text to make an edit—but wound up planting your cursor in just the wrong place.

    On laptops, you get this function by holding down Fn as you tap the regular Delete key.

  • Return and Enter.In almost all programs, these keys do the same thing: wrap your typing to the next line. When a dialog box is on the screen, tapping the Return or Enter key is the same as clicking the confirmation button (like OK or Done).

  • . This key triggers keyboard shortcuts for menu items, as described above.

  • Control. The Control key triggers shortcut menus, as described above.

  • Option. The Option key (labeled Alt on keyboards in some countries) is sort of a "miscellaneous" key. It's the equivalent of the Alt key in Windows.

    It lets you access secret features—you'll find them described all through this book— and type special symbols. For example, you press Option-4 to get the ¢ symbol, and Option-y to get the ¥ yen symbol.

  • Help. In the Finder, Microsoft programs, and a few other places, this key opens up the electronic help screens. But you guessed that.

  • F1, F2, F3… OK, here's where things start to get really complicated.

    In the beginning, the F1, F2, F3, and F4 keys corresponded to the Undo, Cut, Copy, and Paste menu commands. And on Apple's traditional plastic keyboards, they still do. But Apple discovered that not many people were using them for anything. So today, modern Mac keyboards come with those keys reassigned to other functions.

    On laptops, F1 through F4 govern screen brightness ( [image] and [image]) and speaker volume ( [image], [image], and [image]).

    On the aluminum desktop-Mac keyboards, F1 and F2 govern screen brightness, F3 triggers Exposé (Section 5.3.1), and F4 opens Dashboard (Section 5.13), as shown in Figure P3-2. The [image], [image], and [image] volume keys have been moved to F10 through F12.

    So the question is: What if you don't want to trigger the hardware features of these keys? What if you want pressing F1 to mean "F1" (which opens the Help window in most programs)?

    For that purpose, you're supposed to press the Fn key. The Fn key (lower-right on laptops and Bluetooth keyboards, center block of keys on the big aluminum one) switches the function of the function keys.

    Tip: You can reverse the logic, too, so that pressing the F-keys usually triggers software functions, and governs brightness and audio only when you're pressing Fn. See Section P3.3.1.

    The aluminum keyboards also have playback controls ( [image], [image], and [image] )painted on the F7 through F9 keys. They work in QuickTime Player, DVD Player, iTunes,and other programs's handy to have Rewind, Play / Pause, and Fast Forward buttons.

P3.3.2. Notes on Right-Clicking

Apple isn't too proud to steal good ideas from Microsoft; goodness knows, Microsoft has stolen enough from Apple. So in Leopard, shortcut menus are more important than ever (Figure P3-3).

Figure P3-3. Shortcut menus are more important than ever in Leopard. They bring up useful commands in exactly the spots where they're most useful, in menus that are relevant only to what you're clicking.

For years, you could open the shortcut menu of something on the Mac screen by Control-clicking it—and you can still do that. But experienced computer fans have always preferred the one-handed method: right-clicking. That is, clicking something by pressing the right mouse button on a two-button mouse.

"Ah, but that' s what's always driven me nuts about Apple," goes the common refrain. "Their refusal to get rid of their stupid one-button mouse!"

Well, not so fast.

First of all, you can attach any old $6 USB two-button mouse to the Mac, and it'll work flawlessly.

Furthermore, if you bought a desktop Mac since late 2005, you probably already have a two-button mouse—but you might not realize it. Take a look: Is it a white shiny plastic capsule with tiny, gray, scrolling track-pea on the far end? Then you have a Mighty Mouse, and it has a secret right mouse button. It doesn't work until you ask for it.

To do that, choose [image] rightwards double arrow System Preferences. Click Keyboard & Mouse. Click the Mouse tab. There, in all its splendor, is a diagram of the Mighty Mouse. (There's a picture on Section 9.14.3.)

Your job is to choose Secondary Button from the pop-up menu that identifies the right side of the mouse. (The reason it's not called "right button" is because left-handers might prefer to reverse the right and left functions.)

From now on, even though there aren't two visible mouse buttons, your Mighty Mouse does, in fact, register a left-click or a right-click depending on which side of the mouse you push down. It works a lot more easily than it sounds like it would.

Tip: You can right-click using a Mac laptop's trackpad, too. See Section 9.14.3.2.


the_mac_OS_X_desktop.html

Part I: The Mac OS X Desktop

Chapter 1

Chapter 2

Chapter 3

Chapter 4

Chapter 1. Folders and Windows

Getting into Mac OS X

Windows and How to Work Them

The Four Window Views

Icon View

List View

Column View

Cover Flow View

Quick Look

Logging Out, Shutting Down

Getting Help in Mac OS X

1.1. Getting into Mac OS X

When you first turn on a Mac that's running Mac OS X 10.5, an Apple logo greets you, soon followed by an animated, rotating "Please wait" gear cursor—and then you're in. No progress bar, no red tape.

Figure 1-1. Left: On Macs configured to accommodate different people at different times, this is one of the first things you see upon turning on the computer. Click your name. (If the list is long, you may have to scroll to find your name—or just type the first few letters of it.)
Right: At this point, you're asked to type in your password. Type it, and then click Log In (or press Return or Enter; pressing these keys usually "clicks" any blue, pulsing button in a dialog box). If you've typed the wrong password, the entire dialog box vibrates, in effect shaking its little dialog-box head, suggesting that you guess again. (See Chapter 12.)

1.1.1. Logging In

What happens next depends on whether you're the Mac's sole proprietor or have to share it with other people in an office, school, or household.

  • If it's your own Mac, and you've already been through the Mac OS X setup process described in Appendix A, no big deal. You arrive at the Mac OS X desktop.

  • If it's a shared Mac, you may encounter the Login dialog box, shown in Figure 1-1. Click your name in the list (or type it, if there's no list).

If the Mac asks for your password, type it and then click Log In (or press Return). You arrive at the desktop. Chapter 12 offers much more on this business of user accounts and logging in.

1.1.2. The Elements of the Mac OS X Desktop

Thedesktop is the shimmering, three-dimensional Mac OS X landscape shown in Figure 1-2. On a new Mac, it's covered by a starry galaxy photo that belongs to Leopard's overall outer-space graphic theme.

If you've ever used a computer before, most of the objects on your screen are nothing more than updated versions of familiar elements. Here's a quick tour.

Figure 1-2. The Mac OS X landscape looks like a more futuristic version of the operating systems you know and love. This is just a starting point, however. You can dress it up with a different background picture, adjust your windows in a million ways, and, of course, fill the Dock with only the programs, disks, folders, and files you need.

Note: If your desktop looks even barer than this—no menus, no icons, almost nothing on the Dock—then somebody in charge of your Mac has turned on Simple Finder mode for you. Details on Section 12.3.1.
1.1.2.1. Disk icons

Here they are, just where they've always been: the icons of your hard drive and any other disks attached to your Mac. Double-click to open one, as always.

You may notice that icons in Mac OS X are larger than they were in previous soperating systems. You can make them almost any size you like, but Apple made them bigger for two reasons. First, in this era of monitors with ever larger resolution, the icons on our screens have been getting ever smaller and harder to see.

Second, Apple thinks its Mac OS X icons look really cool.

Note: If you find it disturbing that your desktop is littered by disk icons — and you prefer the setup in Windows, where disks remain safely caged in the My Computer window — Leopard can accommodate you. Choose Finder rightwards double arrow Preferences, click General, and turn off the checkboxes of the disks whose icons you don't want on the desktop: Hard disks, External disks, and so on.From now on, you'll have to look in the Sidebar (Section 1.2) or the Computer window (Go rightwards double arrow Computer) to find those disk icons.
1.1.2.2. The Dock

This row of translucent, almost photographic icons is a launcher for the programs, files, folders, and disks you use often—and an indicator to let you know which programs are already open. In Leopard, they now rest on what appears to be a polished, highly reflective shelf.

In principle, the Dock is very simple:

  • Programs go on the left side. Everything else goes on the right, including documents, folders, and disks. (Figure 1-2 shows the dividing line.)

  • You can add a new icon to the Dock by dragging it there. Rearrange Dock icons by dragging them like tiles on a puzzle. Remove a Dock icon by dragging it away from the Dock, and enjoy the animated puff of smoke that appears when you release the mouse button. (You can't remove the icon of a program that's currently open, however.)

  • Click something once to open it. When you click a program's icon, a tiny, shiny reflective dot appears under its icon to let you know that it's open. (The tiny shiny dot replaces the little black triangle of Mac OS X versions gone by.)

  • When you click a folder's icon, you get a stack—an arcing row of icons, or a grid of them, that indicates what's inside. See Section 4.2.2 for more on stacks.

    Each Dock icon sprouts a pop-up menu. To see the menu, hold the mouse button down on a Dock icon, or Control-click it, or right-click it. A shortcut menu of useful commands pops right out.

Because the Dock is such a critical component of Mac OS X, Apple has decked it out with enough customization controls to keep you busy experimenting for months. You can change its size, move it to the sides of your screen, hide it entirely, and so on. Chapter 4 contains complete instructions for using and understanding the Dock.

1.1.2.3. The menu

The [image] menu houses important Mac-wide commands like Sleep, Restart, and Shut Down. They're always available, no matter which program you're using. (In Leopard, the [image] menu looks like a dark black hole. Evidently, black is the new blue.)

1.1.2.4. The menu bar

Every popular operating system saves space by concealing its most important commands in menus that drop down. Mac OS X's menus are especially refined:

  • They're translucent.You can actually see through an open menu to whatever window is beneath. Translucent menus don't particularly help you; in fact, inLeopard, they're so see-through, they can be hard to read, especially when the document window behind them contains text. Consider them showoff-ware.

  • They stay down. Mac OS X is multithreaded, which means that it's perfectly capable of carrying on with its background activities while you study its open, translucent menus. Therefore, Mac OS X menus stay open until you click the mouse, trigger a command from the keyboard, or buy a new computer, whichever comes first.

Tip: Actually, menus are even smarter than that. If give the menu name a quick click, the menu opens and stays open. If you click and hold the mouse button down for a moment, the menu opens, but closes again when you release the mouse button. Apple figures that, in that case, you're just exploring, reading, or hunting for a certain command.

They're logically rearranged. The first menu in every program, which appears in bold lettering, tells you at a glance what program you're in. The commands in this Application menu include About (which indicates what version of the program you're using), Preferences, Quit, and commands like Hide Others and Show All (which help control window clutter, as described on Section 5.5.2).

In short, all of the Application menu's commands actually pertain to the application you're using.

The File and Edit menus come next. As in the past, the File menu contains commands for opening, saving, and closing files. (See the logic?) The Edit menu contains the Cut, Copy, and Paste commands.

The last menu is almost always Help. It opens a miniature Web browser that lets you search the online Mac Help files for explanatory text (Section 1.9.3).

You can operate them from the keyboard. Once you've clicked open a menu, you can highlight any command in it just by typing the first letter (g for Get Info, for example). (It's especially great for "Your country" pop-up menus on Web sites, where "United States" is about 200 countries down in the list. Now you can type united s to jump right to it.)

You can also press Tab to open the next menu, Shift-Tab to open the previous one, and Enter to "click" the highlighted command.

All that's left is figuring out a way to open the menu from the keyboard to start the process (details on Section 5.6.1.3).

Otherwise, the menu bar looks and works much as it has in operating systems past.


folders_and_windows.html

Part I: The Mac OS X Desktop

Chapter 1

Chapter 2

Chapter 3

Chapter 4

Chapter 1. Folders and Windows

Getting into Mac OS X

Windows and How to Work Them

The Four Window Views

Icon View

List View

Column View

Cover Flow View

Quick Look

Logging Out, Shutting Down

Getting Help in Mac OS X

1.1. Getting into Mac OS X

When you first turn on a Mac that's running Mac OS X 10.5, an Apple logo greets you, soon followed by an animated, rotating "Please wait" gear cursor—and then you're in. No progress bar, no red tape.

Figure 1-1. Left: On Macs configured to accommodate different people at different times, this is one of the first things you see upon turning on the computer. Click your name. (If the list is long, you may have to scroll to find your name—or just type the first few letters of it.)
Right: At this point, you're asked to type in your password. Type it, and then click Log In (or press Return or Enter; pressing these keys usually "clicks" any blue, pulsing button in a dialog box). If you've typed the wrong password, the entire dialog box vibrates, in effect shaking its little dialog-box head, suggesting that you guess again. (See Chapter 12.)

1.1.1. Logging In

What happens next depends on whether you're the Mac's sole proprietor or have to share it with other people in an office, school, or household.

  • If it's your own Mac, and you've already been through the Mac OS X setup process described in Appendix A, no big deal. You arrive at the Mac OS X desktop.

  • If it's a shared Mac, you may encounter the Login dialog box, shown in Figure 1-1. Click your name in the list (or type it, if there's no list).

If the Mac asks for your password, type it and then click Log In (or press Return). You arrive at the desktop. Chapter 12 offers much more on this business of user accounts and logging in.

1.1.2. The Elements of the Mac OS X Desktop

Thedesktop is the shimmering, three-dimensional Mac OS X landscape shown in Figure 1-2. On a new Mac, it's covered by a starry galaxy photo that belongs to Leopard's overall outer-space graphic theme.

If you've ever used a computer before, most of the objects on your screen are nothing more than updated versions of familiar elements. Here's a quick tour.

Figure 1-2. The Mac OS X landscape looks like a more futuristic version of the operating systems you know and love. This is just a starting point, however. You can dress it up with a different background picture, adjust your windows in a million ways, and, of course, fill the Dock with only the programs, disks, folders, and files you need.

Note: If your desktop looks even barer than this—no menus, no icons, almost nothing on the Dock—then somebody in charge of your Mac has turned on Simple Finder mode for you. Details on Section 12.3.1.
1.1.2.1. Disk icons

Here they are, just where they've always been: the icons of your hard drive and any other disks attached to your Mac. Double-click to open one, as always.

You may notice that icons in Mac OS X are larger than they were in previous soperating systems. You can make them almost any size you like, but Apple made them bigger for two reasons. First, in this era of monitors with ever larger resolution, the icons on our screens have been getting ever smaller and harder to see.

Second, Apple thinks its Mac OS X icons look really cool.

Note: If you find it disturbing that your desktop is littered by disk icons — and you prefer the setup in Windows, where disks remain safely caged in the My Computer window — Leopard can accommodate you. Choose Finder rightwards double arrow Preferences, click General, and turn off the checkboxes of the disks whose icons you don't want on the desktop: Hard disks, External disks, and so on.From now on, you'll have to look in the Sidebar (Section 1.2) or the Computer window (Go rightwards double arrow Computer) to find those disk icons.
1.1.2.2. The Dock

This row of translucent, almost photographic icons is a launcher for the programs, files, folders, and disks you use often—and an indicator to let you know which programs are already open. In Leopard, they now rest on what appears to be a polished, highly reflective shelf.

In principle, the Dock is very simple:

  • Programs go on the left side. Everything else goes on the right, including documents, folders, and disks. (Figure 1-2 shows the dividing line.)

  • You can add a new icon to the Dock by dragging it there. Rearrange Dock icons by dragging them like tiles on a puzzle. Remove a Dock icon by dragging it away from the Dock, and enjoy the animated puff of smoke that appears when you release the mouse button. (You can't remove the icon of a program that's currently open, however.)

  • Click something once to open it. When you click a program's icon, a tiny, shiny reflective dot appears under its icon to let you know that it's open. (The tiny shiny dot replaces the little black triangle of Mac OS X versions gone by.)

  • When you click a folder's icon, you get a stack—an arcing row of icons, or a grid of them, that indicates what's inside. See Section 4.2.2 for more on stacks.

    Each Dock icon sprouts a pop-up menu. To see the menu, hold the mouse button down on a Dock icon, or Control-click it, or right-click it. A shortcut menu of useful commands pops right out.

Because the Dock is such a critical component of Mac OS X, Apple has decked it out with enough customization controls to keep you busy experimenting for months. You can change its size, move it to the sides of your screen, hide it entirely, and so on. Chapter 4 contains complete instructions for using and understanding the Dock.

1.1.2.3. The menu

The [image] menu houses important Mac-wide commands like Sleep, Restart, and Shut Down. They're always available, no matter which program you're using. (In Leopard, the [image] menu looks like a dark black hole. Evidently, black is the new blue.)

1.1.2.4. The menu bar

Every popular operating system saves space by concealing its most important commands in menus that drop down. Mac OS X's menus are especially refined:

  • They're translucent.You can actually see through an open menu to whatever window is beneath. Translucent menus don't particularly help you; in fact, inLeopard, they're so see-through, they can be hard to read, especially when the document window behind them contains text. Consider them showoff-ware.

  • They stay down. Mac OS X is multithreaded, which means that it's perfectly capable of carrying on with its background activities while you study its open, translucent menus. Therefore, Mac OS X menus stay open until you click the mouse, trigger a command from the keyboard, or buy a new computer, whichever comes first.

Tip: Actually, menus are even smarter than that. If give the menu name a quick click, the menu opens and stays open. If you click and hold the mouse button down for a moment, the menu opens, but closes again when you release the mouse button. Apple figures that, in that case, you're just exploring, reading, or hunting for a certain command.

They're logically rearranged. The first menu in every program, which appears in bold lettering, tells you at a glance what program you're in. The commands in this Application menu include About (which indicates what version of the program you're using), Preferences, Quit, and commands like Hide Others and Show All (which help control window clutter, as described on Section 5.5.2).

In short, all of the Application menu's commands actually pertain to the application you're using.

The File and Edit menus come next. As in the past, the File menu contains commands for opening, saving, and closing files. (See the logic?) The Edit menu contains the Cut, Copy, and Paste commands.

The last menu is almost always Help. It opens a miniature Web browser that lets you search the online Mac Help files for explanatory text (Section 1.9.3).

You can operate them from the keyboard. Once you've clicked open a menu, you can highlight any command in it just by typing the first letter (g for Get Info, for example). (It's especially great for "Your country" pop-up menus on Web sites, where "United States" is about 200 countries down in the list. Now you can type united s to jump right to it.)

You can also press Tab to open the next menu, Shift-Tab to open the previous one, and Enter to "click" the highlighted command.

All that's left is figuring out a way to open the menu from the keyboard to start the process (details on Section 5.6.1.3).

Otherwise, the menu bar looks and works much as it has in operating systems past.


getting_into_mac_os_x.html

Part I: The Mac OS X Desktop

Chapter 1

Chapter 2

Chapter 3

Chapter 4

Chapter 1. Folders and Windows

Getting into Mac OS X

Windows and How to Work Them

The Four Window Views

Icon View

List View

Column View

Cover Flow View

Quick Look

Logging Out, Shutting Down

Getting Help in Mac OS X

1.1. Getting into Mac OS X

When you first turn on a Mac that's running Mac OS X 10.5, an Apple logo greets you, soon followed by an animated, rotating "Please wait" gear cursor—and then you're in. No progress bar, no red tape.

Figure 1-1. Left: On Macs configured to accommodate different people at different times, this is one of the first things you see upon turning on the computer. Click your name. (If the list is long, you may have to scroll to find your name—or just type the first few letters of it.)
Right: At this point, you're asked to type in your password. Type it, and then click Log In (or press Return or Enter; pressing these keys usually "clicks" any blue, pulsing button in a dialog box). If you've typed the wrong password, the entire dialog box vibrates, in effect shaking its little dialog-box head, suggesting that you guess again. (See Chapter 12.)

1.1.1. Logging In

What happens next depends on whether you're the Mac's sole proprietor or have to share it with other people in an office, school, or household.

  • If it's your own Mac, and you've already been through the Mac OS X setup process described in Appendix A, no big deal. You arrive at the Mac OS X desktop.

  • If it's a shared Mac, you may encounter the Login dialog box, shown in Figure 1-1. Click your name in the list (or type it, if there's no list).

If the Mac asks for your password, type it and then click Log In (or press Return). You arrive at the desktop. Chapter 12 offers much more on this business of user accounts and logging in.

1.1.2. The Elements of the Mac OS X Desktop

Thedesktop is the shimmering, three-dimensional Mac OS X landscape shown in Figure 1-2. On a new Mac, it's covered by a starry galaxy photo that belongs to Leopard's overall outer-space graphic theme.

If you've ever used a computer before, most of the objects on your screen are nothing more than updated versions of familiar elements. Here's a quick tour.

Figure 1-2. The Mac OS X landscape looks like a more futuristic version of the operating systems you know and love. This is just a starting point, however. You can dress it up with a different background picture, adjust your windows in a million ways, and, of course, fill the Dock with only the programs, disks, folders, and files you need.

Note: If your desktop looks even barer than this—no menus, no icons, almost nothing on the Dock—then somebody in charge of your Mac has turned on Simple Finder mode for you. Details on Section 12.3.1.
1.1.2.1. Disk icons

Here they are, just where they've always been: the icons of your hard drive and any other disks attached to your Mac. Double-click to open one, as always.

You may notice that icons in Mac OS X are larger than they were in previous soperating systems. You can make them almost any size you like, but Apple made them bigger for two reasons. First, in this era of monitors with ever larger resolution, the icons on our screens have been getting ever smaller and harder to see.

Second, Apple thinks its Mac OS X icons look really cool.

Note: If you find it disturbing that your desktop is littered by disk icons — and you prefer the setup in Windows, where disks remain safely caged in the My Computer window — Leopard can accommodate you. Choose Finder rightwards double arrow Preferences, click General, and turn off the checkboxes of the disks whose icons you don't want on the desktop: Hard disks, External disks, and so on.From now on, you'll have to look in the Sidebar (Section 1.2) or the Computer window (Go rightwards double arrow Computer) to find those disk icons.
1.1.2.2. The Dock

This row of translucent, almost photographic icons is a launcher for the programs, files, folders, and disks you use often—and an indicator to let you know which programs are already open. In Leopard, they now rest on what appears to be a polished, highly reflective shelf.

In principle, the Dock is very simple:

  • Programs go on the left side. Everything else goes on the right, including documents, folders, and disks. (Figure 1-2 shows the dividing line.)

  • You can add a new icon to the Dock by dragging it there. Rearrange Dock icons by dragging them like tiles on a puzzle. Remove a Dock icon by dragging it away from the Dock, and enjoy the animated puff of smoke that appears when you release the mouse button. (You can't remove the icon of a program that's currently open, however.)

  • Click something once to open it. When you click a program's icon, a tiny, shiny reflective dot appears under its icon to let you know that it's open. (The tiny shiny dot replaces the little black triangle of Mac OS X versions gone by.)

  • When you click a folder's icon, you get a stack—an arcing row of icons, or a grid of them, that indicates what's inside. See Section 4.2.2 for more on stacks.

    Each Dock icon sprouts a pop-up menu. To see the menu, hold the mouse button down on a Dock icon, or Control-click it, or right-click it. A shortcut menu of useful commands pops right out.

Because the Dock is such a critical component of Mac OS X, Apple has decked it out with enough customization controls to keep you busy experimenting for months. You can change its size, move it to the sides of your screen, hide it entirely, and so on. Chapter 4 contains complete instructions for using and understanding the Dock.

1.1.2.3. The menu

The [image] menu houses important Mac-wide commands like Sleep, Restart, and Shut Down. They're always available, no matter which program you're using. (In Leopard, the [image] menu looks like a dark black hole. Evidently, black is the new blue.)

1.1.2.4. The menu bar

Every popular operating system saves space by concealing its most important commands in menus that drop down. Mac OS X's menus are especially refined:

  • They're translucent.You can actually see through an open menu to whatever window is beneath. Translucent menus don't particularly help you; in fact, inLeopard, they're so see-through, they can be hard to read, especially when the document window behind them contains text. Consider them showoff-ware.

  • They stay down. Mac OS X is multithreaded, which means that it's perfectly capable of carrying on with its background activities while you study its open, translucent menus. Therefore, Mac OS X menus stay open until you click the mouse, trigger a command from the keyboard, or buy a new computer, whichever comes first.

Tip: Actually, menus are even smarter than that. If give the menu name a quick click, the menu opens and stays open. If you click and hold the mouse button down for a moment, the menu opens, but closes again when you release the mouse button. Apple figures that, in that case, you're just exploring, reading, or hunting for a certain command.

They're logically rearranged. The first menu in every program, which appears in bold lettering, tells you at a glance what program you're in. The commands in this Application menu include About (which indicates what version of the program you're using), Preferences, Quit, and commands like Hide Others and Show All (which help control window clutter, as described on Section 5.5.2).

In short, all of the Application menu's commands actually pertain to the application you're using.

The File and Edit menus come next. As in the past, the File menu contains commands for opening, saving, and closing files. (See the logic?) The Edit menu contains the Cut, Copy, and Paste commands.

The last menu is almost always Help. It opens a miniature Web browser that lets you search the online Mac Help files for explanatory text (Section 1.9.3).

You can operate them from the keyboard. Once you've clicked open a menu, you can highlight any command in it just by typing the first letter (g for Get Info, for example). (It's especially great for "Your country" pop-up menus on Web sites, where "United States" is about 200 countries down in the list. Now you can type united s to jump right to it.)

You can also press Tab to open the next menu, Shift-Tab to open the previous one, and Enter to "click" the highlighted command.

All that's left is figuring out a way to open the menu from the keyboard to start the process (details on Section 5.6.1.3).

Otherwise, the menu bar looks and works much as it has in operating systems past.


windows_and_how_to_work_them.html

1.2. Windows and How to Work Them

In designing Mac OS X, one of Apple's key goals was to address the window-proliferation problem. As you create more files, stash them in more folders, and launch more programs, it's easy to wind up paralyzed before a screen awash with cluttered, overlapping rectangles.

That's the problem addressed by Exposé, a useful feature that's probably worth at least $34 of Mac OS X's $130 price, and Spaces, which is easily worth another $17.35. They're described in detail on pages Section 5.3 and Section 5.3.2.3.

There are some handy clutter and navigation controls on the windows themselves, too. For example:

1.2.1. The Sidebar

The Sidebar is the pane at the left side of every Finder window, unless you've hidden it (and, by the way, also at the left side of every Open dialog box and full-sized Save dialog box).

The Sidebar has been overhauled in Leopard. Now this list has as many as four different sections, each preceded by a collapsible heading:

  • Devices. This section lists every storage device connected to, or installed inside, your Mac: hard drives, CDs, DVDs, iPods, memory cards, USB flash drives, and so on. The removable ones (CDs, DVDs, iPods, and so on) bear a little gray [image] logo, which you can click to eject that disk.

  • Shared. It took 20 years for an operating system to list all the other computers on the home or small-office network, right there in every window, without any digging, connecting, button-clicking, or window-opening. But here it is: a complete list of the other computers on your network whose owners have turned on File Sharing, ready for access. See Chapter 13 for complete details.

  • Places. This primary section of the sidebar lists places (in this case, folders) where you might look for files and folders. Into this list, you can stick the icons of anything at all—files, programs, folders, disks, or whatever—for easy access.

    Each icon is a shortcut. For example, click the Applications icon to view the contents of your Applications folder in the main part of the window (Figure 1-3). And if you click the icon of a file or program, it opens.

  • Searches. The "folders" in this new Sidebar section are actually canned searches that execute instantly when you click one. If you click Today, for example, the main window fills with all files and folders on your computer that you've changed today. Yesterday and Past Week work the same way.

Figure 1-3. The Sidebar makes navigation very quick, because you can jump back and forth between distant corners of your Mac with a single click.
In column view, the Sidebar is especially handy because it eliminates all of the columns to the left of the one you want, all the way back to your hard-drive level. You've just folded up your desktop!
Good things to put here: favorite programs; disks on the network to which you often connect; a document you're working on every day; and so on.
Folder and disk icons here work just like normal ones. You can drag a document onto a folder icon to file it there, drag a downloaded .sit file onto the StuffIt Expander icon there, and so on. In fact, the disks and folders here are even spring-loaded (Section 2.4.4).

The All Images, All Movies, and All Documents searches round up everything in those file-type categories, no matter what folders they're actually sitting in.

These insta-searches are very useful all by themselves, but what's even better is how easy it is to make your own search folders to put here. Section 3.4 has the details.

1.2.2. Fine-tuning the Sidebar

The beauty of this parking lot for containers is that it's so easy to set up with your favorite places. For example:

  • Remove an icon by dragging it out of the Sidebar entirely. It vanishes with a puff of smoke (and even a little whoof sound effect). You haven't actually removed anything from your Mac; you've just unhitched its alias from the Sidebar.

    Tip: You can't drag Shared items out of the list. Also, if you drag a Devices item out of the list, you'll have to choose Finder rightwards double arrow Preferences to put it back in; see the box on Section 1.2.3.

  • Rearrange the icons by dragging them up or down in the list. (You're not allowed to rearrange the computers listed in the Shared section, though.)

  • Install a new iconby dragging it off your desktop (or out of a window) into any spot in the Places list of the Sidebar. Unlike previous versions of Mac OS X, you can't drag icons into any old section of the sidebar—just the Places place.

    Tip: You can also highlight an icon wherever it happens to be and then choose File rightwards double arrow Add to Sidebar, or just press [image] -T.

  • Adjust the width of the Sidebar by dragging its right edge—either the skinny divider line or the extreme right edge of the vertical scroll bar, if there is one. You "feel" a snap at the point when the line covers up about half of each icon's name. Any covered-up names sprout ellipses (…) to let you know (as in "Secret Salaries Spreadsh…").

    Note: The Leopard Sidebar is a lot less flexible than the old one. For example, you can no longer drag the divider bar so far to the left that it hides the icons' names. It stops just to the left of the end of the longest name.Nor can you hide the Sidebar completely by double-clicking the dividing line, by pressing Control-Option- [image] -T, or by dragging the line all the way to the left. None of those methods work anymore; the only way to hide the Sidebar is to use the Old Finder Mode button.

  • Hide the Sidebar by clicking the Old Finder Mode button, a white, capsule-like button in the upper-right corner of the window, or using its menu equivalent (View rightwards double arrow Hide Toolbar). (See Section 1.2.10 for more on the Old Finder Mode button.)

    Then again, why would you ever want to hide the Sidebar? It's one of the handiest navigation aids since the invention of the steering wheel. For example:

  • It takes a lot of pressure off the Dock. Instead of filling up your Dock with folder icons (all of which are frustratingly alike and unlabeled anyway), use the Sidebar to store them. You leave the Dock that much more room for programs and documents.

  • It's better than the Dock.In some ways, the Sidebar is a lot like the Dock, in that you can stash favorite icons there of any sort. But the Sidebar reveals the names of these icons, and the Dock doesn't.

  • It makes disk-ejecting easy.Just click the [image] button next to any removable disk to make it pop out. After 20 years, the Mac finally beats the "It's illogical to eject a disk by dragging it to the Trash!" problem. (For other ways to eject disks, see Section 11.1.1.3.)

  • It makes disc-burning easy.When you've inserted a blank CD or DVD and loaded it up with stuff you want to copy, click the radioactive-looking Burn button next to its name to begin burning that disc. (Details on burning discs in Chapter 11.)

  • You can drag onto its folders and disks.That is, you can drag icons onto Sidebar icons, exactly as though they were the real disks, folders, and programs that they represent.

  • It simplifies connecting to networked disks. Park your other computers' hard drive icons here, as described in Chapter 12, and you shave several steps off the usual connecting-via-network ritual.

1.2.3. Title Bar

The title bar (Figure 1-4) has several functions. First, when several windows are open, the darkened title bar, window name, mini-icon, and colored left-corner buttons tell you which window is active (in front); in background windows, these elements appear dimmed and colorless. Second, the title bar acts as a handle that lets you move the window around on the screen.

TROUBLESHOOTING MOMENT
Fixing the Sidebar

If you've read the preceding paragraphs and gone on a squealing delete-fest just to see how much damage you could inflict on your Sidebar, it's time for a splash of cold water. Once you drag the Macintosh HD or iDisk icon out of the top of the Sidebar, you can't drag them back in. Suddenly you're stuck with the orphaned horizontal divider, with nothing to divide. The top half of your list is empty.

That's why Apple gives you a quick way to restore the Sidebar to its factory settings.

If you choose Finder rightwards double arrow Preferences, and then click the Sidebar button, you discover the checkboxes shown here. They let you put back the Apple-installed icons that you may have removed in haste. Just turn on a checkbox to restore its icon to your Sidebar. So if something you expect to see in your Sidebar isn't there, check back here.

On the other hand, you may as well streamline your computing life by turning off the checkboxes of icons that younever want to see filling your Sidebar.

appear dimmed and colorless. Second, the title bar acts as a handle that lets you move the window around on the screen.

Of course, you can also move Mac OS X windows by dragging any "shiny gray" edge; see Figure 1-4.

Tip: Here's a nifty keyboard shortcut: You can cycle through the different open windows in one program without using the mouse. Just press [image] -~ (that is, the tilde key, to the left of the number 1 key). With each press, you bring a different window forward within the current program. It works both in the Finder and in your everyday programs, and it beats the pants off using the mouse to choose a name from the Window menu.

Figure 1-4. Mac OS X is no longer made of simulated brushed aluminum. Now it's accented with strips of gradient gray (that is, light-to-dark shading). Any of these gradient gray strips are fair game as handles to drag the window.

After you've opened one folder that's inside another, the title bar's secret folder hierarchy menu is an efficient way to backtrack—to return to the enclosing window. Get in the habit of right-clicking (or Control-clicking, or [image] -clicking) the name of the window to access the menu shown in Figure 1-5. (You can release the Control or [image] key immediately after clicking.)

By choosing the name of a folder from this menu, you open the corresponding window. When browsing the contents of the Users folder, for example, you can return to the main hard drive window by Control-clicking the folder name Users and then choosing Macintosh HD from the menu. (The option to Control- or right-click for this function is new in Leopard.)

Tip: Keyboard lovers, take note. Instead of using this title bar menu, you can also jump to the enclosing window by pressing [image] -up arrow, which is the shortcut for the Go rightwards double arrow Enclosing Folder command.

Figure 1-5. Control-click (or right-click, or -click) a Finder window's title bar to summon the hidden folder hierarchy menu.
This trick also works in most other Mac OS X programs. For example, you can -click a document window's title to find out where the document is actually saved on your hard drive.

Pressing [image] -down arrow takes you back into the folder you started in, assuming that it's still highlighted. (This makes more sense when you try it than when you read it.)

Once you've mastered dragging, you're ready for these three terrific title bar tips:

  • Pressing the [image] key lets you drag the title bar of an inactive window—one that's partly covered by a window in front—without bringing it to the front. (Drag any empty part of the title bar—not the title itself.)

    By the way, you can close, minimize, or zoom a background window without the help of the [image] key. Just click one of those three corresponding title-bar buttons normally. Mac OS X does its thing without taking you out of your current window or program.

    Tip: In previous Mac OS X versions, you could press the [image] key to operate any control—resize boxes, pop-up menus, and even scroll bars—in a background window without bringing it to the front. But no longer; in Leopard, you can't operate those window features when they're in the background, with or without the [image] key.

  • By double-clicking the title bar,you minimize the window, making it collapse into the Dock exactly as though you had clicked the Minimize button (assuming you haven't turned off this feature in System Preferences, of course).

  • The Option key means "Apply this action to all windows in the current program." For example, Option-double-clicking any title bar minimizes all desktop windows, sending them flying to the Dock.

1.2.4. Close Button

As the tip of your cursor crosses the three buttons at the upper-left corner of a window, tiny symbols appear inside them: x, -, and +. Ignore the gossip that these symbols were added to help color-blind people who can't distinguish the colors red, yellow, and green. Color-blind people are perfectly capable of distinguishing the buttons by their positions, just as they do with traffic lights.

POWER USERS' CLINIC
The Go to Folder Command

Sometimes a Unix tentacle pokes through the user-friendly Mac OS X interface. Every now and then, you find a place where you can use Unix shortcuts instead of the mouse.

One classic example is the Go rightwards double arrow Go to Folder command (Shift- [image] -G). It brings up a box like the one shown here.

The purpose of this box is to let you jump directly to a certain folder on your Mac by typing its Unix folder path. Depending on your point of view, this special box is either a shortcut or a detour.

For example you want to see what's in the Documents folder of your Home folder, you could choose Go rightwards double arrow Go to Folder and type this:

/Users/chris/Documents

Then click Go or press Return. (In this example, of course, chris is your short account name.)

In other words, you're telling the Mac to open the Users folder in your main hard drive window, then your Home folder inside that, and then the Documents folder inside that. Each slash means "and then open." (You can leave off the name of your hard drive if your path begins with a slash.) When you press Enter, the folder you specified pops open immediately.

Of course, if you really wanted to jump to your Documents folder, you'd be wasting your time by typing all that. Unix (and therefore Mac OS X) offers a handy shortcut that means "home folder." It's the tilde character (~) at the upper-left corner of your keyboard.

To see what's in your Home folder, then, you could type just that ~ symbol into the Go To Folder box and then press Return. Or you could add some slashes to it to specify a folder inside your Home folder, like this:

~/Documents

You can even jump to someone else's Home folder by typing a name after the symbol, like this:

~chris

If you get into this sort of thing, here's another shortcut worth noting: If you type nothing but a slash (/), and then press Return, you jump immediately to the Computer window, which provides an overview of all your disks.

Note, too, that you don't have to type out the full path—only the part that drills down from the win-dow you're in. If your Home folder window is already open, for example, you can open the Pictures folder just by typing Pictures.

But the Go to Folder trick really turns into a high-octane timesaver if you use auto completion. Here's how it works: After each slash, you can type only enough letters of a folder's name to give Mac OS X the idea—de instead of desktop, for example—and then wait a fraction of a second (or, if you're late for a plane, press the Tab key). Mac OS X instantly and automatically fills in the rest of the folder's name. It even auto-capitalizes the folder names for you. (In Unix, capitalization matters.)

For example, instead of typing /Applications/Microsoft Office/ clipart/standard, you could type nothing more than /ap/mi/ cl/st, remembering to press Tab after each pair of letters. Now that's a way to feel like a Unix programmer.

Instead,these cues appear to distinguish the buttons when all three are identical shades of gray, as they are when you use Graphite mode(page142).They also signal you when it's time to click. For example, as described in the previous section, you can use these three buttons even when the window is not frontmost.You know the buttons are ripe for the clicking when you see the little symbols appear under your cursor.

The most important window gadget is the Close button, the red, droplet-like button in the upper-left corner (Figure 1-6). Clicking it closes the window, which collapses back into the icon from which it came.

Tip: If, while working on a document, you see a tiny dot in the center of the Close button, Mac OS X is trying to tell you that you haven't yet saved your work. The dot goes away when you save the document.

Figure 1-6. When Steve Jobs unveiled Mac OS X at a Macworld Expo in 1999, he said that his goal was to oversee the creation of an interface so attractive, "you just want to lick it." Desktop windows, with their juicy, fruit-flavored controls, are a good starting point.

The universal keyboard equivalent of the Close button is [image] -W (for window)—a keystroke well worth memorizing. If you get into the habit of dismissing windows with that deft flex of your left hand, you'll find it far easier to close several windows in a row, because you don't have to aim for successive Close buttons.

In many programs, something special happens if you're pressing the Option key when using the Close button or its [image] -W equivalent: You close all open windows. This trick is especially useful in the Finder, where a quest for a particular document may have left your screen plastered with open windows for which you have no further use. Option-clicking the Close button of any one window (or pressing Option- rightwards double arrow -W) closes all of them.

On the other hand, the Option-key trick doesn't close all windows in every program—only those in the current program. Option-closing a Pages document closes all Pages windows, but your Finder windows remain open.

Moreover, Option-closing works only in enlightened applications. (In this department, Microsoft is not yet enlightened.)

1.2.5. Minimize Button

Click this yellow drop of gel to minimize any Mac window, sending it shrinking, with a genie-like animated effect, into the right end of the Dock, where it then appears as an icon. The window isn't gone, and it hasn't even closed. It's just out of your way for the moment, as though you've set it down on a shelf. To bring it back, click the newly created Dock icon; see Figure 1-7, as well as Chapter 4 for more on the Dock.

Minimizing a window in this way is a great window-management tool. In the Finder, minimizing a window lets you see whatever icons were hiding behind it. In a word processor, this technique lets you type a memo that requires frequent consultation of a spreadsheet behind it.

Figure 1-7. Clicking the Minimize button sends a window scurrying down to the Dock, collapsing in on itself as though being forced through a tiny, invisible funnel. A tiny icon appears on the lower-right corner of its minimized image to identify the program it's running in.

Tip: If you enjoy the ability to roll up your windows in this way, remember that you actually have a bigger target than the tiny Minimize button. The entire title bar becomes a giant Minimize button when you double-click anywhere on it. (That's an option in the Appearance panel of System Preferences, described in Section 4.5.1.)Better yet, you can also minimize the frontmost window of almost any program (including the Finder) from the keyboard by pressing [image] -M. That's a keystroke worth memorizing on Day One.

The Minimize button harbors a very entertaining hidden feature. If you Option-click it, all windows in the current program shrink away simultaneously—great when you've got several Web browser windows open, for example, or an abundance of word processor documents.

You might expect that Option-clicking one minimized window on the Dock would un-minimize all of a program's windows—and indeed, that's true for Cocoa programs (page185). But if it's a Carbon program, like the Finder, you have to click the windows one at a time on the Dock to bring them back.

Tip: Mac OS X can even change menu commands as you press modifier keys. For example, open a couple of Finder windows and then click the Window menu. Focus your eyes on the Minimize Window command. Now press Option and watch both the wording and the listed keyboard equivalent change instantly to Minimize All (Option- [image] -M).

The Option key works wonders on the File menu, too.

POWER USERS' CLINIC
Adjusting the Genie Speed

Apple has a name for the animation you see when you minimize, open, or close a window: the genie effect, because it so closely resembles the way Barbara Eden, Robin Williams, and other TV and movie genies entered and exited their magic lamps and bottles.

But you don't have to watch the "genie" animation precisely the same way, day in and day out. You can slow it down or speed it up like this:

Slow it down. Whenever Steve Jobs first demo'ed Mac OS X, one of his favorite bits was slowing down the animation so that we could see it in graceful, slow motion. How did he do that?

If you Shift-click a window's Minimize button, it collapses into the Dock at about one-fifth its usual speed—an effect sure to produce gasps from onlookers. The Shift key also slows the un-minimizing animation, the one you see when you click a window icon in the dock to restore it to full size. (Shift-clicking a button to slow down its animation is a running theme in Mac OS X. You'll find it mentioned in several spots in this book.)

Speed it up. There's no keystroke for making the animation go faster. You can, however, substitute a faster style of minimizing animation.

To do so, choose [image] rightwards double arrow Dock rightwards double arrow Dock Preferences. From the "Minimize using" pop-up menu, choose Scale Effect, and then close the window. Now, instead of collapsing through an invisible funnel, minimized windows simply shrink as they fly down to the Dock, remaining rectangular. The time you save isn't exactly going to get you home an hour earlier each day, but at least you have the illusion of greater speed.

(Actually, there's a third animation style, too, but there's a trick to unleashing it; see Section 17.1.)

1.2.6. Zoom Button

A click on this green geltab (see Figure 1-6) makes a desktop window just large enough to reveal all of the icons inside it (or, in application programs, large enough to reveal all the text, or graphics, or music). If your monitor isn't big enough to show all the icons in a window, the zoom box resizes the window to show as many as possible.

In either case, a second click on the Zoom button restores the window to its previous size. (The Window rightwards double arrow Zoom command does the same thing.)

1.2.7. The Folder Proxy Icon

Each Finder-window title bar features a small icon next to the window's name (Figure 1-8), representing the open window's actual folder or disk icon. It's a stand-in—a proxy—for the folder itself.

By dragging this tiny icon, you can move or copy the folder into a different folder or disk, into the Sidebar, into the Trash, or into the Dock without having to first close the window.

Tip: You have to hold down the mouse button on the folder proxy icon until the icon darkens before dragging. (It darkens in a fraction of a second.)

Figure 1-8. When you find yourself confronting a Finder window that contains useful stuff, consider dragging its proxy icon to the Dock. You wind up installing its folder or disk icon there for future use. That's not the same as minimizing the window, which puts the window icon into the Dock, and only temporarily at that. (Note: Most Mac OS X document windows also offer a proxyicon feature, but produce only an alias when you drag the proxy to a different folder or disk.)

When you drag this proxy icon to a different place on the same disk, the usual folder dragging rules apply: Hold down the Option key if you want to copy the original disk

or folder; ignore the Option key to move the original folder. (You'll find details on moving and copying icons in the next chapter.)

1.2.8. The Finder Toolbar

Chapter 4 describes this fascinating desktop-window element in great detail.

1.2.9. Two Clicks, One Window

In Mac OS X, double-clicking a folder in a window doesn't leave you with two open windows. Instead, double-clicking a folder makes the original window disappear (Figure 1-9).

Tip: If you Option-double-click a folder, you don't simply replace the contents of a fixed window that remains onscreen; you actually switch windows, as evidenced by their changing sizes and shapes.

Figure 1-9. To help you avoid window clutter, Apple has designed Mac OS X windows so that double-clicking a folder in a window (top) doesn't actually open another window (bottom). Every time you double-click a folder in an open window (except in column view), its contents replace whatever was previously in the window. If you double-click three folders in succession, you still wind up with just one open window.

So what if you've now opened inner folder B, and you want to backtrack to outer folder A? In that case, just click the tiny [image] button—the Backbutton —in the upper-left corner of the window (shown in Figure 1-9), or use one of these alternatives:

  • Choose Go rightwards double arrow Back.

  • Press [image] -[ (left bracket).

  • Press [image] -up arrow.

  • Choose Go rightwards double arrow Enclosing Folder.

None of that helps you, however, if you want to move a file from one folder into another, or compare the contents of two windows. In that case, you probably want to see both windows open at the same time.

You can open a second window using any of these techniques:

  • Choose File rightwards double arrow New Finder Window ( [image] -N).

    Tip: What folder contents fill the "new" window that appears when you use this command? Usually, it's your Home folder, the folder that contains your entire universe of files, folders, and settings.But you can choose any window you want. To make the change, choose Finder rightwards double arrow Preferences. Click the General icon. Change the "New Finder windows open" pop-up menu to whatever folder you'd like to use as the starting point for your computing life. Your Home folder is a good choice, but you're also free to choose your Documents folder, your iDisk, or any folder at all. Now every new Finder window shows you that specified folder, which is a much more useful arrangement.

  • -double-click a disk or folder icon.

  • Double-click a folder or disk icon on your desktop.

GEM IN THE ROUGH
Multiple Views, Same Folder

If you've read this section carefully, you may have discovered a peculiar quirk of the Mac OS X Finder: By choosing File rightwards double arrow New Finder Window (or [image] -double-clicking a disk or folder icon), you open a second, completely independent Finder window. If you stop to think about it, therefore, there's nothing to stop you from opening a third, fourth, or fifth copy of the same folder window. Once they're open, you can even switch them into different views.

Try this, for example: Choose Go rightwards double arrow Applications. Choose File rightwards double arrow New Finder Window ( [image] -N), and then choose Go rightwards double arrow Applications again. Using the View menu or the controls in the toolbar, put one of these windows into list view, and the other into icon view.

This phenomenon has its advantages. For example, you might decide to open the same window twice while doing some hard drive housekeeping. By keeping a list view open, you can check the Size column as you move your files into different folders (so you can make sure the folders fit onto a blank CD, for example). By keeping a column view open, on the other hand, you gain quicker navigational access to the stuff on your drive.

Choose Finder rightwards double arrow Preferences and turn on "Always open folders in a new window." Now when double-clicked, all folders open in to their own new windows. (This is the option for veteran Mac fans who don't care for the new behavior.)

Switch to Old Finder Mode, described next.

1.2.10. Old Finder Mode: The Toolbar Disclosure Button

The upper-right corner of every Finder window contains a little button that looks like a half-inch squirt of Crest toothpaste. When you click it, you enter Old Finder Mode.

Tip: You can also turn Old Finder Mode on or off by pressing Option- [image] -T, the equivalent for the View rightwards double arrow Hide Toolbar command.

"Old Finder Mode," of course, isn't the technical Apple term, but it should be. It was designed for people who come to Mac OS X from an earlier version of the Mac OS, like Mac OS 9, and lose half their hair when they discover how different things are in Mac OS X.

In this mode, three of the biggest behavioral differences between Mac OS X and its predecessor disappear:

  • The Sidebar and the toolbar blink out of sight.

  • Double-clicking a folder now works like it did back in 2000. Every time you doubleclick a folder, you open a new corresponding window.

  • You can add a Mac OS 9–style information strip at the top of the window, which tells you how many icons are in it ("14 items," for example) and the amount of free space remaining on the disk. Just choose View rightwards double arrow Show Status Bar—a command that's dimmed at all timesexcept when you're in Old Finder Mode.

    (When you're not in Old Finder mode, this information strip appears at the bottom of every Finder window, as shown in Figure 1-6. And the Show Status Bar command is always dimmed.)

1.2.10.1. Leaving Old Finder mode

When you've had enough of Old Finder Mode, you can return to regular Mac OS X mode either by clicking the Toolbar Disclosure button again, by pressing Option- [image] -T again, or by choosing View rightwards double arrow Show Toolbar.

Note: You'll find this little white toolbar-control nubbin in a number of toolbar-endowed programs, including Mail, Preview, and others. Clicking it always makes the toolbar go away.

1.2.11. Scroll Bars

Scroll bars appear automatically in any window that isn't big enough to show all of its contents. Without scroll bars in word processors, for example, you'd never be able to write a letter that's longer than your screen is tall. You can manipulate a scroll bar in three ways, as shown in Figure 1-10.

Mac OSX offers an intriguing scroll bar option called"Jump to here."Ordinarily, when you click in the scroll bar track above or below the gelatinous handle, the window scrolls by one screenful. But your other option is to turn on "Scroll to here" mode in the Appearance panel of System Preferences (Section 9.3). Now when you click in the scroll bar track, the Mac considers the entire scroll bar a proportional map of the document, and jumps precisely to the spot you clicked. That is, if you click at the very bottom of the scroll bar track, you see the very last page.

Figure 1-10. Three ways to control a scroll. The scroll bar arrows (lower right) appear nestled together when you first install Mac OS X, as shown here. If you, an old-time Windows or Mac OS 9 fan, prefer these arrows to appear on opposite ends of the scroll bar, visit the Appearance panel of System Preferences, described on Section 9.3.

Figure 1-11. Position your mouse inside a Finder list-view window. You can scroll up and down by pressing and Option as you drag. As you drag, the cursor changes shape, becoming a white-gloved butler's hand. Where can you get that kind of service these days? (This trick now works in icon views, too, which it didn't in Mac OS X 10.4; it actually lets you scroll diagonally, which is even more useful.)

Tip: No matter which scrolling option you choose in the Appearance panel, you can always override your decision on a case-by-case basis by Option-clicking in the scroll bar track. In other words, if you've selected the "Jump to here" option, you can produce a "Jump to the next page" scroll by Option-clicking in the scroll bar track.

It's worth noting, however, that the true speed expert eschews scroll bars altogether. Your Page Up and Page Down keys let you scroll up and down, one screen at a time, without having to take your hands off the keyboard to grab the mouse. The Home and End keys, meanwhile, are generally useful for jumping directly to the top or bottom of your document (or Finder window). And if you've bought a mouse that has a scroll wheel on the top, you can use it to scroll windows, too, without pressing any keys at all.

And then there's the utterly obscure, but charming, diagonal-scrolling method, newly enhanced in Leopard, which is shown in Figure 1-11.

1.2.12. Resize Handle

The lower-right corner of every standard Mac OS X window is ribbed, a design that's meant to imply that you can grip it by dragging. Doing so lets you resize and reshape the window (Figure 1-6).

1.2.13. Path Bar

This little item, new in Leopard, appears when you choose View rightwards double arrow Show Path Bar. It's a tiny map at the bottom of the window that shows where you are in the folder hierarchy. If it says Casey [image] Pictures [image] Picnic, well, then, by golly, you're looking at the contents of the Picnic folder, which is inside Pictures, inside your Home folder.

Tip: Each of the tiny folder icons in this display is fully operational. You can double-click it to open it, or even drag things into it.

1.2.14. Status Bar

The information strip at the bottom of a window tells you how many icons are in the window ("14 items," for example) and the amount of free space remaining on the disk. (If you miss seeing the status bar at the top of every window—what are you, some kind of radical?—see Section 1.2.10.)

GEM IN THE ROUGH
How Much Is That Doggie in the Window?

The status bar shows you disk-space information for the entire disk, but not how much disk space this particular window's contents occupy.

To find out thatpiece of information, make sure that no icon in the window is highlighted. Then choose File rightwards double arrow Get Info (or press [image] -I). The resulting Info window, which is described in more detail at the end of the next chapter, shows the size of the folder or disk whose window you're browsing, along with other useful statistics.


the_four_window_views.html

1.3. The Four Window Views

You can view the files and folders in a desktop window in any of four ways: as icons; as a single, tidy list; in a series of neat columns; or—new in Leopard—as giant document icons that you flip through like they're CDs in a record-store bin (called Cover Flow view). Figure 1-12 shows the four different views.

Every window remembers its view settings independently. You might prefer to look over your Applications folder in list view (because it's crammed with files and folders), but you may prefer to view the Pictures folder in icon or Cover Flow view, where the larger icons serve as previews of the photos.

Figure 1-12. From the top: The same window in icon view, list view, column, and Cover Flow views. Very full folders are best navigated in list or column views, but you may prefer to view emptier folders in icon or Cover Flow views, because larger icons are easier to preview and click.
Remember that in any view (icon, list, column, or Cover Flow), you can highlight an icon by typing the first few letters of its name. In icon, list, or Cover Flow view, you can also press Tab to highlight the next icon (in alphabetical order), or Shift-Tab to highlight the previous one.

To switch a window from one view to another, just click one of the four corresponding icons in the window's toolbar, as shown in Figure 1-12.

You can also switch views by choosing View rightwards double arrow as Icons (or View rightwards double arrow as Columns, or View rightwards double arrow as List, or View rightwards double arrow as Cover Flow), which can be handy if you've hidden the toolbar. Or, for less mousing and more hardbodied efficiency, press [image] -1, [image] -2, [image] -3, or [image] -4 for icon, list, column, or Cover Flow view, respectively.

The following pages cover each of these views in greater detail.

Note: One common thread in the following discussions is the availability of the View Options palette, which lets you set up the sorting, text size, icon size, and other features of each view, either one window at a time or for all windows.

Apple gives you a million different ways to open View Options. You can choose View rightwards double arrow Show View Options, or press [image] -J, or choose Show View Options from the [image] menu at the top of every window.


icon_view.html

1.4. Icon View

In an icon view, every file, folder, and disk is represented by a small picture—an icon. This humble image, a visual representation of electronic bits and bytes, is the cornerstone of the entire Macintosh religion. (Maybe that's why it's called an icon.)

1.4.1. Icon View Options

Mac OS X offers a number of useful icon-view options, all of which are worth exploring. Start by opening any icon view window, and then choose View rightwards double arrow Show View Options ( [image] -J).

1.4.1.1. Always open in icon view

In Mac OS X Leopard, it's easy—almost scarily easy—to set up your preferred look for all folder windows on your entire system. With one click on the "Use as Defaults" button (described below), you can change the window view of 20,000 folders at once—to icon view, list view, or whatever you like.

The "Always open in icon view" option lets you override that master setting, just for this window.

For example, you might generally prefer a neat list view with large text. But for your Pictures folder, it probably makes more sense to set up icon view, so you can see a thumbnail of each photo without having to open it.

That's the idea here. Open Pictures, change it to icon view, and then turn on "Always open in icon view." Now every folder on your Mac is in list view except Pictures.

Note: The wording of this item in the View Options dialog box changes according to the view you're in at the moment. In a list-view window, for example, it says "Always open in list view." In a Cover Flow–view window, it says "Always open in Cover Flow." And so on. But the function is the same: to override the default (master) setting.
1.4.1.2. Icon size

Mac OS X draws the little pictures that represent your icons using sophisticated graphics software. As a result, you (or the Mac) can scale them to almost any size without losing any quality or clarity.

In the View Options window (Figure 1-13), drag the Icon Size slider back and forth until you find a size you like. (For added fun, make little cartoon sounds with your mouth.)

Figure 1-13. Mac OS X lets you choose an icon size to suit your personality. For picture folders, it can often be very handy to pick a jumbo size, in effect creating a slidesorter "light table" effect. Just use the slider in the View Options dialog box, shown here.

1.4.1.3. Grid spacing

Listen up, you young whippersnappers! When I was your age, back when computers used Mac OS 9, you could control how closely spaced icons were in a window. Why, if I wanted to see a lot of them without making the window bigger, I could pack'em in like sardines!

That feature disappeared—for seven years. But it's finally returned to Mac OS X. Figure 1-14 shows all.

1.4.1.4. Text size

Your choices range only from 10 to 16 points, and you still can't choose a different font for your icons' names. But using this slider, you can adjust the type size. And for people with especially big or especially small screens—or people with aging retinas—this feature is much better than nothing.

Figure 1-14. Drag the "Grid spacing" slider to specify how tightly packed you want your icons to be. At the minimum setting (top), they're so crammed that it's almost ridiculous; you can't even see their names. But sometimes, you don't really need to. At more spacious settings (bottom), you get a lot more "white space."

In fact,you can actually specify a different type size for every window on your machine. (Why would you want to adjust the point size independently in different windows? Well, because you might want smaller type to fit more into a crammed list view without scrolling, while you can afford larger type in less densely populated windows.)

1.4.1.5. Label position

Click either Bottom or Right to indicate where you want an icon's name to appear, relative to its icon.

In its own quiet way, this tiny, unheralded feature represents one of the most radical changes to the Finder since the invention of the Mac. As shown in Figure 1-15, it lets you create, in effect, a multiple-column list view in a single window.

1.4.1.6. Show item info

While you've got the View Options palette open, try turning on "Show item info." Suddenly you get a new line of information (in tiny blue type) for certain icons, saving you the effort of opening up the folder or file to find out what's in it. For example:

  • Folders.The info line lets you know how many icons are inside each without having to open it up. Now you can spot empties at a glance.

  • Graphics files.Certain other kinds of files may show a helpful info line, too. For example, graphics files display their dimensions in pixels.

  • Sounds and QuickTime movies.The light-blue bonus line tells you how long the sound or movie takes to play. For example, an MP3 file might say "03' 08," which means three minutes, eight seconds.

  • .zip files.On compressed archives like .zip files (Section 5.12), you get to see the archive's total size on disk (like "48.9 MB").

You can see some of these effects illustrated in Figure 1-15.

Figure 1-15. The View Options dialog box for an icon view window offers the chance to create colored backgrounds for certain windows or even to use photos as window wallpaper (bottom). Using a photo may have a soothing, annoying, or comic effect—like making the icon names completely unreadable. (Note, by the way, how the icon's names have been set to appear beside the icons, rather than underneath. You now have all the handy, freely draggable convenience of an icon view, along with the more compact spacing of a list view.)

1.4.1.7. Show icon preview

This option pertains primarily to graphics, which Mac OS X often displays only with a generic icon (stamped with the file type, like JPEG, TIFF, or PDF). But if you turn on "Show icon preview," Mac OS X turns each icon into a miniature display of the image itself, as shown in Figure 1-15. It's ideal for working with folders full of digital photos.

Tip: A small but delicious point: You can tell just by looking at a PDF file's icon whether it's longer than one page. The icon for a one-page PDF has a curled upper-right corner. But on a multi-page PDF, only the first page's corner curls down. And in the gap it reveals, you can see a tiny bit of the actual Section P3.1 showing!
1.4.1.8. Arrange by

For a discussion of this pop-up menu, see the next section.

1.4.1.9. Background

Here's another Mac OS X luxury that other operating systems can only dream about: You can fill the background of any icon view window on your Mac with a certain color—or even a photo.

Color-coordinating or "wallpapering" certain windows is more than just a gimmick. In fact, it can serve as a timesaving psychological cue. Once you've gotten used to the fact that your main Documents folder has a sky-blue background, you can pick it out like a sharpshooter from a screen filled with open windows. Color-coded Finder windows are also especially easy to distinguish at a glance when you've minimized them to the Dock.

Note: Background colors and pictures disappear in list, column, and Cover Flow views.

Once a window is open,choose View rightwards double arrow View Options ( [image] -J). The bottom of the resulting dialog box offers three choices, whose results are shown in Figure 1-15.

  • White. This is the standard option (not shown).

  • Color.When you click this button, you see a small rectangular button beside the word Color. Click it to open the Color Picker (Section 5.13), which you can use to choose a new background color for the window. (Unless it's April Fool's Day, pick a light color. If you choose a dark one—like black—you won't be able to make out the lettering of the icons' names.)

  • Picture.If you choose this option, a Select button appears. Click it to open the Select a Picture dialog box, already open to your Library rightwards double arrow Desktop Pictures folder. Now choose a graphics file—one of Apple's in the Desktop Pictures folder, or one of your own. When you click Select, you see that Mac OS X has superimposed the window's icons on the photo. As you can see in Figure 1-15, low-contrast or light-background photos work best for legibility.

    Incidentally,the Mac has no idea what sizes and shapes your window may assume in its lifetime. Therefore, Mac OS X makes no attempt to scale down a selected photo to fit neatly into the window. If you have a high-res digital camera, therefore, you see only the upper-left corner of a photo in the window. Use a graphics program to scale the picture down to something smaller than your screen resolution for better results.

1.4.1.10. Use as Defaults

This harmless-looking button can actually wreak havoc—or restore order to your kingdom—with a single click. It applies the changes you've just made in the View Options dialog box to all windows on your Mac (instead of only the frontmost window).

If you set up the frontmost window with a colored background, big icons, small text, and a tight grid, and then you click Use as Defaults, you'll see that look in every disk or folder window you open.

You've been warned.

Fortunately, there are two auxiliary controls that can give you a break from all the sameness.

First, you can set up individual windows to be weirdo exceptions to the rule; see "Always open in icon view," above.

Second, you can remove any departures from the default window view—after a round of disappointing experimentation on a particular window, for example—using a secret button. To do so, choose View rightwards double arrow Show View Options to open the View Options dialog box. Now hold down the Option key. The Use as Defaults button magically changes to say "Restore to Defaults," which means "Abandon all the changes I've foolishly made to the look of this window."

1.4.2. Keeping Icons Neat and Sorted

In general, you can drag icons anywhere within a window. For example, some people like to keep current project icons at the top of the window and move older stuff to the bottom.

If you'd like Mac OS X to impose a little discipline on you, however, it's easy enough to request a visit from an electronic housekeeper who tidies up your icons by aligning them neatly to an invisible grid. In Leopard, you can even specify how tight or loose that grid is.

1.4.2.1. Grid alignment

Mac OS X offers an enormous number of variations on the "snap icons to the underlying rows-and-columns grid" theme:

  • Aligning individual icons to the grid.Press the [image] key while dragging an icon or several highlighted icons. (Don't press the key until after you begin to drag.) When you release the mouse, the icons you've moved all jump into neatly aligned positions.

  • Aligning all icons to the grid.Choose View rightwards double arrow Clean Up (if nothing is selected) or View rightwards double arrow Clean Up Selection (if some icons are highlighted). Now all icons in the window, or those you've selected, jump to the closest positions on the invisible underlying grid.

These same commands appear in the shortcut menu when you Control-click or right-click anywhere inside an icon-view window, which is handier if you have a huge monitor.

Tip: If you press Option, you swap the wording of the command. Clean Up changes to read Clean Up Selection, and vice versa.

Note, by the way, that the grid alignment is only temporary. As soon as you drag icons around, or add more icons to the window, the newly moved icons wind up just as sloppily positioned as before you tidied up.

If you want the Mac to lock all icons to the closest spot on the grid whenever you move them,choose View rightwards double arrow Show View Options ( [image] -J);from the "Arrange by"pop-up menu, choose Snap to Grid.

Even then, though, you'll soon discover that none of these grid-snapping techniques move icons into the most compact possible arrangement. If one or two icons have wandered off from the herd to a far corner of the window, they're merely nudged to the grid points closest to their current locations. They aren't moved all the way back to the group of icons elsewhere in the window.

To solve that problem, use one of the sorting options described next.

Tip: You can always override the grid setting by pressing the [image] key when you drag. In other words, when grid-snapping is turned off, [image] makes your icons snap into position; when grid-snapping is turned on, [image] lets you drag an icon freely.
1.4.2.2. Sorted alignment

If you'd rather have icons sorted and bunched together on the underlying grid — no strays allowed — make a selection from the View menu:

  • Sorting all icons for the moment.If you choose View rightwards double arrow Arrange By rightwards double arrow Name, all icons in the window snap to the invisible grid and sort themselves alphabetically. Use this method to place the icons as close as possible to each other within the window, rounding up any strays.

    The other subcommands in the View rightwards double arrow Arrange By menu work similarly(Size,Date Modified, Label, and so on), but sort the icons according to different criteria.

    As with the Clean Up command, View rightwards double arrow Arrange By serves only to reorganize the icons in the window at this moment. If you move or add icons to the window, they won't be sorted properly. If you'd rather have all icons remain sorted and clustered, try this:

  • Sorting all icons permanently.You can also tell your Mac to maintain the sorting and alignment of all icons in the window, present and future. Now if you add more icons to the window, they jump into correct alphabetical position; if you remove icons, the remaining ones slide over to fill in the resulting gap. This setup is perfect for neat freaks.

To make it happen, open the View menu, hold down the Option key, and choose fromthe "Keep Arranged By" submenu(choose Name,Date Modified,orwhatever sorting criterion you like). As shown at left in Figure 1-16, your icons are now locked into sorted position, as compactly as the grid permits.

(This Option-key trick, new in Leopard, is a shortcut for choosing View rightwards double arrow Show View Options, and then, in the resulting dialog box, choosing from the "Arrange by" submenu.)

Tip: The Option key is up to its usual tricks here; as happens so often in the Finder, it means, "reverse the usual logic."For example, when you open the View menu, you see either "Arrange By" (which temporarily sorts the current batch of icons) or "Keep Arranged By" (which locks present and future icons into a sorted grid). The wording depends on whether or not you've already turned on permanent sorting.But the point here is that pressing the Option key once the View menu is open changes the command — from "Arrange By" to "Keep Arranged By," or vice versa.

Figure 1-16. Use either the View menu (left) or the View Options dialog box (right) to turn on permanent cleanliness mode. From now on, you're not allowed to drag these icons freely. You've told the Mac to keep them on the invisible grid, sorted the way you requested, so don't get frustrated when you try to drag an icon into a new position and then discover that it won't budge.

Although it doesn't occur to most Mac fans, you can also apply any of the commands described in this section—Clean Up, Arrange, Keep Arranged—to icons lying loose on your desktop. Even though they don't seem to be in any window at all, you can specify small or large icons, automatic alphabetical arrangement, and so on. Just click the desktop before using the View menu or the View Options dialog box.

Note: There's only one View Options dialog box. Once it's open, you can adjust the icon sizes or arrangement options of other windows just by clicking them. Each time you click inside a window, the View Options dialog box remains in front, changing to reflect the settings of the window you just clicked.

Incidentally, you can get rid of the View Options box the same way you summoned it: by pressing [image] -J.


list_view.html

1.5. List View

In windows that contain a lot of icons, the list view is a powerful weapon in the battle against chaos. It shows you a tidy table of your files' names, dates, sizes, and so on. In Leopard, alternating blue and white background stripes help you read across the columns in a list-view window.

You have a great deal of control over your columns, in that you get to decide how wide they should be, which of them should appear, and in what order (except that Name is always the first column). Here's how to master these columns:

1.5.1. Sorting the List

Most of the world's list-view fans like their files listed alphabetically. It's occasionally useful, however, to view the newest files first, largest first, or whatever.

When a desktop window displays its icons in a list view, a convenient new strip of column headings appears (Figure 1-17). These column headings aren't just signposts; they're buttons, too. Click Name for alphabetical order, Date Modified to view newest first, Size to view largest files at the top, and so on.

It's especially important to note the tiny,dark gray triangle that appears in the column you've most recently clicked. It shows you which way the list is being sorted.

When the triangle point supward, the oldest files, smallest files, or files beginning with numbers (or the letter A) appear at the top of the list, depending on which sorting criterion you have selected.

Tip: It may help you to remember that when the smallest portion of the triangle is at the top ( [image]), the smallest files are listed first when viewed in size order.

To reverse the sorting order, click the column heading a second time. Now the newest files, largest files, or files beginning with the letter Z appear at the top the list. The tiny triangle turns upside-down.

1.5.2. Flippy Triangles

One of the Mac's most attractive features is the tiny triangle that appears to the left of a folder's name in a list view. In its official documents, Apple calls these buttons disclosure triangles; internally, the programmers call them flippy triangles.

Either way, these triangles are very useful: When you click one, the list view turns into an outline, which displays the contents of the folder in an indented list, as shown in Figure 1-18. Click the triangle again to collapse the folder listing. You're saved the trouble and clutter of opening a new window just to view the folder's contents.

Figure 1-17. You control the sorting order of a list view by clicking the column headings (top). Click a second time to reverse the sorting order (bottom).
You'll find the identical or triangle—indicating the identical information —in email programs, in iTunes, and anywhere else where reversing the sorting order of the list can be useful.

By selectively clicking flippy triangles, you can, ineffect, peer inside two or morefolders simultaneously, all within a single list view window. You can move files around by dragging them onto the tiny folder icons.

Tip: Once you've expanded a folder by clicking its flippy triangle, you can even drag a file icon out of its folder so that it's loose in the list view window. To do so, drag it directly upward onto the column headings area (where it says Name, for example). When you release the mouse, you see that the file is no longer inside the expanded folder.

1.5.3. Your Choice of Columns

Choose View rightwards double arrow Show View Options. In the dialog box that appears, you're offered on/off checkboxes for the different columns of information Mac OS X can show you, as illustrated in Figure 1-19.

Figure 1-18. Click a "flippy triangle" (left) to see the list of the folders and files inside that folder (right). Or press the equivalent keystrokes: -> (to open) and -< (to close).

UP TO SPEED
Flippy Triangle Keystrokes

The keystrokes that let you open and close flippy triangles in a list view are worth committing to memory.

First, pressing the Option key when you click a flippy triangle lets you view a folder's contents and the contents of any folders inside it. The result, in other words, is a longer list that may involve several levels of indentation.

If you prefer to use the keyboard, substitute the right arrow key (to expand a selected folder's flippy triangle) or left arrow key (to collapse the folder listing again). Here again, adding the Option key expands or collapses all levels of folders within the selected one.

Suppose, for example, that you want to find out how many files are in your Pictures folder. The trouble is, you've organized your graphics files within that folder in several category folders. And you realize that the "how many items" statistic in the status bar shows you how many icons are visible in the window. In other words, you won't know your total photo count until you've expanded all the folders within the Pictures folder.

You could perform the entire routine from the keyboard like this: Get to your Home folder by pressing Shift- [image] -H. Select the Pictures folder by typing the letter P. Open it by pressing [image] -O (the shortcut for File rightwards double arrow Open) or [image] -down arrow. Switch to list view, if necessary, with a quick [image] -2. Highlight the entire contents by pressing [image] -A (short for Edit rightwards double arrow Select All).

Now that all folders are highlighted, press Option-right arrow. You may have to wait a moment for the Mac to open every subfolder of every subfolder. But eventually, the massive list appears, complete with many levels of indentation. At last, the "items" statistic in the status bar gives you a complete, updated tally of how many files and folders, combined, are in the window. up to speed

  • Date Modified. This date-and-time stamp indicates when a document was last saved. Its accuracy, of course, depends on the accuracy of your Mac's built-in clock.

    Note: Many an up-to-date file has been lost because someone spotted a very old date on a folder and assumed that the files inside were equally old. That's because the modification date shown for a folder doesn't reflect the age of its contents. Instead, the date on a folder indicates only when items were last moved into or out of that folder. The actual files inside may be much older, or much more recent.

    Figure 1-19. The checkboxes you turn on in the View Options dialog box determine which columns of information appear in a list view window.
    Most people live full and satisfying lives with only the three default columns—Date Modified, Kind, and Size—turned on. But the other columns can be helpful in special circumstances; the trick is knowing what information appears there.

  • Date Created.This date-and-time stamp shows you when a document was first saved.

  • Size.With a glance, you can tell from this column how much disk space each of your file sand folders is taking up in kilobytes, megabytes, or gigabytes—whichever the Mac thinks you'll find most helpful.

    Tip: For disks and folders, you see only a dash—at first. You can, however, instruct the Mac to reveal their sizes, as described on Section 1.5.5.

  • Kind.In this column, you can read what kind of file each icon represents. You may see, for example, Folder, JPEG Image, Application, and so on.

  • Version.This column displays the version numbers of your programs. For folders and documents, you just see a dash.

  • Comments.This rarely seen column can actually be among the most useful. Suppose that you're a person who uses the Comments feature (highlight an icon, choose File rightwards double arrow Get Info, type notes about that item into the Spotlight Comments box). The option to view the first line of comments about each icon can be very helpful, especially when tracking multiple versions of your documents, as shown in Figure 1-20.

    Figure 1-20. The Comments column is often worth turning on. If your monitor is big enough, you can make the Comments column wide enough to show several paragraphs of text, all in a single line— enough to reveal the full life history of each icon.

  • Label.Labels are colors and identifying phrases that you can slap onto icons, wherever they appear, to help you categorize and group them. For details, see Section 2.5.

Even with this column turned off, you can still see an icon's color, of course. But only by turning on this column do you get to see the text phrase that you've associated with each label.

1.5.4. Other View Options

The View Options for a list view include several other useful settings; choose View rightwards double arrow Show View Options, or press [image] -J.

  • Always open in list view.Turn on this option to override your system-wide preference setting for all windows. See "Always open in icon view" on Section 1.4 for details.

  • Icon size.These two buttons offer you a choice of icon size for the current window: either standard or tiny. Unlike icon view, list view doesn't give you a size slider.

    Fortunately, even the tiny icons aren't so small that they show up blank. You still get a general idea of what they're supposed to look like.

  • Text size.As described on Section 1.4.1.5,you can change the type size for your icon labels, either globally or one window at a time.

  • Show columns.Turn on the columns you'd like to appear in the current window's list view, as described in the previous section.

  • Use relative dates.In a list view, the Date Modified and Date Created columns generally display information in a format like this: "Sunday, March 9, 2008." (As noted below, the Mac uses shorter date formats as the column gets narrower.) But when the "Use relative dates" option is turned on, the Mac substitutes the word "Yesterday" or "Today" where appropriate, making recent files easier to spot.

  • Calculate all sizes. See the box below.

  • Show icon preview. Exactly as in icon view, this option turns the icons of graphics files into miniatures of the photos or images within.

  • Use as Defaults. Click to make your changes in the View Options box apply to all windows on your Mac. (Option-click this button to restore a wayward window back to your defaults.)

FREQUENTLY ASKED QUESTION
Calculate All Sizes

When I sort my list view by size, I see only dashes for folder sizes. What am I doing wrong?

Nothing at all; that's normal. When viewing a Finder window, you see a Size statistic for each file. For folders and disks, however, you're shown only an uninformative dash.

Most Mac fans study this anomaly only momentarily, scratch their chins, and then get back to their work. Former Windows users don't even scratch their chins; Windows PCs never show folder-size or disk-size information in list views.

Here's what's going on: It can take a computer a long time to add up the sizes of all files inside a folder. Your System rightwards double arrow Library folder alone, for example, contains over 1,500 files. Instead of making you wait while the Mac does all of this addition, Mac OS X simply shows you a dash in the Size column for a folder.

On occasion, however, you really do want to see how big your folders are. In such cases, choose View rightwards double arrow Show View Options and turn on "Calculate all sizes." You see the folder sizes slowly begin to pop onto the screen, from the top of the window down, as the Mac crunches the numbers of the files within.

In fact, you can even turn on the "Calculate all sizes" option globally — that is, for all windows. In the Mac operating systems of days gone by, this act would have caused a mas-sive slowdown of the entire computer. But remember that Mac OS X is multithreaded—that is, it has the opposite of a one-track mind. It's perfectly capable of devoting all of its attention to calculating your folder sizes and all of its attention to whatever work you're doing in the foreground.

Now consider this anomaly: Suppose you've opted to sort a particular window by folder size—in other words, you've clicked the word Size at the top of the column. Turning on "Calculate all sizes" bewilders the unprepared, as folders arbitrarily begin leaping out of order, forcing the list to rearrange itself a couple of times per second.

What's happening, of course, is that all folders begin at the bottom of the list, showing only dashes in the Size column. Then, as the Mac computes the size of your folders' contents, they jump into their correct sorted order at what may seem to be random intervals. frequently asked question

1.5.5. Rearranging Columns

You're stuck with the Name column at the far left of a window. However, you can rearrange the other columns just by dragging their gray column headers horizontally.If the Mac thinks you intend to drop a column to, say, the left of the column it overlaps, you'll actually see an animated movement—indicating a column reshuffling—even before you release the mouse button.

1.5.6. Adjusting Column Widths

If you place your cursor carefully on the dividing line between two column headings, you'll find that you can drag the divider line horizontally. Doing so makes the column to the left of your cursor wider or narrower.

What's delightful about this activity is watching Mac OS X scramble to rewrite its information to fit the space you give it. For example, as you make the Date Modified (or Created) column narrower,"Sunday,March 9,2008,2:22 PM"shrinks first to "Sun, Mar 9, 2008, 2:22 PM," then to "3/9/08, 2:22 PM," and finally to a terse "3/9/08."

If you make a column too narrow, Mac OS X shortens the file names, dates, or whatever by removing text from the middle. An ellipsis (…) appears to show you where the missing text would have appeared. (Apple reasoned that truncating the ends of file names, as in some other operating systems, would hide useful information like the number at the end of"Letter to Marge 1,""Letter to Marge 2,"and so on.It would also hide the three-letter extensions, such as Thesis.doc, that may appear on file names in Mac OS X.)

For example, suppose you've named a Word document "Ben Affleck—A Major Force for Humanization and Cure for Depression, Acne, and Migraine Headache." (Yes, file names can really be that long.) If the Name column is too narrow, you might see only "Ben Affleck—A Major…Migraine Headache."

Tip: You don't have to make the column mega-wide just to read the full text of a file whose name has been shortened. Just point to the icon's name without clicking. After a moment, a yellow, floating balloon appears—something like a tooltip in Microsoft programs—to identify the full name.And if you don't feel like waiting, hold down the Option key. As you whip your mouse over truncated file names, their tooltip balloons appear instantaneously. (Both of these tricks work in list, column, or Cover Flow views—and in Save and Open dialog boxes, for that matter.)


column_view.html

1.6. Column View

The goal of column view is simple: to let you burrow down through nested folders without leaving a trail of messy, overlapping windows in your wake.

The solution is shown in Figure 1-21. It's a list view that's divided into several vertical panes. The first pane (not counting the Sidebar) shows whatever disk or folder you first opened.

When you click a disk or folder in this list (once), the second pane shows a list of everything in it. Each time you click a folder in one pane, the pane to its right shows what's inside. The other panes slide to the left, sometimes out of view. (Use the horizontal scroll bar to bring them back.) You can keep clicking until you're actually looking at the file icons inside the most deeply nested folder.

Figure 1-21. If the rightmost folder contains pictures, sounds, Office documents, or movies, you can look at them or play them, right there in the Finder. You can drag this jumbo preview icon anywhere—into another folder or the Trash, for example.

If you discover that your hunt for a particular file has taken you down a blind alley, it's not a big deal to backtrack, since the trail of folders you've followed to get here is still sitting before you on the screen. As soon as you click a different folder in one of the earlier panes, the panes to its right suddenly change, so that you can burrow down a different rabbit hole.

Furthermore, the Sidebar is always at the ready to help you jump to a new track; just click any disk or folder icon there to select a new first-column listing for column view.

The beauty of column view is, first of all, that it keeps your screen tidy. It effectively shows you several simultaneous folder levels, but contains them within a single window. With a quick [image] -W, you can close the entire window, panes and all. Second, column view provides an excellent sense of where you are. Because your trail is visible at all times, it's much harder to get lost—wondering what folder you're in and how you got there—than in any other window view.

Note: In Leopard, for the first time, you can change how Column view is sorted; it doesn't have to be alphabetical. Press [image] -J to open the View Options dialog box, and then choose the sorting criterion you want from the "Arrange by" pop-up menu (like Size, Date Created, or Label).

1.6.1. Column View by Keyboard

Efficiency fans can operate this entire process by keyboard alone. For example:

  • You can jump from one column to the next by pressing the right or leftar row keys.

    Each press highlights the first icon in the next or previous column.

  • You can use any ofthe commands in the Go menu,or their keyboard equivalents,or the icons in the Sidebar, to fill your columns with the contents of the corresponding folder—Home, Favorites, Applications, and so on.

  • The Back command(clicking the [image] button on the toolbar,pressing [image] -[,or choosing Go rightwards double arrow Back) works as it does in a Web browser:It retraces your steps backward.You can repeat this command until you return to the column setup that first appeared when you switched to column view. Once you've gone back, in fact, you can then go forward again; choose Go rightwards double arrow Forward, or press [image] -].

  • With in a highlighted column,press the up or down arrow keys to highlight successive icons in the list. Or type the first couple of letters of an icon's name to jump directly to it.

  • When you finally highlight the icon you've been looking for, press [image] -O or [image] -down arrow to open it (or double-click it,of course).You can open anything in any column; you don't have to wait until you've reached the rightmost column.

1.6.2. Manipulating the Columns

The number of columns you can see without scrolling depends on the width of the window. In no other view are the zoom and resize controls as important as they are here.

That's not to say, however, that you're limited to four columns (or whatever fits on your monitor). You can make the columns wider or narrower—either individually or all at once—to suit the situation, according to this scheme:

To make a single column wider or narrower, drag its right-side handle (circled in Figure 1-22).

NOSTALGIA CORNER
Everything Old Is New Again

To many observers, Mac OS X's column view was one of the most radical new features of the operating system. The truth is, however, that it's not new at all.

In fact, column view's most recent ancestor appeared in the NeXT operating system, which Apple bought (along with Steve Jobs, its CEO) in 1997. But column view is even older than that.

As you can see in this sketch from May 1980, the idea of a single-window, multiple-column view has been kicking around at Apple long before the Macintosh debuted.

In the end, this view was deemed too complex for the original Mac, which finally appeared (with only list and icon views) in 1984. It took 17 more years to find its way into the standard Mac OS.

To make all the columns wider or narrower simultaneously, hold down the Option key as you drag that right-side handle.

And here's the tip of the week: Double-click one of the right-side handles to make the column precisely as wide as necessary to reveal all the names of its contents.

Best of all, you can Option-double-click any column's right-side handle to make all columns just as wide as necessary.

Figure 1-22. What you want to do most of the time is adjust one column. Adding the Option key as you drag the handle lets you adjust all columns at once.

1.6.3. View Options

Just as in icon and list view, you can choose View rightwards double arrow Show View Options to open a dialog box—a Spartan one, in this case—offering additional control over your column views.

  • Always open in column view.Once again,this option lets you override your systemwide preference setting for all windows. See "Always open in icon view" on Section 1.4 for details.

  • Text size.Whatever point size you choose here affects the type used for icons in allcolumn views.

  • Show icons.For maximum speed, turn off this option. Now you see only file names—not the tiny icons next to them—in all column views.

  • Show icon preview. In Leopard, for the first time, you can request that the tiny icons in column view display their actual contents—photos show their images, Word and PDF documents show the first page, and so on. Of course, this feature isn't always terrifically useful, since the icons are the size of a hydrogen atom; but now and then, you can get the general gist of what's in a file just by its overall shape and color.

  • Show preview column.The far-right Preview column can be handy when you're browsing graphics, sounds, or movie files. Feel free to enlarge this final column when you want a better view of the picture or movie; you can make it really big. Almost Quick Look big.

The rest of the time, though, the Preview column can get in the way, slightly slowing down the works and pushing other, more useful columns off to the left side of the window. If you turn off this checkbox, the Preview column doesn't appear.

Tip: No matter what view you're in, remember this if you ever start dragging an icon and then change your mind: Press the Esc key or [image] -period, even while the mouse button is still down. The icon flies back to its precise starting place. (Too bad real life doesn't have a similar feature.)


cover_flow_view.html

1.7. Cover Flow View

The new, fourth view in Leopard is one of Apple's favorites; it's one of the handful of Leopard features that gets the most play in Apple's advertising and demos.

As you can sort of see from Figure 1-23, Cover Flow is a visual display that Apple stole from its own iTunes software, where Cover Flow simulates the flipping "pages" of a jukebox, or the CDs in a record-store bin. There, you can flip through your music collection, marveling as the CD covers flip over in 3-D space while you browse.

Figure 1-23. The bottom half of a Cover Flow window is identical to list view. The top half, however, is an interactive, scrolling "CD bin" full of your own stuff. It's especially useful for photos, PDF files, Office documents, and text documents. And when a movie comes up in this virtual data jukebox, you can point to the little button and click it to play the video, right in place.

The idea is the same in Mac OS X, except that now it's not CD covers you're flipping; it's gigantic file and folder icons.

To fire up Cover Flow, open a window. Then click the Cover Flow button identified in Figure 1-23, or choose View rightwards double arrow as Cover Flow, or press [image] -4.

Now the window splits. On the bottom: a traditional list view, complete with sortable columns, exactly as described above.

On the top: the gleaming, reflective, black Cover Flow display. Your primary interest here is the scroll bar. As you drag it left or right, you see your own files and folders float by and flip in 3-D space. Fun for the whole family!

The effect is spectacular, sure. It's probably not something you'd want to set up for every folder, though, because browsing is a pretty inefficient way to find something. But in folders containing photos or movies (that aren't filled with hundreds of files), Cover Flow can be a handy and satisfying way to browse.

And now, notes on Cover Flow:

  • You can adjust the size of Cover Flow display(relative to the list-view half) by dragging up or down on the grip strip area just beneath the Cover Flow scroll bar.

    Figure 1-24. When you point to a PDF file without clicking, you get special arrow buttons that let you turn pages.

  • Multipage PDF documents are special. When you point to one, circled arrow buttons appear on the jumbo icon. You can click them to page through the document—without even opening it for real (Figure 1-24).

  • QuickTime movies are special, too. When you point to its jumbo display, a [image] button appears. Click it to play the movie, right there in the Cover Flow window (Figure 1-23).

  • You can navigate with the keyboard, too. Any icon that's highlighted in the list view (bottom half of the window) is also front and center in the Cover Flow view. Therefore, you can use all the usual list-view shortcuts to navigate both at once. Use the up or down arrow keys, type the first few letters of an icon's name, press Tab or Shift-Tab to highlight the next or previous icon alphabetically, and so on.

  • Cover Flow shows whatever the list view shows. If you expand a flippy triangle to reveal an indented list of what's in a folder, the contents of that folder now become part of the cover flow.

  • The previews are actual icons. When you're looking at a Cover Flow minidocument, you can drag it with your mouse—you've got the world's biggest target—any where you'd like to drag it: another folder, the Trash, whatever.


quick_look.html

1.8. Quick Look

As the preceding several thousand pages make clear, there are lots of ways to view and manage the seething mass of files and folders on a typical hard drive. Some of them actually let you see what's in a document without having to open it—the Preview column in column view, the giant icons in Cover Flow, and so on.

Quick Look, new in Leopard (and very welcome), takes this idea to another level. It lets you open and browse a document nearly at full size—without switching window views or opening any new programs. You highlight an icon (or several), and then do one of these things:

  • Press the Space bar. This is by far the best technique to learn. After all, unless you're editing a file's name, what's the Space bar ever done for you in the Finder? Nothing. But in Mac OS X Leopard, you can highlight any icon and then tap the Space bar for an instant preview.

  • Press [image] -Y. Another keystroke for the same function. The Space bar is still better, though.

  • Click the eyeball icon at the top of the window. If you don't see the big eyeball icon, you probably upgraded your Mac from an earlier version of Mac OS X. But you can add the eyeball to the toolbar easily enough, as described on Section 4.4.2.1.

  • Choose File rightwards double arrow Quick Look.

  • Choose Quick Look from the Action menu ( [image]) at the top of every Finder window.

  • Control-click (or right-click) an icon; from the shortcut menu, choose Quick Look.

You exit Quick Look in any one of these same ways.

Note: Whenever Quick Look appears in a menu or a shortcut menu, its wording changes to reflect the name of the icon. For example, it might say, "Quick Look 'Secret Diary.doc.'"

In any case, the Quick Look window now opens, showing a nearly full-size preview of the document (Figure 1-25). Rather nice, eh?

Figure 1-25. Once the Quick Look window is open, you can play the file (movies and sounds), study it in more detail (most kinds of graphics files), or even read it (PDF, Word, and Excel documents).
You can also click another icon, and another, and another, without ever closing the preview; the contents of the window simply change to reflect whatever you've just clicked.
Supertip: Quick Look even works on icons in the Trash, too, so you can figure out what something is before you nuke it forever.

The idea here is that you can check out a document without having to wait for it to open in the traditional way. For example, you can find out what's in a Word, Excel, or PowerPoint document without actually having to open Word, Excel, or PowerPoint, which saves you about 45 minutes.

1.8.1. What Quick Look Knows

You might wonder: How, exactly, is Quick Look able to display the contents of a document without opening it? Wouldn't it have to somehow understand the internal file format of that document type?

Exactly. And that's why Quick Look doesn't recognize all documents. If you try to preview, for example, a Final Cut Pro video project, a sheet-music file, a .zip archive, or a database file, all you'll see is a six-inch-tall version of its generic icon. You won't see what's inside.

Over time, Apple expects that the makers of those nonrecognized programs will develop plug-ins that teach Quick Look how to peek inside those documents. In the meantime, here's what Quick Look recognizes right out of the box:

  • Graphics files and photos.This is where Quick Look can really shine, because it's often useful to get a quick look at a photo without having to haul iPhoto or Photoshop out of bed. Quick Look recognizes all common graphics formats, including TIFF, JPEG, GIF, PNG, RAW, and Photoshop documents.

  • PDF and text files.Using the scroll bar, you can page through multipage documents, right there in the Quick Look window.

  • Audio and movie files.They begin to play instantly when you open them into the Quick Look window. Most popular formats are recognized (MP3, AIFF, AAC, MPEG4, H.264, and so on). A scroll bar appears so that you can jump around in the movie or song.

  • Microsoft Word,Excel,and PowerPoint documents.Because these formats are so common, Mac OS X comes with a Quick Look plug-in to recognize them. Move through the pages using the vertical scroll bar; switch to a different Excel spreadsheet page using the Sheet tabs at the bottom.

  • Fonts. Totally cool. When you open a font file in Quick Look, you get a crystalclear, huge sampler that shows every letter of the alphabet in that typeface.

  • vCards. A vCard is an address-book entry that people can send by email to each other to save time in updating their Rolodexes. When you drag a name out of Apple's or Microsoft's address books and onto the desktop, for example, it turns into a vCard document. In Quick Look, the vCard opens up as a handsomely formatted index card that displays all of the person's contact information.

  • Pages,Numbers,Keynote,and TextEdit documents. Naturally, since these are Apple programs, Quick Look understands the document formats.

  • HTML (Web pages). If you've saved some Web pages to your hard drive, here's a great way to inspect them without firing up your Web browser.

1.8.2. Fun with Quick Look

Here are some stunts that make Quick Look even more interesting.

  • Zoom in or out. Option-click the preview to magnify it; drag inside the zoomedin image to scroll; Shift-Option-click to zoom back out. Or press Option as you turn your mouse's scroll wheel. (PDF documents have their own zoom in/zoom out keystrokes: -plus and [image] -minus.)

  • Full screen. When you click the Full Screen arrows(identified in Figure 1-25),your screen goes black, and the Quick Look window expands to fill it. Keep this trick in mind when you're trying to read Word, Excel, or PDF documents, since the text is usually too small to read otherwise. (When you're finished with the closeup, click the Full Screen button again to restore the original Quick Look window, or the [image] button to exit Quick Look altogether.)

Tip: How's this for an undocumented shortcut?If you Option-click the eyeball icon in any Finder window, you go straight into Full Screen mode without having to open the smaller Quick Look window first. Kewl.

  • Add to iPhoto. This icon appears in the Quick Look windows of graphics files that you're examining. Click it to add the picture you're studying to your iPhoto photo collection.

  • Keep it going. Once you've opened Quick Look for one icon, you don't have to close it before inspecting another icon.Just keep clicking differenticons; the Quick Look window changes instantly with each click to reflect the new document.

1.8.3. The Quick Look Slideshow

Mac OS X is supposed to be all about graphics and other visual delights. No wonder, then, that it offers a built-in, full-screen slideshow feature.

It works like this: Highlight a bunch of icons, and then open Quick Look. The screen goes black, and the documents begin their slideshow.Each image appears on the screen for about three seconds before the next one appears. (Press the Esc key or [image] -period to end the show.) It's like the Finder slideshow feature that debuted in Mac OS X 10.4, except that it plays all documents that it recognizes, not just graphics.

It's a useful enough feature when you've just downloaded or imported a bunch of photos or Office documents and want a quick look through them. Use the control bar shown in Figure 1-26 to manage the playback.

Figure 1-26. Once the slideshow is underway, you can use this control bar. It lets you pause the slideshow, move forward or backward manually, enlarge the current "slide" to fill the screen, or end the show.
The Index view is especially handy. It displays an array of labeled miniatures, all at once—a sort of Exposé for Quick Look. Click a thumbnail to jump directly to the Quick Look document you want to inspect.

Note: This same slideshow mechanism is available for graphics in Preview and Mail.


logging_out_shutting_down.html

1.9. Logging Out, Shutting Down

If you're the only person who uses your Mac,finishing up awork session is simple.You can either turn off the machine or simply let it go to sleep, in any of several ways.

1.9.1. Sleep Mode

If you're still shutting down your Mac after each use, you may be doing a lot more waiting than necessary. Sleep mode consumes very little power, keeps everything you were doing open and available, and wakes up almost immediately when you press a key or click the mouse.

To make your machine sleep, do one of the following:

  • Close the lid. (Hint: This tip works primarily on laptops.)

  • Choose [image] rightwards double arrow Sleep.

  • Press Control-Eject (or Control-F12, if you don't have an Eject key). In the dialog box shown in Figure 1-27, click Sleep (or type S).

  • Press the Power button on your machine. On desktop models, doing so makes it sleep immediately; on laptops, you get the dialog box shown in Figure 1-27.

  • Hold down the Play/Pause button on your remote control for three seconds. All current Mac models except the Mac Pro come with Apple's tiny white remote control.

    Figure 1-27. Once the Shut Down dialog box appears, you can press the S key instead of clicking Sleep, R for Restart, Esc for Cancel, or Enter for Shut Down.

  • Just walk away, confident that the Energy Saver setting described on Section 9.9.4285 will send the machine off to dreamland automatically at the specified time.

1.9.2. Restart

You shouldn't have to restart the Mac very often—only in times of severe troubleshooting mystification, in fact. Here are a few ways to do it:

  • Choose [image] rightwards double arrow Restart. A confirmation dialog box appears; click Restart (or press Enter).

    Tip: If you press Option as you release the mouse on the [image] rightwards double arrow Restart command, you won't be bothered by an "Are you sure?" confirmation box.

  • Press Control- [image] -Eject. (If you don't have an Eject key, substitute F12.)

  • Press Control-Eject to summon the dialog box shown in Figure 1-27; click Restart (or type R).

1.9.3. Shut Down

To shut down your machine completely (when you don't plan to use it for more than a couple of days, when you plan to transport it, and so on), do one of the following:

  • Choose [image] rightwards double arrow Shut Down. A simple confirmation dialog box appears; click Shut Down (or press Enter).

    Tip: Once again, if you press Option as you release the mouse, no confirmation box appears.

  • Press Control-Option- [image] -Eject. (It's not as complex as it looks—the first three keys are all in a tidy row to the left of the Space bar.)

  • Press Control-Eject (or Control-F12) to summon the dialog box shown in Figure 1-27. Click Shut Down (or press Enter).

  • Wait.If you've set up the Energy Saver preferences (Section 9.11.4) to shut down the Mac automatically at a specified time, you don't have to do anything.

1.9.4. Log Out

If you share your Mac, you should log out when you're done. Doing so ensures that your stuff is safe from the evil and the clueless even when you're out of the room. To do it, choose [image] rightwards double arrow Log Out Chris (or whatever your name is). Or, if you're in a hurry, press Shift- [image] -Q.

When the confirmation dialog box appears, click Log Out (or press Enter), or just wait for two minutes. The Mac hides your world from view and displays the Log In dialog box, ready for the next victim.

Tip: Last time: If you press Option as you release the mouse on the [image] rightwards double arrow Log Out command, you squelch the "Are you sure?" box.

Logging out is described in much more detail in Chapter 12.


getting_help_in_mac_os_x.html

1.10. Getting Help in Mac OS X

It's a good thing you've got a book about Mac OS X in your hands, because the only user manual you get with Mac OS X is the Help menu. You get a Web browser–like program that reads a set of help files that reside in your System rightwards double arrow Library folder.

Tip: In fact, you may not even be that lucky. In Leopard, the general-information Help page about each topic is on your Mac, but thousands of more nichey or more technical pages actually reside online, and require an Internet connection to read.

You're expected to find the topic you want in one of these three ways:

  • Use the new Search box.When you click the Help menu , a tiny search box appears just beneath your cursor (Figure 1-28). You can type a few words here to specify what you want help on: "setting up printer," "disk space," whatever.

    Tip: You can also hit [image] -Shift-/ (that is, [image] -?) to open the Help search box. And you can change that keystroke, if you like, in System Preferences rightwards double arrow Keyboard & Mouse.

    Figure 1-28. In Leopard, you don't have to open the Help program to begin a search. No matter what program you're in, typing a search phrase into the box shown here produces an instantaneous list of help topics, ready to read.

    The menu now becomes a list of Apple help topics pertaining to your search. Click one to open the Help browser described next; you've just saved some time and a couple of steps.

    Tip: The results menu does not, however, show all of Help's results—only the ones Apple thinks are most relevant. If you choose Show All Results at the bottom of the menu, the Help browser opens (described below). It shows a more complete list of Help-search results.

  • Drill down. Alternatively, you can begin your quest for assistance the old-fashioned way:by opening the Help browser first.To do that,choose Help rightwards double arrow MacHelp.(This works only in the Finder, and only when nothing is typed in the Search box. To empty the Search box, click the [image] button at the right end.)

    After a moment, you arrive at the Help browser program shown in Figure 1-29. The starting screen offers several "quick click" topics that may interest you. If so, keep clicking text headings until you find a topic that you want to read.

    You can backtrack by clicking the [image] button at the top of the window. And you can always return to the starting screen by clicking the little Home icon at the top.

    Tip: Annoyingly, the Leopard Help window insists on floating in front of all other windows; you can't send it to the back like any normal program. Therefore, consider making the window tall and skinny, so you can put it beside the program you're working in. Drag the ribbed lower-right corner to change the window's shape.

  • Use the "Ask a Question"blank.Type the phrase you want, such as printing or switching applications, into the Search box at the top of the window, and then press Return. The Mac responds by showing you a list of help-screen topics that may pertain to what you need; see Figure 1-30 for details.

    Figure 1-29. The Mac OS X Help system no longer bunches together the help pages from every program on your Mac. When you're in the Finder, you get the general Macintosh help screens. When you're in iPhoto, you get only iPhoto help screens. And so on.
    But using the Home pop-up menu, you can switch to another program's Help system even if that program isn't open.

    This Search box usually gives you a more complete list of results than you'd have gotten by using the Search box in the Help menu, as described above.

Note: Actually, there's one more place where Help has cropped up in Leopard: in System Preferences dialog boxes. Click the blue, circled question-mark button in the lower-right corner of each System Preferences panel to open a Help page that identifies each control.

Figure 1-30. The bars indicate the Mac's "relevance" rating— how well it thinks each help page matches your search. Double-click a topic's name to open the help page. If it isn't as helpful as you hoped, click the button at the top of the window to return to the list of relevant topics. Click the little Home button to return to the Help Center's welcome screen.

GEM IN THE ROUGH
Menu Help in the Help Menu

Mac OS X Leopard contains a weird, wonderful little en-hancement to its online help system. It helps you find menu commands you can't find.

You're floundering in some program. You're sure there's a Page Numbering command in those menus somewhere. But there are 11 menus and 143 submenus hiding in those menus, and you haven't got time for the pain.

That's when you should think of using the Help menu. When you typepage number (or what-ever) into its Search box, the results menu lists, at the top, the names of any menu commands in that program that contain the words you typed. Better still, it actually opens that menu for you, and displays a big, blue, animated, floating arrow pointing to the command you wanted. You'd have to have your eyes closed to miss it.

Slide your cursor over, click the menu command, and get on with your life.

Supertip: This feature is especially helpful in Web browsers like Safari and Firefox, because it even finds entries in your Bookmarks and History menus!

In Safari, for example, you can pluck a recently visited site out of the hundreds in the daily History submenus, like the "Wednesday, January 9" submenu. You've just saved yourself a lot of poking around menus, trying to find the name of a site you know you've seen recently.)

Ultratip: If you think about it, this feature also means that you have complete keyboard power over every menu in every program in the world. Hit [image] -Shift-? to open the Help search box, type a bit of the command's name, and then use the arrow keys to walk down the results. Hit Enter to trigger the command you want


organizing_your_stuff.html

Chapter 2. Organizing Your Stuff

The Mac OS X Folder Structure

Icon Names

Selecting Icons

Moving and Copying Icons

Color Labels

The Trash

Get Info

2.1. The Mac OS X Folder Structure

The icon for your hard drive (usually called Macintosh HD) may appear in the upper-right corner of your screen. But if you begin each morning by double-clicking it, like millions of other people who've grown used to older versions of the Mac OS, you're in for a shock: Your stuff isn't there.

All you'll find in the Macintosh HD window is a set of folders called Applications, Library, and Users—folders you didn't put there. (If you upgraded an existing Mac to Mac OS X 10.5, you'll also see all your original hard drive folders nestled among them.)

Most of these folders aren't very useful to you, the Mac's human companion. They're there for Mac OS X's own use (which is why the Finder rightwards double arrow Preferences dialog box offers a checkbox that hides their icons entirely). Think of your main hard drive window as storage for the operating system itself, which you'll access only for occasional administrative purposes.

2.1.1. Your Home Folder

Instead of setting up your nest—your files, folders, aliases, and so on—in the hard drive window, Mac OS X keeps all of it in your Home folder. That's a folder bearing your name (or whatever name you typed when you installed Mac OS X).

One way to find the Home folder is to double-click the Users folder, and then double-click the folder inside it that bears your name and looks like a house (see Figure 2-1). Here, at last, is the window that you'll eventually fill with new folders, organize, back up, and so on.

But Mac OS X is rife with shortcuts for opening this all-important folder:

  • Choose Go rightwards double arrow Home, or press Shift- [image] -H.

  • In the Sidebar (Section 1.2), click the Home icon (the little house).

  • In the Dock, click the Home icon.(If you don't see one, consult Section 4.2 for instructions on how to put one there.)

  • Press [image] -N, or choose File rightwards double arrow New Finder Window. (If your Home folder doesn't open when you do that, see Section 1.2.8.)

All of these steps open your Home folder directly.

Figure 2-1. This is it: the folder structure of Mac OS X. It's not so bad, really. For the most part, what you care about are the Applications folder in the main hard drive window and your own Home folder. You're welcome to save your documents and park your icons almost anywhere on your Mac (except inside the System folder or other people's Home folders). But keeping your work in your Home folder makes backing up and file sharing easier.

So why has Apple demoted your files to a folder three levels deep? The answer may send you through the five stages of grief—Denial, Anger, Bargaining, Depression, and finally Acceptance—but if you're willing to go through it, much of the mystery surrounding Mac OS X will fade away.

Mac OS X has been designed from the ground up for computer sharing. It's ideal for any situation where different family members, students, or workers share the same Mac.

Each person who uses the computer will turn on the machine to find his own separate desktop picture, set of files, Web bookmarks, font collection, and preference settings. (You'll find much more about this feature in Chapter 12.)

Like it or not, Mac OS X considers you one of these people. If you're the only one who uses this Mac, fine—simply ignore the sharing features. (You can also ignore all that business at the beginning of Chapter 1 about logging in.) But in its little software head, Mac OS X still considers you an account holder, and stands ready to accommodate any others who should come along.

In any case, now you should see the importance of the Users folder in the main hard drive window. Inside are folders—the Home folders—named for the different people who use this Mac. In general, nobody is allowed to touch what's inside anybody else's folder.

If you're the sole proprietor of the machine, of course, there's only one Home folder in the Users folder—named for you. (The Shared folder doesn't count; it's described on Section 12.6.2.)

This is only the first of many examples in which Mac OS X imposes a fairly rigid folder structure. Still, the approach has its advantages. By keeping such tight control over which files go where, Mac OS X keeps itself pure—and very, very stable. Other operating systems known for their stability, including Windows XP and Windows Vista, work the same way.

Furthermore, keeping all of your stuff in a single folder makes it very easy for you to back up your work. It also makes life easier when you try to connect to your machine from elsewhere in the office (over the network) or elsewhere in the world (over the Internet), as described in Chapter 22.

2.1.2. What's On Your Hard Drive

When you first run Mac OS X, you'll find the following folders in the main hard drive window:

  • Applications. The Applications folder, of course, contains the complete collection of Mac OS X programs on your Mac (not counting the invisible Unix ones). Even so, you'll rarely launch programs by opening this folder; the Dock is a far more efficient launcher, as described in Chapter 4.

  • Desktop. This folder stores icons that appear on the Mac OS X desktop (see the next page for details). The difference is that you don't control this one; Apple does. Anything in here also appears on your desktop. (This Apple-controlled one is usually empty.)

  • Library. This folder bears more than a passing resemblance to the System Folder subfolders of Macs gone by, or the Windows folder on PCs. It stores components for the operating system and your programs (sounds, fonts, preferences, help files, printer drivers, modem scripts, and so on).

  • System. This is Unix, baby. These are the actual files that turn on your Mac and control its operations. You'll rarely have any business messing with this folder, which is why Apple made almost all of its contents invisible.

  • User Guides And Information. Here's a link to a folder that contains random Getting Started guides from Apple, including a Welcome to Leopard booklet.

  • Users. As noted earlier, this folder stores the Home folders for everyone who uses this machine.

  • Your old junk. If you upgraded your Mac from an earlier Mac operating system, your main hard drive window also lists whatever folders you kept there.

If you're one of the dying breed—you're running Leopard on a Mac made before Apple switched to Intel processors—you may have a few relics of Mac OS 9 in this window, too. For example:

  • Applications (Mac OS 9). All your old, pre–Mac OS X programs (or rather, those that you kept in your old Applications folder) wind up in this folder. Unfortunately, you can no longer run them, since the Classic mode is gone now.

  • System Folder. This folder contains Mac OS 9 itself. (Don't confuse the Mac OS 9 folder, called System Folder, with the one that's just called System—that one contains Mac OS X.)

2.1.3. What's in Your Home Folder

Within the folder that bears your name, you'll find another set of standard Mac folders. (You can tell that the Mac considers them holy because they have special logos on their folder icons.) Except as noted, you're free to rename or delete them; Mac OS X creates the following folders solely as a convenience:

  • Desktop. When you drag an icon out of a folder or disk window and onto your Mac OS X desktop, it may appear to show up on the desktop. But that's just an optical illusion, a visual convenience. In truth, nothing in Mac OS X is really on the desktop. It's actually in this Desktop folder, and mirrored on the desktop area.

    The reason is simple enough: Remember that everyone who shares your machine will, upon logging in, see his own stuff sitting on the desktop. Now you know how Mac OS X does it: There's a separate Desktop folder in every person's Home folder.

    UP TO SPEED
    The Computer Window

    In your explorations of the Finder's Go menu, you may have wondered about the command called Computer (Shift- [image] -C). ("Go to my computer? Jeez, I thought I was already at my computer…")

    As in Microsoft Windows, the Computer window holds the icons for all the disks connected to your machine—the hard drive, a CD that you've inserted, an iPod, another external hard drive, and so on—as well as an icon called Network. (The Network icon appears even if you're not, in fact, on a network.) This is the topmost level of your Mac. This is the stuff that can't be put into any folder at all.

    So what's it for? In some ways, the Computer window is redundant. After all, Mac OS X displays your disk icons on the desktop and in the Sidebar.

    But some people, particularly Windows refugees, don't care for that icons-on-the-desktop feature. In the interest of creating a neater, cleaner desktop, they turn it off, in fact (by choosing Finder rightwards double arrow Preferences and turning off the three checkboxes under "Show these items on the Desktop"). Furthermore, in the interest of creating neater, narrower windows, some people also hide the Sidebar.

    In that case, the Computer window still provides access to all of your disks.

    Otherwise, the Computer window really doesn't serve much purpose except as a familiar landmark to Windows veterans and Mac fans who grew used to it in the era before the Sidebar came along.

    You can entertain yourself for hours by proving this point to yourself. If you drag something out of your Desktop folder, it also disappears from the actual desktop. And vice versa. (You're not allowed to delete or rename this folder.)

    Tip: The desktop is actually a folder in your Home folder. That's handy, because it gives you a quick and sneaky way to jump to your Home folder from anywhere. Simply click the desktop background and then press [image] -up arrow (which is the keystroke for Go rightwards double arrow Enclosing Folder; pay no attention to the fact that the command is dimmed at the moment).Because that keystroke always means "open whatever folder contains the one I'm examining," it instantly opens your Home folder. (Your Home folder is, of course, the "parent" of your Desktop folder.)

  • Documents. Apple suggests that you keep your actual work files in this folder. Sure enough, whenever you save a new document (when you're working in Keynote or Word, for example), the Save As box proposes storing the new file in this folder, as described in Chapter 5.

    Your programs may also create folders of their own here. For example, you may find a Microsoft User Data folder for your Entourage email, a Windows folder for use with Parallels or VMWare Fusion (Chapter 8), and so on.

  • Library. As noted earlier, the mainLibrary folder (the one in your main hard drive window) contains folders for fonts, preferences, help files, and so on.

    You have your own Library folder, too, right there in your Home folder. It stores the same kinds of things—but they're your fonts, your preferences, and so on.

    Once again, this setup may seem redundant if you're the only person who uses your Mac. But it makes perfect sense in the context of families, schools, or offices where numerous people share a single machine. Because you have your own Library folder, you can have a font collection that's "installed" on the Mac only when you're using it. Each person's program preference files are stored independently, too (the files that determine where Photoshop's palettes appear, and so on). And each person, of course, sees his own email when launching Mac OS X's Mail program (Chapter 19)—because mail, too, is generally stored in the personal Library folder.

    UP TO SPEED
    The Wacky Keystrokes of Leopard

    Mac OS X offers a glorious assortment of predefined key-strokes for jumping to the most important locations on your Mac: your Home folder, the Applications folder, the Utilities folder, the Computer window, your iDisk, the Network window, and so on.

    Better yet, the keystrokes are incredibly simple to memorize: Just press Shift- [image] and the first letter of the location you want. Shift- [image] -H opens your Home folder, Shift- [image] -A opens the Applications folder, and so on. You learn one, you've learned 'em all.

    The point here is that Shift- [image], in Leopard, means places.

    The other system-wide key combo, Option- [image], means functions. For example, Option- [image] -D hides or shows the Dock, Option- [image] -H is the Hide Others command, Option- [image] -+ magnifies the screen (if you've turned on this feature), Option- [image] -Esc brings up the Force Quit dialog box, and so on. Consistency is always nice.

    Other Library folders store your Favorites, Web browser plug-ins and cached Web pages, keyboard layouts, sound files, and so on. (It's best not to move or rename Library folders.)

  • Movies, Music, Pictures. These folders, of course, are designed to store multimedia files. The various Mac OS X programs that deal with movies, music, and pictures will propose these specialized folders as storage locations. For example, when you plug a digital camera into a Mac, the iPhoto program automatically begins to download the photos on it—and stores them in the Pictures folder. Similarly, iMovie is programmed to look for the Movies folder when saving its files, and iTunes stores its MP3 files in the Music folder.

  • Public. If you're on a network, or if others use the same Mac when you're not around, this folder can be handy: It's the "Any of you guys can look at these files" folder. Other people on your network, as well as other people who sit down at this machine, are allowed to see whatever you've put in here, even if they don't have your password. (If your Mac isn't on an office network and isn't shared, you can throw away this folder.) Details on sharing the Mac are in Chapter 12, and those on networking are in Chapter 13.

  • Sites. Mac OS X has a built-in Web server: software that turns your Mac into a Web site that people on your network—or, via the Internet, all over the world—can connect to. This Mac OS X feature relies on a program called the Apache Web server, which is so highly regarded in the Unix community that programmers lower their voices when they mention it.

NOSTALGIA CORNER
Printing a Window—or a List of Files

Hey, in Mac OS 9, I could print a Finder window. I'd get a neat list of the files, which I could use as a label for a CD I was going to burn, or whatever. How do I print a Finder window in Mac OS X? (The File rightwards double arrow Print command prints a selected document, not the list of files in a window.)

It's easy enough to make a list of files for printing. Once the window is open on your screen, choose Edit rightwards double arrow Select All. Choose Edit rightwards double arrow Copy. Now switch to a word processor and paste. (If you're using TextEdit, use Edit rightwards double arrow Paste and Match Style instead.) You get a tidy list of all the files in that window, ready to format and print.

This simple file name list still isn't the same as printing a window, that's true; you don't get the status bar showing how many items are on the disk and how full the disk is. For that purpose, you can always make a screenshot of the window (Section 14.10), and print that. Of course, that technique's no good if the list of files is taller than the window itself.

Really, what you want is Print Window, a handy shareware program dedicated to printing out your Finder windows, without any of these workarounds or limitations. You can download it from the "Missing CD" page at www.missingmanuals.com.

Details of the Web server are in Chapter 22. For now, though, note that this is the folder where you will put the actual Web pages you want to make available to the Internet at large.


the_mac_os_x_folder_structure.html

Chapter 2. Organizing Your Stuff

The Mac OS X Folder Structure

Icon Names

Selecting Icons

Moving and Copying Icons

Color Labels

The Trash

Get Info

2.1. The Mac OS X Folder Structure

The icon for your hard drive (usually called Macintosh HD) may appear in the upper-right corner of your screen. But if you begin each morning by double-clicking it, like millions of other people who've grown used to older versions of the Mac OS, you're in for a shock: Your stuff isn't there.

All you'll find in the Macintosh HD window is a set of folders called Applications, Library, and Users—folders you didn't put there. (If you upgraded an existing Mac to Mac OS X 10.5, you'll also see all your original hard drive folders nestled among them.)

Most of these folders aren't very useful to you, the Mac's human companion. They're there for Mac OS X's own use (which is why the Finder rightwards double arrow Preferences dialog box offers a checkbox that hides their icons entirely). Think of your main hard drive window as storage for the operating system itself, which you'll access only for occasional administrative purposes.

2.1.1. Your Home Folder

Instead of setting up your nest—your files, folders, aliases, and so on—in the hard drive window, Mac OS X keeps all of it in your Home folder. That's a folder bearing your name (or whatever name you typed when you installed Mac OS X).

One way to find the Home folder is to double-click the Users folder, and then double-click the folder inside it that bears your name and looks like a house (see Figure 2-1). Here, at last, is the window that you'll eventually fill with new folders, organize, back up, and so on.

But Mac OS X is rife with shortcuts for opening this all-important folder:

  • Choose Go rightwards double arrow Home, or press Shift- [image] -H.

  • In the Sidebar (Section 1.2), click the Home icon (the little house).

  • In the Dock, click the Home icon.(If you don't see one, consult Section 4.2 for instructions on how to put one there.)

  • Press [image] -N, or choose File rightwards double arrow New Finder Window. (If your Home folder doesn't open when you do that, see Section 1.2.8.)

All of these steps open your Home folder directly.

Figure 2-1. This is it: the folder structure of Mac OS X. It's not so bad, really. For the most part, what you care about are the Applications folder in the main hard drive window and your own Home folder. You're welcome to save your documents and park your icons almost anywhere on your Mac (except inside the System folder or other people's Home folders). But keeping your work in your Home folder makes backing up and file sharing easier.

So why has Apple demoted your files to a folder three levels deep? The answer may send you through the five stages of grief—Denial, Anger, Bargaining, Depression, and finally Acceptance—but if you're willing to go through it, much of the mystery surrounding Mac OS X will fade away.

Mac OS X has been designed from the ground up for computer sharing. It's ideal for any situation where different family members, students, or workers share the same Mac.

Each person who uses the computer will turn on the machine to find his own separate desktop picture, set of files, Web bookmarks, font collection, and preference settings. (You'll find much more about this feature in Chapter 12.)

Like it or not, Mac OS X considers you one of these people. If you're the only one who uses this Mac, fine—simply ignore the sharing features. (You can also ignore all that business at the beginning of Chapter 1 about logging in.) But in its little software head, Mac OS X still considers you an account holder, and stands ready to accommodate any others who should come along.

In any case, now you should see the importance of the Users folder in the main hard drive window. Inside are folders—the Home folders—named for the different people who use this Mac. In general, nobody is allowed to touch what's inside anybody else's folder.

If you're the sole proprietor of the machine, of course, there's only one Home folder in the Users folder—named for you. (The Shared folder doesn't count; it's described on Section 12.6.2.)

This is only the first of many examples in which Mac OS X imposes a fairly rigid folder structure. Still, the approach has its advantages. By keeping such tight control over which files go where, Mac OS X keeps itself pure—and very, very stable. Other operating systems known for their stability, including Windows XP and Windows Vista, work the same way.

Furthermore, keeping all of your stuff in a single folder makes it very easy for you to back up your work. It also makes life easier when you try to connect to your machine from elsewhere in the office (over the network) or elsewhere in the world (over the Internet), as described in Chapter 22.

2.1.2. What's On Your Hard Drive

When you first run Mac OS X, you'll find the following folders in the main hard drive window:

  • Applications. The Applications folder, of course, contains the complete collection of Mac OS X programs on your Mac (not counting the invisible Unix ones). Even so, you'll rarely launch programs by opening this folder; the Dock is a far more efficient launcher, as described in Chapter 4.

  • Desktop. This folder stores icons that appear on the Mac OS X desktop (see the next page for details). The difference is that you don't control this one; Apple does. Anything in here also appears on your desktop. (This Apple-controlled one is usually empty.)

  • Library. This folder bears more than a passing resemblance to the System Folder subfolders of Macs gone by, or the Windows folder on PCs. It stores components for the operating system and your programs (sounds, fonts, preferences, help files, printer drivers, modem scripts, and so on).

  • System. This is Unix, baby. These are the actual files that turn on your Mac and control its operations. You'll rarely have any business messing with this folder, which is why Apple made almost all of its contents invisible.

  • User Guides And Information. Here's a link to a folder that contains random Getting Started guides from Apple, including a Welcome to Leopard booklet.

  • Users. As noted earlier, this folder stores the Home folders for everyone who uses this machine.

  • Your old junk. If you upgraded your Mac from an earlier Mac operating system, your main hard drive window also lists whatever folders you kept there.

If you're one of the dying breed—you're running Leopard on a Mac made before Apple switched to Intel processors—you may have a few relics of Mac OS 9 in this window, too. For example:

  • Applications (Mac OS 9). All your old, pre–Mac OS X programs (or rather, those that you kept in your old Applications folder) wind up in this folder. Unfortunately, you can no longer run them, since the Classic mode is gone now.

  • System Folder. This folder contains Mac OS 9 itself. (Don't confuse the Mac OS 9 folder, called System Folder, with the one that's just called System—that one contains Mac OS X.)

2.1.3. What's in Your Home Folder

Within the folder that bears your name, you'll find another set of standard Mac folders. (You can tell that the Mac considers them holy because they have special logos on their folder icons.) Except as noted, you're free to rename or delete them; Mac OS X creates the following folders solely as a convenience:

  • Desktop. When you drag an icon out of a folder or disk window and onto your Mac OS X desktop, it may appear to show up on the desktop. But that's just an optical illusion, a visual convenience. In truth, nothing in Mac OS X is really on the desktop. It's actually in this Desktop folder, and mirrored on the desktop area.

    The reason is simple enough: Remember that everyone who shares your machine will, upon logging in, see his own stuff sitting on the desktop. Now you know how Mac OS X does it: There's a separate Desktop folder in every person's Home folder.

    UP TO SPEED
    The Computer Window

    In your explorations of the Finder's Go menu, you may have wondered about the command called Computer (Shift- [image] -C). ("Go to my computer? Jeez, I thought I was already at my computer…")

    As in Microsoft Windows, the Computer window holds the icons for all the disks connected to your machine—the hard drive, a CD that you've inserted, an iPod, another external hard drive, and so on—as well as an icon called Network. (The Network icon appears even if you're not, in fact, on a network.) This is the topmost level of your Mac. This is the stuff that can't be put into any folder at all.

    So what's it for? In some ways, the Computer window is redundant. After all, Mac OS X displays your disk icons on the desktop and in the Sidebar.

    But some people, particularly Windows refugees, don't care for that icons-on-the-desktop feature. In the interest of creating a neater, cleaner desktop, they turn it off, in fact (by choosing Finder rightwards double arrow Preferences and turning off the three checkboxes under "Show these items on the Desktop"). Furthermore, in the interest of creating neater, narrower windows, some people also hide the Sidebar.

    In that case, the Computer window still provides access to all of your disks.

    Otherwise, the Computer window really doesn't serve much purpose except as a familiar landmark to Windows veterans and Mac fans who grew used to it in the era before the Sidebar came along.

    You can entertain yourself for hours by proving this point to yourself. If you drag something out of your Desktop folder, it also disappears from the actual desktop. And vice versa. (You're not allowed to delete or rename this folder.)

    Tip: The desktop is actually a folder in your Home folder. That's handy, because it gives you a quick and sneaky way to jump to your Home folder from anywhere. Simply click the desktop background and then press [image] -up arrow (which is the keystroke for Go rightwards double arrow Enclosing Folder; pay no attention to the fact that the command is dimmed at the moment).Because that keystroke always means "open whatever folder contains the one I'm examining," it instantly opens your Home folder. (Your Home folder is, of course, the "parent" of your Desktop folder.)

  • Documents. Apple suggests that you keep your actual work files in this folder. Sure enough, whenever you save a new document (when you're working in Keynote or Word, for example), the Save As box proposes storing the new file in this folder, as described in Chapter 5.

    Your programs may also create folders of their own here. For example, you may find a Microsoft User Data folder for your Entourage email, a Windows folder for use with Parallels or VMWare Fusion (Chapter 8), and so on.

  • Library. As noted earlier, the mainLibrary folder (the one in your main hard drive window) contains folders for fonts, preferences, help files, and so on.

    You have your own Library folder, too, right there in your Home folder. It stores the same kinds of things—but they're your fonts, your preferences, and so on.

    Once again, this setup may seem redundant if you're the only person who uses your Mac. But it makes perfect sense in the context of families, schools, or offices where numerous people share a single machine. Because you have your own Library folder, you can have a font collection that's "installed" on the Mac only when you're using it. Each person's program preference files are stored independently, too (the files that determine where Photoshop's palettes appear, and so on). And each person, of course, sees his own email when launching Mac OS X's Mail program (Chapter 19)—because mail, too, is generally stored in the personal Library folder.

    UP TO SPEED
    The Wacky Keystrokes of Leopard

    Mac OS X offers a glorious assortment of predefined key-strokes for jumping to the most important locations on your Mac: your Home folder, the Applications folder, the Utilities folder, the Computer window, your iDisk, the Network window, and so on.

    Better yet, the keystrokes are incredibly simple to memorize: Just press Shift- [image] and the first letter of the location you want. Shift- [image] -H opens your Home folder, Shift- [image] -A opens the Applications folder, and so on. You learn one, you've learned 'em all.

    The point here is that Shift- [image], in Leopard, means places.

    The other system-wide key combo, Option- [image], means functions. For example, Option- [image] -D hides or shows the Dock, Option- [image] -H is the Hide Others command, Option- [image] -+ magnifies the screen (if you've turned on this feature), Option- [image] -Esc brings up the Force Quit dialog box, and so on. Consistency is always nice.

    Other Library folders store your Favorites, Web browser plug-ins and cached Web pages, keyboard layouts, sound files, and so on. (It's best not to move or rename Library folders.)

  • Movies, Music, Pictures. These folders, of course, are designed to store multimedia files. The various Mac OS X programs that deal with movies, music, and pictures will propose these specialized folders as storage locations. For example, when you plug a digital camera into a Mac, the iPhoto program automatically begins to download the photos on it—and stores them in the Pictures folder. Similarly, iMovie is programmed to look for the Movies folder when saving its files, and iTunes stores its MP3 files in the Music folder.

  • Public. If you're on a network, or if others use the same Mac when you're not around, this folder can be handy: It's the "Any of you guys can look at these files" folder. Other people on your network, as well as other people who sit down at this machine, are allowed to see whatever you've put in here, even if they don't have your password. (If your Mac isn't on an office network and isn't shared, you can throw away this folder.) Details on sharing the Mac are in Chapter 12, and those on networking are in Chapter 13.

  • Sites. Mac OS X has a built-in Web server: software that turns your Mac into a Web site that people on your network—or, via the Internet, all over the world—can connect to. This Mac OS X feature relies on a program called the Apache Web server, which is so highly regarded in the Unix community that programmers lower their voices when they mention it.

NOSTALGIA CORNER
Printing a Window—or a List of Files

Hey, in Mac OS 9, I could print a Finder window. I'd get a neat list of the files, which I could use as a label for a CD I was going to burn, or whatever. How do I print a Finder window in Mac OS X? (The File rightwards double arrow Print command prints a selected document, not the list of files in a window.)

It's easy enough to make a list of files for printing. Once the window is open on your screen, choose Edit rightwards double arrow Select All. Choose Edit rightwards double arrow Copy. Now switch to a word processor and paste. (If you're using TextEdit, use Edit rightwards double arrow Paste and Match Style instead.) You get a tidy list of all the files in that window, ready to format and print.

This simple file name list still isn't the same as printing a window, that's true; you don't get the status bar showing how many items are on the disk and how full the disk is. For that purpose, you can always make a screenshot of the window (Section 14.10), and print that. Of course, that technique's no good if the list of files is taller than the window itself.

Really, what you want is Print Window, a handy shareware program dedicated to printing out your Finder windows, without any of these workarounds or limitations. You can download it from the "Missing CD" page at www.missingmanuals.com.

Details of the Web server are in Chapter 22. For now, though, note that this is the folder where you will put the actual Web pages you want to make available to the Internet at large.


icon_names.html

2.2. Icon Names

Every document, program, folder, and disk on your Mac is represented by an icon: a colorful little picture that you can move, copy, or double-click to open. In Mac OS X, icons look more like photos than cartoons, and you can scale them to practically any size.

A Mac OS X icon's name can have up to 255 letters and spaces. If you're accustomed to the 31-character or even 8-character limits of older computers, that's quite a luxurious ceiling.

If you're used to Windows, you may be delighted to discover that in Mac OS X, you can name your files using letters, numbers, punctuation—in fact, any symbol except for the colon (:), which the Mac uses behind the scenes for its own folder-hierarchy designation purposes. And you can't use a period to begin a file's name.

To rename a file, click its name or icon (to highlight it) and then press Return or Enter. (Or, if you have time to kill, click once on the name, wait a moment, and then click a second time.)

In any case, a rectangle now appears around the name (Figure 2-2). At this point, the existing name is highlighted; just begin typing to replace it. If you type a very long name, the rectangle grows vertically to accommodate new lines of text.

Tip: If you simply want to add letters to the beginning or end of the file's existing name, press the left or right arrow key immediately after pressing Return or Enter. The insertion point jumps to the corresponding end of the file name.

Figure 2-2. Click an icon's name (top left) to produce the renaming rectangle (top right), in which you can edit the file's name. Leopard is kind enough to highlight only the existing name, and not the suffix (like .jpg or .doc).
Now just begin typing to replace the existing name (bottom left). When you're finished typing, press Return, Enter, or Tab to seal the deal, or just click somewhere else.

When you're finished typing, press Return, Enter, or Tab—or just click somewhere else—to make the renaming rectangle disappear.

You can give more than one file or folder the same name, as long as they're not in the same folder. For example, you can have as many files named "Chocolate Cake Recipe" as you like, provided each is in a different folder. And, of course, files called Recipe. doc and Recipe.xls can coexist in a folder, too.

As you edit a file's name, remember that you can use the Cut, Copy, and Paste commands in the Edit menu to move selected bits of text around, just as though you're word processing. The Paste command can be useful when, for instance, you're renaming many icons in sequence (Quarterly Estimate 1, Quarterly Estimate 2, and so on).

And now, a few tips about renaming icons:

  • When the Finder sorts files, a space is considered alphabetically before the letter To force a particular folder to appear at the top of a list view window, insert a space before its name.

  • Older operating systems sort files so that 10 and 100 come before 2, the numbers 0 and 300 come before 4, and so on. You wind up with alphabetically sorted files like this:"1.Big Day," "10. Long Song," "2. Floppy Hat," "20. Dog Bone," "3. Weird Sort," and so on. Generations of computer users have learned to put zeros in front of their single-digit numbers just to make the sorting look right.

    In Mac OS X, though, you get exactly the numerical list you'd hope for: "1.Big Day," "2.Floppy Hat," "3.Weird Sort," "10.Long Song," and "20.Dog Bone." At long last, you can get out of the habit of putting zeros in front of file names to make them sort properly.

    FREQUENTLY ASKED QUESTION
    Long and Short File Names

    Hey, what's the deal with long file names? I thought this was the big deal in Mac OS X! But I tried saving a Word 2004 document, and it didn't let me use more than 31 letters!

    It's true that you can assign a very long name to a file in the Finder. But you may soon discover that some pre–Mac OS X programs, and even programs that have been rewritten (Carbonized) to run in Mac OS X, still limit you to 31 characters when naming a new document in the Save As dialog box.

    Over time, software companies may get with the program and rejigger their software to overcome this anachronistic glitch. For now, though, all is not lost.

    Even though you can use only 31 characters when saving a new document from, say, AppleWorks or older versions of Word, you're welcome to rename the file in the Finder, using all 255 characters Mac OS X permits. When you reopen the document in the original program, you'll see an abbreviated name in the title bar. (A file that, at the desktop, is called My Visit to Bill Gates's House and Why I'll Take the Apple Bumper Sticker Off My Car Next Time opens into AppleWorks as something like My Visit to Bill Gates's H…)

    The good news is that behind the scenes, Mac OS X still remembers its long name. Even if you edit and resave the document, you'll still find its long file name intact when you view its icon on the desktop.

  • In addition to the letters and numbers, Mac OS X also assigns punctuation marks an "alphabetical order," like this: ' (the accent mark above the Tab key), ^, _, -, space, short and long dashes, comma, semicolon, !, ?, ', ", (, ), [, ], {, }, @, *, /, &, #, %, +, <, =, ??, >, |, ~, and $.

    Numbers come after punctuation; letters come next; and bringing up the rear are these characters: μ (Option-M); π (Option-P); Ω (Option-Z), and [image] (Shift-Option-K).

  • When it comes time to rename files en masse, add-on shareware can help you. A Better Finder Rename, for example, lets you manipulate file names in a batch— numbering them, correcting a spelling in dozens of files at once, deleting a certain phrase from their names, and so on. You can download this shareware from this book's "Missing CD" page at www.missingmanuals.com.


selecting_icons.html

2.3. Selecting Icons

To highlight a single icon in preparation for printing, opening, duplicating, or deleting, click the icon once. (In a list or column view, as described in Chapter 1, you can also click on any visible piece of information about that file—its size, kind, date modified, and so on.) Both the icon and the name darken in a uniquely Leopardish way.

Tip: You can change the color of the oval highlighting that appears around the name of a selected icon. Choose [image] rightwards double arrow System Preferences, click Appearance, and use the Highlight Color pop-up menu.)

Figure 2-3. You can highlight several icons simultaneously by dragging a box around them. To do so, drag from outside of the target icons diagonally across them (right), creating a translucent gray rectangle as you go. Any icons or icon names touched by this rectangle are selected when you release the mouse. If you press the Shift or key as you do this, any previously highlighted icons remain selected.

That much may seem obvious. But most first-time Mac users have no idea how to manipulate more than one icon at a time—an essential survival skill in a graphic interface like the Mac's.

2.3.1. Selecting by Clicking

To highlight multiple files in preparation for moving or copying, use one of these techniques:

  • To highlight all the icons. To select all the icons in a window, press [image] -A (the equivalent of the Edit rightwards double arrow Select All command).

  • To highlight several icons by dragging. You can drag diagonally to highlight a group of nearby icons, as shown in Figure 2-3. In a list view, in fact, you don't even have to drag over the icons themselves—your cursor can touch any part of any file's row, like its modification date or file size.

    Tip: If you include a particular icon in your diagonally dragged group by mistake, [image] -click it to remove it from the selected cluster.

  • To highlight consecutive icons in a list. If you're looking at the contents of a window in list view or column view, you can drag vertically over the file and folder names to highlight a group of consecutive icons, as described above. (Begin the drag in a blank spot.)

    There's a faster way to do the same thing: Click the first icon you want to highlight, and then Shift-click the last file. All the files in between are automatically selected, along with the two icons you clicked. Figure 2-4 illustrates the idea.

    Figure 2-4. Left: To select a block of files in list view, click the first icon. Then, while pressing Shift, click the last one. Mac OS X highlights all the files in between your clicks. This technique mirrors the way Shift-clicking works in a word processor and in many other kinds of programs.
    Right: To remove one of the icons from your selection, -click it.

  • To highlight random icons. If you want to highlight only the first, third, and seventh icons in a window, for example, start by clicking icon No. 1. Then [image] -click each of the others (or [image] -drag new rectangles around them). Each icon darkens to show that you've selected it.

    If you're highlighting a long string of icons and click one by mistake, you don't have to start over. Instead, just [image] -click it again, so that the dark highlighting disappears. (If you do want to start over, you can deselect all selected icons by clicking any empty part of the window—or by pressing the Esc key.)

    The [image] key trick is especially handy if you want to select almost all the icons in a window. Press [image] -A to select everything in the folder, then [image] -click any unwanted icons to deselect them.

GEM IN THE ROUGH
Shortcut Menus, Action Menus

It's part of the Mac's user-friendly heritage: You can do practically everything using only the mouse. Everything is out front, unhidden, and clickable, whether it's an icon, button, or menu.

But as in rival operating systems, you can shave seconds and steps off of your workload if you master shortcut menus: short menus that appear right on things you click and offer commands that the software thinks you might want to invoke at the moment, as shown here at top.

(They used to be called contextual menus, but Apple started calling them "shortcut menus" a few years ago, perhaps because that's what they're called in Windows and Unix.)

To summon a shortcut menu, you click something—an icon, the desktop, inside a window, a link in Safari, text in a word processor—while pressing the Control key. If you have a two-button mouse like Apple's standard Mighty Mouse right-clicking can do the same thing (Section P3.3.2).

A menu drops down listing relevant commands: Get Info, Move to Trash, Copy, and so on. You can either click the command you want, or type the first couple letters of it and then tap the Space bar.

These menus become more useful the more you get to know them. The trouble is, millions of Mac fans never even knew they existed.

That's why, starting in Mac OS X 10.3, Apple introduced a second way to access them. At the top of every Finder window, you'll find a [image] pop-up menu that's technically called the Action menu (shown here at bottom).

It lists the same sorts of commands you'd find in the shortcut menus, but offers two advantages. First, it's visible, so novices stand a better chance of stumbling onto it. Second, you don't need two hands to open it (one on the Control key, one on the mouse)—a distinct perk for anyone whose non-dominant hand is already occupied with a refreshing beverage.

Tip: In icon views, you can either Shift-click or [image] -click to select multiple individual icons. But you may as well just learn to use the [image] key when selecting individual icons. That way, you won't have to use a different key in each view.

Once you've highlighted multiple icons, you can manipulate them all at once. For example, you can drag them en masse to another folder or disk by dragging any one of the highlighted icons. All other highlighted icons go along for the ride. This technique is especially useful when you want to back up a bunch of files by dragging them onto a different disk, delete them all by dragging them to the Trash, and so on.

When multiple icons are selected, the commands in the File and Edit menus—such as Duplicate, Open, and Make Alias—apply to all of them simultaneously.

Tip: Don't forget that you can instantly highlight all the files in a window (or on the desktop) by choosing Edit rightwards double arrow Select All ( [image] -A)—no icon-clicking required.

2.3.2. Selecting Icons from the Keyboard

For the speed fanatic, using the mouse to click an icon is a hopeless waste of time. Fortunately, you can also select an icon by typing the first couple letters of its name.

When looking at your Home window, for example, you can type M to highlight the Movies folder. And if you actually intended to highlight the Music folder instead, press the Tab key to highlight the next icon in the window alphabetically. Shift-Tab highlights the previous icon alphabetically. Or use the arrow keys to highlight a neighboring icon.

(The Tab-key trick works only in icon, list, and Cover Flow views—not column view, alas. You can always use the leftwards double arrow and rightwards double arrow keys to highlight adjacent columns, however.)

After highlighting an icon this way, you can manipulate it using the commands in the File menu or their keyboard equivalents: open ( [image] -O), put it into the Trash ( [image] -Delete), Get Info ( [image] -I), duplicate ( [image] -D), or make an alias, as described later in this chapter ( [image] -L). By turning on the special disability features described on Section 9.1, you can even move the highlighted icon using only the keyboard.

If you're a first-time Mac user, you may find it excessively nerdy to memorize key-strokes for functions the mouse performs perfectly well. If you make your living using the Mac, however, memorizing these keystrokes will reward you immeasurably with speed and efficiency.


moving_and_copying_icons.html

2.4. Moving and Copying Icons

In Mac OS X, there are two ways to move or copy icons from one place to another: by dragging them, or by using the Copy and Paste commands.

2.4.1. Copying by Dragging

You can drag icons from one folder to another, from one drive to another, from a drive to a folder on another drive, and so on. (When you've selected several icons, drag any one of them; the others tag along.) While the Mac is copying, you can tell that the process is still under way even if the progress bar is hidden behind a window, because the icon of the copied material shows up dimmed in its new home, darkening only when the copying process is over. (You can also tell because Leopard's progress box is a lot clearer and prettier than it used to be.) You can cancel the process by pressing either [image] -period or the Esc key.

Tip: If you're copying files into a disk or folder that already contains items with the same names, Mac OS X asks you individually about each one. ("An older item named 'Fiddlesticks' with extension '.doc' already exists in this location.") Note that, thank heaven, Mac OS X tells you whether the version you're replacing is older or newer than the one you're moving.Turn on "Apply to all" if all of the incoming icons should (or should not) replace the old ones of the same names. Then click Replace or Don't Replace, as you see fit, or Stop to halt the whole copying business.

Understanding when the Mac copies a dragged icon and when it moves it bewilders many a beginner. However, the scheme is fairly simple (see Figure 2-5) when you consider the following:

  • Dragging from one folder to another on the same disk moves the icon.

  • Dragging from one disk (or disk partition) to another copies the folder or file. (You can drag icons either into an open window or directly onto a disk or folder icon.)

  • If you press the Option key as you release an icon you've dragged, you copy the icon instead of moving it. Doing so within a single folder produces a duplicate of the file called "[Whatever its name was] copy."

  • If you press the [image] key as you release an icon you've dragged from one disk to another, you move the file or folder, in the process deleting it from the original disk.

NOSTALGIA CORNER
Dragging to Copy a Disk

Help! I'm trying to copy a CD onto my hard drive. When I drag it onto the hard drive icon, I get only an alias–not a copy of the CD.

Sure enough, dragging a disk onto a disk creates an alias.

But producing a copy of the dragged icon is easy enough:

Just press Option or [image] as you drag.

Honestly, though: Why are you trying to copy a CD this way? Using Disk Utility (Section 10.30.9) saves space, lets you assign a password, and usually fools whatever software was on the CD into thinking that it's still on the original CD.

Tip: This business of pressing Option or [image] after you begin dragging is a tad awkward, but it has its charms. For example, it means that you can change your mind about the purpose of your drag in mid-movement, without having to drag back and start over.

And if it turns out you just dragged something into the wrong window or folder, a quick [image] -Z (the shortcut for Edit rightwards double arrow Undo) puts it right back where it came from.

2.4.2. Copying by Using Copy and Paste

Dragging icons to copy or move them probably feels good because it's so direct: You actually see your arrow cursor pushing the icons into the new location.

But you pay a price for this satisfying illusion. You may have to spend a moment or two fiddling with your windows to create a clear "line of drag" between the icon to be moved and the destination folder. (A background window will courteously pop to the foreground to accept your drag. But if it wasn't even open to begin with, you're out of luck.)

There's a better way. Use the Copy and Paste commands to move icons from one window into another (just as you can in Windows, by the way—except you can only copy, not cut, Mac icons). The routine goes like this:

  1. Highlight the icon or icons you want to move.

    Use any of the techniques described on Section 1.9.3.

  2. Choose Edit rightwards double arrow Copy.

    Or press the keyboard shortcut: -C.

    Tip: You can combine steps 1 and 2 by Control-clicking an icon and choosing the Copy command from the shortcut menu that appears—or by using the [image] menu (Section 2.3.1). If you've selected several icons, say five, the command will say "Copy 5 items."

  3. Open the window where you want to put the icons. Choose Edit rightwards double arrow Paste.

    Once again, you may prefer to use the keyboard equivalent: -V. And once again, you can also Control-click inside the window and then choose Paste from the shortcut menu that appears, or you can use the [image] menu.

A progress bar may appear as Mac OS X copies the files or folders; press Esc or [image] -period to interrupt the process. When the progress bar goes away, it means you've successfully transferred the icons, which now appear in the new window.

2.4.3. Dragging from the Title Bar

You may remember from Chapter 1 that the title bar of every Finder window harbors a secret pop-up menu. When you [image] -click it, you're shown a little folder ladder that delineates your current position in your folder hierarchy. You may also remember that the tiny icon just to the left of the window's name is actually a handle that you can drag to move a folder into a different window.

In most programs, you get the same features in document windows, as shown in Figure 2-5. For example, by dragging the tiny document icon next to the document's name, you can perform these two interesting stunts:

  • Drag to the desktop or the Dock. By dragging this icon to the desktop or onto a folder or disk icon, you create an instant alias of the document you're working on. (If you drag into the right end of the Dock, you can park the document's icon there, too.) This is a useful feature when, for example, you're about to knock off for the night, and you want easy access to whatever you've been working on when you return the next day.

  • Drag to the Dock. By dragging this title-bar icon into the Dock icon of an appropriate program, you open your document in that other program. For example, if you're in TextEdit working on a memo, and you decide that you'll need the full strength of Microsoft Word to dress it up, you can drag its title-bar icon directly onto the Word icon in the Dock. Word then launches and opens up the TextEdit document, ready for editing.

Note to struggling writers: Unfortunately, you can't drag an open document directly into the Trash.

2.4.4. Spring-Loaded Folders: Dragging Icons into Closed Folders

Here's a common dilemma: You want to drag an icon not just into a folder, but into a folder nested inside that folder. This awkward challenge would ordinarily require you to open the folder, open the inner folder, drag the icon in, and then close both of the windows you opened. As you can imagine, the process is even messier if you want to drag an icon into a sub-subfolder or even a sub-sub-subfolder.

Figure 2-5. Top: By dragging the document-window proxy icon, you can create an alias of your document on the desktop or anywhere else. (Make sure that the icon has darkened before you begin to drag.)
Bottom: If you -click the name of the document in its title bar, you get to see exactly where this document sits on your hard drive. (Choosing the name of one of these folders opens that folder and switches you to the Finder.)

Instead of fiddling around with all those windows, you can instead use the spring-loaded folders feature (Figure 2-6).

It works like this: With a single drag, drag the icon onto the first folder—but keep your mouse button pressed. After a few seconds, the folder window opens automatically, centered on your cursor:

  • In icon view, the new window instantly replaces the original.

  • In column view, you get a new column that shows the target folder's contents.

  • In list and Cover Flow views, a second window appears.

Figure 2-6. Top: To make spring-loaded folders work, start by dragging an icon onto a folder or disk icon. Don't release the mouse button. Wait for the window to open automatically around your cursor.
Bottom: Now you can either let go of the mouse button to release the file in its new window or drag it onto yet another, inner folder. It, too, will open. As long as you don't release the mouse button, you can continue until you've reached your folder within-a-folder destination.

Still keeping the button down, drag onto the inner folder; its window opens, too. Now drag onto the inner inner folder—and so on. (If the inner folder you intend to open isn't visible in the window, you can scroll by dragging your cursor close to any edge of the window.)

Tip: You can even drag icons onto disks or folders whose icons appear in the Sidebar (Chapter 1). When you do so, the main part of the window flashes to reveal the contents of the disk or folder you've dragged onto. When you let go of the mouse, the main window changes back to reveal the contents of the disk or folder where you started dragging.In short, Sidebar combined with spring-loaded folders make a terrific drag-and-drop way to file a desktop icon from anywhere to anywhere–without having to open or close any windows at all.

When you finally release the mouse, you're left facing the final window. All the previous windows closed on the way. You've neatly placed the icon into the core of the nested folders.

2.4.5. Making Spring-Loaded Folders Work

That spring-loaded folder technique sounds good in theory, but can be disconcerting in practice. For most people, the long wait before the first folder opens is almost enough wasted time to negate the value of the feature altogether. Furthermore, when the first window finally does open, you're often caught by surprise. Suddenly your cursor—mouse button still down—is inside a window, sometimes directly on top of another folder you never intended to open. But before you can react, its window, too, has opened, and you find yourself out of control.

POWER USERS' CLINIC
Designing Your Own Icons

You don't have to be content with the icons provided by Microsoft, Apple, or whoever else wrote your software. You can paste new icons onto your file, disk, and folder icons to help you pick them out at a glance.

The easiest way to replace an icon is to copy it from another icon. To do so, highlight the icon, hold down the Option key and choose File rightwards double arrow Show Inspector (see Section 2.7.1). In the resulting window, click the existing icon, and then choose Edit rightwards double arrow Copy.

Next, click the icon to which you want to transfer the copied picture. Its icon now appears in the Info dialog box that's still open on the screen. Click the icon in the dialog box, and this time choose Edit rightwards double arrow Paste.

If you'd rather introduce all-new icons, you're welcome to steal some of the beautifully designed ones waiting atwww.iconfactory.comand the icon sites linked to it.

Once you've downloaded these special icon files, you can copy their images from the Get Info window as you would any icon.

To design a Mac OS X icon from scratch, use a graphics program like Photoshop or the shareware favorite Graphic-Converter.

Once you've saved your icon file, select it, and then copy and paste its icon using the Show Inspector method described above.

Note that you can't change certain folder icons that Mac OS X considers important, such as Applications or System.

You can, however, change the special Mac OS X folder icons in your Home folder—Pictures, Documents, and so on, and your hard drive icon. You're also not allowed to change icons that belong to other people who share your Mac and sign in under a different name (Chapter 12).

Fortunately, you can regain control of spring-loaded folders using these tricks:

  • Choose Finder rightwards double arrow Preferences. On the General pane, adjust the "Spring-loaded folders and windows" Delay slider to a setting that drives you less crazy. For example, if you find yourself waiting too long before the first folder opens, drag the slider toward the Short setting.

  • You can turn off this feature entirely by choosing Finder rightwards double arrow Preferences and turning off the "Spring-loaded folders and windows" checkbox.

  • Tap the Space bar to make the folder spring open at your command. That is, even with the Finder rightwards double arrow Preferences slider set to the Long delay setting, you can force each folder to spring open when you are ready by tapping the Space bar as you hold down the mouse button. True, you need two hands to master this one, but the control you regain is immeasurable.

    Tip: The Space bar trick works even when "Spring-loaded folders and windows" checkbox (in Finder rightwards double arrow Preferences) is turned off. That's a handy arrangement, because it means that folder windows never pop open accidentally.

  • Whenever a folder springs open into a window, twitch your mouse up to the newly opened window's title bar or down to its information strip. Doing so ensures that your cursor won't wind up hovering on, and accidentally opening up, an inner folder. With the cursor parked on the gradient gray, you can take your time to survey the newly opened window's contents, and plunge into an inner folder only after gaining your bearings.

    Tip: Email programs like Entourage and Mail have spring-loaded folders, too. You can drag a message out of the list and into one of your filing folders, wait for the folder to spring open and reveal its subfolders, and then drag it directly into one of them.

2.4.6. Aliases: Icons in Two Places at Once

Highlighting an icon and then choosing File rightwards double arrow Make Alias (or pressing [image] -L), generates an alias, a specially branded duplicate of the original icon (Figure 2-7). It's not a duplicate of the file—just of the icon; therefore it requires negligible storage space. When you double-click the alias, the original file opens. (A Macintosh alias is essentially the same as a Windows shortcut.)

Because you can create as many aliases as you want of a single file, aliases let you, in effect, stash that file in many different folder locations simultaneously. Double-click any one of them, and you open the original icon, wherever it may be on your system.

Tip: You can also create an alias of an icon by Option- [image] -dragging it out of its window. (Aliases you create this way lack the word alias on the file name—a distinct delight to those who find the suffix redundant and annoying.) You can also create an alias by Control-clicking (or right-clicking) a normal icon and choosing Make Alias from the shortcut menu that appears, or by highlighting an icon and then choosing Make Alias from the [image] menu.

2.4.7. What's Good about Aliases

An alias takes up almost no disk space, even if the original file is enormous. Aliases are smart, too: even if you rename the alias, rename the original file, move the alias, and move the original around on the disk, double-clicking the alias still opens the original icon.

And that's just the beginning of alias intelligence. Suppose you make an alias of a file that's on a removable disc, like a CD. When you double-click the alias on your hard drive, the Mac requests that particular disc by name. And if you double-click the alias of a file on a different machine on the network, your Mac attempts to connect to the appropriate machine, prompting you for a password (see Chapter 13)—even if the other machine is thousands of miles away and your Mac must dial the modem to connect.

Here are a few ways you can put aliases to work:

  • You may want to file a document you're working on in several different folders, or place a particular folder in several different locations.

    NOSTALGIA CORNER
    Favorites Reborn

    Hey! Where the heck are my Favorites?

    Skipped a couple versions of Mac OS X, did you?

    A few versions back, the File rightwards double arrow Add to Favorites command placed the names of icons you've highlighted into a submenu of the Go rightwards double arrow Favorites command. The Favorites scheme, in other words, was yet another mechanism of listing your favorite files, folders, programs, disks, and even network-accessible folders for quick access.

    Trouble was, Mac OS X already had a number of different methods for stashing favorite icons for convenient access, like the Dock, the Finder toolbar, and the Sidebar. So Apple decided that enough was enough; it hid the Add to Favorites command. It's now in your File menu only if you press the Shift key.

    There is, however, still a Favorites folder. It's sitting right there in your Home rightwards double arrow Library folder.

    If you miss this feature—maybe you upgraded from Mac OS X 10.2 and you've got a bunch of stuff already listed in your Favorites—you'll find the new scheme to be much simpler.

    First drag the Favorites folder into your Sidebar.

    From now on, whenever you want to designate an icon as a Favorite, drag it onto the Favorites folder icon in your Sidebar. (Or Option- [image] -drag it to create an alias, or use the hidden File rightwards double arrow Add to Favorites command, or press Shift- [image] -T.)

    Thereafter, to view your collection of faves, just click the Favorites icon.

    This new system is both simpler and easier to understand than the previous mechanism. In fact, this feature may become one of your…favorites.

  • You can use the alias feature to save you some of the steps required to access another hard drive on the network. (Details on this trick in Chapter 13.)

Tip: Mac OS X makes it easy to find the file to which an alias "points" without actually having to open it. Just highlight the alias and then choose File rightwards double arrow Show Original ( [image] -R), or choose Show Original from the [image] menu. Mac OS X immediately displays the actual, original file, sitting patiently in its folder, wherever that may be.

2.4.8. Broken Aliases

An alias doesn't contain any of the information you've typed or composed in the original. Don't email an alias to the Tokyo office and then depart for the airport, hoping to give the presentation upon your arrival in Japan. When you double-click the alias, now separated from its original, you'll be shown the dialog box at bottom in Figure 2-7.

If you're on a plane 3,000 miles away from the hard drive on which the original file resides, click Delete Alias (to delete the orphan alias you just double-clicked) or OK (to do nothing, leaving the orphaned alias where it is).

Figure 2-7. Top: You can identify an alias by the tiny arrow badge on the lower-left corner. (Longtime Mac fans should note that the name no longer appears in italics.)
Bottom: If the alias can't find the original file, you're offered the chance to hook it up to a different file.

In certain circumstances, however, the third button—Fix Alias—is the most useful. Click it to summon the Fix Alias dialog box, which you can use to navigate your entire Mac. When you click a new icon and then click Choose, you associate the orphaned alias with a different original icon.

Such techniques become handy when, for example, you click your book manuscript's alias on the desktop, forgetting that you recently saved it under a new name and deleted the older draft. Instead of simply showing you an error message that says "'Enron Corporate Ethics Handbook' can't be found," the Mac displays the box that contains the Fix Alias button. By clicking it, thus reassociating it with the new document, you can save yourself the trouble of creating a new alias. From now on, double-clicking your manuscript's alias on the desktop opens the new draft.

Tip: You don't have to wait until the original file no longer exists before choosing a new original for an alias. You can perform alias reassignment surgery any time you like. Just highlight the alias icon and then choose File rightwards double arrow Get Info. In the Get Info dialog box, click Select New Original. In the resulting window, find and double-click the file you'd now like to open whenever you double-click the alias.


color_labels.html

2.5. Color Labels

Mac OS X 10.5 includes a welcome blast from the Mac's distant past: icon labels. This feature lets you tag selected icons with one of seven different labels, each of which has both a text label and a color associated with it.

To do so, highlight the icons. Open the File menu (or the [image] menu, or the shortcut menu that appears when you Control-click/right-click the icons). There, under the heading Color Label, you'll see seven colored dots, which represent the seven different labels you can use. Figure 2-8 shows the routine.

2.5.1. What Labels Are Good For

After you've applied labels to icons, you can perform some unique file-management tasks—in some cases, on all of them simultaneously, even if they're scattered across multiple hard drives. For example:

Figure 2-8. Use the File menu, menu, or shortcut menu to apply label tags to highlighted icons.
Instantly, the icon's name takes on the selected shade. In a list or column view, the entire row takes on that shade, as shown in Figure 2-9. (If you choose the little X, you're removing any labels that you may have applied.)

  • Round up files with Find. Using the Find command described in Chapter 3, you can round up all icons with a particular label. Thereafter, moving these icons atonce is a piece of cake—choose Edit rightwards double arrow Select All, and then drag any one of the highlighted icons out of the results window and into the target folder or disk.

    Using labels in conjunction with Find this way is one of the most useful and inexpensive backup schemes ever devised—whenever you finish working on a document that you'd like to back up, Control-click it and apply a label called, for example, Backup. At the end of each day, use the Find command to round up all files with the Backup label—and then drag them as a group onto your backup disk.

  • Sort a list view by label. No other Mac sorting method lets you create an arbitrary order for the icons in a window. When you sort by label, the Mac creates alphabetical clusters withineach label grouping, as shown in Figure 2-9.

    This technique might be useful when, for example, your job is to process several different folders of documents; for each folder, you're supposed to convert graphics files, throw out old files, or whatever. As soon as you finish working your way through one folder, flag it with a label called Done. The folder jumps to the top (or bottom) of the window, safely marked for your reference pleasure, leaving the next unprocessed folder at your fingertips, ready to go.

    Figure 2-9. Sorting by label lets you create several different alphabetical groups within a single window. In Leopard, in fact, you can sort by labels in any view (icon, column, whatever), using the View rightwards double arrow Show View Options palette.
    In a list view, the quickest way to sort by label is to first make the label column visible. Do so by choosing View rightwards double arrow Show View Options and turning on the Label checkbox.

  • Track progress. Use different color labels to track the status of files in a certain project. The first drafts have no labels at all. Once they've been edited and approved, make them blue. Once they've been sent to the home office, they turn purple.(Heck, you could have all kinds of fun with this: Money-losing projects get red tints; profitable ones get green; things that make you sad are blue. Or maybe not.)

2.5.2. Changing Labels

When you first install Mac OS X, the seven labels in the File menu are named for the colors they show: Red, Orange, Yellow, and so on. Clearly, the label feature would be much more useful if you could rewrite these labels, tailoring them to your purposes.

Doing so is easy. Choose Finder rightwards double arrow Preferences. Click the Labels button. Now you see the dialog box shown in Figure 2-10, where you can edit the text of each label.

Figure 2-10. Top left: In the Labels tab of the Preferences dialog box, you can change the predefined label text. Each label can be up to 31 letters and spaces long.
Bottom right: Now your list and column views reveal meaningful text tags instead of color names.


the_trash.html

2.6. The Trash

No single element of the Macintosh interface is as recognizable or famous as the Trash can, which now appears at the end of the Dock.

You can discard almost any icon by dragging it onto the Trash icon (actually a wastebasket, not a trash can, but let's not quibble). When the tip of your arrow cursor touches the Trash icon, the little wastebasket turns black. When you release the mouse, you're well on your way to discarding whatever it was you dragged. As a convenience, Mac OS X even replaces the empty-wastebasket icon with a wastebasket-filled-with crumpled-up-papers icon, to let you know there's something in there.

Tip: Learn the keyboard alternative to dragging something to the Trash: Highlight the icon, and then press [image] -Delete. This technique is not only far faster than dragging, but requires far less precision, especially if you have a large screen. Mac OS X does all the Trash-targeting for you.

2.6.1. Rescuing Files and Folders from the Trash

File and folder icons sit in the Trash forever—or until you choose Finder rightwards double arrow Empty Trash, whichever comes first.

If you haven't yet emptied the Trash, you can open its window by clicking the wastebasket icon once. Now you can review its contents: icons that you've placed on the waiting list for extinction. If you change your mind, you can rescue any of these items by dragging them out of the Trash window.

Tip: If dragging something to the Trash was the last thing you did, you can press [image] -Z—the keyboard shortcut of the Edit rightwards double arrow Undo command. This not only removes it from the Trash, but also returns it to the folder from which it came. This trick works even if the Trash window isn't open.

2.6.2. Emptying the Trash I: Quick and Easy

If you're confident that the items in the Trash window are worth deleting, use any of these three options:

  • Choose Finder rightwards double arrow Empty Trash.

  • Press Shift- [image] -Delete. Or, if you'd just as soon not bother with the "Are you sure?" message, throw the Option key in there, too.

  • Control-click the wastebasket icon (or right-click it, or just click it and hold the mouse button down for a moment); choose Empty Trash from the shortcut menu.

Tip: This last method has two advantages. First, the Mac doesn't bother asking "Are you sure?" (If you're clicking right on the Trash and choosing Empty Trash from the pop-up menu, it's pretty darned obvious you are sure.) Second, this method nukes any locked files without making you unlock them first.

If you use either of the first two methods, the Macintosh asks you to confirm your decision. Click OK. (Figure 2-11 shows both this message and the secret for turning it off forever.)

Either way, Mac OS X now deletes those files from your hard drive.

2.6.3. Emptying the Trash II: Secure and Forever

When you empty the Trash as described above, each Trashed icon sure looks like it disappears. The truth is, though, that the data in each file is still on the hard drive. Yes, the space occupied by the dearly departed is now marked with an internal "This space available" message, and in time, new files that you save may overwrite that spot. But in the meantime, some future eBay buyer of your Mac—or, more imminently, a savvy family member or office mate—could use a program like Norton Utilities to resurrect those deleted files. (In more dire cases, companies like DriveSavers.com can use sophisticated clean-room techniques to recover crucial information—for several hundred dollars, of course.)

That notion doesn't sit well with certain groups, like government agencies, international spies, and the paranoid. As far as they're concerned, deleting a file should really , really delete it, irrevocably, irretrievably, and forever.

Mac OS X has a command, therefore, called Secure Empty Trash. When you choose this command from the Finder menu, the Mac doesn't just obliterate the parking spaces around the dead file. It actually records new information over the old—random 0's and 1's. Pure static gibberish.

The process takes longer than the normal Empty Trash command, of course. But when it absolutely, positively has to be gone from this earth for good (and you're absolutely, positively sure you'll never need that file again), Secure Empty Trash is secure indeed.

2.6.4. Locked Files: The Next Generation

By highlighting a file or folder, choosing File rightwards double arrow Get Info, and turning on the Locked checkbox, you protect that file or folder from accidental deletion (see Figure 2-11 at bottom). A little padlock icon appears on the corner of the full-size icon, also shown in Figure 2-11.

Figure 2-11. Top: Your last warning. Mac OS X doesn't tell you how many items are in the Trash or how much disk space they take up.
If you'd rather not be interrupted for confirmation every time you empty the Trash, you can suppress this message permanently.
To do that, choose File rightwards double arrow Preferences, click Advanced, and turn off "Show warning before emptying the Trash."
Bottom: The Get Info window for a locked file. Locking a file in this way isn't military level security by any stretch–any passing evildoer can unlock the file in the same way. But it does trigger an "operation cannot be completed" warning when you try to put it into the Trash–or indeed when you try to drag it into any other folder–providing at least one layer of protection against mistakes.

Mac OS X doesn't even let you put a locked icon into the Trash—or any other folder. You can't put the icon of an open program into the Trash, either.

If something that's already in the Trash turns out to be locked, click and hold on the Trash itself. Now, when you choose Empty Trash from its shortcut menu, Mac OS X empties the Trash without warnings, locked files and all.

Of course, the other alternative is to unlock what's in the Trash. Fortunately, there's a quick way to do so. Click the Trash icon to open its window, then highlight the icons you want to unlock (or choose Edit rightwards double arrow Select All).

Now press Option- [image] -I (or press Option as you choose File rightwards double arrow Show Inspector). Turn off the Locked checkbox in the resulting Info window. (Yes, you can lock or unlock a mass of files at once.) Now you can send the newly unprotected files to data heaven without any fancy tricks.

(If you're having trouble emptying the Trash, see Chapter 17 for some helpful Unix commands.)


get_info.html

2.7. Get Info

By clicking an icon and then choosing File rightwards double arrow Get Info, you open an important window like the one shown in Figure 2-12. It's a collapsible, multipanel screen that provides a wealth of information about a highlighted icon. For example:

  • For a document icon, you see when it was created and modified, and what programs it "belongs" to.

  • For an alias, you learn the location of the actual icon it refers to.

  • For a program, you see whet her or not it's been updated to run on Intel-based Macs. If so, the Get Info window says Kind: Universal. If not, it says Kind: PowerPC, and will probably run slower than you'd like because it must be translated by Rosetta (Section P3.3.1).

  • For a disk icon, you get statistics about its capacity and how much of it is full.

    GEM IN THE ROUGH
    Opening Things in the Trash

    Now and then, it's very useful to see what some document in the Trash is before committing it to oblivion—and the only way to do that is to open it.

    Trouble is, you can't open it by double-clicking; you'll get nothing but an error message.

    Or at least that's what Apple wants you to think.

    There is, of course, a workaround or two. First of all, you can use Quick Look (Section 1.8) to inspect something in the Trash.

    Or, if Quick Look can't open the file–or if you want to edit it instead of just reading it–drag the document onto the icon of a program that can open it. That is, if a file called Don't Read Me.txt is in the Trash, you can drag it onto, say, the Word or TextEdit icon in your Dock.

    The document dutifully pops open on the screen. Inspect, close, and then empty the Trash (or rescue the document).

  • If you open the Get Info window when nothing is selected, you get information about the desktop itself (or the open window), including the amount of disk space consumed by everything sitting on or in it.

  • If you highlight 11 icons or more simultaneously, the Get Info window shows you how many you highlighted, breaks it down by type ("23 documents, 3 folders," for example), and adds up the total of their file sizes. That's a great opportunity to change certain file characteristics on numerous files simultaneously, such as locking or unlocking them, hiding or showing their filename extensions (Section 5.6), changing their ownership or permissions (Section 13.2.2), and so on.

If you highlight fewer than 11 icons, Mac OS X opens up individual Get Info windows for each one.

2.7.1. Uni-window vs. Multi window

In Mac OS X versions 10.0 and 10.1, a single Get Info window remained on the screen all the time as you clicked one icon after another. (Furthermore, the command was called Show Info instead of Get Info. Evidently "Show Info" sounded too much like it was the playbill for a Broadway musical.)

The single info window—officially called the Inspector—was great for reducing clutter, but it didn't let you compare the statistics for the Get Info windows of two or three folders side by side.

So then, beginning in 10.2, Apple returned to the old way of doing Get Info: A new dialog box appears each time you get info on an icon (unless you've highlighted 11 or more icons, as described above).

UP TO SPEED
Compressing, Zipping, and Archiving

Mac OS X comes with a built-in command that compresses a file or folder down to a single, smaller icon–an archive– suitable for storing or emailing.

It's just like using StuffIt in previous Mac OS versions, except for two big changes. First, Mac OS X creates .zip files, the same compression format used in Windows. That means that you can now send .zip files back and forth to PC owners without worrying that they won't be able to open them. In Leopard, these files open even more reliably in Windows. (Pre-Panther/Tiger/Leopard Mac owners can open .zip files, too. They just use the free StuffIt Expander as usual.)

Second, the software that does the compressing is built right in. Control-click (or right-click) a file or folder, and choose "Compress [the icon's name]" from the shortcut menu. (Of course, you can use the File menu or [image] menu instead.)

Mac OS X thoughtfully creates a .zip archive, but leaves the original behind so you can continue working with it.

Opening a .zip file somebody sends you is equally easy: Just double-click it. Zip!—it opens.

On the other hand, Leopard does not come with StuffIt Expander, the free unstuffing program that recognizes .zip files, .sit files, and just about any other form of compressed files.

If you don't already have a copy of Expander from a previous Mac OS version, you can download and install it yourself, which is worth doing. You can get it from, for example, this book's "Missing CD" page at www.missingmanuals.com.

But the uni-window approach is still available for those occasions when you don't need side-by-side Get Info windows—if you know the secret. Highlight the icon and then press Option- [image] -I (or hold down Option and choose Show Inspector from the File menu). The Get Info Inspector window that appears looks slightly different (it has a smaller title bar and a dimmed Minimize button), and it changes to reflect whatever icons you now click.

2.7.2. The Get Info Panels

Apple built the Get Info window out of a series of collapsed "flippy triangles," as shown in Figure 2-12. Click a triangle to expand a corresponding information panel.

Figure 2-12. Top: The Get Info window can be as small as this, with all of its information panes collapsed.
Bottom: Or it can be as huge as this—it's shown here split in two because the book isn't tall enough to show the whole thing—if you click each flippy triangle to open its corresponding panel of information. The resulting dialog box can easily grow taller than your screen, which is a good argument for either (a) closing the panels you don't need at any given moment or (b) running out to buy a really gigantic monitor.
And as long as you're taking the trouble to read this caption, here's a tasty bonus: There's a new, secret command in Leopard called Get Summary Info. Highlight a group of icons, press Control- -I, and marvel at the special Get Info box that tallies up their sizes and other characteristics.

Depending on whether you clicked a document, program, disk, alias, or whatever, the various panels may include the following:

  • Spotlight Comments. Here, you can type in random comments for your own reference. Later, you can view these remarks in any list view, if you display the Comments column (Section 1.5.3)—and find them when you conduct Spotlight searches.

  • General. Here's where you can view (and edit) the name of the icon, and also see its size, creation date, most recent change date, locked status, and so on.

    If you click a disk, this info window shows you its capacity and how full it is. If you click the Trash, you see how much stuff is in it. If you click an alias, this panel shows you a Select New Original button and reveals where the original file is. The General panel always opens the first time you summon the Get Info window.

  • More Info. Just as the name implies, here you'll find more info, most often the dimensions and color format (graphics only) and when the icon was last opened. These morsels are also easily Spotlight-searchable.

  • Name & Extension. On this panel, you can read and edit the name of the icon in question. The "Hide extension" checkbox refers to the suffix on Mac OS X file names (the last three letters of Letter to Congress.doc, for example).

    Many Mac OS X documents, behind the scenes, have filename extensions of this kind—but Mac OS X comes factory-set to hide them. By turning off this checkbox, you can make the suffix reappear for an individual file. (Conversely, if you've elected to have Mac OS X show all file name suffixes, this checkbox lets you hide filename extensions on individual icons.)

  • Open with. This section is available for documents only. Use the controls on this screen to specify which program will open when you double-click this document, or all documents of its type. (Details on Section 5.6.)

  • Preview. When you're examining pictures, text files, PDF files, Microsoft Office files, sounds, clippings, and movies, you see a magnified thumbnail version of what's actually in that document. This Preview is like a tiny version of Quick Look (Section 1.8). A controller lets you play sounds and movies, where appropriate.

  • Languages. The menus and dialog boxes of well-written Mac OS X programs (iMovie and iPhoto, for example) appear by magic in whatever language you choose. The trouble is, your hard drive carries a lot of baggage as a result; it must store the wording for every menu and dialog box in every language.

    If you're pretty sure you do most of your computing in just one language, expand the Languages tab, select all of the languages you don't speak, and click Remove. You can reclaim a lot of hard-drive space this way.

  • Sharing & Permissions. This is available for all kinds of icons. If other people have access to your Mac (either from across the network or when logging in, in person), this panel lets you specify who is allowed to open or change this particular icon. See Chapter 12 for a complete discussion of this hairy topic.

Here and there, you may even see other panels in the Get Info window, especially when you get info on application icons. For example, iPhoto and iDVD each offer a Plugins panel that lets you manage add-on software modules.

The title-bar hierarchical menu described on Section 1.2.3 works in the Get Info dialog box, too. That is, [image] -click the Get Info window's title bar to reveal where this icon is in your folder hierarchy.


spotlight.html

Chapter 3. Spotlight

Every computer offers a way to find files. And every system offers several different ways to open them. But Spotlight, a star feature of Mac OS X (and beefed up in Leopard), combines these two functions in a way that's so fast, so efficient, so spectacular, it reduces much of what you've read in the previous chapters to irrelevance.

That may sound like breathless hype, but wait till you try it. You'll see.

3.1. The Spotlight Menu

See the little magnifying-glass icon in your menu bar? That's the mouse-driven way to open the Spotlight search box.

The other way is to press [image] -Space bar. If you can memorize only one keystroke on your Mac, that's the one to learn. It works both at the desktop and in other programs.

Tip: You can designate one of your F-keys (top row of the keyboard) to open Spotlight, if you prefer. Choose [image] rightwards double arrow System Preferences, click Spotlight, and use the "Spotlight menu keyboard shortcut" pop-up menu.

In any case, the Spotlight text box appears just below your menu bar (Figure 3-1).

Begin typing to identify what you want to find and open. For example, if you're trying to find a file called Pokémon Fantasy League.doc, typing just pok or leag would probably suffice. (Spotlight doesn't find text in the middles of words, though; it searches from the beginnings of words.)

A menu immediately appears below the search box, listing everything Spotlight can find containing what you've typed so far. (This is a live, interactive search; that is, Spotlight modifies the menu of search results as you type.) The menu lists every file, folder, program, email message, address book entry, calendar appointment, picture, movie, PDF document, music file, Web bookmark, Microsoft Office (Word, PowerPoint, Excel, Entourage) document, System Preferences panel, To Do item, chat transcript, Web site in your History list, and even font that contains what you typed, regardless of its name or folder location.

Figure 3-1. Left: Press -Space, or click the magnifying-glass icon, to make the search bar appear.
Right: As you type, Spotlight builds the list of every match it can find, neatly organized by
type: programs, documents, folders, images, PDF documents, and so on.

If you see the icon you were hoping to dig up, just click it to open it. Or use the arrow keys to "walk down" the menu, and then press Return or Enter to open it.

If you click an application, it pops onto the screen. If you select a System Preferences panel, System Preferences opens and presents that panel. If you choose an appointment, the iCal program opens, already set to the appropriate day and time. Selecting an email message opens that message in Mail or Entourage. And so on.

Spotlight is so fast, it eliminates a lot of the folders-in-folders business that's a side effect of modern computing. Why burrow around in folders when you can open any file or program with a couple of keystrokes?

3.1.1. Spotlight-Menu Tips

It should be no surprise that a feature as important as Spotlight comes loaded with options, tips, and tricks. Here it is—the official, unexpurgated Spotlight Tip-O-Rama:

  • If the very first item—labeled Top Hit—is the icon you were looking for, just press Return or Enter to open it. (That's a change in Leopard; adding the [image] key is no longer necessary.)

    This is a huge deal, because it means that in most cases, you can perform the entire operation without ever taking your hands off the keyboard.

    To open Safari in a hurry, for example, press [image] -Space bar (to open the Spotlight bar), type safa, and hit Enter, all in rapid-fire sequence, without even looking. Presto: Safari is before you.

    (The only wrinkle here is that the Spotlight menu may still be building itself. If you go too quickly, you may be surprised as another entry jumps into the top slot just as you're about to hit Enter—and you wind up opening the wrong thing. Over time, you develop a feel for when the Top Hit is reliably the one you want.)

    GEM IN THE ROUGH
    Sweet Spotlight Serendipity: Equations and Definitions

    In Mac OS X 10.5, Spotlight has been given two quiet enhancements that turn it into a different beast altogether.

    First, it's a tiny pocket calculator, always at the ready. Click in the Search box, type or paste 38*48.2-7+55, and marvel at the first result in the Spotlight menu: 1879.6. There's your answer—and you didn't even have to fire up the Calculator.

    (For shorter equations—only a few characters long—the first result in the Spotlight menu shows the entire equation, like .15*234=35.1.)

    And it's not just a four-function calculator, either. It works with square roots: Type sqrt(25), and you'll get the answer 5. It also works with powers: Type pow(6,6)—that is, 6 to the power of 6—and you'll get 46656.

    You can even type pi to represent—you know, pi.

    For a complete list of math functions in Spotlight, open Terminal (see Chapter 16), type man math, and press Enter.

    Second, the Spotlight menu is now a full-blown English dictionary. Or, more specifically, it's wired directly into Mac OS X's own dictionary, which sits in your Applications folder.

    So if you type, for example, schadenfreude in to the Spotlight box, you'll see, to your amazement, the beginning of the actual definition right there in the menu. Click it to open Dictionary and read the full-blown entry. (In this example, that would be: "noun: pleasure derived by someone from another person's misfortune.")

    And what, exactly, is the Top Hit? Mac OS X chooses it based on its relevance (the importance of your search term inside that item) and timeliness (when you last opened it).

    Tip: In Leopard more than ever, Spotlight makes a spectacular application launcher. That's because, as you'll notice, Job #1 for Spotlight is to display the names of matching programs in the results menu. Their names appear in the list nearly instantly—long before Spotlight has built the rest of the menu of search results.If some program on your hard drive doesn't have a Dock icon, for example—or even if it does—there's no faster way to open it than to use Spotlight.

  • To jump to a search result's Finder icon instead of opening it, [image] -click its name.

  • Spotlight's menu shows you only 20 of the most likely suspects, evenly divided among the categories (Documents, Applications, and so on). The downside: To see the complete list, you have to open the Spotlight window (Section 3.2).

    The upside: It's fairly easy to open something in this menu from the keyboard. Just press [image] -down arrow (or [image] -up arrow) to jump from category to category. Once you've highlighted the first result in a category, you can walk through the remaining four by pressing the arrow key by itself. Then, once you've highlighted what you want, press Return or Enter to open it.

    In other words, you can get to anything in the Spotlight menu with only a few keystrokes.

  • The Esc key (top-left corner of your keyboard) offers a two-stage "back out of this" method. Tap it once to close the Spotlight menu and erase what you've typed, so that you're all ready to type in something different. Tap Esc a second time to close the Spotlight text box entirely, having given up on the whole idea of searching.

    (If you just want to cancel the whole thing in one step, press [image] -Space bar again, or [image] -period, or [image] -Esc.)

  • Think of Spotlight as your little black book. When you need to look up a number in Address Book, don't bother opening Address Book; it's faster to use Spotlight. You can type somebody's name or even part of someone's phone number.

  • Among a million other things, Spotlight tracks the keywords and descriptions you've applied to your pictures in iPhoto. As a result, you can find, open, or insert any iPhoto photo at any time, no matter what program you're using, just by using the Spotlight box at the top of every Open File dialog box (Section 5.8.5)! This is a great way to insert a photo into an outgoing email message, a presentation, or a Web page you're designing. iPhoto doesn't even have to be running.

  • Spotlight is also a quick way to adjust one of your Mac's preference settings. Instead of opening up the System Preferences program, type the first few letters of, say, volume or network or clock into Spotlight. The Spotlight menu lists the appropriate System Preferences panel, so you can jump directly to it.

  • If you point to an item in the Spotlight menu without clicking, a little tooltip balloon appears. It tells you the item's actual name—which is useful if Spotlight listed something because of text that appears inside the file, not its name—and its folder path (that is, where it is on your hard drive).

  • The Spotlight menu lists 20 found items. In the following pages, you'll learn about how to see the rest of the stuff. But for now, note that you can eliminate some of the categories that show up here (like PDF Documents or Bookmarks), and even rearrange them, to permit more of the other kinds of things to enjoy those 20 seats of honor. Details on Section 3.3.

    UP TO SPEED
    What Spotlight Knows

    The beauty of Spotlight is that it doesn't just find files whose names match what you've typed. That would be so 2004!

    No, Spotlight actually looks inside the files. It can actually read and search the contents of text files, RTF and PDF documents, and documents from iWork, Keynote, Pages, Photoshop, and Microsoft Office (Word, Excel, Entourage, and PowerPoint).

    As time goes on, software companies release bits of addon software—plugins—that make their documents searchable by Spotlight too. Check in periodically at, for example, www.apple.com/downloads/macosx/spotlight, to look for Spotlight plug-ins relevant to the kind of work you do. For example, free Spotlight plug-ins are available for OmniGraffle, OmniOutliner, TypeIt4Me, MacDraft, REALBasic, Painter, Wolfram Notebook, and many others.

    But that's only the beginning. Spotlight searches files not only for the text inside them, but also for over 125 other bits of text—a staggering collection of information tidbits including the names of the layers in a Photoshop document, the tempo of an MP3 file, the shutter speed of a digital-camera photo, a movie's copyright holder, a document's page size, and on and on.

    Technically, this sort of secondary information is called metadata. It's usually invisible, although a lot of it shows up in the Get Info dialog box described in Chapter 2.

    You might think that typing something into the Spotlight bar triggers a search. But to be technically correct, Spotlight has already done its searching. In the first 15 to 30 minutes after you install Mac OS X—or in the minutes after you attach a new hard drive—Spotlight invisibly collects information about everything on your hard drive. Like a kid cramming for an exam, it reads, takes notes on, and memorizes the contents of all of your files. (During this time, if you click the Spotlight icon on the menu bar, you'll be told that Spotlight is indexing the drives.) Once it has indexed your hard drive in this way, Spotlight can produce search results in seconds.

    After that initial indexing process, Spotlight continues to monitor what's on your hard drive, indexing new and changed files in the background, in the microseconds between your keystrokes and clicks in other programs.

  • Spotlight shows you only the matches from your account and the public areas of the Mac (like the System, Application, and Developer folders)—but not what's in anyone else's Home folder. If you were hoping to search your spouse's email for phrases like "meet you at midnight," forget it.

  • If Spotlight finds a different version of something on each of two hard drives, it lets you know by displaying a faint gray hard drive name after each such item in the menu.

  • Spotlight works by storing an index, a private, multimegabyte Dewey Decimal system, on each hard drive, disk partition, or USB flash (memory) drive. If you have some oddball type of disk, like a hard drive that's been formatted for Windows, Spotlight doesn't ordinarily index it—but you can turn on indexing by using the File rightwards double arrow Get Info command on that drive's icon and turning indexing on manually.

    Tip: In Leopard, Spotlight can even find words inside of files on other computers on your network—as long as they're also Macs running Leopard. If not, Spotlight can only search for the names of files on other networked computers.

  • If you point to some thing in the results list without clicking, you can press [image] -Ito open the Get Info window for that item.

3.1.2. Advanced Menu Searches

Most people just type the words they're looking for into the Spotlight box. But if that's all you type, you're missing a lot of the fun.

3.1.2.1. Use quotes

If you type more than one word, Spotlight works just the way Google does. That is, it finds things that contain both words somewhere inside.

But if you're searching for a phrase where the words really belong together, put quotes around them. You'll save yourself from having to wade through hundreds of results where the words appear separately.

For example, searching for military intelligence rounds up documents that contain those two words, but not necessarily side-by-side. Searching for "military intelligence" finds documents that contain that exact phrase. (Insert your own political joke here.)

3.1.2.2. Limit by kind

You can confine your search to certain categories using a simple code. For example, to find all photos, type kind:image. If you're looking for a presentation document, but you're not sure whether you used Keynote, iWork, or PowerPoint to create it, type kind:presentation into the box. And so on.

Here's the complete list of kinds. Remember to precede each keyword type with kind and a colon.

To find this: | Use one of these keywords:
A program | app, application, applications
Someone in your address book | contact, contacts
A folder | folder, folders
A message in Mail | email, emails, mail message, mail messages
An iCal appointment | event, events
An iCal task | to do, to dos, todo, todos
A graphic | image, images
A movie | movie, movies
A music file | music
An audio file | audio
A PDF file | pdf, pdfs
A System Preferences control | preferences, system preferences
A Safari bookmark | bookmark, bookmarks
A font | font, fonts
A presentation (PowerPoint, etc.) | presentation, presentations

You can combine these codes with the text you're seeking, too. For example, if you're pretty sure you had a photo called "Naked Mole-Rat," you could cut directly to it by typing mole kind:images or kind:images mole. (The order doesn't matter.)

3.1.2.3. Limit by recent date

You can use a similar code to restrict the search by chronology. If you type date: yesterday, Spotlight limits its hunt to items that you last opened yesterday.

Here's the complete list of date keywords you can use: this week, this month, this year; today, yesterday, tomorrow; next week, next month, next year. (The last four items are useful only for finding upcoming iCal appointments. Even Spotlight can't show you files you haven't created yet.)

3.1.2.4. Limit by metadata

If your brain is already on the verge of exploding, now might be a good time to take a break.

In Mac OS X 10.4, Spotlight could search on either of the criteria described above: Kind or Date.

But in Leopard, Apple added the ability to limit Spotlight searches by any of the 125 different info-morsels that may be stored as part of the files on your Mac: Author, Audio bit rate, City, Composer, Camera model, Pixel width, and so on. Section 3.2.7.4 has a complete discussion of these so-called metadata types. (Metadata means "data about the data"—that is, descriptive info-bites about the files themselves.) Here are a few examples:

  • author:casey. Finds all documents with "casey" in the Author field. (This presumes that you've actually entered the name Casey into the document's Author box. Microsoft Word, for example, has a place to store this information.)

  • width:800. Finds all graphics that are 800 pixels wide.

  • flash:1. Finds all photos that were taken with the camera's flash on. (To find photos with the flash off, you'd type flash:0. A number of the yes/no criteria work this way: Use 1 for yes, 0 for no.)

  • modified:3/7/08-3/10/08. Finds all documents modified between March 7 and March 10.

You can also type created:=6/1/08 to find all the files you created on June 1, 2008. Type modified:<=3/9/08 to find all documents you edited on or before March 9, 2008.

As you can see, three range-finding symbols are available for your queries: <, >, and -. The < means "before" or "less than," the > means "after" or "greater than," and the hyphen indicates a range (of dates, size, or whatever you're looking for).

Tip: Here again, you can string words together. To find all PDFs you opened today, use date:today kind:PDF. And if you're looking for a PDF document that you created on July 4, 2008 containing the word wombat, you can type created:=7/4/08 kind:pdf wombat, although at this point, you're not saving all that much time.

Now, those examples are just a few representative searches out of the dozens that Leopard makes available.

It turns out that the search criteria codes that you can type into the Spotlight box (author:casey, width:800, and so on) correspond to the master list that appears when you choose Other in the Spotlight window, as described on Section 3.2.7.4. In other words, there are 125 different search criteria.

There's only one confusing part: in the Other list, lots of metadata types have spaces in their names. Pixel width, musical genre, phone number, and so on.

Yet you're allowed to use only one word before the colon when you type a search into the Spotlight box. For example, even though pixel width is a metadata type, you have to use width: or pixelwidth: in your search.

So it would probably be helpful to have a master list of the one-word codes that Spotlight recognizes—the shorthand versions of the criteria described on Section 3.2.7.4.

Here it is, a Missing Manual exclusive, deep from within the bowels of Apple's Spotlight department: the master list of one-word codes. (Note that some search criteria have several alternate one-word names.)

Real Search Attribute | One-Word Name(s)
Keywords | keyword
Title | title
Subject | subject, title
Theme | theme
Authors | author, from, with, by
Editors | editor
Projects | project
Where from | wherefrom
Comment | comment
Copyright | copyright
Producer | producer
Used dates | used, date
Last opened | lastused, date
Content created | contentcreated, created, date
Content modified | contentmodified, modified, date
Duration | duration, time
Item creation | itemcreated, created, date
Contact keywords | contactkeyword, keyword
Version | version
Pixel height | pixelheight, height
Pixel width | pixelwidth, width
Page height | pageheight, height
Page width | pagewidth, height
Color space | colorspace
Bits per sample | bitspersample, bps
Flash | flash
Focal length | focallength
Alpha channel | alpha
Device make | make (camera brand)
Device model | model (camera model)
ISO speed | iso
Orientation | orientation
Layers | layer
White balance | whitebalance
Aperture | aperture, fstop
Profile name | profile
Resolution width | widthdpi, dpi
Resolution height | heightdpi, dpi
Exposure mode | exposuremode
Exposure time | exposuretime, time
EXIF version | exifversion
Codecs | codec
Media types | mediatype
Streamable | streamable
Total bit rate | totalbitrate, bitrate
Video bit rate | videobitrate, bitrate
Audio bit rate | audiobitrate, bitrate
Delivery type | delivery
Altitude | altitude
Latitude | latitude
Longitude | longitude
Text content | intext
Display name | displayname, name
Red eye | redeye
Metering mode | meteringmode
Max aperture | maxaperture
FNumber | fnumber, fstop
Exposure program | exposureprogram
Exposure time | exposuretime, time
Headline | headline, title
Instructions | instructions
City | city
State or Province | state, province
Country | country
Album | album, title
Sample rate | audiosamplerate, samplerate
Channel count | channels
Tempo | tempo
Key signature | keysignature, key
Time signature | timesignature
Audio encoding application | audioencodingapplication
Composer | composer, author, by
Lyricist | lyricist, author, by
Track number | tracknumber
Recording date | recordingdate, date
Musical genre | musicalgenre, genre
General MIDI sequence | ismidi
Recipients | recipient, to, with
Year recorded | yearrecorded, year
Organizations | organization
Languages | language
Rights | rights
Publishers | publisher
Contributors | contributor, by, author, with
Coverage | coverage
Description | description, comment
Identifier | id
Audiences | audience, to
Pages | pages
Security method | securitymethod
Content Creator | creator
Due date | duedate, date
Encoding software | encodingapplication
Rating | starrating
Phone number | phonenumber
Email addresses | email
Instant message addresses | imname
Kind | kind
URL | url
Recipient Email addresses | email
Email addresses | email
Filename | filename
File pathname | path
Size | size
Created | created
Modified | modified
Owner | owner
Group | group
Stationery | stationery
File invisible | invisible
File label | label
Spotlight comments | spotlightcomment, comment
Fonts | font
Instrument category | instrumentcategory
Instrument name | instrumentname

3.1.2.5. Boolean searches

Mac OS X 10.5 adds another layer of sophistication to Spotlight searches by permitting what Comp Sci professors call Boolean searches. These are search terms that round up results containing either of two search terms, or both search terms, or one term but not another.

To go Boolean, you're supposed to incorporate terms like AND, OR, or NOT into your search queries.

For example, you can round up a list of files that match two terms by typing, say, vacation AND kids. (That's also how you'd find documents coauthored by two specific people—you and a pal, for example. You'd search for author:Casey AND author:Chris. Yes, you have to type Boolean terms in all capitals.)

Tip: You can use parentheses instead of AND, if you like. That is, typing (vacation kids) finds documents that contain both words, not necessarily together.

If you use OR, you can find icons that match either of two search criteria. Typing kind: jpeg OR kind:pdf turns up photos and PDF files in a single list.

The minus sign (hyphen) works, too. If you did a search for dolphins, hoping to turn up sea-mammal documents, but instead find your results contaminated by football-team listings, by all means repeat the search with dolphins -miami. Mac OS X eliminates all documents containing "Miami."

Tip: The word NOT works the same way. You could type dolphins NOT miami to achieve the same effect. But the hyphen is faster to type.


the_spotlight_menu.html

Chapter 3. Spotlight

Every computer offers a way to find files. And every system offers several different ways to open them. But Spotlight, a star feature of Mac OS X (and beefed up in Leopard), combines these two functions in a way that's so fast, so efficient, so spectacular, it reduces much of what you've read in the previous chapters to irrelevance.

That may sound like breathless hype, but wait till you try it. You'll see.

3.1. The Spotlight Menu

See the little magnifying-glass icon in your menu bar? That's the mouse-driven way to open the Spotlight search box.

The other way is to press [image] -Space bar. If you can memorize only one keystroke on your Mac, that's the one to learn. It works both at the desktop and in other programs.

Tip: You can designate one of your F-keys (top row of the keyboard) to open Spotlight, if you prefer. Choose [image] rightwards double arrow System Preferences, click Spotlight, and use the "Spotlight menu keyboard shortcut" pop-up menu.

In any case, the Spotlight text box appears just below your menu bar (Figure 3-1).

Begin typing to identify what you want to find and open. For example, if you're trying to find a file called Pokémon Fantasy League.doc, typing just pok or leag would probably suffice. (Spotlight doesn't find text in the middles of words, though; it searches from the beginnings of words.)

A menu immediately appears below the search box, listing everything Spotlight can find containing what you've typed so far. (This is a live, interactive search; that is, Spotlight modifies the menu of search results as you type.) The menu lists every file, folder, program, email message, address book entry, calendar appointment, picture, movie, PDF document, music file, Web bookmark, Microsoft Office (Word, PowerPoint, Excel, Entourage) document, System Preferences panel, To Do item, chat transcript, Web site in your History list, and even font that contains what you typed, regardless of its name or folder location.

Figure 3-1. Left: Press -Space, or click the magnifying-glass icon, to make the search bar appear.
Right: As you type, Spotlight builds the list of every match it can find, neatly organized by
type: programs, documents, folders, images, PDF documents, and so on.

If you see the icon you were hoping to dig up, just click it to open it. Or use the arrow keys to "walk down" the menu, and then press Return or Enter to open it.

If you click an application, it pops onto the screen. If you select a System Preferences panel, System Preferences opens and presents that panel. If you choose an appointment, the iCal program opens, already set to the appropriate day and time. Selecting an email message opens that message in Mail or Entourage. And so on.

Spotlight is so fast, it eliminates a lot of the folders-in-folders business that's a side effect of modern computing. Why burrow around in folders when you can open any file or program with a couple of keystrokes?

3.1.1. Spotlight-Menu Tips

It should be no surprise that a feature as important as Spotlight comes loaded with options, tips, and tricks. Here it is—the official, unexpurgated Spotlight Tip-O-Rama:

  • If the very first item—labeled Top Hit—is the icon you were looking for, just press Return or Enter to open it. (That's a change in Leopard; adding the [image] key is no longer necessary.)

    This is a huge deal, because it means that in most cases, you can perform the entire operation without ever taking your hands off the keyboard.

    To open Safari in a hurry, for example, press [image] -Space bar (to open the Spotlight bar), type safa, and hit Enter, all in rapid-fire sequence, without even looking. Presto: Safari is before you.

    (The only wrinkle here is that the Spotlight menu may still be building itself. If you go too quickly, you may be surprised as another entry jumps into the top slot just as you're about to hit Enter—and you wind up opening the wrong thing. Over time, you develop a feel for when the Top Hit is reliably the one you want.)

    GEM IN THE ROUGH
    Sweet Spotlight Serendipity: Equations and Definitions

    In Mac OS X 10.5, Spotlight has been given two quiet enhancements that turn it into a different beast altogether.

    First, it's a tiny pocket calculator, always at the ready. Click in the Search box, type or paste 38*48.2-7+55, and marvel at the first result in the Spotlight menu: 1879.6. There's your answer—and you didn't even have to fire up the Calculator.

    (For shorter equations—only a few characters long—the first result in the Spotlight menu shows the entire equation, like .15*234=35.1.)

    And it's not just a four-function calculator, either. It works with square roots: Type sqrt(25), and you'll get the answer 5. It also works with powers: Type pow(6,6)—that is, 6 to the power of 6—and you'll get 46656.

    You can even type pi to represent—you know, pi.

    For a complete list of math functions in Spotlight, open Terminal (see Chapter 16), type man math, and press Enter.

    Second, the Spotlight menu is now a full-blown English dictionary. Or, more specifically, it's wired directly into Mac OS X's own dictionary, which sits in your Applications folder.

    So if you type, for example, schadenfreude in to the Spotlight box, you'll see, to your amazement, the beginning of the actual definition right there in the menu. Click it to open Dictionary and read the full-blown entry. (In this example, that would be: "noun: pleasure derived by someone from another person's misfortune.")

    And what, exactly, is the Top Hit? Mac OS X chooses it based on its relevance (the importance of your search term inside that item) and timeliness (when you last opened it).

    Tip: In Leopard more than ever, Spotlight makes a spectacular application launcher. That's because, as you'll notice, Job #1 for Spotlight is to display the names of matching programs in the results menu. Their names appear in the list nearly instantly—long before Spotlight has built the rest of the menu of search results.If some program on your hard drive doesn't have a Dock icon, for example—or even if it does—there's no faster way to open it than to use Spotlight.

  • To jump to a search result's Finder icon instead of opening it, [image] -click its name.

  • Spotlight's menu shows you only 20 of the most likely suspects, evenly divided among the categories (Documents, Applications, and so on). The downside: To see the complete list, you have to open the Spotlight window (Section 3.2).

    The upside: It's fairly easy to open something in this menu from the keyboard. Just press [image] -down arrow (or [image] -up arrow) to jump from category to category. Once you've highlighted the first result in a category, you can walk through the remaining four by pressing the arrow key by itself. Then, once you've highlighted what you want, press Return or Enter to open it.

    In other words, you can get to anything in the Spotlight menu with only a few keystrokes.

  • The Esc key (top-left corner of your keyboard) offers a two-stage "back out of this" method. Tap it once to close the Spotlight menu and erase what you've typed, so that you're all ready to type in something different. Tap Esc a second time to close the Spotlight text box entirely, having given up on the whole idea of searching.

    (If you just want to cancel the whole thing in one step, press [image] -Space bar again, or [image] -period, or [image] -Esc.)

  • Think of Spotlight as your little black book. When you need to look up a number in Address Book, don't bother opening Address Book; it's faster to use Spotlight. You can type somebody's name or even part of someone's phone number.

  • Among a million other things, Spotlight tracks the keywords and descriptions you've applied to your pictures in iPhoto. As a result, you can find, open, or insert any iPhoto photo at any time, no matter what program you're using, just by using the Spotlight box at the top of every Open File dialog box (Section 5.8.5)! This is a great way to insert a photo into an outgoing email message, a presentation, or a Web page you're designing. iPhoto doesn't even have to be running.

  • Spotlight is also a quick way to adjust one of your Mac's preference settings. Instead of opening up the System Preferences program, type the first few letters of, say, volume or network or clock into Spotlight. The Spotlight menu lists the appropriate System Preferences panel, so you can jump directly to it.

  • If you point to an item in the Spotlight menu without clicking, a little tooltip balloon appears. It tells you the item's actual name—which is useful if Spotlight listed something because of text that appears inside the file, not its name—and its folder path (that is, where it is on your hard drive).

  • The Spotlight menu lists 20 found items. In the following pages, you'll learn about how to see the rest of the stuff. But for now, note that you can eliminate some of the categories that show up here (like PDF Documents or Bookmarks), and even rearrange them, to permit more of the other kinds of things to enjoy those 20 seats of honor. Details on Section 3.3.

    UP TO SPEED
    What Spotlight Knows

    The beauty of Spotlight is that it doesn't just find files whose names match what you've typed. That would be so 2004!

    No, Spotlight actually looks inside the files. It can actually read and search the contents of text files, RTF and PDF documents, and documents from iWork, Keynote, Pages, Photoshop, and Microsoft Office (Word, Excel, Entourage, and PowerPoint).

    As time goes on, software companies release bits of addon software—plugins—that make their documents searchable by Spotlight too. Check in periodically at, for example, www.apple.com/downloads/macosx/spotlight, to look for Spotlight plug-ins relevant to the kind of work you do. For example, free Spotlight plug-ins are available for OmniGraffle, OmniOutliner, TypeIt4Me, MacDraft, REALBasic, Painter, Wolfram Notebook, and many others.

    But that's only the beginning. Spotlight searches files not only for the text inside them, but also for over 125 other bits of text—a staggering collection of information tidbits including the names of the layers in a Photoshop document, the tempo of an MP3 file, the shutter speed of a digital-camera photo, a movie's copyright holder, a document's page size, and on and on.

    Technically, this sort of secondary information is called metadata. It's usually invisible, although a lot of it shows up in the Get Info dialog box described in Chapter 2.

    You might think that typing something into the Spotlight bar triggers a search. But to be technically correct, Spotlight has already done its searching. In the first 15 to 30 minutes after you install Mac OS X—or in the minutes after you attach a new hard drive—Spotlight invisibly collects information about everything on your hard drive. Like a kid cramming for an exam, it reads, takes notes on, and memorizes the contents of all of your files. (During this time, if you click the Spotlight icon on the menu bar, you'll be told that Spotlight is indexing the drives.) Once it has indexed your hard drive in this way, Spotlight can produce search results in seconds.

    After that initial indexing process, Spotlight continues to monitor what's on your hard drive, indexing new and changed files in the background, in the microseconds between your keystrokes and clicks in other programs.

  • Spotlight shows you only the matches from your account and the public areas of the Mac (like the System, Application, and Developer folders)—but not what's in anyone else's Home folder. If you were hoping to search your spouse's email for phrases like "meet you at midnight," forget it.

  • If Spotlight finds a different version of something on each of two hard drives, it lets you know by displaying a faint gray hard drive name after each such item in the menu.

  • Spotlight works by storing an index, a private, multimegabyte Dewey Decimal system, on each hard drive, disk partition, or USB flash (memory) drive. If you have some oddball type of disk, like a hard drive that's been formatted for Windows, Spotlight doesn't ordinarily index it—but you can turn on indexing by using the File rightwards double arrow Get Info command on that drive's icon and turning indexing on manually.

    Tip: In Leopard, Spotlight can even find words inside of files on other computers on your network—as long as they're also Macs running Leopard. If not, Spotlight can only search for the names of files on other networked computers.

  • If you point to some thing in the results list without clicking, you can press [image] -Ito open the Get Info window for that item.

3.1.2. Advanced Menu Searches

Most people just type the words they're looking for into the Spotlight box. But if that's all you type, you're missing a lot of the fun.

3.1.2.1. Use quotes

If you type more than one word, Spotlight works just the way Google does. That is, it finds things that contain both words somewhere inside.

But if you're searching for a phrase where the words really belong together, put quotes around them. You'll save yourself from having to wade through hundreds of results where the words appear separately.

For example, searching for military intelligence rounds up documents that contain those two words, but not necessarily side-by-side. Searching for "military intelligence" finds documents that contain that exact phrase. (Insert your own political joke here.)

3.1.2.2. Limit by kind

You can confine your search to certain categories using a simple code. For example, to find all photos, type kind:image. If you're looking for a presentation document, but you're not sure whether you used Keynote, iWork, or PowerPoint to create it, type kind:presentation into the box. And so on.

Here's the complete list of kinds. Remember to precede each keyword type with kind and a colon.

To find this: | Use one of these keywords:
A program | app, application, applications
Someone in your address book | contact, contacts
A folder | folder, folders
A message in Mail | email, emails, mail message, mail messages
An iCal appointment | event, events
An iCal task | to do, to dos, todo, todos
A graphic | image, images
A movie | movie, movies
A music file | music
An audio file | audio
A PDF file | pdf, pdfs
A System Preferences control | preferences, system preferences
A Safari bookmark | bookmark, bookmarks
A font | font, fonts
A presentation (PowerPoint, etc.) | presentation, presentations

You can combine these codes with the text you're seeking, too. For example, if you're pretty sure you had a photo called "Naked Mole-Rat," you could cut directly to it by typing mole kind:images or kind:images mole. (The order doesn't matter.)

3.1.2.3. Limit by recent date

You can use a similar code to restrict the search by chronology. If you type date: yesterday, Spotlight limits its hunt to items that you last opened yesterday.

Here's the complete list of date keywords you can use: this week, this month, this year; today, yesterday, tomorrow; next week, next month, next year. (The last four items are useful only for finding upcoming iCal appointments. Even Spotlight can't show you files you haven't created yet.)

3.1.2.4. Limit by metadata

If your brain is already on the verge of exploding, now might be a good time to take a break.

In Mac OS X 10.4, Spotlight could search on either of the criteria described above: Kind or Date.

But in Leopard, Apple added the ability to limit Spotlight searches by any of the 125 different info-morsels that may be stored as part of the files on your Mac: Author, Audio bit rate, City, Composer, Camera model, Pixel width, and so on. Section 3.2.7.4 has a complete discussion of these so-called metadata types. (Metadata means "data about the data"—that is, descriptive info-bites about the files themselves.) Here are a few examples:

  • author:casey. Finds all documents with "casey" in the Author field. (This presumes that you've actually entered the name Casey into the document's Author box. Microsoft Word, for example, has a place to store this information.)

  • width:800. Finds all graphics that are 800 pixels wide.

  • flash:1. Finds all photos that were taken with the camera's flash on. (To find photos with the flash off, you'd type flash:0. A number of the yes/no criteria work this way: Use 1 for yes, 0 for no.)

  • modified:3/7/08-3/10/08. Finds all documents modified between March 7 and March 10.

You can also type created:=6/1/08 to find all the files you created on June 1, 2008. Type modified:<=3/9/08 to find all documents you edited on or before March 9, 2008.

As you can see, three range-finding symbols are available for your queries: <, >, and -. The < means "before" or "less than," the > means "after" or "greater than," and the hyphen indicates a range (of dates, size, or whatever you're looking for).

Tip: Here again, you can string words together. To find all PDFs you opened today, use date:today kind:PDF. And if you're looking for a PDF document that you created on July 4, 2008 containing the word wombat, you can type created:=7/4/08 kind:pdf wombat, although at this point, you're not saving all that much time.

Now, those examples are just a few representative searches out of the dozens that Leopard makes available.

It turns out that the search criteria codes that you can type into the Spotlight box (author:casey, width:800, and so on) correspond to the master list that appears when you choose Other in the Spotlight window, as described on Section 3.2.7.4. In other words, there are 125 different search criteria.

There's only one confusing part: in the Other list, lots of metadata types have spaces in their names. Pixel width, musical genre, phone number, and so on.

Yet you're allowed to use only one word before the colon when you type a search into the Spotlight box. For example, even though pixel width is a metadata type, you have to use width: or pixelwidth: in your search.

So it would probably be helpful to have a master list of the one-word codes that Spotlight recognizes—the shorthand versions of the criteria described on Section 3.2.7.4.

Here it is, a Missing Manual exclusive, deep from within the bowels of Apple's Spotlight department: the master list of one-word codes. (Note that some search criteria have several alternate one-word names.)

Real Search Attribute | One-Word Name(s)
Keywords | keyword
Title | title
Subject | subject, title
Theme | theme
Authors | author, from, with, by
Editors | editor
Projects | project
Where from | wherefrom
Comment | comment
Copyright | copyright
Producer | producer
Used dates | used, date
Last opened | lastused, date
Content created | contentcreated, created, date
Content modified | contentmodified, modified, date
Duration | duration, time
Item creation | itemcreated, created, date
Contact keywords | contactkeyword, keyword
Version | version
Pixel height | pixelheight, height
Pixel width | pixelwidth, width
Page height | pageheight, height
Page width | pagewidth, height
Color space | colorspace
Bits per sample | bitspersample, bps
Flash | flash
Focal length | focallength
Alpha channel | alpha
Device make | make (camera brand)
Device model | model (camera model)
ISO speed | iso
Orientation | orientation
Layers | layer
White balance | whitebalance
Aperture | aperture, fstop
Profile name | profile
Resolution width | widthdpi, dpi
Resolution height | heightdpi, dpi
Exposure mode | exposuremode
Exposure time | exposuretime, time
EXIF version | exifversion
Codecs | codec
Media types | mediatype
Streamable | streamable
Total bit rate | totalbitrate, bitrate
Video bit rate | videobitrate, bitrate
Audio bit rate | audiobitrate, bitrate
Delivery type | delivery
Altitude | altitude
Latitude | latitude
Longitude | longitude
Text content | intext
Display name | displayname, name
Red eye | redeye
Metering mode | meteringmode
Max aperture | maxaperture
FNumber | fnumber, fstop
Exposure program | exposureprogram
Exposure time | exposuretime, time
Headline | headline, title
Instructions | instructions
City | city
State or Province | state, province
Country | country
Album | album, title
Sample rate | audiosamplerate, samplerate
Channel count | channels
Tempo | tempo
Key signature | keysignature, key
Time signature | timesignature
Audio encoding application | audioencodingapplication
Composer | composer, author, by
Lyricist | lyricist, author, by
Track number | tracknumber
Recording date | recordingdate, date
Musical genre | musicalgenre, genre
General MIDI sequence | ismidi
Recipients | recipient, to, with
Year recorded | yearrecorded, year
Organizations | organization
Languages | language
Rights | rights
Publishers | publisher
Contributors | contributor, by, author, with
Coverage | coverage
Description | description, comment
Identifier | id
Audiences | audience, to
Pages | pages
Security method | securitymethod
Content Creator | creator
Due date | duedate, date
Encoding software | encodingapplication
Rating | starrating
Phone number | phonenumber
Email addresses | email
Instant message addresses | imname
Kind | kind
URL | url
Recipient Email addresses | email
Email addresses | email
Filename | filename
File pathname | path
Size | size
Created | created
Modified | modified
Owner | owner
Group | group
Stationery | stationery
File invisible | invisible
File label | label
Spotlight comments | spotlightcomment, comment
Fonts | font
Instrument category | instrumentcategory
Instrument name | instrumentname

3.1.2.5. Boolean searches

Mac OS X 10.5 adds another layer of sophistication to Spotlight searches by permitting what Comp Sci professors call Boolean searches. These are search terms that round up results containing either of two search terms, or both search terms, or one term but not another.

To go Boolean, you're supposed to incorporate terms like AND, OR, or NOT into your search queries.

For example, you can round up a list of files that match two terms by typing, say, vacation AND kids. (That's also how you'd find documents coauthored by two specific people—you and a pal, for example. You'd search for author:Casey AND author:Chris. Yes, you have to type Boolean terms in all capitals.)

Tip: You can use parentheses instead of AND, if you like. That is, typing (vacation kids) finds documents that contain both words, not necessarily together.

If you use OR, you can find icons that match either of two search criteria. Typing kind: jpeg OR kind:pdf turns up photos and PDF files in a single list.

The minus sign (hyphen) works, too. If you did a search for dolphins, hoping to turn up sea-mammal documents, but instead find your results contaminated by football-team listings, by all means repeat the search with dolphins -miami. Mac OS X eliminates all documents containing "Miami."

Tip: The word NOT works the same way. You could type dolphins NOT miami to achieve the same effect. But the hyphen is faster to type.


the_spotlight_window.html

3.2. The Spotlight Window

As you may have noticed, the Spotlight menu doesn't list every match on your hard drive. Unless you own one of those extremely rare 60-inch Apple Skyscraper Displays, there just isn't room.

Instead, Spotlight uses some fancy behind-the-scenes analysis to calculate and display the 20 most likely matches for what you typed. But at the top of the menu, you usually see that there are many other possible matches; it says something like "Show All," meaning that there are other candidates. (Mac OS X no longer tells you how many other results there are.)

There is, however, a second, more powerful way into the Spotlight labyrinth. And that's to use the Spotlight window, shown in Figure 3-2.

3.2.1. Spotlight Window from Spotlight Menu

If the Spotlight menu—its Most Likely to Succeed list—doesn't include what you're looking for, click Show All (or just press Return or Enter). You've just opened the Spotlight window.

Now you have access to the complete list of matches, neatly listed in what appears to be a standard Finder window.

3.2.2. Opening the Spotlight Window Directly

You can also open the Spotlight window directly, without using the Spotlight menu as a trigger.

Actually, there are three ways to get to the Spotlight window (Figure 3-2):

  • -F (for Find, get it?). When you choose File rightwards double arrow Find (or press [image] -F), you get an empty Spotlight window, ready to fill in for your search.

  • Option- [image] -Space bar. This keystroke opens the same window. But instead of starting empty and filling up, this window starts with a list of every single thing on your Mac and winnows down as you type a search query.

    Tip: You can change this keystroke to just about anything you like. See Section 3.3.1.

  • Open any desktop window, and type something into the Search box at upper-right. Presto—the mild-mannered folder window turns into the Spotlight window, complete with search results.

Once you type something to search for, the results are identical.

Figure 3-2. The Spotlight window either lists nothing (top)—or everything on your hard drive (bottom), depending on how you open it. Either way, it's ready to search your entire hard drive (except other people's Home folders). But Spotlight has many tricks up its software sleeve.

3.2.3. The Basic Search

When the Spotlight window opens, you can start typing whatever you're looking for into the Search box at the upper right.

As you type—or, more realistically, a second or two after you type each letter—the window changes to reveal a list of the files and folders whose names contain what you typed. It's just like the Spotlight menu, but in a window with no 20-item results limit (Figure 3-2, bottom).

While the searching is going on, a sprocket icon whirls away in the lower-right corner. To cancel the search in progress, click the [image] button next to the phrase you typed. That button also clears the box so you can type a different word or phrase.

3.2.4. Power Searches

The real beauty of the Spotlight window, though, is that it can hunt down icons using extremely specific criteria; it's much more powerful (and complex) than the Spotlight menu. If you spent enough time setting up the search, you could use this feature to find a document whose name begins with the letters Cro, is over one megabyte in size, was created after 10/1/07 but before the end of the year, was changed within the last week, has the file name suffix .doc, and contains the phrase "attitude adjustment." (Of course, if you knew that much about a file, you'd probably know where it is without having to use the Search window. But you get the picture.)

To use the Search window, you need to feed it two pieces of information: where you want it to search, and what to look for. You can make both of these criteria as simple or complex as you like.

3.2.5. Where to Look

The three phrases at the top of the window—This Mac,"Folder Name,"and Shared— are buttons. Click one of these to tell Spotlight where to search:

  • This Mac means your entire computer, including secondary disks attached to it (or installed inside).

  • "Letters to Congress"(or whatever the current window is) limits the search to whatever window was open when you called up the Spotlight window. So, for example, if you want to search your Pictures folder, open it first and then hit [image] -F. You'll see the "Pictures" button at the top of the window, and you can click it to restrict the search to that folder.

    Note: If no folder window is open when you press [image] -F, this button says "Casey" (or whatever); it identifies your Home folder. That is, Spotlight is prepared to search all your stuff on this Mac.

    Shared. Click this button to expand the search to your entire network and all the computers on it. (This assumes, of course, that you've brought their icons to your screen as described in Chapter 13. If there aren't any shared folders or disks, this button doesn't appear at all.)

If the other computers are Macs running Leopard, Spotlight can even search their files just the way it does on your own Mac—finding words inside the files, for example. If they're any other kind of computer, Spotlight can only search for files by name.

Tip: If the object of your quest doesn't show up, you can adjust the scope of the search with one quick click on another button at the top of the window, like This Mac or Shared. Spotlight updates the results list.

3.2.6. Search by Name/Search by Contents

The two other buttons at the top of the Spotlight window are also very powerful:

  • Contents. This button, the factory setting, works just the way Spotlight usually does. It's prepared to search for the words inside your files, along with all the metadata attached to them.

  • File Name. All of this searching-inside-files business is well and good. But there's no denying that sometimes, you already know a file's name—you just don't know where it is. In this case, it's far faster to search by name, just as people did before Spotlight came along. The list of results will be far shorter, and you'll spot what you want much faster. That's why this button is so welcome.

Tip: If you press Shift as you open the File menu (or as you press [image] -F), the Find command changes to Find by Name. It opens the Find window, preset to search for icons by name. What a shortcut!

3.2.7. Complex Searches

If all you want to do is search your entire computer for files containing certain text, you may as well use the Spotlight menu described at the beginning of this chapter.

Figure 3-3. By repeatedly clicking the + button, you can turn on as many criteria as you'd like; each additional row further narrows the search.

The power of the Spotlight window, though, is that it lets you design much more specific searches, using over 125 different search criteria: date modified, file size, the "last opened" date, color label, copyright holder's name, shutter speed (of a digital photo), tempo (of a music file), and so on. Figure 3-3 illustrates how detailed this kind of search can be.

To set up a complex search like this, you'll use the second row of controls at the top of the window.

And third, and fourth, and fifth. Each time you click one of the + buttons at the right end of the window, a new criterion row appears, whose pop-up menus you can use to specify what date, what file size, and so on. Figure 3-3 shows how you might build, for example, a search for all photo files that you've opened within the last week that contain a Photoshop layer named Freckle Removal.

To delete a row, click the – button at its right end.

Tip: If you press Option, the + button changes into a … button. When you click it, you get sub-rows of parameters for a single criterion. And a pop-up menu that says Any, All, or None appears at the top, so that you can build what are called exclusionary searches.The idea here is that you can set up a search for documents created between November 1 and 7 or documents created November 10 through 14. Or files named Complaint that are also either Word or InDesign files.The mind boggles.

Here's a rundown of the ways you can restrict your search, according to the options you find in the first pop-up menu of a row. Note that after you choose from that first pop-up menu (Last Opened, for example), you're supposed to use the additional pop-up menus to narrow the choice ("within last," "2," and "weeks," for example), as you'll read below.

Note: It may surprise you that choosing something from the Kind pop-up menu triggers the search instantly. As soon as you choose Applications, for example, the window fills with a list of every program on your hard drive. Want a quick list of every folder on your entire machine? Choose Folders. (Want to see which folders you've opened in the last couple of days? Add another row.)If you also type something into the Search box at the very top of the window—before or after you've used one of these pop-up menus—the list pares itself down to items that match what you've typed.
3.2.7.1. Kind

When the first pop-up menu says Kind, you can use the second pop-up menu to indicate what kind of file you're looking for: Applications, Documents, Folders, Images, Movies, Music, PDF files, Presentations, Text files, or Other.

For example, when you're trying to free up some space on your drive, you could round up all your movie files, which tend to be huge. Choosing one of these file types makes the window begin to fill with matches automatically and instantly.

And what if the item you're looking for isn't among the nine canned choices in the second pop-up menu? What if it's an alias, or a Photoshop plug-in, or some other type?

That's what the Other option is all about. Here, you can type in almost anything that specifies a kind of file: Word, Excel, TIFF, JPEG, AAC, final cut, imovie, alias, zip, html, or whatever.

3.2.7.2. Last opened date/Last modified date/Created date

When you choose one of these options from the first pop-up menu, the second popup menu lets you isolate files, programs, and folders according to the last time you opened them, the last time you changed them, or when they were created.

  • today, yesterday, this week, this month, this year. These commands in the second pop-up menu offer quick, canned time-limiting options.

  • within last, exactly, before, after let you be more precise. If you choose Before, After, or Exactly, your criterion row sprouts a month/day/year control that lets you round up items that you last opened or changed before, after, or on a specific day, like 5/27/08. If you choose "within last," you'll see that you can limit the search to things you've opened or changed within a specified number of days, weeks, months, or years.

These are awesomely useful controls, because they let you specify a chronological window for whatever you're looking for.

Tip: You're allowed to add two Date rows—a great trick that lets you round up files that you created or edited between two dates. Set up the first Date row to say "is after," and the second one to say "is before."In fact, if it doesn't hurt your brain to think about it, how about this? You can even have more than two Date rows. Use one pair to specify a range of dates for the file's creation date, for example, and two other rows to limit when it was modified.Science!
3.2.7.3. Name

The beauty of Spotlight is that it finds text anywhere in your files, no matter what their names are. That's why Apple demoted this option—the icon's name—to such a low position in the pop-up menu.

Anyway, when you want to search for an icon by the text that's only in its name, this is your ticket. Capitalization doesn't matter.

Of course, if all you want to do is find files whose names include Sales, you may as well save yourself all of this reading and use the Spotlight menu (or click the File Name button at the top of the window). But using the Search window offers you far more control, thanks to the second pop-up menu that offers you these options:

  • Contains. The position of the letters you type doesn't matter. If you type then, you find files with names like "Then and Now," "Authentic Cajun Recipes," and "Lovable Heathen."

  • Starts with. The Find program will find only files beginning with the letters you type. If you type then, you find "Then and Now,"but not "Authentic Cajun Recipes" or "Lovable Heathen."

  • Ends with. If you type then, you find "Lovable Heathen,"but not files called "Then and Now" or "Authentic Cajun Recipes."

  • Is.This option finds only files named precisely what you type (except that capitalization still doesn't matter). Typing then won't find any of the file names in the previous examples. It would unearth only a file called simply "Then." In fact, a file with a file name suffix, like "Then.doc," doesn't even qualify.

    (If this happens to you, though, here's a workaround: From the first pop-up menu, choose Other; in the dialog box, pick Filename. The Filename criterion ignores extensions; it would find "Then.doc" even if you searched for "then.")

3.2.7.4. Contents

You can think of this option as the opposite of Name. It finds only the text that's inside your files, and completely ignores their icon names.

That's a handy function when, for example, a document's name doesn't match its contents. Maybe a marauding toddler pressed the keys while playing KidPix, inadvertently renaming your doctoral thesis "xggrjpO#$5%////." Or maybe you just can't remember what you called something.

WORKAROUND WORKSHOP
Feeding the Barren Pop-up Menus

The first little pop-up menu in the Spotlight window lists those handy search starting points: Kind, Last opened date, Name, and so on.

But it's actually less fully stocked than it was in Mac OS Xes of days gone by. Apple streamlined the options a bit.

For example, you used to be able to search by label (Section 2.5). You could therefore easily round up all files pertaining to a certain project for backing up, deleting, or burning to a CD en masse. That's off the menu as you first see it.

Gone, too, is the Size criterion, which could be helpful when you're trying to make space on your overstuffed hard drive by ferreting out the huge, multigigabyte files and folders.

Fortunately, you can restore these options to the criterion pop-up menu easily enough. The trick is to use the Other option as described on these pages. In the dialog box shown in Figure 3-4, search for label or size. When you find that criterion, turn on the "In menu" checkbox and click OK.

Presto: You've got your menu back.

3.2.7.5. Other

If this were a math equation, it might look like this: options x options=overwhelming.

Choosing Other from the first pop-up menu opens a special dialog box containing at least 125 other criteria. Not just the big kahunas like Name, Size, and Kind, but far more targeted (and obscure) criteria like "Bits per sample" (so you can round up MP3 music files of a certain quality), "Device make" (so you can round up all digital photos taken with, say, a Canon camera), "Key signature" (so you can find all the GarageBand songs you wrote in the key of F sharp), "Pages" (so you can find all Word documents that are really long), and so on. As you can see in Figure 3-4, each one comes with a short description.

Figure 3-4. Here's the master list of search criteria. Turn on the "In menu" checkboxes of the ones you'll want to re-use often, as described in the box on the previous page. Once you've added some of these search criteria to the menu, you'll get an appropriate set of "find what?" controls ("Greater than"/"Less than" pop-up menus, for example).

You may think that Spotlight is offering you a staggering array of file-type criteria. In fact, though, big bunches of information categories (technically called metadata) are all hooks for a relatively small number of document types. For example:

  • Digital photos and other graphics files account for the metadata types alpha channel, aperture, color space, device make, device model, EXIF version, exposure mode, exposure program, exposure time, flash, FNumber, focal length, ISO speed, max aperture, metering mode, orientation, pixel height, pixel width, red eye, resolution height, resolution width, and white balance.

  • Digital music files have searchable metadata categories like album, audio bit rate, bits per sample, channel count, composer, duration, General MIDI sequence, key signature, lyricist, musical genre, recording date, sample rate, tempo, time signature, track number, and year recorded. There's even a special set of parameters for GarageBand and Soundtrack documents, including, instrument category, instrument name, loop descriptors, loop file type, loop original key, and loop scale type.

  • Microsoft Office documents can contain info bits like authors, contributors, fonts, languages, pages, publishers, and contact information (name, phone number, and so on).

This massive list also harbors a few criteria you may use more often, like Size, Label, and Visibility (which lets you see all the invisible files on your hard drive). See the box on Section 3.2.7.4.

Now, you could argue that in the time it takes you to set up a search for such a specific kind of data, you could have just rooted through your files and found what you wanted manually. But hey—you never know. Someday, you may remember nothing about a photo you're looking for except that you used the flash and an F-stop of 1.8.

Tip: Don't miss the Search box in this dialog box. It makes it super-easy to pluck one useful criterion needle—Size, say—out of the haystack. Also don't forget about the "In menu" checkbox in the right column. It lets you add one of these criteria to the main pop-up menu, so you don't have to go burrowing into Other again the next time.

3.2.8. What to Do with Search Results

The Spotlight window has been drastically simplified since the last version of Mac OS X; it's now a regular old Finder window, with all the familiar views and controls (Figure 3-5).

Figure 3-5. Click a result once to see where it sits on your hard drive (very bottom). If the window is too narrow to reveal the full folder path, run your cursor over them without clicking. As your mouse moves from one folder to another, Leopard briefly reveals its name, compressing other folders as necessary to make room. (Sub-tip: You can drag icons into these folders, too.)

You can work with anything in the results window exactly as though it's a regular Finder window: Drag something to the Trash, rename something, drag something to the desktop to move it there, drag something onto a Dock icon to open it with a certain program, Option- [image] -drag it to the desktop to create an alias, and so on.

You can move up or down the list by pressing the arrow keys, scroll a "page" at a time with the Page Up and Page Down keys, and so on. You can also highlight multiple icons simultaneously, the same way you would in a Finder list view: Highlight all of them by choosing Edit rightwards double arrow Select All; highlight individual items by [image] -clicking them; drag diagonally to enclose a cluster of found items; and so on.

Or you can proceed in any of these ways:

  • Change the view by clicking one of the View icons or choosing from the View menu. You can switch between icon, list, or Cover Flow views (see Chapter 1). Actually, Cover Flow is a great view for search results; since this list is culled from folders all over the computer, you otherwise have very little sense of context as you examine the file names.

    Note: Column view isn't available here, since the search results displayed here are collected from all over your computer. They don't all reside in the same folder. Still, Apple's given you a consolation prize here: the folder path display at the bottom of the window. It tells you where the selected item is hiding on your hard drive just as clearly as column view would have.

  • Sort the results by clicking the column headings (not available in icon view). It can be especially useful to sort by Kind, so that similar file types are clustered together (Documents, Images, Messages, and so on), or to sort by Last Opened, so that the list is chronological.

  • Get a Quick Look at one result by clicking it and then hitting the Space bar. If it's a document type that Mac OS X understands (see Section 1.8.1), you get the big, bold Quick Look preview window.

    POWER USERS' CLINIC
    All Roads Lead to Spotlight

    As you know, you can open the Spotlight window using a keystroke or from the Spotlight menu after performing a search.

    But those methods are only the beginning.

    Try this: Highlight a phrase in any program (except Microsoft ones and a few other weirdos). Control-click (or right-click) the highlighted phrase, and then choose Search in Spotlight from the shortcut menu. Boom: The Spotlight window opens, already stocked with the search results that match your highlighted phrase.

    But wait, there's more! If you're using a Cocoa program (one designed just for Mac OS X, like Mail, Safari, or TextEdit), you can also use the Services rightwards double arrow Spotlight submenu. (See Section 5.10.1 for more on Services.) That command even has a keyboard shortcut of its own: Shift- [image] -F.

    Remember, too, that Spotlight has its claws in all kinds of individual Mac OS X programs. You'll find a Spotlight search bar in System Preferences (so that you can pull up the correct panel), in Mail (to find a certain message), in Automator (to search for components for your software robots), and so on. As software companies get around to it, they're also welcome to incorporate pieces of the Spotlight technology into their own programs.

  • Get more information about a result by selecting it and then choosing File rightwards double arrow Get Info (or pressing [image] -I). The normal Get Info window appears, complete with date, size, and location information.

  • Find out where it is. It's nice to see all the search results in one list, but you're not actually seeing them in their native habitats: in the Finder folder windows where they physically reside.

    If you click once on an icon in the results, the bottom edge of the window becomes a folder map that shows you where that item is.

    For example, in Figure 3-5, the notation in the Path strip means: "The 2006 corvette_owner's manual.pdf icon you found is in the Manuals folder, which is in the Corvette folder, which is in the Documents folder, which is in Casey's Home folder."

    To get your hands on the actual icon, choose File rightwards double arrow Open Enclosing Folder ( [image] -R). Mac OS X highlights the icon in question, sitting there in its window wherever it happens to be on your hard drive.

  • Open the file (or open one of the folders it's in).If one of the found files is the one you were looking for, double-click it to open it (or highlight it and press either [image] -O or [image] -down arrow). In many cases, you'll never even know or care where the file was—you just want to get into it.

    You can also double-click to open any of the folders in the folder map at the bottom of the window. For example, in Figure 3-5, you could double-click the selected PDF icon to open it, or the Manuals folder to open it, and so on.

  • Move or delete the file.You can drag an item directly out of the found-files list and into a different folder, window, or disk—or straight to the Dock or the Trash. If you click something else and then re-click the dragged item in the results list, the folder map at the bottom of the window updates itself to reflect the file's new location.

  • Start over. If you'd like to repeat the search using a different search phrase, just edit the text in the Search bar. (Press [image] -F to empty the Search box and the Spotlight window.) The results pane updates itself as you type.

  • Give up. If none of these avenues suits your fancy, you can close the window as you would any other ( [image] -W).


customizing_spotlight.html

3.3. Customizing Spotlight

You've just read about how Spotlight works fresh out of the box. But you can tailor its behavior, both for security reasons and to fit it to the kinds of work you do.

Here are three ways to open the Spotlight preferences center:

  • Choose Spotlight Preferences at the bottom of the Spotlight menu just after you've performed a search.

  • Use Spotlight itself.Hit [image] -Space bar, type spotl, and press Enter.

  • Choose [image] rightwards double arrow System Preferences. Click Spotlight.

In any case, you wind up face-to-face with the dialog box shown in Figure 3-6.

Figure 3-6. Here's where you can specify what categories of icons you want Spotlight to search, which order you want them listed in the Spotlight menu, and what keystroke you want to use for highlighting the Spotlight bar.

You can tweak Spotlight in three ways here, all very useful:

  • Turn off categories. The list of checkboxes identifies all the kinds of things that Spotlight tracks. If you find that Spotlight uses up valuable menu space listing, say, Web bookmarks or fonts—stuff you don't need to find very often—turn off their checkboxes. Now the Spotlight menu's precious 20 slots are allotted to icon types you care more about.

  • Prioritize the categories. This dialog box also lets you change the order of the category results; just drag an individual list item up or down to change where it appears in the Spotlight menu.

    The factory setting is for Applications to appear first in the menu. That makes a lot of sense if you use Spotlight as a quick program launcher (which is a great idea). But if you're a party planner, and you spend all day on the phone, and the most important Spotlight function for you is its ability to look up someone in your address book, then drag Contacts to the top of the list. You'll have fewer arrow-key presses to perform once the results menu appears.

    POWER USERS' CLINIC
    The Raw Power of the Raw Query

    You may have just slogged through over 20 pages of Spotlight details—but if you can believe it, there are another 40 or 60 to be written. It turns out that the Spotlight most people see is only a subset of the true power awaiting in Leopard.

    For example, what if you wanted to see all the files you've opened in the last 24 hours except email messages and address book entries? Or what if you want to round up all PDF documents and PostScript files you've opened in the last week? Using the Spotlight tools that most people see, you wouldn't be able to set up searches or smart folders that are quite that smart.

    Fortunately for the true Leopard geek, Spotlight also understands a query language—a programming-like syntax that lets you establish far more specific and nuanced searches. You can use it to pull off stunts that would be impossible using the Spotlight menu or window alone.

    To read about the basics of the query language, start at http://developer.apple.com/macosx/spotlight.html; it will lead you to a number of Web pages that explain the full scope of Spotlight's internal lingo.

    You may also get a kick out of studying how Spotlight uses the query language itself. To do that, create a smart folder, and then Get Info on it. (Control-click or right-click it and, from the shortcut menu, choose Get Info.) On the General panel, inspect the string of query text that Spotlight generated behind the scenes (as shown here).

    What you'll learn is that the basic search command always includes the command kMDItem. To search for something by its file type, your query should begin with kMDItemContent-Type; for when you last opened it, use kMDItemLastUsed-Date; and so on.

    For example, here's how you'd type a query that rounds up all files that contain the keyword "kumquat": kMDItem-Keywords == "*kumquat*". (The double = symbol means "equal." You can also use <, >, <=, and so on. The asterisks are wildcards that mean, "There may be other text here, or not; it's still a good match.")

    To signify "and," use two ampersands, like this: &&. For "or," use two vertical bars, like this: ||.

    Once you've read more about this query language, you can build much more complicated searches. This one, for example, finds all audio files, whose author is either Kevin or Steve, that were modified in the last week:

        ((kMDItemAuthors == "Kevin"wc ||
    kMDItemAuthors == "Steve"wc) &&
    (kMDItemContentType == "audio"wc ||
    kMDItemContentType == "video"wc))
    && (kMDItemFSContentChangeDate == $time.this_week)

    And here's how you'd find all PDF documents and PostScript files with a single search:

        ((kMDItemContentTypeTree == 'com.adobe.pdf') ||
    (kMDItemKind == 'Post-Script document'))

    (Most of this stuff actually stands for useful things: MD for metadata, wc for "word-based, case-insensitive," and so on.)

    And where, you may ask, are you supposed to type all these queries? You have two options.

    In the Finder, when you choose File rightwards double arrow Find to produce the Spotlight window, choose Other from the Kind pop-up menu. In the list of six gazillion search parameters, choose Raw Query. You can type your elaborate search string into the text box that appears.

    Second, you can open Terminal (Chapter 16) and use Spotlight's Unix equivalent. The main command you want to learn about is mdfind. For example, at the Terminal prompt, you could type mdfind "kMDItemAcquisitionModel == 'Canon PowerShot S80'" (and then press Enter) to see a list of all photos you took with that particular camera model.

    Spotlight: The Missing Manual? Hmm. Has a nice ring to it, doesn't it?

  • Change the keystroke. Ordinarily, pressing [image] -Space bar highlights the Spotlight search box in your menu bar, and Option- [image] -Space bar opens the Spotlight window described above. If these keystrokes clash with some other key assignment in your software, though, you can reassign them to almost any other keystroke you like.

    Most people notice only the pop-up menu that lets you select one of your F-keys (the function keys at the top of your keyboard). But you can also click inside the white box that lists the keystroke and then press any key combination—Control-S, for example—to choose something different. Whatever keystroke you choose must include at least one of the modifier keys (Option, Control, or [image]) or one of the F-keys (such as F4).

Note: Apple assumes no responsibility for your choosing a keystroke that messes up some other function on your Mac. -S, for example, would not be a good choice.On the other hand, if you choose a Spotlight keystroke that Mac OS X uses for some other function (like Shift- [image] -3), a little yellow alert icon appears in the Spotlight pane. This icon is actually a button; clicking it brings you to the Keyboard & Mouse pane, where you see exactly which keystroke is in dispute, and change it.

Figure 3-7. You can add disks, partitions, or folders to the list of non-searchable items just by dragging them from the desktop into this window. Or, if the private items aren't visible at the moment, you can click the + button, navigate your hard drive, select the item, and click Choose. To remove something from this list, click it and then press the Delete key or click the – button.

3.3.1. Privacy Settings

Ordinarily, Spotlight doesn't consider any corner of your hard drive off-limits. It looks for matches wherever it can except in other people's Home folders. (That is, you can't search through other people's stuff).

But even within your own Mac world, you can hide certain folders from Spotlight searches. Maybe you have privacy concerns—for example, you don't want your spouse Spotlighting your stuff while you're away from your desk. Maybe you just want to create more focused Spotlight searches, removing a lot of old, extraneous junk from its database.

Either way, the steps are simple. Open the Spotlight panel of System Preferences, as described above. Click the Privacy tab. Figure 3-7 explains the remaining steps.

Tip: When you mark a disk or folder as non-searchable, Spotlight actually deletes its entire index (its invisible card-catalog filing system) from that disk. If Spotlight ever seems to be acting wackily, you can use this function to make it rebuild its own index file on the problem disk. Just drag the disk into the Privacy list and then remove it again! Spotlight deletes, and then rebuilds, the index for that disk.(Don't forget the part about "remove it again," though. If you add a disk to the Privacy list, Spotlight is no longer able to find anything on it, even if you can see it right in front of you.)

Once you've built up the list of private disks and folders, close System Preferences. Spotlight now pretends the private items don't even exist.


smart_folders.html

3.4. Smart Folders

You may remember from Chapter 1 (or from staring at your own computer) that the Sidebar at the left side of every Leopard desktop window contains a set of little folders under the Searches heading. Each is actually a smart folder—a self-updating folder that, in essence, performs a continual, 24/7 search for the criteria you specify. (Smart folders are a lot like smart albums in iPhoto and iTunes, smart mailboxes in Mail, and so on.)

Note: In truth, the smart folder performs a search for the specified criteria at the moment you open it. But because it's so fast, and because it's always up to date, it feels as though it's been quietly searching all along.

As it turns out, the ones installed there by Apple are meant to serve as inspiration for you to create your own smart folders. The key, as it turns out, is the little Save button in the upper-right corner of the Spotlight window.

Here's a common example of how you might use it. (It's an example, by the way, that you can't replicate in any other operating system.) You choose File rightwards double arrow Find. You set up the pop-up menus to say "last opened date" and "this week." You click Save. You name the smart folder something like Current Crises, and you turn on "Add to Sidebar" (Figure 3-8).

Tip: Behind the scenes, smart folders that you create are actually special files that are stored in your Home rightwards double arrow Library rightwards double arrow Saved Searches folder.

Figure 3-8. Mac OS X can preserve your search as a smart folder listed in the Sidebar (lower left)—at least, it does as long as "Add To Sidebar" is turned on. You can stash a smart folder in your Dock, too, although it doesn't display a stack of its contents, as normal folders do.

From now on, whenever you click that smart folder, it reveals all of the files you've worked on in the last week or so. The great part is that these items' real locations may be all over the map, scattered in folders all over your Mac and your network. But through the magic of the smart folder, they appear as though they're all in one neat folder.

Tip: If you decide your original search criteria need a little fine-tuning, click the smart folder. From the Action menu, choose Show Search Criteria. You're back on the original setting-up-the-search window. Use the pop-up menus and other controls to tweak your search setup, and then click the Save button once again.To delete a smart folder, just drag its icon out of the Sidebar. (Or if it's anywhere else, like on your desktop, drag it to the Trash like any other folder.)


dock_desktop_and_toolbars.html

Chapter 4. Dock, Desktop, and Toolbars

You can't help reacting, one way or another, to the futuristic, sleek looks of Mac OS X the first time you arrive at its desktop. There's the Dock, looking photorealistic and shiny on its new mirror-finish shelf. There are those Finder windows, 8smooth and textureless with their gentle gradient-gray title bars. And there's the shimmering, even continually morphing backdrop of the desktop itself.

This chapter shows you how to use and control these most dramatic elements of Mac OS X.

4.1. The Dock

For years, most operating systems maintained two different lists of programs. One listed unopened programs until you need them, like the Start menu (Windows) or the Launcher (Mac OS 9). The other kept track of which programs were open at the moment for easy switching, like the taskbar (Windows) or the Application menu (Mac OS 9).

In Mac OS X, Apple combined both functions into a single strip of icons called theDock.

Apple's thinking goes like this: Why must you know whether or not a program is already running? That's the computer's problem, not yours. In an ideal world, this distinction should be irrelevant. A program should appear when you click its icon, whether it's open or not—like on a PalmPilot, for example.

"Which programs are open" already approaches unimportance in Mac OS X, where sophisticated memory-management features make it hard to run out of memory. You can open dozens of programs at once in Mac OS X.

And that's why the Dock combines the launcher and status functions of a modern operating system. Only a tiny white reflective dot beneath a program's icon tells you that it's open.

Whether or not you agree with Apple's philosophy (and not everyone does), Apple has made it as easy as possible to learn to like the Dock. You can customize the thing to within an inch of its life, or even get rid of it completely. This section explains everything you need to know.


the_dock-id001.html

Chapter 4. Dock, Desktop, and Toolbars

You can't help reacting, one way or another, to the futuristic, sleek looks of Mac OS X the first time you arrive at its desktop. There's the Dock, looking photorealistic and shiny on its new mirror-finish shelf. There are those Finder windows, 8smooth and textureless with their gentle gradient-gray title bars. And there's the shimmering, even continually morphing backdrop of the desktop itself.

This chapter shows you how to use and control these most dramatic elements of Mac OS X.

4.1. The Dock

For years, most operating systems maintained two different lists of programs. One listed unopened programs until you need them, like the Start menu (Windows) or the Launcher (Mac OS 9). The other kept track of which programs were open at the moment for easy switching, like the taskbar (Windows) or the Application menu (Mac OS 9).

In Mac OS X, Apple combined both functions into a single strip of icons called theDock.

Apple's thinking goes like this: Why must you know whether or not a program is already running? That's the computer's problem, not yours. In an ideal world, this distinction should be irrelevant. A program should appear when you click its icon, whether it's open or not—like on a PalmPilot, for example.

"Which programs are open" already approaches unimportance in Mac OS X, where sophisticated memory-management features make it hard to run out of memory. You can open dozens of programs at once in Mac OS X.

And that's why the Dock combines the launcher and status functions of a modern operating system. Only a tiny white reflective dot beneath a program's icon tells you that it's open.

Whether or not you agree with Apple's philosophy (and not everyone does), Apple has made it as easy as possible to learn to like the Dock. You can customize the thing to within an inch of its life, or even get rid of it completely. This section explains everything you need to know.


setting_up_the_dock.html

4.2. Setting Up the Dock

Apple starts the Dock off with a few icons it thinks you'll enjoy: Dashboard, QuickTime Player, iTunes, iChat, Mail, the Safari Web browser, and so on. But using your Mac without putting your own favorite icons in the Dock is like buying an expensive suit and turning down the free alteration service. At the first opportunity, you should make the Dock your own.

The concept of the Dock is simple: Any icon you drag onto it (Figure 4-1) is installed there as a button. (You can even drag an open window onto the Dock—a Microsoft Word document you're editing, say—using its proxy icon [Section 1.2.4] as a handle.)

A single click, not a double-click, opens the corresponding icon. In other words, the Dock is an ideal parking lot for the icons of disks, folders, documents, programs, and Internet bookmarks that you access frequently.

Tip: You can install batches of icons onto the Dock all at once—just drag them as a group. That's something you can't do with the other parking places for favorite icons, like the Sidebar and the Finder toolbar.

Figure 4-1. To add an icon to the Dock, simply drag it there. You haven't moved the original file; when you release the mouse, it remains where it was. You've just installed a pointer—like a Macintosh alias or Windows shortcut.

Here are a few aspects of the Dock that may throw you at first:

  • It has two sides. See the whitish dotted line running down the Dock? That's the divider (Figure 4-1). Everything on the left side is an application—a program. Everything else goes on the right side: files, documents, folders, disks, and minimized windows.

    It's important to understand this division. If you try to drag an application to the right of the line, for example, Mac OS X teasingly refuses to accept it. (Even aliases observe that distinction. Aliases of applications can go only on the left side, and vice versa.)

  • Its icon names are hidden. To see the name of a Dock icon, point to it without clicking. You'll see the name appear above the icon.

    When you're trying to find a certain icon in the Dock, run your cursor slowly across the icons without clicking; the icon labels appear as you go. You can often identify a document just by looking at its icon.

  • Folders and disks sprout stacks. If you click a folder or disk icon in the right side of the Dock, a list of its contents sprouts from the icon. It's like X-ray vision without the awkward moral consequences. Turn the page for details on stacks.

  • Programs appear there unsolicited. Nobody but you (and Apple) can put icons on the right side of the Dock. But program icons appear on the left side of the Dock automatically whenever you open a program, even one that's not listed in the Dock. Its icon remains there for as long as it's running.

Tip: The Dock's translucent, reflective look is something to behold. Some people actually find it too translucent. But using TinkerTool, you can tone down the Dock's translucence—a great way to show off at user group meetings. See Section 17.1 for details.

GEM IN THE ROUGH
Living Icons

Mac OS X brings to life a terrific idea, a new concept in main-stream operating systems: icons that tell you something. If the Dock is big enough, you can often tell documents apart just by looking at their icons.

Some program icons even change over time. The Mail icon, for example (Chapter 19) bears a live counter that indicates how many new email messages are waiting for you. (After all, why should you switch into the Mail program if you'll only be disappointed?) The America Online icon sprouts a flag to let you know if an instant message is waiting. You can make your Activity Monitor graph (Section 6.4) show up right on its icon. Toast illustrates the progress of a disc you're burning. And if you minimize a QuickTime movie while it's playing, it shrinks down and continues playing right there in the Dock.

Think of the possibilities. One day the Safari icon could change to let you know when interesting new Web pages have appeared, the Quicken icon could display your current bank balance, and the Microsoft Word icon could change every time Microsoft posts a bug fix.

4.2.1. Organizing and Removing Dock Icons

You can move the tiles of the Dock around by dragging them horizontally. As you drag, the other icons scoot aside to make room. When you're satisfied with its new position, drop the icon you've just dragged.

To remove a Dock icon, just drag it away. (You can't remove the icons of the Finder, the Trash, the Dock icon of an open program, or any minimized document window.) Once your cursor has cleared the Dock, release the mouse button. The icon disappears, its passing marked by a charming little puff of animated cartoon smoke. The other Dock icons slide together to close the gap.

Tip: You can replace the "puff of smoke" animation with one of your own, as described on Section 17.2.2.

Something weird happens if you drag away a Dock program's icon while that program is running. You don't see any change immediately, because the program is still open. But when you quit the program, you'll see that its previously installed icon is no longer in the Dock.

4.2.2. Stacks

A stack is what you get when you click a disk or folder icon on the Dock—and it's one of Leopard's marquee new features. The effect is shown in Figure 4-2.

Tip: If you press Shift as you click, the stack opens in slow motion. Amaze your friends.

In essence, Mac OS X is fanning out the folder's contents so you can see all of them. If it could talk, it would be saying, "Pick a card, any card."

Tip: You can change how the icons in a particular stack fan are sorted: alphabetically, chronologically, or whatever. Just choose "Sort by" from the Dock folder's shortcut menu, and choose from the submenu. Your choices are Name, Date Added (to the Dock), Date Modified, Date Created, or Kind.

UP TO SPEED
The Deal with Dock Shortcut Menus

Every icon on the Dock hides a little shortcut menu filled with useful commands. And every Macintosh book author gets sick and tired of describing the three different ways to open it.

This Macintosh book author has decided to write it up once, in this box—and then refer to this blurb every other time the shortcut menu is mentioned in the chapter.

Way 1: Control-click any Dock icon.

Way 2: If you have a mouse with two buttons, right-click any Dock icon.

Way 3: If you're in no rush, click any Dock icon, but keep the mouse button pressed. The shortcut menu pops up automatically. up to speed

4.2.2.1. Fan vs. grid

Sometimes there are too many icons in a folder to fit in a fan. In that case, the stack becomes a grid instead (Figure 4-2, bottom). The grid, of course, holds many more icons than the fan, although it's not as pretty.

Figure 4-2. Top: When you click the icon of a folder or disk on the Dock (just one single click), you get this effect: a rainbow that shows what's inside. Click an icon to open it, just as though you'd double-clicked it in a window. You can even Option-click one icon after another, opening them all while the stack remains arrayed before you.
Or grab an icon and drag it right out of the stack—into another window, say.
Bottom: If there are too many icons to fit in the arc (as determined by your monitor size), you get this grid instead. Alas, here, too, space is limited. If there are more than fits on the grid, click the "35 more in Finder" icon at the lower right. You go to the folder's regularly scheduled window, where you can see the complete list of icons)

But you can force a certain Dock folder to sprout a fan or a grid all the time, rather than letting Mac OS X decide. From the Dock folder's shortcut menu (Section 4.2.2), choose View As rightwards double arrow Fan or View As rightwards double arrow Grid.

From now on, you'll always get the fan, or always get the grid.

Note: When your Dock is positioned on a side of the screen instead of the bottom, you alwaysget the grid, never the fan. The View As command doesn't even appear in the shortcut menu.

Both the grid and the fan have limited storage space for icons. (The exact number depends on your monitor size. In any case, if there are too many icons to display at once, the last icon says, "24 more in Finder" (or whatever the number is). Click that icon to open the folder's regular window, where all the contents are available.

Of course, then you've defeated the fan's step-saving purpose.

Tip: The ideal solution, of course, would be what Mac OS X had in 10.0 through 10.4: a simple pop-up list of everything in a Dock folder. That's exactly what you get with the free program Quay, available for download from this book's "Missing CD" at www.missingmanuals.com
4.2.2.2. Ready-made stacks

When you first install Mac OS X 10.5, you get a couple of starter stacks just to get you psyched. One is called Downloads; the other is Documents. (Both of these folders are physically inside your Home folder. But you may well do most of your interacting with them on the Dock.)

The Downloads folder, new in Leopard, collects three kinds of Internet arrivals:

  • Files you download from the Web using Safari

  • Files you receive in an iChat file-transfer session

  • File attachments you get via email using Mail.

Unless you intervene, they're sorted by the date you downloaded them.

It's handy to know where to find your downloads, and nice not to have them all cluttering your desktop.

Tip: Once you've opened a stack's fan or grid, you can drag any of the icons right out of the fan or grid. Just drag your chosen icon onto the desktop or into any visible disk or folder. In other words, what lands in the Downloads folder doesn't have to stay there.
4.2.2.3. Creating and removing stacks

Creating a new stack is easy. Just drag anyfolder or disk icon onto the right end of the Dock. That's right: All folders and disks become stacks when clicked on the Dock.

Therefore, to get a stack off the Dock, drag its folder icon away from the Dock and let go. You're not deleting the actual folder—just its Dock shortcut.

Tip: In Leopard, folder icons on the Dock can actually change to reflect their contents. That can be a little disorienting, since you can't get to know a folder by its icon—it keeps changing!The solution is simple: Put an alias of the folder on the Dock instead of the folder itself. Its icon will never change. (Folder aliases don't open into stacks or hierarchical contents menus, however.)
4.2.2.4. Type-selecting in stacks

Once a fan or grid is on the screen, you can highlight any icon in it by typing the first few letters of its name. For example, once you've popped open your Applications-folder stack, you can highlight Safari (for example) by typing sa. (Press Enter or Return to open the highlighted icon.)

Tip: If your mouse has a scroll wheel, it may be faster to whip through the icons by rolling that.
4.2.2.5. Bypassing stacks

If you just want to see what's in a folder, without all the graphic overkill of the fan or thegrid, choose Open "Applications" (or whatever the folder's name is) from the Dock folder's shortcut menu (Section 4.2.2). You go straight to the corresponding window.

Another possibility: -click the folder's icon. You jump immediately to the window that contains that folder's icon. That's not exactly the same thing as opening the Dock folder, but it's sometimes even more useful.

Tip: Actually, this trick has nothing to do with stacks. -clicking any icon on the Dock (or any listing in the Spotlight menu, for that matter) opens to its enclosing folder, so you can see it in its natural habitat.

4.2.3. Three Ways to Get the Dock Out of Your Hair

The bottom of the screen isn't necessarily the ideal location for the Dock. All Mac screens are wider than they are tall, so the Dock eats into your limited vertical screen space. You have three ways out: Hide the Dock, shrink it, or rotate it 90 degrees.

4.2.3.1. Auto-hiding the Dock

To turn on the Dock's auto-hiding feature, choose [image] rightwards double arrow Dock rightwards double arrow Turn Hiding On (or press Option- [image] -D).

Tip: You also find this on/off switch when you choose [image] rightwards double arrow Dock rightwards double arrow Dock Preferences (Figure 4-3), or when you click the System Preferences icon in the Dock, and then the Dock icon. (Section 4.5.1 contains much more about the System Preferences program.)

When the Dock is hidden, it doesn't slide into view until you move the cursor to the Dock's edge of the screen. When you move the cursor back to the middle of the screen, the Dock slithers out of view once again. (Individual Dock icons may occasionally shoot upward into Desktop territory when a program needs your attention—cute, very cute—but otherwise, the Dock lies low until you call for it.)

On paper, an auto-hiding Dock is ideal; it's there only when you summon it. In practice, however, you may find that the extra half-second the Dock takes to appear and disappear makes this feature slightly less appealing.

Many Mac fans prefer to hide and show the Dock at will by pressing the hide/show keystroke, Option- [image] -D. This method makes the Dock pop on and off the screen without requiring you to move the cursor.

4.2.3.2. Shrinking and enlarging the Dock

Depending on your screen's size, you may prefer smaller or larger Dock buttons. The official way to resize them goes like this: Choose [image] rightwards double arrow Dock rightwards double arrow Dock Preferences. In the resulting dialog box, drag the Dock Size slider, as shown in Figure 4-3.

Figure 4-3. To find a comfortable setting for the Magnification slider, choose rightwards double arrow Dock rightwards double arrow Dock Preferences. Leave the Dock Preferences window open on the screen, as shown here. After each adjustment of the Dock Size slider, try out the Dock (which still works when the Dock Preferences window is open) to test your new settings.

There's a much faster way to resize the Dock, however: Just position your cursor carefully in the Dock's divider line, so that it turns into a double-headed arrow (shown in Figure 4-4). Now drag up or down to shrink or enlarge the Dock.

Figure 4-4. Look closely—you can see the secret cursor that resizes the Dock. If you don't see any change in the Dock size as you drag upward, you've reached the size limit. The Dock's edges are already approaching your screen sides.

Tip: If you press Option as you drag, the Dock snaps to certain canned icon sizes+0151those that the programmer actually drew. (You won't see the in-between sizes that Mac OS X generally calculates on the fly.)

As noted in Figure 4-4, you may not be able to enlarge the Dock, especially if it contains a lot of icons. But you can make it almost infinitely smaller. This may make you wonder: How can you distinguish between icons if they're the size of molecules?

The answer lies in the [image] rightwards double arrow Dock rightwards double arrow Turn Magnification On command. What you've just done is trigger the swelling effect shown in Figure 4-3. Now your Dock icons balloon to a much larger size as your cursor passes over them. It's a weird, magnetic, rippling, animated effect that takes some getting used to. But it's another spectacular demonstration of the graphics technology in Mac OS X, and it can actually come in handy when you find your icons shrinking away to nothing.

Tip: New in Leopard: on-the-fly magnifying!If you press Shift-Control as your cursor approaches the Dock, the icons swell into magnification mode even if magnification is turned off in the [image] rightwards double arrow Dock menu. (The icons swell to whatever maximum size you specified in System Preferences (Figure 4-3).
4.2.3.3. Moving the Dock to the sides of the screen

Yet another approach to getting the Dock out of your way is to rotate it, so that it sits vertically against a side of your screen. You can rotate it in either of two ways:

  • The menu way. From the [image] rightwards double arrow Dock submenu, choose "Positionon Left," "Position on Right," or "Position on Bottom," as you see fit.

    TROUBLESHOOTING MOMENT
    Recovering from a MicroDock

    What is a MicroDock? It's what you get when you try to store 300 JPEG files by dragging them onto a folder in the Dock, but you just miss the folder (thanks to its tendency to scoot aside). As a result, you drop all of the graphics directly onto the Dock. They dutifully appear as shown here, at the size of subatomic particles.

    Now you have a problem. How do you get the Dock back to normal? If you dragged the icons off the Dock one at a time, you'd spend two presidential administrations doing it.

    The easiest way to return to a normal Dock is to delete the Dock preferences file from your Home rightwards double arrow Library rightwards double arrow Preferences folder. The file is named com.apple.dock.plist, and you can just drag it into the Trash. (If you're really obsessive about your Dock setup, you can create a backup of this file now, while everything is working properly. In the event of a MicroDock, you can replace the messed-up preferences file with the backup.)

    When you log out and log back in again, you'll be back to the standard Apple Dock.

  • The mouse way. While pressing Shift, drag the Dock's divider line, like a handle, to the side of the screen you want.

You'll probably find that the right side of your screen works better than the left. Most Mac OS X programs put their document windows against the left edge of the screen, where the Dock and its labels might get in the way.

Note: When you position your Dock vertically, the "right" side of the Dock becomes the bottom of the vertical Dock. In other words, the Trash now appears at the bottom of the vertical Dock. So as you read references to the Dock in this book, mentally substitute the phrase "bottom part of the Dock" when you read references to the "right side of the Dock."


using_the_dock.html

4.3. Using the Dock

Most of the time, you'll use the Dock as either a launcher (you click an icon once to open the corresponding program, file, folder, or disk) or as a status indicator (the tiny, shiny reflective spot, identified in Figure 4-1, indicate which programs are running).

But the Dock has more tricks than that up its sleeve. You can use it, for example, to pull off any of the following stunts.

4.3.1. Switch Applications

The Dock isn't just a launcher; it's also a switcher. For example, it lets you:

  • Jump among your open programs by clicking their icons.

  • Drag a document (such as a text file) on to a Dock application (such as the Microsoft Word icon) to open the former with the latter. (If the program balks at opening the document, yet you're sure the program should be able to open the document, add the [image] and Option keys as you drag.)

  • Hide all windows of the program you're in by Option-clicking another Dockicon.

  • Hide all other programs' windows by Option- [image] -clicking the Dock icon of the program you do want (even if it's already in front).

  • This is just a quick summary of the Dock's application-management functions; you'll find the full details in Chapter 5.

4.3.2. Operate the Dock by Keyboard Control

If you turn on keyboard navigation, you can operate the Dock entirely from the keyboard; see Section 5.6.1.3.

4.3.3. Secret Menus

If you read the box on Section 4.2.2, you know that each Dock icon has its own very useful shortcut menu (Figure 4-5).

If you've clicked a minimized window icon, this shortcut menu says only Open (unless it's a minimized Finder window, in which case it also says Close).

But if you've clicked any other kind of icon, you get some very useful hidden commands. For example:

Figure 4-5. Left Control-click or right-click a Dock icon, or click and hold on it, to open the secret
Right: Control-click the divider bar to open a different hidden menu. This one lists a bunch of useful Dock commands, including the ones listed in the rightwards double arrow Dock submenu.

  • [Window names]. The secret Dock menu of a running program usually lists at least one tiny, neatly labeled window icon, like those shown in Figure 4-5. This useful Mac OS X feature means that you can jump directly not only to a certain program, but to a certain open window in that program.

    For example, suppose you've been using Word to edit three different chapters. You can use Word's Dock icon as a Window menu to pull forward one particular chapter, or (if it's been minimized) to pull it up—even from within a different program. (The check mark indicates the frontmost window, even if the entire program is in the background at the moment.)

    Tip: The Finder tile that's always at the beginning of the Dock is, in effect, its own Window menu. Its shortcut menu lists all open desktop windows. The Window menu at the top of the Finder screen does the same thing, but the Dock is available no matter what program you're using.

  • Keep In Dock/Remove From Dock. Here's another item that's relevant only to program icons in the Dock.

    Whenever you open a program, Mac OS X puts its icon in the Dock—marked with a shiny, white reflective spot—even if you don't normally keep its icon there. As soon as you quit the program, its icon disappears again from the Dock.

    If you understand that much, then the Keep In Dock command makes a lot of sense. It means, "Hello, I'm this program's icon. I know you don't normally keep me in your Dock, but I could stay here even after you quit my program. Just say the word." If you find that you've been using, for example, Terminal a lot more often than you thought you would, this command may be the ticket.

    Tip: Actually, there's a faster way to tell a running application to remain in the Dock from now on. Just drag its icon off the Dock and then right back onto it—yes, while the program is running. You have to try it to believe it.

    On the other hand, what if a program's icon is always in the Dock (even when it's not running) and you don't want it there? In that case, this command says Remove From Dock instead. It gets the program's icon off the Dock, thereby returning the space it was using to other icons. (You can achieve the same result by dragging the icon away from the Dock, but evidently too many Mac fans weren't aware of this trick.)

    Use this command on programs you rarely use. When you do want to run those programs, you can always use Spotlight to fire them up.

    Note: If the program is already running, using Remove From Dock does not immediately remove its icon from the Dock, which could be confusing. That's because a program always appears in the Dock when it's open. What you're doing here is saying, "Disappear from the Dock when you're not running"—and you'll see the proof as soon as you quit that program.

  • Open at Login. This command lets you specify that you want this icon to open itself automatically each time you log into your account (Section 9.16). It's a great way to make sure that your email Inbox, your calendar, or the Microsoft Word thesis you've been working on is fired up and waiting on the screen when you sit down to work.

    To make this item stop auto-opening, choose this command from its Dock icon again, so that the check mark no longer appears.

  • Show In Finder. This command highlights the actual icon (in whatever folder window it happens to sit) of the application, alias, folder, or document you've clicked. You might want to do this when, for example, you're using a program that you can't quite figure out, and you want to jump to its desktop folder in hopes of finding a Read Me file there.

    Tip: Once again, there's a much faster way to reveal a Dock icon in its enclosing window: -click its Dock icon.

  • Hide/Show. This operating system is crawling with ways to hide or reveal a selected batch of windows. Here's a case in point: You can hide all traces of the program you're using by choosing Hide from its Dockicon.(You could accomplish the same thing in many other ways, of course; see Section 5.4.2.2.)

    What's cool here is that (a) you can even hide the Finder and all its windows, and(b) if you press Option, the command changes to say Hide Others. This, in its way,is a much more powerful command. It tells all the programs you're not using—the ones in the background—to get out of your face. They hide themselves instantly.

    Note: Once you've hidden a program's windows, this command changes to say Show, which is how you make them reappear.

  • Quit. You can quit any program directly from its Dock shortcut menu. (Finder and Dashboard are exceptions.) You don't have to switch into a program in order to access its Quit command. (Troubleshooting moment: If you get nothing but a beep when you use this Quit command, it's because you've hidden the windows of that program, and one of them has unsaved changes. Click the program's icon, save your document, and then try to quit again.)

    Of course, thanks to Mac OS X's state-of-the-art memory management features, there's less need these days to quit programs at all. Still, you might be thankful for this quick-quitting feature when your boss is coming down the hallway and the Dilbert Web site is on your screen where a spreadsheet is supposed to be.

    Tip: If you hold down the Option key—even after you've opened the pop-up menu—the Quit command changes to say Force Quit. That's your emergency hatch for jettisoning a locked-up program.

4.3.4. Conduct Speed Tests

When you click an application icon in the Dock, its icon jumps up and down a few times as the program launches, as though with excitement at having been selected. The longer a program takes to startup, them or ebounces you see. This has given birth to a hilarious phenomenon: counting these bounces as a casual speed benchmark for application-launching times. "In Design took 12 bouncemarks to open in Mac OS X 10.4," you might read online, "but only three bouncemarks in 10.5."

Tip: If you find the icon bouncing a bit over the top, try this: Choose [image] rightwards double arrow Dock rightwards double arrow Dock Preferences. In the Dock preference pane (shown in Figure 4-3), turn off "Animate opening applications." From now on, your icons won't actually bounce—instead, the little shiny spot underneath it will simply pulse as the application opens.

4.3.5. Drag and Drop

In Leopard, for the first time, Dock icons are spring-loaded. That is, if you drag any icon onto a Dock icon and pause—or, if you're in a hurry, tap the Space bar—the Dock icon opens to receive the dragged file.

Note: It opens, that is, if the spring-loaded folder feature is turned on in Finder rightwards double arrow Preferences.

This technique is most useful in these situations:

  • Drag a document icon onto a Dock folder icon. The folder's Finder window pops open, so that you can continue the drag into a subfolder.

  • You drag a document into an application. The classic example is dragging a photo onto the iPhoto icon. When you tap the Space bar, iPhoto opens automatically. Since your mouse button is still down, and you're technically still in mid-drag, you can now drop the photo directly into the appropriate iPhoto album or Event.

    You can drag an MP3 file into iTunes or an attachment into Mail or Entourage the same way.

4.3.6. Do Your Filing

Once you've tried stashing a few important folders on the right side of your Dock, there's no going back. You can mostly forget all the other navigation tricks you've learned in Mac OS X. The folders you care about are always there, ready for opening with a single click.

Better yet, they're easily accessible for putting away files; you can drag files directly into the Dock's folder icons as though they were regular folders.

In fact, you can even drag a file into a subfolder in a Dock folder. That's because in Leopard, the Dock's folders are spring-loaded. When you drag an icon onto a Dock folder and pause, the folder's window appears around your cursor, so you can continue the drag into an inner folder (and even an innerinner folder, and so on). Section 2.4.4 has the details on spring-loaded folders.

Tip: When you try to drag something into a Dock folder icon, the Dock icons scoot out of the way; the Dock assumes that you're trying to put that something ontothe Dock. But if you press the [image] key as you drag an icon to the Dock, the existing Dock icons freeze in place. Without the [image] key, you wind up playing a frustrating game of chase-the-folder.

4.3.7. Great Things to Put in Your Dock

Now that you know what the Dock's about, it's time to set up shop. Install the programs, folders, and disks you'll be using most often.

They can be whatever you want, of course, but don't miss these opportunities:

  • Your Home folder. Many people immediately drag their hard drive icons—or, perhaps more practically, their Home folders (see Section 2.1)—onto the right side of the Dock. Now they have quick access to every file in every folder they ever use.

  • The Applications folder. Here's a no-brainer: Stash the Applications folder here, so you'll have quick pop-up menu access to any program on your machine.

  • Your Applications folder. As an even more efficient corollary, create a new folder of your own. Fill it with the aliases of just the programs you use most often and park it in the Dock. Now you've got an even more useful Applications folder that opens as a stack.

    Tip: Mac OS X comes with too many programs to fit in a single folder stack. So consider making several folders of your programs, grouped by category: Graphics, Internet, Fun, and so on. Put aliases of the appropriate programs in each one. Presto: a handy stack-based categorized launcher.

  • The Shared folder. If you're using the Mac's accounts feature (Chapter 12), this is your wormhole between all accounts—the one place you can put files where everybody can access them (Section 12.6.2).

    Tip: Ordinarily, dragging an icon off the Dock takes it off the Dock.But if you press [image] as you drag, you drag the actual item representedby the Dock icon from wherever it happens to be on the hard drive! This trick is great when, for example, you want to email a document whose icon is in the Dock; just [image] -drag it into your outgoing message. (Option- [image] -drag, meanwhile, creates an aliasof the Dock item.)


the_finder_toolbar-id001.html

4.4. The Finder Toolbar

At the top of every Finder window is a small set of function icons, all in a gradientgray row (Figure 4-6). The first time you run Mac OS X 10.5, you'll find only these icons on the toolbar:

  • Back, Forward. The Finder works something like a Web browser. Only a single window remains open as you navigate the various folders on your hard drive.

    Figure 4-6. If you -click the upper-right toolbar button repeatedly, you cycle through six combinations of large and small icons and text labels. (Three examples are shown here.) Tip: This same -clicking business cycles through the same toolbar variations in Mail, Preview, and other programs that have toolbars.

    The Back button ( [image] ) returns you to whichever folder you were just looking at. (Instead of clicking, [image] you can also press [image] -[, or choose Go rightwards double arrow Back—particularly handy if the toolbar is hidden,as described below.)

    The Forward button ( [image]) springs to life only after you've used the Back button. Clicking it (or pressing [image] -]) returns you to the window you just backed out of.

  • View controls. The four tiny buttons next to the [image] button switch the current window into icon, list, column, or Cover Flow view, respectively (Section 1.2.12). And remember, if the toolbar is hidden, you can get by with the equivalent commands in the View menu at the top of the screen—or by pressing [image] -1, [image] -2, [image] -3,or [image] -4 (for icon, list, column, and Cover Flow view, respectively).

  • QuickLook. The eyeball icon opens the Quick Look preview for a highlighted icon (or group of them); see Section 1.8.

  • Action ( [image]). You can read all about this context-sensitive pop-up menu on page77

  • Search bar. This little round-ended text box is yet another entry point for the Spotlight feature described in Chapter 3. It's a handy way to search your Mac for some file, folder, disk, or program.

4.4.1. Removing or Shrinking the Toolbar

Between the toolbar, the Dock, the Sidebar, and the large icons of Mac OS X, it almost seems like there's an Apple conspiracy to sell big screens.

Fortunately, the toolbar doesn't have to contribute to that impression. You can hide it with one click—on the white, oval "Old Finder Mode" button (Section 1.2.10). You can also hide the toolbar by choosing View rightwards double arrow Hide Toolbar or pressing Option- [image] -T.(The same keystroke, or choosing View rightwards double arrow Show Toolbar, brings it back.)

But you don't have to do without the toolbar altogether. If its consumption of screen space is your main concern, you may prefer to collapse it—to delete the pictures but preserve the text buttons.

The trick is to [image] -click the Old Finder Mode button. With each click, you make the toolbar take up less vertical space, cycling through six variations of shrinking icons, shrinking text labels, and finally labels without any icons at all (Figure 4-6).

There's a long way to adjust the icon and label sizes, too: Choose View rightwards double arrow Customize Toolbar (or Option- [image] click the Old Finder Mode button). As shown in Figure 4-7, the dialog box that appears offers a Show pop-up menu at the bottom. It lets you choose picture-buttons, Icon Only, or, for the greatest space conservation, Text Only. You can see the results without even closing the dialog box.

Click Done or press Enter to make your changes stick.

Note: In Text Only mode, the four View buttons are replaced by a little pop-up menu called View. Furthermore, the Search bar turns into a one-word button called Search. Clicking it brings up the Spotlight window (Section 3.2).

4.4.2. Adding Your Own Icons to the Toolbar

Mac OS X not only offers a collection of beautifully designed icons for alternate (or additional) toolbar buttons, but makes it easy for you to add anythingto the toolbar, turning the toolbar into a supplementary Dock or Sidebar. This is great news for people who miss having their Home and Applications folder icons at the top of the window, as they were in early Mac OS X versions, or for anyone who's run out of space for stashing favorite icons in the Dock or the Sidebar. (Of course, if that's your problem, you need a bigger monitor.)

4.4.2.1. Apple's toolbar-icon collection

As noted above, the first step in tweaking the toolbar is choosing View rightwards double arrow Customize Toolbar. The window shown in Figure 4-7 appears.

Tip: There's a great secret shortcut for opening the Customize Toolbar window: Option- [image] -click the Old Finder Mode button that appears in the upper-right corner of every Finder window.

Figure 4-7. While this window is open, you can add icons to the toolbar by dragging them into place from the gallery before you. You can also remove icons from the toolbar by dragging them up or down off the toolbar. Rearrange the icons by dragging them horizontally.

This is your chance to rearrange the existing toolbar icons or delete the ones you don't use. You can also add any of Apple's buttons to the toolbar by dragging them from the "gallery" onto the toolbar itself. The existing icons scoot out of your cursor's way, if necessary.

Most of the options in the gallery duplicate the functions of menu commands. Here are a few that don't appear on the standard toolbar:

  • Path. Most of the gallery elements are buttons, but this one creates a pop-up menu on the toolbar. When clicked, it reveals (and lets you navigate) the hierarchy—the path—of folders that you open to reach whichever window is open. (Equivalent: -clicking a window's title, as described on Section 1.2.3.)

  • Eject. This button ejects whichever disk or disk image is currently highlighted. (Equivalent: The File rightwards double arrow Eject command, or holding down the [image] key on your keyboard.)

  • Burn. This button burns a blank CD or DVD with the folders and files you've dragged onto it. (Equivalent: The File rightwards double arrow Burn Disc command.)

  • Customize. This option opens this customizing window that you're already examining. (Equivalent: The View rightwards double arrow Customize Toolbar command.)

  • Separator. This gallery icon doesn't actually do anything when clicked. It's designed to set apart groups of toolbar icons. (For example, you might want to segregate your folder buttons, such as Documents and Applications, from your function buttons, such as Delete and Connect.) Drag this dotted line between two existing icons on the toolbar.

  • Space. By dragging this mysterious-looking item into the toolbar, you add a gap between it and whatever icon is to its left. The gap is about as wide as one icon. (The fine, dark, rectangular outline that appears when you drag it doesn't actually show up once you click Done.)

  • Flexible Space. This icon, too, creates a gap between the toolbar buttons. But this one expands as you make the window wider. Now you know how Apple got the Search box to appear off to the right of the standard toolbar, a long way from its clustered comrades to the left.

  • NewFolder. Clicking this button creates a new folder in whichever window you're viewing. (Equivalent: the File rightwards double arrow New Folder command, or the Shift- [image] -N keystroke.)

  • Delete. This option puts the highlighted file or folder icons into the Trash. (Equivalent: the File rightwards double arrow Move to Trash command, or the [image] -Delete keystroke.)

  • Connect. If you're on a home or office network, this opens the Connect to Server dialog box (see Section 13.3.2) so that you can tap into another computer. (Equivalent: The Go rightwards double arrow Connect to Server command, or [image] -K.)

  • Get Info. This button opens the Get Info window (Section 2.7) for whatever's highlighted.

  • iDisk. The iDisk is your own personal 5-gigabyte virtual hard drive on the Internet. It's your private backup disk, stashed at Apple, safe from whatever fire, flood, or locusts may destroy your office. Of course, you already know this, because you're paying $100 per year for the privilege (see Section 18.6).

    In any case, you can bring your iDisk's icon onto the screen simply by clicking this toolbar icon.

  • Search. This item represents the Spotlight search bar described in Chapter 3.

  • Drag the default set. If you've made a mess of your toolbar, you can always reinstate its original Apple arrangement by dragging this rectangular strip directly upward onto your toolbar.

Note: If a window is too narrow to show all the icons on the toolbar, the right end of the toolbar sprouts a >> symbol. Click it for a pop-up menu that names whichever icons don't fit at the moment. (You'll find this toolbar behavior in many Mac OS X programs, not just the Finder: iPhoto, Safari, Mail, Address Book, and so on.)
4.4.2.2. Adding your own stuff

Millions of Mac fans will probably trudge forward through life using the toolbar to hold the suggested Apple function buttons, and the Sidebar to hold the icons of favorite folders, files, and programs. They may never realize that you can drag any icons at all onto the toolbar—files, folders, disks, programs, or whatever—to turn them into one-click buttons.

In short, you can think of the Finder toolbar as yet another Dock or Sidebar (Figure 4-8).

Figure 4-8. You don't need to choose View rightwards double arrow Customize Toolbar to add your own icons to the toolbar. Just drag them from the desktop or any folder window directly onto the toolbar, at any time. Pause with your cursor on the toolbar for a moment before releasing the icon.

4.4.3. Rearranging or Removing Toolbar Icons

You can drag toolbar icons around, rearranging them horizontally, by pressing [image] as you drag. Taking an icon off the toolbar is equally easy. While pressing the [image] key, just drag the icon clear away from the toolbar. It vanishes in a puff of cartoon smoke.

If the Customize Toolbar sheet is open, you can perform either step without the [image] key.


designing_your_desktop.html

4.5. Designing Your Desktop

In some ways, just buying a Macintosh is a renegade act of self-expression. But that's only the beginning. Now it's time to fashion the computer screen itself according to your personal sense of design and fashion.

4.5.1. System Preferences

Cosmetically speaking, Mac OS X offers two dramatic full-screen features: desktop backgrounds and screen savers.

The command center for both of these functions is the System Preferences program (which longtime Mac and Windows fans may recognize as the former Control Panels). Open it by clicking the System Preferences icon in the Dock, if it's there, or by choosing its name from the [image] menu.

When the System Preferences program opens, you can choose a desktop picture or screen saver by clicking the Desktop & Screen Saver button. For further details on these System Preferences panes, see Section 4.5.1.

4.5.2. Graphic Designers' Corner: The Gray Look

One of the earliest objections to the lively, brightly colored look of Mac OS X came from Apple's core constituency: artists and graphic designers. Some complained that Mac OS X's bright blues (of scroll bar handles, progress bars, the [image] menu, pulsing OK buttons, highlighted menu names and commands), along with the red, green, and yellow window-corner buttons, threw off their color judgment.

These features have been greatly toned down since the original version of MacOSX.The pulsing effects are subtler, the three-dimensional effects are less drastic, and the button colors are less intense. It's all part of Mac OS X's gradual de-colorization; in Leopard, both the [image] menu and the Spotlight menu have gone from colorful to black.

FREQUENTLY ASKED QUESTION
Desktop Fonts

How do I change the fonts used by the Mac OS X Finder?

In Mac OS versions gone by, you could choose any font you liked for your icon labels. You even had a choice of fonts for use in your menus.

Nowadays, that flexibility is gone. You get Lucida Grande in your menus and as icon labels—love it or leave it. You can change the type size in System Preferences, but not the font.

For now, Apple intends to remain conservative with the look of Mac OS X–both for "branding" reasons (to make Mac OS X instantly recognizable) and for technical ones (to make sure that it doesn't open a Pandora's box of interface hacks that wind up destabilizing the machine).

But that's just Apple's intention. You can still fiddle with Mac OS X's look, as described in Chapter 17.

But in case they still bother artists, Apple created what it calls the Graphite look for Mac OS X, which turns all of those interface elements gray instead of blue. To try out this look, choose [image] rightwards double arrow System Preferences;click Appearance;and then choose Graphite from the Appearance pop-up menu.

Tip: The Highlight Color pop-up menu lets you choose a different accent color for your Mac world. This is the background color of highlighted text, the colored oval that appears around highlighted icon names, and a window's "lining" as you drag an icon into it.

4.5.3. Desktop Sounds

Desktop sounds are the tiny sound effects that accompany certain mouse drags. And we're talking tiny—they're so subdued that you might not have noticed them. You hear a little plink/crunch when you drop an icon onto the Trash, a boingy thud when you drag something into a folder, a whoof! when you drag something off the Dock and into oblivion, and so on. The little thud that you hear at the end of a file-copying job is actually useful, because it alerts you that the task is complete.

If all that racket is keeping you awake, however, it's easy enough to turn it off. Open System Preferences, click the Sound icon, and then turn off "Play user interface sound effects."

And if you decide to leave them turned on, please—use discretion when working in a library, neurosurgical operating room, or church.


menulets_the_missing_manual.html

4.6. Menulets: The Missing Manual

See the menu-bar icons in Figure 4-9? Apple calls them Menu Extras, but Mac fans on the Internet have named them menulets. Each is both an indicator and a menu that provides direct access to certain settings in System Preferences. One lets you adjust your Mac's speaker volume; another lets you change the screen resolution; yet another shows you the remaining power in your laptop battery; and so on.

Figure 4-9. These little guys are the direct descendants of the controls once found on the Mac OS 9 Control Strip or the Windows system

To summon the various menulets, you generally visit a certain pane of System Preferences (Section 4.5.1) and turn on a checkbox called, for example, "Show volume in menu bar." Here's a rundown of the various Apple menulets that you may encounter, complete with instructions on where to find this magic on/off checkbox for each:

Tip: The following descriptions indicate the official, authorized steps for installing a menulet. There is, however, a folder on your hard drive that contains 25 of them in a single window, so that you can install one with a quick double-click. To find them, open your hard drive rightwards double arrow System rightwards double arrow Library rightwards double arrow CoreServices rightwards double arrow Menu Extras folder.

  • AirPort lets you turn your AirPort card on or off, join existing AirPort wireless networks, and create your own private ones. To find the "Show" checkbox: Open System Preferences rightwards double arrow Network. From the "Show" pop-up menu, choose AirPort.

  • Battery shows how much power remains in your laptop's battery. To find the "Show" checkbox: Open System Preferences rightwards double arrow Energy Saver rightwards double arrow Options tab.

  • Bluetooth connects to Bluetooth devices, "pairs" your Mac with a cellphone, and so on. To find the "Show" checkbox: Open System Preferences rightwards double arrow Bluetooth. The "Show Bluetooth status in the menu bar" checkbox appears at the bottom of the Settings tab.

  • Clock is the standard menu-bar clock that's been sitting at the upper-right corner of your screen from Day 1. Click it to open a menu where you can check today's date, convert the menu-bar display to a tiny analog clock, and so on. To find the "Show" checkbox: Open System Preferences rightwards double arrow Date & Time. On the Clock tab, turn on "Show the date and time."

  • Displays adjusts screen resolution. On Macs with a projector or second monitor attached, it lets you turn screen mirroring on or off—a tremendous convenience to anyone who gives PowerPoint or Keynote presentations. To find the "Show" checkbox: Open System Preferences rightwards double arrow Displays rightwards double arrow Display tab.

  • is the oddball: There's no checkbox in System Preferences to make this menulet appear. The fact that it even exists is something of a secret.

    To make it appear, open your System rightwards double arrow Library rightwards double arrow CoreServices rightwards double arrow Menu Extras folder as described above, and double-click the Eject.menu icon. That's it! The [image] menulet appears.

    You'll discover that its wording changes: "Open Combo Drive," "Close DVD-ROM Drive," "Eject [Name of Disc]," or whatever, to reflect your particular drive type and what's in it at the moment.

  • Fax reveals the current status of a fax you're sending or receiving, so you're not kept in suspense. To find the "Show" checkbox: Open System Preferences rightwards double arrow Print & Fax, and then click Faxing.

  • HomeSync is useful only if some friendly neighborhood network administrator has set up Mac OS X Server at your office.

Thanks to a feature called portable Home folders, you can take your laptop on the road and do work—and then, on your return, have the changes synced automatically to your main machine at work over the network. Or not automatically; this menulet's Sync Home Now command performs this synchronization on demand.

  • iChat is a quick way to let the world know, via iChat and the Internet (Section 7.5.1.8), that you're away from your keyboard, or available and ready to chat. Via the Buddy List command, it's also a quick way to open iChat itself. To find the "Show" checkbox: Open iChat; it's in your Applications folder. Choose iChat rightwards double arrow Preferences, click the General button, and turn on "Show status in menu bar."

  • Inkturns the Write Anywhere feature on and off as you use your graphics tablet. (That may not mean much to you until you've read about the Ink feature, described on Section 15.6.6.) To find the "Show" checkbox: Open the Ink panel of System Preferences. Even so, the menulet doesn't appear unless a graphics tablet is attached.

  • IrDAis useful only to ancient PowerBooks that have infrared transmitters—if indeed any of them can even run Leopard. This menulet is known for flakiness; you're best off not installing this.

  • Keychain. This menulet isn't represented by an icon in the Menu Extras folder, but it's still useful if you use Leopard's Keychain feature (Section 12.9.5.1). The menulet lets you do things like opening the Security pane of System Preferences and locking a Keychain. To find the "Show" checkbox: Open your Applications rightwards double arrow Utilities folder. Open the Keychain Access program, and then open the Keychain Access rightwards double arrow Preferences rightwards double arrow General tab.

  • PCCard ejects a PC card that you've inserted into the slot in your laptop, if it has such a slot. To make it appear, open your System rightwards double arrow Library rightwards double arrow CoreServices rightwards double arrow Menu Extras folder, and then double-click the PCCard.menu icon.

  • PPP lets you connect or disconnect from the Internet. To find the "Show" checkbox: Open System Preferences rightwards double arrow Network. From the "Show" pop-up menu, choose Internal Modem. Click the Modem tab button.

  • PPPoE (PPP over Ethernet) lets you control certain kinds of DSL connections. To find the "Show" checkbox: Open System Preferences rightwards double arrow Network. From the "Show" pop-up menu, choose Built-in Ethernet. Click the PPPoE tab button.

  • Remote Desktop is a program, sold separately, that lets teachersor system administrators tap into your Mac from across the network. In fact, they can actually see what's on your screen, move the cursoraround, and soon. The menulet lets you do things like turning remote control on and off or sending a message to the administrator. To find the "Show" checkbox: Open System Preferences rightwards double arrow Sharing, and then click Apple Remote Desktop.

  • Script menu lists a variety of useful, ready-to-run AppleScript programs (see Section 7.5.1). To find the "Show" checkbox: Open your Applications folder, and then open the program called AppleScript Utility.

  • Syncis useful only if you have a .Mac account (Section 18.6)—but in that case, it's very handy. It lets you start and stop the synchronization of your Mac's Web bookmarks, calendar, address book, Keychains, and email with another Mac across the Internet, and it always lets you know the date of your last sync. (Syncing is described in more detail in Chapter 19.) To find the "Show" checkbox: Open System Preferences rightwards double arrow. Mac, and then click Sync.

  • TextInput (officially named the Input Menu) makes it easy for you to switch among different text input modes . You're probably most familiar with the normal keyboard. But what if your language uses a different alphabet, like Russian, or thousands of characters, like Chinese? This menulet summons and dismisses the alternative keyboards and input methods needed for these other systems. Details on Section 9.13.3. To find the "Show" checkbox: Open System Preferences rightwards double arrow International. Click the Input Menu tab.

    Note: You also use this menulet when you're trying to figure out how to type a certain symbol like ¥ or § or [image]. You use the menulet to open the Character Palette and Keyboard Viewer—two great character-finding tools that are described in Section 4.5.1.

  • UniversalAccess, new in Leopard, offers simple on/off status indicators for features that are designed to help with visual, hearing, and muscle impairments. Section 4.5.1 has a rundown of what they do. To find the "Show" checkbox: Open System Preferences rightwards double arrow Universal Access.

  • User identifies the account holder (Chapter 12) who's logged in at the moment. To make this menulet appear (in bold, at the far right end of the menu bar), turn on fast user switching, which is described on Section 12.8.

  • Verizon starts and stops your laptop's connection to the Internet via Broadband Access, Verizon's glorious high-speed cellularservice (meaning you can get online almost anywhere—no Wi-Fi required). This service requires a BroadbandAccess PC card, ExpressCard, or external USB thingie from Verizon. Just slip said device into your laptop—and pay $60 a month.

  • Volume, of course, adjusts your Mac's speaker or headphone volume. To find the "Show" checkbox: Open System Preferences rightwards double arrow Sound.

  • VPNstands for virtual private networking, which allows you to tap into a corporation's network so you can, for example, check your work email from home. You can use the menulet to connect and disconnect, for example. To find the "Show" checkbox: Open the program called Internet Connect (in your Applications folder). Click the VPN button.

To remove a menulet, [image] -drag it off of your menu bar, or turn off the corresponding checkbox in System Preferences. You can also rearrange them by [image] -dragging them horizontally.

These little guys are useful, good-looking, and respectful of your screen space. The world could use more inventions like menulets.


programs_in_mac_OS_X.html

Part II: Programs in Mac OS X

Chapter 5

Chapter 6

Chapter 7

Chapter 8

Chapter 5. Documents, Programs, and Spaces

From the day Apple first announced Mac OSX, the company made clear that Mac OS X offered a lot of advantages, particularly in stability—but that you would need all-new versions of your programs to realize these benefits. Most software companies announced that they would get to work Mac OS X–izing their programs, but Mac fans kept reading the same advice: Don't switch to Mac OS X until most or all of the programs you use every day have been adapted to run on it.

For most people, that time is here. One by one, the Mac OS X versions of big-name programs became ready: Microsoft Office, Photoshop, InDesign, QuarkXPress, iMovie, iTunes, Illustrator, Freehand, Quicken, FileMaker, Internet Explorer, and thousands of others. In fact, most of the latest Mac versions run only in Mac OS X.

UP TO SPEED
Carbon, Cocoa, and Classic (R.I.P.)

There are two chief kinds of Mac OS X–compatible programs, known by the geeks as Carbon and Cocoa programs. These terms refer to the programming tools that were used to create them, which also have a small effect on how well they run in Mac OS X. Section 5.10.1 covers them in more detail, but the point is that this chapter describes how Carbon and Cocoa programs work—these are true Mac OS X programs.

Now, until Leopard came along, there was a third software category. Older Macs (pre-Intel Macs) could also run the very old, pre-2001 operating system known as Mac OS 9, and all of its programs. Mac OS X came with a built-in Mac OS 9 simulator called Classic.

Now, a handful of G4 Leopard-capable Mac models can still restart into Mac OS 9, which is better than nothing.

But Classic is gone. Leopard is all Mac OS X, all the time, making life simpler for Apple—and more complicated for anyone who used to rely on some of those older programs.

The celebration, however, lasted only a few years. Apple soon announced that all of the world's programs would have to be written again—because the company was switching to Intel processing chips for all new Macs. Greater speed was the upside— but only if you ran Intel-rewritten programs. The Mac population patiently set about waiting for and buying new versions of their favorite programs again.

The time has come, therefore, to grow accustomed to the way programs and documents relate in Mac OS X.

5.1. Opening Mac OS X Programs

You can launch (open) a program in any of several ways:

  • Click a program's icon on the Dock, the Sidebar, or the Finder toolbar.

  • Use Spotlight. Hit [image] -Space bar, type the first letters of the program's name, and then press Return or Enter.

  • Double-click an application's icon in the Finder.

  • If you've added the Applications folder to your Dock (or, better yet, a folder containing aliases of only the programs you use), click the Dock icon to open the stack (Section 4.2.2). Then click the program you want (or even type the first few letters of its name and then press Return).

  • Highlight an application icon and then press [image] -O (short for File rightwards double arrow Open) or [image] -down arrow.

  • Use the submenus of the [image] menu's Recent Items rightwards double arrow Applications command.

    FREQUENTLY ASKED QUESTION
    What's with the Big "Duh"?

    So, I've just installed Leopard, I'm all excited, and I double-click an Excel document. And now the Mac asks me: "You are opening Microsoft Excel for the first time. Do you want to continue?" Well, HELLO! I double-clicked the icon, didn't I? Does Apple think I'm some kind of idiot?

    It's not you Apple's worried about. It's the silent parade of evil hackers, lurking out there in Internet Land, waiting for the right moment to bring down the Mac.

    See, in the Windows world, spyware authors have to be sneaky about how they install their stuff on your PC. You wouldn't be so stupid as to double-click an application called Spyware Installer™, of course. So the spyware tricks you into running its installer. It commandeers a certain document type (like MP3 or JPEG), reassigning it to its installer. You innocently double-click some document, but an unanticipated program opens—and you've just opened Pandora's box.

    In Mac OS X, that can't happen. When double-clicking some document opens a program for the first time, this dialog box appears, just to let you know what's about to happen. If the program that's about to open isn't the one you were expecting, well, you've got a chance to back out of it.

    And if it is the program you were expecting, click Continue. You won't be asked again about this version of this particular program.

    Note: Mac OS X stores a list of your recently used programs in a text file called com.apple.recentitems.plist, located in your Home folder rightwards double arrow Library rightwards double arrow Preferences folder. And with about $1.00, that information will buy you a cup of coffee in most restaurants.

  • Open a document icon in any of these ways, or drag a document onto the icon of a program that can open it (whether in the Dock, the Finder toolbar, the Sidebar, or in a folder window).

FREQUENTLY ASKED QUESTION
Virtual Memory and Memory Allotments

I'm completely at sea when it comes to using memory in Mac OS X. There's no Memory control panel. There's no box to set the memory allotment in the Get Info dialog box of any program. There's no on/off switch for virtual memory. There's no RAM disk option. There isn't even an About This Macintosh box that shows where all my RAM is going. What on earth is going on?

Mac OS X handles memory with light-years more sophistication and skill than anything Mac fans have used before—so much so, in fact, that these controls no longer even exist.

In the old days, each program claimed a fixed amount of RAM for itself as soon as you launched it. You could view and adjust this number in the program's Get Info box. When you launched a program, it instantly claimed 20 MB of memory (or whatever its programmers thought it might need).

But in Mac OS X, memory allotments are dynamic. They adjust themselves as needed, on the fly. When you launch a program, it might not use very much RAM at all. But when you then use that program to open a huge, complex document, the system supplies more memory automatically. Then, when you close that document, Mac OS X automatically returns the RAM it was using to the pot, so that it's available for use by other programs and functions.

It's true that the About This Mac command no longer opens a little graph depicting how much RAM each program is using, as it did in Mac OS 9. There's no longer much point. The answer is always, "Exactly as much memory as it needs, and it's changing minute by minute."

Still, if you're desperate to know how much memory each of your running programs is using at this instant, open your Applications rightwards double arrow Utilities folder. Open the program called Activity Monitor. It presents a table showing what percentage of your Mac's memory each running program is using.

Then there's the matter of virtual memory, which helps you open more programs simultaneously than should fit into the amount of RAM (electronic memory) your computer has. This feature works by using a chunk of hard drive space as temporary overflow RAM when necessary. Of course, real memory delivers information to your Mac's brain many times faster than the hard drive, which is why virtual memory has a reputation for sluggishness.

In Mac OS X, virtual memory is turned on all the time. But these days, it doesn't slow down your machine much, for a couple of reasons. First, each program uses only as much RAM as it needs to begin with, so far less is wasted. Second, virtual memory in Mac OS X puts only pieces of your programs onto the hard drive, minimizing the slowdown effect. In any case, even if you have 50 programs open, Mac OS X devotes much of your Mac's actual RAM to whatever program is frontmost, so the active program doesn't grow sluggish. You'll notice the sluggishness kicking in only when switching programs or when working on an absolutely huge document that overwhelms your installed RAM. (Want to see how much virtual memory has kicked in? Mac OS X can show you. See Section 16.8.5.6 for instructions.)

Therefore, "out of memory" messages are unheard-of in Leopard. You may, however, be alerted that your hard drive is running out of space, thereby thwarting the efforts of Mac OS X's virtual memory scheme. Make more room—or install more RAM.

Tip: If you press Option as you open an application (or anything else) in the Finder, you automatically close the window that contains its icon. Later, when you return to the Finder, you'll find a neat, clean desktop—no loitering windows.

When you launch a program, the Mac reads its computer code, which lies on your hard drive's surface, and feeds it quickly into RAM (memory). During this brief interval, the icon of the opening program jumps up and down eagerly (or just blinks eagerly; see the tip on Section 4.3.4) in your Dock.

Tip: Want to see multithreading in action? Launch a program that takes a long time to open—that is, whose icon in the Dock does a lot of bouncing.You don't have to wait for the application to finish bouncing—you're wasting perfectly good computing time. Just switch to another program and get to work; the newly opened program keeps right on launching in the background. Multithreading means that Mac OS X can crunch more than one process at a time.

What happens next depends on the program you're using. Most present you with a new, blank, untitled document. Some, like iDVD, automatically open the last file you worked on. Some, like FileMaker and PowerPoint, ask if you want to open an existing document or create a new one. And a few oddball programs don't open any window at all when first launched.

5.1.1. The Application Menu

In each case, however, the very first menu after the [image] appears with bold lettering and identifies the program you're using. It might say iTunes, or Microsoft Word, or Stickies.

This Application menu (Figure 5-1) offers a number of commands pertaining to the entire program and its windows, including About, Quit, and Hide.

Figure 5-1. The first menu in every program lets you know, at a glance, which program you're actually in. It also offers overall program commands like Quit and Hide.

5.1.2. Quitting Programs

You quit a program by pressing [image] -Q, the keyboard equivalent of the Quit command. (In Mac OS X, the Quit command is at the bottom of the Application menu.)

But Mac OS X offers two much more fun ways to quit a program:

  • Control-click or right-click a program's Dock icon and then choose Quit from the pop-up menu.

  • When you've pressed [image] -Tab to summon Leopard's "heads-up display" of open programs (Section 4.3), type the letter Q without releasing the [image] key. The highlighted program quits without further ado.

UP TO SPEED
When Programs Are Actually Folders

You may have noticed that OS X programs don't seem to have 50,000 support files strewn across your hard drive. To open AOL, you no longer need to first open an America Online folder; you can just double-click the AOL icon. That's a much better arrangement than in Mac OS 9 or Windows, where many programs must remain in special folders, surrounded by libraries, dictionaries, foreign language components, and other support files and folders.

The question is: Where did all those support files go?

Mac OS X features packages or bundles, which are folders that behave like single files. Every properly written Mac OS X program looks like a single, double-clickable application icon. Yet to the Mac, it's actually a folder that contains both the actual application icon and all of its hidden support files. (Even documents can be packages, including iDVD project files, iMovie 6 files, and some TextEdit documents.)

If you'd like to prove this to yourself, try this experiment. Choose Go rightwards double arrow Applications. See the Calculator program? Control-click it or right-click it. From the shortcut menu, choose Show Package Contents. You're asking Mac OS X to show you what's inside the Calculator "application icon" folder.

The Calculator package window opens, revealing a Contents folder that you've never seen before. If you open this folder, you'll find a handful of strange-looking, Unix-named folders and files that are, behind the scenes, pieces of the Calculator program itself.

The application-as-folder trick is convenient for you, of course, because it means that you're generally free to move the application to a different window—or uninstall the program by dragging this single icon to the Trash—without worrying that you're leaving behind its entourage of support files. It's also convenient for programmers, because they can update certain aspects of their applications just by replacing one of these component files, without having to rewrite the entire program.

You can even try out this programmery benefit for yourself. In the case of the Calculator and many other Mac OS X programs, the Resources folder contains individual graphics file—PDF or TIFF files—that serve as the graphic elements that you see when using the program. For example, the file lcd.tiff in the calculator's Resources folder contains the image of the calculator's screen (where the numbers appear as you punch the calculator number buttons).

Using a graphics program, you can change the background of this light-yellow calculator screen to, say, light blue. The next time you double-click the Calculator—which you now realize is actually a folder behind the scenes—you'll see your modified calculator design.

5.1.3. Force Quitting Programs

Mac OS X is a rock-solid operating system, but that doesn't mean that programs never screw up. Individual programs are as likely as ever to freeze—or, rather, to hang (to lock up and display the "spinning beach ball of death" cursor). In such cases, you have no choice but to force quit the program—the computer equivalent of terminating it with a blunt instrument.

Doing so doesn't destabilize your Mac; you don't have to restart it. In fact, you can usually reopen the very same program and get on with your life.

You can force quit a stuck program in any of several ways:

  • Control-click (right-click) its Dock icon, or just hold your mouse down on it. Once the shortcut menu appears, press Option so that the Quit command now says Force Quit (see Figure 5-2). Bingo—that program is outta here.

    Figure 5-2. Top: You can force quit a program from the Dock, thanks to the Option key.
    Bottom: When you press Option- -Esc or choose Force Quit from the menu, a tidy box listing all open programs appears. Just click the one you want to abort, click Force Quit, and click Force Quit again in the confirmation box. Often, you may have to force quit a program twice to make it really go away. (Using more technical tools like the Unix kill command, there are other ways to jettison programs. But this is often the most convenient.)

  • Press Option- [image] -Esc, the traditional Mac force quit keystroke.

  • Choose [image] rightwards double arrow Force Quit.

Either way, proceed as shown in Figure 5-2.

Again, force quitting is not bad for your Mac. The only downside to force quitting a program is that you lose any unsaved changes to your open documents, along with any preference settings you may have changed while the program was open.


documents_programs_and_spaces.html

Part II: Programs in Mac OS X

Chapter 5

Chapter 6

Chapter 7

Chapter 8

Chapter 5. Documents, Programs, and Spaces

From the day Apple first announced Mac OSX, the company made clear that Mac OS X offered a lot of advantages, particularly in stability—but that you would need all-new versions of your programs to realize these benefits. Most software companies announced that they would get to work Mac OS X–izing their programs, but Mac fans kept reading the same advice: Don't switch to Mac OS X until most or all of the programs you use every day have been adapted to run on it.

For most people, that time is here. One by one, the Mac OS X versions of big-name programs became ready: Microsoft Office, Photoshop, InDesign, QuarkXPress, iMovie, iTunes, Illustrator, Freehand, Quicken, FileMaker, Internet Explorer, and thousands of others. In fact, most of the latest Mac versions run only in Mac OS X.

UP TO SPEED
Carbon, Cocoa, and Classic (R.I.P.)

There are two chief kinds of Mac OS X–compatible programs, known by the geeks as Carbon and Cocoa programs. These terms refer to the programming tools that were used to create them, which also have a small effect on how well they run in Mac OS X. Section 5.10.1 covers them in more detail, but the point is that this chapter describes how Carbon and Cocoa programs work—these are true Mac OS X programs.

Now, until Leopard came along, there was a third software category. Older Macs (pre-Intel Macs) could also run the very old, pre-2001 operating system known as Mac OS 9, and all of its programs. Mac OS X came with a built-in Mac OS 9 simulator called Classic.

Now, a handful of G4 Leopard-capable Mac models can still restart into Mac OS 9, which is better than nothing.

But Classic is gone. Leopard is all Mac OS X, all the time, making life simpler for Apple—and more complicated for anyone who used to rely on some of those older programs.

The celebration, however, lasted only a few years. Apple soon announced that all of the world's programs would have to be written again—because the company was switching to Intel processing chips for all new Macs. Greater speed was the upside— but only if you ran Intel-rewritten programs. The Mac population patiently set about waiting for and buying new versions of their favorite programs again.

The time has come, therefore, to grow accustomed to the way programs and documents relate in Mac OS X.

5.1. Opening Mac OS X Programs

You can launch (open) a program in any of several ways:

  • Click a program's icon on the Dock, the Sidebar, or the Finder toolbar.

  • Use Spotlight. Hit [image] -Space bar, type the first letters of the program's name, and then press Return or Enter.

  • Double-click an application's icon in the Finder.

  • If you've added the Applications folder to your Dock (or, better yet, a folder containing aliases of only the programs you use), click the Dock icon to open the stack (Section 4.2.2). Then click the program you want (or even type the first few letters of its name and then press Return).

  • Highlight an application icon and then press [image] -O (short for File rightwards double arrow Open) or [image] -down arrow.

  • Use the submenus of the [image] menu's Recent Items rightwards double arrow Applications command.

    FREQUENTLY ASKED QUESTION
    What's with the Big "Duh"?

    So, I've just installed Leopard, I'm all excited, and I double-click an Excel document. And now the Mac asks me: "You are opening Microsoft Excel for the first time. Do you want to continue?" Well, HELLO! I double-clicked the icon, didn't I? Does Apple think I'm some kind of idiot?

    It's not you Apple's worried about. It's the silent parade of evil hackers, lurking out there in Internet Land, waiting for the right moment to bring down the Mac.

    See, in the Windows world, spyware authors have to be sneaky about how they install their stuff on your PC. You wouldn't be so stupid as to double-click an application called Spyware Installer™, of course. So the spyware tricks you into running its installer. It commandeers a certain document type (like MP3 or JPEG), reassigning it to its installer. You innocently double-click some document, but an unanticipated program opens—and you've just opened Pandora's box.

    In Mac OS X, that can't happen. When double-clicking some document opens a program for the first time, this dialog box appears, just to let you know what's about to happen. If the program that's about to open isn't the one you were expecting, well, you've got a chance to back out of it.

    And if it is the program you were expecting, click Continue. You won't be asked again about this version of this particular program.

    Note: Mac OS X stores a list of your recently used programs in a text file called com.apple.recentitems.plist, located in your Home folder rightwards double arrow Library rightwards double arrow Preferences folder. And with about $1.00, that information will buy you a cup of coffee in most restaurants.

  • Open a document icon in any of these ways, or drag a document onto the icon of a program that can open it (whether in the Dock, the Finder toolbar, the Sidebar, or in a folder window).

FREQUENTLY ASKED QUESTION
Virtual Memory and Memory Allotments

I'm completely at sea when it comes to using memory in Mac OS X. There's no Memory control panel. There's no box to set the memory allotment in the Get Info dialog box of any program. There's no on/off switch for virtual memory. There's no RAM disk option. There isn't even an About This Macintosh box that shows where all my RAM is going. What on earth is going on?

Mac OS X handles memory with light-years more sophistication and skill than anything Mac fans have used before—so much so, in fact, that these controls no longer even exist.

In the old days, each program claimed a fixed amount of RAM for itself as soon as you launched it. You could view and adjust this number in the program's Get Info box. When you launched a program, it instantly claimed 20 MB of memory (or whatever its programmers thought it might need).

But in Mac OS X, memory allotments are dynamic. They adjust themselves as needed, on the fly. When you launch a program, it might not use very much RAM at all. But when you then use that program to open a huge, complex document, the system supplies more memory automatically. Then, when you close that document, Mac OS X automatically returns the RAM it was using to the pot, so that it's available for use by other programs and functions.

It's true that the About This Mac command no longer opens a little graph depicting how much RAM each program is using, as it did in Mac OS 9. There's no longer much point. The answer is always, "Exactly as much memory as it needs, and it's changing minute by minute."

Still, if you're desperate to know how much memory each of your running programs is using at this instant, open your Applications rightwards double arrow Utilities folder. Open the program called Activity Monitor. It presents a table showing what percentage of your Mac's memory each running program is using.

Then there's the matter of virtual memory, which helps you open more programs simultaneously than should fit into the amount of RAM (electronic memory) your computer has. This feature works by using a chunk of hard drive space as temporary overflow RAM when necessary. Of course, real memory delivers information to your Mac's brain many times faster than the hard drive, which is why virtual memory has a reputation for sluggishness.

In Mac OS X, virtual memory is turned on all the time. But these days, it doesn't slow down your machine much, for a couple of reasons. First, each program uses only as much RAM as it needs to begin with, so far less is wasted. Second, virtual memory in Mac OS X puts only pieces of your programs onto the hard drive, minimizing the slowdown effect. In any case, even if you have 50 programs open, Mac OS X devotes much of your Mac's actual RAM to whatever program is frontmost, so the active program doesn't grow sluggish. You'll notice the sluggishness kicking in only when switching programs or when working on an absolutely huge document that overwhelms your installed RAM. (Want to see how much virtual memory has kicked in? Mac OS X can show you. See Section 16.8.5.6 for instructions.)

Therefore, "out of memory" messages are unheard-of in Leopard. You may, however, be alerted that your hard drive is running out of space, thereby thwarting the efforts of Mac OS X's virtual memory scheme. Make more room—or install more RAM.

Tip: If you press Option as you open an application (or anything else) in the Finder, you automatically close the window that contains its icon. Later, when you return to the Finder, you'll find a neat, clean desktop—no loitering windows.

When you launch a program, the Mac reads its computer code, which lies on your hard drive's surface, and feeds it quickly into RAM (memory). During this brief interval, the icon of the opening program jumps up and down eagerly (or just blinks eagerly; see the tip on Section 4.3.4) in your Dock.

Tip: Want to see multithreading in action? Launch a program that takes a long time to open—that is, whose icon in the Dock does a lot of bouncing.You don't have to wait for the application to finish bouncing—you're wasting perfectly good computing time. Just switch to another program and get to work; the newly opened program keeps right on launching in the background. Multithreading means that Mac OS X can crunch more than one process at a time.

What happens next depends on the program you're using. Most present you with a new, blank, untitled document. Some, like iDVD, automatically open the last file you worked on. Some, like FileMaker and PowerPoint, ask if you want to open an existing document or create a new one. And a few oddball programs don't open any window at all when first launched.

5.1.1. The Application Menu

In each case, however, the very first menu after the [image] appears with bold lettering and identifies the program you're using. It might say iTunes, or Microsoft Word, or Stickies.

This Application menu (Figure 5-1) offers a number of commands pertaining to the entire program and its windows, including About, Quit, and Hide.

Figure 5-1. The first menu in every program lets you know, at a glance, which program you're actually in. It also offers overall program commands like Quit and Hide.

5.1.2. Quitting Programs

You quit a program by pressing [image] -Q, the keyboard equivalent of the Quit command. (In Mac OS X, the Quit command is at the bottom of the Application menu.)

But Mac OS X offers two much more fun ways to quit a program:

  • Control-click or right-click a program's Dock icon and then choose Quit from the pop-up menu.

  • When you've pressed [image] -Tab to summon Leopard's "heads-up display" of open programs (Section 4.3), type the letter Q without releasing the [image] key. The highlighted program quits without further ado.

UP TO SPEED
When Programs Are Actually Folders

You may have noticed that OS X programs don't seem to have 50,000 support files strewn across your hard drive. To open AOL, you no longer need to first open an America Online folder; you can just double-click the AOL icon. That's a much better arrangement than in Mac OS 9 or Windows, where many programs must remain in special folders, surrounded by libraries, dictionaries, foreign language components, and other support files and folders.

The question is: Where did all those support files go?

Mac OS X features packages or bundles, which are folders that behave like single files. Every properly written Mac OS X program looks like a single, double-clickable application icon. Yet to the Mac, it's actually a folder that contains both the actual application icon and all of its hidden support files. (Even documents can be packages, including iDVD project files, iMovie 6 files, and some TextEdit documents.)

If you'd like to prove this to yourself, try this experiment. Choose Go rightwards double arrow Applications. See the Calculator program? Control-click it or right-click it. From the shortcut menu, choose Show Package Contents. You're asking Mac OS X to show you what's inside the Calculator "application icon" folder.

The Calculator package window opens, revealing a Contents folder that you've never seen before. If you open this folder, you'll find a handful of strange-looking, Unix-named folders and files that are, behind the scenes, pieces of the Calculator program itself.

The application-as-folder trick is convenient for you, of course, because it means that you're generally free to move the application to a different window—or uninstall the program by dragging this single icon to the Trash—without worrying that you're leaving behind its entourage of support files. It's also convenient for programmers, because they can update certain aspects of their applications just by replacing one of these component files, without having to rewrite the entire program.

You can even try out this programmery benefit for yourself. In the case of the Calculator and many other Mac OS X programs, the Resources folder contains individual graphics file—PDF or TIFF files—that serve as the graphic elements that you see when using the program. For example, the file lcd.tiff in the calculator's Resources folder contains the image of the calculator's screen (where the numbers appear as you punch the calculator number buttons).

Using a graphics program, you can change the background of this light-yellow calculator screen to, say, light blue. The next time you double-click the Calculator—which you now realize is actually a folder behind the scenes—you'll see your modified calculator design.

5.1.3. Force Quitting Programs

Mac OS X is a rock-solid operating system, but that doesn't mean that programs never screw up. Individual programs are as likely as ever to freeze—or, rather, to hang (to lock up and display the "spinning beach ball of death" cursor). In such cases, you have no choice but to force quit the program—the computer equivalent of terminating it with a blunt instrument.

Doing so doesn't destabilize your Mac; you don't have to restart it. In fact, you can usually reopen the very same program and get on with your life.

You can force quit a stuck program in any of several ways:

  • Control-click (right-click) its Dock icon, or just hold your mouse down on it. Once the shortcut menu appears, press Option so that the Quit command now says Force Quit (see Figure 5-2). Bingo—that program is outta here.

    Figure 5-2. Top: You can force quit a program from the Dock, thanks to the Option key.
    Bottom: When you press Option- -Esc or choose Force Quit from the menu, a tidy box listing all open programs appears. Just click the one you want to abort, click Force Quit, and click Force Quit again in the confirmation box. Often, you may have to force quit a program twice to make it really go away. (Using more technical tools like the Unix kill command, there are other ways to jettison programs. But this is often the most convenient.)

  • Press Option- [image] -Esc, the traditional Mac force quit keystroke.

  • Choose [image] rightwards double arrow Force Quit.

Either way, proceed as shown in Figure 5-2.

Again, force quitting is not bad for your Mac. The only downside to force quitting a program is that you lose any unsaved changes to your open documents, along with any preference settings you may have changed while the program was open.


opening_mac_os_x_programs.html

Part II: Programs in Mac OS X

Chapter 5

Chapter 6

Chapter 7

Chapter 8

Chapter 5. Documents, Programs, and Spaces

From the day Apple first announced Mac OSX, the company made clear that Mac OS X offered a lot of advantages, particularly in stability—but that you would need all-new versions of your programs to realize these benefits. Most software companies announced that they would get to work Mac OS X–izing their programs, but Mac fans kept reading the same advice: Don't switch to Mac OS X until most or all of the programs you use every day have been adapted to run on it.

For most people, that time is here. One by one, the Mac OS X versions of big-name programs became ready: Microsoft Office, Photoshop, InDesign, QuarkXPress, iMovie, iTunes, Illustrator, Freehand, Quicken, FileMaker, Internet Explorer, and thousands of others. In fact, most of the latest Mac versions run only in Mac OS X.

UP TO SPEED
Carbon, Cocoa, and Classic (R.I.P.)

There are two chief kinds of Mac OS X–compatible programs, known by the geeks as Carbon and Cocoa programs. These terms refer to the programming tools that were used to create them, which also have a small effect on how well they run in Mac OS X. Section 5.10.1 covers them in more detail, but the point is that this chapter describes how Carbon and Cocoa programs work—these are true Mac OS X programs.

Now, until Leopard came along, there was a third software category. Older Macs (pre-Intel Macs) could also run the very old, pre-2001 operating system known as Mac OS 9, and all of its programs. Mac OS X came with a built-in Mac OS 9 simulator called Classic.

Now, a handful of G4 Leopard-capable Mac models can still restart into Mac OS 9, which is better than nothing.

But Classic is gone. Leopard is all Mac OS X, all the time, making life simpler for Apple—and more complicated for anyone who used to rely on some of those older programs.

The celebration, however, lasted only a few years. Apple soon announced that all of the world's programs would have to be written again—because the company was switching to Intel processing chips for all new Macs. Greater speed was the upside— but only if you ran Intel-rewritten programs. The Mac population patiently set about waiting for and buying new versions of their favorite programs again.

The time has come, therefore, to grow accustomed to the way programs and documents relate in Mac OS X.

5.1. Opening Mac OS X Programs

You can launch (open) a program in any of several ways:

  • Click a program's icon on the Dock, the Sidebar, or the Finder toolbar.

  • Use Spotlight. Hit [image] -Space bar, type the first letters of the program's name, and then press Return or Enter.

  • Double-click an application's icon in the Finder.

  • If you've added the Applications folder to your Dock (or, better yet, a folder containing aliases of only the programs you use), click the Dock icon to open the stack (Section 4.2.2). Then click the program you want (or even type the first few letters of its name and then press Return).

  • Highlight an application icon and then press [image] -O (short for File rightwards double arrow Open) or [image] -down arrow.

  • Use the submenus of the [image] menu's Recent Items rightwards double arrow Applications command.

    FREQUENTLY ASKED QUESTION
    What's with the Big "Duh"?

    So, I've just installed Leopard, I'm all excited, and I double-click an Excel document. And now the Mac asks me: "You are opening Microsoft Excel for the first time. Do you want to continue?" Well, HELLO! I double-clicked the icon, didn't I? Does Apple think I'm some kind of idiot?

    It's not you Apple's worried about. It's the silent parade of evil hackers, lurking out there in Internet Land, waiting for the right moment to bring down the Mac.

    See, in the Windows world, spyware authors have to be sneaky about how they install their stuff on your PC. You wouldn't be so stupid as to double-click an application called Spyware Installer™, of course. So the spyware tricks you into running its installer. It commandeers a certain document type (like MP3 or JPEG), reassigning it to its installer. You innocently double-click some document, but an unanticipated program opens—and you've just opened Pandora's box.

    In Mac OS X, that can't happen. When double-clicking some document opens a program for the first time, this dialog box appears, just to let you know what's about to happen. If the program that's about to open isn't the one you were expecting, well, you've got a chance to back out of it.

    And if it is the program you were expecting, click Continue. You won't be asked again about this version of this particular program.

    Note: Mac OS X stores a list of your recently used programs in a text file called com.apple.recentitems.plist, located in your Home folder rightwards double arrow Library rightwards double arrow Preferences folder. And with about $1.00, that information will buy you a cup of coffee in most restaurants.

  • Open a document icon in any of these ways, or drag a document onto the icon of a program that can open it (whether in the Dock, the Finder toolbar, the Sidebar, or in a folder window).

FREQUENTLY ASKED QUESTION
Virtual Memory and Memory Allotments

I'm completely at sea when it comes to using memory in Mac OS X. There's no Memory control panel. There's no box to set the memory allotment in the Get Info dialog box of any program. There's no on/off switch for virtual memory. There's no RAM disk option. There isn't even an About This Macintosh box that shows where all my RAM is going. What on earth is going on?

Mac OS X handles memory with light-years more sophistication and skill than anything Mac fans have used before—so much so, in fact, that these controls no longer even exist.

In the old days, each program claimed a fixed amount of RAM for itself as soon as you launched it. You could view and adjust this number in the program's Get Info box. When you launched a program, it instantly claimed 20 MB of memory (or whatever its programmers thought it might need).

But in Mac OS X, memory allotments are dynamic. They adjust themselves as needed, on the fly. When you launch a program, it might not use very much RAM at all. But when you then use that program to open a huge, complex document, the system supplies more memory automatically. Then, when you close that document, Mac OS X automatically returns the RAM it was using to the pot, so that it's available for use by other programs and functions.

It's true that the About This Mac command no longer opens a little graph depicting how much RAM each program is using, as it did in Mac OS 9. There's no longer much point. The answer is always, "Exactly as much memory as it needs, and it's changing minute by minute."

Still, if you're desperate to know how much memory each of your running programs is using at this instant, open your Applications rightwards double arrow Utilities folder. Open the program called Activity Monitor. It presents a table showing what percentage of your Mac's memory each running program is using.

Then there's the matter of virtual memory, which helps you open more programs simultaneously than should fit into the amount of RAM (electronic memory) your computer has. This feature works by using a chunk of hard drive space as temporary overflow RAM when necessary. Of course, real memory delivers information to your Mac's brain many times faster than the hard drive, which is why virtual memory has a reputation for sluggishness.

In Mac OS X, virtual memory is turned on all the time. But these days, it doesn't slow down your machine much, for a couple of reasons. First, each program uses only as much RAM as it needs to begin with, so far less is wasted. Second, virtual memory in Mac OS X puts only pieces of your programs onto the hard drive, minimizing the slowdown effect. In any case, even if you have 50 programs open, Mac OS X devotes much of your Mac's actual RAM to whatever program is frontmost, so the active program doesn't grow sluggish. You'll notice the sluggishness kicking in only when switching programs or when working on an absolutely huge document that overwhelms your installed RAM. (Want to see how much virtual memory has kicked in? Mac OS X can show you. See Section 16.8.5.6 for instructions.)

Therefore, "out of memory" messages are unheard-of in Leopard. You may, however, be alerted that your hard drive is running out of space, thereby thwarting the efforts of Mac OS X's virtual memory scheme. Make more room—or install more RAM.

Tip: If you press Option as you open an application (or anything else) in the Finder, you automatically close the window that contains its icon. Later, when you return to the Finder, you'll find a neat, clean desktop—no loitering windows.

When you launch a program, the Mac reads its computer code, which lies on your hard drive's surface, and feeds it quickly into RAM (memory). During this brief interval, the icon of the opening program jumps up and down eagerly (or just blinks eagerly; see the tip on Section 4.3.4) in your Dock.

Tip: Want to see multithreading in action? Launch a program that takes a long time to open—that is, whose icon in the Dock does a lot of bouncing.You don't have to wait for the application to finish bouncing—you're wasting perfectly good computing time. Just switch to another program and get to work; the newly opened program keeps right on launching in the background. Multithreading means that Mac OS X can crunch more than one process at a time.

What happens next depends on the program you're using. Most present you with a new, blank, untitled document. Some, like iDVD, automatically open the last file you worked on. Some, like FileMaker and PowerPoint, ask if you want to open an existing document or create a new one. And a few oddball programs don't open any window at all when first launched.

5.1.1. The Application Menu

In each case, however, the very first menu after the [image] appears with bold lettering and identifies the program you're using. It might say iTunes, or Microsoft Word, or Stickies.

This Application menu (Figure 5-1) offers a number of commands pertaining to the entire program and its windows, including About, Quit, and Hide.

Figure 5-1. The first menu in every program lets you know, at a glance, which program you're actually in. It also offers overall program commands like Quit and Hide.

5.1.2. Quitting Programs

You quit a program by pressing [image] -Q, the keyboard equivalent of the Quit command. (In Mac OS X, the Quit command is at the bottom of the Application menu.)

But Mac OS X offers two much more fun ways to quit a program:

  • Control-click or right-click a program's Dock icon and then choose Quit from the pop-up menu.

  • When you've pressed [image] -Tab to summon Leopard's "heads-up display" of open programs (Section 4.3), type the letter Q without releasing the [image] key. The highlighted program quits without further ado.

UP TO SPEED
When Programs Are Actually Folders

You may have noticed that OS X programs don't seem to have 50,000 support files strewn across your hard drive. To open AOL, you no longer need to first open an America Online folder; you can just double-click the AOL icon. That's a much better arrangement than in Mac OS 9 or Windows, where many programs must remain in special folders, surrounded by libraries, dictionaries, foreign language components, and other support files and folders.

The question is: Where did all those support files go?

Mac OS X features packages or bundles, which are folders that behave like single files. Every properly written Mac OS X program looks like a single, double-clickable application icon. Yet to the Mac, it's actually a folder that contains both the actual application icon and all of its hidden support files. (Even documents can be packages, including iDVD project files, iMovie 6 files, and some TextEdit documents.)

If you'd like to prove this to yourself, try this experiment. Choose Go rightwards double arrow Applications. See the Calculator program? Control-click it or right-click it. From the shortcut menu, choose Show Package Contents. You're asking Mac OS X to show you what's inside the Calculator "application icon" folder.

The Calculator package window opens, revealing a Contents folder that you've never seen before. If you open this folder, you'll find a handful of strange-looking, Unix-named folders and files that are, behind the scenes, pieces of the Calculator program itself.

The application-as-folder trick is convenient for you, of course, because it means that you're generally free to move the application to a different window—or uninstall the program by dragging this single icon to the Trash—without worrying that you're leaving behind its entourage of support files. It's also convenient for programmers, because they can update certain aspects of their applications just by replacing one of these component files, without having to rewrite the entire program.

You can even try out this programmery benefit for yourself. In the case of the Calculator and many other Mac OS X programs, the Resources folder contains individual graphics file—PDF or TIFF files—that serve as the graphic elements that you see when using the program. For example, the file lcd.tiff in the calculator's Resources folder contains the image of the calculator's screen (where the numbers appear as you punch the calculator number buttons).

Using a graphics program, you can change the background of this light-yellow calculator screen to, say, light blue. The next time you double-click the Calculator—which you now realize is actually a folder behind the scenes—you'll see your modified calculator design.

5.1.3. Force Quitting Programs

Mac OS X is a rock-solid operating system, but that doesn't mean that programs never screw up. Individual programs are as likely as ever to freeze—or, rather, to hang (to lock up and display the "spinning beach ball of death" cursor). In such cases, you have no choice but to force quit the program—the computer equivalent of terminating it with a blunt instrument.

Doing so doesn't destabilize your Mac; you don't have to restart it. In fact, you can usually reopen the very same program and get on with your life.

You can force quit a stuck program in any of several ways:

  • Control-click (right-click) its Dock icon, or just hold your mouse down on it. Once the shortcut menu appears, press Option so that the Quit command now says Force Quit (see Figure 5-2). Bingo—that program is outta here.

    Figure 5-2. Top: You can force quit a program from the Dock, thanks to the Option key.
    Bottom: When you press Option- -Esc or choose Force Quit from the menu, a tidy box listing all open programs appears. Just click the one you want to abort, click Force Quit, and click Force Quit again in the confirmation box. Often, you may have to force quit a program twice to make it really go away. (Using more technical tools like the Unix kill command, there are other ways to jettison programs. But this is often the most convenient.)

  • Press Option- [image] -Esc, the traditional Mac force quit keystroke.

  • Choose [image] rightwards double arrow Force Quit.

Either way, proceed as shown in Figure 5-2.

Again, force quitting is not bad for your Mac. The only downside to force quitting a program is that you lose any unsaved changes to your open documents, along with any preference settings you may have changed while the program was open.


the_heads-up_program_switcher.html

5.2. The "Heads-Up" Program Switcher

Only one program can be in front, or active, at a time.

To make a different program active, you could click or double-click its icon (in the Dock, the Applications folder, or whatever). But the fastest method is to use the [image] -Tab keystroke (Figure 5-3).

Figure 5-3. Apple calls this row of open program icons a "heads-up display," named after the projected data screens on a Navy jet windshield that lets pilots avoid having to look down at their instruments.

You can use this feature in three different ways, which are well worth learning:

  • If you keep the [image] key pressed, each press of the Tab key highlights the Dock icon of another program, in left-to-right Dock order. Release both keys when you reach the one you want. Mac OS X brings the corresponding program to the front. (To move backward through the open programs, press Shift- [image] -Tab.)

  • If you leave the [image] key pressed, you can choose a program by clicking its icon with your mouse.

  • A single press of [image] -Tab takes you to the program you used most recently, and another press returns you to the program you started in.

    Imagine that, for example, you're doing a lot of switching between two programs—your Web browser and your email program, for example. If you have five other programs open, you don't waste your time [image] -Tabbing your way through all open programs just to "get back" to your Web browser.

Tip: Here's a related keystroke, equally awesome. If you press [image] -tilde (the ~ key next to the 1 key), you switch to the next window in the same program.


exposeacute_death_to_window_clutter.html

5.3. Exposé: Death to Window Clutter

In its day, the concept of overlapping windows on the screen was brilliant, innovative, and extremely effective. (Apple borrowed this idea from a research lab called Xerox PARC.) In that era before digital cameras, MP3 files, and the Web, managing your windows was easy this way; after all, you had only about three of them.

These days, however, managing all the open windows in all the open programs can be like herding cats. Off you go, burrowing through the microscopic pop-up menus of your taskbar buttons (Windows) or the Dock (Mac OS X 10.5), trying to find the window you want. And heaven help you if you need to duck back to the desktop—to find a newly downloaded file, for example, or eject a disk. You'll have to fight your way through 50,000 other windows on your way to the bottom of the "deck."

Exposé represents the first fresh look at this problem in decades. The concept is delicious: With the press of the F9 key, Mac OS X shrinks all windows in all programs to a size that fits on the screen (Figure 5-4), like index cards on a bulletin board. You click the one you want, and you're there. It's fast, efficient, animated, and a lot of fun.

Note: On the superth in aluminum Apple keyboards, use the F3 key instead of F9. The painful details are in the box below.

TROUBLESHOOTING MOMENT
A Tedious Sidebar about the Aluminum Apple Keyboards

Do you have the superthin aluminum Apple keyboard (the wireless one, or the aluminum iMac one)? If so, the keystrokes described in this chapter don't not work.

On that keyboard, the F9, F10, and F11 keys—the keys you need for Exposé—are mapped to the Mac's speaker volume!

Fortunately, the most often used Exposé function, the one that exposes all open windows at once, has its own special key on this keyboard: the F3 key.

So you're covered there: press F3 instead of F9. But what about the other two Exposé functions, normally triggered by F10 and F11?

Method 1: Add the Control key (to Exposé one application's windows only) or the [image] key (to see the desktop). That is, instead of F11 to expose the desktop, you should press [image] -F3.

Method 2: Hold down the Fn key. If you do that, then you can use the F9, F10, and F11 keys like everybody else. (Lots of Fn details are on Section P3.3.1.) Kind of a drag, right?

Method 3: Actually, there's a final twist to all this. In System Preferences rightwards double arrow Keyboard & Mouse, you'll find a checkbox that reverses this logic. It's called "Use all F1, F2, etc. keys as standard function keys."

If that checkbox is on, then you can use F9, F10, and F11 to trigger Exposé exactly as described in this chapter. Now you need the Fn key only when you want those keys to adjust the volume.

5.3.1. More Ways to Exposé

That business about finding a buried window on your screen is probably the way you'll use Exposé most often. But it's actually only one of three Exposé functions. The other options:

Figure 5-4. Top: Quick! Where's the Apple Web page in all this mess?
Bottom: With a tap of the F9 key, you can spot that window, shrunken but not overlapped. As your cursor passes over each thumbnail, the window darkens and identifies itself, courtesy of the floating label in its center. What's especially cool is that these aren't static snapshots of the windows at the moment you Exposé'd them. They're live, still-updating windows, as you'll discover if one of them contains a QuickTime movie during playback or a Web page that's still loading. If you're not pointing to a window, tapping F9 again turns off Exposé without changing anything; if you're pointing to a window, tapping F9 again brings it forward.

5.3.1.1. Find one window in the current program

A second Exposé keystroke is designed to help you find a certain window only in the program you're using—great when you're Web browsing or word processing. When you tap F10 (the factory setting), all of the windows in the front most program spread out and shrink, if necessary, so you can see all of them simultaneously, in full—and so you can click the one you want (see Figure 5-5, top).

Note: As noted in the box on Section 5.3.1, you may have to add the Fn key (that is, press Fn+F9) if you have Apple's superthin, iMa [image] -style keyboard.

And now, tips:

  • While your application windows are arrayed before you, tap the Tab key to switch to the next running program. All of its windows spring to the fore, and all of the other programs' windows grow dim. (Shift-Tab, as usual, cycles through the programs in the opposite direction.)

  • Suppose you pressed F9 to shrink all programs' windows, but you decide that what you really meant to do was press F10 to see only one program's windows. The solution is to press the Tab key, which switches you into F10 mode, dimming (and restoring to full size) all programs' windows but one. At this point, you can press Tab or Shift-Tab to cycle through the open programs as described in the preceding paragraph.

Here's another way to change programs once you've "F10'ed" your windows: Press [image] -Tab to bring up the "heads-up display" application switcher (yes, even while your windows are shrunken). Tab your way through the program icons (Figure 5-5) until the one you want is selected, and then release the keys. That program's windows spring to the front, still miniaturized and arrayed for your selection pleasure.

5.3.1.2. Return to the desktop

The third keystroke (F11 is the factory setting) may be the most useful of all. It sends all windows in all programs cowering to the edges of your screen, revealing the desktop beneath in all its uncluttered splendor (Figure 5-5, bottom). There they remain—forever, or until you tap F11 again, click a visible window edge, double-click an icon, or take some other window-selection step.

Note: Once again: On Apple's superthin, iMa [image] -style keyboard, press Fn+F11 instead. See the box on Section 5.3.1

This is a spectacular opportunity to save headache and hassle in situations like these:

  • You're writing an email message, and you want to attach a file. Tap F11, root around in the Finder until you locate the file you want. Begin to drag it, and then tap F11 again to bring back your email window. Move your cursor, with the file in middrag, directly over the outgoing message window; release the cursor to create the attachment.

    Tip: You can apply the same life-changing shortcut to dragging a graphic into some page-layout program, a folder of photos into iPhoto, a sound or graphic into iMovie, and so on.

    Figure 5-5. Top: When you press the F10 key, you get a clear shot at any window in the current program (Safari, in this example). In the meantime, the rest of your screen attractively dims, as though someone has just shined a floodlight onto the windows of the program in question. It's a stunning effect.
    Bottom: Tap the F11 key when you need to duck back to the desktop for a quick administrative chore. Here's your chance to find a file, throw something away, eject a disk, or whatever, without having to disturb your application windows. (When you first tap F11, even open Finder windows are hidden; at left, you've subsequently opened a window manually.)
    In either case, tap the same function key again to turn off Exposé. Or click one of the window edges, which you can see peeking out from all four edges of the screen.

  • You want to open a different document. For many people, having access to the entire Finder beats the pants off having to use the Open dialog box. Double-clicking the icon you want automatically opens it and turns off Exposé.

  • You're on the Web, and you want to see if some file has finished downloading. Tap F11 to survey the situation on your desktop.

In essence, Apple has finally realized that the desktop really isn't "just another program." If the layer of open programs is the atmosphere, the Finder is the earth below—and the ability to teleport you back and forth is a huge time saver.

Tip: You can switch among the three Exposé modes (F9, F10, or F11), even after you've triggered one. For example, if you press F10 to shrink only one program's windows, you can then press F11 to see the desktop, and then press F9 to shrink all programs' windows.
5.3.1.3. Another way to Exposé

Most of the time, you'll probably use Exposé in two steps. You'll tap the function key once to get the windows out of the way, and tap it again to bring them back (if, indeed, you haven't clicked a window to bring them back).

In some cases, though, you may find it easier to hold down the relevant key. For example, hold down F11 to see if a file is finished copying to the desktop, then release the key to bring back all of the windows. For quick window-clearing situations, that method saves you the step of having to press the key a second time to turn off Exposé.

5.3.2. Three Triggers for Exposé

Exposé is wonderful and all, but the standard keys for triggering its three functions—F9 to expose all windows, F10 for current-application windows, F11 for show-me-the desktop—may leave something to be desired. For one thing, they may already be "taken" by other functions in your programs (like Microsoft Word) or even by your computer (like certain PowerBook G4 models, whose F9 and F10 keys adjust the keyboard illumination). For another thing, those keys are at the top of the keyboard where your typing fingers aren't used to going, and you may have to hunt to make sure you're pressing the right one.

Fortunately, you can reassign the Exposé functions to a huge range of other keys, with or without modifiers like Shift, Control, and Option. To view your options, choose [image] rightwards double arrow System Preferences and then click the Exposé & Spaces icon (Figure 5-6).

Here, you'll discover that you can trigger Exposé's functions in any of three ways:

5.3.2.1. Screen corners

The four pop-up menus (Figure 5-6) represent the four corners of your screen. Using these menus, you can assign an Exposé trigger to each corner; for example, if you choose Desktop from the first pop-up menu, when your pointer hits the upper-left corner of the screen, you'll hide all windows and expose the desktop. (To make the windows come back, click any visible edge of a window, or twitch the cursor back into the same corner.)

Depending on the size of your screen, this option can feel awkward at first. But if you've run out of keystrokes that aren't assigned to other functions, be glad that Apple offers you this alternative.

Note: In previous versions of Mac OS X, of course, whipping the pointer into a corner was one good way to turn on your screen saver. Apple hasn't forgotten about that, which is why you'll also find commands called Start Screen Saver and Disable Screen Saver in the pop-up menus. Apple wanted to make sure that you don't get confused and assign two different functions to the same corner.

Figure 5-6. You can trigger Exposé in any of three ways: by twitching your cursor into a certain corner of the screen (top), pressing a key (lower left), or clicking the extra buttons on a multibutton mouse (lower right), including Apple's Mighty Mouse. Of course, there's nothing to stop you from setting up all three ways, so you can press in some situations and twitch or click in others.

5.3.2.2. Keystrokes

Also in the Dashboard & Exposé preferences, you'll find three pop-up menus—"All windows," "Application windows," and "Show Desktop" —that correspond to the three functions of Exposé as described above. (The fourth pop-up menu, Dashboard, is described at the end of this chapter.) You can't assign any old keystroke to Exposé, but you have far more options than the puny F9, F10, and F11 keys.

Within each pop-up menu, for example, you'll discover that all of your F-keys are available as triggers: F1, F2, F3, and so on. If, while the pop-up menu is open, you press one or more of your modifier keys (Shift, Option, Control, or [image]), all of these F-key choices change to reflect the key you're pressing; now the pop-up menu says Shift-F1, Shift-F2, Shift-F3, and so on. That's how you can make Shift-F1 trigger the hide-all-windows function, for example.

These pop-up menus also contain choices like Left Shift, which refers to the Shift key on the left side of your keyboard. That is, instead of pressing F9 to make all your windows shrink, you could simply tap the Shift key. (This is only an example. Repeat: This is only an example. Actually using the Shift key to shrink all your windows is a terrible, terrible idea, as you'll quickly discover the next time you try to type a capital letter. This feature is intended exclusively for hunt-and-peck typists who never use the Shift key on one side.)

If you have a laptop, you'll also find out that the Fn key is also available for Exposé—and this time, it's a great choice, because Fn otherwise has very little direction in life. (Fn is the neglected key in the lower-left corner of a Mac laptop keyboard, or in the top middle cluster of Apple's aluminum keyboard.)

5.3.2.3. Multiple-button mouse clicks

If your mouse has more than one button, you see a second column of pop-up menus in System Preferences. Each pop-up menu offers choices like Right Mouse Button, Middle Mouse Button, and so on. Use these pop-up menus to assign the three Exposé modes (or Dashboard) to the various clickers on your mouse: right-click to hide all windows, left-side click to reveal the desktop, and so on.

Tip: No matter how you trigger Exposé, try holding down the Shift key as you do it. You'll enjoy watching all your windows shift around with Mac OS X's patented slow-motion animation, which can be quite a sight.


spaces_your_free_quad-display_mac.html

5.4. Spaces: Your Free Quad-Display Mac

Exposé made a big splash when it debuted in Mac OS X 10.3. But Leopard offers another radical step forward in window management that you may even come to prefer. It's called Spaces.

This feature gives you two, four, six, eight, or even sixteen full-size monitors. Ordinarily, of course, attaching so many screens to a single computer would be a massively expensive proposition, not to mention the number it would do on your living space and personal relationships.

But the bonus monitors that Spaces gives you are virtual. They exist only in the Mac's little head. You can look at only one at a time; you switch using a keystroke, a menu, or the mouse. Instead of shuffling through your windows using Exposé, you can now leave them all spread out over a much larger virtual desktop.

Just because the Spaces screens are simulated doesn't mean they're not useful, though. You can dedicate each one to a different program or kind of program. Screen 1 might contain your email and chat windows, arranged just the way you like them. Screen 2 can hold Photoshop, with an open document and the palettes carefully arrayed. On Screen 3: your Web browser in full-screen mode.

You can also have the same program running on multiple screens—but different documents or projects open on each one.

Now, virtual screens aren't a new idea—this sort of software has been available for the Mac and Windows for years. But it's never before been a standard feature of an operating system, and rarely executed with such finesse.

5.4.1. Turning on Spaces

To "install" your new monitors, start by choosing [image] rightwards double arrow System Preferences. Click the Exposé & Spaces icon, then click the Spaces tab. You see something like Figure 5-7.

The setup ritual goes like this:

  • Turn Spaces on. The "Enable Spaces" checkbox is the master on/off switch.

  • Add the menulet. Turn on "Show Spaces in menu bar" to make a menu of your virtual screens appear in the menu bar. It not only lets you switch screens, but the numeral on it also reminds you which screen you're on.

    Tip: Consider turning on this option, if only at first, as a safety net. Otherwise, if you don't remember the keystroke for switching screens, you might lose one of your programs on another screen and not be able to find it!

  • Add rows or columns. Click the + and – buttons to add rows or columns of virtual monitors. There's a difference between rows and columns, by the way. Not only will you eventually learn to sense where your various window setups live, but you can also move from one screen to another by bumping the mouse against the corresponding edge of your current screen—and you'll need to know which edge.

  • Set up program auto-screen assignments. Spaces starts to become truly useful only when you make it part of your routine. You'll eventually memorize where everything is: Web stuff, top left. Email, top right. Photoshop, lower left. Finder with Applications folder open, lower right.

    For that reason, you can use the controls in the center of the System Preferences pane to specify onto which screen certain programs automatically go when they open. Click the + button to view your Applications folder. Double-click a program's icon to make it appear in the list. Now use the pop-up menu in the Space column to indicate which space you want this program to live on, as shown in Figure 5-7.

    Tip: You can also choose All Spaces, meaning that this program's windows are available on every virtual screen. That's handy if it's something you use constantly, like a stock ticker or your phone-book program.

    To make a program stop opening into a certain screen, click its name, and then click the – button.

  • Set up keyboard or mouse triggers. Once you've got your majestic array of Cineplex Displays assembled, you need a way to move among them.

    Spaces comes set up with the Control key as the "I'm switching screens" key. For example, press Control- upwards arrow, to move up one screen, Control- rightwards squiggle arrow to move one screen to the right, and so on. Or, if you have tons of screens, you can jump to one by number (as indicated in the map shown in Figure 5-7): Control-1, Control-4, Control-9, or whatever.

    Figure 5-7. Use the controls at the top to specify how many virtual screens you want—how many rows, how many columns, up to 16 in all. Use the middle section to specify where you want particular programs to appear (that is, on which screen) when they open. Use the bottom controls to set up how you want to move from one screen to another.

    You're welcome to change these keyboard assignments, however, especially if you're already using the Control key for other functions. Use the two bottom pop-up menus.

    For example, suppose you want to switch screens by pressing the Option key rather than Control. In that case, you'd open the "To switch between Spaces" pop-up menu, press Option, and choose " [image] Arrow Keys." (In these pop-up menus, [image] means the Option key, [image] is the Shift key, and ^ means Control.)

Tip: The pop-up menu at the bottom of the window, "To activate Spaces," lets you choose a keystroke that open up the master map of all your screens. (See Figure 5-9.) For tips on choosing a keystroke, see Section 5.3.2.2.

5.4.2. Using Spaces

Once you've got Spaces set up and turned on, the fun begins. Start by moving to the virtual screen you want. Here are some ways to do that:

  • Choose a virtual screen's number from the Spaces menulet, shown in Figure 5-7.

  • Press Control-arrow key, or whatever keystroke you set up as described above. Or hold down Control and keep tapping the arrow key to scroll through all your screens.

  • Press Control-number key to jump to a screen without having to scroll.

  • Use the heads-up switcher (Section 4.3),or the Dock, to select a program; Spaces switches to the proper screen automatically.

Tip: If a program's windows are scattered on different screens, you can click that program's Dock icon repeatedly to jump from window to window. (On the other hand, the window-switching keystroke [image] -~ works only within a single screen. It never takes you from one virtual screen to another.)

When you make a switch, you see a flash of animation as one screen flies away and another appears. You also see the display shown in Figure 5-8 to help you orient yourself among your magnificent array of virtual monitors.

Now that you're "on" the screen you want, open programs and arrange windows onto it as usual.

Figure 5-8. This display appears momentarily when you switch screens. The arrow shows you the screens you're moving to and from. You can even move diagonally. While pressing Control, press two arrow keys on your keyboard at once (like downwards arrow and rightwards squiggle arrow).

5.4.2.1. The big picture

Along with Spaces, Mac OS X 10.5 brings with it yet another window-controlling function-key keystroke: the F8 key. It opens up a gigantic miniature (if there is such a thing) of your entire Spaces universe (Figure 5-9).

Clicking the Spaces icon in the Dock brings up the same display.

Note: As usual, you may run into trouble with this key if you're using Apple's aluminum, super flat keyboard. See the box on Section 5.3.1.

Figure 5-9. Press F8, or click Spaces in your Dock, to open this live master view of all the windows on all the screens. (The windows update in real time—if you're in a chat or playing a movie, for example.) You can actually drag individual windows from one of these "window panes" (actually virtual screens) to another. In fact, you can even use the Exposé keystrokes to make all the windows on all the screens visible at once, for ease in moving them around the screens.

So what can you do here?

  • Get oriented. Especially at first, it's easy to become disoriented among your screens. You could have sworn you opened your favorite Web site—where the heck is it? Pressing F8 gives you an instant readout of where all your windows are sitting at the moment.

  • Switch screens. Click any "pane" of the big-picture view to jump to the screen.

  • Reorder the screens.Using any blank background spot as a handle, you can drag the actual panes of the big-picture view around to rearrange them. If you decide that your email screen should really be at top left, drag it there.

  • Move windows around. Here's the real power of the big-picture view. As shown in Figure 5-9, you can actually drag windows from one screen to another. You can use any part of the window as a handle, not just the title bar.

    Tip: If you press Shift as you drag, you move all windows that belong to the same program simultaneously.

    Hit an Exposé keystroke.You can actually use the F9 and F10 Exposé keystrokes while you're in the F8 big-picture view.

    Yes, this gets kind of meta, but it's useful when you're trying to arrange your windows and programs among your screens. Once you're in the F8 big-picture view, for example, you can hit F9 to see all windows on all screens scurry apart, so that nothing is covered up. Then start dragging windows onto different screens as necessary.

Tip: Once the big-picture view is open, pressing the letter C key rounds up all of your open windows, from all virtual screens, into the first space—a handy way to consolidate your world in times of disorientation. Press C again to send them back where they started.
5.4.2.2. Moving windows among screens

One way to move a particular window to a different screen is to drag it in big-picture view, as shown in Figure 5-9.

But there are two other ways that don't require entering the F8 big-picture view:

  • Drag a window (using its title bar as a handle) all the way to the edge of the screen. Stay there with the mouse button still down. After about a second, you'll see the adjacent screen slide into view; you've just moved the window.

  • Click anywhere inside a window, and keep the mouse button down. Now press your screen-switching keystroke (Control- leftwards double arrow, for example, or Control-3). You've just moved the window to the designated screen.

To be sure, these are power-user techniques that may not come naturally. But the F8 big-picture view is always waiting should you become befuddled.

Tip: What if you want to drag something from one screen (like a photo in iPhoto) into a window that's on a different screen (like an outgoing email message)?Two ways; take your pick. First, you can start dragging whatever it is—and then, in mid-drag, press F8 to open the big-picture view, and complete the drag directly onto the other Space (and even into the relevant window in that Space).Another approach: Start dragging. With the mouse still down, press [image] -Tab to open the application switcher. Continue the drag onto the icon of the receiving program, and still keep the mouse button down. Mac OS X switches to the appropriate virtual screen automatically, and then returns you to what you were doing on the first screen.


hiding_programs_the_old-fashioned_way.html

5.5. Hiding Programs the Old-Fashioned Way

When it comes to getting windows out of your way, nothing can touch Exposé and Spaces for speed and entertainment value. Once you've mastered those features, the traditional rituals of hiding windows will seem charmingly quaint. "When I was your age," you'll tell your grandchildren, "we used to have to hold down the Option key to hide windows!"

But you know the drill at software companies: They addeth, but they never taketh away. All of the old techniques are still around for the benefit of Mac fans who use them by force of habit.

5.5.1. Hiding the Program You're Using

For the purposes of this discussion, when a program is hidden, all of its windows, tool palettes, and button bars disappear. You can bring them back only by bringing the program to the front again (by clicking its Dock icon again, for example).

If your aim is to hide only the program you're currently using, Mac OS X offers a whole raft of approaches to the same problem. Many of them involve the Option key, as listed here:

  • Option-click any visible portion of the desktop. The program you were in vanishes, along with all of its windows.

  • Option-click any other program's icon on the Dock.You open that program (or bring all of its windows to the front) and hide all the windows of the one you were using.

  • Option-click any visible portion of another program's windows.Once again, you switch programs, hiding the one you were using at the time.

  • From the Application menu, choose Hide iPhoto (or whatever the program is). The Application menu is the boldfaced menu that bears the program's name.

  • When you've highlighted a Dock icon by pressing [image] -Tab to rotate through the running programs, press the letter H key. The program hides itself instantly. Leave the [image] key down the whole time, and after pressing the H, press Tab again to move on to the next program. If you release the keys while "stopped" on the program instead, you'll bring it forward rather than hiding it.

  • Press [image] -H. This may be the easiest and most useful trick of all (although it doesn't work in every program).Doing so hides the program you're in; you then "fall down" into the next running program.

Tip: Consider this radical, timesaving proposal: Never quit the programs you use frequently. Instead, simply hit [image] -H whenever you're finished working in a program. That way, the next time you need it, the program launches with zero wait time.There's a limit to this principle; if you have only 512 megabytes of memory and you keep 10 programs open, for example, and one of them is Photoshop, you'll incur a speed penalty. In more moderate situations, though, Mac OS X's virtual-memory scheme is so good that there's almost no downside to leaving your programs open all the time.

To un-hide a program and its windows, click its Dock icon again, choose the Show All command in the Application menu, or press [image] -Tab to summon the heads-up application display.

Tip: The Dock continues to display the icons of all running programs without any indication that you've hidden them. Fortunately, that's easy enough to fix. All you need is the shareware program TinkerTool, which is described on Section 17.1. It offers a simple checkbox that makes hidden programs appear with transparent Dock icons.

5.5.2. Hiding All Other Programs

Choosing Hide Others from your program's Application menu means, of course, "Hide the windows of every program but this one."It even hides your Finder (desktop) windows, although desktop icons remain visible.

Better yet, there's a keystroke for this command: Option- [image] -H. That's one small step for keystrokes, one giant leap for productivity geeks.

If this trick interests you, you might also enjoy its Mac OS X–only corollary, described next.

5.5.3. The Bring-Forward, Hide-All-Others Trick

Here's a terrific technique that lets you bring one program to the front (along with all of its open windows), and hide all other windows of all other open programs—all with one click.

You might think of it as Hero mode, or Front-and-Center mode, or Clear My Calendar mode.

In any case, the trick is to Option- [image] -click the lucky program's icon on the Dock. As it jumps to the fore, all other windows on your Mac are instantly hidden. (You can bring them back, of course, by clicking the appropriate Dock icons.)

5.5.4. Hiding (Minimizing) Individual Windows

In Mac OS X, there's more to managing your window clutter than simply hiding entire programs. You can also hide or show individual windows of a single program. In fact, Apple must believe that hiding a window will become one of your favorite activities, because it offers at least four ways to do so:

  • Choose Window rightwards double arrow Minimize Window, if your program offers such a command, or press [image] -M.

  • Click the Minimize button on the window's title bar, as shown in Figure 5-10.

  • Double-click the window's title bar.

Tip: If you press the Option key as you perform the latter two techniques (and, in some programs, even the first one), you minimize all of your program's open windows to the Dock. (If you had several document windows open, they turn in to side-by-side document icons in the Dock.) This isn't the same thing as hiding the entire program, as described previously—you remain in the same program, but now all of its windows are hidden.Similarly, in most programs, Option-clicking any one of the minimized Dock windows restores all of that program's windows to full prominence.

Figure 5-10. When you click the center button on a window title bar, double-click the title bar, or press -M, you minimize that window, getting it out of your way and off your screen. Minimizing on the Mac is a lot like minimizing in Windows; the minimized window is now represented by an icon on your Dock, which you can click to reopen the window.

In any case, the affected window shrinks down until it becomes a new icon in the right side of the Dock. Click that icon to bring the window back.


how_documents_know_their_parents.html

5.6. How Documents Know Their Parents

Every operating system needs a mechanism to associate documents with the applications that created them. When you double-click a Microsoft Word document icon, for example, it's clear that you want Microsoft Word to launch and open the document.

So how does Mac OS X know how to find a document's mommy?

It actually has four different mechanisms.

  • Your preferences. If you've used the "Always Open with" command to specify a program (Section 5.6.1.1), that's the one that opens.

  • Type/Creator codes. First, it checks to see if the document has an invisible, four-letter Type code and Creator code. It does that because that's how Mac OS 9 used to recognize documents, and Mac OS X wants to ensure compatibility. (Apple used to monitor and track these four-letter codes, in conjunction with the various Mac software companies, so that no two creator codes were alike.)

    The Creator code is the same for a program and the documents it creates—MSWD for Microsoft Word, FMP7 for FileMaker Pro, and so on. That's the entire point: The creator code tells the Mac which program to open when you double-click a particular document.

    The Type code, meanwhile, specifies the document's file format: GIF, JPEG, TIFF, and so on.

    UP TO SPEED
    Window Layering

    Mac OS X takes a layered approach to your programs' windows. They're not all in front or all in back; it's entirely possible to wind up with the windows of different programs sandwiched and layered, front to back.

    Suppose, for example, you have Microsoft Excel in the foreground, but Word in the back-ground. If you click within a visible portion of a background window, you bring only that window of Word to the front.

    The remedy for this situation, if it bothers you, is the Window rightwards double arrow Bring All to Front command, which appears in the Finder and many other programs. It brings all of a program's windows to the front. (You can do the same thing by simply clicking the program's Dock icon, or using the [image] -Tab "heads-up" display.)

    In the Finder, if you prefer, you can also use the Window rightwards double arrow Arrange in Front command. To reveal it, press Option as you open the Window menu. (What used to say "Bring All to Front" changes to say "Arrange in Front.") Mac OS X responds by cascading all open Finder windows, stacking them diagonally, overlapping them so that only their title bars are visible.

    Layered windows shine when you're comparing two documents in two different programs, because it frees you of the window clutter of other open documents. But the time will come when you're ready to bring all of a background program's windows to the front.

    Get into the habit of clicking its Dock icon, or pressing [image] -Tab to select its icon, rather than clicking inside one window. When you do that, all open windows in that application come forward, from wherever they may be.

    When you double-click a document, Mac OS X checks to see if it has a creator code. If so, it then consults an invisible database of icons and codes, the master index that lists the correspondence between creator codes and the applications that generate them.

    If the desktop file discovers a match, then the corresponding program opens the document, which now appears on your screen.

  • Unix database. If the document doesn't have Type or Creator codes (and documents created by Cocoa programs—see Section 5.9—generally don't), Mac OS X consults a second internal Mac OS X database, one that's inherited from Unix systems. The only real interaction you have with it is when you change a document's parent to a different program, as described on the following pages. (Actually, you can open and examine the database—if you're a programmer/geek.)

  • Filename extensions. A filename extension is a suffix following a period in the file's name, as in Letter to Mom.doc. (It's usually three letters long, but doesn't have to be.) These, too, play a role in determining which documents open into which programs—as the operating system's last resort.

Figure 5-11. Top: In the Info window, open the Name & Extension pane. Now you can see what Mac OS X really thinks your file is called. Turn "Hide extension" on if you'd rather not see the file name suffix in the Finder.
Bottom: If you try to add a suffix of your own, Mac OS X objects, in effect saying, "Hey—I've already got a filename extension for this, even if you can't see it. Are you sure you know what you're doing?" (And hallelujah—in Leopard, you can turn off this warning, if you like. Choose Finder rightwards double arrow Preferences rightwards double arrow Advanced pane. Turn off "Show warning before changing an extension.")

That's how Windows identifies its documents. If you double-click something called memo.doc, it opens in Microsoft Word. If you double-click memo.wri, it opens in Microsoft Write, and so on.

Note: Mac OS X comes set to hide most filename extensions, on the premise that they make the operating system look more technical and threatening. If you'd like to see them, however, choose Finder rightwards double arrow Preferences, click the Advanced button, and then turn on "Show all file extensions." Now examine a few of your documents; you'll see that their names now display the previously hidden suffixes.You can hide or show these suffixes on an icon-at-a-time basis, too (or a clump-at-a-time basis). Just highlight the icon or icons you want to affect, and then choose File rightwards double arrow Get Info. In the resulting Info window, proceed as shown in Figure 5-11.

It's possible to live a long and happy life without knowing anything about these codes and suffixes. Indeed, the vast majority of Mac fans may never even encounter them. But if you're prepared for a little bit of technical bushwhacking, you may discover that understanding creator/type codes and file name suffixes can be useful in troubleshooting, keeping your files private, and appreciating how Mac OS X works.

GEM IN THE ROUGH
Using the Dock or Sidebar for Drag-and-Drop

The Mac is smart about the relationship between documents and applications. If you double-click a TextEdit document icon, for example, TextEdit opens automatically and shows you the document.

But it's occasionally useful to open a document using a program other than the one that created it. Perhaps, as is often the case with downloaded Internet graphics, you don't have the program that created it, or you don't know which one was used. This technique is also useful when opening a Read Me file into your word processor, such as Word, instead of the usual TextEdit program.

In such cases, the Dock is handy: Just drag the mystery document onto one of the Dock's tiles, as shown here. Doing so forces the program to open the document—if it can. (Dragging onto a program's icon in the Sidebar or even the Finder toolbar works just as well.)

Incidentally, in general, only the Dock icons of programs that can, in fact, open the file you're dragging become highlighted. The others just shrug indifferently or even scoot aside, thinking you're trying to drag the file into the dock.

Pressing Option- [image] as you drag forces Dock icons to be more tolerant. Now all of them "light up" as your document touches them, indicating that they'll try to open your file. Even so, a "could not be opened" error message may result. As they say in Cupertino, sometimes what a can really needs is a can opener.

5.6.1. Reassigning Documents to Programs

Unfortunately, Type and Creator codes aren't of much use when you encounter a document created by a program that you don't have. If someone emails you a MIDI file (a file-exchange format for music) that she exported from the Finale sheet-music program, you won't be able to open it by double-clicking, unless you, too, have Finale installed. Even if you have a different sheet-music program on your hard drive, just double-clicking the MIDI file won't, by itself, open it.

Filename extensions, meanwhile, have problems of their own. Filename extensions are even less likely to pinpoint which parent program should open a particular document. Suppose you've downloaded a graphic called Sunset.jpg. Well, almost any program these days can open a JPEG graphic—Photoshop, Word, Preview, Safari, and so on. How does Mac OS X know which of these programs to open when you double-click the file?

Fortunately, you can decide. You can reassign a document (or all documents of its kind) to a specific program. Here's the rundown.

5.6.1.1. Reassigning a certain document—just once

Double-clicking a graphics file generally opens it in Preview, the graphics viewer included with Mac OS X (see Section 10.23). Most of the time, that's a perfectly good arrangement. But Preview has only limited editing powers. What if you decide to edit a graphics file more substantially? You'd want it to open, just this once, into a different program—Photoshop Elements, for example.

To do so, you must access the Open With command. You can find it in two places:

  • Highlight the icon, and then choose File rightwards double arrow Open With.

  • Control-click (or right-click) the file's icon. Or, in a Finder window, highlight the icon and then open the Action menu. In the shortcut menu, choose Open With.

Study the submenu for a moment (Figure 5-12, top). The program whose name says "(default)" indicates which program usually opens this kind of document. From this pop-up menu, choose the name of the program you'd rather open this particular file, right now, just this once.

5.6.1.2. Reassigning a certain document—permanently

After opening a TIFF file in, say, Photoshop Elements for editing, you haven't really made any changes in the fabric of your Mac universe. The next time you double-click that file, it opens once again in Preview.

If you wish this particular file would always open in Photoshop Elements, the steps are slightly different. In fact, there are three different ways:

  • In the Choose an Application dialog box, turn on "Always Open With"(shown at bottom in Figure 5-12).

    Start out with one of the previously described techniques (File rightwards double arrow Open With, or Control-click/right-click the file's icon and choose Open With)—but after you see the menu, press the Option key, too. Before your very eyes, the Open With command changes to say Always Open With.

    Figure 5-12. Top: The shortcut menu offers a list of programs capable of opening an icon. If you were to press the Option key right now, the words Open With would suddenly change to say Always Open With.
    Bottom: If you choose Other, you're prompted to choose a different program. Turn on Always Open With if you'll always want this document to open in the new parent program. Otherwise, this is a one-time reassignment.

  • Highlight the icon, and then choose File rightwards double arrow Get Info. Open the "Open with" panel. Choose a new "parent" program's name from the pop-up menu. You'll see that the word "(default)" changes position, now tacking itself onto the name of the new program you've chosen.

Tip: You can use a similar trick to reassign the parenthood of a whole flock of selected icons at once. Once you've selected them, keep the Option key pressed as you choose File rightwards double arrow Show Inspector. In the "Open with" section of this specialized GetInfo window, choose an ew program from the pop-up menu. The message at the top of the window—"22 items," for example—reminds you that you're changing the whole batch at once.
5.6.1.3. Reassigning all documents of one type

So much for reassigning one document (or group of documents) at a time. What if you're writing, say, a book about Mac OS X, and you've been taking a lot of screenshots? Mac OS X saves each captured screen illustration as a graphics file in something called PNG format. That's all fine, except that every time you double-click one of these, it opens into Preview, where you can't paint out unwanted details.

You could reassign all of these files, one at a time, to a different program, but your grandchildren would have grandchildren by the time you finish. In this case, you want to tell Mac OS X, "For heaven's sake, make all PNG files open in Photoshop from now on!"

To make it happen, start by highlighting any PNG file. Choose File rightwards double arrow Get Info. (The shortcut menus won't help you in this case.) Open the "Open with" panel.

From its pop-up menu, choose the program you want to open this kind of document from now on. (If the one you prefer isn't listed, use the Other option, which opens the Choose an Application dialog box so that you can navigate to the one you want. Find and double-click the program.)

This time, follow up by clicking Change All beneath the pop-up menu. (This button is dimmed until you've actually selected a different program from the pop-up menu.) Mac OS X asks you to confirm by clicking Continue or pressing Enter.

From now on, double-clicking any similar kind of document opens it in the newly selected program.


keyboard_control.html

5.7. Keyboard Control

Mac OS X offers a fantastic feature for anyone who believes that life is too short: keyboard-controllable menus, dialog boxes, pop-up menus, and even Dock pop-up menus. You can operate every menu in every program without the mouse or add-on software.

In fact, you can operate every control in every dialog box from the keyboard, including pop-up menus and checkboxes. And you can even redefine many of the built-in Mac OS X keystrokes, like Shift- [image] -3 to capture the screen as a graphic.

In fact, you can even add or change any menu command in any program. If you're a keyboard-shortcut lover, your cup runneth over.

Here are some of the ways you can control your Mac mouselessly. In the following descriptions, you'll encounter the factory settings for the keystrokes that do the magic—but as you'll note in a moment, you can change these key combos to anything you like. (That's fortunate, since many of them, out of the box, conflict with canned brightness and volume keystrokes for laptops.)

5.7.1. Control the Menus

When you press Control-F2, the [image] menu is highlighted. At this point, you can "walk" to another menu by pressing the leftwards double arrow or rightwards double arrow keys (or Tab and Shift-Tab).When you reach the menu you want, open it by pressing downwards arrow, Space, Return, or Enter.

Walk down the commands in the menu by pressing upwards arrow, or downwards arrow, or jump directly to a command in the menu by typing the first couple letters of its name. Finally, "click" a menu command by pressing Enter, Return, or the Space bar.

You can also close the menu without making a selection by pressing Esc or [image] -period.

5.7.2. Control the Dock

Once you've pressed Control-F3, you can highlight any icon on the Dock by pressing the appropriate arrow keys (or, once again, Tab and Shift-Tab).

Then, once you've highlighted a Dock icon, you "click it" by pressing Enter or the Space bar. Again, if you change your mind, press Esc or [image] -period.

Tip: Once you've highlighted a disk or folder icon, you can press the upwards arrow, or downwards arrow keys to make its shortcut menu appear. (If you've positioned the Dock vertically, use the left or right arrow instead!)

5.7.3. Cycle Through Your Windows

Every time you press Control-F4, you bring the next window forward, eventually cycling through every window in every open program. Add the Shift key to cycle through them in the opposite order.

You may remember that Mac OS X offers a different keystroke for cycling through the different windows in your current program (it's [image] -~, the tilde symbol at the upper-left of your keyboard). Control-F4, on the other hand, tours all windows in all programs. Both keystrokes are useful in different situations.

5.7.4. Control the Toolbar

This one is on the unpredictable side, but it more-or-less works in most programs that display a Mac OS X–style toolbar: the Finder, System Preferences, and so on.

When you press Control-F5, you highlight the first button on that toolbar. Move the "focus" by pressing the arrow keys or Tab and Shift-Tab. Then tap Enter or the Space bar to "click" the highlighted button.

5.7.5. Control Tool Palettes

In a few programs that feature floating tool palettes, you can highlight the frontmost palette by pressing Control-F6.At this point, use the arrow keys to highlight the various buttons on the palette. You can see the effect when, for example, you're editing text in TextEdit and you've also opened the Font palette. Pressing Control-F6 highlights the Font palette, taking the "focus" off your document.

5.7.6. Control Dialog Boxes

You can also navigate and manipulate any dialog box from the keyboard.

See the dialog box shown in Figure 5-13? If you turn on "All controls" at the bottom, then pressing the Tab key highlights the next control of any type, whatever it may be—radio button, pop-up menu, and so on. Press the Space bar to "click" a button or open a pop-up menu. Once a menu is open, use the arrow keys (or type letter keys) to highlight commands on it, and the Space bar to "click" your choice.

Tip: Press Control-arrow keys to "click" the different tabs of a dialog box.

Figure 5-13. Turn off any checkboxes for keystrokes that you never use—especially if they seem to conflict with identical keyboard shortcuts in your programs. In fact, there's even a keystroke that turns off all of the "full keyboard access" keystrokes (the ones that let you control menus, Dock, toolbars, palettes, and so on) all at once: Control-F1. (Don't mean to hurt your brain, but you can actually turn off even that keystroke.)

5.7.7. Changing a Menu Command

Suppose you love iPhoto (and who doesn't?). But one thing drives you crazy: The Revert to Original command, which discards all the changes you've ever made since taking the photo, has no keyboard equivalent. You must trek up to the menu bar every time you need that command.

Or maybe it drives you crazy that the Hide command is [image] -H in most programs, but not, for some nutty reason, in Photoshop.

This is why Mac OS X lets you add keyboard shortcuts to menu commands that lack them—or change the command in programs whose key assignments break with tradition.(It works in any program that uses the standard Mac OS X menu software, which rules out Microsoft Word and the other Office programs.) Here's the routine:

  1. Choose [image] rightwards double arrow System Preferences. Click Keyboard & Mouse. Click the Keyboard Shortcuts tab button.

    You arrive at the dialog box shown in Figure 5-13.

  2. Click the + button just beneath the list.

    The dialog box shown in Figure 5-14 appears.

    Figure 5-14. If you choose All Applications from the top pop-up menu, you can change the keyboard combo for a certain combo command wherever it appears. You could, for example, change the keystroke for Page Setup in every program at once.

  3. Indicate which program needs behavior modification.

    In this example, you'd choose iPhoto from the Application pop-up menu. (If the program's name doesn't appear in the pop-up menu, choose Other; navigate to, and double-click, the program you want.)

  4. Carefully type in the name of the menu command whose keyboard shortcut you want to change or add.

    Type it exactly as it appears in the menu, complete with capitalization and the little ellipsis (…) that may follow it. (You make the ellipsis character by pressing Option-semicolon.)

  5. Click in the Keyboard Shortcut box.Press the new or revised key combo you want.

    For example, press Control-R for iPhoto's Revert to Original command. You'll see the Mac's notation of your keystroke appear in the Keyboard Shortcut box—unless, of course, the combo you selected is already in use within that program. In that case, you hear only an error sound that means "Try again."

  6. Click Add.

    The dialog box closes. By scrolling down in your Keyboard Shortcuts list, you'll see that the keystroke you selected has now been written down for posterity under the appropriate program's flippy triangle. (To get rid of it, click its name and then click the – button beneath the list.)

The next time you open the program you edited, you'll see that the new keystroke is in place.


the_save_and_open_dialog_boxes.html

5.8. The Save and Open Dialog Boxes

When you choose File rightwards double arrow Save, you're asked where you want the new document stored on your hard drive. The resulting dialog box is crystal-clear—more than ever, it's a miniature Finder. All of the skills you've picked up working at the desktop come into play here.

To give it a try, launch any Mac OS X program that has a Save or Export command— TextEdit, for example. Type a couple of words, and then choose File rightwards double arrow Save. The Save sheet appears (Figure 5-15).

Tip: In Mac OS X, a quick glance at the Close button in the upper-left corner of a document window tells you whether it's been saved. When a small dot appears in the red button, it means you've made changes to the document that you haven't saved yet. (Time to press [image] -S!). The dot disappears as soon as you save your work.

5.8.1. Sheets

In the days of operating systems gone by, the Save dialog box appeared dead center on the screen, where it commandeered your entire operation. Moreover, because it seemed stuck to your screen rather than to a particular document, you couldn't actually tell which document you were saving—a real problem when you quit out of a program that had three unsaved documents open.

Figure 5-15. Top: The Save dialog box, or sheet, often appears in its compact form.
Right (inset): If you open the Where pop-up menu, you'll find that Mac OS X lists all the places it thinks you might want to save your new document: on the hard drive or iDisk, in a folder that you've put into your Sidebar (Section 1.2), or into a folder you've recently opened.
Bottom: If you want to choose a different folder or create a new folder, click the button shown above to expand the dialog box. Here, you see the equivalent of the Finder—with a choice of icon, list, or column view. Even the Sidebar is here, complete with access to other disks on the network.

In most Mac OS X programs, there's no mystery regarding which document you're saving, because a little Save dialog box called a sheet slides directly out of the document's title bar. Now there's no mistaking which document you're saving.

Better still, this little Save box is a sticky note attached to the document. It stays there, neatly attached and waiting, even if you switch to another program, another document, the desktop, or wherever. When you finally return to the document, the Save sheet is still there, waiting for you to type a file name and save the document.

5.8.2. The Mini Finder

Of course, you, O savvy reader, have probably never saved a document into some deeply nested folder by accident, never to see it again. But millions of novices (and even a few experts) have fallen into this trap.

When the Save sheet appears, however, a pop-up menu shows you precisely where Mac OS X proposes putting your newly created document: usually in the Documents folder of your own Home folder. For many people, this is an excellent suggestion. If you keep everything in your Documents folder, it will be extremely easy to find, and you'll be able to back up your work just by dragging that single folder to a backup disk.

As shown at top in Figure 5-15, the Where pop-up menu gives you direct access to some other places you might want to save a newly created file. (The keystrokes for the most important folders work here, too—Shift- [image] -H for your Home folder, for example.)

In any case, when you save a file, the options in the Where pop-up menu have you covered 90 percent of the time. Most people work with a limited set of folders for active documents.

But when you want to save a new document into a new folder, or when you want to navigate to a folder that isn't listed in the Where pop-up menu, all is not lost. Click the [image] button identified in Figure 5-15. The Save sheet expands miraculously into a very familiar sight: a miniature version of the Finder.

There's your Sidebar, complete with access to the other computers on your network. There's the Back button. There's your toggle switch between views; in Leopard, you can even switch to icon view here, in addition to the traditional list and column views.

Tip: In column view, your first instinct should be to widen this window, making more columns available. Do so by carefully dragging the lower-right corner of the dialog box. Mac OS X remembers the size you like for this Save sheet independently in each program.

Most of the familiar Finder-navigation shortcuts work here, too. For example, press the right and left arrow keys to navigate the columns, or the up and down arrow keys to highlight the disk and folder names within a column. Once you've highlighted a column, you can also type to select the first letters of disk or folder names.

Highlight the name of the folder in which you want to save your newly created document. Alternatively, you can click the New Folder button to create a new folder inside whatever folder is highlighted in the column view. (The usual New Folder keystroke works here, too: Shift- [image] -N.) You'll be asked to type the new name for the folder. After you've done so, click Create (or press Enter). The new folder appears in the rightmost pane of the column view. You can now proceed with saving your new document into it, if you like.

The next time you save a new document, the Save sheet reappears in whatever condition you left it. That is, if you used column view the last time, it's still in column view.

At any time, you can collapse it into simplified view, shown at top in Figure 5-15, by clicking the [image] button to the right of the Where pop-up menu.

Tip: The Save box always displays whatever places you've put in your Sidebar. (In compact view, the Where pop-up menu lists them; in expanded view, you see the Sidebar itself.)The bottom line: If, on some project, you find yourself wanting to save new documents into the same deeply buried folder all the time, press F11 to duck back to the Finder, and add it to your Sidebar. From now on, you'll have quick access to it from the Save dialog box.

5.8.3. Spotlight

The Search bar at the top of the Open and Save dialog box is a clone of the Finder's Search bar (Chapter 3). Press [image] -F to make your insertion point jump there. Type a few letters of the name of the file or folder you're looking for, and up it pops, regardless of its actual hard-disk location.

Your savings: five minutes of burrowing through folders to find it, and several pages of reading about how to navigate the Save and Open boxes.

5.8.4. Insta-Jumping to a Folder Location

Whether you're using the mini-sheet or the expanded view, you can save yourself some folder-burrowing time by following the tip shown in Figure 5-16. This feature is totally undocumented—but well worth learning.

Figure 5-16. The quickest way to specify a folder location is to drag the icon of any folder or disk from your desktop directly into the Save or Open sheet. Mac OS X instantly displays the contents of that folder or disk. You'll see by the Where pop-up menu that Mac OS X has indeed understood your intention.

Tip: If, when the Save box is in its expanded condition, you click the name of an existing file, Mac OS X thoughtfully copies the name of the clicked file into the Save As: text box (which otherwise said "Untitled" or was blank).This trick can save you time when you're saving a second document with a slightly modified name (Oprah and Me: The Inside Story, Chapter 1 and then Oprah and Me: The Inside Story, Chapter 2). It's also useful if you want to replace the original file with the new one you're saving. Instead of having to type out the entire name of the file, you can just click it.

5.8.5. The File Format Pop-up Menu

The Save dialog box in many programs offers a pop-up menu of file formats below the Save As box. Use this menu when preparing a document for use by somebody else—somebody whose computer doesn't have the same software. For example, if you've used a graphics program to prepare a photograph for use on the Web, this menu is where you specify JPEG format (the standard Web format for photos).

5.8.6. The Open File Dialog Box

The dialog box that appears when you choose File rightwards double arrow Open is almost identical to the expanded Save File sheet. Because you encounter it only when you're opening an existing file, this dialog box lacks the Save button, file name field, and so on.

Figure 5-17. The new Media Browser is built right into the Open dialog box. That is, you get miniature listings of your iTunes, iPhoto, and movie files right in the Sidebar, for convenience in importing them into (for example) Keynote, PowerPoint, or a Web design program.

Note: Furthermore, the Open dialog box shows you only icons for disks, folders, and documents that you can actually open at this moment. For example, when you're using GarageBand, picture files show up dimmed.

But it does have a new Sidebar category called Media (see Figure 5-17), which gives you direct access to all your photos, music, and movies. The premise is that Apple figures you might want to import these items into a document you're working on.

Most of the other Save File dialog box controls, however, are equally useful here. That handy Spotlight search bar is still there, only a [image] -F away. Once again, you can begin your navigation by seeing what's on the desktop (press [image] -D) or in your Home folder (press Shift- [image] -H). Once again, you can find a folder or disk by beginning your quest with the Sidebar, and then navigate using either list or column view. And once again, you can drag a folder, disk, or file icon off your desktop directly into the dialog box to specify where you want to look. (If you drag a file icon, you're shown the folder that contains it.)

When you've finally located the file you want to open, do so by double-clicking it or highlighting it (which you can do from the keyboard), and then pressing Return, Enter, or [image] -O.

In general, most people don't encounter the Open File dialog box nearly as often as the Save File dialog box. That's because the Mac offers many more convenient ways to open a file—double-clicking its icon in the Finder, choosing its name from the [image] rightwards double arrow Recent Items command, and so on—but only a single way to save a new file.


two_kinds_of_programs_cocoa_and_carbon.html

5.9. Two Kinds of Programs: Cocoa and Carbon

Mac OS X was supposed to make life simpler. It was supposed to eliminate the confusion and complexity that the old Mac OS had accumulated over the years—and replace it with a smooth, simple, solid system.

Someday, that's exactly what Mac OS X will be. For the moment, however, you're stuck with running two different kinds of programs, each with different characteristics: Cocoa and Carbon.

The explanation involves a little bit of history and a little bit of logic. To take full advantage of Mac OS X's considerable technical benefits, software companies must write new programs for it from scratch. So what should Apple do—send out an email to the authors of the 18,000 existing Mac programs, suggesting that they throw out their programs and rewrite them from the bottom up?

At big companies like Microsoft and Adobe, such a suggestion would wind up on the Joke of the Week bulletin board.

Instead, Apple gave software companies a break. It wrote Mac OS X to let programmers and software companies choose precisely how much work they wanted to put into compatibility with the new system. The various levels include:

  • Update the existing programs (Carbon).If software companies and programmers are willing to put some effort into getting with the Mac OS X program, they can simply adapt, or update, their existing software so that it works with Mac OS X.

    The resulting software looks and feels almost like a true Mac OS X program—you get the crash protection, the good looks, the cool-looking graphics, the Save sheets, and so on—but behind the scenes, the bulk of the computer programming is the same a sit was in MacOS 9. These are what Apple calls Carbonized programs, named for the technology (Carbon) that permits them to run on Mac OS X. (Examples of Carbonized programs include AppleWorks, Photoshop versions before CS3, FileMaker, Microsoft Office 2004, and, believe it or not, the Finder itself.)

    Most Carbonized programs don't offer all of the features available to Mac OS X, however. In the following pages, you'll discover which Mac OS X goodies you sacrifice when using programs adapted this way.

    On the other hand, such software offers a feature that software companies like a lot: A Carbon program is a lot easier to write concurrently with a Windows version of the same software. A Cocoa program, by contrast, is almost certainly locked into Macintosh-only Land.

  • Write new programs from scratch (Cocoa). As Mac OS X becomes more popular, more software companies create new programs exclusively for it. The geeks call such programs Cocoa applications. Although they look exactly like Carbonized programs, they feel a little bit more smooth and solid. And they offer a number of special features that Carbonized programs don't offer.

    Most of the programs that come on every Mac are true Cocoa applications, including iDVD, Safari, iChat, iPhoto, TextEdit, Stickies, Mail, Address Book, and so on.

FREQUENTLY ASKED QUESTION
The Return of Classic?

Are you kidding me? Classic is gone? No more Mac OS 9 at all? But I need to run a couple of old programs!

Yes, the Classic mode—which, until Leopard, let you run older Mac OS 9 programs in a sort of simulation mode—is gone. You can run only Mac OS X programs in Mac OS X.

Or at least that's what Apple wants you to think. Truth is, there's a sneaky way to run Mac OS 9 programs, even in Leopard: a little something called SheepShaver. It's an open-source Mac OS 9 emulator, meaning that it's been written by volunteer collaborators across the Internet.

SheepShaver is difficult to install and isn't what you'd call rock-solid. But it's good to know that, someday, when you absolutely, positively have to run that old program, you're not entirely out of luck.


the_cocoa_difference.html

5.10. The Cocoa Difference

Here are some of the advantages Cocoa programs offer. It's worth reading—not to make you drool about a future when all Mac programs will fall into this category, but to help clear up any confusion you may have about why certain features seem to be present only occasionally.

Note: The following features appear in almost all Cocoa programs. That's not to say that you'll never see these features in Carbonized programs; the occasional Carbon program may offer one of these features or another. That's because programmers have to do quite a bit of work to bring them into Carbon applications—and almost none to include them in Cocoa ones.

5.10.1. The Font Panel

The Mac has always been the designer's preferred computer, and Mac OS X only strengthens its position. For one thing, Mac OS X comes with over 200 absolutely beautiful fonts that Apple licensed from commercial type companies.

When you use a Carbon program, you usually access these fonts the same way as always: using a Font menu. But when you use a Cocoa program, you get the Font panel, which makes it far easier to organize, search, and use your font collection. Chapter 14 describes fonts, and the Font panel, in more detail.

5.10.2. Title Bar Tricks

You may remember from Chapter 2 that the title bar of every Finder window harbors a secret pop-up menu. When you Control-click it (or right-click, or [image] -click), you're shown a little folder ladder that delineates your current position in your folder hierarchy. You may also remember that the tiny icon just to the left of the window's name is actually a handle that you can drag to move a folder into a different window.

In Cocoa programs, you get the same features in document windows, as shown backin Figure 2-5 (Section 2.4.4). (This feature is available in many Carbonized programs, but it isn't a sure thing.) By dragging the tiny document icon next to the document's name, you can perform these two interesting stunts:

  • Drag to the desktop. By dragging this icon to the desktop, or onto a folder or disk icon, you create an instant alias of the document you're working on. This is a useful feature when, for example, you're about to knock off for the night, and you want easy access to whatever you've been working on when you return the next day.

  • Drag to the Dock. By dragging this title-bar icon onto the Dock icon of an appropriate program, you open your document in that other program. For example, if you're in TextEdit working on a memo, and you decide that you'll need the full strength of Microsoft Word to dress it up, you can drag its title-bar icon directly onto the Word icon in the Dock. Word then launches and opens up the TextEdit document, ready for editing.

5.10.3. Services

Apple has always dreamed of a software architecture that would let you mix and match features from different programs—using the Mac's spell checker in Microsoft Word, the drawing tools of PowerPoint in your email program, and so on. (Remember Apple's OpenDoc software project? Neither does anybody else.)

In Mac OS X, Apple's dream has finally become a reality, sort of. Nestled in the Application menu of almost every Mac OS X program is a command called Services. Its submenu lists several functions that technically belong to other programs, as described below.

Unfortunately, these commands are dimmed when you use most Carbonized programs. They become available only when you use Cocoa programs like iChat, TextEdit, Mail, OmniWeb—and the Finder.(Yes, the Finder is a Carbon program. But remember that programmers can add Cocoa features to their older, Carbonized programs; it just takes a lot of work.)

Here's a summary of what they do:

Note: Not all of these Services work in all programs—even Cocoa programs. Implementing them is left to programmers' discretion.
5.10.3.1. ChineseTextConverter

Talk about obscure: This utility, formerly located in your Applications rightwards double arrow Utilities folder, converts selected text that you've written in Chinese using its Simplified text system into the Chinese Traditional text system—or vice versa. Let the celebration begin!

5.10.3.2. Disk Utility

Here's another Service that everyday Mac fans haven't exactly been clamoring for. This one lets software programmers and system administrators check to make sure that the disk image files they've created (Section 10.30.11.2) haven't been altered—without even having to double-click and "mount" the disk image.

5.10.3.3. Finder

The three commands listed in this submenu work only in one situation: when you've highlighted some text that precisely matches the name and folder path of any icon, such as ~/Documents/Marge.jpg. (Details on path notation on Section 1.2.4.)

At that point, you can choose any of these commands from the Services rightwards double arrow Finder submenu:

  • Open.Opens the icon. This command, in effect, lets you open any file on your hard drive, from within any Cocoa program, without having to switch to the Finder. For example, you could keep a list of your favorite files and programs in a TextEdit document, ready for opening without having to leave the program.

  • Reveal. Takes you to the Finder, where the specified icon is highlighted and its enclosing folder opened into a window.

  • Show Info. Switches to the Finder, where the Get Info window for the specified file opens, for your inspection pleasure.

If what you've highlighted isn't the name and path of a document, you'll get only an error message.

5.10.3.4. Font Book

Font Book, as you can read in Chapter 14, is a font-managing program. Among other talents, it can clump your fonts into Collections (subsets of your choice) or Libraries (collections of Collections).

These Service commands generate a whole collection or library of fonts contained in one document (whatever's on the screen at the time). Begin by highlighting the text that uses the fonts (usually you'll want the whole document). Then choose Services rightwards double arrow Font Book rightwards double arrow Create Collection [or Font Library] From Text. In a moment, you'll see that the Font Book program has opened automatically, and there's a new collection or library in the Collection list at the left side, ready for you to rename.

The payoff comes when you want to submit the document to, for example, a graphics shop for professional printing, or to some one who'll beediting your work on a different computer. Font Book can easily export a collection of fonts (File rightwards double arrow Export Collection) that you can send out with the document itself, so the recipients will enjoy the same delightful design you did.

5.10.3.5. Grab

Grab is a screen-capture program in your Applications rightwards double arrow Utilities folder. You use it to turn what you see onscreen into graphics files. It's especially handy when writing computer books or training manuals.

The Grab service, in theory, lets you take your software snapshot from within any Cocoa application, without having to go find and launch Grab separately; unfortunately, it's available only in programs that can accept pasted graphics. You'll find details on Grab's submenu commands (Screen, Selection, Timed Screen) on Section 10.30.11.3.

5.10.3.6. Import Image

This option lets you import a digital photo from a scanner or digital camera, if one is attached and ready to roll. Like Grab, it works only in Cocoa programs that accept pasted graphics, and like Image Capture (on which it's based), it can operate only Web-cammable digital cameras and compatible scanners.

5.10.3.7. Look Up in Dictionary

Here's yet another way to access the Mac's Dictionary program. Highlight a word, choose this command, and presto: The Dictionary program opens automatically and proudly present sade finition for your enlightenment.(There are easier, more universal ways to look up words, as described on Section 5.13.3.5.)

5.10.3.8. Mail

This handy command springs to life only after you've highlighted some text in a Cocoa program—or a file in the Finder.

  • Send Selection. In one step, the Mail Text command launches the Mail program and pastes the highlighted text into the body of a new, outgoing email message. You're saved the trouble of copying, launching Mail, creating a new message, and pasting. You might use this feature when, for example, you find something interesting on a Web page, and you'd like to email it to someone.

  • Send To. This command is useful only if you've highlighted an email address in a text document. This command, too, switches to Mail and creates a new, outgoing message—but this time, MacOS X pastes the text you've highlighted into the "To:" field.

5.10.3.9. Make New Sticky Note

This command copies whatever text you've got highlighted, switches to your Stickies program (Section 5.13.3.14), creates a new sticky note, and pastes your selected material in it. If you're the kind of person who keeps your life—lists, passwords, favorite URLs, to-do list, notes, and so on—in Stickies, this one can save you considerable hassle. No wonder Apple endowed it with its own keyboard shortcut: Shift- [image] -Y.

5.10.3.10. Open URL

When you highlight a Web address in any program, choosing this command fires up your Web browser and takes you to the indicated page.

5.10.3.11. Script Editor

For AppleScript fans only (Chapter 7):

  • Get Result of AppleScript. This command processes whatever text you've highlighted as an AppleScript—and then replaces the selected text with the result of your script.

  • Make New AppleScript. This item works just like Make New Sticky Note, except that it copies your text into Script Editor rather than Stickies.

  • Run as AppleScript. This one runs a selected block of text as if it were an Apple-Script, much like Get Result of AppleScript. The only difference: It doesn't replace the selected text with the result of your script.

None of these Script Editor services do any error checking. If you forget a quotation mark in your script, it simply won't run.

Tip: If you know how to use the do shell script command, you can run Unix commands directly from your service-enabled programs (see Chapter 16).
5.10.3.12. Search with Google

Never let it be said that inspiration is dead in the post-tech-bubble era. This unassuming command adds a powerful research assistant to every program where you can type. Highlight a phrase—Picasso, electric curtains, Yankees game—and hit this command. In seconds, you're online, in your Web browser, facing a list of Web pages from a Google search for that topic. It's a dictionary, thesaurus, news service, and stock ticker all in one.

The gang at Apple loves this one, too. They blessed it with its own keyboard shortcut: Shift- [image] -L (for look up).

5.10.3.13. Send File to Bluetooth Device

Bluetooth is a short-range, wireless, cable-elimination technology. It's great for tossing files between two Macs (or a Mac and a Windows laptop, for that matter), on the fly, on a plane, without any cables or setup. (Your Mac must have a Bluetooth transmitter, of course. All current Mac laptops do.)

If you've highlighted the path of a file (see the tip below), this command grabs the file and hands it off to Bluetooth File Exchange, which begins the process of transmitting it to a nearby Bluetooth computer. (Section 6.2.6.1 describes this ritual.)

5.10.3.14. Speech

As detailed in Chapter 15, Mac OS X doesn't just display text onscreen—it can actually read it out loud.

  • Start Speaking Text. Start by highlighting some text in a Cocoa program. Then choose this command, and presto: The Mac actually reads the text out loud, using the character voice you've chosen in System Preferences (Section 15.4.2.6).

  • Stop Speaking. This command makes the Mac shut up.

Tip: If you highlight an icon in the Finder, the Start Speaking Text command reads its path to you. For example, for a Flowers.tif file in your Home rightwards double arrow Pictures folder, whose path is Users/chris/Pictures/Flowers.tiff, the Mac says, "Users, Chris, Pictures, Flowers dot tiff."
5.10.3.15. Spotlight

As you know from Chapter 3, Spotlight is always at your command, ready to find files, folders, or programs at the touch of a key. But the [image] -Space bar trick requires you to type in a search phrase. This Service command (and its keystroke, Shift- [image] -F), on the other hand, triggers a Spotlight search for a word or phrase that's already typed—one that you've highlighted in whatever document is before you.

5.10.3.16. Summarize

Talk about intriguing: When you choose this command after highlighting some text, the Mac analyzes the sentences you've highlighted and, after a moment, launches Summary Service. This little program, which you probably never even knew you had, displays a greatly shortened version of the original text. Figure 5-18 offers details.

Tip: To save the summarized document as a TextEdit document, choose File rightwards double arrow Save As.
5.10.3.17. TextEdit

This pair of commands also requires you to highlight some text first.

Figure 5-18. Use the Summarize command to create a one-paragraph summary (bottom) of a longer passage (top).
Once the summary appears in the Summary Service program, you can make it more or less concise by dragging the Summary Size slider. You can also ask it to display the most statistically relevant paragraphs instead of sentences, just by clicking the appropriate radio button at the lower left.
(Note: Bear in mind that Summary Service doesn't do any creative rewriting; even Mac OS X can't come up with something coherent if the original wasn't. Instead, Summary Service chooses the most statistically significant sentences to include in the summary.)

  • New Window Containing Selection. If you've highlighted some blob of text—on a Web page, say—this command automatically launches TextEdit, creates a new untitled document, and pastes the highlighted text.

  • Open Selected File. This command works only if you've highlighted some text that matches the name and folder path of a TextEdit document (including its folder path, like ~/Documents/essay.txt). If so, you can choose Services rightwards double arrow TextEdit rightwards double arrow Open Selected File to find and open that document in TextEdit. (If what you've highlighted isn't the name of a document, you'll get only an error message.)

Although these are the commands that come built into a fresh installation of Mac OS X, that's not the end of the versatility. The real beauty of Services is that as new, clever applications come along, they can add their own commands to this menu for your data-manipulation pleasure. Programs like Skype, QuicKeys, RealPlayer, and iData add to the Services menu, for example.

5.10.4. Toolbar Tricks

The toolbar is an increasingly common sight at the top of modern application windows. In any thoughtfully written program, the Customize Toolbar command lets you determine how you want this toolbar to show up—with icons, as icons with text labels beneath them, with text labels alone to save window space, and so on.

But in many Cocoa programs—including the Finder, OmniWeb, Mail, Address Book, and Xcode—there's a much faster way to switch among these toolbar styles: Just [image] click the white button shown in Figure 5-19.

Figure 5-19. By -clicking this button repeatedly, you can cycle among toolbar styles. In Mail, for example, you can cycle between six different toolbar styles: with icons and labels (large and small); with icons only (large and small); and with text labels only (large and small).

5.10.5. Secret Keyboard Shortcuts

For the most part, it's possible to ignore the Unix that beats within the heart of Mac OS X. But every now and then, a refreshing reminder pokes its head up through the fields of gradient gray—and here's one of them.

Although you'll never see it mentioned in the user manuals for Cocoa applications (if there even were such things as user manuals anymore), most of them respond to certain keystrokes left over from the NeXT operating system, which was Mac OS X's ancestor. If you're a card-carrying number of KIAFTMA (the Keyboard Is Always Faster Than the Mouse Association), you'll love these additional keyboard navigation strokes:

  • Control-A. Moves your insertion point to the beginning of the paragraph. (Mnemonic: A = beginning of the Alphabet.)

  • Control-E. Deposits your insertion point at the end of the paragraph. (Mnemonic: E = End.)

  • Control-D. Forward delete (deletes the letter to the right of the insertion point).

  • Control-K. Instantly deletes all text from the insertion point to the right end of the line. (Mnemonic: K = Kills the rest of the line.)

  • Control-O. Inserts a paragraph break, much like Return, but leaves the insertion point where it was, above the break. This is the ideal trick for breaking a paragraph in half when you've just thought of a better ending for the first part.

  • Control-T. Moves the insertion point one letter to the right—and along with it, drags whichever letter was to its left. (Mnemonic: T = Transpose letters.)

  • Option-Delete. Deletes the entire word to the left of the insertion point. When you're typing along in a hurry, and you discover that you've just made a typo, this is the keystroke you want. It's much faster to nuke the previous word and retype it than to fiddle around with the mouse and the insertion point just to fix one letter.

Four additional keystrokes duplicate the functions of the arrow keys. Still, as long as you've got your pinky on that Control key…

  • Control-B, Control-F. Moves the insertion point one character to the left or right, just like the left and right arrow keys. (Mnemonic: Back, Forward).

  • Control-N, Control-P. Moves the insertion point one row down or up, like the down and up arrow keys. (Mnemonic: Next, Previous).

5.10.6. Cool Text-Selection Tricks

By holding down certain keys while dragging through text in a Cocoa program, you gain some wild and wacky text-selection powers. (You'll find them especially useful in, for example, TextEdit and Pages.)

For example:

  • Highlight only one column out of several by Option-dragging. Instead of highlighting all of the text, margin to margin, you get only the text that's within your selection rectangle. This trick is especially handy in Preview, when you want to copy only one portion of a PDF document that has a columnar layout.

  • Highlight several passages simultaneously by [image] -dragging. Each time you [image] -drag, you highlight another block of text, even though the earlier blocks are still selected (see Figure 5-20).

Tip: In most Cocoa programs, you can combine these two tricks. That is, you can select multiple, arbitrary (not full-page-width) blocks of text by pressing both Option and [image] as you drag.

Figure 5-20. The beauty of being able to select multiple blobs of text is that you can format all of them simultaneously (making them bold, for example) with one click. You can also copy the selected portions; when you paste into a different document, you get a tidy excerpt containing only the parts you wanted, all run together.

5.10.7. Background Window Control

The [image] key unlocks a slick trick in Cocoa programs: It lets you operate the buttons and controls of an inactive, background window without bringing it to the front.You can operate a background window's resize box, buttons, pop-up menus, and scroll bars, all while another window is in front of it. In fact, you can even drag through text in a background window—and then drag and drop it into the foreground window. (Freaky!)

In every case, the secret is simply to keep [image] pressed as you click or drag.


universal_apps_intel_macs.html

5.11. Universal Apps (Intel Macs)

By the end of 2006, Apple had switched its entire Macintosh product line over to Intel's Core Duo processors (the successor to the Pentium).

Yes, that Intel. The company that Mac partisans had derided for years as part of the Dark Side. The company that Steve Jobs routinely belittled in his demonstrations of PowerPC chips (which IBM and Motorola supplied to Apple for more than a decade). The company whose marketing mascot Apple lit on fire in a 1996 attack ad on TV.

Why the change? Apple's computers can only be as fast as the chips inside them, and the chips that IBM had in the works just weren't keeping up with the industry. As one editorial put it, "Apple's doing a U-turn out of a dead-end road."

And sure enough, Intel-based Macs start up and run much faster than the old Macs, thanks to the endless march of speed improvements in the chip-making world. And thanks to that Intel chip, today's Macs can even run Microsoft Windows and all of the thousands of Windows programs. (Chapter 8 has details.)

At the time, though, there was a small glitch: Existing Mac software didn't run on Intel chips.

Apple would have to ask the world's software companies to rewrite their programs yet again, after already having dragged them through the Mac OS 9-to-Mac OS X transition only a few years earlier.

Fortunately, the transition wasn't as gruesome as you might expect. First, Apple had already secretly recompiled (reworked) Mac OS X itself to run on Intel chips, beginning with Mac OS X 10.4.4.

Furthermore, Apple wrote an invisible translation program, code-named Rosetta, which permits the existing library of Mac OS X programs—Photoshop, Word, and so on—to run, unmodified, on Intel Macs.

They do not, however, run especially fast on Intel Macs. In fact, many of them run slower than they did on pre-Intel Macs.

To make their programs perform at full speed on Intel-based Macs, programmers have to update their wares. All the big software companies promised to make their programs into universal binaries—programs that run equally well on PowerPC- and Intel-based Macs with a double-click on the very same Finder icon.

Figure 5-21. Here's a quick way to tell if a program is an old one that will run slowly on an Intel Mac (instead of a Universal one that won't require the Rosetta software translation). Highlight its icon and choose File rightwards double arrow Get Info. Near the top, you'll see either "Application: PowerPC" (meaning "old and slow") or "Application: Universal" (meaning "runs fast on both Intel and PowerPC machines").

It took two years for all the big-name programs to fall in line, but they finally did. Photoshop CS3, Microsoft Office 2008, Final Cut Pro, QuarkXPress, FileMaker, Firefox…one by one, the world's most popular Mac programs were reworked into Universal versions. (There's even a list of them—over 7,000 so far—at http://guide.apple.com/universal.)

You have only two indications that you're using a program originally designed for PowerPC-based Macs: first, you'll see a notation in the program's Get Info window (see Figure 5-21). Second, you'll probably discover that the program isn't as fast as it used to be.

If all this talk about architectures and chips makes your brain hurt, you can at least take comfort in one fact: No matter which kind of Mac you've got Leopard installed on, every feature, tip, and trick you've learned from this book will work exactly the same.


installing_mac_os_x_programs.html

5.12. Installing Mac OS X Programs

In general, new programs arrive on your Mac via one of two avenues: on a CD or DVD, or via an Internet download. The CD method is slightly simpler; see "Performing the Installation" later in this section.

For help installing downloaded programs, on the other hand, read on.

5.12.1. .sit, .zip, .tar, .gz, and .dmg

Programs you download from the Internet generally arrive in a specially encoded, compressed form. (And unless you've changed the settings, they arrive in the Downloads folder stack on your Dock.)

The downloaded file's name usually has one of these filename extensions:

  • .sit indicates a StuffIt file, the standard Macintosh file-compression format of years gone by.

  • .zip is the standard Windows compression file format. And because Leopard has a built-in Compress command right in the File menu (and doesn't come with Stuff It Expander), .zip is the new standard Macintosh compression format. It certainly makes life easier for people who have to exchange files with the Windows crowd.

  • .tar is short for tape archive, an ancient Unix utility that combines (but doesn't compress) several files into a single icon, for simplicity in sending.

  • .gz is short for gzip, a standard Unix compression format.

  • .tar.gz or .tgz represents one compressed archive containing several files.

  • .dmg is a disk image, described below.

Fortunately, if you use Safari (Section 10.25) as your Web browser, you don't have to worry about all this, because it automatically unzips and unstuffs them.

If you use some other browser, StuffIt Expander can turn all of them back into usable form when you download a file. (StuffIt Expander doesn't come with Mac OS X, but you can download it for free from, for example, this book's "Missing CD" page at www.missingmanuals.com.)

5.12.2. Disk Images (.dmg files)

Once you've unzipped a downloaded program, it often takes the form of a disk image file, whose name ends with the letters .dmg (second from top in Figure 5-22). Some files arrive as disk images straight from the Web, too, without having been compressed first.

Figure 5-22. Downloading a new program from the Internet may strew your desktop or Downloads folder with icons. A: These are the original downloaded files. Delete them after they're decompressed. B: The compressed file turns into this .dmg file. Double-click it to "mount" the disk image (if it didn't appear automatically). C: And now, the disk image itself. Double-click it to open the software installer window. "Eject" it after the installation is complete. D: Here's the actual software installer window. Drag the software's icon to your Applications folder, or double-click the installer, if you see one here. After the installation is complete, you can delete all of this stuff (except maybe the .dmg file, if you think you might want to install the software again later).

Disk images are extremely common in Mac OS X. All you have to do is double-click the .dmg icon. After a moment, it magically turns into a disk icon on your desktop, which you can work with just as though it's a real disk (third from top in Figure 5-22). For example:

  • Double-click it to open it. The software you downloaded is inside.

  • Remove it from your desktop by dragging it to the Trash (whose icon turns into a big silver Eject key as you drag), highlighting it and pressing [image] -E (the shortcut for File rightwards double arrow Eject), clicking its [image] button in the Sidebar, or Control-clicking (right-clicking) it, and then choosing Eject from the shortcut menu. (You've still got the original .dmg file you downloaded, so you're not really saying goodbye to the disk image forever.)

5.12.3. Cleaning Up after Decompression

When you've finished unzipping or unstuffing a downloaded file, you may have several icons on your desktop or in the Downloads folder. Some are useful; some you're free to trash:

  • The original compressed file. It's safe to throw away the .sit, .tar, .gz, or .tgz file you originally downloaded (after it's decompressed, of course).

  • The .dmg file. Once you've turned it into an actual disk-drive icon, installed the software from it, and "ejected" the disk-drive icon, you can delete the .dmg file. Keep it only if you think you might need to reinstall the software someday.

    FREQUENTLY ASKED QUESTION
    Submit to Apple

    What the—I was working along in Preview, and all of a sudden it just vanished! Poof! And all I got was this lousy dialog box about "submitting to Apple." What's going on?

    Apple is trying to assimilate you.

    Or, more accurately, it's trying to enlist your help in ferreting all the little glitches that make modern computing so much fun. If you're willing to click the Submit Report button and type a few comments ("I was just running Word, minding my own business, and when I clicked the Print toolbar button, the whole thing just crashed"), then Apple will add your report to the thousands flowing in from everyone else.

    The idea is that when its programmers get a moment, they'll study these reports, track down the patterns ("Hmm, we've received 50,000 reports about that Print button in Word"), and then chase down the software company responsible—and, presumably, get a fix under way.

    The report you submit is full of technical info that helps the programmers figure out what was happening at the time of the crash, but no personal information goes along for the ride. So if you feel like doing some good for your fellow Mac fans, by all means submit the report (via the Internet) whenever you're offered the chance.

    Note: If you try to trash the .dmg file before removing the disk-drive icon from the screen, you'll get a "file in use" error message when you try to empty the Trash.

  • The disk image itself. This final icon, the one that contains the actual software or its installer (third from top in Figure 5-22), doesn't exist as a file on your hard drive. It's a phantom drive, held in memory, that will go away by itself when you log out. So after installing its software, feel free to drag it to the Trash (or highlight it and press [image] -E to "eject" it).

5.12.4. Performing the Installation

Working with .tar, .gz, and .dmg files are all skills unique to downloading Mac OS X programs from the Internet. Installing software from a CD or DVD is much more straightforward.

In either case, once you've got a disk icon on your desktop (either a pseudo-disk from a disk image or a CD or DVD you've inserted), you're ready to install the software. You can install many Mac OS X programs just by dragging their icons or folders to your hard drive (usually the Applications folder). Others offer a traditional installer program that requires you to double-click, read and accept a license agreement, and so on.

In both cases, where you decide to install the new program is suddenly a big issue. You have the following two alternatives:

  • In the Applications folder. Most programs, of course, sit in your Applications folder. Most of the time, this is where you'll want to install new programs. Putting them in the Applications folder makes them available to anyone who uses the Mac.

    Note: You can't put anything in your Applications folder unless you have an Administrator account, as described on Section 12.2.1.1.

  • In your Home folder. Suppose you share your Mac with other people, as described in Chapter 12. If that's your situation, you may occasionally want to install a program privately, reserving it for your own use only. In that case, just install or drag it into your Home folder, or a folder inside it. When other people log onto the machine, they won't even know that you've installed that new program, since it doesn't show up in the Applications folder.

    If you don't have an Administrator account, in fact, this is your only option for installing new programs.

5.12.5. Uninstalling Software

In Mac OS X, there's generally no Uninstall program, and no Add/Remove Programs window. To uninstall a program, you just drag it (or its folder) from the Applications folder (or wherever it is) to the Trash.

Some programs also leave harmless scraps of themselves behind; to check for them, look for preference files or folders bearing the dearly departed program's name in your Library folders (especially in Application Support) and your Home rightwards double arrow Library rightwards double arrow Preferences folder.

UP TO SPEED
The Color Picker

Here and there—in System Preferences, iMovie, TextEdit, Microsoft Office, and many other programs—Mac OS X offers you the opportunity to choose a color for some element: for your desktop background, a window, and so on.

The dialog box that appears offers a miniature color lab that lets you dial in any color in the Mac's rainbow. Several color labs, actually, arrayed across the top, each designed to make color-choosing easier in certain circumstances:

Color Wheel. Drag the scroll bar vertically to adjust the brightness, and then drag your cursor around the ball to pick the shade.

Color Sliders. From the pop-up menu, choose the color-mixing method you prefer. CMYK stands for cyan, magenta, yellow, and black. People in the printing industry will feel immediately at home, because these four colors are the component inks for color printing. (These people may also be able to explain why K stands for black.)

RGB is how a TV or computer monitor thinks of colors: as proportions of red, green, and blue light. Gray Scale means shades of gray, like a black-and-white TV. And HSB stands for Hue, Saturation, and Brightness—a favorite color-specifying scheme in scientific circles.

In each case, just drag the sliders to mix up the color you want, or type in the percentages of each component.

Color Palettes. This option presents canned sets of color swatches. They're primarily for programmers who want quick access to the standard colors in Mac OS X. The Web Safe Colors list is useful for Web designers, too; they can tell whether a color will display properly on other computers.

Image Palettes. Here's the visible rainbow arrayed yet another way: in cloudy, color-arranged streaks. (Cool tip: If you drag a graphics file directly into the dialog box, it appears in the spectrum's place. That's a handy trick if you're trying to identify the color of a certain spot of an image, for example. And don't miss the pop-up button at the bottom of the dialog box, which offers a few other stunts.)

Crayons. Now this is a good user interface. You can click each crayon to see its color name: Mocha, Fern, Cayenne, and so on. (Some interior decorator in Cupertino had a field day naming these crayons.)

In any of these color pickers, you can also "sample" a color that's outside the dialog box—a color you found on a Web page, for example. Just click the magnifying-glass icon and then move your cursor around the screen. You'll see the sliders and numbers change inside the dialog box automatically when you click.

Finally, note that you can store frequently used (or frequently admired) colors in the tiny palette squares at the bottom. To do that, drag the big rectangular color swatch (next to the magnifying glass) directly down into one of the little squares, where it will stay fresh for weeks.

If you don't have space for all the colors you want at the bottom of the window, you can drag the small circular dot down to make room for more.


dashboard.html

5.13. Dashboard

As you know, the essence of using Mac OS X is running programs, which of ten produce documents. In Leopard, however, there's a third category: a set of weird, hybrid entities that Apple calls widgets. They appear, all at once, floating in front of your other windows, when you press the F12 key. Welcome to the Dashboard (Figure 5-23).

Note: On the thin aluminum Apple keyboard, the Dashboard has a different keystroke: F4. In fact, you can see a tiny Dashboard logo painted right on the key. (The F12 keystroke can still work—but see the box on Section 5.3.1.)Either way, you can change this keyboard assignment, as described below. Also, on laptops where F12 is the Eject key, you have to hold down the Fn key (lower-left corner).

Figure 5-23. When you summon the Dashboard, you get a fleet of floating miniprograms that convey or convert all kinds of useful information. They appear and disappear all at once, on a tinted translucent sheet that floats in front of all your other windows. You get rid of Dashboard either by pressing the same key again (F12 or whatever) or by clicking anywhere on the screen except on a widget.

What are these weird, hybrid entities, anyway? They're not really programs, because they don't create documents or have Dock icons (although Dashboard itself has a Dock icon). They're certainly not documents, because you can't name or save them. What they most resemble, actually, is little Web pages. They're meant to display information, much of it from the Internet, and they're written using Web programming languages like HTML and JavaScript.

The starter widgets include a calculator, current weather reporter, stock ticker, clock, a new movie-showtimes widget, and so on. (You may have to wait 30 seconds or so for them to "warm up," go online, and display any meaningful information.) Mastering the basics of Dashboard won't take you long at all:

  • To move a widget, drag it around the screen. (Click anywhere but on a button, menu, or text box.)

  • To close a widget, press the Option key as you move the mouse across the widget's face. You'll see the circled X button appear at the widget's top-left corner; click it.

    Tip: If the Widget Bar is open (as described below), every widget displays its X close button. You don't need the Option key.

  • To open a closed widget, click the circled + button at the bottom of the screen. Now the entire screen image slides upward by about an inch to make room for the Widget Bar: a "perforated metal" tray containing the full array of widgets, even the ones that aren't currently on the screen (Figure 5-24). (The complete list, with descriptions, appears later in this chapter.) Open one by clicking its icon.

    Figure 5-24. You'll probably have to scroll the Widget Bar to see all the widgets, by clicking the arrows at either end. When you're finished opening new widgets, close the Widget Bar by clicking its circled X button at the left side of your screen.

    On Mac swith newish graphics cards, a new widget appears by splashing down into the center of your screen, sending realistic pond ripples across the liquidy glass of your screen. These widgets really know how to make an appearance, don't they?

  • To hide one of Apple's widgets, or delete one that you've installed yourself, use the Widget widget described below.

  • To rearrange your widgets as they appear in the Widget Bar, open your hard drive rightwards double arrow Library rightwards double arrow Widgets folder. Here you'll find the icons for the standard Apple Dashboard widgets. To rearrange them, you have to rename them; they appear on the Widget Bar in alphabetical order. (You can also remove a widget for good by deleting it from this folder, if you must.)

Tip: The Dashboard icon also appears in your Dock, just in case you forget the F12 keystroke. On the other hand, if you prefer the keystroke, you can remove the icon from your Dock to make room for more important stuff. Control-click (or right-click) the icon and, from the shortcut menu, choose Remove from Dock.

5.13.1. Dashboard Tips

Like most Leopard features, Dashboard is crawling with cool tips and tricks. Here are a few of the biggies:

  • If you just click an icon on the Widget Bar, the widget appears right in the middle of your screen. But if you drag the widget's icon off the bar, you can deposit it anywhere you like on the screen.

  • There's a great keystroke that opens and closes the Widget Bar: -equal sign (=). (This keystroke may be different on non-U.S. keyboard layouts.)

  • To refresh a certain widget—for example, to update its information from the Internet—click it and press [image] -R. The widget instantly twist-scrambles itself into a sort of ice-cream swirl (you've got to see it to believe it) and then untwists to reveal the new data.

  • You can open more than one copy of the same widget. Just click its icon more than once in the Widget Bar. You wind up with multiple copies of it on your screen: three World Clocks, two Stock Trackers, or whatever. That's a useful trick when, for example, you want to track the time or weather in more than one city, or when you maintain two different stock portfolios.

    If you keep the Shift key pressed when you summon Dashboard, the widgets fly onto the screen in gorgeous, translucent, 3-D slow motion. Aren't you glad you're alive to see the day?

5.13.2. Dashboard Preferences

To change the Dashboard keystroke to something other than F12, choose [image] rightwards double arrow System Preferences, and then click Exposé & Spaces. In Leopard, they're combined in a single System Preferences pane because at their core, they serve similar functions: helping you herd your windows.

Tip: For faster service, Control-click (right-click) the Dashboard icon on the dock. Choose Dashboard Preferences from the shortcut menu.

Here, you'll discover that you can choose almost any other keyboard combination to summon and dismiss the Dashboard, or even choose a screen corner that, when your mouse lands there, acts as the Dashboard trigger.

All of this works exactly as described on Section 5.3.2.2.

5.13.3. Widget Catalog

Here's a rundown of the 20 standard widgets that come preinstalled in Leopard. True, they look awfully simple, but some of them harbor a few secrets.

5.13.3.1. The Widgets widget

This widget is designed to manage all your other widgets (Figure 5-25). It's the easiest way to hide a widget (that is, get it out of Dashboard but leave it on your Mac, in case you change your mind later) or to uninstall it altogether. It has three functions:

Figure 5-25. The Widget widget (whose icon appears at lower left in Figure 5-24) opens up this list of widgets. Turn off a check mark to hide a widget, or click – to completely uninstall any widget you installed yourself. The ones whose boxes aren't checked are the ones that no longer appear on the Widgets bar.

FREQUENTLY ASKED QUESTION
Unchained Widgets

I love the widgets, but I wish they weren't locked away in their own Mac OS X "layer." I'd like to work with the Calculator widget, for example, while I'm doing an Excel spreadsheet, without having to send the spreadsheet to the background.

No problem. What you want is Amnesty Widget Browser, a shareware program that you can download from, among other places, this book's "Missing CD" page at www.missingmanuals.com.

It adds a new menu-bar icon that, when opened, lists all of your widgets by name. You can now open them individually—and, more importantly, without sending your other programs to the background. You've just freed your widgets from the translucent layer where they've been imprisoned.

  • Use the checkboxes to hide or show widgets. You may as well hide the ones you never use.

  • Click the – button to delete a widget for good. You're not allowed to delete Apple's widgets—only ones you've downloaded and installed yourself.

  • Click More Widgets to browse the catalog. You go right to Apple's Widgets Web page, where thousands of new widgets await your downloading pleasure, as described later in this section.

Tip: Drag the lower-right ribbed bar to make the Widgets widget taller or shorter.
5.13.3.2. Address Book

The concept behind this widget is, of course, to give you faster access to your own address book. (Trudging off to the actual Address Book program takes way too long when you just want to look up a number.)

The widget may look like a simple Rolodex card, but it's actually filled with clickable shortcuts. For example:

  • Search bar. Type a few letters of somebody's name here. As you type, the widget homes in on that person's entry from the Address Book program.

    If you see numbers at the bottom edge that say, for example, "1/12," then you've found more than one match. You're looking at the first of 12 matches. You can click the little right/left arrows to page through them. Click the circled X at the right end of the bar to erase the box and start over.

  • Big red dot. Click to open Address Book, with this person's entry staring you in the face. That's what you'd do if, for example, you wanted to edit the entry.

  • Phone number. Click it to fill your screen with an enormous version of the phone number that you could see from outer space. The idea here is that it's big enough to see from across the room as you dial the number on your desk phone.

  • Email address. Click to fire up the Mail program (or whatever email program you use), complete with a fresh outgoing message already addressed to this person. All you have to do is type your message and click Send.

  • Mailing address. Clicking the mailing address fires up your Web browser and takes you to MapQuest.com, already opened up to a map that reveals the pinpoint location of the specified address. Very, very slick.

5.13.3.3. Business (a.k.a. Yellow Pages)

A Yellow Pages of every business and organization in the entire United States wouldn't be especially compact. In fact, it would probably occupy your entire living room. And yet think of the convenience! You could instantly find the closest Chinese restaurant, hospital, or all-night drugstore in a strange city.

Well, now you can, thanks to Business. Into the text box, type whatever it is you're looking for, exactly as though it's a heading in the Yellow Pages business directory. You could type drug store, cleaning service, health club, tailor, library, or whatever. Alternatively, click the triangular down arrow next to this box to see a list of services the widget already knows about.

The widget shoots out the query to the Internet and, after a moment, provides a list of local businesses that match, including phone numbers and addresses. (Click the right or left arrow at the bottom of the window to see the next set of results.)

The contact information is clickable, by the way. Click the name of the place to open a Web page revealing more information, the phone number to enlarge it big enough to see from 50 feet away, or the address to see where this place is on a MapQuest map.

Note: Before Business can show you a list of local businesses, it has to know what you mean by local—in other words, where you are. Now, your Mac may already know where you live. It can extract this information from your original Mac OS X installation, for example, or from the Address Book program (if you've filled in a card for yourself).But if it doesn't seem to know where you are—or if you're traveling with a laptop—you have to tell it. Perform any random search using the widget (try Banks, for example). At the bottom of the results window, you'll see the [image]. Click it to rotate the widget; on the back, you'll see that you can specify a city and state or Zip code, how many listings you want per "page," and how many miles away a business has to be to qualify. Then click Done.
5.13.3.4. Calculator

Here's your basic four-function pocket calculator, with one-number memory storage. Begin by clicking it to make active—which basically means that any typing you do on the number keys get intercepted by this little calculator. (Pressing the number keys is much faster than clicking the onscreen numbers.)

There's not a lot to this calculator; if you need scientific and hexadecimal features, or even square root functions, use the regular Calculator program described on Section 10.3.

5.13.3.5. Dictionary

Apple has provided about 65,000 different ways to access its built-in dictionary/ thesaurus (Section 10.6.3), and here's another one. You click either the word Dictionary or Thesaurus, type the word you want, and press Enter. Instantly, a handy definitions panel drops down to display the appropriate entry. The left/right triangle buttons in the upper-left corner let you walk through the most recent lookups you've done, and the pop-up menu lets you specify whether you want to search the dictionary, the thesaurus, or the Apple terminology glossary (which is new in Leopard).

Tip: Once you've looked up a word, you can look up new words by typing only the first few letters. (You don't even have to press Return.) The Dictionary or Thesaurus automatically displays the definition for the first matching word.

If you click the [image] button in the lower-left corner, the dictionary panel spins around to reveal its back side, where you see the Oxford American Dictionaries logo. Someday when you're feeling curious, click it. You wind up firing up your Web browser and visiting the Oxford University Press Web page.

Tip: See how the first letter of your word appears in a special rounded tab at the left edge of the panel? If you click that letter, you get to see the word you looked up in its alphabetical context among all the other words in the dictionary. It's a neat way to check for additional word forms, to see if perhaps you've misspelled the word, or to scrabble your way out of a tight situation when you're playing the word game "ghost" with someone.
5.13.3.6. ESPN

This widget shows the current or final scores of college and professional sports games. (If the game hasn't started yet, you see the start time.) Click the [image] button in the top right corner to choose the sport you want to track. Click the News button to see headlines—and click a headline to visit ESPN's full article online.

5.13.3.7. Flight Tracker

This handy widget lets you find out which flights fly between which cities—and if the flight is already en route, shows you where it is on the map, how high it's flying, how fast, and whether or not it's going to be on time.

This may look like a small window, but there's a lot going on here:

Figure 5-26. Top: Most of the time, Flight Tracker is like a teeny tiny travel agent, capable of showing you which flights connect which cities. But if one of the flights is marked "En route," double-click it.
Bottom: You see an actual map of its progress, as shown here. You also get to see its speed, and estimated arrival status (early, late, or on time), and even which terminal it will use upon landing. If you click the plane, you can zoom in on it.

  • Flight Finder. If you're planning a trip, the widget can show you a list of flights that match your itinerary. Use the pop-up menus to specify the arrival and departure cities, and which airline you want to study, if any. (Actually, it's usually faster to type the name of the city into the box, if you know it, or, better yet, its three-digit airport code.) Then click Find Flights, or press Return or Enter.

    After a moment, the right side of the screen becomes a scrolling list of flights that match your query. You can see the flight number, the departure and arrival time, and the name of the airline.

    This is a great tool when a friend or relative is flying in and you're unsure of the flight number, airline, or arrival time.

  • Flight Tracker. Most of the time, the status column of the results says "Scheduled," meaning that you're looking at some future flight. Every now and then, however, you get lucky, and it says "en route." This is where things get really fun: Double-click that row of results to see the plane's actual position on a national or international map (Figure 5-26).

Tip: If you click the little [image] button before performing a flight search, the panel flips around to reveal the logo of the company that supplies the flight data. Click the logo to open its Web page. Once you've performed a flight search, however, you lose the [image] button. To bring it back, you must close and reopen the widget.
5.13.3.8. Google

This one's nothing but a standalone Google search bar. Type a search phrase into it, hit Return or Enter, and presto: You're in your Web browser, staring at the Google search results.

5.13.3.9. iCal

Sure, you can always find out today's date by clicking the clock on your menu bar. But this one is so much nicer looking. And besides, you can use this calendar to look ahead or back, or to check your schedule for the day. (That's a new feature in Leopard—the display of whatever appointments you've recorded in iCal for the day. At the top of the list are any all-day events.)

As you click this widget, it cycles through three degrees of expansion; see Figure 5-27.

Figure 5-27. Click the "today's date" panel to expand the second panel, which shows the month. (Click and to move a month at a time.) Click a third time to reveal whatever's on the calendar for the remainder of the day, as recorded in iCal (Section 10.9).

Tip: Press Shift as you click to see the panels expanding or collapsing in slow motion.
5.13.3.10. iTunes

This glossy-looking controller is a remote control for the iTunes music player. It's intended for people who listen to music while they work all day, and have no greater musi [image] -management needs than starting and stopping the music (see Figure 5-28). Of course, you can perform all of the same functions in iTunes itself, in the miniaturized iTunes window, or even using the iTunes Dock icon. But on a Mac with a lot of windows open, with the phone ringing and the baby crying, you may find it quicker to pause the music by hitting F12, and then clicking the Pause button on this widget.

Figure 5-28. The little iTunes widget is filled with clickable areas. (A.) Volume ring. (B.) Next song/previous song. (C.) Play/Stop. (D.) Shuffle (random playback order) on/off. (E.) Loop this song on/off. (F.) Scroll bar (click to jump around in the song). (G.) Click this button to make the widget "flip around." On the back, you'll see a popup menu that lets you change your playlist, as you've created it in iTunes. C.B.A.D.E.F.G.

5.13.3.11. Movies

There's only one new widget in Leopard, and this is it—but it's a good one. It lets you look up the local movie-theater listings for any day this week—without having to endure, the hassle of the newspaper, the hellish touchtone labyrinth of a phone system, or the flashing ads of a Web site.

When you open this widget, you see a miniature movie poster that changes to a different current movie every 3 seconds. At any point, you can click the poster itself to see what's on the "back" of the widget (Figure 5-29).

In the left column, you get a scrolling list of movies in your area. The one whose poster you clicked is highlighted, but you can click any one of them to see, at bottom, all the details: release date, rating, length, cast, genre, a plot synopsis, and a link to the preview (trailer). (After you've watched the trailer, click the left-pointing arrow button at the lower-left corner of the widget.)

The center column lists the theaters near you where the selected movie is playing. Click a theater to see the movie show times in the right column.

Tip: So how does the widget know what's "near you?" Because you've told it. You've clicked the [image] button to flip the widget around to the back, where you can input your Zip code or your city and state.(And yes, it's true: You've now seen three faces of this two-dimensional widget. It's got a front, a back, and a back of the back.)

Incidentally, you're not stuck with this "Choose a movie, and we'll show you the theaters" view. See at the top left, where the title "Movies Theaters" appears? Click the word Theaters to reverse the logic.

Now you're in "Choose a theater, and we'll show you what movies are playing there" mode. This view is much better when, for example, there's only one theater that's really nearby, and you want to know what your options are there.

Tip: To return to the original cycling movie-poster display, click an empty part of the title bar.

Figure 5-29. Top: The Movies widget starts out with a slideshow of movie posters.
Bottom: On the "back," you can read about current movies in theaters, find out which theaters they're in, and see today's show times. The pop-up menu at upper right lets you see the schedule for Today, Tomorrow, and the following four days.

5.13.3.12. People (a.k.a. White Pages)

This widget is worth its weight in silicon. It's a White Pages phone book of the entire United States, all contained in a tiny widget. Specify as much information as you know—the last name and state (or Zip code) at a minimum—and press Return or Enter. In a moment, the widget shows you a list of every matching name, complete with phone number and street address.

Click the phone number to display it in gigantic numbers, large enough to see while dialing across the room (or across town); click the address for a Web page that shows this person's house on a map; and click the [image] button to limit searches to a certain number of miles from the specified city, state, or Zip code.

5.13.3.13. Ski Report

As though you couldn't guess: This widget is for skiers. Click the [image] button and type in the name of the ski resort you're considering visiting. Type in its name (like Vail, CO or Okemo, VT), and then press Return.

Once the widget displays the correct mountain name, click Done and wait as the widget summons the current ski conditions from the Internet and displays them—temperature, base snow depth, surface conditions, and so on—in handy icon form.

5.13.3.14. Stickies

Stickies is a virtual Post-it note that lets you type out random scraps of text—a phone number, a Web address, a grocery list, or whatever.

Of course, Mac OS X already comes with a popular Stickies program (Section 5.13.3.14). So why did Apple duplicate it in Dashboard? Simple—because you can call up this one with a tap on the F12 key, making it faster to open.

On the other hand, this Stickies isn't quite as flexible as the application Stickies. For example, you can't resize the page. And to add a second or a third note, you have to click the + button at the bottom of the screen to reveal the Widget Bar, and then click the Stickies icon for each new page.

On the other other hand, this Stickies isn't quite as bare-bones as you might think. If you click the little [image] button at the bottom-right corner, the note spins around to reveal, on the back, the choice of paper colors, fonts, and font sizes.

5.13.3.15. Stocks

Hey, day traders, this one's for you. This widget lets you build a stock portfolio and watch it rise and fall throughout the day (Figure 5-30).

To set up your portfolio, click the little [image] button at the bottom of the window. The widget flips around, revealing the configuration page on the back:

  • Add a stock to your list by typing its name or stock abbreviation into the box at the top; then click the + button, or press Return or Enter. If there's only one possible match—Microsoft, for example—the widget adds it to the list instantly. If there's some question about what you typed, or several possible matches, you'll see a pop-up menu listing the alternatives, so you can click the one you want.

  • Remove a stock from the list by clicking its name and then clicking Remove.

Tip: Ordinarily, the widget displays the ups and downs of each stock as a dollar amount ("+.92" means up 92 cents, for example). But if you turn on "Show change as a percentage," you'll see these changes represented as percentages of their previous values.But why bother? Once you're looking at the actual stock statistics, you can switch between dollar and percentage values just by clicking any one of the red or green up/down status buttons.

Figure 5-30. More of Apple's built-in widgets. Clockwise from top left: Translation, Stocks, Tile Game (showing a new graphic—in honor of Apple's switch to Intel processors—that you've dragged in to serve as the puzzle), and Weather.

Click Done to return to the original stock display. Here's your list of stocks, their current prices (well, current as of 20 minutes ago), and the amount they've changed—green if they're up, red if they're down. Click a stock's name to see its chart displayed at the bottom. (You control the time scale by clicking one of the little buttons above the graph: "1d" means one day, "3m" means three months, "1y" means one year, and so on.)

Finally, if you double-click the name of the stock, you fly into your Web browser to view a much more detailed stock-analysis page for that stock, courtesy of Quote.com (Lycos Finance).

5.13.3.16. Tile Game

For generations, Microsoft Windows has had its Solitaire game—and for generations, the Mac had the Tile Game. The idea, of course, is to click the squares of the puzzle, using logictore arrange the mback into the original sequence, so that the put-together photograph reappears.

Tip: The widget starts you out with a handsome photo of a leopard—get it?—but you can substitute any photo you like.To pull this off, begin by exiting the Dashboard. Go find the photo you prefer (on the desktop or in iPhoto, for example). Now begin dragging it in any direction. While the mouse is still down, press F12 (or whatever your Dashboard keystroke is)—and drop the dragged graphic directly on the Tile Game puzzle. You've just replaced the existing graphic with your new one. (Figure 5-30 shows an example.)

The first time you use the Tile Game, click inside it to trigger the animated tilescramblingprocess. Click a second time to stop the scrambling; in other words, Apple leaves it to you to decide just how difficult (how scrambled) the puzzle is.

And what should you do if you get frustrated and give up, or you miss the old leopard photo? Just open the Widget Bar and open a fresh copy of the Tile Game.

5.13.3.17. Translation

The next time you travel abroad, plan your trip so that your laptop always has wireless Internet access wherever you go (yeah, right). You'll be able to use this module to translate your utterances—or those of the natives—to and from 13 languages.

Just choose the language direction you want from the "from" and "to" pop-up menus, and then type the word, sentence, or paragraph into the "Translate From" box.

You don't have to click anything or press any key; just wait a moment. In a flash, the bottom of the window shows the translation, as shown at top left in Figure 5-30. (Don't click the curvy double-headed arrow button to perform the translation; that button means "Swap the To and From languages.")

Of course, these translations are performed by automated software robots on the Web. As a result, they're not nearly as accurate as what you'd get from a paid professional. On the other hand, when you're standing in the middle of a strange city and you don't know the language—and you desperately need to express yourself—what Dashboard provides may just be good enough.

Tip: Your first instinct may be to assume that this module is designed for translating things you want to say into the local language. However, you may find it even more useful for translating foreign language paragraphs—from email or Web pages, for example—into your own language so that you can read them.
5.13.3.18. Unit Converter

No matter what units you're trying to convert—meters, grams, inches, miles per hour—the Unit Converter widget is ready.

From the upper pop-up menu, choose the kind of conversion you want: Temperature, Area, Weight, or whatever. (Take a moment to enjoy the clever graphic at the top of the window that helps identify the measurement you've selected.)

Use the lower pair of pop-up menus to specify which units you want to convert to and from, like Celsius to Fahrenheit. Then type in either the starting or ending measurement. To convert 48 degrees Celsius to Fahrenheit, for example, type 48 into the Celsius box. You don't have to click anything or press any key; the conversion is performed for you instantly and automatically as you type.

Never let it be said that technology isn't marching forward.

Tip: Unit Converter is especially amazing when it comes to currency conversions—from pesos to American dollars, for example—because it actually does its homework. It goes online to download up-to-the-minute currency rates to ensure that the conversion is accurate.
5.13.3.19. Weather

This widget is, by far, the most famous Dashboard module. It shows a handy current conditions display for your city (or any other city), and, if you choose, even offers a six-day forecast (Figure 5-29, lower left).

Before you get started, the most important step is to click the [image] button at the lower right corner. The widget flips around, and on the back panel, you'll see where you can specify your city and state or Zip code. You can also specify whether you prefer degrees Celsius or degrees Fahrenheit, and whether you want the six-day forecast to show both highs and lows. (It ordinarily shows only the highs.) Click Done.

Now the front of the widget displays the name of your town, today's predicted high and low, the current temperature, and a graphic representation of the sky conditions (sunny, cloudy, rainy, and so on). Click anywhere to reveal the six-day forecast.

Tip: Evidently, the Weather widget team members at Apple were really proud of their artwork. Lest you miss out on seeing all the beautiful weather graphics, they've given you a secret keystroke that reveals all 19 of the gorgeous and witty sky-weather graphics.All you have to do is hold down [image] and Option as you click repeatedly on the widget. You'll see that, for the town of Nowhere, the weather changes every time you click.
5.13.3.20. Web Clips

Web Clips, a new Leopard feature, lets you make your own widgets with one click. This particular widget, however, is nothing more than a little ad for the Web Clips feature—and a reminder that you must start your Web Clip adventure in Safari, not Dashboard. See "Web Clips," below.

5.13.3.21. World Clock

Sure, this clock shows the current time, but your menu bar does that. The neat part is that you can open up several of these clocks—click World Clock in the Widget Bar repeatedly—and set each one up to show the time in a different city. The result looks like the row of clocks in a hotel lobby, making you look Swiss and precise.

To specify which city's time appears on the clock, click the [image] button at the lower-right corner. The widget flips around, revealing the pop-up menus that let you choose a continent and city.

5.13.4. More Widgets

The best part of the Dashboard is that it's expandable. Thousands of new widgets, written by other people, are available on the Web: games, chat and email notifiers, gas-price reporters, calculators and translators, news and sports updaters, finance and health trackers, and on and on.

To see Apple's current list of goodies, use one of these tactics:

  • The short way. Control-click (or right-click) the Dashboard icon in the Dock. From the shortcut menu, choose More Widgets.

  • The long way. Click the Manage Widgets button that appears when ever the Widgets Bar is exposed; when the Widgets widget opens, click More Widgets.

Either way, you go to the Apple Dashboard downloads page. (Alternatively, check a Ma [image] -downloads Web site like www.versiontracker.com for an even more complete selection.)

Some of the most intriguing widget offerings include the Yahoo Local Traffic widget (gives you the traffic conditions in your area), Air Traffic Control (identifies wireless AirPort base stations within range of your laptop), and TV Tracker (shows you could be watching on TV right now instead of working). There are also FedEx package trackers, joke-of-the-day widgets, comi [image] -strip-of-the-day widgets, and many other varieties. (See Figure 5-31, bottom.)

5.13.4.1. Installing a widget

When you download a widget, Mac OS X is smart enough to install it automatically. First, though, it offers you a trial run, as shown in Figure 5-31.

If you click Keep, Mac OS X copies it into your Home rightwards double arrow Library rightwards double arrow Widgetsfolder. Only you will see that Dashboard widget, because it's been copied into the Widgets folder of your account. Anyone else who has accounts on this Mac won't see it.

Unless, of course, you copy or move that widget into the Library rightwards double arrow Widgets folder (that is, begin with the Library folder in your main hard drive window). The contents of that Widgets folder are available to all account holders.


web_clips_make_your_own_widgets.html

5.14. Web Clips: Make Your Own Widgets

You don't have to be satisfied with Apple's 20 widgets or the several thousand that other people have written. Leopard introduces Web clips, a new way to make a Dashboard widget of your own—in about three clicks.

Web clips exploit an inescapable characteristic of widgets: An awful lot of them exist to deliver real-time information from the Web. That's the point of the Ski Report widget, Weather, Stocks, Flight Tracker, ESPN, and so on.

Figure 5-31. Widgets could, in theory, harbor viruses, so Mac OS X is extremely cautious in downloading them.
Top: When you try to download a widget, the Mac asks if you're sure.
Middle: After you download a widget and confirm your intention, you meet this test-drive mode for newly downloaded widgets. It's a way to play with new widgets before you actually commit to adding them to your system. Play with the widget, and then click Keep to install it (or Delete, if you think it's evil).
Bottom: Not all good things come from Apple. Here's a representative sample of widgets written by other people. From top left: Plasma Tube, Guitar Chords, Chuck Norris Facts, World Radio, and MiniStat 2 (details about your Mac at the moment).

But what if your interest isn't skiing, stocks, or sports? What if it's the New York Times front page? Or the bestselling children's books on Amazon? Or the most-viewed video on You Tube?

That's the beauty of Web clips, a joint venture of Dashboard and the Safari Web browser in Mac OS X 10.5. They let you turn any section of any Web page into a Dashboard widget that updates itself every time you open it. It's like having a real-time keyhole peek at all your favorite Web sites at once.

5.14.1. Creating a Web Clip Widget

Here's how you go about creating a do-it-yourself widget:

  1. Open Safari.

    Safari is the Mac's Web browser. It's in your Applications folder.

  2. Navigate to the Web page that contains the information you want to snip. Click the Web clips button identified in Figure 5-32.

    The screen goes dark, with only a small window of white. As you move your cursor around the page, the small white rectangle conveniently snaps to fit the various rectangular sections of the page.

    As shown in Figure 5-32, your job is to make a frame around the part of the page that usually shows the information you want. If the Web site ever redesigns its pages, it'll wreck your widget—but what the heck. It takes only 5 seconds to make it again.

    Figure 5-32. Drag the little round handles to make the white box just big enough to surround the part of the page you want to enshrine. Or drag inside the box to move the whole thing. Clip button Adjust handles

  3. Adjust the corner or side handles to enclose the piece of page you want. When you're finished, click Add, or press Return or Enter.

    Now Dashboard opens automatically. But wait—what's this? There's a new widget here that wasn't here before. At first, you might not even notice, because it's precisely centered over the piece of Web page that you enclosed. But if you drag it to one side, you'll see that it's a standalone, full-blown, real-time widget.

At this point, you can dress up your widget, adding a little polish to this raw clipping you've ripped out of a Web page. Click the [image] button that appears when you move your mouse to the lower-right corner. The widget flips around to reveal the controls shown in Figure 5-33.

Figure 5-33. Top: Click a frame style to give your widget better-looking edges. If the widget plays sound, it keeps playing sound when you close the Dashboard unless you turn on "Play audio in Dashboard only."
Bottom: Click Edit to return to the front of the widget, where you can adjust its position on the underlying Web page.

Here, you can click one of the frame styles to give your widget a better-looking border.

If you click Edit, the widget flips around to face you again, and here's where it gets weird: You can reposition your widget's contents as though they're a window on the Web page that's visible behind it. Drag the widget contents in any direction within the frame, or resize the frame using the lower-right resize handle. Click Done.

You can make as many Web-clip widgets as you want.

But here's a big screaming caution: If you close one of these homemade widgets, it's gone forever (or at least until you re-create it). They're never represented as icons on the Widget bar, as ordinariy widgets are.

Ah, well—easy come, easy go, right?

Note: If you're of the programmer persuasion—if you're handy in Javascript and HTML, for example—it's much easier to write custom widgets than ever before. (Not just Web-clip widgets; real widgets.)That's because Leopard comes with Dashcode, an easy-to-use widget-assembly environment. You'll find the installer for it on your Leopard installation DVD (in the Optional Installs rightwards double arrow XCode Tools folder), and you'll find tutorials and examples by typing dashcode tutorial into Google.


time_machine_syncing_and_moving_data.html

Chapter 6. Time Machine, Syncing, and Moving Data

The original 1984 Mac didn't make jaws drop because of its speed, price, or sleek looks. What amazed people most was the simplicity and elegance of the user interface. At some point in every Apple demo, the presenter copied a graphic drawn in a painting program (MacPaint) and pasted it directly into a word processor (MacWrite), where it appeared neatly nestled between typed paragraphs of text.

We take this example of data exchange for granted today. But in those days, that simple act struck people like a thunderbolt. After all, if this little computer let you copy and paste between different programs, it could probably do anything.

Today, the Mac is even more adept at helping you move and share your hard-won data. Mac OS X offers several different ways to move information within a single document, between documents, between different programs, and even between the Mac and Windows computers. This chapter leads you through this broad range of data-exchange mechanisms.

6.1. Moving Data Between Documents

You can't paste a picture into your Web browser, and you can't paste MIDI music information into your word processor. But you can put graphics into your word processor, paste movies into your database, insert text into Graphic Converter, and combine a surprising variety of seemingly dissimilar kinds of data.

6.1.1. Cut, Copy, and Paste

The original copy-and-paste procedure of 1984—putting a graphic into a word processor—has come a long way. Most experienced Mac users have learned to trigger the Cut, Copy, and Paste commands from the keyboard, quickly and without even thinking. Here's how the process works:

  1. Highlight some material in a document.

    Drag through some text in a word processor, for example, or highlight graphics, music, movie, database, or spreadsheet information, depending on the program you're using.

  2. Use the Edit rightwards double arrow Cut or Edit rightwards double arrow Copy command.

    Or press the keyboard shortcuts [image] -X (for Cut—think of the X as a pair of scissors) or [image] -C (for Copy). The Macintosh memorizes the highlighted material, socking it away on an invisible storage pad called the Clipboard. If you chose Copy, nothing visible happens. If you chose Cut, the highlighted material disappears from the original document.

    At this point, most Mac fans take it on faith that the Cut or Copy command actually worked. But if you're in doubt, switch to the Finder (by clicking its Dock icon, for example), and then choose Edit rightwards double arrow Show Clipboard. The Clipboard window appears, showing whatever you're copied.

  3. Click to indicate where you want the material to reappear.

    This may entail switching to a different program, a different document, or simply a different place in the same document.

  4. Choose the Edit rightwards double arrow Paste command ( [image] -V).

    The copy of the material you had originally highlighted now appears at your insertion point—if you're pasting into a program that can accept that kind of information. (You won't have much luck pasting, say, a movie clip into Quicken.)

    The most recently cut or copied material remains on your Clipboard even after you paste, making it possible to paste the same blob repeatedly. Such a trick can be useful when, for example, you've designed a business card in your drawing program and want to duplicate it enough times to fill a letter-sized printout. On the other hand.

    UP TO SPEED
    Styled Text

    When you copy text from, for example, Microsoft Word, and then paste it into another program, such as Mail, you may be pleasantly surprised to note that the formatting of that text—bold, italic, font (size, color, and so on)—appears intact in Mail. You're witnessing one of the Mac's most useful but under publicized features: its support for styled text on the Clipboard.

    Almost all Mac OS X–compatible programs transfer the formatting along with the copied text. Every time you paste formatted text copied from one of these programs, the pasted material appears with the same typographical characteristics it had in the original program. Over time, this tiny timesaver spares us years' worth of cumulative reformatting effort—yet another tiny favor the noble Macintosh does mankind.

    whenever you next copy or cut something, whatever was already on the Clipboard is lost forever.

6.1.2. Drag-and-Drop

As useful and popular as it is, the Copy/Paste routine doesn't win any awards for speed. After all, it requires four steps. In many cases, you can replace that routine with the far more direct (and enjoyable) drag-and-drop method. Figure 6-1 illustrates how this works.

Note: Most Cocoa programs (Section 5.9) require you to press the mouse button for a split second before beginning to drag.

Virtually every Mac OS X program works with the drag-and-drop technique, including TextEdit, Stickies, Mail, Sherlock, QuickTime Player, Preview, iMovie, iPhoto, and Apple System Profiler, not to mention other popular programs like Microsoft applications, America Online, and so on.

6.1.2.1. When to use drag-and-drop

As shown in Figure 6-1, drag-and-drop is ideal for transferring material between windows or between programs—from a Web page into Photoshop, for example. It's especially useful when you've already copied something valuable to your Clipboard, since drag-and-drop doesn't involve (and doesn't erase) the Clipboard.

Figure 6-1. To use drag-and-drop, highlight some material. Click in the middle of the highlighted area; press the mouse button for about half a second. Now, with the button still pressed, drag to another place in the document, into a different window, or into a different application. As your cursor enters the target window, a shaded outline appears inside the window's boundaries—the Mac's way of letting you know that it understands your intention. When you release the mouse, the highlighted material appears instantly in its new location.

Its most popular use, however, is rearranging text within a single document. In Word or Pages, for example, you can rearrange entire sections, paragraphs, sentences, or even individual letters, just by dragging them—a wonderfully efficient editing technique.

Tip: When you use drag-and-drop to move text within a document, the Mac moves the highlighted text, deleting the highlighted material from its original location. If you press Option as you drag, however, you make a copy of the highlighted text.
6.1.2.2. Drag-and-drop to the desktop

You can also use drag-and-drop in the one program you use every single day: the Finder itself. As shown in Figure 6-2, you can drag text, graphics, sounds, and even movie clips out of your document windows and directly onto the desktop. Graphics and movies turn into ordinary graphics or movie files; text becomes an icon called a clipping file.

Figure 6-2. When you drag material out of the document window and onto the desktop, you get a clipping file. Its icon depends on the kind of material contained within: (from top) text clipping, picture clipping, or movie clipping. (For easy identification, Mac OS X conveniently titles text clippings by the first line of the text contained inside.) You can view a clipping just by double-clicking it, so that it opens into its own window (left).

When you drag a clipping from your desktop back into an application window, the material in that clipping reappears. Drag-and-drop, in other words, lets you treat your desktop itself as a giant, computer-wide pasteboard—an area where you can temporarily stash pieces of text or graphics as you work.

Tip: When the material you drag to the desktop contains nothing but an Internet address, such as an email address or Web page URL, Mac OS X gives it a special icon and a special function: an Internet location file. See Section 18.7 for details.

6.1.3. Export/Import

When it comes to transferring large chunks of information—especially address books, spreadsheet cells, and database records—from one program to another, none of the data-transfer methods described so far in this chapter does the trick. For these purposes, use the Export and Import commands found in the File menu of almost every database, spreadsheet, email, and address-book program. (In some programs, the Save As command serves this function.)

These Export/Import commands aren't part of Mac OS X, so the manuals (if any) of the applications in question should be your source for instructions. For now, however, the power and convenience of this feature are worth noting—it means that your four years' worth of collected addresses in, say, some old email program can find its way into a newer program, like Address Book, in a matter of minutes.


moving_data_between_documents.html

Chapter 6. Time Machine, Syncing, and Moving Data

The original 1984 Mac didn't make jaws drop because of its speed, price, or sleek looks. What amazed people most was the simplicity and elegance of the user interface. At some point in every Apple demo, the presenter copied a graphic drawn in a painting program (MacPaint) and pasted it directly into a word processor (MacWrite), where it appeared neatly nestled between typed paragraphs of text.

We take this example of data exchange for granted today. But in those days, that simple act struck people like a thunderbolt. After all, if this little computer let you copy and paste between different programs, it could probably do anything.

Today, the Mac is even more adept at helping you move and share your hard-won data. Mac OS X offers several different ways to move information within a single document, between documents, between different programs, and even between the Mac and Windows computers. This chapter leads you through this broad range of data-exchange mechanisms.

6.1. Moving Data Between Documents

You can't paste a picture into your Web browser, and you can't paste MIDI music information into your word processor. But you can put graphics into your word processor, paste movies into your database, insert text into Graphic Converter, and combine a surprising variety of seemingly dissimilar kinds of data.

6.1.1. Cut, Copy, and Paste

The original copy-and-paste procedure of 1984—putting a graphic into a word processor—has come a long way. Most experienced Mac users have learned to trigger the Cut, Copy, and Paste commands from the keyboard, quickly and without even thinking. Here's how the process works:

  1. Highlight some material in a document.

    Drag through some text in a word processor, for example, or highlight graphics, music, movie, database, or spreadsheet information, depending on the program you're using.

  2. Use the Edit rightwards double arrow Cut or Edit rightwards double arrow Copy command.

    Or press the keyboard shortcuts [image] -X (for Cut—think of the X as a pair of scissors) or [image] -C (for Copy). The Macintosh memorizes the highlighted material, socking it away on an invisible storage pad called the Clipboard. If you chose Copy, nothing visible happens. If you chose Cut, the highlighted material disappears from the original document.

    At this point, most Mac fans take it on faith that the Cut or Copy command actually worked. But if you're in doubt, switch to the Finder (by clicking its Dock icon, for example), and then choose Edit rightwards double arrow Show Clipboard. The Clipboard window appears, showing whatever you're copied.

  3. Click to indicate where you want the material to reappear.

    This may entail switching to a different program, a different document, or simply a different place in the same document.

  4. Choose the Edit rightwards double arrow Paste command ( [image] -V).

    The copy of the material you had originally highlighted now appears at your insertion point—if you're pasting into a program that can accept that kind of information. (You won't have much luck pasting, say, a movie clip into Quicken.)

    The most recently cut or copied material remains on your Clipboard even after you paste, making it possible to paste the same blob repeatedly. Such a trick can be useful when, for example, you've designed a business card in your drawing program and want to duplicate it enough times to fill a letter-sized printout. On the other hand.

    UP TO SPEED
    Styled Text

    When you copy text from, for example, Microsoft Word, and then paste it into another program, such as Mail, you may be pleasantly surprised to note that the formatting of that text—bold, italic, font (size, color, and so on)—appears intact in Mail. You're witnessing one of the Mac's most useful but under publicized features: its support for styled text on the Clipboard.

    Almost all Mac OS X–compatible programs transfer the formatting along with the copied text. Every time you paste formatted text copied from one of these programs, the pasted material appears with the same typographical characteristics it had in the original program. Over time, this tiny timesaver spares us years' worth of cumulative reformatting effort—yet another tiny favor the noble Macintosh does mankind.

    whenever you next copy or cut something, whatever was already on the Clipboard is lost forever.

6.1.2. Drag-and-Drop

As useful and popular as it is, the Copy/Paste routine doesn't win any awards for speed. After all, it requires four steps. In many cases, you can replace that routine with the far more direct (and enjoyable) drag-and-drop method. Figure 6-1 illustrates how this works.

Note: Most Cocoa programs (Section 5.9) require you to press the mouse button for a split second before beginning to drag.

Virtually every Mac OS X program works with the drag-and-drop technique, including TextEdit, Stickies, Mail, Sherlock, QuickTime Player, Preview, iMovie, iPhoto, and Apple System Profiler, not to mention other popular programs like Microsoft applications, America Online, and so on.

6.1.2.1. When to use drag-and-drop

As shown in Figure 6-1, drag-and-drop is ideal for transferring material between windows or between programs—from a Web page into Photoshop, for example. It's especially useful when you've already copied something valuable to your Clipboard, since drag-and-drop doesn't involve (and doesn't erase) the Clipboard.

Figure 6-1. To use drag-and-drop, highlight some material. Click in the middle of the highlighted area; press the mouse button for about half a second. Now, with the button still pressed, drag to another place in the document, into a different window, or into a different application. As your cursor enters the target window, a shaded outline appears inside the window's boundaries—the Mac's way of letting you know that it understands your intention. When you release the mouse, the highlighted material appears instantly in its new location.

Its most popular use, however, is rearranging text within a single document. In Word or Pages, for example, you can rearrange entire sections, paragraphs, sentences, or even individual letters, just by dragging them—a wonderfully efficient editing technique.

Tip: When you use drag-and-drop to move text within a document, the Mac moves the highlighted text, deleting the highlighted material from its original location. If you press Option as you drag, however, you make a copy of the highlighted text.
6.1.2.2. Drag-and-drop to the desktop

You can also use drag-and-drop in the one program you use every single day: the Finder itself. As shown in Figure 6-2, you can drag text, graphics, sounds, and even movie clips out of your document windows and directly onto the desktop. Graphics and movies turn into ordinary graphics or movie files; text becomes an icon called a clipping file.

Figure 6-2. When you drag material out of the document window and onto the desktop, you get a clipping file. Its icon depends on the kind of material contained within: (from top) text clipping, picture clipping, or movie clipping. (For easy identification, Mac OS X conveniently titles text clippings by the first line of the text contained inside.) You can view a clipping just by double-clicking it, so that it opens into its own window (left).

When you drag a clipping from your desktop back into an application window, the material in that clipping reappears. Drag-and-drop, in other words, lets you treat your desktop itself as a giant, computer-wide pasteboard—an area where you can temporarily stash pieces of text or graphics as you work.

Tip: When the material you drag to the desktop contains nothing but an Internet address, such as an email address or Web page URL, Mac OS X gives it a special icon and a special function: an Internet location file. See Section 18.7 for details.

6.1.3. Export/Import

When it comes to transferring large chunks of information—especially address books, spreadsheet cells, and database records—from one program to another, none of the data-transfer methods described so far in this chapter does the trick. For these purposes, use the Export and Import commands found in the File menu of almost every database, spreadsheet, email, and address-book program. (In some programs, the Save As command serves this function.)

These Export/Import commands aren't part of Mac OS X, so the manuals (if any) of the applications in question should be your source for instructions. For now, however, the power and convenience of this feature are worth noting—it means that your four years' worth of collected addresses in, say, some old email program can find its way into a newer program, like Address Book, in a matter of minutes.


exchanging_data_with_other_macs.html

6.2. Exchanging Data with Other Macs

Considering how many ways there are to move files back and forth between Macs, it seems almost comical that anybody complained when Apple discontinued built-in floppy disk drives. For one thing, you can almost always email the file to someone— even to yourself! And there are plenty of other ways to move files around.

6.2.1. By Network

With about $50 worth of equipment (or $200, if you want to go wireless), you can connect your Macs together into a network. Once you're done so, you can keep an icon for each Mac's hard drive on your screen. You can open files from the other drives, copy stuff back and forth—anything you would do with your own disk.

Step-by-step instructions are in Chapter 13.

6.2.2. By CD or DVD

You can always burn your files onto a blank CD or DVD and then carry it to the other machine. You'd use this approach when, for example, you have a lot of data to copy, but the two Macs aren't within networking range; for example, they're not in the same room or the same city.

6.2.3. FireWire Disk Mode (Target Disk Mode)

FireWire Disk Mode is a brilliant but little-known, Macintosh-only feature that lets you turn one Mac into an external hard drive for another. This is by far the fastest method yet for transferring a lot of data—even faster than copying files over a network. It's extremely useful in any of these situations:

  • You're traveling with a laptop. You want to copy your life onto it from your main Mac, including your entire 2 GB email folder and project files, before taking it on a trip, and then unload it when you return.

  • You have a new Mac. You want to copy everything off the old one, without having to wait all night.

  • One Mac won't start up. You want to repair it, using another Mac as a "front end."

In the following steps, suppose your main Mac is an iMac, and you want to use a MacBook as an external hard drive for it.

  1. Using a FireWire cable, connect the FireWire jacks of both computers.

    For this trick, you need a 6-pin FireWire cable—not the one that connects a camcorder to a Mac. The one you need has the same, large connector on both ends.

    Note: If both Macs have Apple's FireWire 800 jacks, use a 9-pin FireWire cable instead for much greater speed. If only one Mac has a FireWire 800 jack, use that computer's traditional FireWire 400 connector instead. Otherwise, you need either a special FireWire 800–to–FireWire 400 cable, or the 400-to-800 adapter that came with your Mac.

  2. On the MacBook, choose [image] rightwards double arrow System Preferences. Click Startup Disk.

    The Startup Disk panel opens.

  3. Click Target Disk Mode. In the confirmation box, click Restart.

    The MacBook turns off, then on again. A giant, yellow, FireWire icon ( [image])bounces around the laptop screen.

    Now take a look at the iMac's screen: Sure enough, there's the MacBook's hard drive icon on the desktop. You're ready to copy files onto it or off it, at extremely high speeds, and go on with your life.

  4. When you're finished working with the MacBook, eject it from the iMac's screen as you would any disk. Then turn off the laptop by pressing the power button.

    The next time you turn on the MacBook, it'll start up from its own copy of Mac OS X, even if the FireWire cable is still attached. (You can disconnect the cable whenever you please.)

Note: The steps above describe the Leopard method of setting up Target Disk Mode. But the old way still works, too.Leave the iMac turned on, but shut down the MacBook. (Make sure it's plugged in. You wouldn't want the battery to die in the middle of this process.) Now turn the MacBook on again, but hold down the T key immediately after the chime. After a moment, you see the big yellow Y-shaped FireWire icon on the laptop screen, and the laptop's hard drive shows up on the iMac's desktop. Continue from step 4 above.This method is arguably quicker, because you don't have to open up System Preferences. But it's also more of a pain, because you have to babysit the laptop so that you don't miss the critical T-key moment.

6.2.4. Via the iPod

An iPod is an extremely fine music player with enormous capacity. That's because it contains an actual hard drive that stores the songs.

But because the modern iPod has a USB connector, it makes a dandy portable hard drive for everyday files, too—not just music.

To set the iPod up for data transfer, proceed like this:

  1. Connect the iPod to your Mac with its USB cable or dock.

    Use the white one that came with the iPod. (If this is the first time you've done this, the iTunes Setup Assistant may appear, offering you the chance to name your iPod.)

  2. Open iTunes. Click the iPod icon in the left-side Source list.

    The iPod Preferences window appears.

  3. Turn on "Enable disk use."

    A dialog box warns you that even when you're just syncing up your music collection (and not using the iPod as a hard drive for files), you have to manually eject the iPod after each use.

  4. Click OK, and then OK again.

    After a moment, you see the iPod's icon appear on your desktop.

    Now you've got yourself a multi-gigabyte external hard drive. Just drag your files onto or off the iPod icon, exactly as though it's a disk (which it is). The iPod automatically keeps your data files separate from your music files; your files won't be touched when you update your music collection from iTunes.

    Whenever you're finished using the iPod as a hard drive, eject it in any of the usual ways. For example, drag its icon to the Trash, or Control-click it and choose Eject from the contextual menu.

6.2.5. Via Flash Drive

A flash drive, also called a thumb drive, is a tiny keychain-like doodad that plugs into your USB port. Inside is little more than a big chunk of RAM (memory) that acts like a miniature hard drive. When the flash drive is plugged into your Mac, its icon shows up on the desktop as a disk. Use it as a tiny, 8-gigabyte hard drive (or whatever size you've bought).

The beauty of a flash drive is that it works instantly and automatically with any Mac or any Windows machine, without any software installation or configuration. It's small and light enough to carry around on your keychain…and it's so darned cool. If you regularly transfer documents between Macs or between Macs and PCs, a flash drive will change your life.

6.2.6. Via Bluetooth

Bluetooth is a long-delayed, but promising, cable-elimination technology. It's designed to let Bluetooth-equipped gadgets communicate within about 30 feet, using radio signals.

Already you can get Bluetooth—either built in or as a slide-in cartridge—for computers, printers, Palm and PocketPC organizers, Sony camcorders, and so on. Apple's wireless keyboard and mouse both rely on Bluetooth. Even some phones have built-in Bluetooth transmitters.

Bluetooth comes built into Mac laptops and iMacs, and can be ordered built into Mac Pro models. Once your Mac is equipped, you can sync with a Bluetooth-equipped Palm organizer, use a Bluetooth cell phone as a modem to get you online, use the Apple wireless keyboard or mouse—and transfer files through the air to similarly equipped gear.

Bluetooth isn't especially fast—in fact, it's pretty darned slow.(You get transfer speeds of 30 to 50 K per second, depending on the distance.) But when you consider the time you'd have taken for wiring, passwords, and configuration using any other connection method, you may find that Bluetooth wins, at least in casual, spur-of-the-moment, airport-seat situations.

And when you consider that Bluetooth works no matter what the operating system— Mac, Windows, Palm, Pocket PC—you can see that it has tremendous potential as a universal file-exchange translator, too.

Note: For more detail on configuring your Mac for Bluetooth connections, see Section 6.2.5.
6.2.6.1. Sending a file

To shoot a file or two across the airwaves to a fellow Bluetooth-equipped Mac fan, proceed like this:

  1. Open System Preferences. Click the Bluetooth icon.

    This panel appears in System Preferences only if you do, in fact, have a properly installed Bluetooth adapter.

  2. Adjust the Settings tab as shown at top in Figure 6-3.

    Discoverable means "Other Bluetooth gadgets can see me."

  3. Close System Preferences. From the Bluetooth menulet (Figure 6-3, bottom), choose Send File.

    After a moment, the Select File to Send dialog box appears. (You've actually succeeded in opening a program called Bluetooth File Exchange, which sits in your Applications rightwards double arrow Utilities folder.)

  4. Navigate to, and select, the files you want to send.

    If you're trying to send a bunch of them, you may find it easier to drag their icons onto the Bluetooth File Exchange icon in your Dock.

    Either way, a new Send File dialog box appears.

  5. Click Search.

    The Bluetooth software scans the airwaves in search of other Bluetooth-equipped machines. (They, too, must be in Discoverable mode, by the way.)

  6. In the list of found machines, click the name of the one you want to send your files to, and then click Send.

    What happens now, on the receiving end, depends on how the receiving Mac has been set up (Figure 6-4, top). In most cases, a dialog box tells the receiver that

    Figure 6-3. Top: Make sure that Discoverable is turned on. If a device (like your Mac) isn't in "discoverable" mode, then no other Bluetooth gizmos can see it. You get plenty of privacy, but no productivity. While you're at it, by the way, turn on "Show Bluetooth status in the menu bar."
    Bottom: The Bluetooth menulet makes it quick and easy to shoot a file to another person (Mac or Windows) who's blessed (or shrewd) enough to have a Bluetooth-equipped machine.

    files are arriving; if he clicks Accept, the download proceeds. He's then offered the chance to either (a) open the transferred file or (b) reveal its highlighted icon in the Finder.

    When you send files to a Windows PC or some other gadget using this method, security may be tighter. You may be asked to make up a temporary, one-time password that must be typed into both your Mac and the receiving device within, say, 1 minute, to prove that this transfer is authorized.

6.2.7. Fetching a File

Using the Send a File command in the Bluetooth menulet is a quick and satisfying way to transfer a file—but it's not the only way. You can also perform this entire

Figure 6-4. You can control what happens when someone sends you files via Bluetooth. Usually, you'll want your Mac to ask you whether or not to accept these files. (That's what the option "Ask What to Do" means.) You can also specify where you want received files to wind up—for example, in your Downloads folder.
Middle: When you choose Browse Files from the Bluetooth menulet ( ), this box appears, listing all discoverable Bluetooth machines within range.
Bottom: Once you're looking at the contents of your buddy's Bluetooth shared folder, you can either click a file name and click Get, or you can just drag the file out of the dialog box and onto your desktop.

procedure in reverse. That is, you can go fishing through your buddies' files without them explicitly having to send anything.

To make a Mac invadable, the person to be invaded must turn on the Bluetooth File Transfer checkbox on the Sharing tab of the Bluetooth System Preferences, and indicate which folder contains the files to be shared.

Then all you have to do is choose Browse Device from your own menulet (Figure 6-3)—and let the rummaging begin (Figure 6-4, bottom)!


exchanging_data_with_windows_pcs.html

6.3. Exchanging Data with Windows PCs

It's no surprise that the Mac is great at transferring information among Mac programs. The big news is how easy Mac OS X makes it to transfer files between Macs and Windows computers.

Documents can take one of several roads between your Mac and a Windows machine; many of these methods are the same as Mac-to-Mac transfers. For example, you can transfer a file on a disk (such as a CD or Zip disk), on a flash drive, via network, by Bluetooth, on an iPod, as an attachment to an email message, via Web page, as an FTP download, and so on. The following pages offer some pointers on these various transfer schemes.

6.3.1. Preparing the Document for Transfer

Without special adapters, you can't plug an American appliance into a European power outlet, play a CD on a cassette deck, or open a Macintosh file in Windows. Therefore, before sending a document to a colleague who uses Windows, you must be able to answer "yes" to both of the questions below.

6.3.1.1. Is the document in a file format Windows understands?

Most popular programs are sold in both Mac and Windows flavors, and the documents they create are freely interchangeable. For example, documents created by recent versions of Word, Excel, PowerPoint, FileMaker, Free Hand, Illustrator, Photoshop, Dreamweaver, and many other Mac programs don't need any conversion. The corresponding Windows versions of those programs open such documents with nary a hiccup.

Files in one of the standard exchange formats don't need conversion, either. These formats include JPEG (a photo format used on Web pages), GIF (a cartoon/logo format used on Web pages), HTML (raw Web page documents before they're posted on the Internet), Rich Text Format (a word-processor exchange format that maintains bold, italic, and other formatting), plain text (no formatting at all), QIF (Quicken Interchange Format), MIDI files (for music), and so on.

But what about documents made by Mac programs that don't exist on the typical Windows PC hard drive, like Keynote or Pages? You certainly can't count on your recipient having it.

Do your recipients the favor of first saving such documents into one of the formats listed in the previous paragraphs. In Pages, for example, choose File rightwards double arrow Save As; from the File Type pop-up menu, choose "Word Win 97, 2000." Now name this special version of the document (remember the .doc suffix), and then click Save.

6.3.1.2. Does the file have the correct filename suffix?

As noted in Chapter 5, every document on your hard drive has some kind of tag to tell the computer what program is supposed to open it: either a pair of invisible four letter codes or a filename suffix like .doc.

Microsoft Windows uses only the latter system for identifying documents. Here are some of the most common such codes:

Kind of document | Suffix | Example
Microsoft Word (old) | .doc | Letter to Mom.doc
Microsoft Word (latest) | .doc x | Letter to Mom.docx
Excel | .xls or .xlsx | Profit Projection.xls
PowerPoint | .ppt | Slide Show.ppt
JPEG photo | .jpg | Baby Portrait.jpg
GIF graphic | gif | Logo.gif
Web page | .htm | index.htm

The beauty of Mac OS X is that most programs add these file name suffixes automatically and invisibly, every time you save a new document. You and your Windows comrades can freely exchange documents without ever worrying about this former snag in the Macintosh/Windows relationship.

6.3.2. Notes on Disk Swapping

Once you've created a document destined for a Windows machine, your next challenge is to get it onto that machine. One way is to put the file on a disk—a CD you've burned, for example—which you then hand to the Windows user.

Fortunately, although Windows can't read Mac disks, the Mac can read (and create) Windows-compatible disks. When you insert a Windows-formatted CD into your Mac, its icon appears onscreen just like a Mac disk. You can drag files to and from this disk (or its window) exactly as though you're working with a Mac disk (only slower).

6.3.2.1. Creating a Windows disk on the Mac

You can even create a Windows disk on your Macintosh. CDs and DVDs that you burn on the Mac, for example, are Windows compatible right out of the gate. Chapter 11 has details on disc burning.

6.3.3. Network Notes

Mac OS X can "see" shared disks and folders on Windows PCs that are on the same network. Complete instructions are in Chapter 13.

6.3.4. Via the Internet

Chapter 22 offers details on FTP and Web sharing, two ways to make your Mac available to other computers—Windows PCs or not—on the Internet.


time_machine.html

6.4. Time Machine

As the old saying goes, there are two kinds of people: those who have a regular backup system—and those who will.

You'll get that grisly joke immediately if you've ever known the pain that comes with deleting the wrong folder by accident, or making changes that you regret, or worst of all, having your hard drive die. All those photos, all that music you've bought online, all your email—gone.

Yet the odds are overwhelming that at this moment, you do not have a complete, current, automated backup of your Mac. Despite about a thousand warnings, articles, and cautionary tales a year, guess how many do? About four percent. Everybody else is flying without a net.

If you don't have much to back up—you don't have much in the way of photos, music, or movies—you can get by with burning copies of stuff onto blank CDs or DVDs (Chapter 11) or using the .Mac Backup program described at the end of this chapter. But those methods leave most of your Mac unprotected: all your programs and settings, not to mention Mac OS X itself.

What you really want, of course, is a backup that's rock-solid, complete, and automatic. You don't want to have to remember to do a backup, to insert a tape, to find a cartridge. You just want to know that you're safe.

That's the idea behind Time Machine, a marquee feature of Leopard. It's a silent, set it-and-forget-it piece of peace of mind. You sleep easy, knowing there's a safety copy of your entire system: your system files, programs, settings, music, pictures, videos, document files—everything.

Yes, Time Machine has a fabulous, gorgeous, sci-fi, space-themed recovery mode, where it looks like you're flying back in time to retrieve files, folders, or disks from the past. With luck, you'll never need it. But if your luck runs out, you'll be so happy you set Time Machine up.

6.4.1. Setting up Time Machine

Here's the bad news: Time Machine requires a second hard drive. That's the only way to create a completely safe, automatic backup of your entire main hard drive.

That second hard drive can take any of these forms:

  • An external USB or FireWire hard drive.

  • Another internal hard drive.

  • A partition of any one of those drives.

The hard drive of another Leopard Mac on the network. You must first mount its drive on your screen (Chapter 13).

Tip: It's perfectly OK to back up several Macs onto the same external hard drive, as long as it's got enough room. You can also back up onto a hard drive that has other stuff on it, although of course that means you'll have less room for Time Machine backups.

In all cases, the backup disk must be bigger than the drive you're backing up (preferably much bigger).

Here's what you can't use as the backup disk:

  • An iPod.

  • The iDisk.

  • Your startup drive.

  • CDs, DVDs, flash drives, or any other kind of removable disk.

Note: If Time Machine doesn't recognize the drive you've given it, the drive might not be a standard Mac-formatted hard drive. That's a gotcha that befalls many a Mac fan who buys a new hard drive for backup purposes; many new drives come in Windows format, which Time Machine doesn't recognize.To make a new, empty drive like this ready for Time Machine, open Disk Utility (Section 10.30.9). Click the drive's name, click the Erase tab, choose Mac OS Extended (Journaled) from the Volume Format pop-up menu, and then click Erase.

Sure, it sounds like an Apple plot to sell more hard drives. But you'd be surprised at how cheap hard drives are. At this writing, you can buy a 300-gigabyte internal hard drive for under $90, for goodness' sake, or an external 500-gig drive for $125—and hard drive prices-per-gigabyte only go down.

The first time the Mac sees your second hard drive, it invites you to use it as Time Machine's backup drive (Figure 6-5, top). That could be the moment you connect an external USB or FireWire drive, or the first time you turn on the Mac after installing an internal drive.

If you click Use as Backup Disk, you're taken immediately to the Time Machine pane of System Preferences (Figure 6-6, bottom). It shows that Time Machine is now on, your backup disk has been selected, and the copying process has begun. The Mac copies everything on your hard drive, including Mac OS X itself, all your programs, and everyone's Home folders.

Note: Time Machine doesn't use any compression or encoding; it's copying your files exactly as they sit on your hard drive, for maximum safety and recoverability. On the other hand, it does save some space on the backup drive, because it doesn't bother copying cache files, temporary files, and other files you'll never need to restore.

Your total involvement has been one click. And that, ladies and gentlemen, is the easiest setup for a backup program in history.

Now go away and let the Mac do its thing. The first backup can take a very long time— hours—as the Mac duplicates your entire internal hard drive onto the second drive. The Mac may feel drugged during this time.

Figure 6-5. Top: The Mac has just encountered a second hard drive. Time Machine still works if there's other stuff on the drive, but life is simpler if you don't use that drive for anything but Time Machine. The more space Time Machine has to work with, the farther back in time you'll be able to go to recover deleted or mangled files.
Bottom: The backup has begun. You know that because you see both a progress message and the symbol that appears next to the backup drive's name in your Sidebar.

6.4.2. How the Backups Work

From now on, Time Machine quietly and automatically checks your Mac once per hour. If any file, folder, or setting changes, it gets backed up at the end of the hour. These follow-up backups, of course, take very little time, since Time Machine backs up only what's changed.

So, should disaster strike, the only files you can lose are those that you've changed within the last 59 minutes.

Tip: And even then, you can force more frequent backups if you want to. Any time you want Time Machine to update its backup before the hour's up, Control-click (or right-click) Time Machine's icon on the Dock. From the shortcut menu, choose Back Up Now.You can pause the backup the same way—if you need to use the backup drive for another quick task, for example. Control-click the Dock icon and then choose Stop Backing Up. (Don't forget to turn the backing-up on again when you're finished.)

By the end of the day, you'll have 24 hourly backups on that second disk, all taking up space. So at day's end, Time Machine replaces that huge stash with a single daily backup. You can no longer rewind your system to 3:00 p.m. last Monday, but you can rewind to the way it was at the end of that day.

Similarly, after a week, the dailies are replaced by an end-of-week backup; after a month, the weeklies are replaced by a single end-of-the-month backup. Now you can't rewind to October 24, but you can rewind to November 1. (Apple assumes that it won't take you a whole month to notice that your hard drive has crashed.)

Tip: You can see these backups, if you want. Open your backup drive, open the Backups.backupdb folder, and open the folder named for your computer. Inside, you'll find a huge list of backup folders, bearing names like 2007-12-22-155831. That's the backup from December 22, 2007 at 15:58 (that is, 3:58 p.m.) and 31 seconds.

The point is that Time Machine doesn't just keep one copy of your stuff. It keeps multiple backups. It remembers how things were in every folder—not just yesterday, but last week, last month, and so on. It keeps on making new snapshots of your hard drive until the backup drive is full.

At that point, the oldest ones get deleted to make room for new ones.

FREQUENTLY ASKED QUESTION
The End of Time

What happens when my backup drive gets full?

Good question.

The whole idea of Time Machine is that it preserves multiple backups, so that you can rewind a window or a drive not just to a backup, but to any date in the past. The bigger the hard drive, the farther back those monthly backups are preserved.

Eventually, of course, your backup drive runs out of space. At that point, Time Machine notifies you and offers you a choice.

You can keep using that drive; Time Machine will begin deleting the oldest backups to make room for newer ones.

Or you can install a new Time Machine backup drive. New backups will go on that one; your older backups will still be available on the original drive.

If you ever need to retrieve files or folders from the older disk, Control-click (right-click) the Time Machine icon in the Dock; from the shortcut menu, choose Browse Other Time Machine Disks. In the list of disks, choose the older one. Then click the Time Machine icon on the Dock to enter the Restore mode.

Tip: Ordinarily, Time Machine alerts you when it has to start deleting old backups. If you'd rather have it just do it without bothering you, open System Preferences; click Time Machine; click Options; and finally turn off "Warn when old backups are deleted."

By the way, if a backup is interrupted—if you shut down the Mac, put it to sleep, or take your laptop on the road—no big deal. Time Machine resumes automatically the next time you're home and connected.

6.4.3. Changing Time Machine Settings

Time Machine has three faces in Leopard. There's the application itself, which sits in your Applications folder; click it to enter Restore mode. There's its Dock icon; its shortcut menu has a few commands (like Back Up Now) that aren't available anywhere else.

And then there's its System Preferences pane, where you adjust its settings (Figure 6-6). To see it, choose [image] rightwards double arrow System Preferences, and then click Time Machine. Or choose Time Machine Preferences from Time Machine's Dock icon.

Tip: If your information is especially important, or if you're especially paranoid, you can rotate among more than one backup hard drive. Keep one offsite so you won't be hosed in case of fire, flood, or burglary.

Figure 6-6. Use the big On/Off switch to shut off all Time Machine activity, although it would be hard to imagine why you'd want to risk it. You can click Choose Backup Disk to choose a different hard drive to represent the mirror of your main drive (after the first one is full, for example).

6.4.4. Recovering Lost or Changed Files

All right, you've got Time Machine on the job. You sleep easy at night, confident that your life's in order—and your stuff 's backed up.

Then, one day, it happens: Your hard drive crashes. Or you can't find a file or folder you know you had. Or you save a document and then wish you could go back to an earlier draft. Some kind of disaster—sunspots, clueless spouse, overtired self—has befallen your files.

This is Time Machine's big moment.

Start by pinpointing what you're looking for, in one of these two ways:

  • Open the disk or folder window where the missing or changed item was

    POWER USERS' CLINIC
    Declaring Stuff Off-Limits to Time Machine

    The whole point of Time Machine, of course, is to have a backup of your entire hard drive. That's how most people use it.

    It's conceivable, though, that you might want to exclude some files or folders from the Time Machine treatment. There are two reasons.

    First, you might not want certain, ahem, private materials to be part of your incriminating data trail.

    Second, you might want to save space on the backup drive, either because it's not as big as your main drive or because you'd rather dedicate its space to more backups of the essential stuff. For example, you might decide not to back up your collection of downloaded TV shows, since video files are enormous. Or maybe you use an online photo-sharing Web site as a backup for all your photos, so you don't think it's necessary to include those in the Time Machine backup.

    To eliminate certain icons from the backup, open the Time Machine panel of System Preferences. Click Options.

    In the resulting list, click the + button; navigate your hard drive, and then select the files or folders you don't want backed up. Or just find their actual icons in the Finder and drag them into the list here. (Use the – button to remove items from the list, thereby excluding them from the excluded list.)

    If you're strapped for disk space, one logical candidate to exclude is the System folder on your main hard drive—that is, Mac OS X itself. After all, if you lose your hard drive, you already have a copy of Mac OS X: the original installation DVD. (Of course, it doesn't have all the Apple updates that may have come out since the original version.)

    When you add the System folder to the exclusion list, Time Machine makes another space-saving offer: "Would you like to also exclude other files installed with Mac OS X, such as system applications and UNIX tools?"

    Agreeing (by clicking Exclude All System Files) saves you another several gigabytes of backup space.

  • Type what you're looking for into the Search box at the top of any Finder window. Click the location button that makes the most sense: "This Mac" or the name of the window you're in.

In the case of deleted files or folders, the search will probably come up empty; that's totally OK.

Now click the Time Machine icon on the Dock (or in the Applications folder). Don't look away; you'll miss the show.

Your Leopard desktop slides down the screen like a curtain that's been dropped from above. And it reveals…outer space. This is it, the ultimate Apple eye candy: an animated starry universe, with bits of stardust and meteors occasionally flying outward from the massive nebula at the center.

Front and center is your Finder window—or, rather, dozens of it, stretching back in time (Figure 6-7). Each is a snapshot of that window at the time of a Time Machine backup.

You have four ways to peruse your backup universe:

  • Click individual windows to see what's in them.

  • Drag your cursor through the timeline at the right side. it's like a master dial that flies through the windows into the past.

  • Click one of the two big, flat, perspective arrows. The one pointing into the past means "Jump directly to the most recent window version that's different from the way it is right now."

    In other words, it's often a waste of time to go flipping through the windows one at a time, because your missing or changed file might have been missing or changed for the last 25 backups (or whatever). What you want to know is the last time the contents of this window changed. And that's what the big flat arrows do. They jump from one changed version of this window to another. (Or, if you began with a search, the arrow takes you to the most recent version backup with a matching result.)

  • Use the Search box in the corner of the window. You can search for whatever you're missing in the current backup.

As you go, the very bottom of the screen identifies where you are in time—that is, which backup you're examining.

In many ways, the recovery mode is just like the Finder. You can't actually open, edit, rename, or reorganize anything here. But you can use Quick Look(page58)to inspect the documents, to make sure you've got the right version. And you can use icon, list, or Cover Flow view, as well as column view, to sort through the files you're seeing.

If you're trying to recover an older version of a file or folder, highlight it, and then click the flat arrow button that's pointing away from you; Time Machine skips back to the most recent version that's different from the current one.

If you're trying to restore a deleted file or folder that you've now located, highlight it, and then click Restore (lower-right). The Leopard desktop rises again from the bottom of the screen, there's a moment of copying, and then presto: The lost file or folder is back in the window where it belonged.

Figure 6-7. This is the big payoff for all your efforts.
Top: The familiar desktop slides down, dropping away like a curtain. For the first time, you get to see what's been behind the desktop all this time. Turns out it's outer space.
Bottom: Time Machine shows you dozens of copies of the Finder window, representing its condition at each backup, stretching back to the past.

Note: Time Machine prides itself not just on recovering files and folders, but also on putting them back where they belonged.If you recover a different version of something that's still there, Mac OS X asks if you want to replace it with the recovered version.And if you're recovering a document whose original folder no longer exists, Time Machine automatically recreates the folder so that the recovered item feels at home.
6.4.4.1. Recovering from iPhoto, Address Book, and Mail

It turns out that the Finder isn't the only program that's hooked into Time Machine's magic. iPhoto '08, Address Book, and Mail work with Time Machine, too. Other software companies can also revise their own applications to work with it.

In other words, if you want to recover certain photos, addresses, or email messages that have been deleted, you don't start in the Finder; you start in iPhoto, Address Book, or Mail.

Then click the Time Machine icon on the Dock. Once again, you enter the starry recovery mode—but this time, you're facing a strange, disembodied, stripped-down copy of iPhoto, Address Book, or Mail (Figure 6-8).

Tip: Alternatively, in iPhoto, you can also choose File rightwards double arrow Browse Backups to enter recovery mode.

Figure 6-8. The Time Machine version of iPhoto is a weird, simplified, viewing-only version. You can't do much here besides browse your backups— but when you're in dire straits, that's enough.

You're ready to find your missing data. Click the Jump Back arrow to open the most recent version of your photo library, address book file, or email stash that's different from what you've got now. (You can also use the timeline on the right if you remember the date when things went wrong.)

Tip: If you're looking for something particular, specify that before you start clicking. For example, select the iPhoto event or album first, or type a name into the Address Book search box.

At this point, you can select individual photos (or albums, or events), address book entries, or email messages to restore; just click the Restore button.

Often, though, you'd rather reinstate the entire iPhoto library, Address Book file, or email collection from the backup. That's what the Restore All button is for.

If you click it, the experience is slightly different. iPhoto asks if you're sure you want to replace your iPhoto library. Address Book may discover a lot of duplicate name and-address entries, and invite you to step through them, deciding which one "wins" (the old or the new).

Note: When you finish restoring in Mail, you'll find the restored messages in the On My Mac rightwards double arrow Time Machine rightwards double arrow Recovered folder at the left side of the window.
6.4.4.2. Recovering the entire hard drive

Every hard drive will die at some point. You just hope it won't happen while you own the computer.

But the great gods of technology have a mean-spirited sense of humor, and hard drives do die. But you, as a Time Machine aficionado, won't care. You'll just repair or replace the hard drive, and then do this:

  1. Connect the Time Machine backup disk to the Mac. Insert the Leopard installation DVD. Double-click the Install Mac OS X icon.

    The Mac OS X installer opens up as though it's going to lead you through the process of putting Leopard on the new, empty hard drive. But don't fall for it.

  2. At the Welcome screen, choose Utilities rightwards double arrow Restore System from Backup.

    The Restore Your System dialog box appears.

  3. Click Continue.

    Now you're shown a list of Time Machine backup disks. You probably have only one.

  4. Click your Time Machine backup disk. In the list of backups, click the most recent one.

    The installer goes about copying everything from the backup disk onto your new empty hard drive. When it's all over, you'll have a perfect working system, just the way it was before your series of unfortunate events.

Tip: You can use these steps to rewind to a previous version of Mac OS X 10.5, too—for example, after you install an Apple software update (10.5.2, say) and discover that it "breaks" a favorite program.Beware, however: Restoring your earlier version also erases any files that you've created or changed since you've installed the update. Back them up manually before you proceed!Then follow the steps above; when you're asked to choose a backup to restore, choose the most recent one. When it's all over, copy the latest files (the ones that you manually backed up) back onto the hard drive.
6.4.4.3. Recovering to another Mac

Weirdly enough, you can also use Time Machine as a glorified data bucket that carries your world from one computer to another. You can bring over some or part of any Time Machine backup to a totally different Mac.

On the new machine, connect your backup disk. In the Applications rightwards double arrow Utilities folder, open the program called Migration Assistant. On the first screen, click "From a Time Machine backup." The subsequent screens invite you to choose which backup, which Home folder, and which elements (applications, settings, files) you want to bring over. (You can use the Leopard installation DVD for this purpose, too, as described above.)

6.4.5. Frequently Asked Questions

Time Machine is a very different kind of backup program, and a real departure for longtime Mac addicts. A few questions, therefore, are bound to come up—like these.

  • Can I back up more than one Mac onto the same disk? Yes. Each Mac's backup is stored in a separate folder on that disk.

  • Does the backup disk have to be dedicated to Time Machine? No. It can have other files and folders on it. Keep in mind, though, that the more space is available, the farther back your backup trail can go.

UP TO SPEED
.Mac Backup

Time Machine is by far the most complete, effortless, automatic, safe way to keep your data life safe.

There's an older method, though, one that's available only to members of .Mac, Apple's $100-a-year suite of Internet services.

.Mac membership includes access to a program called Backup, which can give you another automatic backup system for a subset of your files—your most important files.

The beauty of this method is that the backup is offsite, so (unlike Time Machine) it's safe even if fire, flood, or burglary destroys your backup drive.

If you're interested in this oddball little program, consult the free downloadable PDF appendix to this chapter, called ".Mac Backup." It's available on this book's "Missing CD" page at www.missingmanuals.com.

  • Can I use more than one back up disk—like one at the office and on eat home? Yes. Just use the Time Machine panel of System Preferences (or the Time Machine Dock icon's shortcut menu) to select the new backup drive each time you switch.

  • Can I delete something for good, from all the back ups at once? Yes. Click the Time Machine icon on the Dock to enter the Restore (outer-space) mode. Find and select the file or folder you want to obliterate. From the [image] menu, choose Delete From All Backups. (Sneaky, huh? That command is never in the [image] menu except when you're in Time Machine restoring mode.)

  • Can Time Machine back up other hard drives besides the main internal one? Yes. Open System Preferences rightwards double arrow Time Machine. Click Options. Your secondary drives are listed here on the excluded-items list. If you want them backed up too, remove them from the list (click the drive name and then click the – button.)

  • Anything else you want to get off your chest? Yes. Time Machine has trouble with three kinds of files:

First, File Vault (Section 12.9.2). If you've encrypted your Home folder using File Vault, Time Machine can back up only your Home folder only when you've logged out. And when things go wrong, it can recover only your entire Home folder (not individual files or folders). It scarcely seems worth the trouble.

Second, Aperture. Turn off Time Machine backing-up while you're working in Aperture, Apple's professional photo-organizing program.

Finally, remember that Time Machine backs up entire files at a time—not pieces of files. If you edit huge, multigigabyte files like video files, therefore, keep in mind that each giant file gets recopied to the backup drive every time you change it. That is, one 2-gig video file that you work on all day could wind up occupying 48 gigabytes on the backup drive by the end of the day. Consider adding these files to the exclusion list, as described above.


isync.html

6.5. iSync

If Apple ever had evidence to back up its "digital hub" hype, iSync is it.

This attractive, simple program is designed to keep the calendars and phone lists on your various computers, Palm organizer, cell phone, and even your iPod in perfect synchronization, sparing you the headache of the modern age: inputting the same information over and over again. (See Figure 6-9.)

Here's what it can sync:

  • A cell phone. iSync can keep your cell phone and Mac up to date with each other's calendar, Address Book, and to-do list, either via a USB cable or wirelessly, using Bluetooth. It requires a certain amount of technical setup (creating a phone profile, pairing the phone with your Mac, opening iSync, choosing Device rightwards double arrow Add Device, and finally selecting the phone). You'll find detailed instructions in the iSync Help screens.

    Tip: Apple lists phones that are officially compatible with this feature at http://www.apple.com/iSync/devices.html. (Hint: They're mostly Nokia, Motorola, Samsung, and Sony erickson phones.) If your phone isn't on The List, don't miss www.taniwha.org.uk, a Web page that's loaded with drivers and installation instructions for specific phone models.

    Figure 6-9. Top: For each gadget, you can specify which iCal calendar categories you want to sync, which contacts, and so on.
    Bottom: The Safeguard window warns you about exactly how many changes you're about to make. (You can turn off this confirmation box in the iSync rightwards double arrow Preferences dialog box.) You can also revert your setup to the last sync, or back up all your data, using commands in the Devices menu.
    Even with all these safeguards, synchronization can be a tricky business. Just remember never to sync a device with more than one Mac. Similarly, sync only one of each device type (phone, Palm, or iPod) with a certain Mac. Otherwise, iSync may get hopelessly confused as to what's most current.

  • An iPod. iTunes, not iSync, now handles the task of keeping your iPod updated with your iCal and Address Book info. To get started, connect the iPod to the Mac, and then click the Info tab. There, you'll find syncing options for your calendar and Address Book. After the next sync, you'll be able to consult your little black book on your little white block.)

  • A Palm organizer. iSync can sync iCal and Address Book with a Palm-compatible organizer. It doesn't do the work itself; it relies, behind the scenes, on Palm's own HotSync software, which must be installed and properly configured beforehand.

Once that's done, open HotSync Manager in your Palm folder. Choose HotSync rightwards double arrow Conduit Settings. Double-click the item named iSync, and then turn on "Enable iSync for this Palm device."

Click OK, and then quit HotSync Manager. You've just told Palm's own syncing software to butt out. From now on, iSync handles syncing your Mac's info with its Address Book, Date Book, and To Do List. (To edit and sync Notes, you still need Palm Desktop.)

Finally, in iSync, use the Devices rightwards double arrow Add Device command to make iSync "see" your Palm, which you've put into its cradle, attached to its cable, or (if it's a Bluetooth Palm) made it discoverable. To start the sync, click iSync's Sync Now button.

When you open iSync, its toolbar shows the icons of any synchable devices connected to your Mac at the moment. Click an icon on the toolbar—your cell phone, for example—to see the syncing options available. Turn on the check boxes you want, and then click the Sync Now button. After asking what you want to do with each kind of data—"This is the first time you're syncing your book marks. What do you want to do for this sync? (Merge, Keep, Erase?)"—iSync does the deed.

Tip: In iSync, choose iSync rightwards double arrow Preferences and then turn on "Show iSync in menu bar." From now on, you can get the syncing under way by choosing Sync Now from the yin-yang arrow menulet on your menu bar.

iSync is smart when it comes to resolving conflicts among your gadgets. For example, if you edit somebody's home phone number on your Palm, and your spouse simultaneously edits the same person's office number on the Mac, iSync smoothly incorporates both changes into all copies of your address book. Unless you and your spouse both change the home number in different ways; then iSync presents a Resolve Conflicts button. Click it, and choose which info you believe should prevail.


mac_sync.html

6.6. .Mac Sync

This chapter has covered a lot of ways to shuttle files around: back and forth in time, back and forth to other gadgets. But finally, here's a goody reserved for people who pay $100 a year for a .Mac account (Section 18.6): shuttling data back and forth to other Macs.

In System Preferences, a humble preference pane called .Mac lets you set up automatic syncing between Macs, using the Internet as a conduit to transfer data tidbits like these:

  • Safari Bookmarks. If a Web site is important enough to merit bookmarking while you're using your laptop, why shouldn't it also show up in the Bookmarks menu on your desktop Mac at home?

  • Calendars, Contacts. This is a big one. There's nothing as exasperating as realizing that the address book you're consulting on your home Mac is missing somebody you're sure you entered—on your Mac at work. This option keeps all your Macs' Address Books and iCal calendars synchronized. Delete a phone number at work, and you'll find it deleted on your Mac at home, too.

  • Dashboard Widgets. Now the configuration and setup of your widgets on Mac A are synced to Macs B, C, and D, so they all match.

  • keychains. In other words, your passwords. All your Macs can have the same passwords memorized. Worth its weight in gold.

  • Mail Accounts, Rules, Signatures, and Smart Mailboxes. These refer to your account settings and preferences from Mac OS X's Mail programs, not the email messages

    Figure 6-10. To set up .Mac sync, open System Preferences. Click .Mac, and then click the Sync tab. Turn on the checkboxes for the information you want synchronized. Use the pop-up menu at the top to set up an automatic sync schedule. While you're at it, turn on "Show status in menu bar," so you'll be able to start or stop the syncing manually, too.

    themselves. (You can sync those, more or less, by setting up your Mail account as an IMAP account; see Chapter 19.)

  • Notes. This option refers to the notes you enter in the new Mail Notes feature (Chapter 19). How great to make a reminder for yourself on one Mac, and to have it reminding you later on another one. (If you have Microsoft Office, you'll see an Entourage Notes option here, too.)

  • Preferences. All your System Preferences settings.

To set up .Mac syncing, turn on the checkboxes for the items you want synced, as shown in Figure 6-10.

After the first sync, you can turn on the checkboxes on the other Macs, too, in effect telling them to participate in the great data-sharing experiment.

The first time they try, they may get confused. "Hold on. My address book is empty, but the one I'm downloading from the Internet (from the other Mac) is loaded. Who wins?" You get the dialog box shown in Figure 6-11, which lets you decide how to proceed.

Figure 6-11. This message lets you decide how to proceed when data on one of the synced Macs is wildly out of sync with what's been "published" by another Mac. You can merge the information from the two (a great way to combine address books or calendars), make this Mac's data wipe out the other's ("Replace data on .Mac"), or make the Internet based data replace this computer's ("Replace data on computer").
You can do this job en masse (top)—or, if you click Options, you can make this choice independently for each data type.


automator_and_applescript.html

Chapter 7. Automator and AppleScript

If you use your Mac long enough, you're bound to start repeating certain jobs over and over again—renaming files, for example, or importing music files into iTunes. A Windows geek would simply accept this tedium as a cost of using the computer, and move on. But you, time-starved Mac fan, know there has to be an easier way.

In fact, there are two.

  • Automator is a program that lets you teach your Mac what to do, step by step, by assembling a series of visual building blocks called actions. Drag actions into the right order, click a big Run button, and your Mac faithfully runs through the list of steps you've given it (Figure 7-1, top).

    You have a list of preprogrammed actions at your fingertips, so you never have to do any coding or learn any programming language. So creating the little software robots (called workflows) is exceptionally easy.

    On the other hand, your selection of building blocks is limited to what other programmers have already written, so Automator workflows are limited in what they can do. You can't automate a complex newspaper layout using Automator alone, for example, because nobody has written the building-block actions necessary to control all the stages of newspaper production.

    Apple made some big changes to Automator in 10.5, including revamping the interface to make it more modern, more usable—and more logical. It also added a helpful Starting Points menu (Section 7.1.1.2), variables (Section 7.1.1.5), and a bunch of new actions (including Watch Me Do, Loop, and RSS actions, for example).

    For novices, the most exciting new feature of all might be the new Watch Me mode. It lets you just do what you want Automator to learn, as Automator watches and memorizes each keystroke, mouse click, and menu selection. Later, Automator can replay those steps faithfully, like a true-blue macro program.

  • AppleScript is the other, much older way of automating your Mac. You type out English-like commands in a text file called a script, one command per line, and click Run to have your Mac carry out the result (Figure 7-1, bottom).

Figure 7-1. The two faces of Mac automation.
Top: Automator uses a visual, step-by-step metaphor for automation; the down-pointing arrows indicate how each building block "feeds" its result into the next action. You can usually tell what an Automator workflow does at a glance.
Bottom: Script Editor (the program you use to write and edit AppleScript code) is geekier. There's a good amount of programmerese here, and you have to know basic AppleScript syntax before you can begin to understand this script–let alone write your own.

AppleScript is a power user's dream come true, but it's a programming language. If you want to automate even a simple custom job like converting music files to MP3s, you have to get your hands dirty hunting for the AppleScript command that does exactly what you want—and that can be a real pain.

Note: One reason AppleScript is so powerful is that it's been cultivating a following for over a decade. Already, AppleScript commands are available in the software programs from hundreds of companies.As Automator ages, more and more companies are packaging Automator actions with their programs, too. Microsoft Office for Mac 2008, for example, will include its own set of Automator actions that will let you automate the various Office programs.

7.1. Introducing Automator

Automator, like most programs on your Mac, sits waiting in your Applications folder. Double-click Automator's icon to open it for the first time (Figure 7-2).

Figure 7-2. Automator's icon is a computer generated robot image named Otto. (Get it? Otto Matic? Stop, you're killing us!) The icon is supposed to evoke an image of Automator as a servile program, executing your every desire without question. Any similarity to the malevolent androids of I, Robot is purely coincidental.

7.1.1. Navigating the Screen

As shown in Figure 7-3, Automator looks confusing. But once you learn what the different sections do, the layout makes a lot of sense. Here's a run-down of Automator's various parts.

7.1.1.1. Starting Points menu

When you first launch Automator, you're greeted with a new, ultra-simple Starting Points menu. It's an easy launching pad for certain kinds of common workflows— those that work with Files & Folders, Music & Audio, Photos & Images, or Text.

Figure 7-3. In many ways, Automator's interface resembles that of iTunes; the unified theme, the Play button, and even the Library list are all here. The process of working in Automator always flows from left to right. Click the type of data you want to control (Library list), find what you want it to do (Actions list), and drag it into the Workflow pane to build the list of steps you want your software robot to take.

When you click the appropriate icon, make selections from the two pop-up menus beneath it, and click Choose, Automator sets up the beginning of your workflow automatically. Your workflow isn't complete, not by a long shot; all you've done so far is to say, "Work with this kind of file, and specify which ones. "You still have to say what you want done with those files.

Still, you've gotten started.

Of course, if you're a workflow wiz and don't want a jump-start on your project because you're just that good, selecting Custom gives you a clean, action-free document to work with. But even if you are an automating expert, the Starting Points menu is almost always useful. It still saves you those few extra clicks—selecting your base actions, dragging them to the Workflow pane, setting their preferences, and so on— necessary to get your workflow started.

Besides, you don't have to tell anyone you used it.

Tip: You can disable the Starting Points menu entirely by clicking Automator rightwards double arrow Disable Starting Points.
7.1.1.2. Toolbar

At the top of the Automator window, the toolbar offers five fairly self-explanatory buttons. From left to right (Figure 7-3):

  • Hide Library.This button hides the entire left Library pane of Automator, where all of the prefab building-block steps are listed. You wind up with one big Workflow pane.

  • Media. Click to open the standard Media Browser box that pops up all over Mac OSX. You can drag your music, photos, or movies from the Media Browser directly into the Workflow pane, or into an action itself (one with a matching data type, of course), to use that media in your workflow.

    Tip: Media from the Media Browser isn't all you can add to Automator. You can also drag files—text documents, media, folders, and so on—straight from the Finder into your workflow, saving you the hassle of having to search for them in Automator.

  • Record. Click to enter Watch Me mode, where Automator memorizes the steps that you perform manually (Section 7.3.2).

  • Workflow control. Run and Stop "play back" and stop the workflow you're building.

Tip: To save screen space, you can hide the entire Automator toolbar by choosing View rightwards double arrow Toolbar, or by clicking the capsule-shaped button in the upper-right corner of the window. (You can bring the toolbar back by choosing View rightwards double arrow Show Toolbar or clicking the pill button again.)While the toolbar is hidden (and even when it's visible), you can still start and stop playback by choosing Workflow rightwards double arrow Run ( [image] -R) and Workflow rightwards double arrow Stop ( [image] -period).
7.1.1.3. Library pane

The Library pane is the entire left section of the Automator window. It includes the Search box, Library list, Description field, and the list of Actions or Variables list. All of these are described below.

Tip: You can resize either of Automator's left-side columns (Library and Actions) by carefully dragging the vertical divider lines between them.
7.1.1.4. Search box

Like Mac OSX's other Search boxes, this one works in real time — it displays matching actions or variables as you type.

If you start by selecting a folder in the Library list at the left, you're telling Automator, "Search only within this folder of actions or variables. " If you want to search for actions that can process files in the Finder, for example, click Files & Folders in the Library list, and then type file in the Search box.

Tip: You can [image] -click to select several folders and then search all of them simultaneously.Or, to search all of Automator's folders, click Library at the top of the Library list before searching. (That's the best way to find an action or variable if you're not sure what folder it's in.)

Your search results appear in the Actions/Variables list, ranked by relevance to your search terms. You can begin dragging actions directly into the Workflow pane at the right side to build a workflow, as described shortly.

Click the [image] button in the Search box to return to the complete list of actions or variables.

7.1.1.5. Library

Above the Library list, two buttons appear that govern what's displayed in the Library pane:

  • Actions. When you click Actions, the Library lists all the features and data on your Mac that Automator actions can control: Files & Folders, Music, Photos, Text, and so on. When you click a folder, the Actions list on the right shows you every action related to that type of data. For example, when you click Photos in the left-side list, the right-side list of actions offers steps like Flip Images, Crop Images, and so on.

  • When you find an action you want to use in your workflow, you drag it to the right into the large Workflow pane.

  • Variables.New to Automator in Leopard, variables are memorized info chunks that you can reuse in an Automator workflow, exactly as in real programming languages. The Variables list is divided into categories like Date & Time (today's date, today's month, etc.), Locations (the paths to various folders on your Mac), User (your name, phone number, etc.), and so on.

    To see all the available Automator actions or variables on your Mac, click Library in the Library list.

    Later in this chapter, you'll see how it's useful to incorporate these information tidbits into your workflows.

Note: Variables whose icons look like a boxed V are variables that you can change. For example, you can change the formatting of the "Current time" variable by double-clicking it.Variables with [image] icons are predefined and unchangeable.
7.1.1.6. Description field

When you click an action or variable in the list, the Description box provides some terse, superficial information on how to use it. You might see what the action does, what kind of data it expects to receive from the previous action (input), and what the action sends on to the following action (result).

If the variable is editable (it has a V icon), you get to see what parts of it you can change.

Tip: To save space, you can hide the Description field by clicking the [image] button on the bottom edge of the window. Click it again to bring the Description field back.
7.1.1.7. The button

The [image] button in the lower-left corner of the window is a pop-up menu. Its four commands let you create and delete customizable collections called groups and smart groups. They behave exactly like playlists and smart playlists in iTunes:

  • Groups. Groups are customizable folders you add to the Library list. To add an action or variable to a group, drag it from the list onto the Group folder.

  • SmartGroups. Smart groups, new in Leopard, are constantly updated with actions that match the criteria you set for that smart group. (They're available only for actions, not variables.)

    For example, you can create a smart group that lists only actions that work with iPhoto, or actions with Input Types that contain the word "image." Add more criteria by clicking the + button.

Tip: Automator's Library list comes with three factory-installed smart groups: Most Relevant, which displays all the actions relevant to the action you have selected in the Workflow pane; Most Used, which displays the actions you've used the most in your workflows; and Recently Added, which displays actions added by newly installed applications, for example, or actions you downloaded and added yourself.
7.1.1.8. Workflow pane

The Workflow pane is Automator's kitchen. It's where you put your actions in whatever order you want, set any action-specific preferences, and fry them all up in a pan.

But the Workflow pane is also where you see how the information from one action gets piped into another, creating a stream of information. That's how the Workflow pane differentiates Automator from the dozens of non-visual, programming-based automation tools out there. Figure 7-4 shows what a piece of a workflow might look like in the Workflow pane.

When you drag an action out of the Actions list into the Workflow pane, any surrounding actions scoot aside to make room.

Tip: If you double-click an action in the Actions list, Automator inserts it at the bottom of the Workflow pane. (Pressing Enter when an action is highlighted does the same thing.)
7.1.1.9. Log viewer

Under the Workflow pane on the left are two tiny buttons, identified in Figure 7-3. They hide and show two useful pop-up panels that contain logs (mini-reports):

  • The Workflow log shows the results of your workflow: which actions ran successfully, which failed (if any), what each action did, and so on. See Section 7.3.

  • The Variables log (Figure 7-5) shows all the variables used in your workflow. When you run the workflow, the Value list shows you what information was stored in each variable after the workflow finishes.

Tip: You can also hide or show the logs using the relevant commands in the View menu. Option- [image] -L hides or shows the Workflow log. (Unfortunately, the Variables log isn't blessed with a keyboard shortcut.)

Figure 7-4. Anatomy of an Automator action. You can drag the action by its title bar to move it to an earlier or later position in your workflow.

Figure 7-5. The Variables log shows you all the variables you're using in your workflow. The light blue variables are editable; double-click one to modify the variable's name and its settings (in this case, the format for "Today's date").

7.1.2. Opening Existing Workflows

Automator comes with three prebuilt workflows that show off Automator's capabilities. Find them by clicking Help rightwards double arrow Open Examples Folder; open one of these workflows for inspection by double-clicking it.

Tip: In Leopard, you don't actually have to open an Automator document to see how it's set up. Simply select a workflow in the Finder and hit Space bar to activate Quick Look (Section 1.8), which gives you a preview of the entire workflow—actions and all.Note, though, that this only works with workflows saved in Leopard's Automator. Since Apple's own example workflows were created in the older 10.4 version, QuickLook won't properly display them until they're resaved in Leopard.

To many people's surprise, the included workflows are quite useful:

  • Copy Unread Mail to iPod Notes copies any new Mail messages into your iPod's text-notes folder. Later, when you're on the train to work, you can pull out your iPod and read whatever mail you didn't get to at home.

  • Import .Mac Photo Album into iPhoto works only if you have a .Mac account (Section 18.6). It slurps the photos from a photo album you've previously posted on your .Mac site (say, while you were on vacation) and copies them into iPhoto. From there, you can view a full-screen slideshow of the images, or even edit them and post them back onto your .Mac site.

  • Process Images applies the same extreme Photo Booth-like special visual effect to whatever photos you specify in the workflow. No, people haven't exactly been clamoring for an automated way to create mirror-image camera shots, but this workflow does show you the basics of batch-processing photos. You can use it as a template for building your own "Convert to JPEG" or "Scale to 640 x 480 pixels" workflow, for example.

Tip: Apple provides two great Automator examples at their Automator Web site, www.automator.us. "Welcome to the Party!" for example, cleverly demos two new features of Automator—variables and the Loop action—by showing you how to create a workflow that takes photos of your friends and turns them into a cool, party-ready screen saver.

7.1.3. Editing a Workflow

Before you build your own workflows, it's a good idea to understand how actions work together to process information. Here's a guided tour of the Process Images workflow described in the previous paragraphs (Figure 7-6), which will give you deeper insight into building your own workflows.

  1. Ask for Confirmation.

    This common action, available in the Utilities folder, produces a dialog box that tells the innocent bystander what's about to happen (Figure 7-7). It's a good idea to begin each of your own workflows with a box like this, to remind yourself (or your minimum-wage minions) what the workflow actually does.

    In this case, the message informs your audience that the workflow is about to open a folder full of pictures, apply some wacko effects to them, and then open them up in Preview to display the results.

    Tip: If you want the dialog box to appear with a bright warning sign—to inform you, for example, that you're about to erase your entire hard drive—click the robot icon in the upper-left corner of the Ask for Confirmation action. Automator swaps in a robot-with-yellow-triangle icon.Keep in mind, too, that the entire Ask for Confirmation action is 100 percent customizable. Not only can you change the text that appears in the dialog box—you can even change the names of the Cancel and OK buttons.

    Figure 7-6. The Process Images workflow consists of only five actions. (The first action, which just displays an explanatory dialog box, shouldn't even count.) Still, this simple action does in 10 seconds what would take most humans at least 5 minutes: applying the same photo effect to several images.

  2. 2. Get Specified Finder Items.

    The next step in the Process Images workflow comes from the Files & Folders folder. It lets you specify which files you want your workflow to operate on. You can use the Add and Remove buttons to edit the list—to add your own images to be mirrored, for example—or you can drag files straight from the Finder into this list.

    When this action is finished, it passes on a list of files and/or folders to the next action, ready for further processing.

    Note: This example workflow always operates on the same set of four files. But if you were to substitute the Files & Folders rightwards double arrow Ask for Finder Items action instead, Automator would prompt you for the files to process each time you ran the workflow, which is a heck of a lot more useful than applying the same filter over and over again to the same four images.Also, you'll notice that two of the images in the list—"Ladybug on Leaf.jpg" and "Roses.jpg"—have blank document icons. That's because those images were around in 10.4, which is why they're included in the example—but Apple removed them from 10.5, and forgot to take them out of the workflow for Leopard. So when you run the workflow, only two images, not four, will be processed.

    Figure 7-7. A dialog box created by the Ask for Confirmation action. Feel free to edit the action with your own text; the stuff that Apple provides is pretty dry.

  3. Copy Finder Items.

    This is a very important Files & Folders action: it makes a copy of the specified files and folders (in this case, the ones you identified in Step 2) so you don't gum up the originals. You can change where you want the copies stored by editing the "To" pop-up menu in the action. The menu lists obvious locations like Pictures and Desktop, or you can choose Other to select any folder you like.

    Note: The "Replacing existing files" checkbox simply tells Automator that, if there are old files in the Pictures folder with the same names as your new files, you want to delete the old files automatically.

    If you click Options in the action, you'll see that the "Show this action when the workflow runs" checkbox is turned on. That means Automator asks where to store the copies when you run the workflow, so that the destination can be different each time. Otherwise, the files will automatically be copied to whatever folder you select in the pop-up menu right now.

  4. 4. Apply Quartz Composition Filter to Image Files.

    This action (listed in the Photos folder) processes the newly duplicated images from Step 3; in this case, it applies a mirror filter to them. The action then passes the newly-mirrored images onto Step 5. If you prefer, you can choose a different filter from the pop-up menu—to make the image look like a comic-book drawing, for example, instead of applying the mirror filter.

    Note: The Quartz Composition Filter, a piece of Mac OS X's Quartz display technology, can modify images and photos in real time. Photo Booth uses this technology, which is why many of Photo Booth's effects are also in the action's Filter pop-up menu. (See http://developer.apple.com/graphicsimaging/quartz for the incredibly nerdy details on Quartz.)

    Since "Show this action when the workflow runs" under Options is turned on, Automator will present this action to you when you run the workflow. That is, you'll have the chance to choose a different filter each time this workflow runs.

    (By the way, the image of the beach is intended to demonstrate the filter's effect; it's not actually one of your photos.)

    Tip: The big box on the right side of the action isn't there because Apple had nothing to fill the space. Certain filters have settings you can modify, which appear in that box. The Glow filter, for example, lets you specify how much glow you want applied to the image(s).

  5. Open Images in Preview.

    This final action, which also comes from the Photos folder, takes the post-filter images from Step 4 and opens them in Preview (Section 10.23). From there, you can flip, resize, or resave the images.

Try running the workflow by clicking Run. The bottom of the Workflow pane tells you which step of the workflow is running at the moment. As each action finishes, a green check mark appears in its lower-left corner.

Note: If something goes wrong while your workflow is running (or if you click Cancel in a dialog box), your workflow stops in its tracks. To identify the offending step, look for the red X in an action's lower-left corner, or check the Log.

Unfortunately, if your workflow shuts down in the middle, you can't restart it from there. When you click Run the next time, the workflow plays from the beginning.


introducing_automator.html

Chapter 7. Automator and AppleScript

If you use your Mac long enough, you're bound to start repeating certain jobs over and over again—renaming files, for example, or importing music files into iTunes. A Windows geek would simply accept this tedium as a cost of using the computer, and move on. But you, time-starved Mac fan, know there has to be an easier way.

In fact, there are two.

  • Automator is a program that lets you teach your Mac what to do, step by step, by assembling a series of visual building blocks called actions. Drag actions into the right order, click a big Run button, and your Mac faithfully runs through the list of steps you've given it (Figure 7-1, top).

    You have a list of preprogrammed actions at your fingertips, so you never have to do any coding or learn any programming language. So creating the little software robots (called workflows) is exceptionally easy.

    On the other hand, your selection of building blocks is limited to what other programmers have already written, so Automator workflows are limited in what they can do. You can't automate a complex newspaper layout using Automator alone, for example, because nobody has written the building-block actions necessary to control all the stages of newspaper production.

    Apple made some big changes to Automator in 10.5, including revamping the interface to make it more modern, more usable—and more logical. It also added a helpful Starting Points menu (Section 7.1.1.2), variables (Section 7.1.1.5), and a bunch of new actions (including Watch Me Do, Loop, and RSS actions, for example).

    For novices, the most exciting new feature of all might be the new Watch Me mode. It lets you just do what you want Automator to learn, as Automator watches and memorizes each keystroke, mouse click, and menu selection. Later, Automator can replay those steps faithfully, like a true-blue macro program.

  • AppleScript is the other, much older way of automating your Mac. You type out English-like commands in a text file called a script, one command per line, and click Run to have your Mac carry out the result (Figure 7-1, bottom).

Figure 7-1. The two faces of Mac automation.
Top: Automator uses a visual, step-by-step metaphor for automation; the down-pointing arrows indicate how each building block "feeds" its result into the next action. You can usually tell what an Automator workflow does at a glance.
Bottom: Script Editor (the program you use to write and edit AppleScript code) is geekier. There's a good amount of programmerese here, and you have to know basic AppleScript syntax before you can begin to understand this script–let alone write your own.

AppleScript is a power user's dream come true, but it's a programming language. If you want to automate even a simple custom job like converting music files to MP3s, you have to get your hands dirty hunting for the AppleScript command that does exactly what you want—and that can be a real pain.

Note: One reason AppleScript is so powerful is that it's been cultivating a following for over a decade. Already, AppleScript commands are available in the software programs from hundreds of companies.As Automator ages, more and more companies are packaging Automator actions with their programs, too. Microsoft Office for Mac 2008, for example, will include its own set of Automator actions that will let you automate the various Office programs.

7.1. Introducing Automator

Automator, like most programs on your Mac, sits waiting in your Applications folder. Double-click Automator's icon to open it for the first time (Figure 7-2).

Figure 7-2. Automator's icon is a computer generated robot image named Otto. (Get it? Otto Matic? Stop, you're killing us!) The icon is supposed to evoke an image of Automator as a servile program, executing your every desire without question. Any similarity to the malevolent androids of I, Robot is purely coincidental.

7.1.1. Navigating the Screen

As shown in Figure 7-3, Automator looks confusing. But once you learn what the different sections do, the layout makes a lot of sense. Here's a run-down of Automator's various parts.

7.1.1.1. Starting Points menu

When you first launch Automator, you're greeted with a new, ultra-simple Starting Points menu. It's an easy launching pad for certain kinds of common workflows— those that work with Files & Folders, Music & Audio, Photos & Images, or Text.

Figure 7-3. In many ways, Automator's interface resembles that of iTunes; the unified theme, the Play button, and even the Library list are all here. The process of working in Automator always flows from left to right. Click the type of data you want to control (Library list), find what you want it to do (Actions list), and drag it into the Workflow pane to build the list of steps you want your software robot to take.

When you click the appropriate icon, make selections from the two pop-up menus beneath it, and click Choose, Automator sets up the beginning of your workflow automatically. Your workflow isn't complete, not by a long shot; all you've done so far is to say, "Work with this kind of file, and specify which ones. "You still have to say what you want done with those files.

Still, you've gotten started.

Of course, if you're a workflow wiz and don't want a jump-start on your project because you're just that good, selecting Custom gives you a clean, action-free document to work with. But even if you are an automating expert, the Starting Points menu is almost always useful. It still saves you those few extra clicks—selecting your base actions, dragging them to the Workflow pane, setting their preferences, and so on— necessary to get your workflow started.

Besides, you don't have to tell anyone you used it.

Tip: You can disable the Starting Points menu entirely by clicking Automator rightwards double arrow Disable Starting Points.
7.1.1.2. Toolbar

At the top of the Automator window, the toolbar offers five fairly self-explanatory buttons. From left to right (Figure 7-3):

  • Hide Library.This button hides the entire left Library pane of Automator, where all of the prefab building-block steps are listed. You wind up with one big Workflow pane.

  • Media. Click to open the standard Media Browser box that pops up all over Mac OSX. You can drag your music, photos, or movies from the Media Browser directly into the Workflow pane, or into an action itself (one with a matching data type, of course), to use that media in your workflow.

    Tip: Media from the Media Browser isn't all you can add to Automator. You can also drag files—text documents, media, folders, and so on—straight from the Finder into your workflow, saving you the hassle of having to search for them in Automator.

  • Record. Click to enter Watch Me mode, where Automator memorizes the steps that you perform manually (Section 7.3.2).

  • Workflow control. Run and Stop "play back" and stop the workflow you're building.

Tip: To save screen space, you can hide the entire Automator toolbar by choosing View rightwards double arrow Toolbar, or by clicking the capsule-shaped button in the upper-right corner of the window. (You can bring the toolbar back by choosing View rightwards double arrow Show Toolbar or clicking the pill button again.)While the toolbar is hidden (and even when it's visible), you can still start and stop playback by choosing Workflow rightwards double arrow Run ( [image] -R) and Workflow rightwards double arrow Stop ( [image] -period).
7.1.1.3. Library pane

The Library pane is the entire left section of the Automator window. It includes the Search box, Library list, Description field, and the list of Actions or Variables list. All of these are described below.

Tip: You can resize either of Automator's left-side columns (Library and Actions) by carefully dragging the vertical divider lines between them.
7.1.1.4. Search box

Like Mac OSX's other Search boxes, this one works in real time — it displays matching actions or variables as you type.

If you start by selecting a folder in the Library list at the left, you're telling Automator, "Search only within this folder of actions or variables. " If you want to search for actions that can process files in the Finder, for example, click Files & Folders in the Library list, and then type file in the Search box.

Tip: You can [image] -click to select several folders and then search all of them simultaneously.Or, to search all of Automator's folders, click Library at the top of the Library list before searching. (That's the best way to find an action or variable if you're not sure what folder it's in.)

Your search results appear in the Actions/Variables list, ranked by relevance to your search terms. You can begin dragging actions directly into the Workflow pane at the right side to build a workflow, as described shortly.

Click the [image] button in the Search box to return to the complete list of actions or variables.

7.1.1.5. Library

Above the Library list, two buttons appear that govern what's displayed in the Library pane:

  • Actions. When you click Actions, the Library lists all the features and data on your Mac that Automator actions can control: Files & Folders, Music, Photos, Text, and so on. When you click a folder, the Actions list on the right shows you every action related to that type of data. For example, when you click Photos in the left-side list, the right-side list of actions offers steps like Flip Images, Crop Images, and so on.

  • When you find an action you want to use in your workflow, you drag it to the right into the large Workflow pane.

  • Variables.New to Automator in Leopard, variables are memorized info chunks that you can reuse in an Automator workflow, exactly as in real programming languages. The Variables list is divided into categories like Date & Time (today's date, today's month, etc.), Locations (the paths to various folders on your Mac), User (your name, phone number, etc.), and so on.

    To see all the available Automator actions or variables on your Mac, click Library in the Library list.

    Later in this chapter, you'll see how it's useful to incorporate these information tidbits into your workflows.

Note: Variables whose icons look like a boxed V are variables that you can change. For example, you can change the formatting of the "Current time" variable by double-clicking it.Variables with [image] icons are predefined and unchangeable.
7.1.1.6. Description field

When you click an action or variable in the list, the Description box provides some terse, superficial information on how to use it. You might see what the action does, what kind of data it expects to receive from the previous action (input), and what the action sends on to the following action (result).

If the variable is editable (it has a V icon), you get to see what parts of it you can change.

Tip: To save space, you can hide the Description field by clicking the [image] button on the bottom edge of the window. Click it again to bring the Description field back.
7.1.1.7. The button

The [image] button in the lower-left corner of the window is a pop-up menu. Its four commands let you create and delete customizable collections called groups and smart groups. They behave exactly like playlists and smart playlists in iTunes:

  • Groups. Groups are customizable folders you add to the Library list. To add an action or variable to a group, drag it from the list onto the Group folder.

  • SmartGroups. Smart groups, new in Leopard, are constantly updated with actions that match the criteria you set for that smart group. (They're available only for actions, not variables.)

    For example, you can create a smart group that lists only actions that work with iPhoto, or actions with Input Types that contain the word "image." Add more criteria by clicking the + button.

Tip: Automator's Library list comes with three factory-installed smart groups: Most Relevant, which displays all the actions relevant to the action you have selected in the Workflow pane; Most Used, which displays the actions you've used the most in your workflows; and Recently Added, which displays actions added by newly installed applications, for example, or actions you downloaded and added yourself.
7.1.1.8. Workflow pane

The Workflow pane is Automator's kitchen. It's where you put your actions in whatever order you want, set any action-specific preferences, and fry them all up in a pan.

But the Workflow pane is also where you see how the information from one action gets piped into another, creating a stream of information. That's how the Workflow pane differentiates Automator from the dozens of non-visual, programming-based automation tools out there. Figure 7-4 shows what a piece of a workflow might look like in the Workflow pane.

When you drag an action out of the Actions list into the Workflow pane, any surrounding actions scoot aside to make room.

Tip: If you double-click an action in the Actions list, Automator inserts it at the bottom of the Workflow pane. (Pressing Enter when an action is highlighted does the same thing.)
7.1.1.9. Log viewer

Under the Workflow pane on the left are two tiny buttons, identified in Figure 7-3. They hide and show two useful pop-up panels that contain logs (mini-reports):

  • The Workflow log shows the results of your workflow: which actions ran successfully, which failed (if any), what each action did, and so on. See Section 7.3.

  • The Variables log (Figure 7-5) shows all the variables used in your workflow. When you run the workflow, the Value list shows you what information was stored in each variable after the workflow finishes.

Tip: You can also hide or show the logs using the relevant commands in the View menu. Option- [image] -L hides or shows the Workflow log. (Unfortunately, the Variables log isn't blessed with a keyboard shortcut.)

Figure 7-4. Anatomy of an Automator action. You can drag the action by its title bar to move it to an earlier or later position in your workflow.

Figure 7-5. The Variables log shows you all the variables you're using in your workflow. The light blue variables are editable; double-click one to modify the variable's name and its settings (in this case, the format for "Today's date").

7.1.2. Opening Existing Workflows

Automator comes with three prebuilt workflows that show off Automator's capabilities. Find them by clicking Help rightwards double arrow Open Examples Folder; open one of these workflows for inspection by double-clicking it.

Tip: In Leopard, you don't actually have to open an Automator document to see how it's set up. Simply select a workflow in the Finder and hit Space bar to activate Quick Look (Section 1.8), which gives you a preview of the entire workflow—actions and all.Note, though, that this only works with workflows saved in Leopard's Automator. Since Apple's own example workflows were created in the older 10.4 version, QuickLook won't properly display them until they're resaved in Leopard.

To many people's surprise, the included workflows are quite useful:

  • Copy Unread Mail to iPod Notes copies any new Mail messages into your iPod's text-notes folder. Later, when you're on the train to work, you can pull out your iPod and read whatever mail you didn't get to at home.

  • Import .Mac Photo Album into iPhoto works only if you have a .Mac account (Section 18.6). It slurps the photos from a photo album you've previously posted on your .Mac site (say, while you were on vacation) and copies them into iPhoto. From there, you can view a full-screen slideshow of the images, or even edit them and post them back onto your .Mac site.

  • Process Images applies the same extreme Photo Booth-like special visual effect to whatever photos you specify in the workflow. No, people haven't exactly been clamoring for an automated way to create mirror-image camera shots, but this workflow does show you the basics of batch-processing photos. You can use it as a template for building your own "Convert to JPEG" or "Scale to 640 x 480 pixels" workflow, for example.

Tip: Apple provides two great Automator examples at their Automator Web site, www.automator.us. "Welcome to the Party!" for example, cleverly demos two new features of Automator—variables and the Loop action—by showing you how to create a workflow that takes photos of your friends and turns them into a cool, party-ready screen saver.

7.1.3. Editing a Workflow

Before you build your own workflows, it's a good idea to understand how actions work together to process information. Here's a guided tour of the Process Images workflow described in the previous paragraphs (Figure 7-6), which will give you deeper insight into building your own workflows.

  1. Ask for Confirmation.

    This common action, available in the Utilities folder, produces a dialog box that tells the innocent bystander what's about to happen (Figure 7-7). It's a good idea to begin each of your own workflows with a box like this, to remind yourself (or your minimum-wage minions) what the workflow actually does.

    In this case, the message informs your audience that the workflow is about to open a folder full of pictures, apply some wacko effects to them, and then open them up in Preview to display the results.

    Tip: If you want the dialog box to appear with a bright warning sign—to inform you, for example, that you're about to erase your entire hard drive—click the robot icon in the upper-left corner of the Ask for Confirmation action. Automator swaps in a robot-with-yellow-triangle icon.Keep in mind, too, that the entire Ask for Confirmation action is 100 percent customizable. Not only can you change the text that appears in the dialog box—you can even change the names of the Cancel and OK buttons.

    Figure 7-6. The Process Images workflow consists of only five actions. (The first action, which just displays an explanatory dialog box, shouldn't even count.) Still, this simple action does in 10 seconds what would take most humans at least 5 minutes: applying the same photo effect to several images.

  2. 2. Get Specified Finder Items.

    The next step in the Process Images workflow comes from the Files & Folders folder. It lets you specify which files you want your workflow to operate on. You can use the Add and Remove buttons to edit the list—to add your own images to be mirrored, for example—or you can drag files straight from the Finder into this list.

    When this action is finished, it passes on a list of files and/or folders to the next action, ready for further processing.

    Note: This example workflow always operates on the same set of four files. But if you were to substitute the Files & Folders rightwards double arrow Ask for Finder Items action instead, Automator would prompt you for the files to process each time you ran the workflow, which is a heck of a lot more useful than applying the same filter over and over again to the same four images.Also, you'll notice that two of the images in the list—"Ladybug on Leaf.jpg" and "Roses.jpg"—have blank document icons. That's because those images were around in 10.4, which is why they're included in the example—but Apple removed them from 10.5, and forgot to take them out of the workflow for Leopard. So when you run the workflow, only two images, not four, will be processed.

    Figure 7-7. A dialog box created by the Ask for Confirmation action. Feel free to edit the action with your own text; the stuff that Apple provides is pretty dry.

  3. Copy Finder Items.

    This is a very important Files & Folders action: it makes a copy of the specified files and folders (in this case, the ones you identified in Step 2) so you don't gum up the originals. You can change where you want the copies stored by editing the "To" pop-up menu in the action. The menu lists obvious locations like Pictures and Desktop, or you can choose Other to select any folder you like.

    Note: The "Replacing existing files" checkbox simply tells Automator that, if there are old files in the Pictures folder with the same names as your new files, you want to delete the old files automatically.

    If you click Options in the action, you'll see that the "Show this action when the workflow runs" checkbox is turned on. That means Automator asks where to store the copies when you run the workflow, so that the destination can be different each time. Otherwise, the files will automatically be copied to whatever folder you select in the pop-up menu right now.

  4. 4. Apply Quartz Composition Filter to Image Files.

    This action (listed in the Photos folder) processes the newly duplicated images from Step 3; in this case, it applies a mirror filter to them. The action then passes the newly-mirrored images onto Step 5. If you prefer, you can choose a different filter from the pop-up menu—to make the image look like a comic-book drawing, for example, instead of applying the mirror filter.

    Note: The Quartz Composition Filter, a piece of Mac OS X's Quartz display technology, can modify images and photos in real time. Photo Booth uses this technology, which is why many of Photo Booth's effects are also in the action's Filter pop-up menu. (See http://developer.apple.com/graphicsimaging/quartz for the incredibly nerdy details on Quartz.)

    Since "Show this action when the workflow runs" under Options is turned on, Automator will present this action to you when you run the workflow. That is, you'll have the chance to choose a different filter each time this workflow runs.

    (By the way, the image of the beach is intended to demonstrate the filter's effect; it's not actually one of your photos.)

    Tip: The big box on the right side of the action isn't there because Apple had nothing to fill the space. Certain filters have settings you can modify, which appear in that box. The Glow filter, for example, lets you specify how much glow you want applied to the image(s).

  5. Open Images in Preview.

    This final action, which also comes from the Photos folder, takes the post-filter images from Step 4 and opens them in Preview (Section 10.23). From there, you can flip, resize, or resave the images.

Try running the workflow by clicking Run. The bottom of the Workflow pane tells you which step of the workflow is running at the moment. As each action finishes, a green check mark appears in its lower-left corner.

Note: If something goes wrong while your workflow is running (or if you click Cancel in a dialog box), your workflow stops in its tracks. To identify the offending step, look for the red X in an action's lower-left corner, or check the Log.

Unfortunately, if your workflow shuts down in the middle, you can't restart it from there. When you click Run the next time, the workflow plays from the beginning.


building_your_own_workflow.html

7.2. Building Your Own Workflow

You could spend all day playing with the workflows Apple gives you, making minor tweaks and seeing how they affect the workflow's progress. You could even download more preassembled workflows from www.automatorworld.com, macscripter.net, or Apple's own www.automator.us, if you were so inclined.

Still, those options don't give you the kind of hands-on experience you need if you ever want to automate your Mac on your own.

That's why the following pages walk you through building three different Automator workflows from scratch. Along the way, you'll learn several tricks that you'll find handy when you start building your own workflows.

Tip: If you're feeling lazy, you can download the completed workflow projects from this book's "Missing CD" page atwww.missingmanuals.com.

7.2.1. Emailing an iTunes Song

So you're listening to a song in iTunes, and you're seized by an overwhelming urge to email it to someone. Maybe you think your mom would like to hear the new Britney Spears hit (hey, she's your mom), or that your brother would be interested in your latest GarageBand opus (he probably isn't).

The traditional process for emailing a song is a huge pain: locating the song in iTunes, Control-clicking it, choosing Show in Finder from the shortcut menu, creating a new message in Mail, addressing it, typing out a subject and short body message, dragging the song file from the Finder into the email message, and, finally, clicking Send. Life's too short.

Automator can greatly simplify this process. With a simple two-action workflow, you can locate a song from your iTunes Library, set up all the email information you want in a dialog box, and have Automator attach the song file automatically. Figure 7-8 shows what the final workflow looks like.

Figure 7-8. Your new workflow lets you pick a song in your iTunes Library (top), and then attach the song to a new email message. This action is a heck of a lot easier than trying to do all the steps manually.

Note: Your recipient may not be able to play the song if it came from the iTunes music store. Those songs are copy-protected, and play back on a maximum of five computers. (MP3 files, GarageBand compositions, and songs you've ripped from your own CDs, of course, have no such restrictions.)

Here's how to build the workflow:

  1. Open a new Automator workflow window.

    Either choose File rightwards double arrow New or press [image] -N.

  2. In the Starting Points menu, click Music & Audio. From the "Get content from"pop-up menu, choose "my iTunes Library. "Then, from the second pop-up menu, choose "Ask for songs and playlists when my workflow runs."

    Since you're not looking for music files in the Finder or on the Web, you want Automator to look specifically at your iTunes Library.

    The second pop-up menu gives you a bunch of options for how and when you want to specify which song(s) to use in the workflow. These options are pretty self-explanatory: You can either select or search for songs, and you can either do so right now or when you run the workflow. Since you'll probably want to use this workflow more than once, and for different songs, you want the ability to select a song every time the workflow runs.

    When you click Choose, Automator creates a workflow and automatically adds the Asks for Songs action, which matches the options you selected in the Starting Points menu. It lets you pick out one song (or more, if "Allow multiple selection" is on) from your iTunes Library (Figure 7-9, top). Whichever songs you pick will be attached to your new email.

    Note: Whatever you type into the Prompt box will appear as a message in the song-selection dialog box. You can make it say, for example, "Pick a song, any song!"

  3. In the Library list, click Mail.

    (Make sure the Actions button is clicked above the list.) You've just narrowed down the list of available actions to those that pertain to Apple's email program.

  4. From the Actions list, drag the action called New Mail Message into the Workflow pane.

    This action lets you specify the recipient, subject, and content of your new email message. (You can even add an email address straight from your Address Book. Just click the address-card button in the upper-right corner.)

    On the other hand, your workflow won't do you much good if you can only send email to the same person every time. Therefore, to make the workflow more general, you'd be wise to click the Options button and turn on "Show this action when the workflow runs." That way, you can specify a different recipient—and subject, and email account, and so on—each time you run the workflow (Figure 7-9, middle).

    If you look at the description for this action, you'll see that the Input accepts "(Files/Folders, Text)." It explains that if a file is passed from the previous action, it will automatically be attached to the email. Since the Ask for Songs action does pass a file to the action under it—in this case, the song file you select—Automator will conveniently attach it to the email, without needing another action.

    Figure 7-9. Top: The dialog box of the Ask for Songs action. You can search for songs using the field at the bottom, pick one of your playlists using the menu at the top, and even sample a song by clicking the Play button
    Middle: The dialog box of the New Mail Message action. If you have more than one email account, you can select the one you'd like to send the message from in the pop-up menu at the bottom of this window.
    Bottom: The result: an email message with your text, subject, recipient, and attachment. Just click Send and your message is on its way. (You could also have used the Send Outgoing Messages action at the end of your workflow to do this step automatically.)

  5. Choose File rightwards double arrow Save ( [image] -S), give your workflow a name, and save it somewhere easy to find.

    Tip: And if you really find this workflow useful, save it as a standard, double-clickable application and stash it in your Dock. Details on Section 7.4.

That's all there is to it. Click the Run button to test out your new workflow!

7.2.2. Burning an iPhoto Picture CD

iPhoto (Section 10.17.7) is a fantastic program for organizing digital photos. It even has its own photo-backup feature, which burns selected albums' photos to a blank CD or DVD.

However, iPhoto's backup feature burns a disc that maintains iPhoto's complex and user-hostile Library folder structure. That's great if you expect one day to restore the backup to iPhoto, because the backup maintains all your keywords, ratings, albums, comments, and other iPhoto data.

Figure 7-10. Top: The first action presents a dialog box telling you what this workflow does.
Middle: The second action lets you select from your iPhoto Library the images you want to back up.
Bottom: The last action, in a single step, burns those images onto a CD or DVD. It works regardless of whether your Mac has an internal or external burner. Try that simplicity on a PC!

But it's not so great if you want to hand the CD or DVD to anyone who doesn't use iPhoto (like a Mac OS 9 person or a Windows person), because they'll have a devil of a time figuring out where all the photos are in the convoluted Library folder structure.

If you build an Automator workflow to back up your photos instead, you (a) can burn a disc containing only the photos in one simple folder; (b) have more control over which photos are backed up; and (c) learn even more tricks for automating sophisticated operations. Figure 7-10 shows what the final workflow looks like.

Here's how to put it together:

  1. Create a new Automator workflow ( [image] -N).

    The Starting Points screen appears.

  2. Click Photos & Images. From the "Get content from" pop-up menu, choose "my iPhoto Library. "From the second pop-up menu, choose "Ask for photos and albums when my workflow runs." Click Choose.

    Your newly hatched workflow, when it runs, will begin by asking you which photos you want to back up when you run the workflow.

    Tip: What you really want is to round up only the latest batch of photos—since your last backup, for example. Fortunately, one of the actions in the Photos folder is called Find iPhoto Items, and it lets you specify a time period like "Within the last 2 weeks." It would be perfect for this workflow—if it weren't so buggy. (For example, it finds multiple copies of each photo.)For best results, then, create a Smart Album in iPhoto that lets you filter photos based on certain criteria—all your photos taken in the past two months, for example. When you run the workflow, you can choose that album to back up, so that you get only the most recent shots.

  3. In the Library list, click the Utilities folder. Drag the Ask for Confirmation action into the Workflow pane, above the Ask for Photos action. Fill in the text as shown at the top of Figure 7-10.

    You want to drag it above the Ask for Photos action so it's the first thing that happens when you run your workflow. Now you've just directed Automator to begin its work by displaying a dialog box (Figure 7-11).

    Figure 7-11. The explanatory dialog box from the iPhoto Backup workflow. Making the dialog box appear is optional, but it's helpful if you come back to your workflow in a few months and forget what it's supposed to do.

  4. Drag the "Burn a Disc" action to the bottom of the Workflow pane.

    This action takes the images you selected in the Ask for Songs action and burns them to a CD or DVD.

  5. In the Disc Name field of the Burn a Disc action, type "iPhoto Backup from "(that's a space after "from").

    The workflow will complete this phrase later.

  6. Click Variables above the Library list.

    Those variables are about to come in handy. You're going to complete the phrase "iPhoto Backup from" with whatever the date of the backup is.

  7. Click the Date & Time folder in the Library list. Drag the "Today's date" variable into the Disc Name field after "from."

    The CD or DVD's name will be something like "iPhoto Backup from 4/9/08,"making it easy for you to see when you made the backup disk. The date automatically changes whenever you run the workflow.

When you click Run, your workflow springs into action. If there isn't a blank CD or DVD in your Mac, Automator asks for one.

Skip to Section 7.4 to see how to save the result as a double-clickable icon on your desktop.

7.2.3. Converting and Renaming Images

This workflow is the most complicated of these examples, but also the one that saves you the most time. It processes any set of graphics files by converting them to the space-saving JPEG format, shrinking them to reasonable pixel dimensions for sending by email or posting on the Web, saving them in a new folder, and renaming them. If you often need to put pictures on your Web site, or you just like to email pictures to friends, this workflow can be a godsend.

  1. Create a new Automator document ( [image] -N). In the Starting Points menu, click Photos & Images. In the "Get content from" pop-up menu, select "my Mac." Then select "Ask for image files when my workflow runs," and click Choose.

    How will you tell Automator which photos to convert? Earlier in this chapter, you read about the Get Specified Finder Items action in one of Apple's sample workflows. Trouble is, that action requires that you tell Automator which images to convert ahead of time. It doesn't let you choose the images as your workflow is running, which would be far more useful.

    No, if you want to be asked which photos to process when your little program runs, you need the Ask for Finder Items action, which Automator automatically adds to your workflow when you specify your starting point settings.

    Note: Make sure that the Type pop-up menu says Files. (You can't really select a folder to convert to an image.)

    The "Start at" pop-up menu lets you specify what disk location the Open dialog box will present when it first opens. You can save yourself (or whoever will be enjoying your workflow) some time by setting it to the folder that will most likely contain the photos to be processed.

    Fill in the Prompt box with whatever message you want to appear in the Open dialog box. Something like, "Please choose the photos you'd like to have converted" would work fine.

    Finally, it's a good idea to turn on Allow Multiple Selection, so that you can pick several images to convert at once.

  2. In the Library list, click Files & Folders. Double-click the Copy Finder Items action.

    (Double-clicking an action adds it to the bottom of the workflow pane without you having to drag it.)

    This action copies the files you specified in the previous step into a new folder—a safety step that leaves your original images untouched. You can specify any folder you'd like in the "To" pop-up menu, but the Pictures folder is probably the best place to store your newly-copied images.

  3. Double-click the Rename Finder Items action.

    It, too, flies to the bottom of the workflow.

    Now, from the pop-up menu at the top of this action, choose Add Text. Then, in the Add field, type " (small)." (Put a space before the opening paren thesis.) Finally, make sure that the pop-up menu on the right says "after name."

    Why go through all this? First, by appending a standard suffix onto each image file's name, you'll have a standardized naming system: "Joe's Great Dane (small)," "Mary's Labrador (small)," and so on. Second, the suffix tells you, at a glance, that the image has been scaled down. Finally, and most usefully, having "(small)" in each of your image's names makes it easy to find all the images you've converted; all you have to do is use Spotlight (Chapter 3) to search for files with "(small)" in their names.

    Of course, this action hasn't actually converted the images to a smaller size yet. That's the work of the next action you'll add.

  4. In the Library list, click Photos. Double-click the Scale Images action. In the warning dialog box, click Don't Add.

    Whenever you add a "destructive"—or file-changing—action to your workflow, Automator warns you that you're going to be changing files, and offers to add a Copy Finder Items action so you don't screw up your originals. But in this case, you've already copied the images you want to convert in Step 2, so you don't need to do it again.

    In the action's pop-up menu, choose By Percentage, and type 50 in the text field. That's how you tell Automator, "I want you to shrink each of my images by half."

    Note: Automator will shrink each image's height and width by 50%, so technically, you're making your new images a quarter the area of the originals. If you truly want your new images to be half the area of the originals, use 70.71 for the scaling percentage. (That's 50 times the square root of two, if you're scoring at home.)

  5. In the Library list, go back to Files & Folders. Double-click the Filter Finder Items action.

    Change the first pop-up menu to File Type and the second to "is not." In the third menu, choose "JPEG Image File." Click the + button and set the same criteria again—except this time, in the third pop-up menu, choose JPEG 2000 Image File.

    You've just set up a filter that will screen out all the JPEG images you're processing in this workflow. You'll see why in the next step.

  6. Again, click Photos in the Library list. Click the Change Type of Images action, hold the Shift key, and drag it to the bottom of the Workflow pane.

    Holding Shift tells Automator, "Yes, I know I'm adding a destructive action, and no, I don't want to add the Copy Finder Items action again—and thanks for not asking." (If you drag the action to the workflow without holding Shift, Automator will again present the warning dialog box, again offer to add the Copy Finder Items action, and you'll again have to click Don't Add.)

    From the action's To Type pop-up menu, choose JPEG.

    In Step 4, you scaled down the images' dimensions; in this step, you're converting their file format to one that takes up less space. Your final images will be significantly smaller than the originals, consuming as little as one-tenth the disk space (depending on the quality of the originals), which makes them perfect for emailing or posting on the Web.

    As it turns out, the Change Type of Images action fails if it tries to convert a JPEG to a JPEG, which is why you filtered out the JPEGs in the previous step. This way, the action works only on the non-JPEG images when the workflow runs.

    Tip: Most of the actions in this example offer an Options panel at the bottom. When you click the Options button, you see an option called "Show this action when the workflow runs."If you turn on this checkbox, the workflow, when run, will pause at this juncture and ask what to do. For example, instead of using this action to churn out JPEGs, the workflow could ask you what file format you want. In Step 5, it could ask you how much to scale down the images' dimensions. And so on.

  7. Click Files & Folders in the Library list.Double-click the Find Finder Items action.

    Since you filtered out all the JPEG files in an earlier step, how are you going to gather up all the images you processed with this workflow? As mentioned in Step 3, one of the advantages of appending " (small)" to the images' names is that it's easy to find them using Spotlight—or, in Automator's case, the Find Finder Items action.

    In Find Finder Items, make sure the first Whose pop-up menu is set to Name, and the second is set to "contains." Type (small) in the text box. This'll do a simple Spotlight search for all the files on your computer with "(small)" in their names.

    To make sure you find only the images you processed (and not stray files that happen to have "(small)" in their names), click the + button to add another set of criteria. In the second row of options, select "kind" from the first pop-up menu, "is" from the second, and Image from the third.

    Tip: If you've run this workflow before, this action would find every image you ever processed—a mild inconvenience if you want to examine only the last set of images you selected.You can narrow it down by clicking the + to add another set of criteria that finds, for example, only the files you've created today.

  8. Go back to the Photos folder in the Library list, and drag the Open Images in Preview action to your workflow.

    This action is optional. It makes Preview open at the end of the conversion process and present the newly-shrunken images for your inspection. This step also gives you an indication—besides the standard choo sound that Automator makes—that your workflow has successfully completed its mission.

Note: To show all the processed images in the Finder instead of in Preview—so you can drag them to an email, for example—simply replace the Open Images in Preview action with the Files & Folders rightwards double arrow Reveal Finder Items action.

Save your new workflow for later use, and read on for some neat tricks you can do with it.


doing_more_with_automator.html

7.3. Doing More with Automator

The beauty of Automator is that it's not a static, this-or-nothing program: it's a versatile, expandable tool with ever-increasing potential. There are two particular ways to increase Automator's power beyond using the factory-installed actions: adding more actions yourself, and using the new Watch Me Do feature.

7.3.1. Getting More Action(s)

Automator comes with dozens of actions, but you're bound—eventually—to find yourself wishing that there were a few more. Perhaps you'd like some Automator actions to control non-Apple programs like Photoshop, or you'd just like to have a few extra actions to control Mac OS X itself.

Fortunately, Automator can handle actions written by non-Apple programmers, too. Just visit any of the Web sites devoted to Automator actions (like www.automatorworld.com, www.macscripter.net, or www.automator.us), and download any actions you'd like.

If the action's programmers did their jobs right, you can just download the action, run the installer, and sit back and watch as Mac OS X unpacks, copies, and installs the action automatically. The next time you open Automator, the new action will be listed in the correct folder.

If, on the other hand, the action's programmer did not create a self-installing action, you may have to manually double-click the .dmg, .sit, or .zip file that you downloaded. Inside the folder or disk image that results, you should find a file ending in .action. Drag that file into either your Home rightwards double arrow Library rightwards double arrow Automatorfolder(to install the action for use under only your account) or your Library rightwards double arrow Automator folder (to install the action for all users on your Mac). In either case, if this is the first time you're installing an Automator action by hand, you may have to create the folder yourself.

FREQUENTLY ASKED QUESTION
Checking a Workflow's Progress

Some of these actions take their sweet time. Is there some progress bar that will tell me how far along my workflow is?

Actually, Automator provides two ways to check on the status of your workflow: the simple way (call it "the Indicator") and the Work-flow log.

The Indicator lies in the lower-left corner of the Automator window, next to the Log buttons. When your workflow is running, a little status message appears here to tell you exactly which action is running at the moment. You can use that information, along with some common sense, to figure out how close your workflow is to being finished. If the workflow has run its course, the Indicator says, "Workflow completed."

(You can also identify whatever action is running at this moment, thanks to the spinning-sprocket indicator in its lower-left corner. But if you have a tall stack of actions, you might not be able to see the action that's currently running. The list doesn't automatically scroll.)

The Workflow log is even more powerful. Activate it by clicking the list-like button in the bottom-right corner of the Workflow pane (or by hitting Option- [image] -L). It tells you when each action begins and ends, and it also displays geeky data-conversion information (like when Mac OS X is turning "image files" into plain-vanilla Finder files). And unlike the Indicator, the Workflow log keeps its information around even after your workflow is finished—so you can see how long your entire workflow took to run, for example.

Once in Automator, you can use your new actions just as you'd use the ones that came bundled with your Mac: dragging and dropping them in whatever order you want, customizing their settings, and so on.

Before you run any new actions, though, look at the Description field to discover the actions' inputs and outputs. With that information in hand, you'll never accidentally connect, say, your new Saut é Vegetables action to an unrelated action like Burn a Disc.

And finally, if you're interested in writing your own Automator actions (warning: programming experience necessary), visit http://developer.apple.com/documentation/AppleApplications/Conceptual/AutomatorConcepts/Automator.html for an introduction.

7.3.2. Watch Me Mode

Sometimes, you'll run into a task that Automator can't accomplish with any action, no matter how nicely you ask: opening multiple folders of bookmarks in several Safari windows, for example, or automating some no-name program that doesn't know anything about Automator and doesn't come with any actions.

Enter Watch Me Do. In this mode, new in Leopard, you click a Record button. The Automator window disappears, and a black "Automator: Recording" window takes its place. From now until you hit the Stop button, every mouse click and keystroke is recorded, step by step, into Automator. Later, you can survey the list of steps you took and clean them up.

When you run the workflow, your mouse actually moves to reproduce your clicks, and the Mac actually types the same keystrokes you did. It's like watching a ghost control your computer, or maybe a really annoying little brother who won't stop mimicking you.

You can even manipulate the individual steps—delete one, for example, edit the playback speed, or change how long it takes before the step "times out" (gives up).

It's far easier to create workflows using Watch Me Do than having to drag the correct actions into the correct sequence; you're leaving even more of the programming to Automator.

Unfortunately, there are drawbacks to Watch Me Do, too:

  • The conditions on the screen when you run the action must be identical to the way they were when you recorded. If some window isn't the same size, or in the same position, or if some button isn't where it used to be, the workflow derails.

  • Watch Me Do relies on the Mac's accessibility features—the same ones that form the guts of VoiceOver and other tools for the handicapped— and different programs have been "accessibilitized" to wildly varying degrees. You can record and play back steps that involve System Preferences with amazing success, for example. But operating other programs can be hopeless.

That's why Watch Me Do may seem incredibly flaky. For best results, use keystrokes and keyboard shortcuts as much as possible.

Here's an example.

7.3.2.1. Change your Startup Disk

If you use Boot Camp to run Windows on your Mac (Chapter 8), you may find yourself having to open the Startup Disk pane of System Preferences with alarming frequency. And unfortunately, there's no Change Startup Disk action in Automator to make that job less repetitive.

Fortunately, Watch Me Do can automate the process, so you can switch your startup disk with one click on an Automator-created application on your desktop or Dock. Creating the workflow is simple:

  1. Create a new workflow ( [image] -N). Select Custom from the Starting Points menu, and click Choose.

    Since you're just going to work with Watch Me Do, you want a clean, action-free workflow.

  2. Click the Record button.

    The Automator window disappears, and the black Recording window pops up. Everything you do is being recorded right into Automator.

  3. Click System Preferences in the Dock.

    If System Preferences isn't in your Dock, put it there before beginning the recording. (It's in your Applications folder.) Choosing its name from the

    menu generally doesn't work, thanks to some typical Watch Me flakiness.

  4. In System Preferences, click Startup Disk, and then click either your Windows partition or your Mac partition.

    Later, you can create a second workflow to choose your other disk, if you want.

  5. Click Restart. In the confirmation box, click Restart again.

    Don't worry; you're not actually going to restart right now. Instead, Automator pops to the front, nagging you about the fact that it has an open document with unsaved changes—that is, the workflow you're in the middle of making!

  6. Click Cancel.

    Now Mac OS X tells you that Automator canceled the restart you had asked for. Which, of course, you already know.

  7. Click OK. Click Stop in the Recording window.

    The Automator window reopens with a new Watch Me Do action in your workflow(Figure 7-12). The Events list shows you everything you did, step by step—right down to the clicking of the OK button in step 7. And that step should not be part of the workflow.

  8. Click the final step in the workflow action (which says "Click the 'OK' button") and press Delete.

    When you run the workflow, you'll see your cursor magically move from one step to the next, all by itself (well, with a little help from Automator). It repeats every hesitation, misstep, and pause in your original mouse motion. Fortunately, you can speed up a particular step by up to 10X using the Speed slider (also shown in Figure 7-12).

Figure 7-12. After you've recorded a Watch Me workflow, the steps you took appear here. You can drag them up or down to rearrange them; click one and press Delete to eliminate it; or adjust the Playback Speed slider. For now, delete the unnecessary "Click OK" step.

All in all, the mantra to use when dealing with Automator and Watch Me Do is simple: If you can perform a task with a specific action, use the action. Use the Watch Me mode sparingly.


workflows_as_programs_and_plug-ins.html

7.4. Workflows as Programs and Plug-ins

Building an Automator workflow is a satisfying intellectual exercise and a delicious talent to acquire. But if the point of all the effort is to create a saving, step-saving software robot, there seems to be something missing. Are you really going to open the Automator program just to run a workflow you've written?

Nope. You can save a workflow as a regular, double-clickable application, if you like, or embed it in shortcut menus all over your Mac.

7.4.1. Saving a Workflow as an Application

If you just choose File rightwards double arrow Save, you create an Automator Workflow file (with filename extension .workflow). That's the format of most ready-to-use workflows you'll find online, too.

In the Save As dialog box, however, there's another choice for saving your workflows: as an application (Figure 7-13).

A workflow saved as an application has all the benefits associated with normal Mac OS X programs. You can double-click its Finder icon to launch it, drag it to the Dock for one-click launching, or—with the addition of file-launching shareware like LaunchBar or iKey—even associate a key combination with it so that you can run your workflow with a quick press of a function key.

Figure 7-13. Automator has two choices for workflow formats: Workflow (the default) and Application (the non-default). If you're not sure which format you'll want to use for a particular workflow, you can save it once in each format—the workflow runs equally well either way.

So why wouldn't you just save your workflows as applications all the time? First, workflow applications are much larger than workflow documents—as much as 20 times larger. That's a big deal if you plan to distribute your workflows online or via email.

Also, when a workflow application runs, it doesn't give you access to the Workflow log (see the box on Section 7.3)—a big downside if you want to monitor the progress of your workflow in minute detail. Instead, you get a dinky action indicator in the menu bar, as shown in Figure 7-14.

Figure 7-14. The three-part menu-bar indicator tells you that the workflow application is, in fact, running (the spinning progress indicator)—and, more specifically, which action is running (the text next to it). If you want to cancel a workflow halfway through, click the Stop sign.

Finally, it's a pain to edit a workflow application if something goes wrong; you have to open the whole thing in Automator and resave it.

In any case, if you decide to save a workflow as an application, choose File rightwards double arrow Save As, and then select Application from the pop-up menu at the bottom.

7.4.2. Workflows as Plug-ins

There's one more trick up Automator's sleeve, the best of the bunch: You can turn your workflow into a plug-in that can show up in any of several logical places all over the Mac, right where you want it. For example, workflows can show up in shortcut menus in the Finder, appear in the Script menu of your menu bar (Section 7.5.1), serve as an iCal alarm that runs automatically at a specified time, appear in the Print dialog box to process a document you've just finished, and more.

You'll see all of these options when you choose File rightwards double arrow Save As Plug-in. In the pop-up menu in the resulting dialog box, you'll see these options:

  • Finder. When you save a workflow as a Finder plug-in, a new item, named Automator, appears in the Finder's shortcut menu under More–the one that appears when you Control-click (or right-click) an icon or empty space in the Finder, as shown in Figure 7-15.

    This feature is most useful for Automator workflows that are designed to work with the currently-selected Finder item—for example, if you replace the Ask for Finder Items action with the Get Selected Finder Items action in the "Converting and Renaming Images" example earlier in this chapter. This would resize and convert to JPEG any image files you have selected in the Finder—provided you save the workflow as a Finder plug-in.

    Figure 7-15. The Automator submenu is broken into two parts. Above the divider bar, Create Workflow is just a quick way to jump to Automator and open a new workflow window. Below the divider bar is where the real power lies. Here, you can run any of the workflows you've saved as Finder plug-ins, simply by clicking their names.

  • Folder Actions are workflows that run when you do something to a folder in the Finder–opening it, say, or adding files to it. Folder Actions are extremely powerful for image processing, network backup jobs, and much more, but they're also extremely complicated. For an explanation of the ins and outs, read this chapter's bonus AppleScript appendix (on this book's "Missing CD" page at www.missingmanuals.com ).

  • iCal Alarm is a powerful plug-in format that lets you schedule workflows to run at specific times. When you save a workflow in this format, iCal opens and creates a new event named after your plug-in; you're supposed to drag and edit this event to whatever time and day you want the workflow to run. (You can even use iCal's "repeat" pop-up menu to have the workflow run every day, week, and so on.)

    This is truly a fantastic tool. If you have a workflow that plays an iTunes song, for example, you can easily build an alarm clock using nothing more than iCal alarms.

  • Image Capture is a program for importing photos from a camera or scanner (Section 7.5.1.8). If you save a workflow as an Image Capture plug-in, you can choose to run the workflow whenever you import new photos–so you can easily shrink the new images to a smaller size, for example.

  • Print Workflows show up as menu items inside the Print dialog box's PDF menu Section 14.2.2). If you save a workflow as a Print Workflow plug-in, you can easily run the workflow on a document you're about to print–applying a ColorSync filter to the document to compensate for slight discolorations, for example.

  • The Script Menu, described in Figure 7-16, is a convenient list of AppleScripts. But if you save a workflow using this option, it, too, appears in the Script menu (at the bottom). That's a convenient way to run your favorite workflows any time you want, from within any program.

Now, go forth and automate!

Tip: You can find extra Automator resources, including useful workflows and actions, at sites like www.automatorworld.com, www.automatoractions.com, and, of course, www.apple.com/automator.


getting_started_with_applescript.html

7.5. Getting Started with AppleScript

AppleScript is a powerful computer language that's been around since the days of Mac OS 7. Despite its maturity, however, AppleScript is often criticized by seasoned Mac programmers for being too simple, too easy to learn, and too much like English.

Of course, those are precisely the traits you want in a computer language—assuming, of course, that you want to use a computer language at all. If you're an everyday Mac fan—as opposed to some computer-science Ph.D.—AppleScript is by far the easiest programming language to use for automating your Mac.

You can think of AppleScript programs (called scripts) as software robots. A simple AppleScript might perform some daily task, like backing up your Documents folder. A more complex script can be pages long. In professional printing and publishing, where AppleScript has an army of hard-core fans, a script might connect to a photographer's hard drive elsewhere on the Internet, download a photo from a predetermined folder, color-correct it in Photoshop, import it into a specified page-layout document, print a proof copy, and send a notification email to the editor—automatically.

Even if you're not aware of it, you use the technology that underlies AppleScript all the time. Behind the scenes, numerous components of your Mac communicate with each other by sending Apple Events, which are messages bearing instructions or data that your programs send to each other. When you use the Show Original command for an alias, or the Get Info command for a file or folder, an Apple Event tells the Finder how to respond.

AppleScript has several important advantages over Automator—not least of which is its even greater power. Still, AppleScript is a very deep subject—so deep, in fact, that you'd need an entire book to do it justice. This chapter is an appetizer; a book like AppleScript: The Missing Manual is the seven-course meal.

Tip: You can also download an entire chapter about AppleScript—the chapter that appeared in the previous edition of this book—from this book's "Missing CD" page at www.missingmanuals.com.

7.5.1. The Script Menu

You don't have to create AppleScripts to get mileage out of this technology. Mac OS X comes with several dozen prewritten scripts that are genuinely useful—and all you have to do is choose their names from a menu. "Playing back" an AppleScript in this way requires about as much technical skill as pressing an elevator button.

To sample some of these cool starter scripts, you should first add the Script menu to your menu bar (see Figure 7-16, right).

Figure 7-16. Left: Leopard's starter scripts appear in categories.
Right: To make the Script Menu appear, open Applications rightwards double arrow AppleScript rightwards double arrow Apple-Script Utility; turn on "Show Script Menu in menu bar." Apple-Script Utility puts all of the AppleScript options in one place.

The Script Menu provides 16 premade categories, which incorporate over 100 scripts; just choose a script's name to make it run. Here's a summary of the most useful and fun scripts.

Tip: If you press the Shift key as you choose a script's name from the Script menu, Mac OS X takes you directly to that script's location in the Finder (for example, your Home rightwards double arrow Library rightwards double arrow Scripts folder). Better yet, if you press Option as you choose its name, you open the script in Script Editor for inspection or editing.
7.5.1.1. Address Book Scripts

In this submenu, you'll find Import Addresses, which is designed to move your names and addresses into Mac OS X's Address Book program from Entourage, Outlook Express, Palm Desktop, Eudora, Claris Emailer, or Netscape. If you've got a lot of friends, use this script; you'll be glad that you won't have to re-enter all their names, phone numbers, and email addresses. (The accompanying Address Importers sub-folder offers scripts to import from three specific programs.)

7.5.1.2. Basics

This submenu offers three small, handy scripts related to AppleScript: AppleScript Help (which opens the Help Viewer and searches for the word AppleScript); Apple-Script Web site (which opens the AppleScript Web page in your Web browser); and Open Script Editor (opens the Script Editor program, the program you use to read and write AppleScripts).

7.5.1.3. ColorSync

In this folder, you'll find a bunch of ColorSync script droplets (scripts that run when you drop something on their icons) primarily designed for graphic artists, Web site designers, publishers, and so on.

In some cases, choosing a script's name from the menu produces a terse help message, and then an Open dialog box for choosing the graphics file you want to process.

Others have an immediate effect. The "Mimic PC monitor" script, for example, adjusts the colors of your screen so they closely resemble the slightly different hues of a Windows PC monitor. That's a blessing if you're working on a photo or Web page, and you want to preview how it will look to the unwashed masses. (To restore the original colors, visit the Color tab of the Displays pane of System Preferences.)

POWER USERS' CLINIC
Secrets of the Script Menu

The Script menu reflects the contents of two different Scripts folders: the one in your Home rightwards double arrow Library Scripts folder, and the one in your main Library folder. The ones in your Home folder are listed below the second line in the Script menu.

These scripts aren't just for running. They're also ideal for opening up in Script Editor (just by double-clicking) and analyzing line by line, to learn how they work. Once you understand the syntax, you can then copy bits of the code to modify and use in your own scripts. (Script Editor is a program in your Applications rightwards double arrow AppleScript folder; you can use it to type up your own scripts.)

7.5.1.4. Finder Scripts

All of these scripts have to do with the Finder: manipulating files and windows, for example. A few of the most useful:

  • Add to File Names, Add to Folder Names. These scripts tack on a prefix or suffix to the name of every file or folder in the frontmost Finder window (or, if no windows are open, on the desktop). You could use this script to add the word draft or final or old to all of the files in a certain folder.

  • Replace Text in Item Names lets you do a search-and-replace of text bits inside file names, folder names, or both. When one publisher rejects your 45-chapter book proposal, you could use this script to change all 45 chapter files from, for example, "A History of Mouse Pads—A Proposal for Random House, Chapter 1" to "A History of Mouse Pads—A Proposal for Simon & Schuster, Chapter 1."

  • Trim File Names, Trim Folder Names. If you made a mistake in using the Add to File Names script, you can always use the Trim File Names script to undo the damage. This one removes file extensions, suffixes, or prefixes of your choosing.

For example, suppose you've just made a lot of new folders at once. Mac OS X calls them "untitled folder," "untitled folder 2,"and so on. But what if you'd rather have them just called "folder 1," "folder 2,"and so on? Run the Trim Folder Names script; when the dialog box asks you what you want trimmed, type untitled and click OK.

7.5.1.5. Folder Actions

You probably won't use these scripts much, since Control-clicking a folder (or inside its window) offers the same access to folder actions (Section 7.4.2).

7.5.1.6. Font Book

These scripts are intended to be demonstrations of how you might automate certain font-oriented tasks.

7.5.1.7. FontSync Scripts

FontSync is a noble Apple attempt to solve an old problem for desktop publishers. You finish designing some beautiful newsletter, take it to the local printing shop for printing on a high-quality press, and then have to throw out the entire batch—all because the fonts didn't come out right. The printing shop didn't have exactly the same fonts you had when you prepared the document. Or, worse, it did have the same font—but from a different font company, with the same name but slightly different type characteristics.

FontSync can give you early warning for such disasters. When you run the Create FontSync Profile script, several minutes elapse—and then the Mac generates a Font-Sync Profile document. This file contains staggering amounts of information about the design, spacing, and curlicues of every font installed in your system. When you hand that profile over to your print shop, they can drop it onto the accompanying script, called Match FontSync Profile. It tells them precisely what fonts are different on their Macs and yours.

The wishful-thinking aspect of this technology is, of course, that it assumes a lot: that your print shop uses a Mac; that the print shop knows how to use FontSync; and that you remember to create the profile and submit it.

7.5.1.8. iChat

iChat in 10.5 was given a major overhaul, and Apple added tons of fun (if not always useful) features. Among them: You can now run AppleScripts as Alerts when a certain buddy Event takes place. For example, you can auto-accept chat invitations from certain buddies, or even auto-answer them with a canned greeting. You can even control one Mac's music playback by typing commands into the iChat window of another one, elsewhere in the house.

See Section 7.5.1.8 for details.

7.5.1.9. Info Scripts

These two scripts offer minor usefulness. Current Date & Time displays the current date and time in a dialog box, complete with a Clipboard button that copies the information, ready for pasting. Font Sampler creates a handy printable cheat sheet, suitable for posting on your wall, that includes every one of your fonts illustrated in a sentence. (It's less useful now that Font Book has similar printout-generating commands built right in.)

7.5.1.10. Internet Services

Two scripts in this submenu merit special mention. Current Temperature by Zipcode gives you the temperature outside your house—in Fahrenheit and Celsius. It's just one more reason to stay inside all day.

Stock Quote fetches a 20-minute delayed stock quote for the company of your choice. It's not as good as getting real-time quotes, but hey, it's free.

7.5.1.11. Mail Scripts

Most of the scripts in this submenu do nuts-and-bolts things like counting messages in your mailboxes or setting up a new email account. The one that's the most fun, though, is Crazy Message Text (Figure 7-17).

7.5.1.12. Navigation Scripts

This subfolder's scripts let you jump to special folders in the Finder, right from the menu bar within any program. If the folder you want to open doesn't have its own dedicated script, choose from the listing in Open Special Folder.

Tip: If you're game to edit this script in Script Editor, you can modify it to let you choose and open more than one folder simultaneously (by [image] -clicking them, for example). Just type multiple selections allowed true right after the text Choose folder to open: (which appears at the end of a line about a third of the way down the script). Save your changes.

Figure 7-17. Top: Enter your text in the Crazy Message Text dialog box. You can customize the range of font sizes in the message by clicking Set Prefs.
Bottom: Once you click Continue, you end up with a randomlyformatted jumble of text, perfect for avoiding handwriting detection. This script offers a great way to send electronic greeting cards, birthday wishes, or ransom notes.

7.5.1.13. Printing Scripts

These scripts are designed to illustrate the power of AppleScript when it comes to printing and generating PostScript or PDF documents.

One of them, Print Window, plugs a long-standing hole in Mac OS X. It's designed to print a textual list of what's in any folder you choose. (It's a tad buggy, however.)

7.5.1.14. Script Editor Scripts

As the About these scripts command tells you, these 48 canned scripts can help you write faster and more accurate scripts, because the code chunks are free of typos and syntax errors. As you progress, you can add your own code-building scripts here, customized for the kind of scripts you like to build, to make you even more productive. (While writing your script in Script Editor, you insert one of these code chunks by Control-clicking and choosing from the shortcut menu.)

7.5.1.15. UI Element Scripts

Much of the time, scripts perform their magic quietly in the background, out of sight. But if you're trying to automate a program that doesn't respond to the usual AppleScript commands, your scripts can now "operate" them manually by making your Mac think you've clicked menu commands, clicked buttons, and so on.

Note: This feature, called UI (user-interface) scripting, doesn't work until you first open the Universal Access panel of System Preferences and make sure that "Enable access for assistive devices" is turned on.

You wouldn't want to run the scripts in the UI Element Scripts folder just as they are; they're simply samples that show you the correct syntax.

7.5.1.16. URLs

This final set of scripts provides quick links to common Web sites. All, that is, except Download Weather Map, which fetches an up-to-the-minute weather map of the continental United States, saves it on your desktop as eathermap.jpg, and then opens it in Preview for your inspection.

Tip: You can add scripts, files, and even Internet location files (Section 18.7) to the Script Menu, so you can easily launch them all from the menu bar. Anything you drop into the Library rightwards double arrow Scripts folder automatically shows up in the Script menu.On the other hand, if you start adding a lot of your own stuff to the Script menu, you might wish that all Apple's own sample scripts didn't appear there. No problem. Open AppleScript Utility and turn off "Show Computer scripts."

7.5.2. Working with Existing AppleScripts

As you'll quickly realize from using the Script menu, your Mac is teeming with dozens of free, built-in scripts. The best part, though, is that you can see—and even change—how they work, to help you learn more about how to write your own Apple-Scripts. You can even copy sections from Apple's scripts wholesale and use them in your own scripts.

The first step in working with a script, of course, is opening it up. The easiest way is to open the Script menu, point to the category you want, and then Option-click a script's name to open it.

When you're just learning AppleScript, you might as well start by looking at a simple script. Open, for example, the New Application Window script (in the category called Navigation Scripts), by Option-clicking its name. Script Editor opens the file in a new window (Figure 7-18).

Figure 7-18. If you've never seen an AppleScript before, you may be surprised at how simple it looks. As you can probably guess from the commands in the window, this script simply opens the Applications folder in the Finder.

Here's how the script works:

  • tell application "Finder" tells Mac OS X which program is supposed to obey the following commands.

  • activate brings the Finder to the foreground, much as you would by clicking its Dock icon.

  • open folder "Applications" of the startup disk tells the Finder to open a new window, displaying the Applications folder on your main hard drive.

  • end tell directs the Finder to go about its regular business, ignoring further Apple-Script commands.

To test the script, click the Run button, or press [image] -R.

Tip: You can also edit this script to suit your needs. Try replacing "Applications" with "Users," for example, to make the script open the Users folder instead.

7.5.3. Writing Your Own Scripts

Mac OS X comes stocked with dozens of programs—everything but the kitchen sink. All right, everything but the kitchen sink and a metronome. How are you ever going to play the piano in even rhythm without a steady clicking sound provided by your Mac? Sure, sure, you can use GarageBand's metronome in a pinch, but that's like using an industrial pile driver to kill an ant.

Instead, you can use AppleScript to do the job for you. Open a new document in Script Editor (File rightwards double arrow New, or [image] -N), and type this:

    display dialog "Welcome to the AppleScript Metronome"
    set bpm to the text returned of (display dialog -
    "How many beats per minute?" default answer 60)
    set pauseBetweenBeeps to (60 / bpm)
    repeat
    beep
    delay pauseBetweenBeeps
    end repeat

Note: Don't actually type the - character. That's programmerese for, "This is really all supposed to be on the same line, but I ran out of space on the page."

When you run this script, you'll see a dialog box that asks how many beats per minute you want the metronome to tick. Whatever number you type (for example, 120) gets stored in a variable—a temporary holding tank within the script—that you've named bpm.

Next, the script calculates how long it must pause between beeps, and puts that fraction of a second into the "pauseBetweenBeeps." If you told the script to beep 120 times per minute, for example, "pauseBetweenBeeps" would be 0.5, since the script would have to pause half a second between beeps.

Finally, the script creates an endlessly repeating loop: beeping, pausing for the proper period, and then repeating.

Click Run to test out your script, and click Stop when you've had enough beeping.

DAVE'S FAVES
One-Click Attachments from the Desktop

Here's a little Automator trick that can be a lifesaver for anyone who must frequently send documents by email. (It simulates the Send To command in the shortcut menus of Windows machines—which is very, very handy.)

In Automator, build a workflow consisting of only two steps: Get Selected Finder Items (in the Finder category) and New Mail Message (in the Mail category).

If you're always sending files to the same person—your boss, say—you can even specify the address, right there in the Automator workflow pane. You can even set up the subject line and message ahead of time, if your job is really that repetitive.

Now choose File rightwards double arrow Save As Plug-In. Name it Email This, or something.

From now on, you can email a document in the Finder just by Control-clicking it and, from the shortcut menu, choosing Automator rightwards double arrow Email This.

Boom: Mac OS X fires up Mail and creates an outgoing message with the file already attached.

Bonus tip: If you insert another Automator step in between the other two—a Create Archive action (from the Finder category), your shortcut menu will compress the file or folder as a .zip file before emailing it!

Tip: To make your script even cooler, turn on the System Preferences rightwards double arrow Universal Access rightwards double arrow Hearing rightwards double arrow "Flash the screen when an alert sound occurs" checkbox. Now when you run your script, you'll get both an audible beep and a visual flash. If you're recording music, just mute your Mac; you'll keep the visual metronome but you won't hear the beeps anymore.

7.5.4. AppleScript vs. Automator

AppleScript has hundreds and hundreds of uses: automating layout workflows that are too complicated for Automator, controlling programs that Automator doesn't recognize, and programming things that Automator can't handle.

Yet if all you do is look at AppleScript as a second choice to Automator, you're missing out on a lot of power. Truth is, AppleScript lets you do more than Automator will probably let you do in the next 10 years; it's just a lot geekier.

In the end, stick with Automator for simple things. If you need to use AppleScript to automate some aspect of your Mac, though, take pride; you're stepping up to a true power tool. (You can even combine the two, building AppleScripts right into your Automator workflows, thanks to the Run AppleScript action.)

Happy automating!


windows_on_macintosh.html

Chapter 8. Windows on Macintosh

The very moment Apple announced in 2006 that all new Mac models would come with Intel chips inside, the geeks and the bloggers started going nuts. "Let's see," they thought. "Macs and PCs now use exactly the same memory, hard drives, monitors, mice, keyboards, networking protocols, and processors. By our calculations, it ought to be possible make a Mac run Windows!"

Now, some in the Cult of Macintosh were baffled by the very idea. Who on earth, they asked, wants to pollute the magnificence of the Mac with a headache like Windows?

Lots of people, as it turns out. Think of all the potential switchers who are tempted by the Mac's sleek looks, yet worry about leaving Windows behind entirely. Or the people who love Apple's iLife programs, but have jobs that rely on Microsoft Access, Outlook, or some other piece of Windows corporate ware. Even true-blue Mac fans occasionally look longingly at some of the Windows-only games, Web sites, palmtop sync software, or movie download services they thought they'd never be able to use.

So hackers set about trying to make Windows run on Intel Macs almost immediately. But they were wasting their time; within weeks, Apple did the job for them—by inventing Boot Camp.

Actually, today, there are two ways to run Windows on a Mac with an Intel chip:

  • Restart it in Boot Camp. After over a year as a free public-beta program, Boot Camp is finally complete as a new Leopard feature. In short, Boot Camp lets you restart your Mac into Windows.

    At that point, it's a full-blown Windows PC, with no trace of the Mac on the screen. It runs at 100 percent of the speed of a real PC, because it is one. Compatibility with Windows software is excellent. The only drag is that you have to restart the Macagain to return to the familiar world of Mac OS X and all your Mac programs and files.

  • Run Windows in a window.For $80 or so, you can eliminate the Boot Camp Bummer—the business of having to restart the Mac every time you want to switch its operating-system personality. You can buy a program like Parallels, VMWare Fusion, or VirtualBox, which lets you run Windowsin a window.

    You're still running Mac OS X, and all your Mac files and programs are still available. But you've got a parallel universe—Microsoft Windows—running in a window simultaneously.

    Compared with Boot Camp, thisvirtualization software offers only 90 percent of the speed and 90 percent of the software compatibility. But for thousands of people, the convenience of eliminating all those restarts—and gaining the freedom to copy and paste documents between Mac OS X and Windows programs—makes the Windows-in-a-window solution nearly irresistible.

Tip: There's nothing wrong with usingboth on the same Mac, by the way. In fact, the Parallels-type programs can use the same copy of Windows as Boot Camp, so you save disk space and don't have to manage two different Windows worlds.

Both techniques require you to provide your own copy of Windows. And both are described on the following pages.

FREQUENTLY ASKED QUESTION
The Virus Question

Doesn't running Windows on my Mac mean that I'll be exposed to the nightmare world of viruses and spyware, just like the rest of the Windows world?

As a matter of fact, yes.

If you install Windows on your Mac, you should also install Windows antivirus and antispyware software to protect that half of the computer. The world is crawling with commercial programs that do the job; ironically, one of the easiest and least expensive is Microsoft's OneCare Live ($50 a year for up to three computers). There are also lots of free programs, like Microsoft Defender for spyware, and either AVG Antivirus (www.free.grisoft.com) or Avast Antivirus (www.avast.com) for viruses.

The good news is even if your Windows installation gets infected, the Mac side of your computer is unaffected. Just as Mac OS X can't run Windows-only software like, say, Dragon Naturally Speaking, so it can't run Windows virus software.

Some people, therefore, run Windows naked—without virus protection (especially when using Windows-in-a-window programs like Parallels and VMWare Fusion). If a virus does strike, no big deal; they drag the infected copy of Windows to the Trash and just install a fresh one!

Note: Remember, running Windows smoothly and fast requires a Mac with an Intel chip inside. To find out if yours does, choose [image] rightwards double arrow About This Mac. In the resulting dialog box, you'll see, next to the label Processor, either "Intel" something or "PowerPC."If your Mac has a PowerPC chip, skip this chapter. Thereare programs that let you run Windows, but excruciatingly slowly. Frankly, it's not worth the effort.

8.1. Boot Camp

To set up Boot Camp, you need the proper ingredients:

  • An Intel-based Mac. All Mac models introduced in 2006 and later have Intel chips inside. If you're not sure, choose [image] rightwards double arrow About This Mac; if the Processor line says something about Intel, you're good to go

  • A copy of Windows XP or Windows Vista. Windows XP needs Service Pack 2. If you have an earlier copy, you're nottotallyout of luck, but you'll need a hacky approach that you can find online. Let Google be your friend.

    For Windows Vista, you need the Home Basic, Home Premium, Business, or Ultimate Edition. In both cases, an Upgrade disc won't work; you need a full-installation copy. Also, Boot Camp requires the normal 32-bit editions of Windows. The fancy 64-bit versions won't work.

  • At least 10 gigs of free hard drive space.

Then you're ready to proceed.

Note: If you've already been using the public-beta version of Boot Camp, you don't have to follow the procedure below. Instead, start up the Mac in Windows, and then insert your Leopard DVD. The driver installation should begin automatically. When the installer asks you, click Repair. Skip down to "Forth and Back, Windows/Mac," on Section 8.1.2.

8.1.1. Installing Boot Camp

Open your Applications rightwards double arrow tilities folder. Inside, open the program called Boot Camp Assistant.

8.1.1.1. Phase 1: Partition your drive

On the Introduction screen, you can print the instruction booklet, if you like (although the following pages contain the essential info). There's a lot of good, conservative legalese in that booklet: the importance of backing up your whole Mac before you begin, for example.

When you click Continue, you get the dialog box shown in Figure 8-1—the most interesting part of the whole process.

You're being asked topartition—subdivide—your hard drive (which can't be partitioned already), setting aside a certain amount of space that will hold your copy of Windows and all the PC software you decide to install. This partitioning process doesn't involve erasing your whole hard drive; all your stuff is perfectly safe.

The dialog box offers handy buttons like Divide Equally and Use 32 Gigs, but it also lets you drag a space-divider handle, as shown in Figure 8-1, to divide up your drive space between the Mac and Windows sides.

Figure 8-1. How much hard drive space do you want to dedicate to your "PC"? It's not an idle question; whatever you give Windows is no longer available for your Mac. Drag the vertical handle between the Mac and Windows sides of this diagram.

Here's where things get tricky, though. If you choose an amount less than 32 gigabytes for the Windows partition, the Windows XP installer lets you choose between two Windows drive formats:

  • FAT32. This unappetizingly named scheme is older and, if you ask power users and network nerds, more limited. For example, it's only available on disks smaller than 32 gigabytes.

    But the advantage of using FAT32 is that, when it's all over, you'll be able to drag files back and forth from the Windows side to the Mac side.(This works only when you're in Mac OS X; when you're in Windows, you can't see the Mac side of the hard drive without a commercial program like MacDrive [www.macdrive.com].)

  • NTFS. If you choose a partition sizegreater than 32 GB, youmust use the NT File System. It's a more modern, flexible formatting scheme—it offers goodies like fileby-file access permissions, built-in file compression and encryption, journaling (Section B.6.2.1), and so on.

    But on a Boot Camp Mac, NTFS is a drag. It means that when you're running from the Mac side, you can see what's on the Windows partition, but can't add, remove, or change any files.

Note: All this applies only to Windows XP. Windows Vistaalways uses NTFS. You don't have a choice. Bummer.

Most people choose to dedicate a swath of the main internal hard drive to the Windows partition. But if you have a second internal hard drive, you can also choose one of these options:

  • Create a Second Partition. The Boot Camp Assistant carves out a Windows partition fromthat drive.

  • Erase Disk and Create a Single Partition for Windows.Just what it says.

8.1.1.2. Phase 2: Install Windows

On the Start Windows Installation screen, you're supposed to—hey!—start the Windows installation. Grab your Windows XP or Vista CD or DVD and slip it into the Mac. Its installer goes to work immediately.

Following the "I agree to whatever Microsoft's lawyers say" screen, Microsoft's installer asks partition you want to put Windows on. It'sreally important to pick the right one. Play your cards wrong, and you could erase your wholeMac partition. So:

  • Windows XP. Choose the partition (by pressing the up or down arrow keys) called "C: Partition3 <BOOTCAMP>."

  • Windows Vista. Choose the one called "Disk 0 Partition 3 BOOTCAMP."

When you press Enter ,you now encounter another frightening-looking screen (Figure 8-2). Here, Windows invites you to format the new partition.

Figure 8-2. Use the arrow keys to highlight either "Format the partition using the NTFS file system (Quick)" or "Format the partition using the FAT file system (Quick)." Then press Enter. On the following screen, type F to confirm the formatting, then Enter to confirm the whole thing.

  • Windows XP.If your Windows partition is less than 32 gigs, you get to choose between FAT32 or NTFS—a decision that, presumably, you've already made, having read the previous pages. Proceed as shown in Figure 8-2.

  • Windows Vista.Click "Drive options (advanced)," click Format, click OK, and finally click Next. Your Windows partition is now formatted for NTFS, like it or not.

8.1.1.3. Phase 3: Install the drivers

Now a crazy, disorienting sight presents itself: Your Mac, running Windows. There's no trace of the familiar desktop, Dock, or [image] menu; it's Windows now, baby.

Walk through the Windows setup screens, creating an account, setting the time, and so on.

At this point, your Mac is actually a true Windows PC. You can install and run Windows programs, utilities, and even games; you'll discover that they runreally fast and well.

But as Windows veterans know, every hardware feature of a Windows requires adriver—a piece of software that tells the machine how to communicate with its own monitor, networking card, speakers, and so on. And it probably goes without saying that Windows doesn't include any drivers forApple's hardware components.

That's why, at this point, you're supposed to insert your Leopard installation DVD; it contains all of the drivers for the Mac's graphics card, Ethernet and AirPort networking, audio input and output, AirPort wireless antenna, iSight camera, brightness and volume keys, Eject key, and Bluetooth transmitter. When this is all over, your white Apple remote control will even work to operate iTunes for Windows.

WORKAROUND WORKSHOP
How To Right-Click

Every Windows computer comes with a two-button mouse. The left button clicks normally; the right button summons a shortcut menu containing commands for whatever you clicked. The Mac has shortcut menus, too, of course, but they're not nearly as necessary as they are in Windows, where the shortcut menu is often theonly place you'll find a certain command.

So when you're running Windows on your Mac, how are you supposed to right-click?

Well, you could get yourself a two-button mouse, of course. It works fine on a Mac (in Windows or Mac OS X). In fact, most desktop Macs sold since 2006 comewith two-button mouse, called the Mighty Mouse. It doesn'tappear to have two buttons, but you can actually click two different spots on its sloping far side. See Section 9.14.3 for instructions on turning this feature on. The Mighty Mouse works fine for right-clicking in Windows.

If you have a recent Mac laptop, you can trigger a right-click using a sneaky trick:put two fingertips on the trackpad, and then click the button. (That's an option you can turn on or off in the Keyboard & Mouse panel of System Preferences.)

Alternatively, if that's too much to learn, just highlight whatever you want to right-click and then press Shift-F10.

If you're stuck with a one-button Mac mouse, and none of these options works for you, use the Apple Mouse Utility program for Windows. (You can download it from this book's "Missing CD" page at www.missingmanuals.com.) It lets you Control-click to simulate a right-click while you're running Windows.

(It also installs a new Control Panel icon and system-tray pop-up menu, as described later in this chapter.)

Note: Unbeknownst to you, this DVD is actually a dual-mode disc. When you insert it into a Mac running Mac OS X, it appears as the Leopard installer you know and love. But when you slip it into a PC, its secret Windows partition appears—and automatically opens the Mac driver installer!

When you insert the Leopard disc, the driver installer opens and begins work automatically. Click past the Welcome and License Agreement screens, and then click Install. You'll see a lot of dialog boxes come and go; just leave it alone (and don't click Cancel).

A few words of advice:

  • If you see, "The software you are installing has not passed Windows Logo testing," click Continue Anyway. (As if Apple's going to pay Microsoft to have its software certified for quality!)

  • If the installation seems to stall, Windows may be waiting for you to click OK or Next in a window that's hidden behind other windows. Inspect the taskbar and look behind open windows.

  • Windows XP concludes by presenting the Found New Hardware Wizard. Go ahead and agree to update your drivers.

When it's all over, a dialog box asks you to restart the computer; click Restart. When the machine comes to, it's a much more functional Windows Mac. (And it has an online Boot Camp Help window waiting for you on the screen.)

8.1.2. Forth and Back, Windows/Mac

From now on, your main interaction with Boot Camp will be telling it what kind of computer you want your Mac to be today: a Windows machine or a Mac.

Presumably, though, you'll prefer one operating systemmost of the time. Figure 8-3 (top and middle) shows how you specify your favorite.

Tip: If you're running Windows and you just want to get back to Mac OS X right now, you don't have to bother with all the steps shown in Figure 8-3. Instead, click the Boot Camp system-tray icon and, from the shortcut menu, choose Restart in Mac OS X.

From now on, each time you turn on the Mac, it starts up in the operating system you've selected.

If you ever need to switch—when you need Windows just for one quick job, for example—press Option key as the Mac is starting up. You'll see something like the icons shown in Figure 8-3 (bottom).

Tip: To upgrade to Windows Vista: Restart your Mac using Windows. Insert your Vista installation or upgrade disc.Follow the instructions that came with Vista.

Figure 8-3. Top: To choose your preferred operating system—the one that starts up automatically unless you intervene—choose rightwards double arrow System Preferences. Click Startup Disk, and then click the icon for either Mac OS X or Windows. Next, either click Restart (if you want to switch right now) or close the panel.
The identical controls are available when you're running Windows, thanks to the new Boot Camp Control Panel.
Middle: To open the Boot Camp control panel, choose its name from its new icon in the Windows system tray.
Bottom: This display, known as the Startup Manager, appears when you press Option during startup. It displays all the disk icons, or disk partitions, that contain bootable operating systems. Just click the name of the partition you want, and then click the Continue arrow.

8.1.3. Keyboard Translation Guide

Now, if you really want to learn about Windows, you needWindows XP: The Missing Manual (available in Home and Pro editions) orWindows Vista : The Missing Manual.

But suggesting that you go buyanother book would be tacky. So here's just enough to get by.

First of all, a Mac keyboard and a Windows keyboard aren't the same. Each has keys that would strike the other as extremely goofy. Still, you can trigger almost any keystroke that Windows is expecting by substituting special Apple-keyboard strokes, like this:

Windows Keystroke | Apple keyboard
Control-Alt-Delete | Control-Option-Delete
Alt | Option
Backspace | Delete
Delete (forward delete) | (on laptops, Fn-Delete)
Enter | Return or Enter
Num lock | Clear (laptops; Fn-F6)
Print Screen | F14 (laptops: Fn-F11)
Print active window | Option-F14 (laptops: Option-Fn-F11)
Alt key | Option key
key | T

The keyboard shortcuts in your programs aremostly the same as on the Mac, but you have to substitute the Ctrl key for the [image] key. So in Windows programs, Copy, Save, and Print are Ctrl-C, Ctrl-S, and Ctrl-P.

Similarly, the Alt key is the Windows equivalent of the Option key.

Tip: You know that awesome two-finger scrolling trick on Mac laptops (Section 9.14.3.1)? Guess what? It works when you're running Windows, too.

8.1.4. Boot Camp Tip-O-Rama

And now, the finer points of Boot Camp…

  • When you're running Mac OS X, you can get to the documents you created while you were running Windows, which is a huge convenience. Just double-click the Windows disk icon (called NO NAME or Untitled), and then navigate to the Documents and Settings rightwards double arrow [your account name] rightwards double arrow My Documents (or Desktop).

    If you formatted your Windows XP partition using the FAT format as described earlier, you can copy files toor from this partition, and even open them up for editing on the Mac side. If you used NTFS, though, you can only copy themto the Mac side, or open them without the ability to edit them.

    Tip: Actually, there's no reason your Windows "drive" has to be called NO NAME or Untitled. You can rename it as you would any other icon, either in Windows or in Mac OS X. (That's if you used the FAT format. If you used NTFS, you can't change the name in Mac OS X.)

  • On the other hand, while you're running Windows, you generally can't access your Mac files; Windows doesn't even see theMac hard drive.

    One way to around this is to buy a $50 program called MacDrive (www.mediafour.com).

    Another solution: use a disk that both Mac OS X and Windows "see," and keep your shared files onthat. A flash drive works beautifully for this. So does your iDisk (Section 18.6.1) or a shared drive on the network.


boot_camp.html

Chapter 8. Windows on Macintosh

The very moment Apple announced in 2006 that all new Mac models would come with Intel chips inside, the geeks and the bloggers started going nuts. "Let's see," they thought. "Macs and PCs now use exactly the same memory, hard drives, monitors, mice, keyboards, networking protocols, and processors. By our calculations, it ought to be possible make a Mac run Windows!"

Now, some in the Cult of Macintosh were baffled by the very idea. Who on earth, they asked, wants to pollute the magnificence of the Mac with a headache like Windows?

Lots of people, as it turns out. Think of all the potential switchers who are tempted by the Mac's sleek looks, yet worry about leaving Windows behind entirely. Or the people who love Apple's iLife programs, but have jobs that rely on Microsoft Access, Outlook, or some other piece of Windows corporate ware. Even true-blue Mac fans occasionally look longingly at some of the Windows-only games, Web sites, palmtop sync software, or movie download services they thought they'd never be able to use.

So hackers set about trying to make Windows run on Intel Macs almost immediately. But they were wasting their time; within weeks, Apple did the job for them—by inventing Boot Camp.

Actually, today, there are two ways to run Windows on a Mac with an Intel chip:

  • Restart it in Boot Camp. After over a year as a free public-beta program, Boot Camp is finally complete as a new Leopard feature. In short, Boot Camp lets you restart your Mac into Windows.

    At that point, it's a full-blown Windows PC, with no trace of the Mac on the screen. It runs at 100 percent of the speed of a real PC, because it is one. Compatibility with Windows software is excellent. The only drag is that you have to restart the Macagain to return to the familiar world of Mac OS X and all your Mac programs and files.

  • Run Windows in a window.For $80 or so, you can eliminate the Boot Camp Bummer—the business of having to restart the Mac every time you want to switch its operating-system personality. You can buy a program like Parallels, VMWare Fusion, or VirtualBox, which lets you run Windowsin a window.

    You're still running Mac OS X, and all your Mac files and programs are still available. But you've got a parallel universe—Microsoft Windows—running in a window simultaneously.

    Compared with Boot Camp, thisvirtualization software offers only 90 percent of the speed and 90 percent of the software compatibility. But for thousands of people, the convenience of eliminating all those restarts—and gaining the freedom to copy and paste documents between Mac OS X and Windows programs—makes the Windows-in-a-window solution nearly irresistible.

Tip: There's nothing wrong with usingboth on the same Mac, by the way. In fact, the Parallels-type programs can use the same copy of Windows as Boot Camp, so you save disk space and don't have to manage two different Windows worlds.

Both techniques require you to provide your own copy of Windows. And both are described on the following pages.

FREQUENTLY ASKED QUESTION
The Virus Question

Doesn't running Windows on my Mac mean that I'll be exposed to the nightmare world of viruses and spyware, just like the rest of the Windows world?

As a matter of fact, yes.

If you install Windows on your Mac, you should also install Windows antivirus and antispyware software to protect that half of the computer. The world is crawling with commercial programs that do the job; ironically, one of the easiest and least expensive is Microsoft's OneCare Live ($50 a year for up to three computers). There are also lots of free programs, like Microsoft Defender for spyware, and either AVG Antivirus (www.free.grisoft.com) or Avast Antivirus (www.avast.com) for viruses.

The good news is even if your Windows installation gets infected, the Mac side of your computer is unaffected. Just as Mac OS X can't run Windows-only software like, say, Dragon Naturally Speaking, so it can't run Windows virus software.

Some people, therefore, run Windows naked—without virus protection (especially when using Windows-in-a-window programs like Parallels and VMWare Fusion). If a virus does strike, no big deal; they drag the infected copy of Windows to the Trash and just install a fresh one!

Note: Remember, running Windows smoothly and fast requires a Mac with an Intel chip inside. To find out if yours does, choose [image] rightwards double arrow About This Mac. In the resulting dialog box, you'll see, next to the label Processor, either "Intel" something or "PowerPC."If your Mac has a PowerPC chip, skip this chapter. Thereare programs that let you run Windows, but excruciatingly slowly. Frankly, it's not worth the effort.

8.1. Boot Camp

To set up Boot Camp, you need the proper ingredients:

  • An Intel-based Mac. All Mac models introduced in 2006 and later have Intel chips inside. If you're not sure, choose [image] rightwards double arrow About This Mac; if the Processor line says something about Intel, you're good to go

  • A copy of Windows XP or Windows Vista. Windows XP needs Service Pack 2. If you have an earlier copy, you're nottotallyout of luck, but you'll need a hacky approach that you can find online. Let Google be your friend.

    For Windows Vista, you need the Home Basic, Home Premium, Business, or Ultimate Edition. In both cases, an Upgrade disc won't work; you need a full-installation copy. Also, Boot Camp requires the normal 32-bit editions of Windows. The fancy 64-bit versions won't work.

  • At least 10 gigs of free hard drive space.

Then you're ready to proceed.

Note: If you've already been using the public-beta version of Boot Camp, you don't have to follow the procedure below. Instead, start up the Mac in Windows, and then insert your Leopard DVD. The driver installation should begin automatically. When the installer asks you, click Repair. Skip down to "Forth and Back, Windows/Mac," on Section 8.1.2.

8.1.1. Installing Boot Camp

Open your Applications rightwards double arrow tilities folder. Inside, open the program called Boot Camp Assistant.

8.1.1.1. Phase 1: Partition your drive

On the Introduction screen, you can print the instruction booklet, if you like (although the following pages contain the essential info). There's a lot of good, conservative legalese in that booklet: the importance of backing up your whole Mac before you begin, for example.

When you click Continue, you get the dialog box shown in Figure 8-1—the most interesting part of the whole process.

You're being asked topartition—subdivide—your hard drive (which can't be partitioned already), setting aside a certain amount of space that will hold your copy of Windows and all the PC software you decide to install. This partitioning process doesn't involve erasing your whole hard drive; all your stuff is perfectly safe.

The dialog box offers handy buttons like Divide Equally and Use 32 Gigs, but it also lets you drag a space-divider handle, as shown in Figure 8-1, to divide up your drive space between the Mac and Windows sides.

Figure 8-1. How much hard drive space do you want to dedicate to your "PC"? It's not an idle question; whatever you give Windows is no longer available for your Mac. Drag the vertical handle between the Mac and Windows sides of this diagram.

Here's where things get tricky, though. If you choose an amount less than 32 gigabytes for the Windows partition, the Windows XP installer lets you choose between two Windows drive formats:

  • FAT32. This unappetizingly named scheme is older and, if you ask power users and network nerds, more limited. For example, it's only available on disks smaller than 32 gigabytes.

    But the advantage of using FAT32 is that, when it's all over, you'll be able to drag files back and forth from the Windows side to the Mac side.(This works only when you're in Mac OS X; when you're in Windows, you can't see the Mac side of the hard drive without a commercial program like MacDrive [www.macdrive.com].)

  • NTFS. If you choose a partition sizegreater than 32 GB, youmust use the NT File System. It's a more modern, flexible formatting scheme—it offers goodies like fileby-file access permissions, built-in file compression and encryption, journaling (Section B.6.2.1), and so on.

    But on a Boot Camp Mac, NTFS is a drag. It means that when you're running from the Mac side, you can see what's on the Windows partition, but can't add, remove, or change any files.

Note: All this applies only to Windows XP. Windows Vistaalways uses NTFS. You don't have a choice. Bummer.

Most people choose to dedicate a swath of the main internal hard drive to the Windows partition. But if you have a second internal hard drive, you can also choose one of these options:

  • Create a Second Partition. The Boot Camp Assistant carves out a Windows partition fromthat drive.

  • Erase Disk and Create a Single Partition for Windows.Just what it says.

8.1.1.2. Phase 2: Install Windows

On the Start Windows Installation screen, you're supposed to—hey!—start the Windows installation. Grab your Windows XP or Vista CD or DVD and slip it into the Mac. Its installer goes to work immediately.

Following the "I agree to whatever Microsoft's lawyers say" screen, Microsoft's installer asks partition you want to put Windows on. It'sreally important to pick the right one. Play your cards wrong, and you could erase your wholeMac partition. So:

  • Windows XP. Choose the partition (by pressing the up or down arrow keys) called "C: Partition3 <BOOTCAMP>."

  • Windows Vista. Choose the one called "Disk 0 Partition 3 BOOTCAMP."

When you press Enter ,you now encounter another frightening-looking screen (Figure 8-2). Here, Windows invites you to format the new partition.

Figure 8-2. Use the arrow keys to highlight either "Format the partition using the NTFS file system (Quick)" or "Format the partition using the FAT file system (Quick)." Then press Enter. On the following screen, type F to confirm the formatting, then Enter to confirm the whole thing.

  • Windows XP.If your Windows partition is less than 32 gigs, you get to choose between FAT32 or NTFS—a decision that, presumably, you've already made, having read the previous pages. Proceed as shown in Figure 8-2.

  • Windows Vista.Click "Drive options (advanced)," click Format, click OK, and finally click Next. Your Windows partition is now formatted for NTFS, like it or not.

8.1.1.3. Phase 3: Install the drivers

Now a crazy, disorienting sight presents itself: Your Mac, running Windows. There's no trace of the familiar desktop, Dock, or [image] menu; it's Windows now, baby.

Walk through the Windows setup screens, creating an account, setting the time, and so on.

At this point, your Mac is actually a true Windows PC. You can install and run Windows programs, utilities, and even games; you'll discover that they runreally fast and well.

But as Windows veterans know, every hardware feature of a Windows requires adriver—a piece of software that tells the machine how to communicate with its own monitor, networking card, speakers, and so on. And it probably goes without saying that Windows doesn't include any drivers forApple's hardware components.

That's why, at this point, you're supposed to insert your Leopard installation DVD; it contains all of the drivers for the Mac's graphics card, Ethernet and AirPort networking, audio input and output, AirPort wireless antenna, iSight camera, brightness and volume keys, Eject key, and Bluetooth transmitter. When this is all over, your white Apple remote control will even work to operate iTunes for Windows.

WORKAROUND WORKSHOP
How To Right-Click

Every Windows computer comes with a two-button mouse. The left button clicks normally; the right button summons a shortcut menu containing commands for whatever you clicked. The Mac has shortcut menus, too, of course, but they're not nearly as necessary as they are in Windows, where the shortcut menu is often theonly place you'll find a certain command.

So when you're running Windows on your Mac, how are you supposed to right-click?

Well, you could get yourself a two-button mouse, of course. It works fine on a Mac (in Windows or Mac OS X). In fact, most desktop Macs sold since 2006 comewith two-button mouse, called the Mighty Mouse. It doesn'tappear to have two buttons, but you can actually click two different spots on its sloping far side. See Section 9.14.3 for instructions on turning this feature on. The Mighty Mouse works fine for right-clicking in Windows.

If you have a recent Mac laptop, you can trigger a right-click using a sneaky trick:put two fingertips on the trackpad, and then click the button. (That's an option you can turn on or off in the Keyboard & Mouse panel of System Preferences.)

Alternatively, if that's too much to learn, just highlight whatever you want to right-click and then press Shift-F10.

If you're stuck with a one-button Mac mouse, and none of these options works for you, use the Apple Mouse Utility program for Windows. (You can download it from this book's "Missing CD" page at www.missingmanuals.com.) It lets you Control-click to simulate a right-click while you're running Windows.

(It also installs a new Control Panel icon and system-tray pop-up menu, as described later in this chapter.)

Note: Unbeknownst to you, this DVD is actually a dual-mode disc. When you insert it into a Mac running Mac OS X, it appears as the Leopard installer you know and love. But when you slip it into a PC, its secret Windows partition appears—and automatically opens the Mac driver installer!

When you insert the Leopard disc, the driver installer opens and begins work automatically. Click past the Welcome and License Agreement screens, and then click Install. You'll see a lot of dialog boxes come and go; just leave it alone (and don't click Cancel).

A few words of advice:

  • If you see, "The software you are installing has not passed Windows Logo testing," click Continue Anyway. (As if Apple's going to pay Microsoft to have its software certified for quality!)

  • If the installation seems to stall, Windows may be waiting for you to click OK or Next in a window that's hidden behind other windows. Inspect the taskbar and look behind open windows.

  • Windows XP concludes by presenting the Found New Hardware Wizard. Go ahead and agree to update your drivers.

When it's all over, a dialog box asks you to restart the computer; click Restart. When the machine comes to, it's a much more functional Windows Mac. (And it has an online Boot Camp Help window waiting for you on the screen.)

8.1.2. Forth and Back, Windows/Mac

From now on, your main interaction with Boot Camp will be telling it what kind of computer you want your Mac to be today: a Windows machine or a Mac.

Presumably, though, you'll prefer one operating systemmost of the time. Figure 8-3 (top and middle) shows how you specify your favorite.

Tip: If you're running Windows and you just want to get back to Mac OS X right now, you don't have to bother with all the steps shown in Figure 8-3. Instead, click the Boot Camp system-tray icon and, from the shortcut menu, choose Restart in Mac OS X.

From now on, each time you turn on the Mac, it starts up in the operating system you've selected.

If you ever need to switch—when you need Windows just for one quick job, for example—press Option key as the Mac is starting up. You'll see something like the icons shown in Figure 8-3 (bottom).

Tip: To upgrade to Windows Vista: Restart your Mac using Windows. Insert your Vista installation or upgrade disc.Follow the instructions that came with Vista.

Figure 8-3. Top: To choose your preferred operating system—the one that starts up automatically unless you intervene—choose rightwards double arrow System Preferences. Click Startup Disk, and then click the icon for either Mac OS X or Windows. Next, either click Restart (if you want to switch right now) or close the panel.
The identical controls are available when you're running Windows, thanks to the new Boot Camp Control Panel.
Middle: To open the Boot Camp control panel, choose its name from its new icon in the Windows system tray.
Bottom: This display, known as the Startup Manager, appears when you press Option during startup. It displays all the disk icons, or disk partitions, that contain bootable operating systems. Just click the name of the partition you want, and then click the Continue arrow.

8.1.3. Keyboard Translation Guide

Now, if you really want to learn about Windows, you needWindows XP: The Missing Manual (available in Home and Pro editions) orWindows Vista : The Missing Manual.

But suggesting that you go buyanother book would be tacky. So here's just enough to get by.

First of all, a Mac keyboard and a Windows keyboard aren't the same. Each has keys that would strike the other as extremely goofy. Still, you can trigger almost any keystroke that Windows is expecting by substituting special Apple-keyboard strokes, like this:

Windows Keystroke | Apple keyboard
Control-Alt-Delete | Control-Option-Delete
Alt | Option
Backspace | Delete
Delete (forward delete) | (on laptops, Fn-Delete)
Enter | Return or Enter
Num lock | Clear (laptops; Fn-F6)
Print Screen | F14 (laptops: Fn-F11)
Print active window | Option-F14 (laptops: Option-Fn-F11)
Alt key | Option key
key | T

The keyboard shortcuts in your programs aremostly the same as on the Mac, but you have to substitute the Ctrl key for the [image] key. So in Windows programs, Copy, Save, and Print are Ctrl-C, Ctrl-S, and Ctrl-P.

Similarly, the Alt key is the Windows equivalent of the Option key.

Tip: You know that awesome two-finger scrolling trick on Mac laptops (Section 9.14.3.1)? Guess what? It works when you're running Windows, too.

8.1.4. Boot Camp Tip-O-Rama

And now, the finer points of Boot Camp…

  • When you're running Mac OS X, you can get to the documents you created while you were running Windows, which is a huge convenience. Just double-click the Windows disk icon (called NO NAME or Untitled), and then navigate to the Documents and Settings rightwards double arrow [your account name] rightwards double arrow My Documents (or Desktop).

    If you formatted your Windows XP partition using the FAT format as described earlier, you can copy files toor from this partition, and even open them up for editing on the Mac side. If you used NTFS, though, you can only copy themto the Mac side, or open them without the ability to edit them.

    Tip: Actually, there's no reason your Windows "drive" has to be called NO NAME or Untitled. You can rename it as you would any other icon, either in Windows or in Mac OS X. (That's if you used the FAT format. If you used NTFS, you can't change the name in Mac OS X.)

  • On the other hand, while you're running Windows, you generally can't access your Mac files; Windows doesn't even see theMac hard drive.

    One way to around this is to buy a $50 program called MacDrive (www.mediafour.com).

    Another solution: use a disk that both Mac OS X and Windows "see," and keep your shared files onthat. A flash drive works beautifully for this. So does your iDisk (Section 18.6.1) or a shared drive on the network.


windows_in_a_window.html

8.2. Windows in a Window

The problem with Boot Camp is that every time you switch to or from Windows, you have to close down everything you were working on and restart the computer—and reverse the process when you're done. You lose two or three minutes each way. And you can't copy and paste between Mac and Windows programs.

There is another way: an $80 utility called Parallels Workstation for Mac OS X (www.parallels.com), and its rival, VMWare Fusion (www.vmware.com). These programs let you run Windows and Mac OS Xsimultaneously; Windows hangs out in a window of its own, while the Mac is running Mac OS X (Figure 8-4). It's something like the old, dog-slow emulation software known as Microsoft VirtualPC, with one key difference:speed. You're getting about 90 percent of Boot Camp's Windows speed—not fast enough for 3-D games, but plenty fast for just about everything else.

UP TO SPEED
Removing Windows

Maybe you're a switcher who held onto Windows because you were worried that you'd need it. Maybe you're finished with the project, the job, or the phase of life that required you to use Windows on your Mac. But one way or another, there may come a time when you want to get rid of your Windows installation and reclaim all the hard drive space it was using.

Not only can you do that, but the process won't touch anything that's already on the Mac side. You won't have to erase your entire hard drive or anything—Leopard simply erases what's on the Windows partition of your hard drive, and then adds that disk space back to your main,Mac partition.

To do this, start by making sure you've rescued anything worth saving from the Windows side of your computer—it's about to be erased.

Start up in Mac OS X, quit all open programs, and make sure nobody's logged in but you. Now open up the Boot Camp Assistant program in your Applications rightwards double arrow Utilities folder.

On the welcome screen, click "Restore the startup disk to a single volume," and then click Continue. That's all there is to it.

Special notes for special setups: If you installed Windows on a separate hard drive, rather than a partition of yourmain hard drive, don't bother with all this. Just erase the Windows hard drive using Disk Utility, as described in Chapter 10, and format it as a Mac drive.

On the other hand, if your Mac has more than one internal hard drive, and you created a Windows partition on one of them (rather than taking it over completely), open Boot Camp Assistant as described above. This time, though, click "Create or remove a Windows partition," click Continue, click the Windows disk, and then click "Restore to a single Mac OS partition."

Once again, you have to supply your own copy of Windows for the installation process. This time, though, it doesn't have to be Windows XP or Vista. It can be any version of Windows, all the way back to Windows 3.1—or even Linux, FreeBSD, Solaris, OS/2, or MS-DOS.

Having virtualization software on your Intel Mac is a beautiful thing. You can be working on a design in iWork, duck into a Microsoft Access database (Windows only), look up an address, copy it, and paste it back into the Mac program.

And what if you can't decide whether to use Boot Camp (fast and feature-complete, but requires restarting) or Parallels/Fusion(fast and nore starting, but no3-D games)? No problem—install both. They coexist beautifully on a single Mac, and can even use the same copy of Windows.

Together, they turn the Intel-based Macintosh into the Uni-Computer: the single machine that can run nearly 100 percent of the world's software catalog.

8.2.1. Virtualization Tip-O-Rama

Mastering Parallels, Fusion, or VirtualBox means mastering Windows, of course, but it also means mastering these tips:

Figure 8-4. The strangest sight you ever did see: Mac OS X and Windows XP. On the same screen. At the same time. Courtesy of VMWare Fusion. Parallels is very similar.

  • You don'thave to run Windows in a window. With one keystroke, you can make your Windows simulator cover the entire screen. You're still actually running two operating systems at once, but the whole Mac world is hidden for the moment so you can exploit your full screen. Just choose View rightwards double arrow Full Screen.

    Tip: Or use the keystroke Alt-Enter (Parallels) or Ctrl- [image] -Return (Fusion) to enter and exit Full Screen mode.

  • Conversely, both Parallels and Fusion offer something called Coherence or Unity mode, in which there's no trace of the Windows desktop. Instead, each Windows program floats in its own disembodied window, just like a Mac program; the Mac OS X desktop lies reassuringly in the background.

    Tip: In Fusion's Unity mode, you can access your Computer, Documents, Network, Control Panel, Search, and Run commands right from Fusion's Dock icon or launch palette, so you won't even care that there's no Start menu.

    In Parallels, press Alt+Ctrl+Shft to enter or exit Coherence mode. In Fusion, hit Ctrl- [image] -U for Unity mode.

    Tip: In Fusion, in Unity view, you can use the usual Mac keystrokes for Cut, Copy, and Paste within Windows applications ( [image] -C, [image] -X, [image] -V). In Parallels, on the other hand, you can remap all Windows Control-key shortcuts to the [image] c key in Preferences.

    POWER USERS' CLINIC
    Beyond the Big Names

    Parallels and VMWare Fusion are bloodthirsty rivals. New versions tumble out with alarming frequency, each designed to one-up its rival.

    Both also let you specify which program—Macor Windows—opens when you double-click documents of specific types (like JPEG or .DOC). That's yet another way Windows becomes a full player on the Mac team.

    Still, these aren't the only options. A program called VirtualBox (www.virtualbox.org) is not as polished or full-featured as its big-name rivals, but it's not as expensive, either; in fact, it's free. That's because it's open-source software, meaning that programmers around the world volunteer to collaborate on it.

    Finally, several efforts are afoot to create software that lets you run Windows softwarewithout Windows. The most promising one is a $60 program called CrossOver (www.codeweavers.com).

    Sure enough, CrossOver-compatible Windows programs open up and run in Mac OS X just as though they're real Mac programs—without your having to own, install, or fire up a copy of Windows itself.

    Unfortunately, the list of compatible programs is tiny; fewer than 20 Windows programs work flawlessly in CrossOver. The list of programs thatmostly work is longer, though, so check the list on CrossOver's Web site to see if what you need is CrossOver-friendly.

  • To send the "three-fingered salute" when things have locked up in Windows (usually Ctrl+Alt+Delete), press Control-Option- [image] (Fusion) or Ctrl+Fn+Alt+Delete (Parallels). Or use the Send Ctrl-Alt-Delete command in the menus.

  • You can drag files back and forth between the Mac and Windows universes. Just drag icons into, or out of, the Windows window.

  • If you have a one-button mouse, you can "right-click" in Parallels by Control-Shift-clicking. In Fusion, Control-click instead. On Mac laptops, you can right-click by putting two fingers on the trackpad as you click (Section 9.14.3.1).

  • When you quit the virtualization program, you're not really "shutting down"the PC; you're justsuspending it, or putting it to sleep. When you double-click the Parallels/VMWare icon again, everything in your Windows world is exactly as you left it.

  • Your entire Windows universe offiles, folders, and programs is represented by a single file on your hard drive. In Parallels, it's in your Home rightwards double arrow Library rightwards double arrow Parallels folder. In Fusion, it's in your Home rightwards double arrow Documents rightwards double arrow Virtual Machines folder.

    That's super convenient, because it means that you can back up your entire Windows "computer" by dragging a single icon to another drive. And if your Windows world ever gets a virus or spyware infestation, you can drag the entire thing to the Trash—and restore the entire thing from that clean backup.


the_components_of_mac_OS_X.html

Part III: The Components of Mac OS X

Section 4.5.1

Chapter 10

Chapter 11

Chapter 9. System Preferences

The hub of Mac customization is System Preferences, the modern-day successor to the old Control Panel (Windows) or Control Panels (previous Mac systems). Some of its panels are extremely important, because their settings determine whether or not you can connect to a network or go online to exchange email. Others handle the more cosmetic aspects of customizing Mac OS X.

This chapter guides you through the entire System Preferences program, panel by panel.

Tip: Only a system administrator (Section 12.2.1.1) can change settings that affect everyone who shares a certain machine: its Internet settings, Energy Saver settings, and so on. If you see a bunch of controls that are dimmed and unavailable, now you know why.A tiny padlock in the lower-left corner of a panel is the other telltale sign. If you, a nonadministrator, would like to edit some settings, call an administrator over to your Mac and ask him to click the lock, input his password, and supervise your tweaks.

9.1. The System Preferences Window

You can open System Preferences in dozens of ways. Most people choose its name from the [image] menu or click its icon in the Dock. But Option-volume key (one of the speaker-adjustment keys on the top row of the keyboard) or Option-brightness keys opens System Prefs, too.(These tricks open the Sound and Displays panes, respectively, but you can then click Show All or press [image] -L to see the full spread.)

Tip: If you know the name of the System Preferences panel you want, it's often quicker to use Spotlight. To open Energy Saver, for example, hit [image] -Space, type ener, and then press [image] -Enter. See Chapter 3 for more on operating Spotlight from the keyboard.

At first, the rows of icons are grouped according to function: Personal, Hardware, and so on (Figure 9-1, top). But you can also view them in tidy alphabetical order, as shown at bottom in Figure 9-1. That can spare you the ritual of hunting through various rows just to find a certain panel icon whose name you already know. (Quick, without looking: Which row is Date & Time in?) This chapter describes the various panels following this alphabetical arrangement.

Figure 9-1. You can view your System Preferences icons alphabetically (top), rather than in rows of arbitrary categories (bottom); just choose View rightwards double arrow Organize Alphabetically. This approach not only saves space, but also makes finding a certain panel much easier, because you don't need to worry about which category it's in.

Either way, when you click one of the icons, the corresponding controls appear in the main System Preferences window. To access a different preference pane, you have a number of options:

  • Fast: When System Preferences first opens, the insertion point is blinking in the new System Preferences search box. (If the insertion point is not blinking there, press [image] -F.) Type a few letters of volume, resolution, wallpaper, wireless, or whatever feature you want to adjust. In a literal illustration of Spotlight's power, the System Preferences window darkens except for the icons where you'll find relevant controls (Figure 9-2). Click the name or icon of the one that looks most promising.

    Figure 9-2. Even if you don't know what System Preferences panel contains the settings you want to change, Spotlight can help. Type into the box at the top, and watch as the "spotlight" shines on the relevant icons. At that point, you can either click the icon, click the name in the pop-up menu, or arrow down the menu and press Enter to choose. (Apple removed the System Preferences toolbar, but it hopes that this Spotlight business is just as useful.)

  • Fast: Click the Show All icon in the upper-left corner of the window (or press [image] -L, a shortcut worth learning). Then click the icon of the new panel you want.

  • Faster: Choose any panel's name from the View menu—or, if System Preferences is already open, from the System Preferences Dock icon.

  • Fastest: Highlight the first System Preferences icon by pressing Tab. (The highlighting is very faint, but it's there.) Then type the first couple of letters of the icon you want to highlight—p for Print & Fax, di for Displays, or whatever—and then press the Space bar to open that panel.


system_preferences-id001.html

Part III: The Components of Mac OS X

Section 4.5.1

Chapter 10

Chapter 11

Chapter 9. System Preferences

The hub of Mac customization is System Preferences, the modern-day successor to the old Control Panel (Windows) or Control Panels (previous Mac systems). Some of its panels are extremely important, because their settings determine whether or not you can connect to a network or go online to exchange email. Others handle the more cosmetic aspects of customizing Mac OS X.

This chapter guides you through the entire System Preferences program, panel by panel.

Tip: Only a system administrator (Section 12.2.1.1) can change settings that affect everyone who shares a certain machine: its Internet settings, Energy Saver settings, and so on. If you see a bunch of controls that are dimmed and unavailable, now you know why.A tiny padlock in the lower-left corner of a panel is the other telltale sign. If you, a nonadministrator, would like to edit some settings, call an administrator over to your Mac and ask him to click the lock, input his password, and supervise your tweaks.

9.1. The System Preferences Window

You can open System Preferences in dozens of ways. Most people choose its name from the [image] menu or click its icon in the Dock. But Option-volume key (one of the speaker-adjustment keys on the top row of the keyboard) or Option-brightness keys opens System Prefs, too.(These tricks open the Sound and Displays panes, respectively, but you can then click Show All or press [image] -L to see the full spread.)

Tip: If you know the name of the System Preferences panel you want, it's often quicker to use Spotlight. To open Energy Saver, for example, hit [image] -Space, type ener, and then press [image] -Enter. See Chapter 3 for more on operating Spotlight from the keyboard.

At first, the rows of icons are grouped according to function: Personal, Hardware, and so on (Figure 9-1, top). But you can also view them in tidy alphabetical order, as shown at bottom in Figure 9-1. That can spare you the ritual of hunting through various rows just to find a certain panel icon whose name you already know. (Quick, without looking: Which row is Date & Time in?) This chapter describes the various panels following this alphabetical arrangement.

Figure 9-1. You can view your System Preferences icons alphabetically (top), rather than in rows of arbitrary categories (bottom); just choose View rightwards double arrow Organize Alphabetically. This approach not only saves space, but also makes finding a certain panel much easier, because you don't need to worry about which category it's in.

Either way, when you click one of the icons, the corresponding controls appear in the main System Preferences window. To access a different preference pane, you have a number of options:

  • Fast: When System Preferences first opens, the insertion point is blinking in the new System Preferences search box. (If the insertion point is not blinking there, press [image] -F.) Type a few letters of volume, resolution, wallpaper, wireless, or whatever feature you want to adjust. In a literal illustration of Spotlight's power, the System Preferences window darkens except for the icons where you'll find relevant controls (Figure 9-2). Click the name or icon of the one that looks most promising.

    Figure 9-2. Even if you don't know what System Preferences panel contains the settings you want to change, Spotlight can help. Type into the box at the top, and watch as the "spotlight" shines on the relevant icons. At that point, you can either click the icon, click the name in the pop-up menu, or arrow down the menu and press Enter to choose. (Apple removed the System Preferences toolbar, but it hopes that this Spotlight business is just as useful.)

  • Fast: Click the Show All icon in the upper-left corner of the window (or press [image] -L, a shortcut worth learning). Then click the icon of the new panel you want.

  • Faster: Choose any panel's name from the View menu—or, if System Preferences is already open, from the System Preferences Dock icon.

  • Fastest: Highlight the first System Preferences icon by pressing Tab. (The highlighting is very faint, but it's there.) Then type the first couple of letters of the icon you want to highlight—p for Print & Fax, di for Displays, or whatever—and then press the Space bar to open that panel.


the_system_preferences_window.html

Part III: The Components of Mac OS X

Section 4.5.1

Chapter 10

Chapter 11

Chapter 9. System Preferences

The hub of Mac customization is System Preferences, the modern-day successor to the old Control Panel (Windows) or Control Panels (previous Mac systems). Some of its panels are extremely important, because their settings determine whether or not you can connect to a network or go online to exchange email. Others handle the more cosmetic aspects of customizing Mac OS X.

This chapter guides you through the entire System Preferences program, panel by panel.

Tip: Only a system administrator (Section 12.2.1.1) can change settings that affect everyone who shares a certain machine: its Internet settings, Energy Saver settings, and so on. If you see a bunch of controls that are dimmed and unavailable, now you know why.A tiny padlock in the lower-left corner of a panel is the other telltale sign. If you, a nonadministrator, would like to edit some settings, call an administrator over to your Mac and ask him to click the lock, input his password, and supervise your tweaks.

9.1. The System Preferences Window

You can open System Preferences in dozens of ways. Most people choose its name from the [image] menu or click its icon in the Dock. But Option-volume key (one of the speaker-adjustment keys on the top row of the keyboard) or Option-brightness keys opens System Prefs, too.(These tricks open the Sound and Displays panes, respectively, but you can then click Show All or press [image] -L to see the full spread.)

Tip: If you know the name of the System Preferences panel you want, it's often quicker to use Spotlight. To open Energy Saver, for example, hit [image] -Space, type ener, and then press [image] -Enter. See Chapter 3 for more on operating Spotlight from the keyboard.

At first, the rows of icons are grouped according to function: Personal, Hardware, and so on (Figure 9-1, top). But you can also view them in tidy alphabetical order, as shown at bottom in Figure 9-1. That can spare you the ritual of hunting through various rows just to find a certain panel icon whose name you already know. (Quick, without looking: Which row is Date & Time in?) This chapter describes the various panels following this alphabetical arrangement.

Figure 9-1. You can view your System Preferences icons alphabetically (top), rather than in rows of arbitrary categories (bottom); just choose View rightwards double arrow Organize Alphabetically. This approach not only saves space, but also makes finding a certain panel much easier, because you don't need to worry about which category it's in.

Either way, when you click one of the icons, the corresponding controls appear in the main System Preferences window. To access a different preference pane, you have a number of options:

  • Fast: When System Preferences first opens, the insertion point is blinking in the new System Preferences search box. (If the insertion point is not blinking there, press [image] -F.) Type a few letters of volume, resolution, wallpaper, wireless, or whatever feature you want to adjust. In a literal illustration of Spotlight's power, the System Preferences window darkens except for the icons where you'll find relevant controls (Figure 9-2). Click the name or icon of the one that looks most promising.

    Figure 9-2. Even if you don't know what System Preferences panel contains the settings you want to change, Spotlight can help. Type into the box at the top, and watch as the "spotlight" shines on the relevant icons. At that point, you can either click the icon, click the name in the pop-up menu, or arrow down the menu and press Enter to choose. (Apple removed the System Preferences toolbar, but it hopes that this Spotlight business is just as useful.)

  • Fast: Click the Show All icon in the upper-left corner of the window (or press [image] -L, a shortcut worth learning). Then click the icon of the new panel you want.

  • Faster: Choose any panel's name from the View menu—or, if System Preferences is already open, from the System Preferences Dock icon.

  • Fastest: Highlight the first System Preferences icon by pressing Tab. (The highlighting is very faint, but it's there.) Then type the first couple of letters of the icon you want to highlight—p for Print & Fax, di for Displays, or whatever—and then press the Space bar to open that panel.


mac.html

9.2. .Mac

This panel is of no value unless you've signed up for a .Mac account (Chapter 18). It offers four tabs:

  • Account. This is where you fill in your member name and password for your .Mac account, if you've subscribed. (See Chapter 18 for a full discussion of these accounts.) If you're not yet a member, you can click the Learn More button to get started.

  • Sync. Here's where you tell Leopard which elements of your digital world—calendar, address book, email, and so on—you want synchronized, via the .Mac service, among your various Macs. Details on syncing are on Section 6.6.

  • iDisk. The Disk Space graph indicates how full your electronic iDisk is. (And if it approaches your limit of ten gigabytes, an Upgrade Storage button lets you pay Apple for the privilege of gaining more storage.) The Your iDisk Public Folder controls let you specify whether or not other people are allowed to put new files into your Public folder (Section 18.6.2.3), and whether or not outsiders need a password to see what's in your Public folder. Finally, the iDisk Sync On/Off switch is here. There's much more detail on these topics in Chapter 18.

  • Back to My Mac. This new Leopard feature of .Mac does just what the description here says: It lets you, on the road with your laptop (for example), connect to your Mac back home—to retrieve a file you left behind, for example. Step-by-steps are in Chapter 18.


accounts.html

9.3. Accounts

This is the master list of people who are allowed to log into your Mac. It's where you can adjust their passwords, startup pictures, self-opening startup items, permissions to use various features of the Mac, and other security tools. All of this is described in Chapter 12.


appearance.html

9.4. Appearance

This panel is mostly about how things look on the screen: windows, menus, buttons, scroll bars, and fonts. Nothing you find here lets you perform any radical surgery on the overall Mac OS X look—but you can tweak certain settings to match your personal style.

9.4.1. Changing Colors

Two pop-up menus let you crank up or tone down Mac OS X's overall colorfulness:

  • Appearance. Choose between Blue or Graphite. Blue refers to Mac OS X's factory setting—bright, candy-colored scroll-bar handles, progress bars, [image] menu, and pulsing OK buttons—and those shiny red, yellow, and green buttons in the corner of every window. If you, like some graphics professionals, find all this circus-poster coloring a bit distracting, then choose Graphite, which renders all those interface elements in various shades of gray.

  • Highlight color. When you drag your cursor across text, its background changes color to indicate that you've selected it. Exactly what color the background becomes is up to you—just choose the shade you want using the pop-up menu. The Highlight color also affects such subtleties as the lines on the inside of a window as you drag an icon into it.

If you choose Other, the Color Picker palette appears, from which you can choose any color your Mac is capable of displaying (Section 5.13).

9.4.2. Tweaking the Scroll Bars

The two sets of radio buttons control the scroll-bar arrow buttons of all your windows. You can keep these arrows together at one end of the scroll bar, or you can split them up so that the "up" arrow sits at the top of the scroll bar, and the "down" arrow is at the bottom. (Horizontal scroll bars are similarly affected.) For details on the "Jump to the next page" and "Jump to here" options, see Section 1.2.10.

Tip: And what if you want the ultimate convenience: both arrows at both ends of the scroll bar? You just need a moment alone with TinkerTool, described on Section 17.1.

You can also turn on these checkboxes:

  • Use smooth scrolling. This option affects only one tiny situation: when you click (or hold the cursor down) inside the empty area of the scroll bar (not on the handle, and not on the arrow buttons). And it makes only one tiny change: Instead of jumping abruptly from screen to screen, the window lurches with slight accelerations and decelerations, so that the paragraph you're eyeing never jumps suddenly out of view.

  • Minimize when double-clicking a window title bar. This option provides another way to minimize a window. In addition to the tiny yellow Minimize button at the upper-left corner of the window, you now have a much bigger target—the entire title bar.

9.4.3. Number of Recent Items

Just how many of your recently opened documents and applications do you want the Mac to show using the Recent Items command in the [image] menu? Pick a number from the pop-up menus. For example, you might choose 30 for documents, 20 for programs, and 5 for severs.

9.4.4. Font Smoothing Style

The Mac's built in text-smoothing (antialiasing ) feature is supposed to produce smoother, more commercial-looking text anywhere it appears on your Mac: in word processing documents, email messages, Web pages, and so on.

Here, you can control the degree to which text gets smoothed. Use the pop-up menu to choose a setting that suits your eyes—and your monitor. For example, Apple offers Standard for CRT screens (cathode-ray tube—that is, traditional, bulky, televisionstyle screens), and Medium for flat-panel screens like laptops and almost all current desktop Macs. Or just leave the setting at Automatic, which gives text on the main screen the appropriate smoothing.

Either way, the differences are fairly subtle. (See Figure 9-3.) Furthermore, unlike most System Preferences, this one has no effect until the next time you open the program in question. In the Finder, for example, you won't notice the difference until you log out and log back in again.

Figure 9-3. Top: The same 12-point type with text smoothing turned off (top) and on, shown magnified for your inspection pleasure.
Bottom: Here's the widest difference in text-smoothing styles: Light smoothing vs. Strong. Standard and Medium, of course, are in between.

9.4.5. Turning Off Smoothing on Tiny Fonts

At smaller type sizes (10-point and smaller), you might find that text is actually less readable with font smoothing turned on. It all depends upon the font, the size, your monitor, and your taste. For that reason, this pop-up menu lets you choose a cutoff point. If you choose 12 here, for example, then 12-point (and smaller) type still appears crisp and sharp; only larger type, such as headlines, displays the graceful edge smoothing. You can choose a size cutoff as low as 4 points.

(None of these settings affect your printouts, only the onscreen display.)


bluetooth.html

9.5. Bluetooth

This panel, radically redesigned for Leopard, shows up only if your Mac is equipped with a Bluetooth transmitter, either built-in or in the form of an external USB gadget.

Bluetooth is a short-range, low-power, wireless cable-elimination technology. It's designed to connect gadgets in pairings that make sense, like cellphone+earpiece, wireless keyboard+Mac, Palm organizer+Mac, or Mac+cellphone (to connect to the Internet or to transmit files).

Now, you wouldn't want the guy in the next cubicle to be able to operate your Mac using his Bluetooth keyboard. So the first step in any Bluetooth relationship is pairing, where you formally introduce the two gadgets that will be communicating. Here's how that goes:

  1. Open System Preferences rightwards double arrow Bluetooth

    Make sure Bluetooth Power is turned on. (The only reason to turn it off is to save laptop battery power.) Also make sure Discoverable is turned on; that makes the Mac "visible" to other Bluetooth gadgets in range.

  2. Click the + button below the list at left.

    The Bluetooth Setup Assistant opens, offering a list of typical Bluetooth equipment that your Mac can talk to: Mobile Phone, Headset, Printer, etc.

  3. Click the kind of gear you have, and then click Continue.

    The Mac whirs for a moment, and then displays the names of all Bluetooth gadgets that it can sniff out. Usually, it finds the one you're trying to pair.

  4. Click the name of the phone/headset/keyboard/whatever, and then click Continue.

    If you're pairing a mobile phone or something else that has a keypad or keyboard, the Mac now displays a large, eight-digit passcode. It's like a password, except you'll have to input it only this once, to confirm that you are the true owner of both the Mac and the phone. (If it weren't for this passcode business, some guy next to you at the airport could enjoy free laptop Internet access through the cellphone in your pocket.)

    At this point, your phone or palmtop displays a message to the effect that you have 30 seconds to type that passcode. Do it. When the gadget asks if you want to pair with the Mac and connect to it, say yes.

    If you're pairing a phone or palmtop, the Mac now asks which sorts of Bluetooth syncing you want to do. For example, it can copy your iCal appointments, as well as your Address Book address book, to the phone or palmtop.

    (Or, if there are no kinds of Bluetooth syncing that your Mac can do with the gadget—for example, there's nothing an iPhone can accomplish by talking to your Mac, since it doesn't offer Bluetooth file transfers, for example—an error message tells you that, too.)

Tip: A few Bluetooth phones can even get your laptop onto the Internet via the cellular airwaves. No Wi-Fi required—the phone never even leaves your pocket, and your laptop can get online wherever there's a cellphone signal.This is a special setup, however, involving signing up with your cell carrier (and paying an additional monthly fee). If you've signed up, then turn on the third option here ("Access the Internet").

When it's all over, the new gadget is listed in the left-side panel, in the list of Bluetooth cellphones, headsets, and other stuff that you've previously introduced to this Mac. Click the + button to open the Bluetooth Setup Assistant again, or the – button to delete one of the listed items.

And then there's the [image] button. On first click, it's a pop-up menu that says only, "Show More Info." If you select that item and then click [image] again, you get a pop-up menu with a few Bluetooth utility commands.

9.5.1. Advanced Options

If you click Advanced, you arrive at a pop-up panel with a few more tweaky Bluetoothisms:

Figure 9-4. Top: This System Preferences panel reveals a list of every Bluetooth gadget your Mac knows about. Click a Bluetooth device to see details.
Middle: The Bluetooth Setup Assistant scans the area for Bluetooth gadgets, and, after a moment, lists them. Click one, and then click Continue.
Bottom: Where security is an issue, the Assistant offers you the chance to pair your Bluetooth device with the Mac. To prove that you're really the owner of both the laptop and the phone, the Mac displays a one-time password, which you have 30 seconds to type into the phone. Once that's done, you're free to use the phone's Internet connection without any further muss, fuss, or passwords.

  • Open Bluetooth Assistant at startup when no input device is present. Here's where you can tell the Bluetooth Setup Assistant to open up automatically when the Mac thinks no keyboard and mouse are attached (because it assumes that you have a wireless Bluetooth keyboard and mouse that have yet to be set up).

  • Allow Bluetooth devices to wake this computer. Turn on if you want to be able to wake up a sleeping Mac when you press a key, just like a wired keyboard does.

  • Prompt for all incoming audio requests. The Mac will let you know if your Bluetooth cellphone, music player, or another music gadget tries to connect.

  • Share my Internet connection with other Bluetooth devices. Pretty obscure—but when the future arrives, Mac OS X will be ready. The PAN service referred to in the description of this item lets your Mac, which presumably has a wired or Wi-Fi Internet connection, share that connection with Bluetooth gadgets (like palmtops) that don't have an Internet connection.

  • Serial ports. This list identifies which simulated connections are present at the moment. It's a reference to those different Bluetooth profiles (features) that various gadgets can handle. They include Bluetooth File Transfer (other people with Bluetooth Macs can see a list of what's in your Public folder, and help themselves; see Section 6.2.7), Bluetooth File Exchange (other people can send files to you using Bluetooth; Section 10.30.3), Bluetooth-PDA-Sync (personal digital assistants—that is, Palm organizers—can sync with your Mac via Bluetooth); and so on.


cds_ampersand_dvds.html

9.6. CDs & DVDs

This handy pane (Figure 9-5) lets you tell the Mac what it should do when it detects you've inserted a CD or DVD. For example, when you insert a music CD, you probably want iTunes (Chapter 11) to open automatically so you can listen to the CD or convert its musical contents to MP3 or AAC files on your hard drive. Similarly, when you insert a picture CD (such as a Kodak Photo CD), you probably want iPhoto to open in readiness to import the pictures from the CD into your photo collection. And when you insert a DVD from Blockbuster, you want the Mac's DVD Player program to open.

Figure 9-5. You can tell the Mac exactly which program to launch when you insert each kind of disc, or tell it to do nothing at all.

For each kind of disc (blank CD, blank DVD, music CD, picture CD, or video DVD), the pop-up menu lets you choose options like these:

  • Ask what to do. A dialog box appears that asks what you want to do with the newly inserted disc.

  • Open (iDVD, iTunes, iPhoto, DVDPlayer…). The Mac can open a certain program automatically when you insert the disc. When the day comes that somebody writes a better music player than iTunes, or a better digital shoebox than iPhoto, you can use the "Open other application" option.

  • Run script. If you've become handy writing or downloading AppleScript programs (Chapter 7), you can schedule one of your own scripts to take over from here. For example, you can set things up so that inserting a blank CD automatically copies your Home folder onto it for backup purposes.

  • Ignore. The Mac won't do anything when you insert a disc except display its icon on the desktop. (If it's a blank disc, the Mac does nothing at all.)

UP TO SPEED
System Preferences: Under the Hood

The entire System Preferences program is nothing more than a series of graphical front ends for underlying Unix settings. (If you know Unix and feel so inclined you can, in fact, bypass the System Preferences panel completely. Using the defaults command, you can use Mac OS X's Terminal program to make any of the changes described in this chapter—and many others.)

The individual Preferences panes are represented by package icons (Section 5.1.3) in your various Library folders. For example, icons in the basic Leopard set are in System rightwards double arrow Library rightwards double arrow PreferencePanes. Mac OS X also looks for preferences modules in the Network rightwards double arrow Library rightwards double arrow PreferencePanes folder, if there is one.

(All of this is handy to remember when the day comes that you want to delete a Preferences pane.)

Now suppose you've downloaded some new Preferences module, and you want to install it. Just double-clicking a downloaded System Preferences pane does the trick.

If you prefer manual control, you can put a downloaded module into your Home rightwards double arrow Library rightwards double arrow PreferencePanes folder. The beauty of this arrangement, of course, is that everyone who shares a Mac now can see a different assortment of customized Preference panes.

If you're an administrator, you can create a Preference-Panes folder in the Mac's main Library folder, so that everyone with an account on the Mac (Chapter 12) can access your newly added panes.

When you install some new System Preferences pane like TinkerTool, Adobe VersionCue, or TiVo Desktop, it takes the form of a new icon in one of those four PreferencePanes folders. That's good to know when the day comes that you want to remove one of these add-on panes.

Within the System Preferences program, any new panes you add in this way appear in a new row of icons labeled Other (at least when you're viewing System Preferences in Category view).


date_ampersand_time.html

9.7. Date & Time

Your Mac's conception of what time it is can be very important. Every file you createor save is stamped with this time, and every email you send or receive is marked with this time. As you might expect, setting your Mac's clock is what the Date & Time pane is all about.

9.7.1. Date & Time Tab

Click the Date & Time tab. If your Mac is online, turn on "Set date & time automatically," and be done with it. Your Mac set sits own clock by consulting a highly accurate scientific clock on the Internet. (No need to worry about Daylight Saving Time, either; the time servers take that into account.)

Tip: If you have a full-time Internet connection (cable modem or DSL, for example), you may as well leave this checkbox turned on, so your Mac's clock is always correct. If you connect to the Internet by modem, however, turn off the checkbox, so your Mac won't keep trying to dial spontaneously at all hours of the night.

If you're not online and have no prospect of getting there, you can also set the date and time manually. To change the month, day, or year, you can click the digit that needs changing and then either (a) type a new number or (b) click the little arrow buttons. Press the Tab key to highlight the next number. (You can also specify the day of the month by clicking a date on the minicalendar.)

To set the time of day, use the same technique—or, for more geeky fun, you can set the time by dragging the hour, minute, or second hands on the analog clock. Finally, click Save. (If you get carried away with dragging the clock hands around and lose track of the real time, click the Revert button to restore the panel settings.)

GEM IN THE ROUGH
Your Free Time-Difference Calculator

You can use the Time Zone tab of Date & Time to calculate the exact time difference between any two points on earth. To do this, you must have the Time Zone pane open and your menu bar clock turned on and set to View as Digital. (See the discussion of the menu bar clock in this chapter.)

To calculate a time difference, make a note of the current time shown in the menu bar, with the Time Zone correctly set to your own zone. Now click your way across the Time Zone map. With each click, notice that the time in the menu bar changes, updating itself as you cross from time zone to time zone. By comparing the original time on your menu bar with the new time that appears when you've finished clicking, you can easily determine the time difference.

(On the other hand, you can always open Dashboard, described in Chapter 5, and just open two copies of the World Clock widget—one set to each city.)

Tip: If you're frustrated that the Mac is showing you the 24-hour "military time" on your menu bar (that is, 17:30 instead of 5:30 p.m.)—or that it isn't showing military time when you'd like it to—click the Clock tab and turn "Use a 24-hour clock" on or off.Note, however, that this affects only the menu bar clock. If you'd like to reformat the menu bar clock and all other dates (like the ones that show when your files were modified in list views), click the Open International button at the bottom of the Date & Time pane. Once there, click the Formats tab. There you'll see a Customize button for Times, which leads you to a whole new world of time-format customization. You can drag elements of the current time (Hour, Minute, Second, Millisecond, and so on) into any order you like, and separate them with any desired punctuation.

9.7.2. Time Zone Tab

You'd be surprised how important it is to set the Time Zone for your Mac. If you don't do so, the email and documents you send out—and the Mac's conception of what documents are older and newer—could be hopelessly skewed. Teach your Mac where it lives using the Time Zone map, as shown in Figure 9-6.

Figure 9-6. To set your time zone the quick and dirty way, just click on a section of the map to indicate your general region of the world. You'll see the vertical stripe showing your time zone.
If you want to teach the Mac more precisely where you are in that time zone, now use the pop-up menu to specify the closest big city in that time zone. (Or, instead of using the pop-up menu with the mouse, you can also highlight the text in the Closest City box. Then start typing your city name until the Mac gets it.)

9.7.3. Clock Tab

In the Clock pane, you can specify whether or not you want the current time to appear, at all times, at the right end of your menu bar. You can choose between two different clock styles: digital (3:53 p.m.) or analog (a round clock face). You also get several other options that govern this digital clock display: the display of seconds, whether or not you want to include designations for a.m. and p.m., the day of the week, a blinking colon, and the option to use a 24-hour clock.

Tip: At the bottom of the dialog box, you'll find a feature called "Announce the time." At the intervals you specify, the Mac can speak, out loud, the current time: "It's ten o'clock." If you tend to get so immersed in "working" that you lose track of time, Mac OS X just removed your last excuse.

And by the way, your menu bar clock always shows the current time. When you need to know today's date, just click the clock. A menu drops down revealing the complete date. The menu also lets you switch between digital and analog clock types and provides a shortcut to the Date & Time preferences pane.

Tip: This one's for Unix geeks only. You can also set the date and time from within Terminal (Chapter 16). Use sudo (Section 16.7.5.1), type date yyyymmddhhmm.ss, and press Enter. (Of course, replace that code with the actual date and time you want, such as 200804051755.00 for April 5, 2008, 5:55 p.m.) You might find this method faster than the System Preferences route.


desktop_ampersand_screen_saver.html

9.8. Desktop & Screen Saver

This panel offers two ways to show off Mac OS X's glamorous graphics features: desktop pictures and screen savers.

9.8.1. Desktop

Mac OS X comes with several ready-to-use collections of desktop pictures, ranging from National Geographic –;style nature photos to plain solid colors. To install a new background picture, first choose one of the image categories in the list at the left side of the window, as shown in Figure 9-7.

Your choices include Apple Images (muted, soft-focus swishes and swirls), Nature (bugs, water, Leopard outer space), Plants (flowers, soft-focus leaves), Black & White (breathtaking monochrome shots), Abstract (swishes and swirls with wild colors), or Solid Colors (simple grays, blues, and greens).

9.8.1.1. Using your own pictures

Of course, you may feel that decorating your Mac desktop is much more fun if you use one of your own pictures. You can use any digital photo, scanned image, or graphic you want in a lmost any graphics format(JPEG, PICT, GIF, TIFF, Photoshop, and—just in case you hope to master your digital camera by dangling its electronic instruction manual in front of you each morning—even PDF).

That's why icons for your own Pictures folder and iPhoto Albums collections also appear here, along with a button that lets you choose any folder of pictures. When you click one of these icons, you see thumbnail versions of its contents in the main screen to its right. Just click the thumbnail of any picture to apply it immediately to the desktop. (There's no need to remove the previously installed picture first.)

Tip: If there's one certain picture you like, but it's not in any of the listed sources, you can drag its image file onto the well (the miniature desktop displayed in the Desktop panel). A thumbnail of your picture instantly appears in the well and, a moment later, the picture is plastered across your monitor.

Figure 9-7. Using the list of picture sources at left, you can preview an entire folder of your own images before installing one specific image as your new desktop picture. Use the Choose Folder option to select a folder of assorted graphics—or, if you're an iPhoto veteran, click an iPhoto album name, as shown here. Clicking one of the thumbnails installs the corresponding picture on the desktop.

9.8.1.2. Making the picture fit

No matter which source you use to choose a photo of your own, you have one more issue to deal with. Unless you've gone to the trouble of editing your chosen photo so that it matches the precise dimensions of your screen (1280 x 854 pixels, for example), it probably isn't exactly the same size as your screen.

Tip: The top 23 pixels of your graphic are partly obscured by Leopard's translucent menu bar—something to remember when you prepare the graphic.

Fortunately, Mac OS X offers a number of solutions to this problem. Using the popup menu just to the right of the desktop preview well, you can choose any of these options:

  • Fit to Screen. If you choose this option, new in Leopard, your photo appears as large as possible without distortion or cropping. If the photo doesn't precisely match the proportions of your screen, you get "letterbox bars" on the sides or at top and bottom. (Use the swatch button just to the right of the pop-up menu to specify a color for those letterbox bars.)

  • Fill Screen. This option enlarges or reduces the image so that it fills every inch of the desktop. If the image is small, the stretching can look awful. Conversely, if the image is large and its dimensions don't precisely match your screen's, parts get chopped off. At least this option never distorts the picture, as the "Stretch" option does (below).

  • Stretch to Fill Screen. Use this option at your peril, since it makes your picture fit the screen exactly, come hell or high water. Unfortunately, larger pictures may be squished vertically or horizontally as necessary, and small pictures are drastically blown up and squished, usually with grisly-looking results.

  • Center. This command centers the photo neatly on the screen. If the picture is larger than the screen, you see only the middle; the edges of the picture are chopped off as they extend beyond your screen.

    But if the picture is smaller than the screen, it doesn't fill the entire background; instead it just sits right smack in the center of the monitor at actual size. Of course, this leaves a swath of empty border all the way around your screen. As a remedy, Apple provides a color-swatch button next to the pop-up menu (also shown in Figure 9-7). When you click it, the Color Picker appears (Section 5.13), so that you can specify the color in which to frame your little picture.

  • Tile. This option makes your picture repeat over and over until the multiple images fill the entire monitor. (If your picture is larger than the screen, no such tiling takes place. You see only the top center chunk of the image.)

9.8.1.3. Auto picture-changing

The novelty of any desktop picture, no matter how interesting, is likely to fade after several months of all-day viewing. That's why the randomizing function is so delightful.

Turn on "Change picture" at the bottom of the dialog box. From the pop-up menu, specify when you want your background picture to change: "every day," "every 15 minutes," or, if you're really having trouble staying awake at your Mac, "every 5 seconds." (The option called "when waking from sleep" refers to the Mac waking from sleep, not its owner.)

Finally, turn on "Random order," if you like. If you leave it off, your desktop pictures change in alphabetical order by file name.

That's all there is to it. Now, at the intervals you specified, your desktop picture changes automatically, smoothly cross-fading between the pictures in your chosen source folder like a slideshow. You may never want to open another window, because you'll hate to block your view of the show.

9.8.2. Screen Saver

On the Screen Saver panel, you can create your own screen-saver slideshows—an absolute must if you have an Apple Cinema Display and a cool Manhattan loft apartment.

Tip: Of course, a screen saver doesn't really save your screen. LCD flat-panel screens, the only kind Apple sells, are incapable of "burning in" a stationary image of the sort that originally inspired the creation of screen savers years ago.No, these screen savers offer two unrelated functions. First, they mask what's on your screen from passersby whenever you leave your desk. Second, they're a blast.

When you click a module's name in the Screen Savers list, you see a mini version of it playing back in the Preview screen. Click Test to give the module a dry run on your full monitor screen.

When you've had enough of the preview, just move the mouse or press any key. You return to the Screen Saver panel.

Apple provides a few displays to get you started, in two categories: Apple and Pictures.

9.8.2.1. Apple

  • Arabesque. Your brain will go crazy trying to make sense of the patterns of small circles as they come and go, shrink and grow. But forget it; this module, new in Leopard, is all just drugged-out randomness.

  • Computer Name. This display shows nothing more than the Apple logo and the computer's name, faintly displayed on the monitor. (These elements shift position every few minutes—it just isn't very fast.) Apple probably imagined that this feature would let corporate supervisors glance over at the screens of unattended Macs to find out who was not at their desks.

  • Flurry. You get flaming, colorful, undulating arms of fire, which resemble a cross between an octopus and somebody arc welding in the dark. If you click the Options button, you can control how many streams of fire appear at once, the thickness of the arms, the speed of movement, and the colors.

  • iTunes Artwork. Somebody put a lot of work into the album covers for the CDs whose music you own—so why not enjoy them as art? This module builds a gigantic mosaic of album art from your music collection, if you have one. The tiles periodically flip around, just to keep the image changing. (The Options button lets you specify how many rows of album-art squares appear, and how often the tiles flip.)

  • RSS Visualizer. Here, buried 43 layers deep in the operating system, is one of Leopard's most spectacular and useful features: the RSS Visualizer. When this screen saver kicks in, it displays a jaw-dropping, 3-D display of headlines (news and other items) slurped in from the Safari Web browser's RSS reader. (RSS items, short for Really Simple Syndication or Rich Site Summary, are like a cross between email messages and Web pages —they're Web items that get sent directly to you. Details in Section 10.25.)

    After the introductory swinging-around-an-invisible-3-D-pole-against-aswirling-blue-sky-background sequence, the screen saver displays one news blurb at a time. Each remains on the screen just long enough for you to get the point of the headline. Beneath, in small type, is the tantalizing instruction, "Press the '3' key to continue." (It's a different number key for each headline.) If you do, indeed, tap the designated key, you leave the screen saver, fire up Safari, and wind up on a Web page that contains the complete article you requested.

    The whole thing is gorgeous, informative, and deeply hypnotic. Do not use while operating heavy equipment.

    Tip: Click Options to specify which Web site's RSS feed you want displayed.

  • Spectrum. This one's for people who prefer not to have anything specific on their screens, like photos or text; instead, it's just a gradually shifting parade of glowing rainbow hues.

  • Word of the Day. New!! in Leopard: a parade of interesting words drawn from the Mac OS X Dictionary program. Every minute or so, one of these words stops, parks itself on your screen, and displays its dictionary definition. You're invited to tap the D key to open the dictionary to that entry to read more. Build your word power!

Tip: Click Options to specify which dictionary you want: the standard Oxford English, or the new Japanese one.
9.8.2.2. Pictures

The second category of screen savers are all based on the slideshowy presentation of photos. In Leopard, you can choose from three presentations of pictures in whatever photo group you choose, as represented by the three Display Style buttons just below the screen-saver preview.

  • Slideshow displays one photo at a time; they slowly zoom and softly cross-fade into each other.

    Tip: If you click Options, you get choices like "Present slides in random order" (instead of the order they appear in Apple's photo folder, or yours); "Cross-fade between slides" (instead of just cutting abruptly); "Zoom back and forth" (that is, slowly enlarge or shrink each photo to keep it interesting); "Crop slides to fit on screen" (instead of exposing letterbox bars of empty desktop if the photo's shape doesn't match the screen's); and "Keep slides centered" (instead of panning gracefully across).

  • Collage sends individual photos spinning randomly onto the "table," where they lie until the screen is full.

    Tip: This time, the Options button offers the "Present slides in random order" button, plus a "Collage style" pop-up menu that lets you add each photo's name and date to its white, Polaroid-style border.

  • Mosaic will blow your mind; see Figure 9-8.

    Tip: Click the Options button to specify the speed of the receding, the number of photos that become pixels of the larger photo, and whether or not you want the composite photos to appear in random order.

In any case, all of these photo-show options are available for whatever photo set you choose from the list at left. Your choices include:

  • Abstract, Beach, Cosmos, Forest, Nature Patterns, Paper Shadow. These sets include Abstract, which features psychedelic swirls of modern art. In the Beach, Cosmos, Forest, and Nature screen savers, you see a series of tropical ocean scenes, deep space objects, lush rain forests, and leaf/flower shots. Paper Shadow is a slideshow of undulating, curling, black-and-white shadowy abstract forms.

    Each creates an amazingly dramatic, almost cinematic experience, worthy of setting up to "play" during dinner parties like the lava lamps of the Seventies.

  • .Mac and RSS. One of the perks for paying $100 per year for a .Mac membership is the ability to create slideshows online, which can play back either on your own Mac or (if you opted to make it public) on anybody else's.

    Yes, that's right: You can now enjoy a screen saver composed of photos taken by somebody else on the Internet. ("Oh, look, honey, here's some shots of Uncle Jed's crops this summer!")

    Click the Options button to specify, by clicking the + button, which member's slideshow collection you want to view and how you want it to appear.(For example, you can turn off the crossfade between slides, crop the slides so that they fit on the screen, opt to present the slides in random order, and so on.)

    As a bonus, in this configuration screen, you can also specify an RSS feed's address (Section 20.2). The idea, of course, is that you'd specify a photo RSS feed's address here, like the ones generated by iPhoto.

    Tip: If you set up more than one .Mac and RSS-feed address here, the screen saver presents them as sequential slideshows. Drag them up or down the list to change their order.

  • Pictures Folder, Choose Folder. This is one of the coolest modules. It lets you transform your own collection of pictures —whatever you've got in your Home rightwards double arrow Pictures folder—into a self-playing slideshow, complete with spectacular zooming and dissolving effects. (If you keep your photos elsewhere, click Choose Folder instead.)

    Figure 9-8. This feeble four-frame representative sample will have to represent, on this frozen page, the stunning animated pullout that is the Mosiac screen saver.
    It starts with one photo (top); your "camera" pulls back farther and farther, revealing that that photo is just one in a grid—a huge grid— that's composed of all your photos.
    As you pull even farther back, each photo becomes so small that it becomes only one dot of another photo—from the same collection!
    And then that one starts shrinking, and the cycle repeats, on and on into infinity. How could Apple not have mentioned Mosaic in its Leopard advertising?

  • Library, Last Roll, Last 12 Months, Events list, Album list. If you're using iPhoto to organize your digital photos, you'll see its familiar album and event lists here, making it a snap to choose any of your own photo collections for use as a screen saver.

  • Use random screen saver. If you can't decide which one of the modules to use, turn on this checkbox. The Mac chooses a different module each time your screen saver kicks in.

  • Show with clock. This option, new in Leopard, just superimposes the current time on whatever screen saver you've selected. You'd be surprised at how handy it can be to use your Mac as a giant digital clock when you're getting coffee across the room.

9.8.2.3. Activating the screen saver

You can control when your screen saver takes over your monitor in a couple of ways:

  • After a period of in activity. Using the "Start screen saver" slider, you can set the amount of time that has to pass without keyboard or mouse activity before the screen saver starts. The duration can be as short as three minutes or as long as two hours, or you can drag the slider to Never to prevent the screen saver from ever turning on by itself.

    Figure 9-9. Click the Hot Corners button to open this sheet," which lets you designate certain corners of your screen as instant-activation spots, or never-come on spots. Sliding the mouse to the Start Screen Saver corner, for example, turns on your screen saver right away.

    GEM IN THE ROUGH
    Secrets of the Screen Saver Modules

    The canned screen saver modules are stored in your System rightwards double arrow Library rightwards double arrow Screen Savers folder. If you Control click (right-click) one of the icons inside and choose Show Package Contents from the shortcut menu, you'll find a Contents rightwards double arrow Resources folder that contains the individual image files for each module (the outer space photos for Cosmos screen saver, for example).

    Why bother? Because some of these spectacular photos make really good desktop pictures. You're free to copy them out of the Resources folder for that purpose.

  • When you park your cursor in the corner of the screen. If you click the Hot Corner button, you'll see that you can turn each corner of your monitor into a hot corner (Figure 9-9).

    Tip: You can find dozens more screen saver modules from Apple at www.apple.com/downloads/macosx/icons_screensavers, and from other people at www.epicware.com/macosxsavers.html.


displays.html

9.9. Displays

Displays is the center of operations for all your monitor settings. Here, you set your monitor's resolution, determine how many colors are displayed onscreen, and calibrate color balance and brightness.

Tip: You can open up this panel with a quick keystroke from any program on the Mac. Just press Option as you tap one of the screen-brightness keys on the top row of your keyboard.

The specific controls you'll see here depend on the kind of monitor you're using, but here are the ones you'll most likely see:

9.9.1. Display Tab

This tab is the main headquarters for your screen controls. It governs these settings:

  • Resolutions. All Mac screens today can make the screen picture larger or smaller, thus accommodating different kinds of work. You perform this magnification or reduction by switching among different resolutions (measurements of the number of dots that compose the screen). The Resolutions list displays the various resolution settings your monitor can accommodate: 800 x 600, 1024 x 768, and so on (Figure 9-10).

    When you use a low-resolution setting, such as 800 x 600, the dots of your screen image get larger, thus enlarging (zooming in on) the picture —but showing a smaller slice of the page. Use this setting when playing a small QuickTime movie, for example, so that it fills more of the screen. (Lower resolutions usually look blurry on flat-panel screens, though.) At higher resolutions, such as 1280 x 800, the screen dots get smaller, making your windows and icons smaller, but showing more overall area. Use this kind of setting when working on two-page spreads in your page-layout program, for example.

    FREQUENTLY ASKED QUESTION
    The Password-Protected Screen Saver

    I like the fact that when I wander away from my desk, the screen saver protects whatever I was doing from prying eyes. But whoever walks by can just press a key to exit the screen saver, so big deal! I looked all over, and couldn't find any way to make the Mac require a password before exiting the screen saver.

    You had the right idea—you were just looking in the wrong place.

    In System Preferences, click Security. There's the checkbox you're looking for: "Require password to wake this computer from sleep or screen saver."

    You're welcome.

  • Colors. Today's Mac monitors offer different color depth settings, each of which permits the screen to display a different number of colors simultaneously. The Colors pop-up menu generally offers only three choices: 256 Colors, Thousands, and Millions.

    Tip: You can still make your monitor gray scale (shades of gray), even if no choice for it appears here. The trick is to visit the Universal Access panel, described later in this chapter.

  • Refresh Rate. This pop-up menu (available for CRT screens only—that is, not flat panels) lets you adjust how many times per second your screen image is repainted by your monitor's electron gun. Choose a setting that minimizes flicker.

  • Brightness, Contrast. Use these sliders to make the screen look good in the prevailing lighting conditions. The Contrast control appears only on CRT monitors, and you'll usually want it all the way up. The Brightness slider is usually best near the middle.

    Of course, most Apple keyboards have brightness-adjustment keys, so these software controls are included just for the sake of completeness.

    Figure 9-10. In the early days of the Mac, higher color settings required a sacrifice in speed, since the Mac had to compute the color for thousands of individual pixels. Today, there's little downside to leaving your screen at its maximum depth setting ("Millions" of colors). Photos, especially, look best at higher depth settings. (The Detect Displays button appears primarily on laptops; it means "Check for an external monitor or projector.")

    Tip: You can adjust the color depth and resolution of your monitor without having to open System Preferences. Just turn on "Show displays in menu bar," which adds a Monitors pop-up menu (a menulet) to the right end of your menu bar for quick adjustments.

  • Automatically adjust brightness as ambient light changes. This option appears only if you have a PowerBook or MacBook Pro with a light-up keyboard. In that case, your laptop's light sensor also dims the screen automatically in dark rooms—if this checkbox is turned on.

9.9.2. Geometry Tab

This pane appears only on Macs with those increasingly rare CRT (that is, non-flat) screens. It lets you adjust the position, size, and angle of the screen image on the glass itself—controls that can be useful in counteracting distortion in aging monitors.

Tip: Don't miss the opportunity to eliminate the black borders around your screen perimeter! That's just wasted space. Click the Height/Width button. Then click the "expand vertical" and "expand horizontal" buttons at the lower-right corner of the miniature monitor image until you've eliminated the black borders around the screen. (You'll probably have to recenter the whole picture, too.)

9.9.3. Arrangement Tab

From the dawn of the color-monitor era, Macs have had a terrific feature: the ability to exploit multiple monitors all plugged into the computer at the sametime. Any Mac with a video-output jack (laptops, iMacs, eMacs), or any Mac with a second or third video card (Power Macs, Mac Pros), can project the same thing on both screens (mirror mode ); that's useful in a classroom when the "external monitor" is a projector.

Tip: The standard video card in a MacPro has jacks for two monitors. By installing more video cards, you can get up to six monitors going at once.

But it's equally useful to make one monitor act as an extension of the next. For example, you might have your Photoshop image window on your big monitor, but keep all the Photoshop controls and tool palettes on a smaller screen. Your cursor passes from one screen to another as it crosses the boundary.

FREQUENTLY ASKED QUESTION
Blurry Flat-Panel Screens

Yucko! I tried the 800 x 600 setting on my MacBook, and everything got all blurry and big! How do I fix it?

On any flat-panel screen—not just laptop screens—only one resolution setting looks really great: the maximum one. That's what geeks call the native resolution of that screen.

That's because on flat-panel screens, every pixel is a fixed size. At lower resolutions, the Mac does what it can to blur together adjacent pixels, but the effect is fuzzy and unsatisfying. (On a bulky CRT monitor, the electron gun can actually make the pixels larger or smaller, so you don't have this problem.)

You don't have to shut down the Mac to hook up another monitor—just put it to sleep. Or just hook up the monitor or projector and then choose Detect Displays from the Displays menulet.

When you open System Preferences, you see a different Displays window on each screen, so that you can change the color and resolution settings independently for each. Your Displays menulet shows two sets of resolutions, too, one for each screen.

If your Mac can show different images on each screen, your Displays panel offers an Arrangement tab, showing a miniature version of each monitor. By dragging these icons around relative to each other, you can specify how you want the second monitor's image "attached" to the first. Most people position the second monitor's image to the right of the first, but you're also free to position it on the left, above, below, or even directly on top of the first monitor's icon (the last of which produces a video-mirroring setup). For the least likelihood of going insane, consider placing the real-world monitor into the corresponding position—to the right of your first monitor, for example.

For committed multiple-monitor fanatics, the fun doesn't stop there. See the microscopic menu bar on the first-monitor icon? You can drag that tiny strip onto a different monitor icon, if you like, to tell Displays where you'd like your menu bar to appear. (And check out how most screen savers correctly show different stuff on each monitor!)

9.9.4. Color Tab

The Color pane lets you choose an accurate ColorSync profile for your screen (Section 14.8.1), and to calibrate it for correct color display.

When you click Calibrate, the Display Calibrator Assistant opens to walk you through a series of six screens, presenting various brightness and color-balance settings in each screen. You pick the settings that look best to you; at the end of the process, you save your monitor tweaks as a ColorSync profile that ColorSync-savvy programs can use to adjust your display for improved color accuracy.


dock.html

9.10. Dock

See Chapter 4 for details on the Dock and its System Preferences pane.


energy_saver.html

9.11. Energy Saver

The Energy Saver program helps you and your Mac in a number of ways. By blacking out the screen after a period of inactivity, it prolongs the life of your monitor. By putting the Mac to sleep half an hour after you've stopped using it, Energy Saver cuts down on electricity costs and pollution. On a laptop, Energy Saver extends the length of the battery charge by controlling the activity of the hard drive and screen.

Best of all, this pane offers the option to have your computer turn off each night automatically, and turn on again at a specified time in anticipation of your arrival at the desk.

9.11.1. Sleep Tab

The Energy Saver controls are very different on a laptop Mac and a desktop.

On a desktop Mac, you see a pair of sliders; on a laptop, you have to click Show Details to see them (Figure 9-11).

Figure 9-11. Top: Here's what Energy Saver looks like in its expanded condition on a laptop. (On a desktop machine, it's far simpler.) In the "Put the display to sleep" option, you can specify an independent sleep time for the screen.
Bottom: Here are the Schedule controls—a welcome return of the Mac's self-scheduling abilities.

In any case, the top slider controls when the Mac will automatically go to sleep—anywhere from one minute after your last activity to Never. (Activity can be mouse movement, keyboard action, or Internet data transfer; Energy Saver won't put your Mac to sleep in the middle of a download.)

At that time, the screen goes dark, the hard drive stops spinning, and your processor chip slows to a crawl. Your Mac is now in sleep mode, using only a fraction of its usual electricity consumption. To wake it up when you return to your desk, press any key. Everything you were working on, including open programs and documents, is still onscreen, exactly as it was. (To turn off this automatic sleep feature entirely, drag the slider to Never.)

Note: On Macs of old, the beauty of the independent "Put the display to sleep" slider was that you could make the screen go dark before the Mac itself. That way, the Mac would awaken instantly when you touched a key or clicked the mouse.In Mac OS X, the Mac always wakes almost instantly from sleep—one of the great payoffs of Mac OS X. In other words, there's only one good reason left to set the screen to sleep independently of the Mac itself: so that your Mac can run its standard middle-of-the-night maintenance routines, even while the screen is off to save power.

Finally, "Put the hard disk(s) to sleep when possible" saves even more juice—and noise—by letting your drives stop spinning when not in use. The downside is a longer pause when you return to work and wake the thing up, because it takes a few seconds for your hard drive to "spin up" again.

9.11.2. Laptop Options

As noted above, Energy Saver on a laptop offers quite a few additional controls (see Figure 9-11). That's because power management is ten times more important on a laptop, where every drop of battery power counts.

The pop-up menus at the top of the dialog box, for example, let you create different settings for the two states of life for a laptop, when it's plugged in (Power Adapter) and when it's running on battery power (Battery).

Once you've indicated which setting you want to adjust, you can then use the Optimization pop-up menu to choose a canned Energy Saver setting, depending on where you want to fall on the speed-vs.-battery-life spectrum. For example, when you're adjusting the settings for battery-only operation, you can choose Better Battery Life (screen and laptop go to sleep relatively quickly, your processor chip slows down, and the screen brightness dims) or Better Performance (screen sleeps after five minutes, laptop after fifteen, processor runs at top speed).

The Custom option just means "none of the above." Whenever you adjust one of the sliders or checkboxes, Energy Saver automatically changes the pop-up menu to say Custom. Mac OS X remembers your settings here. If you choose one of the presets and then choose Custom again, your hand-adjusted settings remain in place.

9.11.3. Scheduled Startup and Shutdown

By clicking the Schedule button, you can set up the Mac to shut itself down and turn itself back on automatically (Figure 9-11, bottom).

If you work 9 to 5, for example, set the office Mac to turn itself on at 8:45 a.m., and shut itself down at 5:30 p.m.—an arrangement that conserves electricity, saves money, and reduces pollution, but doesn't inconvenience you in the least. In fact, you may come to forget that you've set up the Mac this way, since you'll never actually see it turned off.

Note: The Mac doesn't shut down automatically if you've left unsaved documents open onscreen. It will go to sleep, though.

9.11.4. Waking and Other Options

Click the Options tab to summon a few more controls, which vary depending on your Mac model:

  • Wake when the modem detects a ring. This checkbox appears only if your Mac actually has a dial-up modem. It can be useful in two circumstances: first, if you use your Mac as a fax machine that accepts incoming faxes (Chapter 14), and second, if you dial into your Mac from the road. In either case, when a phone call reaches the laptop's modem, the computer wakes up and accepts the call—if this option is turned on.

    GEM IN THE ROUGH
    Mysteries of the Battery Menulet

    If you've got a laptop, don't miss the checkbox in Energy Saver called "Show battery status in the menu bar." It puts a handy status indicator in the menu bar [image] that keeps you informed of your battery's life.

    When used as a menu, this menulet lets you choose between displaying the actual number of minutes left until a battery is depleted, the percentage of battery life that remains, or a visual emptying-battery icon. (You can also switch among energy-conservation presets—like Better Energy Savings and Better Performance—from this menulet.)

    If you've opted to view the numeric version, you may notice that sometimes the number, or the percentage, is in parentheses, like this: (78%). That's your signal that the laptop is plugged in and charging; you're seeing the number of minutes left until the battery is fully recharged (or the percentage of full charge you've achieved so far). Either way, the readout is counting down (or up) to that joyous moment.

    If you're viewing only the battery icon in the menu bar, here's what the readouts mean:

    Power-cord-in-the-battery: The laptop is plugged in, and the battery is 100 percent charged. Ready to roll, captain!

    Lightning-bolt-in-the-battery: The laptop is plugged in, but the battery is still charging.

    Superimposed X: The laptop is plugged in, but the battery isn't in right, it's missing, or it isn't getting a charge for some other reason.

    Emptying black battery: The laptop is running off of battery power, and has at least 25 percent power left. (The width of the bar reveals how much charge is left.)

    Emptying red battery: You're running off of battery power, and you have less than 25 percent charge remaining.

    A nearly invisible red bar means you have less than nine minutes left. Save those documents, buddy.

  • Wake for Ethernet network administrator access. This option exists exclusively for the purchasers of the software suite called Mac OS X Server, which lets the network guru in an office control (and, with this checkbox, even awaken) sleeping Macs on the network. (On a laptop, this option is only for Power Adapter mode.)

  • Automatically reduce the brightness of the built-in display when using this power source. You see this checkbox only when you're adjusting the settings for battery power mode. It means "Don't use full brightness, so I can save power."

  • Automatically reduce the brightness of the display before display sleep. When this option is on, the screen doesn't just go black suddenly after the designated period of inactivity; instead, it goes to half brightness as a sort of drowsy mode that lets you know full sleep is coming soon.

  • Restart automatically after a power failure. This is a good option if you leave your Mac unattended and access it remotely, or if you use it as a network file server or Web server. It ensures that, if there's even a momentary blackout that shuts down your Mac, it starts itself right back up again when the juice returns. (It's available only when you're adjusting Power Adapter mode on a laptop.)

  • Show battery status in the menu bar. This is the on/off switch for the battery menulet described in the box on the preceding page.

  • Processor performance. Is the scalding metal case of the PowerBook sending your thighs to the emergency room? Here's your quick fix: Choose Reduced from this pop-up menu. Your chip doesn't run nearly as fast now, but it's still plenty fast for email, word processing, and so on—and it runs at about half the temperature. (You'll gain some battery life, too.)


exposeacute_ampersand_spaces.html

9.12. Exposé & Spaces

Exposé and Spaces, the two ingenious window- and screen-management features of Mac OS X, are described in detail in Chapter 5—and so is this joint-venture control panel.


international.html

9.13. International

The International pane's primary job is to set up your Mac to work in other languages. If you bought your Mac with a localized operating system—a version that already runs in your own language—and you're already using the only language, number format, and keyboard layout you'll ever need, then you can ignore most of this panel.

But at the very least, check it out. When it comes to showing off Mac OS X to your friends and loved ones, the "wow" factor on the Mac's polyglot features is huge.

9.13.1. Another Language—Instantly

In Mac OS X, you can shift from language to language in certain programs on the fly, without reinstalling the operating system or even restarting the computer.

On the Language tab, you see a listing of the different languages the Mac can switch into, in the corresponding languages—Français, Español, and so on. Just drag one of the languages to the top of the list to select it as the target language, as shown in Figure 9-12.

Figure 9-12. Top: This is the list of the 19 "system localizations" that you get with a standard Mac OS X installation.
Bottom: Here's Safari running in Dutch. Actually understanding Dutch would be useful at a time like this—but even if you don't, it can't help but brighten up your work day to choose commands like Spraakfunctie or Knip. (Alas, your success with this trick varies by program.)

Now launch Safari, TextEdit, or Stickies. Every menu, button, and dialog box is now in the new language you selected! If you log out and back in (or restart) at this point, the entire Finder will be in the new language, too.

Note: Programs differ widely in their "language awareness." If you use a language beyond the 16 in the list, adding it (use the Edit button) ensures that its relevant features will be available in all programs. (You may still have to add additional language software to make your menus and dialog boxes change.)

UP TO SPEED
The Character Palette

There you are, two-thirds of the way through your local matchmaker newsletter, when it hits you that you need a heart symbol. Right now.

You know there's one in one of your symbol fonts, but you're not about to type every single key combo until you produce the heart symbol. You can't help wishing there was an easier way to find those special symbols that hide among your fonts—fancy brackets, math symbols, special stars and asterisks, and so on.

The Keyboard Viewer (Section 9.13.3.1) is one solution. But there's a better one: the Character Palette. To make it appear, choose Edit rightwards double arrow Special Characters.

Most Cocoa programs have this command. If yours doesn't, here's the long way: Open System Preferences, click the International icon, click the Input Menu tab, and turn on the Character Palette checkbox.

You've just installed the Keyboard menulet.

Next time you're word processing or doing page layout, choose Show Character Palette from this menu.

The resulting window rounds up all symbols from all your fonts at once. To find a particular symbol, click the "by Category" tab, and then click the various category headings: Arrows, Stars/ Asterisks, Math, and so on. Or, for an even more mind-blowing assortment (musical notes, Braille…), choose All Characters from the View pop-up menu.

You can preview variations of the same symbol by opening the Font Variation triangle. You can also use the Search box to find a symbol by name: "heart" or "yen" or "asterisk," for example. When you find the symbol you want, double-click it.

If you're using a Cocoa program, the correct symbol pops into your document. (If not, you may get the correct character in the wrong font. In that case, change the font of the inserted character manually. To find out what font it came from, click the Font Variation flippy triangle to see the font name.)

9.13.2. Formats Tab

Of course, if you're really French (for example), you'll also want to make these changes:

  • On the Format stab, choose your French-speaking country from the Region pop-up menu, so that time and date formats, number punctuation, and currency symbols also conform to your local customs. (Turn on "Show all regions," if necessary.)

    For example, the decimal and thousands separator characters for displaying large numbers differ from country to country. (The number 25,600.99, for example, would be written as 25 600, 99 in France, and as 25.600,99 in Spanish.) And what appears to an American to be July 4 (the notation 7/4), to a European indicates April 7.

    If, for some reason, Apple's preprogrammed settings aren't right for your region, you'll see Customize buttons that let you override them.

  • Choose the French keyboard layout from the Input Menu tab, as explained on Section 9.12.

Tip: Every program capable of switching languages is also clogging up your hard drive with a lot of language files you'll never use. A program like DeLocalizer can sweep through all your programs and delete those files, leaving your software in perfect condition but more svelte. You can get DeLocalizer from this book's "Missing CD" page at www.missingmanuals.com.

9.13.3. Input Menu Tab

While the Mac can display many different languages, typing in those languages is another matter. The symbols you use when you're typing Swedish aren't the same as when you're typing English. Apple solved this problem by creating different keyboard layouts, one for each language. Each rearranges the letters that appear when you press the keys. For example, when you use the Swedish layout and press the semicolon key, you don't get a semicolon (;)—you get an ö.

Apple even includes a Dvorak layout—a scientific rearrangement of the standard layout that puts the most common letters directly under your fingertips on the home row. Fans of the Dvorak layout claim greater accuracy, better speed, and less fatigue.

Use the list in the Input Menu pane to indicate which keyboard layout you want. If you select anything in the list, "Show input menu in menu bar" turns on automatically. A tiny flag icon appears in your menu bar—a keyboard menulet that lets you switch from one layout to another just by choosing its name. (To preview a certain keyboard arrangement, launch the Keyboard Viewer program described next.)

Tip: Instead of using the keyboard menu, you can switch back and forth between the most recently selected pair of keyboard layouts by pressing [image] -Space bar. Alternatively, you can "walk down" the list of layouts by pressing Option- [image] -Space.Of course, these keystrokes are exactly the same as Leopard's preassigned keystrokes for the Spotlight menu and Spotlight window (Chapter 3). Your best bet is to change the Spotlight key assignments as described on Section 3.3.1. Apple's keyboard-layout keystrokes always take precedence over the same shortcuts in your programs.
9.13.3.1. Keyboard Viewer: The Return of Key Caps

Keyboard Viewer, which is descended from the Key Caps program of old, consists of a single window containing a tiny onscreen keyboard (Figure 9-13). When you hold down any of the modifier keys on your keyboard (like [image], Option, Shift, or Control), you can see exactly which keys produce which characters. The point, of course, is to help you learn which keys to press when you need special symbols or non-English characters, such as © or ¢, in each font.

Note: Keyboard Viewer shows only the symbols you can produce by typing keystrokes. A font may contain thousands of other characters that can't actually be typed; the Character Palette (Section 9.13.2) is the only way to access these other symbols.

Figure 9-13. How do you make a π symbol? Top: Open Keyboard Viewer by choosing its name from the keyboard (flag) menulet.
Bottom: Keyboard Viewer reveals the answer. When you press the Option key, the Keyboard Viewer keyboard shows that the pi character (π) is mapped to the P key. To insert the symbol into an open document, just click it in the Keyboard Viewer window.

It's a great tool—if you can find it.

Here's how. Open the International panel of System Preferences, click Input Menu, and turn on the Keyboard Viewer checkbox. The window shown at top in Figure 9-13 appears. (Thereafter, you'll be able to choose its name from the flag menulet at the top of the screen, as shown at top in Figure 9-13.)

To see the effect of pressing the modifier keys, either click the onscreen keys or press them on your actual keyboard. The corresponding keys on the onscreen keyboard light up as they're pressed.

9.13.3.2. Change the Keyboard Viewer font

Different fonts contain different hidden characters. For example, Palatino contains an [image] character (pressing Shift-Option-K), but Adobe Garamond does not.

Fortunately, Keyboard Viewer lets you see the characters lurking within almost any installed font; just choose a font's name from the Font pop-up menu to see all of its modifier-key characters. (You may have to change the keyboard layout to see all symbols in some fonts.) Alas, this feature doesn't work in a few of the fonts where it would be the most useful—certain symbol fonts like Symbol and Zapf Dingbats.

Tip: You're not stuck viewing all characters in 12-point size—a good thing, because some of them are hard to read when displayed that small. Just "zoom" the Keyboard Viewer window by clicking its Zoom button. You magnify the Keyboard Viewer window and its font, creating a full-scale on-screen keyboard.


keyboard_ampersand_mouse.html

9.14. Keyboard & Mouse

This panel lets you do some frivolous fine-tuning of your mouse, keyboard, and (for laptops) trackpad. It also unlocks Mac OS X's strange and remarkable Full Keyboard Access feature, which lets you control your Mac's menus, windows, dialog boxes, buttons, the Dock, and the toolbar—all from the keyboard (Section 5.6.1.3). Here's a tour of the Keyboard & Mouse tabs.

UP TO SPEED
Bringing Dead Keys to Life

If you press Option while the Keyboard Viewer window is open, you see certain keys turn orange (shown in Figure 9-13, for example). This highlighting identifies the Mac's five dead keys—keys that, when pressed once, type nothing onscreen in most programs.

However, when you then type another key—a normal letter, for example—it appears with the dead key's displayed marking over it.

To type the ñ in jalapeño, for example, you must first press Option-N and then type an n. This same two-step approach lets you type characters like ö and é.

9.14.1. Keyboard Tab

The changes you make are tiny, but can have a cumulatively big impact on your daily typing routine.

  • Key Repeat Rate, Delay Until Repeat. You're probably too young to remember the antique once known as the typewriter. On some electric versions of this machine, you could hold down the letter X key to type a series of XXXXXXXs—ideal for crossing something out in a contract, for example.

    On the Mac, every key behaves this way. Hold down any key long enough, and it starts spitting out repetitions, making it easy to type, for example, "No WAAAAAAAY!" or "You go, girrrrrrrrrl!" These two sliders govern this behavior. On the right: a slider that determines how long you must hold down the key before it starts repeating (to prevent triggering repetitions accidentally, in other words). On the left: a slider that governs how fast each key spits out letters once the spitting has begun.

  • Use all F1, F2, etc. keys as standard function keys. This option appears only on laptops and aluminum-keyboard Macs. It's complicated, so read slowly.

    On Mac laptops, many of the F-keys on the top row perform laptop-related functions. For example, the F1 and F2 keys adjust the screen brightness, F3, F4, and F5 control the speaker volume, and so on. (You have the same setup on the aluminum Apple keyboard. Many of its F-keys have special hardware-control functions, too.)

    So what if you want to use those keys for other functions? For example, the F1 key is the Help key in many programs. How can you open Help, if F1 makes the screen dimmer?

    In those situations, you're supposed to trigger the F-key's second personality by pressing the Fn key simultaneously. So if F1 opens Help on a desktop Mac, Fn-F1 does it on a laptop.

    If you find yourself using the software features (like Help) more often than the hardware features (like brightness), you can reverse this logic. Turning on "Use all F1, F2, etc. keys as standard function keys" lets the F-keys be F-keys, so they have no hardware-control functions. Now F1 by itself opens Help. Now, however, you add the Fn key for the hardware functions like brightness and volume.

  • Illuminate keyboard in low light conditions. This setting appears only if your Mac's keyboard does, in fact, light up when you're working in the dark—a showy feature of, for instance, some 15- and all 17-inch Mac laptops. You can specify that you want the internal lighting to shut off after a period of activity (to save power when you've wandered away, for example), or you can turn the lighting off altogether.

  • Modifier Keys. This button lets you turn off, or remap, the functions of the Option, Caps Lock, Control, and [image] keys. It's for Unix programmers whose pinkies can't adjust to the Mac's modifier-key layout—and for anyone who keeps hitting Caps Lock by accident during everyday typing.

9.14.2. Mouse Tab

It may surprise you that the cursor on the screen doesn't move five inches when you move the mouse five inches on the desk. Instead, the cursor moves farther when you move the mouse faster.

How much farther depends on how you set the first slider here. The Fast setting is nice if you have an enormous monitor, since you don't need an equally large mouse pad to get from one corner to another. The Slow setting, on the other hand, forces you to pick up and put down the mouse frequently as you scoot across the screen. It offers very little acceleration, but it can be great for highly detailed work like pixel-by-pixel editing in Photoshop.

The Double-Click Speed setting specifies how much time you have to complete a double-click. If you click too slowly —beyond the time you've allotted yourself with this slider—the Mac "hears" two single clicks instead.

If you have an Apple Mighty Mouse—the white mouse that has come with desktop Macs since 2005—then the Mouse tab is a much fancier affair (Figure 9-14).

Figure 9-14. This enormous photographic display shows up only if you have the Mighty Mouse, Apple's "two-button" mouse. The pop-up menus let you program the right, left, and side buttons of this mouse. It offers functions like opening Dashboard, triggering Exposé, and so on.
This is also where you can turn the rightclicking feature on (just choose Secondary Button from the appropriate pop-up menu)—or swap the right- and left-click buttons' functions.

9.14.3. Trackpad Tab

This panel shows up only if you have a laptop. At the top, you find duplicates of the same Tracking Speed and Double-Click Speed sliders described above —but these let you establish independent tracking and clicking speeds for the trackpad.

9.14.3.1. Trackpad Gestures

You may love your Mac laptop now, but wait until you find out about these special features. They make your laptop crazy better. It turns out you can point, click, scroll, and right-click—all on the trackpad itself, without a mouse and without ever having to move your fingers.

  • Use two fingers to scroll. This one is sweet. You have to try it to believe it.

    When you turn this option in, dragging two fingers across your trackpad scrolls whatever window is open, just as though you had slid over to the scroll bar and clicked there. Except doing it with your two fingers, right in places, is infinitely faster and less fussy. In Leopard, you even get a Scrolling Speed slider.

    Tip: You'll be allowed to scroll only up or down—unless you also turn on "Allow horizontal scrolling."

  • Zoom while holding Control. Here's another irresistible feature. Once you learn it, you'll never look back.

    When this checkbox is turned on, you can zoom into the screen image, magnifying the whole thing, just by dragging two fingers up or down the trackpad while you're pressing the Control key. You can zoom in so far that the word "zoom" in 12-point type fills the entire monitor.

    This feature comes in handy with amazing frequency. It's great for reading Web pages in tiny type, or enlarging Web movies, or studying the dot-by-dot construction of a button or icon that you admire. Just Control-drag upward to zoom in, and Control-drag downward to zoom out again.

    In Leopard, for the first time, you can customize this feature to within an inch of its life. For example, you can substitute the Option or [image] key, if Control isn't working out for you (use the pop-up menu).

    Tip: If you don't have a laptop—and therefore you don't have a trackpad—you can get the same effect by Control-scrolling using any mouse that has a trackwheel or trackpea on top, like Apple's standard Mighty Mouse. See "Universal Access" later in this chapter.

    If you click Options, you get even more choices. First, you can specify how you want to scroll around within your zoomed-in screen image. The factory setting, "Continuously with pointer," is actually pretty frustrating; the whole screen shifts around whenever you move the cursor. ("So the pointer is at or near the center of the image" is very similar.) "Only when the pointer reaches an edge" is a lot less annoying, and lets you use the cursor (to click buttons, for example) without sending the entire screen image darting away from you.

    Tip: Also in the Options box: the ability to turn off the pixel-smoothing feature that adds a certain blurriness to the zoomed-in image —and a reminder that you can press Option- [image] -\ (backslash) to turn it on or off at any time.

  • Clicking. Under normal circumstances, you touch your laptop's trackpad exclusively to move the cursor. For clicking and dragging, you're supposed to use the clicking button beneath the trackpad.

    Many people find, however, that it's more direct to tap and drag directly on the trackpad, using the same finger that's been moving the cursor. That's the purpose of this checkbox. When it's on, you can tap the trackpad surface to register a mouse click at the location of the cursor. Double-tap to double-click.

  • Dragging. This option lets you move icons, highlight text, or pull down menus—in other words, to drag, not just click—using the trackpad.

  • Start by tapping twice on the trackpad, then immediately after the second tap, begin dragging your finger. (If you don't start moving promptly, the laptop assumes that you were double-clicking.) You can stroke the trackpad repeatedly to continue your movement, as long as your finger never leaves the trackpad surface for more than about one second. When you "let go," the drag is considered complete.

  • Drag Lock. If you worry that you're going to "drop" what you're dragging if you stop moving your finger, turn on this option instead. Once again, begin your drag by double-clicking, then move your finger immediately after the second click.

    When this option is on, however, you can take your sweet time in continuing the movement. In between strokes of the trackpad, you can take your finger off the laptop for as long as you like. You can take a phone call, a shower, or a vacation; the Mac still thinks that you're in the middle of a drag. Only when you tap again does the laptop consider the drag a done deal.

  • For secondary clicks, place two fingers on the trackpad then click the button. What Apple's punctuation-challenged programmers are trying to say here is, "You can right-click now!"

    And sure enough: If you click with your thumb while your index and middle fingers are resting on the trackpad, you get a right-click (or a Control-click). Right-clicking, of course, opens a shortcut menu filled with useful commands pertaining to whatever you're clicking.

    This technique is a lot more natural than it sounds. But like trackpad scrolling and trackpad zooming, it soon becomes an indispensable skill.

9.14.3.2. Trackpad options

  • Ignore accidental trackpad input. This option addresses a chronic syndrome of laptop owners who turn on the Clicking option. When you type along and a finger accidentally brushes the trackpad, it sends the insertion point onto a different line of text. Before you even notice, you've typed over, or typed into, some random part of your document.

    This ingenious option locks out the click-and-drag trackpad functions when you're actually typing on the keyboard—an elegantly simple solution.

  • Ignore trackpad when mouse is present. Here's another ingenious advance in laptop technology. When you hook up a mouse, trackball, or tablet to your laptop, the trackpad is deactivated. If you're using a mouse, then you probably won't want to use the trackpad—and by turning on this checkbox, you're no longer susceptible to brushing it accidentally.

9.14.4. Bluetooth Tab

People have named their Macs for years (Voyager, Li'l Abner, PowerThang G5). Now they can name their keyboards and mice—and, indeed, must—to accommodate Apple's cordless Bluetooth keyboard and mouse. Here's where you type in their names (so your Mac knows which wireless keyboard and mouse it's "listening" to in a room full of them) and monitor their battery levels.

9.14.5. Keyboard Shortcuts

Mac OS X comes loaded with keyboard shortcuts for common tasks—and now you can reassign them to shortcuts you prefer. For a full discussion of the options on this pane, see Section 5.6.1.3.


network.html

9.15. Network

The Network panel is the brain of your Mac's Internet and local networking connections. See Chapters Chapter 13 and Chapter 18 for the settings you need to plug in.


parental_controls.html

9.16. Parental Controls

These controls, new in Leopard, are described at length in Chapter 12.


print_ampersand_fax.html

9.17. Print & Fax

Chapter 14 describes printing and faxing in detail. This panel's purpose in life is to offer a centralized list of the printers you've introduced to the Mac, to specify the one you use most of the time, and to report on their status.


quicktime.html

9.18. QuickTime

The settings in the QuickTime panel affect the way movies are played back on your Mac, including movies that stream to you from a Web page and movies that you watch using QuickTime Player (Chapter 15).

You don't have to touch most of these options, but here are a few worth tweaking:

  • Register. Fill in the blanks to upgrade to QuickTime Pro; see Chapter 15.

  • Browser. These settings control how your Web browser's QuickTime plug-in works with streaming video. "Play movies automatically, "for example, tells the plug-in to start playing movies as soon as they begin downloading, rather than wait for the entire movie to download first. (If you have a dial-up Internet connection, you'll probably want this turned off to keep the incoming movie from stuttering.)

  • Update. These controls provide an easy way to download the latest QuickTime software version.

  • Streaming. Some streaming QuickTime Website sare setup with multiple versions of the same movie, each saved at a different size and frame rate. Based on your connection speed setting here, the QuickTime plug-in can automatically request the appropriately sized version of a movie for the best possible playback. Usually, Automatic detects the speed, saving you the trouble of muddling with the pop-up menu.

    The Enable Instant-On feature means that you can begin watching a streaming QuickTime movie before it's been fully downloaded.

    However, this feature works because QuickTime analyzes how fast the movie data is arriving from the Web, and extrapolating. "If I'm getting 30 K of data per second," for example, "then I can begin playing this movie after three seconds' worth have arrived on this Mac. The rest of the movie data will keep coming in while I'm playing back, so I can play this movie uninterrupted."

    Well, right—unless the stream doesn't keep coming at 30 K per second. If Internet traffic slows down the stream at some point, you'll wind up with a paused movie and a "loading" indicator while QuickTime catches up.

    The purpose of the Play slider, then, is to compensate for such network delays. Drag the slider toward Short Delay if you'd rather wait longer for the movie to begin, but enjoy uninterrupted playback.

  • Advanced. Synthesizer: Here, you can choose a music synthesizer for playing back MIDI files. You don't have any choice unless you've searched Google for Sound-Fonts, downloaded some, and put them in your Library rightwards double arrow Audio rightwards double arrow Sounds rightwards double arrow Banks folder. Transport Setup: On Automatic, QuickTime attempts to determine the best protocol and Internet port (channel)for in coming movie data. QuickTime usually works best if you set the Transport Protocol to http, and the Port ID to 80.

    Enable kiosk mode: This option shortens the shortcut menu that appears when you Control-click a QuickTime movie in your Web browser—by eliminating the QuickTime Settings and Save Movie As options. Enable Flash: Lets QuickTime play Flash animations and movies (like the ones on You Tube). You definitely want this one turned on, or you'll miss out on a lot of stuff on the Web.

    MIME Settings: Lets you identify which kinds of Internet streams (that is, which formats of audio and video) you'd like QuickTime to handle. Visit these controls if, for example, a certain Internet radio show is opening up the Real Player instead of QuickTime Player. Media Keys: Media keysare supposed to be special passwords that unlock movies so you can watch them. As it turns out, nobody uses them.


security.html

9.19. Security

Mac OS X turns out to be one of the most secure operating systems on earth—and this panel helps to explain why. See Chapter 12 for details on locking up your Mac.


sharing.html

9.20. Sharing

Mac OS X is an upstanding network citizen, flexible enough to share its contents with other Macs, Windows PCs, people dialing in from the road, people dialing in from the Internet, and so on. On this totally overhauled panel, you'll find on/off switches for each of these sharing channels. In this book, many of these features are covered in other chapters:

  • Screen Sharing, File Sharing. Chapter 13.

  • Printer Sharing. Chapter 14.

  • Web Sharing. Chapter 22.

  • Remote Login. Chapter 22.

  • Remote Management. Lets someone else control your Mac using Apple Remote Desktop, a popular add-on program for teachers.

  • Remote Apple Events. Lets Apple Script gurus (Chapter 7) send commands to Macs across the network.

  • Xgrid Sharing. Xgrid is powerful software that lets you divide up a complex computational task—like computer animation or huge scientific calculations— among a whole bunch of Macs on your network, so that they automatically work on the problem when they're otherwise sitting idle. If you're intrigued, visit http://developer.apple.com/hardware/hpc/xgrid_intro.html.

  • Internet Sharing. Chapter 18.

  • Bluetooth Sharing. This pane lets you set up Bluetooth file sharing, a way for other people near you to shoot files over to (or receive files from) your laptop—without muss, fuss, or passwords. Section 6.2.6.1 has the details.


software_update.html

9.21. Software Update

Few operating-system ideas are simpler or better than this one: Whenever Apple improves or fixes some piece Mac OS X or some Apple-branded program, the Software Update program can notify you, download the update, and install it into your system automatically. These updates may include new versions of programs like iPhoto and iMovie; drivers for newly released printers, scanners, cameras, and such; bug fixes and security patches; and so on.

Software Update doesn't run rampant through your system software, however. It's quietly respectful. For example, Software Update doesn't download the new software without asking your permission first and explicitly telling you what it plans to install, as shown in Figure 9-15.

Figure 9-15. When Software Update finds an appropriate software morsel, it presents this dialog box that offers to install it automatically. (If you see a smaller version of this dialog box, with no visible list of the new components, click the Details button.)
Apple has always created updated and bug-fixing versions of its software components, but they don't do you any good if you don't know about them. You no longer have to scour Mac news Web sites to discover that one of these components has been released and then hunt down the software itself.

9.21.1. Scheduled Check Tab

For maximum effortlessness, turn on the "Check for updates" checkbox and then select a frequency from the pop-up menu—daily, weekly, or monthly. If you also turn on "Download important updates in the background," you'll still be notified before anything gets installed, but you won't have to wait for the downloading—the deed will already be done.

(If you've had "Check for updates" turned off, you can always click the Check Now button to force Mac OS X to report in to see if new patches are available.)

9.21.2. Installed Updates Tab

Software Update also keeps a meticulous log of everything it drops into your system. On this tab, you see them listed, for your reference pleasure.

Tip: In your hard drive rightwards double arrow Library rightwards double arrow Receipts folder, you'll find a liberal handful of .pkg files that have been downloaded by Software Update.Most of these are nothing more than receipts that help Mac OS X understand which updaters you've already downloaded and installed. They make intriguing reading, but their primary practical use is finding whether or not you've installed, for example, the 10.5.2 update.


sound.html

9.22. Sound

Using the panes of the Sound panel, you can configure the sound system of your Mac in any of several ways.

Tip: Here's a quick way to jump directly to the Sound panel of System Preferences—from the keyboard, without ever having to open System Preferences or click Sound. Just press Option as you tap one of the volume-adjustment keys on the top row of your Apple keyboard.

9.22.1. Sound Effects Tab

"Sound effects" means error beeps —the sound you hear when the Mac wants your attention, or when you click someplace you shouldn't.

Just click the sound of your choice to make it your default system beep. Most of the canned choices here are funny and clever, yet subdued enough to be of practical value as alert sounds (Figure 9-16).

As for the other controls on the Sound Effects panel, they include:

  • Alert volume slider. Some Mac fans are confused by the fact that even when they drag this slider all the way to the left, the sound from games and music CDs still plays at full volume.

    POWER USERS' CLINIC
    Storing Apple Software Updates

    The great unspoken migraine of Software Update is this: If you ever reinstall Mac OS X from its original CD or DVD (when you install a new hard drive or move to a new com-puter, for example), you'll have to download and install all relevant updates again. That is, if your Mac came with Mac OS X 10.5 and iPhoto 7.0.1, you'll have to download and install the 10.5.1 updater, the iPhoto 7.0.2 updater, and so on.

    Fortunately, although you can't skip the reinstallation process, you can skip the download step—by preserving the update installers as they arrive.

    Each time Software Update finds updates to install, turn on the ones you wish to install, and then choose Update rightwards double arrow Install and Keep Package.

    Later, you can reinstall your downloaded updates at any time simply by double-clicking each installer. (They wind up in your Macintosh HD rightwards double arrow Library rightwards double arrow Packages folder.)

    The sole downside: When there are multiple updates that require restarting your Mac, you have to restart after each one you install. On its own, Software Update would save up its one restart until all of the updates are installed.

    The actual main volume slider for your Mac is the "Output volume" slider at the bottom of the Sound pane. The "Alert volume" slider is just for error beeps; Apple was kind enough to let you adjust the volume of these error beeps independently.

    Figure 9-16. You can adjust your overall speaker volume independently from the alertbeep volume, thank goodness. Tip nerds should note that you can also adjust the alert volume by holding down the Option key as you drag the handle in the speakervolume menulet (on your menu bar).

  • Play user interface sound effects. This option produces a few subtle sound effects during certain Finder operations: when you drag something off of the Dock, into the Trash, or into a folder, or when the Finder finishes a file-copying job.

  • Play feedback when volume is changed. Most Mac keyboards have little volume adjustment keys on the top row that, when pressed, adjust the overall speaker level. Each time you press one of these keys, the Mac beeps to help you gauge the current volume.

    That's all fine when you're working at home. But more than one person has been humiliated in an important meeting when the Mac made a sudden, inappropriately loud sonic outburst—and then amplified that embarrassment by furiously and repeatedly pressing the volume-down key, beeping all the way.

    If you turn off this checkbox, the Mac won't make any sound at all as you adjust its volume. Instead, you'll see only a visual representation of the steadily decreasing (or increasing) volume level.

    Tip: If you like the little volume-adjustment clicks most of the time, you can shut them up on a one-shot basis by pressing Shift as you tap the volume keys.

  • Play Front Row sound effects. You can read about Front Row, which turns your Mac screen into a giant multimedia directory for your entire Mac, in Chapter 15. All this option does is silence the little clicks and whooshes that liven up the proceedings when you operate Front Row's menus.

9.22.2. Output Tab

"Output" means speakers or headphones. For 99 percent of the Mac-using community, this pane offers nothing useful except the Balance slider, with which you can set the balance between your Mac's left and right stereo speakers. The "Choose a device" wording seems to imply that you can choose which speakers you want to use for playback. But Internal is generally the only choice, even if you have external speakers. (The Mac uses your external speakers automatically when they're plugged in.)

A visit to this pane is necessary, however, if you want to use USB speakers or a Bluetooth or USB phone headset. Choose its name from the list.

9.22.3. Input Tab

This panel lets you specify which sound source you want the Mac to "listen to," if you have more than one connected: external microphone, internal microphone, line input, USB headset, or whatever. It also lets you adjust the sensitivity of that microphone—its input volume —by dragging the slider and watching the real-time Input level meter above it change as you speak.

Put another way, it's a quick way to see if your microphone is working.

Tip: The new "Use ambient noise reduction" is great if you make podcasts or use dictation software. It turns any mike into what amounts to a noise-canceling microphone, deadening the background noise while you're recording.


speech-id001.html

9.23. Speech

Your Mac's ability to speak—and be spoken to—is described in juicy detail starting on Section 15.4.


spotlight-id003.html

9.24. Spotlight

Here's how you tell the Mac (a) which categories of files and information you want the Spotlight search feature to search, (b) which folders you don't want searched, for privacy reasons, and (c) which key combination you want to use for summoning the Spotlight menu or dialog box. Details appear are in Chapter 3.


startup_disk.html

9.25. Startup Disk

Use this panel to pick the System Folder your Mac will use the next time it starts up—when you're swapping between Mac OS X and Windows (running with Boot Camp), for example. Check out the details in Chapter 8.


time_machine-id001.html

9.26. Time Machine

Here's the master on/off switch and options panel for Time Machine, which is described in Chapter 6.


universal_access.html

9.27. Universal Access

The Universal Access panel is designed for people who type with one hand, find it difficult to use a mouse, or have trouble seeing or hearing. (These features can also be handy when the mouse is broken or missing.)

9.27.1. Seeing Tab (Magnifying the Screen)

If you have trouble seeing the screen, then boy, does Mac OS X have features for you (Figure 9-17).

Figure 9-17. You'll be amazed at just how much you can zoom in to the Mac's screen using this Universal Access pane. In fact, there's nothing to stop you from zooming in so far that a single pixel fills the entire monitor. (That may not be especially useful for people with limited vision, but it can be handy for graphic designers learning how to reproduce a certain icon, dot by dot.)

9.27.1.1. VoiceOver

One option is VoiceOver, which makes the Mac read out loud every bit of text that's on the screen. VoiceOver is described on Section 15.5.1.3.

9.27.1.2. Zoom

Another quick solution is to reduce your monitor's resolution —thus magnifying the image—using the Displays panel described earlier in this chapter. If you have a 17-inch or larger monitor set to, say, 640 x 480, the result is a greatly magnified picture.

That method doesn't give you much flexibility, however, and it's a hassle to adjust. If you agree, then try the Zoom feature that appears here; it lets you enlarge the area surrounding your cursor in any increment.

To make it work, press Option- [image] -8 as you're working. Or, if the Seeing panel is open, click On in the Zoom section. That's the master switch.

No zooming actually takes place, however, until you press Option- [image] -plus sign (to zoom in) or Option- [image] -minus sign (to zoom out). With each press, the entire screen image gets larger or smaller, creating a virtual monitor that follows your cursor around the screen.

Tip: If you have a laptop, just using the Control-key trackpad trick described on Section 9.14.3.1 is a far faster and easier way to magnify the screen.And if you have a mouse with a scroll wheel on top (or a scroll-BB, like Apple's standard Mighty Mouse), you can also zoom in or out by pressing Control while you scroll that.

If you click Options, you'll find acres of options that control when the enlarged screen image pans (all the time, or only when the pointer hits a screen edge), the maximum or minimum degree of enlargement, and so on.

9.27.1.3. Display (inverted colors)

While you're at it, pressing Control-Option- [image] -* (asterisk), or clicking the "Switch to Black on White" button, inverts the colors of the screen, so that text appears white on black—an effect that some people find easier to read. (This option also freaks out many Mac fans who turn it on by mistake, somehow pressing Control-Option- [image] -* by accident during everyday work. They think that the Mac's expensive monitor has just gone loco. Now you know better.)

Tip: There's also a button called Use Grayscale, which banishes all color from your screen. This is another feature designed to improve text clarity, but it's also a dandy way to see how a color document will look when printed on a monochrome laser printer.

No matter which color mode you choose, the "Enhance contrast" slider is another option that can help. It makes blacks blacker and whites whiter, further eliminating in-between shades and thereby making the screen easier to see. (If the Universal Access panel doesn't happen to be open, you can always use the keystrokes Control-Option [image] -< and -> to decrease or increase contrast.)

9.27.2. Hearing Tab (Flashing the Screen)

If you have trouble hearing the Mac's sounds, the obvious solution is to increase the volume, which is why this panel offers a direct link to the Sound preferences pane. (If your Mac doesn't have external speakers, consider getting some.)

Fortunately, hearing your computer usually isn't critical (except when working in music and audio, of course). The only time audio is especially important is when the Mac tries to get your attention by beeping. For those situations, turn on "Flash the screen when an alert sound occurs" (an effect you can try out by clicking the Flash Screen button). Now you'll see a white flash across the entire monitor whenever the Mac would otherwise beep—not a bad idea on laptops, actually, so that you don't miss beeps when you've got the speakers muted.

9.27.3. Keyboard Tab (Typing Assistance)

This panel offers two clever features designed to help people who have trouble using the keyboard.

  • Sticky Keys lets you press multiple-key shortcuts (involving keys like Shift, Option, Control, and [image]) one at a time instead of all together.

    To make Sticky Keys work, first turn on the master switch at the top of the dialog box. Then go to work on the Mac, triggering keyboard commands as shown in Figure 9-18.

    Figure 9-18. Whenever you want to press a multiple-key keystroke like Shift- -D, press them one at a time. You'll see ghost images of these keys superimposed on your screen, as though to show you which keystrokes you've added to your temporary collection. To "un-press" a key you've already pressed, press it again twice.

    If you press a modifier key twice, meanwhile, you lock it down. (Its onscreen symbol gets brighter to let you know.) When a key is locked, you can use it for several commands in a row. For example, if a folder icon is highlighted, you could double-press [image] to lock it down—and then type O (to open the folder), look around, and then press W (to close the window). Press the [image] key a third time to "un-press" it.

    Tip: The checkbox called "Press the Shift key five times to turn Sticky Keys on or off" gives you the flexibility of turning Sticky Keys on and off at will, without even taking a trip to System Preferences. Whenever you want to turn on Sticky Keys, press the Shift key five times in succession. You'll hear a special clacking sound effect alerting you that you just turned on Sticky Keys. (Repeat the five presses to turn Sticky Keys off again.)

  • Slow Keys, on the other hand, doesn't register a key press at all until you've held down the key for more than a second or so—a feature designed to screen out accidental key presses.

    If "Use click key sounds" is turned on, you'll hear a little typing sound each time you press a key—but none of these key presses registers unless you hold the key down for a moment. (Use the Acceptance Delay slider to govern this threshold.)

    GEM IN THE ROUGH
    Direct System Preferences Access from the Dock

    As noted earlier in this chapter, Mac OS X offers a tidy pop-up menu of System Preferences panels right there in your Dock. That's a great feature, one that saves you several steps on the way to System Preferences—but it works only when System Preferences is already running.

    Wouldn't it be cool if your favorite preference panels could pop up from the Dock anytime, whether System Preferences was running or not?

    Here's how you do it. Make a new folder (in your Home folder, for example). Name it whatever you'll want the Dock icon to say—SysPrefs or Control Panels, for example. Stick it into your Sidebar for a moment.

    Now open your System rightwards double arrow Library rightwards double arrow PreferencePanes folder, which contains the icons for the various System Preferences panes. Select all of them—or only the ones you actually use.

    Drag them into the SysPrefs folder on your Sidebar, taking care to press Option- [image] as you release the mouse. (Option- [image] -dragging makes aliases of them.) If the .prefPane suffix on the aliases bugs you, select all of the aliases, press Option- [image] -I, open the Name & Extension panel in the Info window, and then turn on "Hide extension."

    Finally, drag the SysPrefs folder onto the right side of your Dock. Now, whenever you want to open a particular panel, just click this SysPrefs Dock icon. You get a handy pop-up stack, as shown here; one more click opens the panel you want.

    You hear a different sound when the Mac actually accepts the key press—and, of course, you'll see the letter you typed appear onscreen.

9.27.4. Mouse & Trackpad Tab (Cursor Control from the Keyboard)

Mouse Keys is designed to help people who can't use the mouse—or who want more precision when working in graphics programs. It lets you click, drag, and otherwise manipulate the cursor by pressing the keys on your numeric keypad. (It's not very useful on keyboards that don't have separate numeric keypads, including laptops.)

When Mouse Keys is turned on, the 5 key acts as the clicker—hold it down for a moment to "click the mouse," do that twice to double-click, and so on. Hold down the 0 key to lock down the mouse button, and the period key to unlock it. (The amount of time you have to hold them down depends on how you've set the Initial Delay slider.)

Move the cursor around the screen by pressing the eight keys that surround the 5 key. (For example, hold down the 9 key to move the cursor diagonally up and to the right.) If you hold one of these keys down continuously, the cursor, after a pause, begins to move smoothly in that direction—according to the way you have adjusted the sliders called Initial Delay and Maximum Speed.

Tip: The checkbox called "Press the Option key five times to turn Mouse Keys on or off" saves you the trouble of opening System Preferences.

At the bottom of this window, you'll find the Cursor Size slider. It's a godsend not only to people with failing vision, but also to anyone using one of Apple's large, super-high-resolution screens; as the pixel density increases, the arrow cursor gets smaller and smaller. This slider lets you make the arrow cursor larger—much larger, if you like—making it much easier to see.


the_free_programs.html

Chapter 10. The Free Programs

Right out of the box, Mac OS X comes with a healthy assortment of about 50 freebies: programs for sending email, writing documents, doing math, even playing games. Some are dressed-up versions of Mac programs that have been around for years. Others, though, are new programs that not only show off some of Mac OS X's most dramatic new technologies, but also let you get real work done without having to invest in additional software.

10.1. Your Free Mac OS X Programs

You've got a broad assortment of programs in the Applications folder in the main hard drive window. The Applications rightwards double arrow Utilities folder holds another couple of dozen miniprograms that handle such workaday jobs as setting up printers and network connections, fixing problems on your hard disk, and monitoring the behind-the-scenes processing performed by your Mac whenever you launch and run programs.

This chapter guides you through every item in your new software library, one program at a time. (Depending on your Mac model, you may find other programs in your Applications folder. Apple occasionally includes software of its own, or from other companies, to spice up the collection for, say, iMacs or MacBooks.)

Tip: A reminder: You can jump straight to the Applications folder in the Finder by pressing Shift- [image] -A (the shortcut for Go rightwards double arrow Applications), or by clicking the Applications folder icon in the Sidebar. You might consider adding the Application folder's icon to the Dock, too, so you can access it no matter what program you're in. Shift- [image] -U (or Go rightwards double arrow Utilities) takes you, of course, to the Utilities folder.


your_free_mac_os_x_programs.html

Chapter 10. The Free Programs

Right out of the box, Mac OS X comes with a healthy assortment of about 50 freebies: programs for sending email, writing documents, doing math, even playing games. Some are dressed-up versions of Mac programs that have been around for years. Others, though, are new programs that not only show off some of Mac OS X's most dramatic new technologies, but also let you get real work done without having to invest in additional software.

10.1. Your Free Mac OS X Programs

You've got a broad assortment of programs in the Applications folder in the main hard drive window. The Applications rightwards double arrow Utilities folder holds another couple of dozen miniprograms that handle such workaday jobs as setting up printers and network connections, fixing problems on your hard disk, and monitoring the behind-the-scenes processing performed by your Mac whenever you launch and run programs.

This chapter guides you through every item in your new software library, one program at a time. (Depending on your Mac model, you may find other programs in your Applications folder. Apple occasionally includes software of its own, or from other companies, to spice up the collection for, say, iMacs or MacBooks.)

Tip: A reminder: You can jump straight to the Applications folder in the Finder by pressing Shift- [image] -A (the shortcut for Go rightwards double arrow Applications), or by clicking the Applications folder icon in the Sidebar. You might consider adding the Application folder's icon to the Dock, too, so you can access it no matter what program you're in. Shift- [image] -U (or Go rightwards double arrow Utilities) takes you, of course, to the Utilities folder.


address_book-id001.html

10.2. Address Book

The Address Book is a database that stores names, addresses, email addresses, phone numbers, and other contact information. Address Book is described beginning on Section 5.13.3.2.


applescript.html

10.3. AppleScript

This folder contains all of the scripts and tools described in Chapter 7.


automator.html

10.4. Automator

This software-robot program, too, is introduced in Chapter 7.


calculator-id001.html

10.5. Calculator

The Calculator is much more than a simple four-function memory calculator. It can also act as a scientific calculator for students and scientists, a conversion calculator for metric and U.S. measures, and even a currency calculator for world travelers.

The little Calculator widget in the Dashboard is quicker to open, and it's great for quick four-function number crunches. But the standalone Calculator program is far more powerful. For example:

  • The calculator has three modes: Basic, Advanced, and Programmer (Figure 10-1). Switch among them by choosing from the View menu (or pressing [image] -1 for Basic, [image] -2 for Advanced, or [image] -3 for Programmer).

    Tip: You can also cycle among the three modes by repeatedly clicking what, on most windows, is the Zoom button (the green round dot at upper left). It's a first for the Mac—a Zoom button that changes function each time you click it—but it's kind of neat.

  • You can operate the calculator by clicking the onscreen buttons, but it's much easier to press the corresponding number and symbol keys on your keyboard.

  • you go, you can make Calculator speak each key you press. The Mac's voice ensures that you don't mistype as you keep your eyes on the receipts in front of you, typing by touch.

    Just choose Speech rightwards double arrow Speak Button Pressed to turn this feature on or off. (You choosewhich voice does the talking in the Speech panel of System Preferences.)

    Tip: If you have a laptop, don't miss the embedded numeric keypad, superimposed on the right side of the keyboard and labeled on the keys in a different color ink. When you press the Fn key in the lower-left corner of the keyboard, typing these keys produces the numbers instead of the letters. (You can also press the NumLock key to stay in number mode, so you don't have to keep pressing Fn.)

  • Press the C key to clear the calculator display.

  • Once you've calculated a result, you can copy it (using Edit rightwards double arrow Copy, or [image] -C) and paste it directly into another program.

  • The Calculator even offers Reverse Polish Notation (RPN), a system of entering numbers that's popular with some mathematicians, programmers, and engineers, because it lets them omit parentheses. Choose View rightwards double arrow RPN to turn it on and off.

Tip: How cool is this? In most programs, you don't need Calculator or even a Dashboard widget. Just highlight an equation (like 56*32.1-517) right in your document, and press [image] -Shift-8. Presto—Mac OS X replaces the equation with the right answer. This trick works in TextEdit, Mail, Entourage, FileMaker, and many other programs.And if you ever find that it doesn't work, remember that the Spotlight menu is now a calculator, too. Type or paste an equation into the Spotlight search box; instantly, the answer appears in the results menu.

Figure 10-1. The Calculator program offers a four-function Basic mode, a full-blown scientific calculator mode, and a programmer's calculator (shown here, and capable of hex, octal, decimal, and binary notation). The first two modes offer a "paper tape" feature (View rightwards double arrow Show Paper Tape) that lets you correct errors made way back in a calculation.
To edit one of the numbers on the paper tape, drag through it, retype, and then click Recalculate Totals. You can also save the tape as a text file by choosing File rightwards double arrow Save Tape As, or print it by selecting File rightwards double arrow Print Tape.

10.5.1. Conversions

Calculator is more than a calculator; it's also a conversion program. No matter what units you're trying to convert—meters, grams, inches, miles per hour—the Calculator is ready. Truth is, the Units Converter widget in Dashboard is simpler and better than this older Calculator feature. But if you've already got the Calculator open, here's the drill:

  1. Clear the Calculator (for example, type the letter C on your keyboard). Type in the starting measurement.

    To convert 48 degrees Celsius to Fahrenheit, for example, type 48.

  2. From the Convert menu, choose the kind of conversion you want.

    In this case, choose Temperature. When you're done choosing, a dialog box appears.

  3. Use the pop-up menus to specify which units you want to convert to and from.

    To convert Celsius to Fahrenheit, choose Celsius from the first pop-up menu, and Fahrenheit from the second.

  4. Click OK.

    That's it. The Calculator displays the result—in degrees Fahrenheit, in this example.

The next time you want to make this kind of calculation, you can skip steps 2, 3, and 4. Instead, just choose your desired conversion from the Convert rightwards double arrow Recent Conversions submenu.

Calculator is especially amazing when it comes to currency conversions—from pesos to American dollars, for example—because it actually does its homework. It goes online to download up-to-the-minute currency rates to ensure that the conversion is accurate. (Choose Convert rightwards double arrow Update Currency Exchange Rates.)

Tip: If you Control-click (or right-click) the Calculator's results display, the shortcut menu offers an option called Large Type. If you choose it, you get huge, enormous, gigantic type, superimposed upon a smoky background window for contrast—a great way to make sure the peons in the back row can see the answer.


chess.html

10.6. Chess

Mac OS X comes with only one game, but it's a beauty (Figure 10-2). Chess is a traditional chess game played on a gorgeously rendered board with a set of realistic 3-D pieces. You can rotate the board in space, as described in Figure 10-2.

The program is actually a 20-year-old Unix-based chess program, GNU Chess, that Apple packaged up in a new wrapper.

10.6.1. Playing a Game of Chess

When you launch Chess, you're presented with a fresh, new game that's set up in Human vs. Computer mode—meaning that you (the Human, with the light-colored pieces) get to play against the Computer (your Mac, on the dark side). Drag the chess piece of your choice into position on the board, and the game is afoot.

If you choose Game rightwards double arrow New Game, however, you're offered a pop-up menu with choices like Human vs. Computer, Human vs. Human, and so on. If you switch the pop-up menu to Computer vs. Human, you and your Mac trade places; the Mac takes the white side of the board and opens the game with the first move, and you play the black side.

Tip: The same New Game dialog box also offers a pop-up menu called Variant, which offers three other chess-like games: Crazyhouse, Suicide, and Losers. The Chess help screens (choose Help rightwards double arrow Chess Help, click "Starting a new chess game") explain these variations.

Figure 10-2. You don't have to be terribly exact about grabbing the chess pieces when it's time to make your move. Just click anywhere within a piece's current square to drag it into a new position on the board (shown here in its Marble incarnation). And how did this chess board get rotated like this? Because you can grab a corner of the board and rotate it in3-Dspace. Cool!

On some night when the video store is closed and you're desperate for entertainment, you might also want to try the Computer vs. Computer option, which pits your Mac against itself. Pour yourself a beer, open a bag of chips, and settle in to watch until someone—either the Mac or the Mac—gains victory.

10.6.2. Chess Prefs

Choose Chess rightwards double arrow Preferences to find some useful controls like these:

  • Style. Apple has gone nuts with the computer-generated materials options in this program. (Is it a coincidence that Steve Jobs is also the CEO of Pixar, the computer animation company?)

    In any case, you can choose all kinds of wacky materials for the look of your game board—Wood, Metal, Marble, or Grass (?)—and for your playing pieces (Wood, Metal, Marble, or Fur).

  • Computer Plays. Use this slider to determine how frustrated you want to get when trying to win at Chess. The farther you drag the slider toward the Stronger side, the more calculations the computer runs before making its next move—and, thus, the harder it gets for you to outthink it. At the Faster setting, Chess won't spend more than 5 seconds ruminating over possible moves. Drag the slider all the way to the right, however, and the program may analyzeeach move for as long as 10 fun-filled hours. This hardest setting, of course, makes it all but impossible to win a game (which may stretch on for a week or more anyway).

    Choosing the Faster setting makes it only mildly impossible.

  • Speech. The two checkboxes here let you play Chess using the Mac's built-in voice-recognition features, telling your chess pieces where to go instead of dragging them, and listening to the Mac tell you which moves it's making. Section 15.5.1.2 has the details.

Tip: If your Chess-playing skills are less than optimal, the Moves menu will become your fast friend. The three commands tucked away there undo your last move (great for recovering from a blunder), suggest a move when you don't have a clue what to do next, and display your opponent's previous move (in case you failed to notice what the computer just did).

10.6.3. Studying Your Games

You can choose Game rightwards double arrow Save Game to save any game in progress, so you can resume it later.

To analyze the moves making up a game, use the Game Log command, which displays the history of your game, move by move. A typical move would be recorded as "Nb8—c6," meaning the knight on the b8 square moved to the c6 square. Equipped with a Chess list document, you could recreate an entire game, move by move.

Tip: If you open this window before you begin a new game, you can see the game log fill in the moves as they happen.


dashboard-id001.html

10.7. Dashboard

In Leopard, Dashboard is now a true-blue, double-clickable application. Its behavior doesn't actually change much as a result—it works exactly as described in Chapter 5, and exactly as it always has. But one perk is that you can remove its icon from your Dock, which you couldn't do before.


dictionary-id001.html

10.8. Dictionary

For word nerds everywhere, the Dictionary (and Thesaurus) is a blessing—it a handy way to look up word definitions, pronunciations, and synonyms. To be precise, Leopard now comes with electronic versions of seven reference works in one:

  • The entire New Oxford American Dictionary.

  • The complete Oxford American Writers Thesaurus.

  • A new dictionary of Apple terms, from A/UX to widget. (Apparently there aren't any Apple terms that begin with X, Y, or Z.)

  • Wikipedia. Of course, this famous open-source, citizen-created encyclopedia isn't actually on your Mac. All Dictionary does is give you an easy way to search the online version, and display the results right in the comfy Dictionary window.

    Figure 10-3. When you open the Dictionary, it generally assumes that you want a word's definition (top left). If you prefer to see the Wikipedia entry (lower right) at startup time instead, for example, choose Dictionary rightwards double arrow Preferences—and drag Wikipedia upward so that it precedes New Oxford American Dictionary. That's all there is to it!

  • A Japanese dictionary, thesaurus, and Japanese-to-English translation dictionary

Tip: You don't ordinarily see the Japanese reference books. You have to turn them on in Dictionary rightwards double arrow Preferences.

Mac OS X also comes with about a million ways to look up a word:

  • Double-click the Dictionary icon. You get the window shown at top in Figure 10-3. As you type into the Spotlight-y search box, you home in on matching words; double-click a word, or highlight it and press Enter, to view a full, typographically elegant definition, complete with sample sentence and pronunciation guide.

    Tip: And if you don't recognize a word in the definition, click that wordto look up its definition. (Each word turns blue and underlined when you point to it, as a reminder.) You can then double-click again in that definition—and on, and on, and on.(You can then use the History menu, the [image] and [image] buttons on the toolbar, or the [image] -[ and [image] -] keystrokes to go back and forward in your chain of lookups.)

    It's worth exploring the Dictionary rightwards double arrow Preferences dialog box, by the way. There, you can choose U.S. or British pronunciations and adjust the font size.

  • Press F12. Yes, the Dictionary is one of the widgets in Dashboard (Section 5.13.3.4).

  • Control-click (right-click) a highlighted word in a Cocoa program. From the shortcut menu, choose Look Up in Dictionary. The Dictionary program opens to that word. (Or visit the Dictionary's Preferences box and choose "Open Dictionary panel." Now you get a panel that pops out of the highlighted word instead.)

  • Use the dict:// prefix in your Web browser. This might sound a little odd, but it's actually ultra-convenient, because it puts the dictionary right where you're most likely to need it: while you're reading stuff on the Web.

    Turns out that you can look up a word (for example, preposterous) by typing dict:// preposterous into the address bar—in the spot where you'd normally type http://www.whatever. When you hit Return, Mac OS X opens the Dictionary automatically and presents the search results from all of its resources (dictionary, thesaurus, Apple terms, and Wikipedia).

  • Point to a word in a Cocoa program, and then press Control- [image] -D. That keystroke makes the definition panel sprout right from the word you were pointing to. (The advantage here, of course, is that you don't have to highlight the word first.)

There's another new Dictionary feature worth noticing, too: the front matter of the Oxford American Dictionary (the reference pages at the beginning). Here are some delicious writers' tools, including guides to spelling, grammar, capitalization, punctuation, chemical elements, and clichés, along with the full text of the Declaration of Independence and the U.S. Constitution. Just choose Go rightwards double arrow Front/Back Matter—and marvel that your Mac comes with a built-in college English course.

Tip: Here's a trick for the informationally thirsty Mac fan (or speed reader). Once you've invoked the Control- [image] -D keystroke, keep the Control and [image] keys pressed. Now drag the cursor across the text. As you push the mouse around, the definition pops up for every word you touch.Got a big screen or poor eyesight? Then bump up the type size. Dictionary's toolbar has bigger/smaller buttons, and there's a Font Size pop-up menu in the Preferences window.


dvd_player.html

10.9. DVD Player

DVD Player, your Mac's built-in movie projector, is described in Chapter 11.


exposeacute.html

10.10. Exposé

Evidently, turning built-in features into standalone applications is a trend. Like Dashboard, Exposé (Section 5.3.1) now has an icon all its own in Applications. Double-clicking it triggers the F9 effect, which means shrinking and moving all open windows around so you can see them simultaneously.


font_book-id002.html

10.11. Font Book

For details on this font-management program, see Chapter 14.


front_row.html

10.12. Front Row

This full-screen multimedia playback program is now part of Mac OS X; it's available even on Macs that didn't come with Apple's slim white remote control. Chapter 15 has details.


garageband.html

10.13. GarageBand

GarageBand, Apple's do-it-yourself music construction kit, isn't actually part of Mac OS X. If you have a copy, that's because it's part of the iLife suite that comes on every new Mac (GarageBand, iMovie, iPhoto, iWeb).


ical-id001.html

10.14. iCal

In many ways, iCal is not so different from those "Hunks of the Midwest Police Stations" paper calendars people leave hanging on the walls for months past their natural lifespan. But iCal offers several advantages over paper calendars. For example:

  • Itcan automate the process of entering repeating events, such as weekly staff meetings or gym workout dates.

  • iCal can give you a gentle nudge (with a sound, a dialog box, or even an email) when an important appointment is approaching.

  • iCal can share information with your Address Book program, with Mail, with your iPod or iPhone, with other Macs, with "published" calendars on the Internet, or with a Palm organizer. Some of these features require one of those .Mac accounts described in Chapter 18, and some require iSync (Chapter 6). But iCal also works fine on a single Mac, even without an Internet connection.

  • iCal can subscribe to other people's calendars. For example, you can subscribe to your spouse's calendar, thereby finding out when you've been committed to after-dinner drinks on the night of the big game on TV.

Tip: iCal's Dock icon now displays today's date—even when iCal isn't running. That's reason enough to upgrade to Leopard right there, n'est-ce pas?

10.14.1. Working with Views

When you open iCal, you see something like Figure 10-4. By clicking one of the View buttons above the calendar, you can switch among these views:

  • Day shows the appointments for a single day in the main calendar area, broken down by time slot.

    If you choose iCal rightwards double arrow Preferences, you can specify what hours constitute a workday. This is ideal both for those annoying power-life people who get up at 5 a.m. for two hours of calisthenics and the more reasonable people who sleep until 11 a.m.

    Tip: iCal provides a quick way to get to the current day's date—choose View rightwards double arrow Go to Today, or press [image] -T.

    Figure 10-4. In iCal, the miniature navigation calendar (lower left) provides an overview of adjacent months. You can jump to a different week or day by clicking the and buttons, and then clicking within the numbers. Double-click any appointment to see the info balloon shown here. You can hide the To Do list either by using the Window rightwards double arrow Hide To Dos command or by clicking the thumbtack button identified here.

  • Week fills the main display area with seven columns, reflecting the current week. (You can establish a five-day work week instead in iCal rightwards double arrow Preferences.)

    Tip: If you double-click the date above the calendar, you open the day view for that day.

  • Month shows the entire month that contains the current date (Figure 10-4). Double-click a date number to open the day view for that date.

    To save space, iCal generally doesn't show you the times of your appointments in Month view. If you'd like to see them anyway, choose iCal rightwards double arrow Preferences, click General, and turn on "Show time in month view."

Tip: If your mouse has a scroll wheel, you can use it to great advantage in iCal. For example, when entering a date, turning the wheel lets you jump forward or backward in time. It also lets you change the priority level of a To Do item you're entering, or even tweak the time zone as you're setting it.

In any of the views, double-click an appointment to see more about it. The very first time you do that, you get the full-blown editing panel shown in Figure 10-5.

After that, double-clicking an event produces only the summary balloon shown in Figure 10-4. If you want to make changes, you can then click the Edit button.

Tip: In Week or Day view, iCal now sprouts a handy horizontal line that shows where you are in time right now. (Look in the hours-of-the-day "ruler" down the left side of the window to see this line's little red bulb.) A nice touch, and a handy visual aid that can tell you at a glance when you're already late for something.

10.14.2. Making an Appointment

The basic iCal calendar is easy to figure out. After all, with the exception of one unfortunate Gregorian incident, we've been using calendars successfully for centuries.

Even so, there are two ways to record a new appointment: a simple way and a more flexible, elaborate way.

10.14.2.1. The easy way

You can quickly record an appointment using any of several techniques, listed here in order of decreasing efficiency:

  • Double-click the appointed time on the calendar, in any view. A colored box appears; this is where you type the name for your new appointment.

  • When viewing a day or week view, drag vertically through the time slots that represent the appointment's duration, and then type inside the newly created colored box.

  • Using the month view, double-click in a blank area of the appropriate date's square, and then type in the newly created colored bar.

  • Choose File rightwards double arrow New Event (or press [image] -N). A new appointment appears on the currently selected day, regardless of the current view.

  • In any view, Control-click or right-click a date and choose New Event from the shortcut menu.

Unless you use the drag-over-hours method, a new event believes itself to be one hour long. But in Day or Week view, you can adjust its duration by dragging the bottom edge vertically. Drag the dark top bar up or down to adjust the start time.

In many cases, that's all there is to it. You have just specified the day, time, and title of the appointment. Now you can get on with your life.

Figure 10-5. In Leopard, there's no longer an information "drawer" panel off at the right side of the screen; all the details for an appointment sprout right out of the appointment itself. Tab your way to an organized life.
Tip: If this Edit balloon is blocking a part of the calendar you need to see, no biggie: just drag the balloon out of the way, using any blank spot as a handle.

10.14.2.2. The long way

The information balloon shown in Figure 10-5 contains much more detailed information about a certain appointment. It appears when you double-click a newly created appointment.

Tip: After you've already edited an appointment once, the full info balloon is a little more effort to open; double-clicking an event produces only the summary balloon shown in Figure 10-4.The short way to open the full balloon is to click the appointment, and then press [image] -E (which is short for Edit rightwards double arrow Edit Event). The long way is to double-click the appointment to get the summary balloon, and click Edit inside it.

For each appointment, you can Tab your way to the following information areas:

  • Subject. That's the large, bold type at the top—the name of your appointment. For example, you might type Fly to Phoenix.

  • Location. This field makes a lot of sense; if you think about it, almost everyone needs to record where a meeting is to take place. You might type a reminder for yourself like My place, a specific address like 212 East 23, or some other helpful information like a contact phone number or flight number.

  • All-day.An "all-day" event, of course, refers to something that has no specific time of day associated with it: a holiday, a birthday, a book deadline. When you turn on this box, you see the name of the appointment jump to the top of the iCal screen, in the area reserved for this kind of thing; see Figure 10-4.

  • From, to. You can adjust the times shown here by typing, clicking buttons, or both. Press Tab to jump from one setting to another, and from there to the hours and minutes of the starting time.

    For example, start by clicking the hour, then increase or decrease this number either by pressing your up and down arrow keys or by typing a number. Press Tab to highlight the minutes and repeat the arrow-buttons-or-keys business. Finally, press Tab to highlight the AM/PM indicator, and type either A or P—or press the up or down arrow key—to change it, if necessary.

    Tip: If you specify a different ending date, a banner appears across the top of the calendar.

  • Time zone. This option appears only after you choose iCal rightwards double arrow Preferences rightwards double arrow Advanced, and then turn on "Turn on time zone support. "And you would do that only if you plan to be traveling on the day that this appointment comes to pass.

    Once you've done that, a "time zone" pop-up menu appears. It starts out with "America/New York" (or whatever your Mac's usual time zone is); if you choose Other, a tiny world map appears. Click the time zone that represents where you'll be when this appointment comes due. From the shortcut menu, choose the major city that's in the same zone you'll be in.

    Tip: The "time zone" pop-up menu remembers each new city you select. The next time you travel to a city you've visited before, you won't have to do that clicking-the-world-map business.

    Now, when you arrive in the distant city, use the Time Zone pop-up menu at the top-left corner of the iCal window to tell iCal where you are. You'll see all of iCal's appointments jump, like magic, to their correct new time slots.

  • Repeat. The pop-up menu here contains common options for recurring events: every day, every week, and so on. It starts out saying None.

    Once you've made a selection, you get an end pop-up menu that lets you specify when this event should stop repeating. If you choose "Never," you're stuck seeing this event repeating on your calendar until the end of time (a good choice for recording, say, your anniversary, especially if your spouse might be consulting the same calendar). You can also turn on "After" (a certain number of times), which is a useful option for car and mortgage payments. And if you choose "On date," you can specify the date that the repetitions come to an end; use this option to indicate the last day of school, for example.

    "Custom" lets you specify repeat schedules like "First Monday of the month" or "Every two weeks."

  • Calendar.A calendar, in iCal's confusing terminology, is a subset—a category—into which you can place various appointments. You can create one for yourself, another for family-only events, another for book-club appointments, and so on. Later, you'll be able to hide and show these categories at will, adding or removing them from the calendar with a single click. Details begin on Section 10.14.3.5.

    Tip: Use this same pop-up menu to change an appointment's category. If you filed something in "Company Memos" that should have been in "Sweet Nothings for Honey-Poo," open the event's information balloon and reassign it. Quick.

  • Alarm. This pop-up menu tells iCal how to notify you when a certain appointment is about to begin. iCal can send any of four kinds of flags to get your attention. It can display a message on the screen (with a sound, if you like), send you an email, run a script of the sort described in Chapter 7, or open a file on your hard drive. (You could use this unusual option to ensure that you don't forget a work deadline by flinging the relevant document open in front of your face at the eleventh hour.)

    Once you've specified an alarm mechanism, a new pop-up menu appears to let you specify how much advance notice you want for this particular appointment. If it's a TV show you like to watch, you might set up a reminder only five minutes before airtime. If it's a birthday, you might set up a two-day warning to give yourself enough time to buy a present. In fact, you can set up more than one alarm for the same appointment, each with its own advance-warning interval.

    Tip: In iCal rightwards double arrow Preferences rightwards double arrow Advanced, you can opt to prevent alarms from going off—a good checkbox to inspect before you give a presentation in front of 2,000 people. There's also an option to stifle alarms except when iCal is open. In other words, just quitting iCal is enough to ensure that those alarms won't interrupt whatever you're doing.

  • Attendees. If the appointment is a meeting or some other gathering, you can type the participants' names here. If a name is already in your Address Book program, iCal proposes autocompleting the name for you.

    If you separate several names with commas, iCal automatically turns each into a shaded oval pop-up button. You can click it for a pop-up menu of commands like Remove Attendee and Send Email. (That last option appears only if the person in your Address Book has an email address, or if you typed a name with an email address in brackets, like this: Chris Smith <chris@yahoo.com>.)

    Once you've specified some attendees, a Send button appears in the Info balloon. If you click it, iCal fires up Mail and prepares ready-to-send messages, each with an iCal.ics attachment: a calendar-program invitation file. See the box below.

  • Attachment. This new option lets you fasten a file to the appointment. It can be anything: a photo of the person you're meeting, a document to finish by that deadline, the song that was playing the first time you met this person—whatever.

  • Url. What Apple really means here, of course, is URL—a Uniform Resource Locator, better known as a Web address like www.apple.com. If there's a URL relevant to this appointment, by all means type it here. Type more than one, if it'll help you; just be sure to separate each with a comma.

  • Note. Here's your chance to customize your calendar event. You can type, paste, or drag any text that you like in the note area—driving directions, contact phone numbers, a call history, or whatever.

    Your newly scheduled event now shows up on the calendar, complete with the color coding that corresponds to the calendar category you've assigned.

10.14.3. What to Do with an Appointment

Once you've entrusted your agenda to iCal, you can start putting it to work. iCal is only too pleased to remind you (via pop-up messages) of your events, reschedule them, print them out, and so on. Here are a few of the possibilities.

10.14.3.1. Editing events

To edit a calendar event's details, you have to open its Info balloon, as described in Figure 10-5.

UP TO SPEED
Inviting Guests

The truth is, this business of automatic invitations to iCal events hasn't really caught on yet. It's still fairly complicated, and requires compatible software on the receivers' end.

When you click Send at the bottom of the info balloon, your guests receive your invitation. If they use iCal, the invitation appears in their Notifications panel. (To open the Notifications panel, click the tiny envelope icon in the lower-left corner of the window.) They can click Accept, Decline, or Maybe.

In your Notifications window, you then see the status of each invitee's name: a checkmark for Accepted, an X for Declined, a ? for Maybe, and an arrow for Not Yet Responded. (Your guests, meanwhile, will be delighted to find that the appointment automatically appears on their calendars once they commit.)

Now, suppose you send an invitation to your sister, who doesn't have a Mac. She just gets an email message that says, "Chris Smith has invited you to the event: Company Hoedown, scheduled for February 02, 2008 at 3:00 PM. To accept or decline this invitation, click the link below." Un-fortunately, there generally is no link. She just has to know to open the .ics attachment.

If she uses a calendar program that understands this attachment, the appointment appears on her calendar, and her RSVP shows up in your iCal Notification panel.

Tip: If you just want to change an event's name, Option-double-click it right in place.And if you want to change only an appointment's "calendar" category, Control-click (or right-click) anywhere on the appointment, and, from the resulting shortcut menu, choose the category you want.In both cases, you bypass the need to open the Info balloon.

You don't have to bother with this if all you want to do is reschedulean event, however, as described next.

10.14.3.2. Rescheduling events

If an event in your life gets rescheduled, you can drag an appointment block vertically in a day- or week-view column to make it later or earlier the same day, or horizontally to another date in any view. (If you reschedule a recurring event, iCal asks if you want to change only this occurrence, or this andall future ones.)

If something is postponed for, say, a month or two, you're in trouble, since you can't drag an appointment beyond its month window. You have no choice but to open the Info balloon and edit the starting and ending dates or times—or just cut and paste the event to a different date.

10.14.3.3. Lengthening or shortening events

If a scheduled meeting becomes shorter or your lunch hour becomes a lunch hour-and-a-half (in your dreams), changing the length of the representative calendar event is as easy as dragging the bottom border of its block in any column view (see Figure 10-6).

Tip: In week view, if you've grabbed the bottom edge of an appointment's block so that the cursor changes, you can drag horizontally to make an appointment cross the midnight line and extend into a second day.

Figure 10-6. You can resize any iCal calendar event just by dragging its bottom border. As your cursor touches the bottom edge of a calendar event, it turns into a double-headed arrow. You can now drag the event's edge to make it take up more or less time on your calendar.

10.14.3.4. Printing events

To commit your calendar to paper, choose File rightwards double arrow Print, or press [image] -P. The resulting Print dialog box lets you include only a certain range of dates, only events on certain calendars, with or without To Do lists or mini-month calendars, and so on.

10.14.3.5. Deleting events

To delete an appointment, just select it and then press the Delete key. If you delete a recurring event (like a weekly meeting), iCal asks whether you want to delete only that particular instance of the event, or the whole series from that point forward.

10.14.4. Searching for Events

You should recognize the oval text box at the top of the iCal screen immediately: It's almost identical to the Spotlight box. This search box is designed to let you hide all appointments except those matching what you type into it. Figure 10-7 has the details.

Figure 10-7. As you type into the search box (top right), iCal builds a little search-results list at the bottom of the window. Double-click any row of the list to jump to and highlight the corresponding event on the calendar, and open up its summary balloon.

10.14.5. The "Calendar" Category Concept

Just as iTunes has playlists that let you organize songs into subsets, and iPhoto has albums that let you organize photos into subsets, iCal has calendars that let you organize appointments into subsets. They can be anything you like. One person might have calendars called Home, Work, and TV Reminders. Another might have Me, Spouse 'n' Me, and Whole Family. A small business could have categories called Deductible Travel, R&D, and R&R.

To create a calendar, double-click any white space in the Calendar list (below the existing calendars), or click the + button at the lower-left corner of the iCal window. Type a name that defines the category in your mind.

Tip: Click a calendar name before you create an appointment. That way, the appointment will already belong to the correct calendar.

To change the color-coding of your category, Control-click (right-click) its name; from the shortcut menu, choose Get Info. The Calendar Info box appears. Here, you can change the name, color, or description of this category—or turn off alarms for this category.

You assign an appointment to one of these categories using the pop-up menu on its Infoballoon, or by Control-clicking (right-clicking) an event and choosing a calendar name from the shortcut menu. After that, you can hide or show an entire category of appointments at once just by turning on or off the appropriate checkbox in the Calendars list.

Tip: iCal also has calendar groups: calendar containers that consolidate the appointments from several other calendars. Super-calendars like this make it easier to manage, hide, show, print, and search subsets of your appointments.To create a calendar group, choose File rightwards double arrow New Calendar Group. Name the resulting item in the Calendar list; for the most part, it behaves like any other calendar. Drag other calendar names onto it to include them. Click the flippy triangle to hide or show the component calendars.

10.14.6. "Publishing" Calendars to the Web

One of iCal's best features is its ability to post your calendar on the Web, so that other people (or you, on a different computer) can subscribe to it, which adds your appointments to their calendars. If you have a .Mac account, then anyone with a Web browser can also view your calendar, right online.

For example, you might use this feature to post the meeting schedule for a club that you manage, or to share the agenda for a series of upcoming financial meetings that all of your co-workers will need to consult.

10.14.6.1. Publishing

Begin by clicking the calendar category you want in the left-side list. (iCal can publish only one calendar category at a time. If you want to publish more than one calendar, create a calendar group.)

Then choose Calendar rightwards double arrow Publish; the dialog box shown at top in Figure 10-8 appears. This is where you customize how your saved calendar is going to look and work. You can even turn on "Publish changes automatically," so whenever you edit the calendar, iCal connects to the Internet and updates the calendar automatically. (Otherwise, you'll have to choose Calendar rightwards double arrow Refresh every time you want to update the Web copy.)

While you're at it, you can include To Do items, notes, and even alarms with the published calendar.

Figure 10-8. If you click "Publish on: .Mac," iCal posts the actual, viewable calendar on the Web, as shown in Figure 10-9. If you choose "a private server," you have the freedom to upload the calendar to your own personal Web site, if it's WebDAV-compatible (ask your Web-hosting company). Your fans will be able to download the calendar, but not view it online.

Figure 10-9. Your calendar is now live on the Web. Your visitors can control the view, switch dates, double-click an appointment for details—it's like iCal Live!

When you click Publish, your Mac connects to the Web and then shows you the Web address (the URL) of the finished page, complete with a Send Mail button that lets you fire the URL off to your colleagues.

10.14.6.2. Subscribing

If somebody else has published a calendar, you subscribe to it by choosing Calendar rightwards double arrow Subscribe. In the Subscribe to Calendar dialog box, type in the Internet address you received from the person who published the calendar. Alternatively, click the Subscribe button on any iCal Web page (Figure 10-9, lower left).

Either way, you can also specify how often you want your own copy to be updated (assuming you have a full-time Internet connection), and whether or not you want to be bothered with the publisher's alarms and notes.

When it's all over, you see a new "calendar" category in your left-side list, representing the published appointments.

Tip: Want to try it out right now? Visit www.icalshare.com, a worldwide clearinghouse for sets of iCal appointments. You can subscribe to calendars for shuttle launches, Mac trade shows, National Hockey League teams, NASCAR races, soccer matches, the Iron Chef and Survivor TV shows, holidays, and much more. You'll never suffer from empty-calendar syndrome again.

Figure 10-10. Using the To Do Info balloon, you can give your note a priority, a calendar (category), or a due date. Tasks that come due won't show up on the calendar itself, but a little exclamation point triangle appears in the To Do Items list. Sorting pop-up Priority pop-ups Hide/Show To Do list

10.14.7. To Do Lists

iCal's Tasks feature lets you make a To Do list and shepherds you along by giving you gentle reminders, if you so desire (Figure 10-10). What's nice is that Mac OS X now maintains a single To Do list, which shows up both in iCal and in Mail.

To see the list, click the pushpin button at the lower-right corner of the iCal screen. Add a new task by double-clicking a blank spot in the list that appears, or by choosing File rightwards double arrow New To Do. After the new item appears, you can type to name it.

To change the task's priority, alarm, repeating pattern, and so on, double-click it. An Info balloon appears, just as it does for an appointment.

Tip: Actually, there's a faster way to change a To Do item's priority—click the tiny three-line ribbed handle at the right side of the list. Turns out it's a shortcut menu that lets you choose Low, Medium, or High priority (or None).

To sort the list (by priority, for example), use the pop-up menu at the top of the To Do list. To delete a task, click it and then press the Delete key.

Tip: You have lots of control over what happens to a task listing after you check it off. In iCal rightwards double arrow Preferences, for example, you can make tasks auto-hide or auto-delete themselves after, say, a week or a month. (And if you asked them to auto-hide themselves, you can make them reappear temporarily using the Show All Completed Items command in the pop-up menu at the top of the To Do list.)


ichat-id001.html

10.15. iChat

Details on the iChat instant-messaging program can be found in Section 7.5.1.8.


idvd.html

10.16. iDVD

iDVD isn't really part of Mac OS X, although you probably have a copy of it; as part of the iLife software suite, iDVD comes free on every new Mac. iDVD lets you turn your digital photos or camcorder movies into DVDs that work on almost any DVD player, complete with menus, slideshow controls, and other navigation features. iDVD handles the technology; you control the style.

For a primer on iDVD, see the free, downloadable iLife appendix to this chapter, available on this book's "Missing CD" page at www.missingmanuals.com.


image_capture.html

10.17. Image Capture

This unsung little program is something of an orphan. It was designed to download pictures from a USB digital camera and then process them automatically (turning them into a Web page, scaling them to emailable size, and so on). Of course, after Image Capture's birth, iPhoto came along, generally blowing its predecessor out of the water.

Even so, Apple includes Image Capture with Mac OS X for these reasons:

  • Image Capture makes it easy to download only some pictures from your camera (Figure 10-11). Until iPhoto '08 came along, iPhoto could only download the entire contents of your camera's memory card.

  • Image Capture can grab images from Mac OS X–compatible scanners, too, not just digital cameras

  • Image Capture can download your sounds (like voice notes) from a digital still camera; iPhoto can't.

    Figure 10-11. Top: You can set up Image Capture to open automatically when you attach a USB camera to your Mac. One click (on Download All) transfers its pictures to your hard drive. Bottom:
    If you click Download Some, you get this "slide-sorter" window, where you can choose the individual pictures you want to download, rotate selected shots (using the buttons at the top), or delete shots from the camera. In slide-sorter view, Shift-click the thumbnails of the individual pictures you want. In list view, Shiftclick or -click as though they're Finder list-view files.

  • Image Capture can turn a compatible digital camera into a Webcam, broadcasting whatever it "sees" to anyone on your office network—or the whole Internet. Similarly, it can share a scanner with all the networked Macs in your office.

You can open Image Capture in either of two ways. You can simply double-click its icon in your Applications folder, or you can set it up to open automatically whenever you connect a USB digital camera and turn it on. To set up that arrangement, openImage Capture manually. Choose Image Capture rightwards double arrow Preferences, click the General tab, and then choose Image Capture from the "When a camera is connected, open" pop-up menu.

Once Image Capture is open, it looks like Figure 10-11.

In Image Capture, you can use the pop-up menus described below.

10.17.1. Download Folder

Use this pop-up menu to choose a destination folder for the pictures. Image Capture proposes putting photos, sounds, and movies from the camera into your Home folder's Pictures, Music, and Movies folders, respectively. When the downloading process is complete, Mac OS X opens the corresponding folder automatically, saving you the trouble of finding it.

10.17.2. Automatic Task

Download, schmownload—Image Capture is just warming up. It comes equipped to process the downloaded photos in several useful ways. For example:

  • None. Translation: "Just download the pictures, please."

  • Build slideshow. After the download is complete, your screen goes black, and a smooth full-screen slideshow begins, featuring the newly downloaded pictures gracefully cross-fading one to the next (without musical accompaniment, alas).

  • Build web page. Creates an actual, and very attractive, Web page of your downloaded shots. Against a black background, you get thumbnail images of the pictures in a Web page document called index. html. (You'll find it in your Home folder rightwards double arrow Pictures rightwards double arrow Webpage folder, which also contains the graphics files incorporated into this HTML document.) Image Capture automatically opens up this page in your Web browser, proud of its work.

    Just click one of the small images to view it at full size, exactly as your Web site visitors will be able to do once this page is actually on the Web. (Getting it online is up to you, although Apple's HomePage feature—part of the .Mac subscription program described on Section 18.6—is one of the easiest methods.)

    iPhoto offers more Web page option sand better-looking results, but Image Capture is handy when you just need something quick and dirty.

  • Crop to 3 x 5, fit to 3 x 5….Each option here creates a photo gallery as a PDF document (Section 14.5.3), ready to print out and then, presumably, to cut apart with scissors or a paper cutter. Each offers neatly arranged photos in the dimensions you've selected.

    And what if a photo doesn't precisely fit the proportions you've selected? The "crop to" options center each photo within the specified shape, and then trim the outer borders if necessary. The "fit to" options shrink the photo as necessary to fit into the specified dimensions, sometimes leaving blank white margins.

    Note: The "crop" commands never touch the actual downloaded photos. The downloaded image files themselves retain their full size and resolution.

  • Preview. This option opens the fresh pictures in Preview (Section 10.23), so that you can get a better (and bigger) look at them.

  • Other. The beauty of the Image Capture system is that people can, in theory, write additional processing scripts. Once you've written or downloaded them, drop them into your System rightwards double arrow Library rightwards double arrow Image Capture rightwards double arrow Automated Tasksfolder. Then enjoy their presence in the newly enhanced Automatic Task pop-up menu.

10.17.3. Download Some, Download All

Clicking Download All, of course, begins the process of downloading the photos to the folder you've selected. A progress dialog box appears, showing you thumbnail images of each picture that flies down the wire.

Clicking Download Some, however, opens the picture browser shown at bottom in Figure 10-11. Now you can select the photos you want to download, rotate, or delete from the camera. (In icon view, you click and Shift-click to select a bunch of consecutivephotos, and [image] -click to add individual photos to the selection. In icon view, you can only click and Shift-click to select individual photos.)

10.17.4. Downloading from Across the Network

You're sitting in front of Macintosh #1, but the digital camera is connected to Macintosh #2 downstairs, elsewhere on the network. What's a Mac fan to do?

GEM IN THE ROUGH
Image Capture Super-Prefs

Image Capture Super-Prefs Apple spared no expense on this baby. Lurking in the dialog box that appears when you click the Options button (shown in Figure 10-11) are some very powerful features. They're well worth exploring

The Download Options controls, for example, let you set Image Capture to grab pictures automatically when you plug in the camera, saving you a click on the Download button. Here's where you specify, too, that you want to delete the photos from the camera after they've been downloaded to the Mac—another step-saving option that prepares your memory card for more pictures.

The Information tab, meanwhile, tells you some highly specific technical details about the camera or scanner that's currently hooked up. gem in the rough

All right, that situation may not exactly be the scourge of modern computing. Still, downloading pictures from a camera attached to a different computer can occasionally be useful. In a graphics studio, for example, when a photographer comes back from the field, camera brimming with fresh shots, he can hook up the camera to his Mac so that his editor can peruse the pictures on hers, while he heads home for a shower.

To share your camera on the network, hook it up, choose Devices rightwards double arrow Browse Devices, click Sharing, and turn on "Share my devices." Turn on Web sharing, too, if you like (Figure 10-12). (This trick works with scanners, too.)

Figure 10-12. Connect the camera and turn it on.
Top: Choose Devices rightwards double arrow Browse Devices and click Sharing.
Middle: Turn on "Share my devices," and "Enable Web Sharing." Note the Web address in the middle of the dialog box. Click OK.
Bottom: Now anyone else on the Internet can open Safari, type that IP address into their address bar, and peep at the contents of your Mac's digital camera!("Meet George Jetson…")
(P.S.—The IP address must be a public address, as described on Section 22.1.)Image Capture

On the other Mac, open Image Capture and choose Devices rightwards double arrow "Browsedevices. "Open the flippy triangle, select the camera, and click Connected. Now the dialog box shown in Figure 10-11 appears; you can view and download the photos exactly as though the camera's connected to your Mac.

10.17.5. Downloading from Across the Internet

You can also share your camera's contents with the whole Internet, assuming your Mac has its own, publicly accessible IP address (Section 22.1). Figure 10-12 has the details for the setup.

10.17.6. Image Capture as Web Spycam

All digital cameras can share what's currently on their memory cards via the Internet as previously described. If you have one of a few newer models, in fact, you can actually control the camera remotely. You can spy on whatever's in the room where the camera is, taking snapshots on demand. (Can you say, "Babysittercam"?)

Note: The Webcammable cameras include recent Canon PowerShot models, some Kodaks, and several Nikon digital SLRs.

Figure 10-13. Assuming your scanner is compatible with Mac OS X (that is, if it's TWAIN-compatible), this preview window appears automatically when you turn on the scanner and open Image Capture. Open the drawer to specify the dimensions and resolution you want. Click Overview if you need to repeat the preview. Next, drag across the image to indicate which part you want to capture (otherwise, the Scan button is dimmed), and then click Scan when you're ready to go.

To set this up, begin as shown in Figure 10-12. Then, if your camera is one of the compatible models, the Remote Monitor tab (shown dimmed in Figure 10-12)springs to life, along with the buttons labeled Delete, Take Picture, and so on.

Clicking Take Picture captures a picture exactly as you would if you'd been next to the camera and pressed the shutter button.

If you click the Remote Monitor tab, you see, at full size, whatever the camera is seeing; the image is updated once every minute. (The pictures are blasted to you via the Internet, but not captured onto the memory card.) Click the light-switch icon to change the shutter interval.

10.17.7. Scanning

If you haven't changed the "Open scanner window when Image Capture is launched" setting (in Image Capture rightwards double arrow Preferences rightwards double arrow Scanner), you should see the window (Figure 10-13) when you turn on your scanner and fire up Image Capture.


imovie_iphoto.html

10.18. iMovie, iPhoto

Here's another pair of the iLife apps—not really part of Mac OS X, but probably kicking around on your Mac because iLife comes with all new Macs.

A basic getting-started chapter for these programs awaits, in free downloadable PDF form, on this book's "Missing CD" page at www.missingmanuals.com

Tip: If that basic guide isn't enough for you, keep in mind that masterfully written, in-depth guides are available in the form of iMovie'08 &iDVD: The Missing Manual and iPhoto '08: The Missing Manual..(Corresponding Missing Manual titles are available for earlier versions of these programs, too.)


isync-id001.html

10.19. iSync

See Chapter 6 for details on this file-synchronization software.


itunes-id001.html

10.20. iTunes

iTunes is Apple's beloved digital music-–library program. Chapter 11 tells all.


mail-id001.html

10.21. Mail

See Chapter 19 for the whole story.


photo_booth.html

10.22. Photo Booth

It may be goofy, it may be pointless, but the Photo Booth program is a bigger time drain than Solitaire, the Web, and Dancing with the Stars put together.

It's a match made in heaven for Macs that have a tiny video camera above the screen, but you can also use it with a camcorder, iSight, or Webcam. Just be sure that the camera is turned on and hooked up before you open Photo Booth. (Photo Booth doesn't even open if your Mac doesn't have some kind of camera.)

Open this program and then peer into the camera. Photo Booth acts like a digital mirror, showing whatever the camera sees—that is, you.

But then click the Effects button. You enter a world of special visual effects—and we're talking very special. Some make you look like a pinhead, or bulbous, or a Siamese twin; others simulate Andy Warhol paintings, fisheye lenses, and charcoal sketches (Figure 10-14). In the Leopard version, in fact, there are five pages of effects, nine previews on a page; click the left or right arrow buttons, or press - [image] -left or right arrow key, to see them all. (The last two pages hold backdrop effects, described below.)

Some of the effects have sliders that govern their intensity; you'll see them appear when you click the preview.

Figure 10-14. The Photo Booth effects must have been dreamed up one night at Apple in the midst of a serious beer party. They're truly, disturbingly creative. If you decide that you really look best without any help from Apple's warped imagery, click the Normal icon in the center.

10.22.1. Still Photos

When you find an effect that looks appealing (or unappealing, depending on your goals here), click the camera button, or press - [image] -T. You see and hear a three-second countdown, and then snap!—your screen flashes white to add illumination, and the resulting photo appears on your screen. Its thumbnail joins the collection at the bottom.

Tip: If that countdown is getting on your nerves, Option-click the camera button. You can get rid of the screen flash, too, by Shift-clicking. Needless to say, if you press Option and Shift, you get neither the countdown nor the flash.

10.22.2. 4-Up Photos

Until Leopard came along, Photo Booth was not like a real photo booth in one glaring regard: It didn't take four photos in a strip, like the photo booths at the mall.

Now it does, sort of. If you click the 4-Up button identified in Figure 10-14, then when you click the Camera icon (or press - [image] -T), the 3-2-1 countdown begins, and then Photo Booth snaps four consecutive photos in two seconds. You can exploit the timing just the way you would in a real photo booth-—make four different expressions, horse around, whatever.

The result is a single graphic with four panes. (In Photo Booth, they appear rakishly assembled at an angle; but when you export the image, they appear straight, like panes of a window.) Its icon plops into the row of thumbnails at the bottom of the window, just like the single still photos.

10.22.3. Movies

Here's another Leopard twist: Photo Booth can now record videos, complete with those wacky distortion effects. Click the third icon below the screen, the Movie icon (Figure 10-14), and then click the camera button (or press - [image] -T). You get the 3-2-1 countdown-—but this time, Photo Booth records a video, with sound, until you click the Stop button or the hard drive is full, whichever comes first. (The little digital counter at left reminds you that you're still filming.) When it's over, the movie's icon appears in the row of thumbnails, ready to play or export.

GEM IN THE ROUGH
De-Mirrorizing Your Photos

Technically, Photo Booth acts like a mirror not a camera. That is, every picture you take is actually flipped, left-to-right. If there's ever text in the picture-—something written on your T-shirt, for example-—or if you ever examine the way your hair is parted, you'll realize that every image is backwards.

That's why, in Leopard, you can now click a thumbnail at the bottom of the window and then choose Edit rightwards double arrow Flip Photo. You've just made the photo match what a camera would have seen.

Or choose Edit rightwards double arrow Auto Flip New Photos if you want Photo Booth to do the flipping for you from now on.

10.22.4. Exporting Shots and Movies

To look at a photo or movie you've captured, click its thumbnail in the scrolling row at the bottom of the screen. (To return to camera mode, click the camera button.)

Fortunately, these masterpieces of goofiness and distortion aren't locked in Photo Booth forever. You can share them with your adoring public in any of four ways:

  • Drag a thumbnail out of the window to your desktop. Or use the File rightwards double arrow Reveal in Finder command to see the actual picture or movie files.

    Tip: They're in your Home rightwards double arrow Pictures rightwards double arrow Photo Booth folder. You'll find one JPEG apiece for single shots, four JPEG files for a 4-up, and a .MOV movie file for videos.

    GEM IN THE ROUGHStill and Video Backdrops

    In Mac OS X 10.5, Photo Booth and iChat are cousins, and they're closer than ever. One particular feature, in fact, is identical in each: custom backdrops. You can replace the actual, mundane background of your office or den with something far more exciting: a rushing waterfall, for ex-ample, or a rider's-eye view of a roller coaster. In fact, you can use any photo or video you want as the background. It's just like the blue-screen or green-screen technology that Hollywood uses to put their actors someplace they're not—but without the blue-screen or green-screen.

    To replace your background in Photo Booth, click Effects. The third page of effects offers eight canned backgrounds, prepared by Apple for your enjoyment: various spectacular stills (cloudscape, color dots, the moon) and videos (Eiffel Tower plaza, aquarium, roller coaster, tropical beach, Yosemite waterfall)

    The final page offers eight empty preview squares. You're supposed to drag a still or a video from your desktop (or iPhoto) into these empty squares, making them not so empty.

    In any case, prepare the backdrop by clicking one of the preview squares. Photo Booth says, "Please step out of the frame." Do it. Photo Booth is going to memorize what its field of view looks like without you in it, so that when you reappear, it can tell you apart from your boring office background.

    Now, when you record the movie or take the photo, you'll be amazed to discover that Photo Booth has just transplanted you to the far more exotic locale you selected.(Alas, blotches may result if the background includes movement or highly contrasting elements.)

  • Click Mail to send the photo or movie as an outgoing attachment in Mail.

  • Click the iPhoto button to import the shot or movie into iPhoto.

  • Click Account Picture to make this photo represent you on the Login screen (Section 12.2.4)

Tip: You can choose one frame of a Photo Booth movie to represent you. As the movie plays, click the Pause button, then drag the scroll-bar handle to freeze the action on the frame you want. Then click Account Picture.Similarly, you can click your favorite one pane of a 4-up image to serve as your account photo—it expands to fill the Photo Booth screen—before clicking Account Picture.And speaking of interesting headshots: If you export a 4-up image and choose it as your buddy icon in iChat (Section 7.5.1.8), you'll get an animated buddy icon. That is, your tiny icon cycles among the four images, creating a crude sort of animation. It's sort of annoying, actually, but all the kids are doing it.

As you set off on your Photo Booth adventures, a note of caution: Keep it away from children. They won't move from Photo Booth for the next 12 years.


preview.html

10.23. Preview

Preview is Mac OS X's built-in graphics viewer, fax viewer, and PDF reader. It's always been teeming with features that most Mac owners never even knew were there—but in Leopard, it's become a real powerhouse.

10.23.1. Preview as Graphics Viewer

Preview's hallmark is its surprising versatility. It can display and manipulate pictures saved in a wide variety of formats, including common graphics formats like JPEG, TIFF, PICT, and GIF; less commonly used formats like BMP, PNG, SGI, TGA, and MacPaint; and even Photoshop, EPS, and PDF graphics. You can even open animated GIFs by adding a Play button to the toolbar, as described below.

10.23.1.1. Bunches o' graphics

If you highlight a group of image files in the Finder and open them all at once (for example, by pressing [image] -O), Preview opens the first one, but lists the thumbnails of the whole group in the Sidebar. You can walk through them with the upwards arrow and downwards arrow keys, or you can choose View rightwards double arrow Slideshow (Shift- [image] -F) to begin a full-screen slideshow.

Tip: Use the [image] menu below the Sidebar group to change the sorting order of these thumbnails.
10.23.1.2. Cropping graphics

To crop graphics in Preview, drag across the part of the graphic that you want to keep. To redraw, drag the round handles on the dotted rectangle; or, to proceed with the crop, choose Tools rightwards double arrow Crop. (The keyboard shortcut is [image] -K.)

If you don't think you'll ever need the original again, save the document. Otherwise, choose File rightwards double arrow Save As to spin the cropped image out as a separate file, preserving the original in the process.

Tip: You can also rotate an image—even a PDF document—in 90-degree increments and then flip it vertically or horizontally, using the commands in the Tools menu. In fact, if you select several thumbnails in the Sidebar first, you can rotate or flip them all simultaneously.
10.23.1.3. Fixing up photos

Preview is no Photoshop, but it's getting a lot closer. Let us count the ways:

  • Choose Tools rightwards double arrow Inspector.A floating palette appears. Click the first tab to see the photo's name, when it was taken, its pixel dimensions, and so on. Click the second one for even more geeky photo details, including camera settings like the lens type, ISO setting, focus mode, whether the flash was on, and so on.

  • ChooseTools rightwards double arrow Adjust Color. A translucent, floating color-adjustment palette appears, teeming with sliders for brightness, contrast, exposure, saturation (color intensity), temperature and tint (color cast), sharpness, and more. See Figure 10-15.

    Figure 10-15. Humble little Preview has grown up into a big, strong mini-Photoshop. You can really fix up a photo if you know what you're doing, using these sliders. Or you can just click the Auto Levels button. It sets all those sliders for you, which generally does an amazing job of making almost any photo look better.

  • Choose Tools rightwards double arrow Adjust Size. This command, new in Leopard, lets you adjust a photo's resolution, which comes in handy a lot. For example, you can scale an unwieldy10-megapixel, gazillion-by-gazillion-pixel shot down to an ice 640-by-480 JPEG that's small enough to send by email. Or you can shrink a photo down so it fits within a desktop window, for use as a window background (Section 1.4.1.8).

    There's not much to it. Type in the new print dimensions you want for the photo, in inches or whatever units you choose from the pop-up menu. If you like, you can also change the resolution (the number of pixels per inch) by editing the Resolution box.

10.23.1.4. Cutting people out of backgrounds

Here's a Photoshoppy feature you would never, ever expect to find in a simple viewer like Preview. You can now extract a person (or anything, really) from its background. That's handy when you want to clip yourself out of a group shot to use as your iChat portrait, when you want to paste somebody into a new background, or when you break up with someone and want them out of your photos.

  • Solid backgrounds. If the background is simple—mostly a solid color or two—you can do this job quickly. Start by making sure the toolbar is visible ( [image] -B). From the Select pop-up menu, choose Instant Alpha.

    This feature is extremely weird, but here goes: Click the first background color that you want to eliminate. Preview automatically dims out all the pixels that match the color you clicked. Click again in another area to add more of the background to the dimmed patch.

    POWER USERS' CLINIC
    Scaling and Resampling

    When you're fooling around with a picture's size and resolution in the Change Size dialog box, a couple of the options here take a little explaining

    If "Scale proportionally" is turned on, Preview changes the Height number when you change the Width number, and vice versa. In other words, it won't let you change the shape of the photo; that's why a little padlock icon appears to bracket the Height and Width boxes.

    If "Resample image" is turned off, then Preview adjusts the image's size by making the existing dots bigger or smaller—but never changes the number of dots.(That's why a padlock bracket links all three boxes together. For example, you can make the image larger—but you'll lower the number of dots per inch.)

    If "Resample image" is turned on, then you're giving Pre-view permission to add or subtract pixels as necessary to scale the photo up or down. Of course, it can't create detail that wasn't there in the original, but if you're scaling the picture up, it does a decent job of generating new pixels by averaging the colors of the neighboring ones.

    Actually, if you click and drag a tiny distance, you'll see sensitivity-percentage numbers appear next to your cursor. They indicate that the more you drag, the more you're expanding the selection to colors close to the one you clicked. The proper technique, then, isn't click-click-click; it's drag-drag-drag.

    If you accidentally eat into part of the person or thing that you want to keep, Option-drag across it to remove those colors from the selection.

    When it looks like you've successfully isolated the subject from the background, press Return or Enter. There it is, ready to cut or copy.

    Tip: If Preview seems to be highlighting too much or too little, drag .

  • Complex backgrounds. If the background isn'tprimarily solid colors, the process is a little trickier. Again, start by making sure the toolbar is visible ( [image] -B). From the Select pop-up menu, choose Extract Shape.

    Now carefully trace the person or thing that you'll want to extract. Preview marks your tracing with a fat pink line (Figure 10-16).

    Figure 10-16. After your outline is complete, the fat pink outline sprouts a trail of tiny handles. Drag them to refine the edge.

    You can trace straight lines by releasing your mouse button and clicking the next endpoint. Preview draws a straight line between your last drag and the click.

    Tip: If the pink outline is too thick or too thin for your tastes, hold down the–or + keys to make the entire line grow thinner or thicker.

    Don't worry if you're not exact; you'll be able to refine the outline later. (Zoom in for tight corners by pressing [image] -+.) Continue until you've made a complete closed loop. Or just double-click to say, "Connect where I am now with where I started."

    (Hit Esc to erase the line and start over—or give up.)

    When you're done, the outline sprouts dotted handles, as shown in Figure 10-16. You can drag them to refine the border's edges. When the outline looks close enough, press Return or Enter.

    Now you enter the Instant Alpha mode described above. If you see bits of background still showing, dab them with the mouse; they fade into the foggy "not included" area. If you accidentally chopped out a piece of your person, Option-dab. In both cases, Preview includes all pixels of the same color you dabbed, making it easy to remove, for example, a hunk of fabric.

    When it all looks good, press Return or Enter. Preview ditches the background, leaving only the outlined person. If you choose File rightwards double arrow Save As, you'll have yourself an empty-background picture, ready to import or paste into another program.

Once you've exported the file, congratulate yourself. You've just created a graphic with analpha channel, which, in computer-graphics terrms, is a special mask that can be used for transparency or blending. The background that you deleted—the empty white part—appears transparent when you import the graphic into certain graphically sophisticated programs. For example:

  • iMovie '08. You can drag your exported graphic directly onto a filmstrip in an iMovie project. The white areas of the exported Preview image become transparent, so whatever video is already in the filmstrip plays through it. Great for opening credits or special effects.

  • Preview.Yes, Preview itself recognizes incoming alpha channels. So after you cut the background out of photo A, you can select what's left (press [image] -A), copy it to the Clipboard ( [image] -C), open photo B, and paste ( [image] -V). The visible part of photo A gets pasted into the background of photo B.

  • Photoshop, Photoshop Elements.Of course, these advanced graphics programs recognize alpha channels, too. Paste in your Preview graphic; it appears as a layer, with the existing layers shining through the empty areas.

Tip: Here's a great way to create a banner or headline for your Web page: Create a big, bold-font text blog in TextEdit. Choose File rightwards double arrow Print; from the PDF pop-up button, choose Open PDF in Preview.In Preview, crop the document down, and save it as a PNG-format graphic (because PNG recognizes alpha channels). Then use the Instant Alpha feature to dab out the background and the gaps inside the letters. When you import this image to your Web page, you'll find a professional-looking text banner that lets your page's background shine through the empty areas of the lettering.
10.23.1.5. Converting file formats

Preview doesn't just open all these file formats—it can also convert between most of them. You can pop open some old Mac PICT files and turn them into BMP files for a Windows user, pry open some SGI files created on a Silicon Graphics workstation and turn them into JPEGs for use on your Web site, and so on.

Tip: What's even cooler is you can open raw PostScript files right into Preview, which converts them into PDF files on the spot. You no longer need a PostScript laser printer to print out high-end diagrams and page layouts that come to you as PostScript files. Thanks to Preview, even an inkjet printer can handle them.

All you have to do is open the file you want to convert and choose File rightwards double arrow Save As. In the dialog box that appears, choose the new format for the image using the Format pop-up menu (JPEG, TIFF, PNG, or Photoshop, for example). Finally, click Save to export the file.

Figure 10-17. Left: To open or close the Sidebar (right), choose View rightwards double arrow Sidebar, press Shift- -D, or click the Sidebar button on the toolbar. If the toolbar isn't visible, press -B. Drag the central scroll bar to make the Sidebar bigger. Right: Some PDF files fill the Sidebar with a ready-made table of contents instead.

10.23.2. The Sidebar

The Sidebar slides out from the side of the main Preview window whenever (a) you open a multipage PDF or TIFF file, (b) you highlight a bunch of graphics files in the Finder and open them all at once, or (c) you click the Sidebar button in the Preview toolbar, or choose View rightwards double arrow Sidebar. (If your PDF file has been prepared with a table of contents, the Sidebar shows that.)

The idea is that these thumbnails let you navigate pages or graphics without having to open a rat's nest of individual windows. Figure 10-17 expands on the idea.

10.23.3. Preview as PDF Reader

Preview is a nearly full-blown equivalent of Acrobat Reader, the free program used by millions to read PDF documents. It lets you search PDF documents, copy text out of them, add comments, fill in forms, and click live hyperlinks—features that used to be available only in Adobe's Acrobat Reader.

Here are the basics:

  • Zoom in and out using [image] -plus and [image] -minus.

  • Use the View rightwards double arrow PDF Display submenu to control how the PDF document appears: as two-page spreads; as single scrolling sheets of "paper towel"; with borders that indicate ends of pages; and so on.

  • Use [image] -left arrow and [image] -right arrow to page through a document. (Your Page Up and Page Down keys aren't quite the same thing; they shift to the previous or next part of the same page, if it wasn't already visible.)

    Tip: Some PDF documents include a table of contents, which you'll see in Preview's Sidebar, complete with flippy triangles that denote major topics or chapter headings (Figure 10-17, right). You can use the up arrow and down arrow keys alone to walk through these chapter headings, and then expand one that looks good by pressing the right arrow key. Collapse it again with the left arrow key.In other words, you expand and collapse flippy triangles in Preview just as you do in a Finder list view.

  • Bookmark your place by choosing Bookmarks rightwards double arrow Add Bookmark ( [image] -D); type a clever name. In future, you'll be able to return to that spot by choosing its name from the Bookmarks menu.

  • Type in notes, add clickable links (to Web addresses or other spots in the document), or use circles and rectangles to draw your reader's attention to certain sections, as shown in Figure 10-18. (Those circles and rectangles even work on image files.)

    Note: Unlike the Preview of Mac OS X versions past, these remain living, editable entities even after the document is saved and reopened. These are full-blown Acrobat annotations; they'll show up when your PDF document is opened by Acrobat Reader or even on Windows PCs.

  • Use the Tools rightwards double arrow Mark Up submenu to add highlighting, strike-through, or underlining on whatever text you select.

    Tip: Preview ordinarily stamps each text note with your name and the date. If you'd rather not have that info added, choose Preview rightwards double arrow Preferences, click General, and then turn off "Add name to annotations."

    Figure 10-18. Learn the keystrokes for the PDF markings you can make: Oval (Control -O), Rectangle (Control -R), Note (Control- -N), or Link (Control- -L). That's a lot faster than using the Tools rightwards double arrow Annotate submenu every time. Hit that keystroke, then drag diagonally to define a rectangle, oval, or link. Or click to place a Note icon, and edit that note in the left margin. You can drag or delete the annotation's little icon, or adjust its look using the Tools rightwards double arrow Inspector palette.

  • Turn antialiasing (font smoothing) on or offto improve readability. To find the on/off switch, choose Preview rightwards double arrow Preferences, and click the PDF tab. (Though antialiased text generally looks great, it's sometimes easier to read very small type with antialiasing turned off. It's a little jagged, but clearer nonetheless.)

  • Turn on View rightwards double arrow PDF Display rightwards double arrow Continuous to scroll through multipage PDF documents in one continuous stream, instead of jumping from page to page when you use the scroll bars.

  • To find a word or phrase somewhere in a PDF document, press [image] -F (or choose Edit rightwards double arrow Find rightwards double arrow Find) to open the Find box—or just type into the [image] box at the top of the Sidebar, if it's open. Proceed as shown in Figure 10-19.

  • If you want to copy some text out of a PDF document—for pasting into a word processor, for example, where you can edit it—click the Text tool (the letter A on the toolbar) or choose Tools rightwards double arrow Text Tool. Now you can drag through some text and then choose Edit rightwards double arrow Copy, just as though the PDF document is a Web page. You can even drag across page boundaries.

    Tip: Ordinarily, dragging across text selects the text from one edge of the page to the other. But if you want to copy only the first column of several, for example,Option-drag. Preview now lets you drag out any arbitrary selection rectangle, thereby highlighting any block of text you like, ready for copying.

  • You can save a single page from a PDF as a TIFF file in order to use it in other graphics, word processing, or page layout programs that might not directly recognize PDF.

    To extract a page, use the usual File rightwards double arrow Save As command, making sure to choose the new file format from the pop-up menu. (If you choose a format like Photoshop or JPEG, Preview converts only the currently selected page of your PDF document. That's because there's no such thing as a multipage Photoshop or JPEG graphic. But you already knew that.)

    Figure 10-19. Left: Type into the Search or Find box. Matches appear in the Sidebar, with page numbers; click one to go there. Right: In longer documents, it helps to turn on "Group by section." You now see only the names of the document sections, ranked by relevance.

  • Add keywords to a graphic or PDF (choose Tools rightwards double arrow Inspector, click the Â tab, click the + button). Later, you'll be able to call up these documents with a quick Spotlight search for those details.

10.23.4. The Toolbar

You can have hours of fun with Preview's toolbar. Exactly as with the Finder toolbar, you can customize it (by choosing View rightwards double arrow Customize Toolbar—or by Option- [image] clicking the upper-right toolbar button), rearrange its icons (by [image] -dragging them sideways), and remove icons (by [image] -dragging them downward).

Tip: Unhappy about the full inch of screen space consumed by the toolbar? No problem. Just [image] -click the toolbar button (the white capsule in the upper-right corner). With each click, you cycle to the next toolbar style: large icons, small icons, no text labels, only text labels, and so on.


quicktime_player.html

10.24. QuickTime Player

There's a lot to say about QuickTime player, but it's all in Chapter 15.


safari.html

10.25. Safari

Apple's first and only Web browser feels decidedly faster and more modern than Internet Explorer, and there are enough tips and tricks lurking inside to last you a lifetime. Details in Section 10.25.


stickies-id001.html

10.26. Stickies

Stickies creates virtual Post-it notes that you can stick anywhere on your screen—a triumphant software answer to the thousands of people who stick notes on the edges of their actual monitors. Like the Stickies widget in Dashboard, you can open this program with a keystroke (highlight some text, then press Shift- [image] -Y)—but it's a lot more powerful.

You can use Stickies to type quick notes and to-do items, paste in Web addresses or phone numbers you need to remember, or store any other little scraps and snippets of text you come across. Your electronic Post-it notes show up whenever the Stickies program is running (Figure 10-20).

Figure 10-20. In the old days of the Mac, the notes you created with Stickies were text-only, single-font deals. Today, however, you can use a mix of fonts, text colors, and styles within each note. You can even paste in graphics, sounds, and movies (like PICT, GIF, JPEG, QuickTime, AIFF, whole PDF files, and so on), creating the world's most elaborate reminders and to-do lists.

10.26.1. Creating Sticky Notes

The first time you launch Stickies, a few sample notes appear automatically, describing some of the program's features. You can quickly dispose of each sample by clicking the close button in the upper-left corner of each note or by choosing File rightwards double arrow Close ( [image] -W).

Each time you close a note, a dialog box asks if you want to save it. If you click Don't Save (or press [image] -D), the note disappears permanently.

To create a new note, choose File rightwards double arrow New Note ( [image] -N). Then start typing or:

  • Drag text in from any other program, such as TextEdit, AppleWorks, or Microsoft Word. Or drag text clippings from the desktop directly into your note. You can also drag a PICT, GIF, JPEG, or TIFF file into a note to add a picture. You can even drag a sound or movie in. (A message asks if you're sure you want to copy the whole whopping QuickTime movie into a little Stickies note.)

  • Drag the icon of a PDF file into a note.(Stickies can even accommodate multipage PDF files. At first, you see only the first page, but a scroll bar is available to see the rest.)

  • How weird is this? You can even drag a Microsoft Word document into a note!

  • Choose File rightwards double arrow Import and select any plain text file or RTF (Rich Text Format) document to bring it into a note.

  • Drag URLs into a note directly from a Web browser's address bar.

    Tip: If one particular note contains your most important information—your to-do list, say—you can force it to remain in front of all other windows, even if Stickies itself gets shunted to the background. Just click the note, and then choose Note rightwards double arrow Floating Window.

    In TextEdit, Mail, or other Cocoa applications, select a chunk of text and then choose Make New Sticky Note from the program's Services menu (Section 5.10.1). This command launches Stickies, creates a new note, and fills it with your selected text—all in one step.

Note: All your notes are stored in a file called Stickies Database, located in your Home rightwards double arrow Library folder. You're free to copy it, pass it along, and so on, just as you would any file.

Have a favorite style for your sticky notes? First create a new note, choosing the color and text style that you like and setting it to the size you prefer. Then choose Note rightwards double arrow Use as Default. All new notes you create now appear in the size, font, and color of your choice.

10.26.2. Growing and Shrinking Notes

Stickies includes a few built-in tricks for managing a deskful of notes:

  • There's a small resize handle on the lower-right corner of each note. Drag it to make notes larger or smaller onscreen

  • Use the small triangle in the upper-right corner of each note to zoom and shrink note windows with a single click. The first click collapses a note down to a more compact size. Another click pops the note back open to normal size.

  • The best option: Double-click anywhere along the dark strip at the top of each note to collapse it into a compact one-line mininote, as shown in Figure 10-21. You also can collapse a selected note by choosing Window rightwards double arrow Miniaturize Window (—-M).

Tip: The most efficient way to use Stickies is to keep the notes in their collapsed state, as shown in Figure 10-21. When a note is collapsed, the first line of text shows up in tiny type in the collapsed title bar of the note, so you don't have to expand the note to remember what's in it. And since many—if not most—of your notes can probably be summed up in a couple of words ("Pick up dry cleaning," "Call Mom"), it's possible to keep your sticky notes in their collapsed state permanently.

Figure 10-21. If the first line of text gets truncated, as in the third note shown here, you can tug the right corner of the note and drag it wider without de-miniaturizing it.

GEM IN THE ROUGH
The Hidden Stickies Commands

The casual Stickies user may miss some of the program's more interesting commands, which are accessible only through the shortcut menus that pop up when you Control-click (or right-click) a sticky note. Here's what you'll find only in the shortcut pop-up menus:

Check Spelling As You Type. Turning on this spell check option (in the Spelling menu) flags misspelled words the moment you type them. You must turn this option on or off for each note individually

Speech. Don't just read your notes—listen to them. You can use the Mac's Text-to-Speech feature to hear your notes read aloud. Choose Speech rightwards double arrow Start Speaking to hear the Mac read a selected portion of a note, or use the command with nothing selected to hear the entire contents of a note. The only way to stop the speech is to Control-click again and choose Speech rightwards double arrow Stop Speaking.

(To pick the voice and speed of the reader, go to the Speech pane of System Preferences, as described on Section 15.4.2.6.)

Writing Direction. This feature is intended to let you type in non-English languages. But even in English, you can have plenty of fun with unsuspecting suckers by choosing Right to Left, so that all your text is right-justified and the insertion point moves to the left as you type.

10.26.3. Formatting Notes

Stickies has several word processor–like commands for creating designer sticky notes, with any combination of fonts, colors, and styles. You can also choose from six background colors from the Color menu. For the full scoop on Mac OS X's Font panel, choosing colors, and other typographic finery, see Section 14.7.3.

10.26.4. Saving Sticky Notes

The notes you create in Stickies last only as long as you keep them open. If you close a note to get it out of the way (and you click Don't Save in the confirmation box), it vanishes permanently.

If you want to preserve the information you've stuffed into your notes in a more permanent form, use File rightwards double arrow Export Text to save each note as a standalone TextEdit document. When you use the Export Text command, you have the following options:

  • Plain Text. This option saves your note as a plain text file, with neither formatting nor pictures.

  • RTFstands for Rich Text Format, a special exchange format that preserves most formatting, including font, style, and color choices. You can open the resulting RTF file in just about any word processor with all of your formatting still intact.

  • RTFD. RTFD, a strange and powerful variant of RTF, is a Rich Text Format document with attachments. How do you "attach" items to an RTFD file? Drag the icon of an actual application (Preview, Calculator, or whatever) or a multipage PDF file, into a sticky note. The icon for the program or document appears in the note, but double-clicking the icon doesn't do anything. When you export the note as an RTFD file, the result is a TextEdit document that has embedded within it the entire program or document that you dragged in. The program icon appears just as it did in the sticky note, but if you double-click the icon, the program now actually opens. (For more about RTFD files, see the box on Section 10.28.6.)

    You can also paste a graphic into your sticky note. When you export the note as an RTFD document, the resulting package file includes a graphics file of the format that you pasted.

    If you don't have embedded programs or documents in your notes, then exported RTFD files are exactly the same as their RTF counterparts.

Tip: You can import the Stickies file from your old Mac OS 9 System Folder. Just choose File rightwards double arrow Import Classic Stickies. In the Open File dialog box, navigate to the old System Folder rightwards double arrow Preferences rightwards double arrow Stickies File document and open it.


system_preferences-id002.html

10.27. System Preferences

This program opens the door to the nerve center of Mac OS X's various user preferences, settings, and options. Section 4.5.1 covers every option in detail.


textedit-id001.html

10.28. TextEdit

TextEdit: It's not just for Read Me files anymore.

TextEdit (Figure 10-22) is a basic word processor—but it's not nearly as basic as it used to be. You can create real documents with real formatting, using style sheets, colors, automatic numbering and bullets, tables, and customized line spacing, and—get this—even save the result as a Microsoft Word document. There's even a multiplelevel Undo command. If you had to, you could write a novel in TextEdit and it would look pretty decent.

Figure 10-22. The text ruler gives you control over tab stops, line spacing, paragraph justification, and so on. Pressing -R makes it appear and disappear. The Style pop-up menu lists canned sets of character and paragraph formatting, so you can apply them consistently throughout a document.

10.28.1. TextEdit's Two Personalities

The one confusing aspect of TextEdit is that it's both a plain text editor (no formatting; globally compatible) and a true word processor(fonts, sizes, styles; compatible with other word processors). You need to keep your wits about you as you edit, because the minute you add formatting to your document, TextEdit no longer lets you save it as a plain text file.

Here's the scheme:

  • You can change a plain text document to a formatted one by choosing Format rightwards double arrow Make Rich Text. The ruler appears automatically to remind you that a new world of formatting has just become available.

  • Conversely, you can change a formatted document (a Word file you've opened, for example) to a plain text document by choosing Format rightwards double arrow Make Plain Text. An alert message appears to point out that you're about to lose all formatting.

  • If you know what kind of document you always want to open, go to the TextEdit rightwards double arrow Preferences dialog box; on the New Document tab, select Rich Text or Plain Text. That's what you'll get each time you choose File rightwards double arrow New.

10.28.2. Working in TextEdit

As you begin typing, all the usual word processing rules apply, with a few twists:

  • Choose Bold, Italic, and font sizes using the Format rightwards double arrow Font submenu, or choose Format rightwards double arrow Font rightwards double arrow Show Fonts ( [image] -T) to open up the standard Mac OS X Font panel (Section 14.7.3). You can even create subscript or superscript, change the color of the text (Format rightwards double arrow Font rightwards double arrow Show Colors), and so on.

  • Common paragraph-alignment options—Align Left, Align Right, Center, Justify—are all available as ruler buttons and also reside in the Format rightwards double arrow Text submenu. Adjust the line spacing (single, double, or any fraction or multiple) using the Spacing pop-up menu in the ruler.

  • The ruler also offers automatic bulleting and numbering of paragraphs. Just choose the numbering style you prefer from the Lists pop-up menu.

    UP TO SPEED
    The Deal with Microsoft Word

    Yes, you read that correctly: Humble TextEdit can open and create Microsoft Word documents! Your savings: the $400 price of Microsoft Office!

    Well, sort of.

    When you open a Microsoft Word document in TextEdit, most of the formatting comes through alive: bold, italic, font choices, colors, line spacing, alignment, and so on. Even very basic tables make it into TextEdit, although with different column widths.

    A lot of Word-specific formatting does not survive crossing the chasm, however: borders, style sheets, footnotes, and the like. Bullets and numbered lists don't make it, either, even though TextEdit can create its own versions of these. And TextEdit doesn't recognize the comments and change tracking that your collaborators might use to mark up your manuscript.

    Saving a TextEdit document as a Word document (File rightwards double arrow Save As) is a better bet, because Word understands the many kinds of formatting that TextEdit can produce—including bullets, numbering, and tables. The one disappointment is that Word doesn't recognize any style sheets you've set up in TextEdit. The formatting applied by those style names survives—just not the style names themselves.

    Even so, a built-in Word-document editor is a huge, huge step for the Mac OS. It means that in many cases, you can be a first-class citizen on the playing field of American business. Nobody ever needs to know that you're (a) using a Mac, and (b) not using the real Microsoft Word.

  • You can select several non-adjacent bits of text simultaneously. To pull this off, highlight your first piece of text by dragging, and then press [image] as you use the mouse to select more text. Bingo: You've highlighted two separate chunks of text.

    When you're done selecting bits of text here and there, you can operate on them en masse. For example, you can make them all bold or italic with one fell swoop. You can even use the Cut, Copy, and Paste commands, as described in the next section. When you cut or copy, the command acts upon all your selections at once.

You can also drag any one of the highlighted portions to a new area, confident that the other chunks will come along for the ride. All of the selected areas wind up consolidated in their new location.

Tip: If you Option-drag one of the highlighted bits, you copy it, leaving the original in place.

  • Similarly, you can use the Find command to highlight a certain term everywhere it appears in a document. To do that, choose Edit rightwards double arrow Find rightwards double arrow Find (or just press [image] -F). Fill in the "Find" and "Replace with" boxes—and then press the Control key. The Replace All button changes to say Select All.

    GEM IN THE ROUGH
    What's New in TextEdit

    TextEdit might not look as though it's had a visit from the Overhaul Fairy. But here and there, some welcome new formatting features await.

    Page numbering.When you open the Print dialog box (File rightwards double arrow Print) and then expand it by clicking the [image] button, a new option appears called "Print header and footer." It stamps the page number, date, and title at the top and bottom of each page.

    Smart Copy/Paste.How long, oh Lord, have we waited for this?

    When this option is turned on, and you double-click a word and then delete or cut it, TextEdit doesn't leave behind an awkward two-space gap. Only one space character remains between the words that remain.

    The same magic happens when you paste text into a document, too. TextEdit automatically adds or deletes space characters as necessary so that there's exactly one space before the first pasted word and after the last one. You can turn this feature on either for the document you're now editing (Edit rightwards double arrow Substitutions rightwards double arrow Smart Copy/Paste), orfor all future documents (TextEdit rightwards double arrow Preferences rightwards double arrow New Document tab rightwards double arrow Smart Copy/Paste).

    Autosave. TextEdit can now save changes to your work automatically at intervals you specify, from every 15 seconds to every five minutes. The on/off switch for this feature is in TextEdit rightwards double arrow Preferences; click the Open and Save tab, and then choose from the "Autosave modified documents" pop-up menu.

    Auto Hyperlinks. When you type a Web address like www.cnn.com, TextEdit can format it automatically as a blue, underlined link that you can actually click to open the corresponding Web page. You can turn this feature on either for the document you're now editing (Edit rightwards double arrow Substitutions rightwards double arrow Smart Links), or for all future documents (TextEdit rightwards double arrow Preferences rightwards double arrow New Document tab rightwards double arrow Smart Links). It doesn't work for email addresses, alas. Grammar Checking. See "TextEdit's Other Writing Tools" on Section 10.28.7. gem in the rough

    Grammar Checking. See "TextEdit's Other Writing Tools" on Section 10.28.7.

    Tip: Oh, don't get TextEdit started on secret keystrokes in the Find box. If you press Option, for example, the Replace All button changes to say In Selection (meaning that you'll search-and-replace only the highlighted blob of text).You can combine the two previous tricks, too. If you press Control and Option, the Replace All button changes to say In Selection—but now you're selecting, not replacing, all occurrences of the search text just within the highlighted block.

    POWER USERS' CLINIC
    Advanced Typography in TextEdit

    If you just sprayed your coffee upon reading the heading of this sidebar, you're forgiven. Advanced typography in TextEdit? Isn't that a little bit like saying "page layout in Note Pad"?

    Not at all. TextEdit is a gleaming showcase for Mac OS X's typographical smarts.

    Most of the commands in the Format rightwards double arrow Font submenu should be familiar to you: Bold, Italic, Underline, and so on. But a few were once found only in expensive page-layout programs like In Design and QuarkXPress. For example:

    Kern. Use these commands, such as Tighten and Loosen, to nudge the letters of the selected text closer together or farther apart—an especially useful feature when you're fiddling with headlines and headings.

    There are no controls to set how much you want to kern the text, but you can apply these commands repeatedly to the same text selection to intensify them. If you want your text to be very tight, for example, just keep choosing the Tighten command. The characters creep closer and closer together until they crash into each other.

    Ligature. Ligatures are letter pairs, such as fl and ff, that, in fancy typesetting, are often conjoined into special combination characters, as shown here. If you choose Format rightwards double arrow Font rightwards double arrow Ligature rightwards double arrow Use Default (or Use All), TextEdit displays these letter pairs with the appropriate ligatures, as shown here. (This works only if the font you're using has those ligatures built into it. New York, Charcoal, Apple Chancery, and all Adobe Expert fonts do, for example, but many other fonts don't.)

    Baseline. The baseline is the imaginary "floor" for text characters in a line of type. You can push text above this line or sink it below the baseline using the Raise and Lower commands in the Baseline submenu. The Superscript and Subscript commands, meanwhile, shift characters far above or below the baseline, so you can write stuff like H20.

    Character Shape. In a few fonts, such as Adobe Expert fonts, this submenu offers a choice between Traditional Form and specialized type treatments like Small Caps.

    Copy Style/Paste Style. If mastering the Styles pop-up menu (described on the next page) is too much effort, these commands offer another way to copy and paste just the font formatting to other text—the font, color, style, and size, but none of the actual text or paragraph attributes, such as alignment.

    Smart Quotes. In Leopard, for the first time, TextEdit can automatically curlify the ordinarily straight "quote" and 'apostrophe' marks into the more typographically pleasing "curly" quotes and 'curly' apostrophes.

    If you've already typed quotes into a document, you can fix them all by choosing Edit rightwards double arrow Substitutions rightwards double arrow Smart Quotes. Or, to make sure all your documents have curly quotes from now on, choose Text Edit rightwards double arrow Preferences; in the Preferences dialog box, turn on "Smart quotes."

    Even then, though, you can still produce a straight quote or apostrophe mark when you need one, like when you're indicating feet or inches (6'1"). Just hold down the Control key as you type the apostrophe or quote mark.

  • If you Option-drag vertically, you can freely select an arbitrary column of text (not necessarily the entire page width). This technique is very useful when you want to select only one column in a multicolumn layout, or when you want to select the numbers in a list ("1.,""2.,"and so on) and format them all at once. (As noted earlier, this trick also works in Preview PDF documents.)

10.28.3. Style Sheets

A style is a prepackaged collection of formatting attributes that you can apply and reapply with a click of the mouse (bold, 24-point Optima, double-spaced, centered, for instance). You can create as many styles as you need: chapter headings, sidebar styles, and so on. You end up with a collection of custom-tailored styles for each of the repeating elements of your document.

Once you've created your styles, you can apply them as you need them, safe in the knowledge that they'll be consistent throughout the document. During the editing process, if you notice you accidentally styled a headline using the Subhead style, you can fix the problem by simply reapplying the correct style.

Note: Unlike a real word processor, TextEdit doesn't let you change a style's formatting and thereby update every occurrence of it. You can't search and replace by style, either.

  • Creating a named style. To create a style, format some text so that it looks the way you like it, complete with font, color, line spacing, tab settings, and so on.

    Figure 10-23. Top: Highlight the text you want to format. Then, from the Styles pop-up menu in the ruler, choose Other. With each click of the button, you summon a snippet of the next chunk of formatting. When you find one you like, you can either click Apply (to zap the highlighted text into submission) or Add To Favorites (to reuse this canned style later). In the latter case, you can give the new style a name (bottom).

    Then, from the Styles pop-up menu in the ruler, choose Other (Figure 10-23, top). Click Add to Favorites, type a name for the style, turn on both checkboxes (Figure 10-23, bottom), and click Add.

  • Applying a style. Later, when you want to reuse the formatting you setup, highlight some text and then choose the appropriate name from the Styles pop-up menu. TextEdit applies the formatting immediately.

    Tip: If you simply click inside a paragraph, applying a style affects only paragraph attributes like line spacing, tab stops, and alignment. If you highlight a random chunk of text instead, applying a style affects only character attributes like the font and type size. If you highlight an entire paragraph, however, both text and paragraph formatting appear.

  • Deleting a style. To delete a superfluous style, choose Other from the Styles pop-up menu on the ruler. Click the Favorite Styles button, choose the unwanted style's name from the pop-up menu, and then click Remove From Favorites. (Deleting a style doesn't affect any formatting that's already in your document; it just removes the name from the Styles menu.)

  • Copying by example. In Word and most other "serious" word processors, the routines above correctly describe how you use styles. In TextEdit, however, you can use Option- [image] -C and Option- [image] -V (Format rightwards double arrow Copy Style and Format rightwards double arrow Paste Style) to grab formatting from one place in your document and reuse it elsewhere. (Of course, you can't apply styles in text-only documents.)

10.28.4. Tables

Tables can make life a heck of a lot easier when you want to create a résumé, agenda, program booklet, list, multiple-choice test, Web page, or another document where numbers, words, and phrases must be aligned across the page. In the bad old days, people did it by pressing the Tab key to line up columns—a technique that turned into a nightmare as soon as you tried to add or delete text. But using a word processor's table feature is light-years easier and more flexible, because each row of a table expands infinitely to contain whatever you put into it. Everything else on its row remains aligned.

Tip: Tables are also critical for designing Web pages, as any Web designer can tell you. Even though you can't see the table outlines, many a Web page is filled with columns of text that are aligned invisibly by tables. And now that TextEdit can save your work as an HTML document, it's suddenly a viable candidate for designing basic Web pages.

  • Createa table by choosing Format rightwards double arrow Text rightwards double arrow Table. The floating Table palette appears (Figure 10-24). Use it to specify how many rows and columns you want. The placeholder table in your document adjusts itself in real time.

  • Format the table using the other controls in the Table palette. The Alignment controls let you specify how the text in one of the table cells hugs its border. Cell Border controls the thickness of the line around the selected cells' borders (or, if you enter 0, makes the table walls invisible). The color swatch next to Cell Border specifies the color of the solid lines. The Cell Background controls let you color in the table cells with colors of your choice. (Choose Color Fill from the pop-up menu, and then click the color swatch.) This is an especially valuable option for Web designers.

    Figure 10-24. Note to Web designers: TextEdit may not be Dreamweaver, but it's great for spinning out quick Web pages, thanks to the table features. Here, you can see that a big table forms the underlying structure for this Web page, along with a couple of nested ones and color selections.

  • Adjust the rows and columns by dragging the cell borders.

  • Merge two selected cells by clicking Merge Cells in the Table palette. Once you've done that, you can use the Split Cell button to split them apart again. (Split Cell doesn't work except in cells you've previously merged.)

  • Nest one table inside a cell of another by clicking in the cell and then clicking Nest Table. Change the numbers in the Rows and Columns boxes to set up its dimensions (Figure 10-24).

10.28.5. TextEdit as Web Designer

The new Table palette isn't the only clue that Apple intends TextEdit to be a quickand-dirty Web page design program. Consider these other tools:

  • You can easily add graphics to the page by dragging or pasting them into a document. The program understands TIFF, PICT, JPG, and GIF formats.

  • You can add Web-style hyperlinks by highlighting "Click here"(or whatever the link says), choosing Format rightwards double arrow Text rightwards double arrow Link, and entering the Web address in the resulting dialog box. Or just drag a link in from Safari, Mail, or another program. (To edit the link later, Control-click it, and then choose Edit Link.)

  • To save a document as an HTML (Web page) file, choose File rightwards double arrow Save As; from the File Format pop-up menu, choose Web Archive.

  • Don't miss the HTML options in TextEdit rightwards double arrow Preferences. On the "Open and Save" tab, you can specify what kind of HTML document you want to produce, what cascading style sheets (CSS) setting you want, and whether or not you want TextEdit to include code to preserve blank areas (white space) in your layout.

Tip: When you open a Web page document—that is, an HTML document—TextEdit is faced with a quandary. Should it open up the page as though it's a Web page, interpreting the HTML code as though it's a browser? Or should it reveal the underlying HTML code itself?Actually, that's up to you. When you choose File rightwards double arrow Open, turn on "Ignore rich text commands" to make the document open up as HTML code. (To make this change permanent, turn on the same checkbox on the "Open and Save" pane of the TextEdit rightwards double arrow Preferences dialog box.)

GEM IN THE ROUGH
Files Within Files Within Files

It's no surprise that you can include formatted text and pictures in a TextEdit document, but here's a shocker. You can also embed an entire program or document within a TextEdit file.

Try this experiment: Create a new TextEdit document in Rich Text mode. Drag a couple of program icons into the TextEdit document. Do the same with some documents that were created using native Mac OS X programs (another TextEdit document, for example).

When you save the file, Mac OS X saves embedded copies of the applications and documents you dragged into the TextEdit document itself. (The TextEdit file is saved in a format called RTFD, which is a Rich Text Format document with attachments.)

Once you've saved the file, you can double-click any of the icons in the file to launch the embedded items. In the TextEdit document shown here, you could launch the Chess, DVD Player, and Mail programs—all right from within the file.

To make things even wilder, it's possible to drag a TextEdit file containing embedded items into another TextEdit file, saving a file within a file within a file.

One important point: The double-clickable icons you create in TextEdit using this method are not aliases or links to your original documents and programs. They're actual, full copies. If you embed a 10 MB program into a TextEdit document, you'll end up with a 10 MB TextEdit file!

10.28.6. The TextEdit Preferences

Most of the settings in the TextEdit Preferences rightwards double arrow New Document pane have no effect on documents that are already open—only on documents you open or create from now on. Most of the settings are self-explanatory; nonetheless, handy explanatory balloons appear if you point to an option without clicking. Here are a few settings that may not be immediately clear:

  • Font. If Helvetica 12 doesn't especially float your boat, you can change TextEdit's starting font.Note that you can set two default fonts—one for RichText documents and another one for Plain Text files.

    Note: By definition, plain text files don't have any formatting. So whatever font you choose here for Plain Text files is for your editing pleasure only. If you plan to send the file to anyone else, remember that the font choice won't be saved with the document.

  • Window Size. These settings have no effect unless you're in Wrap to Window mode, in which the text rewraps to fit the window width, as opposed to Wrap to Page mode. (You choose these options from TextEdit's Format menu.)

    If you are in Wrap to Window mode, then these dimensions determine the size of the window that appears each time you create a new TextEdit document.

  • Properties. These boxes—Author, Company, and Copyright—are some of the tags that Spotlight inspects when it searches your Mac. If you'd like to be able to round up your documents by these characteristics, fill them in here to specify the information you want to use for most documents. (To fill them in differently for individual documents, choose File rightwards double arrow Show Properties instead.)

10.28.7. TextEdit's Other Writing Tools

TextEdit includes a few other very useful document-editing tools:

  • Allow Hyphenation. When you select this command from the Format menu, TextEdit breaks up words by syllable and inserts hyphens when necessary in order to create more visually pleasing line breaks.

    Tip: It's especially important to turn this feature on if your paragraph alignment is set to Justify, or if you create narrow columns of text. If hyphenation is turned off, TextEdit won't break up whole words at the end of a line—even if it leaves big, ugly white gaps between words.

  • Prevent Editing. When you turn this option on (again, in the Format menu), you're locked out. You can select and copy text to your heart's content, but you can't change anything. Prevent Editing mode can be useful if you want to prevent yourself from making accidental changes to a file, but it's not much of a security feature. (All anyone has to do is choose Format rightwards double arrow Allow Editing to regain full editing privileges.)

  • Spelling and grammar checking. TextEdit can give you live, interactive spelling and grammar checking, just as in Microsoft Word and other word processors. That is, misspelled words or badly written sentences or fragments get flagged with a dashed red line the moment you type them. (The grammar part is new in Leopard.)

    You can turn these on independently. From the Edit rightwards double arrow Spelling and Grammar submenu, choose either "Check Spelling While Typing" or "Check Grammar While Typing."

    Some people, though, find that it's less intrusive to save the checking until the first draft of the document is complete. At that point you can open the full spelling and grammar checker by choosing Edit rightwards double arrow Spelling and Grammar rightwards double arrow Show Spelling and Grammar (or press Shift- [image] -:). (Turning on the "Check grammar" checkbox is optional.)

    Figure 10-25. You're never more than a Control-click (or right-click) away from more accurate spelling in TextEdit. Once you Controlclick a questionable word, the suggestions of Apple's built-in dictionary appear right in the shortcut menu, along with the Learn and Ignore commands.

    Figure 10-26. Once you've begun typing a word, press either F5 or Option-Esc to produce the list of possible word completions shown here. If TextEdit correctly anticipates the rest of the word, great; press Tab, Return, or the Space bar to accept the suggestion, and then keep right on typing. If TextEdit guesses wrong, you can either select a different word in the list (using the mouse or the arrow keys), or tap Esc to ignore the suggestions and continue typing.

    Using the panel, you can correct errors (choosing from the suggestions generated by Apple's built-in spelling dictionary) or tell TextEdit to learn or ignore other suspected misspellings.

    The quickest way to handle spelling and grammar corrections, though, is shown in Figure 10-25.

    Tip: This feature isn't really a TextEdit function—it's a system-wide spelling and grammar checker that you'll also find in Stickies, Mail, iCal, iPhoto, and other programs. You learn it once, you've learned it forever.

  • AutoComplete. This feature is ideal for anyone who's in a hurry, who's unsure of a spelling, or who's trying to solve a crossword puzzle. See Figure 10-26 for details, and note that AutoComplete is actually available in almost every Cocoa program.


time_machine-id002.html

10.29. Time Machine

This marquee feature of Leopard is described in Chapter 6.


utilities_your_mac_os_x_toolbox.html

10.30. Utilities: Your Mac OS X Toolbox

The Utilities folder (inside your Applications folder) is home to another batch of freebies: another couple of dozen tools for monitoring, tuning, tweaking, and troubleshooting your Mac.

The truth is, you're likely to use only about six of these utilities. The rest are very specialized gizmos primarily of interest to network administrators or Unix geeks who are obsessed with knowing what kind of computer-code gibberish is going on behind the scenes.

Tip: Even so, Apple obviously noticed that as the sophistication of Mac OS X fans grows, more people open the Utilities folder more often. That's why there's a menu command and a keystroke that can take you there. In the Finder, choose Go rightwards double arrow Utilities (Shift- [image] -U).

10.30.1. Activity Monitor

Activity Monitor is designed to let the technologically savvy Mac fan see how much of the Mac's available power is being tapped at any given moment.

10.30.1.1. The Processes table

Even when you're only running a program or two on your Mac, dozens of computational tasks (processes) are going on in the background. The top half of the dialog box, which looks like a table, shows you all the different processes—visible and invisible—that your Mac is handling at the moment.

Check out how many items appear in the Process list, even when you're just staring at the desktop. It's awesome to see just how busy your Mac is! Some are easily recognizable programs (such as Finder), while others are background system-level operations you don't normally see. For each item, you can see the percentage of CPU being used, who's using it (either your account name, someone else's, or root, meaning the Mac itself), and how much memory it's using.

Or use the pop-up menu above the list to see:

  • All Processes. This is the complete list of running processes; you'll notice that the vast majority are little Unix applications you never even knew you had.

  • My Processes. This list shows only the programs that pertain to your world—your login. There are still plenty of unfamiliar items, but they're all running to serve your account.

  • Windowed Process. Now this is probably what you were expecting: a list of actual programs with actual English names, like Activity Monitor, Finder, Safari, and Mail. These are the only ones running in actual windows, the only ones that are visible, which is what most people probably think of as programs.

10.30.1.2. The System monitor tabs

At the bottom of Activity Monitor, you're offered five tabs that reveal intimate details about your Mac and its behind-the-scenes efforts (Figure 10-27):

  • CPU. As you go about your usual Mac business, opening a few programs, dragging a playing QuickTime movie across the screen, playing a game, and so on, you can see the CPU graph rise and fall, depending on how busy you're keeping the CPU. On multiple-processor Macs, you see a different bar for each chip, enabling you to see how efficiently Mac OS X is distributing the work among them.

    Tip: You may also want to watch this graph right in your Dock (choose View rightwards double arrow Dock Icon rightwards double arrow ShowCPUHistory) or in a bar at the edge of your screen (choose Window rightwards double arrow Floating CPU Window rightwards double arrow Horizontally).Finally, there's the weirdly uncapitalized command View rightwards double arrow "Show CPU monitors on top of other windows." It makes the little bar float on top of all your other programs, so you can't miss it.

  • System Memory. Here's a colorful graph that reveals the state of your Mac's RAM at the moment.

    The number below the graph shows how much memory is installed in your Mac. If, when your Mac is running a typical complement of programs, the Wired number plus the Active number nearly equals your total RAM amount, it's time to consider buying more memory. You're suffocating your Mac.

  • Disk Activity. Even when you're not opening or saving a file, your Mac's hard drive is frequently hard at work, shuffling chunks of program code into and out of memory, for example. Here's where the savvy technician can see exactly how frantic the disk is at the moment.

  • Disk Usage. This little graph offers one of the quickest ways to check out how full your hard drive is at the moment. (If you have more than one drive—say, a flash drive, tape-backup drive, or whatever—choose another drive's name from the pop-up menu.)

  • Network. Keep an eye on how much data is shooting across your office network with this handy EKG-ish graph.

Figure 10-27. The many faces of Activity Monitor.
Top: It can be a graph of your processor (CPU) activity, your RAM usage at the moment, your disk capacity, and so on. For most people, only the processes listed here with tiny icons beside their names are actual windowed programs—those with icons in the Finder, the ones you actually interact with.
Don't miss the top-left Quit button. It's a convenient way to jettison a locked-up program when all else fails.
Bottom: If you doubleclick a process's name, you get a three-tab dialog box that offers stunningly complete reams of data (mostly of interest only to programmers) about what that program is up to. (The Open Files and Ports tab, for example, shows you how many files that program has opened, often invisibly.)

10.30.2. AirPort Utility

You use the AirPort Utility to set up and manage AirPort base stations (Apple's line of wireless Wi-Fi networking routers).

If you click Continue, it presents a series of screens, posing one question at a time: what you want to name the network, what password you want for it, and so on. Once you've followed the steps and answered the questions, your AirPort hardware will be properly configured and ready to use.

10.30.3. Audio MIDI Setup

Maybe you've heard that Mac OS X comes with spectacular internal wiring for music, sound, and MIDI (Musical Instrument Digital Interface, a standard "language" for inter-synthesizer communication). It's available, that is, to music software companies who have written their wares to capitalize on these tools.

This configuration program offers two tabs. The first, Audio Devices, is the master control panel for all your various sound inputs and outputs: microphones, line inputs, external speakers, and so on. For most people, this is meaningless, because most Macs have only one input (the microphone) and one output (the speakers). But if you're sitting in your darkened music studio, which is humming with high-tech audio gear whose software has been designed to work with this little program, you'll smile when you see this tab.

These condtab, MIDIDevices, should look familiar to synthesizer fans who have used software like OMS or FreeMIDI to teach the Mac about their studio configurations. By clicking Add Device, you create a new icon that represents one of your pieces of gear. Double-click the icon to specify its make and model. Finally, by dragging lines from the "in" and "out" arrows, you teach your Mac and its MIDI software how the various components are wired together.

10.30.4. Bluetooth File Exchange

One of the luxuries of using a Mac that has Bluetooth is the ability to shoot files (to colleagues who own similarly clever gadgets) through the air, up to 30 feet away. Bluetooth File Exchange makes it possible, as described on Section 6.2.5.

10.30.5. Boot Camp Assistant

On Macs with Intel inside, this program helps you create (or destroy) a partition of your hard drive to hold a copy of Microsoft Windows. Details in Chapter 8.

10.30.6. ColorSync Utility

If you use ColorSync (because you're in the high-end color printing business, for instance), you might be surprised to find that the ColorSync pane is gone from the System Preferences program. Instead, that pane's settings have been merged into this beefed-up program.

This bet-you'll-never-touch-it utility combines two functions:

  • Its Profile First Aid tab performs a fairly esoteric task: repairing ColorSync profiles that may be "broken" because they don't strictly conform to the ICC profile specifications. (ICC [International Color Consortium] profiles are part of Apple's ColorSync color management system, as described on Section 7.5.1.3.) If a profile for your specific monitor or printer doesn't appear in the Profiles tab of this program when it should, Profile First Aid is the tool you need to fix it.

  • The Profiles tab lets you review all the ColorSync profiles installed on your system. The area on the right side of the window displays information about each ColorSync profile you select from the list on the left.

The other tabs are described on Section 7.5.1.3.

10.30.7. Console

Console is a viewer for all of Mac OS X's text logs—the behind-the-scenes, internal Unix status messages being passed between the Mac OS X and other applications.

Opening the Console log is a bit like stepping into an operating room during a complex surgery: You're exposed to stuff the average person just isn't supposed to see. (Typical Console entries: "kCGErrorCannotComplete" or "do Get Display Transfer By Table.") You can adjust the font and word wrapping using Console's Font menu, but the truth is that the phrase "CGXGet Window Type: Invalid window–1" looks ugly in just about any font!

Console isn't useless, however. These messages can be of significant value to programmers who are debugging software or troubleshooting a messy problem, or, occasionally, to someone you've called for tech support.

10.30.8. DigitalColor Meter

DigitalColor Meter can grab the exact color value of any pixel on your screen, which can be helpful when matching colors in Web page construction or other design work. After launching the DigitalColor Meter, just point anywhere on your screen. A magnified view appears in the meter window, and the RGB (red-green-blue) color value of the pixels appears in the meter window. You can display the color values as RGB percentages or actual values, in Hex form (which is how colors are defined in HTML; white is represented as #FFFFFF, for example), and in several other formats.

Here are some tips for using the DigitalColor Meter to capture color information from your screen:

  • To home in on the exact pixel (and color) you want to measure, drag the Aperture Size slider to the smallest size—one pixel. Then use the arrow keys to move the aperture to the precise location you want.

  • PressShift- [image] -C (Color rightwards double arrow Copy Coloras Text) to puton the Clip board the numeric value of the color you're pointing to.

  • Press Shift- [image] -H (Color rightwards double arrow Hold Color) to "freeze" the color meter on the color you're pointing to—a handy stunt when you're comparing two colors onscreen.

    You can point to one color, hold it using Shift- [image] -H, and then move your mouse to the second color. Pressing Shift- [image] -H again releases the hold on the color.

  • When the Aperture Size slider is set to view more than one pixel, Digital Color Meter measures the average value of the pixels being examined.

10.30.9. Directory

Directory is, at its heart, a glorified address book that lets you see and organize lists of people, groups of people, meeting rooms, and equipment (like projectors or TV carts). This utility is geared toward corporate worker bees who are overseen by a system-administrator king bee—one who's equipped the office with a Mac OS X Server. (Without Mac OS X Server and instructions from a network geek, Directory isn't especially useful.)

10.30.10. Directory Utility

Here's another little program that's not intended for use by ordinary humans. It's exclusively for corporate network administrators. (And it replaces the NetInfo program that came with Mac OS X through version 10.4.)

This utility controls the access that each individual Mac on a network has to Mac OS X's directory services—special databases that store information about users and servers. Directory Access also governs access to LDAP directories (Internet- or intranetbased "white pages" for Internet addresses).

A network administrator can use Directory Access to do things like select NetInfo domains, set up search policies, and define attribute mappings. If those terms don't mean anything to you, just pretend you never read this paragraph and get on with your life.

10.30.11. Disk Utility

This important program serves two key functions:

  • It serves as Mac OS X's own little Norton Utilities: a powerful hard drive administration tool that lets you repair, erase, format, and partition disks. In everyday life, you'll probably use Disk Utility most often for its Repair Permissions feature, which solves an uncanny number of weird little Mac OS X glitches. But it's also worth keeping in mind, in case you ever find yourself facing a serious disk problem.

  • Disk Utility also creates and manages disk images, electronic versions of disks or folders that you can exchange electronically with other people.

The following discussion tackles the program's two personalities one at a time.

10.30.11.1. Disk Utility, the hard drive–repair program

Here are some of the tasks you can perform with this half of Disk Utility:

  • Repair folders, files, and program that don't work because you supposedly don't have sufficient "access privileges." This is by far the most common use of Disk Utility, not to mention the most reliable and satisfying. Using the Repair Disk Permissions button fixes an astonishing range of bizarre Mac OS X problems, from programs that won't open to menulets that freeze up the works.

  • Get size and type information about any disks attached to your Mac.

  • Fix disks that won't appear on your desktop or behave properly.

  • Completely erase disks—including rewritable CDs and DVDs (such as CD-RW and DVD-RW discs).

  • Partition a disk into multiple volumes (that is, subdivide a drive so that its segments appear on the desktop with separate disk icons).

    Tip: In Leopard, for the first time in Mac history, Disk Utility can create or enlarge disk partitions without requiring you to erase the entire hard drive. Details below.

  • Set up a RAID array (a cluster of separate disks that acts as a single volume).

Note: Disk Utility can perform some of its magic on the startup disk—the disk that's running Mac OS X at the moment. For example, it can check the disk for damage, fix the permissions of the disk, or even adjust its partitions.But any other operation, like reformatting, erasing, or actually repairing the disk, still requires the Mac to start up from a different disk (your Leopard DVD, for example). Otherwise, it'd be like a surgeon performing an appendectomy on himself—not a great idea.

The left Disk Utility panel lists your hard drive and any other disks in or attached to your Mac at the moment. When you click the name of your hard drive's mechanism, like "74.5 GB Hitachi iC25N0…" (not the "Macintosh HD" partition label below it), you see a panel with five tabs, one for each of the main Disk Utility functions:

  • First Aid. This is the disk-repair part of Disk Utility, and it does a terrific job at fixing many disk problems. When you're troubleshooting, Disk Utility should always be your first resort.

    To use it, click the icon of a disk and then click either Verify Disk (to get a report on the disk's health) or Repair Disk (which fixes whatever problems the program finds). In other words, First Aid attempts to perform the same healing effects on a sick hard drive as, say, a program like Norton Utilities.

    If Disk First Aid reports that it's unable to fix the problem, then it's time to invest in a program like DiskWarrior (www.alsoft.com).

    Tip: If Disk Utility finds nothing wrong with a disk, it reports, "The volume appears to be OK." Don't be alarmed at the not-so-congratulatory wording of that message—that's the strongest vote of confidence Disk Utility can give.

    You may wind up using the Verify and Repair Disk Permissions buttons even more often. Their function is to straighten out problems with the invisible Unix file permissions that keep you from moving, changing, or deleting files or folders. (The occasional software installer cancreate problems like this.) You'd be surprised how often running one of these permission checks solves little Mac OS X glitches.

    Chapter 12 has a much more detailed discussion of permissions.

  • Erase. Select a disk, choose a format (always Mac OS Extended [Journaled], unless you're formatting a disk for use on a Windows machine or an ancient Mac running Mac OS 8.1 or earlier), give it a name, and click Erase to wipe a disk clean.

  • Partition. With the Partition tools, you can erase a hard drive in such a way that you subdivide its surface. Each chunk is represented on your screen by another hard drive icon (Figure 10-28).

    There are some very good reasons not to partition a drive these days: A partitioned hard drive is more difficult to resurrect after a serious crash, requires more navigation when you want to open a particular file, and offers no speed or safety benefits.

    Figure 10-28. Partitioning your drive with Disk Utility no longer involves erasing it completely. Select the drive you want to partition from the list on the left, and click the Partition tab. Click the + button for each new partition you want.
    Now drag the horizontal dividers in the Volumes map to specify the relative sizes of the partitions you want to create. Assign a name and format for each partition in the Volume Information area, and then click Apply.

    On the other hand, there's one very good reason to do it: Partitioning is the only way to use Boot Camp, described as Chapter 8. Your Mac is a Mac when running off of the first partition, and a Windows PC when starting up from the second one.

  • RAID. RAID stands for Redundant Array of Independent Disks, and refers to a special formatting scheme in which a group of separate disks are configured to work together as one very large, very fast drive. In a RAID array, multiple disks share the job of storing data—a setup that can improve speed and reliability.

    Most Mac users don't use or set up RAID arrays, probably because most Mac users only have one hard drive (and Disk Utility can't make your startup disk part of a RAID array).

    If you're using multiple external hard disks, though, you can use Apple RAID to merge them into one giant disk. Just drag the icons of the relevant disks (or disk partitions) from the left-side list of disks into the main list (where it says, "Drag disks or volumes here to add to set"). Use the RAID Type pop-up menu to specify the RAID format you want to use (Stripe is a popular choice for maximizing disk speed), name your new mega-disk, and then click Create. The result is a single "disk" icon on your desktop that actually represents the combined capacity of all the RAID disks.

  • Restore. This tab lets you make a perfect copy of a disk or a disk image, much like the popular shareware programs Carbon Copy Cloner and Super Duper. You might find this useful when, for example, you want to make an exact copy of your old Mac's drive on your new one. You can't do that just by copying your old files and folders manually. If you try, you won't get the thousands of invisible files that make up Mac OS X. If you use the Restore function, they'll come along for the ride.

    POWER USERS' CLINIC
    Partition Adjustments on the Fly

    In Leopard, for the first time, you can expand, shrink, or create partitions without having to erase the whole hard drive. If you're into partitioning at all, this is a huge convenience.

    Expanding a partition. Suppose, for example, that your main hard drive has two partitions: a main one (200 gigs) and a secondary one (50 gigs) that used to hold all your photos and movies. But you've outgrown the second partition, and have moved all those photos and movies to their own external hard drive. Wouldn't it be nice to add the newly unoccupied 50 gigs to your main partition?

    You can do that without having to erase the whole hard drive. (This process, however, nukes everything on the second partition, so make sure you're prepared to lose it all.)

    Open Disk Utility. Click the name of the hard drive (for example, "Hitachi HTS541616J9SA00"—not "Macintosh HD"). Click Partition. You see a display like the one in Figure 10-28.

    Click the second partition (or third, or whatever partition is just after the one you want to expand) and then click the–button below the list. Poof! It's gone.

    Now you can drag the main partition's bottom edge downward (or type a new size into the Size box), expanding it into the free area. Take a deep breath, and then click Apply.

    Shrinking a partition. In Figure 10-28, you can see that a portion of the first partition is lightly shaded. (It's blue in real life.) The blue represents data; you can't shrink a partition so much that it crowds out your files. You can, however, shrink the partition to eliminate empty space. Just drag the lower edge of its map chunk upward.

    Creating new partitions. Any time there's leftover space on the drive, you can create new partitions from it.

    To do that, click the + button, and proceed as described in Figure 10-28.

    Start by dragging the disk or disk image you want to copy from into the Source box. Then drag the icon of the disk you want to copy to into the Destination box.

    Tip: If you want to copy an online disk image onto one of your disks, you don't have to download it first. Just type its Web address into the Source field. You might find this trick convenient if you keep disk images on your iDisk, for example.

    If you turn on Erase Destination, Disk Utility obliterates all the data on your target disk before copying the data. If you leave this checkbox off, however, Disk Utility simply copies everything onto your destination, preserving all your old data in the process. (The Skip Checksum checkbox is available only if you choose to erase your destination disk. If you're confident that all of the files on the source disk are 100% healthy and whole, turn on this checkbox to save time. Otherwise, leave it off for extra safety.)

    Finally, click the Restore button. (You might need to type in an administrator password.) Restoring can take a long time for big disks, so go ahead and make yourself a cup of coffee while you're waiting.

Tip: Instead of clicking a disk icon and then clicking the appropriate Disk Utility tab, you can just Controlclick (or right-click) a disk's name and choose Information, First Aid, Erase, Partition, RAID, or Restore from the shortcut menu.
10.30.11.2. Disk Utility, the disk-image program

The world's largest fan of disk images is Apple itself; the company often releases new software in disk-image form. A lot of Mac OS X add-on software arrives from your Web download in disk-image form, too, as shown below.

Disk images are popular for software distribution for a simple reason: Each image file precisely duplicates the original master disk, complete with all the necessary files in all the right places. When a software company sends you a disk image, it ensures that you'll install the software from a disk that exactly matches the master disk.

It's important to understand the difference between a disk-image file and the mounted disk (the one that appears when you double-click the disk image). If you flip back to Section 5.12.2 and consult Figure 5-22, this distinction should be clear.

Tip: After you double-click a disk image, click Skip in the verification box that appears. If something truly got scrambled during the download, you'll know about it right away—your file won't decompress correctly, or it'll display the wrong icon, for example.In fact, you can make Disk Utility always skip that verification business, which is a relic from the days of floppy disks. To do so, choose Disk Utility rightwards double arrow Preferences, and turn off "Check images on locked media."

You can create disk images, too. Doing so can be very handy in situations like the following:

  • You want to create a backup of an important CD. By turning it into a disk-image file on your hard drive, you'll always have a safety copy, ready to burn back onto a new CD. (This is an essential practice for educational CDs that kids will be handling soon after eating peanut butter and jelly.)

  • You want to replicate your entire hard drive—complete with all of its files, programs, folder setups, and so on—onto a new, bigger hard drive (or a new, better Mac), using the Restore feature described earlier.

  • You want to back up your entire hard drive, or maybe just a certain chunk of it, onto an iPod or another disk. (Again, you can later use the Restore function to complete the transaction.)

    GEM IN THE ROUGH
    The Sparse Image

    One of the coolest Disk Utility features is also one of the most buried.

    Turns out you can make a nice, hermetically sealed, password-protected disk image that starts out small, but magically increases as you stuff more files into it. If the usual disk image is like a steel bucket—a fixed size forever—a sparse image is like an elastic bag.

    Choose File rightwards double arrow New rightwards double arrow Blank Disk Image. In the resulting dialog box, name the file you're creating (which you'll double-click to make the virtual disk appear), as well as the virtual disk itself.

    From the Volume Size pop-up menu, choose the maximum size this disk image will ever be. The beautiful part is that it will probably never occupy that much disk space; it starts out small, and slowly expands only as necessary. But you're setting the maximum here.

    From the Encryption pop-up menu, choose one of the two scrambling methods that will password-protect your disk image. Finally, from the Image Format pop-up menu—this is the key step—choose "sparse disk image."

    Click Create. Make up a password (type it twice); for added security, don't store in your Keychain. (If you store it in your Keychain, no password at all will be required to open it by snoopy passersby.) Then click Create.

    Now, on your desktop, there's a disk image file with the suffix ". sparseimage." It occupies only 26 MB on your hard drive to start with.

    Double-click it and enter your password to bring the actual virtual disk icon to your desktop. You can now start filling the disk image up with private stuff. The .sparseimage file will grow automatically to accommodate it—but only as necessary.

  • You bought a game that requires its CD to be in the drive at all times. Many programs like these run equally well off of a mounted disk image that you made from the original CD.

  • You want to send somebody else a copy of a disk via the Internet. You simply create a disk image, and then send that—preferably in compressed form.

Here's how you make a disk image.

  • To imageize a disk or partition. Click the name of the disk in the left-panel list, where you see the disks currently in, or attached to, your Mac. (The topmost item is the name of your drive, like "484.0 MB MATSHITA DVD-R" for a DVD drive or "74.5 GB Hitachi" for a hard drive. Beneath that entry, you generally see the name of the actual partition, like "Macintosh HD," or the CD's name as it appears on the screen.)

    Then choose File rightwards double arrow New rightwards double arrow Disk Image from [whatever the disk or partition's name is].

  • To image-ize a folder. Choose File rightwards double arrow New rightwards double arrow Disk Image from Folder. In the Open dialog box, click the folder you want and then click Image.

Tip: Disk Utility can't turn an individual file into a disk image. But you can put a single file into a folder, and then make a disk image of it.

Either way, the next dialog box (Figure 10-29) offers some fascinating options.

  • Image Format. If you choose "read/write," your disk image file, when double clicked, turns into a super-bimitation of a hard drive. You can drag files and folders onto it, drag them off of it, change icons' names on it, and so on.

    If you choose "read-only," however, the result behaves more like a CD. You can copy things off of it, but not make any changes to it.

    Figure 10-29. These two pop-up menus let you specify (a) what kind of disk image you want, and (b) whether or not you want it password protected. The latter option is great when you want to password-protect one folder, without bothering with your entire Home folder.

    The "compressed" option is best if you intend to send the resulting file by email, post it for Web download, or preserve the disk image on some backup disk for a rainy day. It takes a little longer to create a simulated disk when you double-click the disk image file, but it takes up a lot less disk space than an uncompressed version.

    Finally, choose "DVD/CD master" if you're copying a CD or a DVD. The resulting file is a perfect mirror of the original disc, ready for copying onto a blank CD or DVD when the time comes.

  • Encryption. Here's an easy way to lock private files away into a vault that nobody else can open. If you choose one of these two AES encryption options (choose AES-128, if you value your time), you're asked to assign a password to your new image file. Nobody can open it without the password—not even you. On the other hand, if you save it into your Keychain (Section 12.9.5.1), it's not such a disaster if you forget the password.

  • SaveAs. Choose a name and location for your new image file. The name you choose here doesn't need to match the original disk or folder name.

    When you click Save (or press Enter), if you opted to create an encrypted image, you're asked to make up a password at this point.

    Otherwise, Disk Utility now creates the image and then mounts it—that is, turns the image file into a simulated, yet fully functional, disk icon on your desktop.

    When you're finished working with the disk, eject it as you would any disk (Controlclick it and choose Eject, for example). Hang onto the .dmg disk image file itself, however. This is the file you'll need to double-click if you ever want to recreate your "simulated disk."

10.30.11.3. Turning an image into a CD

One of the other most common disk-image tasks is turning a disk image back into a CD or DVD—provided you have a CD or DVD burner on your Mac, of course.

All you have to do is drag the .dmg file into the Disk Utility window, select it, and click the Burn icon on the toolbar (or, alternatively, Control-click the .dmg icon and choose Burn from the shortcut menu). Insert a blank CD or DVD, and then click Burn.

10.30.12. Grab

Grab takes pictures of your Mac's screen, for use when you're writing up instructions, illustrating a computer book, or collecting proof of some secret screen you found buried in a game. You can take pictures of the entire screen (press [image] -Z, which for once in its life does not mean Undo) or capture only the contents of a rectangular selection (press Shift- [image] -A). When you're finished, Grab displays your snapshot in a new window, which you can print, close without saving, or save as a TIFF file, ready for emailing or inserting into a manuscript.

Now, as experienced Mac enthusiasts already know, the Mac OS has long had its own built-in shortcuts for capturing screenshots: Press Shift- [image] -3 to take a picture of the whole screen, and Shift- [image] -4 to capture a rectangular selection.

So why use Grab instead? In many cases, you shouldn't. The Shift- [image] -3 and Shift- [image] -4 shortcuts work like a dream. But there are some cases in which it might make more sense to opt for Grab. Here are three:

  • Grab can make a timed screen capture (choose Capture rightwards double arrow Timed Screen, or press Shift- [image] -Z), which lets you enjoy a 10-second delay be fore the screen shot is actually taken. After you click the Start Timer button, you have an opportunity to activate windows, pull down menus, drag items around, and otherwise set up the shot before Grab shoots the picture.

  • When you capture a screenshot using Grab's Selection command, the size of your selection is displayed, in pixels, right under the pointer as you drag. If you need to capture a 256-pixel-wide square, for example, you can do so with pinpoint accuracy. (Choose Edit rightwards double arrow Inspector to read the dimensions of a screenshot after you capture it.)

  • With Grab, you have the option of including the cursor in the picture, which is extremely useful when you're showing a menu being pulled down or a button being clicked. (Mac OS X's screenshot keystrokes, by contrast, always eliminate the pointer.) Use the technique described in Figure 10-30 to add the pointer style of your choice to a Grab screenshot.

Tip: Actually, if you're going to write a book or manual about Mac OS X, the program you really need is Snapz Pro X; a trial version is available from this book's "Missing CD" at www.missingmanuals.com, among other places. It offers far more flexibility than any of Mac OS X's own screenshot features. For example, you have a choice of file format, you can neatly snip out just one dialog box or window with a single click, and you can even capture movies of screen activity.

Figure 10-30. Unlike the Shift- -3 or Shift- -4 keystrokes, Grab lets you include the pointer/cursor in the picture—or hide it. Choose Grab rightwards double arrow Preferences and pick one of the eight different pointer styles, or choose to keep the pointer hidden by activating the blank button in the upper-left corner.

10.30.13. Grapher

Yes, kids, it's the next episode of Apple's on-again, off-again love affair with the graphing calculator! Now you, too, can create 2-D or 3-D graphs of staggering beauty and complexity.

But seriously, folks. This equation grapher is an amazing piece of work.

When you first open Grapher, you're asked to choose what kind of virtual "graph paper" you want: two-dimensional (standard, polar, logarithmic) or three-dimensional (cubic, spherical, cylindrical). Click a name to see a preview; when you're happy with the selection, click Open.

Now the main Grapher window appears (Figure 10-31). Do yourself a favor. Spend a few wow-inducing minutes choosing canned equations from the Examples menu, and watching how Grapher whips up gorgeous, colorful, sometimes animated graphs on the fly.

Figure 10-31. In general, you type equations into Grapher just as you would on paper (like z=2xy). If in doubt, check the online help, which offers enough hints on functions, constants, differential equations, series, and periodic equations to keep the A Beautiful Mind guy busy for days.

When you're ready to plug in an equation of your own, type it into the text box at the top of the window. If you're not such a math hotshot, or you're not sure of the equation format, work from the canned equations and mathematical building blocks that appear when you choose Equation rightwards double arrow New Equation from Template or Window rightwards double arrow Show Equation Palette (a floating window containing a huge selection of math symbols and constants).

Tip: If you don't know the keystroke that produces a mathematical symbol like pi or theta, you can just type the word pi or theta. Grapher replaces it with the correct symbol automatically.

Once the graph is up on the screen, you can tailor it like this:

  • To move a 2-D graph in the window, choose View rightwards double arrow Move Tool and then drag; to move a 3-D graph, [image] -drag it.

  • To rotate a 3-D graph, drag in any direction. If you add the Option key, you flip the graph around only one axis.

  • To change the colors, line thicknesses, 3-D "walls," and other graphic elements, click the I button (or choose Window rightwards double arrow Show Inspector) to open the formatting palette. The controls you find here vary by graph type, but rest assured that Grapher can accommodate your every visual whim.

  • To change the fonts and sizes, choose Grapher rightwards double arrow Preferences. On the Equations panel, the four sliders let you specify the relative sizes of the text elements. If you click the sample equation, the Font panel appears (Section 14.7.3), so you can fiddle with the type.

  • Add your own captions, arrows, ovals, or rectangles using the Object menu.

When it's all over, you can preserve your masterpiece using any of these techniques:

  • Export a graphic by choosing File rightwards double arrow Export.

  • Copy an equation to the Clipboard by Control-clicking it and choosing Copy As rightwards double arrow TIFF (or EPS, or whatever) from the shortcut menu. Now you can paste it into another program.

    POWER USERS' CLINIC
    For Mathematicians (and Physicists, Scientists, and Students) Only

    If you're into math, science, or studying math or science, Grapher is a tremendous addition to Mac OS X. There's a whole lot to it—but if you're just getting started, here are a few features not to miss:

    • You can calculate values, intercepts, derivatives, and integrals (even indefinite integrals) by using the Equation rightwards double arrow Evaluation and Equation rightwards double arrow Integration commands.

    • Some useful ready-made equation components await in the pop-up button at the right side of the equation text box. Using the Sum and Product symbols, for example, you can quickly calculate summations and products.

    • That same pop-up menu can help you generate piecewise, parametric, and other specialized kinds of graphs (this means you, math students).

  • Export an animated graph by choosing Equation rightwards double arrow Create Animation. The resulting dialog box lets you specify how long you want the movie to last (and a lot of other parameters).

Tip: If you Shift-drag the starting or ending images at the bottom, you can change their size.

Finally, click Create Animation. After a moment, the finished movie appears. If you like it the way it is, choose File rightwards double arrow Save As to preserve it on your hard drive for future generations.

10.30.14. Java

Programmers generally use the Java programming language to create small programs that they then embed into Web pages—animated effects, clocks, calculators, stock tickers, and so on. Your browser automatically downloads and runs such applets (assuming that you have "Enable Java" turned on in your browser).

Your Java folder contains several Java-related tools, which exist primarily for the benefit of Web programmers and Web programs (including Safari).

10.30.15. Keychain Access

Keychain Access memorizes and stores all your secret information—passwords for network access, file servers, FTP sites, Web pages, and other secure items. For instructions on using Keychain Access, see Chapter 12.

10.30.16. Migration Assistant

This little cutie automates the transfer of all your stuff from one Mac to another—your Home folder, network settings, programs, and more. This comes in extremely handy when you buy a newer, better Mac—or when you need Time Machine to recover an entire dead Mac's worth of data. (It can also copy everything over from a secondary hard drive or partition.)

The instructions on the screen guide you through the process (see Section A.7).

10.30.17. Network Utility

The Network Utility gathers information about Web sites and network citizens. It offers a suite of standard Internet tools like NetStat, Ping, Traceroute, Finger, and Whois—advanced tools, to be sure, but ones that even Mac novices may be asked to fire up when calling a technician for Internet help.

FREQUENTLY ASKED QUESTIONS
Key Caps: Missing In Action?

Hey, where's Key Caps!? I used to use this program all the time to figure out how to type special symbols (like ¢) with hidden key combinations (like Option-4). Now it's not even there anymore!

Well, that's not quite true. It's now called Keyboard Viewer. You get to it via System Preferences rightwards double arrow International rightwards double arrow Input Menu.

Section 9.13.3.1 tells all.

Otherwise, you probably won't need to use Network Utility to get your work done. However, Network Utility can be useful when you're performing Internet detective work.

  • Whois ("who is") can gather an amazing amount of information about the owners of any particular domain (such as www.apple.com)—including name and address info, telephone numbers, and administrative contacts. It uses the technique shown in Figure 10-32.

    Figure 10-32. The Whois tool is a powerful part of Network Utility. First enter a domain that you want information about, then choose a Whois server from the pop-up menu (you might try whois. networksolutions. com). When you click the Whois button, you get a surprisingly revealing report about the owner of the domain, including phone numbers, fax numbers, contact names, and so on.

  • Use Ping to enter a Web address (such as www.google.com), and then "ping" (send out a "sonar" signal to) the server to see how long it takes for it to respond to your request. Network Utility reports the response time in milliseconds—a useful test when you're trying to see if a remote server (a Web site, for example) is up and running. (The time it takes for the ping to report back to you also tells you how busy that server is.)

  • Traceroute lets you track how many "hops" are required for your Mac to communicate with a certain Web server. Just type in the network address or URL, and then click Trace. You'll see that your request actually jumps from one trunk of the Internet to another, from router to router, as it makes its way to its destination. You'll learn that a message sometimes crisscrosses the entire country before it arrives at its destination. You can also see how long each leg of the journey took, in milliseconds.

10.30.18. ODBC Administrator

This program is designed to arbitrate ODBC access requests. Any questions?

If you have no idea what that means, and no corporate system administrator has sat down to explain it to you, then your daily work probably doesn't involve working with corporate ODBC (Open Database Connectivity) databases. You can ignore this program or throw it away.

10.30.19. Podcast Capture

This program is a front end for Podcast Producer, a professional-league podcast recording and publishing program that's part of Apple's Mac OS X Server software suite. Unless you work in an office where a Mac OS X Server hums away in a back room, you can toss this program.

10.30.20. RAID Utility

Another program you probably don't need. It's useful only if your office has Mac OS X Server, and only if your Mac has a RAID (multiple-disk system) card installed.

10.30.21. System Profiler

System Profiler (once called Apple System Profiler) is a great tool for learning exactly what's installed on your Mac and what's not—in terms of both hardware and software. The people who answer the phones on Apple's tech-support line are particularly fond of System Profiler, since the detailed information it reports can be very useful for troubleshooting nasty problems.

There are now three ways to open System Profiler:

  • Slow. Burrow into your Applications rightwards double arrow Utilities folder; double-click System Profiler.

  • Medium. Choose [image] rightwards double arrow About This Mac. In the resulting dialog box, click More Info.

    Tip: If you click your Mac OS X version number twice in the About box, you get to see your Mac's serial number!

  • Fast. Hold down the Option key, which makes the [image] rightwards double arrow About This Mac command change to say System Profiler. Choose it.

When you launch System Profiler, it reports information about your Mac in a list down the left side (Figure 10-33).

They fall into these categories:

  • Hardware. Click this word to see precisely which model Mac you have, what kind of chip is inside (and how many), how much memory it has, and its serial number.

    If you expand the flippy triangle, you get to see details about which Memory slots are filled and the size of the memory module in each slot; what kind of Disc Burning your Mac can do (DVD-R, DVD+R, and so on); what PCI Cards are installed in your expansion slots; what Graphics/Displays circuitry you have (graphics card and monitor); what's attached to your ATA bus (internal drives, like your DVD drive and hard drive); what's connected to your SCSI, USB, and FireWire chains, if anything; and much more.

    Figure 10-33. Does your Mac-Book's chip run at 2 Ghz or 2.6? What percentage of your external hard drive is filled up? Want a comprehensive list of every program installed on your Mac, with version numbers? Can your DVD burner burn dual-layer discs? And (shown here): Does your laptop have any open slots for extra RAM?

  • Network. This section reveals details on your AirPort Card (if you have one), what Modems you have, what Internet connection Locations you've established (Section 18.5.1), and so on.

  • Software. Click this heading to see exactly which version of Mac OS X you have, and what your computer's name is, as far as the network is concerned ("Chris's Computer," for example).

    The Applications list documents every program on your system, with version information—a quick inventory of what you've installed on your Mac. It's useful for spotting duplicate copies of programs.

    Tip: The right-hand column of the Applications list identifies each program as being Universal or PowerPC (or, in rare cases, Intel). (A Universal program can run natively—at full speed—on either Intel-based Macs or earlier models; a PowerPC program runs natively on older Macs, but somewhat slower on Intel Macs because it has to go through the Rosetta translator described on Section 5.10.7). This list is a handy summary of which programs have been updated for the Intel generation.

    Similar information shows up in the Extensions panel. In this sense, "extensions" doesn't mean system extensions like those that made life a living hell in Mac OS 9 and earlier. In Mac OS X, the term extensions refers to a different kind of addon component to the core system software. Generally, these are drivers for the Mac's various components, which sit in the System rightwards double arrow Library rightwards double arrow Extensions folder. Whatever's in that folder is what you see listed in this panel.

    Other categories include self-explanatory lists like Fonts, Preference Panes, and Startup Items.

    Finally, the Logs panel reveals your Mac's secret diary: a record of the traumatic events that it experiences from day to day. (Many of these are the same as those revealed by the Console utility; see Section 10.30.7.) Some reveal crash logs, which are detailed technical descriptions of what went wrong when various programs crashed, and what was stored in memory at the time.

    POWER USERS' CLINIC
    The Xcode Tools

    The Leopard DVD includes a special batch of programs, known as the Xcode Tools, primarily for developers (programmers) who write Mac OS X software. You'll need some of these programs if you want to get into some of the more esoteric (or, as some would say, fun) Mac OS X tricks and tips.

    To install these tools, open the Optional Installs rightwards double arrow Xcode Tools window on the DVD, and doubleclick XcodeTools. mpkg. After following the onscreen prompts, you wind up with a new folder called Developer on your hard drive. Its Applications rightwards double arrow Utilities folder contains a few programs that are user-friendly enough even for nonprogrammers.

    CrashReporterPrefs, for example, lets you tell Mac OS X when to display the "Application Unexpectedly Quit" dialog box. If you choose Server, you'll never see one of those annoying dialog boxes again—perfect if you have a program that just won't stop crashing.

    Also, if you open Developer rightwards double arrow Applications rightwards double arrow Graphics Tools, you'll find Quartz Composer Visualizer. This program lets you build screen savers, animations, and tons of other graphical goodies without writing a single line of code.

    Finally, don't miss Core Image Fun House (also in Developer rightwards double arrow Applications rightwards double arrow Graphics Tools). It's intended to be a showcase for Mac OS X's Core Image technologies, which constitute a ready-to-use photo-transformation toolkit that software companies can build into their programs. Fun House lets you apply dozens of mindblowing visual effects to your images and movies—distortions, color corrections, solar flares, and so on—with nothing more than a few clicks. (If your Mac is fast enough, you can even adjust filters in real time, so you can see the result of your modifications as you make them.) One possibility is shown here.

    When you're done psychedelicizing your image, you can export it to a standard JPEG or TIFF image by choosing File rightwards double arrow Save As. From there, you can show it off on a Web site, email it to your friends, or make it your desktop background.

    Unfortunately, there's not much plain English here to help you understand the crash, or how to avoid it in the future. Most of it runs along the lines of "Exception: EXC_BAD_ACCESS (0x0001); Codes: KERN_INVALID_ADDRESS (0x0001) at 0x2f6b657d." In other words, it's primarily for the benefit of programmers. Still, tech-support staff may occasionally ask to see the information in one of these logs.

Tip: If any of these screens is showing you more or less technical information than you'd like, use the View menu to choose Mini Profile, Basic Profile, or Full Profile.
10.30.21.1. Saving a report

To create a handsomely formatted report that you can print or save, choose File rightwards double arrow Save, and then choose Rich Text Format from the File Format pop-up menu. Note, however, that the resulting report can be well over 100 pages long. In many cases, you're better off simply making a screenshot of the relevant Profiler screen, as described on Section 14.10, or saving the thing as a PDF file (Section 14.2.2).

10.30.22. Terminal

Terminal opens a terminal window with a command line interface, taking you deep into the world of Unix, the operating system on which Mac OS X is based. Chapters Chapter 16 and Chapter 17 offer a crash course on this powerful window into the Mac's shadow operating system.

10.30.23. VoiceOver Utility

For details on this screen-reader software, see Section 15.5.1.3.

10.30.24. X11

Deep inside Mac OS X beats the heart of Unix, the industrial-strength operating system that drives many a corporation (and thrills many a programmer geek). X11 is a version of the X Window System, a software suite that gives Unix programs a face—makes them appear in actual windows. Some details are in Chapter 17, and many more are at http://developer.apple.com/opensource/tools/X11.html.


cds_dvds_and_itunes.html

Chapter 11. CDs, DVDs, and iTunes

How the Mac Does Disks

Burning CDs and DVDs

iTunes: The Digital Jukebox

DVD Movies

11.1. How the Mac Does Disks

Apple shocked the world when, in 1998, it introduced the iMac without a floppy disk drive—and proceeded to eliminate the floppy drive from all subsequent Mac models in the following years. Apple argued that the floppy disk was dead: It was too small to serve as a backup disk, and, in the Internet age, it was a redundant method of exchanging files with other computers.

These days, even Windows PC manufacturers have left the floppy drive for dead. Joining it in the great CompUSA in the sky: Zip disks, Jaz disks, SyQuest disks, SuperDisks, Peerless disks…

11.1.1. Disks Today

So what's springing up to take the floppy's place? Let us count the disks:

11.1.1.1. Hard drives and the iPod

Thanks to the Mac's FireWire or USB jacks, it's easier than ever to attach an external hard drive for extra storage. It would be hard to imagine a more convenient second hard drive than, for example, Apple's iPod. Most models are not only outstanding MP3 music players but also double as self-powered, extremely compact, bootable hard drives.

11.1.1.2. CDs, DVDs

You wouldn't get far in today's computer world without a CD/DVD drive. Most commercial software comes on a CD or DVD—not to mention the music CDs that the Mac can play so expertly.

CD-ROM stands for "compact disc, read-only memory"—in other words, you can't freely add and delete files from one, as you can from a hard drive.

But your Mac can also record onto blank CDs, of course, and probably blank DVDs too, thanks to a built-in CD/DVD burner. A burner can record onto either of two kinds of blank discs:

  • CD-R (or DVD-R). You can fill this type of disc with your own files—once. (The R stands for recordable.) The disc can't be erased, although you can add to it (see Section 10.30.9).

  • CD-RW (or DVD-RW).The initials stand for rewritable; using Disk Utility (Section 10.23.1.4), you can erase one of these discs and rerecord it, over and over again. Of course, CD-RW and DVD-RW blank discs are somewhat more expensive than the one-shot kind.

The standard Mac CD/DVD drive can also play DVD movies that you've rented or bought, but you may also occasionally use it for data DVDs—that is, DVDs that contain Mac files or software installers.

Most Leopard-capable Macs contain what Apple calls the Super Drive: a drive, actually made by a company like Pioneer or Matsushita, that can play and record DVDs (and CDs, too). A SuperDrive means that you can use blank DVDs as massive backup disks that hold 4.7 GB or 8.5 GB each. (That's 4.7 gigs for regular blank DVDs, and 8.5 gigs on the newer, more expensive dual-layer blanks. Not all Macs recognize dual-layer DVDs, though. Check your copy of System Profiler, as described on Section 10.30.19.)

If you've used iMovie to edit your home camcorder footage, you can also save them onto one of these DVDs for playback in standard home DVD players—the perfect way to distribute your masterpiece to friends and family with spectacular quality.

The first generations of SuperDrive could record only onto so-called DVD-R and DVD-RW blank discs (note the hyphen).The latest SuperDrives, found in, for example, the Power Mac G5, can also record your files onto DVD+R and DVD+RW discs (note the plus sign), which have dangerously similar names but very different formatting.

11.1.1.3. Flash drives

The most recent invention is among the most convenient: tiny, keychain-sized flash drives or thumb drives, which plug directly into your USB jack and serve as low-capacity hard drives with no moving parts. Inside, they contain nothing but RAM—pure memory.

Flash drives are fantastic, inexpensive gadgets that typically hold between 128 megabytes and 64 gigabytes. They work on any Mac or Windows PC, and don't require any drivers or special software installation. Ask for one for your birthday.

11.1.2. Disks In, Disks Out

When you insert a disk, its icon shows up in three places (unless you've changed your Finder preferences): on the right side of the screen, in the Computer window, and in the Sidebar (Section 1.2). To see what's on a disk you've inserted, double-click its icon.

Note: You can make the Mac work like Windows, if you choose. For example, to open a single window containing icons of all currently inserted disks, choose Go rightwards double arrow Computer (which produces the rough equivalent of the My Computer window).To complete the illusion that you're running Windows, you can even tell Mac OS X not to put disk icons on the desktop at all. Just choose Finder rightwards double arrow Preferences, click General, and turn off the four top checkboxes—"Hard disks," "External disks," "CDs, DVDs, and iPods," and "Connected servers." They'll no longer appear on the desktop—only in your Computer window. (You can stop them from appearing in the Sidebar, too, by clicking the Sidebar button in the Finder preferences and turning off the same checkboxes.)

Figure 11-1. You may see all kinds of disks on the Mac OS X desktop (shown here:hard drive, CD, iPod, iDisk)—or none at all, if you've chosen to hide them using the Finder rightwards double arrow Preferences command. But chances are pretty good you won't be seeing many floppy disk icons.

To remove a disk from your Mac, use one of these methods:

  • Hold down the Eject key on your keyboard. Mac keyboards, both on laptops and desktops, have a special Eject key ( [image] ), usually in the upper-right corner. Hold it down for a moment to make a CD or DVD pop out. (If you don't have an Eject key, hold down F12 instead.)

  • Drag its icon onto the Trash icon. For years, this technique has confused and frightened first-time Mac users. Their typical reaction: Doesn't the Trash mean "delete"? Yes, but only when you drag file or folder icons there—not disk icons. Dragging a disk icon into the Trash (at the end of the Dock) makes the Mac spit the disk out. (If you've dragged a disk image icon or the icon of a networked disk, this maneuver unmounts them—that is, gets them off your screen.)

    The instant you begin dragging a disk icon, the Trash icon on the Dock changes form, as though to reassure the novice that dragging a disk icon there will only eject the disk. As you drag, the wastebasket icon morphs into a giant-sized [image] logo.

  • Highlight the disk icon, and then choose File rightwards double arrow Eject (or press [image] -E). The disk pops out.

  • Control-click (or right-click) the disk icon. Choose Eject from the shortcut menu.

  • Use the Sidebar. Click the [image] button next to a disk's name in the Sidebar.

    Tip: Any of these techniques also work to get network disks and disk images off your screen.

11.1.3. Startup Disks

When you turn the Mac on, it hunts for a startup disk—that is, a disk containing a System folder. If you've ever seen the dispiriting blinking folder icon on a Mac's screen, you know what happens when the Mac can't find a startup disk. It blinks like that forever, or until you find and insert a disk with a viable System folder on it.

FREQUENTLY ASKED QUESTION
The Eject Button That Doesn't

When I push the [image] key on my keyboard (or the Eject button on my CD-ROM drawer), howcome the CD doesn't come out?

There might be three things going on. First of all, some file on the disc might be open—that is, in use by one of your programs. You're not allowed to eject the disc until that file is closed.

Second, to prevent accidental pushings, the Eject key on the modern Mac keyboard is designed to work only when you hold it down steadily for a second or two. Just tapping it doesn't work.

Third, remember that once you've inserted a disk, the Mac won't let go unless you eject it in one of the official ways.

On Mac models with a CD tray (drawer), pushing the button on the CD-ROM door opens the drawer only when it's empty. If there's a disc in it, you can push that button till doomsday, but the Mac will simply ignore you.

That behavior especially confuses people who are used to working with Windows. (On a Windows PC, pushing the CD button does indeed eject the disc.) But on the Mac, pushing the CD-door button ejects an inserted disc only when the disc wasn't seated properly, or the Mac couldn't read the disc for some other reason, and the disc's icon never appeared onscreen.

The Eject key on the modern Mac keyboard, however, isn't so fussy. It pops out whatever CD or DVD is in the drive.

Oh—and if a CD or DVD won't come out at all (and its icon doesn't show up on the desktop), restart the Mac. Keep the mouse button pressed as the Mac restarts to make the disc pop out.

And if even that technique doesn't work, look for a tiny pinhole in or around the slot. Inserting a straightened paper clip, slowly and firmly, will also make the disc pop out.

11.1.3.1. Creating a startup disk

By installing the Mac OS onto a disk—be it a hard drive or a DVD—you can create a startup disk. Not all disks are capable of starting up the Mac, but any Leopard Mac can start up from an external FireWire hard drive.

11.1.3.2. Selecting a startup disk

It's perfectly possible to have more than one startup disk simultaneously attached to your Mac. That's the deal, for example, whenever you've inserted the Mac OS X DVD into your Mac: Both your main hard drive and the DVD contain a System folder, and each is a startup disk. Some veteran Mac fans deliberately create other startup disks— using iPods, for example—so that they can easily start the Mac up from a backup disk, or from a different version of the OS.

Only one System folder can be operational at a time. So how does the Mac know which to use as its startup disk? You make your selection in the Startup Disk pane of System Preferences (Figure 11-2).

Tip: If you're in a hurry to start the machine up from a different disk, just click the disk icon and then click Restart in the System Preferences window. You don't have to close the System Preferences window first.

Figure 11-2. In the Startup Disk pane of System Preferences, the currently selected disk—the one that will be "in force" the next time the machine starts up—is always highlighted. You also see the System folder's version, the name of the drive it's on, and its actual name.

11.1.4. Erasing a Disk

Mac OS X doesn't have an Erase Disk command at the desktop. When you want to erase a disk (such as a DVD-RW disc), the only tool Apple gives you is Disk Utility, which sits in your Applications rightwards double arrow Utilities folder. This is the same program you use to erase, repair, or subdivide (partition) a hard drive.

Once you've opened Disk Utility, click the name of the disk (in the left-side list), click the Erase tab, and then click the Erase button.

You won't be able to do so, though, if:

  • The disk is a standard CD-ROM, DVD, a previously recorded CD-R disc, or a disk elsewhere on the network.

  • You're trying to erase the startup disk. You can't wipe out the disk that contains the currently running System folder any more than you can paint the floor directly beneath your feet. (To erase your built-in hard drive, for example, you must start up from the Mac OS X DVD.)


how_the_mac_does_disks.html

Chapter 11. CDs, DVDs, and iTunes

How the Mac Does Disks

Burning CDs and DVDs

iTunes: The Digital Jukebox

DVD Movies

11.1. How the Mac Does Disks

Apple shocked the world when, in 1998, it introduced the iMac without a floppy disk drive—and proceeded to eliminate the floppy drive from all subsequent Mac models in the following years. Apple argued that the floppy disk was dead: It was too small to serve as a backup disk, and, in the Internet age, it was a redundant method of exchanging files with other computers.

These days, even Windows PC manufacturers have left the floppy drive for dead. Joining it in the great CompUSA in the sky: Zip disks, Jaz disks, SyQuest disks, SuperDisks, Peerless disks…

11.1.1. Disks Today

So what's springing up to take the floppy's place? Let us count the disks:

11.1.1.1. Hard drives and the iPod

Thanks to the Mac's FireWire or USB jacks, it's easier than ever to attach an external hard drive for extra storage. It would be hard to imagine a more convenient second hard drive than, for example, Apple's iPod. Most models are not only outstanding MP3 music players but also double as self-powered, extremely compact, bootable hard drives.

11.1.1.2. CDs, DVDs

You wouldn't get far in today's computer world without a CD/DVD drive. Most commercial software comes on a CD or DVD—not to mention the music CDs that the Mac can play so expertly.

CD-ROM stands for "compact disc, read-only memory"—in other words, you can't freely add and delete files from one, as you can from a hard drive.

But your Mac can also record onto blank CDs, of course, and probably blank DVDs too, thanks to a built-in CD/DVD burner. A burner can record onto either of two kinds of blank discs:

  • CD-R (or DVD-R). You can fill this type of disc with your own files—once. (The R stands for recordable.) The disc can't be erased, although you can add to it (see Section 10.30.9).

  • CD-RW (or DVD-RW).The initials stand for rewritable; using Disk Utility (Section 10.23.1.4), you can erase one of these discs and rerecord it, over and over again. Of course, CD-RW and DVD-RW blank discs are somewhat more expensive than the one-shot kind.

The standard Mac CD/DVD drive can also play DVD movies that you've rented or bought, but you may also occasionally use it for data DVDs—that is, DVDs that contain Mac files or software installers.

Most Leopard-capable Macs contain what Apple calls the Super Drive: a drive, actually made by a company like Pioneer or Matsushita, that can play and record DVDs (and CDs, too). A SuperDrive means that you can use blank DVDs as massive backup disks that hold 4.7 GB or 8.5 GB each. (That's 4.7 gigs for regular blank DVDs, and 8.5 gigs on the newer, more expensive dual-layer blanks. Not all Macs recognize dual-layer DVDs, though. Check your copy of System Profiler, as described on Section 10.30.19.)

If you've used iMovie to edit your home camcorder footage, you can also save them onto one of these DVDs for playback in standard home DVD players—the perfect way to distribute your masterpiece to friends and family with spectacular quality.

The first generations of SuperDrive could record only onto so-called DVD-R and DVD-RW blank discs (note the hyphen).The latest SuperDrives, found in, for example, the Power Mac G5, can also record your files onto DVD+R and DVD+RW discs (note the plus sign), which have dangerously similar names but very different formatting.

11.1.1.3. Flash drives

The most recent invention is among the most convenient: tiny, keychain-sized flash drives or thumb drives, which plug directly into your USB jack and serve as low-capacity hard drives with no moving parts. Inside, they contain nothing but RAM—pure memory.

Flash drives are fantastic, inexpensive gadgets that typically hold between 128 megabytes and 64 gigabytes. They work on any Mac or Windows PC, and don't require any drivers or special software installation. Ask for one for your birthday.

11.1.2. Disks In, Disks Out

When you insert a disk, its icon shows up in three places (unless you've changed your Finder preferences): on the right side of the screen, in the Computer window, and in the Sidebar (Section 1.2). To see what's on a disk you've inserted, double-click its icon.

Note: You can make the Mac work like Windows, if you choose. For example, to open a single window containing icons of all currently inserted disks, choose Go rightwards double arrow Computer (which produces the rough equivalent of the My Computer window).To complete the illusion that you're running Windows, you can even tell Mac OS X not to put disk icons on the desktop at all. Just choose Finder rightwards double arrow Preferences, click General, and turn off the four top checkboxes—"Hard disks," "External disks," "CDs, DVDs, and iPods," and "Connected servers." They'll no longer appear on the desktop—only in your Computer window. (You can stop them from appearing in the Sidebar, too, by clicking the Sidebar button in the Finder preferences and turning off the same checkboxes.)

Figure 11-1. You may see all kinds of disks on the Mac OS X desktop (shown here:hard drive, CD, iPod, iDisk)—or none at all, if you've chosen to hide them using the Finder rightwards double arrow Preferences command. But chances are pretty good you won't be seeing many floppy disk icons.

To remove a disk from your Mac, use one of these methods:

  • Hold down the Eject key on your keyboard. Mac keyboards, both on laptops and desktops, have a special Eject key ( [image] ), usually in the upper-right corner. Hold it down for a moment to make a CD or DVD pop out. (If you don't have an Eject key, hold down F12 instead.)

  • Drag its icon onto the Trash icon. For years, this technique has confused and frightened first-time Mac users. Their typical reaction: Doesn't the Trash mean "delete"? Yes, but only when you drag file or folder icons there—not disk icons. Dragging a disk icon into the Trash (at the end of the Dock) makes the Mac spit the disk out. (If you've dragged a disk image icon or the icon of a networked disk, this maneuver unmounts them—that is, gets them off your screen.)

    The instant you begin dragging a disk icon, the Trash icon on the Dock changes form, as though to reassure the novice that dragging a disk icon there will only eject the disk. As you drag, the wastebasket icon morphs into a giant-sized [image] logo.

  • Highlight the disk icon, and then choose File rightwards double arrow Eject (or press [image] -E). The disk pops out.

  • Control-click (or right-click) the disk icon. Choose Eject from the shortcut menu.

  • Use the Sidebar. Click the [image] button next to a disk's name in the Sidebar.

    Tip: Any of these techniques also work to get network disks and disk images off your screen.

11.1.3. Startup Disks

When you turn the Mac on, it hunts for a startup disk—that is, a disk containing a System folder. If you've ever seen the dispiriting blinking folder icon on a Mac's screen, you know what happens when the Mac can't find a startup disk. It blinks like that forever, or until you find and insert a disk with a viable System folder on it.

FREQUENTLY ASKED QUESTION
The Eject Button That Doesn't

When I push the [image] key on my keyboard (or the Eject button on my CD-ROM drawer), howcome the CD doesn't come out?

There might be three things going on. First of all, some file on the disc might be open—that is, in use by one of your programs. You're not allowed to eject the disc until that file is closed.

Second, to prevent accidental pushings, the Eject key on the modern Mac keyboard is designed to work only when you hold it down steadily for a second or two. Just tapping it doesn't work.

Third, remember that once you've inserted a disk, the Mac won't let go unless you eject it in one of the official ways.

On Mac models with a CD tray (drawer), pushing the button on the CD-ROM door opens the drawer only when it's empty. If there's a disc in it, you can push that button till doomsday, but the Mac will simply ignore you.

That behavior especially confuses people who are used to working with Windows. (On a Windows PC, pushing the CD button does indeed eject the disc.) But on the Mac, pushing the CD-door button ejects an inserted disc only when the disc wasn't seated properly, or the Mac couldn't read the disc for some other reason, and the disc's icon never appeared onscreen.

The Eject key on the modern Mac keyboard, however, isn't so fussy. It pops out whatever CD or DVD is in the drive.

Oh—and if a CD or DVD won't come out at all (and its icon doesn't show up on the desktop), restart the Mac. Keep the mouse button pressed as the Mac restarts to make the disc pop out.

And if even that technique doesn't work, look for a tiny pinhole in or around the slot. Inserting a straightened paper clip, slowly and firmly, will also make the disc pop out.

11.1.3.1. Creating a startup disk

By installing the Mac OS onto a disk—be it a hard drive or a DVD—you can create a startup disk. Not all disks are capable of starting up the Mac, but any Leopard Mac can start up from an external FireWire hard drive.

11.1.3.2. Selecting a startup disk

It's perfectly possible to have more than one startup disk simultaneously attached to your Mac. That's the deal, for example, whenever you've inserted the Mac OS X DVD into your Mac: Both your main hard drive and the DVD contain a System folder, and each is a startup disk. Some veteran Mac fans deliberately create other startup disks— using iPods, for example—so that they can easily start the Mac up from a backup disk, or from a different version of the OS.

Only one System folder can be operational at a time. So how does the Mac know which to use as its startup disk? You make your selection in the Startup Disk pane of System Preferences (Figure 11-2).

Tip: If you're in a hurry to start the machine up from a different disk, just click the disk icon and then click Restart in the System Preferences window. You don't have to close the System Preferences window first.

Figure 11-2. In the Startup Disk pane of System Preferences, the currently selected disk—the one that will be "in force" the next time the machine starts up—is always highlighted. You also see the System folder's version, the name of the drive it's on, and its actual name.

11.1.4. Erasing a Disk

Mac OS X doesn't have an Erase Disk command at the desktop. When you want to erase a disk (such as a DVD-RW disc), the only tool Apple gives you is Disk Utility, which sits in your Applications rightwards double arrow Utilities folder. This is the same program you use to erase, repair, or subdivide (partition) a hard drive.

Once you've opened Disk Utility, click the name of the disk (in the left-side list), click the Erase tab, and then click the Erase button.

You won't be able to do so, though, if:

  • The disk is a standard CD-ROM, DVD, a previously recorded CD-R disc, or a disk elsewhere on the network.

  • You're trying to erase the startup disk. You can't wipe out the disk that contains the currently running System folder any more than you can paint the floor directly beneath your feet. (To erase your built-in hard drive, for example, you must start up from the Mac OS X DVD.)


burning_cds_and_dvds.html

11.2. Burning CDs and DVDs

Who misses the floppy drive anymore? A blank CD holds at least 450 times as many files, and a blank DVD holds about 3,250 times as many!

You can buy blank CDs incredibly cheaply in bulk—$20for100discs, for example—via the Web. (To find the best prices, visit www.shopper.com or www.buy.com and search for blank CD-R.) Blank DVDs are only slightly more expensive—about $30 for 100.

Burning a CD or DVD is great for backing stuff up, transferring stuff to another computer (even a Windows PC), mailing to somebody, or offloading (archiving) older files to free up hard drive space.

You can burn a disc in either of two ways: with the blank disc inserted or without.

11.2.1. Burn Folders: Without the Disc

The burn folder is a special folder that you fill up by dragging file and folder icons to it. Then, when you're ready to burn, you just insert the blank disc and go.

UP TO SPEED
Mac OS Extended Formatting

Whether you use Disk Utility to erase a disk (or when you first install Mac OS X and elect to erase the hard drive in the process), you'll be confronted with a choice between formatting options called Mac OS Extended and UNIX File System (UFS). (Depending on the kind of disk, you may also see an option to create a DOS-formatted disk for use in Windows machines.)

Mac OS Extended or Mac OS Extended (Journaled) refers to the HFS Plus filing system, a disk format that has been proudly maximizing disk space for Mac fans since Mac OS 8.1. (For a definition of journaling, see Section A.6.)

Mac OS X still accepts disks that were prepared using the older, Mac OS Standard formatting—the ancient HFS (hierarchical filing system) format—but you can't use one as your startup disk, and any file names longer than 31 characters will appear chopped-off.

As for the UNIX File System option, it's exclusively for use on computers that run Unix (the pure variety, not the dressed-up version that is Mac OS X).

The burn-folder concept has a lot going for it:

  • No wasted hard drive space. Using the old system of burning discs, you inserted the blank and then dragged files and folders onto its icon. The Mac duplicated each item, parking it in an invisible, temporary holding area until you were ready to burn.

    Trouble is, you were therefore doubling the disk-space requirement of the files you intended to burn. If you were burning a DVD to get older files off your hard drive because you were running low on space, you found yourself with a Catch-22. You couldn't free up drive space without burning a DVD first—but you didn't have enough drive space to burn a DVD!

    If you use a burn folder instead, the Mac just sets aside aliases of the files and folders you want to burn. Aliases take up negligible hard drive space. When you finally burn the disc, the designated material is copied directly onto the CD or DVD.

  • Easy reuse. You can keep a burn folder on your desktop, prestocked with the folders you like to back up. Each time you burn a disc, you get the latest version of those folders' contents, and you're saved the effort of having to gather them each time.

  • Prepare ahead of time. You can get a CD or DVD ready to burn without having a blank disc on hand.

Here's how you use burn folders:

  1. Create a burn folder.

    To make a burn folder appear on your desktop, choose File rightwards double arrow New Burn Folder. To create one in any other window, Control-click (or right-click) a blank spot inside that window and, from the shortcut menu, choose New Burn Folder.

    Either way, a new folder appears, bearing the universal Mac radioactive "burn" symbol (Figure 11-3).

  2. Rename it.

    Its name is highlighted, so you can just start typing to rename it. Press Enter when you're finished.

  3. Load up the folder by dragging files and folders onto it.

    If you double-click the burn folder to open its window (Figure 11-3), you'll notice that you're not actually copying huge files. You're simply making a list of aliases.

    Tip: To check how many megabytes' worth of stuff you've added so far—so you don't overflow your CD or DVD—click the Burn button in the upper-right corner of the burn folder's window. The resulting message, shown at bottom in Figure 11-3, tells you the current total. (Hit the Enter key, or click Cancel, to close the dialog box.)

  4. Decorate the window, if you like.

    You can choose list view or icon view; you can drag the icons into an arrangement that you like; you can change the background color of the window; and so on. One nice feature of the Mac (which is not available on The Other OS) is that the look of a window is preserved when you burn it to CD.

  5. Click the Burn button in the upper-right corner of the window, or choose File rightwards double arrow Burn Disc.

    Figure 11-3. Top: A burn folder looks like any ordinary folder—except that it has that radioactive logo on it. You can drag files and folders right into its window; Mac OS X displays only aliases for now, but when you burn the disc, the actual files and folders will be there.
    If you open the burn folder, you find an unusual strip across the top. Its most important feature is the Burn button at the right.
    Bottom: Ready to proceed, Captain.

  6. Insert a blank disc.

    If you have a slot-loading Mac, slip the disc into the slot. If your Mac has a sliding CD/DVD tray instead, open it first by pressing the button on the tray, or pressing your [image] key for about one second.

    Tip: Once you've inserted a CD or DVD into your tray, you can close it either by pushing gently on the tray or by pressing the [image] key again.

    One last confirmation box appears, where you can name the disc and choose a burning speed for it.

  7. Click Burn (or press Enter).

    The Mac's laser proceeds to record the CD or DVD, which can take some time. Feel free to switch into another program and continue using your Mac. When it's all over, you have a freshly minted CD or DVD, whose files and folders you can open on any Mac or Windows PC.

11.2.2. Burn Folders: With a Blank Disc On Hand

If you have a blank disc ready to go, burn folders are even simpler to use. In fact, you may not even be aware that you're using them. The whole operation requires fewer steps—yet it still doesn't require the Mac to duplicate all the files you plan to burn.

Start by inserting a blank disc. After a moment, the Mac displays a dialog box asking, in effect, what you want to do with this blank disc (unless you've fiddled with your preference settings). See Figure 11-4 for instructions.

Figure 11-4. Top: Choose Open Finder if you plan to copy regular Mac files onto the CD or DVD, or Open iTunes if you plan to burn a music CD using iTunes. (Click "Make this action the default" if you figure you'll always answer this question the same way.) Click OK.
Drag the disc onto the Burn icon in the Dock, or choose File rightwards double arrow Burn Disc.
Bottom: Confirm your choice in this box.

If you choose Open Finder, you'll see the disc's icon appear on the desktop after a moment; its icon also appears in the Sidebar, complete with a round Burn symbol that looks like a radioactivity logo.

At this point, you can begin dragging files and folders onto the disc's icon, or (if you double-click the icon) into its window. You can add, remove, reorganize, and rename the files on it just as you would in any standard Finder window. All you're really doing is dragging aliases around; the real files are left untouched on your hard drive. You can also rename the CD or DVD itself just as you would a file or folder (Section 2.2).

Tip: The status bar at the bottom of the window gives you a running tally of the disk space you've filled up so far. (It may say, for example, "223.2 MB of 702.8 used on disc.") At last, you have an effortless way to exploit the blank disc's capacity with precision.

When the disk contains the files and folders you want to immortalize, do one of these things:

  • Choose File rightwards double arrow Burn Disc.

  • Click the Burn button next to the disc's name in the Sidebar.

  • Drag the disc's icon toward the Trash icon in the Dock. As soon as you begin to drag, the Trash icon turns into that yellow fallout-shelter logo. Drop the disc's icon onto it.

(For some reason, the Burn Disc command no longer appears in the shortcut menu when you Control-click or right-click the disc's icon—at least not in 10.5.1.)

In any case, the dialog box shown at bottom left in Figure 11-4 now appears. Click Burn. When the recording process is over, you'll have yourself a DVD or CD that works in any other Mac or PC.

Here are a few final notes on burning CDs and DVDs at the desktop:

  • Not sure what kinds ofdisks your Mac can burn? Open System Profiler (in your Applications rightwards double arrow Utilities folder). Expand the Hardware triangle, and click the Disc Burning category. There it is, plain as day: a list of the formats your machine can read and write (that is, burn). For example, you might see: "CD-Write: -R, -RW. DVD-Write: -R, -RW, +R, +RW."

  • In the Finder, you can only record an entire disc at once; you can't add any more files after the first burn. There is a trick, however, that lets you add more to a previously recorded CD-R or DVD-R if you use Disk Utility instead. (Technically, you create a multisession disc.) See the box on the facing page.

  • If you do a lot of disc burning, a full-fledged CD-burning program like Toast Titanium (www.roxio.com) adds myriad additional formatting options that let you make startup CDs, video CDs, and so on.

  • When you insert a CD-RW or DVD-RW disc that you've previously recorded, the box shown at top in Figure 11-4 doesn't appear. Instead, the disc's icon simply appears on the desktop as though it's an ordinary CD. Before you can copy new files onto it, you must erase it using Disk Utility as described in the previous section.

  • The discs that your Mac burns work equally well on Macs and Windows (or Linux) PCs. If you plan to insert a CD or DVD into a PC, however, remember that Windows doesn't permit certain symbols in a Windows file name (\ / : * ? " < > |). You'll run into trouble if any of your file names contain these symbols. In fact, you won't be able to open any folders on your disc that contain illegally named files.

GEM IN THE ROUGH
How to Burn a Multisession CD in Mac OS X

Most people think that once you've burned a CD-R or DVD-R disc, it's done. You can't burn more onto it.

In fact, though, you can use humble old Disk Utility, right there in your Applications rightwards double arrow Utilities folder, to burn a single disc as many times as you like. That's right—regular, cheapie CD-R discs, not CD-RW (rewritable). (All of this applies to DVD-Rs, too.)

What you'll create here is a multisession disc. Each time you burn more material onto it, you create a new disc icon that will appear separately when you insert the CD. Shown here at top, for example, is a disc that's been burned twice. A folder called Photo Rabbit was burned to the CD first. Then, a week later, a folder called "Brighter. pix" was burned onto the same disc, creating a second session (disc icon).

To pull off this stunt, prepare the material you intend to burn the first time. For example, put it all into a folder on your desktop.

Now open Disk Utility. Choose File rightwards double arrow New rightwards double arrow Disk Image from Folder. When prompted, navigate to, and select, the folder you want to burn, and then click Image.

Type a name for the disk image you're creating. Specify a location (like the Desktop) and then click Save. In this example, suppose it's called PhotoRabbit CD.dmg.

When you're ready to burn, open Disk Utility. Click the Burn icon on the toolbar. Navigate to, and click once, the disk image (PhotoRabbit CD.dmg).Then click Burn.

In the resulting Burn Disc dialog box, click the blue [image] button at the upper right. The dialog box expands, as shown here. Turn on "Leave disc appendable."Click Burn to record the material onto the CD.

When it comes time to add new material to that disc, repeat all of these steps so far. This time, in the dialog box shown above, you'll see that instead of Burn, the lower-right button now says Append. That's your clue that Disk Utility understands what it's about to do: add information to an existing CD, resulting in a second disk icon on the desktop containing only the new material.

You've just created a multisession disc!

You can repeat the process over and over again, adding more and more material to a disc—or at least until it's just about full.


itunes_the_digital_jukebox.html

11.3. iTunes: The Digital Jukebox

iTunes, in your Applications folder, is the ultimate software jukebox (Figure 11-5). It can play music CDs, tune in to Internet radio stations, load up your iPod music player or iPhone, and play back digital sound files (including the Internet's favorite format, MP3 files) and other popular audio formats. It can also turn selected tracks from your music CDs into MP3 files, so that you can store favorite songs on your hard drive to play back anytime—without having to dig up the original CDs. If your Mac can burn CDs, iTunes lets you record your own custom audio CDs that contain only the good songs. Finally, of course, iTunes is the shop window for the online iTunes Store ($1 a song).

iTunes can also burn MP3 CDs: music CDs that fit much more than the usual 74 or 80 minutes of music onto a disc (because they store songs in MP3 format instead of AIFF). Not all CD players can play MP3 discs, however, and the sound quality is slightly lower than standard CDs.

The first time you run iTunes, you're asked (a) whether you want iTunes to be the program your Mac uses for playing music files from the Internet, (b) whether you want it to ask your permission every time it connects to the Internet, and (c) whether you want the program to scan your Home folder for all music files already on it. (You can decline to have your hard drive scanned at this time. Later, you can always drag it, or any other folder, directly into the iTunes window for automatic scanning.)

Figure 11-5. When the Library icon is selected in the Source list, you can click the Browse button (upper-right) to produce a handy, supplementary view of your music database, organized like a Finder column view. Itlets you drill down from a performer's name (leftcolumn) to an album by that artist (right column) to the individual songs on that album (bottom half, beneath the browser panes).

Tip: The following pages present a mini-manual on iTunes. For the full scoop, plus coverage of the iPod and the iTunes Store, consult iPod: The Missing Manual.

11.3.1. MP3 Files and Company

The iTunes screen itself is set up to be a list—a database—of every song you've got in formats like MP3, AIFF, WAV, AAC, and Apple Lossless. iTunes automatically finds, recognizes, and lists all such files in your Home folder rightwards double arrow Music rightwards double arrow iTunes rightwards double arrow iTunes Music folder.

Tip: You can instruct iTunes to display the contents of other folders, too, by choosing File rightwards double arrow Add to Library. It promptly copies any sound files from the folder you "show" it into your Home folder rightwards double arrow Music rightwards double arrow iTunes rightwards double arrow iTunes folder.

11.3.2. Audio CDs

If you're not into collecting MP3 files, you can also populate the main list here simply by inserting a music CD. The songs on it immediately show up in the list.

At first, they may appear with the exciting names "Track 01," "Track 02," and so on. But after a moment, iTunes connects to the Internet and compares your CD with the listings at www.gracenote.com, a global database of music CDs and their contents. If it finds a match among the thousands of CDs there, it copies the album and song names into iTunes, where they reappear every time you use this particular CD.

Tip: If you connect an iTunes-compatible portable MP3 player to your Mac (the iPod isn't the only one), its name, too, shows up in the left-side Source list. You can add songs to your player (by dragging them onto its icon), rename or reorder them, and so on.

FREQUENTLY ASKED QUESTION
Auto-Playing Music CDs

How do I make music CDs automatically play when they'reinserted into the Mac?

First, make sure iTunes is slated to open automatically when you insert a music CD. You do that on the CDs & DVDs panel of System Preferences (use the "When you insert a music CD" pop-up menu).

Then all you have to do is make sure iTunes knows to begin playing automatically once it launches. Choose iTunes rightwards double arrow Preferences, click the Advanced icon, and then click Importing; from the On CD Insert pop-up menu, choose Begin Playing. Click OK.

From now on, whenever you insert a music CD, iTunes will open automatically and begin playing.

11.3.3. The iPod and iPhone

Unless you're just off the shuttle from Alpha Centauri, you probably already know that the iPod is Apple's tiny, elegant music player. It, and its cellular pal the iPhone, are designed to integrate seamlessly with iTunes.

All you have to do is connect the iPod or iPhone to the Mac via its FireWire or USB 2.0 cable. You'll see the gadget's icon show up in the iTunes Source list. Click its icon to view its contents—and click the tabs (Music, TV Shows, Podcasts, and so on) to specify what Mac material you'd like copied over to it.

11.3.4. The iTunes Music Store

The iTunes Music Store is incredibly easy to figure out. Right from within iTunes, you can search or browse for over 6 million pop songs, classical pieces, and even comedy excerpts—and then buy them for $1 apiece. Then there are the TV shows (episodes for $2 a piece, with no ads, from over 350 series), movies (500), free podcasts (65,000), audiobooks (20,000), music videos (100,000), iPod games, and more. Sure, you may go broke, but at least you'll be entertained.

Besides, there are no monthly fees, and your downloads don't go poof! into the ether if you decide to cancel your subscription, as they do with some rival services.

Start by clicking the Store icon in the iTunes Source list. You go online and land on the home page, which looks and works like a Web page. Use the Search Music Store box (top right corner) to find the songs or performers you're interested in. Doubleclick a song or video to hear or view a 30-second excerpt. (For audio books, you get a 90-second excerpt.)

11.3.4.1. Buying music

If you decide to buy a song, you need an Apple Account. Click the Account: Sign In button on the right side of the iTunes window to get started. (If you've ever bought or registered an Apple product on the company's Web site, signed up for AppleCare, ordered an iPhoto book, or have a .Mac membership, you probably have an Apple Account already. All you have to do is remember your name—usually your email address—and password.)

WORKAROUND WORKSHOP
iPod Independence

Out of the box, the iPod and iTunes come set for automatic synchronization. That is, as soon as you hook them together, iTunes sends your complete music library (the contents of your Library "folder" in iTunes) to the iPod. The iPod's songs and playlists always match the Mac's.

Apple's idea here was to ensure that you don't use the iPod as a convenient piracy machine. Your iPod gets its music from your Mac, but can't put its songs onto a Mac.

At least that's the theory. But what if your hard drive selfdestructs, vaporizing the 945 MP3 files that you've made from your paid-for CD collection? You legally own those copies. Shouldn't you have the right to retrieve them from your own iPod?

If you believe that the answer is yes, a quick search at www.versiontracker.com for the word "iPod" will bring up a list of programs like iPod Viewer and iPod.iTunes, which let you copy music from the iPod to the Mac.

These programs know that the name of the super-secret music folder on the iPod, called iPod_Control, is invisible, which is why you can't see it on your desktop without the help of these utilities.

When you click the Buy button next to a song's name, iTunes downloads it into your Home rightwards double arrow Music rightwards double arrow iTunes Music folder. It also shows up in the Purchased Music "playlist" in the Source list for convenient access.

11.3.4.2. Restrictions

Most songs from the iTunes Store are copy-protected—gently. For example:

  • Maximum offive computers. Apple lets you play your Store–bought songs on up to five computers at once. However, to prevent you from becoming a rampant music pirate, you must prove your honesty by authorizing these five machines.

    You authorized your first machine when you signed up for an Apple Account for the iTunes store. To authorize a song to play on another computer, copy it over from the first machine. Then, in iTunes, select the song and click the [image] button. Type your Apple Account user name and password in the box that appears. This second computer is now authorized to play that song—and any other songs you bought using the same Apple Account.

    Tip: Thinking of putting that older computer up for sale? Before you wipe the drive clean and send it on its way, be sure to deauthorize it (choose Advanced rightwards double arrow Deauthorize Computer), so that you're not wasting one of your five "authorized computer" slots. Erasing a hard drive, by itself, does not deauthorize a computer.

  • Maximum of10 CDs per playlist. You can also burn purchased tracks to blank CDs, so you can listen to them in the car or the big stereo rack in the living room. Here's another tiny form of copy protection: If you've added store-bought songs to a given playlist, you can't burn more than ten CD copies of it in a row without making at least one change to that list. Changing the song order slightly will do.

Music publisher EMI now offers its songs without any copy protection (at $1.30 instead of $1.00); Apple hopes to score similar deals with other record companies. Well, we can dream, can't we?

11.3.5. Playing Music

To turn your Mac into a music player, click iTunes' Play button [image] or press the Space bar. The Mac immediately begins to play the songs whose names have checkmarks in the main list (Figure 11-5), or the CD that's currently in your Mac.

Tip: The central display at the top of the window shows not only the name of the song and album, but also where you are in the song, as represented by the diamond in the horizontal strip. Drag this diamond, or click elsewhere in the strip, to jump around in the song.To view the current music's sound levels, click the tiny triangle at the left side of this display to see a pulsing VU meter, indicating the various frequencies.

11.3.6. Playing with Playback

As music plays, you can control and manipulate the music and the visuals of your Mac in all kinds of interesting ways. Some people don't move from their Macs for months at a time.

11.3.6.1. Turning on visuals

Visuals are onscreen light shows that pulse, beat, and dance in sync to the music. The effect is hypnotic and wild. (For real party fun, invite some people who grew up in the Sixties to your house to watch.)

To summon this psychedelic display, choose View rightwards double arrow Turn On Visuals, or just press [image] -T. The show begins immediately—although it's much more fun if you choose View rightwards double arrow Full Screen ( [image] -F) so thes how takes over your whole monitor. True, you won't get a lot of work done, but when it comes to stress relief, visuals are a lot cheaper than a hot tub.

Once the screen is alive with visuals, you can turn it into your personal bio feedback screen by experimenting with these keys:

Key | Function
? | Displays a cheat sheet of secret keystrokes. (Press it repeatedly to see the other shortcut keys.)
F | Displays, in the upper-left corner of your screen, how many frames per second iTunes' animation is managing—a quick, easy way to test the power of your graphics circuitry.

GEM IN THE ROUGH
Playing Across the Network

If you've taken the trouble to set up a home network, you can share songs and playlists with up to five networked computers. You could, for example, tap into your roommates' jazz collection without getting up from your desk, and they can sample the zydeco and tejano tunes from your World Beat playlist. The music you decide to share is streamed over the network to the other computer.

You can't share music across the Internet; only within your own home or office network. Technically speaking, the computers must be on the same subnet. (Open the Network panel of System Preferences to check your subnet number.)

To make your music available to others, choose iTunes rightwards double arrow Preferences, click the Sharing icon, and turn on "Share my library on the local network." They'll find your iTunes collection listed in the Source pane, ready to play.

Unfortunately, you can't listen to a song from the iTunes Music Store across the network until you enter the Apple account name and user password that was used to purchase the song. Your Mac now takes one of the five spots on the song's authorized list. If you don't type in the owner's name and password for purchased songs, iTunes just skips those tracks.

T | Turns frame rate capping on or off—a feature that limits the frame rate to 30 frames per second, to avoid sapping your Mac's horsepower when you're working in other programs (not really much of an issue in Mac OS X, of course).
I | Shows/hides info about the current song.
C | Shows/hides the current Visuals configuration (the name of the current waveform, style, and color scheme) in the upper-right corner of the screen.
M | Turns slideshow mode on or off. In slideshow mode, the visuals keep changing color and waveform as they play. (Otherwise, the visuals stick with one style and color.)
N | Turns "high-contrast colors mode" on or off.
B | Turns on the [image] in the center of the Visuals screen.
R | Chooses a new waveform/style/color at random.
Q or W | Cycles through the various waveform styles stored in iTunes.
A or S | Cycles though variations on the currently selected waveform.
Z or X | Cycles through color schemes.
Number keys | Cycle through the ten different preset, preprogrammed waveform/color/style configurations.
Up/down arrow keys | Louder/softer
D | Restores the default waveform settings.

By the way, these are the secret keystrokes for the built-in visuals. The Web is crawling with add-on modules that have secret keystrokes of their own.

11.3.6.2. Keyboard control

You can control iTunes' music playback using its menus, of course, but the keyboard can be far more efficient. Here are a few of the control keystrokes worth noting:

Function | Keystroke
Play, Pause | Space bar
Next song/previous song | right arrow, left arrow
Next source/previous source | down arrow, up arrow
Louder | -up arrow
Quieter | -down arrow
Mute | Option- [image] -M
Fast-forward, rewind | Option- [image] -right arrow, -left arrow
Eject | -E
Turn Visuals on | -T
Turn Visuals off | -T or mouse click
Full-screen visuals | -F
Exit full-screen visuals | -T, [image] -F, Esc, or mouse click

Tip: You can also control CD playback from the Dock. Control-click the iTunes icon (or click and hold on it) to produce a pop-up menu offering playback commands like Pause, Next Song, and Previous Song, along with a display that identifies the song currently being played.

Figure 11-6. Drag the sliders (bass on the left, treble on the right) to accommodate the strengths and weaknesses of your speakers or headphones (and listening tastes). Or save yourself the trouble—use the pop-up menu above the sliders to choose a canned set of slider positions for Classical, Dance, Jazz, Latin, and so on. These settings even transfer to the iPod.

11.3.6.3. Playing with the graphic equalizer

If you choose Window rightwards double arrow Equalizer, you get a handsome control console that lets you adjust the strength of each musical frequency independently (Figure 11-6).

11.3.6.4. Preventing ear-blast syndrome

Here's a clever touch: In the iTunes rightwards double arrow Preferences dialog box, if you click the Playback icon, you see a checkbox called Sound Check. Its function is to keep the playback volume of all songs within the same basic level, so that you don't have to adjust the volume to compensate for different recorded levels. (This setting, too, gets transferred to your iPod or iPhone.)

Come to think of it, you could wile away quite a few happy afternoons just poking through the Preferences dialog box. It grows richer with every successive version of iTunes.

11.3.7. Copying (Ripping) CD Songs to Your Hard Drive

iTunes lets you convert your favorite songs from audio CDs into files on your hard drive. Once they've been transferred to your Mac, you can play them whenever you like, without needing the original CD.

To rip a CD (as aficionados would say) to your hard drive, make sure that only the songs you want to capture have checkmarks in the main list. Choose a format for the files you're about to create using the pop-up menu on the iTunes rightwards double arrow Preferences rightwards double arrow Advanced rightwards double arrow Importingtab. Then click the Import CD button at the lower-right corner of the window (see Figure 11-7).

Figure 11-7. Watch the display at the top of the window to see how long the conversion is going to take, and which song iTunes is working on. As iTunes finishes processing each song, you see a small, circled checkmark next to its name in the main list to remind you that you've got it on board and no longer need the CD in your machine.

When it's all over, you'll find the imported songs listed in your Library. (Click the Library icon in the left-side Source list.) From there, you can drag them into any other "folder" (playlist), as described next.

11.3.8. Playlists—and Smart Playlists

When you click the Music icon in the left-side Source list, the main part of the screen displays every music file iTunes knows about (and even every QuickTime movie file; iTunes will play back soundtracks). It's organized much like a Finder window, with columns indicating the song length, singer or band, album, and so on. As always, you can rearrange these columns by dragging their headings, sort your list by one of these criteria by clicking its heading, reverse the sorting order by clicking the heading a second time, and so on. To find a particular song, just type a few letters into the Spotlight-ish Search blank above the list. iTunes hides all but the ones that match.

Apple recognizes that you may not want to listen to all your songs every time you need some tunes. That's why iTunes lets you create playlists—folders in the Source list that contain only certain songs. In effect, you can devise your own albums, like one called Party Tunes, another called Blind Date Music, and so on.

11.3.8.1. Creating playlists

To create a new playlist, click the + button in the lower-left corner of the window, or choose File rightwards double arrow New Playlist ( [image] -N). Alternatively, if you've already highlighted certain songs—by [image] -clicking them or Shift-clicking them—you can choose File rightwards double arrow New Playlist From Selection.

A new playlist appears as an icon in the Source list. You can rename one by double clicking it, and add songs to one by dragging them out of the main list.

Tip: Deleting a song from a playlist doesn't delete it from the Library (or your hard drive). Similarly, it's fine to add the same song to as many different playlists as you like, since you're not actually increasing the size of your Library. (You might be starting to pick up a running theme in Apple's software. Playlists work just like albums in iPhoto, or the Sidebar in the Finder.)
11.3.8.2. Playing with criteria

Smart playlists constantly rebuild themselves according to criteria you specify. You might tell one smart playlist to assemble 45 minutes' worth of songs that you've rated higher than four stars but rarely listen to, and another to list your most-often-played songs from the Eighties.

Tip: To rate a song, make the window wide enough that you can see the Rating column. (If you don't see this column, Control-click any column heading and choose Rating from the list of options.) Then just click the Rating column for a selected song. The appropriate number of stars appears—one, two, three, four, or five—depending on the position of your click. You can change a song's rating as many times as you like—a good thing, considering the short shelf life of a pop hit these days.

To make a smart playlist, choose File rightwards double arrow New Smart Playlist (Option- [image] -N)—or just Option-click the + button beneath the source list. The dialog box shown in Figure 11-8 appears. The controls here are designed to set up a search of your music database. Figure 11-8, for example, illustrates how you'd find up to 74 Beatles tunes released between 1965 and 1968—that you've rated three stars or higher and that you've listened to exactly twice.

When you click OK, your smart playlist is ready to show off. When you click its name in the Source list, the main song list updates itself according to your criteria and any changes in your music collection. (Smart playlists get transferred to your iPod or iPhone, but don't continue to update themselves there.)

Figure 11-8. A Smart Playlist is a powerful search command for your iTunes database. You can set up certain criteria, like the hunt for particular Beatles tunes illustrated here. The "Live updating"checkbox makes iTunes keep this playlist updated as your collection changes, as you change your ratings, as your Play Count changes, and so on.

11.3.9. iTunes: Burning Music CDs

iTunes can record selected sets of songs, no matter what the original sources, onto a blank CD. When it's all over, you can play the burned CD on almost any standard CD player, just as you would a CD from the record store—but this time, you hear only the songs you like, in the order you like, with all of the annoying ones eliminated.

GEM IN THE ROUGH
Internet Radio and Podcasts

Audio CDs and MP3 files aren't the only sources of musical and spoken sound you can listen to as you work. iTunes also lets you tune in to hundreds of Internet-based radio stations, which may turn out to be the most convenient music source of all. They're free, they play 24 hours a day, and their music collections make yours look like a drop in the bucket. You can also download and listen to podcasts, which are like homemade (sometimes very h o m e m a d e ) ,Web-distributed personal radio shows.

For radio, click Radio in the leftside Source list. In the main list, if you're connected to the Internet, you'll see categorieslike Blues, Classic Rock, Classical, and so on, as shown here. Click the flippy triangle to see a list of Internet radio stations in that category.

When you see one that looks interesting, double-click it. (The higher the number in the Bit Rate column, the better the sound quality.) Wait a moment for your Mac to connect to the appropriate Internet site, and then let the music begin!

Unfortunately, there's no easy way to capture Internet broadcasts or save them onto your hard drive. You can, however, drag the name of one into the Source list, or your Library, or even a playlist, to make it easier to access later on.

If you discover other Internet radio stations that sound interesting, choose Advanced rightwards double arrow Open Stream, type in the station's Web address (URL), and press Return.

To grab a podcast, click Music Store in the Source list. In the master category list at the left side of the musicstore "page," click Podcasts. Now iTunes lets you browse a vast list of available podcasts. When you click one that looks promising, you'll see that you can either listen to it on the spot, or—and here's the real fun—click Subscribe.

Once you do that, a new icon called Podcasts appears in your Source list; click it to find the latest episodes of the podcasts you've subscribed to. Sync those babies to your iPod, and you've got interesting material—or, at least fresh material—to listen to every day of the week.

Tip: Use CD-R discs. CD-RW discs are not only more expensive, but may not work in standard CD players. (Not all players recognize CD-R discs either, but the odds are better.)

Start by creating a playlist for the CD you're about to make. Click its icon in the leftside Source list to see the list you've built. Drag songs up or down in the list to reflect their playback order. Keep these points in mind:

  • The readout at the bottom of the list shows how much time the songs will take.

  • About 74 or 80 minutes ofAIFF audio files fit on one CD. But ifyou make an MP3 CD instead (choose iTunes rightwards double arrow Preferences rightwards double arrow Advanced rightwards double arrow Burning tab, and then choose MP3 CD as the format), you can fit at least ten times as much. Note, though, that MP3 CDs don't play on all CD players—only those advertised with this feature. Also note that your MP3 CD can't include songs you've bought on Apple's iTunes music store; iTunes won't convert them into the non-copy-protected MP3 format.

  • You can control how many seconds of silence iTunes leaves between tracks on your custom CD. Choose iTunes rightwards double arrow Preferences rightwards double arrow Advanced rightwards double arrow Burning tab, and make a selection from the Gap Between Songs pop-up menu.

When everything is set up, click the Burn Disc button in the playlist window. Insert a blank CD into the Mac. The burning process takes some time. Feel free to work in other programs while iTunes chugs away.


dvd_movies.html

11.4. DVD Movies

Using DVD Player, newly enhanced in Leopard, your Mac can play Hollywood DVDs as though it was born to do so.

Watching movies on your Mac screen couldn't be simpler: Just insert the DVD. The Mac detects that it's a video DVD (as opposed to, say, one that's just filled with files) and, unless you've fiddled with your preference settings, opens the DVD Player program (Figure 11-9). (It can take awhile.)

If DVD Player doesn't start up automatically when you insert a DVD movie, you can open it yourself. It's sitting there in your Applications folder. (Then fix the problem, using the CDs & DVDs panel of System Preferences.)

11.4.1. Playing a Movie

Once DVD Player starts playing your movie, you can use the "remote control," which is deconstructed in Figure 11-9. Or just use the keyboard controls:

  • By far the easiest way to start and stop Playback is to press the Space bar—once to start, again to pause, again to start again.

  • Press Shift- [image] - rightwards double arrow to fast-forward; press that combination repeatedly to cycle from twice to 4, 8, 16, or 32 times normal speed. (Or just choose a speed from the Controls rightwards double arrow Scan Rate submenu.)

    Similarly, press Shift- [image] - leftwards double arrow to scan backwards. Click Play (or press the Space bar) to resume normal playback.

  • You can make the movie louder or quieter by repeatedly tapping [image] - upwards arrow, or - downwards arrow. That's a good keystroke to remember when you've hidden the remote control itself.

Figure 11-9. Top: DVDs on your screen!Use your mouse to click the buttons, if you like; that's a lot more direct than having to use the arrow keys on a remote control.
Bottom: You can orient this controller either horizontally or vertically on your screen by choosing Controls rightwards double arrow Use Vertical Controller. You can also do without this remote control altogether, since all of its buttons have keyboard equivalents.

Or, if you prefer a clip 'n' save cheat sheet of all the keystrokes, here it is:

Function | Keystroke
Play, Pause | Space bar
Fast-forward | Shift- [image] - rightwards double arrow
Rewind | Shift- [image] - leftwards double arrow
Skip back 5 seconds | Option- [image] - rightwards double arrow
Skip forward 5 seconds | Option- [image] - leftwards double arrow
Louder | - upwards arrow ,
Quieter | - downwards arrow .
Mute/Unmute | Option- [image] - downwards arrow .
Next/previous "chapter" | rightwards double arrow , leftwards double arrow
Main menu | -~ (upper left of your keyboard)
Full-screen mode | -F
Half, normal, maximum size | -1, -2, -3
Eject | -E
Show/hide remote control | Option- [image] -C
Add a bookmark | -= (equal sign)

Tip: Isn't that cool how DVD Player automatically displays the subtitles for the dialog (if subtitles exist on the DVD) when you hit the Mute key?

11.4.2. Full-Screen Playback

In Leopard, DVD movies begin playing back in in full-screen mode all by themselves (you no longer have to choose View rightwards double arrow Enter Full Screen). Even the menu bar disappears. (To make it reappear, move your cursor near the top of the screen.)

As shown in Figure 11-10, though, a new suite of powerful navigation controls is still available, even in full-screen mode.

Figure 11-10. Even in full-screen mode, you can control the playback and navigate the disc using the new, translucent, pop-up control bars.
The chapter list appears when you move your cursor to the top of the screen. The "remote control" bar appears when the cursor approaches the bottom.
One especially cool feature is the new Player Settings button. It opens the Zoom controls window shown here, which gives you manual control over the width and height of the picture on your screen.
Don't miss the scrubber bar at the very bottom, either. It lets you scroll directly to any spot in the DVD.

11.4.3. Language Fun

Most Hollywood DVDs have been programmed with onscreen subtitles to help those with hearing impairments and people sitting in noisy bars. Click the Subtitle button (Figure 11-9) to turn on the subtitles, and click again to hide them. (You can specify the language you want—English subtitles, Spanish subtitles, or whatever the DVD offers—by clicking the same button repeatedly. Or choose DVD Player rightwards double arrow Preferences, click the Disc Setup icon, and choose a language from the Subtitle pop-up menu.)

Meanwhile, each time you click the Audio button on the remote, the movie's soundtrack switches to a different language (if, in fact, alternate soundtrack languages have been provided). You'll see the name of each language appear briefly in the remote's "display." (You can also use the Audio button as a pop-up menu to choose the language you want directly.)

Tip: For real fun, turn on English subtitles but switch the soundtrack to a foreign language. No matter how trashy the movie you're watching, you'll gain much more respect from your friends and family when you tell them that you're watching a foreign film.

11.4.4. Bookmarks and Video Clips

Two DVD Player features are designed to help you flag and return to favorite moments or scenes in a DVD movie.

  • Bookmarks. Each time you find a spot you'll want to find again later (during playback or when paused),hit [image] -= (equal sign),or choose Controls rightwards double arrow New Bookmark. DVD Player invites you to name the bookmark. You can also accept its proposal of 1:23:15 (or whatever the hours:minutes:seconds count happens to be).

    Once you click OK, you can use the Go rightwards double arrow Bookmarks submenu to jump from one bookmark to another.

    Tip: Ordinarily, DVD Player is smart enough to begin playing back a movie from the point where you stopped, even if you ejected the DVD in the meantime and three years have gone by.But when you create a bookmark, the "Name your bookmark" dialog box offers you the chance to define a default bookmark. That means, "Next time you insert this disc, play back from here instead of where I stopped."

    Figure 11-11. When you choose Controls rightwards double arrow New Video Clip, this box appears. Find the starting point of the favorite scene and then click the upper Set button. Now play or navigate to the end of the scene, and click the lower Set button. When you click Save, you're invited to name the scene. From now on, you can play the scene by choosing from the Go rightwards double arrow Video Clips submenu.

  • Video Clips. A video clip is exactly the same as a bookmark, except that you're supposed to designate a starting point and an ending point. (Don't get excited; a video clip isn't a standalone file that's saved on your computer, and you can't send it or share it. It only works within DVD Player.)

    Figure 11-11 shows how you create and use a video clip.

11.4.5. Chapter Thumbnails

There are roughly 7 trillion different ways to navigate a DVD now, but one of them lets you have a little creative fun: You can create your own scene thumbnails.

That might not be an especially tempting feature when you're playing Hollywood DVDs. But on homemade DVDs, made either by you or somebody else, these custom scene markers can be handy signposts.

First choose Window rightwards double arrow Chapters ( [image] -B) to open the new chapter thumbnail palette. Here you'll find the existing scene breaks, which may or may not already have "poster frame" images (Figure 11-12).

All the action takes place in the Action menu [image] at the bottom of the panel. For example, it contains the Generate Missing Thumbnails command, for use on DVDs that have chapter breaks but no little poster frames to represent them.

Whether there is a poster frame for a particular chapter or not, you can substitute an image of your own. Find the exact frame of the movie that you think looks better than what's already in the Chapters palette; click the chapter in the palette, and, from the [image] pop-up menu, choose Use Current Frame for Thumbnail. Presto: You've replaced the unhelpful (or nonexistent) chapter image with one that works better.

FREQUENTLY ASKED QUESTION
Region Changing

The first time I tried to play a DVD, I got this weird message about initializing the region code. What's up with that?

Hollywood generally releases a movie in each part of the world at different times. A movie may come out on video in the U.S. when it's just hitting screens in Europe. We certainly can't have people watching a DVD before the movie studio says it's OK! That's why many discs are region-locked, so that they play back only on players in certain geographical regions.

As a DVD player in disguise, your Mac is just doing its duty. You can change its region (you'll be offered the chance to do so when you insert a region-locked DVD from another region), but only five times—and then it's frozen forever in the fifth version.

The dialog box shows you which region your DVD is designed for: 1 for the U.S. and Canada; 2 for Japan, Europe, South Africa, and the Middle East; 3 for Southeast and East Asia; 4 for Australia, New Zealand, Pacific Islands, Central America, Mexico, South America, and the Caribbean; 5 for Eastern Europe, Africa, and North Korea; 6 for China; and 8 for airplanes, cruise ships, and so on. Any DVD that you burn yourself is assigned region 0, meaning that it will play anywhere.

(There's no Region 7. Maybe it's reserved for the empty spot in movie executives' hearts.)

11.4.6. The Big Picture

Now, watching a movie while sitting in front of your Mac is not exactly the great American movie-watching dream. Fortunately, every recent Mac model has a video-output jack; with the proper cables, you can connect the Mac to your TV for a much more comfortable movie-watching experience.

Figure 11-12. Double-click a chapter thumbnail to jump to that spot in the video. Use the pop-up menu at the top to switch between Chapters, Bookmarks, and Video Clips you've made. And use the menu at the bottom to manage the chapters' names and images.

GEM IN THE ROUGH
Parental Controls

The new parental controls in Leopard aren't much. You can't say, for example, "Don't play anything rated PG-13 or above"; you have to rate each DVD yourself, one at a time.

But they're better than nothing.

Insert the DVD you're worried about. Choose File rightwards double arrow Get Disk Info. Click the Parental Controls tab.

Click the [image] button and enter your administrator's password. (Unless, of course, your 8-year-old is the administrator of this Mac instead of you, in which case this DVD is the least of your problems.)

Now you can select either "Always ask for authorization" or "Always allow to be played," depending on your feelings about this movie. Click OK.

All you've done so far, however, is to specify what happens when you turn on parental controls—and you haven't done that yet. Choosing Features rightwards double arrow Enable Parental Control does the trick.

When parental control is turned on, nobody's allowed without watch the "always ask for authorization" DVDs unless they correctly input your administrator's password.

Which nobody knows except you. (Right?)

Just be sure to connect the cable directly to the TV. If you connect it to your VCR instead, you'll probably get a horrible, murky, color-shifting picture—the result of the built-in copy-protection circuitry of every VCR.

Or what the heck—just ask for an Apple TV for your birthday.


the_technologies_of_mac_OS_X.html

Part IV: The Technologies of Mac OS X

Chapter 12

Chapter 13

Chapter 14

Chapter 15

Chapter 16

Chapter 17

Chapter 12. Accounts, Parental Controls, and Security

In an era when security is the hottest high-tech buzzword, Apple was smart to make security a focal point for Leopard. Mac OS X was already virus-free and better protected from Internet attacks than Windows. But Mac OS X 10.5 is the most impenetrable Mac system yet, filled with new defenses against the dark arts.

You'll spot big and small security enhancements all over Leopard and the programs that accompany it. This chapter covers the whole range of them.

On the premise that the biggest security threat of all comes from other people in your home or office, though, the most important security feature in Mac OS X is the accounts system.

12.1. Introducing Accounts

The concept of user accounts is central to Mac OS X's security approach. Like the Unix under its skin (and also like Windows XP and Vista), Mac OS X is designed from the ground up to be a multiple-user operating system. You can configure a Mac OS X machine so that everyone must log in—that is, you have to click or type your name and type in a password—when the computer turns on (Figure 12-1).

Upon doing so, you discover the Macintosh universe just as you left it, including these elements:

  • Your documents, files, and folders.

  • Your preference settings in every program you use:Web browser bookmarks and preferred home page; desktop picture, screen saver, and language; icons on the desktop and in the Dock—and the size and position of the Dock itself; and so on.

  • Email account(s), including personal information and mailboxes.

  • Your personally installed programs and fonts.

  • Your choice of programs that launch automatically at startup.

This system means that several different people can use it throughout the day, without disrupting each other's files and settings. It also protects the Mac from getting fouled up by mischievous (or bumbling) students, employees, and hackers.

If you're the only person who uses your Mac, you can safely skip most of this chapter. The Mac never pauses at startup time to demand the name and password you made up when you installed Mac OS X, because Apple's installer automatically turns on something called automatic login (Section 12.5). You will be using one of these accounts, though, whether you realize it or not.

Furthermore, when you're stuck in line at the Department of Motor Vehicles, you may find the concepts presented here worth skimming, as certain elements of this multiple-user system may intrude upon your solo activities—and figure in the discussions in this book—from time to time.

Tip: Even if you don't share your Mac with anyone and don't create any other accounts, you might still be tempted to learn about the accounts feature because of its ability to password-protect the entire computer. All you have to do is to turn off the automatic login feature described on Section 12.5. Thereafter, your Mac is protected from unauthorized fiddling when you're away from your desk or when your laptop is stolen.

12.1.1. The First Account

When you first installed Mac OS X, whether it was 10.5 or an earlier version, you were asked for a name and password. You may not have realized it at the time, but you were creating the first user account on your Macintosh. Since that fateful day, you may have made a number of changes to your desktop—adjusted the Dock settings, set up your folders and desktop the way you like them, added some favorites to your Web browser, and so on—without realizing that you were actually making these changes only to your account.

You've probably been saving your documents into your own Home folder, which is the cornerstone of your own account. This folder, generally named after you and stashed in the Users folder on your hard drive, stores not only your own work, but also your preference settings for all the programs you use, special fonts that you've installed, your own email collection, and so on.

Now then: Suppose you create an account for a second person. When she turns on the computer and signs in, she finds the desktop exactly the way it was factory-installed by Apple—stunning Earth-in-space desktop picture, Dock along the bottom, the default Web browser home page, and so on. She can make the same kinds of changes to the Mac that you've made, but nothing she does affects your environment the next time you log in.

In other words, the multiple-accounts feature has two components: first, a convenience element that hides everyone else's junk; and second, a security element that protects both the Mac's system software and everybody's work.

Figure 12-1. When you set up several accounts, you don't turn on the Mac so much as sign into it. A command in the menu called Log Out summons this signin screen, as does the Accounts menu described later in this chapter. Click your own name, and type your password (if any), to get past this box and into your own stuff.


accounts_parental_controls_and_security.html

Part IV: The Technologies of Mac OS X

Chapter 12

Chapter 13

Chapter 14

Chapter 15

Chapter 16

Chapter 17

Chapter 12. Accounts, Parental Controls, and Security

In an era when security is the hottest high-tech buzzword, Apple was smart to make security a focal point for Leopard. Mac OS X was already virus-free and better protected from Internet attacks than Windows. But Mac OS X 10.5 is the most impenetrable Mac system yet, filled with new defenses against the dark arts.

You'll spot big and small security enhancements all over Leopard and the programs that accompany it. This chapter covers the whole range of them.

On the premise that the biggest security threat of all comes from other people in your home or office, though, the most important security feature in Mac OS X is the accounts system.

12.1. Introducing Accounts

The concept of user accounts is central to Mac OS X's security approach. Like the Unix under its skin (and also like Windows XP and Vista), Mac OS X is designed from the ground up to be a multiple-user operating system. You can configure a Mac OS X machine so that everyone must log in—that is, you have to click or type your name and type in a password—when the computer turns on (Figure 12-1).

Upon doing so, you discover the Macintosh universe just as you left it, including these elements:

  • Your documents, files, and folders.

  • Your preference settings in every program you use:Web browser bookmarks and preferred home page; desktop picture, screen saver, and language; icons on the desktop and in the Dock—and the size and position of the Dock itself; and so on.

  • Email account(s), including personal information and mailboxes.

  • Your personally installed programs and fonts.

  • Your choice of programs that launch automatically at startup.

This system means that several different people can use it throughout the day, without disrupting each other's files and settings. It also protects the Mac from getting fouled up by mischievous (or bumbling) students, employees, and hackers.

If you're the only person who uses your Mac, you can safely skip most of this chapter. The Mac never pauses at startup time to demand the name and password you made up when you installed Mac OS X, because Apple's installer automatically turns on something called automatic login (Section 12.5). You will be using one of these accounts, though, whether you realize it or not.

Furthermore, when you're stuck in line at the Department of Motor Vehicles, you may find the concepts presented here worth skimming, as certain elements of this multiple-user system may intrude upon your solo activities—and figure in the discussions in this book—from time to time.

Tip: Even if you don't share your Mac with anyone and don't create any other accounts, you might still be tempted to learn about the accounts feature because of its ability to password-protect the entire computer. All you have to do is to turn off the automatic login feature described on Section 12.5. Thereafter, your Mac is protected from unauthorized fiddling when you're away from your desk or when your laptop is stolen.

12.1.1. The First Account

When you first installed Mac OS X, whether it was 10.5 or an earlier version, you were asked for a name and password. You may not have realized it at the time, but you were creating the first user account on your Macintosh. Since that fateful day, you may have made a number of changes to your desktop—adjusted the Dock settings, set up your folders and desktop the way you like them, added some favorites to your Web browser, and so on—without realizing that you were actually making these changes only to your account.

You've probably been saving your documents into your own Home folder, which is the cornerstone of your own account. This folder, generally named after you and stashed in the Users folder on your hard drive, stores not only your own work, but also your preference settings for all the programs you use, special fonts that you've installed, your own email collection, and so on.

Now then: Suppose you create an account for a second person. When she turns on the computer and signs in, she finds the desktop exactly the way it was factory-installed by Apple—stunning Earth-in-space desktop picture, Dock along the bottom, the default Web browser home page, and so on. She can make the same kinds of changes to the Mac that you've made, but nothing she does affects your environment the next time you log in.

In other words, the multiple-accounts feature has two components: first, a convenience element that hides everyone else's junk; and second, a security element that protects both the Mac's system software and everybody's work.

Figure 12-1. When you set up several accounts, you don't turn on the Mac so much as sign into it. A command in the menu called Log Out summons this signin screen, as does the Accounts menu described later in this chapter. Click your own name, and type your password (if any), to get past this box and into your own stuff.


introducing_accounts.html

Part IV: The Technologies of Mac OS X

Chapter 12

Chapter 13

Chapter 14

Chapter 15

Chapter 16

Chapter 17

Chapter 12. Accounts, Parental Controls, and Security

In an era when security is the hottest high-tech buzzword, Apple was smart to make security a focal point for Leopard. Mac OS X was already virus-free and better protected from Internet attacks than Windows. But Mac OS X 10.5 is the most impenetrable Mac system yet, filled with new defenses against the dark arts.

You'll spot big and small security enhancements all over Leopard and the programs that accompany it. This chapter covers the whole range of them.

On the premise that the biggest security threat of all comes from other people in your home or office, though, the most important security feature in Mac OS X is the accounts system.

12.1. Introducing Accounts

The concept of user accounts is central to Mac OS X's security approach. Like the Unix under its skin (and also like Windows XP and Vista), Mac OS X is designed from the ground up to be a multiple-user operating system. You can configure a Mac OS X machine so that everyone must log in—that is, you have to click or type your name and type in a password—when the computer turns on (Figure 12-1).

Upon doing so, you discover the Macintosh universe just as you left it, including these elements:

  • Your documents, files, and folders.

  • Your preference settings in every program you use:Web browser bookmarks and preferred home page; desktop picture, screen saver, and language; icons on the desktop and in the Dock—and the size and position of the Dock itself; and so on.

  • Email account(s), including personal information and mailboxes.

  • Your personally installed programs and fonts.

  • Your choice of programs that launch automatically at startup.

This system means that several different people can use it throughout the day, without disrupting each other's files and settings. It also protects the Mac from getting fouled up by mischievous (or bumbling) students, employees, and hackers.

If you're the only person who uses your Mac, you can safely skip most of this chapter. The Mac never pauses at startup time to demand the name and password you made up when you installed Mac OS X, because Apple's installer automatically turns on something called automatic login (Section 12.5). You will be using one of these accounts, though, whether you realize it or not.

Furthermore, when you're stuck in line at the Department of Motor Vehicles, you may find the concepts presented here worth skimming, as certain elements of this multiple-user system may intrude upon your solo activities—and figure in the discussions in this book—from time to time.

Tip: Even if you don't share your Mac with anyone and don't create any other accounts, you might still be tempted to learn about the accounts feature because of its ability to password-protect the entire computer. All you have to do is to turn off the automatic login feature described on Section 12.5. Thereafter, your Mac is protected from unauthorized fiddling when you're away from your desk or when your laptop is stolen.

12.1.1. The First Account

When you first installed Mac OS X, whether it was 10.5 or an earlier version, you were asked for a name and password. You may not have realized it at the time, but you were creating the first user account on your Macintosh. Since that fateful day, you may have made a number of changes to your desktop—adjusted the Dock settings, set up your folders and desktop the way you like them, added some favorites to your Web browser, and so on—without realizing that you were actually making these changes only to your account.

You've probably been saving your documents into your own Home folder, which is the cornerstone of your own account. This folder, generally named after you and stashed in the Users folder on your hard drive, stores not only your own work, but also your preference settings for all the programs you use, special fonts that you've installed, your own email collection, and so on.

Now then: Suppose you create an account for a second person. When she turns on the computer and signs in, she finds the desktop exactly the way it was factory-installed by Apple—stunning Earth-in-space desktop picture, Dock along the bottom, the default Web browser home page, and so on. She can make the same kinds of changes to the Mac that you've made, but nothing she does affects your environment the next time you log in.

In other words, the multiple-accounts feature has two components: first, a convenience element that hides everyone else's junk; and second, a security element that protects both the Mac's system software and everybody's work.

Figure 12-1. When you set up several accounts, you don't turn on the Mac so much as sign into it. A command in the menu called Log Out summons this signin screen, as does the Accounts menu described later in this chapter. Click your own name, and type your password (if any), to get past this box and into your own stuff.


creating_an_account.html

12.2. Creating an Account

Suppose somebody new joins your little Mac family—a new worker, student, or love interest, for example. And you want to make them feel at home on your Mac.

Begin by opening System Preferences (Section 4.5.1). In the System Preferences window, click Accounts. You have just arrived at the master control center for account creation and management (Figure 12-2).

To create a new account, start by unlocking the Accounts panel. That is, click the [image] at lower-left, and fill in your own account name and password.

Now you can click the + button beneath the list of accounts. The little panel shown at bottom in Figure 12-2 appears.

12.2.1. Phase 1: Choose an Account Type

As though this business of accounts and passwords isn't complicated enough already, Mac OS X 10.5 offers more types of accounts than ever. And you're expected to specify which type each person gets at the moment you create an account.

To do that, open the New Account pop-up menu (Figure 12-2, bottom). Its five account types are described on the following pages.

Figure 12-2. Top: The screen lists everyone who has an account. From here, you can create new accounts or change passwords. If you're new at this, there's probably just one account listed here: yours. This is the account that Mac OS X created when you first installed it. You, the all-wise administrator, have to click the to authenticate yourself before you can start making changes.
Bottom: In the revamped Leopard account-creation process, the first step is choosing which type of account you want to create.

12.2.1.1. Administrator accounts

If this is your own personal Mac, just beneath your name on the Accounts pane of System Preferences, it probably says Admin. This, as you could probably guess, stands for Administrator.

Because you're the person who originally installed Mac OS X, the Mac assumes that you are its administrator—the technical wizard in charge of it. You're the teacher, the parent, the resident guru. You're the one who will maintain this Mac. Only an administrator is allowed to:

  • Install new programs into the Applications folder.

  • Add fonts that everybody can use.

  • Make changes to certain System Preferences panes (including Network, Date & Time, Energy Saver, and Startup Disk).

  • Use some features of the Disk Utility program.

  • Create, move, or delete folders outside of your Home folder.

  • Decide who gets to have accounts on the Mac.

  • Open, change, or delete anyone else's files.

  • Bypass FileVault using a master password (Section 12.9.2).

The administrator concept may be new to you, but it's an important pill to swallow. For one thing, you'll find certain settings all over Mac OS X that you can change only if you're an administrator—including many in the Accounts pane itself. For another thing, administrator status plays an enormous role when you want to network your Mac to other kinds of computers, as described in the next chapter. And finally, in the bigger picture, the fact that the Mac has an industrial-strength accounts system, just like traditional Unix and recent Windows operating systems, gives it a fightingchance in the corporations of America.

As you create accounts for other people who'll use this Mac, you're offered the opportunity to make each one an administrator just like you. Needless to say, use discretion. Bestow these powers only upon people as responsible and technically masterful as yourself.

12.2.1.2. Standard accounts

Most people, on most Macs, are ordinary Standard account holders (Figure 12-2). These people have everyday access to their own Home folders and to the harmless panes of System Preferences, but most other areas of the Mac are off limits. Mac OS X won't even let them create new folders on the main hard drive, except inside their own Home folders (or in the Shared folder described starting on Section 12.6.2).

A few of the System Preferences panels display a padlock icon ( [image] ). If you're a Standard account holder, you can't make changes to these settings without the assistance of an administrator. Fortunately, you aren't required to log out so that an administrator can log in and make changes. You can just call the administrator over, click the padlock icon, and let him type in his name and password (if, indeed, he feels comfortable with you making the changes you're about to make).

12.2.1.3. Managed accounts with Parental Controls

A Managed account is the same thing as a Standard account—except that you've turned on Parental Controls. (These controls are described later in this chapter.) You can turn a Managed account into a Standard account just by turning off Parental Controls, and vice versa.

That is, this account usually has even fewer freedoms—because you've limited the programs that this person is allowed to use, for example. Use a Managed account for children or anyone else who needs a Mac with rubber walls.

12.2.1.4. Sharing Only

This kind of account, new in Leopard, is extremely useful—if your Mac is on a network (Chapter 13).

See, ordinarily, you can log in and access the files on your Mac in either of two ways:

  • In person, seated in front of it.

  • From across the network.

This arrangement was designed with families and schools in mind: lots of people sharing a single Mac.

This setup got a little silly, though, when the people on a home or office network each have their own computers. If you wanted your spouse or your sales director to be able to grab some files off of your Mac, you'd have to create full-blown accounts for them on your Mac, complete with an utterly unnecessary Home folder that they'd never use.

That's why the Sharing Only account is such a great idea. It's available only from across the network. You can't get into it by sitting down at the Mac itself—it has no Home folder! Finally, of course, a Sharing Only account holder can't make any changes to the Mac's settings or programs. (And since they don't have Home folders, you also can't turn on FileVault for these accounts, as described on Section 12.9.2.)

In other words, a Sharing Only account exists solely for the purpose of file sharing on the network, and people can enter their names and passwords only from other Macs.

Once you've set up this kind of account, all the file-sharing and screen-sharing goodies described in Chapter 13 become available.

12.2.1.5. Group

A group is just a virtual container that holds the names of other account holders. You might create one for your most trusted colleagues, another for those rambunctious kids, and so on—all in the name of streamlining the file-sharing privileges feature described on Section 13.2.2. The box below covers groups in more detail.

12.2.1.6. The Guest account

Here's an unsung new feature of Mac OS X 10.5: The Guest account is actually useful now.

Note: The Guest account isn't listed among the account types in the New Account pop-up menu (Figure 12-2). That's because there's only one Guest account; you can't actually create additional ones.But it's still an account type with specific characteristics. It's sitting right there in the list of accounts, from Day One.

Mac OS X has always offered a special account called the Guest account. It was great for accommodating visitors, buddies, or anyone else who was just passing through and wanted to use your Mac for awhile. If you let such people use the Guest account, your own account remains private and un-messed-with.

POWER USERS' CLINIC
Creating Groups

Changing permissions settings on a networked Mac, or one with a lot of account holders, is a lot easier if you sweep all your minions into sub-sets called groups.

This process used to require a complicated series of Unixy steps that, if not performed carefully, could seriously foul up your Mac.

But in Mac OS X Leopard, you can create a group as easily as you'd create an account. And in the same place: the Accounts pane of System Preferences.

Click the tiny [image] in the lower-left corner. When prompted, type in your administrator's name and password, and then click OK. The Mac is just making sure that somebody with a clue is at the helm.

Now click the + button as though you're about to create a new account. But from the New Account pop-up menu (shown at bottom in Figure 12-2), choose Group. Type a name for the new group (Accounting, Kids, or whatever), and click Create Group.

Now you see something like the list shown here: check-boxes for all of this Mac's account holders. Turn on the checkboxes for the ones you consider worthy of being a part of this group.

You can create as many groups as you like. Later, when it comes time to share a folder or file, you'll save time by choosing a group name instead of setting these permissions one person at a time.

But before Mac OS X 10.5, there was a problem: Any changes your friend made—downloading mail, making Web bookmarks, putting up a raunchy desktop picture—would still be there for the next guest to enjoy, unless you painstakingly restored everything back to neutral. The Guest account was like a hotel room shared by successive guests. And you were the maid.

In Leopard, any changes your guest makes while using your Mac are automatically erased when she logs out. Files are deleted, email is nuked, setting changes are forgotten. It's like a hotel that gets demolished and rebuilt after each guest departs.

As noted above, the Guest account is permanently listed in the Accounts panel of System Preferences. Ordinarily, though, you don't see it in the Login screen list; if you're ordinarily the only person who uses this Mac, you don't need to have it staring you in the face every day.

So to use the Guest account, bring it to life by turning on "Allow guests to log into this computer." You can even turn on the parental controls described earlier in this chapter by clicking Open Parental Controls, or permit the guest to exchange files with your Mac from across the network (Chapter 13) by turning on "Allow guests to connect to shared folders."

Just remember to warn your vagabond friend that once he logs out, all traces of his visit are wiped out forever. (At least from your Mac.)

12.2.2. Phase 2: Name, Password, and Status

All right. So you clicked the + button. From the New Account pop-up menu, you chose the type of account you wanted to create.

Now, on the same starter sheet, you fill in the most critical information about the new account holder:

  • Name. If it's just the family, this could be Chris or Robin. If it's a corporation or school, you probably want to use both first and last names.

  • Short Name. You'll quickly discover the value of having a short name—an abbreviation of your actual name—particularly if your name is, say, Alexandra Stephanopoulos.

    When you sign into your Mac in person, you can use either your long or short name. But when you access this Mac by dialing into it or connecting from across the network (as described in the next chapter), use the short version.

    As soon as you tab into this field, the Mac proposes a short name for you. You can replace the suggestion with whatever you like. Technically, it doesn't even have to be shorter than the "long" name, but spaces and most punctuation marks are forbidden.

  • Password, Verify. Here's where you type this new account holder's password(Figure 12-2). In fact, you're supposed to type it twice, to make sure you didn't introduce a typo the first time. (The Mac displays only dots as you type, to guard against the possibility that somebody is watching over your shoulder.)

    The usual computer book takes this opportunity to stress the importance of a long, complex password—a phrase that isn't in the dictionary, something made up of mixed letters and numbers. This is excellent advice if you create sensitive documents and work in a big corporation.

    But if you share the Mac only with a spouse or a few trusted colleagues in a small office, you may have nothing to hide. You may see the multiple-users feature more as a convenience (keeping your settings and files separate) than a protector of secrecy and security. In these situations, there's no particular urgency to the mission of thwarting the world's hackers with a convoluted password.

    In that case, you may want to consider setting up no password—leaving both password blanks empty. Later, whenever you're asked for your password, just leave the Password box blank. You'll be able to log in that much faster each day.

  • Password Hint. If you gave yourself a password, you can leave yourself a hint in this box. If your password is the middle name of the first person who ever kissed you, for example, your hint might be "middle name of the first person who ever kissed me."

    Later, if you forget your password, the Mac will show you this cue to jog your memory.

  • Turn on File Vault protection. Section 12.9.2 has more on this advanced corporate security feature. (This option isn't available for Sharing Only accounts.)

When you finish setting up these essential items, click Create Account. If you left the password boxes empty, the Mac asks for reassurance that you know what you're doing; click OK.

You then return to the Accounts pane, where you see the new account name in the list at the left side.

Here, three final decisions await your wisdom:

  • .Mac User Name. Each account holder might well have her own .Mac account (especially because Apple offers a family-pack deal on these accounts). Since the .Mac service is growing in importance and features—email address, Web site, iDisk, syncing, Back to My Mac, and so on—it's convenient to associate each account with its own .Mac name.

  • Enable Parental Controls."Parental controls" refers to the newly enhanced Mac OS X 10.5 feature that limits what your offspring are allowed to do on this computer—and how much time a day that they're allowed to spend glued to the mouse. (You can turn on parental controls only for Standard and Guest accounts, even though the checkbox appears for Admin accounts too.) Details are on Section 12.3.1.

  • Allow user to administer this computer. This checkbox lets you turn ordinary, unsuspecting Standard or Managed accounts into Administrator accounts, as described above. You know—when your kid turns 18.

12.2.3. Phase 3: Choose a Picture

The usual Mac OS X sign-in screen (Figure 12-1) displays each account holder's name, accompanied by a little picture.

When you click the sample photo, you get a pop-up menu ofApple-supplied graphics; you can choose one to represent you. It becomes not only your icon on the sign-in screen, but also your "card" photo in Mac OS X's Address Book program and your icon in iChat.

If you'd rather supply your own graphics file—a digital photo of your own head, for example—then choose Edit Picture from the pop-up menu. As shown in Figure 12-3, you have several options:

  • Drag a graphics file directly into the "picture well"(Figure 12-3). Use the cropping slider below the picture to frame it properly.

    Figure 12-3. Once you've selected a photo to represent yourself (left), you can adjust its position relative to the square "frame" (right), or adjust its size by dragging the slider. Finally, when the picture looks correctly framed, click Set. (The next time you return to the Images dialog box, you can recall the new image using the Recent Pictures pop-up menu.)

  • Click Choose. You're shown a list of what's on your hard drive. Find and double-click the image you want.

  • Take a new picture. If your Mac has a built-in camera above the screen, or if you have an external webcam or a camcorder hooked up, click the little camera button. The Mac counts down from 3 with loud beeps to help you get ready, and then takes the picture.

In each case, click Set to enshrine your icon forever (or until you feel like picking a different one).

12.2.4. Phase 4: Startup Items

There's one additional System Preferences setting that your account holders can set up for themselves: which programs or documents open automatically upon login. (This is one decision an administrator can't make for other people. It's available only to whoever is logged in at the moment.)

To choose your own crew of self-starters, open System Preferences and click the Accounts icon. Click the Login Items tab. As shown in Figure 12-4, you can now build a list of programs, documents, disks, and other goodies that automatically launch each time you log in. You can even turn on the Hide checkbox for each one, so that the program is running in the background at login time, waiting to be called into service with a quick click.

Figure 12-4. You can add any icon to the list of things you want to start up automatically. Click the + button to summon the Open dialog box where you can find the icon, select it, and then click Choose. Better yet, if you can see the icon in a folder or disk window (or on the desktop), just drag it into this list. To remove an item, click it in the list and then click the -button.

Don't feel obligated to limit this list to programs and documents, by the way. Disks, folders, servers on the network, and other fun icons can also be startup items, so that their windows are open and waiting when you arrive at the Mac each morning.

Tip: Here's a much quicker way to add something to the Login Items list: Control-click (or right-click) its Dock icon and choose "Open at Login" from the shortcut menu.


parental_controls-id001.html

12.3. Parental Controls

If you're setting up a Standard account, the Parental Controls checkbox affords you the opportunity to shield your Mac—or its very young, very fearful, or very mischievous operator—from confusion and harm. This is a helpful feature to remember when you're setting up accounts for students, young children, or easily intimidated adults. (This checkbox is available for Admin accounts, too, but trying to turn it on produces only a "Silly rabbit—this is for kids!" sort of message.)

Leopard introduces a lot more peace of mind for parents than other operating systems. You can now specify how many hours a day each person is allowed to use the Mac, and declare certain hours (like sleeping hours) off-limits. You can specify exactly who your kids are allowed to communicate with via email (if they use Mail) and instant messaging (if they use iChat), what Web sites they can visit (if they use Safari), what programs they're allowed to use, and even what words they can look up in the Mac OS X Dictionary.

Here are all the ways you can keep your little Standard account holders shielded from the Internet—and themselves. For sanity's sake, the following discussion refers to the Standard account holder as "your child."But some of these controls—notably those in the System category—are equally useful for people of any age who feel overwhelmed by the Mac, are inclined to mess it up by not knowing what they're doing, or are tempted to mess it up deliberately.

Note: If you use any of these options, the account type listed on the Accounts panel changes from "Standard" to "Managed."

12.3.1. System

On this tab, you see the options shown in Figure 12-5. Use these options to limit what your Managed-account flock is allowed to do. You can limit them to using certain programs, for example, or prevent them from burning DVDs, changing settings, or fiddling with your printer setups.

(Limiting what people can do to your Mac when you're not looking is a handy feature under any shared-computer circumstance. But if there's one word tattooed on its forehead, it would be "Classrooms!")

On the panel that pops up when you click Configure, you have two options: "Use Simple Finder" and "Only allow selected applications."

12.3.1.1. Use Simple Finder

If you're really concerned about somebody's ability to survive the Mac—or the Mac's ability to survive them—turn on "Use Simple Finder." Then turn on the checkboxes of the programs that person is allowed to use.

Suppose you're the lucky Mac fan who's been given a Simple Finder account. When you log in, you discover the barren world shown in Figure 12-6. There are only three menus ( [image] , Finder, and File), a single onscreen window, no hard drive icon, and a bare-bones Dock. The only folders you can see are in the Dock. They include:

  • My Applications. These are aliases of the applications that the administrator approved. They appear on a strange, fixed, icon view, called "pages." List and column views don't exist. The Simple person can't move, rename, delete, sort, or change the display of these icons—merely click them. If you have too many to fit on one screen, you get numbered page buttons beneath them, which you click to move from one set to another.

    Figure 12-5. In the Parental Controls window, you can control the capabilities of any account holder on your Mac. In the lower half of the System tab window, you can choose applications and even Dashboard widgets by turning on the boxes next to their names. (Expand the flippy triangles if necessary.) Those are the only programs these account holders will be allowed to use. (The new Search box helps you find certain programs without knowing their categories.)

  • Documents. Behind the scenes, this is your Home rightwards double arrow Documents folder. Of course, as a Simple Finder kind of soul, you don't have a visible Home folder. All your stuff goes in here.

  • Shared. This is the same Shared folder described on Section 12.6.2. It's provided so that you and other account holders can exchange documents. However, you can't open any of the folders here, only the documents.

  • Trash. The Trash is here, but you won't use it much. Selecting or dragging any icon is against the rules, so you're left with no obvious means of putting anything into your Trash.

Figure 12-6. The Simple Finder doesn't feel like home—unless you've got one of those Spartan, space-age, Dr. Evil–style pads. But it can be just the ticket for less-skilled Mac users, with few options and a basic one click interface. Every program in the My Applications folder is actually an alias to the real program, which is safely ensconced in the off-limits Applications folder.

The only programs with their own icons in the Dock are Finder and Dashboard.

Otherwise, you can essentially forget everything else you've read in this book. You can't create folders, move icons, or do much of anything beyond clicking the icons that your benevolent administrator has provided. It's as though Mac OS X moved away and left you the empty house.

  • To keep things extra-simple, Mac OS X permits only one window at a time to be open. It's easy to open icons, too, because one click opens it, not two.

  • The File menu is stunted, offering only a Close Window command. The Finder menu only gives you two options: About Finder and Run Full Finder. (The latter command prompts you for an administrator's user name and password, and then turns back into the regular Finder—a handy escape hatch. To return to Simple Finder, just choose Finder rightwards double arrow Return to Simple Finder.)

  • The [image] menu is really bare-bones: You can Log Out, Force Quit, or go to Sleep. That's it.

  • There's no trace of Spotlight.

Although the Simple Finder is simple, any program (at least, any that the administrator has permitted) can run from Simple Finder. A program running inside the Simple Finder still has all of its features and complexities—only the Finder has been whittled down to its essence.

In other words, Simple Finder is great for streamlining the Finder, but novices won't get far combating their techno-fear until the world presents us with Simple Keynote, Simple Mail, and Simple Microsoft Word. Still, it's better than nothing.

When Simple people try to save documents, they'll find that although the Save box lists the usual locations (Desktop, Applications, and so on), they can in fact save files only into their own Home folders or subfolders inside them.

12.3.1.2. Only allow selected applications

By tinkering with the checkboxes here, you can declare certain programs off-limits to this account holder, or turn off his ability to remove Dock icons, burn CDs, and so on.

You can restrict this person's access to the Mac in several different ways:

  • Limit the programs. At the bottom of the dialog box shown in Figure 12-5, you see a list of all the programs in your Applications folder (an interesting read in its own right). Only checked items show up in the account holder's Applications folder.

    Tip: If you don't see a program listed, use the Search box, or drag its icon from the Finder into the window.

    If, for instance, you're setting up an account for use in the classroom, you may want to turn off access to programs like Disk Utility, iChat, and Tomb Raider.

  • Limit the features. When you first create them, Standard account holders are free to burn CDs or DVDs, modify what's on the Dock, change their passwords, and view the settings of all System Preferences panels (although they can't change all of these settings).

Depending on your situation, you may find it useful to turn off some of these options. In a school lab, for example, you might want to turn off the ability to burn discs (to block software piracy). If you're setting up a Mac for a technophobe, you might want to turn off the ability to change the Dock (so your colleague won't accidentally lose access to his own programs and work).

12.3.2. Content (Dictionary and Web)

"Content," in this case, means "two options we really didn't have any other place to put." Actually, what it really means is Dictionary and Safari.

12.3.2.1. Hide profanity in Dictionary

As you know from Chapter 10, Mac OS X comes with a complete electronic copy of the New Oxford American Dictionary. And "complete," in this case, means "it even has swear words."

Turning on "Hide profanity in Dictionary" is like having an Insta-Censor™. It hides most of the naughty words from the dictionary whenever your young account holder is logged in (Figure 12-7).

Figure 12-7. Something's oddly missing from the Dictionary when Parental Controls are turned on: dirty words.

12.3.2.2. Web S ite Restrictions

This feature is designed to limit which Web sites your kid is allowed to visit.

Frankly, trying to block the racy stuff from the Web is something of a hopeless task; if your kid doesn't manage to get round this blockade by simply using a different browser, he'll just wind up seeing the dirty pictures at another kid's house. But at least you can enjoy the illusion of taking a stand, using approaches of three degrees of severity:

  • Allow unrestricted access to Web sites. In other words, no filtering. Anything goes.

  • Try to limit access to adult Web sites automatically. Those words—"try to"—are Apple's way of admitting that no filter is foolproof.

    In any case, Mac OS X comes with a built-in database of Web sites that it already knows may be inappropriate for children—and these sites won't appear in Safari while this account holder is logged in. By clicking Customize and then editing the "Always allow" and "Never allow" lists, you can override its decisions on a siteat-a-time basis.

  • Allow access to only these Web sites. This is the most restrictive approach of all: It's a whitelist, a list of the only Web sites your youngster is allowed to visit. It's filled with kid-friendly sites like Disney and Discovery Kids, but of course you can edit the list by clicking the + and–buttons below the list.

12.3.3. Mail & iChat

Here, you can build a list of email and chat addresses, corresponding to the people you feel comfortable letting your kid exchange emails and chat with. Click the + button below the list, type the address, press Enter, lather, rinse, and repeat.

Tip: No, you can't drag cards in from your Address Book; that would be much too simple. But after clicking the + button to create a new row in the list (in Edit mode), you can drag just the email address out of an Address Book card that you've opened up.

For reasons explained in a moment, turn on "Send permission emails to," and plug in your own email address.

Now then: When your youngster uses Apple's Mail program to send a message to someone who's not on the approved list, or tries to iChat with someone not on the list, he gets the message shown at top in Figure 12-8. If he clicks Ask Permission, then your copy of Mail shortly receives a permission-request message (Figure 12-8, middle); meanwhile, the outgoing message gets placed in limbo in his Drafts folder.

If you add that person's address to the list of approved correspondents, then the next time your young apprentice clicks the quarantined outgoing message in his Drafts folder, the banner across the top lets him know that all is well—and the message is OK to go out (Figure 12-8, bottom).

POWER USERS' CLINIC
Parental Remote Controls

It occurred to somebody at Apple that the new Parental Controls feature might be especially useful in a classroom. That person further realized that it'd be very cool if you could adjust the settings for Macs A, B, C, and D while seated at Mac E. That is, the teacher might prefer not to have to scurry from kid's desk to kid's desk to make changes.

And that's why you can operate Parental Controls from another Mac on the same network.

Phase 1: While seated at the first kid's Mac, open System Preferences; open Parental Controls; click the [image]; enter your password.

Now click the name of the account you want to manage remotely. Then, from the [image] menu below the list of accounts, choose Allow Remote Setup. Close System Preferences. Repeat for each account on each Mac that you'll want to manage from afar.

Phase 2: Go back to your teacher's desk. On your own Mac, choose Go rightwards double arrow Connect To Server. In the resulting dialog box, click Browse.

Now you get a list of the other Macs on the network. Click one and enter an administrator's name and password for that Mac.

Now open System Preferences, click Parental Controls, click the [image] , and then enter your password again. This time, you'll see a section in the Accounts list called Other Computers. Click the account name (on the kid's Mac) whose settings you want to change. Enter the administrator name and password of the remote computer one more time, and off you go!

Note: This feature doesn't attempt to stop email or chat using other programs, like Microsoft Entourage or Skype. If you're worried about your efforts being bypassed, block access to those programs using the Forbidden Applications list described above.

Figure 12-8. Top: If your kid tries to contact someone who's not on the Approved list, he can either give up or click Ask Permission.
Bottom: In the latter case, you'll know about it. If you're convinced that the would-be correspondent is not, in fact, a stalker, you can grant permission by clicking Always Allow.
Your young ward gets the good news the next time he visits his Drafts folder, where the message has been awaiting word from you, the Good Parent.

When your underling fires up iChat or Mail, she'll discover that her Buddy List is empty except for the people you've identified.

Handling the teenage hissy fit is your problem.

12.3.4. Time Limits

Clever folks, those Apple programmers. They must have kids of their own.

They realize that some parents care about how much time their kids spending front of the Mac, and some also care about which hours (Figure 12-9):

  • How much time. In the "Weekday time limits" section, turnon "Limit computer use to," and then adjust the slider. A similar slider appears for Weekend time limits.

  • Which hours. In the "Bedtime" section, turn on the checkbox for either "School nights" or "Weekend," and then set the hours of the day (or, rather, night) when the Mac is unavailable to your young account holders.

In other words, this feature may have the smallest pages-to-significance ratio in this entire book. Doesn't take long to explain it, but it could bring the parents of Mac addicts a lot of peace.

12.3.5. Logs

The final tab of the Parental Controls panel is Big Brother Central. Here's a complete rundown of what your kids have been up to. Its four categories—Websites visited, Websites blocked, Applications, and iChat—are extremely detailed. For example, in Applications, you can see exactly which programs your kids tried to use when, and how much time they spent in each one. Figure 12-10 shows the idea.

Figure 12-9. Top: If this account holder tries to log in outside of the time limits you specify here, she'll encounter only a box that says, "Computer time limits expired." She'll be offered a pop-up menu that grants her additional time, from 15 minutes to "Rest of the day"—but it requires your parental consent (actually, your parental password) to activate.
Bottom: Similarly, if she's using the Mac as her time winds down, she gets this message. Once again, you, the allknowing administrator, can grant her more time using this dialog box.

If you see something that you really think should be off limits—a site in the Websites Visited list, an application, an iChat session with someone—click its name and then click Restrict. You've just nipped that one in the bud.

Conversely, if the Mac blocked a Web site that you think is really OK, click its name in the list, and then click Allow. (And if you're wondering what a certain Web page is, click it and then click Open.)

Figure 12-10. These logs track everything your kid tried to do; it's spying, sure, but it's for the good of the child. (Right?) Use the popup menus at the top to change the time period being reported (Today, This Week, or whatever) and how they're grouped in the list—by date or by application/Web site.


editing_accounts.html

12.4. Editing Accounts

If you're an administrator, you can change your own account in any way you like.

If you have any other kind of account, though, you can't change anything but your picture and password. If you want to make any other changes, you have to ask an admin to log in, make the changes you want made to your account, and then turn the computer back over to you.

12.4.1. Deleting Accounts

Hey, it happens: Somebody graduates, somebody gets fired, somebody dumps you. Sooner or later, you may need to delete an account from your Mac.

When that time comes, click the account name in the Accounts list and then click the minus-sign button beneath the list. Mac OS X asks what to do with all of the dearly departed's files and settings (Figure 12-11):

  • Save the home folder in a disk image. This option presents the "I'll be back" approach. Mac OS X preserves the dearly departed's folders on the Mac, in a tidy digital envelope that won't clutter your hard drive, and can be reopened in case of emergency.

    In the Users rightwards double arrow Deleted Users folder, you find a disk image file (.dmg) like the ones described on Section 5.12. If you double-click it, a new, virtual disk icon named for the deleted account appears on your desktop. You can open folders and root through the stuff in this "disk," just as if it were a living, working Home folder.

    If fate ever brings that person back into your life, you can use this disk image to reinstate the deleted person's account. Start by creating a brand-new account. Then copy the contents of the folders in the mounted disk image (Documents, Pictures, Desktop, and so on) into the corresponding folders of the new Home folder.

  • Do not change the home folder. This time, Mac OS X removes the account, in that it no longer appears in the Login list or in the Accounts panel of System Preferences—but it leaves the Home folder right where it is. Use this option if you don't intend to dispose of the dearly departed's belongings right here and now.

    POWER USERS' CLINIC
    Moving Your Home Folder Between Computers

    Mac OS X proposes putting all of the account holders' Home folders in one special folder (Users) on the main hard drive. But being able to put your Home folder on a different disk can have its advantages, too. If you travel back and forth between home and work, for example, you might find it convenient to keep your entire life on an iPod or some other portable disk. In corporate environments, a network administrator may want you to keep your Home folder elsewhere on the Windows network. (Yes, Mac OS X is that compatible.)

    You can do it, but you'll have to exploit the sometimes intimidating power of NetInfo Manager, a program included with Mac OS X that's designed to let you perform just such technical tasks.

    Begin by copying your Home folder to the iPod (or wherever). To make absolutely sure that you're getting everything in it, use Terminal—described in Chapter 16. Open up a Terminal window and type this command:

        sudo ditto -rsrc "/Users/casey"
      "/Volumes/path-to-new-folder"

    Of course, type your account name instead of "casey," and the folder path instead of "path-to-new-folder." Use the folder-path notation described on Section 1.2.4.

    Now open the Accounts pane of System Preferences. Control-click (or right-click) your account's name; from the shortcut menu, choose Advanced Options.

    In the new Advanced Options dialog box, in the Home Directory box, type the folder path to your new home folder—or just click Choose and show Mac OS X where it is.

    Now restart the Mac. Log back in, and test the new Home-folder arrangement. If everything is working perfectly, you can delete the original from the internal hard drive.

    If your intention is to take the external hard drive back and forth to work, repeat the procedure on the Mac at work.

    Just make sure that the external drive is plugged in, powered up, and running before you try to log in; otherwise, the Mac won't be able to find the Home folder at all, and will give you an error message.

  • Delete the home folder. This button offers the "Hasta la vista, baby" approach. The account and all of its files and settings are vaporized forever, on the spot.

Note: If you delete a Shared Only account, you're not offered the chance to preserve the Home folder contents—because a Shared Only account doesn't have a Home folder.


setting_up_the_login_process.html

12.5. Setting Up the Login Process

Once you've set up more than one account, the dialog box shown in Figure 12-1 appears whenever you turn on the Mac, whenever you choose [image] rightwards double arrow Log Out, or whenever the Mac logs you out automatically (Section 12.9.3). But a few extra controls let you, an administrator, set up either more or less security at the login screen—or, put another way, build in less or more convenience.

POWER USERS' CLINIC
The Secret Account Options

Anyone who knows Mac OS X very well might object to one sentence in this section: "If you're an administrator, you can change your own account in any way you like."

Because everybody knows that there's one aspect of an account that even an admin can't change: the account's short name. Once that's created, it's yours forever, or at least until you delete the account.

Now, you won't find this feature listed on Apple's "300 New Leopard Features" Web page, but it's true: In Leopard, there's now a secret way to pick a different short name. You can't easily change the one you created originally, but you can create another one—shorter, more memorable—that also works when you're logging in or authenticating yourself.

To find it, Control-click (or right-click) the account's name in the list at the left side of the Accounts panel in System Preferences. From the shortcut menu, choose Advanced Options.

The strange and wonderful Advanced Options panel appears. Right there in the middle is a "Short name" box, but don't edit that; it won't work.

Instead, click the + button below the Aliases list. You're offered the chance to type in an alternative short name and then click OK. You can create as many of these aliases as you like.

When it's all over, click OK. The next time you log into your Mac, you can use your new, improved short name instead of the old one.

Rejoice that you lived to see the day.

Open System Preferences, click Accounts, and then click the Login Options button (Figure 12-12). Here are some of the ways you can shape the login experience for greater security (or greater convenience):

Figure 12-11. Top: This dialog box lets you know where to find the deleted account's material, should the need arise.
Bottom: The files and settings of accounts you deleted live on, in the Users rightwards double arrow Deleted Users folder.

  • Automatic login. This option eliminates the need to sign in at all. It's a timesaving, hassle-free arrangement if only one person uses the Mac, or if one person uses it most of the time.

    When you choose an account holder's name from this pop-up menu, you're prompted for his name and password. Type it and click OK.

    From now on, the dialog box shown in Figure 12-1 won't appear at all at startup time. After turning on the machine, you, the specified account holder, zoom straight to your desktop.

    Of course, only one lucky person can enjoy this express ticket. Everybody else must still enter their names and passwords. (And how can they, since the Mac rushes right into the Automatic person's account at startup time? Answer: The Automatic thing happens only at startup time. The usual login screen appears whenever the current account holder logs out—by choosing [image] rightwards double arrow Log Out, for example.)

  • Display login window as. Under normal circumstances, the login screen presents a list of account holders when you power up the Mac, as shown in Figure 12-1. That's the "List of users" option in action.

    If you're especially worried about security, however, you might not even want that list to appear. If you turn on "Name and password," each person who signs in must type both his name (into a blank that appears) and his password—a very inconvenient, but more secure, arrangement.

    Figure 12-12. These options make it easier or harder for people to sign in, offering various degrees of security. By the way: Turning on "Name and password" also lets you sign in as >console, a troubleshooting technique described on Section 10.30.7. It's also one way to sign in with the root account (Section 16.9), once you've activated it.

  • Show the Restart, Sleep, and Shut Down buttons. Truth is, the Mac OS X security system is easy to circumvent. Truly devoted evildoers can bypass the standard login screen in a number of different ways: restart in FireWire disk mode, restart at the Unix Terminal, and so on. Suddenly, these no-goodniks have full access to every document on the machine, blowing right past all of the safeguards you've so carefully established.

    One way to thwart them is to use FileVault (Section 12.9.2). Another is to turn off this checkbox. Now there's no Restart or Shut Down button to tempt mischief-makers. That's plenty of protection in most homes, schools, and workplaces; after all, Mac people tend to be nice people.

    But if you worry that somebody with a pronounced mean streak might restart simply by pulling the plug, then either use FileVault or set the Open Firmware password, as described in the box below.

  • Show Input menu in login window. If the Input menu (Section 9.13.3) is available at login time, it means that people who use non-U.S. keyboard layouts and alphabets can use the login features without having to pretend to be American.(It also means that you have a much wider universe of difficult-to-guess passwords, since your password can be in, for example, Japanese characters. Greetings, Mr. Bond-san.)

    POWER USERS' CLINIC
    The Firmware Password

    After all this discussion of security and passwords, it may come as a bit of a shock to learn that enterprising villains can bypass all of Mac OS X's security features in 10 seconds. If you haven't turned on FileVault, their nefarious options include using the Unix console described in Appendix B, using FireWire disk mode (Section 6.2), and so on.

    But there is one way to secure your Mac completely: by using the very secret, little known Firmware Password program.

    It's on your original Leopard DVD, in the Applications rightwards double arrow Utilities folder, just where it's been in previous Mac OS X versions—but in 10.5, Apple has made it invisible.

    Use TinkerTool (Section 17.1) to make the Finder show all hidden files and folders; then insert your Leopard DVD. Open the Applications rightwards double arrow Utilities folder that has magically appeared. You'll find the Firmware Password program inside. (On pre-Intel Macs, it's called Open Firmware Password. For the purposes of the features described here, however, it works identically.)

    When you run this utility, turn on "Require password to change firmware settings," as shown here. Then make up a master password that's required to start up from anything but the internal drive.

    Next, you're asked for an administrator's password. Finally, a message tells you, "The settings were successfully saved." Restart the Mac.

    From now on, whenever you attempt to start up in anything but the usual way, you're asked to type the Open Firmware password. For example, you see it when you press the C key to start up from a CD, or when you press Option to choose a different startup disk or partition.

    None of the usual startup-key tricks work. Holding down the C key to start up from a CD, holding down N to start up from a NetBoot server, pressing T to start up in Target Disk Mode, pressing D to start up from the installation DVD in diagnostic mode, pressing [image] -V to start up in Verbose mode, [image] -S to start up in Single-user mode, [image] -Option-P-R key to reset the parameter RAM, pressing Option to start up from a different system disk, pressing Shift to enter Safe Boot mode—none of it works without the master Open Firmware Password.

  • Show password hints. As described earlier, Mac OS X is kind enough to display your password hint ("middle name of the first person who ever kissed me") after you've typed it wrong three times when trying to log in. This option lets you turn off that feature for an extra layer of security. The hint will never appear.

  • Use VoiceOver at login window. The VoiceOver feature (Section 15.5.1.3) is all well and good if you're blind. But how are you supposed to log in? Turn on this checkbox, and VoiceOver speaks the features on the Login panel, too.

  • Enable fast user switching. This feature lets you switch to another account without having to log out of the first one, as described on Section 12.8.

  • View as. If you do, in fact, turn on Fast User Switching, a new menu appears at the upper-right corner of your screen, listing all the account holders on the machine. Thanks to this pop-up menu, you can now specify what that menu looks like. It can display the current account holder's full name (Name), the short name (Short Name), or only a generic torso-silhouette icon (Icon) to save space on the menu bar.


signing_in_logging_out.html

12.6. Signing In, Logging Out

Once somebody has set up your account, here's what it's like getting into, and out of, a Mac OS X machine. (For the purposes of this discussion, "you" are no longer the administrator—you're one of the students, employees, or family members for whom an account has been set up.)

12.6.1. Identifying Yourself

When you first turn on the Mac—or when the person who last used this computer chooses [image] rightwards double arrow Log Out—the login screen shown in Figure 12-1 appears. At this point, you can proceed in any of several ways:

  • Restart. Click if you need to restart the Mac for some reason. (The Restart and Shut Down buttons don't appear here if the administrator has chosen to hide them as a security precaution; see Section 12.5.)

  • Shut Down. Click if you're done for the day, or if sudden panic about the complexity of user accounts makes you want to run away. The computer turns off.

  • Log In. To sign in, click your account name in the list. If you're a keyboard speed freak, you can also type the first letter or two—or press the up or down arrow keys—until your name is highlighted. Then press Return or Enter.

    Either way, the password box appears now (if a password is required). If you accidentally click the wrong person's name on the first screen, you can click Back. Otherwise, type your password, and then press Enter (or click Log In).

    You can try as many times as you want to type the password. With each incorrect guess, the entire dialog box shudders violently from side to side, as though shaking its head "No." If you try unsuccessfully three times, your hint appears—if you've set one up. (If you see a strange [image] icon in the password box, guess what? You've got your Caps Lock key on, and the Mac thinks you're typing an all-capitals password.)

Tip: So what happens if you forget your password, and even the Mac's administrator doesn't know it? On your third attempt to type the password correctly, the Mac shows you your password hint (unless the administrator has turned off the Hint option) and a button called Reset Password. When you click it, the Mac asks for the master password (Section 12.9.2), which the administrator almost certainly knows.Once that's typed in, you're allowed to make up a new password for your own account (and, presumably, a better hint this time). No harm done.

Once you're in, the world of the Mac looks just the way you left it (or the way an administrator set it up for you). Everything in your Home folder, all your email and bookmarks, your desktop picture and Dock settings—all of it is unique to you. Your Home folder even contains its own Library folder, which maintains a separate (additional) set of fonts and preference settings just for you. Your Applications folder may even have programs that other account holders don't see.

INFREQUENTLY ASKED QUESTION
The Case of the Forgotten Password

Help—I forgot my password! And I never told it to anybody, so even the administrator can't help me!

No problem. Your administrator can simply open up System Preferences, click Accounts, click the name of the person who forgot the password, and then click Reset Password to re-establish the password.

But you don't understand. I am the administrator! And I'm the only account!

Aha—that's a different story. All right, no big deal. At the login screen, type a gibberish password three times. On the last attempt, the Mac will offer you the chance to reset the password. All you have to do is type in your master password (Section 12.9.2) to prove your credentials.

Um—I never set up a master password.

All right then. That's actually good news, because it means you didn't turn on FileVault. (If you had, and you'd also forgotten the master password, your account would now be locked away forever.)

Insert the Mac OS X DVD. Restart the Mac while pressing down the letter C key, which starts up the Mac from the DVD and launches the Mac OS X installer.

On the first installer screen, choose Installer rightwards double arrow Reset Password. When the Reset Password screen appears, click the hard drive that contains Mac OS X. From the first pop-up menu, choose the name of your account. Now make up a new password and type it into both boxes. Click Save, close the window, click the installer, and restart.

And next time, be more careful! Write down your password on a Post-it note and affix it to your monitor. (Joke—that's a joke!)

Unless you're an administrator, you're not allowed to install any new programs (or indeed, to put anything at all) into the Applications folder. That folder, after all, is a central software repository for everybody who uses the Mac, and the Mac forbids everyday account holders from moving or changing all such universally shared folders.

12.6.2. Logging Out

When you're finished using the Mac, choose [image] rightwards double arrow Log Out (or press Shift- [image] -Q). A confirmation message appears; if you click Cancel or press Esc, you return to whatever you were doing. If you click Log Out, or press Return, you return to the screen shown in Figure 12-1, and the entire sign-in cycle begins again.

Tip: If you press Option as you choose [image] rightwards double arrow Log Out (or as you press [image] -Q), the confirmation box doesn't appear.


sharing_across_accounts.html

12.7. Sharing Across Accounts

It's all fine to say that every account is segregated from all other accounts. It's nice to know that your stuff is safe from the prying eyes of your co-workers or family.

But what about collaboration? What if you want to give some files or folders to another account holder?

You can't just open up someone else's Home folder and drop it in there. Yes, every account holder has a Home folder (all in the Users folder on your hard drive). But if you try to open anybody else's Home folder, you'll see a tiny red [image] icon superimposed on almost every folder inside, telling you "Look, but don't touch."

Fortunately, there are a couple of wormholes between accounts (Figure 12-13):

FREQUENTLY ASKED QUESTION
Shared Data Files

My wife and my eight-year-old kid share my Mac. Over the years, we've amassed a fabulous collection of MP3 files, but at the moment, I'm the only one who sees them in iTunes. This business of separate environments for every account holder is all well and good, but what about when we want to access the same files—like our iTunes library?

The problem is that the iTunes library is stored in the Music folder of just one person. Fortunately, the solution is easy enough.

Whoever is the administrator—probably your eight-year-old—should move the iTunes folder (currently in somebody's Music folder) to the Users rightwards double arrow Shared folder. Now it's available to everybody.

At this point, each account holder can log in, fire up iTunes, choose iTunes rightwards double arrow Preferences rightwards double arrow Advanced, and click the Change button to choose the relocated iTunes Music folder in the Shared folder.

From now on, each person will be able to see and access the entire library of iTunes tunes, but will still enjoy the flexibility to build individual playlists.

  • The Shared folder. Sitting in the Users folder is one folder that doesn't correspond to any particular person: Shared. Everybody can freely access this folder, inserting and extracting files without restriction. It's the common ground among all the account holders on a single Mac. It's Central Park, the farmer's market, and the grocery-store bulletin board.

  • The Public folder. In your Home folder, there's a folder called Public. Anything you copy into it becomes available for inspection or copying (but not changing or deleting) by any other account holder, whether they log into your Mac or sign in from across the network.

    Figure 12-13. Top: In other people's Home folders, the Public and Sites folders are available for your inspection. These two folders contain stuff that other people have "published" for the benefit of their co-workers.
    Middle: In the Public folder is the Drop Box, which serves the opposite purpose. It lets anyone else who uses this Mac hand in files to you; they, however, can't see what's in it.
    Bottom: Inside the Users folder (to get there from a Home folder, press up arrow) is the Shared folder, a wormhole connecting all accounts. Everybody has full access to everything inside.

  • The Drop Box. And inside your Public folder is another cool little folder: the Drop Box. It exists to let other people give files to you, discreetly and invisibly to anyone else. That is, people can drop files and folders into your Drop Box, but they can't actually open it. This folder, too, is available both locally (in person) and from across the network.


fast_user_switching.html

12.8. Fast User Switching

The account system described so far in this chapter has its charms. It keeps everyone's stuff separate, it keeps your files safe, and it lets you have the desktop picture of your choice.

Unfortunately, it can go from handy to hassle in one split second. That's when you're logged in, and somebody else wants to duck in just for a second—to check email or a calendar, for example. What are you supposed to do—log out completely, closing all your documents and quitting all your programs, just so the interloper can look something up? Then afterward, you'd have to log back in and fire up all your stuff again, praying that your inspirational muse hasn't fled in the meantime.

Fortunately, that's all over now. Fast User Switching—a feature modeled on a similar Windows feature, which itself was modeled on a Unix feature—lets Person B log in and use the Mac for a little while. All of your stuff, Person A, simply slides into the background, still open the way you had it; see Figure 12-14.

When Person B is finished working, you can bring your whole work environment back to the screen without having to reopen anything. All your windows and programs are still open, just as you left them.

To turn on this feature, open the Accounts panel of System Preferences (and click the [image] , if necessary, to unlock the panel). Click Login Options, and turn on "Enable fast user switching." (You can see this dialog box in Figure 12-12.)

The only change you notice immediately is the appearance of your own account name in the upper-right corner of the screen (Figure 12-14, top). You can change what this menu looks like by using the "View as" pop-up menu, also shown in Figure 12-12.

That's all there is to it. Next time you need a fellow account holder to relinquish control so that you can duck in to do a little work, just choose your name from the Accounts menu. Type your password, if one is required, and feel guiltless about the interruption.

And now, the finer points of Fast User Switching:

  • Depending on how many programs are open and how much memory the Mac has, switching accounts may entail a delay and a good deal of hard drive activity. That's Mac OS X's virtual memory scheme "setting down" what was in memory in your account to make room for the incoming account's stuff.

  • To exit an open account, choose [image] rightwards double arrow Log Out as usual. Or just choose Login Window from the Accounts menu. It ensures that you can get to your own account no matter whose is running at the moment.

  • Weirdly enough, a bunch of account holders can be using the same program simultaneously in their own parallel universes. Even if Microsoft Word was open in your account, Chris, Casey, and Robin can each open the same copy of the same program simultaneously when they fast-switch into their own accounts. (Word, in that case, uses up four times as much memory, of course.)

    Figure 12-14. Top: The appearance of the Accounts menu lets you know that Fast User Switching is turned on. The circled checkmark indicates people who are already logged in, including those who have been "fast user switched" into the background. The dimmed name shows who's logged in right now.
    Bottom: When the screen changes from your account to somebody else's, your entire world slides visibly offscreen as though it's mounted on the side of a rotating cube—a spectacular animation made possible by Mac OS X's Quartz Extreme graphics software.

  • You can't make changes to accounts (in System Preferences) that are still logged in. Nor, as you'd expect, can you turn off Fast User Switching while other people are logged in. Can't turn on FileVault, either.

  • If you try to shut the Mac down or rest art it while other people are logged in, a dialog box tells you, "There are currently logged in users who may lose unsaved changes if you shut down this computer." And you're asked to type in an administrator's name and password to establish that you know what the heck you're doing.

    Here's a moral dilemma for the modern age. If you proceed by typing the password and clicking Shut Down, you shut down all accounts that were open in the background and any open documents—and if those documents hadn't been saved, any changes are gone forever. If you click Cancel, you can't shut down the Mac until you hunt down the account holders whose stuff is still open in the background so they can log out.

    Tip: You can avoid this awkward situation in either of two ways: (1) Trust each other completely, or (2) save all your documents before you let anyone else cut in and send your account to the background.

  • Remember the Shared folder (in the Users folder on the hard drive)? It's still the wormhole connecting all accounts. If you want to share a file with another account holder, put it there.

  • Your account isn't anesthetized completely when it's switched into the background. In fact, it keeps on doing whatever you set it to doing. If you were downloading some big file, for example, it keeps right on downloading when the next guy logs in.


six_mac_os_x_security_shields.html

12.9. Six Mac OS X Security Shields

Mac OS X has a spectacular reputation for stability and security. At this writing, not a single Mac OS X virus has emerged—a spectacular feature that makes Windows look like a waste of time. There's no Windows-esque plague of spyware, either (downloaded programs that do something sneaky behind your back). In fact, there isn't any Mac spyware.

The usual rap is, "Well, that's because Windows is a much bigger target. What virus writer is going to waste his time on a computer with eight percent market share?"

That may be part of the reason Mac OS X is virus-free. But Mac OS X has also been built more intelligently from the ground up. Listed below are a few of the many drafty corners of a typical operating system that Apple has solidly plugged:

  • The original Windows XP came with five of its ports open. Mac OS X has always come from the factory with all of them shut and locked.

    Ports are channels that remote computers use to connect to services on your computer: one for instant messaging, one for Windows XP's remote-control feature, and so on. It's fine to have them open if you're expecting visitors. But if you've got an open port that exposes the soft underbelly of your computer without your knowledge, you're in for a world of hurt. Open ports are precisely what permitted viruses like Blaster to infiltrate millions of PCs. Microsoft didn't close those ports until the Windows XP Service Pack 2.

  • Whenever a program tried to install itself in the original Windows XP, the operating system went ahead and installed it, potentially without your awareness.

    In Mac OS X, that never happens. You're notified at every juncture when anything is trying to install itself on your Mac. In fact, you're even notified when you're opening a disk image or .zip file that could contain an installable program (Figure 12-15).

    Figure 12-15. Mac OS X hovers like a stage mother, always informing you when you're at a point where something virusy could be happening. It warns you when you download a compressed file that could contain a runnable program (top), and even when an installer has to run a tiny subprogram before the installation (bottom).

  • Unlike certain other operating systems, Mac OS X doesn't even let an a dministrator touch the files that drive the operating system itself without pestering you to provide your password and grant it permission to do so. A Mac OS X virus (if there were such a thing) could theoretically wipe out all of your files, but wouldn't be able to access anyone else's stuff—and couldn't touch the operating system itself.

  • You probably already know about the Finder's Secure Empty Trash option (Section 2.6.2). But an option on the Erase tab of the Disk Utility program can do the same super-erasing of all free space on your hard drive. We're talking not just erasing, but recording gibberish over the spots where your files once were—once, seven times, or thirty-five times—utterly shattering any hope any hard-disk recovery firm (or spy) might have had of recovering passwords or files from your hard drive.

  • Safari's Private Browsing mode means that you can freely visit Web sites without leaving any digital tracks—no history, no nothing (Section 20.1.5).

  • Every time you try to download something, either in Safari or Mail, that contains executable code (a program, in other words), a dialog box warns you that it could conceivably harbor a virus—even if your download is compressed as a .zip or .sit file (Figure 12-16).

Figure 12-16. And still more warnings. This operating system intends to make darned sure no program ever runs without your knowledge (which is how Windows PCs get viruses and spyware).
It tries to protect you, for example, when you double-click a document and the required program opens for the first time (top). It also warns you the first time you double-click any program that came from the Internet (bottom).

Those are only a few tiny examples. Here are a few of Mac OS X's big-ticket defenses.

12.9.1. The Firewall

If you have a broadband, always-on connection, you're open to the Internet 24 hours a day. It's theoretically possible for some cretin to use automated hacking software to flood you with files or take control of your machine. Mac OS X's firewall feature puts up a barrier to such mischief.

Fortunately, it's not a complete barrier. One of the great joys of having a computer is its ability to connect to other computers. Living in a cement crypt is one way to avoid getting infected, but it's not much fun.

So if you open the Security panel of System Preferences, and click the Firewall tab, you see something like Figure 12-17 at top. It offers three settings:

  • "Allow all incoming connections" is the same as having no firewall at all. Now, most of the Internet's cretins are far more interested in tapping into Windows machines than Macs, but you never know. Best to avoid this one.

  • "Allow only essential services" is the closest thing Leopard has to "block everything." It gives access only to a small, fixed set of deep-seated services that Mac OS X needs to get by.

  • "Set access for specific services and applications" is the best choice for most people. It blocks all incoming pings except those addressed to programs and features that you've approved.

And how do they get approved? Above the horizontalline (Figure 12-17,top), features of Mac OS X itself are listed. They get added to this list automatically when you turn them on in System Preference: File Sharing, Printer Sharing, and so on.

Non-Apple programs can request passage through your firewall, too (Figure 12-17, bottom); if you click Always Allow, they appear below the line in this list.

Now, there are a few footnotes regarding the firewall:

Figure 12-17. Top: Apple's new firewall in Mac OS X 10.5 looks like this.
It lists the programs that have been given permission to receive communications from the Internet. At any point, you can change a program's Block/ Allow setting, as shown here.
Bottom: From time to time, some program will ask for permission to communicate with its mother ship. If it's a program you trust, click Always Allow.
You can also click the + button to navigate your Applications folder and manually choose programs for inclusion.
For more power and flexibility, install a shareware program like Firewalk or Brickhouse (available from www.missingmanuals.com, for example).

  • If you're using Mac OS X's Internet connection sharing feature (Section 18.5.4), then it's important to turn on the firewall only for the first Mac—the one that's the gateway to the Internet. Leave the firewall turned off on all the Macs "downstream" from it. You want to protect your Macs from the nasties of the Internet; you don't need them giving each other the cold shoulder.

  • Similarly, ifyou've bought a router to distribute your Internet connection to multiple computers, it probably has its own firewall circuitry built in. In that case, you can turn off Mac OS X's own firewall.

  • Two useful features are hiding behind the Advanced button(which is visible in Figure 12-17):

    Enable Stealth Mode is designed to slam shut the Mac's back door to the Internet. See, hackers often use automated hacker tools that send out "Are you there?" messages. They're hoping to find computers that are turned on and connected full-time to the Internet. If your machine responds, and they can figure out how to get into it, they'll use it, without your knowledge, as a relay station for pumping out spam or masking their hacking footsteps.

    Enable Stealth Mode, then, makes your Mac even more invisible on the network; it means that your Mac won't respond to the electronic signal called a ping. (On the other hand, you won't be able to ping your machine, either, when you're on the road and want to know if it's turned on and online.)

    Enable Firewall Logging creates a little text file where Mac OS X records every attempt that anyone from the outside makes to infiltrate your Mac. (To view the log, click the Open Log button. The file opens in Console for your inspection.)

12.9.2. FileVault

The Security pane of System Preferences is one of Leopard's most powerful security features. Understanding what it does, however, may take a little slogging.

As you know, the Mac OS X accounts system is designed to keep people out of each other's stuff. Ordinarily, for example, Chris isn't allowed to go rooting through Robin's stuff.

Until FileVault came along, though, there were all kinds of ways to circumvent this protection system. A sneak or a showoff could:

  • Start up your Mac (if it's a pre-2003 model) in Mac OS 9, which knows nothing about Mac OS X permissions.

  • Start up the Mac in FireWire disk mode (Section 6.2).

  • Remove the hard drive and hook it up to a Linux machine or another Mac.

In each case, they'd then be able to run rampant through everybody's files, changing or trashing them with abandon. For people with sensitive or private files, the result was a security hole bigger than Steve Jobs' bank account.

FileVault is an extra line of defense. When you turn on this feature, your Mac automatically encrypts (scrambles) everything in your Home folder, using something called AES-128 encryption. (How secure is that? It would take a password-guessing computer 149 trillion years before hitting paydirt. Or, in more human terms, slightly longer than two back-to-back Kevin Costner movies.)

This means that unless someone knows (or can figure out) your password, FileVault renders your files unreadable for anyone but you and your computer's administrator—no matter what sneaky tricks they try to pull.

You won't notice much difference when FileVault is turned on. You log in as usual, clicking your name and typing your password. Only a slight pause as you log out indicates that Mac OS X is doing some housekeeping on the encrypted files: freeing up some space and/or backing up your home directory with Time Machine.

Tip: This feature is especially useful for laptop owners. If someone swipes or "borrows" your laptop, they can't get into your stuff without the password.

Here are some things you should know about FileVault's protection:

  • It's useful only if you've logged out. Once you're logged in, your files are accessible. If you want the protection, log out before you wander away from the Mac. (Or let the screen saver close your account for you; see Section 12.9.3.)

  • It covers only your Home folder. Any thing in your Applications, System, or Library folders is exempt from protection.

  • An administratorcan access your files, too. According to Mac OS X's caste system, anyone with an administrator's account can theoretically have unhindered access to his peasants' files—even with FileVault on—if that administrator has the master password described below.

  • It keep so ther people from opening your files, not from deleting them. It's still possible for someone to trash all your files, without ever seeing what they are. There's not much you can do about this with FileVault on or off—all a malicious person needs to do is start deleting the encrypted files, and your data is gone. (FileVault works by encrypting your Home folder into eight-megabyte chunks.)

  • Shared folders in your Home folder will no longer be available on the network. That is, any folders you've shared won't be available to your co-workers except when you're at your Mac and logged in.

  • Backup programs may throw a tizzy. FileVault's job is to "stuff " and "unstuff " your Home folder as you log in and out. Backup programs that work by backing up files and folders that have changed since the last backup may therefore get very confused.

    Even Time Machine (Chapter 6) doesn't always play well with FileVault. For one thing, it can copy the encrypted Home folder only when it's closed—that is, when you're logged off. So you don't get the continuous hourly backups that everyone else gets.

    Second, in times of tragedy, Time Machine can restore only your entire Home folder; you can't recover individual documents or folders in it.

  • It's only as secure as your password. If someone can figure out your account's password, they can bypass FileVault for your account. Even more seriously, if someone can figure out the master password (see below), they can bypass FileVault for every account on your computer.

  • If you for get your password and your administrator forgets the master password, you're toast. If this happens, your data is permanently lost. You'll have no choice but to erase your hard drive and start from scratch.

To turn FileVault on, proceed like this:

  1. In System Preferences, click Security, and then click FileVault. Click Set Master Password.

    If you're the first person to try to turn on FileVault, you need to create a master password first.

    The master password is an override password that gives an administrator full power to access any account, even without knowing the account holder's password, or to turn off FileVault for any account.

    The thinking goes like this: Yeah, yeah, the peons with Standard accounts forget their account passwords all the time. But with FileVault, a forgotten password would mean the entire Home folder is locked forever—so Apple gave you, the technically savvy administrator, a back door. (And you, the omniscient administrator, would never forget the master password—right?)

    When you click Set Master Password, the dialog box shown at top in Figure 12-18 appears.

  2. Click "Turn On FileVault."

    You'll see an error message if other account holders are simultaneously logged in (using Fast User Switching). Otherwise, you're asked to type your account password. An explanatory dialog box appears offering some options.

    If you select the "Use secure erase" option, Mac OS X works harder when it erases files that you delete, and that makes it harder for the bad guys to obtain the encrypted data even if they kidnap your computer.

    If you select "Use secure virtual memory," Mac OS X also encrypts the contents of virtual memory (Section 12.9.5.4). (All accounts share the same virtual-memory files in Mac OS X, so an evil hacker with sophisticated tools could conceivably analyze the virtual-memory files on your Mac to see what's in the documents you have open on the screen.)

    Note: You can also turn on FileVault for an account at the moment you create it in System Preferences rightwards double arrow Accounts.

  3. Click "Turn On FileVault" again.

    Figure 12-18. Top: To turn on FileVault for an account, you must start by making up a master password: a skeleton key that can get you into somebody's account even if they forget their password. (You have no idea how often this happens.)
    Type in your master password twice, and give yourself a hint
    Bottom: When you click OK, you see that the Security dialog box now says, "A master password is set for this computer." In the event of an emergency, you'll get the hint when you click an account name at the Login screen, and then click Reset Password.
    Now you can click Turn On FileVault to begin the encryption process.

    Now Mac OS X logs you out of your own account. (It can't encrypt a folder that's in use.) Some time passes while it converts your Home folder into a protected state, during which you can't do anything but wait.

    After a few minutes, you arrive at the standard login window, where you can sign in as usual, confident that your stuff is securely locked away from anyone who tries to get at it when you're not logged in.

Note: To turn off FileVault, open System Preferences, click Security, and then click Turn Off FileVault. Enter your password and click OK. (The master password sticks around once you've created it, however, in case you ever want to turn FileVault on again.)

12.9.3. Logout Options

As you read earlier in this chapter, the usual procedure for finishing up a work session is for each person to choose [image] rightwards double arrow Log Out. After you confirm your intention to log out, the Login screen appears, ready for the next victim.

But sometimes people forget. You might wander off to the bathroom for a minute, but run into a colleague there who breathlessly begins describing last night's date and proposes finishing the conversation over pizza. The next thing you know, you've left your Mac unattended but logged in, with all your life's secrets accessible to anyone who walks by your desk.

You can prevent that situation using either of two checkboxes, both in the Security panel of System Preferences:

  • Require password to wake this computer from sleep or screen saver. This option gives you a password-protected screen saver that locks your Mac after a few minutes of inactivity. Now, whenever somebody tries to wake up your Mac after the screen saver has appeared (or when the Mac has simply gone to sleep according to your settings in the Energy Saver panel of System Preferences), the "Enter your password" dialog box appears. No password? No access.

    UP TO SPEED
    Password Hell

    With the introduction of the master password, you now have quite a few different passwords to keep straight. Each one, however, has a specific purpose:

    Account password. You type this password in at the normal login screen. You can't get into anyone else's account with it—only yours. Entering this password unlocks FileVault, too.

    Administrator password. You're asked to enter this password whenever you try to install new software or modify certain system settings. If you're the only one who uses your computer (or you're the one who controls it), your administrator password is your account password. Otherwise, you're supposed to go find an administrator (the parent, teacher, or guru who set up your account to begin with), and ask that person to type in his name and password once he's assessed what you're trying to do.

    Master password. Think of this password as a master key. If anyone with FileVault forgets her account password, the administrator who knows the master password can unlock the account. The master password also lets an administrator change an account's password right at the Login screen, whether FileVault is turned on or not.

    Root password. This password is rarely useful for anything other than Unix hackery, as described on Section 16.9.

  • Log out after __ minutes of inactivity. If you prefer, you can make the Mac sign out of your account completely if it figures out that you've wandered off (and it's been, say, 15 minutes since the last time you touched the mouse or keyboard). Instead, it presents the standard Login screen.

Note: Beware! If there are open, unsaved documents at the moment of truth, the Mac can't log you out.

12.9.4. The Password Assistant

Plenty of software features require you to make up a password: Web sites, accounts, networked disks, and so on. No wonder most people wind up trying to use the same password in as many situations as possible. Worse, they use something easily guessable like their names, kids' names, spouse's names, and so on. Even regular English words aren't very secure, because hackers routinely use dictionary attacks—software that tries to guess your password by running through every word in the dictionary—to break in.

To prevent evildoers from guessing your passwords, Leopard comes with a goodpassword suggestion feature called the Password Assistant. It cheerfully generates one suggestion after another for impossible-to-guess passwords. (recharges8@exchangeability, anyone?)

Fortunately, you won't have to remember most ofthem, thanks to the Keychain passwordmemorizing feature described at the end of this chapter. (The only password you have to memorize is your account password.)

See Figure 12-19 for details on the Password Assistant.

Figure 12-19. Any place you're supposed to make up a password, including in the Accounts pane of System Preferences, a key icon appears. When you click it, the Password Assistant opens. Use the pop-up menu and the Length slider to specify how long and unguessable the password is. The Quality graph shows you just how tough it is to crack this password.
(In the Type pop-up menu, you might wonder about FIPS-181. It stands for the Federal Information Processing Standards Publication 181, which sets forth the U.S. government's standard for password-generating algorithms.)

12.9.5. The Keychain

The information explosion of the computer age may translate into bargains, power, and efficiency, but as noted above, it carries with it a colossal annoyance: the proliferation of passwords we have to memorize. Shared folders on the network, Web sites, your iDisk, FTP sites—each requires another password.

Apple has done the world a mighty favor with its Keychain feature. The concept is brilliant. Whenever you log into Mac OS X and type in your password, you've typed the master code that tells the computer, "It's really me. I'm at my computer now. "From that moment on, the Mac automatically fills in every password blank you encounter, whether it's a Web site in Safari or Opera, a shared disk on your network, a wireless network, an encrypted disk image, or an FTP program like Transmit or RBrowser. With only a few exceptions, you can safely forget all of your passwords except your login password.

These days, all kinds of programs and services know about the Keychain and offer to store your passwords there. For example:

  • In Safari, whenever you type your name and password for a certain Web page and then click OK, a dialog box asks: "Would you like to save this password?" (See Figure 12-20, top.)

    Note: This offer is valid only if, in Safari rightwards double arrow Preferences, you've clicked the AutoFill tab and turned on "User names and passwords." If not, the "Would you?" message never appears.Note, too, that some Web sites use a nonstandard login system that also doesn't produce the "Would you?" message. Unless the Web site provides its own "Remember me" or "Store my password" option, you're out of luck; you'll have to type in this information with every visit.

  • When you connect to a shared folder or disk on the network, the opportunity to save the password in your Keychain is equally obvious (Figure 12-20, bottom).

  • You also see a "Remember password (add to Keychain)" option when you create an encrypted disk image using Disk Utility.

  • Apple's Mail program stores your email account passwords in your Keychain. Your .Mac account information is stored there, too (on the .Mac pane of System Preferences).

  • Microsoft's Entourage program offers to store your passwords. So do FTP (filetransfer) programs like RBrowser and Fetch; check their Preferences dialog boxes.

  • A "Remember password"option appears when you type in the password for a wireless network or AirPort base station.

  • The iTunes program memorizes your Apple Music Store password, too.

12.9.5.1. Locking and unlocking the Keychain

If you work alone, the Keychain is automatic, invisible, and generally wonderful. Logging in is the only time you have to type a password. After that, the Mac figures,"Hey, I know it's you; you proved it by entering your account password. That ID is good enough for me. I'll fill in all your other passwords automatically." In Apple parlance, you've unlocked your Keychain just by logging in.

Figure 12-20. Top: Safari is one of several Internet-based programs that offer to store your passwords in the Keychain; just click Yes. The next time you visit this Web page, you'll find your name and password already typed in.
Middle: At any time, you can see a complete list of the memorized Web passwords by choosing Safari rightwards double arrow Preferences, clicking AutoFill, and then clicking the Edit button next to "User names and passwords." This is also where you can delete a password, thus making Safari forget it.
Bottom: When you connect to a server (a shared disk or folder on the network), just turn on "Remember this password in my keychain."

But there may be times when you want the Keychain to stop filling in all of your passwords, perhaps only temporarily. Maybe you work in an office where someone else might sit down at your Mac while you're getting a candy bar.

Of course, you can have Mac OS X lock your Mac—Keychain and all—after a specified period of inactivity (Section 12.9.3).

If you want to lock the Keychain manually, so that no passwords are autofilled in until you unlock it again, you can use any of these methods. Each requires the Keychain Access program (in your Applications rightwards double arrow Utilities folder):

  • Lock the Keychain manually. In the Keychain Access program, choose File rightwards double arrow Lock Keychain [Your Name] ( [image] -L), or just click the big padlock at upper left. Click the Lock button in the toolbar of the Keychain Access window (Figure 12-21).

  • Choose Lock Keychain [Your Name] from the Keychain menulet. To put the Keychain menulet on your menu bar, open Keychain Access, choose Keychain Access rightwards double arrow Preferences. In Preferences, click General, and then turn on Show Status in Menu Bar.

  • Lock the Keychain automatically. In the Keychain Access program, choose Edit rightwards double arrow Change Settings for Keychain [your name]. The resulting dialog box lets you set up the Keychain to lock itself, say, five minutes after the last time you used your Mac, or whenever the Mac goes to sleep. When you return to the Mac, you're asked to re-enter your account password in order to unlock the Keychain, restoring your automatic-password feature.

Whenever the Keychain is locked, Mac OS X no longer fills in your passwords.

Note: As noted above, you unlock your Keychain using the same password you use to log into Mac OS X, but that's just a convenience. If you're really worried about security, you can choose Edit rightwards double arrow Change Password for Keychain [your name], thereby establishing a different password for your Keychain, so that it no longer matches your login password.Of course, doing so also turns off the automatic-Keychain-un locking-when-you-log-in feature.
12.9.5.2. Managing Keychain

To take a look at your Keychain, open the Keychain Access program. By clicking one of the password rows, you get to see its attributes—name, kind, account, and so on (Figure 12-21).

Tip: The primary purpose of the Keychain is, of course, to type in passwords for you automatically. However, it's also an excellent place to record all kinds of private information just for your own reference: credit card numbers, ATM numbers, and so on. Simply choose File rightwards double arrow New Password Item (if it's a name and password) or File rightwards double arrow New Secure Note (if you just want to type a blob of very, very private text).No, the Mac won't type them in for you automatically anywhere, but it does maintain them in one central location that is, itself, password-protected.

Figure 12-21. In the main Keychain list, you can doubleclick a listing for more details about a certain password—including the actual password it's storing.
To see the password, turn on "Show password." The first time you try this, you're asked to prove your worthiness by entering your Keychain password (usually your account password). If you then click Always Allow, you won't be bothered for a password-to-see-thispassword again.

12.9.5.3. Multiple Keychains

By choosing File rightwards double arrow New Keychain, you can create more than one Keychain, each with its own master password. On one hand, this might defeat the simplicity goal of the Keychain. On the other hand, it's conceivable that you might want to encrypt all of your business documents with one master password, and all of your personal stuff with another, for example.

If you do have more than one Keychain, you can view all of them by clicking the little Show Keychains button at the lower-left corner of the Keychain Access window; now you see a list of all your Keychains (including some maintained by Microsoft Office and Mac OS X itself). Click their names to switch among them.

12.9.5.4. Keychain files

Keychains are represented by separate files in your Home rightwards double arrow Library rightwards double arrow Keychains folder. Knowing that can be handy when you want to delete a Keychain or copy it to another Mac—your laptop, for example. (Then again, the File rightwards double arrow Export command may be even more convenient.)

12.9.6. Secure Virtual Memory

Virtual memory is a trick that computers use to keep a lot of programs open at once—more, in fact, than they technically have enough memory (RAM) for. How do they manage keeping so many software balls in the air? Easy: They set some of them down on the hard drive.

When you bring Photoshop to the front, Mac OS X frees up the necessary memory for it by storing some of the background programs' code on the hard drive. When you switch back to, say, Safari, Mac OS X swaps Photoshop for the Safari code it needs from the hard drive, so that the frontmost program always has full command of your actual memory.

Sophisticated software snoopers could, in theory, sneak up to the Mac while you're logged in but away from your desk. Using a built-in Unix command called strings, the no-goodniks could actually read what's stored on the hard drive in that virtualmemory swap file—in particular, your passwords.

But the "Use secure virtual memory"checkbox (on theSecurity pane of System Preferences) takes away all their fun; it encrypts your virtual memory swap file so nobody can read it. (You may also find that it slows down your Mac, though, especially when you switch from one program to another.)


networking_file_sharing_and_screen_sharing.html

Chapter 13. Networking, File Sharing, and Screen Sharing

Just about every Mac ever built is network-ready. Buy a couple of components, and you can connect all the computers in your office together, with or without wires. The process of rigging the hardware and software for a network is somewhat more technical than, say, emptying the Trash, but it's not exactly rocket science.

Once you've got a network, you can copy files from one machine to another —even between Windows PCs and Macs—just as you'd drag files between folders on your own Mac. You can send little messages to each other's screens. Everyone on the network can consult the same database or calendar. You can play games over the network. You can share a single printer, cable modem, or fax modem among all the Macs in the office. You can connect to this network from wherever you are in the world, using the Internet as the world's longest extension cord back to your office.

And in Mac OS X 10.5, you can even do screen sharing, which means that you, the wise computer whiz, can see what's on the screen of your pathetic, floundering relative or buddy elsewhere on the network. You can even seize control of the other Mac's mouse and keyboard. You can troubleshoot, fiddle with settings, and so on. It's the next best thing to being there —and often a lot better than being there.

Tip: You don't necessarily need a network to exchange files between Macs (and even PCs). If each computer is equipped with Bluetooth circuitry, they can shoot files back and forth wirelessly, as described on Section 6.2.6.1.

This chapter concerns itself with local networking —setting up a network in your home or small office. But don't miss its sibling, Chapter 18, which is about hooking up to the somewhat larger network called the Internet.

13.1. Wiring the Network

Most people connect their computers using one of two connection systems: Ethernet or Wi-Fi (which Apple calls AirPort).

13.1.1. Ethernet Networks

These days, every Mac and every network-ready laser printer has an Ethernet jack on the back or side panel (see Figure 13-1). If you connect all of the Macs and Ethernet printers in your small office to a central Ethernet hub or router —acompact, inexpensive box with jacks for 5, 10, or even more computers and printers —you've got yourself a very fast, very reliable network. (Most people wind up hiding the hub in a closet, and running the wiring either along the edges of the room or inside the walls.) You can buy Ethernet cables, plus the hub, at any computer store or, less expensively, from an Internet-based mail-order house. (Hubs aren't Mac-specific.)

Tip: If you want to connect only two Macs —say, your laptop and your desktop machine —you don't need an Ethernet hub. Instead, you just need a standard Ethernet cable. Run it directly between the Ethernet jacks of the two computers. (You don't need a special crossover Ethernet cable, as you did with Macs of old.) Then connect the Macs as described in the box on Section 13.1.2.Or don't use Ethernet at all; just use a FireWire cable or a person-to-person AirPort network.

Figure 13-1. Every Mac OS X–compatible Mac has an Ethernet jack (left). It looks like an overweight telephone jack. It connects to an Ethernet router or hub (right) via an Ethernet cable (also known as Cat 5 or Cat 6), which ends in what looks like an overweight telephone-wire plug (also known as an RJ-45 connector).

Ethernet is the best networking system for many offices. It's fast, easy, and cheap.

13.1.2. AirPort Networks

Wi-Fi, known to the geeks as 802.11 and to Apple fans as AirPort, means wireless networking. It's the technology that lets laptops the world over get online at high speed in any Wi-Fi "hot spot." Hot spots are everywhere these days: in homes, offices, coffee shops (notably Starbucks), hotels, airports, and thousands of other places.

Tip: At www.jiwire.com, you can type in an address or a city and learn exactly where to find the closest Wi-Fi hot spots.

When you're in a Wi-Fi hot spot, your Mac has a very fast connection to the Internet, as though it's connected to a cable modem or DSL.

AirPort circuitry comes preinstalled every Mac laptop, iMac, and Mac Mini, and you can order it built into a new Mac Pro.

This circuitry lets your machine connect to your network and the Internet without any wires at all. You just have to be within about 150 feet of a base station or (as Windows people call it) access point, which must in turn be physically connected to your network and Internet connection.

If you think about it, the AirPort system is a lot like a cordless phone, where the base station is, well, the base station, and the Mac is the handset.

The base station can take any of these forms:

  • AirPort base station. Apple's sleek, white, squarish or rounded base stations ($100 to $180) permit as many as 50 computers to connect simultaneously.

    UP TO SPEED
    AirPort a, b, g, and n: Regular or Supersized?

    In the short history of wireless networking, Wi-Fi gear has come in several variants, bearing the absurdly user-hostile names 802.11b, 802.11g, 802.11a, 802.11n, and so on.

    The difference involves the technical specs of the wireless signal. Original AirPort uses the 802.11b standard; AirPort Extreme uses 802.11g; the current AirPort cards and base stations use 802.11n.

    So what's the difference? Equipment bearing the "b" label transfers data through the air at up to 11 megabits per second; the "g" system is almost five times as fast (54 Mbytes/sec); and "n" is supposed to be four times as fast as that.

    (Traditionally, geeks measure network speeds in megabits, not megabytes. If you're more familiar with megabytes, though, here's a translation: The older AirPort gear has a top speed of 1.4 megabytes per second, versus more than 6 megabytes per second for the AirPort Extreme stuff.)

    (Oh, and while we're using parentheses here: The only place you'll get the quoted speeds out of this gear is when you're on the moon. Here on earth, signal strength is affected by pesky things like air, furniture, walls, floors, wiring, phone interference, and antenna angle. Speed and signal strength diminish proportionally as you move away from the base station.)

    Now, each successive version of the Wi-Fi base station/laptop circuitry standard is backward-compatible. For example, you can buy a new, 802.11n base station, and still connect to it from your ancient 802.11g PowerBook. You won't get any greater speed, of course —that would require a laptop with an 802.11n transmitter —but you'll enjoy the greater range in your house.

    It's important to understand, though, that even the most expensive, top-tier cable modem or DSL service delivers Internet information at only about half a megabyte per second. The bottleneck is the Internet connection, not your network. Don't buy newer AirPort gear thinking that you're going to speed up your email and Web activity.

    Instead, the speed boost you get with AirPort Extreme is useful only for transferring files between computers and gadgets on your own network (like the bandwidth-hungry Apple TV) —and playing networkable games.

    And one more note: All Wi-Fi gear works together, no matter what kind of computer you have. There's no such thing as a "Windows" wireless network or a "Macintosh" wireless network. Macs can use non-Apple base stations, PCs can use AirPort base stations, and so on.

    The less expensive one, the AirPort Express, is so small that it looks like a small white power adapter. It also has a USB jack so you can share a USB printer on the network. It can serve up to 10 computers at once.

  • A wireless broadband router. Lots of other companies make less expensive Wi-Fi base stations, including Linksys (www.linksys.com) and Belkin (www.belkin.com). You can plug the base station into an Ethernet router or hub, thus permitting 10 or 20 wireless-equipped computers, including Macs, to join an existing Ethernet network without wiring. (With all due non-fanboyism, however, Apple's base stations and software are infinitely more polished and satisfying to use.)

    Tip: It's perfectly possible to plug a Wi-Fi base station into a regular router, too, to accommodate both wired and wireless computers.

  • Another Mac. Your Mac can also impersonate an AirPort base station. In effect, the Mac becomes a software-based base station, and you save yourself the cost of a separate physical base station.

A few, proud people still get online by dialing via modem, which is built into some AirPort base station models. The base station is plugged into a phone jack. Wireless Macs in the house can get online by triggering the base station to dial by remote control.

Tip: If you connect through a modern router or AirPort base station, you already have a great firewall pro tecting you. You don't have to turn on Mac OS X's firewall.

For the easiest AirPort network setup, begin by configuring your Mac so that it can go online the wired way, as described in the previous pages. Once it's capable of connecting to the Internet via wires, you can then use the Airport Utility (in your Applications rightwards double arrow Utilities folder) to transmit those Internet settings wirelessly to the base station itself. From then on, the base station's modem or Ethernet jack —not your Mac's —will do the connecting to the Internet.

GEM IN THE ROUGH
Networking Without the Network

In a pinch, you can connect two Macs without any real network at all. You can create an Ethernet connection without a hub or a router —or an AirPort connection without a Wi-Fi base station.

To set up the wired connection, just run a standard Ethernet cable between the Ethernet jacks of the two Macs. (You don't need to use an Ethernet crossover cable, as you did in days of old.)

To set up a wireless connection, from your [image] menulet, choose Create Network. Make up a name for your little private network, and then click OK. On the second Mac, choose [image] rightwards double arrow Join Network, enter the same private network name, and click Join.

At this point, your two Macs belong to the same ad hoc micro-network. But that doesn't mean that you've started accessing their files yet.

To do that, in the Finder on one of the Macs, choose Go rightwards double arrow Connect to Server. The Network window opens, showing the icons for all the computers on the local network. Double-click the one you want, enter the account password, if necessary, and you're in.

Whether you've set up your own wireless network or want to hop onto somebody else's, Chapter 18 has the full scoop on joining Wi-Fi networks.

13.1.3. FireWire Networks

FireWire networks?

You're forgiven for splurting your coffee. Everyone knows that FireWire is great for hooking up a camcorder or a hard drive, and a few people know about FireWire Disk Mode. But not many people realize that FireWire makes a fantastic networking cable, since it's insanely, blisteringly fast. (All right, gigabit Ethernet is faster, and so is FireWire 800. But attaining that kind of networking nirvana requires that all your Macs, hubs, and other networking gear are all gigabit-Ethernet or FireWire 800-compatible.)

FireWire networking, technically known as IP over FireWire, is an unheralded, unsung feature of Mac OS X. But when you have a lot of data to move between Macs —your desktop and your laptop, for example —a casual FireWire network is the way to go. It lets you copy a gigabyte of email, pictures, or video files in a matter of seconds.

Here's how you unleash this secret feature:

  1. Connect two Macs with a FireWire cable.

    You can't use the one that fits a camcorder. You need a six-pin-to-six-pin cable for traditional FireWire jacks. If you want to use the faster FireWire 800 connection on some of the latest Mac models, you'll need to shop for an even less common cord.

    In any case, the computers can remain turned on, which is a big difference from FireWire Disk Mode (Section 6.2). (The other difference is that you can continue to use both Macs while they're connected.)

    Figure 13-2. In the Network pane of System Preferences, you can add your FireWire port to the list of network connections. The point of this window, by the way, is that a Mac can maintain simultaneous open network connections—Ethernet, AirPort, FireWire, and dial-up modem. (That's a feature called multihoming.)

  2. Open System Preferences. Click Network. Click the [image] icon and enter your Administrator password. Click the + button below the list of network connections.

    The tiny dialog box shown in Figure 13-2 appears, letting you specify what kind of network connection you want to set up.

  3. From the pop-up menu, choose FireWire. Click Create.

    Now your newly created FireWire connection appears in the list.

  4. Repeat steps 2–3 on the second Mac.

    By now, it may have dawned on you that you can't actually get online via FireWire, since your cable runs directly between two Macs. But you can always turn on Internet Sharing (Section 18.5.4) on the other Mac.

  5. Quit System Preferences.

    Your Macs are ready to talk —fast. Read the following pages for details on sharing files between them.

Tip: Once you've switched on your FireWire connection, you may need to turn File Sharing or Internet Sharing off and on again to make it work.


wiring_the_network.html

Chapter 13. Networking, File Sharing, and Screen Sharing

Just about every Mac ever built is network-ready. Buy a couple of components, and you can connect all the computers in your office together, with or without wires. The process of rigging the hardware and software for a network is somewhat more technical than, say, emptying the Trash, but it's not exactly rocket science.

Once you've got a network, you can copy files from one machine to another —even between Windows PCs and Macs—just as you'd drag files between folders on your own Mac. You can send little messages to each other's screens. Everyone on the network can consult the same database or calendar. You can play games over the network. You can share a single printer, cable modem, or fax modem among all the Macs in the office. You can connect to this network from wherever you are in the world, using the Internet as the world's longest extension cord back to your office.

And in Mac OS X 10.5, you can even do screen sharing, which means that you, the wise computer whiz, can see what's on the screen of your pathetic, floundering relative or buddy elsewhere on the network. You can even seize control of the other Mac's mouse and keyboard. You can troubleshoot, fiddle with settings, and so on. It's the next best thing to being there —and often a lot better than being there.

Tip: You don't necessarily need a network to exchange files between Macs (and even PCs). If each computer is equipped with Bluetooth circuitry, they can shoot files back and forth wirelessly, as described on Section 6.2.6.1.

This chapter concerns itself with local networking —setting up a network in your home or small office. But don't miss its sibling, Chapter 18, which is about hooking up to the somewhat larger network called the Internet.

13.1. Wiring the Network

Most people connect their computers using one of two connection systems: Ethernet or Wi-Fi (which Apple calls AirPort).

13.1.1. Ethernet Networks

These days, every Mac and every network-ready laser printer has an Ethernet jack on the back or side panel (see Figure 13-1). If you connect all of the Macs and Ethernet printers in your small office to a central Ethernet hub or router —acompact, inexpensive box with jacks for 5, 10, or even more computers and printers —you've got yourself a very fast, very reliable network. (Most people wind up hiding the hub in a closet, and running the wiring either along the edges of the room or inside the walls.) You can buy Ethernet cables, plus the hub, at any computer store or, less expensively, from an Internet-based mail-order house. (Hubs aren't Mac-specific.)

Tip: If you want to connect only two Macs —say, your laptop and your desktop machine —you don't need an Ethernet hub. Instead, you just need a standard Ethernet cable. Run it directly between the Ethernet jacks of the two computers. (You don't need a special crossover Ethernet cable, as you did with Macs of old.) Then connect the Macs as described in the box on Section 13.1.2.Or don't use Ethernet at all; just use a FireWire cable or a person-to-person AirPort network.

Figure 13-1. Every Mac OS X–compatible Mac has an Ethernet jack (left). It looks like an overweight telephone jack. It connects to an Ethernet router or hub (right) via an Ethernet cable (also known as Cat 5 or Cat 6), which ends in what looks like an overweight telephone-wire plug (also known as an RJ-45 connector).

Ethernet is the best networking system for many offices. It's fast, easy, and cheap.

13.1.2. AirPort Networks

Wi-Fi, known to the geeks as 802.11 and to Apple fans as AirPort, means wireless networking. It's the technology that lets laptops the world over get online at high speed in any Wi-Fi "hot spot." Hot spots are everywhere these days: in homes, offices, coffee shops (notably Starbucks), hotels, airports, and thousands of other places.

Tip: At www.jiwire.com, you can type in an address or a city and learn exactly where to find the closest Wi-Fi hot spots.

When you're in a Wi-Fi hot spot, your Mac has a very fast connection to the Internet, as though it's connected to a cable modem or DSL.

AirPort circuitry comes preinstalled every Mac laptop, iMac, and Mac Mini, and you can order it built into a new Mac Pro.

This circuitry lets your machine connect to your network and the Internet without any wires at all. You just have to be within about 150 feet of a base station or (as Windows people call it) access point, which must in turn be physically connected to your network and Internet connection.

If you think about it, the AirPort system is a lot like a cordless phone, where the base station is, well, the base station, and the Mac is the handset.

The base station can take any of these forms:

  • AirPort base station. Apple's sleek, white, squarish or rounded base stations ($100 to $180) permit as many as 50 computers to connect simultaneously.

    UP TO SPEED
    AirPort a, b, g, and n: Regular or Supersized?

    In the short history of wireless networking, Wi-Fi gear has come in several variants, bearing the absurdly user-hostile names 802.11b, 802.11g, 802.11a, 802.11n, and so on.

    The difference involves the technical specs of the wireless signal. Original AirPort uses the 802.11b standard; AirPort Extreme uses 802.11g; the current AirPort cards and base stations use 802.11n.

    So what's the difference? Equipment bearing the "b" label transfers data through the air at up to 11 megabits per second; the "g" system is almost five times as fast (54 Mbytes/sec); and "n" is supposed to be four times as fast as that.

    (Traditionally, geeks measure network speeds in megabits, not megabytes. If you're more familiar with megabytes, though, here's a translation: The older AirPort gear has a top speed of 1.4 megabytes per second, versus more than 6 megabytes per second for the AirPort Extreme stuff.)

    (Oh, and while we're using parentheses here: The only place you'll get the quoted speeds out of this gear is when you're on the moon. Here on earth, signal strength is affected by pesky things like air, furniture, walls, floors, wiring, phone interference, and antenna angle. Speed and signal strength diminish proportionally as you move away from the base station.)

    Now, each successive version of the Wi-Fi base station/laptop circuitry standard is backward-compatible. For example, you can buy a new, 802.11n base station, and still connect to it from your ancient 802.11g PowerBook. You won't get any greater speed, of course —that would require a laptop with an 802.11n transmitter —but you'll enjoy the greater range in your house.

    It's important to understand, though, that even the most expensive, top-tier cable modem or DSL service delivers Internet information at only about half a megabyte per second. The bottleneck is the Internet connection, not your network. Don't buy newer AirPort gear thinking that you're going to speed up your email and Web activity.

    Instead, the speed boost you get with AirPort Extreme is useful only for transferring files between computers and gadgets on your own network (like the bandwidth-hungry Apple TV) —and playing networkable games.

    And one more note: All Wi-Fi gear works together, no matter what kind of computer you have. There's no such thing as a "Windows" wireless network or a "Macintosh" wireless network. Macs can use non-Apple base stations, PCs can use AirPort base stations, and so on.

    The less expensive one, the AirPort Express, is so small that it looks like a small white power adapter. It also has a USB jack so you can share a USB printer on the network. It can serve up to 10 computers at once.

  • A wireless broadband router. Lots of other companies make less expensive Wi-Fi base stations, including Linksys (www.linksys.com) and Belkin (www.belkin.com). You can plug the base station into an Ethernet router or hub, thus permitting 10 or 20 wireless-equipped computers, including Macs, to join an existing Ethernet network without wiring. (With all due non-fanboyism, however, Apple's base stations and software are infinitely more polished and satisfying to use.)

    Tip: It's perfectly possible to plug a Wi-Fi base station into a regular router, too, to accommodate both wired and wireless computers.

  • Another Mac. Your Mac can also impersonate an AirPort base station. In effect, the Mac becomes a software-based base station, and you save yourself the cost of a separate physical base station.

A few, proud people still get online by dialing via modem, which is built into some AirPort base station models. The base station is plugged into a phone jack. Wireless Macs in the house can get online by triggering the base station to dial by remote control.

Tip: If you connect through a modern router or AirPort base station, you already have a great firewall pro tecting you. You don't have to turn on Mac OS X's firewall.

For the easiest AirPort network setup, begin by configuring your Mac so that it can go online the wired way, as described in the previous pages. Once it's capable of connecting to the Internet via wires, you can then use the Airport Utility (in your Applications rightwards double arrow Utilities folder) to transmit those Internet settings wirelessly to the base station itself. From then on, the base station's modem or Ethernet jack —not your Mac's —will do the connecting to the Internet.

GEM IN THE ROUGH
Networking Without the Network

In a pinch, you can connect two Macs without any real network at all. You can create an Ethernet connection without a hub or a router —or an AirPort connection without a Wi-Fi base station.

To set up the wired connection, just run a standard Ethernet cable between the Ethernet jacks of the two Macs. (You don't need to use an Ethernet crossover cable, as you did in days of old.)

To set up a wireless connection, from your [image] menulet, choose Create Network. Make up a name for your little private network, and then click OK. On the second Mac, choose [image] rightwards double arrow Join Network, enter the same private network name, and click Join.

At this point, your two Macs belong to the same ad hoc micro-network. But that doesn't mean that you've started accessing their files yet.

To do that, in the Finder on one of the Macs, choose Go rightwards double arrow Connect to Server. The Network window opens, showing the icons for all the computers on the local network. Double-click the one you want, enter the account password, if necessary, and you're in.

Whether you've set up your own wireless network or want to hop onto somebody else's, Chapter 18 has the full scoop on joining Wi-Fi networks.

13.1.3. FireWire Networks

FireWire networks?

You're forgiven for splurting your coffee. Everyone knows that FireWire is great for hooking up a camcorder or a hard drive, and a few people know about FireWire Disk Mode. But not many people realize that FireWire makes a fantastic networking cable, since it's insanely, blisteringly fast. (All right, gigabit Ethernet is faster, and so is FireWire 800. But attaining that kind of networking nirvana requires that all your Macs, hubs, and other networking gear are all gigabit-Ethernet or FireWire 800-compatible.)

FireWire networking, technically known as IP over FireWire, is an unheralded, unsung feature of Mac OS X. But when you have a lot of data to move between Macs —your desktop and your laptop, for example —a casual FireWire network is the way to go. It lets you copy a gigabyte of email, pictures, or video files in a matter of seconds.

Here's how you unleash this secret feature:

  1. Connect two Macs with a FireWire cable.

    You can't use the one that fits a camcorder. You need a six-pin-to-six-pin cable for traditional FireWire jacks. If you want to use the faster FireWire 800 connection on some of the latest Mac models, you'll need to shop for an even less common cord.

    In any case, the computers can remain turned on, which is a big difference from FireWire Disk Mode (Section 6.2). (The other difference is that you can continue to use both Macs while they're connected.)

    Figure 13-2. In the Network pane of System Preferences, you can add your FireWire port to the list of network connections. The point of this window, by the way, is that a Mac can maintain simultaneous open network connections—Ethernet, AirPort, FireWire, and dial-up modem. (That's a feature called multihoming.)

  2. Open System Preferences. Click Network. Click the [image] icon and enter your Administrator password. Click the + button below the list of network connections.

    The tiny dialog box shown in Figure 13-2 appears, letting you specify what kind of network connection you want to set up.

  3. From the pop-up menu, choose FireWire. Click Create.

    Now your newly created FireWire connection appears in the list.

  4. Repeat steps 2–3 on the second Mac.

    By now, it may have dawned on you that you can't actually get online via FireWire, since your cable runs directly between two Macs. But you can always turn on Internet Sharing (Section 18.5.4) on the other Mac.

  5. Quit System Preferences.

    Your Macs are ready to talk —fast. Read the following pages for details on sharing files between them.

Tip: Once you've switched on your FireWire connection, you may need to turn File Sharing or Internet Sharing off and on again to make it work.


file_sharing.html

13.2. File Sharing

When you're done wiring (or not wiring, as the case may be), your network is ready. Your Mac should "see" any Ethernet or shared USB printers, in readiness to print (Chapter 14). You can now play network games or use a network calendar. And you can now turn on File Sharing, one of the most useful features of the Mac OS.

In File Sharing, you can summon the icon for a folder or disk attached to another computer on the network, whether it's a Mac or a Windows PC. It shows up in a Finder window, as shown in Figure 13-3.

At this point, you can drag files back and forth, exactly as though the other computer's folder or disk is a hard drive connected to your own machine.

The thing is, it's not easy being Apple. You have to write one operating system that's supposed to please everyone, from the self-employed first-time computer owner to the network administrator for NASA. You have to design a networking system simple enough for the laptop owner who just wants to copy things to a desktop Mac when returning from a trip, yet secure and flexible enough for the network designer at a large corporation.

Clearly, different people have different attitudes toward the need for security and flexibility.

That's why Leopard offers two ways to share files —a simple and limited way, and a more complicated and flexible way:

  • The simple way: the Public folder. Every account holder has a Public folder. It's free for anyone else on the network to access. Like a grocery store bulletin board, there's no password required. Super-convenient, super-easy.

    There's only one downside, and you may not care about it: You have to move or copy files into the Public folder before anyone else can see them. Depending on how many files you want to share, this can get tedious and eat up disk space.

    Figure 13-3. Here's the master switch that makes your Public folder (and any other folders you designate) available to other people on the network. You can edit the Computer Name, if you like. Your Mac will appear on the network with this name. Make it nice and descriptive, such as Front Desk iMac.

  • The flexible way: Any folder. You can also make any file, folder, or disk available for inspection by other people on the network. This method means that you don't have to move files into the Public folder, for starters. It also gives you elaborate control over who is allowed to do what to your files. You might want to permit your company's executives to see and edit your documents, but allow the peons in Accounting just to see them. And Andy, that unreliable goofball in Sales? You don't want him even seeing what's in your shared folder.

    Of course, setting up all those levels of control means more work and more complexity.

13.2.1. Setup: The Public Folder

Inside your Home folder, there's a folder called Public. Inside everybody's Home folder is a folder called Public.

Anything you copy into this folder is automatically available to everyone else on the network. They don't need a password, they don't need an account on your Mac —they just have to be on the same network.

To make your Public folder available to your network mates, you have to turn on the File Sharing master switch. Choose [image] rightwards double arrow System Preferences, click Sharing, and turn on File Sharing (Figure 13-3).

Now round up the files and folders you want to share with all comers on the network, and drag them into your Home rightwards double arrow Public folder. That's all there is to it.

Note: You may notice that there's already something in your Public folder: a folder called Drop Box. It's there so that other people can give you files from across the network, as described later in this chapter.

So now that you've set up Public folder sharing, how are other people supposed to access your Public folder? See Section 13.3.1.

13.2.2. Setup: Sharing Any Folder

If the Public folder method seems too simple and restrictive, then you can graduate to the "share any folder" method. In this scheme, you can make any file, folder, or disk available to other people on the network.

This time, you don't have to move your files anywhere; they sit right where you have them. And this time, you can set up elaborate sharing privileges (also known as permissions) that grant individuals different amount of access to your files.

This method is more complicated to set up than that Public-folder business. In fact, just to underline its complexity, Apple has created two different setup procedures. You can share one icon at a time by opening its Get Info window; or you can work in a master list of shared items in System Preferences.

The following pages cover both methods.

13.2.2.1. The Get Info method

Here's how to share a Mac file, disk, or folder disk using its Get Info window.

The following steps assume that you've opened [image] rightwards double arrow System Preferences, clicked Sharing, and then turned on File Sharing, as shown in Figure 13-3.

  1. Highlight the file, folder, or disk you want to share. Choose File rightwards double arrow Get Info.

    The Get Info dialog box appears (Figure 13-4). Expand the General panel, if it's not already visible.

    Note: Sharing an entire disk means that every folder and file on it is available to anyone you give access to. On the other hand, by sharing only a folder or two, you can keep most of the stuff on your hard drive private, out of view of curious network comrades. Sharing only a folder or two does them a favor, too, by making it easier for them to find files you've made available. This way, they don't have to root through your entire drive looking for the folder they actually need.

  2. Turn on "Shared folder."

    Enter your Administrative password, if necessary.

    OK, this disk or folder is now shared. But with whom?

    Figure 13-4. The file-sharing permissions controls are back in the Get Info box for any file, folder, or disk—right back where they were in Mac OS 9 in days of old.
    By the way: If the Finder quits when you click the + button to fiddle with the permissions, you're not alone. There's a quick fix, though, awaiting on Apple's Help Web site. It's here:
    http://docs.info.apple.com/article.html?artnum=307128

  3. Expand the Sharing & Permissions panel, if it's not already visible. Click the [image] icon and enter your administrator's password.

    The controls in the Sharing & Permissions area spring to life and become editable. You wanted individual control over each account holder's access? You've got it.

    At the bottom of the Info panel is a little table. The first column can display the names of individual account holders, like Casey or Chris, or groups of account holders, like Everyone or Accounting Dept.

    The second column lists the privileges each person or group has for this folder.

    Now, the average person has no clue what "privileges" means, and this is why things get a little hairy when you're setting up folder-by-folder permissions. But read on; it's not as bad as it seems.

  4. Edit the table by adding people's names. Then set their access permissions.

    At the moment, your name appears in the Name column, and it probably says Read & Write in the Privilege column. In other words, you're currently the master of this folder. You can put things in, and you can take things out.

    But at the moment, the privileges for "Everyone" is probably "Read only." Other people can see this folder, but can't do anything with it.

    Now your job is to work through this list of people, specifying how much control each person has over the file or folder you're sharing.

    To add the name of a person or group, click the + button below the list. The people list shown in Figure 13-5 appears.

    Figure 13-5. This list includes every account holder on your Mac, plus groups you've set up (Section 12.2.1.3), plus the contents of your Address Book (see the Note on Section 13.2.2.2). One by one, you can add them to the list of lucky sharers of your file or folder—and then change the degree of access they have to the stuff you're sharing.

    Now click a name in the list. Then, from the Privilege pop-up menu, choose a permissions setting.

    Read & Write has the most access of all. This person, like you, can add, change, or delete any file in the shared folder, or make any changes you like to a document. Give Read & Write permission to people you trust not to mess things up.

    Read only means "look, but don't touch." This person can see what's in the folder (or file) and can copy it, but can't delete or change the original. It's a good setting for distributing company documents or making source files available to your minions.

    Write only (drop box) means that other people can't open the folder at all. They can drop things into it, but it's like dropping icons through a mail slot: The letter disappears into the slot, and then it's too late for them to change their minds. As the folder's owner, you can do what you like with the deposited goodies. This drop-box effect is great when you want students, co-workers, or family members to be able to turn things in to you —homework, reports, scandalous diaries —without running the risk that someone else might see those documents. (This option doesn't appear for documents —only disks and folders.)

    No access is an option only for "Everyone." It means that other people can see this file or folder's icon, but can't do a thing with it.

    Tip: Usually, you'll want the privileges for the folder to also apply to everything inside it; it would be a real drag to have to change the sharing privileges of the contents one icon as a time. That's why the [image] menu at the bottom of the Get Info box has a command called "Apply to enclosed items."

  5. Close the Get Info window.

    Now the folder is ready for invasion from across the network.

13.2.2.2. The System Preferences method

It's very convenient to turn on sharing one folder at a time, using the Get Info window. But there's another way in, too, one that displays all of your shared stuff in one handy master list.

To see it, choose [image] rightwards double arrow System Preferences. Click Sharing. Click File Sharing (and make sure it's turned on).

Now you're looking at a slightly different kind of permissions table, shown in Figure 13-6. It has three columns:

  • Shared items. The first column lists the files, folders, and disks you've shared. You'll probably see immediately that everybody's Public folder is already listed here, since they're all shared automatically. (You can turn offsharing for a Public folder, too, just by clicking it and then clicking the - button.)

    Figure 13-6. Hiding in System Preferences is a list of every file, disk, and folder that you've shared. To stop sharing something, click it and click the – button. To share something new, drag its icon off the desktop, or out of its window, directly into the Shared Folders list.

    But you can add more icons to this list. Either drag them into the list directly from the desktop or a Finder window, or click the + sign, navigate to the item you want to share, select it, and then click Add. Either way, that item now appears in the Shared Folders list.

  • Users. When you click a shared item, the second column sprouts a list of who gets to work with it from across the network. You're probably listed here, of course, since it's your stuff. But somebody called Unknown User also appears in this list (a reference to people who sign in as Guests, as described on Section 12.2.1.6). There's also a listing here for Everyone, which really means, "everyone else" —that is, everyone else who's not specifically listed here.

    You can add to this list, too. Click the + button to open the person-selection box shown in Figure 13-5. It lists the other account holders on your Mac, and some predefined groups (Section 12.2.1.3), as well as the contents of your Address Book.

    Note: Most of the Address Book people don't actually have accounts on this Mac, of course. If you choose somebody from this list, you're asked to make up an account password. When you click Create Account, you have actually created a Sharing Only account on your Mac for that person, as described on Section 12.2.1.3. When you return to the Accounts pane of System Preferences, you'll see that new person listed.

    Figure 13-7. The Options box lets you see how many people are currently connected to your Mac over the network (top). It also lets you turn your Mac into an FTP server, as described in Chapter 22. Finally, it lets you turn on sharing so that Windows PCs can see your stuff over the network, too.

    Double-click a person's name to add her to the list of people who can access this item from over the network, and then set up the appropriate privileges (described next).

    To remove someone from this list, of course, just click the name and then click the – button.

  • Users. This third column lets you specify how much access each person in the second column has to this folder. Your choices are Read & Write (full access to change or delete this item's contents); Read Only (open or copy, but can't edit or delete); and Write Only (Drop Box), which lets the person put things into this disk or folder, but not open it or see what else is in it.

    For the Everyone group, you also get an option called No Access, which means that this item is completely off-limits to everyone else on the network.

Note: Chapter 16 contains an intriguingly geeky discussion of the underlying Unix operations that determine these settings.

This pane of System Preferences also offers an Options button. As shown in Figure 13-7 it offers a couple of advanced options, including sharing your Mac with Windows PCs on the network. (For that trick, see the box on Section 13.4.)

And now, having slogged through all of these options and permutations, your Mac is ready for invasion from across the network.


accessing_shared_files.html

13.3. Accessing Shared Files

So far in this chapter, you've read about setting up a Mac so that people at other computers can access its files.

Now comes the payoff: sitting at another computer and connecting to the one you set up. There are two ways to go about it: You can use Leopard's new, streamlined Sidebar network, or you can use the older, more flexible Connect to Server command. The following pages cover both methods.

13.3.1. Connection Method A: Use the Sidebar

Suppose, then, that you're seated in front of your Mac, and you want to see the files on another Mac on the network. Proceed like this:

  1. Open any Finder window.

    In the Shared category of the Sidebar at the left side of the window, icons for all the computers on the network appear. See Figure 13-8.

    Tip: The same Sidebar items show up in the Save and Open dialog boxes of your programs, too, making the entire network available to you for opening and saving files.

    If you don't see a certain Mac's icon here, it might be turned off, it might not be on the network, or it might have File Sharing turned off. (And if you don't see any computers at all in the Sidebar, then your computer might not be on the network. Or maybe you've turned off the checkboxes for "Connected Servers" and "Bonjour Computers" in Finder rightwards double arrow Preferences rightwards double arrow Sidebar.)

    Figure 13-8. Macs often appear in the Sidebar with model-specific names (MacBook, iMac, and so on). Other computers (like PCs) have generic blue monitors. When you click All in the Sidebar, you see both the icons of individual computers and the icons of network chunks (like AppleTalk zones and Windows workgroups).

    POWER USERS' CLINIC
    What You Can See

    What You Can See Precisely which other folders you can see on the remote Mac depend on what kind of account you have there: Guest, Standard, or Administrator. (See the previous chapter.)

    If you're using the Guest account, you can see only the Public and Drop Box folders. The rest of the Mac is invisible and off limits to you.

    If you have a Standard account, you can see other people's Public and Drop Box folders, plus your own Home folder.

    (Of course, those are just the factory settings; somebody could have turned on sharing for additional folders.)

    If you're an administrator, you get to see icons for the account-holder folders and the hard drive itself to which you're connecting. In fact, you even get to see the names of any other disks connected to that Mac.

    If you, O lucky administrator, open the hard drive, you'll discover that you also the freedom to see and manipulate the contents of the Applications, Desktop, Library, and Users rightwards double arrow Shared folders.

    You can even see what folders are in other users' Home folders, although you can't open them or put anything into them.

    Finally, as described in the previous chapter, there's the root user. This account has complete freedom to move or delete any file or folder anywhere, including critical system files that could disable your Mac. Section 16.9 has the details.

    If there are more than six icons in the Sidebar, or if you're on a corporate-style network that has sub-chunks like nodes or workgroups, you also see an icon called All. Click it to see the full list of network entities that your Mac can see: not just individual Mac, Windows, and Unix machines, but also any "network neighborhoods" (limbs of your network tree). For example, you may see the names of AppleTalk zones (clusters of machines, as found in big companies and universities).

    Or, if you're trying to tap into a Windows machine, open the icon representing the workgroup (computer cluster) that contains the machine you want. In small office networks, it's usually called MSHOME or WORKGROUP. In big corporations, these workgroups can be called almost anything —as long as it's no more than 12 letters long with no punctuation. (Thanks, Microsoft.)

    If you do see icons for workgroups or other network "zones," double-click your way until you're seeing the icons for individual computers.

    Note: If you're a network nerd, you may be interested to note that Mac OS X 10.5 can "see" servers that use the SMB/CIFS, NFS, FTP, and WebDAV protocols running on Mac OS X Server, AppleShare, Unix, Linux, Novell NetWare, Windows NT, Windows 2000, Windows XP, and Windows Vista servers. But Sidebar reveals only the shared computers on your subnet (your local, internal office network). (It also shows Back to My Mac if it's set up; see Section 13.5.3.4.)

  2. Click the computer whose files you want to open.

    In the main window, you now see the icons for each account holder on that computer: Mom, Dad, Sissy, whatever. If you have an account on the other computer, you'll see a folder representing your stuff, too (Figure 13-9).

    Figure 13-9. Without requiring any name or password on the other Mac, you have full access to anything the other account holders have left in their Public folders. (There's a Public folder in everyone's Home folder.) At this point, you're considered a Guest.

    At this point, the remaining instructions diverge, depending on whether you want to access other people's stuff or your stuff. That's why there are two alternative versions of step 3 here:

  3. a. If you want to access the stuff that somebody else has left for you, double-click that person's Public folder.

    Instantly, the icon for that folder appears on your desktop, and an Eject button [image] appears beside the computer's name in the Sidebar. (You can turn off both of those visual signals in Finder rightwards double arrow Preferences.)

    In this situation, you're only a Guest. You don't have to bother with a password. On the other hand, the only thing you can generally see inside the other person's account folder is his Public folder.

    Tip: Actually, you might see other folders here —if the account holder has specifically shared them and decided that you're important enough to have access to them, as described on Section 13.2.2.

    One thing you'll find inside the Public folder is the Drop Box folder. This folder exists so that you can give files and folders to the other person. You can drop any of your own icons onto the Drop Box folder —but you can't open the Drop Box folder to see what other people have put there. It's one-way, like a mail slot in somebody's front door.

    If you see anything else at all in the Public folder you've opened, then it's stuff that the account holder has copied there for the enjoyment of you and your network mates. You're not allowed to delete anything from the other person's Public folder or make changes to them.

    Figure 13-10. Top: You can sign in to your account on another Mac on the network (even while somebody else is actually using that Mac in person). Click Connect As (top right), and then enter your name and password. Turn on "Remember this password" to speed up the process for next time.
    The Action ( ) pop-up menu offers a Change Password that gives you the opportunity to change your account password on the other machine, just in case you suspect someone saw what you typed.
    Bottom: No matter which method you use to connect to a shared folder or disk, its icon shows up in the Sidebar. It's easy to disconnect, thanks to the little button.

    You can, however, open those icons, read them, or even copy them to your Mac — and then edit your copies.

    b. To access your own Home folder on the other Mac, click it, and then click the Connect As button (Figure 13-10). Sign in as usual.

    When the "Connect to the file server" box appears, you're supposed to specify your account name and password (from the Mac you're tapping into). This is the same name and password you'd use to log in if you were actually sitting at that machine.

    Type your short user name and password. (If you're not sure what your short user name is, open System Preferences on your home-base Mac, click Accounts, and then click your account name.) And if you didn't set up a password for your account, leave the password box empty.

    Tip: The dialog box shown in Figure 13-10 includes the delightful and timesaving "Remember this password in my keychain" option, which makes the Mac memorize your password for a certain disk so you don't have to type it —or even see this dialog box —every darned time you connect. (If you have no password, though, the "Remember password" doesn't work, and you'll have to confront —and press Enter to dismiss —the "Connect to the file server" box every time.)

    When you click Connect (or press Return or Enter), your own Home folder on the other Mac appears. Its icon shows up on your desktop, and a little [image] button appears next to its name. Click it to disconnect.

    Tip: Once you've connected to a Mac using your account, the other Mac has a lock on your identity. You'll be able to connect to the other Mac over and over again during this same computing session, without ever having to retype your password.

    In the meantime, you can double-click icons to open them, make copies of them, and otherwise manipulate them exactly as though they were icons on your own hard drive. Depending on what permissions you've been given, you can even edit or trash those files.

    Tip: There's one significant difference between working with "local" icons and working with those that sit elsewhere on the network. When you delete a file from another Mac on the network, either by pressing the Delete key or by dragging it to the Trash, a message appears to let you know that you're about to delete that item instantly and permanently. It won't simply land in the Trash "folder," awaiting the Empty Trash command.

    You can even use Spotlight to find files on that networked disk. If the Mac across the network is running Leopard, in fact, you can search for words inside its files, just as though you were sitting in front of it. If not, you can search only for text in files' names.

13.3.2. Connection Method B: Connect to Server

The Sidebar method of connecting to networked folders and disks is practically effortless. It involves nothing more than clicking your way through folders —a skill that, in theory, you already know.

But the Sidebar method lacks some advantages of the older "Connect to Server" method of Mac OS X versions gone by. For example, the Sidebar method doesn't let you type in a disk's network address. As a result, you can't access any shared disk on the Internet (an FTP site, for example), or indeed anywhere beyond your local subnet (your own small network).

Fortunately, there's another way. When you choose Go rightwards double arrow Connect to Server, you get the dialog box shown in Figure 13-11. You're supposed to type in the address of the shared disk you want.

Figure 13-11. The Sidebar method of connecting to shared disks and folders is quick and easy, but it doesn't let you connect to certain kinds of disks. The Connect to Server method entails plodding through several dialog boxes and doesn't let you browse for shared disks, but it can find just about every kind of networked disk.

For example, from here, you can connect to:

  • Everyday Macs on your network. If you know the IP address of the Mac you're trying to access (you geek!), you can type nothing but its IP address into the box and then hit Connect.

    And if the other Mac runs Mac OS X 10.2 or later, you can just type its Bonjour (Rendezvous) name: afp://upstairs-PowerMac.local/.

    Tip: To find out your Mac's IP address, open the Network pane of System Preferences. There, near the top, you'll see a message like this: "AirPort is connected to Tim's Hotspot and has the IP address 192.168.1.113." That's your IP address.To see your Bonjour address, open the Sharing pane of System Preferences pane. Click File Sharing. Near the top, you'll see the computer name with ".local" tacked onto its name —and hyphens instead of spaces —like this: Little-MacBook.local.

    After you enter your account password and choose the shared disk or folder you want, its icon appears on your desktop and in the Sidebar. You're connected exactly as though you had clicked Connect As (Figure 13-10).

    The next time you open the Connect to Server dialog box, Mac OS X remembers that address, as a courtesy to you, and shows it pre-entered in the Address field.

  • Macs across the Internet. If your Mac has a permanent (static) IP address, the computer itself can be a server, to which you can connect from anywhere in the world via the Internet. Details on this procedure begin on Section 22.1.

  • An iDisk. An iDisk is a file server, too (Section 18.6.1). The easiest way to bring your own iDisk icon to the screen is to click the iDisk icon in your Sidebar. But what if you're not using your own Mac? What if you're visiting a friend, and you want to bring your iDisk to his screen?

    In that case, you could choose Go rightwards double arrow Disk rightwards double arrow Other User's iDisk —or, if you're a Connect to Server kind of person, type afp://idisk.mac.com into the Connect to Server dialog box. When you click Connect, the Mac asks for your iDisk name and password. Type them in, and after a moment, your iDisk's icon pops up on the desktop.

  • Windows machines. Find out the PC's IP address or computer name, and then use this format for the address: smb://192.168.1.34 or smb://Cheapo-Dell.

    After a moment, you're asked to enter your Windows account name and password, and then to choose the name of the shared folder you want. When you click OK, the shared folder appears on your desktop as an icon, ready to use. (More on sharing with Windows PCs later in this chapter.)

    Tip: If you know the name of the shared folder, you can add that after a slash, like this: smb://192.168.4.23/ sharedstuff. You save yourself one dialog box.

    GEM IN THE ROUGH
    Faster Ways to Connect Next Time

    If you expect that you might want to access a shared disk or folder again later, take a moment to make an alias of it. (For example, Control-click it and choose Make Alias from the shortcut menu.)

    Next time, you can bring it back to your screen later just by double-clicking the alias. And if you turned on "Remember this password in my keychain," you won't even be asked for your name and password again.

    Similarly, if you drag a shared folder into the Dock, you can bring it back to your screen later just by clicking its icon.

    You can even drag its icon into the Login Items window described on Section 9.16. Now the disk appears on your desktop automatically each time you log in —the most effortless arrangement of all.

  • NFS servers. If you're on a network with Unix machines, you can tap into one of their shared directories using this address format: nfs://Machine-Name/pathname, where Machine-Name is the computer's name or IP address, and pathname is the folder path (Section 1.2.4) to the shared item you want.

  • FTP servers. Mac OS X makes it simple to bring FTP servers onto your screen, too. (These are the drives, out there on the Internet, that store the files used by Web sites.)

    In the Connect to Server dialog box, type the FTP address of the server you want, like this: www.apple.com. If the site's administrators have permitted anonymous access —the equivalent of a Guest account —that's all there is to it. A Finder window pops open, revealing the FTP site's contents.

    If you need a password for the FTP site, however, what you type into the Connect to Server dialog box should incorporate the account name you've been given, like this: yourname@www.apple.com. You'll be asked for your password.

    UP TO SPEED
    Hello, Bonjour

    Throughout this chapter, and throughout this book, you'll encounter rituals in which you're supposed to connect to another Mac, server, or printer by typing in its IP address (its unique network address).

    But first of all, IP addresses are insanely difficult to memorize (192.179.244.3, anyone?). Second, networks shouldn't require you to deal with them anyway. If a piece of equipment is on the network, it should announce its presence, rather than making you specifically call for it by name.

    Now you can appreciate the beauty of Bonjour (formerly Rendezvous), an underlying Mac OS X networking technology that lets networked gadgets detect each other on the network automatically and recognize each other's capabilities.

    It's Bonjour at work, for example, that makes other Macs' names show up in your iTunes program so that you can listen to their music from across the network. Bonjour is also responsible for filling up your Bonjour buddy list in iChat automatically, listing everyone who's on the same office network; for making shared Macs' names show up in the Sidebar's Network icon; and for making the names of modern laser printers from HP, Epson, or Lexmark appear like magic in the list of printers in the Print dialog box.

    And if you're lucky enough to have (a) a TiVo Series 2 (or later) video recorder for your television, (b) a home network that connects it with your Mac, and (c) TiVo's Home Networking Option, you already know that your Mac's name magically appears on the TiVo screen. This allows you to play your iTunes music, or put on a slide show of your iPhoto pictures, right on the TV. Once again, it's Bonjour at work.

    It's even more tantalizing to contemplate the future of Bonjour. To quotewww.zeroconf.org, whose underlying technology forms the basis of Bonjour:

    "The long-term goal of Zeroconf is to enable the creation of entirely new kinds of networked products, products that today would simply not be commercially viable because of the inconvenience and support costs involved in setting up, configuring, and maintaining a network to allow them to operate."

    But that's just the beginning. If electronics companies show interest (and some have already), you may someday be able to connect the TV, stereo, and DVD player with just a couple of Ethernet cables, instead of a rat's nest of audio and video cables.

    For most of us, that day can't come soon enough.

    Tip: You can even eliminate that password-dialog box step by using this address format: yourname:yourpassword@www.apple.com.

    Once you type it and press Return, the FTP server appears as a disk icon on your desktop (and in the Sidebar). Its contents appear, ready to open or copy.

  • WebDAV server. This special Web-based shared disk requires a special address format, like this: http://Computer-Name/pathname. (Technically, the iDisk is a WebDAV server —but there are far user-friendlier ways to get at it.)

In each case, once you click OK, you may be asked for your name and password.

And now, some timesaving features in the Connect to Server box:

  • Once you've typed a disk's address, you can click+to add it to the list of server favorites. The next time you want to connect, you can just double-click its name.

  • The clock-icon pop-up menu lists Recent Servers —computers you've accessed recently over the network. If you choose one of them from this pop-up menu, you can skip having to type in an address.

Tip: Like the Sidebar network-browsing method, the Connect to Server command displays each connected computer as an icon in your Sidebar, even within the Open or Save dialog boxes of your programs. You don't have to burrow through the Sidebar's Network icon to open files from them, or save files onto them.

13.3.3. Disconnecting Yourself

When you're finished using a shared disk or folder, you can disconnect from it by clicking the [image] icon next to its name in the Sidebar.

13.3.4. Disconnecting Others

In Mac OS X, you really have to work if you want to know whether other people on the network are accessing your Mac. You have to choose System Preferences rightwards double arrow Sharing rightwards double arrow File Sharing rightwards double arrow Options. There you'll see something like, "Number of users connected: 1." (See Figure 13-12.)

Figure 13-12. This dialog box asks you how much notice you want to give your co-workers that they're about to be disconnected, and what message to send them before the axe falls.

Maybe that's because there's nothing to worry about. You certainly have nothing to fear from a security standpoint, since people from across the network are allowed to access only their own folders. Nor will you experience much computer slowdown as you work, thanks to Mac OS X's prodigious multitasking features.

Still, if you're feeling particularly antisocial, you can slam shut the door to your Mac just by turning off the File Sharing feature. Click System Preferences in the Dock, click the Sharing icon, and turn off File Sharing.

If anybody is, in fact, connected to your Mac at the time (from aMac), you see the dialog box in Figure 13-12. If not, your Mac instantly becomes an island once again.


networking_with_windows.html

13.4. Networking with Windows

Microsoft Windows may dominate the corporate market, but there are Macs in the offices of America. Mac OS X represents a historic moment in Mac-Windows relations: It lets Macs and Windows PCs see each other on the network, with no special software (or talent) required.

In fact, you can go in either direction. Your Mac can see shared folders on the Windows PCs, and a Windows PC can see shared folders on your Mac.

It goes like this:

13.4.1. Seated at the Mac, Seeing the PC

Suppose you have a Windows PC and a Mac on the same wired or wireless network. Here's how you get the Mac and PC chatting:

  1. On your Windows PC, share some files.

    This isn't really a book about Windows networking (thank heaven), but here are the basics.

    Just as on the Mac, there are two ways to share files in Windows. One of them is super-simple: You just copy the files you want to share into a central, fully accessible folder. No passwords, accounts, or other steps are required.

    In Windows XP, that special folder is the Shared Documents folder, which you can find by choosing Start rightwards double arrow My Computer. Share it on the network as shown in Figure 13-13, top.

    In Windows Vista, it's the Public folder, which appears in the Navigation pane of every Explorer window. (In Vista, there's one Public folder for the whole computer, not one per account holder.)

    The second, more complicated method is the "share any folder" method, just as in Leopard. Ingeneral, you right-click the folder you want to share, choose Properties from the shortcut menu, click the Sharing tab, and turn on "Share this folder on the network" (Figure 13-13, top). Repeat for any other folders you want to make available to your Mac.

  2. On the Mac, open any Finder window.

    The shared PCs may appear as individual computer names in the Sidebar, or you may have to click the All icon to see the icons of their workgroups (network clusters — an effect shown on Section 13.3). Unless you or a network administrator changed it, the workgroup name is probably MSHOME or WORKGROUP. Double-click the workgroup name you want.

    Tip: You can also access the shared PC via the Connect to Server command, as described on Section 13.3.2. You could type into it smb://192.168.1.103 (or whatever the PC's IP address is) and hit Return —and then skip to step 5. In fact, using the Connect to Server method often works when the Sidebar method doesn't.

    Figure 13-13. Top: To share a folder in Windows XP, right-click it, choose Properties, and then turn on "Share this folder on the network." In the "Share name" box, type a name for the folder as it will appear on the network. (No spaces are allowed).
    Bottom: Back in the safety of Mac OS X, click the PC's name in the Sidebar. (If it's part of a workgroup, click All, and then your workgroup name first. And if you still don't see the PC's name, see the box on Section 13.4.3.)
    Next, click the name of the shared computer. If the files you need are in a Shared Documents or Public folder, no password is required. You see the contents of the PC's Shared Documents folder or Public folder, as shown here. Now it's just like file sharing with another Mac.
    If you want access to any other shared folder, click Connect As, and see Figure 13-14.

    Now the names of the individual PCs on the network appear in your Finder window.

  3. Double-click the name of the computer you want.

    If you're using one of the simple file-sharing methods on the PC, as described above, that's all there is to it. The contents of the Shared Documents or Public folder now appear on your Mac screen. You can work with them just as you would your own files.

    If you're not using one of those simple methods, and you want access to individual shared folders, read on.

    Note: In Windows XP Pro, the next step won't work unless you turn off Simple File Sharing. To do that, choose Tools rightwards double arrow Folder Options in any Explorer window. Click the View tab and turn off "Use simple file sharing."

  4. Click Connect As.

    This button appears in the top right corner of the Finder window; you can see it at bottom in Figure 13-13, bottom.

    Figure 13-14. Top: The PC wants to make sure that you're authorized to visit it. If the terminology here seems a bit geeky by Apple standards, no wonder—this is Microsoft Windows' lingo you're seeing, not Apple's. Fortunately, you see this box only the very first time you access a certain Windows folder or disk; after that, you see only the box shown below.
    Bottom: Here, you see a list of shared folders on the PC. Choose the one you want to connect to, and then click OK. Like magic, the Windows folder shows up on your Mac screen, ready to use!

    Now you' re asked for your name and password (Figure 13-14, top).

  5. Enter the name and password for your account on the PC, and then click OK..

    At long last, the contents of the shared folder on the Windows machine appear in your Finder window, just as though you'd tapped into another Mac (Figure 13-14, bottom). The icon of the shared folder appears on your desktop, too, and an Eject button [image] appears next to the PC's name in your Sidebar.

    From here, it's a simple matter to drag files between the machines, open Word documents on the PC using Word for the Mac, and so on—exactly like you're hooked into another Mac.

13.4.2. Seated at the PC, Seeing the Mac

Cross-platformers, rejoice: Mac OS X lets you share files in both directions. Not only can your Mac see other PCs on the network, but they can see the Mac, too.

On the Mac, choose [image] rightwards double arrow System Preferences. Click Sharing, click File Sharing (make sure File Sharing is turned on), and then click Options to open the dialog box shown in Figure 13-15.

Your mission now is to turn on "Share files and folders using SMB." Although Apple can't bring itself to use the term Windows in this dialog box, that's what it means by SMB.

Below that checkbox, you see a list of all the accounts on your Mac. Turn on the checkboxes to specify which Mac user accounts you want to be able to access. You must type in each person's password, too. Click Done to return to the System Preferences pane.

Figure 13-15. Prepare your Mac for visitation by the Windows PC. It won't hurt a bit. The system-wide On switch for invasion from Windows is the third checkbox here, in the System Preferences rightwards double arrow Sharing rightwards double arrow File Sharing rightwards double arrow Options box.
Next, turn on the individual accounts whose icons you'll want to show up on the PC. Enter their account passwords, too. Click Done when you're done.

Before you close System Preferences, study the line near the middle of the window, where it says: "Other users can access your computer at afp://MacBook-Pro" (or whatever your computer's name is). You'll need this name shortly, although not the "afp://" part.

Now, on Windows XP, open My Network Places; in Windows Vista, choose Start rightwards double arrow Network. If you've sacrificed the proper animals to the networking gods, your Mac's icon should appear by itself in the network window, as shown in Figure 13-16, top.

Note: If you don't see your Mac here, proceed immediately to the box on the facing page.

Double-click the Mac's icon. Public-folder stuff is available immediately. Otherwise, you have to sign in with your Mac account name and password; Figure 13-16, middle, has the details.

Figure 13-16. Top: Double-click the icon of the Mac you want to visit from your Windows machine (Vista is shown here).
Middle: Type your Mac's name in all capitals (or its IP address), then a backslash, and then your Mac account short name. (You can find out your Mac's name on the Sharing pane of System Preferences.)
Enter your Mac account's password, too. Turn on "Remember my password" if you plan to do this again someday. Click OK.
Bottom: Here's your Mac Home folder —in Windows! Open it up to find all your stuff.

In the final window, you see your actual Home folder —on a Windows PC! You're ready to open its files, copy them back and forth, or whatever (Figure 13-16, bottom).

If your Mac's icon doesn't appear, and you've read the box below, wait a minute or two. Try restarting the PC. In Windows XP, try clicking "Microsoft Windows Network" or "View workgroup computers" in the task pane.

If your Mac still doesn't show up, you'll have to add it the hard way. In the address bar of any Windows window, type \\macbook-pro\chris (but substitute your Mac's actual computer name and your short account name), taking care to use backslashes, not normal / slashes. You can also type your Mac's IP address in place of its computer name.

In the future, you won't have to do so much burrowing; your Mac's icon should appear automatically in the My Network Places or Network window.

13.4.3. More Mac-Windows Connections

The direct Mac-to-Windows file-sharing feature of Mac OS X is by far the easiest way to access each other's files. But it's not the only way. Here are a few more possibilities (not including disks, flash drives, and other removable gadgets):

  • iDisk. If you have a .Mac account, the iDisk is a brilliantly simple way to transfer files —even those that are too big to email —between Macs and PCs. Details on Section 18.6.1.

    GEM IN THE ROUGH
    When Macs and PCs Don't See Each Other

    If your Mac's icon doesn't show up on the PC at all, or vice versa, it's probably because the Mac doesn't know anything about Windows workgroups. And even a lowly home PC is part of a workgroup (a corporate cluster), whether it knows it or not. And until your Mac is part of that very tiny club, it won't be able to see your PCs, and they won't be able to see it.

    So if you're having no luck with this whole Mac-PC thing, try this. Open System Preferences. Click Network. Click whatever connection you're on right now (like AirPort or Ethernet). Click Advanced. Click WINS.

    Now you see the peculiar set of controls shown here. The Workgroup pop-up menu already lists the workgroups that your Mac sees. Choose "workgroup" from the pop-up menu. Click OK, and then click Apply.

    And marvel as your Win-dows PCs' names show up in the Sidebar, where they didn't before.

    (Of course, your work-group name might not be "workgroup," but that and mshome are the two most common Windows home-network workgroup names.)

  • Web Serving. Mac OS X's built-in Apache software turns your Mac into a living Web site. And the beauty of the Web, of course, is that it doesn't care what kind of computer you're using. The contents of the Web site are dished up exactly the same way to Macs, Windows machines, Unix machines, and so on.

    All of this provides a great way to distribute files to other people on the network — even people who are using less enlightened operating systems. You can simply list files for distribution on a simple Web page, to which other people on the network can connect.

    Chapter 22 offers the full details of setting up such a system —but in the context of making your Mac available to anyone on the Internet. The point to note here is that other people on your office network can access your Mac in exactly the same way, just by typing http://192.168.1.5/~chris/ (that is, your IP address followed by ~ and your short account name) into the address bar of their Web browsers.

  • FTP. Think of an FTP server as something like a Web site designed specifically as a holding tank for files that you want to distribute or accept. Here again, though, it's worth remembering that you can use the Mac OS X built-in FTP server to distribute and accept files on your local network, not just over the Internet. The Windows PC user, using only a Web browser, can download any files in the folder that you've set up for such transactions. Chapter 22 has complete details. (And using an FTP client program —the Windows equivalent of Transmit or CyberDuck, for example —that person can copy files to and from the folder.)

  • Bluetooth. If your Mac and a PC each have Bluetooth adapters, you can share files between them as though there's no language barrier at all.

    Apple's Bluetooth adapter comes with a nondenominational file-exchange program called Bluetooth File Exchange. Not all Windows Bluetooth adapters come with such a program. But if this PC's adapter does (3Com's adapters do, for example), you should be able to shoot files between the machines with the greatest of ease — and no setup whatsoever. See Section 6.2.6.1.


screen_sharing.html

13.5. Screen Sharing

The prayers of baffled beginners and exasperated experts everywhere have now been answered. Now, when the novice needs help from the guru, the guru doesn't have to run all the way downstairs or down the hall to assist. Thanks to the new screen-sharing feature of Leopard, you can see exactly what's on the screen of another Mac, from across the network —and even seize control of the other Mac's mouse and keyboard (with the newbie's permission, of course).

(Anyone who's ever tried to help someone troubleshoot over the phone knows exactly what this means. If you haven't, this small example may suffice: "OK, open the Apple menu and choose 'About This Mac.'" Pause. "What's the Apple menu?")

Nor is playing Bail-Out-the-Newbie the only situation when screen sharing is useful. It's also great for collaborating on a document, showing something to someone for approval, or just freaking each other out. It can also be handy when you are the owner of both Macs (a laptop and a desktop, for example), and you want to run a program that you don't have on the Mac that's in front of you. (You might want to adjust the playlist selection on the upstairs Mac that's connected to your sound system, for example.)

Or maybe you just want to keep an eye on what your kids are doing on the Macs upstairs in their rooms.

The controlling person can do everything on the controlled Mac, including running programs, messing around the folders and files, and even shutting down the controlled Mac.

Note: Leopard is crawling with different ways to use screen sharing. You can do it over a network, over the Internet, and even during an iChat chat.That method, described in Section 7.5.1.8, is much simpler and better than the small-network method described here. It doesn't require names or passwords, it's easy to flip back between seeing the other guy's screen and your own, and you can transfer files by dragging them from your screen to the other guy's (or vice versa).Then again, the small-network method described here is built right into the Finder, doesn't require logging into iChat, and doesn't require Leopard running on both computers.

As always, trying to understand meta concepts like seeing one Mac's screen on the monitor of another can get confusing fast. So in this example, suppose that you want to take control of Mac #1 while seated at Mac #2.

13.5.1. Mac #1: Give Permission in Advance

It would be a chaotic world (although greatly entertaining) if any Mac could randomly take control of any other Mac. Fortunately, though, nobody can share your screen or take control of your Mac without your explicit permission.

To give such permission, choose [image] rightwards double arrow System Preferences rightwards double arrow Sharing, and then turn on Screen Sharing.

Note: If a message appears to the effect that "Screen Sharing is currently being controlled by the Remote Management service," turn off the Remote Management checkbox and then try again.

At this point, there are three levels of security to protect your Mac against unauthorized remote-control mischief:

  • Secure. If you stop here, anyone with an account on your Mac will be able to tap in and take control any time they like, even when you're not around. They'll just have to enter the same name and password that they'd use if they were sitting in front of your machine.

    If "anyone" means "you and your spouse" or "you and the other two fourth-grade teachers," then that's probably perfectly fine.

  • Securer. For greater security, though, you can limit who's allowed to stop in. Click "Only these users" and then click the + sign. A small panel appears, listing everyone with an account on your Mac. Choose the ones you trust not to mess things up while you're away from your Mac (Figure 13-17).

    Figure 13-17. Your Mac is now ready to be observed and even controlled by other machines across the network. The people listed here are allowed to tap in anytime they like, even when you're not at your machine.

  • Securest. If you click "Only these users" and then don't add anyone to the list, then nobody can tap into your screen.

    Alternatively, if you're only a little bit of a Scrooge, you can set things up so that they can request permission to share your screen —as long as you're sitting in front of your Mac at the time and feeling generous.

    To set this up, click Computer Settings and turn on "Anyone may request permission to share screen." Now your fans will have to request permission to enter, and you'll have to grant it (by clicking OK on the screen), in real time, while you're there to watch what they're doing.

13.5.2. Mac #2: Take Control

All right, Mac #1 has been prepared for invasion. Now suppose you're the person on the other end. You're the guru, or the parent, or whoever wants to take control.

Sit at Mac #2 elsewhere on your home or office network. Open a Finder window. Expand the Sharing list in the Sidebar, if necessary, so that you see the icon of Mac #1.

When you click that Mac's icon, the dark strip at the top of the main window displays a button that wasn't there before: Share Screen. Proceed as shown in Figure 13-18.

Tip: In theory, you can also connect from across the Internet, assuming you left your Mac at home turned on and connected to a broadband modem, and assuming that you've worked through the port-forwarding issue described on Section 22.1.In this case, though, you'd begin by choosing Go rightwards double arrow Connect to Server in the Finder; in the Connect to Server box, you'd type in vnc://123.456.78.90 (or whatever your home Mac's public IP address is). The rest of the steps are the same.

Figure 13-18. Top: Start by clicking Share Screen in the strip at the top of the other Mac's window.
Middle: If you've been pre-added to the V.I.P. list of authorized screen sharers, as described above, you can sign in with your name and password. If not, you can request permission to share Mac #1's screen. You'll be granted permission only if Mac #1's owner happens to be sitting in front of it at the moment, and has opted to accept such requests.
Bottom: If you request permission, the other person (sitting at Mac #1) sees your request in this form.

If you signed in successfully, or if permission is granted, then a weird and wonderful sight appears. As shown in Figure 13-19, your screen now fills with a second screen— from the other Mac. You have full keyboard and mouse control to work with that other machine exactly as though you're sitting in front of it.

Figure 13-19. Don't be alarmed. You're looking at the other Mac's desktop in a window on your Mac desktop. You have keyboard and mouse control, and so does the other guy (if he's there); when you're really bored, you can play King of the Cursor. (Note the Screen Sharing toolbar, which has been made visible by choosing View rightwards double arrow Show Toolbar.)

Well, maybe not exactly. There are a few caveats.

  • Mismatched screen sizes. If the other screen is smaller than yours, no big deal. It floats at actual size on your monitor, with room to spare.

    But if it's the same size as yours or larger, then the other Mac's screen gets shrunken down to fit in a window.

    If you'd prefer to see it at actual size, choose View rightwards double arrow Turn Scaling Off. Of course, now you have to scroll in the Screen Sharing window to see the whole image.

    Tip: Another way to turn scaling on and off is to click the first button on the Screen Sharing toolbar (Figure 13-19).

  • The speed-vs.-blurriness issue. Remember, you're asking the other Mac to pump its video display across the network —and that takes time. Entire milliseconds at a time, in fact.

    So ordinarily, the Mac uses something called adaptive quality, which just means that the screen gets blurry when you scroll, quit a program, or do anything else that creates a sudden change in the picture. You can turn off this feature by choosing View rightwards double arrow Full Quality. Now you get full sharpness all the time —but things take longer to scroll, appear, and disappear.

  • Manage the Clipboard. Believe it or not, you can actually copy and paste material from the remote-controlled Mac to your own —or the other way —thanks to a freaky little wormhole in the time-space continuum.

    Just make the toolbar visible (you can see it in Figure 13-19). Click the second button on it to copy the faraway Mac's clipboard contents onto your Clipboard. Or click the third button to put what's on your Clipboard onto the other Mac's Clipboard. Breathe slowly and drink plenty of fluids, and your brain won't explode.

    Note: Unfortunately, there's no way to transfer files while screen sharing —only material you've copied out of documents.

  • Quitting. When you hit the [image] -Q keystroke, you don't quit Screen Sharing; you quit what ever program is running on the other Mac! So when you're finished having your way with the other computer, choose Screen Sharing rightwards double arrow Quit Screen Sharing to return to your own desktop (and your own sanity).

13.5.3. Variations on Screen Sharing

The steps above guide you through screen sharing between two Leopard Macs. But Leopard's screen-sharing technology is based on a standard technology called VNC, and Mac OS X is bristling with different permutations.

13.5.3.1. Screen Sharing through iChat

Two people who both have Mac OS X 10.5 or later can perform exactly the same screen-sharing stunt Over the Internet. No accounts, passwords, or setup are required — only the granting of permission by the other guy. Just initiate an iChat chat, and then proceed as described on Section 13.5.3. It's really awesome.

GEM IN THE ROUGH
Screen Sharing with Windows and Other Oddball Machines

The beauty of Leopard's screen-sharing technology is that it isn't Leopard's screen-sharing technology. It's a popular, open standard called VNC (Virtual Network Computing).

Once you've turned on Screen Sharing on your Leopard Mac, any computer on earth with a free VNC client program —sort of a viewer program —can pop onto your machine for a screen share. VNC clients are available for Windows, Linux, pre-Leopard Macs, and even some cellphones.

To prepare your Leopard Mac for invasion, open the Sharing pane of System Preferences. Click Screen Sharing, and click Computer Settings. Turn on "VNC viewers may control screen with password," and make up a password. (VNC doesn't know anything about Mac OS X account passwords, so you're making up one password for sharing your whole Mac.)

Give that password to the lucky few who have your trust. Let them plug your Mac's public IP address (Section 22.1) into their VNC clients —or let them connect over your office network, using the address displayed on the Screen Sharing pane ("vnc://Black-MacBook," for example) —and let the sharing begin.

13.5.3.2. Screen Sharing with a pre-Leopard Mac

Both Macs don't have to be running Mac OS X 10.5 to use screen sharing. As it turns out, Mac OS X 10.3 and 10.4 are capable of sharing their screens, too —it's just that the on/off switch has a different name. Figure 13-20 has details.

Once you've turned on Apple Remote Desktop on the older Mac, as shown in Figure 13-20, you can sit at your Leopard Mac and take control by clicking Share Screen in the Sidebar, exactly as described above.

Note: At this point, the screen sharing is one-way: The Leopard Mac can see the older Mac's screen. If you want the older Mac to access the Leopard Mac's screen, return to the box shown in Figure 13-20. Turn on "VNC viewers may control screen with password," and make up a password. Now download the free Chicken of the VNC software; it's available from this book's "Missing CD" page at www.missingmanuals.com. Use it to access the Leopard Mac; the box on Section 13.5.3 has more details on this concept.

Figure 13-20. On pre-10.5 Macs, there's no option for Screen Sharing in the Sharing pane of System Preferences. There is one, however, called Apple Remote Desktop —and that's the one that permits screen sharing with 10.5 machines. When you click it, you're offered many of the same options that Leopard offers. More, in fact.

13.5.3.3. Screen Sharing the manual way

Screen Sharing is an actual, double-clickable program, with its own icon on your Mac. (It's in the System rightwards double arrow Library rightwards double arrow CoreServices folder.) When you double-click it, you can type in the public IP address (Section 22.1) or domain name of the computer you want to connect to, and presto: You're connected!

13.5.3.4. Screen Sharing with Back to My Mac

"Back to My Mac" is a new Leopard feature that's intended to simplify the nightmare of remote networking. It works only if:

  • You're a .Mac member.

  • You have at least two Macs, both running Leopard. On each one, you've entered your .Mac information into the .Mac pane of System Preferences, and logged in.

Once that's all in place, your Macs behave exactly as though they're on the same home network, even though they're thousands of miles apart across the network.

To set it up, proceed as shown in Figure 13-21.

Figure 13-21. On the first Mac, open System Preferences. Click .Mac, and then click Back to My Mac. Click Start. Close System Preferences. Repeat on each Mac, making sure that they all have the same .Mac account information.

Now, on each Mac you'll want to "visit" from afar, open the System Preferences rightwards double arrow Sharing pane and turn on File Sharing and/or Screen Sharing.

Then, on your laptop in New Zealand, you'll see an entry for Back to My Mac in the Sharing section of your Sidebar. Click to see the icon of your Mac back at home. At this point, you can connect to it for file sharing by clicking Connect As (Section 13.3.2), or take control of it by clicking Share Screen (Section 13.5.2).

In theory, Back to My Mac spares you an awful long visit to networking hell (including the port-forwarding headache described on Section 22.1), because Apple has done all the configuration work for you.

Note: Lots of people can't get Back to My Mac to work. Apple says that the problems are related to (a) this being a new service with some kinks to be worked out, (b) firewall problems, and (c) router incompatibilities. Apple also says that you'll have the best luck on networks that involve only an AirPort base station —and not a hardware router.All the technical details are available online. Go to http://search.info.apple.com and do a search for 306672. (That's the article number that explains the Back to My Mac issues.)


more_dialing_in_from_the_road.html

13.6. More Dialing In from the Road

If you're one of the several million lucky people who have full-time Internet connections —in other words, cable modem or DSL accounts —a special thrill awaits. You can connect to your Mac from anywhere in the world via the Internet. If you have a laptop, you don't need to worry when you discover you've left a critical file on your desktop Mac at home.

Mac OS X offers several ways to connect to your Mac from a distant location, including file sharing over the Internet, Back to My Mac, virtual private networking, FTP, and SSH (secure shell). Chapter 22 has the details.


printing_faxing_fonts_and_graphics.html

Chapter 14. Printing, Faxing, Fonts, and Graphics

The Macintosh may be only the eight-percent solution in the mainstream business world, but in the graphics and printing industries, it's the 800-pound gorilla. You'd better believe that when Apple designed Mac OS X, it worked very hard to keep its graphics and printing fans happy.

This chapter tackles printing, faxing, fonts, graphics, ColorSync, and PDF (Acrobat) files, which Mac OS X uses as an everyday exchange format—one of the biggest perks in Mac OS X.

14.1. Mac Meets Printer

One of the biggest complaints about the original Mac OS X was that at the outset, not many printer companies had rewritten their printer drivers—the software that controls various printer models—for Mac OS X. Fortunately, the situation has improved: Today's Mac OS X comes with hundreds of printer drivers from Epson, HP, Lexmark, Canon, and others.

14.1.1. Setting Up a Printer

One beauty of Mac OS X is that setting up a printer for the first time is incredibly easy. The first time you want to print something, follow this guide:

  1. Connect the printer to the Mac, and then turn the printer on.

    Inkjet printers usually connect to your USB jack. Laser printers generally hook up to your Ethernet connector. (If you're on an office network, the laser printer may already be connected somewhere else on the network, saving you this step. If you're hooking the printer straight into your Mac's Ethernet jack, you may need an Ethernet crossover cable to connect it, rather than a standard Ethernet cable.)

  2. Open the document you want to print. Choose File rightwards double arrow Print. In the Print dialog box, choose your printer's name from the Printer pop-up menu (or one of its submenus, if any).

    Cool! Wasn't that easy? Very nice how the Mac autodiscovers, autoconfigures, and auto lists almost any USB, FireWire, Bluetooth, or Bonjour (Rendezvous) printer.

    Have a nice afternoon. The End.

    Oh—unless your printer isn't listed in the Printer pop-up menu. In that case, read on.

  3. From the Printer pop-up menu, choose Add Printer (Figure 14-1, top).

    Figure 14-1. Top: To introduce your Mac to a new printer, try to print something—and then choose Add Printer from this pop-up menu.
    Bottom: Your Mac should automatically "see" any printers that are hooked up and turned on. Click the one you want, and then click Add.

    A special setup window opens (Figure 14-1, bottom), which is even better at autodetecting printers available to your Mac. If you see the printer's name now, in the Printer Browser window, click it, and then click Add (Figure 14-1, bottom). You've just designated that printer as the default printer, the one that you'll print on most of the time.

    You're all set. Have a good time.

    Unless, of course, your printer still isn't showing up. Proceed to step 4.

  4. Click the icon for the kind of printer you have: Windows, Bluetooth, AppleTalk, 1/3/2008 IP (that is, an Internet printer), or whatever.

    Choose AppleTalk if you're connected to a laser printer via an Ethernet network cable or AirPort wireless network. Choose Windows if there's a Windows-only printer out there on your office network. And so on.

    After a moment, the names of any printers that are turned on and connected appear in the printer list. For most people, that means only one printer—but one's enough.

  5. Click the name of the printer you want to use.

    As an optional step, you can open the Print Using pop-up menu at the bottom of the dialog box. Choose "Select a driver to use," and then, in the list that appears, choose your particular printer's model name, if you can find it. That's how your Mac knows what printing features to offer you when the time comes: double-sided, legal size, second paper tray, and so on.

  6. Click Add.

    After a moment, you return to the main Printer Browser window (Figure 14-1, top), where your printer now appears. You're ready to print.

Note: If you still don't see your printer's name show up, ask yourself: Is my Mac on a corporate network? Does the network have an LPR (Line Printer) printer? If you and your company's network nerd determine that the printer you want to use is, in fact, an LPR printer, click IP Printing at the top of the Printer Browser dialog box. Fill in the appropriate IP address and other settings, as directed by your cheerful network administrator.

14.1.2. The Printer List

If you're lucky enough to own several printers, repeat the steps above for each one. Eventually, you'll have introduced the Mac to all the printers available to it, so all their names show up in the printer list.

To see the printer list so far, open System Preferences rightwards double arrow Print & Fax. (The old Printer Setup Utility has gone to the great Best Buy in the sky.) You can have all kinds of fun here:

  • Choose a default printer. As indicated by the Default Printer pop-up menu, Leopard intends, conveniently enough, to use whichever printer you used for the last printout for the next one. Most people, after all, don't switch printers much.

    Still, you can choose one particular printer from this pop-up menu to set it as the default printer—the one that the Mac uses unless you intervene by choosing from the Printer pop-up menu in the Print dialog box (Figure 14-1).

  • Create desktop printer icons. This handy, little-known feature gives you drag-and-drop access to your printers.

    From the Print & Fax pane of System Preferences, just drag a printer's icon out of the window and onto the desktop (or wherever you like). Repeat for your other printers. From now on, you can print a document on a certain printer just by dragging the document's icon onto the appropriate printer desktop icon.

  • Recover a gig of drive space. You know how Mac OS X comes with the necessary software for hundreds upon hundreds of printers? Unless you're in Oprah's tax bracket, you probably don't own that many printers—but their drivers are taking up nearly a gigabyte of hard drive space!

    To clean out the ones you don't need, open your hard drive rightwards double arrow Library rightwards double arrow Printers folder. Throw away the folders for printer companies that didn't make your printer. (Administrator account required.)


mac_meets_printer.html

Chapter 14. Printing, Faxing, Fonts, and Graphics

The Macintosh may be only the eight-percent solution in the mainstream business world, but in the graphics and printing industries, it's the 800-pound gorilla. You'd better believe that when Apple designed Mac OS X, it worked very hard to keep its graphics and printing fans happy.

This chapter tackles printing, faxing, fonts, graphics, ColorSync, and PDF (Acrobat) files, which Mac OS X uses as an everyday exchange format—one of the biggest perks in Mac OS X.

14.1. Mac Meets Printer

One of the biggest complaints about the original Mac OS X was that at the outset, not many printer companies had rewritten their printer drivers—the software that controls various printer models—for Mac OS X. Fortunately, the situation has improved: Today's Mac OS X comes with hundreds of printer drivers from Epson, HP, Lexmark, Canon, and others.

14.1.1. Setting Up a Printer

One beauty of Mac OS X is that setting up a printer for the first time is incredibly easy. The first time you want to print something, follow this guide:

  1. Connect the printer to the Mac, and then turn the printer on.

    Inkjet printers usually connect to your USB jack. Laser printers generally hook up to your Ethernet connector. (If you're on an office network, the laser printer may already be connected somewhere else on the network, saving you this step. If you're hooking the printer straight into your Mac's Ethernet jack, you may need an Ethernet crossover cable to connect it, rather than a standard Ethernet cable.)

  2. Open the document you want to print. Choose File rightwards double arrow Print. In the Print dialog box, choose your printer's name from the Printer pop-up menu (or one of its submenus, if any).

    Cool! Wasn't that easy? Very nice how the Mac autodiscovers, autoconfigures, and auto lists almost any USB, FireWire, Bluetooth, or Bonjour (Rendezvous) printer.

    Have a nice afternoon. The End.

    Oh—unless your printer isn't listed in the Printer pop-up menu. In that case, read on.

  3. From the Printer pop-up menu, choose Add Printer (Figure 14-1, top).

    Figure 14-1. Top: To introduce your Mac to a new printer, try to print something—and then choose Add Printer from this pop-up menu.
    Bottom: Your Mac should automatically "see" any printers that are hooked up and turned on. Click the one you want, and then click Add.

    A special setup window opens (Figure 14-1, bottom), which is even better at autodetecting printers available to your Mac. If you see the printer's name now, in the Printer Browser window, click it, and then click Add (Figure 14-1, bottom). You've just designated that printer as the default printer, the one that you'll print on most of the time.

    You're all set. Have a good time.

    Unless, of course, your printer still isn't showing up. Proceed to step 4.

  4. Click the icon for the kind of printer you have: Windows, Bluetooth, AppleTalk, 1/3/2008 IP (that is, an Internet printer), or whatever.

    Choose AppleTalk if you're connected to a laser printer via an Ethernet network cable or AirPort wireless network. Choose Windows if there's a Windows-only printer out there on your office network. And so on.

    After a moment, the names of any printers that are turned on and connected appear in the printer list. For most people, that means only one printer—but one's enough.

  5. Click the name of the printer you want to use.

    As an optional step, you can open the Print Using pop-up menu at the bottom of the dialog box. Choose "Select a driver to use," and then, in the list that appears, choose your particular printer's model name, if you can find it. That's how your Mac knows what printing features to offer you when the time comes: double-sided, legal size, second paper tray, and so on.

  6. Click Add.

    After a moment, you return to the main Printer Browser window (Figure 14-1, top), where your printer now appears. You're ready to print.

Note: If you still don't see your printer's name show up, ask yourself: Is my Mac on a corporate network? Does the network have an LPR (Line Printer) printer? If you and your company's network nerd determine that the printer you want to use is, in fact, an LPR printer, click IP Printing at the top of the Printer Browser dialog box. Fill in the appropriate IP address and other settings, as directed by your cheerful network administrator.

14.1.2. The Printer List

If you're lucky enough to own several printers, repeat the steps above for each one. Eventually, you'll have introduced the Mac to all the printers available to it, so all their names show up in the printer list.

To see the printer list so far, open System Preferences rightwards double arrow Print & Fax. (The old Printer Setup Utility has gone to the great Best Buy in the sky.) You can have all kinds of fun here:

  • Choose a default printer. As indicated by the Default Printer pop-up menu, Leopard intends, conveniently enough, to use whichever printer you used for the last printout for the next one. Most people, after all, don't switch printers much.

    Still, you can choose one particular printer from this pop-up menu to set it as the default printer—the one that the Mac uses unless you intervene by choosing from the Printer pop-up menu in the Print dialog box (Figure 14-1).

  • Create desktop printer icons. This handy, little-known feature gives you drag-and-drop access to your printers.

    From the Print & Fax pane of System Preferences, just drag a printer's icon out of the window and onto the desktop (or wherever you like). Repeat for your other printers. From now on, you can print a document on a certain printer just by dragging the document's icon onto the appropriate printer desktop icon.

  • Recover a gig of drive space. You know how Mac OS X comes with the necessary software for hundreds upon hundreds of printers? Unless you're in Oprah's tax bracket, you probably don't own that many printers—but their drivers are taking up nearly a gigabyte of hard drive space!

    To clean out the ones you don't need, open your hard drive rightwards double arrow Library rightwards double arrow Printers folder. Throw away the folders for printer companies that didn't make your printer. (Administrator account required.)


making_the_printout.html

14.2. Making the Printout

The experience of printing depends on the printer you're using—laser printer, inkjet, or whatever. In every case, however, all the printing options hide behind two commands: File rightwards double arrow Page Setup, which you need to adjust only occasionally, and File rightwards double arrow Print, which you generally use every time you print. You'll find these two commands in almost every Macintosh program.

14.2.1. Page Setup

The Page Setup dialog box lets you specify some key characteristics about the document you're going to print: orientation, paper dimensions, and so on; see Figure 14-2.

The options here vary by program and printer. The Page Setup options for an Epson inkjet, for example, differ dramatically from those for a laser printer. Only your printer's user manual can tell you exactly what these choices do.

Tip: You must configure the Page Setup settings independently in each program you use. And by the way, to change the default paper size for all new documents, choose Save As Default from the Settings pop-up menu. (Mac fans in the UK: You're welcome.)

14.2.2. The Print Command

Although you can grow to a ripe old age without ever seeing the Page Setup dialog box, you can't miss the Print dialog box. It appears, like it or not, whenever you choose File rightwards double arrow Print in one of your programs.

Once again, the options you encounter depend on the printer you're using. In Leopard, they also depend on whether or not you expand the dialog box by clicking the [image] button; doing so reveals a lot of useful options, including a handy preview; see Figure 14-3.

Note: The exact layout of this expanded Print dialog box differs by program, but most modern ones resemble Figure 14-3.

Figure 14-2. Here in Page Setup are the controls you need to print a document rotated sideways on the page, so it prints "the long way." The Scale control, which lets you reduce or enlarge your document, can be handy if the program you're using doesn't offer such a control. And the Paper Size pop-up menu, of course, specifies the size of the paper you're printing on—US Letter, US Legal, envelopes, or one of the standard European or Japanese paper sizes (A4 and B5).

If you expand the box, here's what you may find:

  • Printer. If you have more than one printer connected to your Mac, you can indicate which you want to use for a particular printout by choosing its name from this pop-up menu.

  • Presets. Here's a way to preserve your favorite print settings: Once you've proceeded through this dialog box, specifying the number of copies, which printer trays you want the paper taken from, and so on, you can choose Save As from the pop-up menu, and then assign your settings set a name (like "Borderless, 2 copies"). Thereafter, you'll be able to recreate that elaborate suite of settings simply by choosing its name from this pop-up menu.

  • Copies. Type the number of copies you want printed. The Collated checkbox controls the printing order for the various pages. For example, if you print two copies of a three-page document, the Mac generally prints the pages in this order: 1, 2, 3, 1, 2, 3. If you turn off Collated, on the other hand, it prints in this order: 1, 1, 2, 2, 3, 3.

  • Pages. You don't have to print an entire document—you can print, say, only pages Section P3.1 through Chapter 1.

    Tip: You don't have to type numbers into both the From and To boxes. If you leave the first box blank, the Mac assumes that you mean "from Section P3.1." If you leave the second box blank, the Mac understands you mean "to the end." To print only the first three pages, in other words, leave the first box blank, and type 3 into the second box. (These page numbers refer to the physical pages you're printing, not to any fancy numbering you've set up in your word processor. As far as the Print dialog box is concerned, the first printed page is Section P3.1, even if you've told your word processor to label it Section 11.4.5.)

    Figure 14-3. Top: Most of the time, all you want is one darned copy of what's on your screen. So the standard Print dialog box is Spartan indeed.
    Bottom: When you expand the box, you get a new world of options, including a preview that you can page through. The options here depend on the printer model. On the Layout pane, you can save paper by choosing a higher number from the Pages per Sheet popup menu.

  • Paper Size, Orientation. Some body at Apple finally realized how frustrating it was to have to open the Page Setup dialog box to change the paper size and orientation settings, and then open the Print dialog box for other settings. Now, in most programs, these controls are duplicated right in the Print dialog box for your convenience.

  • PDF. A PDF file, of course, is an Adobe Acrobat document—a file that any Mac, Windows, Linux, or Unix user can view, read, and print using either Preview or the free Acrobat Reader (included with every PC and earlier Mac operating system).

    You can easily save any document as a PDF file instead of printing it—a truly beautiful feature that saves paper, ink, and time. The document remains on your hard drive, and the text inside is even searchable using Spotlight.

    But that's just the beginning. Apple has added a long list of additional PDF options (like password-protected PDFs, emailed ones, and so on).It faced a design quandary: How could it offer a new list of PDF-related options without junking up the Print dialog box?

    Its solution was a strange little item called a pop-up button, shown in Figure 14-3, top. Use it like a pop-up menu. The command you'll use most often is probably Save as PDF, which turns the printout into a PDF file instead of sending it to the printer. For details on the other PDF-related options here, see Section 14.6.1.

  • Preview. This button, present only in the collapsed version of the Print dialog box (Figure 14-3, top), provides a print-preview function to almost every Mac OS X program on earth, which, in the course of your life, could save huge swaths of the Brazilian rain forest and a swimming pool's worth of ink in wasted printouts.

    Technically, the Preview button sends your printout to Preview. Preview lets you zoom in or zoom out, rotate, or otherwise process your preview. When you're satisfied with how it looks, you can print it (File rightwards double arrow Print), cancel it (File rightwards double arrow Close), or turn it into a PDF file (File rightwards double arrow Save as PDF).

  • Supplies. This feature will strike you either as blissfully convenient or disgustingly mercenary: a button that takes you directly to a Web page where you can buy new cartridges for your specific printer model.

    If you examine the unnamed pop-up menu just below the Presets pop-up menu, you find dozens of additional options. They depend on your printer model and the program you're using at the moment, but here are some typical choices:

  • Layout. As described in Figure 14-3, you can save paper and ink or toner cartridges by printing several miniature "pages" on a single sheet of paper.

  • Paper Handling. You can opt to print out your pages in reverse order so that they stack correctly, or you can print just odd or even pages so that you can run them through again for double-sided printing.

  • Paper Feed. If you chose the correct printer model when setting up your printer, then this screen "knows about" your printer's various paper trays. Here's where you specify which pages you want to come from which paper tray. (By far the most popular use for this feature is printing the first page of a letter on company letterhead, and the following pages on blank paper from a second tray.)

  • Cover Page. Yes, that throwaway info page has made its way from the fax world into the hard-copy world.

  • Scheduler. This option lets you specify when you want your document to print. If you're a freelancer, sitting at home with an inkjet on your desk, you might not immediately grasp why anyone wouldn't want the printouts right now. But try printing a 400-page catalog in a big office where other people on the network might conceivably resent you for tying up the laser printer all afternoon, and you'll get the idea.

  • ColorSync. Most color printers offer this panel, where you can adjust the color settings—to add a little more red, perhaps. This is also where you indicate whose color-matching system you want to use: Apple's ColorSync, your printer manufacturer's, or none at all.

Then, below the light gray line in this pop-up menu, you'll find a few options that are unique to the chosen printer or program. Some HP printers, for example, offer Cover Page, Finishing, and other choices. Other likely guest commands:

  • Quality & Media (inkjet printers only). Here's where you specify the print quality you want, the kind of paper you're printing on, and so on. (The name of this panel varies by manufacturer.)

  • [Program Name].Whichever program you're using—Mail, Word, AppleWorks, or anything else—may offer its own special printing options on this screen.

  • Summary. This command summons a text summary of all your settings so far.

Tip: Here's one for the technically inclined. Open your Web browser and enter this address: http://127.0.0.1:631. You find yourself at a secret "front end" for CUPS (Common Unix Printing System), the underlying printing technology for Mac OS X 10.5. This trick lets your Mac communicate with a huge array of older printers that don't yet have Mac OS X drivers. Using this administration screen, you can print a test page, stop your printer in its tracks, manage your networked printers and print jobs, and more—a very slick trick.

14.2.3. Printing

When all of your settings look good, click Print (or press Enter) to send your printout to the printer.


managing_printouts.html

14.3. Managing Printouts

After you've used the Print command, you can either sit there until the paper emerges from the printer, or you can manage the printouts-in-waiting. That option is attractive primarily to people who do a lot of printing, have connections to a lot of printers, or share printers with many other people.

Start by opening the printer's window. If you're already in the process of printing, just click the printer's Dock icon. If not, open [image] rightwards double arrow System Preferences rightwards double arrow Print & Fax, click the printer's name, and then click Open Print Queue.

At this point, you see something like Figure 14-4: The printouts that will soon be sliding out of your printer appear in a tidy list.

Here are some of the ways in which you can control these waiting printouts, which Apple collectively calls the print queue:

  • Delete them. By clicking an icon, or [image] -clicking several, and then clicking the Delete toolbar button, you remove items from the list of waiting printouts. Now they don't print.

    Figure 14-4. Waiting printouts appear in this window. You can sort the list by clicking the column headings (Name or Status), make the columns wider or narrower by dragging the column-heading dividers horizontally, or reverse the sorting order by clicking the column name a second time. The Supply Level button opens a graph that shows how much ink each cartridge has remaining (certain printer models only).

  • Pause them. By highlighting a printout and then clicking the Hold button, you pause that printout. It doesn't print out until you highlight it again and then click the Resume button. (Other documents continue to print.) This pausing business could be useful when, for example, you need time to check or refill the printer, or when you're just about to print your resignation as your boss drops by to offer you a promotion.

  • Halt them all. You can stop all printouts from a printer by clicking Pause Printer. (They resume when you click the button again, which now says Resume Printer.)

You can't rearrange printouts by dragging them in the queue list. But remember that you can resequence the printing order by choosing the Scheduler option described on Section 14.2.2; you can also drag waiting printouts between these lists, shifting them from one printer to another.

Tip: As you now know, the icon for a printer's queue window appears automatically in the Dock when you print. But in Mac OS X 10.5, it stays in the Dock for the rest of the day; it doesn't disappear when the printing is complete.If you wish it would, Control-click (or right-click) the printer's Dock icon; from the shortcut menu, choose Auto Quit.


printer_sharing.html

14.4. Printer Sharing

Printer sharing is for people (or offices) with more than one Mac, connected to a network, who'd rather not buy a separate printer for each machine. Instead, you connect the printer to one Mac, flip a couple of software switches, and then boom: The other Macs on the network can send their printouts to the printer without actually being attached to it—even wirelessly attached, if they're on an AirPort network.

Note: Of course, this feature is most useful when you're sharing printers that can hook up to only one Mac at a time, like USB inkjet photo printers. Office laser printers are often designed to be networked from Day One.

Figure 14-5. Top: On the Mac with the printer, open the Sharing panel of System Preferences. Turn on Printer Sharing. Turn on the checkbox for the printer(s) you want to share.
Bottom: To use a shared printer elsewhere on the network, open the document you want to print, and then choose File rightwards double arrow Print. In the Print dialog box, choose Add Printer. The shared printer is clearly identified; click it and click Add, just as you'd add any printer (Figure 14-1). From now on, it shows up in the Printer pop-up menu just like any other printer.

Setting up printer sharing is easy; see Figure 14-5, top. Then, to make a printout from across the network, see the instructions in Figure 14-5, bottom.

If your PC-wielding friends install Bonjour for Windows (a free download from this book's "Missing CD" page at www.missingmanuals.com), they can even print to your Mac's shared printer, too.

Tip: Of course, your Mac (the one attached to the printer) must be turned on in order for the other computers to print. In part, that's because the documents-in-waiting from other people pile up on your hard drive.


faxing.html

14.5. Faxing

Using the Mac as a fax machine is a terrific idea, for a lot of reasons. It saves money on paper and fax cartridges, and spares you the expense of buying a physical fax machine. Faxing from the Mac also eliminates the silly and wasteful ritual of printing something out just so you can feed it into a fax machine. And because your fax originates directly from the heart of Mac OS X instead of being scanned by a crummy 200-dpi fax-machine scanner, it blesses your recipient with a great-looking document.

Here's the basic idea: When faxes come in, you can read them on the screen, opt to have them printed automatically, or even have them emailed to you so that you can get them wherever you are in the world. (Try that with a regular fax machine.) And sending a fax is even easier on a Mac than on a regular fax machine: You just use the File rightwards double arrow Print command, exactly like you're making a printout of the onscreen document.

There are only two downsides of using a Mac as a fax machine:

FREQUENTLY ASKED QUESTION
Scanning: The Opposite of Printing

Will my scanner work with Mac OSX?

These days, the odds are pretty good.

For the first couple of years A.M. (After Mac OS X), scanning was a sore spot for Mac fans. Precious few scanners worked with Mac OS X even a year after its release.

These days, Mac OS X recognizes almost any Epson scanner and any scanner that works with the so-called TWAIN scanning standard (which, if you can believe it, stands for Technology Without An Interesting Name). As noted on Section 10.17.7, you can use Mac OS X's Image Capture program to operate such scanners without even installing any software.

If you're hanging onto an older scanner model that predates these scanning standards, run, don't walk, to www.hamrick.com to download VueScan. It's a $50 shareware program that makes dozens of scanners work with Mac OS X, including:

SCSI models including all SCSI scanners from Apple, Epson, Canon, HP, Microtek, UMAX, Linotype-Hell, Acer/BenQ, and Agfa.

USB models including all scanners from Epson and many from Canon, HP, Microtek, UMAX, and others.

FireWire models including all scanners from Epson, Microtek, UMAX, and Linotype-Hell.

The funny thing is, you may even want VueScan if you already have a driver for your scanner, because VueScan's controls and speed may be superior to what you've got.

  • The Mac needs its own phone line. Otherwise, your Mac, answering each incoming call, will give friends and relatives a screaming earful when they call to express their love.

    Of course, you can avoid that prerequisite by using your Mac exclusively for sending faxes, so that it doesn't answer the phone. Or if you need to receive the occasional fax, you could just turn on the fax-receiving feature only when somebody is about to send you a fax. Or you could buy an automated fax/voice splitter that sends voice lines to the phone and incoming faxes to the Mac.

    But in general, the Mac-as-fax works best if it has its own line.

  • You can't fax from a book or magazine. The one big limitation of Mac-based faxing is that you can only transmit documents that are, in fact, on the computer. That pretty much rules out faxing notes scribbled on a legal pad, clippings from People magazine, and so on, unless you scan them in first.

14.5.1. Setting Up Faxing

Open System Preferences. Click Print & Fax. Click the + button, and proceed as shown in Figure 14-6.

Note: Unfortunately, Apple no longer builds fax modems into new Macs—not even laptops. You can buy an external dangly Apple USB Fax/Modem for $50, however. As soon as it's plugged into a USB port, its name appears in the Printers list.

Figure 14-6. When you click the + button, this handy list of fax modems pops up. Chances are, you have only one—and it's either an old Apple Internal or a USB External model that you bought from Apple. Click its name, and then click Add.

If you intend to send faxes from the Mac, type in your return fax number in the Fax Number box.

Tip: If you're smart, you'll also turn on "Show fax status in menu bar." It installs a fax menulet that lets you monitor and control your fax sending and receiving.

If you intend to receive faxes, click Receive Options, and turnon "Receive faxes on this computer." Then specify how soon the fax machine should pick up the call (after how many rings—you don't want it answering calls before you have a chance).

Finally, you can say how you want to handle incoming faxes, as described in Figure 14-7.

Figure 14-7. When your Mac answers the fax line, it can do three things with the incoming fax. Option 1: Save it as a PDF file that you open with Preview. (The Mac proposes saving these files into the Users rightwards double arrow Shared rightwards double arrow Shared Faxes folder, but you can set up a more convenient folder.) Option 2: Print it out automatically, just like a real fax machine. Option 3: Email it to you, so you can get your faxes even when you're not home (and so you can forward the fax easily).

14.5.2. Sending a Fax

When you're ready to send a fax, type up the document you want to send. Choose File rightwards double arrow Print. In the Print dialog box (Figure 14-3), open the PDF pop-up button and choose Fax PDF.

The dialog box shown in Figure 14-8 appears. Here are the boxes you can fill in:

  • To. If you like, you can simply type the fax number into the To box, exactly the way it should be dialed: 1-212-553-2999, for example. You can send a single fax to more than one number by separating each with a comma and a space.

    If you fax the same people often, though, you're better off adding their names and fax numbers to the Address Book (Chapter 19). That way, you can click the little silhouette button to the right of the To box and choose the recipient, as shown in Figure 14-8.

    Note: At this writing, the Address Book feature doesn't work when you're sending from Microsoft Word or Excel. You have to type in the fax number by hand.

    Figure 14-8. When you send a fax, you get a modified Print dialog box. Here is where you specify a cover page (and what you want on it).
    You can type a fax number into the To box, or you can click the silhouette head button to open a miniature version of Address Book. It lets you choose someone's name by double-clicking. All phone numbers appear here, so look for those identified as fax numbers. (Chances are that these listings don't include the 1- long distance prefix, which is why Apple gave you a separate Dialing Prefix box.) If you've built groups in your address book, you can send to everyone in a group at once.

  • Settings. Most of the time, fiddling with the printing pop-up menu isn't relevant to sending a fax. (ColorSync? On a black-and-white fax? Get real!) But the standard printing controls are here for your convenience. You can use the Scheduler pane to specify a time for your outgoing fax, the Layout pane to print more than one "page" per sheet, and so on.

  • Use Cover Page, Subject, Message. If you turn on this checkbox, you're allowed to type a little message into the Subject and Message boxes.

    Beware! Don't press the Return key to add a blank line to your message. Mac OS X thinks you intend to "click" the Fax button—and off it goes!

    Tip: Choosing Save as PDF from the little PDF pop-up button, at this moment, is your only chance to keep a copy of the fax you're sending.
14.5.2.1. Sending

When everything looks good, hit the Fax button. Although it may look like nothing is happening, check your Dock, where the icon for your fax/modem has appeared. If you click it, you'll see a clone of the dialog box shown in Figure 14-4, indicating the progress of your fax. Here you can pause the faxing, delete it, or hold it, exactly as you would a printout. (Your Fax menulet, if you've installed it, also keeps you apprised of the fax's progress; see Figure 14-9.)

Otherwise, you don't get much feedback on the faxing process. Once the connection sounds are complete, you don't hear anything, see anything, or receive any notice that the fax was successful.

(If your fax was not successfully sent for some reason, the modem's window automatically reschedules the fax to go out in five minutes.)

Tip: On a network, only one Mac has to be connected to a phone line. On that Mac, open System Preferences, click Sharing, turn on Printer Sharing, and turn on the checkbox for your fax modem. From now on, other Macs on the network can send out faxes via the one that has a phone line! (They'll see the shared modem listed in the Fax dialog box.)

Figure 14-9. The Fax menulet (top) says "Dialing… Connecting…" and so on. Click to see the Hang Up Now command.
The Fax queue shows the faxes that are currently sending or scheduled to go out later. To see which documents you've successfully sent, and when they went out, choose Jobs rightwards double arrow Show Complete Jobs.

14.5.2.2. Checking the log, checking the queue

To see the log of all sent and received faxes, choose [image] rightwards double arrow System Preferences rightwards double arrow Print & Fax.Double-click your fax/modem'sname; its fax-management window appears, but that's not what you're interested in. Instead, choose Jobs rightwards double arrow Show Completed Jobs. You get a status window that looks a lot like the one for a printer (Figure 14-9, bottom).

14.5.3. Receiving a Fax

A Mac that's been set up to answer calls does a very good impersonation of a fax machine. You don't even have to be logged in to get faxes, although the Mac does have to be turned on. In System Preferences rightwards double arrow Energy Saver rightwards double arrow Options, turnon "Wake when modem detects a ring" to prevent your Mac from being asleep at the big moment.

When a fax call comes in, the Mac answers it after the number of rings you've specified. Then it treats the incoming fax image in the way you've specified in System Preferences: by sending it to your email program, printing it automatically, or just saving it as a PDF file in a folder that you've specified.


pdf_files.html

14.6. PDF Files

Sooner or later, almost everyone with a personal computer encounters PDF (portable document format) files. Many a software manual, Read Me file, and downloadable "white paper" comes in this format. Until recently, you needed the free program called Acrobat Reader if you hoped to open or print these files. Windows devotees still do.

PDF files, however, are one of Mac OS X's common forms of currency. In fact, you can turn any document (in any program with a Print command) into a PDF file—a trick that once required the $250 program called Adobe Acrobat Distiller. (Maybe Apple should advertise: "Buy Acrobat for $250, get Mac OS X free—and $120 cash back!")

But why would you want to do so? What's the big deal about PDF in Mac OS X? Consider these advantages:

  • Other people see your layout. When you distribute PDF files to other people, they see precisely the same fonts, colors, page design, and other elements that you put in your original document. And here's the kicker: They get to see all of this even if they don't have the fonts or the software you used to create the document.

    POWER USERS' CLINIC
    Beyond Mac OS X Fax

    As you'll discover pretty quickly, Mac OS X's built-in faxing feature is bare-bones, to say the least. For example, you can't design your own cover pages, and you can't open a fax you've sent, in order to inspect it.

    There are alternatives. For starters, the shareware world is a good place to shop. For example, you can try Page-Sender, Cocoa eFax, or any of the other shareware faxing programs listed at www.versiontracker.com. (Do a search for fax on the Mac OS X tab.)

    (Contrast with the alternative. Say you're sending somebody a Microsoft Word document. If your correspondent doesn't have precisely the same fonts you have, then he'll see a screwy layout. And if he doesn't have Word or a program that can open Word files, he'll see nothing at all.)

  • It'suniversal. PDF files are very common in the Macintosh, Windows, Unix/Linux, and even Palm and Pocket PC organizer worlds. When you create a PDF file, you can distribute it (by email, for example) without worrying about what kinds of computers your correspondents are using.

  • It has very high resolution. PDF files print at the maximum quality of any printer. A PDF file prints great both on cheapo inkjets and on high-quality image-setting gear at professional print shops. (Right now you're looking at a PDF file that was printed at a publishing plant.)

  • You can search it. Although you may be tempted to think of a PDF file as something like a captured graphic of the original document, it has several key differences. Behind the scenes, its text is still text; Spotlight can find a PDF in a haystack in a matter of seconds. That's an especially handy feature when you work with electronic software manuals in PDF format.

Note: All right, that joke about a free copy of Acrobat is an exaggeration. Mac OS X alone creates screen-optimized PDF files: compact, easy-to-email files that look good onscreen but don't have high enough resolution for professional printing. For high-end purposes and more optimization for specific uses (Web, fancy press machines, and so on), you still need a program like Adobe Acrobat, Illustrator, or InDesign.

14.6.1. Opening PDF Files

There's nothing to opening up a PDF file: Just double-click it. Preview takes over from there, and opens the PDF file on your screen.

14.6.2. Creating PDF Files

Opening, schmopening—what's really exciting in Mac OS X is the ability to create your own PDF files. The easiest way is to click the PDF pop-up button in the standard Print dialog box (Figure 14-10). When you click it, you're offered a world of interesting PDF-creation possibilities:

  • Save as PDF. Mac OS X saves your printout-to-be to the disk as a PDF document instead of printing it.

  • Save PDF as PostScript. You get a PostScript file instead of PDF. (PostScript is a format preferred by some designers and print shops. It consists of highly precise "what to draw" instructions for PostScript laser printers.)

  • Fax PDFfaxes a document instead of printing it, as described on the preceding pages.

  • Mail PDF generates a PDF, and then attaches it to an outgoing message in Mail. Great for exchanging layout-intensive documents with collaborators who don't have the same fonts, layout software, or taste as you.

  • Save as PDF-X creates a specialized PDF format, popular in the printing industry, that's extra compact because it contains the minimum data needed to print the document.

  • Save PDF to iPhoto creates a PDF version of the document and then exports it to iPhoto. That's not such a bad idea; iPhoto is great at managing and finding any kind of graphics documents, including PDFs.

    Tip: Remember that once you send a document or layout to iPhoto, you can turn it into a custom-printed book, calendar, greeting card, or postcard.

  • Save PDF to Web Receipts Folder is one of the simplest and sweetest features in all of Mac OS X.

    You use it when you've just ordered something on a Web site, and the "Print This Receipt" screen is staring you in the face. Don't waste paper and ink (and, later, time trying to find it!). Instead, use this command. You get a perfectly usable PDF version, stored in your Home rightwards double arrow Documents rightwards double arrow Web Receipts folder, where you can use Spotlight to find it later, when you need to consult or print it because your gray-market goods never arrived.

  • Edit Menu lets you prune this very list to remove the options you never use.

Figure 14-10. The PDF button is crawling with neat ways to process a document while it's still open—and you can add to this pop-up button's list, too. For example, you can create even more elaborate pathways for documents you want to print or convert to PDF using an Automator workflow (Chapter 7). Or, to pare down this menu, choose Edit Menu.


fontsmdashand_font_book.html

14.7. Fonts—and Font Book

Mac OS X delivers type that is all smooth, all the time. Fonts in Mac OS X's formats— called TrueType, PostScript Type 1, and OpenType—always look smooth onscreen and in printouts, no matter what the point size.

Mac OS X also comes with a program that's just for installing, removing, inspecting, and organizing fonts. It's called Font Book (Figure 14-11), it's in your Applications folder, and it's been much improved in Leopard.

Figure 14-11. Each account holder can have a separate set of fonts; your set is represented by the User icon. You can drag fonts and font families between the various Fonts folders represented here— from your User account folder to the Computer icon, for example, making it available to all account holders.

14.7.1. Where Fonts Live

Brace yourself. In Mac OS X, there are three Fonts folders. The fonts you actually see listed in the Fonts menus and Font panels of your programs are combinations of these Fonts folders' contents.

They include:

  • Your private fonts (your Home folder rightwards double arrow Library rightwards double arrow Fonts). This Fonts folder sits right inside your own Home folder. You're free to add your own custom fonts to this folder. Go wild—it's your font collection and yours alone. Nobody else who uses the Mac can use these fonts; they'll never even know that you have them.

  • Main font collection (Library rightwards double arrow Fonts). Any fonts in this folder are available to everyone to use in every program. (As with most features that affect everybody who shares your Macintosh, however, only people with Administrator accounts can change the contents of this folder.)

  • Essential system fonts (System rightwards double arrow Library rightwards double arrow Fonts). This folder contains the 35 fonts that the Mac itself needs: the typefaces you see in your menus, dialog boxes, icons, and so on. You can open this folder to see these font suitcases, but you can't do anything with them, such as opening, moving, or adding to them. Remember that, for stability reasons, the System folder is sealed under glass forever. Only the superuser (Section 16.7.5.1) can touch these files—and even that person would be foolish to do so.

With the exception of the essential system fonts, you'll find an icon representing each of these locations in your Font Book program, described next.

Note: And just to make life even more exciting, Adobe's software installers may donate even more fonts to your cause, in yet another folder: your Home rightwards double arrow Application Support folder.

14.7.2. Font Book: Installing and Managing Fonts

One of the biggest perks of Mac OS X is its preinstalled collection of over 50 great looking fonts—"over $1,000 worth," according to Apple, which licensed many of them from type companies. In short, fewer Mac users than ever will wind up buying and installing new fonts.

But when you do buy or download new fonts, you're in luck. There's no limit to the number of fonts you can install.

14.7.2.1. Looking over your fonts

Right off the bat, Font Book is great for one enjoyable pursuit: looking at samples of each typeface. Click Computer, for example, click the first font name, and then press the down arrow key. As you walk down the list, the rightmost panel shows you a sample of each font (Figure 14-11).

You can also click any font family's flippy triangle (or highlight its name and then press the right arrow) to see the font variations it includes: Italic, Bold, and so on.

Tip: When you first open Font Book, the actual text of the typeface preview (in the right panel) is pretty generic. Don't miss the Preview menu, though. It lets you substitute a full display of every character (choose Repertoire)—or, if you choose Custom, it lets you type your own text.
14.7.2.2. Printing a reference sheet

For the first time in Mac OS X 10.5, you can now print a handy, whole-font sampler of any font. Click its name and then choose File rightwards double arrow Print. In the Print dialog box, click the [image] button to expand the dialog box, if necessary.

As shown in Figure 14-12, you can use the Report Type pop-up menu to choose from three reference-sheet styles:

  • Catalog prints the alphabet twice (uppercase and lowercase) and the numbers in each selected font; use the Sample Size slider to control the size. This style is the most compact, because more than one print sample fits on each sheet of paper.

  • Repertoire prints a grid that contains every single character in the font. This report may take more than one page per font.

  • Waterfall prints the alphabet over and over again, with increasing type sizes, until the page is full. You can control which sizes appear using the Sample Sizes list.

When everything looks good, click Print.

Figure 14-12. From the Report Type pop-up menu, choose the style you want. The preview screen shows you each one before you commit it to paper. Type-size controls always appear in the lower right.

14.7.2.3. Eliminating duplicates

Since your Mac accesses up to three folders containing fonts, you might wonder what happens in the case of conflicts. For example, suppose you have two slightly different fonts, both called Optima, which came from different type companies, and are housed in different Fonts folders on your system. Which font do you actually get when you use it in your documents?

The scheme is actually fairly simple: Mac OS X proceeds down the list of Fonts folders in the order shown on Section 14.7.1, beginning with your own home Fonts folder. It only acknowledges the existence of the first duplicated font it finds.

If you'd rather have more control, open Font Book. A bullet (•) next to a font's name is Font Book's charming way of trying to tell you that you've got copies of the same font in more than one of your Fonts folders. You might have one version of Comic Sans in your own Home rightwards double arrow Library rightwards double arrow Fonts folder, for example, and another in your Mac's main Fonts folder.

Click the one that you want to keep, and then choose Edit rightwards double arrow Resolve Duplicates. Font Book turns off all other copies, and the bullet disappears.

14.7.2.4. Adding, removing, and hiding fonts

Here's what you can do with Font Book:

  • Install a font. When you double-click a font file's icon in the Finder, Font Book opens and presents the typeface for your inspection pleasure. If you like it, click Install Font. You've just installed it into your account's Fonts folder, so that it appears in the Font menus of all your programs. (If you'd rather install it so that it appears in all account holders' Fonts menus, see Figure 14-11.)

  • Remove a font. Removing a font from your machine iseasy: Highlight it in the Font Book list, and then press the Delete key. (You're asked to confirm the decision.) Before taking such a drastic and permanent step, however, keep in mind that you can simply disable (hide) the font instead. Read on.

  • Disable a font. When you disable a font, you're simply hiding it from your programs. You might want to turn off a font so that you can use a different version of it (bearing the same name but from a different type company, for example), or to make your Font menus shorter, or to make programs like Microsoft Word start up faster. You can always turn a disabled font back on if you ever need it again.

Tip: How's this for a sweet new feature in Leopard? Mac OS X can now activate fonts automatically as you need them. When you open a document that relies on a font it doesn't have, Leopard activates that font and keeps it available until that particular program quits.Actually, it does better than that. If it doesn't see that font installed, it actually searches your hard drive on a quest to find the font—and then it asks you if you want it installed, so the document will look right.

To disable a font, just click it (or its family name; see Figure 14-11) and then click the checkbox button beneath the list (or press Shift- [image] -D). Confirm your decision by clicking Disable in the confirmation box. (Turn on "Do not ask me again," if you're the confident sort.)

The font's name now appears gray, and the word Off appears next to it, making it absolutely clear what you've just done.(To turn the font on again, highlight its name, and then click the now-empty checkbox button, or press Shift- [image] -D again.)

Note: When you install, remove, disable, or enable a font using Font Book, you see the changes in the Font menus and panels of your Cocoa programs immediately. You won't see the changes in open Carbon programs, however, until you quit and reopen them.
14.7.2.5. Font collections

A collection, like the ones listed in the first Font Book column, is a subset of your installed fonts. Apple starts you off with collections called things like PDF(a set of standard fonts used in PDF files) and Web (fonts you're safe using on Web pages—that is, fonts that are very likely to be installed on the Macs or Windows PCs of your Web visitors).

But you can create collections called, for example, Headline or Sans Serif, organized by font type. Or you can create collections like Brochure or Movie Poster, organized by project. Then you can switch these groups of fonts on or off at will, just as though you'd bought a program like Suitcase.

To create a new collection, click the leftmost + button to create a new entry in the Collections column, whose name you can edit. Then click one of the font storage locations—User or Computer—and drag fonts or font families onto your newly created collection icon. (Recognize this process from play lists in iTunes, or albums in iPhoto?) Each font can be in as many different collections as you want.

To remove a font from the collection, click its name, and then press Delete. You're not actually removing the font from your Mac, of course—only from the collection.

Tip: Each time you create a new font collection, Mac OS X records its name and contents in a little file in your Home folder rightwards double arrow Library rightwards double arrow Font Collections folder.By copying these files into the Shared folder (see Section 12.6.2), you can make them available to anyone who uses the Mac. If your sister, for example, copies one of these files from there into her own Home folder rightwards double arrow Library rightwards double arrow Font Collections folder, she'll see the name of your collection in her own Fonts panel. This way, she can reap the benefits of the effort and care you put into its creation.
14.7.2.6. Font libraries

Don't get confused; a font library is not the same as a font collection.

A font library is a set of fonts outside Font Book that you can install or uninstall on the fly. They don't have to be in any of your Fonts folders; Font Book can install them from wherever they happen to be sitting on your hard drive (or even on the network). Font Book never copies or moves these font files as you install or remove them from libraries; it simply adds them to your Font menus by referencing them right where they sit.

Tip: That can be a handy arrangement if you periodically work on different projects for different clients. Why burden your day-to-day Font menu with the 37 fonts used by Beekeeper Quarterly magazine, when you need to work with those fonts only four times a year?

Once you've added some fonts to a library, you can even set up collections within that library.

To create a library, choose File rightwards double arrow New Library; the library appears in the Collection list at the left side of Font Book. Now you can drag fonts into it right from the Finder, or set up collections inside it by highlighting the library's icon and choosing File rightwards double arrow New Collection.

14.7.2.7. Exporting fonts

Next time you submit a design project to a print shop or graphics bureau, you won't have to worry that they won't have the right fonts. It's easy to collect all the fonts you used in a document, and then export them to a folder, ready to submit, along with your document, to the print shop.

Use the Services rightwards double arrow Font Book rightwards double arrow Create Collection From Text command. Font Book opens and shows you a new collection it's created, containing all the fonts used in your document. Click the collection, and then choose File rightwards double arrow Export Collection. The software prompts you to name and choose a location for the exported fonts folder.

Note: The Create Collection From Text command doesn't work in all programs, but you can always build and export a collection manually.

14.7.3. The Fonts Panel

As noted in Chapter 5, some existing Mac programs have simply been touched up—Carbonized, in the lingo—to be Mac OS X–compatible. Choosing fonts in these programs works exactly as it always has on the Mac: You choose a typeface name from the Font menu or a formatting palette.

Things get much more interesting when you use Cocoa programs (Section 5.9), like TextEdit, iMovie, Pages, Keynote, Numbers, iPhoto, and Mail. They offer a standard Mac OS X feature called the Fonts panel. If you're seated in front of your Mac OS X machine now, fire up Text Edit or Pages and follow along.

14.7.3.1. Choosing fonts from the Fonts panel

Suppose you've just highlighted a headline in TextEdit, and now you want to choose an appropriate typeface for it.

In Text Edit, you open the Fonts panel (Figure 14-13) by choosing Format rightwards double arrow Font rightwards double arrow Show Fonts ( [image] -T). If you've ever used Font Book, this display should look familiar. The first column lists your Collections, as described above. The second column, Family, shows the names of the actual fonts in your system. The third, Typeface, shows the various style variations—Bold, Italic, Condensed, and so on—available in that type family. (Oblique and Italic are roughly the same thing; Bold, Black, and Ultra are varying degrees of boldface.)

The last column lists a sampling of point sizes. You can use the size slider, choose from the point-size pop-up menu, or type any number into the box at the top of the Size list.

14.7.3.2. Designing collections and favorites

At the bottom of the Fonts panel, the [image] menu offers a few useful tools for customizing the standard Fonts panel:

  • Add to Favorites. To designate a font as one of your favorites, specify a font, style, and size by clicking in the appropriate columns of the Fonts panel. Then use this command.

    From now on, whenever you click Favorites in the Collections column, you'll see a list of the typefaces you've specified.

  • Show Preview. The Fonts panel is great and all that, but you may have noticed that, at least at first, it doesn't actually show you the fonts you're working with—something of an oversight in a window designed to help you find your fonts. See Figure 14-13 for details. (Choose this command again—now called Hide Preview—to get rid of this preview.)

    Figure 14-13. The Fonts panel, generally available only in Cocoa programs, offers elaborate controls over text color, shadow, and underline styles. It also contains some of the genetic material of old-style programs like Suitcase and Font Juggler.
    See the handy font sample shown here above the font lists? To get it, choose Show Preview from the pop-up menu. Or use the mousy way: Place your cursor just below the title bar (where it says Fonts) and drag downward.

    Tip: Once you've opened the Preview pane, feel free to click the different sizes, typeface names, and family names to see the various effects.

  • Hide Effects. The "toolbar" of the Fonts panel lets you create special text effects— colors, shadows, and so on—as shown in Figure 14-13. This command hides that row of pop-up buttons.

  • Color. Opens the Color Picker (Section 5.13), so you can specify a color for the highlighted text in your document.

  • Characters. Opens the Character Palette (Section 9.13.2), so you can choose a symbol without having to remember the crazy keyboard combo that types it.

  • Typography. Opens the Typography palette (see Figure 14-14).

  • Edit Sizes. The point sizes listed in the Fonts panel are just suggestions. You can actually type in any point size you want. By choosing this command, in fact, you can edit this list so that the sizes you use most often are only a click away.

  • Manage Fonts. Opens Font Book, described earlier in this chapter.

    Figure 14-14. The Typography palette is a collapsible menagerie of fancy type effects, which vary by font. In this example, turning on Common Ligatures creates fused letter pairs like fl and fi; the Small Capitals option created the "Do Not Drink" style; and so on.


colorsync-id001.html

14.8. ColorSync

As you may have discovered through painful experience, computers aren't great with color. Each device you use to create and print digital images "sees" color a little bit differently, which explains why the deep amber captured by your scanner may be rendered as chalky brown on your monitor, yet come out as a fiery orange on your Epson inkjet printer. Since every gadget defines and renders color in its own way, colors are often inconsistent as a print job moves from design to proof to press.

ColorSync attempts to sort out this mess, serving as a translator between all the different pieces of hardware in your workflow. For this to work, each device (scanner, monitor, printer, digital camera, copier, proofer, and so on) has to be calibrated with a unique ColorSync profile—a file that tells your Mac exactly how it defines colors. Armed with the knowledge contained in the profiles, the ColorSync software can compensate for the various quirks of the different devices, and even the different kinds of paper they print on.

Most of the people who lose sleep over color fidelity are those who do commercial color scanning and printing, where "off " colors are a big deal. After all, a customer might return a product after discovering, for example, that the actual product color doesn't match the photo on a company's Web site.

14.8.1. Getting ColorSync Profiles

ColorSync profiles for many color printers, scanners, and monitors come built into Mac OS X. When you buy equipment or software from, say, Kodak, Agfa, or Pantone, you may get additional profiles. If your equipment didn't come with a ColorSync profile, visit Profile Central (www.chromix.com), where hundreds of model-specific profiles are available for downloading. Put new profiles into the Library rightwards double arrow ColorSync rightwards double arrow Profiles folder.

GEM IN THE ROUGH
The Coolest Feature?

Deep in the ColorSync Utility program beats one of the coolest Mac OS X features that no-body's ever discovered.

On the Profiles tab, you can click the name of a color-device profile and view a lab plot of its gamut (the colors it's capable of displaying). What you might not realize, however, is that this is a 3-D graph; you can drag its corners to spin it in space.

But that's not the cool part. The tiny triangle in the corner of the graph is a pop-up menu. If you choose "Hold for comparison" and then choose a different color profile, you'll see both lab plots superimposed, revealing the spectrum areas where they overlap—and the yawning gaps where they can't display the same colors.

You'll find out, among other things, that some printers can't display nearly as many colors as your monitor can, and that inkjets are much better at depicting, say, cyan than green.

And while we're discussing features you might have missed: You can double-click a profile's name to view a dizzyingly complex scientific description of its elements.

Blue colorant tristimulus, anyone?

14.8.2. Default Profiles

In professional graphics work, a ColorSync profile is often embedded right in a photo, making all this color management automatic. Using the ColorSync Utility program (in Applications rightwards double arrow Utilities), you can specify which ColorSync profile each of your gadgets should use. Click the Devices button, open the category for your device (scanner, camera, display, printer, or proofer), click the model you have, and use the Current Profile pop-up menu to assign a profile to it.

Tip: In the Displays pane of System Preferences, you'll find a Color tab. Its Calibrate button is designed to create a profile for your particular monitor in your particular office lighting—all you have to do is answer a few fun questions onscreen and drag a few sliders.

14.8.3. More on ColorSync

If you ache to learn more about ColorSync, you won't find much in Mac OS X's Help system. Instead, search the Web. At www.apple.com/colorsync, for example, you'll find articles, tutorials, and links. Going to a site like www.google.com and searching for ColorSync is also a fruitful exercise.


graphics_in_mac_os_x.html

14.9. Graphics in Mac OS X

Now you're talking! If you want to see dilated pupils and sweaty palms, just say "graphics" to any Mac OS X junkie.

Yes, Mac OS X has made graphics a huge deal, thanks to its sophisticated Quartz graphics-processing technology. Everywhere you look in Mac OS X, you'll find visual effects that would make any other operating system think about early retirement.

For example: Menus are transparent, and when you release them, they fade away instead of snapping off. You can set Excel 3-D graphs to be slightly transparent, so that they don't block other bars in a 3-D graph. When you paste files into windows in icon view, their icons fade into view. When you open an especially long message in Mail, its text fades in from white. When you open a widget in Dashboard, it splashes down with a pond-ripple effect. And when you switch accounts using Fast User Switching, your work environment slides off the screen as though it's pasted on the side of an animated cube.

UP TO SPEED
AppleScript and ColorSync

Using AppleScript, described in Chapter 7, you can harness ColorSync in elaborate ways. Just by dragging document icons onto AppleScript icons, for example, you can embed ColorSync profiles, modify the profiles already incorporated, remove profiles, review the profile information embedded in a graphic, and much more. Better yet, you don't even have to know AppleScript to perform these functions—just use the built-in AppleScripts that come with Mac OS X.

To find them, open the Library rightwards double arrow ColorSync rightwards double arrow Scripts folder. Unfortunately, there aren't any instructions for using these 18 ready-made AppleScripts. Nonetheless, Apple's real hope is that these example scripts give you a leg up on creating your own AppleScripts—that someday you, the print shop operator, will be able to automate your entire color processing routine using AppleScript and ColorSync.

All of these visual goodies owe their existence to Quartz (or its enhanced successor, Quartz Extreme, which is not available on older Macs).

14.9.1. Graphics Formats in Mac OS X

Mac OS X understands dozens of Mac and Windows graphics file formats. Better yet, its Preview program can open such graphics and then export them in a different format, making it an excellent file-conversion program.

You can confidently double-click graphics files—from a digital camera, scanner, or Web download, for example—in any of these formats:

  • PICT files. For almost 20 years, the PICT file was the graphics format Mac fans were most familiar with. It was the graphics format used by the Macintosh Clipboard, and it was the format created by the Shift- [image] -3 keystroke (see the end of this chapter).

    Unfortunately, no other kinds of computers could open these files, so PICT files gave conniptions to the equipment at printing shops. Mac OS X acknowledges the existence of PICT files, and can open them just fine; the Preview program can even export them. Otherwise, however, Mac OS X dramatically downplays the importance of PICT files, which will soon ride into the sunset.

  • TIFF files. The TIFF file format is a high-density bitmap—that is, the Mac has memorized the color of each tiny dot in the file. Trying to enlarge one is like enlarging a fax: Make it too big, and the image breaks down into visible dots.

    Nonetheless, TIFF files are very popular in the printing industry—most of the graphics in this book, for example, were stored as TIFF files. They print beautifully, work nicely in page-layout programs, and are understood by both Macs and PCs.

  • JPEG files. This format is one of the most popular on the Web, particularly for photos or other high-quality, full-color artwork.

    What makes JPEG files ideal for online use is that they've been compressed (using a program like Photoshop). Just enough of the color data has been thrown out from the original file to make the image a quick download without noticeably affecting its quality.

  • GIFfiles. GIF stands for graphics interchange format. Today,GIF files are used almost exclusively on the Web, usually for solid-colored graphics like cartoons, headlines, and logos. (A GIF file can have a maximum of 256 colors, which is not even close to the photorealism of, say, JPEG. That's what makes GIF files inappropriate for photographs.)

  • PNG files. As it turns out, one of the algorithms used by GIF files is, technically speaking, the property of a company called Unisys, which threatened to sue everybody who was creating GIF files. "No problem," said the World Wide Web Consortium. "We'll just come up with our own replacement—a file format that has no legal strings attached." What they created was PNG (for Portable Network Graphics).You can save AppleWorks, Photoshop, and Preview documents in PNG format, and every modern Web browser understands it. Screenshots you take in Mac OS X (that is, captured images of the screen, as described in the following pages) are now in the PNG format.

    PNG files don't lose quality when compressed, as JPEG files do. On the other hand, PNG files don't accommodate animation, as GIF files do. And when it comes to photos, they don't offer as impressive a size/quality balance as JPEG.

  • PDF (Acrobat) files. As noted earlier in this chapter, Mac OS X traffics effortlessly in PDF files, meaning that you can distribute documents you create to almost anyone, confident that they'll be able to open and print your stuff regardless of what kind of computer, fonts, and programs they have.

  • Photoshop files. If you're a graphic designer or webmeister, this one is kind of neat: Mac OS X can open (and Preview can even export) actual Photoshop files (except for so-called 16-bit RGB files). In practical terms, the fact that Mac OS X can open and display these files means that you could use a Photoshop masterpiece, complete with layers and transparency, as, for example, a Mac OS X desktop background.

  • BMP. You can think of this graphics format as the PICT files of the Windows world. It's nice that MacOS X can open (and Preview can export)them, especially because you may occasionally find .bmp files on the Web or attached to email messages.

  • Silicon Graphics, Mac Paint, Targ. Talk about obscure—you could go through your whole life without ever seeing a graphic in one of these formats. Silicon Graphics is, of course, the format created by Silicon Graphics computers. MacPaint is a black and-white only, 8-by-10-inch maximum, ancient Macintosh graphics format that disappeared from the scene in about 1988. And Targ (Targa) is the file format once used by products from the Truevision Corporation.


screen-capture_keystrokes.html

14.10. Screen-Capture Keystrokes

If you're reading a chapter about printing and graphics, you may someday be interested in creating screenshots—printable illustrations of the Mac screen.

Screenshots are a staple of articles, tutorials, and books about the Mac (including this one). Mac OS X has a secret built-in feature that lets you make them—and includes some very cool convenience features.

Here's how to capture various regions of the screen.

14.10.1. The Whole Screen

Press Shift- [image] -3 to create a picture file on your desktop, in PNG format, that depicts the entire screen image. A satisfying camera-shutter sound tells you that you were successful.

The file is called Picture 1.png. Each time you press Shift- [image] -3, you get another file, called Picture 2, Picture 3, and so on. You can open these files into Preview or any other graphics program, in readiness for editing, printing, or exporting in a different format.

Tip: It doesn't have to be Shift- [image] -3. You can change this keystroke, or any of these screenshot keystrokes, to anything you like. Open System Preferences rightwards double arrow Keyboard & Mouse rightwards double arrow Keyboard Shortcuts. Expand the Screen Shots list. Click the keystroke you want to change, and then press the new key combo you prefer.

14.10.2. One Section of the Screen

You can capture just a rectangular region of the screen by pressing Shift- [image] -4. Your cursor turns into a crosshair with two tiny digital readouts—the horizontal and vertical coordinates of your cursor on the screen at this moment. (The numbers are pixels, as measured from the upper-left corner of the screen, which has coordinates 0, 0.)

Now drag diagonally across the screen to capture only a rectangular chunk of it. When you drag and release the mouse, you hear the camera-click sound, and the Picture 1 file appears on your desktop as usual—containing only the rectangle that you enclosed.

In Leopard, in fact, this feature has been goosed up quite a bit. Once you've begun dragging diagonally, while the mouse is still down, you can press any of these keys for special manipulation effects:

  • Space bar. While you hold down the Space bar with one hand, your selection rectangle is frozen in size and shape. With your mouse hand, you can move the cursor with the entire selection rectangle attached, the better to fine-tune your positioning relative to your target.

  • Shift key. When you hit Shift, you confine the dragging action of your mouse to a single dimension: horizontal or vertical. Which dimension depends on how you move your mouse after you hit Shift.

    For example, suppose you drag out a two-inch square, and then you pause. With the mouse button still down, you press Shift. If you now continue to drag downward, the selected area maintains a fixed width; you're increasing only the rectangle's height.

  • Option key. If you hold down Option after beginning to drag, Mac OS X creates a rectangular selection that grows from the center point outward. That is, it treats your initial click as the rectangle's center point, rather than as a diagonal corner.

14.10.3. A Dialog Box, Menu, Window, or Icon

Why fuss with cleaning up a screenshot after you've taken it? Using this trick, you can neatly snip one screen element out from its background.

Make sure the dialog box, menu, window, or icon is visible. Then press Shift- [image] -4. But instead of dragging diagonally, tap the Space bar.

Your cursor turns into a tiny camera (Figure 14-15). Move it so the misty blue highlighting fills the window or menu you want to capture—and then click. The resulting Picture file snips the window or menu neatly from its background.

Figure 14-15. To capture just one dialog box, use the old Camera Cursor trick. That is, invoke Shift- -4 and then tap the Space bar to produce the cursor shown here. Click the element you want to snip it from its background. (Press the Space bar a second time to exit "snip one screen element" mode and return to "drag across an area" mode.) If you ever change your mind about taking any kind of screenshot, press -period or the Esc key.

Shift- [image] -4 and then the Space bar also captures the Dock in one quick snip. Once you've got the camera cursor, just click any blank spot in the Dock (between icons).

Tip: If you hold down the Control key as you click or drag (using any of the techniques described above), you copy the screenshot to your clipboard, ready for pasting, rather than saving it as a new graphics file on your desktop.

As noted in Chapter 10, Mac OS X also offers another way to create screenshots: the Grab program in your Applications rightwards double arrow Utilities folder. Grab's chief selling point is its timer option, which lets you set up the screen before it takes the shot.

But if you're really serious about capturing screenshots, you should opt instead for Snapz Pro X (www.ambrosiasw.com), which can capture virtually anything on the screen—even movies of onscreen procedures, along with your narration—and save it in your choice of graphics format.


sound_movies_and_speech.html

Chapter 15. Sound, Movies, and Speech

For years, as other computer companies whipped themselves into a frenzy trying to market one multimedia computer or another, Mac fans just smiled. Macs have been capable of displaying sound and graphics—no add-on sound, graphics, or video boards required—from day one, years before the word multimedia was even coined.

The Mac's superiority at handling sound and video continues in Mac OS X. QuickTime, for example, is software that lets you play digital movies on your screen and watch live "streaming" broadcasts from the Internet. This chapter covers both creative pursuits: creating and using sound, and playing and editing movies.

As a bonus, this chapter also covers Mac OS X's speech features (how to command your Mac by voice, as well as making your Mac talk back); and Front Row, the full screen, across-the-room, remote-controlled presentation mode for movies, sounds, photos, and DVDs.

15.1. Playing Sounds

You can have a lot of fun with digital sounds—if you know where to find them, where to put them, and how to edit them. You can play almost any kind of digitized sound files, even MP3 files, right in the Finder—if you put its window into column view or Cover Flow view (or use Quick Look). But that's just the beginning.

15.1.1. Controlling the Volume

Adjusting the volume of your Mac's speakers couldn't be easier: Just add the speaker menu let to your menu bar, as directed in Figure 15-1. That illustration also shows the Sound pane of System Preferences, which offers another way to go about it.

Tip: Actually, all current Macs offer an even more direct way to control the speaker volume: speaker-control keys right on the keyboard ( [image] and [image]). (The [image] key next to them is the Mute button, which instantaneously cuts off all the Mac's sound—a wonderful feature when you find yourself trying to use the Mac surreptitiously in a library or church.)

Figure 15-1. The tiny speaker silhouette in the upper-right corner of your screen turns into a volume slider when you click it. To make this sound menulet appear, open the Sound pane of System Preferences and turn on "Show volume in menu bar" (bottom). (Of course, another way to adjust the overall speaker volume is to drag the "Output volume" slider in System Preferences.)

The Output tab of this pane, by the way, is designed to let you adjust the left-to-right balance of your stereo speakers, if you have them. The stereo speakers on most Macs that have them (iMacs, laptops) are already perfectly centered, so there's little need to adjust this slider unless you generally list to one side in your chair. (You may find additional controls here if you have extra audio gear—an old iSub subwoofer system, for example.)

Tip: In the Audio MIDI Setup program (in Applications rightwards double arrow Utilities), you can set up and configure much fancier speaker setups, including 5.1 and 6.1 surround-sound systems.

15.1.2. Alert Beeps and You

Error beepsare the quacks, beeps, or trumpet blasts that say, "You can't click here." (Try typing letters into a dialog box where a program expects numbers, for example.)

15.1.2.1. Choosing an alert beep

To choose one that suits your own personal taste, open the Sound pane of System Preferences (Figure 15-1, bottom). The Sound Effects screen offers a canned choice of 14 witty and interesting sound snippets for use as error beeps. Press the up and down arrow keys to walk through them, listening to each. The one that's highlighted when you close the window becomes the new error beep.

You can also drag the "Alert volume" slider to adjust the error beep volume relative to your Mac's overall speaker setting.

15.1.2.2. Adding new alert beeps

Mac OS X's error beeps are AIFF sound files, a popular Mac/Windows/Internet sound format—which, as a testimony to its potential for high quality, is also the standard sound-file format for music CDs. (The abbreviation stands for audio interchange file format.)

As with fonts, Mac OS X builds the list of error beeps that you see in the Sound panel of System Preferences from several folder sources:

  • System rightwards double arrow Library rightwards double arrow Sounds folder. This folder contains the basic Mac OS X set. Because it's in the System folder, it's off-limits to manipulation by us meddlesome human beings. You can't easily delete one of the original Mac OS X error beeps or add to this collection.

  • Home folder rightwards double arrow Library rightwards double arrow Sounds folder. It's easy enough to add sounds for your own use—just add them to this folder.

  • Library rightwards double arrow Sounds folder. If you, an administrator, want to make a sound file available to all account holders on your Mac (if there's more than one), create a new Sounds folder in the main hard drive window's Library folder. Any sound files you put there now appear in every account holder's list of alert sounds.

The sound files you put into these folders must be in AIFF format, and their names must end with the extension .aiff or .aif.

Note: Any changes you make to these Sounds folders don't show up in the Sound pane until the next time you open it.


playing_sounds.html

Chapter 15. Sound, Movies, and Speech

For years, as other computer companies whipped themselves into a frenzy trying to market one multimedia computer or another, Mac fans just smiled. Macs have been capable of displaying sound and graphics—no add-on sound, graphics, or video boards required—from day one, years before the word multimedia was even coined.

The Mac's superiority at handling sound and video continues in Mac OS X. QuickTime, for example, is software that lets you play digital movies on your screen and watch live "streaming" broadcasts from the Internet. This chapter covers both creative pursuits: creating and using sound, and playing and editing movies.

As a bonus, this chapter also covers Mac OS X's speech features (how to command your Mac by voice, as well as making your Mac talk back); and Front Row, the full screen, across-the-room, remote-controlled presentation mode for movies, sounds, photos, and DVDs.

15.1. Playing Sounds

You can have a lot of fun with digital sounds—if you know where to find them, where to put them, and how to edit them. You can play almost any kind of digitized sound files, even MP3 files, right in the Finder—if you put its window into column view or Cover Flow view (or use Quick Look). But that's just the beginning.

15.1.1. Controlling the Volume

Adjusting the volume of your Mac's speakers couldn't be easier: Just add the speaker menu let to your menu bar, as directed in Figure 15-1. That illustration also shows the Sound pane of System Preferences, which offers another way to go about it.

Tip: Actually, all current Macs offer an even more direct way to control the speaker volume: speaker-control keys right on the keyboard ( [image] and [image]). (The [image] key next to them is the Mute button, which instantaneously cuts off all the Mac's sound—a wonderful feature when you find yourself trying to use the Mac surreptitiously in a library or church.)

Figure 15-1. The tiny speaker silhouette in the upper-right corner of your screen turns into a volume slider when you click it. To make this sound menulet appear, open the Sound pane of System Preferences and turn on "Show volume in menu bar" (bottom). (Of course, another way to adjust the overall speaker volume is to drag the "Output volume" slider in System Preferences.)

The Output tab of this pane, by the way, is designed to let you adjust the left-to-right balance of your stereo speakers, if you have them. The stereo speakers on most Macs that have them (iMacs, laptops) are already perfectly centered, so there's little need to adjust this slider unless you generally list to one side in your chair. (You may find additional controls here if you have extra audio gear—an old iSub subwoofer system, for example.)

Tip: In the Audio MIDI Setup program (in Applications rightwards double arrow Utilities), you can set up and configure much fancier speaker setups, including 5.1 and 6.1 surround-sound systems.

15.1.2. Alert Beeps and You

Error beepsare the quacks, beeps, or trumpet blasts that say, "You can't click here." (Try typing letters into a dialog box where a program expects numbers, for example.)

15.1.2.1. Choosing an alert beep

To choose one that suits your own personal taste, open the Sound pane of System Preferences (Figure 15-1, bottom). The Sound Effects screen offers a canned choice of 14 witty and interesting sound snippets for use as error beeps. Press the up and down arrow keys to walk through them, listening to each. The one that's highlighted when you close the window becomes the new error beep.

You can also drag the "Alert volume" slider to adjust the error beep volume relative to your Mac's overall speaker setting.

15.1.2.2. Adding new alert beeps

Mac OS X's error beeps are AIFF sound files, a popular Mac/Windows/Internet sound format—which, as a testimony to its potential for high quality, is also the standard sound-file format for music CDs. (The abbreviation stands for audio interchange file format.)

As with fonts, Mac OS X builds the list of error beeps that you see in the Sound panel of System Preferences from several folder sources:

  • System rightwards double arrow Library rightwards double arrow Sounds folder. This folder contains the basic Mac OS X set. Because it's in the System folder, it's off-limits to manipulation by us meddlesome human beings. You can't easily delete one of the original Mac OS X error beeps or add to this collection.

  • Home folder rightwards double arrow Library rightwards double arrow Sounds folder. It's easy enough to add sounds for your own use—just add them to this folder.

  • Library rightwards double arrow Sounds folder. If you, an administrator, want to make a sound file available to all account holders on your Mac (if there's more than one), create a new Sounds folder in the main hard drive window's Library folder. Any sound files you put there now appear in every account holder's list of alert sounds.

The sound files you put into these folders must be in AIFF format, and their names must end with the extension .aiff or .aif.

Note: Any changes you make to these Sounds folders don't show up in the Sound pane until the next time you open it.


recording_sound.html

15.2. Recording Sound

If you hope to record new sounds, you need amicrophone. Your microphone situation depends on the kind of Mac you have:

  • Laptop, iMac, eMac. You have a built-in microphone, usually a tiny hole near the screen. This microphone couldn't be more convenient; it's always with you, and always turned on.

  • Other desktop Macs. You can plug in an external USB microphone (the Macintosh Products Guide at www.guide.apple.com offers a list) or use an adapter (such as the iMic,www.griffintechnology.com) that accommodates a standard microphone.

Tip: No matter which model you have, an Apple iSight videoconferencing camera works well as a microphone.

The Sound pane of System Preferences lets you choose which sound source you want the Mac to listen to. Click the Input tab, and then click the sound source you want: external USB microphone, external analog microphone (that is, something plugged into the microphone or Line In jacks of Macs that have them), built-in microphone, iSight, or whatever.

15.2.1. Making the Recording

Once you've got your microphone situation taken care of, you need to get your hands on some sound-recording software. You can use shareware programs like Amadeus II, or try iMovie, GarageBand (both came with your Mac), or QuickTime Player Pro (read on).

15.2.1.1. The GarageBand method

Although you might never suspect it, every Mac comes with a basic recording program. It's GarageBand, which lurks in your Applications folder.

Figure 15-2. GarageBand opens with a Piano track in place. You can delete it, though (Track- rightwards double arrow Delete Track). What you want is a new digital-audio track, which you get when you choose Track rightwards double arrow New Basic Track. You're ready to record sound!

Open GarageBand; on the welcome screen, click Create New Music Project. Name your project and click Create.

When you arrive at the main GarageBand track layout, choose Track rightwards double arrow NewBasicTrack (Figure 15-2). Click the red Record Voice button and begin to speak. Click Stop to complete the recording. To play it, press the Home key to rewind, and then the Space bar to play. (If you hear nothing, choose GarageBand rightwards double arrow Preferences rightwards double arrow Audio/Midi, and make sure the correct microphone was selected as the audio input. Oh—and make sure your Mac's speakers aren't muted.)

When you're satisfied with the recording, choose Share rightwards double arrow Send to iTunes. If you have GarageBand '08, you're now asked what file format you want (MP3 or AAC). If not, the recording pops its way into iTunes.

Either way, once it's in iTunes, you'll have to convert it to the AIFF format to use it as a startup beep. Visit the iTunes rightwards double arrow Preferences rightwards double arrow Advanced rightwards double arrow Importing tab; choose AIFF Encoder from the Import Using pop-up menu. Click OK. Finally, back in the iTunes list, click the name of your recording and then choose Advanced rightwards double arrow Convert Selection to AIFF.

When the conversion is complete, drag the new AIFF file to the desktop. Drag it into one of your Sounds folders, and presto—you've just created a new alert sound!

15.2.1.2. The QuickTime Player Pro method

Open QuickTime Player (in your Applications folder). Choose File rightwards double arrow New Audio Recording. Click the round, red Record button and begin to speak. Option-click what's now the square Stop button to pause the recording, or click without the Option key to end (Figure 15-3).

Tip: Don't adjust the tiny speaker (volume) slider in the Audio Recording window unless you're wearing headphones. This slider lets you monitor the sound—and turning it up while the Mac's speakers are live risks producing the hideous shriek known as feedback.

Figure 15-3. The primary design element of QuickTime Player's audio-recording console is a live "VU" level meter. Test your setup by speaking into the microphone. If this meter twitches in response, you're ready to record.

When you're satisfied with the recording, choose File rightwards double arrow Export. In the resulting dialog box, choose "Sound to AIFF" from the Export pop-up menu. Make sure the file name ends in .aiff, then navigate to a Sounds folder, and click Save. Your sound is ready to play.


quicktime_movies.html

15.3. QuickTime Movies

A QuickTime movie is a video file you can play from your hard drive, a CD or DVD, or the Internet. Like any movie, it creates the illusion of motion by flashing many individual frames (photos) per second before your eyes, while also playing a synchronized soundtrack.

15.3.1. QuickTime Player

Thousands of Mac OS X programs can open QuickTime movies, play them back, and sometimes even incorporate them into documents: Word, FileMaker, Keynote, PowerPoint, Safari, America Online, and even the Finder (Figure 15-4).

Figure 15-4. You can play QuickTime movies right in the Finder. In Cover Flow view or column view, click the button, as shown here. The two buttons on the right end are frame-advance buttons.
Or just highlight a movie item and press the Space bar to give it a Quick Look look.

But the cornerstone of Mac OS X's movie-playback software is QuickTime Player, which sits in your Applications folder (and even comes factory-installed in the Dock). It's designed not only to play movies, but also to show pictures, and to play sounds, in all kinds of formats.

15.3.1.1. Playing movies with QuickTime Player

You can open a movie file by double-clicking it. As shown in Figure 15-5, a number of controls help you govern the movie's playback:

  • Scroll bar. Drag the triangle to jump to a different spot in the movie.

    Tip: You can also press the right and left arrow keys to step through the movie one frame at a time. If you press Option-right or -left arrow key, you jump to the beginning or end of the movie. In the Pro version, Option-arrow key also jumps to the beginning or ending of a selected stretch of the movie.

  • Resize handle. Drag diagonally to make the window bigger or smaller.

    Tip: When you drag the resize handle, QuickTime Player strives to maintain the same aspect ratio (relative dimensions) of the original movie, so that you don't accidentally squish it. If you want to squish it, however— perhaps for the special effect of seeing your loved ones as they would look with different sets of horizontal and vertical genes—press Shift as you drag.If you press Option while dragging, meanwhile, you'll discover that the movie frame grows or shrinks in sudden jumping factors of two—twice as big, four times as big, and so on. On slower Macs, keeping a movie at an even multiple of its original size in this way ensures smoother playback.

  • Selection handles. These tiny handles appear only in the Pro version. You use them to select, or highlight, stretches of footage.

    Figure 15-5. Some of the controls shown here are available only in the Pro version of QuickTime Player. They appear as soon as you type in your registration code (which you get when you pay $30).

  • Volume.If you like, you can make the soundtrack louder or softer by dragging this slider with your mouse or clicking in its "track." You may find it easier, however, to press the up or down arrow keys.

    Tip: To mute the sound, click the little speaker icon, or press Option-down arrow. Press Option-up arrow to make the volume slider jump to full-blast position.

  • Audio level meters. This tiny graph dances to indicate the relative strength of various frequencies in the soundtrack, like the VU meters on a stereo. If you don't see any dancing going on while the movie plays, then you've opened a movie that doesn't have a soundtrack.

  • Counter. In "hours:minutes:seconds" format, this display shows how far your Playhead cursor has moved into the movie. (Click this readout for an option to change the display to frames.)

    If you have QuickTime Pro, the counter reveals the position of the selection handle you've most recently clicked (if any).

  • Rewind, Fast-forward. By clicking one of these buttons and keeping the mouse button pressed, you get to speed through your movie, backward and forward, respectively, complete with sound.

  • Rewind to Start, Jump to End. These buttons do exactly what they say: scroll to the beginning or end of your movie. In the Pro version, they can also jump to the beginning and ending of the selected portion of the movie (if any). All of this, in other words, is exactly the same as pressing the Option-left arrow or -right arrow keys.

    Tip: Try minimizing a QuickTime Player window while a movie is playing. It shrinks to the Dock—and keeps on playing. Do this enough times, and you'll know what it's like to be Steve Jobs on stage.
15.3.1.2. Hidden controls

Don't miss the Window rightwards double arrow Show A/V Controls commands. As shown in Figure 15-6, they let you fine-tune the video and audio (mostly the audio) you're experiencing.

Figure 15-6. The new A/V Controls should really be called A controls, because they govern only the audio; they don't affect the V (video picture) at all, unless you count the playback-speed controls on the right side.

15.3.1.3. Fancy playback tricks

Nobody knows for sure what Apple was thinking when it created some of these additional features—exactly how often do you want your movie to play backward?—but here they are. Some of these features are available only in the unlocked Pro version of QuickTime Player, as indicated below.

  • Change the screen size. Using the View menu commands, such as Double Size and Fit to Screen, you can enlarge or reduce the actual "movie screen" window. Making the window larger may also make the movie coarser, because QuickTime Player simply enlarges every dot that was present in the original. Still, when you want to show a movie to a group of people more than a few feet back from the screen, these larger sizes are perfectly effective.

  • Play more than one movie. You can open several movies at once and then run them simultaneously. (Of course, the more movies you try to play at once, the jerkier the playback gets.)

    Tip: If you have Player Pro, you can use the View rightwards double arrow Play All Movies command to begin playback of all open movies at the same instant.

  • Play the movie backward. You can play the movie backward—but not always smoothly—by pressing [image] -left arrow, or by Shift-double-clicking the movie itself.

    UP TO SPEED
    QuickTime Player vs. QuickTime Player Pro

    Mac OS X comes with the all-around audio, video, and picture player known as QuickTime Player. If you peruse its menus, however, you'll discover that over half the commands are dimmed, unavailable, and marked by a little logo that says "PRO."

    Actually, what it really says is, "Pay us $30! C'mon, pal!"

    If you choose one of these dimmed commands, you get a dialog box that describes the feature you would have available if you upgraded to QuickTime Pro for $30 by clicking the Buy Now button. Once you've turned QuickTime Player into Player Pro, all of those dimmed features spring to life, and the PRO logos disappear.

    (Even if you paid for the Pro version of QuickTime 6, you have to pay again for the Leopard version, QuickTime 7—a distinct sore point for a lot of Mac fans.)

    To execute this transaction, open the QuickTime pane of System Preferences. (If you're already in QuickTime Player, choose QuickTime Player rightwards double arrow Registration.) Click Buy QuickTime Pro. You wind up on the Apple Store Web site, which stands ready to accept your order.

    Apple then gives you a serial number, which you should type into the QuickTime System Preferences pane.

    Once you've upgraded, you gain several immediate benefits—not the least of which is the permanent disappearance of the "PRO" logos in all of the QuickTime Player menus. Now QuickTime Player can edit your movies, as described later in this chapter. It can also import many more sound and graphics formats, record audio and video, and—via the File rightwards double arrow Export command—convert sounds, movies, and graphics into other formats.

    Nor is QuickTime Pro the only upgrade you can buy. For another $20, you can add the MPEG-2 Playback Component, which gives QuickTime Player the ability to open and play MPEG-2 files (like the high-quality files found on a DVD).

    (QuickTime isn't so great at converting these files, though; in the translation to many formats, including DV and H.264, it loses the audio track. If your intention is to convert an MPEG-2 file to, say, DV format for editing in iMovie, you need a free program like MPEG StreamClip to assist with the conversion. You'll find it with a quick Google search.)

    (You must keep the Shift button pressed to make the backward play back continue.) There's no better way to listen for secret subliminal messages.

  • Loop the movie. When you choose View rightwards double arrow Loop and then click Play, the movie repeats endlessly until you make it stop.

  • Play a selection (Pro only). When you choose View rightwards double arrow Loop Back and Forth and then click Play, the movie plays to the end—and then plays backward, from end to beginning. It also repeats this cycle until you make it stop.

15.3.2. Internet Streaming QuickTime

QuickTime Player also lets you watch "Internet slideshows, "watch a couple of live TV stations, or listen to the radio—all as you work on your Mac, and all at no charge.

15.3.2.1. Streaming video from your browser

With ever-increasing frequency, Web sites advertise streaming video events, such as Steve Jobs keynote speeches and the occasional live rock concert. You'll find a note on a Web page, for example, that says, "Watch the live debate by clicking here on October 15 at 9:00 p.m. EST." (If you open QuickTime Player itself, rather than double-clicking a movie to open it, you arrive at the billboard screen shown in Figure 15-7. It offers links to free streaming music, TV shows, podcasts, and music videos.)

If you do so, you'll sometimes be able to watch it in your browser, and sometimes you'll be transported once again into QuickTime Player, which connects to the appropriate Internet "station" and plays the video in its window. (You can also choose File rightwards double arrow Open URL from within QuickTime Player to type in the Web address.)

Figure 15-7. Several "picks of the day" are featured in this billboard window, which is what you get when you doubleclick the QuickTime Player icon (rather than double-clicking a movie file).
On the right are links to free TV shows and podcasts; on the left, plugs for new iTunes music. In the middle: a huge, rotating display of ads for five of Apple's favorite videos of the moment. You can jump directly to one of the five by clicking the small gray buttons above the big ad panel.

Note: You don't have much control when watching a live broadcast. You generally can't rewind, and you certainly can't fast-forward. You may be able to pause the broadcast, but when you un-pause, you wind up at the current broadcast moment—not where you stopped.
15.3.2.2. Manipulating your Favorites

When you choose Window rightwards double arrow Favorites rightwards double arrow Show Favorites, you see a list of items you've put there for quick access.

Although few people use this feature, it's possible to add the icons of your own QuickTime movies to the Favorites panel—not QuickTime TV channels, but actual movies on your hard drive. To do so, you can use either of these methods:

  • Drag the icon of a QuickTime movie, picture file, or sound clipping directly off your desktop and into QuickTime Player's Favorites window.

  • Open a movie, picture, or sound, and then choose Window rightwards double arrow Favorites rightwards double arrow Add Movie As Favorite.

You can also reorganize the Favorites icons by dragging them up or down in the list. To delete one, just click its name and then press Delete (and click OK to confirm).

15.3.3. QuickTime Player Pro

If you've spent the $30 to upgrade your free copy of QuickTime Player to the Pro version, you've unlocked a number of useful features. For example:

  • Your View menu contains additional playback options, such as those described in "Fancy playback tricks" on Section 15.3.1.2.

  • When you find a QuickTime movie on a Web page, you can often save it to your hard drive. (Click the movie; hold down the mouse button until a pop-up menu appears; choose Save As QuickTime Movie, or the equivalent in your browser.)

  • Using the Window rightwards double arrow Show Movie Properties command, you can view, turn on and off, add, or delete the individual tracks in a particular movie. (Most movies have nothing but a video track and a soundtrack. But a few specialized movies may also contain a text track, an animation track, alternate soundtracks, and so on.)

  • TheView rightwards double arrow Full Screen ( [image] -F) command is the best possible way to view a QuickTime movie on your screen. When you use this command, QuickTime Player blacks out the screen and devotes most of the Mac's processing power to playing the movie smoothly. (See Figure 15-8.)

By far the most powerful feature you gain in the Pro version, however, is its ability to edit QuickTime movies. Read on.

15.3.3.1. Selecting footage

Before you can cut, copy, or paste footage, you have to specify which footage you want to manipulate. See the two tiny triangle handles that start out at the left end of the horizontal scroll bar, as shown in Figure 15-5? These are the "in" and "out" points; by dragging these handles, you can isolate the scene you want to cut or copy.

Tip: You can gain more precise control over the selection procedure by clicking one of the handles and then pressing the right or left arrow key. Doing so expands or contracts the selected chunk of footage by one frame at a time.You may also prefer to select a piece of footage by Shift-clicking the Play button. As long as you hold down the Shift key, you continue to select footage. When you release the Shift key, you stop the playback, and the selected passage appears in gray on the scroll bar.

Figure 15-8. When you jiggle your mouse in Full Screen mode, you get this control panel for pausing, stopping, rewinding, and so on. Just remember that although Full Screen is terrific when you want to play a movie for a large group of people, an enlarged QuickTime movie is also a jerkier and grainier one.

Once you've highlighted a passage of footage, you can proceed as follows:

  • Jump to the beginning or end of the selected footage by pressing Option- leftwards double arrow or Option- rightwards double arrow.

  • Deselect the footage by dragging the two handles together again.

  • Play only the selected passage by choosing View rightwards double arrow Play Selection Only ( [image] -T).(The other Movie menu commands, including Loop, apply only to the selection at this point.)

  • Drag the movie picture out of the Player window and onto the desktop, where the selected portion becomes a movie clipping that you can double-click to view.

  • Cut, copy, or clear the highlighted material using the commands in the Edit menu.

Tip: If you paste some text directly into QuickTime Player Pro, you get a two-frame title—like an opening credit—at the location of the scroll bar playhead. (If you need it to be longer, paste it repeatedly.) QuickTime Player automatically uses the font, size, and style of the text that was in the text clipping. You can paste a graphic image, too, which gets you a two-frame "slide" of that still image.If you find it easier, you can also drag a text or picture clipping file directly from the desktop into the QuickTime Player window; once again, you get a two-frame insert.
15.3.3.2. Pasting footage

After cutting or copying footage, you can move it elsewhere in the movie.Specify where you want the pasted material to go by clicking or dragging in the horizontal scroll bar so that the playhead marks the spot; then choose Edit rightwards double arrow Paste. The selection handles (and their accompanying gray scroll bar section) appear to show you where the new footage has appeared. (That makes it easy for you to promptly choose Edit rightwards double arrow Cut, for example, if you change your mind.)

But in QuickTime Player Pro, Cut and Paste are just the beginning of your options. For example:

  • Edit rightwards double arrow Trim to Selection eliminates the outer parts of the movie—the pieces that aren't selected. All that remains is the part you first highlighted.

  • Edit rightwards double arrow Add to Movie adds whatever's on the Clipboard so that it plays simultaneously with the selected footage—a feature that's especially useful when you're adding a different kind of material to the movie (see Figure 15-9). For example, if you paste one clip into another, you get a picture-in-picture effect.

  • If you choose Edit rightwards double arrow Add to Selection & Scale, what ever you're pasting gets stretched or compressed in time so that it fits the highlighted region, speeding up or slowing down both the audio and video. The effect can be powerful, comical, or just weird.

Tip: You can edit sounds exactly as you edit movies, using the same commands and shortcuts. Use the File rightwards double arrow Open File command to locate a sound file to open. It opens exactly like a QuickTime movie, except with only a scroll bar, no picture.
15.3.3.3. Saving the finished movie

After you've finished working on your sound or movie, you can send it back out into the world in any of several ways. If you choose File rightwards double arrow Save As, for example, you can specify a new name for your edited masterpiece. You must also choose one of these two options:

  • Save as a reference movie. You'll almost never want to use this option, which produces a very tiny QuickTime file that contains no footage at all. Instead, it's something like an alias of the movie that works only as long as the original, unedited movie remains on your hard drive. If you try to email the newly saved file, your unhappy recipient won't see anything at all.

  • Save as a self-contained movie. This option produces a new QuickTime movie— the one you've just finished editing. Although it consumes more disk space, it has none of the drawbacks of the "reference movie" file described above.

Figure 15-9. QuickTime Player Pro has a little-known subtitling feature, complete with freedom of type style. Copy some formatted text from a word processor, highlight a slice of footage in QuickTime Player, and choose Edit rightwards double arrow Add to Movie. The copied text appears as a subtitle on a black band, beneath the picture, as shown here.

15.3.3.4. Exporting the finished work

The File rightwards double arrow Save As command spins out every edited movie in the QuickTime file format. The File rightwards double arrow Export command, on the other hand, lets you specify the format in the process of exporting it. The resulting dialog box offers two pop-up menus that can be very useful in tailoring your finished work for specific purposes:

  • Export.Using this pop-up menu, you can convert your movie to AVI (Windows movie) format, DV Stream (for use as a clip in digital-video editing programs like iMovie and Final Cut), Image Sequence (a very large collection of individual still frames), and so on. This pop-up menu also lets you convert a sound you've been working on to AIFF, System 7, Wave (Windows), and other formats.

  • Use. This pop-up menu lets you establish your preferences for the export format you've just specified above. For example, if you're exporting your movie as individual still frames, use this pop-up menu to specify the format for those individual still frames—BMP (Windows bitmap format), JPEG, and so on. If you're exporting your work as a QuickTime movie, you can specify how much QuickTime Player should compress it. (Compression makes a file smaller, but decreases the video quality.) If you intend to let people watch this movie over the Internet, for instance, you should use one of the Streaming options, which make the movie extremely small and extremely cruddy-looking.

15.3.3.5. Compression and special effects

One of QuickTime Player's most powerful features is hidden in the Export dialog box, in a place where you might never find it. If none of the canned compression settings appeal to you, you can click the Options button. In the Settings dialog box that appears (see Figure 15-10), QuickTime Player Pro offers a staggering degree of control over the movie you're exporting. (The resulting dialog box varies according to the compression method you've selected.)

GEM IN THE ROUGH
QuickTime Virtual Reality

If they live to be 100, most Mac users will probably never encounter a QuickTime VR movie. Yet this kind of "panorama movie" technology is built into every Mac.

The trick is finding a QuickTime VR movie; your safest bet is, as usual, the Web. (The best starting point is Apple's own QuickTime VR page, www.apple.com/quicktime/technolo-gies/qtvr.)

When you open a QuickTime VR movie, you might think at first that you've simply opened a still photo (there's no scroll bar, for example). The trick is to drag your cursor around inside the photo. Doing so rotates the "camera," enabling you to look around you in all directions.

Then try pressing the Shift key, to zoom in (move forward) as much as you like. If you go too far, the image becomes too grainy. Press the Control key to zoom out (move backward).

And if you really want to blow your mind, try one of the cubic VR movies posted on that Web page. It lets you rotate your view not just side to side, but also up to the sky and down to your feet.

Using the free and commercial tools listed on the Apple Web site (or several that aren't, including Pano Tools), you can even make your own QuickTime VR movies—provided you've got a camera, a tripod, and a good deal of patience.

When exporting a movie as a QuickTime Movie, for example, this is where you can specify the compression format, the frames per second, and (by clicking Size) the dimensions of the finished movie.

Tip: By clicking Options, you'll find the QuickTime 7 compression scheme called H.264, which offers such great quality at such low file sizes that Apple, among others, gets all sweaty-palmed just thinking about it. It's a terrific compression scheme for any movies that you export—but remember that QuickTime 7 (free for Windows and Mac) is required to see them.

Figure 15-10. If you're used to standard moviemaking software, like iMovie or Final Cut, you may wonder where QuickTime Player hides its compression settings. They're here, in the Options dialog box (left) and the Settings boxes that spring from within it (right). Hint: For smooth playback, use 15 frames per second or above (television playback is 30 fps); for best quality but small file size, use the Sorenson 3 Video Compressor or, if you're sure your audience has QuickTime 7 or later, H.264.

As a bonus, you even get a Filter button that offers 14 special video effects. They let you blur or sharpen your movie, adjust the brightness or contrast, fiddle with the color balance, and so on. Similarly, when you're exporting a sound file, the Options button lets you specify the sound quality you want, the compression method, and more—all various ways of manipulating the tradeoff between file size and sound quality.


speech_recognition.html

15.4. Speech Recognition

Although it may surprise many Mac users, the Mac is quite talented when it comes to speech. Its abilities fall into two categories: reading text aloud, using a synthesized voice; and taking commands from your voice.

The Apple marketing machine may have been working too hard when it called this feature "speech recognition"—the Mac OS feature called PlainTalk doesn't take dictation, typing out what you say. (For that, you need a program like iListen, www.macspeech.com—or, better yet, Dragon Naturally Speaking, an amazing dictation program for Windows that you can run on your Intel-based Mac in Windows, as described in Chapter 8.)

Instead, PlainTalk is what's known as a command-and-control technology. It lets you open programs, trigger AppleScripts, choose menu commands, trigger keystrokes, and click dialog box buttons and tabs—just by speaking their names.

Few people use PlainTalk speech recognition. But if your Mac has a microphone, PlainTalk is worth at least a 15-minute test drive. It may become a part of your work routine forever.

Figure 15-11. Turn listening on and off here. If you turn on "Listen only while key is pressed," the Mac pays attention to you only when you're pressing a key (like Esc). As a convenience, it even pauses iTunes playback while you're pressing the key. If you turn on "Listen continuously with keyword," you have to say a certain keyword to "get its attention" before speaking each command. In the Keyword blank, type the word you want the Mac to listen for as it monitors the sound from your mike.

15.4.1. Your First Conversation with the Mac

The on/off switch for speech recognition in Mac OS X is the Speech pane of System Preferences (Figure 15-11). Where you see "Speakable items" (on the Speech Recognition tab), click On.

15.4.1.1. The Feedback window

Check out your screen: A small, microphone-like floating window now appears (Figure 15-12). The word Esc in its center indicates the "listen" key—the key you're supposed to hold down when you want the Mac to respond to your voice. (You wouldn't want the Mac listening all the time—even when you said, for example, "Hey, it's cold in here. Close the window." Therefore, the Mac comes set to listen only when you're pressing that key.)

You can specify a different key, if you wish, or eliminate the requirement to press a key altogether, as described in the next section.

When you start talking, you'll also see the Mac's interpretation of what you said written out in a yellow balloon just over the Feedback window.

15.4.1.2. The Speakable Commands window

The only commands PlainTalk understands are listed in the Speakable Commands window. (If it's not open, see Figure 15-12.) Keeping your eye on this window is essential, because it offers a complete list of everything your Mac understands. As you can see, some of the commands represent shortcuts that would take several steps if you had to perform them manually.

Here are a few examples of what you'll find in the list at first:

  • Phone for [Steve Jobs].Displays Steve Jobs's phone number in huge digits across your screen—the fastest way yet to look up a number of somebody in your Address Book program.

    You can also say "Chat with Steve Jobs" (or whomever) to begin a new chat session in iChat with that person, "Mail this to Steve Jobs" to send the current document as a Mail attachment, or "Meet with Steve Jobs" to add an iCal appointment with this person's information attached.

    Figure 15-12. Left: The Feedback window lacks the standard Close and Minimize buttons. If it's in your way, just double-click it (or say "minimize speech window") to shrink it into your Dock. If you choose Speech Preferences from its bottom-edge triangle, you open the Speech Preferences window.
    Right: Choosing Open Speech Commands window, of course, opens the list of things you can say.

  • Set alarm for 30 minutes. (You can say any number of minutes or hours—"Set alarm for two hours," or whatever.) The Mac asks you to type a little message, which will serve as the iCal dialog box that appears at the specified time.

    Tip: Check the complete list of iCal- and Address Book–related commands in the Speech Commands window.

  • Close this window. Closes the front most window instantly.

  • Empty the Trash. Works only when you're in the Finder.

  • Switch to Safari. Brings Safari to the front. (Actually, you can say "switch to" and then the name of any running or recently used program.)

  • Quit all applications. Saves you the trouble of switching into each program and choosing Quit.

  • Open the Speech Commands window or Show me what to say. Opens the Speech Commands window, of course.

  • What day is it? Tells you the date.

  • Tell me a joke. Begins a pathetic/funny knock-knock joke. You've got to play along, providing the "Who's there?" and "So-and-so who?" answers.

Mac OS X updates the listing in the Speech Commands window in real time, according to the context. When you switch from one program to another, you see a list of the local commands that work in the new program. You'll discover that when you use the "Tell me a joke" command, for example, you don't necessarily have to say, "Who's there?" You can also say "Stop," "Go away," or "Stop with the jokes!" (It must really be fun to work at Apple.)

15.4.1.3. Speaking to the Mac

Finish up on the Speech pane of System Preferences. Use the Microphone pop-up menu to specify which microphone you'll be using (if you have a choice). Click Calibrate to adjust its sensitivity.

Now you're ready to begin. While pressing the Esc key (if that's still the one identified in the Feedback window), begin speaking. Speak normally; don't exaggerate or shout. Try one of the commands in the Speakable Commands list—perhaps "What time is it?" If your mike is set up properly, the round Feedback window displays animated sound waves when you speak.

15.4.2. Customizing Speech Recognition

You can tailor the speech recognition feature in two ways: by adjusting the way it looks and operates, and by adding new commands to its vocabulary.

15.4.2.1. Changing when the Mac listens

Having the microphone "open," listening full-time, is an invitation for disaster. Everyday phone conversations, office chatter, and throat clearings would completely bewilder the software, triggering random commands.

Therefore, you must explicitly tell the Mac when you're addressing it. When you first turn on the speech recognition feature, the Mac expects you to alert it by pressing a key, like the Esc key, when you speak.

Tip: To change the key you hold down when you want the Mac to listen, visit the Speech pane of System Preferences; click the Speech Recognition tab; click Settings; and then click Change Key. A little message prompts you to press the keyboard key you'd prefer to use. Your choices are Esc, Delete, F5 through F12, or the keys on your numeric keypad—with or without the Shift, Control, or Option keys.

If you'd rather not have to press some key whenever you want the computer's attention, click the other option in this pane, "Listen continuously with keyword." Now to get the computer's attention you must speak the keyword—which you type into the Keyword box—before each command. For example, you might say, "Computer, open AppleWorks," or "Hal, what day is it?"

The name you specify appears in the middle of the round Feedback window.

Note: This method of getting the computer's attention is less reliable than the push-a-key-to-talk system. Especially if you name the computer Hal. Although that's hilarious in theory, polysyllabic names work better in practice.

By using the "Keyword is" pop-up menu, meanwhile, you can specify how big your window of opportunity is:

  • Optional before commands. If you work alone in a quiet room, this is the choice for you. It means that you don't have to press a key or say the Mac's name when issuing a voice command. Everything you say is considered a command.

  • Required before each command.Nothing you say is interpreted as a command unless you say the computer's keyword first, as in, "Macintosh, switch to Microsoft Word."

  • Required 15 seconds after last command, Required 30 seconds after last command.Sometimes you want to issue several commands in a row, and would feel foolish saying, "Computer, close all windows. Computer, empty the Trash. Computer, switch to Calculator." When you turn on this option, you can say the computer's name just once; all commands that you issue in the next 15 or 30 seconds "belong to" that first salutation. The push-to-talk key and the spoken name, in this case, serve as a master on/off switch for the Mac's listening mode.

    Tip: If you're not using the push-to-talk method, you can still turn speech recognition off temporarily by saying, "Turn on push to talk." (Now the Mac listens to you only when you're pressing the designated key.) When you want to return to listening-all-the-time mode, say, "Listen continuously."
15.4.2.2. Changing the feedback

Another set of options on the Speech Recognition tab governs what the Mac does when it understands something that you've said. For example:

  • Play sound. The Mac generally makes a sound whenever it recognizes something you've said. Use this pop-up menu to control which of your built-in beeps you want it to use—or choose None.

  • Speak command acknowledgement. Sometimes the Speech Feedback window shows you a message of its own. When you use the "Empty the Trash" command, for example, text in the Feedback window may inform you that a locked item prevents the emptying. The Mac generally reads this text aloud to you; turn this checkbox off if you'd rather have the Mac be silent.

15.4.2.3. Triggering menus by voice

On the Speech pane of System Preferences, click the Speech Recognition tab, and then click the Commands minitab. Here you'll find a list of the command categories that Speakable Items can understand. As you turn each checkbox on or off, watch the Speech Commands window. Giant swaths of commands appear or disappear as you fool with these checkboxes, giving you a good indication as to their function. Here's a rundown:

  • Address Book. These commands let you look up numbers; add appointments to your iCal calendar; set up alarm reminders for yourself; mail things to people; and begin text, audio, or video chats with people whose names are already in your Address Book.

  • Global Speakable Items. This is the master list of Speakable Items, shown in Figure 15-12.

  • Application-Specific Items. Certain Mac OS X programs come with preset lists of commands that work only when you're in the relevant program. For example, whenever you're in the Finder, you can say, "Empty the Trash," "Go to my Home directory," "Hide the Dock," "Minimize all windows," "Make a new folder," and so on. When this checkbox is off, the Mac no longer recognizes any of these handy commands.

  • Application Switching. This is the command category at the bottom half of the Speech Commands list—"Switch to Address Book," "Switch to AOL," and so on.

  • Front Window.In your Speech Commands window, note the appearance of a new category of commands, called Front Window. The idea here is to provide you with quick speech-recognition access to the most prominent buttons, tabs, and icons in whichever window is before you. Figure 15-13 elaborates on the idea.

  • Menu Bar. This command lets you open menus (in the menu bar) by speaking their names.

Once you say its name ("File menu," for example), the menu opens. Now you can say any command in the open menu ("New Playlist," "Save," or whatever). The Menu Bar category of the Speech Commands window changes to remind you of what you can say at any given moment.

Figure 15-13. The Front Window commands change automatically to reflect the controls that are in the front most window. For example, in the Date & Time pane of System Preferences, you can say anything in the circled area of the Speech Commands window: the name of any tab or window control (indicated by the arrows). Whenever you say an item, the Mac "clicks" it for you. You can also speak the menus' names to open them.

The combination of Front Window and Menu Bar commands lets you do quite a bit of work on your Mac without ever needing the mouse or keyboard.

15.4.2.4. Improving the PlainTalk vocabulary

By putting an alias of a favorite document, folder, disk, or program into your Home rightwards double arrow Library rightwards double arrow Speakable Items folder, you can teach PlainTalk to recognize its name and open it for you on command. You can name these icons anything you want. You can also rename the starter set that Apple provides. You'll have the best luck with multiword or polysyllabic names—"Microsoft Word," not just "Word."

One kind of icon PlainTalk can open is an AppleScript icon (see Chapter 7). If you open your Home folder rightwards double arrow Library rightwards double arrow Speech rightwards double arrow Speakable Items, you'll discover that most of the built-in speakable-item icons are, in fact, AppleScript icons. The point is that you can make PlainTalk do almost anything you want, especially in the Finder, simply by creating AppleScripts and putting them into the Speakable Items folder.

15.4.2.5. Application-specific commands

Most of the preinstalled PlainTalk commands work in any program. You can say, for example, "Open iTunes" to launch iTunes from within any program.

However, you can also create commands that work only in a specific program. They sit in your Speakable Items rightwards double arrow Application Speakable Items folder, inside individual application-name folders. For example, Mac OS X comes with commands for Safari that include Go Back, Go Forward, and Page Down.

If you get good at AppleScript, you can create your own application-command folders in the Speakable Items rightwards double arrow Application Speakable Items folder.

Then open the program for which you want to create special commands and say, "Make this application speakable." The Mac creates a folder for the program in the Speakable Items folder; fill it with the AppleScripts you've created. (Not all programs can be AppleScript-controlled.)

Note: If you give an application-specific icon the exact same name as one of the global commands, the Mac executes the application-specific one—if that program is running.
15.4.2.6. PlainTalk tips, tricks, and troubleshooting

When you're creating new commands, click the Helpful Tips button at the lowerright corner of the Commands pane (of the Speech Recognition pane of the Speech pane of System Preferences).


the_mac_reads_to_you.html

15.5. The Mac Reads to You

So far in this chapter, you've read about the Mac's listening ability. But the conversation doesn't have to be one-way; it's even easier to make the Mac talk.

Some Mac OS X programs come with their own built-in speaking features.For example, Mail can read your messages a loud; just Control-click (or right-click) inside a message window and, from the pop-up menu, choose Speech rightwards double arrow Start Speaking. Most Cocoa programs can speak when you use the Start Speaking Text command in the Services menu. You can add a Speak command in FileMaker Pro scripts. Mac OS X's Chess and Calculator programs can talk back, too.

But that's kid stuff. Truth is, the Mac can read almost anything you like: text that you pass your cursor over, alert messages, menus, and any text document in any program. It can speak in your choice of 24 synthesizer voices, ages 8 to 50. The Mac's voice comes out of its speakers. Most read with a twangy, charmingly Norwegian accent— all but Alex, who makes his debut in Leopard and sounds scarily like a professional human voice-over artist.

Note: This reading-text business is not the same thing as the Mac's VoiceOver feature. VoiceOver is designed to read everything on the screen, including pop-up menus, buttons, and other controls, to visually impaired Mac fans (and to permit complete control, mouse-free, of everything). Details begin on Section 15.5.1.3.

15.5.1. Setting Up the Mac's Voice

To configure the way the Mac talks, revisit the Speech pane of System Preferences. Click the Text to Speech tab at the top of the window. As you can see in Figure 15-14, you can control which of the Mac's voices you want your computer to use, as well as how fast it should speak.

Tip: Five of the voices sing rather than speak. Good News sings to the tune of "Pomp and Circumstance," otherwise known as the Graduation March. Bad News sings to the tune of Chopin's Prelude in C minor, better known as the Funeral March. Cellos sings to the tune of Grieg's Peer Gynt suite. Pipe Organ sings to the tune of the Alfred Hitchcock TV theme. Bells sings the typical church-bell carillon melody.In other words, these voices sing whatever words you type to those melodies. (To hear the melody in its entirety, don't use any punctuation.)

Figure 15-14. At the outset, you see only six voices— the ones that sound the most human. Choose More Voices to see the complete list of 22.
Then, for 15 minutes of hilarity, try clicking the voices in turn to hear sample sentences. Drag the slider to affect how fast each one speaks. (Clearly, Apple's programmers had some fun with this assignment.)

Here are all the different occasions when the Mac can talk to you.

15.5.1.1. Announce when alerts are displayed

If you turn on this checkbox, you can make the Mac read aloud error messages and alert messages that may appear on your screen. If you click the Set Alert Options button, you find these useful controls:

  • Voice.Use this pop-up menu to specify the voice you want reading your error messages. (It doesn't have to be the same as the standard Mac default voice that's used for other purposes.)

  • Phrase. Use this pop-up menu to specify which utterance the Mac speaks before the actual error message—for example,"Excuse me! The Trash could not be emptied," or "Attention! The document could not be printed."

    If you choose "Next in the phrase list" or "Random from the phrase list" from this pop-up menu, you'll never hear the same expletive twice. Better yet, choose Edit Phrase List to open a dialog box where you can specify your own words of frustration. (Apple Computer, Inc., is not liable for any trouble you may get into with people in neighboring cubicles.)

  • Delay. The ostensible purpose of the Talking Alerts feature is to get your attention if you've wandered away from your Mac—mentally or physically. The chances are slim, but an urgent problem might occur that, if left undetected, could land you in trouble. (A 500-page printout brought to its knees by a paper jam comes to mind.)

    In other words, if you're still sitting in front of your Mac, you may not need the Mac to speak to get your attention; you could simply read the onscreen message. That's why you can set this slider to make the Mac wait, after the error message appears, for up to a minute before trying to flag you with its voice. That way it won't harangue you unnecessarily. (Click Play for a sense of how long the Mac will delay before speaking.)

GEM IN THE ROUGH
Talking to Chess

If your friends and co-workers are, for some reason, still unimpressed by Mac OS X and your mastery of it, invite them over to watch you play a game of chess with your Mac—by talking to it.

(Actually, this feature isn't purely for entertainment: Some chess players prefer to move without looking at the board. By speaking their moves to the computer—and having the computer respond by speaking its own moves—these people can play "blindfolded.")

Open the Chess program. Unless you've turned it off (in Chess rightwards double arrow Preferences), the game's speech-recognition feature is already turned on. When it's on, the round Feedback window should be visible onscreen.

To learn how to speak commands in a way that Chess understands, click the small gray triangle at the bottom of the Speech Feedback window to open the Speech Commands window. As usual, it lists all the commands that Chess can comprehend.

You specify the location of pieces using the grid of numbers and letters that appears along the edges of the chessboard. The white king, for example, starts on square e1 because he's in the first row (1) and the fifth column (e). To move the king forward by one square, you'd say: "King e1 to e2."

As the Speech Commands window should make clear, a few other commands are at your disposal. "Take back move" is one of the most useful. When you're ready to close in for the kill, the syntax is: "Pawn e5 takes f6."

And smile when you say that.

15.5.1.2. Announce when an application requires your attention

A jumping Dock icon means that the program is trying to get your attention. It might be because your printer is out of paper, or it might be because you've tried to shut down but one program still has open, unsaved documents. In any case, now the Mac can tell you, in so many words, which program needs some loving care.

15.5.1.3. Speak selected text when the key is pressed

As promised, this is the feature that lets you hear any Web page read to you, any email message, any sticky note—a welcome break for sore eyes. Furthermore, if you do any kind of writing at all, you'll discover the value of having your material read back to you out loud; it's a proofreading technique that reveals all kinds of typos and wordos that you wouldn't catch just by reading, even if you read it 50 times.

The very first time you turn on this checkbox, the Mac prompts you to specify a keystroke. (Later, you can always change the keystroke by clicking Set Key.) Choose a keystroke that doesn't conflict with the program you're using, like Control-T.

Now go to the program where you'd like the reading to happen. Highlight some text (or press [image] -A to select all of it). Then press the keystroke you specified. The Mac begins reading it aloud immediately. To interrupt the playback, press the same keystroke again.

And be glad you were alive to see the day.

Tip: If you have an iPod, your Mac can convert any text or word processing document into a spoken recording, so that you can listen to it when you're on the go. To pull this off, download the two free conversion AppleScripts from this book's "Missing CD" at www.missingmanuals.com.


voiceover-id001.html

15.6. VoiceOver

The Mac has always been able to read stuff on the screen out loud. But Apple has taken this feature light-years farther, turning it into a full-blown screen reader for the benefit of people who can't see. Voice Over doesn't just read every scrap of text it finds

UP TO SPEED
For Laptop Lovers Only

Tons of the special VoiceOver keystrokes require the use of an F-key (like F2 or F5). If you have a Mac laptop, though, the F-keys come wired to functions like adjusting the speaker volume or screen brightness. The VoiceOver keystrokes won't work, in other words, unless you also press the Fn key at the lower-left corner of the keyboard.

If remembering to add Fn becomes a hassle (or you don't have enough fingers), open the Keyboard & Mouse pane of System Preferences. Click the Keyboard tab, and turn on "Use all F1, F2, etc. keys as standard function keys."

Now you've reversed the logic. You need the Fn key only when adjusting the volume or brightness, and don't need it for things like VoiceOver keystrokes.

on the screen—it also lets you control everything on the screen (menus, buttons, and so on) without ever needing the mouse.

As you can guess, learning VoiceOver means learning a lot of new keyboard shortcuts (see the massive table at the end of this section). Fortunately, most of them involve the same two modifier keys pressed together: Control-Option.

Note: VoiceOver works beautifully in Cocoa programs like Safari, TextEdit, and Mail, but doesn't work well in iTunes, Microsoft Word, and other Carbon programs. As software companies revise their wares, compatibility is sure to improve. (Furthermore, VoiceOver is available in English only.)

15.6.1. Turning on VoiceOver

You can turn on VoiceOver on the Universal Access pane of System Preferences. But you may as well get used to using the keyboard shortcuts for VoiceOver; in this case, pressing [image] -F5 serves as the on/off switch.

Tip: Tap the Control key by itself to pause the speech feature; tap again to resume. Oh—and if Alex's voice doesn't quite do it for you, consider buying the really amazing-sounding ones from www.cepstral.com or www.speechissimo.com.

Figure 15-15. As you press Control-Option and the arrow keys, a thick black border—the VoiceOver cursor—identifies whatever VoiceOver is currently pronouncing. When it lands on a menu or pop-up menu you'd like to open, press the Space bar; VoiceOver opens the menu so you can sonically explore it using the down arrow key.

15.6.2. "Feeling" the Screen

Once you've turned on VoiceOver, the idea is to "walk" around the window, listening as VoiceOver pronounces each item. It first says the name of the window you're in, and then, as you walk around, it will say, "Scroll bar," "Back button," "Home button," and so on. Since, presumably, you can't see the screen, the idea here is to help you get your bearings.

You take this tour of the screen by pressing Control-Option with the four arrow keys (Figure 15-15).

Tip: Couldn't quite understand what VoiceOver said? Press Control-Option-Z to hear it again.Or press Control-Option-Shift-Z to save the spoken utterance as a sound file on your desktop—a handy option if you want to play it for someone later (like a tech-support guru who might understand an error message's meaning better than you did).

Figure 15-16. When you hear something you'd like to "click," press Enter; otherwise, press Esc to close the list. (Note that the VoiceOver menu's keystroke lists omit the "Control-Option" part.) You can press Control-Option-right brace (}) or left brace ({) to increase or decrease the VoiceOver menu's type size.

When VoiceOver announces that you're in a scroll bar, Web page, table, list, or menu, press Control-Option-Shift-down arrow. You've just turned on interactive mode within this control area (and VoiceOver says, for example, "Start interacting with scroll bar"). Now the familiar Control-Option-arrow key keystrokes move you around only with in the interactive area, so that you can listen to your options.

To leave the interactive area, press Control-Option-Shift-up arrow.

15.6.3. VoiceOver Menu Lists

If you're truly visually impaired, you probably don't care quite so much about the spatial relationships of the on screen elements. That's why VoiceOver comes equipped to display high-visibility, white-on-black lists of things that you can navigate with the arrow keys alone (Figure 15-16). For example:

  • The Item Chooser menu lists every window element available to you. (On a Web page, the item menu may take a long time to appear, because it lists everything clickable on the page—600 links and bullets, for example). Keystroke: Control-Option-I.

  • A list of all open windows appears when you hold down Control-Option, and press F2 twice.

  • A list of all running programs shows up when you hold down Control-Option, and then tap F1 twice.

  • TheVoiceOver menu lists all of VoiceOver's keystrokes, offers direct access to VoiceOver's preference settings, and more. Keystroke: Control-Option-F7.

15.6.4. Operating Onscreen Controls

Using only the keyboard, you can use VoiceOver to operate checkboxes, radio buttons, lists, scroll bars, sliders, and menus. You can even select and edit text, move or resize windows, and drag icons around in the Finder—all without the mouse.

For example, here's how you operate the menu bar. Press Control-Option-M to highlight the very first menu—the [image] menu. From here, you can use the right/left arrow keys to choose a different menu. (VoiceOver pronounces their names). Open the one you want by pressing the down arrow key. At this point, the up/down arrow keys walk you through the commands; the right/left arrow keys open or close a submenu. Press Return to select a menu item, or Esc to close the menu without selecting anything.

Tip: You can even operate your menulets—the status icons at the right end of the menu bar—the same way. Highlight the first one by pressing Control-Option-M twice, and then proceed as described above.

15.6.5. VoiceOver Preferences

The VoiceOver Utility teems with ways to fine-tune VoiceOver options. Technically, it's in your Applications rightwards double arrow Utilities folder—but you can open it from the keyboard by pressing Control-Option-F8. Here, in Leopard's expanded edition of VoiceOver, you'll find nine tabs' worth of controls:

  • General. Lets you type a spoken greeting to let you know when VoiceOver is running.

  • Verbosity.Controls how much of what's on the screen VoiceOver reads. Do you want it to speak what you're typing? Should it let you know when you're pressing a modifier key like Option or Shift? Do you want to hear about bold and italic text when it's reading a document?

    Tip: If you find Voice Over to be frustratingly chatty, you're not alone. But on the Verbosity pane of the Voice Over Utility, you can choose Do Nothing from a pop-up menu to shut VoiceOver up for that category.

  • Speech. Controls what VoiceOver's voice sounds like (on the Voices tab), complete with rate, pitch, and volume controls. On the Pronunciation tab, you can change how the voice pronounces symbols. For example, it can say, "Splat!" instead of "exclamation point."

  • Navigation. Governs how VoiceOver speaks on screen elements. Usually, it pronounces whatever is highlighted by the black rectangle (the VoiceOver cursor), which you drive using the keyboard—but if you like, it can speak what the arrow cursor is touching instead.

  • Web.Specifies whether or not you want VoiceOver to pronounce the names of graphics (on Web pages, for example).

  • Sound. Two little options here. One mutes the voice entirely; the other produces little clicking sounds as your cursor "hits" various onscreen areas. (You could turn off the voice, for example, and get around solely by listening for these "positional audio" clicks.)

  • Visuals.If you're completely blind, these options are irrelevant. If you have some vision, though, this panel lets you specify a degree of magnification for whatever the VoiceOver cursor touches. It also offers a VoiceOver caption box at the lowerleft corner of your screen, which displays, as text, whatever the VoiceOver voice is currently reading.

  • NumPad. Just in case you didn't think there were enough VoiceOver keystrokes to learn, here are 17 more. They correspond to the keys on your Mac's numeric keypad, and lots of them are useful shortcuts.

  • Pronunciation. This pane lets you construct a list of terms that require special pronunciation. For example, Apple has already taught VoiceOver to say "smiley" when it reads the :) characters.

15.6.6. The VoiceOver Master Keyboard List

As you've seen, mastering VoiceOver means learning a long list of keyboard shortcuts. Here are a few—all right, quite a few—of the most important ones.

Basic Functions | Keystroke
Turn VoiceOver on or off | -F5
VoiceOver menu | Control-Option-F7
VoiceOver Help | Control-Option-Question mark (?)
Help for a highlighted item | Control-Option-H
Lock/unlock Control-Option keys | Control-Option-Semicolon (;)
Open the Commands menu for an item | Control-Option-H twice
Open VoiceOver Utility | Control-Option-F8
Start keyboard practice (speaks key names) | Control-Option-K
Close a menu, stop an action, or exit a mode | Esc or Control-Option-Esc
Ignore the next key combination you press | Control-Option-Tab
Magnify or shrink what's in the VoiceOver cursor box | Control-Option-right brace (})/ left brace ({)
Hide or show the VoiceOver cursor and caption box | Control-Option-F11
Resize or move the caption panel | Control-Option-Shift-F10. (Press repeatedly to cycle through Resize and Move functions. Then use arrow keys to resize the caption panel or move it. Press Shift-arrow keys to move by smaller amounts.)
Increase/decrease font size in the caption panel | Control-Option- [image] -right bracket (])/left bracket ([)
"Screen curtain" effect (totally black screen for privacy) | Control-Option-Shift-F11
Tile Visuals mode on/off | Control-Option-F10

Note: In Tile Visuals mode, the screen goes black except for whatever element is currently highlighted by the VoiceOver cursor, which moves directly to the center of the screen. This feature can be a tremendous help if you have some extremely limited vision.

Navigation | Keystroke
Highlight next window/dialog box element | Control-Option-arrow keys
Top/bottom of window, text area, etc., without scrolling | Control-Option-Home/End (Laptops: Control-Option-Fnleft arrow/right arrow)
Top/bottom of area, scrolling if necessary | Control-Option-Shift-Home/ End (Laptops: Control-Option-Shift-Fn-left arrow/ right arrow)
Top of the window | Control-Option- [image] -Home (Laptops: Control-Option- [image] -Fn-left arrow)
Lower-right corner of the window | Control-Option- [image] -End (Laptops: Control-Option- [image] -Fn-right arrow)
Bring the VoiceOver cursor's window to the front | Control-Option-Shift-F2
List every element of a window | Control-Option-I
Highlight the Dock | Control-Option-D
Move to the desktop | Control-Option-Shift-D
Highlight first menu | Control-Option-M (Use arrow keys to move to the other menus.)
Highlight first menulet | Control-Option-M twice
Open the Spotlight menu | Control-Option-M three times
Open a shortcut menu | Control-Option-Shift-M
Back/Forward (movements of the VoiceOver cursor) | Control-Option-left bracket ([)/right bracket (])
Turn cursor tracking on or off temporarily | Control-Option-Shift-F3
Move VoiceOver cursor to keyboard focus | Control-Option-Shift-F4
Move keyboard focus to VoiceOver cursor | Control-Option-Command-F4
Move VoiceOver cursor to mouse | Control-Option-Shift-F5
Move mouse to VoiceOver cursor | Control-Option-Command-F5

Getting Your Bearings | Keystroke
Speak program's name | Control-Option-F1
Display a menu of program names | Control-Option-F1 twice. (Esc to close it.)
Display a menu of window names | Control-Option-F2
Menu of window names, this program only | Control-Option-F2 twice
Describe what's in the VoiceOver cursor box | Control-Option-F3
Describe what you've highlighted using the keyboard | Control-Option-F4
Describe what's under the mouse | Control-Option-F5
Say mouse's position (pixels from top-left screen corner) | Control-Option-F5 twice
Click what's under the mouse | Control-Option-Shift-Space bar (twice for a double-click)
Describe the selected item | Control-Option-F6
Read everything in the VoiceOver cursor box | Control-Option-A
Read everything visible in the window | Control-Option-Shift-W
Repeat the last spoken phrase | Control-Option-Z
Save the last spoken phrase to a file on the desktop | Control-Option-Shift-Z. (Also saves a crash log that can help a technician figure out what went wrong.)

Web Pages | Keystroke
List the links on a Web page | Control-Option-U
Next frame/Previous frame | Control-Option- Command-M/Control- Option-Command-Shift-M

Text Manipulation | Keystroke
Read all text | Control-Option-A
Get text attributes | Control-Option-T
Add a bookmark in text | Control-Option-Shift-1
Jump to a bookmark in text | Control-Option-1
Read paragraph in VoiceOver cursor | Control-Option-P
Read previous/next paragraph | Control-Option-Shift-Page Up/Page Down
Read sentence in VoiceOver cursor | Control-Option-S
Read previous/next sentence | Control-Option-Page Up/Page Down
Read line in VoiceOver cursor | Control-Option-L
Read previous/next line | Control-Option- upwards arrow / downwards arrow
Read word in VoiceOver cursor | Control-Option-W (Press twice to hear the word spelled; press a third time to hear the word spelled phonetically.)
Read next /previous word | Control-Option- rightwards double arrow / leftwards double arrow
Read character in VoiceOver cursor | Control-Option-C (Press twice to hear the phonetic character.)
Read previous/next character | Control-Option-Shift- rightwards double arrow / leftwards double arrow
Move to first/last visible word | Control-Option-Home/End (Laptops: Control-Option- Fn- rightwards double arrow / leftwards double arrow )
Move to last visible word | Control-Option-End
Move to beginning/end of text, scrolling if necessary | Control-Option-Shift-Home/ End (Laptops: Control- Option-Shift-Fn- rightwards double arrow / leftwards double arrow )
New tab stop (in TextEdit) | Control-Option-Space bar
Delete the current tab stop (in TextEdit) | Control-Option-Delete

Tip: If your Mac life depends on VoiceOver, you could probably use its assistance when logging in, too. VoiceOver can indeed assist by, for example, reading the list of account holders to you—but only if you ask it to. See Section 12.6.


ink_handwriting_recognition.html

15.7. Ink: Handwriting Recognition

In the same way that your grandmother turned yesterday's dinner into today's sandwich (and tomorrow's soup), Apple recycled the handwriting technology of its failed Newton handheld and added it to Mac OS X. It's now called Ink, and it does exactly what it used to: turns your handwriting into "typed" text in any program.

You can't very well write directly on your Apple Cinema Display (although that would be cool). So Ink appears in Mac OS X only if you have a graphics tablet, one of those stylus-and-pad devices found generally only on the desks of graphic artists. (Wacom is the best-known tablet company, but there are a couple of others.)

Can Ink really replace the keyboard? Not for anything more than quick notes, that's for sure. But it can be handy when you're Web surfing, sketching, filling in database forms, and so on.

Still, let's face it: You could count the number of people with Wacom digitizing tablets who use them for handwriting input on one hand. And so, to avoid sacrificing any more old-growth trees to this book than absolutely necessary, the how-to for Ink is available as a free downloadable PDF appendix to this chapter. You'll find it on this book's "Missing CD" page at www.missingmanuals.com.

Figure 15-17. Front Row is all about drilling down through the menu screens, exactly as on an iPod. Start here, on the main menu. Use the center button on the remote, or the Space bar on your keyboard, to select a command or category and open the next screen. Keep going like that until you're watching your movies or slideshows, or listening to your music.

Note: Why on earth did Apple go to all this software-writing trouble just to satisfy the tiny community of graphics-tablet owners? That's exactly what the GICPWBAMBDOPTC (Great Internet Confederacy of People Who Believe that Apple Must Be Developing a One-Piece Tablet Computer) wants to know.


front_row-id001.html

15.8. Front Row

For the last few years, most new Mac models have come with a peculiar accessory: a slim white remote control, looking for all the world like an iPod that's lost too much weight. If you point it at the Mac and press the remote's Menu button, you're catapulted into the magic world of Front Row, a special overlay that provides access to your music, photos, movies, and DVD player—with super-big fonts and graphics that are visible from the couch across the room.

It might seem a little bit weird, then, to hear that Front Row, the software, is now a part of Leopard. In other words, it gets installed on all Macs, even the ones that didn't come with a remote control and don't have an infrared sensor.

That's because you can operate Front Row entirely from the keyboard—even from across the room, if you have a Bluetooth wireless one. So now even infrared-less Macs like the Mac Pro are invited to the Front Row party.

As shown in Figure 15-17, Front Row has been redesigned to look like the menu system of the Apple TV. It's all about drilling down from one menu into another.

Use the arrow keys or the + and – buttons on the remote to choose the primary activity you're interested in: Music, Photos, DVD, or Videos. Use the Space bar or the [image] button as the Enter key to choose that kind of entertainment. You'll find, to your delight, that Front Row lets you fire up not only all the music you've got in iTunes, all the photos in iPhoto, and so on, but also all the music, photos, and videos stored on other Macs on your network (assuming you've left iPhoto and iTunes running on those Macs).

The bottom line: Your Mac is now an entertainment center that can be operated from across the room. Bit by bit, Apple is sneaking into the living room—and Front Row is its Trojan horse.

Here, then, is the cheat sheet for navigating your Mac's entertainment collections— whether you have a Front Row remote or not.

How to | Using the Remote | Using the Keyboard
Open and close Front Row | Menu | -Esc
Navigate menus and lists | +, – | upwards arrow , downwards arrow
Return to a previous menu | Menu | Esc
Select an item in a menu or list |  | Space bar or Return
Play and pause audio or video |  | Space bar or Return
Change volume | +, – | upwards arrow , downwards arrow
Go to the next/previous song, photo, or DVD chapter |  | rightwards double arrow , leftwards double arrow
Rewind/fast-forward (DVD or movie) | (press and hold the button) | rightwards double arrow , leftwards double arrow (hold down)


the_unix_crash_course.html

Chapter 16. The Unix Crash Course

As you're certainly aware by now, Mac OS X's resemblance to the original Mac operating system is only superficial. The engine underneath the pretty skin is utterly different. In fact, it's Unix, one of the oldest and most respected operating systems in use today. The first time you see it, you'd swear that Unix has about as much in common with the original Mac OS as a Jeep does with a melon (see Figure 16-1).

What the illustration at the bottom of Figure 16-1 shows, of course, is a command line interface: a place where you can type out instructions to the computer. This is a world without icons, menus, or dialog boxes. The mouse is almost useless here.

Surely you can appreciate the irony: The brilliance of the original 1984 Macintosh was that it eliminated the command line interface that was still the ruling party on the computers of the day (like Apple II and DOS machines). Most nongeeks sighed with relief, delighted that they'd never have to memorize commands again. Yet here's Mac OS X, Apple's supposedly ultramodern operating system, complete with a command line! What's going on?

Actually, the command line never went away. At universities and corporations worldwide, professional computer nerds kept right on pounding away at the little C: or $ prompts, appreciating the efficiency and power such direct computer control afforded them.

You're forgiven if your reaction to the idea of learning Unix is, "For goodness'sake— can't I finish learning one way to control my new operating system before I have to learn yet another one?"

Absolutely. You never have to use Mac OS X's command line. In fact, Apple has swept it far under the rug, obviously expecting that most people will use the beautiful icons and menus of the regular desktop. There are, however, some tasks you can perform only at the command line, although fewer with each release of Mac OS X.

Figure 16-1. Top: What most people think of when they think "Macintosh" is a graphic interface (GUI)—one that you control with a mouse, using icons and menus to represent files and commands.
Bottom: Terminal offers a second way to control Mac OS X: a command line interface, which you operate by typing out programming commands.

For intermediate or advanced Mac fans with a little time and curiosity, however, the command line opens up a world of possibilities. It lets you access corners of Mac OS X that you can't get to from the regular desktop. It lets you perform certain tasks with much greater speed and efficiency than you'd get by clicking buttons and dragging icons. And it gives you a fascinating glimpse into the minds and moods of people who live and breathe computers.

If you've ever dabbled in Excel macros, experimented with AppleScript, or set up a Mac on a network, you already know the technical level of the material you're about to read. The Unix command line may be unfamiliar, but it doesn't have to be especially technical, particularly if you have some "recipes" to follow like the ones in this chapter and the next.

Note: Unix is an entire operating system unto itself. This chapter is designed to help you find your footing and decide whether or not you like the feel of Unix. If you get bit by the bug, see Appendix E for sources of additional Unix info.

16.1. Terminal

The keyhole into Mac OS X's Unix innards is a program called Terminal, which sits in your Applications rightwards double arrow Utilities folder (see Figure 16-2). Terminal is named after the terminals (computers that consist of only a monitor and keyboard) that still tap into the mainframe computers at some universities and corporations. In the same way, Terminal is just a window that passes along messages to and from the Mac's brain.

The first time you open Terminal, you'll notice that there's not much in its window except the date, time and source of your last login, and the command line prompt (Figure 16-2).

UP TO SPEED
Mac OS X's Unix Roots

In 1969, Bell Labs programmer Ken Thompson found himself with some spare time after his main project, an operating system called Multics, was canceled. Bell Labs had withdrawn from the expensive project, disappointed with the results after four years of work.

But Thompson still thought the project—an OS that worked well as a cooperative software-development environment—was a promising idea. Eventually, he and colleague Dennis Ritchie came up with the OS that would soon be called Unix (a pun on Multics). Bell Labs saw the value of Unix, agreed to support further development, and became the first corporation to adopt it.

In the age when Thompson and Ritchie started their work on Unix, most programmers wrote code that would work on only one kind of computer (or even one computer model). Unix, however, was one of the first portable operating systems; its programs could run on different kinds of computers without having to be completely rewritten. That's because Thompson and Ritchie wrote Unix using a new programming language of their own invention called C.

In a language like C, programmers need only write their code once. After that, a software Cuisinart called a compiler can convert the newly hatched software into the form a particular computer model can understand.

Unix soon found its way into labs and, thanks to AT&T's low academic licensing fees, universities around the world. Programmers all over the world added to the source code, fixed bugs, and then passed those modifications around.

In the mid-1970s, the University of California at Berkeley became the site of especially intense Unix development. Students and faculty there improved the Unix kernel (the central, essential part of the OS), added features, and wrote new Unix applications. By 1977, they had enough additional software to release their own version of Unix, the first of several Berkeley Software Distribution (BSD) versions.

As it happened, the government's Defense Advanced Research Projects Agency (DARPA) was seeking a uniform, portable OS to use for their growing wide-area network, originally called ARPAnet (and now called the Internet).

DARPA liked Unix and agreed to sponsor further research at Berkeley. In January 1983, DARPA changed ARPAnet's networking protocol to TCP/IP—and the Internet was born, running mostly on Unix machines.

Cut to 1985. Steve Jobs left Apple to start NeXT Computer, whose NextStep operating system was based on BSD Unix. When Apple bought NeXT in 1996, Jobs, NextStep (eventu-ally renamed OpenStep) and its Terminal program came along with it. The Unix that beats within Mac OS X's heart is just the latest resting place for the OS that Jobs's team developed at NeXT.

So the next time you hear Apple talk about its "new" operating system, remember that its underlying technology is actually over 35 years old.

For user-friendliness fans, Terminal doesn't get off to a very good start; this prompt looks about as technical as computers get. It breaks down like this:

  • office-mac:is the name of your Mac (at least, as Unix thinks of it). It's usually the Mac's Computer Name (as it appears in the Sharing pane of System Preferences), but it's occasionally the name your Mac goes by on the Internet.

    Figure 16-2. On the Web, Mac OS X's Terminal is one of the most often-discussed elements of Mac OS X. Dozens of step-bystep tutorials for performing certain tasks circulate online, usually without much annotation as to why you're typing what you're typing. As you read this chapter, remember that capitalization matters in Terminal, even though it doesn't in the Finder. As far as most Unix commands are concerned, Hello and hello are two different things.

  • ~. The next part of the prompt indicates what folder you're "in" (Figure 16-2). It denotes the working directory—that is, the currently open folder. (Remember, there are no icons in Unix.) Essentially, this notation tells you where you are as you navigate your machine.

    The very first time you try out Terminal, the working directory is set to the symbol ~. That tilde symbol is important shorthand; it means "your own Home folder." It's what you see the first time you start up Terminal, but you'll soon be seeing the names of other folders here—office-mac: /Users or office-mac: /System/Library, for example. (More on this slash notation on Section 1.2.4.)

    Note: Before Apple came up with the user-friendly term folder to represent an electronic holding tank for files, folders were called directories. In this chapter, you'll encounter the term directory almost exclusively. In any discussion of Unix, "directory" is simply the correct term.Besides, using a term like "working folder" within earshot of Unix geeks is likely to get you lynched.

  • chris$ begins with your short user name. It reflects whoever's logged into the shell (see the box on the facing page), which is usually whoever's logged into the Mac at the moment. As for the $ sign, think of it as a colon. In fact, think of the whole prompt shown in Figure 16-2 as Unix's way of saying, "OK, Chris, I'm listening. What's your pleasure?"

Unless you've fiddled with Terminal's preferences, the insertion point looks like a tall rectangle at the end of the command line. It trots along to the right as you type.

16.1.1. Unix Programs

An enormous number of programs have been written for Unix. And thanks to thousands of open-source developers—programmers all over the world who collaborate and make their work available for the next round of modification—much of this software is freely available to all, including Mac OS X users.

Each Unix command generally calls up a single application (or process, as geeks call it) that launches, performs a task, and closes. Many of the best-known such applications come with Mac OS X.

Here's a fun one: Just type uptime and press Enter or Return. (That's how you run a Unix program: Type its name and press Enter.) On the next line, Terminal shows you how long your Mac has been turned on continuously. It shows you something like:"13:096:00PMup 8 days,15:04,1 user, loadaverages:1.24,1.37,1.45"—meaning your Mac has been running for 8 days, 15 hours nonstop.

You're finished running the uptime program. The $ prompt returns, suggesting that Terminal is ready for whatever you throw at it next.

UP TO SPEED
bash, Terminal, and Shells

One Unix program runs automatically when you open a Terminal window: bash. It's Apple's chosen shell for Mac OS X 10.5.

A shell is a Unix program that interprets the commands you've typed, passes them to the kernel (the operating sys-tem's brain), and then shows you the kernel's response.

In other words, the shell is the Unix Finder. It's the program that lets you navigate the contents of your hard drive, see what's inside certain folders, launch programs and documents, and so on.

There are actually several different shells available in Unix, each with slightly different command syntax. All of the popular ones—like tcsh, ksh, and zsh—come with Mac OS X. (You can choose among them as your default shell using, of all things, the Accounts pane of System Preferences. Click the [image] , enter your Administrator passsword, and then Control-click or right-click your account name in the list; choose Advanced Options. There, on the Advanced Options panel, you'll find the Login Shell box, where you can make the change.) But on a clean installation of Leopard, Terminal comes set to use bash.

bash evolved from the original sh shell, which was named the Bourne shell after its inventor. bash got its name, then, as the Bourne Again Shell (get it?).

You can open additional Terminal windows (100 or more, depending on how many other programs are running) by choosing File rightwards double arrow New ShellWindow. Even slicker, Leopard's Terminal now lets you open multiple sessions in tabs (just like with Safari) by choosing File rightwards double arrow New Tab. Each window and tab runs independently of any others. For proof, try opening several windows and then running the cal command in each.

Try this one: Type cal at the prompt, and then press Enter. Unix promptly spits out a calendar of the current month.

    office-mac:~ chris$ cal
          May 2008
    Su Mo Tu We Th Fr Sa
                 1  2  3
     4  5  6  7  8  9 10
    11 12 13 14 15 16 17
    18 19 20 21 22 23 24
    25 26 27 28 29 30 31

    office-mac:~ chris$

This time, try typing cal 6 2008, cal -y, or cal -yj. These three commands make Unix generate a calendar of June 2008, a calendar of the current year, and a calendar of Julian days of the current year, respectively.

Tip: The mouse isn't very useful at the command line. You generally move the cursor only with the left and right arrow keys. (The Delete key works as it always does.)You can use the mouse, however, to select text from anywhere in the window (or other programs) and paste it in at the prompt. You can also use the mouse to drag an icon off your desktop into the Terminal window, as shown in Figure 16-3.


terminal-id001.html

Chapter 16. The Unix Crash Course

As you're certainly aware by now, Mac OS X's resemblance to the original Mac operating system is only superficial. The engine underneath the pretty skin is utterly different. In fact, it's Unix, one of the oldest and most respected operating systems in use today. The first time you see it, you'd swear that Unix has about as much in common with the original Mac OS as a Jeep does with a melon (see Figure 16-1).

What the illustration at the bottom of Figure 16-1 shows, of course, is a command line interface: a place where you can type out instructions to the computer. This is a world without icons, menus, or dialog boxes. The mouse is almost useless here.

Surely you can appreciate the irony: The brilliance of the original 1984 Macintosh was that it eliminated the command line interface that was still the ruling party on the computers of the day (like Apple II and DOS machines). Most nongeeks sighed with relief, delighted that they'd never have to memorize commands again. Yet here's Mac OS X, Apple's supposedly ultramodern operating system, complete with a command line! What's going on?

Actually, the command line never went away. At universities and corporations worldwide, professional computer nerds kept right on pounding away at the little C: or $ prompts, appreciating the efficiency and power such direct computer control afforded them.

You're forgiven if your reaction to the idea of learning Unix is, "For goodness'sake— can't I finish learning one way to control my new operating system before I have to learn yet another one?"

Absolutely. You never have to use Mac OS X's command line. In fact, Apple has swept it far under the rug, obviously expecting that most people will use the beautiful icons and menus of the regular desktop. There are, however, some tasks you can perform only at the command line, although fewer with each release of Mac OS X.

Figure 16-1. Top: What most people think of when they think "Macintosh" is a graphic interface (GUI)—one that you control with a mouse, using icons and menus to represent files and commands.
Bottom: Terminal offers a second way to control Mac OS X: a command line interface, which you operate by typing out programming commands.

For intermediate or advanced Mac fans with a little time and curiosity, however, the command line opens up a world of possibilities. It lets you access corners of Mac OS X that you can't get to from the regular desktop. It lets you perform certain tasks with much greater speed and efficiency than you'd get by clicking buttons and dragging icons. And it gives you a fascinating glimpse into the minds and moods of people who live and breathe computers.

If you've ever dabbled in Excel macros, experimented with AppleScript, or set up a Mac on a network, you already know the technical level of the material you're about to read. The Unix command line may be unfamiliar, but it doesn't have to be especially technical, particularly if you have some "recipes" to follow like the ones in this chapter and the next.

Note: Unix is an entire operating system unto itself. This chapter is designed to help you find your footing and decide whether or not you like the feel of Unix. If you get bit by the bug, see Appendix E for sources of additional Unix info.

16.1. Terminal

The keyhole into Mac OS X's Unix innards is a program called Terminal, which sits in your Applications rightwards double arrow Utilities folder (see Figure 16-2). Terminal is named after the terminals (computers that consist of only a monitor and keyboard) that still tap into the mainframe computers at some universities and corporations. In the same way, Terminal is just a window that passes along messages to and from the Mac's brain.

The first time you open Terminal, you'll notice that there's not much in its window except the date, time and source of your last login, and the command line prompt (Figure 16-2).

UP TO SPEED
Mac OS X's Unix Roots

In 1969, Bell Labs programmer Ken Thompson found himself with some spare time after his main project, an operating system called Multics, was canceled. Bell Labs had withdrawn from the expensive project, disappointed with the results after four years of work.

But Thompson still thought the project—an OS that worked well as a cooperative software-development environment—was a promising idea. Eventually, he and colleague Dennis Ritchie came up with the OS that would soon be called Unix (a pun on Multics). Bell Labs saw the value of Unix, agreed to support further development, and became the first corporation to adopt it.

In the age when Thompson and Ritchie started their work on Unix, most programmers wrote code that would work on only one kind of computer (or even one computer model). Unix, however, was one of the first portable operating systems; its programs could run on different kinds of computers without having to be completely rewritten. That's because Thompson and Ritchie wrote Unix using a new programming language of their own invention called C.

In a language like C, programmers need only write their code once. After that, a software Cuisinart called a compiler can convert the newly hatched software into the form a particular computer model can understand.

Unix soon found its way into labs and, thanks to AT&T's low academic licensing fees, universities around the world. Programmers all over the world added to the source code, fixed bugs, and then passed those modifications around.

In the mid-1970s, the University of California at Berkeley became the site of especially intense Unix development. Students and faculty there improved the Unix kernel (the central, essential part of the OS), added features, and wrote new Unix applications. By 1977, they had enough additional software to release their own version of Unix, the first of several Berkeley Software Distribution (BSD) versions.

As it happened, the government's Defense Advanced Research Projects Agency (DARPA) was seeking a uniform, portable OS to use for their growing wide-area network, originally called ARPAnet (and now called the Internet).

DARPA liked Unix and agreed to sponsor further research at Berkeley. In January 1983, DARPA changed ARPAnet's networking protocol to TCP/IP—and the Internet was born, running mostly on Unix machines.

Cut to 1985. Steve Jobs left Apple to start NeXT Computer, whose NextStep operating system was based on BSD Unix. When Apple bought NeXT in 1996, Jobs, NextStep (eventu-ally renamed OpenStep) and its Terminal program came along with it. The Unix that beats within Mac OS X's heart is just the latest resting place for the OS that Jobs's team developed at NeXT.

So the next time you hear Apple talk about its "new" operating system, remember that its underlying technology is actually over 35 years old.

For user-friendliness fans, Terminal doesn't get off to a very good start; this prompt looks about as technical as computers get. It breaks down like this:

  • office-mac:is the name of your Mac (at least, as Unix thinks of it). It's usually the Mac's Computer Name (as it appears in the Sharing pane of System Preferences), but it's occasionally the name your Mac goes by on the Internet.

    Figure 16-2. On the Web, Mac OS X's Terminal is one of the most often-discussed elements of Mac OS X. Dozens of step-bystep tutorials for performing certain tasks circulate online, usually without much annotation as to why you're typing what you're typing. As you read this chapter, remember that capitalization matters in Terminal, even though it doesn't in the Finder. As far as most Unix commands are concerned, Hello and hello are two different things.

  • ~. The next part of the prompt indicates what folder you're "in" (Figure 16-2). It denotes the working directory—that is, the currently open folder. (Remember, there are no icons in Unix.) Essentially, this notation tells you where you are as you navigate your machine.

    The very first time you try out Terminal, the working directory is set to the symbol ~. That tilde symbol is important shorthand; it means "your own Home folder." It's what you see the first time you start up Terminal, but you'll soon be seeing the names of other folders here—office-mac: /Users or office-mac: /System/Library, for example. (More on this slash notation on Section 1.2.4.)

    Note: Before Apple came up with the user-friendly term folder to represent an electronic holding tank for files, folders were called directories. In this chapter, you'll encounter the term directory almost exclusively. In any discussion of Unix, "directory" is simply the correct term.Besides, using a term like "working folder" within earshot of Unix geeks is likely to get you lynched.

  • chris$ begins with your short user name. It reflects whoever's logged into the shell (see the box on the facing page), which is usually whoever's logged into the Mac at the moment. As for the $ sign, think of it as a colon. In fact, think of the whole prompt shown in Figure 16-2 as Unix's way of saying, "OK, Chris, I'm listening. What's your pleasure?"

Unless you've fiddled with Terminal's preferences, the insertion point looks like a tall rectangle at the end of the command line. It trots along to the right as you type.

16.1.1. Unix Programs

An enormous number of programs have been written for Unix. And thanks to thousands of open-source developers—programmers all over the world who collaborate and make their work available for the next round of modification—much of this software is freely available to all, including Mac OS X users.

Each Unix command generally calls up a single application (or process, as geeks call it) that launches, performs a task, and closes. Many of the best-known such applications come with Mac OS X.

Here's a fun one: Just type uptime and press Enter or Return. (That's how you run a Unix program: Type its name and press Enter.) On the next line, Terminal shows you how long your Mac has been turned on continuously. It shows you something like:"13:096:00PMup 8 days,15:04,1 user, loadaverages:1.24,1.37,1.45"—meaning your Mac has been running for 8 days, 15 hours nonstop.

You're finished running the uptime program. The $ prompt returns, suggesting that Terminal is ready for whatever you throw at it next.

UP TO SPEED
bash, Terminal, and Shells

One Unix program runs automatically when you open a Terminal window: bash. It's Apple's chosen shell for Mac OS X 10.5.

A shell is a Unix program that interprets the commands you've typed, passes them to the kernel (the operating sys-tem's brain), and then shows you the kernel's response.

In other words, the shell is the Unix Finder. It's the program that lets you navigate the contents of your hard drive, see what's inside certain folders, launch programs and documents, and so on.

There are actually several different shells available in Unix, each with slightly different command syntax. All of the popular ones—like tcsh, ksh, and zsh—come with Mac OS X. (You can choose among them as your default shell using, of all things, the Accounts pane of System Preferences. Click the [image] , enter your Administrator passsword, and then Control-click or right-click your account name in the list; choose Advanced Options. There, on the Advanced Options panel, you'll find the Login Shell box, where you can make the change.) But on a clean installation of Leopard, Terminal comes set to use bash.

bash evolved from the original sh shell, which was named the Bourne shell after its inventor. bash got its name, then, as the Bourne Again Shell (get it?).

You can open additional Terminal windows (100 or more, depending on how many other programs are running) by choosing File rightwards double arrow New ShellWindow. Even slicker, Leopard's Terminal now lets you open multiple sessions in tabs (just like with Safari) by choosing File rightwards double arrow New Tab. Each window and tab runs independently of any others. For proof, try opening several windows and then running the cal command in each.

Try this one: Type cal at the prompt, and then press Enter. Unix promptly spits out a calendar of the current month.

    office-mac:~ chris$ cal
          May 2008
    Su Mo Tu We Th Fr Sa
                 1  2  3
     4  5  6  7  8  9 10
    11 12 13 14 15 16 17
    18 19 20 21 22 23 24
    25 26 27 28 29 30 31

    office-mac:~ chris$

This time, try typing cal 6 2008, cal -y, or cal -yj. These three commands make Unix generate a calendar of June 2008, a calendar of the current year, and a calendar of Julian days of the current year, respectively.

Tip: The mouse isn't very useful at the command line. You generally move the cursor only with the left and right arrow keys. (The Delete key works as it always does.)You can use the mouse, however, to select text from anywhere in the window (or other programs) and paste it in at the prompt. You can also use the mouse to drag an icon off your desktop into the Terminal window, as shown in Figure 16-3.


navigating_in_unix.html

16.2. Navigating in Unix

If you can't see any icons for your files and folders, how are you supposed to work with them?

UP TO SPEED
Pathnames 101

In many ways, browsing the contents of your hard drive using Terminal is just like doing so with the Finder. You start with a folder, and move down into its subfolders, or up into its parent folders.

In this chapter, you'll be asked to specify a certain file or folder in this tree of folders. But you can't see their icons from the command line. So how are you supposed to identify the file or folder you want?

By typing its pathname. The pathname is a string of folder names, something like a map, that takes you from the root level to the next nested folder, to the next, and so on. (The root level is, for learning-Unix purposes, the equivalent of your main hard drive window. It's represented in Unix by a single slash. The phrase /Users, in other words, means "the Users folder in my hard drive window"—or, in Unix terms, "the Users directory at the root level.")

One way to refer to the Documents folder in your own Home folder, for example, would be /Users/chris/Documents (if your name is Chris, that is).

You have no choice but to ask Unix to tell you what folder you're looking at (using the pwd command), what's in it (using the ls command), and what folder you want to switch to (using the cd command), as described in the following pages.

16.2.1. pwd (Print Working Directory, or "Where am I?")

Here's one of the most basic navigation commands: pwd, which stands for print working directory. The pwd command doesn't actually print anything on your printer. Instead, the pwd command types out, on the screen, the path Unix thinks you're in (the working directory).

Try typing pwd and pressing Enter. On the next line, Terminal may show you something like this:

    /Users/chris/Movies

Terminal is revealing the working directory's path—a list of folders-in-folders, separated by slashes, that specifies a folder's location on your hard drive. /Users/chris/Movies pinpoints the Movies folder in Chris's Home folder (which, like all Home folders, is in the Users directory).

Tip: Capitalization counts in Unix. Command names are almost always all lowercase (like cal and pwd). But when you type the names of folders, be sure to capitalize correctly.

16.2.2. ls (List, or "What's in here?")

The ls command, short for list, makes Terminal type out the names of all the files and folders in the folder you're in (that is, your working directory). You can try it right now: Just type ls and then press Enter. Terminal responds by showing you the names of the files and folders inside in a list, like this:

    Desktop   Downloads Movies    Pictures  Sites
    Documents Library   Music     Public

In other words, you see a list of the icons that, in the Finder, you'd see in your Home folder.

Note: Terminal respects the limits of the various Mac OS X accounts (Chapter 12). In other words, a Standard or Administrator account holder isn't generally allowed to peek further into someone else's Home folder. If you try, you'll be told, "Permission denied."

You can also make Terminal list what's in any other directory (one that's not the working directory) just by adding its pathname as an argument. Arguments are extra pieces of information following the command that refine how the command should run. (Remember the calendar example? When you wanted the June 2008 calendar, you typed cal 6 2008. The "6" and "2008" parts were the arguments—that is, everything you typed after the command itself.)

To see a list of the files in your Documents directory, then, you could just type ls /Users/chris/Documents. Better yet, because the ~ symbol is short for "my home directory," you could save time by typing ls ~/Documents. The pathname "~/Documents" is an argument that you've fed the ls command.

16.2.2.1. About flags

As part of a command's arguments, you can sometimes insert option flags (also called switches)—modifying characters (or short phrases) that affect how the command works, just like option settings do in GUI applications. In the calendar example, you can type cal -y to see a full-year calendar; the -y part is an option flag.

Option flags are almost always preceded by a hyphen (-), although you can usually run several flags together following just one hyphen. If you type ls -al, both the -a and -l flags are in effect.

Here are some useful options for the ls command:

  • -a. The unadorned ls command even displays the names of invisible files and folders—at least by the Finder's definition. The Unix shell uses its own system of denoting invisible files and folders, and ignores the Finder's. That doesn't mean you're seeing everything; files that are invisible by the Unix definition still don't show up.

    You can use one of the ls command's flags, however, to force even Unix-invisible files to appear. Just add the -a flag. In other words, type this: ls -a. Now when you press Enter, you might see something like this:

        .                       Desktop            Music
    ..                      Documents          Pictures
    .CFUserTextEncoding     Downloads          Public
    .DS_Store               Library            Sites
    .Trash                  Movies

  • -F. As you see, the names of invisible Unix files all begin with a period (Unix folk call them dot files). But are these files or folders? To find out, use ls with the -F option (capitalization counts), like this: ls -aF. You're shown something like this:

        ./                      Desktop/         Music/
    ../                     Documents/       Pictures/
    .CFUserTextEncoding     Downloads/       Public/
    .DS_Store               Library/         Sites/
    .Trash/                 Movies/

    The names of the items themselves haven't changed, but the -F flag makes slashes appear on directory (folder) names. This example shows that in your home directory, there are 12 other directories and two files.

  • -G. Here's a fascinating flag that makes ls display color-coded results: blue for directories, red for programs, normal black-on-white type for documents, and so on.

  • -R. The -R flag produces a recursive listing—one that shows you the directories within the directories in the list. Listing all of the home directory could take several pages, but if you type ls -R Movies, for example, you might get something like this:

        Bad Reviews.doc    Old Tahoe Footage 2 Picnic Movie 2    Reviews.doc
    ./Old Tahoe Footage 2:
    Tahoe 1.mov   Tahoe 3.mov    Tahoe Project File
    Tahoe 2.mov   Tahoe 4.mov
    ./Picnic Movie 2:
    Icon?      Media      Picnic Movie 2 Project
    ./Picnic Movie 2/Media:
    Picnic Movie 1 Picnic Movie 3 Picnic Movie 5
    Picnic Movie 2 Picnic Movie 4 Picnic Movie 6

In other words, you've got two subdirectories here, called Old Tahoe Footage 2 and Picnic Movie 2—which itself contains a Media directory.

Tip: As you can tell by the cal and ls examples, Unix commands are very short. They're often just two-letter commands, and an impressive number of those use alternate hands (ls, cp, rm, and so on).The reason has partly to do with conserving the limited memory of early computers and partly to do with efficiency: Most programmers would just as soon type as little as possible to get things done. User-friendly it ain't, but as you type these commands repeatedly over the months, you'll eventually be grateful for the keystroke savings.

16.2.3. cd (Change Directory, or "Let Me See Another Folder")

Now you know how to find out what directory you're in, and how to see what's in it, all without double-clicking any icons. That's great information, but it's just information. How do you do something in your command line Finder—like switching to a different directory?

To change your working directory, use the cd command, followed by the path of the directory you want to switch to. Want to see what's in the Movies directory of your home directory? Type cd/Users/chris/Movies and press Enter. The $ prompt shows you what it considers to be the directory you're in now (the new working directory). If you perform an ls command at this point, Terminal shows you the contents of your Movies directory.

That's a lot of typing, of course. Fortunately, instead of typing out that whole path (the absolute path, as it's called), you can simply specify which directory you want to see relative to the directory you're already in.

For example, if your Home folder is the working directory, the relative pathname of the Trailers directory inside the Movies directory would be Movies/Trailers. That's a lot shorter than typing out the full, absolute pathname (/Users/chris/Movies/Trailers).

If your brain isn't already leaking from the stress, here's a summary of the three different ways you could switch from ~/(your home directory) to ~/Movies:

  • cd /Users/chris/Movies. That's the long way—the absolute pathname. It works no matter what your working directory is.

  • cd~/Movies. This, too, is an absolute pathname that you could type from anywhere. It relies on the ~ shorthand (which means "my home directory," unless you follow the ~ with another account name).

  • cd Movies. This streamlined relative path exploits the fact that you're already in your home directory.

Tip: Actually, there's a fourth way to specify a directory that involves no typing at all: dragging the icon of the directory you want to specify directly into the Terminal window. Figure 16-3 should make this clear.

Figure 16-3. This may be the quickest way of all to identify a directory or file you want to manipulate: Don't type anything. When you drag icons directly from the desktop into a Terminal window, the icon's pathname appears automatically at the insertion point. Terminal even adds backslashes to any special characters in these pathnames for you (a necessary step known as escaping the special characters; see Section 16.2.6).

16.2.4. .. (Dot-Dot, or "Back Me Out")

So now you've burrowed into your Movies directory. How do you back out?

Sure, you could type out the full pathname of the directory that encloses Movies—if you had all afternoon. But there's a shortcut: You can type a double period (..) in any pathname. This shortcut represents the current directory's parent directory (the directory that contains it).

To go from your home directory up to /Users, for example, you could just type cd .. (that is, cd followed by a space and two periods).

You can also use the dot-dot shortcut repeatedly to climb multiple directories at once, like this: cd ../.. (which would mean "switch the working directory to the directory two layers out.") If you were in your Movies directory, ../.. would change the working directory to the Users directory.

Another trick: You can mix the .. shortcut with actual directory names. For example, suppose your Movies directory contains two directories: Trailers and Shorts. Trailers is the current directory, but you want to switch to the Shorts directory. All you'd have to do is type cd ../Shorts, as illustrated in Figure 16-4.

Figure 16-4. The double dot tells Unix to switch its attention to the Movies directory (walking upward through the directory tree); the rest tells it to walk down the Movies directory into the Shorts directory. Note that the prompt always identifies the current working directory.

16.2.5. Keystroke-Saving Features

By now, you might be thinking that clicking icons would still be faster than doing all this typing. Here's where the typing shortcuts of the bash shell come in.

16.2.5.1. Tab completion

You know how you can highlight a file in a Finder window by typing the first few characters of its name? The tab-completion feature works much the same way. Over time, it can save you miles of finger movement.

It kicks in whenever you're about to type a pathname. Start by typing the first letter or two of the path you want, and then press Tab. Terminal instantly fleshes out the rest of the directory's name. As shown in Figure 16-5, you can repeat this process to specify the next directory-name chunk of the path.

Some tips for tab completion:

  • Capitalization counts.

  • Terminal adds backslashes automatically if your directory names include spaces, $ signs, or other special characters. But you still have to insert your own backslashes when you type the "hint" characters that tip off tab completion.

    Figure 16-5. Top: You type cd /U and then press Tab.
    Second from top: Terminal finishes the directory name Users for you.
    Third from top: You type c and then press Tab.
    Bottom: Terminal finishes the home directory name, chris. You can also use tab completion to specify file names, as when you type ls -l Movies/R and then press Tab; Terminal finishes the name Reviews.doc.

  • If it can't find a match for what you typed, Terminal beeps.

    If it finds several files or directories that match what you typed, Terminal beeps; when you press Tab again, terminal shows you a list of them. To specify the one you really wanted, type the next letter or two and then press Tab again.

16.2.5.2. Using the history

You may find yourself at some point needing to run a previously entered command, but dreading the prospect of re-entering the whole command. Retyping a command, however, is never necessary. Terminal (or, rather, the shell it's running) remembers the last 500 commands you entered. At any prompt, instead of typing, just press the up or down arrow keys to walk through the various commands in the shell's memory. They flicker by, one at a time, at the $ prompt—right there on the same line.

16.2.5.3. Wildcards

Wildcards are special characters that represent other characters—and they're huge timesavers.

The most popular wildcard is the asterisk (*), which means "any text can go here." For example, to see a list of the files in the working directory that end with the letters te, you could type ls *te. Terminal would show you files named Yosemite, BudLite, Brigitte, and so on—and hide all other files in the list. If the wildcard matches any directories, you'll also see the contents of those directories as well, just as though you'd used ls with each of the full directory names.

Likewise, to see which files and directories begin with "Old," you could type ls Old* and press Enter. You'd be shown only the names of icons in the working directory called Old Yeller, Old Tahoe Footage, Olduvai Software, and so on.

If you add the asterisk before and after the search phrase, you'd find items with that phrase anywhere in their names. Typing ls *jo* will show you the files named Mojo, johnson, Major Disaster, and so on.

Tip: Using * by itself means "show me everything." To see a list of what's in a directory and in the directories inside it (as though you'd highlighted all the folders in a Finder list view and then pressed [image] -right arrow), just type ls *.

WORKAROUND WORKSHOP
No Spaces Allowed

Terminal doesn't see a space as a space. It thinks that a space means, for example, "I've just typed a command, and what follows is an argument." If you want to see what's in your Short Films directory, therefore, don't bother typing ls ~/Movies/Short Films. You'll only get a "No such file or directory" error message, thanks to the space in the Short Films directory name.

Similarly, % signs have a special meaning in Unix. If you try to type one in a pathname (because a directory name contains %, for example), you'll have nothing but trouble.

Fortunately, you can work around this quirk by using a third reserved, or special, character: the backslash (\). It says, "Ignore the special meaning of the next character—a space, for example. I'm not using it for some special Unix meaning. I'm using the following space as, well, a space." (At a Unix user-group meeting, you might hear someone say, "Use the slash character to escape the space character.")

The correct way to see what's in your Short Films directory, then, would be ls ~/Movies /Short\ Films. (Note how the backslash just before the space means, "This is just a space— keep it moving, folks.")

Of course, if you have to enter a lot of text with spaces, it'd be a real pain to type the backslash before every single one. Fortunately, instead of using backslashes, you can enclose the whole mess with single quotation marks. That is, instead of typing this:

cd /Users/chris/My\ Documents/Letters\ to\ finish/Letter\ to\ Craig.doc

…you could just type this:

cd '/Users/chris/My Documents/Letters to finish/Letter to Craig.doc'

It can get even more complicated. For example, what if there's a single quote in the path? (Answer: Protect it with double quotes.) Ah, but you have years of study ahead of you, grasshoppa.

16.2.6. Directory Switching

A hyphen (-) after the cd command means "Take me back to the previous working directory." For example, if you changed your working directory from ~/Movies/Movie 1 to ~/Documents/Letters, simply enter cd -to change back to ~/Movies/Movie 1. Use cd - a second time to return to ~/Documents/Letters. (Note the space between cd and the hyphen.)

Tip: If you're doing a lot of switching between directories, you'll probably find it quicker to open and switch between two Terminal windows or tabs, each with a different working directory.

16.2.7. The ~ Shortcut

You already know that the tilde (~) character is a shortcut to your home directory. But you can also use it as a shortcut to somebody else's home directory simply by tacking on that person's account name. For example, to change to Miho's home directory, use cd ~Miho.

16.2.7.1. Special keys

The bash shell offers dozens of special keystroke shortcuts for navigation. You may recognize many of them as useful undocumented shortcuts that work in any Cocoa application, but even more are available (and useful) in Terminal:

Control-U | Erases the entire command line you're working on (to the insertion point's left).
Control-A | Moves the insertion point to the beginning of the line.
Control-E | Moves the insertion point to the end of the line.
Control-T | Transposes the previous two characters.
Esc-F | Moves the insertion point to the beginning of the next word.
Esc-B | Moves the insertion point to the beginning of the current word.
Esc-Delete | Erases the previous word (defined as "anything that ends with a space, slash, or most other punctuation marks; periods and asterisks not included"). You have to hold down Esc as you press Delete; repeat for each word.
Esc-D | Erases the word, or section of a word, following the insertion point.
Esc-C | Capitalizes the letter following the insertion point.
Esc-U | Changes the next word or word section to all uppercase letters.
Esc-L | Changes the next word or word section to all lowercase letters.


working_with_files_and_directories.html

16.3. Working with Files and Directories

The previous pages show you how to navigate your directories using Unix commands. Just perusing your directories isn't particularly productive, however. This section shows you how to do something with the files you see listed—copy, move, create, and delete directories and files.

Tip: You're entering Serious Power territory, where it's theoretically possible to delete a whole directory with a single typo. As a precaution, consider working through this section with administrator privileges turned off for your account, so that you won't be able to change anything outside your home directory—or to be really safe, create a new, test account just for this exercise so even your personal files won't be at risk.

16.3.1. cp (Copy)

Using the Unix command cp, you can copy and rename a file in one move. (Try that in the Finder!)

The basic command goes like this: cp path1 path2, where the path placeholders represent the original file and the copy, respectively.

16.3.1.1. Copying in place

To duplicate a file called Thesis.doc, you would type cp Thesis.doc Thesis2.doc. (That's just one space between the names.) You don't have to call the copy Thesis2—you could call it anything you like. The point is that you wind up with two identical files in the same directory with different names. Just remember to add a backslash before a space if you want to name the copy with two words (Thesis\ Backup, for example).

Tip: If this command doesn't seem to work, remember that you must type the full names of the files you're moving—including their file name suffixes like .doc or .gif, which Mac OS X usually hides. Using the ls command before a copy may help you find out what the correct, full file names should be. Or you may just want to use the tab-completion feature, making Terminal type the whole name for you.
16.3.1.2. Copying and renaming

To copy the same file into, say, your Documents folder instead, just change the last phrase so that it specifies the path, like this: cp Reviews.doc ~/Documents/Reviews2.doc.

FREQUENTLY ASKED QUESTION
The Slash and the Colon

OK, I'm so confused. You say that slashes denote nested directories. But I know that traditionally, colons (:) denote the Mac's internal folder notation, and that's why I can't use colons in the names of my icons. What's the story?

At the desktop, the Mac still uses colons as path separators instead of the slash. Therefore, you are allowed to use slashes in file names in the Finder, but not a colon.

Conversely, in Terminal, you can use colons in file names but not slashes!

Behind the scenes, Mac OS X automatically converts one form of punctuation to the other, as necessary. For example, a file named Letter 6/21/2007 in the Finder shows up as Letter 6:21:2007 in Terminal. Likewise, a directory named Attn: Jon in Terminal appears with the name Attn/ Jon in the Finder. Weird—and fun!

Tip: Note that cp replaces identically named files without warning. Use the -i flag (that is, cp -i) if you want to be warned before cp replaces a file like this.
16.3.1.3. Copying without renaming

To copy something into another directory without changing its name, just use a pathname (without a file name) as the final phrase. So to copy Reviews.doc into your Documents folder, for example, you would type cp Reviews.doc ~/Documents.

Tip: You can use the "." directory shortcut (which stands for the current working directory) to copy files from another directory into the working directory, like this: $ cp ~/Documents/Reviews.doc. (Notice the space and the period after Reviews.doc.)
16.3.1.4. Multiple files

You can even copy several files or directories at once. Where you'd normally specify the source file, just list their pathnames separated by spaces, as shown in Figure 16-6.

Figure 16-6. The first argument of this command lists two different files. The final clause indicates where they go.

POWER USERS' CLINIC
Your Metadata's Safe with Us

Metadata means "data about data." For example, the handwritten note on a shoebox of photos is metadata for the image data inside, reminding you of the photos' date, location, camera information, or even which CDs hold the digital versions. This metadata lets you locate and access the actual data quickly (and also helps you decide if you should go to the trouble in the first place).

Computer files have metadata too, and the more the computer can scribble down, the easier it can operate with the bazillions of files living on your hard drive. The Mac has always stored some file metadata in one way or another, but Leopard really goes whole hog. It now recognizes a Unix feature called extended attributes to store all kinds of file metadata.

In fact, many of the special Leopard features described in this book, like Time Machine and Downloaded Application Tagging, depend on extended attributes to perform their magic. Apple also uses extended attributes now to keep track of traditional Mac metadata like file types and creators (Section 5.6), and even resource forks (features carried over from OS 9 that Mac OS X still has to recognize).

When you create, modify, or move files in the Finder, you don't have to worry about extended attributes; the Mac always keeps them together with their associated files.

When you're working with files on the command line, however, you have to be more cautious. In Leopard (and Tiger too), the most common Unix file tools, like cp, mv, tar, and rsync (with the -E flag), manage extended attributes correctly. However, as you explore with other tools, it's wise to use them to duplicate rather than move files, until you're sure all the bits stay together.

The command line tool for peeking in on your extended attributes is xattr, which you'll learn about later in this chapter.

You can also use the * wildcard to copy several files at once. For example, suppose you've got these files in your iMovie Projects directory: Tahoe 1.mov, Tahoe 2.mov, Tahoe 3.mov, Tahoe 4.mov, Script.doc, and Tahoe Project File. Now suppose you want to copy only the QuickTime movies into a directory called FinishedMovies. All you'd have to do is type cp *mov ../FinishedMovies and press Enter; Mac OS X instantly performs the copy.

If you wanted to copy all of those files (not just the movies) to another directory, you'd use the * by itself, like this: cp * ../Finished Movies.

Unfortunately, if the iMovie Projects directory contains other directories and not just files, that command produces an error message. The Unix cp command doesn't copy directories within directories unless you explicitly tell it to, using the -R option flag. Here's the finished command that copies everything in the current directory—both files and directories—into FinishedMovies: cp -R * ../FinishedMovies.

Here's one more example: a command that copies everything (files and directories) with Tahoe in its name into someone else's Drop Box directory: cp -R *Tahoe* ~miho/ Public/Drop\ Box.

16.3.2. mv (Moving and Renaming Files and Directories)

Now that you know how to copy files, you may want to move or rename them. To do so, you use the Unix command mv almost exactly the same way you'd use cp (except that it always moves directories inside of directories you're moving, so you don't have to type -R).

The syntax looks like this: mv oldname newname. For example, to change your Movies directory's name to Films, you'd type mv Movies Films. You can rename both files and directories this way.

16.3.2.1. Moving files and directories

To rename a file and move it to a different directory simultaneously, just replace the last portion of the command with a pathname. To move the Tahoe1 movie file into your Documents directory—and rename it LakeTahoe at the same time—type this: mv Tahoe1.mov ~/Documents/LakeTahoe.mov.

All the usual shortcuts apply, including the wildcard. Here's how you'd move everything containing the word Tahoe in your working directory (files and directories) into your Documents directory: mv *Tahoe* ~/Documents.

16.3.2.2. Option flags

You can follow the mv command with any of these options:

  • -i. Makes Terminal ask your permission before replacing a file with one of the same name.

  • -f. Overwrites like-named files without asking you first. (Actually, this is how mv works if you don't specify otherwise.)

  • -n. Doesn't overwrite like-named files; just skips them without prompting.

  • -v. Displays verbose (fully explained) explanations on the screen, letting you know exactly what got moved.

Tip: If you use a combination of options that appear to contradict each other—like the -f, -i, and -n options—the last option (farthest to the right) wins.

By the way, the mv command never replaces a directory with an identically named file. It copies everything else you've asked for, but it skips files that would otherwise wipe out folders.

16.3.3. mkdir (Create New Directories)

In the Finder, you make a new folder by choosing File rightwards double arrow New Folder. In Terminal, you create one using the mkdir command (for make directory).

Follow the command with the name you want to give the new directory, like this: mkdir 'Early iMovie Attempts' (the single quotes in this example let you avoid having to precede each space with a backslash).

The mkdir command creates the new directory in the current working directory, although you can just as easily create it anywhere else. Just add the pathname to your argument. To make a new directory in your Documents rightwards double arrow Finished directory, for example, type mkdir '~/Documents/Finished/Early iMovie Attempts'. Thanks to Spotlight's constant eye on file activity, the new directory appears immediately in the Finder.

Tip: If there is no directory called Finished in your Documents directory, you just get an error message—unless you use the -p option, which creates as many new directories as necessary to match your command. For example, mkdir -p '~/Documents/Finished/Early iMovie Attempts' would create both a Finished directory and an Early iMovie Attempts directory inside of it.

16.3.4. touch (Create Empty Files)

To create a new, empty file, type touch filename. For example, to create the file practice. txt in your working directory, use touch practice.txt.

And why would you bother? For the moment, you'd use such new, empty files primarily as targets for practicing the next command.

16.3.5. rm (Remove Files and Directories)

Unix provides an extremely efficient way to trash files and directories. With a single command, rm, you can delete any file or directory—or all of those that you're allowed to access with your account type.

The dangers of this setup should be obvious, especially in light of the fact that deletions are immediate in Unix. There is no Undo, no Empty Trash command, no "Are you sure?" dialog box. In Unix, all sales are final.

The command rm stands for "remove," but could also stand for "respect me." Pause for a moment whenever you're about to invoke it. For the purpose of this introduction to rm, double-check that administration privileges are indeed turned off for your account.

To use this command, just type rm, a space, and the exact name of the file you want to delete from the working directory. To remove the file practice.txt you created with the touch command, for example, you'd just type rm practice.txt.

To remove a directory and everything in it, add the -r flag, like this: rm -r Practice-Folder.

If you're feeling particularly powerful (and you like taking risks), you can even use wildcards with the rm command. Now, many experienced Unix users make it a rule to never use rm with wildcards while logged in as an administrator, because one false keystroke can wipe out everything in a directory. But here, for study purposes only, is the atomic bomb of command lines, the one that deletes everything in the working directory: rm -rf *.

Tip: Be doubly cautious when using wildcards in rm command lines, and triply cautious when using them while logged in as an administrator.If you're using Time Machine, you have a safety net, of course. But why tempt fate?

Just after the letters rm, you can insert options like these:

  • -d deletes any empty directories it finds, in addition to files. (Otherwise, empty directories trigger an error message.)

  • -f squelches any attempts to get your attention, even if there's a problem, like a permission error or nonexistent file. The command proceeds, full speed ahead.

  • -i(for interactive) makes the Mac ask for confirmation before each deletion.

  • -P securely overwrites the file three times. (It's an alternative to the srm command described next.)

16.3.6. srm (Secure Removal)

srm is a command line version of the Finder's Secure Empty Trash function (Section 2.6.2). It lets you choose just how thoroughly Mac OS X scrubs the hard drive spot where the deleted file once sat.

The srm utility lets you specify three general levels of deletion:

  • Simple. The -s flag tells srm to perform a simple secure removal, overwriting the deleted material with random data just once. It's faster than the Finder's Secure Empty Trash, but not as thorough.

  • Medium. The -m flag designates medium level, which overwrites the unwanted data seven times with various types of random and not-so-random data. This is similar to what you get when you use the Finder's Secure Empty Trash command, and it's thorough enough to meet U.S. Department of Defense security requirements.

  • Strong. If you don't specify either -s or -m, srm will perform a strong secure removal. That entails recording over the spot where the deleted file sat 35 times, each time using a different string of data as specified by the Gutmann algorithm. (And what is the Gutmann algorithm? A series of data patterns that make recovery of an erased file almost impossible. More than you ever wanted to know is at www.cs.auckland.ac.nz/~pgut001/pubs/secure_del.html.)

The bottom line: To make sure no one ever, ever reads that poem you typed out for your cat one lonely, bleary-eyed evening, type srm "My Twinkie.doc". That will be the end of it, and neither the CIA nor Norton Utilities will ever know what it was.

16.3.7. echo (A Final Check)

You can make rm or srm less risky by prefacing it with the echo command. It makes Terminal type out the command a second time, this time with a handy list of exactly what you're about to obliterate. If you've used wildcards, you see the names of the files that will be affected by the * character. If you type echo rm -r *, for example (which, without the echo part, would normally mean "delete everything in this directory"), you might see a list like this:

    rm -r Reviews.doc Tahoe Footage Picnic Movie Contract.doc

Once you've reviewed the list and approved what Terminal is about to do, then you can retype the command without the echo portion.

Note: The rm command doesn't work on file or directory names that begin with a hyphen (-). To delete these items from your working directory, preface their names with a dot slash (./), like this: rm ./-Recipes.doc.


online_help.html

16.4. Online Help

Mac OS X comes with over 1,200 Unix programs like the ones described in this chapter. How are you supposed to learn what they all do?

Fortunately, almost every Unix program comes with a help file. It may not appear within an elegant, gradient-gray Leopard window—in fact, it's pretty darned plain— but it offers much more material than the regular Mac Help Center.

These user-manual pages, or manpages, hold descriptions of virtually every command and program available. Mac OS X, in fact, comes with manpages on almost 9,000 topics—over 30,000 printed pages' worth.

Alas, manpages rarely have the clarity of writing or the learner-focused approach in the Mac Help Center. They're generally terse, just-the-facts descriptions. In fact, you'll probably find yourself needing to reread certain sections again and again. The information they contain, however, is invaluable to new and experienced Unix fans alike, and the effort spent mining them is usually worthwhile.

16.4.1. Using man

To access the manpage for a given command, type man followed by the name of the command you're researching. For example, to view the manpage for the ls command, enter: man ls.

Tip: The -k option flag lets you search by keyword. For example, man -k appletalk produces a list of all manpages that refer to AppleTalk, whereupon you can pick one of the names in the list and man that page name.

Now the manual appears, one screen at a time, as shown in Figure 16-7.

Figure 16-7. To move on to the next man screen, press the Space bar. To go back, press the up arrow key or the B key. To close the manual and return to a prompt, press Q. You can also search for a certain phrase by typing a / (to produce the "find what?" prompt); thereafter, type n to find the next occurrence.

A typical manpage begins with these sections:

  • Name. The name and a brief definition of the command.

  • Synopsis. Presents the syntax of the command, including all possible options and arguments, in a concise formula. For example, the synopsis for du (disk usage) is as follows: du [-H | -L | -P] [-I mask] [-a | -s | -d depth] [- [image]] [-h | -k] [-x] [file …].

    That line shows all the flags available for the du command and how to use them.

    Brackets ([ ]) surround the optional arguments. (All of the arguments for du are optional.)

    Vertical bars called pipes (|) indicate that you can use only one item (of the group separated by pipes) at a time. For example, when choosing options to use with du, you can use either -H, -L, or -P—not two or all three at once.

    The word file in the synopsis means "type a pathname here." The ellipsis (…) following it indicates that you're allowed to type more than one pathname.

  • Description. Explains in more detail what the command does and how it works. Often, the description includes the complete list of that command's option flags.

For more information on using man, view its own manpage by entering—what else?—man man.

Tip: The free program ManOpen, available for download at www.missingmanuals.com, is a Cocoa manual pages reader that provides a nice looking, easier-to-control window for reading manpages.Or why not just use Dashboard? Download the *NIX Manual widget (from this book's "Missing CD" page at www.missingmanuals.com, for example). It provides an equally attractive interface to the manpages.

16.4.2. Other Online Help

Sometimes Terminal shoves a little bit of user manual right under your nose—when it thinks you're having trouble. For example, if you use the mkdir command without specifying a pathname, mkdir interrupts the proceedings by displaying its own synopsis as a friendly reminder (subtext: "Um, this is how you're supposed to use me"), like this: usage: mkdir [-pv] [-m mode] directory…


terminal_preferences.html

16.5. Terminal Preferences

If you spend endless hours staring at the Terminal screen, as most Unix junkies do, you'll eventually be grateful for the preference settings that let you control how Terminal looks and acts. In fact, in Leopard's Terminal 2.0, you can manage your preferences in a whole new way.

Instead of having a single set of options saved (as with other applications), Terminal now manages your options as named settings groups, allowing you to quickly apply different settings to different windows at any time using the Inspector window (Shell rightwards double arrow Show Inspector).

You can also save the layout of entire groups of windows, each with their own settings in effect, into a single configuration, allowing you to recreate those layouts in an instant.

Configure your settings using Terminal's Preferences panel (Figure 16-8), which you get to by choosing Terminal rightwards double arrow Preferences (of all places).

16.5.1. Startup

The Startup tab lets you configure what Settings or Window group Terminal should use to open (in case you want something other than the default). This tab also gives you another way to switch from bash to a different default shell. (Where it says "Shells open with," choose "command (complete path)" and then type /bin/bash for bash, or /bin/tcsh for tcsh. New Terminal windows will then open with that shell.)

Figure 16-8. To access the Terminal Inspector, choose Terminal rightwards double arrow Show Inspector (or press -I). This window shows all of your Terminal saved settings. To apply any to an existing window, just select the window and then a setting.

16.5.2. Settings

This tab is the heart of Terminal's preferences management. On the left: a list of settings categories. On the right: the options for the currently selected category. Terminal comes with several preconfigured settings, and you can add and remove these and your own using the+and-buttons below the list. (To restore all the options for the prepackaged settings to their original state, select Restore Defaults from the [image] menu.)

To see your changes reflected instantly in a Terminal window, make sure the window you're watching is using the same setting that you are modifying.

16.5.2.1. Text

Here's where you control what the insertion point looks like, along with choices of fonts and colors.

Note: No matter what font you choose, typed characters align vertically. They appear monospaced as though they're all Monaco or Courier.
16.5.2.2. Window

  • Title. Turn on the elements that you'd like the current Terminal window to display in the title bar. Remember, your preferences can be different for each setting group; you might therefore want the windows' title bars to identify the differences.

  • WindowSize. The Dimensions boxes affect the width in characters (columns) and height in lines (rows) of new Terminal windows. (Of course, you can always resize an existing window by dragging its lower-right corner. As you drag, the title bar displays the window's current dimensions.)

  • Color. Not only can you set the background color, but you can set its opacity as well, making your Terminal windows translucent—a sure way to make novices fall to their knees in awe. Just drag the slider to the right and watch the background of the active window nearly disappear, like the Cheshire Cat, leaving only text.

    Tip: This effect looks especially cool if you make the Terminal window black with white or yellow writing.

  • Scrollback. As your command line activity fills the Terminal window with text, older lines at top disappear from view. So that you can get back to these previous lines for viewing, copying, or printing, Terminal offers a scrollback buffer, which sets aside a certain amount of memory—and adds a scroll bar—so that you can do so. The new Terminal stores the data in this buffer much more efficiently, so you should have no problem keeping this at its default unlimited setting. However, if you do get the crazy urge to display all 1.3 million lines from the manpages, you just might run out of memory if you don't set a limit.

Note: And how would you do that? By running this command, of course: find /usr/share/man/man* -name "*gz" -exec man -P cat /{} \;
16.5.2.3. Shell

  • Startup. Enter a command here (for example, cal -y), and each time you open a new window, you'll see its output and then get a new prompt. (If you just want the output without a new prompt, check "Run inside shell.")

  • When the shell exits. When you're finished fooling around in Terminal, you end your session either by closing the window, or more properly, by typing exit (or pressing Control-D) at the prompt. The "When the Shell Exits" setting determines what happens when you do that.

  • Prompt before closing. Shell commands can take some time to complete. In some cases, when you attempt to close a Terminal window before its work is finished, Terminal asks you if you're sure you want to cancel the process and lose your work. The options here let you configure when you want to be prompted, if ever, and even which processes you don't want Terminal to warn you about.

16.5.2.4. Keyboard

These controls let you choose keyboard shortcuts that help you navigate your Terminal window, or that send strings of canned text to the shell. As your Unix prowess grows, these shortcuts become more useful.

Tip: For some Unix geeks, the non-Unixy location of the Control key has been frustrating enough to keep them from using Macs. They use that key constantly, and would rather not have to rewire their brains to handle the changed location.But this problem is easily remedied. In System Preferences, in Keyboard & Mouse, the Modifier Keys button lets you swap the Control and Caps Lock keys' functions, allowing the confused pinkies of Unix-heads to once again find their way.

16.5.3. Window Groups

Once you've gone to town with Terminal settings, you might end up with a mosaic of windows spread across your display (or displays)—your main Terminal window, a couple of man (user-manual) windows, a top window showing all the running programs, and so on. You gotta love it: Each window has its own color scheme and title to reflect what it's doing, and all the windows are sized perfectly to contain their text output.

It would be a shame to lose all of that when you quit Terminal. Fortunately, you won't have to, thanks to Window Groups.

Choose Window rightwards double arrow Save Windows as Group and name the group. You'll be able to recreate your masterpiece when you return to Terminal by selecting that group name from Window rightwards double arrow Open Window Group. (Of course, your original output won't be there, but any commands you've configured to run at startup will display their new output.)

The Window Groups Preferences tab is just a place to view these groups and delete any you no longer need. Using the [image] pop-up menu, you can also export these groups as files to import into other machines (or other accounts).

16.5.4. Connect to Server

When you use Terminal to connect to other computers across a network—a common Terminal task—you use commands like ssh and ftp in conjunction with the other computer's name or IP address. For example, you might type ssh bertha.acmeco.com or ssh 192.168.43.76.

The trouble is, these IP names and addresses are hard to remember—and the numbers may change over time. To make connecting easier, Terminal can use the magic of Bonjour—a networking feature in which Macs announce their presence to the network, using their plain-English names. Bonjour lets you browse other Macs on your network just as you'd browse them in the Finder (Chapter 13).

To get started, choose File rightwards double arrow New Remote Connection. Continue as shown in Figure 16-9.

Tip: Even if the remote machine isn't running Bonjour, you can still add its address to the Server list manually by clicking the + button below it. Likewise, all command lines entered in the bottom field get added to the pop-up menu beside it, allowing you to quickly reconnect without having to browse at all.

Figure 16-9. From the left side, choose the service you want; from the right, you can choose from a list of machines whose Remote Login and FTP checkboxes are turned on in the Sharing panel of System Preferences. Type your account name into the User box. As you adjust the connection options, the box at the bottom shows the Unix command that you're building. Click Connect to open a new Terminal window and send that command inside it.


terminal_tips_and_tricks.html

16.6. Terminal Tips and Tricks

After you've used Terminal awhile, you may feel ready for a few of these power tips.

16.6.1. Switching Windows

You can switch among your various Terminal windows by pressing [image] -1, [image] -2, and so on (up to [image] -9). You'll be able to identify the windows easily if you choose to include the Command key in the title bars. (Use the Window section of the Settings Preference pane.)

16.6.2. Non-Contiguous Selection

You can select blobs of text, just as in Microsoft Word or TextEdit. To select a single rectangle of text anywhere in the window, Option-drag through it. To select multiple rectangles, [image] -drag. You can then copy and paste just those selected blobs.

16.6.3. Double-Clickable Unix Tools

Most people are used to thinking of Unix applications as programs you run from within Terminal. Many, though, appear in the Finder as regular old icons—and you can open them by double-clicking, just as you would a traditional Mac OS X program. This trick isn't very useful for commands that require flags. But for some, like cal, clicking provides a quick way to run the program, especially if you keep it in your Dock.

To double-click a Unix program, though, you first have to find it—and that may not be easy. Mac OS X's Unix directory structure is labyrinthine indeed.

But why not ask Terminal where the program is? You can do exactly that using the which command: which cal, for example. Terminal responds with /usr/bin/cal, telling you that cal resides in the /usr/bin directory.

To get there, use the open command in Terminal, like this: open /usr/bin. A window opens in the Finder; inside, you'll find the cal icon. Drag the icon to the right side of the Dock.

From now on, when you click that Dock icon, a new Terminal window opens, automatically displaying this month's calendar. You've shaved several precious seconds off the time it would have taken you to open iCal.


changing_permissions_with_terminal.html

16.7. Changing Permissions with Terminal

Permissions is a largely invisible, but hugely important, Mac OS X and Unix feature. The behind-the-scenes permissions setting for a file or folder determines whether or not you're allowed to open it, change it, or delete it. Permissions are the cornerstone of several important Mac OS X features, including the separation of user accounts and the relative invulnerability of the operating system itself.

POWER USERS' CLINIC
The Termination of .term Files?

The ability to save different sets of windows settings is actually nothing new to Terminal. In earlier versions, you could export a .term file that stored a window's (or window group's) settings. Opening the .term file opened a new window (or window group) with those settings.

In Terminal 2, you get easier management for these settings and a different way of storing them. Instead of using a separate file for each setting, Terminal now saves them all in the single com.apple.Terminal.plist file (in ~/Library/Preferences).

If you had any .term files in the standard location (~/Library/ Application Support/Terminal) when you first opened Leopard's Terminal, they still appeared in the Inspector—but Terminal no longer reads them.

Instead, upon Terminal's very first launch, those files' settings are copied into the new com.apple.Terminal.plist file. That's why, after the first time you open Terminal, adding additional .term files to ~/Library/Application Support/ Terminal doesn't make them appear in the Inspector. To do that, double-click the .term files in the Finder; Terminal imports them.

Double-clicking a .term file still opens a Terminal window using those settings. But if that's what you want, why be so passé? Instead, double-click the newer .terminal files you get by exporting either your window or window groups settings. You'll find the Export command on the [image] menu of both the Settings and Window Groups tabs of the Preferences panel.

As you know from Chapter 13, you can get a good look at the permissions settings for any file, folder, or disk by highlighting it and choosing File rightwards double arrow Get Info in the Finder. But even there, you're not seeing all of the permission settings Unix provides, and every now and then, you might want to. Suppose, for example, that you're ateacher in charge of a computer lab containing 25 Macs. On each computer, you've created Standard accounts (see Chapter 12) for five students, for a total of 125 student accounts.

Soon after the students start using the lab, you notice a bit more giggling and frantic typing than you'd expect from students researching Depression-era economics. You nonchalantly stroll to the end of the room and do a quick about-face at one of the desks. Aha—iChat! Horribly depressed by the comments you read there regarding your fashion sense, you vow to keep students from using that application ever again.

You have several options:

  • Delete iChat from the Applications folder. Unfortunately, the Computer Club meets in your classroom after school, and its members routinely use iChat to communicate. (Talking out loud, after all, is so 20th century.)

  • Use Parental Controls. You can open System Preferences, click Accounts, and click Parental Controls. You'd then click to configure Finder & System, select Some Limits, and turn off the iChat checkbox from the list of allowable applications. Repeat 124 times. (Though it is nice that Leopard now lets you do this remotely.)

  • Buy, install, and configure Mac OS X Server. Then you can create and configure workgroups with any permission settings you wanted. (Apple offers a four-day training course if you get stuck.)

  • Use Terminal. Go to a Mac, fire up Terminal, and type a quick command to turn off iChat's execute permissions for Standard account holders. (This process won't affect the Computer Club, because its members all have Administrator accounts.) Repeat only 24 times.

    In fact, if walking to each machine is too much work, you can even use the ssh technique described in Chapter 22 to run the command remotely from a single machine, while seated in the comfort of your own teacher's chair.

    This, of course, is by far the best solution. It'll take several pages to work through this example. But in the process, you'll learn an amazing amount about Terminal and the Unix underpinnings of Mac OS X.

Note: The original Unix permission system has been around longer than disco, and still serves well in Mac OS X. But Leopard introduces a secondary permission system to help make some of its new features work. These Access Control Lists (ACLs) provide much finer control of permissions, allowing you, for example, to assign multiple owners and groups to a single file. ACLs are also behind the file-sharing permissions described on Section 2.7.2.Not all files, or even most files on your Mac use ACLs. But when they're present, the ACL permissions override the file's Unix permissions. For details on ACLs, download this chapter's free appendix, "Access Control Lists," from this book's "Missing CD" page at www.missingmanuals.com.

16.7.1. Looking at Permissions

In general, when you double-click a file icon in the Finder, it opens either as a program or opens into a program (if it's a document).

But as noted on Section 5.1.3, most Mac OS X application icons in the Finder are really folders posing as single files. Inside the folder, or package, are all the files that application depends on to run, including the actual application file itself, the one that opens when you double-click the package icon. If you turn off the execute permission for that inner nugget, you prevent it from running—and, as in this classroom example, you can turn it off for certain kinds of account holders and not others.

To inspect the permissions for iChat, open the Applications folder. Control-click the iChat icon. From the shortcut menu, choose Show Package Contents. A new Finder window opens, revealing the contents of the iChat application package.

Open the Contents rightwards double arrow MacOS folder; inside you'll find the individual iChat program file. (Nobody would ever bother opening iChat by double-clicking this icon, but it's possible.) You could inspect its permissions by highlighting the inner iChat icon, choosing File rightwards double arrow Get Info, and then expanding the Sharing and Permissions section.

The Unix way is faster. In Terminal, just use the ls command like this:

    ls -l /Applications/iChat.app/Contents/MacOS

The -l flag produces a long list—an expanded display showing extra information about each item in the directory, in this case its single iChat file. Terminal's response is something like this:

    total 10616
    -rwxrwxr-x 1 root admin 5434128 Oct 3 23:27 iChat

Thanks to the -l option, the first line displays the grand total size of all the loose files in the directory: 10616. (It's measured in 512-byte blocks. If you also included the -k flag, you would see this measurement in kilobytes.)

Next you see the name of the one inhabitant of the MacOS directory: iChat. (If there were more, you would see each item on its own line.) But what is -rwxrwxr-x? Is Terminal having a meltdown?

Not at all; you're just seeing more Unix shorthand, listed in what are supposed to be helpful columns. Figure 16-10 breaks down the meaning of each clump of text.

  • Type. The first character of the line indicates the file type—usually d (a directory), l (a symbolic link—the Unix version of an alias), or, as in this case, a hyphen (a file).

  • File mode. Rammed together with the type (like this: rwxrwxr-x) is a string of nine characters. It indicates, in a coded format, the actual access permissions for that item, as described in the next section.

  • Owner. Terminal's response also identifies the account name of whoever owns this file or directory, which is usually whoever created it. Remember that root means that Mac OS X itself owns it. That's why even administrators generally aren't allowed to delete directories that bear "root" ownership.

    Note: In the Finder's Get Info windows, you may see ownership listed as System. That's Apple's kinder, gentler term for root.

  • Group. After the owner comes the name of the group that owns this file or directory. "Wheel," as in "big wheel, "indicates the group with the highest powers (administrators are not part of this group); the "admin" group contains all administrators.

  • Pathname. At the end of the line (following the file's size and date) comes the path of this file or directory, relative to the listed directory.

16.7.2. File-Mode Code

To understand the coded nine-character file-mode section, you need a good grasp of the topics covered in Chapter 13. There you'll find out that as you create new files and directories, you can specify who else is allowed to see or make changes to them. In fact, you can specify these permissions for three different categories of people: the owner (usually yourself), your group (Section 12.2.1.3), and everyone else.

The file-mode column is made of three subcolumns (Figure 16-10), which correspond to those same three categories of people: owner, group, and everybody else.

Within each sequence, three characters describe the read (r), write (w), and execute (x) permissions that this person or group has to this file or directory (more on these concepts in a moment). A hyphen (-) means, "Nope, this person isn't allowed this kind of access." In Figure 16-10, you can see that, if you were the owner of this file, you could do everything you want to it—because there are no hyphens.

Figure 16-10. If you look very closely and move your nose right up against the screen, you'll see that the file-mode column isn't just a string of random letters—it's three distinct sets of information that tell you who's allowed to do what.

There's an x in all other columns too, meaning that anyone can execute (launch) this file. Since there's also a w in both the owner and group columns, those user categories could, in theory, even make changes to the file (although there would never be a reason to do so).

The three forms of access—read, write, and execute—have slightly different meanings when applied to files and directories:

  • Read access to a file means that someone can open and read it. (In the case of a program like iChat, the system needs to "read" the file on your behalf in order to run it.) Read access to a directory (folder), on the other hand, just means that someone using Terminal can see a list of its contents using a command like ls.

  • Write access to a file means that someone can modify and save changes to it. Write access to a directory means that someone can add, remove, and rename any item the folder contains (but not necessarily the items within its subdirectories).

    Note: Turning off write access to a certain file doesn't protect it from deletion. As long as write access is turned on for the folder it's in, the file is still trashable.To protect a certain file from deletion, in other words, you must also worry about the access settings of the folder that encloses it.

  • Execute access, when applied to an application, means that people can run that particular program. (In fact, Unix distinguishes applications from ordinary files by checking the status of this setting.)

    Of course, you can't very well "run" a directory. If this x bit is turned on for a directory, it's called the searchable bit (as opposed to the execute access bit), and it means that you can make it the working directory, using the cd command. You still can't see what's in the folder if you don't also have read permissions, but you're welcome to read or copy a file in it as long as you know its full pathname.

16.7.3. Group Detective Work

Back to the task of keeping iChat from launching. The x in every user category tells you that anyone can run this program. Your mission, should you choose to accept it, is to change these settings so that one class of account holder can run iChat (Admin), but not another (Standard).

As you've seen, every file's set of permissions identifies both an owner and a group. The group that owns the iChat file is admin. As you would expect, the Admin class of users is part of the admin group, so administrators and anyone else in the admin group will have no trouble running the program.

You just have to make sure that no other account holders—Standard ones—are also part of the admin group. That's easy enough to find out.

To find out what Unix groups you belong to, type id in Terminal and press Enter. On the next line, Terminal types out a list of items beginning with your account name—that's your user id (your uid)—followed by the name of your primary group (your gid). Next are the names of all the groups that include your account. (The Mac refers to accounts and groups by number, which are listed here.) If you have an Administrator account, it's probably something like uid=501(chris) gid=20(staff) groups=20(staff),98(_lpadmin),81(_appserveradm),79(_appserverusr),102(com.apple.sharepoint.group.1),80(admin).

But you want to find what groups incorporate Standard account holders. To determine what groups someone else's account belongs to, type id casey (or whatever the account name is). You'll probably see that Casey doesn't belong to the admin group. And, in fact, that's true for all Standard account holders.

All right then: The admin group contains only Admin users. As far as permissions are concerned, then, Standard account holders fall into the everyone else category.

You just need to turn off iChat's execute permissions for everyone else, then, to complete your task. Doing so allows only the file's owner (root) and members of its group (admin) to execute the file (that is, to open the program). All other account holders, meaning Standard account holders, are out of luck. They'll actually have to pay attention in class.

16.7.4. chmod (Change Mode)

The Unix command for changing file modes (permissions) is chmod (for change mode). Here's the command you use on the iChat file:

    chmod o-x /Applications/iChat.app/Contents/MacOS/iChat

And here's how to understand it.

The command line begins, naturally, with the chmod command itself, and ends with the pathname of the iChat file.

In between are three characters that make up the three parts of a mode-change clause: o-x.

The first character, o, represents the class of user that the change affects. In this spot, you can type u to symbolize the file's owner, g for its group, o for other (everyone else), and a to indicate all three classes at once.

The second character represents the operation to perform, which in most cases is either to add a permission (use the + symbol) or remove one (use the – sign).

The final character specifies which permission to change: r for read, w for write, or x for execute.

The complete chmod command provided above, then, says, "Remove the execute permissions for others," which is precisely what you want to do.

16.7.5. Permission to Change Permissions

If you actually try the chmod command described above, however, you get only an error message ("Operation not permitted").

Only the owner of an item can change its permissions. And you're not iChat's owner; root is (that is, Mac OS X itself).

So how do you solve the problem? One solution would be to turn on the root account as described on Section 16.9, and then log on as root. But that's a hassle, and turning on the root account always entails a security risk.

Instead, you could always open the Get Info window for the iChat application file, make yourself the owner, and then type in your name and password to prove you're an administrator. Then open Terminal, use the chmod command now that you're the file's owner, return to the Finder, open Get Info again, and change the file's permissions back to root.

For a Unix guru, that's an awful lot of steps for something that should take only a few keystrokes. As it turns out, the final possibility is quick and easy, which explains its popularity in Unix circles. It's the sudo command.

16.7.5.1. sudo

sudo is a cool command name. Technically, it's short for superuser do, which means that you're allowed to execute any command as though you'd logged in with the root (superuser) account—but without actually having to turn on the root account, log out, log back in again, and so on.

It's also a great command name because it looks as though it would be pronounced "pseudo,"as in,"I'm just pretending to be the root user for a moment. I'm here under a pseudonym." (In fact, you pronounce it "SOO-doo," because it comes from super user do. In the privacy of your own brain, though, you can pronounce it however you like.)

Note: Only Administrator account holders can use the sudo command.

If you have the root account—or can simulate one using sudo—you can override any permissions settings, including the ones that prevent you from changing things in the Applications directory (like iChat).

Finally, you're ready to change the permissions of that infernal iChat application file. To use sudo, you must preface an entire command line with sudo and a space. Type this:

    sudo chmod o-x /Applications/iChat.app/Contents/MacOS/iChat

Taken slowly, this command breaks down as follows:

  • sudo. "Give me the power to do whatever I want."

  • chmod. "Change the file mode…"

  • o-x. "…in this way: remove execute permission for others…"

  • /Applications/iChat.app/Contents/MacOS/iChat."…from the file called iChat, which is inside the Applications rightwards double arrow iChat.app rightwards double arrow Contents rightwards double arrow MacOS folder."

The first time you run sudo, you're treated to the characteristic deadpan humor of programmers worldwide: "We trust you have received the usual lecture from the local System Administrator. It usually boils down to these three things: 1) Respect the privacy of others, and 2) Think before you type. 3) With great power comes great responsibility."

In other words, sudo is a powerful tool that lets you tromp unfettered across delicate parts of Mac OS X, so you should proceed with caution. At the outset, at least, you should use it only when you've been given specific steps to follow, as in this chapter.

Now sudo asks for your usual login password, just to confirm that you're not some seventh-grader up to no good. If you are indeed an administrator, and your password checks out, sudo gives you a five-minute window in which, by prefacing each command with sudo, you can move around as though you're the all-high, master root account holder. (If you don't use sudo again within a five-minute span, you have to input your password again.)

Now whenever anyone who isn't an administrator tries to open iChat, its icon bounces just once in the Dock before dying painlessly.

To restore its original permissions, use the same command, but replace the – with a +, like this:

    sudo chmod o+x /Applications/iChat.app/Contents/MacOS/iChat

Note: Whenever you run the Mac's Repair Permissions function (either automatically, which happens each time you install a Mac OS X update, or manually, using Disk Utility), iChat returns to its original permissions settings. You have to rerun the command if you want its protections in place.

16.7.6. Protecting Files En Masse

It could happen to you. You've got yourself a folder filled with hundreds of files— downloaded photos from your digital camera, for example. Most are pretty crummy, but the ones you took in Tahoe (and therefore have Tahoe in their file names) are spectacular. You want to protect those files from deletion without having to turn on the Locked checkbox (Section 2.6.4) of every file individually.

UP TO SPEED
Beware the Dread Typo

Use sudo with caution, especially with the rm command. Even a single typing error in a sudo rm command can be disastrous.

Suppose, for example, that you intended to type this:

sudo rm -ri /Users/Jim/Pictures

…but you accidentally inserted a space after the first slash, like this:

sudo rm -ri / Users/Jim/Pictures

You've just told Terminal to delete all data on all drives!

Because of the extra space, the rm command sees its first pathname argument as being only /, the root directory. The -r flag means "and all directories inside it."

Good thing you added the -i flag, which instructs Mac OS X to ask you for confirmation before deleting each directory. It's almost always a good idea to include -i whenever you use sudo with rm.

History buffs (and Unix fans) may remember that Apple's first iTunes 2 installer, released in October 2001, contained a tiny bug: the tendency to erase people's hard drives. (Oops!) Apple hastily withdrew the installer and replaced it with a fixed one. Behind the scenes, an improperly formed rm command was the culprit.

Here again, you could operate in the Finder, just like ordinary mortals. You could use Spotlight to round up all files with Tahoe in their names, highlight all of them in the search results window, choose File rightwards double arrow Get Info, and then turn on Locked for all of them at once. But doing it the Unix way builds character.

When you turn on a file's Locked checkbox, Mac OS X turns on an invisible switch known to Unix veterans as the user immutable flag. Not even the superuser is allowed to change, move, or delete a file whose user immutable flag is turned on.

The command you need to change such flags is chflags—short for change flags, of course. You can follow the chflags command with three arguments: its own option flags, the file flags, and the pathname of the file whose flags are being changed. In this case, the flag you care about is called uchg (short for user changeable; in other words, this is the immutable flag).

To protect all of the Tahoe shots in one fell swoop, then, here's what you'd type at the prompt:

    chflags uchg ~/Pictures/*Tahoe*

The asterisks are wildcards that mean "all files containing the word Tahoe in their names." So in English, you've just said, "Change the immutable flag (the Locked checkbox setting) for all the Tahoe files in my Pictures folder to 'locked.'"

Tip: To unlock a file, thus turning off its uchg flag, just add the prefix "no," like this: chflags nouchg ~/ Pictures/*Tahoe*.

To view the results of your handiwork right in Terminal, issue this command: ls -lO ~/Pictures (or any other path to a folder containing locked items). That's the familiar ls (list) command that shows you what's in a certain directory, followed by an -l flag for a more complete listing, and an -O flag that produces a "flags" column in the resulting table.

In any case, Terminal might spit out something like this:

    total 830064
    -rw-r—r—1 chris   chris  -      158280000  Jun 16 20:05 Sunset.jpg
    -rw-r—r—1 chris   chris  uchg   58560000   Jun 16 20:05 NewMoon.jpg
    -rw-r—r—1 chris   chris  uchg   107520000  Jun 16 20:05 Tahoe.jpg
    -rw-r—r—1 chris   chris  uchg   100560000  Jun 16 20:05 Buddy.jpg

The fourth column, the product of the -O flag, lists any file flags that have been set for each file. In this case, three of the files are listed with uchg, which represents the user immutable (locked) flag. (The hyphen for the first listed file means "no flags"— that is, not locked.)

16.7.7. Making Files Hide

Back at the school computer lab, you're still grumpy. The students leave piles of file and folder icons splattered across all the Macs' desktops, and you've had enough. Not only is it a sign of laziness and disorganization, but the icons cover the desktop picture of the hallowed school mascot: the red-backed toad eater.

You've warned them enough, and now it's time for action: no World of Warcraft at lunchtime unless the desktops are clean in 15 minutes!

As you finish writing the new rule on the whiteboard, you turn to face the students' Mac screens—and you're stunned. The full, uncluttered image of your beloved marsupial gazes back from the Macs' displays; the offending icons are gone. How could that be? There hasn't even been time for the students to select all the icons and drag them to the Trash!

Apparently the students weren't as lazy as you thought: They've been learning the Way of the Terminal. What they actually did was sweep all those icons under the rug, Unix style, with this command:

    chflags hidden ~/Desktop/*

They manipulated another file flag, called the hidden flag, which is new to Leopard. The command turns on the hidden flag for all files (indicated by the asterisk) in the Desktop folder—and so their icons disappear. The actual file is still there; but you just can't see it in the Finder anymore.

Of course, you're not about to let some punk kids pull one over on you. In your copy of Terminal, you deftly type chflags nohidden ~/Desktop/* to bring the icons back.

The students have 13 minutes left to really clean their desktops.


_useful_unix_utilities.html

16.8. 20 Useful Unix Utilities

So far, you've read about only a handful of the hundreds of Unix programs that are built into Mac OS X and ready to run. Yes, ls and sudo are very useful tools, but they're only the beginning. As you peruse beginner-level Unix books and Web sites (see Appendix E), for example, you'll gradually become familiar with a few more important terms and tools.

Here's a rundown of some more cool (and very safe) programs that await your experimentation.

Tip: If you don't return to the $ prompt after using one of these commands, type q or, in some cases, quit, and then hit Enter.

16.8.1. 20 Useful Unix Utilities

16.8.1.1. bc

Mac OS X and Windows aren't the only operating systems that come with a basic calculator accessory; Unix is well equipped in this regard, too.

When you type bc and hit Enter, you get a copyright notice and then…nothing. Just type the equation you want to solve, such as 2+2, or 95+97+456+2-65,or (2*3)+16595*(2.5*2.5), and then press Enter. On the next line, bc instantly displays the result of your calculation.

(In computer land, * designates multiplication and / represents division. Note, too, that bc solves equations correctly; it calculates multiplication and division before addition and subtraction, and inner parentheses before the outer ones. For more bc tricks and tips, type man bc at the prompt.)

16.8.1.2. kill

Mac OS X offers no shortage of ways to cut the cord on a program that seems to be locked up or runnning amok. You can force quit it, use Activity Monitor, or use kill.

The kill program in Terminal simply force quits a program, as though by remote control. (It even works when you SSH into your Mac from a remote location, as described in Chapter 22.) All you have to do is follow the kill command with the ID number of the program you want to terminate.

And how do you know its ID number? You start by running top—described in a moment—whose first column shows the PID (process ID) of every running program.

Tip: Unless you also use sudo, you can kill only programs that you "own"—those that are running under your account. (The operating system itself—root—is always running programs of its own, and it's technically possible that other people, dialing in from the road, are running programs of their own even while you're using the Mac!)

When you hear Unix fans talk about kill online, they often indicate a number flag after the command, like this: kill -9. This flag is a "noncatchable, non-ignorable kill." In other words, it's an industrial-strength assassin that accepts no pleas for mercy from the program you're killing.

If you check top and find out that BeeKeeper Pro's process ID is 753, you'd abort it by typing kill -9 753 and then pressing Enter.

16.8.1.3. open

What operating system would be complete without a way to launch programs? In Mac OS X's version of Unix, the command is easy enough: open -a, as in open -a Chess. The -a flag allows you to specify an application by name, regardless of where it is on your hard drive, exactly the way Spotlight does it. You can even specify which document you want to open into that program like this: open -a Preview FunnyPhotoOfCasey.tif.

Tip: The -e flag opens any text document in TextEdit (or whatever your default text editor may be), like this: open -e Diary.txt. This shortcut saves you from having to specify TextEdit itself.

The real utility of this command might not be apparent at first, but imagine doing something like this in the Finder: Select from a folder of hundreds of HTML files those that contain the word "Sequoia" in their file names and preview them all withthe OmniWeb browser, regardless of what application they're actually associated with. You could do it with the help of the Spotlight command, but that would take quite a few steps. In Terminal, though, you just switch to that directory (using the cd command) and type open -a OmniWeb *Sequoia*. Done!

Of course, you may not often bother simply launching programs and documents this way. Nevertheless you can see how useful open can be when you're writing automated scripts for your Mac, like those used by the launchd command scheduler program (Section 16.8.5.4).

16.8.1.4. ps

The ps (process status)command is another way to get a quick look at all the programs running on your Mac, even the usually invisible ones, complete with their ID numbers. (For the most helpful results, use the -a, -u, -x, and -w flags like this: ps -auxw. For a complete description of these and other flags, type man ps and hit Enter.)

16.8.1.5. shutdown

It's perfectly easy to shut down your Mac from the [image] menu. But using shutdown with its -h flag (for halt) in Terminal has its advantages. For one thing, you can control when the shutdown occurs, using one of these three options:

  • Now. You can safely shut down by typing shutdown -h now. (Actually, only the root user is allowed to use shutdown, so you'd really type sudo shutdown now and then type in your administrator's password when asked.)

  • Later today. Specify a time instead of now. Typing sudo shutdown -h 2330, for example, shuts down your machine at 11:30 p.m. today (2330 is military time notation for 11:30 p.m.).

  • Any time in the next 100 years. To make the machine shut down at 5:00 p.m. on April 3, 2008, for example, you could type sudo shutdown -h 0804031700.(That number code is in year [last two digits]:month:date:hour:minute format.)

Tip: Once you set the auto-shutdown robot in motion, you can't stop it easily. You must use the kill command described earlier to terminate the shutdown process itself. To find out shutdown's ID number in order to terminate it, look for the pid number in the output of the shutdown command, or use the top or ps command.

There are still more useful flags. For example:

  • Using the -r flag instead of -h means "restart instead of just shutting down," as in sudo shutdown -r now.

  • You can use shutdown to knock all connected network users off your machine without actually shutting down. Use the -k flag, like this: sudo shutdown -k now.

One of the most powerful uses of shutdown is turning off Macs by remote control, either from across the network or across the world via Internet. That is, you can use SSH (described in Chapter 22) to issue this command.

16.8.1.6. tar, gzip, zip

You know how Mac OS X 10.5 can create compressed .zip archive files? (If not, check Section 5.12.)

Terminal lets you stuff and combine files in these formats with the greatest of ease. To compress a file, just type gzip, a space, and then the pathname of the file you want to compress (or drag the file directly from the desktop into the Terminal window). When you press Enter or Return, Mac OS X compresses the file.

"Tarring" a folder (combining its contents into a single file—a tarball, as Unix hepcats call it) is only slightly more complicated. You have to specify the resulting file's name, followed by the actual directory pathname, like this: tar -cf Memos.tar /Users/chris/ Memos. Add the -z flag if you want to tar and compress the folder: tar -czf Memos. tar.gz /Users/chris/Memos.

To combine and compress files using zip, just specify a name for the zip file and the names of the items to zip, like this: zip StaffordLake.zip Stafford* (which would cram all files in the working directory whose name begins with Stafford into a single archive).

To zip a folder, include the -r flag as well: zip -r Memos /Users/chris/Memos.

In any case, if you switch to the Finder, you see that the file or folder you specified is now compressed (with the suffix .gz), combined (with the suffix .tar), or both (with the suffix tar.gz or .zip).

Unfortunately, the command line zip utility doesn't handle extended attributes properly (see the next page), so stick with tar and gzip if you want to create guaranteed Mac-friendly archives. The best format is a gzipped tarball, which the Finder will properly open with a double-click. (If you only gzip a file without tarring, the Finder won't preserve any resource forks when opening it.) You can also use these utilities to open combined and compressed files, but they can easily overwrite existing items of the same name if you're not careful. Use the Finder or Stuff It Expander to eliminate that worry.

Note: The gzip command deletes the original file after gzipping it. The tar and zip commands, on the other hand, "stuff" things but leave the originals alone.

16.8.2. top (table of processes)

When you type top and press Enter, you get a handy table that lists every program that's currently running on your Mac, including the obscure background ones you may not even know exist (Figure 16-11).

You also get statistics that tell you how much memory and speed (CPU power) they're sucking down. In this regard, top is similar to Activity Monitor, described on Section 6.4.

Tip: If you type top -u, you get a list sorted by CPU usage, meaning the power-hungry programs are listed first. If your Mac ever seems to act sluggish, checking top -u to see what's tying things up is a good instinct.

Figure 16-11. The top display remains onscreen, automatically updating itself as you work, until you type q to quit the program. The plain-English program names are in there somewhere.

16.8.3. xattr (extended attributes)

The xattr command lets you see and manage the extended attributes (AEs) of your files—the invisible metadata (Section 3.1.2.3) that describes all kinds of characteristics of every file, from the exposure of a digital camera shot to the tempo of a song in iTunes. (Chapter 3 has much more on metadata and searching for it.)

Running xattr * lists any AEs in your working directory. If you ran it in your ~/ Downloads folder, the command might look like this:

    MacChris:Downloads chris$ xattr *
    NeoOffice-2.2.2-Intel.dmg: com.apple.FinderInfo
    NeoOffice-2.2.2-Intel.dmg: com.apple.quarantine
    ServerAdminTools10.5.dmg: com.apple.FinderInfo
    ServerAdminTools10.5.dmg: com.apple.quarantine
    TextWrangler_2.2.1.dmg: com.apple.FinderInfo
    TextWrangler_2.2.1.dmg: com.apple.quarantine
    inrainbows.zip: com.apple.quarantine

Only four files are listed, but each of their AEs gets its own line. What you'll find in common to all of these files is that they hold a "com.apple.quarantine" AE.

You know how, the first time you open a program on your Mac, you get the dialog box shown in Figure 12-16 (Section 12.9.1)? Now you know how the Mac knows that this is the first time you ran it: That detail was stored as one of its extended attributes.

If you really can't stand those messages, you could prevent the nag box from appearing with another Unix command. For example, if you've just installed NeoOffice, you could simply remove the quarantine AE using the xattr command's -d flag, like this:

    xattr -d com.apple.quarantine NeoOffice-2.2.2-Intel.dmg

You can also use the ls command to see AEs. When you use just the -l flag with ls,files with AEs show an @ sign at the end of the permission codes:

    MacChris: Downloads chris$ ls -l
    total 523800
    -rw-r--r--@ 1 chris staff 140825264 Oct 29 14:52 NeoOffice-
    2.2.2-Intel.dmg

To see what those AEs are, add the @ flag:

    MacChris:Downloads chris$ ls -l@
    total 523800
    -rw-r--r--@ 1 chris   staff 140825264 Oct 29 14:52 NeoOffice-
    2.2.2-Intel.dmg
            com.apple.quarantine       42

16.8.4. Aliases

Aliases in Unix have nothing to do with traditional Macintosh icon aliases. Instead, Unix aliases are more like text macros, in that they're longish commands that you can trigger by typing a much shorter abbreviation.

For example, remember the command for unlocking all the files in a folder? (It was sudo chflags -R nouchg [pathname]. To unlock everything in your account's Trash, for example, you'd type sudo chflags -R nouchg ~/.trash.)

Using the alias command, however, you can create a much shorter command (unlock, for example) that has the same effect. (The alias command takes two arguments: the alias name you want, and the command it's supposed to type out, like this: alias unlock='sudo chflags -R nouchg ~/.trash'.)

The downside is that aliases you create this way linger in Terminal's memory only while you're still in the original Terminal window. As soon as you close it, you lose your aliases. When you get better at Unix, therefore, you can learn to create a .bash_profile file that permanently stores all your command aliases.(Hint:Open or create a file called .bash_profile in your home directory, and add to it one alias command per line.)

16.8.5. nano, emacs, vim

One way to create and edit text files containing aliases (and to perform other command related tasks) is to use nano, a popular text editor that's an improved version of the pico editor (see Figure 16-12). In fact, if you try to run pico, nano opens instead.

As you'll discover just by typing nano and pressing Enter, nano is a full-screen Unix application. You enter text in nano much as you do in TextEdit, yet nano is filled with features that are especially tailored to working with Unix tasks and commands.

Nor is nano the only text editor that's built into the Unix under Mac OS X. Some Unix fans prefer the more powerful and complex vim or emacs, in the same way that some people prefer Microsoft Word to TextEdit.

Figure 16-12. A new nano session. One key difference between nano and, say, TextEdit: To scroll, you must use the up and down arrow keys, or the Prev Pg and Next Pg commands—not the Terminal scroll bar.

16.8.5.1. date

Used all by itself, the date command simply displays the current date and time. However, you can use its long list of date "conversion specifications" (enter man date to see all of them) to format the date string in any conceivable way. Begin the string with a + and then enter the formatting you like, mixing in any regular text as well, like this:

    office-mac:~ chris$ date +"I can't believe it's already week %V
    of %Y, here in the %Z time zone. But what do you expect on a %A
    at %l:%M %p?"
    I can't believe it's already week 26 of 2008, here in the PST
    time zone. But what do you expect on a Tuesday at 11:26 AM?

Note: Be careful about using date with sudo. If you do, and accidentally forget the leading +, you reset your Mac's built-in clock.
16.8.5.2. grep

The grep program is a filter, a powerful program designed to search data for text that matches a specified pattern. It can pass on the processed result to another program, file, or the command line itself.

You specify the text pattern you want grep to search using a notation called regular expressions. For example, the regular expression dis[ck] searches for either disk or disc. Another example: To search for lines in a file containing the addresses from 200 to 299 Redwood Way, you could tell grep that you're looking for "\<2[0-9][0-9] Redwood Way".

One terrific thing about grep is that its search material can be part of any file, especially plain text files. The text files on your Mac include HTML files, log files, and—possibly juiciest of all—your email mailbox files. Using grep, for example, you could search all your Mail files for messages matching certain criteria, with great efficiency and even finer control than with Spotlight.

16.8.5.3. find

Now that Spotlight's on the scene, you might wonder why you would need to use the Unix find command. Well, for one, find takes file searching to a whole new level. For example, you can find files based on their permissions, owner name, flag settings, and of course any kind of name pattern you can think of using regular expressions.

Also, like with most other Unix commands, you can "pipe" the find command's list of found files straight into another program for further processing. You might do this to change their names, convert them to other formats, or even upload them to a network server.

Perhaps best of all, since you can run find with sudo, you can look for files existing anywhere on your hard disk, regardless of directory permission settings.

GEM IN THE ROUGH
Eliza, I Have Issues with My Mother

Therapy, whether it's about your frustrations with your Mac or any other subject, is expensive. Still, it feels good to talk to someone about whatever's bother-ing you—and Mac OS X is ready to listen.

Hidden in the emacs text-editing program is a fully unlicensed automated psychoanalyst named Eliza. To enter her office, open Terminal, type emacs and press Enter. After the introductory screen has appeared, press Shift-Esc, type xdoctor, and then press Enter.

"I am the psychothera-pist," Eliza begins. "Please, describe your problems. Each time you are finished talking, type RET twice." (She means, "Press the Return key twice.")

As you can see from this illustration, she isn't exactly Sigmund Freud. But she's very entertaining, and surprisingly responsive.

When your session is finished, press Control-X and then Control-C to exit Eliza and emacs.

To find all the files in your Home directory with "Bolinas" in their names, for example, you would use this command:

    find ~/ -name '*Bolinas*'

Or, to ignore capitalization:

    find ~/ -iname '*Bolinas*'

And this command searches for all the locked files in your Home directory:

    find ~/ -flags uchg

16.8.5.4. mdfind

If you have a place in your heart for Spotlight, you'll be happy to see the mdfind command in Terminal. It performs the same kinds of searches, finding by metadata like music genre or exposure data for photos.

To find all reggae songs, for example, try:

mdfind 'kMDItemMusicalGenre == "Reggae"'

To find all photos you shot with the flash on:

    mdfind 'kMDItemFlashOnOff == "1"'

The mdls command reveals all of the metadata for a particular file, like the IMG_3033. jpg picture in this example:

    ongaku:Photos$ mdls IMG_3033.JPG
    kMDItemAcquisitionMake         = "Canon"
    kMDItemAcquisitionModel        = "Canon PowerShot S3 IS"
    kMDItemAperture                = 4.65625
    kMDItemBitsPerSample           = 32
    kMDItemColorSpace              = "RGB"
    kMDItemContentCreationDate     = 2007-06-30 14:51:07 -0700
    kMDItemContentModificationDate = 2007-06-30 14:51:07 -0700
    kMDItemContentType             = "public.jpeg"

You can find more about constructing your queries here: http://developer.apple.com/ documentation/Carbon/Conceptual/SpotlightQuery/Concepts/QueryFormat.html.com

16.8.5.5. launchd

launchd is a multitalented Unix program that's responsible for launching system programs, during startup or any time thereafter. Part of its job is triggering certain commands according to a specified schedule, even when you're not logged in. People can use launchd to trigger daily backups or monthly maintenance, for example. You can program your unattended software robot by editing simple property list files.

Mac OS X comes set up to run launchd automatically; it's the very first process that starts up when the Mac does. It launches all your other startup items, in fact. (If you open the Activity Monitor program in your Applications rightwards double arrow Utilities folder, you'll see it listed among the administrator processes that your Mac is running all the time.)

In fact, launchd comes with three under-the-hood Unix maintenance tasks already scheduled: a daily job, a weekly job, and a monthly job. They come set to run at 3:15 a.m. (the first two), and 5:30 a.m. If your Mac isn't generally turned on in the middle of the night, these healthy jobs may never run.

You can either leave your Mac on overnight every now and then or, if you're feeling ambitious, change the time for them to be run. A glance at man launchd.plist shows you how. (Hint: It involves using sudo nano and editing the three com.apple.periodic property list files in /System/Library/LaunchDaemons—but be careful not to mess with anything else in there!)

Note: Some other Unix systems (and versions of Mac OS X) use the cron utility to run these jobs. cron also exists on Leopard and will start working as it does elsewhere—the minute you add a new cron job. See the cron and crontab manpages for details.
16.8.5.6. ftp

FTP (and its relative, telnet) aren't exclusively Unix programs, of course. Techies from all walks of operating-system life have used telnet for years whenever they want to tap into another computer from afar, and FTP to deliver and download software files. Details on FTP are in Chapter 22.

POWER USERS' CLINICSecrets of Virtual Memory

The top command's table offers a fascinating look at the way Mac OS X manages memory. In the "VM" section, for example, you'll see current statistics for pageins and pageouts—that is, how many times the virtual-memory system has had to "set down" software code for a moment as it juggles your open programs in actual memory. (These numbers are pointed out in Figure 16-11.)

The pageins and pageouts statistics are composed of two different numbers, like this: 45451(0) pageins, 42946(0) pageouts. The big number tells you how many times your Mac has had to shuffle data in and out of memory since the Mac started up. The number in parentheses indicates how much of this shuffling it's done within the last second.

The pageouts value is the number to worry about. If it stays above zero for a while, your Mac is gasping for RAM (as the hard drive thrashing sounds and program-switching delays are probably also telling you).

In the listing of individual programs, the last four columns provide details about the memory usage of each listed program. The one you care about is the RPRVT (Resident Private) column, which shows how much memory each program is actually using at the moment. This number goes up and down as you work, illustrating the miracle of Mac OS X: Programs don't just grab a chunk of memory and sit with it. They put RAM back in the pot when they don't need it.


putting_it_together.html

16.9. Putting It Together

All of the Unix syntax and vocabulary presented in this chapter is all well and good, and it'll give you the rosy glow of having mastered something new. But it still doesn't entirely explain why Unix gives programmers sweaty palms and dilated pupils.

The real power of Unix comes down the road—when you start stringing these commands together.

Suppose, for example, you want to round up all the TIFF image files related to your Yosemite project, scale them to a common size, convert them to JPEG files, and copy them to an FTP site. How would you go about it?

You could, of course, use Spotlight to search for all TIFF files that have "Yosemite" in their names. But what if your images were named otherwise but kept in folders with Yosemite in their names? You would have to find those folders first, and then the TIFF files within them.

You could perform the next step (scaling and converting the image) either manually or by a preprogrammed script or Automator workflow, using a program like Photoshop or even iPhoto. Once the images were all done, you'd need to collect them and then use your favorite FTP program to upload them to the server.

If you've mastered Unix, though, you could shave 12 minutes off of your workday just by changing to an empty working directory (in this example, ~/Stage) and typing this as one long line:

    find ~ -type f -ipath '*yosemite*tif' -print0 | xargs -0 sips
    -Z 250 -s format jpeg --out ~/Stage && ftp -u ftp://ftp.coast
    photo.com/Incoming *

Even after almost 50 pages of Unix basics, that mass of commands probably looks a tad intimidating. And, indeed, if you've never programmed before, even the following breakdown may make your eyes glaze over. Nevertheless, pieces of it should now look familiar:

  • find ~ -type f-ipath '*yosemite*tif' -print0 |. This segment searches your Home directory (~) for files (-type f) whose pathnames (-ipath, meaning "capitalization doesn't matter") contain the word Yosemite and end in tif. Remember, the asterisks here are wildcard characters, which stand for "any number of characters." The command so far makes a list of all matching files, which it keeps in its little head.

    The -print0 command formats this list of found files' pathnames, separating them with the null character (a special character that programmers use to indicate where one string of text ends and another begins) instead of the usual spaces. It lets the command work with pathnames that contain spaces, a common occurrence on Macs (but a rarity in Unix). You'll see how it does this shortly.

    Then comes the pipe (the vertical bar), which you can use to direct the results (output) of one command into the input of another. In this case, it sends the list of found pathnames on to the next command.

  • xargs -0 sips -z 250 -s format jpeg --out ~/Stage &&.xargs is an argument builder. In this case, it builds an argument from the list of files it received from the find command and provides it to sips for processing. In other words, xargs hands a list of files to sips, and sips runs the same command on each one.

    The -0 flag tells xargs that the pathnames are separated by the null character. (Otherwise,xargs would separate pathnames at each space character, which would choke sips.)

    For each file it gets, sips first scales the image's largest dimension to 250 pixels, and its other dimension proportionally. (That way, any image will fit into a 250 x 250-pixel box on a Web page, for example.)

    sips then sets the format (-s format) of the image to JPEG and saves it, with the correct .jpg extension, in the ~/Stage directory.

    The double ampersands (&&) at the end of this fragment tell the shell to run the next command only when it's successfully finished with the previous one. (If it fails, the whole thing stops here.) So, once sips is done with each file it gets from xargs, the shell moves on to this:

  • ftp-uftp://ftp.coast-photo.com/Incoming*. The ftp utility included with Leopard can work a lot like curl in the way it can upload and download files with a single command. In this case, the command uploads (-u) every file from the working directory (as specified by the asterisk—that is, all of the sips-processed files) to the Incoming directory of the coast-photo.com FTP site.

    GEM IN THE ROUGH
    The Famous Animated-Desktop Trick

    It was one of the first great Mac OS X hacks to be passed around the Internet: the classic "screen-saver-on-the-desk-top" trick. In this scheme, your desktop shows more than some wussy, motionless desktop picture. It actually displays one of the Screen Effects animation modules.

    Start by choosing the screen saver module you prefer, using the Screen Effects panel of System Preferences. (The one called "flurry" makes a good choice.)

    Then, in Terminal, type: /System/Library/Frameworks/Screen Saver.framework/Resources/ScreenSaverEngine.app/ Contents/MacOS/ScreenSaverEngine -background &

    Finally, press Enter. (Note that there are no spaces or Returns in the command, even though it appears broken onto more than one line here.)

    Presto: The active screen saver becomes your desktop picture! Fall back into your chair in astonishment.

    Once you've regained your composure, look in the Terminal window again. The number that follows the [1] in the following line is the process ID of your background desktop program.

    You'll need that number when it comes time to turn off the effect, which is a good idea, since the desktop/screen saver business drains a massive amount of your Mac's processing power. The whole thing is a gimmicky showoff stunt you'll generally want to turn off before conducting any meaningful work.

    To turn off this effect, type kill 496 (or whatever the process ID is), and then press Enter.

    And if you get tired of typing out that long command, download xBack from www.gideonsoftworks.com/xback.html. It's a simple piece of shareware that lets you turn this effect, plus many additional options, on and off with the click of a mouse.

Note: As written, this command works only if you don't need a password to get into the FTP site. Otherwise, build your FTP account name and password into its address like this: ftp://chris:password@ftp.coast-photo.com/Incoming.

When you press Return or Enter after this gigantic command, Mac OS X scans all the directories inside your Home directory, rounds up all the Yosemite-related images, scales them, converts and renames them, and then uploads each to the FTP directory.

Once you've gained some experience with Unix commands and programs like these, you'll find it fairly easy to adapt them to your own tasks. For example, here's a more versatile command that searches a directory called Projects for all TIFF files modified after 6:00 that morning, converts them to thumbnail-sized JPEGs, and then plops them into the images directory of your FTP-accessible Web server:

POWER USERS' CLINIC
X11

If you've ever poked around in your /Applications/Utilities folder, you might have spotted the program called X11.

No, it's not the codename of a top-secret project Apple forgot to remove before shipping Leopard. X11 is another name for the X Window System, a GUI that came to being on Unix systems at about the same time the Macintosh was introduced. ("GUI" stands for graphic user interface, and it means "icons, windows, and menus like you're used to—not typing commands at a prompt.")

More importantly, X11 allows your Mac to run many of the Unix GUI applications, both free and commercial, that have become available over the years.

Getting X11 to work right with Mac OS X used to require some fiddling. But in Leopard, you can run it without much fuss. X11 comes with several "X" programs, which are found in /usr/X11/bin. Your shell knows about this directory, and Terminal knows about X11, so you can run these applications like any other command.

To launch the X11 clock, for example, start in Terminal. Type xclock and press Enter. After a moment, the X11 icon appears in your Dock–and a small clock window appears beside your other windows, just like any normal program.

(As you'll discover, X11 programs are more visually pleasing than Unix code. But they have not, ahem, been designed by Steve Jobs.)

To stop the X application, you can close its window, or press Control-C in Terminal. (No new prompt appears while the X application is running.)

Many other X applications come with Leopard; in Terminal, type ls /usr/X11/bin to list them. Some interesting ones to try are xterm, xcalc, glxgears, and xman. You can even add more X applications by downloading and compiling source code (a daunting task for anyone new to Unix), or through a "ports" system like MacPorts (www.macports.org), which provides software packages "ported" to Mac OS X for easier installation.

    cd ~/Stage && find ~/Projects -type f -iname *tif -newermt 6:00
    -print0 | xargs -0 sips -Z 128 -s format jpeg --out ~/Stage &&
    ftp -u ftp://carlos:birdie@ftp.coast-photo.com/htdocs/images *
    && mv * ~/Backup/

Tip: You don't have to type out that entire command line every time you need it; you can save the whole thing as a .command file on your desktop that runs the command when double-clicked.First, create a new plain text document; you can use TextEdit. Type in the entire command that you want to memorialize. Save the document with a name ending with .command—for example, ProcessImages.command. (Documents with this extension appear with a spiffy icon in the Finder.)Next, make that file itself executable by using the chmodxs command. If, for example, you want only the owner of the ProcessImages.command file, you would type: chmod u+x ProcessImages.command.

With just a few more keystrokes, you could modify that command to collect some files, lock them, and place copies of each in every account holder's Home directory, as well as several different servers at the same time. What's more, it emails you a report when it's done. Using launchd, you could even configure this routine to trigger itself

POWER USERS' CLINIC
The Root Account

Standard, Administrator, Managed, Sharing Only, and Guest aren't the only kinds of accounts. There's one more, one that wields ultimate power, one person who can do anything to any file anywhere. This person is called the superuser.

Unix fans speak of the superuser account—also called the root account—in hushed tones, because it offers absolutely unrestricted power. The root account holder can move, delete, rename, or otherwise mangle any file on the machine, no matter what folder it's in. One wrong move—or one malicious hacker who manages to seize the root account—and you've got yourself a $2,000 doorstop. That's why Mac OS X's root account is completely hidden.

Truth is, you can enjoy most rootlike powers without actually turning on the root account. Here are some of the things the root account holder can do—and the ways you can do them without ducking into a phone booth to become the superuser:

See crucial system files that are ordinarily invisible.Of course, you can also see them easily by using the free-ware program TinkerTool (Section 17.1). You can also use the Terminal program described in this chapter.

Peek into other account holders' folders (or even trash them).You don't have to be the superuser to do this—you just have to be an administrator who's smart enough to use the Get Info command, as described on Section 2.7.2.

Use powerful Unix system commands.Some of the Unix commands you can issue in Mac OS X require superuser powers. As noted in this chapter, however, there's a simple command—the sudo command—that grants you root powers without you actually having to log into the root account. Details on Section 16.7.5.1.

Using the sudo command is faster, easier, and more secure than using the root account. It doesn't present the risk that you'll walk away from your Mac while logged in as the root user, thereby opening yourself up to complete annihilation from a passing evildoer (in person or over the Internet).

But if you're a Unix geek, and you want to poke around the lowest levels of the operating system, or you're in a time of crisis, and you really, really need to log in with the root account, see the free downloadable appendix to this chapter ("Enabling the Root Account"). It's available on this book's "Missing CD" page at www.missingmanuals.com.

automatically every day at 11:00 p.m. Considering the hundreds of Unix programs included with Mac OS X and the thousands of others available on the Internet, the possibilities are limitless.

For some guidance in picking up your Unix career from here, see Appendix E.


hacking_mac_os_x.html

Chapter 17. Hacking Mac OS X

Section 4.5.1 shows you how to customize your desktop picture, error beep, and screen saver. But if you're sneaky, creative, or just different, you can perform more dramatic visual and behavioral surgery on your copy of Mac OS X—from changing the start up screen image to replacing the "poof" that appears when you drag something off the Dock with a new animation of your own. All you need is a few of Mac OS X's less obvious tools, or some free downloadable customizing software, and a few recipes like the ones in this chapter.

Some of these tricks are frivolous. Some are functional and useful. And although Apple sanctions not a one, all are perfectly safe.

17.1. TinkerTool: Customization 101

If you poke around the Mac OS X Web sites and news groups long enough, you'll find little bits of Unix code being passed around. One of them purports to let you change the genie animation that you see when you minimize a window to the Dock. Another eliminates the drop shadow behind icon names on your desktop. Yet another lets you change the transparency of the Terminal window (Chapter 16)—a cool, although not especially practical, effect.

If you really want to fool around with these bits of Unix code, go for it. You can find most of these tidbits at Web sites like www.macosxhints.com.

But the truth is, there's no good reason for you to subject yourself to the painstaking effort of typing out Unix commands when easy-to-use, push-button programs are available to do the same thing.

TinkerTool, for example, is a free utility that offers an amazing degree of control over the fonts, desktop, Dock, scroll bar arrows, and other aspects of the Mac OS X environment.

Here are some of the highlights:

  • Kill the animations. When you open any icon, expand a Get Info panel, and so on, you see little animated expansion effects. It's nice, but it takes time. TinkerTool can turn them off (see Figure 17-1).

    Figure 17-1. TinkerTool is a doubleclickable program that makes changes only to your account settings. (Mercifully, it's free. You can get it from this book's "Missing CD" page at www.missingmanuals.com.)

  • Dock. TinkerTool lets you give hidden programs transparent icons on the Dock and specify the Dock's position on the screen—left, right, bottom, or top—and even whether it's centered or flush against one corner. TinkerTool also unlocks a third option for the animation of windows collapsing onto the Dock. In addition to the standard Mac OS X choices (Genie and Scale), you also get something called Suck In (no comment).

    Tip: TinkerTool can even turn off the glassy, 3-D look of the Leopard Dock, which isn't universally adored.

  • Scroll bars. TinkerTool gives you greater control over the placement of Mac OS X's scroll bar arrows—together at one end of the scroll bar, duplicated at both ends of the scroll bar, and so on.

  • Visibility. TinkerTool can make the thousands of invisible Unix files appear as full-blooded icons. (Power users, you know who you are.)

  • Fonts. Tinker Tool lets you change the fonts for dialog boxes, menus, title bars, help balloons, and so on.

What's terrific about TinkerTool is that it's completely safe. It's nothing more than a front end for a number of perfectly legitimate Unix settings that Apple simply opted to make unavailable in the regular Finder. Furthermore, the changes you make using TinkerTool are stored in your own Home rightwards double arrow Library folder—that is, they affect only your account. Whatever changes you make don't affect the Mac experience for anyone else using your machine. And TinkerTool's Reset pane makes it easy to restore everything back to the way it was before you started fooling around.


tinkertool_customization_101.html

Chapter 17. Hacking Mac OS X

Section 4.5.1 shows you how to customize your desktop picture, error beep, and screen saver. But if you're sneaky, creative, or just different, you can perform more dramatic visual and behavioral surgery on your copy of Mac OS X—from changing the start up screen image to replacing the "poof" that appears when you drag something off the Dock with a new animation of your own. All you need is a few of Mac OS X's less obvious tools, or some free downloadable customizing software, and a few recipes like the ones in this chapter.

Some of these tricks are frivolous. Some are functional and useful. And although Apple sanctions not a one, all are perfectly safe.

17.1. TinkerTool: Customization 101

If you poke around the Mac OS X Web sites and news groups long enough, you'll find little bits of Unix code being passed around. One of them purports to let you change the genie animation that you see when you minimize a window to the Dock. Another eliminates the drop shadow behind icon names on your desktop. Yet another lets you change the transparency of the Terminal window (Chapter 16)—a cool, although not especially practical, effect.

If you really want to fool around with these bits of Unix code, go for it. You can find most of these tidbits at Web sites like www.macosxhints.com.

But the truth is, there's no good reason for you to subject yourself to the painstaking effort of typing out Unix commands when easy-to-use, push-button programs are available to do the same thing.

TinkerTool, for example, is a free utility that offers an amazing degree of control over the fonts, desktop, Dock, scroll bar arrows, and other aspects of the Mac OS X environment.

Here are some of the highlights:

  • Kill the animations. When you open any icon, expand a Get Info panel, and so on, you see little animated expansion effects. It's nice, but it takes time. TinkerTool can turn them off (see Figure 17-1).

    Figure 17-1. TinkerTool is a doubleclickable program that makes changes only to your account settings. (Mercifully, it's free. You can get it from this book's "Missing CD" page at www.missingmanuals.com.)

  • Dock. TinkerTool lets you give hidden programs transparent icons on the Dock and specify the Dock's position on the screen—left, right, bottom, or top—and even whether it's centered or flush against one corner. TinkerTool also unlocks a third option for the animation of windows collapsing onto the Dock. In addition to the standard Mac OS X choices (Genie and Scale), you also get something called Suck In (no comment).

    Tip: TinkerTool can even turn off the glassy, 3-D look of the Leopard Dock, which isn't universally adored.

  • Scroll bars. TinkerTool gives you greater control over the placement of Mac OS X's scroll bar arrows—together at one end of the scroll bar, duplicated at both ends of the scroll bar, and so on.

  • Visibility. TinkerTool can make the thousands of invisible Unix files appear as full-blooded icons. (Power users, you know who you are.)

  • Fonts. Tinker Tool lets you change the fonts for dialog boxes, menus, title bars, help balloons, and so on.

What's terrific about TinkerTool is that it's completely safe. It's nothing more than a front end for a number of perfectly legitimate Unix settings that Apple simply opted to make unavailable in the regular Finder. Furthermore, the changes you make using TinkerTool are stored in your own Home rightwards double arrow Library folder—that is, they affect only your account. Whatever changes you make don't affect the Mac experience for anyone else using your machine. And TinkerTool's Reset pane makes it easy to restore everything back to the way it was before you started fooling around.


redoing_mac_os_xs_graphics.html

17.2. Redoing Mac OS X's Graphics

The professional interface artists at Apple use Adobe Photoshop, just like professional artists everywhere else. But in Mac OS X, they've made very little effort to cover their tracks. In Cocoa programs and even a few Carbonized ones, every element of the famous Aqua interface is nothing more than a Photoshop-generated graphics file.

The beauty of graphics files, of course, is that you can edit them. Maybe you just want to adjust the colors. Maybe you found a replacement graphic online. Or maybe you actually want to draw a new graphic from scratch. In each of these cases, by using a program like Adobe Photoshop or Photoshop Elements, you can dress up your own desktop in your own way.

In addition to a little artistic talent, all you need to know is how to open the graphics that constitute the interface of each program. The routine generally goes like this:

  1. In the Finder, open the Applications folder. Control-click (or right-click) the icon of the program you want to edit; choose Show Package Contents from the shortcut menu.

    You may remember from Chapter 5 that most Mac OS X programs may look like single icons, but are actually disguised folders containing all of their own support files.

    You can choose almost any Cocoa program to edit in this way:Address Book, Chess, iChat, Mail, iPhoto, Safari, iDVD, iMovie, TextEdit, whatever.

  2. Open the Contents rightwards double arrow Resources folder.

    Inside are the objects of your search: the graphics files (often in TIFF or PDF format) that constitute the "face" of the program you're editing. (Sometimes they're one more folder down, in a folder representing your language—English.lproj, for example.)

    When you're editing the iPhoto, for example, the Resources folder contains the graphics that create slideshow playback buttons, the toolbar buttons, and so on. There's nothing to stop you from swapping in photos of your friends' heads in their places. Figure 17-2 shows another example.

    While you're at it, you may also want to open up Mac OS X's Mail program and redesign its toolbar icons. The sky's the limit!

    Tip: If you think you may want to return to the program's original look after your experiment, make a safety copy of these files before proceeding.

    Figure 17-2. Top: Cocoa programs are nothing more than a bunch of artistically done Photoshop TIFF files, buried in the program's package rightwards double arrow Contents rightwards double arrow Resources folder. When you feel the need for change, go ahead and edit them—hey, it's your computer.
    Bottom: When you're editing the Calculator program, you can edit the LCD_center.tif, LCD_right. tif, and LCD_left.tif files (left) to change the look of the readout window (right). In this example, the "center" portion gets stretched as wide as necessary to fill the width of the Calculator screen.

  3. Open the TIFF files in Photoshop.

    Edit them brilliantly.

  4. Save your changes.

    The deed is done. You now have a program that you can definitely call your own.

17.2.1. Editing the Trash, Dashboard, and Finder Icons

You can edit the Finder's Dock icon, Dashboard's Dock icon, and the Trash icons (empty and full) exactly as described above—but you have to peek into a different corner to find them. The Dock program isn't in your Applications folder; it's in your System folder. And in Mac OS X, the System folder is sacred territory, forbidden to humans. An error message lets you know that you're not allowed to edit the graphics files that make up Mac OS X itself (rather than its applications).

In this Mac OS X hack and in several others in this chapter, you have to find a way around this kind of OS self-protection. You can go about it in either of two ways:

  • Log into Mac OS X as the root user, as described on Section 16.9.

  • Simpler yet: -drag the icon you want out of the System folder, edit a copy of it (preserve the original, just in case), and then [image] -drag it back into place.

    As soon as you begin to [image] -drag one of these sacred files, Mac OS X asks you to prove your hackworthiness by entering an administrator's name and password—and then it lets you proceed with your surgery.

In any case, to edit the Finder or Trash icons, you'd start by opening the System rightwards double arrow Library rightwards double arrow CoreServices folder. Control-click Dock and choose Show Package Contents from the shortcut menu. The Dock window opens. Open the Contents rightwards double arrow Resources folder. These are the graphics you want to edit (as PNG graphics instead of TIFF): finder.png, trashempty.png, trashfull.png, and dashboard.png.

17.2.2. Replacing the Poof

When you drag an icon off the Dock or toolbar, it disappears with a puff of virtual smoke—a cute, cartoon-like animation that Apple's been trying to work into its operating systems ever since the days of the Newton palmtop. Most people find this tiny, one-second display of interface magic charming and witty, but others argue that it demeans the dignity of the otherwise professional-looking Mac OS X.

If you follow that latter camp, you can replace the animation just by editing Apple's own five-frame "poof " animation. Figure 17-3 shows the procedure.

17.2.3. Editing Your Menulets

You can colorize the little menu bar symbols fondly called menulets, or even completely redesign their graphics. Like many other Mac OSX screen elements, these are nothing more than little tiny graphics saved in PDF format.

Here again, you can't save changes to them unless you (a) log in as the root user, or(b) [image] -drag the original files to the desktop, edit them, and then [image] -drag them back in. Open the System rightwards double arrow Library rightwards double arrow CoreServices rightwards double arrow Menu Extras folder.

Here, you can find individual files (actually packages) for almost every menulet: Battery, Clock, Displays, and so on. Open which ever one you want to customize (Airport. menu, for example) by Control-clicking it and choosing Show Package Contents. As usual, open the Contents rightwards double arrow Resources folder.

Inside are a number of TIFF files that represent the various forms your menulet might take; the Volume icon, for example, seems to emit different numbers of sound waves depending on your volume setting. Edit each of the graphics as you see fit. (The ones whose names are tagged with an s or w represent the inverted highlighted graphic, which you see when you actually click the menulet.)

Figure 17-3. The "poof" animation is nothing more than five individual frames of cartoon smoke, 128 pixels square. You'll find its file sitting inside the Dock package, as described in the previous section, along with the finder.png and Trash files. As shown here in Photoshop Elements, you can substitute any graphics you want, as long as you fit them evenly on this 640-pixel-tall "film strip" (that is, 128 pixels times five). Save, quit, and then restart.

POWER USERS' CLINIC
Giant Icons

In Mac OS X 10.5, Apple did something secret and artistic: It quadrupled the potential size of its icons. Instead of the measly 128 pixels square (which is all that most people ever see, maximum), you can blow them up to a colossal 512 pixels square. They're less like icons than art you can hang on your wall.

To see the effect, you have to use Terminal (see Chapter 16). Type this command, exactly as you see it here, but all on one line:

    defaults write
    com.apple.finder
    DesktopViewOptions
    -dict IconSize -integer
    256; killall Finder

It's quite a shocking sight—and, in fact, rather too big to be useful. It also works only on desktop icons—not icons in folders.

To turn the effect off, press [image] -J to open the View Options dialog box. Adjust the icon-size slider; the least touch of that slider turns the giganto-icon effect off again.


replacing_the_finder_icons.html

17.3. Replacing the Finder Icons

This one's easy: Just download CandyBar, a simple drag-and-drop program. With no technical skill whatsoever, you can use this program to replace the icon pictures featured on your folders, your disks, and the Finder toolbar. It even comes with several collections of perky (but nonphotorealistic) replacement icons (Figure 17-4).

Figure 17-4. To use CandyBar, just drag your new icons into the appropriate slots. When you restart the Mac, you'll find your new icons in place. Restoring the original icons is equally simple.


rewriting_the_words.html

17.4. Rewriting the Words

Mac OS X stores the text and settings of its menus, dialog boxes, and other elements in special text files called plist (for Property List) files. They sit in one of the three Library folders (in your Home folder, the System folder, or the hard drive window).

The easiest way to edit them is to use Apple's Property List Editor, a program that came on your Mac OS X Developer CD. Once you've installed your developer tools as described on Section 10.30.21, you can find Property List Editor in Developer rightwards double arrow Applications rightwards double arrow Utilities.

There are hundreds of plist files, so some experimentation and patience is required. Most of the cool changes you can make to your plists can be made much more easily using TinkerTool, described at the beginning of this chapter. Here, however, is an example of a smaller change you can make this way.

17.4.1. Renaming the Trash

It's called Trash, but in Mac OS X, it looks more like an office wastebasket. When inspiration on the work you're supposed to be doing runs dry, consider remedying this discrepancy by changing the name of the Trash icon to something more appropriate.

In PropertyList Editor, choose File rightwards double arrow Open. Navigate to System rightwards double arrow Library rightwards double arrow Core Services rightwards double arrow Dock rightwards double arrow Contents rightwards double arrow Resources rightwards double arrow English.lproj rightwards double arrow InfoPlist.strings.

Click the Root triangle to view and edit the settings, as directed in Figure 17-5.

Figure 17-5. Top: This simple file contains the name of the Trash icon on the Dock—and the name of the Eject icon that replaces it when you're dragging a disk. By double-clicking the text in the Value column, you can edit these descriptions to change the corresponding names.
Bottom: The resulting Trash has a very different name.

Once you're finished making the change, choose File rightwards double arrow Save As, and save your edited plist document to the desktop. Now replace the original document (after making a safety copy, if you like) with your edited version, using either of the techniques described on Section 17.2.2.

In any case, the next time you log in, you see your new name on the Trash.

17.4.2. Rewording the Dock

Using the same routine described in the previous paragraphs, you can edit all of the commands that pertain to the Dock—both its commands in the [image] menu (Dock Preferences, Turn Magnification On, and so on) and the shortcut menus that pop out of the Dock icons themselves. These wordings are in System rightwards double arrow Library rightwards double arrow Core Services rightwards double arrow Dock.app rightwards double arrow Contents rightwards double arrow Resources rightwards double arrow English.lproj rightwards double arrow DockMenus.plist.Click the flippy triangles to see the various commands you can rewrite.


your_bright_hacking_future.html

17.5. Your Bright Hacking Future

Someone could write a whole book on hacking Leopard, and somebody probably will (or has). Plenty more little recipes are floating around the Web. Lots of them involve typing a few commands into Terminal (Chapter 16), but that's really not so bad if you type carefully.

Here, for example, is a representative baker's dozen of the hacks that you'll find with a quick search at www.macosxhints.com:

  • How to create turn a group of images in Preview into a multi-page PDF file

  • How to change the Dock's colors with Automator

  • How to remove Spotlight from the menu bar

  • How to disable Spotlight completely

  • How to make the menu bar stop being translucent

  • How to change the Dictionary's font

  • How to remove the outer-space imagery from Time Machine's background

  • How to change Time Machine's backup interval

  • How to install Leopard on an older Mac

  • How to eliminate the blue-and-white stripes from Finder list views

  • How to bring back rounded window corners

  • How to disable certain Front Row menu items

  • How to modify the gray startup Apple logo

Happy hacking!


mac_OS_online.html

Part V: Mac OS Online

Chapter 18

Chapter 19

Section 10.25

Section 7.5.1.8

Chapter 22

Chapter 18. Internet Setup

As Apple's programmers slogged away for months on the massive Mac OS X project, there were areas where they must have felt like they were happily gliding on ice: networking and the Internet. For the most part, the Internet already runs on Unix, and hundreds of extremely polished tools and software chunks were already available.

Plenty of people still connect to the Internet using a modem that dials out over ordinary phone lines. But their numbers are shrinking; over half of the U.S. Internet population connects over higher-speed wires, using broadband connections that are always on: cable modems, DSL, or corporate networks. This chapter explains how to set up each one (and how to use each with a wireless AirPort system).

This chapter also describes some of Mac OS X's offbeat Internet featurettes: the iDisk, a backup or transfer disk that resides on the Internet; the other Apple .Mac account features, including HomePage, which lets you publish your own Web pages; Internet Connection Sharing, which lets several computers in the same household share a single broadband connection; the system-wide Internet bookmarks known as Internet location files; and iSync, the software that keeps data on your cellphone, Palm organizer, and multiple Macs all in sync.

18.1. The Best News You've Heard All Day

If you upgraded to Mac OS X 10.5 from an earlier version of the Mac OS, breathe easy. Mac OS X was kind enough to pick up your networking and Internet settings from that earlier installation. The moment you first see the Mac OS X desktop, you're ready to use the Internet (and skip the next two pages).

Read on, however, if you need to plug in the Internet settings manually. If you're setting up a new Mac, or if you've just used Mac OS X's "clean install" option (Appendix A), or if you simply want to create a new Internet account, you definitely have some typing to look forward to.

Tip: If you haven't yet set up an Internet connection, reading the next few pages will guide you through plugging the proper settings into System Preferences.If you're more of a doer than a reader, however, you may prefer the "Assist me" button at the bottom of the Network pane of System Preferences. It asks how you want to connect to the Internet (by dial-up modem, DSL, cable modem, and so on), and then walks you through the process of typing in the settings, if necessary.


internet_setup.html

Part V: Mac OS Online

Chapter 18

Chapter 19

Section 10.25

Section 7.5.1.8

Chapter 22

Chapter 18. Internet Setup

As Apple's programmers slogged away for months on the massive Mac OS X project, there were areas where they must have felt like they were happily gliding on ice: networking and the Internet. For the most part, the Internet already runs on Unix, and hundreds of extremely polished tools and software chunks were already available.

Plenty of people still connect to the Internet using a modem that dials out over ordinary phone lines. But their numbers are shrinking; over half of the U.S. Internet population connects over higher-speed wires, using broadband connections that are always on: cable modems, DSL, or corporate networks. This chapter explains how to set up each one (and how to use each with a wireless AirPort system).

This chapter also describes some of Mac OS X's offbeat Internet featurettes: the iDisk, a backup or transfer disk that resides on the Internet; the other Apple .Mac account features, including HomePage, which lets you publish your own Web pages; Internet Connection Sharing, which lets several computers in the same household share a single broadband connection; the system-wide Internet bookmarks known as Internet location files; and iSync, the software that keeps data on your cellphone, Palm organizer, and multiple Macs all in sync.

18.1. The Best News You've Heard All Day

If you upgraded to Mac OS X 10.5 from an earlier version of the Mac OS, breathe easy. Mac OS X was kind enough to pick up your networking and Internet settings from that earlier installation. The moment you first see the Mac OS X desktop, you're ready to use the Internet (and skip the next two pages).

Read on, however, if you need to plug in the Internet settings manually. If you're setting up a new Mac, or if you've just used Mac OS X's "clean install" option (Appendix A), or if you simply want to create a new Internet account, you definitely have some typing to look forward to.

Tip: If you haven't yet set up an Internet connection, reading the next few pages will guide you through plugging the proper settings into System Preferences.If you're more of a doer than a reader, however, you may prefer the "Assist me" button at the bottom of the Network pane of System Preferences. It asks how you want to connect to the Internet (by dial-up modem, DSL, cable modem, and so on), and then walks you through the process of typing in the settings, if necessary.


the_best_news_youve_heard_all_day.html

Part V: Mac OS Online

Chapter 18

Chapter 19

Section 10.25

Section 7.5.1.8

Chapter 22

Chapter 18. Internet Setup

As Apple's programmers slogged away for months on the massive Mac OS X project, there were areas where they must have felt like they were happily gliding on ice: networking and the Internet. For the most part, the Internet already runs on Unix, and hundreds of extremely polished tools and software chunks were already available.

Plenty of people still connect to the Internet using a modem that dials out over ordinary phone lines. But their numbers are shrinking; over half of the U.S. Internet population connects over higher-speed wires, using broadband connections that are always on: cable modems, DSL, or corporate networks. This chapter explains how to set up each one (and how to use each with a wireless AirPort system).

This chapter also describes some of Mac OS X's offbeat Internet featurettes: the iDisk, a backup or transfer disk that resides on the Internet; the other Apple .Mac account features, including HomePage, which lets you publish your own Web pages; Internet Connection Sharing, which lets several computers in the same household share a single broadband connection; the system-wide Internet bookmarks known as Internet location files; and iSync, the software that keeps data on your cellphone, Palm organizer, and multiple Macs all in sync.

18.1. The Best News You've Heard All Day

If you upgraded to Mac OS X 10.5 from an earlier version of the Mac OS, breathe easy. Mac OS X was kind enough to pick up your networking and Internet settings from that earlier installation. The moment you first see the Mac OS X desktop, you're ready to use the Internet (and skip the next two pages).

Read on, however, if you need to plug in the Internet settings manually. If you're setting up a new Mac, or if you've just used Mac OS X's "clean install" option (Appendix A), or if you simply want to create a new Internet account, you definitely have some typing to look forward to.

Tip: If you haven't yet set up an Internet connection, reading the next few pages will guide you through plugging the proper settings into System Preferences.If you're more of a doer than a reader, however, you may prefer the "Assist me" button at the bottom of the Network pane of System Preferences. It asks how you want to connect to the Internet (by dial-up modem, DSL, cable modem, and so on), and then walks you through the process of typing in the settings, if necessary.


network_centralmdashand_multihoming.html

18.2. Network Central—and Multihoming

In this chapter, you'll be spending a lot of time in the Network pane of System Preferences (Figure 18-1).(Choose [image] rightwards double arrow System Preferences; click Network.) This list summarizes the ways your Mac can connect to the Internet or an office network—Ethernet, AirPort wireless, Bluetooth, FireWire, cellular modem card, VPN (Chapter 22), and so on—and how each connection is doing.

Figure 18-1. The network connections listed here are tagged with color-coded dots. A green dot means turned on and connected to a network; yellow means working, but not connected at the moment; red means you haven't yet set up a connection method.

There's quite a bit going on here in this radically redesigned control panel; for example, it completely replaces the old Internet Connect program. Now you set up all your network connections here, and you can connect and disconnect to all your networks here.

18.2.1. Multihoming

What you may not realize is that the order of the network connections listed here is important. That's the sequence the Mac uses as it tries to get online. If one of your programs needs Internet access, and the first method isn't hooked up, the Mac switches to the next available connection automatically.

In fact, Mac OS X can maintain multiple simultaneous network connections—Ethernet, AirPort, dial-up, even FireWire—a feature known as multihoming.

This feature is especially relevant for laptops. When you open your Web browser, your laptop might first check to see if it's at the office, plugged into a cable modem via an Ethernet cable, which is the fastest, most secure type of connection. If there's no Ethernet, it looks for an AirPort network. Finally, if it draws a blank there, the laptop reluctantly dials the modem. It may not be the fastest Internet connection, but it's all you've got at the moment.

Here's how to go about setting up the connection attempt sequence you want:

  1. Open System Preferences. Click the Network icon.

    The Network Status screen (Figure 18-1) brings home the point of multihoming: You can have more than one network connection operating at once.

  2. From the [image] pop-up menu, choose Set Service Order.

    Now you see the display shown in Figure 18-2. It lists all the different ways your Mac knows how to get online, or onto an office network.

    Figure 18-2. The key to multihoming is sliding the network connection methods' names up or down. Note that you can choose a different connection sequence for each location. (Locations are described later in this chapter.)

  3. Drag the items up and down in the list into priority order.

    If you have a wired broadband connection, for example, you might want to drag Built-in Ethernet to the top of the list, since that's almost always the fastest way to get online.

  4. Click OK.

    You return to the Network pane of System Preferences, where the master list of connections magically re-sorts itself to match your efforts.

Your Mac will now be able to switch connections even in real time, during a single Internet session. If lightning takes out your Ethernet hub in the middle of your Web surfing, your Mac will seamlessly switch to your AirPort network, for example, to keep your session alive.

All right then: Your paperwork is complete. The following pages guide you through the process of setting up these various connections.


broadband_connections.html

18.3. Broadband Connections

If your Mac is connected wirelessly or, um, wirefully to a cable modem, DSL, or office network, you're one of the lucky ones. You have a high-speed broadband connection to the Internet that's always available, always on. You never have to wait to dial, disconnect, or download. You're connected to the Net via your Mac's Ethernet jack or AirPort antenna, leaving the dial-up era behind.

18.3.1. Automatic Configuration

The real beauty of most broadband connections these days is that they require no setup whatsoever. Take a new Mac out of the box, plug in the Ethernet cable to your cable modem (or choose a wireless network from the [image] menulet), and you can begin surfing the Web instantly.

That's because most cable modems, DSL boxes, and wireless base stations automatically feed all of the necessary configuration settings to the Mac (including techie specs like IP address and DNS Server addresses), courtesy of a glorious feature called DHCP.

UP TO SPEED
PPPoE and DSL

If you have DSL service, you may be directed create a PPPoE service. (You do that on the Network pane of System Preferences; click your Ethernet connection, and then choose Configuration rightwards double arrow Create PPPoE Service.)

It stands for PPP over Ethernet, meaning that although your DSL "modem" is connected to your Ethernet port, you still have to make and break your Internet connections manually, as though you had a dial-up modem.

Fill in the PPPoE dialog box as directed by your ISP (usually just your account name and password). From here on in, you start and end your Internet connections exactly as though you had a dial-up modem.

This acronym means dynamic host configuration protocol, which is tech-ese for: "We'll fill in your Network pane of System Preferences automatically."

18.3.2. Manual Configuration

If, for some reason, you're not able to surf the Web or check email the first time you try, it's conceivable that your broadband modem or your office network doesn't offer DHCP. In that case, you may have to fiddle with the Network pane of System Preferences, preferably with a customer-support rep from your broadband provider on the phone.

On the Network pane, click either AirPort or Built-in Ethernet, depending on how your Mac is connected to the broadband modem. Now you see something like Figure 18-3.

Figure 18-3. Don't be alarmed by the morass of numbers and periods—it's all in good fun. (If you find TCP/IP fun, that is.)

In this illustration, you see the setup for a cable-modem account with a static IP address, which means you have to type in all of these numbers yourself, as guided by the cable company. The alternative is a DHCP server account, which fills most of it in automatically.

18.3.3. Ethernet Connections

The beauty of Ethernet connections is that they're super-fast and super-secure. No bad guys sitting across the coffee shop, armed with shareware "sniffing" software, can intercept your email and chat messages, as they theoretically can when you're on wireless.

As shown in Figure 18-3, clicking the name of an Ethernet connection in the Network pane reveals the geeky settings required for a manual Ethernet setup.

For most people, the correct setting in the Configure pop-up menu is "Using DHCP," which means "Mac OS X fills in the correct settings for you."

If your network geek or Internet provider has instructed you to use other settings, then you'll probably be asked to choose Manually. That is, your cable or phone company will tell you precisely which IP address (Internet address) to type in here. You'll also have to fill in all the other boxes here—Subnet Mask, Router,and so on—with cryptic numbers separated by periods.

Note: But look at the bright side: You've just been given a static IP address, an Internet address that is all your own and that won't change. Because your Mac has this one reliable address, several cool Mac OS X features are available to you. For example, it's easier to access your files from anywhere in the world, as described in Chapter 22.

That's all the setup—click Apply Now. If your settings are correct, you're online, now and forever. You never have to worry about connecting or disconnecting.

18.3.4. AirPort (Wi-Fi) Connections

AirPort is Apple's term for the 802.11 (Wi-Fi) wireless networking technology. If you have it, your Mac can communicate with a wireless base station up to 300 feet away, much like a cordless phone. Doing so lets you surf the Web from your laptop in the hotel room, for example, or share files with someone across the building from you.

POWER USERS' CLINIC
The Super-Secret, New, Hot-Spot Management Box

If you open System Preferences rightwards double arrow Network, click AirPort in the left-side list, and then click Advanced, you see the cool new dialog box shown here. It lets you manage the list of Wi-Fi hot spots that Mac OS X has memorized on your travels.

For example, you can delete the old ones. You can also double-click a Wi-Fi net's name to type in and store its password. Finally, you can drag the hot spots' names up and down the list to establish a priority for making connections when more than one is available.

Ordinarily, Mac OS X memorizes the names of the various hot spots that you join on your travels. It's kind of nice, actually, because it means you're interrupted less often by the "Do you want to join?" box.

But if you're alarmed at the massive list of hot spots that Leopard has memorized—for privacy reasons, say— here's where you turn off "Remember any network this computer has joined."

Chapter 13 has much more information about setting up an AirPort network. The real fun begins, however, when it comes time to join one.

Sometimes you just want to join a friend's Wi-Fi network. Sometimes you've got time to kill in an airport, and it's worth a $7 splurge for half an hour. And sometimes, at some street corners in big cities, Wi-Fi signals bleeding out of apartment buildings might give you a choice of 20 or 30 free hot spots to join.

Note: Not all attempts to join Wi-Fi hot spots are successful, even the unlocked ones. Sometimes the signal is strong enough to make the hot spot's name show up in your [image] menu, but not enough for an actual connection. Sometimes, for security, hot spots are rigged to permit only specific computers to join (see the box on the next page), and yours isn't one of them. And sometimes wireless routers are broadcasting, but their Internet connection is down.

Figure 18-4. Left: Congratulations—your Mac has discovered new Wi-Fi hot spots all around you! Double-click one to join it. But if you see a icon next to the hot spot's name, beware: It's been protected by a password. If you don't know it, then you won't be able to connect.
Right: Later, you can always switch networks using the AirPort menulet.

Either way, your Mac joins Wi-Fi hot spots like this:

  • First, it sniffs around for a Wi-Fi network that you've used before. If it finds one, it connects quietly and automatically. You're not asked for permission, a password, or anything else; you're just online. (It's that way, for example, when you come home with your laptop every day.) For details on this memorization feature, see the box on Section 18.3.4.

  • If the Mac can't find a previous hot spot, but it detects a new hot spot or two, a message appears on the screen (Figure 18-4), displaying their names. Double-click one to connect.

  • If you missed the opportunity to join a hot spot when the message appeared, or if you joined the wrong one or a non-working one, then you have another chance. You can always choose a hot spot's name from the [image] menulet, as shown in Figure 18-4 at right. A [image] icon indicates a hot spot that requires a password—a tiny but terrific new Leopard feature—so you don't waste your time trying to join those (unless, of course, you have the password).

Tip: If you don't want your Mac to keep interrupting you with its discoveries of new hot spots—it can get pretty annoying when you're in a taxi driving through a city—you can shut them off. In System Preferences, click Network, click AirPort, and then turn off "Ask to join new networks."

18.3.5. Commercial Hot Spots

Choosing the name of the hot spot you want to join is generally all you have to do—if it's a home Wi-Fi network.

POWER USERS' CLINIC
The Secret Life of the AirPort Menulet

Here's something not one Mac fan in a thousand knows about: a secret diagnostic mode in the [image] menulet.

Turns out that if you press the Option key as you open the [image] menulet, you get a special treat: a faint gray interior menu that identifies some diagnostic details of your current wireless network. You get to see the hot spot's channel, your current data rate, and the MAC address of your AirPort card.

AMAC address has nothing to do with Macs; Windows PCs have MAC addresses, too. It stands for Media Access Control, although the equivalent term, Ethernet Hardware Address, is much more descriptive. It's a unique identifier for your networking card, whether it's your Ethernet card or your AirPort circuitry.

Every now and then, somebody will ask for your MAC address—usually when helping you troubleshoot network problems or get onto a really exclusive Wi-Fi hot spot. (Some hot spots are so restrictive, the network administrator has to register each MAC address that's allowed to use it.)

Unfortunately, joining a commercial Wi-Fi hot spot—one that requires a credit card number (in a hotel room or airport, for example)—requires more than just connecting to it. You also have to sign into it before you can send so much as a single email message.

To do that, open your Web browser. You'll see the "Enter your payment information" screen either immediately or as soon as you try to open a Web page of your choice. (Even at free hot spots, you might have to click OK on a welcome page to initiate the connection.)

Supply your credit card information or (if you have a membership to this Wi-Fi chain, like Boingo or T-Mobile) your name and password. Click Submit or Proceed, try not to contemplate how this $8 per hour is pure profit for somebody, and enjoy your surfing.


dial-up_modem_connections.html

18.4. Dial-up Modem Connections

If you ask Apple, dial-up modems are dead. Macs don't even come with built-in modems anymore. You can get an external USB modem for $50, but clearly, Apple is trying to shove the trusty dial-up technology into the recycling bin.

Still, millions of people never got the memo. If you're among them, you need to sign up for Internet service. Hundreds of companies, large and small, would love to become your Internet service provider (ISP), generally charging $20 or so per month for the privilege of connecting you to the great Internet.

Once you've selected a service provider, you plug its settings into the Network pane of System Preferences. You get the necessary information directly from your ISP by consulting either its Web page, the instruction sheets that came with your account, or a help-desk agent on the phone.

Note: The following instructions don't pertain to America Online. It comes with its own setup program and doesn't involve any settings in System Preferences.

18.4.1. Setting Up the Modem

Open System Preferences and click Network. If your modem isn't already listed, click the + button at lower left; from the Interface pop-up menu that appears, choose External Modem, and then click Create.

Your modem connection now appears in the list at the left side of the pane. Click it. Now fill in the blanks like this:

  • Configuration. It's called Default at first, which is fine. If you like, you can choose Add Configuration from this pop-up menu and then name it after your ISP (Earthlink, for example).

  • Telephone Number. This is the local access number that your modem is supposed to dial to connect to your ISP.

    Tip: If you need your Mac to dial a 9 or an 8 for an outside line (as you would from within a hotel), or *70 to turn off Call Waiting, add it to the beginning of the phone number followed by a comma. The comma means "Pause for 2 seconds." You can also put the comma to good use when typing in the dialing sequence for a calling-card number.

  • Account Name. This is your account name, as assigned by the ISP. If you're BillG@ earthlink.net, for example, type BillG here.

  • Password. Specify your ISP account password here. Turn on "Save password" if you'd rather not retype it every time you connect.

18.4.2. The Advanced Button

Click the Advanced button to bring up a special dialog box filled with tweaky,soon-to-be-obsolete modem settings (Figure 18-5). Most of the action is on these two tabs:

18.4.2.1. The Modem tab

On the Modem tab, you specify which kind of modem you have. Roughly 99.99999 percent of Macs with modems have Apple modems, which is why the pop-up menu already says "Apple." If you, the heretic, have some other kind of modem, choose its name from the pop-up menu.

Figure 18-5. Dial-up modems may be fading in the era of high-speed Internet connections, but they're not dead yet. Mac OS X still offers a full panoply of tweaky settings.

Tip: This list of modems corresponds to configuration files in your Library rightwards double arrow Modem Scripts folder. You can save a ton of disk space and simplify your life by throwing away the scripts for all modems except the one you actually use.

Some other handy settings include:

  • Wait for dial tone before dialing. This setting is for you, North American laptop owners. Because the dial tones in certain foreign countries sound weird to the Mac, it therefore won't dial; it's still listening for that good old North American dial tone. In that case, turning off this checkbox makes the Mac dial bravely even though it hasn't heard the sound it's listening for.

  • Dialing. Specify what kind of phone service you have—Tone, or in a few rural locations, Pulse.

  • Sound. By clicking Off, you make your Mac dial the Internet silently, sparing sleeping family members or dorm roommates from having to listen to your modem shriek as it connects.

18.4.2.2. The PPP tab

On the PPP tab, you can specify how long the Mac waits before hanging up the phone line after your last online activity, and how many times the Mac should redial if the ISP phone number is busy.

And you'll almost certainly want to turn on "Connect automatically when needed." It makes your Mac dial the Internet automatically whenever you check your email or open your Web browser. (Otherwise, you'd have to establish the Internet call manually by opening System Preferences rightwards double arrow Network and clicking Connect. Only then could you check your email or open your Web browser.)

18.4.3. Going Online

That's all there is to it. If you've turned on "Connect automatically when needed, "your Mac dials and connects to the Internet automatically whenever an Internet-related program tries to connect (a Web browser or email program, for example).

If you didn't turn on that option, then you can make your Mac dial the Internet in one of two ways:

  • Use the Network pane. Right here in System Preferences, you can click Connect to make the connection.

  • Use the menu-bar icon. If you were smart, however, you turned on "Show modem status on menu bar" in System Preferences rightwards double arrow Network. It adds the [image] menulet to the upper-right corner of your screen, which lets you get online with one quick menu choice (Figure 18-6).

18.4.4. Disconnecting

The Mac automatically drops the phone line 15 minutes after your last activity online (or whatever interval you specified on the PPP tab of the Advanced dialog box). In fact, if other people have accounts on your Mac (Chapter 12), the Mac doesn't even hang up when you log out. It maintains the connection so that the next person can surf the Net without redialing.

Figure 18-6. Life is simplest when you've told your Mac to dial automatically when it needs to get online. But you can also go online on command, using this menulet.

Of course, if other people in your household are screaming for you to get off the line so they can make a call, you can also disconnect manually. Choose Disconnect from the [image] menulet.

Tip: If you have more than one ISP, or if you travel between locations with your laptop, don't miss the Location feature. It lets you switch sets of dial-up modem settings—including the local phone number—with a simple menu selection. It's described on the facing page.

GEM IN THE ROUGH
Cellular Wireless

Wi-Fi hot spots are fast and usually cheap—but they're hot spots. Beyond 150 feet away, you're offline.

No wonder laptop luggers across America are getting into cellular Internet services. All of the big cellphone companies offer PC cards or ExpressCards that let your laptop get online at high speed anywhere in major cities. No hunting for a coffee shop; with a cellular Internet service, you can check your email while zooming down the road in a taxi. (Outside the metropolitan areas, you can still get online wirelessly, though much more slowly.) Verizon and Sprint offer the fastest cellular Internet networks, using a technology called EV-DO. AT&T's and T-Mobile's of-ferings are much slower.

So why isn't the world beating a path to this delicious technology's door? Because it's expensive—at this writing, $60 a month on top of your phone bill.

You may also be able to get your laptop online by connecting it to your cellphone with a cable—a lower-priced, slower option. Ask your cellphone carrier.


switching_locations.html

18.5. Switching Locations

If you travel with a laptop, you know the drill. You're constantly opening up System Preferences rightwards double arrow Network so that you can switch between Internet settings: Ethernet at the office, Wi-Fi at home. Or maybe you simply visit the branch office from time to time, and you're getting tired of having to change the local access number for your ISP each time you leave home (and return home again).

The simple solution is the [image] Location submenu, which appears once you have set up more than one Location. As Figure 18-7 illustrates, all you have to do istell it where you are. Mac OS X handles the details of switching Internet connections.

Figure 18-7. The Location feature lets you switch from one "location" to another just by choosing its name— either from the menu (top) or from this pop-up menu in System Preferences (bottom).
The Automatic location just means "the standard, default one you originally set up." (Don't be fooled: Despite its name, Automatic isn't the only location that offers multihoming, described earlier in this chapter.)

18.5.1. Creating a New Location

To create a Location, which is nothing more than a set of memorized settings, open System Preferences, click Network, and then choose Edit Locations from the Location pop-up menu. Continue as shown in Figure 18-8.

Tip: You can use the commands in the [image] menu to rename or duplicate a Location.

When you click Done, you return to the Network panel. Take this opportunity to set up the kind of Internet connection you use at the corresponding location, just as described on the first pages of this chapter.

If you travel regularly, you can build a list of Locations, each of which "knows" the way you like to get online in each city you visit.

A key part of making a new Location is putting the various Internet connection types (Ethernet, AirPort, Modem, Bluetooth) into the correct order. Your connections will be slightly quicker if you give the modem priority in your Hotel setup, the AirPort connection priority in your Starbucks setup, and so on.

Figure 18-8. When you choose Edit Locations, this list of existing Locations appears; click the + button. A new entry appears at the bottom of the list. Type a name for your new location, such as Chicago Office or Dining Room Floor.

You can even turn off some connections entirely. For example, if you use nothing but a cable modem when you're at home, you may want to create a location in which only the Ethernet connection is active. Use the Make Service Inactive command in the [image] pop-up menu.

Conversely, if your laptop uses nothing but Wi-Fi when you're on the road, your Location could include nothing but the AirPort connection. You'll save a few seconds each time you try to go online, because your Mac won't bother hunting for an Internet connection that doesn't exist.

18.5.2. Making the Switch

Once you've set up your various locations, you can switch among them using either the Location pop-up menu (in System Preferences rightwards double arrow Network) or the [image] rightwards double arrow Location submenu, as shown in Figure 18-7. As soon as you do so, your Mac is automatically set to get online the way you like.

Tip: If you have a laptop, create a connection called Offline. From the Show pop-up menu, choose Network Port Configurations; make all the connection methods in the list inactive. When you're finished, you've got yourself a laptop that will never attempt to go online. You've got yourself the laptop equivalent of Airplane Mode on a cellphone.

18.5.3. Internet Sharing

If you have cable modem or DSL service, you're a very lucky individual. Not only do you benefit from great speed when surfing the Web or processing email, but your connection is on full-time. You never have to wait for some modem to dial (screeching all the way), and wait again for it to disconnect. Too bad only one computer in your household or office can enjoy these luxuries.

Actually, it doesn't have to be that way. You can spread the joy of high-speed Internet to every Mac (and PC) on your network in either of two ways:

  • Buy a router. A router is a little box, costing about $50, that connects directly to the cable modem or DSL box. In most cases, it has multiple Internet jacks so you can plug in several Macs, PCs, and/or wireless base stations. As a bonus, a router provides excellent security, serving as a firewall to keep out unsolicited visits from hackers on the Internet. (If you use a router, turn off Mac OS X's own firewall in System Preferences rightwards double arrow Security.)

  • Use Internet Sharing. Mac OS X's Internet Sharing feature is the software version of a router, in that it distributes a single Internet signal to every computer on the network. But unlike a router, it's free. You just fire it up on the one Mac that's connected directly to the Internet—the gateway computer.

    But there's a downside: If the gateway Mac is turned off or asleep, the other machines can't get online.

    Most people use Internet Sharing to share a broadband connection like a cable modem or DSL. But in fact, Internet Sharing works if the gateway Mac connects to the Internet via dial-up modem or even a Bluetooth cellphone.

    The only requirement is that the gateway Mac also has a network connection (Ethernet, AirPort, or FireWire) to the Macs that will share the connection.

18.5.4. Turning On Internet Sharing

To turn on Internet Sharing on the gateway Mac, open the Sharing panel of System Preferences. Turn on Internet Sharing, as shown in Figure 18-9, and then confirm your decision by clicking Start. (In most setups, you'll want to turn on Internet Sharing only on the gateway Mac.)

To set up sharing, you have to specify (a) how the gateway Mac is connected to the Internet, and (b) how it's connected to the other Macs on your office network:

  • Share your connection from. Using this pop-up menu, identify how this Mac (the gateway machine) connects to the Internet—via Built-in Ethernet, AirPort, or whatever. If you select AirPort, you create the software base station effect described in the next section.

  • To computers using. Turn on the checkboxes to teach your Mac how the other Macs are connected to it—via what form of networking, in other words.

Note: Which checkboxes appear here depend on which kinds of Internet connections are turned on in the Network pane of System Preferences. If the gateway Mac doesn't have AirPort circuitry, for example, or if AirPort is turned off in the current configuration, the AirPort option doesn't appear.

Figure 18-9. Ka-ching! Mac OS X's Internet Sharing just saved you the cost of a $50 hardware router. In this example, the Mac is connected to a cable modem via Ethernet. But other Macs are connected to it via wireless AirPort and by a FireWire cable. And now they can get online, too, even though they're not directly connected to the cable modem.

Now visit each of the other Macs on the same network. Open the Network pane of System Preferences. Select AirPort, Built-in Ethernet, or FireWire—whichever reflects how each Mac is connected to your network. Then, from the Configure pop-up menu, choose Using DHCP. Leave everything else blank. Finally, click Apply Now.

As long as the gateway Mac remains turned on, you should find that both it and your other Macs can get onto the Internet simultaneously, all at high speed. (Even Windows PCs on the same network can also get online, as long as you set them up to use DHCP just as you did your "downstream" Macs.)

Note: If you're like most people, your gateway Mac has only one Ethernet port. How, you may wonder, can you plug in both the cable modem and the local network?One approach is to install a second Ethernet card. The more economical approach: Connect the cable modem to the Uplink or WAN jack on your Ethernet hub or router. (On some models, an ordinary Ethernet port can be turned into an Uplink port if you flip a tiny switch.) Your gateway Mac plugs into the hub as usual.

18.5.5. The Software Base Station Effect

If the gateway Mac has AirPort circuitry, turning on Internet Sharing (and "To computers using: AirPort") has another profound effect: It creates a software base station. The Mac itself is now the transmitter for Internet signals to and from any other AirPort-equipped Macs within range. You just saved yourself the cost of an Apple base station.

Tip: Internet Sharing can create the opposite effect, too: Instead of letting a wireless Mac piggyback on a wired Mac's connection, you can let a wired Mac share a wireless connection.Suppose, for example, that you and a buddy both have laptops in a hotel lobby. You're online, having paid $13 to use the hotel's Wi-Fi network. If you set up Internet Sharing appropriately, your buddy can connect to yours via an Ethernet cable or even a FireWire cable and surf along with you—no extra charge.


mac_services.html

18.6. .Mac Services

In January 2000, Apple CEO Steve Jobs explained to the Macworld Expo crowds that he and his team had had a mighty brainstorm: Apple controls both ends of the connection between a Mac and the Apple Web site. As a result, Apple should be able to create some pretty clever Internet-based features as a reward to loyal Mac fans. Later that same day, the Apple Web site offered a suite of free services called iTools.

POWER USER'S CLINIC
Internet Sharing as a Bridge

Ordinarily, only one Mac has Internet Sharing turned on: the one that's connected directly to the Internet.

But sometimes, you might want another Mac "downstream" to have it on, too. That's when you want to bridge two networks.

Consider the setup shown here: There are really two networks: one that uses AirPort, and another con-nected to an Ethernet hub.

If you play your cards right, all of these Macs can get online simultaneously, using a single Internet connection.

Set up the gateway Mac so that it's an AirPort base station, exactly as described on these pages.

Start setting up the bridge Mac the way you'd set up the other AirPort Macs—with AirPort selected as the primary connection method, and "Using DHCP" turned on in the Network panel.

Then visit the bridge Mac's Sharing panel. Turn on Internet Sharing here, too, but this time select "To computers using: Built-in Ethernet."

The bridge Mac is now on both networks. It uses the AirPort connection as a bridge to the gateway Mac and the Internet—and its Ethernet connection to share that happiness with the wired Macs in its own neighborhood.

Then the technology bubble burst.

These days, .Mac subscriptions (as they're now called) cost $100 per year. For a full description, see Figure 18-10.

Figure 18-10. The .Mac features appear as buttons on the .Mac Web site. For example, iCards are attractively designed electronic greeting cards that you can send by email. Backup is a basic backup program that you can download from this site. Webmail, HomePage, an antivirus program, and features that synchronize your iCal and iSync data with other computers are the other secondtier features. The best feature, however, is iDisk.

18.6.1. Signing Up for .Mac

Open System Preferences and click the .Mac icon. Click Learn More. You now go online,where your Web browser has opened up to the.Macsign-upscreen.Fill in your name and address, make up an account name and password, turn off the checkbox that invites you to get junk mail, and so on.

The final step is to return to the .Mac pane of System Preferences. Fill in the account name and password you just composed, if necessary. You're ready to use .Mac.

18.6.2. iDisk

The iDisk is an Internet-based hard-drive icon on your desktop, holding up to 10 gigabytes of files. (Your .Mac account comes with 10 gigabytes of storage. In your account settings at www.mac.com, you can decide how to divide up that storage between your iDisk and the other .Mac stuff, like mail and your Web sites. And, of course, you can pay more money for more storage.)

Anything you drag into the folders inside this iDisk icon gets copied to Apple's secure servers on the Internet. Meanwhile, on your end, it appears to work just like a harddrive.

In other words, iDisk can be a handy pseudo-hard drive. When you're saving a document from within a program, you can save it directly onto your iDisk. And because

this backup disk is offsite, if a fire or thief destroys your office and your backup disks, your iDisk is still safe.

Furthermore,you can pull the iDisk onto any computer's screen—MacorWindows—at your office, at your home, at your friend's house, so you don't need to carry around a physical disk to transport important files.

18.6.2.1. Pulling it onto your screen

Apple must really love the iDisk concept, because it has devised about 300 different ways to pull the iDisk icon onto your screen (Figure 18-11):

  • Choose Go rightwards double arrow iDisk rightwards double arrow My iDisk (or press Shift- [image] -I).

  • Click the iDisk icon in the Sidebar (ofa Finder window or a Save or Open dialog box).

  • Choose Go rightwards double arrow Connect to Server. At the bottom of the resulting dialog box, type http://idisk.mac.com/casey(substitute your actual account name for casey). Press Enter. Type your .Mac name and password, if necessary, and then click Connect. (This is the quickest approach if you're using somebody else's Mac.)

    Figure 18-11. Choose GoGo rightwards double arrow iDiskGo rightwards double arrow My iDisk (top) or click the iDisk icon in your Sidebar. When the iDisk finally appears (bottom right), double-click it—and wait—to see its contents (bottom left). Note that you can't create your own folders on this special disk; you must drag your files directly into one of the folders shown here.

  • Visit www.mac.com and click the iDisk icon. Type in your name and password, and then click Enter. Finally, click Open Youri Disk. (Clearly,this is a lot more work

    than the one-click methods already described. Use this technique when you're using a public machine far from home, for example.)

At this point, thei Disk behaves like an external hard drive. You can drag files or folders from your hard drive into one of the folders that appear on the iDisk.

Note: You can't create your own folders in the iDisk's main window. You must put your files and folders into one of the folders already on the iDisk, such as Documents or Pictures. If you try to drag an icon directly into the iDisk window, or onto the iDisk icon, you'll get an error message.

Thereafter, you can retrieve or open whatever you copied to the iDisk. Open one of the folders on it; you can now open, rename, trash, or copy (to your hard drive) whatever you find inside.

18.6.2.2. Making the iDisk fast and synchronized

As you can imagine, copying files to and from a disk on the Internet is slower than copying them between hard drives on the same Mac. The iDisk has a reputation, therefore, of being very slow.

But the iDisk doesn't have to run at the speed of an anesthetized slug. Behind the scenes, Mac OS X can keep a full, invisible copy of the iDisk's contents on your hard drive. When you add something to the iDisk, therefore, it seems to appear there instantly—even when you're not online—because all you've done is copy something onto a secret stash of your own drive. The Mac will begin the process of transmitting the copy to the online iDisk at the next opportunity. In short, you can leave the iDisk's icon onscreen for as long as you like, even when you're offline.

Figure 18-12. To turn on iDisk syncing, open System Preferences, click .Mac, click iDisk, and then turn on iDisk Syncing by clicking the Start button. If you have a broadband connection, leave "Update: Automatically" selected. If you opt for manual synchronization (on a dial-up connection, for example), you have to trigger your own syncs by clicking the button next to the iDisk's name in the Sidebar.

To turn on this feature, see Figure 18-12.

Tip: If you have more than one Mac in different locations (home and office, for example), you can keep your key files synchronized among all of them by turning on this automatic iDisk syncing on all of the machines. You've burned your last "Take Home" CD!
18.6.2.3. The Public folder

In general, whatever you put onto your iDisk is private and password-protected. There's one exception, however: Whatever you put into the Public folder on any iDisk can be seen, opened, and copied by any other .Mac member. All they need is your member name—not your .Mac password (although you can password-protect it, if you like). Think of the iDisk Public folder as the long-lost twin of the Public folder in your own Home folder.

The Public folder is terrific for storing family photos where anyone who's interested can look at them. It's also handy when you're collaborating; just post the latest drafts of your work in the Public folder for your co-workers to review.

To view someone else's Public folder, use one of these techniques; suppose the person's .Mac name is SkiBunny23:

  • From Mac OS X 10.3,10.4,or10.5. Choose Go rightwards double arrow iDisk rightwards double arrow Other User's Public Folder. Type in the person's member name, and hit Return.

  • Mac OS X 10.1 or 10.2. Choose Go rightwards double arrow Connect to Server. At the bottom of the dialog box, type http://idisk.mac.com/skibunny23/Public. Click Connect or press Enter. If a password is required, use public as the user name and, well, the password as the password.

    Tip: Actually, there's a simpler way: Use iDisk Utility, described below.

  • From Mac OS 9. Choose [image] rightwards double arrow Chooser, click Apple Share,click the Server IP Address button, type idisk.mac.com in the Server Address box, and then click Connect. Type skibunny23; for the password, use public (unless the folder really is password protected, in which case you should type the password you were given). Then click Connect. Select the iDisk, and then click OK.

  • From Windows. See the box on the next page.

After a minute or so, a new iDisk icon appears on your desktop, bearing that member's name. Double-click it to view its contents. You can copy these files to your hard drive, or double-click them to open them directly.

18.6.2.4. iDisk options

If you open System Preferences, click the .Mac icon, and click iDisk, you're offered a few interesting options, along with a graph that shows how full your iDisk is getting. Here, you can also make these changes:

  • Let people put stuff in your Public folder. Ordinarily, other people can deposit stuff into your Public folder as well as copy things out. If you'd rather set it up so that only you can drop things in there, click "Read only."

  • Password-protect your Public folder. Probably a good idea if you decide to make your Public folder available for deposits.

Note: These functions are available to pre-Panther/Tiger people (and Windows people too) if they visit www.mac.com, click ".Mac Downloads," sign in, and download the program called iDisk Utility (or iDisk Utility for Windows).

18.6.3. Email

Apple offers an email address to each .Mac member.

Probably anyone who can get to the Apple Web site already has an email account. So why bother? The first advantage is the simple address: YourName@mac.com. And because .Mac is a Mac-only service, the odds are good that you'll be able to claim the name you want. No longer must you be known as bgates28514@earthlink.net. (Cultdom hasits privileges.)

POWER USER'S CLINIC
The iDisk from Windows

Once, you could get to your iDisk only from a Macintosh. These days, you can bring your iDisk onto the screen of any computer, even one running Windows or Linux.

The procedure varies by operating system, but the general idea is the same: You're going to create a new "hard drive" in your My Computer window, whose icon represents the iDisk.

If you have Windows XP and plan to connect regularly, you can download the free iDisk Utility for Windows, which makes pulling up someone's iDisk a simple matter of a couple of clicks. Visit www.mac.com and click .Mac Down-loads to find it.

Otherwise, here are the steps for different Windows versions:

Windows Vista: Open your Web browser. Go to www.mac.com and log in; click iDisk in the left column. A new browser window opens. Type your .Mac name and password, and click Log In.

Windows XP: Choose Tools rightwards double arrow Map Network Drive in any desktop window.

Windows 2000: Choose Tools rightwards double arrow Map Network Drive. Click "Web folder or FTP site."

Windows 98: Open My Computer. Double-click the Web Folders icon; double-click Add Web Folder.

In the XP/2000/98 cases, you should now type in this address as the location to add: http://idisk.mac.com/casey (where casey is your .Mac member name). When you're asked for a name and password, type in your usual .Mac name and password.

After a minute or two, you'll find the icon for your iDisk in the My Computer window, sitting there as though it's a hard drive attached to the PC. In Windows XP, for example, it's in the Network Drives category, called something like "Frank23 on 'idisk.mac.com.'"

Second, Mac.com addresses are integrated into Mac OS X's Mail program, as you'll see in the next chapter. And finally, you can read your .Mac email from any computer anywhere in the world, via the www.mac.com Web site.

18.6.4. HomePage

Creating a Web page (an HTML document) isn't difficult. Using a program like Dreamweaver, GoLive, Netscape Composer, Keynote, or even Microsoft Word, you can design the text and graphics for a simple Web page in a single afternoon.

It's much more difficult, however, to figure out how to post that Web page—to hang it on the Internet where the world can see it. To do that, you need special software, several passwords and codes, and a lot of help from your ISP.

The .Mac HomePage feature eliminates all that hassle. All you have to do is drag your Web-page documents and graphics into the Sites folder on your iDisk. Your Webpage is instantly available for viewing by everyone on the Internet.

Tip: You can create as many Web pages as you want. When you return to the HomePage screen, a list of your existing Web pages appears (complete with Edit Page and Delete Page buttons).

If you already know how to design Web pages, great; put the HTML documents and graphics you've created into the Sites folder of your iDisk.

Then tell your friends its Web address. Suppose that the Web page you designed is called index.html, and that your .Mac member name is SkiBunny. In that case, your custom-designed Web address is http://homepage.mac.com/skibunny/index.html (although most people can leave off everything after your member name).

And if you have no experience designing Web pages, Mac OS X itself can help you:

  • iPhoto and Image Capture can both turn photos from your digital camera into handsome art-gallery Web pages. After they've done so, drag the resulting HTML documents and image folders into your iDisk's Sites folder. Presto! You've got yourself a photo-gallery Web page.

  • Sign into www.mac.com. If you click HomePage, you'll find a large gallery of canned Web site design templates that you can easily fill up and post in cyberspace: photo albums, movie players, résumés, baby announcements, and so on.

When you finally click the Publish button at the top of the screen, new Web page (HTML) documents appear in the Sites folder of your iDisk. Also, your screen now displays your page's URL (Web address), which you can email to anyone who'd be interested. Unfortunately, it's not particularly catchy; it's along the lines of http://homepage.mac.com/YourMemberName/baby.html.

Finally, your Web page is available for anyone on the Internet to see. Corporations and professional Web designers may sniff at the simplicity of the result—but it takes them a lot longer than 10 minutes to do their thing.

18.6.5. Backup

.Mac membership also includes access to a program called Backup, which can give you an effortless, even automatic backup system for your most important files. It's among the easiest-to-use backup program sever written, butit doesn't give you as much peace of mind as Time Machine (Chapter 6), which backs up your entire computer.

For details on Backup, see this chapter's free downloadable appendix. It's on this book's "Missing CD" page at www.missingmanuals.com.

18.6.6. iSync

iSync is the little program that syncs your calendar and address book to your cellphone or Palm organizer. Details are on Section 6.5.


internet_location_files.html

18.7. Internet Location Files

An Internet location file (Figure 18-13) is like a system-wide bookmark: When you double-click one, your Web browser opens to that page, or your email program generates an outgoing message to a predetermined addressee. You could put a folder full of location files for favorite Websites into the Dock. Do the same with addresses to which you frequently send email. There after, you save as tepevery time you want to jump to a particular Web page or send email to a particula rperson—just choose the appropriate name from the Dock folder's Stack. (It's fine to rename them, by the way.)

Figure 18-13. To create an Internet location file, drag a highlighted address from a program like TextEdit to your desktop. Although Web and email addresses are the most popular types, you can also create location files for the addresses of newsgroups (news://news.apple.com), FTP sites (ftp://ftp.apple.com), AppleShare servers (afp://at/Engineering:IL5 3rd Floor), AppleTalk zones (at://IL5 2nd Floor), and even Web pages stored on your Mac (file://MacintoshHD/Website Stuff/home.html).


mail_and_address_book.html

Chapter 19. Mail and Address Book

Email is a fast, cheap, convenient communication medium. In fact, these days, anyone who doesn't have an email address is considered some kind of freak.

If you do have an email address or two, you'll be happy to discover that Mac OS X includes Mail, a program that lets you get and send email messages without having to wade through a lot of spam (junk mail). Mail is a surprisingly complete program, redesigned for Mac OS 10.5, and it's filled with shortcuts and surprises around every turn.

And this desktop post office offers more than just mail—among other things, you can also use the program as a personal notepad and a newsreader for your favorite Web sites.

Not bad for a freebie, eh?

19.1. Setting Up Mail

What you see the first time you open Mail may vary. If you've signed up for a .Mac account (and typed its name into the .Mac pane of System Preferences), you're all ready to go; you see the message viewer window described on Section 19.2.1. If you don't get the offer to set up an account, choose File rightwards double arrow Add Account to jumpstart the process. (That's also how you add other accounts later.)

If you get your mail from some other service provider, like Verizon, Comcast, Gmail, Yahoo, or whatever, Mail setup is almost as easy. Apple has rounded up the acronymladen server settings for 30 popular mail services and built them right in.

All you have to do is type your mail name and password into the box (Figure 19-1). If eMail recognizes the suffix (for example, @gmail.com), and if "Automatically set up account" is turned on, then Mail does the heavy lifting for you.

Figure 19-1. Leopard Mail takes the pain, agony, and acronyms out of setting up an email account on your Mac. Forget about remembering your SMTP server address (or even what SMTP stands for), and just type your email address and password into the box. If you use a mainstream mail provider like Gmail, Hotmail, Yahoo, Comcast, or Verizon, Mail configures your account settings automatically after you click the Create button.

Now, if you use a service provider that Mail doesn't recognize when you type in your email name and password—you weirdo—then you have to set up your mail account the long way. Mail prompts you along, and you confront the dialog boxes shown in Figure 19-2, where you're supposed to type in various settings to specify your email account. Some of this information may require a call to your Internet service provider (ISP).

Here's the rundown:

  • Account Typeis where you specify what flavor of email account you have. See the box on Section 19.2 for details; check with your ISP if you're not sure which type you have.

  • Account Descriptionis for your reference only. If you want an affectionate nickname for your email account, type it here.

  • Full Name(shown in Figure 19-1) will appear in the "From:" field of any email you send. Type it just the way you'd like it to appear.

  • Email Addressis the address you were assigned when you signed up for Internet services, such as billg@microsoft.com.

  • Incoming Mail Server, Outgoing Mail Serverare where you enter the information your ISP gave you about its mail servers. Usually, the incoming server is a POP3 server and its name is related to the name of your ISP, such as popmail.mindspring.com.

    Figure 19-2. These dialog boxes let you plug in the email settings provided by your ISP. If you want to add another email account later, choose File rightwards double arrow Add Account, and then enter your information in the resulting dialog box. (Or, if you like doing things the hard way, choose Mail rightwards double arrow Preferences rightwards double arrow Accounts tab, click the + in the lower-left corner of the window, and enter your account information in the fields on the right.)

    The outgoing mail server (also called the SMTP server) usually looks something like mail.mindspring.com.

  • Outlook Web Access Serverappears only if you choose Exchange for the Account Type. You can get the name of this server (also known as an Internet Information Server, or IIS) from your network administrator.

  • User Name, Password. Enter the name and password provided by your ISP. (Often, they're the same for both incoming and outgoing servers.)

Click Continue when you're finished.

Mail can also import your email collection from an email program you've used before— Entourage, Thunderbird, Netscape/Mozilla, Eudora, or even a version of Mac OS X Mail that's stored somewhere else (say, on an old Mac's hard drive). Importing is a big help in making a smooth transition between your old email world and your new one.

Figure 19-3. If you go to File rightwards double arrow Import Mailboxes, Mail offers to import your old email collection from just about any other Mac email program (top). You can even specify which email folders you want to import (bottom). When the importing process is finished—and it can take a very long time—you'll find precisely the same folders set up in Mail.

To bring over your old mail and mailboxes, choose File rightwards double arrow Import Mailboxes. Figure 19-3 has the details.

UP TO SPEED
POP, IMAP, Exchange, and Web-based Mail

When it comes to email, there are four primary flavors of servers (Internet computers that process email):POP (also known as POP3), IMAP (also known as IMAP4), Exchange, and Web-based. Each has its own distinct taste, with different strengths and weaknesses. (AOL mail could be considered a fifth kind, but if you follow the instructions at http://members.aol.com/adamkb/aol/mailfaq/imap/applemail.html, you can read your AOL mail as if it came from a regular IMAP account.)

POP accounts(Post Office Protocol) are the most common kind on the Internet. A POP server transfers your incoming mail to your hard drive before you read it, which works fine as long as you're only using one computer to access your email.

If you want to take your email along on the road, you have to copy the Mail folder from your Home rightwards double arrow Library folder into the corresponding location on your laptop's hard drive. That way, when you run Mail on the laptop, you'll find your messages and attachments already in place.

IMAP servers (Internet Message Access Protocol) are newer and have more features than POP servers, but aren't as common. IMAP servers keep all of your mail online, rather than making you store it on your hard drive; as a result, you can access the same mail regardless of the computer you use. IMAP servers remember which messages you've read and sent, to boot. It's a great setup if, for example, you check your email on an iPhone, because the deletions and replies you process on the phone will be there on your Mac when you get home.

(Your Mac.com account is an IMAP account, which is why you can access the mail in your Inbox repeatedly from any Mac in the world, anywhere you go. You can opt for a Gmail account to be an IMAP account, too.)

One downside to this approach, of course, is that you can't delete your email—or read it for the first time—unless you're online, because all of your mail is on an Internet server. Another disadvantage is that if you don't conscientiously manually delete mail after you've read it, your online mail-box eventually overflows. Sooner or later, the system starts bouncing new messages back to their senders, annoying your friends.

Exchange servers are are popular in corporations and some schools. Most of the time, employees tap into these servers using a Windows program like Outlook. Corporate geeks like Exchange servers because they're easy to set up and maintain, and because they offer many of the same features as IMAP servers. Luckily, Mail can read and send email through Exchange servers as though your Mac were just another beige PC.

Free, Web-based services like Hotmail, Yahoo, and Gmail also store your mail on the Internet, but you can use a Web browser on any computer to read and send messages. They're slower and more cumbersome to use than "regular" email accounts, but they're usually free. Unfortunately, Mail can't check accounts that are entirely Web-based.

Fortunately, the big name Web-based email services also offer POP or IMAP servers. If you have a .Mac account, for example, you'll find that you can read your email using either a Web browser or Mail (which, in the background, taps into the .Mac IMAP server). Same goes for Google's Gmail service, which lets you check your email either on the Web—or using either a POP or IMAP server (see Gmail's help pages for details on making that work).

Conversely, more and more POP and IMAP accounts are also offering a Web-based component. For example, whoever provides your Internet service—EarthLink, Verizon, or Speakeasy, for instance—probably provides both POP service and a Web-based way of accessing your email, so you can access your mail either from home or from an Internet café in Bangladesh.

All Mail cares about, though, is whether your email account allows POP, IMAP, or Exchange access; what you do on the Web is, as far as Mail is concerned, your own business.


setting_up_mail.html

Chapter 19. Mail and Address Book

Email is a fast, cheap, convenient communication medium. In fact, these days, anyone who doesn't have an email address is considered some kind of freak.

If you do have an email address or two, you'll be happy to discover that Mac OS X includes Mail, a program that lets you get and send email messages without having to wade through a lot of spam (junk mail). Mail is a surprisingly complete program, redesigned for Mac OS 10.5, and it's filled with shortcuts and surprises around every turn.

And this desktop post office offers more than just mail—among other things, you can also use the program as a personal notepad and a newsreader for your favorite Web sites.

Not bad for a freebie, eh?

19.1. Setting Up Mail

What you see the first time you open Mail may vary. If you've signed up for a .Mac account (and typed its name into the .Mac pane of System Preferences), you're all ready to go; you see the message viewer window described on Section 19.2.1. If you don't get the offer to set up an account, choose File rightwards double arrow Add Account to jumpstart the process. (That's also how you add other accounts later.)

If you get your mail from some other service provider, like Verizon, Comcast, Gmail, Yahoo, or whatever, Mail setup is almost as easy. Apple has rounded up the acronymladen server settings for 30 popular mail services and built them right in.

All you have to do is type your mail name and password into the box (Figure 19-1). If eMail recognizes the suffix (for example, @gmail.com), and if "Automatically set up account" is turned on, then Mail does the heavy lifting for you.

Figure 19-1. Leopard Mail takes the pain, agony, and acronyms out of setting up an email account on your Mac. Forget about remembering your SMTP server address (or even what SMTP stands for), and just type your email address and password into the box. If you use a mainstream mail provider like Gmail, Hotmail, Yahoo, Comcast, or Verizon, Mail configures your account settings automatically after you click the Create button.

Now, if you use a service provider that Mail doesn't recognize when you type in your email name and password—you weirdo—then you have to set up your mail account the long way. Mail prompts you along, and you confront the dialog boxes shown in Figure 19-2, where you're supposed to type in various settings to specify your email account. Some of this information may require a call to your Internet service provider (ISP).

Here's the rundown:

  • Account Typeis where you specify what flavor of email account you have. See the box on Section 19.2 for details; check with your ISP if you're not sure which type you have.

  • Account Descriptionis for your reference only. If you want an affectionate nickname for your email account, type it here.

  • Full Name(shown in Figure 19-1) will appear in the "From:" field of any email you send. Type it just the way you'd like it to appear.

  • Email Addressis the address you were assigned when you signed up for Internet services, such as billg@microsoft.com.

  • Incoming Mail Server, Outgoing Mail Serverare where you enter the information your ISP gave you about its mail servers. Usually, the incoming server is a POP3 server and its name is related to the name of your ISP, such as popmail.mindspring.com.

    Figure 19-2. These dialog boxes let you plug in the email settings provided by your ISP. If you want to add another email account later, choose File rightwards double arrow Add Account, and then enter your information in the resulting dialog box. (Or, if you like doing things the hard way, choose Mail rightwards double arrow Preferences rightwards double arrow Accounts tab, click the + in the lower-left corner of the window, and enter your account information in the fields on the right.)

    The outgoing mail server (also called the SMTP server) usually looks something like mail.mindspring.com.

  • Outlook Web Access Serverappears only if you choose Exchange for the Account Type. You can get the name of this server (also known as an Internet Information Server, or IIS) from your network administrator.

  • User Name, Password. Enter the name and password provided by your ISP. (Often, they're the same for both incoming and outgoing servers.)

Click Continue when you're finished.

Mail can also import your email collection from an email program you've used before— Entourage, Thunderbird, Netscape/Mozilla, Eudora, or even a version of Mac OS X Mail that's stored somewhere else (say, on an old Mac's hard drive). Importing is a big help in making a smooth transition between your old email world and your new one.

Figure 19-3. If you go to File rightwards double arrow Import Mailboxes, Mail offers to import your old email collection from just about any other Mac email program (top). You can even specify which email folders you want to import (bottom). When the importing process is finished—and it can take a very long time—you'll find precisely the same folders set up in Mail.

To bring over your old mail and mailboxes, choose File rightwards double arrow Import Mailboxes. Figure 19-3 has the details.

UP TO SPEED
POP, IMAP, Exchange, and Web-based Mail

When it comes to email, there are four primary flavors of servers (Internet computers that process email):POP (also known as POP3), IMAP (also known as IMAP4), Exchange, and Web-based. Each has its own distinct taste, with different strengths and weaknesses. (AOL mail could be considered a fifth kind, but if you follow the instructions at http://members.aol.com/adamkb/aol/mailfaq/imap/applemail.html, you can read your AOL mail as if it came from a regular IMAP account.)

POP accounts(Post Office Protocol) are the most common kind on the Internet. A POP server transfers your incoming mail to your hard drive before you read it, which works fine as long as you're only using one computer to access your email.

If you want to take your email along on the road, you have to copy the Mail folder from your Home rightwards double arrow Library folder into the corresponding location on your laptop's hard drive. That way, when you run Mail on the laptop, you'll find your messages and attachments already in place.

IMAP servers (Internet Message Access Protocol) are newer and have more features than POP servers, but aren't as common. IMAP servers keep all of your mail online, rather than making you store it on your hard drive; as a result, you can access the same mail regardless of the computer you use. IMAP servers remember which messages you've read and sent, to boot. It's a great setup if, for example, you check your email on an iPhone, because the deletions and replies you process on the phone will be there on your Mac when you get home.

(Your Mac.com account is an IMAP account, which is why you can access the mail in your Inbox repeatedly from any Mac in the world, anywhere you go. You can opt for a Gmail account to be an IMAP account, too.)

One downside to this approach, of course, is that you can't delete your email—or read it for the first time—unless you're online, because all of your mail is on an Internet server. Another disadvantage is that if you don't conscientiously manually delete mail after you've read it, your online mail-box eventually overflows. Sooner or later, the system starts bouncing new messages back to their senders, annoying your friends.

Exchange servers are are popular in corporations and some schools. Most of the time, employees tap into these servers using a Windows program like Outlook. Corporate geeks like Exchange servers because they're easy to set up and maintain, and because they offer many of the same features as IMAP servers. Luckily, Mail can read and send email through Exchange servers as though your Mac were just another beige PC.

Free, Web-based services like Hotmail, Yahoo, and Gmail also store your mail on the Internet, but you can use a Web browser on any computer to read and send messages. They're slower and more cumbersome to use than "regular" email accounts, but they're usually free. Unfortunately, Mail can't check accounts that are entirely Web-based.

Fortunately, the big name Web-based email services also offer POP or IMAP servers. If you have a .Mac account, for example, you'll find that you can read your email using either a Web browser or Mail (which, in the background, taps into the .Mac IMAP server). Same goes for Google's Gmail service, which lets you check your email either on the Web—or using either a POP or IMAP server (see Gmail's help pages for details on making that work).

Conversely, more and more POP and IMAP accounts are also offering a Web-based component. For example, whoever provides your Internet service—EarthLink, Verizon, or Speakeasy, for instance—probably provides both POP service and a Web-based way of accessing your email, so you can access your mail either from home or from an Internet café in Bangladesh.

All Mail cares about, though, is whether your email account allows POP, IMAP, or Exchange access; what you do on the Web is, as far as Mail is concerned, your own business.


checking_your_mail.html

19.2. Checking Your Mail

You get new mail and send mail you've already written using the Get Mail command. You can trigger it in any of several ways:

  • Click Get Mail on the toolbar.

  • Choose Mailbox rightwards double arrow Get All New Mail (or press Shift- [image] -N).

    Note: If you have multiple email accounts, you can also use the Mailbox rightwards double arrow Get New Mail submenu to pick just one account to check for new mail.

  • Control-click (or right-click) Mail's Dock icon, and choose Get New Mail from the shortcut menu. (You can use this method from within any program, as long as Mail is already open.)

  • Wait. Mail comes set to check your email automatically every few minutes. To adjust its timing or turn this feature off, choose Mail rightwards double arrow Preferences, click General, and then choose a time interval from the "Check for new mail" pop-up menu.

Now Mail contacts the mail servers listed in the Accounts pane of Mail's preferences, retrieving new messages and downloading any files attached to those messages. It also sends any outgoing messages that couldn't be sent when you wrote them.

Tip: The far-left column of the Mail window has a tiny Mail Activity monitor tucked away; click the square icon at the bottom of the Mail window to reveal Mail Activity. If you don't want to give up window real estate, or you prefer to monitor your mail in a separate window, you can do that, too. The Activity Viewer window gives you a Stop button, progress bars, and other useful information. Summon it by choosing Window rightwards double arrow Activity Viewer, or by pressing [image] -0.Also, if you're having trouble connecting to some (or all) of your email accounts, choose Window rightwards double arrow Connection Doctor. There, you can see detailed information about which of your accounts aren't responding. If your computer's Internet connection is at fault, you can click Assist Me to try to get back online.

19.2.1. The Mailboxes List

If you've used earlier versions of Mail, the first thing that you'll notice in Leopard is that the Mailbox panel isn't just for mailboxes anymore. Categories like Reminders and RSS Feeds can appear there, too, as shown in Figure 19-4. But the top half of this gray-blue column on the left side lists all your email accounts' folders (and subfolders, and sub-subfolders) for easy access. Mail now looks quite a bit like iTunes (and iPhoto, and the Finder)—except here you have mailboxes where your iTunes library and connected iPods would be.

In the Mailboxes panel, sometimes hidden by flippy triangles, you may find these folders:

  • Inbox holds mail you've received. If you have more than one email account, you can expand the triangles to see separate folders for your individual accounts. You'll see this pattern repeated with the Sent, Junk, and other mailboxes, too—separate accounts have separate subheadings.

    Tip: If Mail has something to tell you about your Inbox (like, for instance, that Mail can't connect to it), a tiny warning triangle appears on the right side of the Mailboxes column. Click it to see what Mail is griping about.If you see a lightning-bolt icon, that's Mail's way of announcing that you're offline. Click the icon to try to connect to the Internet.

    Figure 19-4. If you've ever used iTunes, you'll notice a lot of similarities with the Mail window. All your information sources— mailboxes, notes, To Do items, and RSS Feeds—are grouped tidily in the far left column where you can always see them. Buttons along the top of the Mail window let you create new messages, notes, and tasks with a click. To see what's in one of these folders, click it once. The list of its messages appears in the top half of the right side of the window (the Messages list). When you click a message name, the message itself appears in the bottom half of the main window (the Preview pane).

  • Outboxholds mail you've written but haven't yet sent (because you were on an airplane when you wrote it, for example). If you have no mail waiting to be sent, the Outbox itself disappears.

  • Draftsholds messages you've started but haven't yet finished, and don't want to send just yet.

  • Sent, unsurprisingly, holds copies of messages you've sent.

  • Trash works a lot like the Trash on your desktop, in that messages you put there don't actually disappear. They remain in the Trash folder until you permanently delete them or move them somewhere else—or until Mail's automatic trash cleaning service deletes them for you (Section 19.5.11.2).

  • Junk appears automatically when you use Mail's spam filter, as described later in this chapter.

  • On My Macis a folder on your Mac for your mail-filing convenience. You can set these folders up yourself (Section 19.5.6).

    This handy panel isn't just for mailboxes,. It's also a hangout for other information that Mail corrals, including:

  • Reminders. Any Notes you've jotted down while working in Mail are here. (See Section 19.8 for notes on Notes.) To Do items hang out here as well (Section 21.16).

  • RSS Feeds.Who needs to bop into a Web browser to keep up with the news? Mail brings it right to you while you're corresponding. Section 19.7 explains how to set up RSS feeds in Mail.

  • Mail Activity. You don't need to summon a separate window to see how much more of that message with the giant attachment the program still has to send. To reveal the Mail activity panel, click the middle icon in the bottom left side of the Mail window (Figure 19-5).

Figure 19-5. The many panes of Mail. Click an icon in the Mailboxes column to see its contents in the Messages list. When you click the name of a message in the Messages list (or press the upwards arrow and downwards arrow keys to highlight successive message names in that list), you see the message itself, along with any attachments, in the Preview pane. Click one of the column headings (From, Subject, and so on) to sort your mail collection by that criterion.


writing_messages.html

19.3. Writing Messages

To send an email, click New in the toolbar or press [image] -N. The New Message form, shown in Figure 19-6, opens. Here's how you go about writing a message:

  1. In the "To:" field, type the recipient's email address.

    If somebody is in your Address Book (Section 5.13.3.2), type the first couple of letters of the name or email address; Mail automatically completes the address. (If the first guess is wrong, type another letter or two until Mail revises its guess.)

    Tip: If you find Mail constantly tries to autofill in the address of someone you don't really communicate with, you can zap that address from its memory by choosing Window rightwards double arrow Previous Recipients. Click the undesired address, and then click Remove From List.

    As in most dialog boxes, you can jump from blank to blank (from the "To:" field to the "Cc:" field, for example) by pressing the Tab key.

    GEM IN THE ROUGH
    The Mighty Morphing Interface

    You don't have to be content with the factory-installed design of the Mail screen. You can control almost every aspect of its look and layout.

    For example, you can control the main window's information columns exactly as you would in a Finder list view window—make a column narrower or wider by dragging the right edge of its column heading, rearrange the columns by dragging their titles, and so on.

    You can also control which columns appear using the commands in the View rightwards double arrow Columns menu. Similarly, you can sort your email by clicking these column headings, exactly as in the Finder. Click a second time to reverse the sorting order.

    The various panes of the main window are also under your control. For example, you can drag the divider bar between the Messages list and the Preview pane up or down to adjust the relative proportions, as shown here. In fact, you can get rid of the Preview pane altogether by double-clicking the divider line, double-clicking just above the vertical scroll bar, or dragging the divider line's handle all the way to the bottom of the screen. Bring it back by dragging the divider line up from the bottom.

    You can also control the Mailboxes pane. Drag its thin vertical line that separates this tinted column from the white messages area to make the column wider or narrower. You can even drag it so tightly that you see only the mailboxes' icons. You can make the column disappear or reappear by choosing View rightwards double arrow Hide Mailboxes (or View rightwards double arrow Show Mailboxes), or by pressing Shift- [image] -M.

    Finally, you have full control over the toolbar, which works much like the Finder toolbar. You can rearrange or remove icon buttons (by [image] -dragging them); add interesting new buttons to the toolbar (by choosing View rightwards double arrow Customize Toolbar); change its display to show just text labels or just icons—either large or small (by repeatedly [image] -clicking the white, oval, upper-right toolbar button); or hide the toolbar entirely (by clicking that white button or using the View rightwards double arrow Hide Toolbar command).

    If you want to send this message to more than one person, separate their addresses with commas: bob@earthlink.net, billg@microsoft.com, steve@apple.com.

    Tip: If you send most of your email to addresses within the same organization (like reddelicious@apple.com, grannysmith@apple.com, and winesap@apple.com), Mail can automatically turn all other email addresses red. It's a feature designed to avoid sending confidential messages to outside addresses.To turn this feature on, choose Mail rightwards double arrow Preferences, click Composing, turn on "Mark addresses not ending with," and then type the "safe" domain (like apple.com) into the blank.

    Figure 19-6. A message has two sections: the header, which holds information about the message; and the body, the big empty area that contains the message itself. In addition, the Mail window has a toolbar, which offers features for composing and sending messages. The Signature pop-up menu doesn't exist until you create a signature (Section 22.1); the Account pop-up menu lets you pick which email address you'd like to send the message from (if you have more than one email address).

  2. To send a copy to other recipients, enter their address(es) in the "Cc:" field.

    Cc stands for carbon copy. Getting an email message where your name is in the "Cc:" line implies: "I sent you a copy because I thought you'd want to know about this correspondence, but I'm not expecting you to reply."

    Tip: If Mail recognizes the address you type into the "To:" or "Cc:" box (because it's someone in your Address Book, for instance), the name turns into a shaded, round-ended box button. Besides looking cool, these buttons have a small triangle on their right; when you click it, you get a list of useful commands (including Open in Address Book).These buttons are also drag-and-droppable. For example, you can drag one from the "To:" box to the "Cc:" field, or from Address Book to Mail.

  3. Type the topic of the message in the Subject field.

    It's courteous to put some thought into the Subject line. (Use "Change in plans for next week," for instance, instead of "Yo.") And leaving it blank only annoys your recipient. On the other hand, don't put the entire message into the Subject line, either.

  4. Specify an email format.

    There are two kinds of email: plain text and formatted (which Apple calls Rich Text). Plain text messages are faster to send and open, are universally compatible with the world's email programs, and are greatly preferred by many veteran computer fans. And even though the message itself is plain, you can still attach pictures and other files. (If you want to get really graphic with your mail, you can also use the Stationery option, which gives you preformatted message templates to drop in pictures, graphics, and text. Flip to Section 19.4 for more on using stationery.)

    Resourceful geeks have even learned how to fake some formatting in plain messages: They use capitals or asterisks instead of bold formatting (*man* is he a GEEK!),"smileys"like this— :-) —instead of pictures, and pseudo-underlines for emphasis (I _love_ Swiss cheese!).

    By contrast, formatted messages sometimes open slowly, and in some email programs the formatting doesn't come through at all.

    To control which kind of mail you send on a message-by-message basis, choose, from the Format menu, either Make Plain Text or Make Rich Text. To change the factory setting for new outgoing messages, choose Mail rightwards double arrow Preferences; click the Composing icon; and choose from the Message Format pop-up menu.

    Tip: If you plan to send formatted mail, remember that your recipients won't see the fonts you use unless their machines have the same ones installed. Bottom line: For email to Mac and Windows fans alike, stick to universal choices like Arial, Times, and Courier.

  5. Type your message in the message box..

    You can use all standard editing techniques, including copy and paste, drag-and drop, and so on. If you selected the Rich Text style of email, you can use word processor–like formatting (Figure 19-7).

    As you type, Mail checks your spelling, using a dotted underline to mark questionable words (also shown in Figure 19-7). To check for alternative spellings for a suspect word, Control-click it. From the list of suggestions in the shortcut menu, click the word you really intended, or choose Learn Spelling to add the word to the Mac OS X dictionary.

    Tip: Adding a word to the dictionary in Mail also adds it to the dictionaries of all other programs that use the global Mac OS X spelling checker, and vice versa. In other words, you don't have to teach "speciation" to Mail, Safari, and TextEdit—only to one of them.(To turn off automatic spell check, choose Edit rightwards double arrow Spelling and Grammar rightwards double arrow Check Spelling rightwards double arrow Never. Or, if you'd prefer for Mail to wait until you're done composing your messages before spell checking, choose Edit rightwards double arrow Check Spelling rightwards double arrow Before Sending.)

    Figure 19-7. If you really want to use formatting, click the Fonts icon on the toolbar to open the Font panel, or the Colors icon to open the Color Picker (Section 5.13). The Format menu (in the menu bar) contains even more controls: paragraph alignment (left, right, or justify), and even Copy and Paste Style commands that let you transfer formatting from one block of text to another.

    If you're composing a long email message, or if it's one you don't want to send until later, click the Save as Draft button, press [image] -S, or choose File rightwards double arrow Save As Draft. You've just saved the message in your Drafts folder. It'll still be there the next time you open Mail. To reopen a saved draft later, click the Drafts icon in the Mailboxes column and then double-click the message that you want to work on.

  6. Click Send (or press Shift- [image] -D).

    Mail sends the message. (If you have a dial-up modem, it dials, squeals, and connects first.)

    Tip: To resend a message you've already sent, Option-double-click the message in your Sent mailbox. Mail dutifully opens up a brand-new duplicate, ready for you to edit, readdress if you like, and then send again.(The prescribed Apple route is to highlight the message and then choose Message rightwards double arrow Send Again, but that's not nearly as much fun.)

    If you'd rather have Mail place each message you write in the Outbox folder instead of connecting to the Net when you click Send, choose Mailbox rightwards double arrow Take All Accounts Offline. While you're offline, Mail refrains from trying to connect, which is a great feature when you're working on a laptop at 39,000 feet. (Choose Mailbox rightwards double arrow Take All Accounts Online to reverse the procedure.)

    UP TO SPEED
    Bcc, Reply-to, and Priority

    A blind carbon copy is a secret copy. This feature lets you send a copy of a message to somebody secretly, without any of the other recipients knowing that you did so. To view this field when composing a message, choose View rightwards double arrow Bcc Address Field.

    You can use the "Bcc:" field to quietly signal a third party that a message has been sent. For example, if you send your coworker a message that says, "Chris, it bothers me that you've been cheating the customers," you could Bcc your supervisor to clue her in without getting into trouble with Chris.

    The "Bcc:" box is useful in other ways, too. Many people send email messages (corny jokes, for example) to a long list of recipients. You, the recipient, have to scroll through a very long list of names the sender placed in the "To:" or "Cc:" field.

    But if the sender used the "Bcc:" field to hold all the recipients' email addresses, you, the recipient, won't see any names but your own at the top of the email. (Spammers have also learned this trick, which is why it usually looks like you're the only recipient of junk messages when there are actually millions of other people who received the same message.)

    Another hidden field you can add to your messages is Reply-To. (Choose View rightwards double arrow Reply-To Address Field.) That field has one simple purpose: to make the recipient's email program reply to a different email address than the one you sent the message from. For example, if your business email address isn't working but you absolutely have to send a field report to your boss, you can send the message from your personal email account but put your business address in the Reply-To field. That way, when your boss emails you back to congratulate you, the email goes to your business account.

    Finally, if you click the three-line pop-up button on the left side of an email message and choose Customize, you can enable one more hidden header option: Priority. (It's the pop-up menu with an exclamation mark in it.) If you turn on the check box next to that pop-up menu and click OK, all your email messages let you set how important they are on a three-tiered scale.

    The good part about this system is that it lets your recipient see that an email you've sent is, for example, urgent. The bad part is that not every email program displays the priority of email—and even if your recipient's email program does display your message's priority, there's no guarantee that it'll make him respond any faster.

19.3.1. Attaching Files to Messages

Sending little text messages is fine, but it's not much help when you want to send somebody a photograph, a sound, or a Word document. To attach a file to a message you've written, use one of these methods:

  • Drag the icons you want to attach directly off the desktop (or out of a folder) into the New Message window. There your attachments appear with their own hyperlinked icons (shown in Figure 19-7), meaning that your recipient can simply click to open them. recipient's ISP for being too big.

    Tip: Exposé was born for this moment. Hit the F11 key to make all open windows flee to the edges of the screen, revealing the desktop. Root around until you find the file you want to send. Begin dragging it; without releasing the mouse, press F11 again to bring your message window back into view. Complete your drag into the message window.

    Mail makes it look as though you can park the attached file's icon (or the full image of a graphics file) inside the text of the message, mingled with your typing. Don't be fooled, however; on the receiving end, all of the attachments will be clumped together at the end of the message (unless your recipient also uses Mail or you've sent pictures with Stationery as described on Section 19.4).

    POWER USERS' CLINIC
    Attachment Tricks

    Nowadays, what's attached to an email message is often more important than the message itself. You might send a PowerPoint file to a co-worker or send your aunt a picture of your new dog, for example, without bothering to write anything more than "See attached" in the body of the message.

    That's why it's such a pain when email attachments don't go through properly—or when they're too big to send at all. Luckily, Mac OS X now provides three tools for making attachments smaller and more compatible with Windows, so you'll never get another angry "I can't see attached!" reply again.

    If you're sending images along with your message, you can shrink them down right in Mail. Use the Image Size pop-up menu in the lower-right corner of the window to pick a smaller size for the images (like Medium or Small).

    You can keep tabs on the total size of your attachments in the lower-left corner of the window, too. Ideally, you should keep the total under 2 MB, so dial-up users don't get annoyed—and so your message doesn't get rejected by your recipient's ISP for being too big.

    Use the Finder to compress big files before you send them. As described on Section 5.12, the Finder creates zip-compressed files, which generally take up much less space than the originals.

    You can pick from two different formats for your attachments: normal or Windows-friendly. Normal attachments open correctly on both Macs and PCs. Trouble is, a normal attachment may show up on a PC accompanied by a useless second attachment whose name starts with "._". (Your recipients should just ignore it.)

    Windows-friendly attachments, on the other hand, always work correctly on PCs—but may not open at all on Macs. Unless you work in an all-Windows company, then, stick with the normal setting.

    To use the Windows-friendly setting for an open message, choose Edit rightwards double arrow Attachments rightwards double arrow Send Windows Friendly Attachments. (If no message is open, the command says "Always Send Windows Friendly Attachments" instead). You can also adjust the setting on a per-email basis using the Send Windows Friendly Attachments checkbox at the bottom of the attachment dialog box.

  • Drag the icons you want to attach from the desktop onto Mail's Dock icon. Mail dutifully creates a new, outgoing message, with the files already attached.

  • Click the Attach icon on the New Message toolbar, choose File rightwards double arrow Attach File, or press Shift- [image] -A. The standard Open File sheet now appears, so that you can navigate to and select the files you want to include. (You can choose multiple files simultaneously in this dialog box. Just [image] -click or Shift-click the individual files you want as though you were selecting them in a Finder window.)

    Once you've selected them, click Choose File (or press Enter). You return to the New Message window, where the attachments' icons appear, ready to ride along when you send the message.

To remove an attachment, drag across its icon to highlight it, and then press the Delete key. (You can also drag an attachment icon clear out of the window into your Dock's Trash, or choose Message rightwards double arrow Remove Attachments.)

If you have a high-speed connection like a cable modem, by the way, have pity on your recipient. A big picture or movie file might take you only seconds to send, but tie up your correspondent's modem for hours.

19.3.2. Signatures

Signatures are bits of text that get stamped at the bottom of your outgoing email messages. A signature might contain a name, a postal address, a pithy quote, or even a scan of your real signature, as shown in Figure 19-8.

You can customize your signatures by choosing Mail rightwards double arrow Preferences, and then clicking the Signatures icon. Here's what you should know:

  • To build up a library of signatures that you can use in any of your accounts: Select All Signatures in the leftmost pane, and then click the + button to add each new signature (Figure 19-8, top). Give each new signature a name in the middle pane, and then customize the signatures' text in the rightmost pane (Figure 19-8, bottom).

    Tip: If you ever get tired of a signature, you can delete it forever by selecting All Signatures rightwards double arrow [your signature's name], clicking the – button, and then clicking OK.

  • To make a signature available in one of your email accounts: Drag the signature's name from the middle pane onto the name of the account in the leftmost pane. In other words, you can make certain signatures available to only your work (or personal) account, so you never accidentally end up appending your secret FBI contact signature to the bottom of a birthday invitation you send out.

  • To assign a particular signature to one account: In the left pane, click an account; choose from the Choose Signature pop-up menu. Each time you compose a message from that account, Mail inserts the signature you selected.

    Tip: To make things more interesting for your recipients, pick At Random; Mail selects a different signature each time you send a message. Or, if you're not that much of a risk-taker, choose In Sequential Order; Mail picks the next signature in order for each new message you write.

    Figure 19-8. Top: Your library of signatures. Click the + button to add a new signature.
    Bottom: After giving your signature a name in the middle pane and typing your signature's text on the right, don't miss the Format menu, which you can use to dress up your signature with colors and other formatting. You can even paste a picture into the signature box. Click OK when you're finished. (You'll be able to use formatted signatures only if you're sending Rich Text messages, of course.)

    Remember, that you can always change your signature on a message-by-message basis, using the Signature pop-up menu in any new email message.

  • To use the signature feature as a prefix in replies: Turn on "Place signature above quoted text." If you turn on this setting, your signature gets inserted above any of the text that you're replying to, rather than below. You'd use this setting if your "signature" said something like, "Hi there! You wrote this to me—".

    Tip: If you're into consistent typographical styling, also turn on "Always match my default font." That setting makes sure any messages you send contain the signature in the same font as the rest of the message, lending an air of professionalism to your message.


stationery.html

19.4. Stationery

Rich text—and even plain text—messages are fine for your everyday personal and business correspondence. After all, you really won't help messages like "Let's have a meeting on those third-quarter earnings results" much by adding visual bells and whistles.

But suppose you have an occasion where you want to jazz up your mail, like an electronic invitation to a bridal shower or a mass-mail update as you get your kicks down Route 66.

These messages just cry out for Mail's new Stationery feature. Stationery means colorful, predesigned mail templates that you make your own by dragging in photos from your own collection. Those fancy fonts and graphics will certainly get people's attention when they open the message.

Note: They will, that is, if their email programs understand HTML formatting. That's the formatting that Mail uses for its stationery. (If the nerd-word HTML rings a bell, it's because this HyperText Markup Language is the same used to make many Web pages so lively and colorful.)It might be a good idea to make sure everyone on your recipient list has a mail program that can handle HTML; otherwise, your message may look like a jumble of code and letters in the middle of the screen.

To make a stylized message with Mail Stationery:

  1. Create a new message.

    Click File rightwards double arrow New Message, press [image] -N, or click the New Message button on the Mail window toolbar. The choice is up to you.

  2. On the right side of the toolbar on the New Message window, click Show Stationery.

    A panel opens up, showing you all the available templates, in categories like "Birthday" and "Announcements."

  3. Click a category, and then click a stationery thumbnail image to apply it to your message.

    The body of your message changes to take on the look of the template.

  4. If you like what you see, click the Hide Stationery button on the toolbar to fold up the stationery-picker panel.

    Tip: If you don't like the background color, try clicking the thumbnail; some templates offer a few different color choices.

    Now, without question, Apple's canned stationery looks fantastic. The only problem is, the photos that adorn most of the templates are pictures of somebody else's family and friends. Unless you work for Apple's modeling agency, you probably have no clue who they are.

    Fortunately, it's easy enough to replace those placeholder photos with your own snaps.

  5. Add and adjust pictures.

    Click the Photo Browser icon on the message toolbar to open up a palette that lists all the photos you've stored in iPhoto, Aperture, and Photo Booth (Figure 19-9).

    Tip: If you don't keep your pictures in any of those programs, you can drag any folder of pictures onto the Photo Browser window to add them.

    Figure 19-9. To use Stationery, start by clicking a template, then add your own text in place of the generic copy that comes with the template.
    Click the Photo Browser button at the top of the message window to open your Mac's photo collections (shown at right), and then drag the images you want into the picture boxes on the stationery template. You don't have to know a lick of HTML to use the templates—it's all drag, drop, and type, baby.

    Now you can drag your own pictures directly onto Apple's dummy photos on the stationery template. They replace the sunny models.

    To resize a photo in the template, double-click it. A slider appears that lets you adjust the photo's size within the message. Drag the mouse around the photo window to reposition the picture relative to its frame.

  6. Select the fake text and type in what you really want to say.

    Unless you're writing to your Latin students, of course, in which case "Duis nonsequismodol oreetuer iril dolore facidunt" might be perfectly appropriate.

    In any case, as you type over the dummy text, your words are autoformatted to match the template design.

Once you've got that message looking the way you want it, address it just as you would any other piece of mail, and click the Send button to get it on its way.

Tip: You're not stuck with Apple's designs for your Stationery templates; you can make your own. Just make a new message, style the fonts and photos the way you want them, and then choose File rightwards double arrow Save as Stationery. You can now select your masterwork in the Custom category, which appears down at the end of the list in the stationery-picker panel.

If you decide that the message would be better off as plain old text, click Show Stationery on the message window. In the list of template categories, click Stationery and then Original to strip the color and formats out of the message.

Tip: If you find you're using one or two templates a lot (if, for example, all your friends are having babies these days), drag your frequently used templates into the Favorites category so you don't have to go wading around for them.To remove one from Favorites, click it, and then click the [image] in the top-left corner of the thumbnail.


reading_email.html

19.5. Reading Email

Mail puts all incoming email into your Inbox; the statistic after the word Inbox lets you know how many messages you haven't yet read. New messages are also marked with light blue dots in the main list.

Tip: The Mail icon in the Dock also shows you how many new messages you have waiting; it's the number in the red circle.

Click the Inbox folder to see a list of received messages. If it's a long list, press Control-Page Up and Control-Page Down to scroll. Click the name of a message once to read it in the Preview pane, or double-click a message to open it into a separate window. (If a message is already selected, pressing Return or Enter also opens its separate window.)

Tip: Instead of reading your mail, you might prefer to have Mac OS X read it to you, as you sit back in your chair and sip a strawberry daiquiri. Highlight the text you want to hear (or choose Edit rightwards double arrow Select All), and then choose Edit rightwards double arrow Speech rightwards double arrow Start Speaking. You'll hear the message read aloud, in the voice you've selected on the Speech pane of System Preferences (Section 4.5.1).To stop the insanity, choose Edit rightwards double arrow Speech rightwards double arrow Stop Speaking.

Once you've viewed a message, you can respond to it, delete it, print it, file it, and so on. The following pages should get you started.

19.5.1. Threading

Threading is one of the most useful mail-sorting methods to come along in a long time—and it's available in Mail. When threading is turned on, Mail groups emails with the same subject (like "Raccoons" and "Re: Raccoons") as a single item in the main mail list.

To turn on threading, choose View rightwards double arrow Organize by Thread. If several messages have the same subject, they all turn light blue to indicate their membership in a thread (Figure 19-10).

Here are some powerful ways to use threading:

  • View a list of all the messages in a thread by clicking its heading. In the Preview pane, you see a comprehensive inventory of the thread (Figure 19-10). You can click a message's name in this list to jump right to it.

    UP TO SPEED
    All the Little Symbols

    The first column of the main email list shows little symbols that let you know at a glance how you've processed certain messages. The most common one is, of course, the light-blue dot [image] , which means "new message." (After reading a message, you can mark it once again as an unread message by choosing Message rightwards double arrow Mark rightwards double arrow As Unread [Shift- [image] -U]—or by Control-clicking the message's name and then choosing Mark rightwards double arrow As Unread from the shortcut menu.)

    You might also see these symbols, which represent messages that you've replied to [image], forwarded [image], redirected [image], or flagged [image].

    A well-guarded secret, however, is that the "replied to" and "forwarded" symbols aren't just indicators—they're buttons.

    When you see one of these symbols next to your original message, click it to jump straight to your reply (or forwarded message). You're spared the trouble of having to search through all your mailboxes.

    Incidentally, you may have noticed that Mail marks a message as having been read the moment you click it. You can change it back to unread by using its shortcut menu—but there's also a more permanent workaround.

    If you hide the Preview pane by double-clicking the divider bar just above it, Mail no longer marks messages "read" just because you clicked them in the list. (You can bring back the Preview pane by double-clicking just above the vertical scroll bar, or by dragging the divider bar back up from the bottom.)

  • Move all the members of a thread to a new mailbox simply by moving its heading. You might find this useful, for example, when you've just finished a project and want to file away all the email related to it quickly. (As a bonus, a circled number tells you how many messages you're moving as you drag the heading.) You can even delete all the messages in a thread at once by deleting its heading.

    Figure 19-10. Threads have two parts: a heading (the subject of the thread, listed in dark blue when it's not selected) and members (the individual messages in the thread, listed in light blue and indented). Often, the main list shows only a thread's heading; click the flippy triangle to reveal its members.

  • Examine thread members from multiple mailboxes. Normally, threads only display messages held in the samemailbox, but that's not especially convenient when you want to see both messages (from your Inbox) and your replies (in your Sent box). To work around that problem, click Inbox, and then [image] -click the Sent mailbox (or any other mailboxes you want to include). Your threads seamlessly combine related messages from all of the selected mailboxes.

  • Quickly collapse all threads by choosing View rightwards double arrow Collapse All Threads. If your main list gets cluttered with too many expanded threads, this is a quick way to force it into order. (If, on the other hand, your main list isn't cluttered enough, choose View rightwards double arrow Expand All Threads.)

  • Send someone all the messages in a thread by selecting the thread's heading and clicking Forward. Mail automatically copies all the messages of the thread into a new message, putting the oldest at the top. You might find this useful, for instance, when you want to send your boss all the correspondence you've had with someone about a certain project.

19.5.2. Adding the Sender to Your Address Book

When you choose the Message rightwards double arrow Add Sender To Address Book command, Mail memorizes the email address of the person whose message is on the screen. In fact, you can highlight a huge number of messages and add all the senders simultaneously using this technique.

Thereafter, you'll be able to write new messages to somebody just by typing the first few letters of the name or email address.

19.5.3. Data Detectors

Here's a cool step-saver, new in Leopard: a little something Apple likes to call data detectors.

In short, Mail recognizes commonly used bits of information that may appear in a message: a physical address, a phone number, a date and time, and so on. With one quick click, you can send that information into the appropriate Mac OS X program, like iCal, Address Book, or your Web browser (for looking an address up on a map).

Here's how it works. When you spot a name, address, date, or time, point to it without clicking. Mail draws a dotted rectangle around it. Control-click inside the rectangle, or right-click, or click the pop-up [image] at the right side.

Figure 19-11. Mail can detect street addresses, phone numbers, dates, and times. When it spots something you may want to add to another program like Address Book or iCal, it draws a dotted line around the info when you point to it without clicking. Click the little to get a shortcut menu for further options—like automatically adding the address to your Address Book program or seeing the address pinpointed on a Google map.

As shown in Figure 19-11, a shortcut menu appears. Its contents vary depending on what you're pointing to:

  • A mailing address. You can choose Show Map from the shortcut menu; your Web browser opens automatically and shows you that address on a Google map.

    Alternatively, you can choose Create New Contact (to add an Address Book entry for this address) or Add to Existing Contact (if the person is in your Address Book—just not the address). Like magic, a little editing box sprouts out of the data-detected rectangle, prefilled with the information from the message, so that you can approve it.

    Tip: If you highlight some text in the message and then click the pop-up [image] menu, Mail also fills in the Notes field in this person's Address Book entry with the highlighted text. Wicked cool.

  • A date and time. The shortcut menu offers two useful commands. Create New iCal Event opens Mac OS X's calendar program and creates a new appointment at the date and time identified in the message. It's up to you to type a name for the date, set an alarm, and do all the other appointment-setting things described in Chapter 10.

    Tip: If, while working in iCal, you ever forget where this event came from, double-click it. In the Info balloon, you'll see a link that takes you right back to the original Mail message that started it all.

    If you choose Show This Date in iCal, though, you go to iCal, which opens directly to the specified date and/or time. The logic of this feature is overwhelming; after all, when someone emails you to ask if you're free for drinks next Thursday at 10, what's the first thing you usually want to do? Check your calendar, of course.

19.5.4. Opening Attachments

Just as you can attach files to a message, so people often send files to you. Sometimes they don't even bother to type a message; you wind up receiving an empty email message with a file or two attached. Only the presence of the file's icon in the message body tells you that there's something attached.

Tip: Mail doesn't ordinarily indicate the presence of attachments in the Messages list. It can do so, however. Just choose View rightwards double arrow Columns rightwards double arrow Attachments. A new column appears in the email list—at the far right—where you'll see a paper-clip icon and the number of file attachments listed for each message.

Mail doesn't store downloaded files as normal file icons on your hard drive. They're actually encoded right into the .mbox mailbox databases described on Section 19.5.11.2. To extract an attached file from this mass of software, you must proceed in one of these ways:

  • New in Leopard: Click the Quick Look button in the message header. Instantly, you're treated to a nearly full-size preview of the file's contents. Yes, Quick Look has come to email. Its strengths and weaknesses here are exactly as described Chapter 1.

    Tip: If the attachments are pictures, clicking Quick Look gives you a full-screen slideshow of every attached image.If you jiggle the mouse a little during the slideshow, you get a useful row of buttons along the bottom of the screen, too; they're described on Section 1.8.3.

  • Click the Save button in the message header to save it to the Mac's Downloads folder, nestled within easy reach in the Dock.

    Tip: If you don't want to use the Downloads folder, you can choose a new autosave location for attachments by choosing Mail rightwards double arrow Preferences rightwards double arrow General rightwards double arrow Downloads.

  • Control-click (or right-click) the attachment's icon, and choose Save Attachment from the shortcut menu. You'll be asked to specify where you want to put it. Or save time by choosing Save to Downloads Folder, meaning the Downloads folder in the Dock.

  • Drag the attachment icon out of the message window and onto any visible portion of your desktop (or any visible folder).

  • Click the Save button at the top of the email, or choose File rightwards double arrow Save Attachments. (If the message has more than one attachment, this maneuver saves all of them.)

    Tip: The Save button at the top of the Preview pane doubles as a pop-up menu; if you click it and keep the mouse button pressed, you can select from several other options for saving the attachments—like importing them into iPhoto or downloading only one of them.

    WORKAROUND WORKSHOP
    Dial-up Blues

    If you're among the few, the proud, who still connect to the Internet with a dial-up modem, you may find that Mail is painfully slow at opening and reading email—and that it slows down other Internet programs, like your Web browser, whenever it checks for new mail.

    Fortunately, you can take a few steps to speed up Mail (and, indirectly, your other Internet programs):

    Cut back on mail checks. Choose Mail rightwards double arrow Preferences, click General, and change the "Check for new mail" pop-up to "Every hour," or even "Manually." That way, Mail won't tie up your phone line by trying to connect every five minutes.

    Whenever you have a choice, don't sign up for HTML email. HTML mail takes far longer to arrive than plain email. Therefore, if you ever sign up for companies' email updates (like Apple's eNews bulletin or the New York Times's Circuits newsletter), choose to receive the messages as text, not HTML.

    Turn off graphics in formatted mail. If you have no choice but to receive HTML messages, the least you can do is block the pictures, which are the biggest and slowest elements of a formatted message.

    To do that, choose Mail rightwards double arrow Preferences, click Viewing, and then turn off "Display remote images in HTML messages." From now on, you'll see a special Load Images button at the top of the Preview pane whenever you select an HTML message. If you feel that the empty boxes (where the graphics would have appeared) really deprive the message of its oomph, click that button to make Mail download all the images in the current message—this time only, because you've asked for them.

    Don't auto-download attachments. If you use an IMAP, .Mac, or Exchange account, you can set up Mail so it won't download attachments until you tell it to.

    Open the Accounts pane of Mail's preferences, select your account, click Advanced, and choose "All messages, but omit attachments" from the pop-up menu in the middle. From now on, Mail won't download attachments unless you command it to do so.

  • Double-click the attachment's icon, or single-click the blue link underneath the icon. If you were sent a document (a photo, Word file, or Excel file, for example), it now opens in the corresponding program.

    Note: After the attachment is open, use the File rightwards double arrow Save As command to save the file into a folder of your choice. Otherwise, any changes you make to the document won't be visible except when you open it from within Mail.

  • Control-click the attachment's icon. From the shortcut menu, you can specify which program you want to use for opening it, using the Open With submenu.

19.5.4.1. When attachments don't open

If you're unable to open a file attachment, there are several possible reasons. For starters, your correspondent's email program may have compressed or encoded the file so it takes less time to send.

Mac OS X can open .zip and other common compressed formats with a simple double-click. But if the format is some wacky off-brand scheme, try dragging the attachment's icon onto that of StuffIt Expander, a little program that can gracefully decode just about any geeky Internet file. (You can download it for free fromwww.stuffit.com.)

Some mysterious attachment types aren't necessarily hard to open. For example:

  • .exe. This denotes an executable file—more specifically, a Windows program. Mac OS X itself can't run Windows programs. If you have an Intel-based Mac and you've installed Boot Camp, Parallels, or VMW are Fusion (Chapter 8), of course, you can copy the file to the Dark Side and deal with it there.

  • .html. A file whose name ends in .html or .htm is a Web page. In the beginning, Web pages hung out only on the Internet. These days, however, you're increasingly likely to find that you've downloaded one to your Mac's hard drive. (It may be a software manual for some shareware, for example.) You can open it by double-clicking; Mac OS X comes set to open all .htm and .html files in Safari.

  • .vcf. A "business-card" file; see Section 19.10.1.2.

If you've received a file with a three-letter code not listed here, you may well have a file that can be opened only by a Windows program that you don't own. You might consider asking your correspondent to resend it in one of the more universal formats, such as the graphics formats JPEG and TIFF, or the text formats RTF and TXT. In addition, any layout, graphics, or text file can be turned into a PDF; if you're still having trouble opening the attachment, ask your correspondent to send the attachment in that format instead.

19.5.5. Replying to a Message

To answer a message, click the Reply button on the message toolbar (or choose Message rightwards double arrow Reply, or press [image] -R). If the message was originally addressed to multiple recipients, you can send your reply to everyone simultaneously by clicking Reply All instead.

A new message window opens, already addressed. As a courtesy to your correspondent, Mail places the original message at the bottom of the window, set off by a vertical bar, as shown in Figure 19-12.

Tip: If you highlight some text before clicking Reply, Mail pastes only that portion of the original message into your reply. That's a great convenience to your correspondent, who now knows exactly which part of the message you're responding to.

Figure 19-12. In Rich Text–formatted Mail messages (not to be confused with RTF [Rich Text Format] word processing format, which is very different), a reply includes the original message, marked in a special color (which you can change in Mail rightwards double arrow Preferences) and with a vertical bar to differentiate it from the text of your reply.
(In plain-text messages, each line of the reply is >denoted >with >brackets, although only your recipient will see them.) The original sender's name is automatically placed in the "To:" field. The subject is the same as the original subject with the addition of Re: (shorthand for Regarding). You're now ready to type your response.

At this point, you can add or delete recipients, edit the Subject line or the original message, attach a file, and so on.

Tip: Use the Return key to create blank lines in the original message. Using this method, you can splice your own comments into the paragraphs of the original message, replying point by point. The brackets preceding each line of the original message help your correspondent keep straight what's yours and what's hers.

When you're finished, click Send. (If you click Reply All in the message window now, your message goes to everyone who received the original note, even if you began the reply process by clicking Reply. Mac OS X, in other words, gives you a second chance to address your reply to everyone.)

19.5.6. Forwarding Messages

Instead of replying to the person who sent you a message, you may sometimes want to pass the note on to a third person.

To do so, click the Forward toolbar button (or choose Message rightwards double arrow Forward, or press Shift- [image] -F). A new message opens, looking a lot like the one that appears when you reply. You may wish to precede the original message with a comment of your own, along the lines of: "Frank: I thought you'd be interested in this joke about your mom."

Finally, address it as you would any outgoing piece of mail.

19.5.7. Redirecting Messages

A redirected message is similar to a forwarded message, with one useful difference: When you forward a message, your recipient sees that it came from you. When you redirect it, your recipient sees the original writer's name as the sender. In other words, a redirected message uses you as a low-profile relay station between two other people.

Treasure this feature. Plenty of email programs, including Outlook and Outlook Express for Windows, don't offer a Redirect command at all. You can use it to transfer messages from one of your own accounts to another, or to pass along a message that came to you by mistake.

To redirect a message, choose Message rightwards double arrow Redirect, or press Shift- [image] -E. You get an outgoing copy of the message—this time without any quoting marks. (You can edit redirected messages before you send them, too, which is perfect for April Fools' Day pranks.)

19.5.8. Printing Messages

Sometimes there's no substitute for a printout. Choose File rightwards double arrow Print, or press [image] -P to summon the Print dialog box.

19.5.9. Filing Messages

Mail lets you create new mailboxes in the Mailboxes pane. You might create one for important messages, another for order confirmations from Web shopping, still another for friends and family, and so on. You can even create mailboxes inside these mailboxes, a feature beloved by the hopelessly organized.

Mail in Leopard even offers smart mailboxes—self-updating folders that show you all your mail from your boss, for example, or every message with "mortgage" in its subject. It's the same idea as smart folders in the Finder or smart playlists in iTunes: folders whose contents are based around criteria that you specify (Figure 19-13).

Figure 19-13. Mail lets you create self-populating folders. In this example, the "New Mail from Steve" smart mailbox will automatically display all messages from Steve Jobs at Apple that you've received in the past week.

The commands you need are all in the Mailbox menu. For example, to create a new mailbox folder, choose Mailbox rightwards double arrow New Mailbox, or click the + button at the bottom of the Mailboxes column. To create a smart mailbox, choose Mailbox rightwards double arrow New Smart Mailbox.

Mail asks you to name the new mailbox. If you have more than one email account, you can specify which one will contain the new folder. (Smart mailboxes, however, always sit outside your other mailboxes.)

Tip: If you want to create a folder-inside-a-folder, use slashes in the name of your new mailbox. (If you use the name Cephalopods/Squid, for example, Mail creates a folder called Cephalopods, with a subfolder called Squid.) You can also drag the mailbox icons up and down in the drawer to place one inside another.None of those tricks work for smart mailboxes, however. The only way to organize smart mailboxes is to put them inside a smart mailbox folder, which you create using Mailbox rightwards double arrow New Smart Mailbox. You might do that if you have several smart mailboxes for mail from your co-workers ("From Jim," "From Anne," and so on) and want to put them together in one collapsible group to save screen space.

When you click OK, a new icon appears in the mailbox column, ready for use.

You can move a message (or group of messages) into a mailbox folder in any of three ways:

  • Drag it out of the main list onto the mailbox icon (Figure 19-14).

  • In the list pane, highlight one or more messages, and then choose from the Message rightwards double arrow Move To submenu, which lists all your mailboxes.

  • Control-click (or right-click) a message, or one of several that you've highlighted. From the resulting shortcut menu, choose Move To, and then, from the submenu, choose the mailbox you want.

Of course, the only way to change the contents of a smart mailbox is to change the criteria that it uses to populate itself. To do so, double-click the smart mailbox icon and use the dialog box that appears.

Figure 19-14. You can use any part of a message's "row" in the list as a handle; the envelope cursor tells you that Mail knows what's happening. You can also drag messages en masse onto a folder. If you Option-drag a message into a folder, you make a copy, leaving the original message where it is.

19.5.10. Flagging Messages

Sometimes you'll receive email that prompts you to some sort of action, but you may not have the time (or the fortitude) to face the task at the moment. ("Hi there… it's me, your accountant. Would you mind rounding up your expenses for 1997 through 2007 and sending me a list by email?")

That's why Mail lets you flag a message, summoning a little flag icon in a new column next to a message's name. These indicators can mean anything you like—they simply call attention to certain messages. You can sort your mail list so that all your flagged messages are listed first; click the flag at the top of the column heading. (If you really want to get serious about following up on the contents of a message, you can also create a To Do item, as explained on Section 19.9.)

To flag a message in this way, select the message (or several messages) and then choose Message rightwards double arrow Mark rightwards double arrow As Flagged, or press Option- [image] -L, or Control-click the message's name in the list and, from the shortcut menu, choose Mark rightwards double arrow As Flagged. (To clear the flags, repeat the procedure, but use the Mark rightwards double arrow As Unflagged command instead.)

Tip: This whole flagging business has another useful side effect. When Mail finds messages that it thinks are spam, it marks them with little trash-bag icons in the flag column. If you sort your mail by flag, then, all your spam gets grouped together—which is great if you want to do one big spam-cleaning by dragging it all to the Trash.

19.5.11. Finding Messages

When you deal with masses of email, you may come to rely on Mail's dedicated searching tools. They're fast and convenient, and when you're done with them, you can go right back to browsing your Message list as it was.

19.5.11.1. Finding messages within a mailbox

The box in the upper-right corner of the main mail window is Mail's own private Spotlight. You can use it to hide all but certain messages, as shown in Figure 19-15.

Tip: You can also set up Mail to show you only certain messages that you've manually selected, hiding all others in the list. To do so, highlight the messages you want, using the usual selection techniques (Section 2.3). Then choose View rightwards double arrow Display Selected Messages Only. (To see all of them again, choose View rightwards double arrow Display All Messages.)

Figure 19-15. You can jump to the search box by clicking or by pressing Option -F. As you type, Mail shrinks the list of messages. You can fine-tune your results using the buttons just above the list. To return to the full message list, click the tiny at the right side of the search box.

In Leopard, this search field is more powerful than ever. For example:

  • You have the power of Spotlight charging up your search rankings; the most relevant messages for your search appear high on the list. And Notes and To Do items show up in the search results now, too.

  • When you're searching, a thin row of buttons appears underneath the toolbar. You can use these buttons to narrow your results to only messages with your search term in their subject, for example, or to only those messages in the currently selected mailbox.

  • When you select a message in the search view, the Preview pane pops up from the bottom of the window. If you click Show in Mailbox, on the other hand, you exit the search view and jump straight to the message in whatever mailbox it came from. That's perfect if the message is part of a thread, since jumping to the message also displays all the other messages from its thread.

  • If you think you'll want to perform the current search again sometime, click Save in the upper-right corner of the window. Mail displays a dialog box with your search term and criteria filled in; all you have to do is give it a name and click OK to transform your search into a smart mailbox that you can open any time.

19.5.11.2. Finding text within an open message

You can also search for certain text within an open message. Choose Edit rightwards double arrow Find rightwards double arrow Find (or press [image] -F) to bring up the Find dialog box (Figure 19-16).

Figure 19-16. The Find box works just as it does in a word processor, except that the Replace function works only on messages that you've written yourself—Mail doesn't let you change the words of mail you've received. (Lawyers would have a field day with that one.)

19.5.12. Deleting Messages

Sometimes it's junk mail. Sometimes you're just done with it. Either way, it's a snap to delete a selected message, several selected messages, or a message that's currently before you on the screen. You can press the Delete key, click the Delete button on the toolbar, choose Edit rightwards double arrow Delete, or drag messages out of the list window and into your Trash mailbox—or even onto the Dock's Trash icon.

Tip: If you delete a message by accident, the Undo command (Edit rightwards double arrow Undo or [image] -Z) restores it.

All of these commands move the messages to the Trash folder. If you like, you can then click its icon to view a list of the messages you've deleted. You can even rescue messages by dragging them back into another mailbox (back to the Inbox, for example).

POWER USERS' CLINIC
Secrets of the Mbox Files

Mail keeps your messages in a series of mailbox database files in your Home rightwards double arrow Library rightwards double arrow Mail folder, inside folders named for your accounts (Outbox, Deleted Messages, and so on).

Knowing this permits you to perform a number of interesting tricks. First of all, now you know what files to back up for safekeeping.

Second, now you know which files to copy to your laptop to maintain email continuity when you travel.

And finally, if you have messages on an old Mac that you'd like to copy to your new one, you know where they're stored.

19.5.12.1. Method 1: Emptying the Trash folder

Mail doesn't vaporize messages in the Trash folder until you "empty the trash," just like in the Finder. You can empty the Trash folder in any of several ways:

  • Click a message (or several) within the Trash folder list, and then click the Delete icon on the toolbar (or press the Delete key). Now those messages are really gone.

  • Choose Mailbox rightwards double arrow Erase Deleted Messages ( [image] -K). (If you have multiple accounts, choose Erase Deleted Messages rightwards double arrow In All Accounts.)

  • Control-click (or right-click) the Trash mailbox icon, and then choose Erase Deleted Messages from the shortcut menu. Or choose the same command from the [image] pop-up menu at the bottom of the window.

  • Wait. Mail will permanently delete these messages automatically after a week.

    If a week is too long (or not long enough), you can change this interval. Choose Mail rightwards double arrow Preferences, click Accounts, and select the account name from the list at left. Then click Mailbox Behaviors, and change the "Erase deleted messages when" pop-up menu. If you choose Quitting Mail from the pop-up menu, Mail will take out the trash every time you quit the program.

19.5.12.2. Method 2: Deleted mail turns invisible

Mail offers a second—and very unusual—method of deleting messages that doesn't involve the Trash folder at all. Using this method, pressing the Delete key (or clicking the Delete toolbar button) simply hides the selected message in the list. Hidden messages remain hidden, but don't go away for good until you use the Rebuild Mailbox command described in the box on Section 19.6.1.

If this arrangement sounds useful, choose Mail rightwards double arrow Preferences; click Accounts and select the account from the list on the left; click Mailbox Behaviors; and then turn off the checkbox called "Move deleted messages to a separate folder" or "Move deleted messages to the Trash mailbox." (The checkbox's wording depends on what kind of account you have.) From now on, messages you delete vanish from the list.

They're not really gone, however. You can bring them back, at least in ghostly form, by choosing View rightwards double arrow Show Deleted Messages (or pressing [image] -L). Figure 19-17 shows the idea.

Figure 19-17. To resurrect a deleted message (indicated in light gray type), Control-click it and choose Undelete from the shortcut menu.

Using this system, in other words, you never truly delete messages; you just hide them.

At first, you might be concerned about the disk space and database size involved in keeping your old messages around forever like this. Truth is that Mac OS X is perfectly capable of maintaining many thousands of messages in its mailbox databases—and with the sizes of hard drives nowadays, a few thousand messages aren't likely to make much of a dent.

Meanwhile, there's a huge benefit to this arrangement. At some point, almost everyone wishes they could resurrect a deleted message—maybe months later, maybe years later. Using the hidden-deleted-message system, your old messages are always around for reference. (The downside to this system, of course, is that SEC investigators can use it to find incriminating mail that you thought you'd deleted.)

When you do want to purge these messages for good, you can always return to the Special Mailboxes dialog box and turn the "Move deleted mail to a separate folder" checkbox back on.

19.5.13. Archiving Mailboxes

Time Machine (Chapter 6) keeps a watchful eye on your Mac and backs up its data regularly—including your email. If you ever delete a message by accident or otherwise make a mess of your email stash, you can duck into Time Machine right from within Mail, as described on Section 6.4.4.1.

But not everybody wants to use Time Machine, for personal reasons—lack of a second hard drive, aversion to software named after H. G. Wells novels, whatever.

Yet having a backup of your email is critically important. Think of all the precious mail you'd hate to lose: business correspondence, electronic receipts, baby's first message. Fortunately, there's a second good way to back up your email—archive it, like this:

  1. In the Mailboxes column, choose which mailbox or mailboxes you wish to archive.

    If you have multiple mailboxes in mind, Control-click (or right-click) each one until you've selected all the ones you want.

  2. At the bottom of the Mail window, open the [image] pop-up menu and choose Archive Mailbox(es).

    This step is shown in Figure 19-18. (You can also get to this command by choosing Mailbox rightwards double arrow Archive.)

  3. In the box that appears, navigate to the place you want to stash this archive of valuable mail, like a server, flash drive, or folder. Click Choose.

    Your archived mailboxes are saved to the location you've chosen. You can now go back to work writing new messages.

    Later, if you need to pull one of those archives back into duty, choose File rightwards double arrow Import Mailboxes. Choose the "Mail for Mac OS X" option and navigate back to the place you stored your archived mailboxes.

Note: If you archive mailboxes on a regular basis, don't worry about changing the name of the .mbox file to prevent it from overwriting a previous archive. Mail is smart enough to stick a number at the end of the new file name for you.

Figure 19-18. If you don't use Time Machine (Section 6.4) to back up your Mac, archiving your mailboxes on a regular basis can save you hours of grief and bad language if something unfortunate happens to Mail or your Mac in general. All you need to do is select which mailbox you want to archive, and then choose Archive Mailbox from the menu. A dialog box pops up, asking you where to save your archived mail, and Mail takes care of the rest.

19.5.14. Message Rules

Once you know how to create folders, the next step in managing your email is to set up a series of message rules (filters) that file, answer, or delete incoming messages automatically based on their contents (such as their subject, address, and/or size). Message rules require you to think like the distant relative of a programmer, but the mental effort can reward you many times over. Message rules turn Mail into a surprisingly smart and efficient secretary.

19.5.14.1. Setting up message rules

Here's how to set up a message rule:

  1. Choose Mail rightwards double arrow Preferences. Click the Rules icon.

    The Rules pane appears, as shown at top in Figure 19-19.

  2. Click Add Rule.

    Now the dialog box shown at bottom in Figure 19-19 appears.

  3. Use the criteria options (at the top) to specify how Mail should select messages to process.

    For example, if you'd like the program to watch out for messages from a particular person, you would set up the first two pop-up menus to say "From" and "Contains," respectively.

    To flag messages containing loan,$$$$,XXXX,!!!!, and so on, set the pop-up menus to say "Subject" and "Contains."

    You can set up multiple criteria here, so you flag messages whose subjects contain any one of those common spam triggers. (If you change the "any" pop-up menu to say "all," then all of the criteria must be true for the rule to kick in.)

  4. Specify which words or people you want the message rule to watch for.

    In the text box to the right of the two pop-up menus, type the word, address, name, or phrase you want Mail to watch for—a person's name, or $$$$, in the previous examples.

    Figure 19-19. Top: Mail rules can screen out junk mail, serve as an email answering machine, or call important messages to your attention. All mail message rules you've created appear in this list. (The color shading for each rule is a reflection of the colorizing options you set up, if any.)
    Bottom: Double-click a rule to open the Edit Rule dialog box, where you can specify what should set off the rule and what it should do in response.

  5. In the lower half of the box, specify what you want to happen to messages that match the criteria.

    If, in Steps 1 and 2, you've told your rule to watch for junk mail containing $$$$ in the Subject line, here's where you can tell Mail to delete it or move it into, say, a Junk folder.

    With a little imagination, you'll see how the options in this pop-up menu can do absolutely amazing things with your incoming email. Mail can colorize, delete, move, redirect, or forward messages—or even play a sound when you get a certain message.

    By setting up the controls as shown in Figure 19-19, for example, you'll have specified that whenever your mother (mom@mcmail.com) sends something to your Gmail account, you'll hear a specific alert noise as the email is redirected to a different email account, chickadee745@hotmail.com.

  6. In the very top box, name your mail rule. Click OK.

    Now you're back to the Rules pane (Figure 19-19, top). Here you can choose a sequence for the rules you've created by dragging them up and down. Here, too, you can turn off the ones you won't be needing at the moment, but may use again one day.

    Tip: Mail applies rules as they appear, from top to bottom, in the list. If a rule doesn't seem to be working properly, it may be that an earlier rule is intercepting and processing some messages before the "broken" rule even sees them. To fix this, try dragging the rule (or the interfering rule) up or down in the list.

GEM IN THE ROUGH
The Email Answering Machine

If you're going on vacation, you can turn Mail into an email answering machine that sends a canned "I'm away until the 15th" message to everyone who writes you.

To do so, set the first set of pop-up menus in the Rules dialog box so that they say Account and the name of your account. In the bottom half of the dialog box, select Reply to Message from the pop-up menu. Click "Reply message text," and then type your boilerplate reply in the resulting box.

Keep in mind, though, that mail rules only work when Mail is open and connected to the Internet. If your computer is set to turn off after a certain period of time, therefore, make sure to disable that feature before you go on vacation.

Also: If you subscribe to mailing lists, set up another mail rule that intercepts and files them before your answering-machine rule kicks in. Otherwise, you'll incur the wrath of other Internet citizens by littering their email discussion groups with copies of your auto-reply message.


the_anti-spam_toolkit.html

19.6. The Anti-Spam Toolkit

Spam, the junk that now makes up more than 80 percent of email, is a problem that's only getting worse. Luckily, you, along with Mail's advanced spam filters, can make it better—at least for your email accounts.

19.6.1. Using the Junk Mail Filter

You'll see the effects of Mail's spam filter the first time you check your mail: A certain swath of message titles appears in color. These are the messages that Mail considers junk.

Note: Out of the box, Mail doesn't apply its spam-targeting features to people whose addresses are in your address book, to people you've emailed recently, or to messages sent to you by name rather than just by email address. You can adjust these settings in Mail rightwards double arrow Preferences rightwards double arrow Junk Mail tab.

During your first couple of weeks with Mail, your job is to supervise Mail's coloring job. That is, if you get spam that Mail misses, click the message, and then click the Junk button at the top of its window (identified in Figure 19-5), or the Junk icon on the toolbar. On the other hand, if Mail flags legitimate mail as spam, slap it gently on the wrist by clicking the Not Junk button. Over time, Mail gets better and better at filtering your mail; it even does surprisingly well against the new breed of image only spam.

The trouble with this so-called Training mode is that you're still left with the task of trashing the spam yourself, saving you no time whatsoever.

Once Mail has perfected its filtering skills to your satisfaction, though, open Mail's preferences, click Junk Mail, and click "Move it to the Junk mailbox." From now on, Mail automatically files what it deems junk into a Junk mailbox, where it's much easier to scan and delete the messages en masse.

Tip: Don't miss the "Trust Junk Mail headers set by your Internet Service Provider" option in the Junk Mail pane of the preference window. If you turn on that checkbox, Mail takes your ISP's word that certain messages are spam, giving you a double layer of spam protection.

19.6.2. More Anti-Spam Tips

The Junk filter goes a long way toward cleaning out the spam from your mail collection—but it doesn't catch everything. If you're overrun by spam, here are some other steps you can take:

  • Don't let the spammers know you're there.You choose Mail rightwards double arrow Preferences, click Viewing, and turn off "Display remote images in HTML messages." This option saves you time, because graphics are big and slow to download. It also shields you from unexpected free samples of pornographers' wares.

    But it also thwarts a common spammer tactic by blocking graphics that appear to be embedded into a message, but are actually retrieved from a Web site somewhere.

    Spammers use that embedded-graphics trick to know that their message has fallen on fertile ground—a live sucker who actually looks at these messages—but with that single preference switch, you can fake them out.

  • Rules. Set up some message rules, as described on Section 19.5.14, that autoflag messages as spam that have subject lines containing trigger words like "Viagra," "Herbal," "Mortgage,""Refinance,""Enlarge,""Your"—you get the idea.

  • Create a private account. If you're overrun by spam, consider sacrificing your address to the public areas of the Internet, like chat rooms, online shopping, Web site and software registration, and newsgroup posting. Spammers use automated software robots that scour every public Internet message and Web page, recording email addresses they find. (In fact, that's probably how they got your address in the first place.)

    Using this technique, at least you're now restricting the junk mail to one, secondary mail account. Reserve a separate email account for person-to-person email.

Here are some suggestions for avoiding landing on spammers' lists in the first place:

  • Don't ask for it. When filling out forms online, turn off the checkboxes that say, "Yes, send me exciting offers and news from our partners."

  • Fake out the robots. When posting messages in a newsgroup or message board, insert the letters NOSPAM somewhere into your email address. Anyone replying to you via email must delete the NOSPAM from your email address, which is a slight hassle. Meanwhile, though, the spammers' software robots will lift a bogus email address from your online postings.

    TROUBLESHOOTING MOMENT
    Rebuilding Your Mail Databases

    As noted earlier in this chapter, Mail keeps your messages in a series of mailbox database files in your Home rightwards double arrow Library rightwards double arrow Mail folder.

    Over time, as you add and delete hundreds of messages from these database files, some digital sawdust gets left behind, resulting in peculiarities when addressing messages or general Mail sluggishness. You also wind up with massive message files hidden on your hard drive, which can consume hundreds of megabytes of disk space. That's a particular bummer if you like to copy your message databases to your laptop when you go on a trip.

    Fortunately, it's easy enough to rebuild the message data-bases. Doing so cleanses, repairs, and purges your message files. As a result, you wind up with a much more compact and healthy database.

    To rebuild a mailbox, highlight it in the Mailboxes column in Mail. (Highlight several by [image] -clicking, if you like.) Then choose Mailbox rightwards double arrow Rebuild. Mac OS X takes several minutes (or hours, depending on the size of your mailboxes) to repair and compact your database—but if you're experiencing Mail weirdness or slowness, it's well worth the sacrifice.

  • Never reply to spam. Doing so identifies your email address as an active one, and can lead to even more unwanted mail. Along the same lines, never click the "Please remove me from your list" link at the bottom of an email unless you know who sent the message.

And for goodness' sake, don't order anything sold by the spammers. If only one person in 500,000 does so, the spammer makes money.


rss_feeds.html

19.7. RSS Feeds

In Leopard, Mail moves beyond mail. It's now a program that helps you keep yourself up to date with the world outside—and within your own little corner of it.

For example, the ability to subscribe to those constantly updating news summaries known as RSS feeds in your Web browser (Section 20.2) has saved a lot of people a lot of time over the years. After all, why waste precious minutes looking for the news when you can make the news find you?

With Leopard's Mail, you don't even have to waste the seconds switching from your Inbox to your browser or dedicated RSS program to get a fresh dose of headlines. They can appear right in the main Mail window. You don't even have to switch programs to find out which political candidate shot his foot off while it was still in his mouth.

In fact, if you find it too exhausting to click the RSS icon in the Mailboxes list, you can choose instead to have all your RSS updates land right in your Inbox along with all your other messages.

19.7.1. Adding RSS Feeds

With just a few clicks, you can bring the news of the world right in with the rest of your mail. Choose File rightwards double arrow Add RSS Feeds, and then proceed as shown in Figure 19-20.

Tip: As you turn on the feeds you want to see in Mail, [image] -click to select a bunch of feeds at once.

If you want the RSS headlines to appear in your Inbox like regular email messages, turn on "Show in Inbox." Finally, once you've chosen the feeds you want to see, click Add. Your feeds now appear wherever you told them to go: either the Inbox or the Mailboxes column.

Now, in the RSS category of your Mailboxes list, the names of your RSS feeds show up; the number in the small gray circle tells you how many unread headlines are in the list. If a feed headline intrigues you enough to want more information, click "Read More…" to do just that. Safari pops up and whisks you away to the Web site that sent out the feed in the first place.

Tip: Click the up arrow button next to a feed's name to move all of its updates into your Inbox; there, they appear with the same blue RSS label, but they behave as though they're an Inbox category to spare you having to flip back and forth between two distant areas of the Mailboxes list.If you accidentally click that arrow, and you don't really want 57 headlines from RollingStone.com peppering your daily dose of mail, click the feed's name and then click the down-pointing arrow next to it; it returns to the RSS section of the list. Alternatively, you can Control-click (or right-click) the feed name under Mailboxes and turn off "Show in Inbox" from the shortcut menu.

Figure 19-20. In the Add RSS Feeds box, you can click to add sites you've already subscribed to in Safari. If you don't already have the feed bookmarked in Safari, click "Specify a custom feed URL" and paste the feed's address into the resulting box. If you've got a ton of feeds and don't want to wade through them all, use the search box to seek out the specific feed you need.

19.7.2. Managing Feeds

Now that you've got your feeds in Mail, you may want to fiddle around with them.

  • Updating. You can change the frequency of your news updates by choosing Mail rightwards double arrow Preferences rightwards double arrow RSS rightwards double arrow Check for Updates. You can automatically up date them every half hour, every hour, or every day. You can also command Mail to update a certain feed right now; Control-click the feed's name in the Mailboxes list and, from the shortcut menu, choose "Update BBC News" (or whatever its name is).

  • Archiving. You can save and store a whole batch of feeds in an archive file, just as you can do with regular mailboxes; choose Mailbox rightwards double arrow Archive Feed. A dialog box walks you through saving a copy of all the messages to a backup drive or other location for safekeeping.

  • Sharing. If you want to share the news with a friend, Control-click a headline; from the shortcut menu, choose Forward (or Forward as Attachment) to pop the info into a new Mail message that you can send off to your pal.

  • Renaming. You don't have to use the site's full name in your Mail window—after all, "WaPo" fits much better in the Mailboxes column than "Washington Post." To rename a feed, select it and then choose Mailbox rightwards double arrow Rename Feed. Type in the new name and press Enter. (You can also Control-click or right-click the name to bring up the Rename Feed option.)

  • Deleting. After you've read a news item and are do new it hit, click the Delete button at the top of the window. You can tell Mail to dump all the old articles after a certain amount of time (a day, a week, a month…) in Mail rightwards double arrow Preferences rightwards double arrow RSS rightwards double arrow Remove Articles.

    Or, to get rid of an RSS feed altogether, select it and then choose Maibox rightwards double arrow Delete Feed. (Control- or right-clicking the name gives you the same option.)


notes.html

19.8. Notes

Let's face it: No operating system is complete without Notes. You have to have a place for little reminders, phone numbers, phone messages, Web addresses, brainstorms, shopping-list hints—anything that's worth writing down, but too tiny to justify heaving a whole word processor onto its feet.

The silly thing is how many people create reminders for themselves by sending themselves an email message.

That system works, but it's a bit inelegant. Fortunately, Mac OS X now has a dedicated Notes feature. As a bonus, it syncs automatically to the Notes folder of your iPhone's mail program, or to other computers, as long as you have an IMAP-style email account (see the box on Section 19.2).

Notes look like actual yellow notepaper with ruled lines, but you can style 'em, save 'em, and even send 'em to your friends. You can type into them, paste into them, and attach pictures to them. And unlike loose scraps of paper or email messages to yourself that may get lost in your mailbox, Notes stay obediently tucked in the Reminders section of the Mailboxes list so you can always find them when you need them.

Tip: Ordinarily, Notes also appear in your Inbox, at the top. If you prefer to keep your Inbox strictly for messages, though, you can remove the Notes. Choose Mail rightwards double arrow Preferences rightwards double arrow Accounts rightwards double arrow Mailbox Behaviors, and then turn off "Store notes in Inbox." The Notes will still be waiting for you in the side column, down in the Reminders area.

To create a note, click the Note button on the Mail toolbar. You can also choose File rightwards double arrow New Note or press Control- [image] -N to pop up a fresh piece of onscreen paper.

Once you have your Note, type your text and click the Fonts and Colors buttons at the top of the window to style it. To insert a picture, click the Attach button, and then find the photo or graphic on your Mac you want to use. Figure 19-21 shows an example.

Note: You can also attach other kinds of files to a Note—ordinary documents, for example. But you can't send such Notes to other people—only Notes with pictures.

Figure 19-21. They may look like little pads of scratch paper, but Mail Notes let you paste in Web addresses and photos alongside your typed and formatted text. If you want to share, click the Send button to have the entire Note plop into a new Mail message, ready to be addressed.

When you're finished with your Note, click Done to save it. When you look for it in the Reminders category of the Mailboxes list, you'll see that Mail used the first line of the Note as its subject.

To delete a Note for good, select it and press the Delete key.

If you've worked hard on this little Note and want to share it, double-click it to open the note into a new window. Click the Send button on its toolbar. Mail puts the whole thing into a new Mail message—complete with yellow-paper background—so your pal can see how seriously (and stylishly) you take the whole concept of "Note to self."


to_dos.html

19.9. To Dos

You've got all this mail piling up with all sorts of things to remember: dinner dates, meeting times, project deadlines, car-service appointments. Wouldn't it be great if you didn't have to remember to look through your mailbox to find out what you're supposed to be doing that day?

It would, and it is, thanks to Mail's To Do feature. And the best part is that Mail accesses the same To Do list as iCal. The same task list shows up in both programs.

19.9.1. Creating To Dos

You can use To Dos in several different ways. For example, when you get an email message that requires further action ("I need the photos for the condo association newsletter by Friday"), highlight the important part of the text. Then do any of these things:

  • Click To Do in the message window's toolbar.

  • Choose File rightwards double arrow New To Do.

  • Press Option- [image] -Y.

  • Control-click (or right-click) the highlighted text, and then choose New To Do from the shortcut menu.

In each case, Mail pops a copy of the selected text into a yellow strip of note-style paper at the top of the message, as shown in Figure 19-22.

That task is also listed in the Reminders area of the Mailboxes list. If you need to see all the tasks that await you from all your mail accounts, click the flippy triangle to have it spin open and reveal your chores. The number in the gray circle indicates how many To Do items you still need to do.

Tip: Control-click (or right-click) any item in this To Do list to open a shortcut menu that offers useful controls for setting its due date, priority, and calendar (that is, iCal category).

When you click the To Do area of the Mailboxes list, all your tasks are listed in the center of the Mail window. Click the gray arrow after each To Do subject line to jump back to the original message it came from.

Tip: Not all of your life's urgent tasks spring from email messages. Fortunately, you can create standalone To Dos, too. Just click the To Do button at the top of the Mail window when no message is selected. A blank item appears in your To Do list with the generic name "New To Do." Select the name to overwrite it with what this reminder is really about: Buy kitty litter TODAY (or whatever).

19.9.2. Completing and Deleting To Dos

When you complete a task, click the small checkbox in front of the To Do subject line—either in the message itself or in the Reminders list. Once you've marked a task as Done this way, the number of total tasks in the Reminders list goes down by one, and that's one less thing you have to deal with.

To delete a big yellow To Do banner from a message, point to the left side of the banner until a red handwritten-looking X appears. Click the X to zap the To Do banner from the message.

You can delete a To Do item from the Reminders list by selecting it and then pressing Delete, among other methods.

Figure 19-22. Top: If a message brings a task that you need to complete, you can give yourself an extra little reminder, right in Mail. Highlight the pertinent text and click the To Do button to add a large, colorful reminder to the top of the message.
Bottom: Click the arrow next to the first line of the To Do for a quick and easy way to set a due date/time and alarm, and also choose which calendar you want to use for this particular chore.

19.9.3. To Do List: Mail/iCal Joint Custody

Seeing your To Do items in Mail is great—when you're working in Mail. Getting them into iCal is even better, though, because you can see the big picture of an entire day, week, or month. As it turns out, Mail and iCal share the exact same To Do list. Create a To Do in one program, and it shows up instantly in the other one.

Tip: You can even set the due date and priority of a task from within Mail. Those controls are in the To Do Options balloon (Figure 19-22). You open this balloon by Control-clicking the task and choosing Edit To Do, or just by clicking the large arrow button that appears to the left of a To Do banner in an email message window. Later, in iCal, if you double-click a To Do item, and then click "Show in Mail," you get whisked back to the original message, sitting right there in Mail.


address_book-id002.html

19.10. Address Book

Address Book is Mac OS X's little-black-book program—an electronic Rolodex where you can stash the names, job titles, addresses, phone numbers, email addresses, and Internet chat screen names of all the people in your life (Figure 19-23). Address Book can also hold related information, like birthdays, anniversaries, and any other tidbits of personal data you'd like to keep at your fingertips.

Once you make Address Book the central repository of all your personal contact information, you can call up this information in a number of convenient ways:

  • You can launch Address Book and search for a contact by typing just a few letters in the Search box.

    GEM IN THE ROUGH
    To Dos and Notes: The Big Sync

    Whether you edit your To Do list and Notes in your email program (Mail) or your calendar program (iCal), they're always just one sync away from a Palm organizer, a cellphone, or an iPod.

    You do the iPod syncing in iTunes, of all places. Just connect the iPod to the Mac, select its icon in the source list, and click the Contacts tab. Scroll to the Calendars area and turn on the calendars you want to copy to the iPod. Finally, click the Apply button in the corner of the iTunes window. Once you've synchronized iPod with Mac, you can find your calendars and To Do items on the iPod at iPod rightwards double arrow Extras rightwards double arrow Calendars rightwards double arrow To Dos.

    And what about the iPhone? If you have that glorious comination of a .Mac account and an iPhone, your To Do items sync right over from your Mac to the iPhone. Find them on the phone in Mail rightwards double arrow Accounts rightwards double arrow.Mac rightwards double arrow Apple Mail To Do.

    Note: To Dos and Notes from .Mac mail accounts sit in their own little area of the Reminders list in Mail. Control-click the .Mac ones; in the shortcut menu, you'll see options for syncing and editing with your shared calendar. If you check your .Mac mail in a Web browser when you're away from home, you can see (but not edit) the Notes you've created on your Mac.

    (Your To Do list, however, doesn't show up in the Web-based version of .Mac mail. Yet, anyway. Perhaps that's on Apple's own To Do list.)

  • Regardless of what program you're in, you can use a single keystroke (F12 is the factory setting, or F4 on aluminum keyboards) to summon the Address Book Dashboard widget (Section 5.13.3.2). There, you can search for any contact you want, and hide the widget with the same quick keystroke when you're done.

  • When you're composing messages in Mail, Address Book automatically fills in email addresses for you when you type the first few letters.

    Tip: If you choose Window rightwards double arrow Address Panel (Option- [image] -A) from within Mail, you can browse all of your addresses without even launching the Address Book program. Once you've selected the people you want to contact, just click the "To:" button to address an email to them—or, if you already have a new email message open, to add them to the recipients.

    Figure 19-23. The big question: Why isn't this program named iContact? With its threepaned view, soft rounded corners, and gradient-gray background, it looks like a close cousin of iPhoto, iCal, and iTunes.

  • When you use iChat to exchange instant messages with people in your Address Book, the pictures you've stored of them automatically appear in chat windows.

  • If you've bought a subscription to the .Mac service (Section 18.6), you can synchronize your contacts to the Web, so you can see them while you're away from your Mac (Section 6.6). You can also share Address Books with fellow .Mac members: Choose Address Book rightwards double arrow Preferences rightwards double arrow Sharing,click the box for "Share your address book," and then click the + button to add the .Mac pals you want to share with. You can even send them an invitation to come share your contact list. If you get an invitation yourself, open your own Address Book program and choose Edit rightwards double arrow Subscribe to Address Book.

  • Address Book can send its information to an iPod or an iPhone, giving you a "little black book" that fits in your shirt pocket, can be operated one-handed, and comes with built-in musical accompaniment. (To set this up, open iTunes while your iPod or iPhone is connected. Click the iPod/iPhone's icon; on the Contacts or Info tab, turn on "Synchronize Address Book Contacts.")

You can find Address Book in your Applications folder or (in a fresh installation of Mac OS X) in the Dock.

19.10.1. Creating Address Cards

Each entry in Address Book is called a card—like a paper Rolodex card, with predefined spaces to hold all the standard contact information.

To add a new person, choose File rightwards double arrow New Card, press [image] -N, or click the + button beneath the Name column. Then type in the contact information, pressing the Tab key to move from field to field, as shown in Figure 19-24.

Tip: If you find yourself constantly adding the same fields to new cards, check out the Template pane of Address Book's Preferences (Address Book rightwards double arrow Preferences). There, you can customize exactly which fields appear for new cards.

Figure 19-24. If one of your contacts happens to have three office phone extensions, a pager number, two home phone lines, a cellphone, and a couple of fax machines, no problem—you can add as many fields as you need. Click the little green + buttons when editing a card to add more phone, email, chat name, and address fields. (The buttons appear only when the existing fields are filled.) Click a field's name to change its label; you can select one of the standard labels from the pop-up menu (Home, Work, and so on) or make up your own labels by choosing Custom, as seen in the lower portion of this figure.

Each card also contains a free-form Notes field at the bottom, where you can type any other random crumbs of information you'd like to store about the person (pet's name, embarrassing nicknames, favorite Chinese restaurant, and so on).

19.10.1.1. Editing an address

When you create a new address card, you're automatically in Edit mode, which means you can add and remove fields and change the information on the card. To switch into Browse Mode (where you can view and copy contact information but not change it), click the Edit button or choose Edit rightwards double arrow Edit Card ( [image] -L). You can also switch out of Browse Mode in the same ways.

Tip: Regardless of which mode you're in—Edit or Browse—you can always type, drag, or paste text into the Notes field of an address card.
19.10.1.2. Adding addresses from Mail

You can also make new contacts in the Address Book right in Mail, saving you the trouble of having to type names and email addresses manually. Select a message in Mail, then choose Message rightwards double arrow Add Sender to Address Book (or press [image] -Y).Presto:Mac OS X adds a new card to the Address Book, with the name and email address fields already filled in. Later, you can edit the card in Address Book to add phone numbers, street addresses, and so on.

19.10.2. Importing Addresses

The easiest way to add people to Address Book is to import them from another program like Entourage, Outlook Express, or Palm Desktop.

Address Book isn't smart enough to read an Entourage or Outlook Express database—it can only import files in vCard format, the less common LDIF format, or tab-separated database files (described next).

Figure 19-25. This example shows three other kinds of fields that you can plug into your address cards. The phonetic first/last name fields (shown at top) let you store phonetic spellings of hard to-pronounce names. The other fields store screen names for instant messaging networks such as Jabber and Yahoo. To add fields like these, choose from the Card rightwards double arrow Add Field menu.

Still, Mac OS X comes with handy AppleScripts that import addresses automatically from Entourage, Eudora, and tab-separated text files; another Apple Script imports them semi-automatically from Palm Desktop, Outlook Express, Claris Emailer, and Netscape.

Choose Address Book Scripts rightwards double arrow Import Addresses from the Script menu at the top of the screen (Section 7.5.1), and follow the prompts. A minute or two later, you'll have all your old contacts safely transferred into Address Book.

Tip: If you've got contacts in the online Yahoo Address Book, you can sync them up with your Mac OS X Address Book—a new feature in Leopard. Choose Address Book rightwards double arrow Preferences rightwards double arrow General; turn on Yahoo Address Book. Next, click Configure and type your user name and password. Since Yahoo Address Book lives online, you need to be connected to the Internet to link and sync with it.
19.10.2.1. About vCards

Address Book exchanges contact information with other programs primarily through vCards. vCard is short for virtual business card. More and more email programs send and receive these electronic business cards, which you can identify by their .vcf filename extensions (if, that is, you've set your Mac to display these extensions).

If you ever receive an email to which a vCard file is attached, drag the .vcf file into your Address Book window to create an instant entry with a complete set of information. You can create vCards of your own, too. Just drag a name out of your Address Book and onto the desktop (or into a piece of outgoing mail).

Tip: In addition to letting you create vCards of individual entries, Address Book makes it easy to create vCards that contain several entries. To do so, [image] -click the entries in the Name column that you want included, and drag them to the desktop. There, they'll appear all together as a single vCard. You can even drag an item from the Group column to the desktop to make a vCard that contains all the group's entries.Keep this trick in mind if you ever want to copy all your contacts from an old PC to a new Mac. By creating a single vCard containing all your contacts, you've made it trivial to import them into the copy of Address Book running on your new Mac.

19.10.3. Groups

A group is a collection of related address cards, saved under a single descriptive name (as shown in Figure 19-23).

POWER USERS' CLINIC
The Windows-to-Address-Book Journey

Getting names and addresses out of one Mac program and into another is one thing. But what if your contacts are stored on a Windows PC running Microsoft Outlook, the most-used contact manager in the world?

Easy: Use Outlook's Export command to create a tab-delimited text file containing all your contacts. Then copy the text file to your Mac.

In Address Book, choose File rightwards double arrow Import rightwards double arrow Text File (or use the Address Book Import AppleScript described on the facing page), locate the file you exported from Outlook, and click Open. After a short delay, your new contacts appear, ready to go in Address Book.

Organizing your contacts into groups can make them much easier to find and use— especially when your database of addresses climbs into the hundreds. For example, if you regularly send out a family newsletter to 35 relatives, you might gather the address cards of all your assorted siblings, cousins, nieces, nephews, uncles, and aunts into a single group called Family. When addressing an outgoing message using Mail, you can type this group name to reach all of your kin at once. A person can be a member of as many different groups as you want.

Tip: When you send an email message to a group en masse, how does Mail know which email address to use for each person?Because you've told it. Choose Edit rightwards double arrow Edit Distribution List. A special dialog box appears, listing everyone in each group, along with each person's complete list of email addresses. (Use the tiny pop-up menu above the list to choose Phone or Address; that way, you can also indicate the preferred phone number and mailing address.)

To create a group, click the + button at the bottom of the Group column in the Address Book window, or choose File rightwards double arrow New Group (Shift- [image] -N.) Type a name for the newly spawned group icon in the Group column, and then populate it with address cards by dragging entries from the Name list into the group. Clicking a group name automatically locates and displays (in the Names column) all the names that are a part of that group—and hides any that aren't.

GEM IN THE ROUGH
Cool Group Tricks

Dragging cards into and out of groups can be a great way to spend an afternoon, but groups can actually be powerful timesavers. For example, if a card is selected in the Name column, you can quickly highlight all the groups it belongs to by pressing the Option key.

If you've created a lot of groups, it can be very difficult to find a specific one—especially because Address Book's Search box looks only for individual cards. To get around this limitation, click in the Group list and then type the first few letters of a group's name. Address Book jumps right to the first matching group.

You can even add groups to other groups. You might find it useful to keep a Nieces group and a Nephews group, for example, but to keep both groups inside a master Family group. To do this, you'd [image] -click Nieces and Nephews in the Group list, and then Option-drag them onto the Family group. Now, whenever you select Family, you'll see both groups listed among the rest of the cards; double-click either group to see its members.

Also, don't miss the Smart Groups feature of the Address Book. Smart address groups, like smart folders in the Finder, automatically populate themselves with items that match criteria you specify. For example, you might create a smart group called Apple Employees that lists all your contacts with "apple.com" in their email addresses.

To create a smart group, choose File rightwards double arrow New Smart Group (Option- [image] -N). Then use the resulting dialog box (which looks a lot like Mail's smart mailbox dialog box) to specify how you'd like the smart group to fill itself.

Once you're done, you can use your new smart group much like you'd use a regular group. You can't add contacts to a smart group yourself, of course, but you can still send an email to all the members of a smart group, for example, or drag one to the Finder to create a composite vCard.

Tip: To turn a set of address cards into a group very quickly, select multiple entries from the Names column—by either Shift-clicking the names (to make contiguous selections) or [image] -clicking (for non-contiguous selections)—and then choose File rightwards double arrow New Group From Selection. You end up with a new group containing all the selected names.
19.10.3.1. Removing someone from a group

To take someone out of a group, first click the group name, and then click the person's name in the Name column and press the Delete key. If you want to remove the person from Address Book itself, click Delete in the resulting dialog box. Otherwise, just click "Remove from Group" or press Return. Address Book keeps the card, but removes it from the currently selected group.

Note: If you selected All in the Group column, rather than a specific group, you don't get a "Remove from Group" option. Instead, the Mac just asks you to confirm that you do, in fact, want to permanently remove the card.

19.10.4. Adding Pictures

You can dress up each Address Book entry with a photo. Whenever you're editing somebody's address book card, drag a digital photo—preferably 64 pixels square, or a multiple of it—onto the empty headshot square; the image shows up as shown in Figure 19-26. Or double-click the picture well; now you can either browse to a picture on your hard drive by clicking Choose, or, if this person is with you, take a new photo by clicking the camera icon. (Don't miss the swirly button next to it, which lets you apply nutty Photo Boothish effects.) At that point, you can enlarge, reposition, and crop the new photo.)

You don't necessarily have to use a photo, of course. You could add any graphic that you want to represent someone, even if it's a Bart Simpson face or a skull and crossbones. You can use any standard image file in an address card—a JPEG, GIF, PNG, TIFF, or even a PDF.

From now on, if you receive an email from that person, the photo shows up right in the email message.

Tip: If you've got snapshots in iPhoto, it's particularly easy to add a picture to any address card. Just drag a picture directly from the main iPhoto window to the picture frame on the address card to insert it.
19.10.4.1. Replacing and removing a picture

To replace a photo on an address card, just drag a new image on top of the old one. If you want to get rid of an existing picture without replacing it, select the card, then choose Card rightwards double arrow Clear Custom Image (or, in Edit mode, press Delete).

19.10.5. Finding an Address

You can search for an Address Book entry inside the currently selected group by typing a few letters of a name (or address, or any other snippet of contact information) in the Search box (Figure 19-26). To search all your contacts instead of just the current group, click All in the Group list.

Tip: You can press [image] -F to jump directly to the search field and start typing. Your savings: one mouse click.

If Address Book finds more than one matching card, use the downwards arrow and upwards arrow keys, or Return and Shift-Return, to navigate through them.

Figure 19-26. With each letter you type, Address Book filters your social circle and displays the number of matches at the bottom. The matching records themselves appear in the Name column, the first of the matching card entries appears in the far-right pane, and the matching text itself appears highlighted in the matching card.

Figure 19-27. The options that become available when you click the field labels on an address card vary according to field type. Pop-up menus let you send email, open a Web page, or view a map, depending on the type of field you've clicked.

Once you've found the card you're looking for, you can perform some interesting stunts. If you click the label of a phone number ("home" or "office", for example), you see the Large Type option: Address Book displays the number in an absurdly gigantic font that fills the entire width of your screen, making it possible to read the number as you dial from across the room. You can also click the label of an email address to create a preaddressed email message, or click a home page to launch your Web browser and go to somebody's site.

You can also copy and paste (or drag) address card info into another program or convert it into a Sticky Note.

Tip: Once you find a street address in your Address Book, you can find those coordinates on a map by Control-clicking (or right-clicking) the address part of the card and choosing "Map Of" from the shortcut menu, as shown in Figure 19-27. Your Web browser obediently leaps up to display the address on a Google map.

19.10.6. Changing the Address Book Display

You can't do much to customize Address Book's appearance, but the Preferences pane (Address Book rightwards double arrow Preferences) gives you at least a couple of options in the General pane that are worth checking out:

  • Display Order. Choose to have names displayed with the first name followed by the last name, or vice versa.

  • Sort By. Sort the entries in Address Book by either first or last name.

  • Font Size. Choose from Regular, Large, or Extra Large. Unfortunately, you can't change anything else about the font used in the Address Book; the color, face, and style are all locked down.

19.10.7. Printing Options

When you choose File rightwards double arrow Print and click the [image] to expand the Print box, the Style pop-up menu offers four ways to print whatever addresses are selected at the moment:

  • Mailing Labels. This option prints addresses on standard sheets of sticky mailing labels—Avery, for example—that you buy at office-supply stores.

    Tip: As you manipulate settings, you can see your changes in the preview pane on the left. If the preview is too small for you to see, use the Zoom slider. (It doesn't affect your printout.)If you want to access the traditional Print dialog box (to specify paper type, for example), use the unlabeled pop-up menu in the middle of the dialog box top choose Paper Type or whatever. Return to the Labels or Envelopes panes by choosing Address Book from the same pop-up.

  • Envelopes. This feature is great if you have bad handwriting; rather than handaddressing your envelopes, you can have Address Book print them out for you. Use the Layout pop-up menu to pick the size of your envelopes—it's usually listed on the outside of the envelope box.

    Note: Both the Mailing Labels and Envelopes options print only the contacts for which you have, in fact, entered physical mailing addresses.

  • Lists. If all you want is a paper backup of your Address Book entries, use this setting. In the Attributes list, turn on the checkboxes of the fields you want printed—just name and phone number, for example.

  • Pocket Address Book. This feature prints out a convenient paperaddress book from your virtual one. If you pick Indexed from the Flip Style pop-up menu, each page's edge will even list the first letters of the last names listed on the page, making it a cinch to find the page with the address you want. (Here again, you can pick which fields you'd like to include—phone numbers, addresses, and so on.)

As you fiddle with the options presented here, you get to see a miniature preview, right in the dialog box, that shows what you're going to get.

No matter which mode you choose, the only cards that print are the ones that were selected when you chose File rightwards double arrow Print. If you want to print all your cards, therefore, click All in the Group column before you print.

Tip: You can combine the smart-groups feature with the printing features in one clever way: to print yourself a portable phone book when you're heading off for a visit to a different city. That is, set up a smart group that rounds up everyone you know who lives in Chicago, and then print that as a pocket address book.

19.10.8. Address-Book Backups

When you think about it, the contents of your Address Book may represent years of typing and compiling effort. Losing all that information to a corrupted database or a hard drive crash could be devastating. Here are four ways to protect your Address Book data:

POWER USERS' CLINIC
Automatic Notifications

In Address Book, notifying friends and family that your email address has changed is a piece of cake.

Choose Address Book rightwards double arrow Preferences rightwards double arrow General and turn on "Notify people when my card changes." From now on, whenever you change the information in your own address card (like home address, email address, or phone number), Address Book asks whether you want to send a notification email–a virtual change-of-address card. If you do, click Notify.

In the resulting dialog box, choose which groups of people you want to notify, and then personalize the outgoing message. When you click Send, Address Book delivers an email to all the people in the groups you chose, attaching your new vCard (Section 19.10.1.2). When your recipients get the email, they can simply drag the vCard into their own Address Books to update their information about you.

(If you ever want to send updates to your contacts manually, just choose File rightwards double arrow Send Updates.)

  • Turn on .Mac syncing. As described on Section 6.6, having a .Mac account has its privileges—and one of them is automatic synchronizing with other Macs, or just with the .Mac mothership in the Internet cloud.

  • Use the Backup command. Periodically choose File rightwards double arrow Back Up Address Book. If something goes wrong—say, a batch of important contacts gets inadvertently deleted—you can go back to a previously saved version to rescue the data by choosing File rightwards double arrow Revert to Address Book Backup.

  • Backup your entire Address Book database.Open your Home rightwards double arrow Library rightwards double arrow Application Support folder. Copy the entire Address Book folder to another disk—burn it to a CD, download it to your iPod, or upload it to a file server, for example. Now your contact data is safe even in the event of a hard drive failure.

  • Back up your whole Mac with Time Machine. Chapter 6 tells you how.

Note: If you've upgraded from Mac OS X Tiger to Leopard, you've probably noticed that the Address Book can no longer communicate wirelessly with Bluetooth cellphones. If you miss that feature terribly, especially the ability to send text messages from Address Book over your phone's Bluetooth connection, consider the emitSMS Dashboard widget.It lets you send off SMS notes to mobile phone numbers right from your Mac. It works with almost any Bluetooth phone and can look up recipients in the Address Book. You can even write missives longer than the standard 160-character limit (although you're still billed for each 160-character chunk)—which is much easier to do from the comfort of your Mac's keyboard anyway. Download emitSMS from this book's "Missing CD" page at www.missingmanuals.com.


safari-id001.html

Chapter 20. Safari

The Internet has come a long way since its early days in the 1960s, when it was a communications network for universities and the military. Today, that little network has morphed into a international information hub, entertainment provider, and world's biggest mall. For that, we can thank the development of the World Wide Web—the visual, point-and-click face of the Internet.

Apple is obviously intrigued by the possibilities of the Internet. With each new release of Mac OS X, more clever tendrils reach out from the Mac to the world's biggest network: Dashboard, the Wikipedia link in the Dictionary program, Web clippings, Back to My Mac, and so on.

FREQUENTLY ASKED QUESTION
Where to Specify Your Preferred Mail and Browser Programs

Hey! Where the heck do I specify what browser I want to open when, say, I click a link in an email message? It used to be in the Internet panel of System Preferences, but that panel doesn't exist anymore!

You're right. What used to be the Internet panel is now the .Mac panel, and the places where you set up your preferred email and Web programs have gone off to the great software company in the sky.

This is going to sound a little odd. But to indicate that you want some other browser to be your favorite, you start by opening Safari. Choose Safari rightwards double arrow Preferences, click the General tab, and choose from the Default Web Browser pop-up menu.

You change email programs using the same twisted logic: You open Mail, and then open its Preferences.

If you'd rather set your default Web browser and email program (and RSS reader, and so on) from System Preferences, try RCDefaultApp, a free System Preference panel that's about 50 times more powerful than the old Internet panel ever was. (You can download it from the "Missing CD" page at www.missingmanuals.com.)

But Apple's most obvious Internet-friendly creation is Safari, a smartly designed window to the Web (now available for Mac OS X and, believe it or not, Windows). This chapter is all about Safari; the compass icon in the Dock points the way to your Internet adventure.

20.1. Safari

If you want to get something done right, you have to do it yourself.

At least that must be what Apple was thinking when it wrote its own Web browser a few years ago, which so annoyed Microsoft that it promptly ceased all further work on the Mac version of its own Internet Explorer.

Safari is beautiful, very fast, and filled with delicious features. It's not, however, Internet Explorer, and so some Web sites—certain banking sites, for example—refuse to acknowledge its existence. In these situations, you might try the Mac version of Firefox, a free browser available at www.getfirefox.com.

Figure 20-1. The Safari window offers tools and features that let you navigate the Web almost effortlessly. These various toolbars and buttons are described in this chapter. One difference that may throw you if you're used to other browsers: When you're loading a Web page, the progress bar appears as a colored stripe that gradually darkens the address bar itself, rather than as a strip at the bottom of the window.

20.1.1. Browsing Basics and Toolbars

You probably know the drill when it comes to Web browsers. When you click an underlined link (hyperlink) or a picture button, you're transported from one Web page to another. One page may be the home page of General Motors; another may contain critical information about a bill in Congress; another might have baby pictures posted by a parent in Omaha. Altogether, several billion Web pages await your visit.

Tip: Text links aren't always blue and underlined. In fact, trendy Web designers sometimes make it very difficult to tell which text is clickable, and which is just text. When in doubt, move your cursor over some text; if the arrow changes to a pointing-finger cursor, you've found yourself a link.

Some of the other Safari tips that may not be obvious:

  • Graphics worth saving. When you see a picture you'd like to keep, Control-click it (or right-click) and choose Save Image to Downloads from the shortcut menu. Safari stores it as a new graphics file in Leopard's Downloads folder on your hard drive. (You can specify where Safari saves downloaded pictures on the Safari rightwards double arrow Preferences rightwards double arrow General tab. In that case, the shortcut menu's wording changes to say, for example, "Save Image to 'Pictures.'")

    Tip: You can also save a graphic to the desktop just by dragging it there, right out of the Safari window. If you're looking at a picture that you'd like to add to your pictures in iPhoto, Control-click the image and choose Add Image to iPhoto Library. Sweet!

  • Scrollbars. Use the scroll bar to move up and down the page—or to save mousing, press the Space bar each time you want to see more. Press Shift-Space to scroll up. (The Space bar serves its traditional, space-making function only when the insertion point is blinking in a text box or the address bar.)

    You can also press your up and down arrow keys to scroll one line at a time. Page Up and PageDown scroll in full-screen increments, while Home and End whisk you to the top or bottom of the current Web page. And if your mouse has a scroll wheel, it works, too. (Hold Shift while you're rolling the wheel to scroll horizontally.)

20.1.2. Safari Toolbars

Many of Safari's most useful controls come parked on toolbars and buttons that you summon or hide by choosing their names from the View menu. Here's what they do:

20.1.2.1. Address bar

When you type a new Web page address (URL) into this strip and press Enter, the corresponding Web site appears.

Note: If only an error message results, then you may have mistyped the address, or the Web page may have been moved or dismantled—a relatively frequent occurrence in today's rapidly-changing World Wide Web.Similarly, you'll see an error message if Safari can't connect to the Internet at all. (This error message is a masterpiece of clarity: "You are not connected to the Internet.")In that case, click Network Diagnostics to see if Mac OS X can track down the source of your connection trouble. Once you get back online, Safari automatically loads any pages you've been waiting to read.

Because typing out Internet addresses is so central to the Internet experience and such a typo-prone hassle, the address bar is rich with features that minimize keystrokes. For example:

  • You don't have to click the address bar before typing; just press [image] -L.

  • You can highlight the entire address (so it's ready to be typed over with a new one)by clicking the very upper or lower edge of the address bar text box. Alternatively, you can click the small icon just to the left of the current address, or triple-click the address bar, or press [image] -L.

  • You don't have to type out the whole Internet address. You can omit the http://, www, and .com portions; Safari fills in those standard address bits for you. To visit NYTimes.com,for example,a speed freak might press [image] -L to highlight the address bar, type nytimes, and then press Enter.

  • GEM IN THE ROUGH
    Let AutoFill Do the Typing

    Safari can also remember user names, passwords, and other information you type into the text boxes you encounter in your Web travels.

    To turn on this great feature, visit the Safari rightwards double arrow Preferences rightwards double arrow AutoFill tab. If you turn on "Using info from my Address Book card," whenever you're supposed to fill in your shipping address on a Web form, you can click the AutoFill button in the address bar to have Safari fill in the blanks for you automatically. (If you don't see the AutoFill button—see Figure 20-2—choose its name from the View menu, or use Edit rightwards double arrow AutoFill Form to do the deed instead.)

    Alternatively, just click a text box—Name, for example—and start typing. As soon as Safari recognizes a familiar scrap of your contact information, it fills out the rest of the word automatically. (If it guessed wrong, just keep typing.)

    If, in Preferences, you turn on "User names and passwords," then each time you type a password into a Web page, Safari offers to memorize it for you. It's a great time-and brainsaver, even though it doesn't work on all Web sites. (Of course, use it with caution if you share an account on your Mac with other people.)

    When you want Safari to "forget" your passwords—for security reasons, for example—revisit that Safari rightwards double arrow Preferences rightwards double arrow AutoFill tab. Click one of the Edit buttons, and then delete the Web site names for which your information has been stored.

    Turn on Other Forms if you'd like Safari to remember the terms you've typed into search engines, shopping sites, online gaming sites, and so on.

    Tip: You're Web surfing, and you suddenly need to look up an appointment in iCal. What do you do?The power user opens other programs right from within Safari by typing ical:// in the address bar—or ichat://, addressbook://, or sherlock://—and then pressing Return or Enter. (Unfortunately, those are just about the only Apple programs that work with this URL-launching trick.)You can also type mailto: to open a new outgoing email message in your default email program, or mailto: steve@apple.com to preaddress that outgoing message to Steve Jobs. (Of course, remember to replace that email address with someone you'd actually like to contact.)

  • When you begin to type into the address bar,the AutoComplete feature compares what you're typing against a list of Web sites you've recently visited or that you've saved as bookmarks. Safari displays a drop-down list of Web addresses that seem to match what you're typing. To spare yourself the tedium of typing out the whole thing, click the correct complete address with your mouse, or use the down arrow key to reach the desired listing and then press Enter. The complete address you select then pops into the address bar.

Tip: You might wonder why the View menu even offers you the chance to hide the address bar. If it were hidden, how could you use the Web?Simple: Even with this bar hidden, you can briefly summon it by pressing [image] -L. Type the address you want and then press Enter to make the bar disappear again. That's good news for people with small screens—and for Mac trivia collectors.

You can summon or dismiss a number of individual buttons on the address bar, in effect customizing it (Figure 20-2):

  • Back/Forward. Click the [image] button to revisit the page you were just on. Keyboard shortcut: Delete, or [image] -left arrow, or [image] -left bracket.

    Once you've clicked [image], you can then click the [image] button (or press [image] -right arrow, or [image] -right bracket) to return to the page you were on before you clicked the Back button. Click and hold on the [image] button for a drop-down list of all the Web pages you've visited during this online session.

Figure 20-2. You summon or hide these buttons by choosing View rightwards double arrow Customize Address bar and dragging buttons onto or off the address bar. Some of them lack text labels, but all offer tooltip labels that you can read by pointing to the button without clicking.

That pop-up menu lists the sites by name, as in "The New York Times—Breaking News, World News & Multimedia." To view the actual addresses instead, Optionclick (and hold the mouse down on) the Back or Forward button.

Tip: Instead of clicking and holding the [image] or [image] button for these tricks, you can save half a second of waiting by just Control-clicking.

  • Home. Click to bring up the Web page you've designated as your home page (in Safari rightwards double arrow Preferences rightwards double arrow General tab).

  • AutoFill. Click this button to make Safari fill in Web order forms with your name, address, and other information. See the box on Section 20.1.2.

  • Text Size. You can adjust the point size of a Web page's text using these buttons. When you visit a Web site designed for Windows computers—whose text often looks too small on Mac screens—you can use these buttons to bump up the size. Keyboard shortcut: -plus or [image] -minus.

  • Stop/Reload. Click the Stop button to interrupt the downloading of a Web page you've just requested (if you've made a mistake, for instance). Keyboard shortcut: Esc or [image] -period.

    Once a page has finished loading, the Stop button turns into a Refresh button. Click this circular arrow if a page doesn't look or work quite right, or if you want to see the updated version of a Web page (such as a breaking-news site) that changes constantly. Safari redownloads the Web page and reinterprets its text and graphics. Keyboard shortcut: -R.

  • Web Clip. This scissors-clipping-coupon icon is the key to creating Dashboard Web clips, as described on Section 5.13.4. Click this button, and then select the part of the page you want to widgetize.

  • Add Bookmark. When you find a Web page you might like to visit again, click this button. You can also press [image] -D, or choose Bookmarks rightwards double arrow Add Bookmark, or drag the tiny icon from the address bar directly onto your Bookmarks bar.

    As shown in Figure 20-3, Safari offers to add this Web page's name (or a shorter name that you specify for it) either to the Bookmarks menu or to the Bookmarks bar described below. The next time you want to visit that page, just select its name in whichever location you chose.

    Tip: Press Shift- [image] -D to add the bookmark to the menu instantly—no questions asked, no dialog box presented.

    You can rearrange the names in your Bookmarks menu easily: Choose Bookmarks rightwards double arrow Show All Bookmarks (Option- [image] -B), or click the tiny book icon shown in Figure 20-3. In the resulting organization window, drag the bookmarks up and down.

    For more dramatic management tasks—to edit, rename, or delete your bookmarks, for example—also see Figure 20-3.

  • Google Search. Here's one of Safari's most profoundly useful features—a Search box that automatically sends your search request to Google.com, the world's most popular Web search page. Press Option- [image] -F to deposit your insertion point inside this rounded text box, type something you're looking for—phony baloney, say—and then press Enter. Safari takes you directly to the Google results page.

    Figure 20-3. Top: Once you've got a juicy Web page on the screen, you can drag its tiny page-logo icon from the address bar directly onto the Bookmarks bar or menu.
    Second from top: Safari realizes that you may prefer a shorter name to appear on the space-limited bar, so it offers you the chance to type in a label you prefer.
    Third from top: When you click OK, the new button appears on the bar, as shown here. (You can also drag any link to the bar, such as a blue underlined phrase from a Web page, or even an icon from your desktop!) To remove a button, drag it off the bar; to rearrange the icons, just drag them.
    Bottom: Click the little book icon (circled) to open the Organize Bookmarks window. Here, you can drag names up or down to rearrange the list, or drag them into a "folder" that becomes a submenu in the Bookmarks menu. (Create a submenu by clicking the + button below the list.) You can edit a bookmark by clicking once on its name or URL, or delete one by pressing Delete.

    Tip: The tiny [image] at the left end of the Google bar is a pop-up menu of your most recent searches.Bonus Tip: If you Control-click (or right-click) a highlighted word or phrase on a Web page, you can choose Google Search from the shortcut menu to search for that text. And, even cooler, this trick works in all Cocoa programs—not just Safari.

  • Print. You can add a printer icon to Safari for point-and-click paper action if you don't want to bother with [image] -P.

  • Bug. Ladies and gentlemen, this is Apple at its most humble. This insect-shaped button opens a tiny "Dear Apple" box, where you can tell Apple about a Safari feature or Web page that doesn't work. If you click Options, you can even send Apple a screen illustration of, for example, a screwy Web-page layout that Safari delivered.

20.1.2.2. Bookmarks bar

The Bookmarks menu is one way to maintain a list of Web sites you visit frequently. But opening a Web page from that menu requires two mouse clicks—an exorbitant expenditure of energy. The Bookmarks bar (View rightwards double arrow Bookmarks Bar), on the other hand, lets you summon a few very favorite Web pages with only one click.

Tip: If you have a bunch of bookmarks stored in another Web browser, use that browser's export feature to save them in a file, and then use Safari's File rightwards double arrow Import Bookmarks command to save you the time of re-entering the bookmarks by hand.

Figure 20-3 illustrates how to add buttons to, and remove them from, this toolbar.

Tip: As shown in Figure 20-3, you can drag a link from a Web page onto your Bookmarks bar. But you can also drag a link directly to the desktop, where it turns into an Internet location file. Thereafter, to launch your browser and visit the associated Web page whenever you like, just double-click this icon.Better yet, stash a few of these icons in your Dock or Sidebar for even easier access.

20.1.3. Status Bar

The Status bar at the bottom of the window tells you what Safari is doing (such as "Opening page…" or "Done"). When you point to a link without clicking, the Status bar also tells you which URL opens if you click it. For those two reasons, it's a very useful strip, but it doesn't appear when you first run Safari. You have to summon it by choosing View rightwards double arrow Show Status Bar.

20.1.4. Tips for Better Surfing

Safari is filled with shortcuts and tricks for better speed and more pleasant surfing. For example:

20.1.4.1. SnapBack

The little orange SnapBack button ( [image] ), which sometimes appears at the right end of the address bar or Google search bar, takes you instantly back to the Web page whose address you last typed (or whose bookmark you last clicked), or to your first Google results page.

The point here is that, after burrowing from one link to another in pursuit of some Google result or Amazon listing, you can return to your starting point without having to mash the Back button over and over again. (The SnapBack button doesn't appear until you've actually clicked away from the first page you visited.)

Tip: At any time, you can designate your current page as the new SnapBack page. To do so, choose History rightwards double arrow Mark Page for SnapBack (Option- [image] -K).And you can snap back from the keyboard, too: Option- [image] -P.
20.1.4.2. Stifle pop-ups and pop-unders

The world's smarmiest advertisers inundate us with pop-up and pop-under ads—nasty little windows that appear in front of the browser window or, worse, behind it, waiting to jump out the moment you close your current window. They're often deceptive, masquerading as error messages or dialog boxes, and they'll do absolutely anything to get you to click inside them.

If this kind of thing is driving you crazy, choose Safari rightwards double arrow Block Pop-Up Windows, so that a checkmark appears next to the command. It's a war out there—but at least you now have some ammunition.

Note: This feature doesn't squelch small windows that pop up when you click a link—only windows that appear unbidden.Even unbidden windows, however, are sometimes legitimate (and not ads)—notices of new banking features, warnings that the instructions to use a site have changed, and so on. Safari can't tell these from ads and stifles them too. So if a site you trust says "Please turn off pop-up blockers and reload this page," you know you're probably missing out on a useful pop-up message.And one more thing: These days, the evildoers of the Internet have begun to create pop-up windows using nonstandard programming code that Safari and other browsers can't do anything about. Fortunately, they're still fairly rare.
20.1.4.3. Impersonating Internet Explorer

Sooner or later, you'll run into a Web site that doesn't work in Safari. Why? When you arrive at a Web site, your browser identifies itself. That's because many commercial Web sites display a different version of the page depending on the browser you're using, thanks to differences in the way various browsers interpret Web layouts.

But because you're one of the minority oddballs using Safari, your otherwise beloved Web site tells you: "Sorry, browser not supported." (Will this problem change now that Apple has released a Windows version of Safari? We can only hope.)

In such times of trouble, you can make Safari impersonate any other browser, which is often good enough to fool the picky Web site into letting you in.

The key to this trick is Safari's Debug menu, which is generally hidden. You can make it appear in either of two ways:

  • Download TinkerTool, a free program available on the "Missing CD" page at www.missingmanuals.com. It offers a simple checkbox that turns on the debug menu.

  • Use the Terminal command defaults write com.apple.Safari Include DebugMenu 1.(Details on using Terminal in Chapter 16.)

    When you next open Safari, the new Debug menu appears right next to Help. Most of its commands are designed to appeal to programmers, but the submenu you want—User Agent—is useful to everyone. It lets Safari masquerade as a different browser. Choose User Agent rightwards double arrow Mac MSIE 5.22, for example, to assume the identity of Internet Explorer for Macintosh.

Tip: If you're into Web-page coding or design, Safari's Debug menu houses a Leopard first: the Web Inspector. Control-click (or right-click) any part of a Web page—image, text, link—and choose Inspect Element from the shortcut menu.The Web Inspector highlights the element you clicked and opens a window so you can see every little bit of HTML coding that went into putting that item on the page. You also see the style sheets, images, and other files displayed in the Inspector's window—making it really easy to see (and learn) how the page was made.
20.1.4.4. Where am I?

As you dig your way down into a Web site, you may wish you could have left a trail of bread crumbs to mark your path. Ah, but Safari has already thought of that. See Figure 20-4.

Figure 20-4. If you -click the title bar (centered just above the address bar), Safari displays the "ladder" of pages you descended to arrive at the current one.

20.1.4.5. Faster browsing without graphics

Graphics are part of what makes the Web so compelling. But they're also responsible for making Web pages take so long to arrive on the screen. Without them, Web pages appear almost instantaneously—and you still get fully laid-out Web pages with all their text and headlines.

To turn off graphics, choose Safari rightwards double arrow Preferences, and then click the Appearance tab. Turn off "Display images when the page opens," and close the Preferences window. Now try visiting a few Web pages and enjoy the substantial speed boost. (If you wind up on a Web page that's nothing without its pictures, return to Safari rightwards double arrow Preferences, turn the same checkbox on, and then reload the page.)

20.1.4.6. Viewing Web pages offline

You don't have to be connected to the Net to read a favorite Web page. You can save a certain Web page on your hard drive so that you can peruse it later—on your laptop during your commute, for example—just by choosing File rightwards double arrow Save As.

To save the entire page, along with all its images, movies, and so on, choose Web Archive from the Format pop-up menu.

Tip: Whenever you buy something online, don't waste paper by printing out the final "This is your receipt" page. Instead, choose File rightwards double arrow Print and, from the PDF pop-up button, choose Save PDF to Web Receipts folder. Safari saves it as a PDF file into a tidy folder (in your Home rightwards double arrow Documents folder) called Web Receipts. Nice touch!
20.1.4.7. Sending a page to a friend

Safari provides two different ways of telling a friend about the page you're looking at. You might find that useful when you come across a particularly interesting news story, op-ed piece, or burrito recipe.

  • The send-the-whole-page method. While looking at a page, choose File rightwards double arrow Mail Contents of This Page ( [image] -I) to open a new Mail message with a copy of the actual Web page in the body. Address the message and click Send.

    Caution:HTML messages (like the ones you send with this technique) are bandwidth-clogging monstrosities, so the message can take a while to download on the other end—especially over a dial-up connection.

  • The send-a-link method. To send just a link to the page you're looking at, choose File rightwards double arrow Mail Link to This Page (Shift- [image] -I). Then proceed as usual, addressing the message and clicking Send.

    Links take only a split second for your recipient to download, and they're guaranteed to display properly in all email programs. All your recipients have to do is click the link to open it in their Web browsers.

20.1.4.8. Expanding Web forms

If the customer-service comment form on that corporate Web site doesn't give you enough room to rant properly, you can resize the text box right on the page—a new, very welcome feature in Leopard. Figure 20-5 tells all.

Figure 20-5. This trick works on a Web page's text fields—comment boxes, forms to send a letter to the mayor, and so on. You can resize such boxes by dragging the three diagonal ribbed lines in the lower-right corner of the text field. The rest of the page adjusts itself to the new text-box size, and you have room to say what you need to say.

20.1.4.9. Designate your home page

The first Web site you encounter when Safari connects to the Internet is an Apple Web site. This site is your home page. You'll probably find Web browsing more fun, though, if you specify your favorite Web page as your home page.

To do that, navigate your way to the page you prefer. Google, or its news page, http://news.google.com, is a good starting place. So is your favorite newspaper home page, or www.macsurfer.com, a summary of the day's Mac news coverage around the world, or maybe www.dilbert.com for today's Dilbert cartoon.

Then choose Safari rightwards double arrow Preferences, click the General tab, and click Set to Current Page (or type the address into the box).

If you can't decide on a home page, or your mood changes from day to day, use the "New windows open with" pop-up menu to choose Empty Page. Some people prefer this setup, which makes Safari load very quickly when you first open it. Once this empty window opens, then you can tell the browser where you want to go today.

Tip: In the Safari rightwards double arrow Preferences rightwards double arrow General tab, you can also choose Bookmarks. Then, whenever you open a new window or launch Safari, you can choose exactly which page you want to open by choosing from a list of your bookmarks.
20.1.4.10. The History Menu

The History menu lists the Web sites you've visited in the last week or so, neatly organized into subfolders like "Earlier Today" and "Yesterday." (A similar menu appears when you click and hold on the Back or Forward button.) These are great features if you can't recall the URL for a Web site that you remember having visited recently.

Tip: As illustrated on Section 1.10, the new Help search box searches all of a program's menus—including Safari's History menu. You can re-find a site without hunting through all the History submenus manually.
20.1.4.11. Finding text within Web pages

The Google Search bar can help you find Web sites that match your keywords. But some pages are so long, dense, or poorly designed that finding the words on the page needs a whole'nother search engine. Fortunately, Safari's new search-within-the-page function shines a light on the words or phrase you're seeking.

To use it, press [image] -F and then type your search word into the Find box (Figure 20-6). As Safari locates the word or words, it displays them within a bright yellow box and dims the background of the rest of the page. The Find bar also tells you how many times the word or phrase occurs on the page; you can jump to each instance. Click the [image] to start over with new search terms, or click Done to close the Find bar and return to your normal browsing activity.

Figure 20-6. Once you enter your keywords ("Eagles" in this case), the browser dims the page and highlights every instance of that word—making it much easier to find what you're looking for across a crowded Web page.

20.1.4.12. Zoom in on PDF pPages

PDF files are all over the Web as, among other things, forms to download, online brochures, and scanned book pages. But they aren't always especially readable in a browser window.

Unless, that is, you're using Safari and its new PDF viewing and saving tools. The next time you're squinting at a PDF in the window, point to the bottom edge of the document; you'll see a toolbar appear like the one in Figure 20-7. With these four icons, you can zoom out, zoom in, open the file in Preview, or save the PDF file itself to your Downloads folder.

Figure 20-7. If you're having trouble reading the tiny type in a PDF, hover your mouse at the bottom of it to invoke Safari's PDF toolbar. You can zoom out, zoom in, open the file in the Mac's Preview program, or even download it from the Web site with a well-placed click.

20.1.5. Tabbed Browsing

Beloved by hardcore surfers the world over, tabbed browsing is a way to keep a bunch of Web pages open simultaneously—in a single, neat window. Figure 20-8 illustrates.

Turning on tabbed browsing unlocks a whole raft of Safari shortcuts and tricks, which are just the sort of thing power surfers gulp down like Gatorade:

  • If there's a certain set of Web sites you like to visit daily, put the bookmarks in to one folder, using Bookmarks rightwards double arrow Add Bookmark Folder and the Bookmarks organizer window (Figure 20-3). You can then load all of them at once into a single tabbed window, simply by selecting the resulting "folder" in the Bookmarks menu—or the Bookmarks bar—and choosing Open in Tabs from the submenu.

    The beauty of this arrangement is that you can start reading the first Web page while all of the others load into their own tabs in the background.

    Tip: Click the [image] icon at the left end of the Bookmarks bar. In the Bookmarks organizer, click the Bookmarks Bar item in the left-side list. Now you can see an Auto-Click checkbox for each listed folder.If you turn on this checkmark, then you'll be able to open all the bookmarks in that folder into tabs, all at once, merely by clicking the folder's name in the Bookmarks bar. (If you want to summon the normal menu from the folder, just hold the mouse button down.)

    Figure 20-8. Top: First turn on tabbed browsing in Safari's Preferences rightwards double arrow Tabs window. (For best results, also turn on "Select new tabs as they are created.")
    Bottom: Now, when you -click a link, or type an address and press -Return or -Enter, you open a new tab, not a new window as you ordinarily would. You can now pop from one open page to another by clicking the tabs just under your Bookmarks bar, or close one by clicking its button (or pressing -W).

  • A variation on a theme: When you have a bunch of pages open in tabs, you can drag the tabs across the window to rearrange the order. When you have them the way you want them, Control-click (or right-click) a tab, and then choose "Add Bookmark for These [Number] Tabs" from the shortcut menu. You can save your saved tabs to the Bookmarks bar and load all those pages with one click.

  • If you Option-click a tab's [image] (close) button, you close all tabs except the one you clicked. The same thing happens if you hold down Option and choose File rightwards double arrow Close Other Tabs, or if you press Option- [image] -W.

  • If you Option- [image] -click a link, it opens in a separate window, rather than a new tab. (When tabbed browsing is turned off, you just [image] -click a link to open a new window.)

  • If you find yourself with a bunch of separate browser windows all over your screen, you can neatly consolidate them all into one nicely tabbed Safari window by choosing Window rightwards double arrow Merge All Windows.

    FREQUENTLY ASKED QUESTION
    Erasing Your Tracks—and Private Browsing

    So, about this History menu: I'd just as soon my wife/husband/boss/parent/kid not know what Web sites I've been visiting. Must that History menu display my movements quite so proudly?

    Some people find it creepy that Safari maintains a complete list of every Web site they've seen recently, right there in plain view of any family member or co-worker who wanders by.

    To delete just one particularly incriminating History listing, click the book icon at the left end of the Bookmarks bar; in the resulting Bookmarks organizer window, click History. Expand the relevant date triangle, highlight the offending address, and then press your Delete key. Click the book icon again to return to normal browsing. You've just rewritten History!

    Or, to erase the entire History menu, choose History rightwards double arrow Clear History.

    Of course, the History menu isn't the only place where you've left footprints. If you choose Safari rightwards double arrow Reset Safari instead, you also erase all other shreds of your activities: any cookies (Web-page preference files) you've accumulated, your list of past downloads, the cache files (tiny Web graphics files on your hard drive that a browser stores to save time when you return to the page they came from), and so on. This is good information to know; after all, you might be nominated to the Supreme Court some day.

    That's a lot of work just to cover my tracks; it also erases a lot of valuable cookies, passwords, and History entries I'd like to keep. Is all that really necessary just so I can duck in for an occasional look at the Hot Bods of the Midwestern Tax Preparers' Association Web site?

    No, it's not. A feature called private browsing lets you surf without adding any pages to your History list, searches to your Google search box, passwords to Safari's saved password list, or autofill entries to Safari's memory. (Apple says that this feature is intended for use at public Macs, where you don't want to reveal anything personal to subsequent visitors. Ha!)

    The trick is to choose Safari rightwards double arrow Private Browsing before you start browsing. Once you OK the explanation box, Safari records nothing while you surf. (Nothing, that is, except cookies. Your tracks, in other words, are not completely hidden. You can erase cookies, if need be, in Safari rightwards double arrow Preferences rightwards double arrow Security.)

    When you're ready to browse "publicly" again, choose Safari rightwards double arrow Private Browsing once more so the checkmark goes away. Safari once again begins taking note of the pages you visit—but it never remembers the earlier ones.

    In other words, what happens in Private Browsing stays in Private Browsing.

  • If you Shift- [image] -click a link, Safari opens that page in a tab behind the one you're reading. That's a fantastic trick when you're reading a Web page and see a reference you want to set aside for reading next, but you don't want to interrupt whatever you're reading.

Tip: Deep in the guts of Safari is a neatly formatted page that lists nearly every keyboard shortcut in Safari. To see it (so you can print it, perhaps), Control-click the Safari icon in the Finder. Choose Show Package Contents from the shortcut menu. In the new window, open Contents rightwards double arrow Resources. Finally, drag the icon called Shortcuts.html right into the Safari window.(If you've installed the Debug menu as described on Section 20.1.4.4, there's an even easier way: Choose Debug rightwards double arrow Keyboard and Mouse Shortcuts.)

FREQUENTLY ASKED QUESTION
Cookie Control

Help! I'm afraid of cookies! The cookies are trying to watch me!

Cookies are something like Web page preference files. Certain Web sites—particularly commercial ones like Amazon.com—deposit them on your hard drive like little bookmarks, so that they'll remember you the next time you visit. Most cookies are perfectly innocuous—and, in fact, are extremely helpful, because they help Web sites remember your tastes. Cookies also spare you the effort of having to type in your name, address, credit card number, and so on, every time you visit these Web sites.

But fear is widespread, and the media fans the flames with tales of sinister cookies that track your movement on the Web. If you're worried about invasions of privacy, Safari is ready to protect you.

Once the browser is open, choose Safari rightwards double arrow Preferences rightwards double arrow Security tab. The buttons in this dialog box are like a paranoia gauge. If you click Never, you create an acrylic shield around your Mac. No cookies can come in, and no cookie information can go out. You'll probably find the Web a very inconvenient place; you'll have to re-enter your information upon every visit, and some Web sites may not work properly at all.

A good compromise is "Only from sites you navigate to," which accepts cookies from sites you want to visit, but blocks cookies deposited on your hard drive by sites you're not actually visiting—cookies an especially evil banner ad gives you, for example.

Note, too, the Show Cookies button, which reveals the shockingly complete list of every cookie you've accumulated so far—and offers you the chance to delete the ones that don't look so savory.


safari-id002.html

Chapter 20. Safari

The Internet has come a long way since its early days in the 1960s, when it was a communications network for universities and the military. Today, that little network has morphed into a international information hub, entertainment provider, and world's biggest mall. For that, we can thank the development of the World Wide Web—the visual, point-and-click face of the Internet.

Apple is obviously intrigued by the possibilities of the Internet. With each new release of Mac OS X, more clever tendrils reach out from the Mac to the world's biggest network: Dashboard, the Wikipedia link in the Dictionary program, Web clippings, Back to My Mac, and so on.

FREQUENTLY ASKED QUESTION
Where to Specify Your Preferred Mail and Browser Programs

Hey! Where the heck do I specify what browser I want to open when, say, I click a link in an email message? It used to be in the Internet panel of System Preferences, but that panel doesn't exist anymore!

You're right. What used to be the Internet panel is now the .Mac panel, and the places where you set up your preferred email and Web programs have gone off to the great software company in the sky.

This is going to sound a little odd. But to indicate that you want some other browser to be your favorite, you start by opening Safari. Choose Safari rightwards double arrow Preferences, click the General tab, and choose from the Default Web Browser pop-up menu.

You change email programs using the same twisted logic: You open Mail, and then open its Preferences.

If you'd rather set your default Web browser and email program (and RSS reader, and so on) from System Preferences, try RCDefaultApp, a free System Preference panel that's about 50 times more powerful than the old Internet panel ever was. (You can download it from the "Missing CD" page at www.missingmanuals.com.)

But Apple's most obvious Internet-friendly creation is Safari, a smartly designed window to the Web (now available for Mac OS X and, believe it or not, Windows). This chapter is all about Safari; the compass icon in the Dock points the way to your Internet adventure.

20.1. Safari

If you want to get something done right, you have to do it yourself.

At least that must be what Apple was thinking when it wrote its own Web browser a few years ago, which so annoyed Microsoft that it promptly ceased all further work on the Mac version of its own Internet Explorer.

Safari is beautiful, very fast, and filled with delicious features. It's not, however, Internet Explorer, and so some Web sites—certain banking sites, for example—refuse to acknowledge its existence. In these situations, you might try the Mac version of Firefox, a free browser available at www.getfirefox.com.

Figure 20-1. The Safari window offers tools and features that let you navigate the Web almost effortlessly. These various toolbars and buttons are described in this chapter. One difference that may throw you if you're used to other browsers: When you're loading a Web page, the progress bar appears as a colored stripe that gradually darkens the address bar itself, rather than as a strip at the bottom of the window.

20.1.1. Browsing Basics and Toolbars

You probably know the drill when it comes to Web browsers. When you click an underlined link (hyperlink) or a picture button, you're transported from one Web page to another. One page may be the home page of General Motors; another may contain critical information about a bill in Congress; another might have baby pictures posted by a parent in Omaha. Altogether, several billion Web pages await your visit.

Tip: Text links aren't always blue and underlined. In fact, trendy Web designers sometimes make it very difficult to tell which text is clickable, and which is just text. When in doubt, move your cursor over some text; if the arrow changes to a pointing-finger cursor, you've found yourself a link.

Some of the other Safari tips that may not be obvious:

  • Graphics worth saving. When you see a picture you'd like to keep, Control-click it (or right-click) and choose Save Image to Downloads from the shortcut menu. Safari stores it as a new graphics file in Leopard's Downloads folder on your hard drive. (You can specify where Safari saves downloaded pictures on the Safari rightwards double arrow Preferences rightwards double arrow General tab. In that case, the shortcut menu's wording changes to say, for example, "Save Image to 'Pictures.'")

    Tip: You can also save a graphic to the desktop just by dragging it there, right out of the Safari window. If you're looking at a picture that you'd like to add to your pictures in iPhoto, Control-click the image and choose Add Image to iPhoto Library. Sweet!

  • Scrollbars. Use the scroll bar to move up and down the page—or to save mousing, press the Space bar each time you want to see more. Press Shift-Space to scroll up. (The Space bar serves its traditional, space-making function only when the insertion point is blinking in a text box or the address bar.)

    You can also press your up and down arrow keys to scroll one line at a time. Page Up and PageDown scroll in full-screen increments, while Home and End whisk you to the top or bottom of the current Web page. And if your mouse has a scroll wheel, it works, too. (Hold Shift while you're rolling the wheel to scroll horizontally.)

20.1.2. Safari Toolbars

Many of Safari's most useful controls come parked on toolbars and buttons that you summon or hide by choosing their names from the View menu. Here's what they do:

20.1.2.1. Address bar

When you type a new Web page address (URL) into this strip and press Enter, the corresponding Web site appears.

Note: If only an error message results, then you may have mistyped the address, or the Web page may have been moved or dismantled—a relatively frequent occurrence in today's rapidly-changing World Wide Web.Similarly, you'll see an error message if Safari can't connect to the Internet at all. (This error message is a masterpiece of clarity: "You are not connected to the Internet.")In that case, click Network Diagnostics to see if Mac OS X can track down the source of your connection trouble. Once you get back online, Safari automatically loads any pages you've been waiting to read.

Because typing out Internet addresses is so central to the Internet experience and such a typo-prone hassle, the address bar is rich with features that minimize keystrokes. For example:

  • You don't have to click the address bar before typing; just press [image] -L.

  • You can highlight the entire address (so it's ready to be typed over with a new one)by clicking the very upper or lower edge of the address bar text box. Alternatively, you can click the small icon just to the left of the current address, or triple-click the address bar, or press [image] -L.

  • You don't have to type out the whole Internet address. You can omit the http://, www, and .com portions; Safari fills in those standard address bits for you. To visit NYTimes.com,for example,a speed freak might press [image] -L to highlight the address bar, type nytimes, and then press Enter.

  • GEM IN THE ROUGH
    Let AutoFill Do the Typing

    Safari can also remember user names, passwords, and other information you type into the text boxes you encounter in your Web travels.

    To turn on this great feature, visit the Safari rightwards double arrow Preferences rightwards double arrow AutoFill tab. If you turn on "Using info from my Address Book card," whenever you're supposed to fill in your shipping address on a Web form, you can click the AutoFill button in the address bar to have Safari fill in the blanks for you automatically. (If you don't see the AutoFill button—see Figure 20-2—choose its name from the View menu, or use Edit rightwards double arrow AutoFill Form to do the deed instead.)

    Alternatively, just click a text box—Name, for example—and start typing. As soon as Safari recognizes a familiar scrap of your contact information, it fills out the rest of the word automatically. (If it guessed wrong, just keep typing.)

    If, in Preferences, you turn on "User names and passwords," then each time you type a password into a Web page, Safari offers to memorize it for you. It's a great time-and brainsaver, even though it doesn't work on all Web sites. (Of course, use it with caution if you share an account on your Mac with other people.)

    When you want Safari to "forget" your passwords—for security reasons, for example—revisit that Safari rightwards double arrow Preferences rightwards double arrow AutoFill tab. Click one of the Edit buttons, and then delete the Web site names for which your information has been stored.

    Turn on Other Forms if you'd like Safari to remember the terms you've typed into search engines, shopping sites, online gaming sites, and so on.

    Tip: You're Web surfing, and you suddenly need to look up an appointment in iCal. What do you do?The power user opens other programs right from within Safari by typing ical:// in the address bar—or ichat://, addressbook://, or sherlock://—and then pressing Return or Enter. (Unfortunately, those are just about the only Apple programs that work with this URL-launching trick.)You can also type mailto: to open a new outgoing email message in your default email program, or mailto: steve@apple.com to preaddress that outgoing message to Steve Jobs. (Of course, remember to replace that email address with someone you'd actually like to contact.)

  • When you begin to type into the address bar,the AutoComplete feature compares what you're typing against a list of Web sites you've recently visited or that you've saved as bookmarks. Safari displays a drop-down list of Web addresses that seem to match what you're typing. To spare yourself the tedium of typing out the whole thing, click the correct complete address with your mouse, or use the down arrow key to reach the desired listing and then press Enter. The complete address you select then pops into the address bar.

Tip: You might wonder why the View menu even offers you the chance to hide the address bar. If it were hidden, how could you use the Web?Simple: Even with this bar hidden, you can briefly summon it by pressing [image] -L. Type the address you want and then press Enter to make the bar disappear again. That's good news for people with small screens—and for Mac trivia collectors.

You can summon or dismiss a number of individual buttons on the address bar, in effect customizing it (Figure 20-2):

  • Back/Forward. Click the [image] button to revisit the page you were just on. Keyboard shortcut: Delete, or [image] -left arrow, or [image] -left bracket.

    Once you've clicked [image], you can then click the [image] button (or press [image] -right arrow, or [image] -right bracket) to return to the page you were on before you clicked the Back button. Click and hold on the [image] button for a drop-down list of all the Web pages you've visited during this online session.

Figure 20-2. You summon or hide these buttons by choosing View rightwards double arrow Customize Address bar and dragging buttons onto or off the address bar. Some of them lack text labels, but all offer tooltip labels that you can read by pointing to the button without clicking.

That pop-up menu lists the sites by name, as in "The New York Times—Breaking News, World News & Multimedia." To view the actual addresses instead, Optionclick (and hold the mouse down on) the Back or Forward button.

Tip: Instead of clicking and holding the [image] or [image] button for these tricks, you can save half a second of waiting by just Control-clicking.

  • Home. Click to bring up the Web page you've designated as your home page (in Safari rightwards double arrow Preferences rightwards double arrow General tab).

  • AutoFill. Click this button to make Safari fill in Web order forms with your name, address, and other information. See the box on Section 20.1.2.

  • Text Size. You can adjust the point size of a Web page's text using these buttons. When you visit a Web site designed for Windows computers—whose text often looks too small on Mac screens—you can use these buttons to bump up the size. Keyboard shortcut: -plus or [image] -minus.

  • Stop/Reload. Click the Stop button to interrupt the downloading of a Web page you've just requested (if you've made a mistake, for instance). Keyboard shortcut: Esc or [image] -period.

    Once a page has finished loading, the Stop button turns into a Refresh button. Click this circular arrow if a page doesn't look or work quite right, or if you want to see the updated version of a Web page (such as a breaking-news site) that changes constantly. Safari redownloads the Web page and reinterprets its text and graphics. Keyboard shortcut: -R.

  • Web Clip. This scissors-clipping-coupon icon is the key to creating Dashboard Web clips, as described on Section 5.13.4. Click this button, and then select the part of the page you want to widgetize.

  • Add Bookmark. When you find a Web page you might like to visit again, click this button. You can also press [image] -D, or choose Bookmarks rightwards double arrow Add Bookmark, or drag the tiny icon from the address bar directly onto your Bookmarks bar.

    As shown in Figure 20-3, Safari offers to add this Web page's name (or a shorter name that you specify for it) either to the Bookmarks menu or to the Bookmarks bar described below. The next time you want to visit that page, just select its name in whichever location you chose.

    Tip: Press Shift- [image] -D to add the bookmark to the menu instantly—no questions asked, no dialog box presented.

    You can rearrange the names in your Bookmarks menu easily: Choose Bookmarks rightwards double arrow Show All Bookmarks (Option- [image] -B), or click the tiny book icon shown in Figure 20-3. In the resulting organization window, drag the bookmarks up and down.

    For more dramatic management tasks—to edit, rename, or delete your bookmarks, for example—also see Figure 20-3.

  • Google Search. Here's one of Safari's most profoundly useful features—a Search box that automatically sends your search request to Google.com, the world's most popular Web search page. Press Option- [image] -F to deposit your insertion point inside this rounded text box, type something you're looking for—phony baloney, say—and then press Enter. Safari takes you directly to the Google results page.

    Figure 20-3. Top: Once you've got a juicy Web page on the screen, you can drag its tiny page-logo icon from the address bar directly onto the Bookmarks bar or menu.
    Second from top: Safari realizes that you may prefer a shorter name to appear on the space-limited bar, so it offers you the chance to type in a label you prefer.
    Third from top: When you click OK, the new button appears on the bar, as shown here. (You can also drag any link to the bar, such as a blue underlined phrase from a Web page, or even an icon from your desktop!) To remove a button, drag it off the bar; to rearrange the icons, just drag them.
    Bottom: Click the little book icon (circled) to open the Organize Bookmarks window. Here, you can drag names up or down to rearrange the list, or drag them into a "folder" that becomes a submenu in the Bookmarks menu. (Create a submenu by clicking the + button below the list.) You can edit a bookmark by clicking once on its name or URL, or delete one by pressing Delete.

    Tip: The tiny [image] at the left end of the Google bar is a pop-up menu of your most recent searches.Bonus Tip: If you Control-click (or right-click) a highlighted word or phrase on a Web page, you can choose Google Search from the shortcut menu to search for that text. And, even cooler, this trick works in all Cocoa programs—not just Safari.

  • Print. You can add a printer icon to Safari for point-and-click paper action if you don't want to bother with [image] -P.

  • Bug. Ladies and gentlemen, this is Apple at its most humble. This insect-shaped button opens a tiny "Dear Apple" box, where you can tell Apple about a Safari feature or Web page that doesn't work. If you click Options, you can even send Apple a screen illustration of, for example, a screwy Web-page layout that Safari delivered.

20.1.2.2. Bookmarks bar

The Bookmarks menu is one way to maintain a list of Web sites you visit frequently. But opening a Web page from that menu requires two mouse clicks—an exorbitant expenditure of energy. The Bookmarks bar (View rightwards double arrow Bookmarks Bar), on the other hand, lets you summon a few very favorite Web pages with only one click.

Tip: If you have a bunch of bookmarks stored in another Web browser, use that browser's export feature to save them in a file, and then use Safari's File rightwards double arrow Import Bookmarks command to save you the time of re-entering the bookmarks by hand.

Figure 20-3 illustrates how to add buttons to, and remove them from, this toolbar.

Tip: As shown in Figure 20-3, you can drag a link from a Web page onto your Bookmarks bar. But you can also drag a link directly to the desktop, where it turns into an Internet location file. Thereafter, to launch your browser and visit the associated Web page whenever you like, just double-click this icon.Better yet, stash a few of these icons in your Dock or Sidebar for even easier access.

20.1.3. Status Bar

The Status bar at the bottom of the window tells you what Safari is doing (such as "Opening page…" or "Done"). When you point to a link without clicking, the Status bar also tells you which URL opens if you click it. For those two reasons, it's a very useful strip, but it doesn't appear when you first run Safari. You have to summon it by choosing View rightwards double arrow Show Status Bar.

20.1.4. Tips for Better Surfing

Safari is filled with shortcuts and tricks for better speed and more pleasant surfing. For example:

20.1.4.1. SnapBack

The little orange SnapBack button ( [image] ), which sometimes appears at the right end of the address bar or Google search bar, takes you instantly back to the Web page whose address you last typed (or whose bookmark you last clicked), or to your first Google results page.

The point here is that, after burrowing from one link to another in pursuit of some Google result or Amazon listing, you can return to your starting point without having to mash the Back button over and over again. (The SnapBack button doesn't appear until you've actually clicked away from the first page you visited.)

Tip: At any time, you can designate your current page as the new SnapBack page. To do so, choose History rightwards double arrow Mark Page for SnapBack (Option- [image] -K).And you can snap back from the keyboard, too: Option- [image] -P.
20.1.4.2. Stifle pop-ups and pop-unders

The world's smarmiest advertisers inundate us with pop-up and pop-under ads—nasty little windows that appear in front of the browser window or, worse, behind it, waiting to jump out the moment you close your current window. They're often deceptive, masquerading as error messages or dialog boxes, and they'll do absolutely anything to get you to click inside them.

If this kind of thing is driving you crazy, choose Safari rightwards double arrow Block Pop-Up Windows, so that a checkmark appears next to the command. It's a war out there—but at least you now have some ammunition.

Note: This feature doesn't squelch small windows that pop up when you click a link—only windows that appear unbidden.Even unbidden windows, however, are sometimes legitimate (and not ads)—notices of new banking features, warnings that the instructions to use a site have changed, and so on. Safari can't tell these from ads and stifles them too. So if a site you trust says "Please turn off pop-up blockers and reload this page," you know you're probably missing out on a useful pop-up message.And one more thing: These days, the evildoers of the Internet have begun to create pop-up windows using nonstandard programming code that Safari and other browsers can't do anything about. Fortunately, they're still fairly rare.
20.1.4.3. Impersonating Internet Explorer

Sooner or later, you'll run into a Web site that doesn't work in Safari. Why? When you arrive at a Web site, your browser identifies itself. That's because many commercial Web sites display a different version of the page depending on the browser you're using, thanks to differences in the way various browsers interpret Web layouts.

But because you're one of the minority oddballs using Safari, your otherwise beloved Web site tells you: "Sorry, browser not supported." (Will this problem change now that Apple has released a Windows version of Safari? We can only hope.)

In such times of trouble, you can make Safari impersonate any other browser, which is often good enough to fool the picky Web site into letting you in.

The key to this trick is Safari's Debug menu, which is generally hidden. You can make it appear in either of two ways:

  • Download TinkerTool, a free program available on the "Missing CD" page at www.missingmanuals.com. It offers a simple checkbox that turns on the debug menu.

  • Use the Terminal command defaults write com.apple.Safari Include DebugMenu 1.(Details on using Terminal in Chapter 16.)

    When you next open Safari, the new Debug menu appears right next to Help. Most of its commands are designed to appeal to programmers, but the submenu you want—User Agent—is useful to everyone. It lets Safari masquerade as a different browser. Choose User Agent rightwards double arrow Mac MSIE 5.22, for example, to assume the identity of Internet Explorer for Macintosh.

Tip: If you're into Web-page coding or design, Safari's Debug menu houses a Leopard first: the Web Inspector. Control-click (or right-click) any part of a Web page—image, text, link—and choose Inspect Element from the shortcut menu.The Web Inspector highlights the element you clicked and opens a window so you can see every little bit of HTML coding that went into putting that item on the page. You also see the style sheets, images, and other files displayed in the Inspector's window—making it really easy to see (and learn) how the page was made.
20.1.4.4. Where am I?

As you dig your way down into a Web site, you may wish you could have left a trail of bread crumbs to mark your path. Ah, but Safari has already thought of that. See Figure 20-4.

Figure 20-4. If you -click the title bar (centered just above the address bar), Safari displays the "ladder" of pages you descended to arrive at the current one.

20.1.4.5. Faster browsing without graphics

Graphics are part of what makes the Web so compelling. But they're also responsible for making Web pages take so long to arrive on the screen. Without them, Web pages appear almost instantaneously—and you still get fully laid-out Web pages with all their text and headlines.

To turn off graphics, choose Safari rightwards double arrow Preferences, and then click the Appearance tab. Turn off "Display images when the page opens," and close the Preferences window. Now try visiting a few Web pages and enjoy the substantial speed boost. (If you wind up on a Web page that's nothing without its pictures, return to Safari rightwards double arrow Preferences, turn the same checkbox on, and then reload the page.)

20.1.4.6. Viewing Web pages offline

You don't have to be connected to the Net to read a favorite Web page. You can save a certain Web page on your hard drive so that you can peruse it later—on your laptop during your commute, for example—just by choosing File rightwards double arrow Save As.

To save the entire page, along with all its images, movies, and so on, choose Web Archive from the Format pop-up menu.

Tip: Whenever you buy something online, don't waste paper by printing out the final "This is your receipt" page. Instead, choose File rightwards double arrow Print and, from the PDF pop-up button, choose Save PDF to Web Receipts folder. Safari saves it as a PDF file into a tidy folder (in your Home rightwards double arrow Documents folder) called Web Receipts. Nice touch!
20.1.4.7. Sending a page to a friend

Safari provides two different ways of telling a friend about the page you're looking at. You might find that useful when you come across a particularly interesting news story, op-ed piece, or burrito recipe.

  • The send-the-whole-page method. While looking at a page, choose File rightwards double arrow Mail Contents of This Page ( [image] -I) to open a new Mail message with a copy of the actual Web page in the body. Address the message and click Send.

    Caution:HTML messages (like the ones you send with this technique) are bandwidth-clogging monstrosities, so the message can take a while to download on the other end—especially over a dial-up connection.

  • The send-a-link method. To send just a link to the page you're looking at, choose File rightwards double arrow Mail Link to This Page (Shift- [image] -I). Then proceed as usual, addressing the message and clicking Send.

    Links take only a split second for your recipient to download, and they're guaranteed to display properly in all email programs. All your recipients have to do is click the link to open it in their Web browsers.

20.1.4.8. Expanding Web forms

If the customer-service comment form on that corporate Web site doesn't give you enough room to rant properly, you can resize the text box right on the page—a new, very welcome feature in Leopard. Figure 20-5 tells all.

Figure 20-5. This trick works on a Web page's text fields—comment boxes, forms to send a letter to the mayor, and so on. You can resize such boxes by dragging the three diagonal ribbed lines in the lower-right corner of the text field. The rest of the page adjusts itself to the new text-box size, and you have room to say what you need to say.

20.1.4.9. Designate your home page

The first Web site you encounter when Safari connects to the Internet is an Apple Web site. This site is your home page. You'll probably find Web browsing more fun, though, if you specify your favorite Web page as your home page.

To do that, navigate your way to the page you prefer. Google, or its news page, http://news.google.com, is a good starting place. So is your favorite newspaper home page, or www.macsurfer.com, a summary of the day's Mac news coverage around the world, or maybe www.dilbert.com for today's Dilbert cartoon.

Then choose Safari rightwards double arrow Preferences, click the General tab, and click Set to Current Page (or type the address into the box).

If you can't decide on a home page, or your mood changes from day to day, use the "New windows open with" pop-up menu to choose Empty Page. Some people prefer this setup, which makes Safari load very quickly when you first open it. Once this empty window opens, then you can tell the browser where you want to go today.

Tip: In the Safari rightwards double arrow Preferences rightwards double arrow General tab, you can also choose Bookmarks. Then, whenever you open a new window or launch Safari, you can choose exactly which page you want to open by choosing from a list of your bookmarks.
20.1.4.10. The History Menu

The History menu lists the Web sites you've visited in the last week or so, neatly organized into subfolders like "Earlier Today" and "Yesterday." (A similar menu appears when you click and hold on the Back or Forward button.) These are great features if you can't recall the URL for a Web site that you remember having visited recently.

Tip: As illustrated on Section 1.10, the new Help search box searches all of a program's menus—including Safari's History menu. You can re-find a site without hunting through all the History submenus manually.
20.1.4.11. Finding text within Web pages

The Google Search bar can help you find Web sites that match your keywords. But some pages are so long, dense, or poorly designed that finding the words on the page needs a whole'nother search engine. Fortunately, Safari's new search-within-the-page function shines a light on the words or phrase you're seeking.

To use it, press [image] -F and then type your search word into the Find box (Figure 20-6). As Safari locates the word or words, it displays them within a bright yellow box and dims the background of the rest of the page. The Find bar also tells you how many times the word or phrase occurs on the page; you can jump to each instance. Click the [image] to start over with new search terms, or click Done to close the Find bar and return to your normal browsing activity.

Figure 20-6. Once you enter your keywords ("Eagles" in this case), the browser dims the page and highlights every instance of that word—making it much easier to find what you're looking for across a crowded Web page.

20.1.4.12. Zoom in on PDF pPages

PDF files are all over the Web as, among other things, forms to download, online brochures, and scanned book pages. But they aren't always especially readable in a browser window.

Unless, that is, you're using Safari and its new PDF viewing and saving tools. The next time you're squinting at a PDF in the window, point to the bottom edge of the document; you'll see a toolbar appear like the one in Figure 20-7. With these four icons, you can zoom out, zoom in, open the file in Preview, or save the PDF file itself to your Downloads folder.

Figure 20-7. If you're having trouble reading the tiny type in a PDF, hover your mouse at the bottom of it to invoke Safari's PDF toolbar. You can zoom out, zoom in, open the file in the Mac's Preview program, or even download it from the Web site with a well-placed click.

20.1.5. Tabbed Browsing

Beloved by hardcore surfers the world over, tabbed browsing is a way to keep a bunch of Web pages open simultaneously—in a single, neat window. Figure 20-8 illustrates.

Turning on tabbed browsing unlocks a whole raft of Safari shortcuts and tricks, which are just the sort of thing power surfers gulp down like Gatorade:

  • If there's a certain set of Web sites you like to visit daily, put the bookmarks in to one folder, using Bookmarks rightwards double arrow Add Bookmark Folder and the Bookmarks organizer window (Figure 20-3). You can then load all of them at once into a single tabbed window, simply by selecting the resulting "folder" in the Bookmarks menu—or the Bookmarks bar—and choosing Open in Tabs from the submenu.

    The beauty of this arrangement is that you can start reading the first Web page while all of the others load into their own tabs in the background.

    Tip: Click the [image] icon at the left end of the Bookmarks bar. In the Bookmarks organizer, click the Bookmarks Bar item in the left-side list. Now you can see an Auto-Click checkbox for each listed folder.If you turn on this checkmark, then you'll be able to open all the bookmarks in that folder into tabs, all at once, merely by clicking the folder's name in the Bookmarks bar. (If you want to summon the normal menu from the folder, just hold the mouse button down.)

    Figure 20-8. Top: First turn on tabbed browsing in Safari's Preferences rightwards double arrow Tabs window. (For best results, also turn on "Select new tabs as they are created.")
    Bottom: Now, when you -click a link, or type an address and press -Return or -Enter, you open a new tab, not a new window as you ordinarily would. You can now pop from one open page to another by clicking the tabs just under your Bookmarks bar, or close one by clicking its button (or pressing -W).

  • A variation on a theme: When you have a bunch of pages open in tabs, you can drag the tabs across the window to rearrange the order. When you have them the way you want them, Control-click (or right-click) a tab, and then choose "Add Bookmark for These [Number] Tabs" from the shortcut menu. You can save your saved tabs to the Bookmarks bar and load all those pages with one click.

  • If you Option-click a tab's [image] (close) button, you close all tabs except the one you clicked. The same thing happens if you hold down Option and choose File rightwards double arrow Close Other Tabs, or if you press Option- [image] -W.

  • If you Option- [image] -click a link, it opens in a separate window, rather than a new tab. (When tabbed browsing is turned off, you just [image] -click a link to open a new window.)

  • If you find yourself with a bunch of separate browser windows all over your screen, you can neatly consolidate them all into one nicely tabbed Safari window by choosing Window rightwards double arrow Merge All Windows.

    FREQUENTLY ASKED QUESTION
    Erasing Your Tracks—and Private Browsing

    So, about this History menu: I'd just as soon my wife/husband/boss/parent/kid not know what Web sites I've been visiting. Must that History menu display my movements quite so proudly?

    Some people find it creepy that Safari maintains a complete list of every Web site they've seen recently, right there in plain view of any family member or co-worker who wanders by.

    To delete just one particularly incriminating History listing, click the book icon at the left end of the Bookmarks bar; in the resulting Bookmarks organizer window, click History. Expand the relevant date triangle, highlight the offending address, and then press your Delete key. Click the book icon again to return to normal browsing. You've just rewritten History!

    Or, to erase the entire History menu, choose History rightwards double arrow Clear History.

    Of course, the History menu isn't the only place where you've left footprints. If you choose Safari rightwards double arrow Reset Safari instead, you also erase all other shreds of your activities: any cookies (Web-page preference files) you've accumulated, your list of past downloads, the cache files (tiny Web graphics files on your hard drive that a browser stores to save time when you return to the page they came from), and so on. This is good information to know; after all, you might be nominated to the Supreme Court some day.

    That's a lot of work just to cover my tracks; it also erases a lot of valuable cookies, passwords, and History entries I'd like to keep. Is all that really necessary just so I can duck in for an occasional look at the Hot Bods of the Midwestern Tax Preparers' Association Web site?

    No, it's not. A feature called private browsing lets you surf without adding any pages to your History list, searches to your Google search box, passwords to Safari's saved password list, or autofill entries to Safari's memory. (Apple says that this feature is intended for use at public Macs, where you don't want to reveal anything personal to subsequent visitors. Ha!)

    The trick is to choose Safari rightwards double arrow Private Browsing before you start browsing. Once you OK the explanation box, Safari records nothing while you surf. (Nothing, that is, except cookies. Your tracks, in other words, are not completely hidden. You can erase cookies, if need be, in Safari rightwards double arrow Preferences rightwards double arrow Security.)

    When you're ready to browse "publicly" again, choose Safari rightwards double arrow Private Browsing once more so the checkmark goes away. Safari once again begins taking note of the pages you visit—but it never remembers the earlier ones.

    In other words, what happens in Private Browsing stays in Private Browsing.

  • If you Shift- [image] -click a link, Safari opens that page in a tab behind the one you're reading. That's a fantastic trick when you're reading a Web page and see a reference you want to set aside for reading next, but you don't want to interrupt whatever you're reading.

Tip: Deep in the guts of Safari is a neatly formatted page that lists nearly every keyboard shortcut in Safari. To see it (so you can print it, perhaps), Control-click the Safari icon in the Finder. Choose Show Package Contents from the shortcut menu. In the new window, open Contents rightwards double arrow Resources. Finally, drag the icon called Shortcuts.html right into the Safari window.(If you've installed the Debug menu as described on Section 20.1.4.4, there's an even easier way: Choose Debug rightwards double arrow Keyboard and Mouse Shortcuts.)

FREQUENTLY ASKED QUESTION
Cookie Control

Help! I'm afraid of cookies! The cookies are trying to watch me!

Cookies are something like Web page preference files. Certain Web sites—particularly commercial ones like Amazon.com—deposit them on your hard drive like little bookmarks, so that they'll remember you the next time you visit. Most cookies are perfectly innocuous—and, in fact, are extremely helpful, because they help Web sites remember your tastes. Cookies also spare you the effort of having to type in your name, address, credit card number, and so on, every time you visit these Web sites.

But fear is widespread, and the media fans the flames with tales of sinister cookies that track your movement on the Web. If you're worried about invasions of privacy, Safari is ready to protect you.

Once the browser is open, choose Safari rightwards double arrow Preferences rightwards double arrow Security tab. The buttons in this dialog box are like a paranoia gauge. If you click Never, you create an acrylic shield around your Mac. No cookies can come in, and no cookie information can go out. You'll probably find the Web a very inconvenient place; you'll have to re-enter your information upon every visit, and some Web sites may not work properly at all.

A good compromise is "Only from sites you navigate to," which accepts cookies from sites you want to visit, but blocks cookies deposited on your hard drive by sites you're not actually visiting—cookies an especially evil banner ad gives you, for example.

Note, too, the Show Cookies button, which reveals the shockingly complete list of every cookie you've accumulated so far—and offers you the chance to delete the ones that don't look so savory.


rss_the_missing_manual.html

20.2. RSS: The Missing Manual

In the beginning, the Internet was an informational Garden of Eden. There were no bannerads, pop-ups, flashy animations, or spam messages. Back then, people thought the Internet was the greatest idea ever.

Those days, unfortunately, are long gone. Web browsing now entails a constant battle against intrusive advertising and annoying animations. And with the proliferation of Web sites of every kind—from news sites to personal weblogs (blogs)—just reading your favorite sites can become a full-time job.

Enter RSS, a technology that lets you subscribe to feeds—summary blurbs provided by thousands of sources around the world, from Reuters to Apple to your nerdy nextdoor neighbor. You use a program like Safari to "subscribe" to updates from such feeds, and then read any new articles or postings at your leisure.

The result: You spare yourself the tedium of checking for updates manually, plus you get to read short summaries of new articles without ads and blinking animations. And if you want to read a full article, you can click its link in the RSS feed to jump straight to the main Web site.

Figure 20-9. The Length slider controls how much text appears for each RSS blurb; if you drag it all the way to the left, you're left with nothing but headlines. To change the number and order of the articles being displayed, use the search options on the right. And if you feel a sudden desire to tell your friends about an amazing RSS feed you've just discovered, use the "Mail Link to This Page" link in the lower-right section of the window.

Note: RSS either stands for Rich Site Summary or Really Simple Syndication. Each abbreviation explains one aspect of RSS—either its summarizing talent or its simplicity.

20.2.1. Viewing an RSS Feed

So how do you sign up for these free, automatic RSS "broadcasts? "Watch your address bar as you're surfing the Web. When you see a blue RSS button appear (identified back in Figure 20-1), Safari is telling you, "This site has an RSS feed available."

To see what the fuss is all about, click that button. Safari switches into RSS-viewing mode, as shown in Figure 20-9.

At this point, you have two choices:

  • Add the RSSfeed as a bookmark. Use the Bookmarks rightwards double arrow Add Bookmark command, and add the feed to your Bookmarks menu, Bookmarks bar, or Mail (Section 19.7) as you would any Web page. From now on, you'll be able to see whether the RSS feed has had any new articles posted—without actually having to visit the site. Figure 20-10 (top) has the details.

  • Close the RSS feed altogether. To do so, just click the RSS button again. You're left back where you started, at whatever Web page you were visiting.

20.2.2. RSS Tricks

RSS is a tremendously flexible and powerful technology, especially in Safari. The fun never ends, as these tricks illustrate.

20.2.2.1. Creating RSS summaries

If you create a new bookmark folder (Section 20.1.2.1) and fill it with RSS feeds, you can see the total number of new articles right next to the folder's name (Figure 20-10, bottom). You might create a folder of Mac news feeds, for instance, so you know whenever there's a important event in the Mac world.

From then on, by clicking the folder's name (and opening its pop-up menu), you can see which feeds have new articles; they're the ones with numbers next to their names. If you [image] -click a bookmark folder's name—in either the Bookmarks bar or the Bookmarks menu—Safari shows you all the feeds, neatly collated into one big, easily digestible list for your perusing pleasure. (If you're billing by the hour, you can also choose View All RSS Articles from the folder's pop-up menu to achieve the same effect.)

Tip: To make the merged list more useful, click New under the Sort By heading. Now Safari displays any new articles at the top of the list, regardless of what site they came from, so you don't have to hunt through the list for new articles yourself.
20.2.2.2. The personal clipping service

The search box at the right of any RSS-viewing window works pretty much as you'd expect: It narrows down the list of articles to only those that contain your search terms.

But that's barely scratching the surface of the search field's power. If you've adopted the feed-merging trick described above, the Search box can search several feeds at once—perfect, for example, if you want to see all the news from Mac sites that has to do with iTunes.

Now how much would you pay? But get this—you can then save the search itself as a bookmark. Use the Bookmark This Search link at the lower-right corner of the window. Give the bookmark a name, choose where it should appear in Safari, and then click Add.

You've just turned Safari into a high-tech personal clipping service. With one click on your new bookmark, you can search all your favorite news sources simultaneously— the feeds you've selected—for the terms you want. You've just saved yourself hours of daily searching—not to mention the expense of a real clipping service.

Figure 20-10. Top: Want to specify when Safari should check for updates to your RSS bookmarks? In Safari rightwards double arrow Preferences, click RSS. Turn on Bookmarks Bar and Bookmarks Menu. (If you're an especially impatient person, select "Every 30 minutes" from the "Check for updates" pop-up menu.)
Bottom: Next to your RSS feeds' names (in this screenshot, VersionTracker and Wired), a number tells you how many new articles are waiting for you. If you have a bookmark folder containing several RSS feeds in it (here, Potato News), the number reflects the total number of new articles in that folder's feeds. Never again will you have to check a Web site for updates the old-fashioned way.

Tip: If you find RSS feeds completely addictive in Safari, you'll love them in Mail—where you can display them right in the program's window or have them land in your Inbox like regular messages. Flip back to Section 19.7 if you skipped that chapter.
20.2.2.3. The RSS screen saver

In System Preferences rightwards double arrow Desktop & Screen Saver rightwards double arrow Screen Saver tab, you'll find the RSS Visualizer screen saver, one of the most impressive displays of Mac OS X technology you'll ever see. When you click Options and select an RSS feed (and enable screen savers), you set up Mac OS X to get news from that feed whenever you're away from your Mac. When the screen saver comes on, you're treated to a three-dimensional animation of the news from that site—along with astonished gazes from your co-workers.

If a news story grabs your interest, press the number key mentioned at the bottom of the screen. The screen saver fades out, and Safari comes forward to display the associated article.

Tip: But what if the feed you want isn't part of Safari's repertoire? No problem. Add the feed to your Safari bookmarks and relaunch System Preferences.
20.2.2.4. Make feeds open automatically

It's easy enough to set up any favorite Web site as your home page, the page that opens automatically whenever you start Safari or create a new window. It turns out, though, that you can also make an RSS feed—or a list of feeds—your home page. Open the feeds you want, choose Safari rightwards double arrow Preferences, click General, and click Set to Current Page.

In other words, suppose you start by opening a list of local, national, international, business, and sports news feeds. In that case, you've just made yourself a fantastic imitation of newspaper headlines, but tailored to your interests with spectacular precision: The Francis J. McQuaid Times (or whatever your name is).

Tip: If you've turned on tabbed browsing, you can Shift- [image] -click headlines. That makes the full articles open in background tabs while you continue to read the headlines.

Articles in this Safari-newspaper arrangement are timelier than anything you could read in print—and they're completely free. If you miss a day of reading the headlines, no problem; the headlines stick around for days, and disappear only once you've read them. And finally, when you're done reading, you don't have to worry about recycling your "newspaper." No trees were harmed in the making of this publication.

Welcome to the future of news: customized, free, up-to-date, and paperless.

Tip: To find more RSS feeds, visit a site like www.feedster.com or www.syndic8.com, or just watch for the appearance of the blue RSS button in the address bar.By the way, Safari isn't the only RSS reader. If you catch the RSS bug, you might want to try out a program like NetNewsWire (http://ranchero.com/netnewswire/), which offers many more power-user features.


ichat-id002.html

Chapter 21. iChat

Somewhere between email and the telephone lies a unique communication tool calledinstant messaging. Plenty of instant messenger programs run on the Mac, but guess what? You don't really need any of them. Mac OS X comes with its very own instant messenger program called iChat, built right into the system and ready to connect to your friends on the AIM, Jabber, or Google Talk networks.

To start up iChat, go to Applications rightwards double arrow iChat, or just click iChat's Dock icon. It looks like a blue speech balloon with a camcorder inside, which is a clue to one of iChat's best and most substantially beefed-up Leopard features: live video chats over the Internet. This chapter covers how to use iChat to communicate by video, audio, and text with your online pals.

21.1. Welcome to iChat

iChat does five things very well:

  • Instant messaging. If you don't know what instant messaging is, there's a teenager near you who does.

    It's like live email. You type messages in a chat window, in real time, and your friends type replies back to you. Instant messaging combines the privacy of email and the immediacy of the phone.

    In this regard, iChat is a lot like AOL's popular Instant Messenger (AIM) and Buddy Chats. In fact, iChat lets you type back and forth with any of AIM's 150 million members, which is a huge advantage. (It speaks the same "chat" language as AIM.) But iChat's visual design is pure Apple.

  • Free long distance. If your Mac has a microphone, and so does your buddy, the two of you can also chatout loud, using the Internet as a free long-distance phone. Wait, not just the two of you—the10 of you, thanks to iChat's party-line feature.

  • Free videoconferencing. iChat's old name was iChat AV, where AV stood for audio-video. In Leopard, the program is just called iChat, but its multimedia heritage remains. If you and your buddies each have broadband Internet connections and a camera—like the one built into many Mac models or even a digital camcorder—up to four participants can join in video chats, all onscreen at once, no matter where they happen to be in the world. This arrangement is a jaw-dropping visual stunt that can bring distant collaborators face-to-face without plane tickets—and it costs about $99,900 less than professional videoconferencing gear.

  • File transfers. Got an album of high-quality photos or a giant presentation file that's too big to send by email? Forget about using some online file-transfer service or networked server; you can drag that Filezilla directly to your buddy's Mac, through iChat, for a direct machine-to-machine transfer. (It lands in your Downloads folder.)

  • Presentations. You can open up most kinds of documents, at nearly full size, to show your video buddy, right there in the iChat window, without actually having to transfer it. That's a new feature called iChat Theater.


welcome_to_ichat.html

Chapter 21. iChat

Somewhere between email and the telephone lies a unique communication tool calledinstant messaging. Plenty of instant messenger programs run on the Mac, but guess what? You don't really need any of them. Mac OS X comes with its very own instant messenger program called iChat, built right into the system and ready to connect to your friends on the AIM, Jabber, or Google Talk networks.

To start up iChat, go to Applications rightwards double arrow iChat, or just click iChat's Dock icon. It looks like a blue speech balloon with a camcorder inside, which is a clue to one of iChat's best and most substantially beefed-up Leopard features: live video chats over the Internet. This chapter covers how to use iChat to communicate by video, audio, and text with your online pals.

21.1. Welcome to iChat

iChat does five things very well:

  • Instant messaging. If you don't know what instant messaging is, there's a teenager near you who does.

    It's like live email. You type messages in a chat window, in real time, and your friends type replies back to you. Instant messaging combines the privacy of email and the immediacy of the phone.

    In this regard, iChat is a lot like AOL's popular Instant Messenger (AIM) and Buddy Chats. In fact, iChat lets you type back and forth with any of AIM's 150 million members, which is a huge advantage. (It speaks the same "chat" language as AIM.) But iChat's visual design is pure Apple.

  • Free long distance. If your Mac has a microphone, and so does your buddy, the two of you can also chatout loud, using the Internet as a free long-distance phone. Wait, not just the two of you—the10 of you, thanks to iChat's party-line feature.

  • Free videoconferencing. iChat's old name was iChat AV, where AV stood for audio-video. In Leopard, the program is just called iChat, but its multimedia heritage remains. If you and your buddies each have broadband Internet connections and a camera—like the one built into many Mac models or even a digital camcorder—up to four participants can join in video chats, all onscreen at once, no matter where they happen to be in the world. This arrangement is a jaw-dropping visual stunt that can bring distant collaborators face-to-face without plane tickets—and it costs about $99,900 less than professional videoconferencing gear.

  • File transfers. Got an album of high-quality photos or a giant presentation file that's too big to send by email? Forget about using some online file-transfer service or networked server; you can drag that Filezilla directly to your buddy's Mac, through iChat, for a direct machine-to-machine transfer. (It lands in your Downloads folder.)

  • Presentations. You can open up most kinds of documents, at nearly full size, to show your video buddy, right there in the iChat window, without actually having to transfer it. That's a new feature called iChat Theater.


three_chat_networks.html

21.2. Three Chat Networks

iChat lets you reach out to chat partners on three different networks:

  • The AIM network. If you've signed up for a .Mac address (the paid kind or the free kind described below) or a free AOL Instant Messenger (AIM) account, you can chat with anyone in the 150-million-member AOL Instant Messenger network.

  • The Jabber network. Jabber is another chat network, whose key virtue is itsopen-source origins. In other words, it wasn't masterminded by some corporate media behemoth; it's an all-volunteer effort, joined by thousands of programmers all over the world. There's no one Jabber chat program (like AOL Instant Messenger). There are dozens, available for Mac OS X, Windows, Linux, Unix, Palm and PocketPC organizers, and so on. All of them can chat with each other across the Internet in one glorious frenzy of typing.

    And now there's one more program that can join the party: iChat.

  • Google Talk. Evidently, Google felt that there just weren't enough different chat programs, because it released its own chat program in 2005.

    Behind the scenes, it uses the Jabber network, so Google Talk doesn't really count as a different network. (Hence the headline.) But it does mean that you can use iChat to converse with all those Google Talkers, too.

  • Your own local network. Thanks to the Bonjour network-recognition technology (which Apple called Rendezvous before the Attack of the Trademark Lawyers), you can communicate with other Macs on your own office network without signing up for anything at all—and without being online. This is a terrific feature when you're sitting around a conference table, idly chatting with colleagues using your wireless laptop (and the boss thinks you're taking notes).

Each network generally has its own separate Buddy List window and its own chat window, but you can consolidate all of your various chats into a single window (Section 21.7).

You log into each network separately using the iChat rightwards double arrow Accounts submenu, butyou can be logged into all of them at once. This is a great option if your friends are spread out among different chat networks.

Note: If you're on AOL's AOL Instant Messenger (AIM) service, why would you want to use iChat instead of AOL's own AIM program? Easy: Because iChat is a nice, cleanly designed program that's free of advertisements, chatbots, and clunky interface elements.

Otherwise, however, chatting and videoconferencing works identically on all three networks. Keep that in mind as you read the following pages.


signing_up.html

21.3. Signing Up

When you open iChat for the first time, you see the "Welcome To iChat" window (Figure 21-1). This is the first of several screens in the iChat setup sequence, during which you're supposed to tell it which kinds of chat accounts you have, and set up your camera, if any.

An account is a name and password. Fortunately, these accounts are free, and there are several ways to acquire one.

Tip: The easiest procedure is to set up your accounts before you open iChat for the first time, because then you can just plug in your names and passwords in the setup screens.You can input your account information later, though. Choose iChat rightwards double arrow Preferences, click the Accounts button, click the + button, and choose the right account type (Jabber, .Mac, Google Talk, or AIM) from the Account Type pop-up menu.

21.3.1. How to get a free .Mac account

If you're already a member of Apple's .Mac service (Chapter 18), iChat fills in your Mac.com user name and password automatically.

If not, you can get an iChat-only .Mac account for free. To get started, do one of these two things:

  • Click the "Get an iChat Account" button that appears on the second Setup Assistant screen.

  • Choose iChat rightwards double arrow Preferences, click the Accounts button, click the + button, and click Create New.Mac Account.

Either way, you go to an Apple Web page, where you can sign up for a free iChat account name. You'll also get 60 days of the more complete .Mac treatment (usually $100 a year) described in Chapter 18. When your trial period ends, you'll lose all of the other stuff that .Mac provides, but you'll get to keep your iChat name.

Note: If your .Mac name ismissingmanualguy, you'll appear to everyone else as missingmanualguy@mac.com. The software tacks on the "@mac.com" suffix automatically.

Figure 21-1. The iChat setup assistant gives you the chance to input your account names and passwords, if you already have them. Only one of these screens ("Set up iChat Instant messaging") offers you the chance to create a chat account, in this case a free .Mac account. Otherwise, you're expected to have a name and password (for AIM, Google Talk or Jabber, for example) already.

21.3.2. How to get a free Jabber (or Gmail) account

You can't create a Jabber account using iChat. Apple expects that, if you're that interested in Jabber, you already have an account that's been set up by the company you work for (Jabber is popular in corporations) or by you, using one of the free Jabber programs.

For example, at www.adiumx.com, you can download a great chat program for Mac OS X that presents you, the first time you open it, with a Preferences:Accounts screen. Click the + button, choose Jabber, type in any screen name and password you like— and when you're told that your account doesn't exist, mutter, "I know, I know," and click Register. Your account is now created (your account name is Francis@jabber.org, for example), and you can plug that screen name and password into iChat.

Alternatively, you can just sign up for a free Google Talk account, which is the same as having a free Gmail account. (Go to Gmail.com to sign up for one.)

Once you've got a Gmail address, choose iChat rightwards double arrow Preferences rightwards double arrow Accounts, and click the + button. Under Account Type, choose Google Talk and type in your complete Gmail address(like gwashington@gmail.com) and password. Your Gmail name pops up on iChat's Jabber list—along with any of your Gmail contacts who are already online and yapping.

21.3.3. How to get a free AIM account

You can't create an AIM account in iChat, either. If you're an America Online member, your existing screen name and password work; if you've used AIM before, you can use your existing name and password.

If you've never had an AIM account, you can sign up at https://my.screenname.aol.com. Click "Create one FREE now" to make up an AIM screen name.


the_buddy_lists.html

21.4. The Buddy Lists

Once you've entered your account information, you're technically ready to start chatting. All you need now is a chatting companion, or what's called a buddy in instant-messaging circles. iChat comes complete with a Buddy List window in which you can house the chat "addresses" for all your friends, relatives, and colleagues out there on the Internet.

Actually, to be precise, iChat comes with three buddy lists (Figure 21-2):

  • AIM Buddy List. This window lists all of your chat pals who haveeither .Mac or AIM accounts; they all share the same buddy list. You see the same list whether you log into your .Mac or your AIM account.

  • Jabber List. Same idea, except that all of your contacts in this window must have Jabber or Google Talk accounts.

  • Bonjour. This list is limited to your local network buddies—the ones in the same building, most likely, and on the same network. You can't add names to your Bonjour list; anyone who's on the network and running iChat appears automatically in the Bonjour list.


making_a_list.html

21.5. Making a List

When you start iChat, your buddy lists automatically appear (Figure 21-2). If you don't see them, choose the list you want from the Window menu: Bonjour, Buddy List, or Jabber. (Or press their keyboard shortcuts: -1, [image] -2, or [image] -3.)

Adding a buddy to this list entails knowing that person's account name, whether it's on AIM, Mac.com, or Jabber. Once you have it, you can either choose Buddies rightwards double arrow Add Buddy (Shift- [image] -A) or click the + button at the bottom-left corner of the window.

Down slides a sheet attached to the Buddy List window, offering a window into the Address Book program (Chapter 19).

Tip: As you accumulate buddies, your Buddy List may become crowded. If you choose View rightwards double arrow Show Offline Buddies (so that the checkmark disappears), only your currently online buddies show up in the Buddy List—a much more meaningful list for the temporarily lonely.

Figure 21-2. Left: Click the + button to add a new buddy, either by choosing from your address book or from scratch (by clicking New Person). If you've used AIM before, you may find that you've already got buddies in your list. AIM accounts store their buddy lists on AOL's computers, so that you can keep your buddies even if you switch computers.
Right: Is your Buddy List taking up too much screen space? Use the options in the View menu to lose the buddy pictures and other chunky icons to streamline the window.

If your chat companion is already in Address Book, scroll through the list until you find the name you want (or enter the first few letters into the Search box), click the name, and then click Select Buddy.

If not, click New Person and enter the buddy's AIM address, .Mac address, or (if you're in the Jabber list) Jabber address. You're adding this person to both your Buddy List and your Address Book.

21.5.1. Broadcasting Your Status

Using the pop-up menu just below your name (Figure 21-3, right), you can display your current mental status to other people's buddy lists. You can announce that you're Available, Away, or Drunk. (You have to choose Edit Status Menu for that one; see Figure 21-3, left.)

Better yet, if you have music playing in iTunes, you can tell the world what you're listening to at the moment by choosing Current iTunes Track. (Your buddy can even click that song's name to open its screen on the iTunes Store, all for Instant Purchase Gratification.)

For some people, by far the juiciest option is a new one in Mac OS X 10.5: a status called Invisible (available for .Mac and AIM accounts only). It's like a Star Trek cloaking device for your onscreen presence (Figure 21-3). Great for stalkers!

Figure 21-3. Left: Choose Edit Status Menu from the pop-up menu at the top of the iChat buddy list to set up more creative alternatives to "Available" and "Away."
Right: Your edited list of status messages is now available. The most interesting one is Invisible. It lets you see your friends online, but they can't see you—great when you're too busy to chat with annoying barely-acquaintances, but want to keep an eye out for a particular pal. You can still send and receive messages anyone on your Buddy List.

21.5.2. Sorting and sizing your friends

In View rightwards double arrow Sort Buddies, you can rearrange your buddies as they're listed in the Buddy lists:

  • By Availability. Your available pals move to the top of the list, sorted alphabetically by last name. Unavailable buddies (marked by red dots and visible Away messages) get shoved to the bottom.

  • By First Name, By Last Name. Just what you'd think.

  • Manually. This option lets you drag your friends up and down your Buddy List in order of your purely personal preferences, regardless of the alphabet.

Tip: In View rightwards double arrow Buddy Names, you can chose to see your friends listed by Full Names, Short Names (usually the first name), or by Handle (IM screen name). If your Buddy List is showing screen names ("jdeaux444") mixed in with proper names ("Johann Deux"), it's because you haven't recorded the real-nameless people's real names. Click a buddy's name, choose Buddies rightwards double arrow Show Info, then click Address Card and fill in the person's first and last names.

Once you get a lot of people piled on your list, all with their buddy pictures and audio/video chat icons, you may feel like iChat is taking up way too much screen real estate. If you want a more space-efficient view of your buddy list (like the one shown on the right in Figure 21-2), go to the View menu and turn off Show Buddy Pictures, Show Audio Status, or Show Video Status. You can turn off Buddy Groups here as well, if you'd prefer to see your buddies in one undivided list.


let_the_chat_begin.html

21.6. Let the Chat Begin

As with any conversation, somebody has to talk first. In chat circles, that's called inviting someone to a chat.

21.6.1. They Invite You

To "turn on your pager" so you'll be notified when someone wants to chat with you, run iChat. Hide its windows, if you like, by pressing [image] -H.

GEM IN THE ROUGH
Making iChat Auto-Answer

When you invite another Mac to a video chat, someone has to be sitting in front of it to accept your invitation. That's an important privacy feature, of course, because it prevents total strangers from peeking in on you when you're walking around in your underwear.

But having to have a live human at the other end is kind of a bummer if you just want to peek in on your house, your kids, or your spouse while you're away, using your iSight camera or camcorder as a sort of security cam or nannycam. In the pre-Leopard days, you could set up iChat to auto-answer your video-chat invitations only by using add-on software or geekster Terminal commands.

In Leopard, though, that option is available right out of the box.

Choose iChat rightwards double arrow Preferences rightwards double arrow Alerts and then turn on Run AppleScript. From the adjoining pop-up menu, choose Auto Accept. From now on, iChat will love all your buddies and accept their invites immediately.

When someone tries to "page" you for a chat, iChat comes forward automatically and shows you an invitation message like the one in Figure 21-4. If the person initiating a chat isn't already in your Buddy List, you'll simply see a note that says "Message from [name of the person]."

Tip: If you're getting hassled by someone on your AIM/.Mac buddy list, click his screen name and choose Buddies rightwards double arrow Block Person. If the person isn't online at the time, go to iChat rightwards double arrow Preferences rightwards double arrow Accounts rightwards double arrow Security and click the button for Block specific people. Click the Edit List button, and then type in the screen name of the person you want out of your IM life.

Figure 21-4. You're being invited to a chat! Your buddy wants to have a typed chat (top left) or a spoken one (top right). To begin chatting, click the invitation window, type a response in the bottom text box if you like (for text chats), and click Accept (or press Enter). Or click Decline to lock out the person sending you messages—a good trick if someone's harassing you.

GEM IN THE ROUGH
iTunes by Remote Control

Thanks to some sneaky AppleScripting (Chapter 7), you can now use iChat as a glorified music-system remote control for another Mac. Specifically, you can sit at Mac #1, controlling the iTunes playback of Mac #2 elsewhere in the house. That's handy when Mac #2 is connected to your sound system, and you really don't feel like getting up off the couch.

To set it all up, start on Mac #1, the one you'll be using in person. In iChat, choose iChat rightwards double arrow Preferences rightwards double arrow Accounts. Click Bonjour, and turn on Use Bonjour Instant Messaging. Close the window.

On Mac #2, the one with iTunes, open iChat. Choose iChat rightwards double arrow Preferences rightwards double arrow Alerts. From the Event pop-up menu, choose Message Received. Turn on Run AppleScript on this Mac, too, and then select iTunes Remote Control from the pop-up menu.

Now, while seated at Mac #1, you can control Mac #2's music playback by typing one-word commands into iChat. You can type any of these commands: play, pause, status, next, previous, mute, unmute, or help. After you type your command (like mute when the phone rings and you're blasting Green Day), hit the Return key to make iTunes on the other Mac obey your orders.

You'll get responses in the iChat window, too. For example, if you send "next," iChat types back, "Playing next track. Now playing 'In This Diary' by The Ataris.")

21.6.2. You Invite Them

To invite somebody in your Buddy List to a chat:

  • For a text chat, double-click the person's name, type a quick invite ("You there?"), and press Enter.

    Tip: You can invite more than one person to the chat. Each time you click the + button at the bottom of the Participants list, you can choose another person to invite. (Or [image] -click each name in the buddy list to select several people at once and then click the A button at the bottom of the list to start the text chat.)Everyone sees all the messages everyone sends.

  • To start an audio or video chat, click the microphone or movie-camera icon in your Buddy List (shown in Figure 21-2).

To initiate a chat with someone who isn't in the Buddy List, choose File rightwards double arrow New Chat With Person. Type the account name of the person, and then click OK to send the invitation.

Either way, you can have more than one chat going at once. In the Olden Days (before October 2007), real iChat nerds often wound up with screens overflowing with individual chat windows. Juggling them all, and keeping them all current, was just part of the fun—and still can be.

But in modern times, you can now contain all your conversations in a single window. If you like the idea of a consolidated chatspace, chose iChat rightwards double arrow Preferences rightwards double arrow Messages and slap a checkmark in the "Collect chats into a single window" Box. Figure 21-5 has the details.

Figure 21-5. Now, when you're conversing with several buddies, you can bounce between conversations by clicking the buddy names on the side of the window. It's not as adventurous as keeping all your chats going in separate windows, but it's a lot easier to hide when the boss comes your way.


text_chatting.html

21.7. Text Chatting

A typed chat works like this: Each time you or your chat partner types something and then presses Enter, the text appears on both your screens (Figure 21-6). iChat displays each typed comment next to an icon, which can be any of these three things:

  • A picture they added. If the buddy added her own picture—to her own copy of iChat, a Jabber program, or AOL Instant Messenger—it will be transmitted to you, appearing automatically in the chat window. Cool!

  • A picture you added. If you've added a picture of that person to the Buddy List or Address Book, you see it here instead. (After all, your vision of what somebody looks like may not match his own self-image.)

  • Generic. If nobody's done icon-dragging of any sort, you get a generic icon—either a blue globe (for .Mac people), a light bulb (for Google Talkers), or the AOL Instant Messenger running man (for AIM people).

Figure 21-6. As you chat, your comments always appear on the right. If you haven't yet created a custom icon, you'll look like a blue globe or an AOL running man. You can choose a picture for yourself either in your own Address Book card or right in iChat. And Web links your pals paste into messages are perfectly clickable— your Web browser leaps right up to take you to the site your friend has shared.

To choose a graphic to use as your own icon, click the square picture to the right of your own name at the top of the Buddy, Jabber, or Bonjour list. From the pop-up palette of recently selected pictures, choose Edit Picture to open a pop-up image selection palette, where you can take a snapshot with your Mac's camera or choose a photo file from your hard drive. Feel free to build an array of different graphics to represent yourself—and to change them in mid-chat, using this pop-up palette, to the delight or confusion of your conversation partner.

Tip: When you minimize the iChat message window, its Dock icon displays the icon of the person you're chatting with—a handy reminder that she's still there.

21.7.1. In-chat fun

Typing isn't the only thing you can do during a chat. You can also perform any of these stunts:

  • Open the drawer. Choose View rightwards double arrow Show Chat Participants to hide or show the "drawer" that lists every person in your current group chat. To invite somebody new to the chat, click the + button at the bottom of the drawer, or drag the person's icon out of the Buddy list window and into this drawer.

  • Format your text. You can press [image] -B or [image] -I to make your next typed utterance bold or italic. Or change your color or font by choosing Format rightwards double arrow Show Colors or Format rightwards double arrow Show Fonts, which summons the standard Mac OS X color or font palettes. (If you use some weird font that your chat partners don't have installed, they won't see the same typeface.)

  • Insert a smiley. When you choose a face (like Undecided, Angry, or Frown) from this quick-access menu of smiley options (at the right end of the text-reply box), iChat inserts it as a graphic into your response.

    On the other hand, if you know the correct symbols to produce smileys—that :) means a smiling face, for example—you can save time by typing them instead of using the pop-up menu. iChat converts them into smiley icons on the fly, as soon as you send your reply.

    Send a file. Choosing Buddies rightwards double arrow Send File lets you send a file to all the participants in your chat.

POWER USERS' CLINIC
Getting Animated in iChat

Most people find the text that scrolls by quite dynamic enough. But if you need more activity in the iChat window, you can also add moving icons to liven up your Buddy List. Such an icon, an animated GIF file, is actually built of several individual frames that are played in succession, creating a crude sort of animation.

To find an animated GIF file worthy of representing you or your buddies, look online, where thousands are available online. Search for them with Google, or visit sites like www.gifanimations.com or www.gifs.net.

Once you've secured a good animated GIF, add it to your iChat profile (as described on the previous page), then choose iChat rightwards double arrow Preferences rightwards double arrow General, and turn on "Animate buddy pictures."

You can even make your own animated GIF icons in Photo Booth (Chapter 10). Take a four-frame picture using the 4-up photo option, taking care to make four different crazy faces as the camera snaps four times.

When the four shots show up in the Photo Booth photo tray, click the Buddy Picture button to make that shot your new iChat photo.

You can assign a Photo Booth animated GIF to another buddy, too; choose File rightwards double arrow Export from the Photo Booth menu. Save the file to your Mac and add it to your Address Book card for that pal. (Whether or not you tell your friend what image you've associated with his screen name is up to you.)

Better yet, just drag the file's icon from the Finder into the box where you normally type. (This trick works well with pictures, because your conversation partner sees the graphic right in his iChat window.)

This is a fantastic way to transfer a file that would be too big to send by email. A chat window never gets "full," and no attachment is too large to send.

This method halves the time of transfer, too, since your recipients get the file as you upload it. They don't have to wait 20 minutes for you to send the file, and then another 20 minutes to download it, as they would with email or FTP.

Note, though, that this option isn't available in old versions of the AOL Instant Messenger program—only new versions and iChat.

If you have multiple conversations taking place—and are flinging files around to a bunch of people—you can keep an eye on each file's progress with the File Transfer Manager. Choose Window rightwards double arrow File Transfers (or press Option- [image] -L) to pop open an all-in-one document delivery monitor.

Tip: If you've opened the Participants drawer, you can drag files from the Finder onto individual participants' names in this drawer to send files directly to them.

  • Get Info on someone. If you click a name in your Buddy list, and then choose Buddies rightwards double arrow Show Info (or Control-click someone's name and choose Show Info from the shortcut menu), you get a little Info window about your buddy, where you can edit her name, email address, and picture. (If you change the picture here, you'll see it instead of the graphic your buddy chose for herself.)

    If you choose Actions from the Show pop-up menu at this point, you can make iChat react when this particular buddy logs in, logs out, or changes status—for example, by playing a sound or saying, "She's here! She's here!"

  • Send an Instant Message. Not everything in a chat session has to be "heard" by all participants. If you choose Buddies rightwards double arrow Send Instant Message, you get a private chat window, where you can "whisper" something directly to a special someone behind the other chatters' backs.

    GEM IN THE ROUGH
    The Chat Transcript

    Every now and then, you'll wish you could preserve a chat for all time—a particularly meaningful conversation with a friend, lover, or customer-service agent.

    On the iChat rightwards double arrow Preferences rightwards double arrow Messages panel, you can turn on "Automatically save chat transcripts." From now on, the text of your conversations is automatically saved in your Home rightwards double arrow Documents rightwards double arrow iChats folder. To view a chat later, double-click its icon. It opens within iChat, compete with all colors and formatting.

    Even if you don't turn on this "Automatically" checkbox, you can save individual chats in progress by choosing File rightwards double arrow Save a Copy As.

  • Send a Secure Message. Fellow .Mac members can engage in encrypted chats that keep the conversation strictly between participants. If you didn't turn on encrypted chats when you set up your .Mac account in iChat, choose iChat rightwards double arrow Preferences rightwards double arrow Accounts rightwards double arrow Security, and then click Encrypt.

  • Send Email. If someone messages you, "Hey, will you email me directions? "you can do so on the spot by choosing Buddies rightwards double arrow Send Email. Your email program opens up automatically so you can send the note along; if your buddy's email address is part of his Address Book info, the message is preaddressed.

  • Send an SMS message to a cellphone. If you're using an AIM screen name or .Mac account, you can send text messages directly to your friends' cellphones (in the United States, anyway). Choose File rightwards double arrow Send SMS. In the box that pops up, type the full cellphone number, without punctuation, like this: 2125551212.

Press Enter to return to the chat window. Type a very short message (a couple of sentences, tops), and then press Enter.

Tip: If iChat rudely informs you that your own privacy settings prevent you from contacting "this person," choose iChat rightwards double arrow Preferences, click Accounts, click your chat account, and turn on "Allow anyone."

Obviously, you can't carry on much of an interactive conversation this way. The only response you get is from AOL's computers, letting you know that your message has been sent. But what a great way to shoot a "Call me!" or "Running late—see you tonight!" or "Turn on channel 4 right now!!!" message to someone's phone.

On the other hand, if you're going to be away from your Mac for a few hours, you can have iChat forward incoming chat messages to your cellphone. Choose iChat rightwards double arrow Preferences rightwards double arrow Accounts and click Configure AIM Mobile Forwarding. In the resulting window, fill in your own cellphone number, so the incoming messages know where to go.

Just remember that some wireless carriers charge you by the message. So if a lot of buddies are constantly pinging you, you may want to switch to a plan with more (or unlimited) SMS messages each month.

21.7.2. Popping the Balloons

The words you might have for iChat's word-balloon design might be "cute" and "distinctive." But it's equally likely that your choice of words includes "juvenile" and "annoying."

Fortunately, behind iChat's candy coating are enough options tucked away in the View menu that you'll certainly find one that works for you (see Figure 21-7).

You can even change iChat's white background to any image using View rightwards double arrow Set Chat Background. Better yet, find a picture you like and drag it into your chat window; iChat immediately makes it the background of your chat. To get rid of the background and revert to soothing white, choose View rightwards double arrow Clear Chat Background.


audio_chats.html

21.8. Audio Chats

iChat becomes much more exciting when you exploit its AV Club capabilities. Even over a dial-up modem connection, you can conduct audio chats, speaking into your microphone and listening to the responses from your speaker.

Figure 21-7. iChat can look like almost anything. Here, for example, is what a chat looks like with the balloon effect turned off (giving you colored rectangles instead). You can even turn off balloons and pictures if they bother you that much. You can also hide the names, if you like. You make these changes for a chat in progress using the View menu. You can also change the color and typeface settings in the iChat rightwards double arrow Preferences rightwards double arrow Messages panel

If you have a broadband connection, though, you get a much more satisfying experience—and, if you have a pretty fast Mac, up to 10 of you can join in one massive, free conference call from across the Internet. (Specifically, you need a 867-megahertz G4 processor or faster to make audio calls with up to five people. To initiate an audio chat with six to 10 participants, you need a Mac with an Intel processor, a G5 chip, a 1-gigahertz G4 chip, or dual 800-megahertz G4s.)

A telephone icon next to a name in your buddy list tells you that the buddy has a microphone, and is ready for a free Internet "phone call." If you see what appear to be stacked phone icons, then your pal's Mac has enough horsepower to handle a multiple-person conference call. (You can see these icons back in Figure 21-2.)

POWER USERS' CLINIC
Bluetooth Headset Voice Chats

If hollering at your computer isn't your preferred method of civilized conversation, you can conduct your audio (and video) chats while wearing a Bluetooth headset instead.

If you haven't paired your headset with your Mac yet, go to iChat rightwards double arrow Preferences rightwards double arrow Audio/Video and click the button for Set Up Bluetooth Headset. This fires up the Mac's Bluetooth Setup Assistant program to guide you through the process.

After you get your Bluetooth headset married to your Mac, go to [image] rightwards double arrow System Preferences rightwards double arrow Output and select your headset in the list. Click the Input tab in the box to fiddle with the volume levels so you're not too loud and distorted when you speak into the mic—and not deafened when sound comes into your head.

To begin an audio chat, take your pick:

  • Click the telephone icon next to the buddy's name, or

  • Highlight someone in the Buddy List, and then click the telephone icon at the bottom of the list, or

  • If you're already in a text chat, choose Buddies rightwards double arrow Invite to Audio Chat.

Once your invitation is accepted, you can begin speaking to each other. The bars of the sound-level meter let you know that the microphone—which you've specified in the iChat rightwards double arrow Preferences rightwards double arrow Audio/Video tab—is working.

Tip: Although the audio is full-duplex (you can hear and speak simultaneously, like a phone but unlike a walkie-talkie), there may be a delay, like you're calling overseas on a bad connection. If you can't hear anything at all, check out iChat's Help system, which contains a long list of suggestions.


video_chats.html

21.9. Video Chats

If you and your partner both have broadband Internet connections, even more impressive feats await. You can conduct a free video chat with up to four people, who show up on three vertical panels, gorgeously reflected on a shiny black table surface. This isn't the jerky, out-of-audio-sync, Triscuit-sized video of Windows videoconferencing. If you've got the Mac muscle and bandwidth, your partners are as crisp, clear, bright and smooth as television—and as big as your screen, if you like.

People can come and go; as they enter and leave the "videosphere," iChat slides their glistening screens aside, enlarging or shrinking them as necessary to fit on your screen.

Apple offers this luxurious experience, however, only if you have luxurious gear:

  • A video camera. It can be the tiny iSight camera that's embedded above the screens of iMacs and laptops; an external FireWire iSight camera; an ordinary digital camcorder (as long as your Mac has at least a G5 chip inside); or a golf-ball Webcam that connects via FireWire instead of USB.

    Tip: You and your buddy don't both need the same gear. If only you have a camera, for example, you can choose Buddies rightwards double arrow Invite to One-Way Video Chat (or Audio Chat). Your less-equipped buddy can see you, but has to speak (audio only) or type in response.

  • A fast processor. This is miserably picky information, but confronting it now will save you many headaches down the road:

    If your Mac has a 867-megahertz G4 processor or anything faster, you can have one-on-one video chats. To pull off a multiperson video chat, the Mac that initiates the call—invites everyone else to join—must contain a G5 processor or dual G4s running at 1 gigahertz or faster. If you want to join a multiperson video chat, you need an Intel G5 chip, a 1-gigahertz G4 chip, or dual 800-megahertz G4s.

  • Bandwidth. You need Internet upload/download speeds of at least 100 kilobits per second for basic, tiny video chats with one other person, and a minimum of 384 Kbps for four-way video chats. And those are for the smallest video windows. Starting a video chat at the highest video quality requires 1,800 Kbps—speeds that residential DSL packages may not be able to muster.

Tip: As you're beginning to appreciate, iChat's system requirements are all over the map. Some features require very little horsepower; others require tons.To find out exactly which features your Mac can handle, choose Video rightwards double arrow Connection Doctor; from the Show pop-up menu, choose Capabilities. There's a little chart of all iChat features, showing checkmarks for the ones your Mac can manage.

If you see a camcorder icon next to a buddy's name, you can have a full-screen, high-quality video chat with that person, because they, like you, have a suitable camera and a high-speed Internet connection. If you see a stacked camcorder icon, then that person has a G5 or a faster Mac that's capable of joining a four-way video chat.

To begin a video chat, click the camera icon next to a buddy's name, or highlight someone in the Buddy List and then click the camcorder icon at the bottom of the list. Or, if you're already in a text chat, choose Buddies rightwards double arrow Invite to Video Chat.

Figure 21-8. That's you in the smaller window. To move your own mini-window, click a different corner, or drag yourself to a different corner. If you need to blow your nose or do something else unseemly, Option-click the microphone button to freeze the video and mute the audio. Click again to resume.

A window opens, showing you. This Preview mode is intended to show what your buddy will see. (You'll probably discover that you need some kind of light in front of you to avoid being too shadowy.) As your buddies join you, they appear in their own windows (Figure 21-8).

And now, some video-chat notes:

  • If your conversation partners seem unwilling to make eye contact, it's not because they're shifty. They're just looking at you, on the screen, rather than at the camera—and chances are you aren't looking into your camera, either.

  • Don't miss the Video rightwards double arrow Full Screen command! Wild.

  • You can have video chats with Windows computers, too, as long as they're using a recent version of AOL Instant Messenger. Be prepared for disappointment, though; the video is generally jerky, small, and slightly out of sync. That's partly due to the cheap USB Webcams most PCs have, and partly due to the poor video codec (compression scheme) that's built into AOL Instant Messenger.

  • If you use iChat with a camcorder, you can set the camera to VTR (playback) mode and play a tape right over the Internet to whoever is on the other end! (The video appears flipped horizontally on your screen, but looks right to the other person.)

  • You can capture a still "photo"ofa video chat by [image] -dragging the image to your desktop, or by choosing Video rightwards double arrow Take Snapshot (Option- [image] -S).

  • Don't want to see yourself in the picture-in-picture window during your video chat? Choose Video rightwards double arrow Hide Local Video. (That's new in 10.5.)

  • This cutting-edge technology can occasionally present cutting-edge glitches. The video quality deteriorates, the transmission aborts suddenly, the audio has an annoying echo, and so on. When problems strike, iChat Help offers a number of tips; the Video rightwards double arrow Connection Doctor can identify your network speed. (iChat video likes lots of network speed.)

  • Just as you can save your typed transcripts of instant message conversations, you can record your audio and video chats. Once you start a chat, choose Video rightwards double arrow Record Chat. Your buddy is asked if it's OK for you to proceed with the recording (to ward off any question of those pesky wiretapping laws); if permission is granted, iChat begins recording the call.

When you've got what you want, click Stop. Your recordings are automatically saved into Home rightwards double arrow Documents rightwards double arrow iChats(AAC files for audio conversations, MPEG-4 files for video chats). From there, you can drag them into iTunes to play or sync them up with an iPod or iPhoto. Yes, you can now relive those glorious iChat moments when you're standing in line at the grocery store.

21.9.1. Bluescreen Backdrops and Video FX

If your video chats look like a bunch of cubicle-dwellers sitting around chatting at their desks, you can liven things up with one of Leopard's most glamorous and jaw-dropping features: photo or video backgrounds for your talking head. Yes, now you can make your video chat partners think you're in Paris, on the moon, or even impersonating a four-panel Andy Warhol silkscreen.

Note: The iChat and Photo Booth backdrop effects are serious, serious processor hogs; they require, at minimum, a Mac with a Core 2 Duo processor. And bandwidth, man, serious bandwidth—at least 128 Kbps for both upload and download speeds.

Here's how to prepare your backdrop for a video chat:

  1. Go to iChat rightwards double arrow Preferences rightwards double arrow Audio/Video.

    A video window opens so you can see yourself.

  2. Press Shift- [image] -E (or go to Video rightwards double arrow Show Video Effects).

    The Effects box appears, looking a lot like the one in Photo Booth (Chapter 10); a lot of the visual backdrops are quite similar. Click the various squares of the tic-tac-toe grid to see how each effect will transform you in real time: making your face bulbous, for example, or rendering you in delicate colored pencil shadings.

    The first two pages of effects all do video magic on you and everything else in the picture. If you want one of those, click it; you're done. There's no step 3. Your video-chat buddies now see you in your distorted or artistic new getup.

    The second two pages of effects, however, don't do anything to your image. Instead, they replace the background.

    This is the really amazing part. In TV and movies, replacing the background is an extremely common special effect. All you have to do is set up a perfectly smooth, evenly lit, shadowless blue or bright green backdrop behind the subject. Later, the computer replaces that solid color with a new picture or video of the director's choice.

    iChat, however, creates exactly the same special effect (Figure 21-9) without requiring the bluescreen or the greenscreen. Read on.

  3. Click the background effect you want.

    Suppose, for example, that you've clicked the video loop showing the Eiffel Tower with people walking around. At this point, a message appears on the screen that says, "Please step out of the frame."

  4. Duck out of camera range (or move off to one side).

    See, iChat intends to memorize a picture of the real background—without you in it. When you return to the scene, your high-horsepower Mac then compares each pixel of its memorized image with what it's seeing now. Any differences, it concludes, must be you. And that is how it can create a bluescreen effect without a bluescreen.

    Note: To make this work, both the camera and the background must be perfectly still. If the lighting or the visuals shift or change in any way, you may get some weird, glitchy effects where your real background bleeds through.

  5. When the screen says, "Background detected," step back into the frame.

    Zut alors! You are now in virtual Paris. Go ahead and start the video chat with your friends, and don't forget your beret.

If you want to clear out the background or change it, click the Original square in the middle of the Effects palette and then choose a different backdrop. (You can also change backdrops in mid-chat by choosing Video rightwards double arrow Show Video Effects to open the effects palette.)

If things get too weird and choppy onscreen, you can restore the normal background by choosing Video rightwards double arrow Reset Background. (That's also handy if you suddenly have to have a video talk with your boss about your excessive use of iChat while he's away on his business trip.)

Figure 21-9. Top left: You have plenty of backgrounds to choose from for your next video chat. Click an effect to add it to your chat window. Click the small arrows at the bottom of the window to advance or retreat through the various effects styles. Click the Original square in the middle of the window to erase the effect and start again from scratch.
Lower right: Let the live bluescreen action begin!

Tip: You can use one of your own photos or video clips as iChat backdrops, too. In the Video Effects box, click the arrows on the bottom until you get to the screen with several blank User Backdrop screens. Next, drag a photo or video from the desktop directly onto one of the blank screens. Click it just like you would any of Apple's stock shots.


sharing_your_screen.html

21.10. Sharing Your Screen

As you've seen already in this chapter, iChat lets you share your thoughts, your voice, and your image with the people on your buddy lists. And now, for its next trick, it lets you share…your computer.

iChat's screen sharing feature is a close relative of the network screen-sharing feature described in Chapter 13. It lets you not only see what's on a far-away buddy's screen, but control it, taking command of the distant mouse and keyboard. (Of course, screen sharing can work the other way, too.)

You can open folders, create and edit documents, and copy files on the shared Mac screen. Sharing a screen makes collaborating as easy as working side by side around the same Mac, except now you can be sitting in San Francisco while your buddy is banging it out in Boston.

And if you're the family tech-support specialist—but the family lives all over the country—screen sharing makes troubleshooting a heckuva lot easier. You can now jump on your Mom's shared Mac and figure out why the formatting went wacky in her Word document, without her having to attempt explaining it to you over the phone. ("And then the little thingie disappeared and the doohickey got scrambled…")

Note: Of course, in these days of Big Scary Internet Security Issues, you want to make sure the person you share your screen with is someone you trust completely, because he or she is going to have the same access to your Mac as you do. Needless to say, do not accept screen-sharing invitations from people you don't know. Also, be leery of people on your Bonjour list asking you to share your screen, because Bonjour identities can be easily faked.

To make iChat screen sharing work, you and your buddy must both be running Macs with Leopard. On the other hand, you can share over any account type: AIM, .Mac, Google Talk, Bonjour, or Jabber.

To begin, click the sharee's name in your Buddy List.

  • If you want to share your screen with this person, choose Buddies rightwards double arrow Share My Screen.

  • If you want to see her screen (because she has all the working files on her Mac), choose Buddies rightwards double arrow Ask to Share.

Note: Similar commands are available in the Screen Sharing pop-up button—the one that looks like two overlapping squares at the bottom of the Buddy List window. The commands say "Share My Screen with casey234" and "Ask to Share casey234's screen."

Once the invitation is accepted, the sharing begins, as shown in Figure 21-10. To help you communicate further, iChat politely opens up an audio chat with your buddy so you can have a hands-free discussion about what you're doing on the shared machine.

Figure 21-10. Top: You either send or receive an invitation to start sharing your screen, but make sure you know with whom you're dealing before accepting the offer and starting the sharing process.
Bottom: When you're sharing someone else's screen, you have the option to click back and forth between the two Mac screens.

If you're seeing someone else's screen, you see his Mac desktop in full-screen view, right on your own machine. You also see a small window showing your own Mac; click it to switch back to your own desktop.

Tip: To copy files from Mac to Mac, drag them between the two windows. Files dragged to your Mac wind up in your Downloads folder.

If something's not right, or you need to bail out of a shared connection immediately, press Control-Escape on the Mac's keyboard.


ichat_theater.html

21.11. iChat Theater

Talk about the next best thing to being there. The new iChat Theater feature lets you make pitches and presentations to people and committees in faraway cities—without standing in a single airport-security line.

That's because iChat Theater turns the chat window into a presentation screen for displaying and narrating your own iPhoto or Keynote slideshows, QuickTime movie files, and even text documents. Your buddy, on the other end of the iChat line, sees these documents at nearly full size—with you in a little picture-in-picture screen in the corner.

All you need is:

  • Some stuff to show off. iChat Theater can display exactly the same kinds of files that Quick Look (Chapter 1) can display:Word, Excel, and PowerPoint documents, photos, text and HTML files, PDF files, audio and movie files, fonts, vCards, Pages, Numbers, Keynote, and TextEdit documents, and so on.

  • A zippy broadband Internet connection. iChat Theater likes384 kilobits per second or faster; check with your Internet provider if you aren't sure of your connection speed.

  • A fast Mac. Any Leopard Mac can use replacement mode (where the other guy just sees your presentation, not you); for side-by-side mode (where your video image appears in a small inset to one side, and both video frames are slightly angled), you both need superfast Macs (dual 1-GHz G4 processor, G5, or Intel chip) and superfact connections.

To get the show running, you can take one of two approaches.

  • If a video chat is under way, you can just drag the file(s) you want to share into the video window. iChat asks if you want to send the file to the person or share it with iChat Theater (Figure 21-11, top). Click iChat Theater, of course.

  • If no video chat is in progress, choose File rightwards double arrow Share a File in iChat Theater. Locate the file that you want to present on your hard drive. When iChat asks you to start a video chat with the buddy who's going to be your audience, click the video-camera icon next to that person's name (or choose Video rightwards double arrow Invite to Video Chat).

When your friend accepts, the curtain goes up, as shown the bottom of Figure 21-11. The file you're sharing takes center stage (er, window) and your buddy appears in a little video window off to the side. Click the [image] button to expand the view to full screen.

If you have iPhoto '08, sharing picture albums is one menu command away: Choose File rightwards double arrow Share iPhoto with iChat Theater. When the Media Browser pops up, pick the album you want to present. The first picture in the selected album appears in the iChat window before iPhoto itself opens, so you can use iPhoto's nice controls for cruising forward (or backward) through your album.

The same thing happens if you're running a Keynote presentation in iChat Theater: The first slide shows up in the chat window while the Keynote program launches to provide you with the proper controls to click through the rest of the slides in the presentation.

Figure 21-11. Top: You can start an iChat Theater session by choosing File rightwards double arrow Share a File with iChat Theater, or as shown here, by simply dropping the file on an open video chat window and going for the iChat Theater option.
Bottom: Once you've started a Theater show in Chat, the shared file takes center stage so you both can look at it and discuss amongst yourselves.

When the show is over, close the window to end the iChat Theater session.


ichat_tweaks.html

21.12. iChat Tweaks

If you've done nothing but chat in iChat, you haven't even scratched the surface. The iChat rightwards double arrow Preferences dialog box gives you plenty of additional control. A few examples:

  • General pane. If you turn on Show status in menu bar, you bring the iChat menulet to your menu bar. It lets you change your iChat status (Available, Away, and so on), whether you're in iChat or not.

    And if you turn off When I quit iChat, set my status to Offline, then quitting iChat doesn't actually log you out. When someone wants a chat with you, iChat opens automatically.

    The General pane is also where you tell iChat what to do when you're temporarily away from the Mac. You can have it automatically reply to chat invitations with your personalized "I'm not here" message. When you come back to the Mac or wake it up from sleep, you can have iChat flip your status from Away to Available all by itself.

  • Accounts pane. If you have more than one AIM, Jabber, or .Mac account, you can switch among them here. Your passwords are conveniently saved in your Mac OS X Keychain.

  • Messages pane. The Messages preference panel lets you design your chat windows— the background color, word balloon color, and typeface and size of text you type.

    GEM IN THE ROUGH
    iChat on Autopilot

    If you've read this chapter all the way through, then you know that iChat can respond to chat invitations by running an AppleScript. And if you've read Chapter 7, you know that AppleScript is capable of…almost anything.

    As a proof of concept, Apple's AppleScript product manager has created a truly evil script that you can choose in the iChat rightwards double arrow Preferences rightwards double arrow Alerts rightwards double arrow Run AppleScript pop-up menu. It's called iChat Autopilot; you can download it from this book's "Missing CD" page at www.missingmanuals.com.

    In short, this very special script simulates your end of the chat. It carries on a fairly generic conversation, periodically typing perfectly plausible all-purpose utterances, occasion-ally excusing yourself while you answer the doorbell, and otherwise doing an excellent impersonation of a distracted, preoccupied, but still well-meaning you.

    Let it run. Give your buddies the satisfaction of knowing you're there for them.

    Even though you're really watching TV downstairs.

    If you want to set a special background image for your chats, you can do that as well—just drag a graphics file into the chat preview box on this pane. You can revert to a white background by choosing View rightwards double arrow Clear Background.

    Tip: Here's a little tweak, right on the Messages pane, that nobody ever mentions: the preference setting called "Watch for my name in incoming messages." It alerts you any time anyone, in any of the open chats, types your name, even if you're doing something else on the Mac. (As in, "Casey, are you there? Casey!? CASEY!!")

  • Alerts pane. Here, you can choose how iChat responds to various events. For example, it can play a sound, bounce its Dock icon, or say something out loud whenever you log in, log out, receive new messages, or run an AppleScript, as described earlier in this chapter.

  • Audio/Video pane. This is where you get a preview of your own camera's output, limit the amount of bandwidth (signal-hogging data) the camera uses (a troubleshooting step), and specify that you want iChat to fire up automatically whenever you switch on the camera.


ssh_ftp_vpn_and_web_sharing.html

Chapter 22. SSH, FTP, VPN, and Web Sharing

Email and Web surfing may be the most popular Internet activities, but the world's most gigantic network has many other uses. The general idea is always the same, though: letting one computer reach out and touch another.

Mac OS X offers a few features that embrace the more literal aspects of that notion. For example, you can turn your Mac into a Web server—an actual living Web site that anyone on the Internet can visit. This chapter also explores various advanced methods of manipulating your own Mac from the road, including remote access technologies like long-distance file sharing, FTP, SSH, and virtual private networking (VPN).

Note: Most of these technologies are designed for full-time Internet connections (cable modem or DSL, for example). If you have a dial-up modem, these features work only when you're actually online. Still, they may occasionally be useful anyway. You could always get online, call up a friend and say, "Check out my Web site right now—here's the current IP address" or call someone back home to say, "I have to grab a file off my hard drive. Could you make the Mac on my desk go online?"

22.1. Web Sharing

Using the Sharing pane of System Preferences, you can turn your Mac into a Web site (or server), accessible from the Web browsers of people on your office network, the Internet at large, or both.

This feature assumes, of course, that you've already created some Web pages. For this purpose, you can use Web design programs (Macromedia Dreamweaver, for example, or the free Netscape Composer) or save documents out of TextEdit or Word as Web pages. Or you could let Mac OS X build Web pages for you using iPhoto or Image Capture.

After you provide your friends and co-workers with your Mac's Website address, they can view your Web pages, graphics, and documents in their own Web browsers. And whenever you're online, your Web site is also available to any one on the Internet—but you don't have to pay a penny to a Web-hosting company.

UP TO SPEED
The IP Address Mess: Port Forwarding

There are so many ways to connect to your Mac from another computer. You can use Web sharing, SSH, file sharing, screen sharing, and so on. They're easy to use—when you want to connect across your home or office network.

When you want to connect from across the Internet, though, things get complicated fast.

In that case, you need to know your home Mac's IP address. (It stands for Internet Protocol.) An IP address is always made up of four numbers separated by periods, like 192.168.1.104. Every computer on earth that's directly connected to the Internet has its own unique IP address.

Now, if you have only one Mac, and it's connected directly to your broadband modem, no big deal. You can find out its IP address by opening System Preferences, clicking Sharing, and clicking File Sharing.

Unfortunately, your Mac at home probably isn't connected directly to the Internet. If you're like most people, it's connected to a router, or maybe an AirPort base station, so that several computers in your house can share the same Internet connection. In this setup, the router (or base station) has a unique IP address—not the Macs connected to it.

(The router doles out private IP addresses to each computer in your house or office, usually beginning with 192 or 10. If you check your Mac's IP address in System Preferences, you'll find out only its private address—not the public one that's accessible from the Internet. To find out that information, you have to check your router or base station's configuration screen; check the router's manual for instructions.)

All right: How are you supposed to connect to one particular Mac if it's connected to a router and doesn't have a true, "public" IP address?

One solution is Back to My Mac, the remote-access feature described on Section 13.5.3.4. It solves the behind-the-router problem for you, but it requires a .Mac account (Section 18.6).

Otherwise, your only hope is to turn on a router feature called port forwarding. It makes the router pass signals intended for a specific port (Section 12.9) to one particular computer on the network. For example, you could direct all port-80 communications to the Mac doing Web serving, for example, and all 548 traffic to a Mac doing file sharing.

The point is that, even with port forwarding, you still can't access two different machines using the same port. (For some services, including ssh and Timbuktu, you can work around this limitation by logging into the machine specified for port forwarding, and then from that machine, log into the others on the rest of the network.)

Turning on port forwarding doesn't require a programming degree, but it's not simple by any means. For starters, the steps are different for every router model.

Fortunately, you can find guided tutorials on the Web. You can use Google to search for your particular router model, or check, www.portforward.com which offers free step-by-steps for hundreds of router models, including Apple's AirPort base stations. Even so, try to arrange the assistance of someone who knows networking.

In this chapter, the term "your IP address" means your public IP address. If you have only one Mac, that's its IP address. If you have a router or wireless network, use that device's IP address—as passed along by port forwarding.

Tip: Web sharing is also an easy and efficient way to share your Mac files with Windows PCs, either those on your office network or those on the Internet. No special software or translation is required, and posting your files on the Web page avoids all the usual complexities of sending files by email.

Mac OS X's Web Sharing feature isn't some feeble junior version, either. Inside Mac OS X is Apache, one of the strongest and most popular Unix Web server programs—precisely the same one that drives 60 percent of the Internet's commercial Web sites.

The bottom line: If you build it, they won't necessarily come. But you'll have the capacity to handle them if they do.

22.1.1. Firing Up Web Sharing

Here's how you turn your Mac into a low-budget Web site:

  1. Put the HTML documents, graphics, and files you want to publish into your Home rightwards double arrow Sites folder.

    Every account's Home folder has a Sites folder, and therefore the Mac can actually serve up lots of Web sites at once.

    Your Web site's home page, by the way, won't appear unless it's named index.html. (Apple has already put an index.html document into your Sites folder, just to give you the idea; feel free to replace it.) And the other files you put in Sites aren't accessible unless they're linked from your index.html page.

  2. Open System Preferences; click Sharing. Turn on the Web Sharing checkbox (Figure 22-1).

    Figure 22-1. Use the Sharing System Preferences pane to make designated folders on your hard drive available to anyone on the Internet. Note that your Mac's IP address, shown here in underlined type, works only when people connect from across the local network. It probably won't work from across the Internet; see the box on the facing page.
    Also note the line below the Computer Name box. That's your Mac's Bonjour name, which is a bit friendlier than its IP address.

    You've just made the contents of your Sites folder available to anyone who connects to your Mac.

  3. Send your network address to your friends and co-workers.

    People on your local office network can use your Mac's Bonjour name to connect. It appears at the top of the Sharing pane, as shown in Figure 22-1. For example, your colleagues can type http://office-mac.local/~chris into their Web browsers, where office-mac.local is your Mac's Bonjour name.

    If other people will be connecting from the Internet, you need to figure out your public IP address; as noted in the box on Section 22.1, that might be your router'sIP address, not your Mac's.

    Your Mac Web site's address might be, for example, http://111.222.3.44/~chris/ (the number is your public IP address, and the name should be your short user name). Don't forget the final slash. Tell your friends to bookmark it so they won't have to remember all that.

You've just put your Mac-based Web page on the Internet for all to see—that is, all who know your secret Web address. Maybe you'll want to distribute the address only to other people on your office network, using your tiny Web site as a distribution source for documents. Or maybe you'll want to go whole-hog, hosting an e-commerce Web site.(Read on.)

22.1.2. The Mac's Own Web Site

The instructions above show you how to create a Web site in your Home rightwards double arrow Sites folder. In other words, they guide you through the process of creating a personal Web site.

But if you have an Administrator account (Chapter 12), you can also put your Web pages into the main hard drive window's Library rightwards double arrow WebServer rightwards double arrow Documents folder. This is your Mac's main Web site folder, and its address is simply http://111.222.3.44/. That is, it's just your public IP address, no user name needed. (Here again, if people will be connecting from across your office network rather than the Internet, they can replace the IP number with your Mac's Bonjour name.)

Working with this primary Web site folder is only slightly different from the personal ones described above. Because you're now working inside an official Mac OS X system folder, you must mind your permissions (Section 13.2.2). Using the File rightwards double arrow Get Info command, you should set up the permissions of any folders and documents inside the Library rightwards double arrow WebServer rightwards double arrow Documents folder (an Images folder, for example) as described on Section 13.2.2.

That way, you can ensure that your visitors are allowed to see your Web documents— and that random Internet hoodlums can't make any changes to them.

22.1.3. The Easiest Way to Distribute Files

Here's a handy secret: If there isn't a document whose name is index.html in your Sites folder (or Library rightwards double arrow WebServer rightwards double arrow Documents folder), then visitors see, in their browsers, a handy list of the files that are in that folder (see Figure 22-2).

This is a terrific convenience: It offers a quick, simple way for you to make a bunch of documents available for downloading. All your visitors have to do is click one of these file names. It downloads immediately, no matter what kind of computer your Web visitor is using.

Tip: This has nothing to do with Web sharing, but it's kind of cool: You can see the contents of any folder on your Mac, just by typing its folder pathname into a Web browser's address bar. For example, to see what's in your Documents folder, type file:///Users/chris/Documents/ into Safari's address bar. You get a tidy list like the one shown in Figure 22-2, revealing what's in that folder. Click a link to open it. (If you're using Safari, you open a Finder window revealing the folder's contents instead.).

Figure 22-2. Here's a great way to make files available to other people on your network or collaborators across the Internet. Just put your files into the Sites or Library rightwards double arrow WebServer rightwards double arrow Documents folder and make sure nothing is named index.html. The Parent Directory link takes you to the folder that contains this one—in this case, the Library rightwards double arrow WebServer rightwards double arrow Documents folder

22.1.4. More on Apache

As noted above, Apache is the most popular Web-serving software in the world. As you can well imagine, it's powerful, reliable—and very technical. It is, after all, a Unix program.

You can read more at any of these sources:

  • The Apache manual. To open it up, type http://localhost/manual/ into your browser's address bar. You won't get far reading this thing if you haven't spent some time at a technical college, but at least you'll know what you're up against.

  • Apache: The Definitive Guide. A book from O'Reilly.

  • MacOSXHints.com. Dozens of Mac OS X fans have posted specific Apachetweaking tips and tricks atwww.macosxhints.com.

Note, too, that $350 will buy you a graphic front end for the various Apache settings, in the form of Tenon's iTools program (no relation to Apple's old iTools service). It still requires an understanding of the technical aspects of Web hosting, but at least it spares you from having to type out Unix commands to make your changes.


web_sharing.html

Chapter 22. SSH, FTP, VPN, and Web Sharing

Email and Web surfing may be the most popular Internet activities, but the world's most gigantic network has many other uses. The general idea is always the same, though: letting one computer reach out and touch another.

Mac OS X offers a few features that embrace the more literal aspects of that notion. For example, you can turn your Mac into a Web server—an actual living Web site that anyone on the Internet can visit. This chapter also explores various advanced methods of manipulating your own Mac from the road, including remote access technologies like long-distance file sharing, FTP, SSH, and virtual private networking (VPN).

Note: Most of these technologies are designed for full-time Internet connections (cable modem or DSL, for example). If you have a dial-up modem, these features work only when you're actually online. Still, they may occasionally be useful anyway. You could always get online, call up a friend and say, "Check out my Web site right now—here's the current IP address" or call someone back home to say, "I have to grab a file off my hard drive. Could you make the Mac on my desk go online?"

22.1. Web Sharing

Using the Sharing pane of System Preferences, you can turn your Mac into a Web site (or server), accessible from the Web browsers of people on your office network, the Internet at large, or both.

This feature assumes, of course, that you've already created some Web pages. For this purpose, you can use Web design programs (Macromedia Dreamweaver, for example, or the free Netscape Composer) or save documents out of TextEdit or Word as Web pages. Or you could let Mac OS X build Web pages for you using iPhoto or Image Capture.

After you provide your friends and co-workers with your Mac's Website address, they can view your Web pages, graphics, and documents in their own Web browsers. And whenever you're online, your Web site is also available to any one on the Internet—but you don't have to pay a penny to a Web-hosting company.

UP TO SPEED
The IP Address Mess: Port Forwarding

There are so many ways to connect to your Mac from another computer. You can use Web sharing, SSH, file sharing, screen sharing, and so on. They're easy to use—when you want to connect across your home or office network.

When you want to connect from across the Internet, though, things get complicated fast.

In that case, you need to know your home Mac's IP address. (It stands for Internet Protocol.) An IP address is always made up of four numbers separated by periods, like 192.168.1.104. Every computer on earth that's directly connected to the Internet has its own unique IP address.

Now, if you have only one Mac, and it's connected directly to your broadband modem, no big deal. You can find out its IP address by opening System Preferences, clicking Sharing, and clicking File Sharing.

Unfortunately, your Mac at home probably isn't connected directly to the Internet. If you're like most people, it's connected to a router, or maybe an AirPort base station, so that several computers in your house can share the same Internet connection. In this setup, the router (or base station) has a unique IP address—not the Macs connected to it.

(The router doles out private IP addresses to each computer in your house or office, usually beginning with 192 or 10. If you check your Mac's IP address in System Preferences, you'll find out only its private address—not the public one that's accessible from the Internet. To find out that information, you have to check your router or base station's configuration screen; check the router's manual for instructions.)

All right: How are you supposed to connect to one particular Mac if it's connected to a router and doesn't have a true, "public" IP address?

One solution is Back to My Mac, the remote-access feature described on Section 13.5.3.4. It solves the behind-the-router problem for you, but it requires a .Mac account (Section 18.6).

Otherwise, your only hope is to turn on a router feature called port forwarding. It makes the router pass signals intended for a specific port (Section 12.9) to one particular computer on the network. For example, you could direct all port-80 communications to the Mac doing Web serving, for example, and all 548 traffic to a Mac doing file sharing.

The point is that, even with port forwarding, you still can't access two different machines using the same port. (For some services, including ssh and Timbuktu, you can work around this limitation by logging into the machine specified for port forwarding, and then from that machine, log into the others on the rest of the network.)

Turning on port forwarding doesn't require a programming degree, but it's not simple by any means. For starters, the steps are different for every router model.

Fortunately, you can find guided tutorials on the Web. You can use Google to search for your particular router model, or check, www.portforward.com which offers free step-by-steps for hundreds of router models, including Apple's AirPort base stations. Even so, try to arrange the assistance of someone who knows networking.

In this chapter, the term "your IP address" means your public IP address. If you have only one Mac, that's its IP address. If you have a router or wireless network, use that device's IP address—as passed along by port forwarding.

Tip: Web sharing is also an easy and efficient way to share your Mac files with Windows PCs, either those on your office network or those on the Internet. No special software or translation is required, and posting your files on the Web page avoids all the usual complexities of sending files by email.

Mac OS X's Web Sharing feature isn't some feeble junior version, either. Inside Mac OS X is Apache, one of the strongest and most popular Unix Web server programs—precisely the same one that drives 60 percent of the Internet's commercial Web sites.

The bottom line: If you build it, they won't necessarily come. But you'll have the capacity to handle them if they do.

22.1.1. Firing Up Web Sharing

Here's how you turn your Mac into a low-budget Web site:

  1. Put the HTML documents, graphics, and files you want to publish into your Home rightwards double arrow Sites folder.

    Every account's Home folder has a Sites folder, and therefore the Mac can actually serve up lots of Web sites at once.

    Your Web site's home page, by the way, won't appear unless it's named index.html. (Apple has already put an index.html document into your Sites folder, just to give you the idea; feel free to replace it.) And the other files you put in Sites aren't accessible unless they're linked from your index.html page.

  2. Open System Preferences; click Sharing. Turn on the Web Sharing checkbox (Figure 22-1).

    Figure 22-1. Use the Sharing System Preferences pane to make designated folders on your hard drive available to anyone on the Internet. Note that your Mac's IP address, shown here in underlined type, works only when people connect from across the local network. It probably won't work from across the Internet; see the box on the facing page.
    Also note the line below the Computer Name box. That's your Mac's Bonjour name, which is a bit friendlier than its IP address.

    You've just made the contents of your Sites folder available to anyone who connects to your Mac.

  3. Send your network address to your friends and co-workers.

    People on your local office network can use your Mac's Bonjour name to connect. It appears at the top of the Sharing pane, as shown in Figure 22-1. For example, your colleagues can type http://office-mac.local/~chris into their Web browsers, where office-mac.local is your Mac's Bonjour name.

    If other people will be connecting from the Internet, you need to figure out your public IP address; as noted in the box on Section 22.1, that might be your router'sIP address, not your Mac's.

    Your Mac Web site's address might be, for example, http://111.222.3.44/~chris/ (the number is your public IP address, and the name should be your short user name). Don't forget the final slash. Tell your friends to bookmark it so they won't have to remember all that.

You've just put your Mac-based Web page on the Internet for all to see—that is, all who know your secret Web address. Maybe you'll want to distribute the address only to other people on your office network, using your tiny Web site as a distribution source for documents. Or maybe you'll want to go whole-hog, hosting an e-commerce Web site.(Read on.)

22.1.2. The Mac's Own Web Site

The instructions above show you how to create a Web site in your Home rightwards double arrow Sites folder. In other words, they guide you through the process of creating a personal Web site.

But if you have an Administrator account (Chapter 12), you can also put your Web pages into the main hard drive window's Library rightwards double arrow WebServer rightwards double arrow Documents folder. This is your Mac's main Web site folder, and its address is simply http://111.222.3.44/. That is, it's just your public IP address, no user name needed. (Here again, if people will be connecting from across your office network rather than the Internet, they can replace the IP number with your Mac's Bonjour name.)

Working with this primary Web site folder is only slightly different from the personal ones described above. Because you're now working inside an official Mac OS X system folder, you must mind your permissions (Section 13.2.2). Using the File rightwards double arrow Get Info command, you should set up the permissions of any folders and documents inside the Library rightwards double arrow WebServer rightwards double arrow Documents folder (an Images folder, for example) as described on Section 13.2.2.

That way, you can ensure that your visitors are allowed to see your Web documents— and that random Internet hoodlums can't make any changes to them.

22.1.3. The Easiest Way to Distribute Files

Here's a handy secret: If there isn't a document whose name is index.html in your Sites folder (or Library rightwards double arrow WebServer rightwards double arrow Documents folder), then visitors see, in their browsers, a handy list of the files that are in that folder (see Figure 22-2).

This is a terrific convenience: It offers a quick, simple way for you to make a bunch of documents available for downloading. All your visitors have to do is click one of these file names. It downloads immediately, no matter what kind of computer your Web visitor is using.

Tip: This has nothing to do with Web sharing, but it's kind of cool: You can see the contents of any folder on your Mac, just by typing its folder pathname into a Web browser's address bar. For example, to see what's in your Documents folder, type file:///Users/chris/Documents/ into Safari's address bar. You get a tidy list like the one shown in Figure 22-2, revealing what's in that folder. Click a link to open it. (If you're using Safari, you open a Finder window revealing the folder's contents instead.).

Figure 22-2. Here's a great way to make files available to other people on your network or collaborators across the Internet. Just put your files into the Sites or Library rightwards double arrow WebServer rightwards double arrow Documents folder and make sure nothing is named index.html. The Parent Directory link takes you to the folder that contains this one—in this case, the Library rightwards double arrow WebServer rightwards double arrow Documents folder

22.1.4. More on Apache

As noted above, Apache is the most popular Web-serving software in the world. As you can well imagine, it's powerful, reliable—and very technical. It is, after all, a Unix program.

You can read more at any of these sources:

  • The Apache manual. To open it up, type http://localhost/manual/ into your browser's address bar. You won't get far reading this thing if you haven't spent some time at a technical college, but at least you'll know what you're up against.

  • Apache: The Definitive Guide. A book from O'Reilly.

  • MacOSXHints.com. Dozens of Mac OS X fans have posted specific Apachetweaking tips and tricks atwww.macosxhints.com.

Note, too, that $350 will buy you a graphic front end for the various Apache settings, in the form of Tenon's iTools program (no relation to Apple's old iTools service). It still requires an understanding of the technical aspects of Web hosting, but at least it spares you from having to type out Unix commands to make your changes.


ftp-id001.html

22.2. FTP

FTP sites (file transfer protocol) store pieces of software that can be accessed from the Internet. If you've heard of FTP at all, it was probably under one of two circumstances— either you've downloaded software from an Internet FTP site, or you've created and maintained your own Web site.

POWER USERS' CLINIC
CGI Scripts

A CGI script (Common Gateway Interface) is a program— written in a language like Perl, AppleScript, or Python—that runs right on your Web page. You've seen these on many a Web page: Web-visitor counters, interactive polls, shopping forms, and so on. Apple even includes a few of them with Mac OS X; they're in your System rightwards double arrow Library rightwards double arrow Perl rightwards double arrow [version number] rightwards double arrow CGI Scripts folder, for example.

If you've got a CGI script of your own that you'd like to incorporate into your Web page, copy it into your Library rightwards double arrow WebServer rightwards double arrow CGI folder. (This means you, administrators.) The script's Web address becomes http://111.222.3.44/cgi-bin/scriptname. (Substitute your actual public IP address and the real name of the script file, of course.)

Unfortunately, you won't get far testing out your CGI script, because it comes with its "execute" permissions turned off. To turn them on again, you need to use the chmod (change mode) command.

You can use a permission-changing shareware program like SuperGetInfo, available from the "Missing CD" page of www.missingmanuals.com, or you can do the job in Terminal, as described on Section 16.7. (In this case, you'd type sudo chmod 755 test-cgi.)

The chmod command is a quick way to change access privileges—including Execute permission, which isn't available in the File rightwards double arrow Get Info window.

The 755 business is a long story, which you can read at any Terminal prompt by typing man chmod and hitting Enter. In short, however, this code is shorthand for "Change the permissions so that everyone else can read and execute (but not make changes to) this file"—just what you want for a CGI script.

After hitting Enter, you're ready to proceed. Now sudo asks for your administrator's password. Once you've entered it, press Enter; the deed is done. You can test your script either on the same Mac (http://localhost/cgi-bin/test-cgi) or on another one across the network or across the Internet (http://111.222.3.44/cgi-bin/test-cgi).

22.2.1. Uploading and Downloading from FTP Sites

Hooking into an FTP site generally requires an FTP client program that runs on the kind of computer you use (Mac, Windows, or whatever). On Mac OS X, popular FTP client programs include the shareware programs Transmit, Fetch, Interarchy, and Captain FTP, and the free RBrowser (which is available from the "MissingCD" page at www.missingmanuals.com.

Using these programs, Web designers, for example, can view a list of all the text and graphics documents, sitting there on an Internet-connected computer somewhere, that make up their Web pages. The effect is shown in Figure 22-3.

When they want to update one of those pages, they add it to this list; to delete a Web page, they remove it from this list.

Figure 22-3. Top: To access your Mac OS X machine from across the Internet, fire up a program like RBrowser and use the address ftp://111.222.33.4 (or whatever your public IP address is). Be sure the first pop-up menu says FTP, not Public FTP—otherwise, you won't be offered the chance to type in your account name and password.
Bottom: Once you're looking at an FTP server's contents, you can drag files from your desktop into the list. Copy them to your Mac by dragging them out of the list onto your desktop, or open them by double-clicking.

22.2.2. Just Downloading from FTP Sites

If you're just going to look at and download files (but not upload or delete any), you don't even need a special FTP program. You can get to the files much more directly using one of these two methods:

  • Any old Web browser will work. Open Safari, for example, and type ftp://ftp.apple. com (or whatever the address is) into the address bar. A dialog box asks for an account name and password, if they're required. Once you're in, you switch to the Finder and see the contents of the FTP site as a window full of standard file icons. (In other browsers, you see the list of the FTP site right in the browser window.)

  • Using the Finder's Go rightwards double arrow Connect to Server command, you can mount read-only FTP volumes right on your desktop, much like a public iDisk.

    In the Connect to Server dialog box, just enter the address of the FTP server you would like to mount—ftp://ftp.apple.com, for example. You'll soon see the ftp.apple.com icon appear on your desktop, looking just like your other disks. Open it up and drag out whatever you want to download.

22.2.3. Becoming an FTP Server

Thanks to Mac OS X and its Wonder Unix, you can also turn your own Mac into an FTP site. Once again, the key is the Sharing pane of System Preferences; this time, turn on the File Sharing checkbox, click Options, and click "Share files and folders using FTP." Click OK.

Once again, the key to your own Mac is its public IP address (see the box on Section 22.1). At this point, you, or other people you trust, can connect to your FTP server by running an FTP program like RBrowser (see Figure 22-3) or just typing ftp://111.222.33.4 (or whatever your public IP address is) into their Web browsers.


connecting_from_the_road.html

22.3. Connecting from the Road

You can also connect to your Mac's regular File Sharing feature (Chapter 13) from over the Internet. This feature is a blessing to anyone who travels, whether with a laptop or to a branch office, because you'll never be up the creek without a paddle if you discover that you left an important file at home.

The easiest way to go about it is to use Back to My Mac (Section 13.5.3.4), which is one of Apple's $100-a-year .Mac services.

If you'd rather spend time than money, though, you can set up a remote-file-sharing system on your own. Start by setting up the home-base Mac for file sharing, as directed in Chapter 13; then figure out your Mac's public IP address, as described in the box on Section 22.1.

Finally, once you're on the road, go online and proceed like this:

  1. Choose Go rightwards double arrow Connect to Server.

    The Connect to Server dialog box appears, as shown in Figure 22-4.

  2. Type in the public IP address of the Mac to which you want to connect, and then click Connect (or press Enter).

    See the box on Section 22.1 for a discussion of public vs. private IP addresses.

  3. Enter your name and password, and then click Connect.

    From here, it's just as though you were connecting to another computer on your office network (Chapter 13), although it's a good bit slower. But when you're in Hong Kong and need a document from your Mac in Minneapolis, you may not care.

Figure 22-4. The Connect to Server dialog box lets you type in the IP address for the shared Mac to which you want access. (Ensuring that the shared Mac is turned on and connected to the Internet is the network administrator's problem.)


remote_access_with_ssh.html

22.4. Remote Access with SSH

Are you a geek? Take this simple test at home. Do you get excited about Mac OS X's ability to permit SSH access?

If you answered "What's SSH?" or "I'm already being quiet, "then the following discussion of Unix remote control may not interest you. To be sure, SSH is not a program with a graphic user interface (icons and menus).You operate it from within a program like Terminal by typing commands, exactly as described in Chapter 16.

If you're willing to overlook that little peccadillo, though, SSH (Secure Shell) is an extremely powerful tool. It lets you connect to your Mac from any where—froms across the network or across the Internet. And once you're connected, you can take complete control of it, copying files, running commands, rearranging folders, or even shutting it down, all by remote control.

22.4.1. Getting In

Here's how you go about using SSH:

  1. Set up your Mac by opening the Sharing panel of System Preferences, and then turning on the Remote Login checkbox.

    You've just told the Mac it's OK for you (or other people with accounts on your machine) to connect from the road. Quit System Preferences.

  2. Go away

    You can move to another machine on the network, or another computer on the Internet. Once you're online with that other machine, you can contact your home base machine from within a program like Terminal.

    Tip: It doesn't have to be Terminal, and it doesn't have to be a Mac. You can get SSH client programs for almost any kind of computer, including Windows and Mac OS 9.For pre–Mac OS X Macs, for example, you can try Mac SSH or NiftyTelnet SSH, both of which you can download from this book's "Missing CD" page at www.missingmanuals.com. For Windows, try Putty (www.puttyssh.org).

  3. At the prompt, type ssh -l chris 111.222.3.44. Press Enter.

    Instead of chris, substitute your short account name (as you're known on the Mac you're tapping into), and replace the phony IP address shown here with your real public address. (If your Mac back home has a domain name unto itself, such as macmania.com, you can type that instead of the IP address.

    If all goes well, the ssh command acknowledges your first successful connection by displaying a message like this: "The authenticity of host '172.24.30.189 (172.24.30.189)' can't be established. RSA key fingerprint is d9:f4:11:b0:27:1a:f1: 14:c3:cd:25:85:2b:78:4d:e7. Are you sure you want to continue connecting (yes/ no)?"(This message won't appear on subsequent connections.) You're seeing SSH's security features at work.

  4. Type yes and press Enter.

    Now you see one more note: "Warning: Permanently added '172.24.30.189' (RSA) to the list of known hosts." You're then asked for your account password.

  5. Type your account password and press Enter.

    You're in. Issue whatever commands you want. You can now conduct a full Unix Terminal session as described in Chapter 16—but by remote control.

    Tip: For a more thorough description of SSH and its options, type man ssh at the prompt.

22.4.2. Remote Control Program Killing

One of the most common uses of SSH is quitting a stuck program. Maybe it's a program that doesn't respond to the usual Force Quit commands—;maybe even the Finder or Terminal. Or maybe, having just arrived in Accounting on the fifth floor, you realize that you accidentally left your Web browser, open to Dilbert.com, up on your screen in clear view of passersby.

In any case, you'd fire up Terminal and proceed like this (what you type is shown in bold; the Mac's responses are in normal type):

    home-mac:~ chris$ ssh 172.24.30.182
    The authenticity of host '172.24.30.182 (172.24.30.182)' can't
    be established. RSA key fingerprint is d9:f4:11:b0:27:1a:f1:14:c
    3:cd:25:85:2b:78:4d:e7.
    Are you sure you want to continue connecting (yes/no)? yes
    Warning: Permanently added '172.24.30.182' (RSA) to the list of
    known hosts.
    chris@172.24.30.189's password: fisheggs
    Last login: Thu Nov 13 17:23:38 2005
    Welcome to Darwin!
    office-mac:~ chris$ top

The top -u command, as described in Chapter 16, displays a list of running programs. After a block of memory statistics, you might see a list like this:

    294 top         6.5%  0:01.10  1   16   26   276K   416K   652K  27.1M
    293 bash        0.0%  0:00.03  1   12   15   168K   856K   768K  18.2M
    292 login       0.0%  0:00.01  1   13   37   140K   408K   492K  26.9M
    291 Terminal    0.0%  0:05.50  3   60  115  2.99M  5.41M  6.59M   149M
    287 HotKey      0.0%  0:00.34  4  151   78   760K  2.24M  2.67M  96.5M
    283 Finder      0.0%  0:02.04  2   89  162  3.95M  17.1M  15.5M  165M
    282 SystemUISe  0.9%  0:01.51  2  241  327  3.03M  7.85M  8.54M  158M
    281 Dock        0.0%  0:00.24  2   77  132   780K  10.7M  2.80M  139M

As you can see, the Finder is process number 283. If that's the stuck program, then, you could quit it like so:

    office-mac:~ chris$ kill 283

Or if you're sure of the program's exact name, just use the killall command with the program's name instead of its process ID. To handle a stuck Finder, you would type this:

    office-mac:~ chris$ killall Finder

Either way, the Finder promptly quits (and relaunches in a healthier incarnation, you hope). You could also, at this point, type sudo shutdown -h now to make your Mac, elsewhere on the network, shut down. (Terminal doesn't type any kind of response.)

If you ended your SSH session by shutting down the other Mac, you can just close the Terminal window now. Otherwise, type exit to complete your SSH session.


virtual_private_networking.html

22.5. Virtual Private Networking

After reading the previous pages, you might assume that it's a piece of cake for business people to connect to their corporate networks across the Internet from wherever they happen to be: their homes, hotel rooms, or local Starbucks. But even though the steps on the preceding pages work fine if you're dialing into your home machine, they'll probably fail miserably when you want to connect to a corporate network. There's one enormous obstacle in your way: Internet security.

The typical corporate network is guarded by a team of steely-eyed administrators for whom Job Number One is preventing access by unauthorized visitors. They perform this job primarily with the aid of a super-secure firewall that seals off the company's network from the Internet.

So how can you tap into the network from the road? One solution is to create a hole in the firewall for each authorized user — software that permits incoming Internet traffic only from specified IP addresses like your Mac's. Unfortunately, this setup isn't bulletproof, security-wise. It's also a pain for administrators to manage.

Another solution: You could dial directly into the corporate network, modem-to modem. That's plenty secure, but it bypasses the Internet, and therefore winds up being expensive. (Want proof? Try this simple test: Make a call from the Tokyo Hilton to the Poughkeepsie Sheet Metal home office. Have a look at your hotel bill when you check out.)

Fortunately, there's a third solution that's both secure and cheap: the Virtual Private Networke, or VPN. Running a VPN allows you to create a super-secure "tunnel" from your Mac, across the Internet, and straight into your corporate network. All data passing through this tunnel is heavily encrypted; to the Internet eavesdropper, it looks like so much undecipherable gobbledygook.

And it's cheap—whether you're accessing the Internet via your home DSL, a local ISP number from a hotel, or wirelessly from your stool at Starbucks.

Remember, though, that VPN is a corporate tool, run by corporate nerds. You can't use this feature without these pieces in place:

  • A VPN server. This is a big deal. If your tech department tells you they don't have one, then that's that—no tunneling for you.

    If they do have one, then you'll need to know the type of server it is. Mac OS X's VPN software can connect to VPN servers that speak PPTP (Point to Point Tunneling Protocol) and L2TP/IPsec (Layer 2 Tunneling Protocol over the IP Security Protocol), both relatives of the PPP language spoken by modems. Most corporate VPN servers work with at least one of these protocols.

    You'll also need to know the Internet address of your VPN server (for example, http://vpn.ferrets-r-us.com).

  • An account on the remote network that allows VPN access.Your remote network can be set up in many different ways, but in every case, you'll still need to confirm with your network administrator that your account on it allows VPN access.

  • All necessary account information. Make sure you have all the scraps of connection information you'll need to dial in. That would include your user (account) name, at the very least. You may also need an NT Domain name; VPN servers are often part of Microsoft Windows NT networks, which won't let you in until you know this domain name.

    Some networks also may require that you type in the currently displayed password on an RSA SecurID card,which your administrator will provide. This James Bondish, credit card–like thing displays a password that changes every few seconds, making it rather difficult for hackers to learn "the" password. (If your network doesn't require a SecurID card, you'll need a standard password instead.)

    Finally, if your office offers L2TP connections, you'll need yet another password called a Shared Secret to ensure that the server you're connecting to is really the server that you intend to connect to.

22.5.1. Setting Up the VPN Connection

If you're lucky, your company's network geek has provided you with a VPN settings file, a little double-clickable icon that automatically opens the Network pane of System Preferences and fills in the blanks for you. If not, you can do all that manually:

  1. Open System Preferences. Click Network. Click the + button below the list of connections at the left side.

    The "Select an interface" sheet appears.

  2. From the pop-up menu, choose VPN.

    Now a new pop-up menu appears, called VPN Type; you're supposed to choose either L2TP (Layer 2 Tunneling Protocol) or PPTP (Point to Point Tunneling Protocol). Find out which system your company's network uses.

    Tip: Leopard doesn't work with the third popular type, called IPSec (IP Security). If your company uses that type, though, you can download Cisco's free IPSec connection program for Mac OS X from cisco.com.

  3. Choose the type of VPN from the VPN Type pop-up menu. Type a name for this connection (it can be anything you want). Click Create.

    You return to the main Network pane, where the settings boxes for your VPN are waiting (Figure 22-5).

  4. Fill in the server address and account name. Click Authentication Settings to specify your password and other security settings.

    Here, for example, is where you indicate that you have one of those SecurID cards.

  5. Click OK. Turn on "Show VPN Status in menu bar.

    That checkbox makes the VPN menulet appear; it's your ticket to getting connected (Figure 22-5, top).

Tip: If you always connect to the same VPN, you can turn on the new Leopard feature called VPN on Demand. It autoconnects you to your corporate VPN every time you direct your Web browser to a Web site, file server, or resource that requires the VPN connection, saving you some steps.To set this up, click Advanced. (You can see this button in the figure below.) Click VPN on Demand; click +. Enter the corporate VPN domain. You're good to go—as long as you've got your network geek's permission. (Some of them get antsy about VPN on Demand, since it could be a security risk if your laptop is stolen.)

Figure 22-5. You're on your way to joining the corporate network—from thousands of miles away. Virtual private networking is ideal for the paranoid (because it's very secure) and the cheap (because you're using the Internet as a giant wire connecting you to your home).

Close System Preferences. You're ready to connect.

22.5.2. Connecting to a VPN

Connect the way you normally do—via cable modem, DSL, office network, modem, AirPort, or whatever. Once you're online, choose your VPN's name from the VPN menulet. You'll be asked for your credentials: your password, for example, or the code that's displayed on your SecurID card.

If all goes well, several status messages go by. The last one says, "Connected To" and gives the IP address of the network equipment you've reached out and touched.

At this point, you're connected to the corporate network. You can perform the same network-related tasks you could if you were actually in that office: check your email, view internal corporate Web pages, access internal FTP servers, make printouts on laser printers thousands of miles away, and so on.

You generally can't browse things, though. That is, depending on your network, you might not be able to use your Sidebar to view a list of the other computers on the office network, or see a list of networked printers.

In this case, to access these services, you must know their IP addresses. For example, to connect to a shared folder on another computer, choose Go rightwards double arrow Connect to Server, type its network address, and press Enter.

Tip: To connect to a shared folder on a Windows machine, the address looks like this: smb://111.222.33.4/ sales-docs. Of course, you'd substitute the correct IP address for the dummy one shown here, and insert the actual name of the shared folder. (You can also use its DNS name instead of the IP address, if you know it, like this: smb://big-blue-server.ferret-lan.com/sales-docs.)

When you're finished accessing the remote network, choose Disconnect from the VPN menulet. (Accessing other Web sites can be slow while you're on a VPN.)

22.5.3. The Fine Points of VPN

For all the wonders of VPN, here are some possible complications:

  • If you're using a router at home (a little box that shares one cable modem or DSL box with several computers),it might not be able to handle the tunneling protocols, or it might not have that feature turned on. Check the router's manual, or ask its manufacturer for more information. For example, the first-generation (silver) AirPort base stations can't handle VPNs at all.

  • If the corporate network doesn't seem to like your name and password, you might need to add your NT domain name and a backwards slash to the beginning of your account name (like this: dom01\msmith) before trying again.

    If you're able to make the connection, but experiencing trouble reaching services by their DNS names (for example, big-blue-server.com), your Mac could be having difficulty finding the right DNS server. Working with your network administrator, open the Network pane of System Preferences. Click VPN, then click Advanced, and then DNS; enter the desired DNS server addresses in the DNS Servers box. Click OK, then Apply, and then try the VPN connection again.

  • If you're still having problems using the VPN, look at the logs (automatically kept technical records) for clues to share with your network administrator. To view these records, open the Console program (in Applications rightwards double arrow Utilities). Click Show Log List, expand the /var/log section, and click ppp.log.


appendixes.html

Part VI: Appendixes

Appendix A

Appendix B

Appendix C

Appendix D

Appendix E

A. Installing Mac OS X 10.5

If your computer came with Mac OS X 10.5 already installed on it, you can skip this appendix—for now. But if you're running an earlier version of the Mac OS and want to savor the Leopard experience, this appendix describes how to install the new operating system on your Mac.

A.1. Getting Ready to Install

For starters, you need to make sure that you and your Mac have what it takes to handle Mac OS X—specifically:

  • A Macintosh with a G4, G5, or Intel processor. Those old Power Mac G3s and PowerBook G3s have finally fallen off the Mac OS X upgrade path. (And G4 machines require an 867-megahertz chip or faster.) Basically, most Macs manufactured since the end of 2004 are eligible, which isn't bad at all.

  • Plenty of free hard disk space. You need 9 GB free to install the full Mac OS X 10.5—more if you install the Developer Tools, less if you decline to install all the optional languages and printer drivers (more on this in a moment).

  • A lot of memory. Apple recommends at least 512 MB of memory, but Mac OS X absolutely loves memory. For the greatest speed, install 1 gigabyte—2 or more if you can afford it.

    (And these days, you probably can.)

  • The latest firmware. Firmware describes the low-level, underlying software instructions that control the actual circuitry of your Mac. Every now and then, Apple updates it for certain Mac models, and it's very important that your Mac has the absolute latest. If yours doesn't, a message will appear to let you know during the Leopard installation. Some Macs might just spit the DVD right out. Quit the installer and grab the latest updater from www.apple.com/support/downloads.

  • A copy of Leopard to install. Apple sells Leopard in several ways. There's the regular Leopard DVD, for example, and there's the Family Pack, which authorizes you to install Leopard on up to five Macs in the same household.(Neither version is copyprotected; only the honor system stops you from installing on a sixth Mac.)

    And then there's the version that comes with every new Mac. It's labeled Mac OS X Leopard Disc 1, but it's the same thing as the sold-separately DVD. (Disc 2, in this case, contains all the other programs that come with a new Mac, like the iLife software suite.)


installing_mac_os_x_105.html

Part VI: Appendixes

Appendix A

Appendix B

Appendix C

Appendix D

Appendix E

A. Installing Mac OS X 10.5

If your computer came with Mac OS X 10.5 already installed on it, you can skip this appendix—for now. But if you're running an earlier version of the Mac OS and want to savor the Leopard experience, this appendix describes how to install the new operating system on your Mac.

A.1. Getting Ready to Install

For starters, you need to make sure that you and your Mac have what it takes to handle Mac OS X—specifically:

  • A Macintosh with a G4, G5, or Intel processor. Those old Power Mac G3s and PowerBook G3s have finally fallen off the Mac OS X upgrade path. (And G4 machines require an 867-megahertz chip or faster.) Basically, most Macs manufactured since the end of 2004 are eligible, which isn't bad at all.

  • Plenty of free hard disk space. You need 9 GB free to install the full Mac OS X 10.5—more if you install the Developer Tools, less if you decline to install all the optional languages and printer drivers (more on this in a moment).

  • A lot of memory. Apple recommends at least 512 MB of memory, but Mac OS X absolutely loves memory. For the greatest speed, install 1 gigabyte—2 or more if you can afford it.

    (And these days, you probably can.)

  • The latest firmware. Firmware describes the low-level, underlying software instructions that control the actual circuitry of your Mac. Every now and then, Apple updates it for certain Mac models, and it's very important that your Mac has the absolute latest. If yours doesn't, a message will appear to let you know during the Leopard installation. Some Macs might just spit the DVD right out. Quit the installer and grab the latest updater from www.apple.com/support/downloads.

  • A copy of Leopard to install. Apple sells Leopard in several ways. There's the regular Leopard DVD, for example, and there's the Family Pack, which authorizes you to install Leopard on up to five Macs in the same household.(Neither version is copyprotected; only the honor system stops you from installing on a sixth Mac.)

    And then there's the version that comes with every new Mac. It's labeled Mac OS X Leopard Disc 1, but it's the same thing as the sold-separately DVD. (Disc 2, in this case, contains all the other programs that come with a new Mac, like the iLife software suite.)


getting_ready_to_install.html

Part VI: Appendixes

Appendix A

Appendix B

Appendix C

Appendix D

Appendix E

A. Installing Mac OS X 10.5

If your computer came with Mac OS X 10.5 already installed on it, you can skip this appendix—for now. But if you're running an earlier version of the Mac OS and want to savor the Leopard experience, this appendix describes how to install the new operating system on your Mac.

A.1. Getting Ready to Install

For starters, you need to make sure that you and your Mac have what it takes to handle Mac OS X—specifically:

  • A Macintosh with a G4, G5, or Intel processor. Those old Power Mac G3s and PowerBook G3s have finally fallen off the Mac OS X upgrade path. (And G4 machines require an 867-megahertz chip or faster.) Basically, most Macs manufactured since the end of 2004 are eligible, which isn't bad at all.

  • Plenty of free hard disk space. You need 9 GB free to install the full Mac OS X 10.5—more if you install the Developer Tools, less if you decline to install all the optional languages and printer drivers (more on this in a moment).

  • A lot of memory. Apple recommends at least 512 MB of memory, but Mac OS X absolutely loves memory. For the greatest speed, install 1 gigabyte—2 or more if you can afford it.

    (And these days, you probably can.)

  • The latest firmware. Firmware describes the low-level, underlying software instructions that control the actual circuitry of your Mac. Every now and then, Apple updates it for certain Mac models, and it's very important that your Mac has the absolute latest. If yours doesn't, a message will appear to let you know during the Leopard installation. Some Macs might just spit the DVD right out. Quit the installer and grab the latest updater from www.apple.com/support/downloads.

  • A copy of Leopard to install. Apple sells Leopard in several ways. There's the regular Leopard DVD, for example, and there's the Family Pack, which authorizes you to install Leopard on up to five Macs in the same household.(Neither version is copyprotected; only the honor system stops you from installing on a sixth Mac.)

    And then there's the version that comes with every new Mac. It's labeled Mac OS X Leopard Disc 1, but it's the same thing as the sold-separately DVD. (Disc 2, in this case, contains all the other programs that come with a new Mac, like the iLife software suite.)


four_kinds_of_installation.html

A.2. Four Kinds of Installation

The Mac OS X installer can perform a number of different installations. For example, it can put a copy of Mac OS X 10.5 onto a hard drive that currently has:

  • Nothing on it. If you one day have to erase your hard drive completely—because it's completely hosed, or, less drastically, because you've bought a new, empty external hard drive—this is how to do it. See "Erase & Install," on Section A.7, for a step-by-step guide.

  • Mac OS 9. See "The Basic Installation" on the facing page for a step-by-step explanation. (Your old Mac OS 9 System Folder will still be there after the installation, but it won't do you much good. Classic doesn't exist anymore, and the only Leopard-compatible Macs that can restart into Mac OS 9 are a handful of pre-2003 G4 models.)

  • Mac OS X 10.0 through 10.4. The Leopard installer can turn your older copy of Mac OS X into the 10.5 version, in the process maintaining all of your older preferences, fonts, documents, accounts, and so on. See "The Upgrade Installation" on Section A.4.

    POWER USERS' CLINIC
    The Partitioning Question

    Before you install Leopard, you might want to confront the issue of partitioningyour Mac's hard drive—dividing its surface so that it shows up on your desktop with two different icons and two different names. You can keep Mac OS 9 on one (if you have a G5, pre-Intel machine) and Mac OS X on the other. For that matter, you can keep Leopard on one, and Tiger on the other. Now you can live like a king, enjoying all the advantages of people who have two separate hard drives.

    As a bonus, the Mac even comes with a partitioning program: Disk Utility. And it no longer requires first erasing the drive completely; you can re-partition on the fly, without disturbing whatever is already on the drive. For details, see Section 10.30.11.1.

    On the other hand, a substantial body of evidence (specifically, hundreds of moaning Mac fans online) points to the wisdom of performing a clean install, rather than an upgrade installation. (Apple calls the clean install the "Archive & Install" option.) A clean installation provides a healthier, more glitch-proof copy of 10.5. See "The Clean Install" on Section A.6.

  • MacOSX10.5. In times of dire troubleshooting, when nothing in Appendix B has helped, you can actually give yourself a fresh copy of 10.5, even though it's already on the hard drive. See "The Clean Install" on Section A.6.


the_basic_installation.html

A.3. The Basic Installation

The installation process takes about 45 minutes, but for the sake of your own psyche, you'll probably want to set aside a whole afternoon. Once the installation is overkl;, you'll want to play around, organize your files, and learn the lay of the land.

A.3.1. Phase 1: The Installer

Here's how you install Leopard onto a drive that doesn't have a version of Mac OS X on it already:

  1. Insert the Mac OS X DVD. Double-click the Install Mac OS X icon in the disc's main window (Figure A-1). When the Restart button appears, click it.

    The Mac starts up from the disc and takes you directly to the first Installer screen.

    Figure A-1. Your installation adventure is about to begin. The very first step, though, is restarting the Mac, which the installer invites you to do.

    The installer soon falls into a pattern: Read the instructions, make a couple of choices, and click Continue to advance to the next screen. As you go, the list on the left side of the screen reveals where you are in the overall procedure.

    Tip: You can back out of the installation at any time before step 5, just by choosing Installer rightwards double arrow Quit Installer. When the Restart button appears, click it. Then eject the Mac OS X disc, either by holding down the mouse button while the computer restarts or, if you have a tray-loading CD drive, by pushing its Eject button during the moment of darkness during the restart.

  2. Work your way through the Select Language screen, Welcome screen, and Software License Agreement screens, clicking Continue each time.

    Note that once you're past the Select Language screen, the Mac OS X Installer menu bar becomes available. In the Utilities menu are some very useful commands; they let you jump directly into programs like Disk Utility (to erase or partition your hard drive), Terminal (to do some Unixy preparatory steps), System Profiler (to see how much memory this machine has), Reset Password (if you've forgotten yours), and more.

    If you do decide to take that detour to another program, when you quit it, you'll return to the Installer program, right where you left off.

    The Software License Agreement requires you to click a button confirming that you agree with whatever Apple's lawyers say.

  3. On the Select a Destination screen, click the disk or partition on which you want to install Mac OS X.

    Icons for all of your disks (or partitions) appear on the screen, but ones that are off-limits to Mac OS X (like CDs and USB hard drives) appear dimmed, if at all.

    WORKAROUND WORKSHOP
    The Leopard "Up to Date" Upgrade Disk

    When you buy Leopard from a store, you get the installer described on these pages—the one capable of performing either an Upgrade installation or an "Archive and Install" (that is, a clean install).

    You may have received a different DVD, however, thanks to Apple's Software Up-to-Date program. (That's where you pay only $20 or so for the upgrade—a consolation prize offered to anyone who bought a new Mac only a few weeks before a major new Mac OS X version comes out.) You'll know if you have this version, because the disc bears the label Upgrade Disc.

    Trouble is, there's no Archive and Install option when you run this installer. After all, these discs are intended to upgrade the copy of Mac OS X that's already on your new Mac.

    That doesn't mean, though, that you can't perform a clean install at all. If you use the Erase and Install option, you do indeed get a clean installation of Leopard. You'll have to recreate your accounts and settings, but at least you'll wind up with the considerable stability benefits of a clean installation.

    Click the icon of the drive—or the partition, if you've created one to hold Mac OS X—that will be your new main startup drive.

    Note: If a yellow, triangular exclamation point logo appears on a drive, it probably has a newer version of Mac OS X 10.5 on it. (Read the message at the bottom of the dialog box to find out.) That's the case if you're trying to install from the original 10.5 DVD, but you already have 10.5.2 on the hard drive, for example. No problem; you should be reading "The Clean Install" instructions on Section A.6 anyway.

  4. Click Continue.

    You arrive at the Easy Install screen. The easiest way to proceed here is to click Install. But don't.

    Instead, take the time to click Customize.

    The Installer shows you a list of the various chunks that constitute Mac OS X. A few of them are easily dispensable. For example, if you turn off Additional Fonts, Language Translations (for Japanese, German, French, and so on), the drivers for printer models that you don't own, and the X11 Unix kit (Section 16.9), you save a staggering 5.5 gigabytes. It's like getting a whole mini-hard drive for free (ka-ching!). Click Done when you're finished gloating.

    POWER USERS' CLINIC
    Installing From an iPod

    All right, so you want to install Leopard onto a Mac that has a broken DVD drive. Or you want a faster, less scratch-prone way to install Mac OS X.

    If you have another Mac that does have a working DVD drive, and you also have an iPod or an external hard drive, here's a sweeter way.

    First, back up your iPod or external drive, if necessary; you're about to erase it. (You can skip this step if you use your iPod just for music. In theory, it's already a backup—of your iTunes music library! After you're finished with this little exercise, hook the iPod back up to the first Mac, and let iTunes sync all your tunes right back onto it.)

    Open Disk Utility (in your Applications rightwards double arrow Utilities folder). On the Erase tab, erase the iPod.

    Now click the Re-store tab in Disk Utility. From the Source list at the left side of the window (shown here), drag the Leopard DVD's icon into the top (source) box, and the iPod's icon into the destination box. Click Re-store, and confirm your decision.

    After the copying is complete, you can plug your iPod in any Mac and run the Leopard installer, exactly as described in this chapter.

  5. Click Install.

    Now you're in for a 25-minute wait as the Installer copies software onto your hard drive. When the installer's finished, you see a message indicating that your Mac will restart in 30 seconds. If you haven't wandered off to watch TV, click the Restart button to end the countdown and get on with it.

Mac OS X 10.5 is now installed on your Mac—but you're not quite ready to use it yet. See "The Setup Assistant" on Section A.7.


the_upgrade_installation.html

A.4. The Upgrade Installation

If Mac OS X version 10.0 through 10.4-point-anything is on your hard drive, the Leopard installer can neatly nip and tuck its software code, turning it into version 10.5.Every thing remains just as you had it: your accounts, folders, files, email, network settings, everything-else settings, and so on.

This sophisticated surgery occasionally leaves behind a minor gremlin here and there: peculiar cosmetic glitches, a checkbox that doesn't seem to work, and so on. If that possibility concerns you, a clean install is a safer way to go. (A clean install does, however, require a little more post-installation fiddling to reinstate your settings, notably your Internet and network preferences.)

If you're still game to perform the upgrade installation, follow the previously outlined steps 1 through 3. On the Select Destination screen, however, click Options.

Now you're offered several variations of the basic installation. The one you want is Upgrade Mac OS X. Click it, and then click OK. Proceed with the previous step 4. (The button described there now says Upgrade, though, instead of Install.)


the_clean_install_archive_and_install.html

A.5. The Clean Install ("Archive and Install")

In Mac OS 9 and Windows, the clean install is considered an essential troubleshooting technique. It entails installing a second System Folder or Windows folder—a fresh one, uncontaminated by the detritus left behind by you and your software programs.

In general, though, you and your software can't invade the Mac OS X System folder. The kind of gradual corruption that could occur in those older operating systems is theoretically impossible in Mac OS X, and therefore the need to perform a clean install is almost completely eliminated.

That's the theory, anyway. In fact, somehow or other, things do go wrong with your Mac OS X installation. Maybe you or somebody else has been fiddling around in Terminal and wound up deleting or changing some important underlying files. Certain shareware programs can perform deep-seated changes like this, too.

The point is that eventually, you may wish you could just start over with a new, perfect copy of Mac OS X. And thanks to the clean install ("Archive and Install") option, you can—without having to erase the hard drive first.

Start by following steps 1 through 3 in "The Basic Installation" section. On the Select Destination screen, though, click Options. Now you're offered four kinds of installation. Turn on "Archive and Install." ("Preserve Users and Network Settings" should be on, too.)

This powerful option leaves all of your accounts (Home folders, documents, pictures, movies, Favorites, email, and so on) untouched. As the option's name implies, it also leaves your network and Internet settings alone. But it deactivates your old System folder (you'll find it, later, in a new folder called Previous System Folders) and puts a new one in its place. And that's exactly what you want.

Click OK and then continue with step 4 (Section A.3.1). When it's all over, you'll be confident that your Mac OS X installation is clean, fresh, and ready for action.

TROUBLESHOOTING MOMENT
Journaling

If you decide to erase your hard drive before installing Leopard, you're offered a choice of several formats for your hard drive, like "Mac OS Extended (Journaled)" and "Unix File System." If you choose the first option, you turn on a special, background feature of OS X known as file journaling.

When file journaling is turned on, your Mac keeps a personal diary of everything you do on your hard drive–opening, saving, deleting files, and so on. Journaling offers two benefits: a shorter startup time and safety in the event of a crash.

Here's how it works: When you press the power button, Mac OS X checks to see whether your computer was shut down properly (by choosing [image] rightwards double arrow Shut Down, for example, instead of just pulling out the plug).

If you didn't shut down properly, Mac OS X examines your hard drive the next time you start up to see if it needs repair. It has to scan the whole drive–which can take anywhere from a couple of minutes (if your hard drive is less than 10 GB) to a couple of hours (if your hard drive is more than 200 GB). Thanks to file journaling, however, Leopard can tell what was happening when your computer shut down–and therefore spend a lot less time checking your hard drive.

There are some downsides to the journaled format, however. First, this procedure doesn't actually recover what you were working on when your Mac shut down; it can only try to keep files you already saved from getting corrupted. Second, file journaling can make it take slightly longer for your programs to save files.

Mac OS X doesn't prevent you from having different hard drives with different formats. You can use the journaled format on your main hard drive, but not on your external FireWire drive—or vice versa. (If you ever want to change the format of one of your disks, use Disk Utility, although you'll have to erase all the information on the disk first.)

If you leave your Mac on all the time (if you run it as a Web server, for example), it's a good idea to use the journaled hard drive format. Keep in mind, too, that blackouts affect your hard drive just as much as pulling the plug. So if you live in Iraq, a solar-powered house, or anywhere else where power is inconsistent, journaling can be a lifesaver.


erase_ampersand_install.html

A.6. Erase & Install

The final installation option is called Erase & Install (known to the geek community as "Nuke 'n' Pave"). As you can guess, it erases your entire hard drive and installs the ultimate clean, fresh, sparkling new copy of Leopard and its applications there. Use this "nuke-and-pave" option when you're about to sell your Mac and want to ensure that no trace of your former stuff is still there.

If you're absolutely certain that you won't regret completely erasing the computer (or you have a brand-new, virgin hard drive), follow the previously described steps 1 through 3. On the Select Destination screen, though, click Options, and select Erase & Install. Continue with step 4.


the_setup_assistant.html

A.7. The Setup Assistant

When the Mac restarts after the installation, the first thing you experience is one of the most visually stunning post-installation OS startup movies in history: a flythrough of deep space, accompanied by scooby-dooby music and a fancy parade of 3-D, computer-generated translations of the word "Welcome." Once Apple has quite finished showing off its multimedia prowess, you arrive at a Welcome screen.

Note: You also hear a man's voice letting you know that if you're blind, you can press Esc to hear audio guidance for setting up the Mac and learning VoiceOve.If you do so, you're treated to a crash course in VoiceOver, the screen-control/screen-reading software described on Section 15.5.1.3. This, by the way, is the only time you'll be offered this tutorial, so pay attention. (Hint: Here are the basics. Hold down the Control and Option keys and press the arrow keys to highlight different elements of the screen, hearing them pronounced. When a new window opens, press Control-Option-Shift-W to read the contents of the window. Press Control-Option-Space bar to "click.")

Once again, you're in for a click-through-the-screens experience, this time with the aim of setting up your Mac's various options. After answering the questions on each screen, click Continue.

The number and sequence of information screens you'll encounter depend on whether you've upgraded an existing Mac or started fresh, but here are some of the possibilities:

  • Welcome. Click the name of the country you're in.

  • Select Your Keyboard. Different countries require different keyboard layouts. For example, if you choose the Canadian layout, pressing the ] key on a U.S. keyboard produces the ç symbol. Click Continue.

  • Do you already own a Mac? If you choose "Transfer my information from another Mac," the installer will assist you in sucking all of your old programs, files, folders, and settings from the old Mac to the new one.

    You have to help it, however, by connecting a FireWire cable between the two Macs, and then restarting the old Mac while holding down its T key. ("FireWire connection established.") Yes, that's right: the installer is putting you into FireWire Disk Mode (Section 6.2) for super-high-speed transfer.

    You're using the Mac OS X Migration Assistant, shown in Figure A-2. The bottom of the screen lets you know how much stuff you've tagged for transferring, and how much disk space remains on the new Mac.

    When you click Transfer, the data-copying process begins.

    Figure A-2. The Migration Assistant is actually pretty amazing. It brings over to your new Mac (or new Mac OS X installation) all of the files, settings, folders, and even installed programs from an older Mac—or, in times of tragedy, from a Time Machine backup (see Chapter 6).
    Along the way, you'll be asked whose account folder(s) you want brought over, which other stuff (like applications, files, and folders) to copy, and which sorts of settings.
    When it's all over, you might have to reactivate a couple of Adobe programs, but otherwise, you should be ready to roll on your new (or new-feeling) Mac.

  • Select a Wireless Service. This is your chance to introduce the Mac to any wireless networks in the vicinity. Click the network name you want to join, if you see it. If you don't see it, click Rescan to make the Mac sniff again in an attempt to locate the network. Or if there's no wireless hot spot at all—hey, it could happen—click Different Network Setup.

    In that event, you're offered choices like Airport wireless, Cable modem/DSL modem, Local network (Ethernet), and "My computer does not connect to the Internet." (Bummer!) When you click Continue, you may be asked for specific information—the local access number, account name, and password, and so on— regarding your Internet account. See Chapter 18 for advice on filling in these settings.

  • Enter Your Apple ID. Here, you're offered the chance to type in, or create, an Apple ID—which is your email address. An Apple ID doesn't cost anything, but it makes life easier if you want to buy songs from the Apple Music Store, order gift books or prints from iPhoto, and so on. (If you have a .Mac account—see Section 18.6—put that account info here.

  • Registration Information. This is your chance to become a grain of sand on the great beach of the Apple database (and to set up your own "card" in Mac OS X's Address Book program).

    Tip: If you're not interested in providing your personal information to Apple, or if you've already done so during a previous installation, press [image] -Q. A message offers you Skip, Shut Down, and Cancel buttons. If you click Skip, you jump straight ahead to "Create Your Account," below.

  • A Few More Questions. Where will you primarily use this computer? What best describes what you do? Do you want to get junk mail from Apple?

  • Create Your Account. Most of the steps up to this point have been pretty inconsequential, but this is a big moment. You're about to create your account—your Administrator account, in fact, as described in Chapter 12.

    All you have to do is make up a name, usually a short variation of your name and a password. Choose carefully, because you can't easily change your account name later.

    What you come up with here is extremely important, especially if several different people use this Mac at different times, or if other people connect to it on a network. See Section 11.2 for details on creating a password and a hint that will help you remember it.

    FREQUENTLY ASKED QUESTION
    Selective Installs

    Whoops! I accidentally trashed my copy of the Calculator. How can I get it back? Do I have to reinstall the whole, seething, 9 GB mass of Mac OS X?

    Fortunately, no. If you know the secret, you can install only specific components of Mac OS X without having to install the whole darned thing.

    What you need is Pacifist, a shareware program that lets you install individual files and folders from the archipelago that is the collection of Mac OS X installation discs.

    Technically, the Mac OS X installer is composed of dozens of sub-installers known as .pkg package files, which the installer opens one after another. That's the point of Pacifist—it lets you open an individual .pkg file.

    Pacifist can also check existing installations and find missing or altered files. You can download it from this book's "Missing CD" page at www.missingmanuals.com.

    If you're the only one who uses your Mac, it's perfectly OK to leave the password blank empty.

  • Select a Picture For This Account. If your Mac has a built-in camera (most models do), you can take a photo of yourself to use as your account icon. Just click "Take a video snapshot." You get a three-second countdown, and then the Mac snaps your photo. (You can always reshoot it.) Adjust the cropping by dragging inside the photo, and adjust the size by dragging the slider beneath it.

    If you're camera-shy, of course, you can choose "Choose from the picture library" instead, and find an Apple-provided icon instead.

  • Your .Mac Billing Information. If you have a .Mac membership, Apple cheerfully lets you know when it will expire.

  • Thanks For being a .Mac member. Aw, shucks.

  • Thank You. When you click Go, you wind up at the Mac OS X desktop, just as described in Chapter 1


uninstalling_mac_os_x_105.html

A.8. Uninstalling Mac OS X 10.5

There isn't any easy way to remove Mac OS X Leopard if you decide that you don't like it.

The chief problem is that thousands of its pieces are invisible. Even if you start up the Mac from another disk and then drag all the visible Mac OS X folders to the Trash, you'll leave behind many megabytes of software crumbs that you can't see.

So if you want to retreat to something earlier, back up the data that's worth preserving—mainly, your Home folder and Applications folder—and then erase the hard drive or partition and reinstall the operating system that you prefer.


troubleshooting.html

B. Troubleshooting

Whether it's a car engine or an operating system, anything with several thousand parts can develop the occasional technical hiccup. Mac OS X is far more resilient than its predecessors, but it's still a complex system with the potential for occasional glitches.

It's safe to say that you'll have to do less troubleshooting in Mac OS X than in Mac OS 9 or Windows, especially considering that most freaky little glitches go away if you just try these two steps, one at a time:

  • Quit and restart the wayward program.

  • Log out and log back in again.

It's theother problems that'll drive you batty.

B.1. Minor Eccentric Behavior

All kinds of glitches may befall you, occasionally, in Mac OS X. Your desktop picture doesn't change when you change it in System Preferences. A menulet doesn't open when you click it. A program won't open—it just bounces in the Dock a couple of times and then stops.

When a single program is acting up like this, but quitting and restarting it does no good, try the following steps, in the following sequence.

B.1.1. First Resort: Repair Permissions

An amazing number of mysterious glitches arise because thepermissions of either that item or something in your System folder—that is, the complex mesh of interconnected Unix permissions described in Chapter 12—have become muddled.

When something doesn't seem to be working right, therefore, open your Applications rightwards double arrow Utilities folder and open Disk Utility. Proceed as shown in Figure B-1.

This is a really, really great trick to know.

Tip: Many Mac mavens, in fact, believe in running this Repair Permissions routine after running any kind of installer, just to nip nascent problems in the bud. That includes both installers of new programs and of Apple's own Mac OS X updates.

Figure B-1. Click your hard drive's name in the left-side list; click the First Aid tab; click Repair Disk Permissions; and then read an article while the Mac checks out your disk. If the program finds anything amiss, you'll see messages like these. Among the text, you may recognize some Unix shorthand for read, write, and execute privileges (Chapter 17).

B.1.2. Second Resort: Look for an Update

If a program starts acting up immediately after you've installed or upgraded to Mac OS X 10.5, chances are good that it has some minor incompatibility. Chances are also good that you'll find an updated version on the company's Web site.

B.1.3. Third Resort: Toss the Prefs File

A corrupted preference file can bewilder the program that depends on it.

Before you go on a dumpfest, however, take this simple test. Log in using adifferent account(perhaps a dummy account that you create just for testing purposes). Run the problem program. Is the problem gone? If so, then the glitch exists only when you are logged in—which means it's a problem withyourcopy of the program's preferences.

Return to your own account. Open your Home foldera rightwards double arrow Library rightwards double arrow Preferences folder, where you'll find neatly labeled preference files for all of the programs you use. Each ends with the file name suffix .plist. For example, com.apple.finder. plist is the Finder's preference file, com.apple.dock.plist is the Dock's, and so on.

Put the suspect preference file into the Trash, but don't empty it. The next time you run the recalcitrant program, it will build itself a brand-new preference file that, if you're lucky, lacks whatever corruption was causing your problems.

If not, quit the program. You can reinstate its original .plist file from the Trash, if you'd find that helpful as you pursue your troubleshooting agenda.

Remember, however, that you actually havethreePreferences folders. In addition to your own Home folder's stash, there's a second one in the Library folder in the main hard drive window (which administrators are allowed to trash), and a third in the System rightwards double arrow Library folder in the main hard drive window (which nobody is allowed to trash—at least not without one of the security-bypass methods described in the box on the next page).

In any case, the next time you log in, the Mac creates fresh, virginal preference files.

B.1.4. Fourth Resort: Restart

Sometimes you can give Mac OS X or its programs a swift kick by restarting the Mac. It's an inconvenient step, but not nearly as time-consuming as what comes next. And it can fix problems that cropped up when you started up the computer.

B.1.5. Last Resort: Trash and Reinstall the Program

Sometimes reinstalling the problem program clears up whatever the glitch was.

First, however, throw away all traces of it. Open the Applications folder and drag the program's icon (or its folder) to the Trash. In most cases, the only remaining pieces to discard are its .plist file (or files) in your Home rightwards double arrow Library rightwards double arrow Preferences folder, and any scraps bearing the program's name in your Library rightwards double arrow Application Support folder. (You can do a quick Spotlight search to round up any other pieces.)

Then reinstall the program from its original disc or installer—after first checking the company's Web site to see if there's an updated version, of course.


minor_eccentric_behavior.html

B. Troubleshooting

Whether it's a car engine or an operating system, anything with several thousand parts can develop the occasional technical hiccup. Mac OS X is far more resilient than its predecessors, but it's still a complex system with the potential for occasional glitches.

It's safe to say that you'll have to do less troubleshooting in Mac OS X than in Mac OS 9 or Windows, especially considering that most freaky little glitches go away if you just try these two steps, one at a time:

  • Quit and restart the wayward program.

  • Log out and log back in again.

It's theother problems that'll drive you batty.

B.1. Minor Eccentric Behavior

All kinds of glitches may befall you, occasionally, in Mac OS X. Your desktop picture doesn't change when you change it in System Preferences. A menulet doesn't open when you click it. A program won't open—it just bounces in the Dock a couple of times and then stops.

When a single program is acting up like this, but quitting and restarting it does no good, try the following steps, in the following sequence.

B.1.1. First Resort: Repair Permissions

An amazing number of mysterious glitches arise because thepermissions of either that item or something in your System folder—that is, the complex mesh of interconnected Unix permissions described in Chapter 12—have become muddled.

When something doesn't seem to be working right, therefore, open your Applications rightwards double arrow Utilities folder and open Disk Utility. Proceed as shown in Figure B-1.

This is a really, really great trick to know.

Tip: Many Mac mavens, in fact, believe in running this Repair Permissions routine after running any kind of installer, just to nip nascent problems in the bud. That includes both installers of new programs and of Apple's own Mac OS X updates.

Figure B-1. Click your hard drive's name in the left-side list; click the First Aid tab; click Repair Disk Permissions; and then read an article while the Mac checks out your disk. If the program finds anything amiss, you'll see messages like these. Among the text, you may recognize some Unix shorthand for read, write, and execute privileges (Chapter 17).

B.1.2. Second Resort: Look for an Update

If a program starts acting up immediately after you've installed or upgraded to Mac OS X 10.5, chances are good that it has some minor incompatibility. Chances are also good that you'll find an updated version on the company's Web site.

B.1.3. Third Resort: Toss the Prefs File

A corrupted preference file can bewilder the program that depends on it.

Before you go on a dumpfest, however, take this simple test. Log in using adifferent account(perhaps a dummy account that you create just for testing purposes). Run the problem program. Is the problem gone? If so, then the glitch exists only when you are logged in—which means it's a problem withyourcopy of the program's preferences.

Return to your own account. Open your Home foldera rightwards double arrow Library rightwards double arrow Preferences folder, where you'll find neatly labeled preference files for all of the programs you use. Each ends with the file name suffix .plist. For example, com.apple.finder. plist is the Finder's preference file, com.apple.dock.plist is the Dock's, and so on.

Put the suspect preference file into the Trash, but don't empty it. The next time you run the recalcitrant program, it will build itself a brand-new preference file that, if you're lucky, lacks whatever corruption was causing your problems.

If not, quit the program. You can reinstate its original .plist file from the Trash, if you'd find that helpful as you pursue your troubleshooting agenda.

Remember, however, that you actually havethreePreferences folders. In addition to your own Home folder's stash, there's a second one in the Library folder in the main hard drive window (which administrators are allowed to trash), and a third in the System rightwards double arrow Library folder in the main hard drive window (which nobody is allowed to trash—at least not without one of the security-bypass methods described in the box on the next page).

In any case, the next time you log in, the Mac creates fresh, virginal preference files.

B.1.4. Fourth Resort: Restart

Sometimes you can give Mac OS X or its programs a swift kick by restarting the Mac. It's an inconvenient step, but not nearly as time-consuming as what comes next. And it can fix problems that cropped up when you started up the computer.

B.1.5. Last Resort: Trash and Reinstall the Program

Sometimes reinstalling the problem program clears up whatever the glitch was.

First, however, throw away all traces of it. Open the Applications folder and drag the program's icon (or its folder) to the Trash. In most cases, the only remaining pieces to discard are its .plist file (or files) in your Home rightwards double arrow Library rightwards double arrow Preferences folder, and any scraps bearing the program's name in your Library rightwards double arrow Application Support folder. (You can do a quick Spotlight search to round up any other pieces.)

Then reinstall the program from its original disc or installer—after first checking the company's Web site to see if there's an updated version, of course.


frozen_programs_force_quitting.html

B.2. Frozen Programs (Force Quitting)

The occasional unresponsive application has become such a part of Mac OS X life that, among the Mac cognoscenti online, the dreaded, endless "please wait" cursor has been given its own acronym: SBOD (Spinning Beachball of Death). When the SBOD strikes, no amount of mouse clicking and keyboard pounding will get you out of the recalcitrant program.

Here are the different ways you can go aboutforce quittinga stuck program (the equivalent of pressing Control-Alt-Delete in Windows), in increasing order of desperation:

  • Use the Dock. If you can't use the program's regular File rightwards double arrow Quit command, try Control-clicking or right-clicking its Dock icon and choosing Quit from the popup menu.

  • Force quit the usual way. Choose [image] rightwards double arrow Force Quit to terminate the stuck program, or use one of the other force-quit methods described on Section 5.1.3.

  • Force quit the sneaky way. Some programs, including the Dock, don't show up at all in the usual Force Quit dialog box. Your next attempt, therefore, should be to open the Activity Monitor program (in Applications rightwards double arrow Utilities), which showseverything that's running. Double-click a program and then, in the resulting dialog box, click Quit to force quit it. (Unix hounds: You can also use the killcommand in Terminal, as described on Section 10.30.22.)

    WORKAROUND WORKSHOP
    Fixing Permissions Problems

    Sooner or later, when you try to move, rename, or delete a certain file or folder, you may get an error message like "The folder 'Junk' could not be opened because you do not have sufficient access privileges"—or "The operation could not be completed because this item is owned by Chris" (or by root, which means by Mac OS X itself).

    What they're trying to say is, you've run into a permissions problem.

    As noted in Chapter 12, Mac OS X is designed to accommodate a number of different people who share the same Mac over time. Nobody is allowed to meddle with other people's files or folders. But even if you're the solo operator of your Mac, you still share it with Mac OS X itself (which the error messages may refer to as root or system).

    In any case, if you're confident that whatever you're trying to do isn't some kind of nihilistic, self-destructive act like trashing the Applications folder, it's easy enough to get past these limitations. Just highlight the recalcitrant file or folder and then choose File rightwards double arrow Get Info. In its window, you'll find a Sharing & Permissions panel that lets you give yourself Read & Write privileges—if you have an Administrator account, that is. (Just don't perform this surgery on files in the System folder.)

    Now you can do whatever you like with this folder.

    Tip: If you find yourself having to quit the Dock more than once, here's an easier way: Make yourself a little AppleScript (Chapter 7) consisting of a single line: tell application "Dock" to quit. Save it as an application. Whenever you feel that the Dock (or Spaces or Exposé, which technically belong to the Dock) needs a good kick in the rear, double-click your little AppleScript.

  • Force quit remotely. If the Finder itself has locked up, you can't very well get to Activity Monitor (unless it occurred to you beforehand to stash its icon in your Dock—not a bad idea). At this point, you may have to abort the locked program from another computer across the network, if you're on one, by using theSSH (secure shell) command. The end of Chapter 22 offers a blow-by-blow description of how you might terminate a program by remote control in this way, either from elsewhere on the office network or even from across the Internet.

    Tip: If all of this seems like a lot to remember, you can always force restart the Mac. On most Macs, you do that by holding down the power button for five seconds. If that doesn't work, press Control- [image] -power button.


cant_move_or_rename_an_icon.html

B.3. Can't Move or Rename an Icon

If you're not allowed to drag an icon somewhere, the error message that appears almost always hits the nail on the head: You're trying to move a file or folder that isn't yours. The box on the facing page explains the solutions to this problem.


application_wont_open.html

B.4. Application Won't Open

If a program won't open (if its icon bounces merrily in the Dock for a few seconds, for instance, but then nothing happens), begin by trashing its preference file, as described on Section B.1.4. If that doesn't solve it, reinstalling the program usually does.

Figure B-2. A kernel panic is almost always related to some piece of add-on hardware. And look at the bright side: At least you get this handsome dialog box in Leopard. That's a lot better than the Mac OS X 10.0 and 10.1 effect—random text gibberish super-imposing itself on your screen.


startup_problems.html

B.5. Startup Problems

Not every problem you encounter is related to running applications. Sometimes trouble strikes before you even get that far. The following are examples.

B.5.1. Kernel Panic

When you see the cheerful, multilingual dialog box shown in Figure B-2, you've got yourself akernel panic—a Unix nervous breakdown.

(In such situations, user panic might be the more applicable term, but that's programmers for you.)

If you experience a kernel panic, it's almost always the result of a hardwareglitch— most often a bad memory (RAM) board, but possibly an accelerator card, graphics card, SCSI gadget, or USB hub that Mac OS X doesn't like. A poorly seated AirPort card can bring on a kernel panic, too, and so can a bad USB or FireWire cable.

If simply restarting the machine doesn't help, detach every shred of gear that didn't come from Apple. Restore these components to the Mac one at a time until you find out which one was causing Mac OS X's bad hair day. If you're able to pinpoint the culprit, seek its manufacturer (or its Web site) on a quest for updated drivers, or at least try to find out for sure whether the add-on is compatible with Mac OS X.

Tip: This advice goes for your Macintosh itself. Apple periodically updates the Mac's own"drivers" in the form of a firmware update. You download these updates from the Support area of Apple's Web site (if indeed Mac OS X's own Software Update mechanism doesn't alert you to their existence).

There's one other cause for kernel panics, by the way, and that's moving, renaming, or changing the access permissions for Mac OS X's essential system files and folders—the Applications or System folder, for example. (See Chapter 12 for more on permissions.) This cause isn't even worth mentioning, of course, because nobody would be that foolish.

B.5.2. Safe Mode (Safe Boot)

In times of troubleshooting, Mac OS 9 fans used to press the Shift key at startup to turn off the extensions. Windows fans press an F-key to start up in Safe Mode. Either way, the idea is the same: to turn off all nonessential system-software nubbins in an effort to get a sick machine at least powered up.

Although not one person in a hundred knows it, Mac OS X offers the same kind of emergency keystroke. It can come in handy when you've just installed some new piece of software and find that you can't even start up the machine, or when one of your fonts is corrupted, or when something you've designated as a Login Item turns out to be gumming up the works. With this trick, you can at least turn on the computer so that you can uninstall the cranky program.

The trick is topress the Shift key as the machine is starting up. Hold it down from the startup chime until you see the words "Safe Boot," in red lettering, on the login screen.

Welcome to Safe Mode.

What have you accomplished?

  • Checked your hard drive. The Shift-key business makes the startup process seem to take a very long time; behind that implacable Apple logo, Mac OS X is actually scanning your entire hard drive for problems. It's running the same disk check that's described on Section 21.5.2x.

  • Brought up the login screen. When you do a safe boot, you must click your name and enter your password, even if you normally have Automatic Login turned on.

  • Turned off your kernel extensions. All kinds of software nuggets load during the startup process. Some of them, you choose yourself: icons you add to the Login Items list in the System Preferences rightwards double arrow Accounts pane. Others are normally hidden: a large mass of kernel extensions, which are chunks of software that add various features to the basic operating system. (Apple's kernel extensions live in your System rightwards double arrow Library rightwards double arrow Extensions folder; others may be in your Library rightwards double arrow StartupItems folder.)

    If you're experiencing startup crashes, some non-Apple installer may have given you a kernel extension that doesn't care for Mac OS X 10.5—so in Safe Mode, they're all turned off.

  • Turned off your fonts. Corrupted fonts are a chronic source of trouble—and because you can't tell by looking, they're darned difficult to diagnose. So just to make sure you can at least get into your computer, Safe Mode turns them all off (except the authorized, Apple-sanctioned ones that it actually needs to run, which are in your System rightwards double arrow Library rightwards double arrow Fonts folder).

  • Trashed your font cache. The font cache is a speed trick. Mac OS X stores the visual information for each of your fonts on the hard drive, so that the system won't have to read in every single typeface off your hard drive when you open your Font menus or the Font panel.

    When these files get scrambled, startup crashes can result. That's why a Safe Boot moves all of these files into the Trash. (You'll even see them sitting there in the Trash after the startup process is complete, although there's not much you can do with them except walk around holding your nose and pointing.)

  • Turned off your login items. Safe Mode also prevents any Finder windows from opening and prevents your own hand-picked startup items from opening—that is, whatever you've asked Leopard to auto-open by adding them to the System Preferences rightwards double arrow Accounts rightwards double arrow Login Items list.

This, too, is a troubleshooting tactic. If some login item crashes your Mac every time it opens, you can squelch it just long enough to remove it from your Login Items list.

Tip: If you don't hold down the Shift key until you click the Log In button (after entering your name and password at the login screen), you squelch only your login items but not the fonts and extensions.

Once you reach the desktop, you'll find a long list of standard features inoperable. You can't use DVD Player, capture video in iMovie, use a wireless network, use certain microphones and speakers, or use your modem. (The next time you restart, all of this goodness will be restored, assuming you're no longer clutching the Shift key in a sweaty panic.)

In any case, the beauty of Safe Mode is that it lets you get your Mac going. You have access to your files, so at least the emergency of crashing-on-startup is over. And you can start picking through your fonts and login items to see if you can spot the problem.

B.5.3. Gray Screen During Startup

Confirm that your Mac has the latest firmware, as described earlier. Detach and test all your non-Apple add-ons. Finally, perform a disk check (see below).

B.5.4. Blue Screen During Startup

Most of the troubleshooting steps for this problem (which is usually accompanied by the Spinning Beachball of Death cursor) are the same as those described under "Kernel Panic" above.

B.5.5. Forgotten Password

If you or one of the other people who use your Mac have forgotten the corresponding account password, no worries: Just read the box on Section 12.6.


fixing_the_disk.html

B.6. Fixing the Disk

The beauty of Mac OS X's design is that the operating system itself is frozen in its perfect, pristine state, impervious to conflicting system extensions, clueless Mac users, and other sources of disaster.

That's the theory, anyway. But what happens if something goes wrong with the complex software that operates the hard drive itself?

Fortunately, Mac OS X comes with its own disk-repair program. In the familiar Mac universe of icons and menus, it takes the form of a program in Applications rightwards double arrow Utilities called Disk Utility. In the barren world of Terminal and the command line interface, there's a utility that works just as well but bears a different name:fsck(for file system check).

In any case, running Disk Utility or its alter egofsckis a powerful and useful troubleshooting tool that can cure all kinds of strange ills, including these problems, among others:

  • Your Mac freezes during startup, either before or after the Login screen.

  • The startup process interrupts itself with the appearance of the text-only command line.

  • You get the "applications showing up as folders" problem.

B.6.1. Method 1: Disk Utility

The easiest way to check your disk is to use the Disk Utility program. Use this method if your Mac can, indeed, start up. (See Method 2 if you can't even get that far.)

Disk Utility can't fix the disk it'son(except for permissions repairs, described at the beginning of this appendix).That's why you have to restart the computer from the Leopard installation disc (or another startup disk), and run Disk Utility from there. The process goes like this:

  1. Start up the Mac from the Leopard DVD.

    The best way to do that is to insert the disc and then restart the Mac while holding down the C key.

    You wind up, after some time, at the Mac OS X Installer screen. Don't be fooled— installing Mac OS X isnotwhat you want to do here. Don't click Continue!

  2. Choose Utilities rightwards double arrow Disk Utility.

    That's the unexpected step. After a moment, the Disk Utility screen appears.

    Tip: You could also skip steps 1 and 2 by starting up from an external hard drive, like an iPod onto which you've installed Mac OS X. Just run its own copy of Disk Utility to check yourMac'shard drive.

  3. Click the disk or disk partition you want to fix, click the First Aid tab, and then click Repair Disk.

    The Mac whirls into action, checking a list of very technical disk-formatting parameters.

    If you see the message, "The volume 'Macintosh HD' appears to be OK, "that's meant to begoodnews. Believe it or not, that cautious statement is as definitive an affirmation as Disk Utility is capable of making about the health of your disk.

    Disk Utility may also tell you that the disk is damaged, but that it can't help you. In that case, you need a more heavy-duty disk-repair program like Drive 10 (www.micromat.com) or DiskWarrior (www.alsoft.com).

B.6.2. Method 2: fsck at the Console

Disk Utility isn't of much use when you can't find the Leopard DVD, when your DVD driveisn't working, or when you're in a hurry to get past the startup problems that are plaguing your machine. In these cases, you'll be glad that you can boot into the Mac's raw Unix underlayer to perform some diagnostic (and healing) commands.

Specifically, you'll be glad that you can run the Unix programfsck, for which Disk Utility is little more than a pretty faceplate.

Like any Unix program,fsckruns at the command line. You launch it from the all-text, black Unix screen by typingfsckand pressing Enter. (As discussed in the box on the facing page, you can also usefsck -f.)

You can't, however, just runfsckin Terminal. You have to run it when the usual arsenal of graphic-interface programs—like the Finder and its invisible suite of accessory programs—isn't running.

B.6.2.1. Single-user mode( -S at startup)

The Terminal program is the best known form of Mac OS X's command line, but it's not the only one. In fact, there are several other ways to get there.

In general, you don't hear them mentioned except in the context of troubleshooting, because the Terminal program offers many more convenient features for doing the same thing. And because it's contained in a Mac OS X–style window, Terminal is not so disorienting as the three methods you're about to read.

POWER USERS' CLINIC
Journaling vs. fsck

Mac OS X 10.5 comes withjournalingturned on. As noted on Section A.6 journaling means that the Mac keeps a diary about every tiny bit of hard drive activity. In event of a crash or freeze, the Mac knows precisely what was going on at the time, and precisely which files might have been damaged.

In theory, then, you'll never need fsck at all. After all, there's nothing to check. The Mac's journaling software is always on top of things—and, if the journal indicates that there was trouble saving a file, Mac OS X can finish or undo the change.

Even Apple concedes, however, that in the real world, things can still go wrong, even with journaling turned on.

That's why, when you attempt to usefsckas described on these pages, a message will inform you that, hey, you don'tneedto repair your disk. Thanks to journaling, there's no damage to repair.

If you decide to proceed on the off chance that something's gone wrong behind your journal's back, just use the-fflag to force the disk check, like this: fsck -f.

Note, however, that you may see a series of phony error messages when you do this. If you see any of these messages, you should ignore them:

  • "Volume bitmap needs minor repair"

  • "Invalid volume free block count" or "block count changed from XX to YY"

  • "Volume header needs minor repair"

  • "Incorrect block count for file"

If you see anyothererror messages, though, let fsck go ahead and repair them.

All of these techniques take you into console mode, shown in Figure B-3. In console mode, Unix takes over your screen completely, showing white type against black, no windows or icons in sight. Abandon the mouse, all ye who enter here; in console mode, you can't do anything but type commands.

Figure B-3. In console mode, your entire screen is a command line interface. Unix jockeys can go to town here. Everyone else can timidly type fsck -y after the localhost:/ root # prompt—see this prompt on the very last line?—and hope for the best.

To get there in times of startup troubleshooting, press [image] -S while the Mac is starting up. (If you're stuck at the frozen remnants of a previous startup attempt, you may first have to force restart your Mac; see the tip on Section B.3.)

Instead of arriving at the usual desktop, you see technical-looking text scrolling up a black screen as the Mac runs its various startup routines. When it finally stops at the localhost # prompt, you're ready to type commands. You're now in what's called single-user mode, meaning that the Unix multiple-accounts software has yet to load. You won't be asked to log in.

FREQUENTLY ASKED QUESTION
Viruses? What Viruses?

One great thing about the old Mac OS was that there were hardly any viruses to worry about—all of the nasties seemed to be written for Windows. But now that we're using Unix, which has been around for 30 years and has a huge user base, is it time to worry again?

Nope. There are even fewer viruses for Unix than for the Mac OS.

You still need to be careful with Word and Excel macro viruses, of course. If you open a Word or Excel attachment sent by email from someone else, and a big fat dialog box warns you that it contains macros, simply click Disable Macros and get on with your life. And you still need an antivirus program for Windows if you run it on your Mac (Chapter 8).

Otherwise, you have little to worry about. After six years, there hasn't been one single Mac OS X virus outbreak—partly because virus writers have a smaller "audience" in Mac fans, and partly because Mac OS X is more difficult to hack.

Sleep well.

At the localhost # prompt, type fsck -y (note the space before the hyphen) and press Enter. (The y means "yes," as in "yes, I want you to fix any problems automatically.") If the Mac refuses because journaling is turned on (Section A.6), you can also typefsck -fy to force the disk check.

Tip: You've probably gone to this trouble for the sake of running fsck, the Unix disk-checking program. But you can also use ls, cd, rm, or any of the other Unix commands described in Chapter 16.

Now the file system check program takes over, running through five sets of tests. When it's complete, you'll see one of two messages:

  • The volume Macintosh HD appears to be OK. All is well. Type exit and press Return to proceed to the usual Login screen and desktop.

  • File system was modified. A good sign, but just a beginning. You need to run the program again. Onefsck pass often repairs only one layer of problems, leaving another to be patched in the next pass. Type fsck -ya second time, a third time, and so on, until you finally arrive at a "disk appears to be OK" message.

    Typeexit at the prompt and press Return to get back to the familiar world of icons and windows.

TROUBLESHOOTING MOMENT
The Reinstall

When some component is missing, your troubleshooting steps have failed, and Mac OS X continues to act up, consider reinstalling Mac OS X.

That's not a big deal at all. It involves inserting the Leopard DVD, restarting the Mac, pressing the C key as the computer starts up, and proceeding with the installer as described in Appendix A.

The good news is that the standard Mac OS X installation (as opposed to the radical "Erase and Install" option) doesn't touch your files, folders, or settings. It simply patches what-ever holes have opened up in the Unix undercarriage of your operating system—which, every now and then, does you a world of good.

And what if you've updated your DVD's copy of Leopard with little updates—Mac OS X 10.5.1, 10.5.2, and so on?

In that case, you'll have to do a clean install (that is, an "Archive & Install" as described in Appendix A). It gives you a brand-new Mac OS X System folder, neatly retiring the previous one (and, in fact, renaming it Previous System Folder).

Yes, your new, virginal System folder isn't the latest version of Mac OS X. But that's OK—Software Update will offer you all of the updaters since your Mac OS X DVD was pressed. (If you were smart enough to save these updaters as described on Section 9.22, you won't even have to download them from the Web again.)

In no time (all right, in 35 minutes), you'll be right back where you were, this time without the glitches.


where_to_get_troubleshooting_help.html

B.7. Where to Get Troubleshooting Help

If the basic steps described in this chapter haven't helped, the universe is crawling with additional help sources.

In general, this is the part in any Mac book where you're directed to Apple's help Web site, to various discussion forums, and so on—and, indeed, those help sources are listed below.

But the truth is, the mother of all troubleshooting resources is not any of those—it's Google. You'll find more answers faster using Google than you ever will by starting at any of the individual help sites below. That's because Google includes all of those help sites in its search!

Suppose, for example, that you've just installed the 10.5.1 software update for Leopard, and it's mysteriously turned all your accounts (including your own) into Standard accounts. And without any Administrator account, you can't install new programs, change network settings, add or edit other accounts, and so on.

You could go to one Web site after another, hunting for a fix, repeating your search— or you could just type Leopard 10.5.1 standard accounts into Google and hit Enter. See Figure B-4.

Figure B-4. Don't waste your time. Start any troubleshooting search at Google. Leave out small words like "it," "the," "of," and so on; Google ignores them.
Bottom: Presto: Google's very first results link contains the answer.

B.7.1. Help Online

These Web sites contain nothing but troubleshooting discussions, tools, and help:

  • Apple Discussion Groups (http://discussions.info.apple.com). The volume and quality of question-and-answer activity here dwarfs any other free source. If you're polite and concise, you can post questions to the multitudes here and get more replies to them than you'll know what to do with.

  • Apple's help site (www.apple.com/support). Apple's help Web site includes downloadable manuals, software updates, frequently asked questions, and many other resources.

    It also has a Search box, which may look mild-mannered but is actually the mother of all troubleshooting resources: the Knowledge Base. This is the collection of 50,000 individual technical articles, organized in a searchable database, that the Apple technicians themselves consult when you call for help. You can search it either by typing in keywords or by using pop-up menus of question categories.

  • MacFixIt (www.macfixit.com). The world's one-stop resource for Mac troubleshooting advice; alas, you have to pay to access the good stuff.

B.7.2. Help by Telephone

Finally, consider contacting whoever sold you the component that's making your life miserable: the printer company, scanner company, software company, or whatever.

If it's a Mac OS problem, you can call Apple at 800-275-2273 (that's 800-APL-CARE). For the first 90 days following your purchase of Mac OS X (which, as far as Apple knows, is the date of your first call), the technicians will answer your questions for free.

After that, unless you've paid for AppleCare for your Mac (a three-year extended warranty program), Apple will charge you to answer your questions. Fortunately, if the problem turns out to be Apple's fault, they won't charge you.


the_windows-to-mac_dictionary.html

C. The Windows-to-Mac Dictionary

Maybe you were persuaded by the Apple "Switch" ad campaign. Maybe you like the looks of today's Macs. Or maybe you've just had one virus, spyware download, or service pack too many. In any case, if you're switching to Mac OS X from Windows, this appendix is for you. It's an alphabetical listing of every common Windows function and where to find it in Mac OS X. After all, an operating system is an operating system. The actual functions are pretty much the same—they're just in different places.

Tip: If this listing only whets your appetite for information about making the switch, read Switching to the Mac: The Missing Manual, Leopard Edition. In addition to an expanded version of this appendix, it also contains useful information on moving your files from the PC to the Mac, copying over your email, transferring your contacts to Address Book, and so on.

C.1. About [This Program]

To find out the version number of the program you're using, don't look in the Help menu. Instead, look in the application menu next to the [image] menu—the one that bears the name of the program you're in. That's where you find the About command for Macintosh programs.


about_this_program.html

C. The Windows-to-Mac Dictionary

Maybe you were persuaded by the Apple "Switch" ad campaign. Maybe you like the looks of today's Macs. Or maybe you've just had one virus, spyware download, or service pack too many. In any case, if you're switching to Mac OS X from Windows, this appendix is for you. It's an alphabetical listing of every common Windows function and where to find it in Mac OS X. After all, an operating system is an operating system. The actual functions are pretty much the same—they're just in different places.

Tip: If this listing only whets your appetite for information about making the switch, read Switching to the Mac: The Missing Manual, Leopard Edition. In addition to an expanded version of this appendix, it also contains useful information on moving your files from the PC to the Mac, copying over your email, transferring your contacts to Address Book, and so on.

C.1. About [This Program]

To find out the version number of the program you're using, don't look in the Help menu. Instead, look in the application menu next to the [image] menu—the one that bears the name of the program you're in. That's where you find the About command for Macintosh programs.


accessibility_options_control_panel.html

C.2. Accessibility Options control panel

The special features that let you operate the computer even with impaired vision, hearing, or motor control are called Universal Access in Mac OS X. They're in System Preferences (see Section 4.5.1).


active_desktop.html

C.3. Active Desktop

The Mac never displays Web pages directly on the desktop—and knowing Apple, that's probably a point of pride. But Dashboard (Chapter 5) keeps Internet data only a keystroke away.


add_hardware_control_panel.html

C.4. Add Hardware control panel

The Mac requires no program for installing the driver for a new external gadget. The drivers for most printers, mice, keyboards, cameras, camcorders, and other accessories are preinstalled. If you plug something into the Mac and find that it doesn't work immediately, just install the driver from the included CD (or the manufacturer's Web site).


add_or_remove_programs_control_panel.html

C.5. Add or Remove Programs control panel

Here's another one you just don't need on the Macintosh. Installing a program onto the Mac is described on Section 5.12. Removing a program simply involves dragging its icon to the Trash. (For a clean sweep, inspect your Home rightwards double arrow Library rightwards double arrow Preferences and Library rightwards double arrow Application Support folders to see if any preference files got left behind.)


all_programs.html

C.6. All Programs

There's no Programs menu built into Mac OS X, like the one on the Windows Start menu. If you'd like one, drag your Applications folder into the end of the Dock. Now its icon is a tidy pop-up menu of every program on your machine.


alt_key.html

C.7. Alt key

On the Mac, it's the Option key, although the key usually says "Alt" on it too. (In some countries, it says only Alt.) You can substitute Option for Alt in any keystroke in most popular programs. The Option key has a number of secondary features on the Mac, too: It hides the windows of one program when you click into another, and so on.


automatic_update.html

C.8. Automatic Update

The [image] rightwards double arrow Software Update command does exactly the same thing.


backspace_key.html

C.9. Backspace key

It's in the same place on the Macintosh keyboard, but it's called the Delete key.


battery_level.html

C.10. Battery Level

The battery-level graph ( [image] ) for your Mac laptop now appears in the menu bar, rather than in the system tray. (If you don't see it, open System Preferences rightwards double arrow Energy Saver and turn it on.)


bios.html

C.11. BIOS

You'll never have to update or even think about the ROM of your Macintosh (the approximate equivalent of the BIOS on the PC). It's permanent and unchanging. The very similar firmware of your Macintosh does occasionally have to be updated in order to work with a new version of the Mac operating system or some dramatic new feature—once every four years, perhaps. You'll be notified on the screen when the time comes.


briefcase.html

C.12. Briefcase

Mac OS X doesn't have anything like the Briefcase, a Windows invention designed to help you keep your files in sync between a laptop and a desktop computer. On the other hand, if you sign up for a .Mac account (Chapter 18), you get a program called Backup that is similarly designed to keep folders synchronized between two machines. And you can use iSync (Chapter 6) to keep your calendar, addresses, and other items synched between multiple computers.


calculator-id002.html

C.13. Calculator

The calculator program in Mac OS X is almost identical to the one in Windows, except that it can also perform conversions (temperature, distance, currency, and so on) and features an editable "paper tape." It sits in your Applications folder and is described in Chapter 10. (There's a simpler Calculator in Dashboard, too; see the end of Chapter 5. And don't forget that you can type quick math equations into the Â Spotlight menu.)


camera_and_scanner_wizard.html

C.14. Camera and Scanner Wizard

When you connect a digital camera or scanner to your Mac, iPhoto or Image Capture opens automatically and prepares to download the pictures automatically. Details in Chapter 10.


cds.html

C.15. CDs

To open the CD/DVD drawer, or, if you have a slot-loading drive, to spit out the disc that's in it, hold down the [image] key on your Mac keyboard. If it's an older Mac keyboard without a [image] key, you can eject a CD (or any other disk) by Control-clicking (or rightclicking) its desktop icon and then choosing Eject from the shortcut menu. There are various other ways to eject a disk, but the point is that you never do so by pushing the Eject button on the disk drive itself.


character_map.html

C.16. Character Map

This Windows program helps you find out what keys you need to press to trigger trademark symbols, copyright symbols, and other special characters. The equivalent on the Mac is called the Keyboard Viewer (page334) —but the Character Palette (Section 9.13.2) is even easier to use.


clean_install.html

C.17. Clean Install

The Mac OS X 10.5 installer can give you a fresh, virginal copy of the operating system, just as the Windows installer can. Instructions are in Appendix A.


clipboard.html

C.18. Clipboard

The Mac's clipboard works much like the one in Windows. In the Finder, you can choose Edit rightwards double arrow Show Clipboard to see whatever you most recently copied or cut.


command_line.html

C.19. Command line

In Mac OS X, the command line is alive and well—but it speaks Unix, not DOS. You get to it by opening Terminal, which is described in Chapter 16.


control_panel.html

C.20. Control Panel

The Control Panel in Mac OS X is called System Preferences, and you open it from your [image] menu. As in Windows XP or Vista, you can view these icons either by category or in a simple alphabetical list: Just choose either Organize by Categories or Organize Alphabetically from the View menu.


copy_cut_paste.html

C.21. Copy, Cut, Paste

When you're editing in a word processor or graphics program, the Mac OS X Cut, Copy, and Paste commands work exactly as they do in Windows.

At the desktop, however, there are a few differences. You can indeed copy icons and paste them into a new window using the Copy and Paste commands—but you just can't cut them out of a window, as you can in Windows. On the other hand, Mac OS X offers a handy secondary feature: If you paste into a word or text processor instead of into another desktop window, you get a list of the names of the icons you copied.


ctrl_key.html

C.22. Ctrl key

On the Macintosh, you generally substitute the [image] key in keystrokes that would involve the Control key in Windows. In other words, the Save command is now [image] -S instead of Ctrl-S, Open is [image] -O instead of Ctrl-O, and so on.


date_and_time.html

C.23. Date and Time

To set your Mac's calendar and clock, open Date & Time in System Preferences.


delete_key_forward_delete.html

C.24. Delete Key (Forward Delete)

Most desktop Mac keyboards have a forward-delete key (labeled Del) exactly like the ones on PCs. On Mac laptops, and on Apple's aluminum keyboards, you trigger the forward-delete function by pressing the Delete key while simultaneously pressing the Fn key.


desktop-id001.html

C.25. Desktop

The Macintosh desktop is pretty much the same idea as the Windows desktop, with a few key differences:

  • Disk icons show up on the Mac desktop as soon as they are inserted or connected. You don't have to open a window to see their icons.

  • You change the desktop picture using the Desktop & Screen Saver panel of System Preferences.

  • The Trash is an icon in the Dock, not on the desktop.


directories.html

C.26. Directories

Most people call them folders on the Mac.


disk_defragmenter.html

C.27. Disk Defragmenter

There's no such utility included with Mac OS X; the system auto-defragments in the background.(A defragmenting program moves around the pieces of files on your hard drive in an effort to optimize their placement and speed of opening.)


disks.html

C.28. Disks

Working with disks is very different on the Mac. Every disk inside, or attached to, a Macintosh is represented on the screen by an icon. Mac OS X does have something like the My Computer window (choose Go rightwards double arrow Computer), but both the icons on the desktop and the icons in the Computer window reflect only the disks currently inserted in your Mac. You'll never see an icon for an empty drive, as you do on Windows, and there's no such thing as drive letters (because the Mac refers to disks, not to drives— and refers to them by name).


display_control_panel.html

C.29. Display control panel

The functions of the Windows Display Control Panel lurk in the Mac OS X System Preferences program—just not all in one place. You set up your desktop picture and screen saver using the Desktop & Screen Saver pane, and adjust your monitor settings using the Displays pane. (Mac OS X offers no equivalent to the Appearance tab in Windows, for changing the system-wide look of your computer.)


dll_files.html

C.30. DLL files

The Macintosh equivalent of DLL files—shared libraries of programming code—are invisible and off-limits. As a result, no Macintosh user ever experiences DLL conflicts or out-of-date DLL files.


dos_prompt.html

C.31. DOS prompt

There's a command line in Mac OS X, but it's Unix, not DOS. For details, see Chapter 16.


drivers.html

C.32. Drivers

See "Add or Remove Programs."


end_task_dialog_box.html

C.33. End Task dialog box

If some Macintosh program is hung or frozen, you escape it pretty much the same way you would in Windows: by forcing it to quit. To bring up the Force Quit dialog box, you press Option- [image] -Esc or choose [image] rightwards double arrow Force Quit.


exiting_programs.html

C.34. Exiting programs

You can quit a program either by choosing Quit from the menu bearing its name (next to the [image] menu), or by right-clicking (or Control-clicking) its Dock icon and then choosing Quit from the pop-up menu.


explorer.html

C.35. Explorer

The Mac has its own "tree" view of the files and folders on your hard drive: list view. By expanding the "flippy triangles" of your folders, you build a hierarchy that shows you as much or as little detail as you like.

If you prefer the Explorer effect of clicking a folder in one pane to see its contents in the next, try Column view instead. Both views are described in Chapter 1.


favorites.html

C.36. Favorites

In Mac OS X, there isn't one single Favorites menu that lists both favorite Web sites and favorite icons. The Bookmarks menu of Safari, the Web browser, lists only Web sites, and the Favorites folder at the desktop (Section 2.4.7) lists only favorite files, folders, disks, and other icons.


faxing-id001.html

C.37. Faxing

Faxing is built into Leopard; it's described in Chapter 14. (Hint: Choose File rightwards double arrow Print; from the PDF button at the bottom of the Print dialog box, choose Fax PDF.)


file_sharing-id001.html

C.38. File Sharing

See Chapter 13 for an in-depth look at the Macintosh networking and file-sharing system.


floppy_disks.html

C.39. Floppy disks

Floppy drives on Macs disappeared in about 1998. According to Apple, it's much more efficient to transfer files between machines using an Ethernet cable (Chapter 13), a CD or DVD that you burned (Chapter 11), your Internet-based iDisk (Chapter 18), or email (Chapter 19).


folder_options.html

C.40. Folder Options

The Folder Options control panel in Windows is a collection of unrelated settings that boil down to this:

  • General tab. Exactly as in Windows, it's up to you whether or not double-clicking a folder opens up a second window—or just changes what's in the first one. On the Mac, you make these changes using the Finder rightwards double arrow Preferences command. There you'll find the option called "Always open folders in a new window."

  • View tab. Most of the options here don't exist on the Mac. For example, system files are always hidden on the Mac; you can't opt to make them visible (at least not with the built-in controls). You can, however, choose whether you want to see the filename extensions in your desktop windows (like .doc and .html). Choose Finder rightwards double arrow Preferences rightwards double arrow Advanced, and turn "Show all file extensions" on or off.

  • File Types tab. Just as in Windows, you can reassign certain document types so that double-clicking opens them up in the program of your choice. But on the Mac, you can reassign either a whole class of files at once, as in Windows, or one file at a time. To do it, you use the Get Info window as described on Section 5.6.1.1.

  • Offline Files. There's no equivalent feature on the Mac.


fonts.html

C.41. Fonts

The Mac and Windows both use TrueType, PostScript, and Open Type fonts. (In fact, your Mac can even use the exact font files you had in Windows.) On the Mac, however, there are actually three different folders that can contain them. A complete discussion is in Chapter 14.


help_and_support.html

C.42. Help and Support

At the desktop, choose Help rightwards double arrow Mac Help. In other programs, the Help command is generally at the right end of your menus, exactly as on Windows.


hibernation.html

C.43. Hibernation

The Mac can't hibernate at all, as modern PCs do, cutting all power but remembering what programs and documents you had open for a faster restart later. Sleep mode is the closest it gets; see "Standby Mode".


internet_explorer.html

C.44. Internet Explorer

Microsoft has abandoned the Mac version of Internet Explorer. Apple would prefer, of course, that you try Safari, its own Web browser, but many a power user prefers Firefox, which is nearly identical to the Windows version.


internet_options.html

C.45. Internet Options

On the Mac, you find the options for your Web browser by choosing Safari rightwards double arrow Preferences.


irqs.html

C.46. IRQs

They don't exist on the Mac.


java-id001.html

C.47. Java

This interpreter of tiny Web-page programs is alive and well in Mac OS X. Java programs run fine in all Mac Web browsers.


keyboard_control_panel.html

C.48. Keyboard control panel

You can make exactly the same kinds of settings—and more—on the Keyboard & Mouse pane of System preferences.


logging_in-id001.html

C.49. Logging in

The multiple-accounts feature of Mac OS X is extremely similar to that of Windows 2000, Windows XP, and Windows Vista. In each case, you can, if you wish, create a requirement to log in with a name and password before using the computer. This arrangement keeps separate the documents, email, and settings of each person who uses the computer. (Chapter 12 tells all.)


mail_control_panel.html

C.50. Mail control panel

Mac OS X comes with its own email program (described in Chapter 19); all of its settings are contained within the program.


maximize_button.html

C.51. Maximize button

On the Mac, clicking the Zoom button (the green button at the upper-left corner of a window) does something like the Maximize button in Windows: It makes your window larger. On the Mac, however, clicking the zoom button never makes the window expand to fill the entire screen. Instead, the window grows—or shrinks—precisely enough to enclose its contents.


menus.html

C.52. Menus

On the Macintosh, there's only one menu bar, always at the very top of the screen. The menus change depending on the program and the window you're using, but the point is that the menu bar is no longer inside each window you open.

Tip: Just because you don't see the little underlines in the menus doesn't mean you can't operate all of the menus from the keyboard, as in Windows. See Section 5.6.1.3 for details.


minimize_button-id001.html

C.53. Minimize button

You can minimize a Mac OS X window to the Dock, just the way you would minimize a Windows window to the taskbar. You do so by double-clicking its title bar, pressing [image] -M, choosing Window rightwards double arrow Minimize Window, or clicking the yellow Minimize button at the top left of a window. (Restore the window by clicking its icon in the Dock.)


mouse_control_panel.html

C.54. Mouse control panel

The equivalent settings can be found in the Keyboard & Mouse panel of System Preferences.


my_computer.html

C.55. My Computer

The Mac's Computer window is very similar (choose Go rightwards double arrow Computer), in that it shows the icons of all disks (hard drive, CD, and so on). On the other hand, it shows only the disks that are actually inserted or connected. (See "Disks.")


my_documents_my_pictures_my_music.html

C.56. My Documents, My Pictures, My Music

The equivalent buckets for your everyday documents, music files, and pictures are the Documents, Pictures, and Music folders in your Home folder.


my_network_places.html

C.57. My Network Places

On the Mac, the "network neighborhood" is almost always on the screen: It's the Sidebar, the panel at the left side of every Finder window. All of the Macs and PCs on your network are always listed here, in the Shared category (unless you turned this feature off in Finder rightwards double arrow Preferences, of course).


network_neighborhood.html

C.58. Network Neighborhood

See the previous entry.


notepad.html

C.59. Notepad

There's no Mac OS X Notepad program. But give Stickies a try (Section 5.13.3.14), or use the system-wide Notes feature (Section 19.8).


personal_web_server.html

C.60. Personal Web Server

To find out how to turn your Mac into a state-of-the-art Web server, see Chapter 22.


phone_and_modem_options_control_panel.html

C.61. Phone and Modem Options control panel

To find the modem settings for your Mac, see Section 18.4.


power_options.html

C.62. Power Options

To control when your Mac goes to sleep and (if it's a laptop) how much power it uses, use the Energy Saver pane of System Preferences (Section 4.5.1).


printer_sharing-id001.html

C.63. Printer Sharing

To share a USB inkjet printer with other Macs on the network, open the Sharing pane of System Preferences on the Mac with the printer. Turn on Printer Sharing.

To use the shared printer from across the network, open the document you want to print, choose File rightwards double arrow Print, and choose the name of the shared printer from the first pop-up menu.


printers_and_faxes.html

C.64. Printers and Faxes

For a list of your printers, open the Print & Fax pane of System Preferences (Chapter 14). For details on faxing, see "Faxing."


prntscrn_key.html

C.65. PrntScrn key

You capture pictures of your Mac screen by pressing Shift- [image] -3 (for a full-screen grab) or Shift- [image] -4 (to grab a selected portion of the screen). There are many options available; see the end of Chapter 14.


program_files_folder.html

C.66. Program Files folder

The Applications folder (Go rightwards double arrow Applications) is like the Program Files folder in Windows—except that you're not discouraged from opening it and double-clicking things. On the Macintosh, every program bears its true name; Microsoft Word, for example, is called Microsoft Word, not WINWORD.EXE.


properties_dialog_box.html

C.67. Properties dialog box

You can call up something very similar for any icon (file, folder, program, disk, printer) by highlighting its icon and then choosing File rightwards double arrow Get Info. But objects in Macintosh programs generally don't contain Properties dialog boxes.


recycle_bin.html

C.68. Recycle Bin

Mac OS X has a Trash icon at the end of the Dock. In general, it works exactly like the Windows Recycle Bin—and why not, since the Macintosh Trash was Microsoft's inspiration?—but there are a couple of differences. The Macintosh never automatically empties it, for example. That job is up to you; the simplest way is to Control-click it, or right-click it, and choose Empty Trash from the shortcut menu.

The Mac never bothers you with an "Are you sure?" message when you throw something into the Trash, either. The Mac interrupts you for permission only when you choose File rightwards double arrow Empty Trash. And you can even turn that confirmation off, if you like (in Finder rightwards double arrow Preferences).

To put icons into the Trash, drag them there, or highlight them and then press [image] -Delete.


regional_and_language_options_control_pa.html

C.69. Regional and Language Options control panel

The close equivalent is the International panel of System Preferences.


registry.html

C.70. Registry

There is no registry. Let the celebration begin!


run_command.html

C.71. Run command

The Mac's command line is Terminal (Chapter 16).


safe_mode.html

C.72. Safe Mode

You can press the Shift key during startup to suppress the loading of certain software libraries, but Mac OS X's "safe mode" isn't quite as massively stripped-down as Windows's Safe Mode.


scandisk.html

C.73. ScanDisk

Just like Windows, the Mac automatically scans and, if necessary, repairs its hard drive every time your machine starts up. To run such a check on command, open Disk Utility (located in the Applications rightwards double arrow Utilities folder), click the name of your hard drive, and then click the First Aid tab.


scheduled_tasks.html

C.74. Scheduled Tasks

To schedule a task to take place unattended, use the launchd Unix command in Terminal (Section 16.8.5.4), or one of the scheduling programs listed at www.versiontracker.com.


scrap_files.html

C.75. Scrap files

On the Mac, they're called clipping files, and they're even more widely compatible. You create them the same way: Drag some highlighted text, or a graphic, out of a program's window and onto the desktop. There it becomes an independent clipping file that you can drag back in—to the same window, or a different one.


screen_saver-id001.html

C.76. Screen saver

The Mac's screen savers are impressive. Open System Preferences and click the Desktop & Screen Saver icon.


search.html

C.77. Search

In Mac OS X, you have the ultimate file-searching tool: Spotlight (Chapter 3). Get psyched!

To find Web sites, use the Google Search box at the top of the Safari browser.


shortcut_menus.html

C.78. Shortcut menus

They work exactly the same as they do in Windows. You produce a shortcut menu by Control-clicking things like icons, list items, and so on. (If you have a two-button mouse, feel free to right-click instead of using the Control key.)


shortcuts.html

C.79. Shortcuts

On the Mac, they're known as aliases. See Section 2.4.6.


sounds_and_audio_devices.html

C.80. Sounds and Audio Devices

Open System Preferences; click the Sound icon. You may also want to explore the Audio MIDI Setup program in Applications rightwards double arrow Utilities.


speech_control_panel.html

C.81. Speech control panel

The Mac's center for speech recognition and text-to-speech is the Speech panel of System Preferences. As Chapter 15 makes clear, the Mac can read aloud any text in any program, and it lets you operate all menus, buttons, and dialog boxes by voice alone.


standby_mode.html

C.82. Standby mode

On the Mac, it's called Sleep, but it's the same idea. You make a Mac laptop sleep by closing the lid. You make a Mac desktop sleep by choosing [image] rightwards double arrow Sleep, or just walking away; the Mac goes to sleep on its own, according to the settings in the Energy Saver pane of System Preferences.


start_menu.html

C.83. Start menu

There's no Start menu in Mac OS X. Instead, you stash the icons of the programs, documents, and folders you use frequently onto the Dock at the edge of the screen, or into the Places section of the Sidebar at the left edge of every Finder window.

Exactly as with the Start menu, you can rearrange the seicons (drag them horizontally) or remove the ones you don't use often (drag them away from the Dock and then release). To add new icons of your own, just drag them into place (applications go to the left of the Dock's divider line, documents and folders to the right).


startup_folder.html

C.84. StartUp folder

To make programs launch automatically at startup, include them in the list of Login Items in the System Preferences rightwards double arrow Accounts pane.


system_control_panel.html

C.85. System control panel

The Mac has no central equivalent of the System window on a Windows PC. But its functions have analogs here:

  • General tab. To find out your Mac OS X version number and the amount of memory on your Mac, choose [image] rightwards double arrow About This Mac.

  • Computer Name tab. Open System Preferences, click Sharing, and edit your computer's network name here.

  • Hardware tab. The closest thing the Mac has to the Device Manager is System Profiler (in your Applications rightwards double arrow Utilities folder).

  • Advanced tab. In Mac OS X, you can't easily adjust your virtual memory, processor scheduling, or user profile information.

  • System Restore tab. Mac OS X's Time Machine feature is like System Restore on steroids; see Chapter 6.

  • Automatic Updates tab. Choose [image] rightwards double arrow Software Updates.

  • Remote tab. Mac OS X Leopard offers remote control in the form of Screen Sharing, described in Chapter 13.


system_tray.html

C.86. System Tray

The Mac OS X equivalent of the system tray (also called the notification area) is the row of menulets at the upper-right corner of your screen; see Section 4.5.3.


taskbar.html

C.87. Taskbar

Mac OS X doesn't have a taskbar, but it does have something very close: the Dock (Chapter 4). Open programs are indicated by a small, shiny dot beneath their icons in the Dock. If you hold down your cursor on one of these icons (or Control-click it, or right-click it), you get a pop-up list of the open windows in that program, exactly as in Windows XP and Vista.

On the other hand, some conventions never die. Much as in Windows, you cycle through the various open Mac programs by holding down the [image] key and pressing Tab repeatedly.


taskbar_and_start_menu_control_panel.html

C.88. Taskbar and Start Menu control panel

To configure your Dock (the equivalent of the Taskbar and Start menu), choose [image] rightwards double arrow Dock rightwards double arrow Dock Preferences, or click the Dock icon in System Preferences.


three-fingered_salute.html

C.89. "Three-fingered salute"

Instead of pressing Ctrl-Alt-Delete to jettison a stuck program on the Mac, you press Option- [image] -Esc. A Force Quit dialog box appears. Click the program you want to toss, click Force Quit, confirm your choice, and then relaunch the program to get on with your day.


tooltips.html

C.90. ToolTips

Small, yellow identifying balloons pop up on the Mac almost as often as they do in Windows. Just point to a toolbar icon or truncated file name without clicking. (There's no way to turn these labels off.)


tweakui.html

C.91. TweakUI

The closest equivalent for this free, downloadable, but unsupported Microsoft utility for tweaking the look of your PC is TinkerTool for Mac OS X. It's described in Chapter 17.


user_accounts_control_panel.html

C.92. User Accounts control panel

Like Windows 2000, Windows XP, and Windows Vista, Mac OS X was designed from Square One to be a multiuser operating system, keeping each person's files, mail, and settings separate. You set up and manage these accounts in System Preferences rightwards double arrow Accounts (Chapter 12).


window_edges.html

C.93. Window edges

You can enlarge or shrink a Mac OS X window only by dragging its lower-right corner—not its edges.


windows_or_winnt_folder.html

C.94. Windows (or WINNT) folder

Mac OS X's operating system resides in a folder simply called System, which sits in your main hard drive window. Exactly as in recent Windows versions, you're forbidden to add, remove, or change anything inside. Also as in Windows, most of it is invisible anyway.


windows_logo_key.html

C.95. Windows logo key

The Mac has no equivalent for the [image] key on most PC keyboards.


windows_media_player.html

C.96. Windows Media Player

The Mac comes with individual programs for playing multimedia files:

  • QuickTime Player (Chapter 15) to play back movies and sounds.

  • iTunes (Chapter 11) to play CDs, Internet radio, MP3 files, and other audio files. (As a bonus, unlike Windows XP, iTunes can even create MP3 files.)

  • DVD Player (Chapter 11) for playing DVDs. This program is in the Applications folder.

Windows Media Player is, however, available in a Macintosh version, paradoxical though that may sound. You can download it from www.microsoft.com/mac.


windows_messenger.html

C.97. Windows Messenger

Mac OS X's instant-messaging, audio- and videoconferencing software is called iChat, and it's described in Section 7.5.1.8.


wordpad.html

C.98. WordPad

The TextEdit program (in the Applications folder) is a word processor along the lines of WordPad. It can even open and save Word files, as WordPad can.


zip_files.html

C.99. Zip files

Zip files exist on the Mac, too, and you create them almost the same way: Controlclick (or right-click) a file or folder and choose Compress from the shortcut menu. See Section 5.12 for a discussion of software compression standards on the Mac.


where_to_go_from_here.html

D. Where to Go From Here

If read in a comfortable chair with good lighting, this book can be the foundation of a sturdy Mac OS X education. But particularly when it comes to mastering the Unix side of this operating system, years of study may await you still.

D.1. Web Sites

The Web is the salvation of the Mac OS X fan, especially considering the information vacuum that marked Mac OS X's early days. The Internet was the only place where people could find out what the heck was going on with their beloved Macs. Here are the most notable Web sites for learning the finer points of Mac OS X.

D.1.1. Mac OS X

  • www.macosxhints.com. A gold mine of tips, tricks, and hints.

  • www.macintouch.com. An excellent daily dose of reporting about Mac questions, problems, and news.

  • www.osxfaq.com. Unix tips and techniques, frequently asked questions, and links to useful sites.

  • www.resexcellence.com. A rich source of information on the underpinnings of Mac OS X, with a focus on changing them.

  • www.versiontracker.com and www.macupdate.com. Massive databases that track, and provide links to, all the latest software for Mac OS X.

  • www.apple.com/developer. Even if you aren't a developer, joining the Developer Connection (Apple's programmers' club) gets you an email newsletter and access to the discussion boards, which are a great place for hearing Mac news first—all for free. (Pay $500 a year to become a Select member, and you get CDs mailed to you containing upcoming versions of Mac OS X.)

  • www.macobserver.com. A good source for news and commentary about the Mac and related products.

  • www.macworld.com. The discussion boards are an ideal place to find solutions for problems. When a bug pops up, the posts here are a great place to look for fixes.

  • www.macfixit.com. The ultimate Mac troubleshooting Web site, complete with a hotbed of Mac OS X discussion.

  • www.macdevcenter.com. O'Reilly's own Mac site. Full of tutorials, news, and interesting weblogs (techie diaries).

  • www.geekculture.com. A hilarious satire site, dedicated to lampooning our tech addiction—especially Apple tech. Perhaps best known for the David Pogue's Head icon for Mac OS X (http://geekculture.com/download/davidpogue.html).

    Or perhaps not.

D.1.2. Mac OS X–Style Unix Lessons and Reference

  • www.westwind.com/reference/OS-X/commandline. A command reference of cd, ls, rm, and all the other commands you can use in Terminal or the console.

  • www.ee.surrey.ac.uk/Teaching/Unix. A convenient, free Web-based course in Unix for beginners.

Tip: Typing unix for beginners into a search page like Google.com nets dozens of superb help, tutorial, and reference Web sites. If possible, stick to those that feature the bash shell; that way, everything you learn online should be perfectly applicable to navigating Mac OS X via Terminal.


web_sites.html

D. Where to Go From Here

If read in a comfortable chair with good lighting, this book can be the foundation of a sturdy Mac OS X education. But particularly when it comes to mastering the Unix side of this operating system, years of study may await you still.

D.1. Web Sites

The Web is the salvation of the Mac OS X fan, especially considering the information vacuum that marked Mac OS X's early days. The Internet was the only place where people could find out what the heck was going on with their beloved Macs. Here are the most notable Web sites for learning the finer points of Mac OS X.

D.1.1. Mac OS X

  • www.macosxhints.com. A gold mine of tips, tricks, and hints.

  • www.macintouch.com. An excellent daily dose of reporting about Mac questions, problems, and news.

  • www.osxfaq.com. Unix tips and techniques, frequently asked questions, and links to useful sites.

  • www.resexcellence.com. A rich source of information on the underpinnings of Mac OS X, with a focus on changing them.

  • www.versiontracker.com and www.macupdate.com. Massive databases that track, and provide links to, all the latest software for Mac OS X.

  • www.apple.com/developer. Even if you aren't a developer, joining the Developer Connection (Apple's programmers' club) gets you an email newsletter and access to the discussion boards, which are a great place for hearing Mac news first—all for free. (Pay $500 a year to become a Select member, and you get CDs mailed to you containing upcoming versions of Mac OS X.)

  • www.macobserver.com. A good source for news and commentary about the Mac and related products.

  • www.macworld.com. The discussion boards are an ideal place to find solutions for problems. When a bug pops up, the posts here are a great place to look for fixes.

  • www.macfixit.com. The ultimate Mac troubleshooting Web site, complete with a hotbed of Mac OS X discussion.

  • www.macdevcenter.com. O'Reilly's own Mac site. Full of tutorials, news, and interesting weblogs (techie diaries).

  • www.geekculture.com. A hilarious satire site, dedicated to lampooning our tech addiction—especially Apple tech. Perhaps best known for the David Pogue's Head icon for Mac OS X (http://geekculture.com/download/davidpogue.html).

    Or perhaps not.

D.1.2. Mac OS X–Style Unix Lessons and Reference

  • www.westwind.com/reference/OS-X/commandline. A command reference of cd, ls, rm, and all the other commands you can use in Terminal or the console.

  • www.ee.surrey.ac.uk/Teaching/Unix. A convenient, free Web-based course in Unix for beginners.

Tip: Typing unix for beginners into a search page like Google.com nets dozens of superb help, tutorial, and reference Web sites. If possible, stick to those that feature the bash shell; that way, everything you learn online should be perfectly applicable to navigating Mac OS X via Terminal.


free_email_newsletters.html

D.2. Free Email Newsletters

  • The OS X list. Once you've signed up (at www.themacintoshguy.com/lists/index.html), your email In box will overflow with Mac OS X discussion, chatter, and discoveries. A great place to ask questions, both simple and difficult.

  • TidBITS.com. A free, weekly Mac newsletter with lots of useful tricks, reviews, and news.

  • Apple's own newsletters. At www.apple.com/enews/subscribe, you can sign up for free weekly newsletters on a variety of topics: music, QuickTime, programming, and so on.


advanced_books_programming_books.html

D.3. Advanced Books, Programming Books

By a happy coincidence, this book is published by O'Reilly Media, the industry's leading source of technical books for Mac users, programmers, and system administrators. If this book has whetted your appetite for more advanced topics, these current and upcoming books on Unix, programming Mac OS X, and administering large networks could come in handy.

D.3.1. Mac Essentials

  • AppleScript: The Missing Manual by Adam Goldstein. This book is a patient, witty guide to the basics of scripting your Mac with AppleScript. Step-by-step examples include batch-renaming files in the Finder, altering and applying text styles in TextEdit, tweaking QuickTime movie files, and much more.

  • AppleScript: The Definitive Guide by Matt Neuburg. Once you've got the basics down, this book takes you deeper into AppleScript, teaching you the finer details of the language from the ground up.

  • Mac OS X Leopard Pocket Guide by Chuck Toporek. Need a handy guide to Mac OS X Leopard that you can carry around in your laptop bag? This small book fits in your pocket just as easily as it does your computer bag, and includes hundreds of tips for using and configuring Mac OS X 10.5.

D.3.2. Unix Essentials

  • Learning Unix for Mac OS X Tiger by Dave Taylor. A tour of the Mac's Unix base, for the uninitiated. Includes descriptions of the hundreds of Unix programs that come with the Mac. (Plenty of this material is relevant, although the book has not been updated for Leopard.)

  • Learning the bash Shell, 3rd Edition, by Cameron Newham. If you plan on using the Terminal application to do Unixy stuff on your Mac, this book shows you your way around Leopard's default shell, bash.

  • Learning GNU Emacs, 3rd Edition, by Debra Cameron, James Elliott, Marc Loy, Eric S. Raymond, and Bill Rosenblatt. A guide to the GNU emacs editor, one of the most widely used and powerful Unix text editors.

  • Learning the vi and vim Editors, 7th Edition, by Linda Lamb, Elbert Hannah, and Arnold Robbins. A complete guide to editing with vi and vim, the text editors available on nearly every Unix system.

  • Unix Power Tools, 3rd Edition, by Shelley Powers, Jerry Peek, Tim O'Reilly, and Mike Loukides. Practical advice about most every aspect of advanced Unix: POSIX utilities, GNU versions, detailed bash, tcsh, and ksh shell coverage, and a strong emphasis on Perl.

D.3.3. Mac OS X Administration

  • Postfix: The Definitive Guide by Kyle D. Dent. If you're planning to run your own email server, this book shows you how to configure and run Mac OS X's built-in mail server, Postfix.

  • Apache: The Definitive Guide, 3rd Edition, by Ben Laurie and Peter Laurie. Describes how to set up and secure the Apache Web server software.

  • Apache Cookbook, 2nd Edition, by Ken Coar and Rich Bowen. A collection of configuration examples for all Apache users, from novices to advanced practitioners.


the_master_mac_os_x_secret_keystroke_list.html

E. The Master Mac OS X Secret Keystroke List

Here it is, by popular, frustrated demand: The master list of every secret (or not-so-secret) keystroke in Mac OS X Leopard, including all of the keys you can press during startup. Clip and post to your monitor (unless, of course, you got this book from the library).

Note: You can find another huge list of keystrokes in the discussion of VoiceOver, Leopard's screen-control feature, on Section 15.6.6. For the most part, the following list doesn't include the keystrokes that are already listed in your menus, either—like [image] -P for Print, [image] -S for Save, and so on.

Table E-1. Startup Keystrokes
Keys to Hold Down | Effect
C | Starts up from a CD
D | Starts up from the first partition
N | Starts up from network server
R | Resets the laptop screen
T | Puts the Mac into FireWire Target Disk mode
X | Starts up in Mac OS X (if 9 is on the same disk)
Option | Shows icons of all startup disks and partitions, so you can choose one for starting up.
Shift-Option- [image] -Delete | Starts up from external drive (or CD)
Option- [image] -P-R | Zaps the parameter RAM (PRAM). (Hold down until you hear the second chime.)
Option- [image] -O-F | Brings up Open Firmware screen (pre-Intel Macs).
-V | Shows Unix console messages during startup, logout, and shutdown
-S | Starts up in single-user (Unix command-line) mode
Mouse down | Ejects a stuck CD or DVD
Shift | Just after powering up: Turns off kernel extensions (Section B.5.1)
Shift | Just after logging in: Prevents Finder windows and startup items from opening. (They'll return the next time you start up.)

Table E-2. In the Finder
-Space | Highlights Spotlight box
Option- [image] -Space | Opens Spotlight window
rightwards double arrow , leftwards double arrow | Expands or collapses a selected folder in list view
Option- rightwards double arrow | Expands a folder in a list view and all folders inside it
Option- leftwards double arrow | Collapses folder and all folders inside it
- upwards arrow | Opens parent folder
Shift-Option- [image] - upwards arrow | Selects the Desktop
- downwards arrow (or [image] -O) | Opens the selected icon
Option-click the flippy triangle | Expands or collapses all folders within that window
Tab | Selects next icon alphabetically
Shift-Tab | Selects previous icon alphabetically
Space bar | Opens Quick Look preview of highlighted icon(s)
Space bar | (During a spring-loaded folder drag) Opens the disk or folder under mouse immediately
Option- [image] -drag | Scrolls a Finder window in any direction (list or icon view)
Option-click the Zoom button | Enlarges the window to full screen
Option-click Close button | Closes all Finder windows
-drag an icon | Moves it into, or out of, the System folder (administrator password required)
Option | Changes Quick Look button to Slideshow button
-drag | Rearranges or removes menu lets or toolbar icons
-click window title | Opens a pop-up menu showing the folder path
Option-click the Minimize button | Minimizes all windows (works in most programs)

Table E-3. Menu
Option | Changes "About This Mac" to "System Profiler"
Option | Eliminates confirmation box from Restart, Shut Down, and Log Out

Table E-4. Finder Menu
Option | Eliminates confirmation box from Empty Trash and Secure Empty Trash
Shift- [image] -Q | Logs out
Shift-Option- [image] -Q | Logs out without confirmation box
Shift- [image] -Delete | Empties the Trash
Shift-Option- [image] -Delete | Empties the Trash without confirmation box
Option-"Empty Trash" | Empties the Trash without confirmation box
-comma | Opens Preferences
-H | Hide This Program
Shift- [image] -H | Hide Other Programs

Table E-5. File Menu
-N | New Finder Window
Shift- [image] -N | New Folder
Option- [image] -N | New Smart Folder
-O or [image] - downwards arrow | Open
Control- [image] -O | Open in New Window
Option-click File menu | Changes "Open With" to "Always Open With"
-O | Close Window
Option- [image] -O | Close All
-I | Get Info
Option- [image] -I | Show Inspector
Control- [image] -I | Summary Info (of selected icons)
-D | Duplicate
-L | Make Alias
-Y | Quick Look
Option- [image] -Y | Slideshow (of selected icons)
-R | Show Original (of alias)
-T | Add to Sidebar
Shift- [image] -T | Add to Favorites
Shift-Delete | Move to Trash
-E | Eject
-F | Find
Shift- [image] -F | Find by Name

Table E-6. Edit Menu
-Z | Undo
-C, [image] -X, [image] -V | Cut, Copy, Paste
-A | Select All
Option- [image] -A | Deselect All

Table E-7. View Menu
-1, [image] -2, [image] -3, [image] -4 | Icon, List, Column, Cover Flow views
Option | Changes "Clean Up Selection" to "Clean Up"
Option | Changes "Keep Arranged By" to "Arrange By"
Option- [image] -T | Show/Hide Toolbar
-J | Show/Hide View Options palette

Table E-8. Go Menu
-[, [image] -] | Back, Forward
- upwards arrow | Enclosing folder
Control- [image] - upwards arrow | Enclosing folder in new window
Shift- [image] -C | Computer window
Shift- [image] -H | Home window
Shift- [image] -D | Desktop window
Shift- [image] -K | Network window
Shift- [image] -I | Open iDisk
Shift- [image] -A | Applications window
Shift- [image] -A | Go to Folder
-K | Connect to Server

Table E-9. Window Menu
-M | Minimize
Option- [image] -M | Minimize All
Option | Changes "Bring All to Front" to "Arrange in Front"

Table E-10. Help Menu
Shift- [image] -? Opens Help search box

Table E-11. Power Keys
Control- | Brings up dialog box for shutdown, sleep, or restart
Option- [image] - | Sleep
Control-Option- [image] - | Shut Down
Control- [image] -power | Restart

Table E-12. The Dock
Option-click a Dock icon | Switches to new program and hides previous one
Option- [image] -D | Hides/shows the Dock
-click a Dock or Stacks icon | Reveals its actual Finder icon
Option- [image] -click a Dock icon | Switches to this program and hides all others
Control-click a Dock icon | Opens a shortcut menu
-drag an icon onto a Dock icon | Prevents Dock icons from moving, so you can drop your icon onto one of them
-drag a Dock icon | Drags the actual item
Option- [image] -drag an icon onto the Dock | Forces Dock program icon to open the icon you're dropping

Table E-13. Managing Programs
Option-click a Dock icon | Switches to new program and hides previous one
Option-click in a window | Switches to new program and hides previous one
-H | Hide this program's windows (works in most apps)
Option- [image] -H | Hide all other programs' windows (most apps)
F8 | Spaces: Enters "big picture" view of your virtual screens (if you've turned on Spaces)
Shift-F8 | Spaces: Enters "big picture" view in slow motion
Control-1, 2, 3, 4… | Jump to a specific Spaces screen
Control- upwards arrow, downwards arrow, leftwards double arrow, rightwards double arrow | Next Spaces screen in this direction
F9 | Exposé: Shrinks and tiles all windows in all programs
Shift-F9 | Exposé: Shrinks and tiles all windows in slow motion
F10 | Exposé: Shrinks and tiles all windows in front most program
F11 | Exposé: Flings all windows in all programs to edges of screen, revealing desktop
F12 | Dashboard widgets
-Tab | Press and release: Switches back and forth between current and previous open program
-Tab | Hold down [image]: Displays floating icons of open programs. Press Tab repeatedly to cycle through them. (Add Shift to cycle backward through open programs on the Dock.)
-~ Switches to next open window in this program. (Add Shift to cycle in the opposite direction.)
Option- [image] -Esc | Opens the Force Quit dialog box (to close a stuck program)
Shift- [image] -3 | Captures the screen image as a PDF file on your desktop
Shift- [image] -4 | Produces a crosshair; drag to capture a selected portion of the screen as a PDF graphics file. (Press Space to get the "camera" cursor that snips out just a menu, icon, or window.)
-Space | Switches keyboard layout (if more than one is installed). (If you use Spotlight, you must choose a different keystroke for this function.)

Table E-14. Dialog Boxes
-comma | Opens Preferences dialog box (any Apple program)
Esc | "Clicks" the Cancel button in a dialog box
Enter | "Clicks" the OK button (or other blue, highlighted button) in a dialog box
Option- [image] -F | Moves insertion point to the Search box in most Apple programs
-D, [image] -R | "Clicks" the Don't Save or Replace button


colophon.html

Appendix. Colophon

This book was written on a black MacBook laptop that remained attached to David Pogue like an appendage. It was typed in Microsoft Word, with substantial assistance from the typing-shortcut program TypeIt4Me (www.typeit4me.com) and the macro program QuicKeys (www.quickeys.com).

The book's screen illustrations were captured with Ambrosia Software's Snapz Pro X (www.ambrosiasw.com), edited in Adobe Photoshop CS3 (www.adobe.com), and overlaid with labels, lines, and circles in Macromedia Freehand Mac OS X.

The author composed the index, entry by entry, using a highly tweaked FileMaker database and a clever Perl script that converted FileMaker's output into a fully formatted index.

The book was designed and laid out in Adobe InDesign CS3 on a PowerBook G4 and Power Mac G5. The fonts include Formata (as the sans-serif family) and Minion (as the serif body face). To provide the symbols ( [image], [image], [image] , and so on), Phil Simpson designed two custom fonts using Macromedia Fontographer.

The book was then exported as Adobe Acrobat PDF files for final transmission to the printing plant in Michigan.


index.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]


SYMBOL.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

(Action) menu
(Back) button 2nd 3rd
(Forward delete) key
..back out (Unix command) 2nd
.Mac
Backup
email account
free iChat account 2nd
HomePage
iDisk 2nd 3rd 4th 5th
settings 2nd 3rd 4th
signing up
sync 2nd 3rd


A.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

a menu
Locations 2nd
AAC files
About This Program
Accessibility Options (Windows)
accounts 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th
.Mac username
advanced settings
alternate short names
creating 2nd 3rd
deleting 2nd
editing 2nd
fast user switching 2nd 3rd
FileVault 2nd 3rd 4th 5th 6th
groups
guest account 2nd
login items
name and short name 2nd
parental controls 2nd 3rd
password 2nd
password hint
picture
sharing files between 2nd 3rd 4th
your first one 2nd
Accounts settings
Active Desktop (Windows)
Activity Monitor 2nd 3rd 4th
force quitting
Add Hardware (Windows)
Add to iPhoto button
Quick Look 2nd
Add/Remove Programs (Windows)
Address Book 2nd 3rd 4th 5th 6th 7th 8th 9th 10th
Add To Address Book 2nd 3rd
adding photos
address groups 2nd 3rd 4th
backing up
creating contacts 2nd
data detectors
finding contacts 2nd
Importer script
importing addresses 2nd
printing 2nd
recovering addresses with Time Machine 2nd
syncing with other Macs 2nd 3rd
widget
administrator accounts 2nd
AIFF files
AIM network
AirPort (Wi-Fi) networks 2nd 3rd 4th 5th 6th 7th 8th
ad hoc (Mac-to-Mac)
AirPort Utility 2nd
base stations
commercial hot spots
connecting to hot spots 2nd
hot spot priority order
menulet 2nd
software base stations
types of
aliases 2nd 3rd 4th
broken
Unix
All Programs (Windows)
Alt key
Apache Web server 2nd 3rd 4th 5th 6th 7th
Appearance settings 2nd 3rd
gray (Graphite) color theme
Apple ID
AppleScript 2nd 3rd 4th 5th 6th 7th 8th 9th
and ColorSync
Application menu
Applications folder
Mac OS 9 folder
Archive and Install installation 2nd
audio files
Quick Look 2nd 3rd 4th 5th
Audio Midi Setup
auto-hiding 2nd
basics of 2nd
Downloads folder
dragging an open window to
dragging into folders
dragging onto
force opening documents
Keep in Dock command
moving to sides of screen 2nd
removing icons
setting up 2nd 3rd 4th
settings
shortcut menus 2nd 3rd 4th
showing hidden programs
shrinking and enlarging 2nd
switching programs
window management
Automatic Update (Windows)
Automator 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd 24th 25th 26th
actions
backup iPhoto sample project 2nd 3rd 4th
convert and rename images sample project 2nd 3rd 4th 5th
downloading more actions 2nd
editing workflows 2nd 3rd 4th
email to iTunes sample project 2nd 3rd 4th 5th 6th


B.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

Back button 2nd 3rd
Back to My Mac
port forwarding
screen sharing
backing up
.Mac Backup
Address Book
Target disk mode
Backspace
bash shell
battery
interpreting the gauge
menu-bar gauge
power options
bc (basic calculator)
BCC (blind carbon copy)
bedtime
BIOS (Windows)
Bluetooth 2nd 3rd 4th 5th 6th
Address Book
Bluetooth File Exchange
getting files 2nd
keyboards and mice
menulet
pairing with new gadgets 2nd
sending files 2nd
settings
sharing with Windows 2nd
BMP files
Bonjour 2nd
bookmarks
arranging and deleting 2nd
bookmarks bar
syncing bookmarks 2nd 3rd
Boolean searches
Boot Camp 2nd 3rd 4th 5th 6th 7th
Boot Camp Assistant
how to right-click
installing 2nd 3rd
opening Mac documents in Windows (or viceversa) 2nd
partitioning
switching back and forth
Windows vs. Mac keystrokes 2nd
Briefcase (Windows)
broadband connections 2nd 3rd 4th 5th
bundles
Burn folders 2nd 3rd 4th 5th 6th 7th
burning discs 2nd 3rd 4th 5th 6th
burn folders
burning music CDs 2nd
Business (Yellow Pages) widget


C.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

cable modems 2nd 3rd 4th 5th
cal (calendar)
Calculate All Sizes option
Calculator 2nd 3rd 4th
in Spotlight menu
unit conversions 2nd
widget
Windows
Camera and Scanner Wizard (Windows)
capturing the screen 2nd 3rd
Carbon programs 2nd
CC (carbon copy)
cd (change directory) 2nd
CDs & DVDs
CD-R 2nd 3rd
erasing
Front Row
ripping to your hard drive 2nd
settings
System Profiler 2nd
types of 2nd 3rd 4th 5th 6th
cellphones
Address Book
syncing with iSync 2nd 3rd
cellular modem cards
CGI scripts
Character Map (Windows)
Character Palette
chatting 2nd 3rd 4th 5th
Chess 2nd 3rd 4th
controlling by voice
chflags (change flags)
Chicken of the VNC
chmod (change mode)
clean install 2nd
Clean Up command 2nd 3rd 4th 5th
Clipboard
clipping files 2nd
clock (menu-bar) 2nd
Close button 2nd 3rd 4th
Cocoa programs
Cocoa vs. Carbon 2nd
discontiguous text selections
keyboard shortcuts for text editing 2nd
special features of 2nd 3rd 4th 5th
Color Picker dialog box
colors
as window backgrounds
fonts
gray Desktop theme
highlighting color
retouching photos 2nd
ColorSync 2nd 3rd 4th
and AppleScript
ColorSync Utility 2nd
printing
profiles
sample AppleScripts
column view 2nd 3rd 4th 5th 6th
keyboard shortcuts 2nd
manipulating columns 2nd
view options 2nd
command-line interface
comments
Computer window
Connect to Server 2nd 3rd 4th 5th
connecting from the road 2nd
FTP servers
port forwarding
Terminal
Console
Control Panel (Windows)
cookies
Copy and Paste 2nd 3rd 4th
icons 2nd 3rd 4th
Windows
Cover Flow view 2nd 3rd 4th
adjusting size of
paging through PDFs
cp (copy)
crashed programs
CrossOver
Ctrl key (Windows)
CUPS (Common Unix Printing System)
currency formats


D.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

Dashboard 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th
Address Book widget
aluminum keyboards 2nd 3rd 4th 5th
Business (Yellow Pages) widget
Calculator widget
catalog of Widgets 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th
changing the icon 2nd
Dictionary widget
downloading new widgets 2nd
Google widget
iCal widget
iTunes widget
make your own widgets 2nd 3rd 4th 5th
opening and closing 2nd
preferences
Stickies widget
Stocks widget 2nd
tips
Web Clips widget
Widgets widget
data
drag and drop
exchanging with other Macs 2nd 3rd 4th 5th 6th 7th 8th
exchanging with Windows PCs 2nd
data detectors 2nd
date & time
formats
menu-bar clock
military time
setting the clock
settings 2nd
time zone
date command
dead keys
Declaration of Independence
defined
keystroke triggers 2nd
mouse-button triggers
show all windows
show Desktop
windows of one program
Desktop 2nd 3rd
animated-desktop trick
auto-changing picture 2nd
choosing Desktop picture 2nd 3rd 4th
differences from Windows
System Preferences
Desktop & Screen Saver settings 2nd 3rd 4th 5th 6th 7th 8th 9th
Desktop folder 2nd
Desktop window
Developer Tools
Devices (in Sidebar)
dial-up modems 2nd 3rd 4th 5th
AirPort base stations
connecting and disconnecting
email survival tricks
menulet
pulse vs. dial
dialog boxes
keyboard control
Dictionary 2nd 3rd 4th
Apple terminology
front matter
grammar
Japanese
ways to look up a word
widget
Wikipedia
digital cameras
Image Capture 2nd 3rd 4th 5th 6th 7th
iPhoto
DigitalColor Meter 2nd
Directory
Directory Utility
Disk Defragmenter (Windows)
disk images 2nd 3rd 4th 5th
CD or DVD masters
encrypted
expanding and opening 2nd 3rd 4th 5th
types of
Disk Utility 2nd 3rd 4th 5th 6th 7th 8th 9th
creating disk images 2nd 3rd
disk repair 2nd
erasing disks
journaling 2nd
partitioning
Restore Function 2nd
disks 2nd 3rd 4th 5th 6th 7th
differences from Windows
hiding icons of
icons
inserting and ejecting 2nd
viewing disk space
Displays
menulet
Displays settings 2nd 3rd 4th 5th
DLL files (Windows)
Dock 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th
adding icons to
documents
Dock 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th
printing 2nd 3rd 4th 5th 6th 7th 8th 9th
reassigning en masse
reassigning to new programs 2nd 3rd 4th 5th 6th 7th 8th
recovering with Time Machine 2nd 3rd 4th 5th
relationship to parent programs 2nd 3rd 4th 5th
Save dialog box 2nd
Documents folder
Stacks
DOS prompt (Windows)
double-clicking
speed sensitivity
Downloads folder
iChat
drag and drop 2nd
dragging inactive windows
Drop Box
folder
permissions settings
DSL 2nd
DVD Player 2nd 3rd 4th 5th 6th 7th
alternate languages
bookmarks
chapter thumbnails
connecting to a TV
DVD regions
favorite clips
full-screen playback
keyboard shortcuts
parental controls
playing movies 2nd 3rd
subtitles 2nd
Dvorak keyboard


E.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

echo (confirm)
Eliza therapist
emacs
email see also Mail
.Mac
Exchange servers
Energy Saver settings 2nd 3rd 4th 5th
Esc key
Spotlight menu
ESPN widget
Ethernet networks 2nd 3rd
Excel documents
Quick Look 2nd 3rd 4th 5th
Exchange servers
exiting programs
Explorer (Windows)
Exposé & Spaces settings 2nd 3rd 4th 5th


F.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

F1
assigning functions
Fast User Switching 2nd 3rd 4th
how it works
Favorites
in Windows
faxing 2nd 3rd 4th
checking the log
receiving
sending 2nd 3rd
setting up 2nd
file attachments
opening 2nd 3rd 4th
sending
File Sharing 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd 24th
accessing Public folder
accessing shared files 2nd 3rd 4th 5th 6th 7th 8th 9th
accessing your Home folder
any-folder method
Bonjour
Connect to Server 2nd 3rd 4th 5th
disconnecting others
disconnecting yourself
setting permissions
setting up Public folder 2nd
sharing any folder 2nd 3rd 4th 5th 6th 7th
sharing permissions 2nd 3rd 4th 5th
sharing Windows folders
troubleshooting Windows connections
using FTP
using the Sidebar 2nd 3rd 4th 5th 6th
with Windows PCs 2nd 3rd 4th 5th 6th
workgroups
file-mode code
filename extensions 2nd
files see also backing up; documents; icons
aliases 2nd 3rd
locked 2nd
printing lists of
Trash 2nd 3rd 4th 5th
FileVault 2nd 3rd 4th 5th 6th
master password 2nd 3rd 4th
turning on 2nd 3rd 4th
find command 2nd
Finder see also column view; icon view; list view; Cover Flow view; Sidebar; windows
aliases 2nd 3rd
Cover Flow 2nd 3rd 4th
Dock 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th
Get Info 2nd 3rd 4th
Home folder 2nd 3rd 4th 5th 6th 7th 8th
icon/list/column view 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd
labels 2nd 3rd 4th
moving and copying icons 2nd 3rd 4th 5th 6th 7th 8th
Quick Look 2nd 3rd 4th 5th
selecting icons 2nd 3rd 4th 5th 6th
setting default view
toolbar 2nd 3rd 4th 5th 6th
Trash 2nd 3rd 4th 5th
turning off animations
windows 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th
finding
calendar events
email messages 2nd
in Address Book 2nd 3rd 4th
in PDF files
in TextEdit 2nd
Spotlight 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st
text on a Web page
Firewall 2nd 3rd 4th
stealth mode
FireWire
disk mode
networking
Firmware password
flags
Flash drives 2nd
Flight Tracker widget
flippy triangles
floppy disks
Fn key
Folder actions 2nd 3rd
library
logs 2nd
menulet
sample workflows 2nd
saving as a shortcut menus 2nd
saving as an application
Starting Points
time saving as an application
tour of 2nd 3rd 4th 5th 6th 7th
variables
Watch Me mode 2nd 3rd 4th
workflows
writing your own 2nd 3rd
Folder Options (Windows)
folder path notation
path bar
folder paths
folder proxy icon 2nd 3rd 4th
folders see also icons
aliases
Dock 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th
flippy triangles 2nd
Spotlight 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th
spring loaded 2nd 3rd
Trash 2nd 3rd 4th 5th
Font Book 2nd 3rd 4th 5th 6th 7th 8th 9th
eliminating duplicate fonts
examining and printing fonts
exporting fonts 2nd
font libraries
Font panel 2nd 3rd 4th
type color
type effects
typography
fonts 2nd 3rd 4th 5th 6th 7th 8th 9th
changing Desktop and menu fonts
Character Palette
choosing 2nd 3rd
collections and favorites
font folders 2nd
for Desktop icons
Keyboard Viewer 2nd
Quick Look 2nd 3rd
reference sheets
smoothing style 2nd
System Profiler 2nd
where they live
FontSync
force quitting 2nd 3rd 4th
Forward button 2nd
Front Row 2nd
keyboard shortcuts 2nd
frozen programs
fsck (file system check) 2nd 3rd
FTP
becoming a server
Connect to Server 2nd 3rd
Unix command
uploading and downloading 2nd 3rd 4th
full-screen mode
DVD Player
iChat
Quick Look 2nd


G.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

GarageBand 2nd
Get Info 2nd 3rd 4th 5th
comments
creation date
file name extension
files size
Inspector window 2nd
Languages
Open With
panels of 2nd 3rd
repairing permissions
Sharing & Permissions
Summary window
GIF files
GMail accounts
Go to Folder command
Google
troubleshooting help
widget
Google Talk
Grab 2nd
grammar checker 2nd 3rd
Grapher 2nd 3rd
graphics 2nd 3rd 4th
file formats
Quick Look 2nd 3rd
screenshots 2nd
graphics tablets
grep command 2nd
grid
icon alignment 2nd 3rd 4th 5th
icon spacing 2nd
group accounts 2nd
guest account 2nd
gz files 2nd
gzip command


H.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

hacking Mac OS X 2nd 3rd 4th 5th 6th 7th 8th
editing menulets
renaming the Trash
replacing graphics
TinkerTool 2nd
handwriting recognition
hard drives
Activity Monitor 2nd 3rd
Disk Utility 2nd
journaling 2nd
troubleshooting
Unix File System
headphones
help 2nd 3rd
books and Web sites 2nd 3rd 4th
by phone
keyboard shortcuts
online resources
search box
Unix 2nd 3rd
Hibernation (Windows)
Hide Others
Home folder 2nd 3rd 4th
contents of 2nd 3rd 4th 5th
moving to external drive
Public folder
home page
HomePage
HomeSync menulet
Hotmail accounts
HTML files
Quick Look 2nd 3rd


I.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

iCal 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th
alarms
calendars (categories) 2nd
day/week/month views 2nd
inviting attendees 2nd
making an appointment 2nd 3rd 4th 5th 6th
publishing calendars on the Web 2nd 3rd
rescheduling and editing events 2nd
subscribing to Web calendars
To Do lists
widget
iChat 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd 24th 25th
animated buddy icons
animated GIF icons
audio chats 2nd
auto-answer feature
automated conversation
Bluetooth headsets
Buddy List 2nd 3rd 4th 5th
chat invitations 2nd 3rd 4th
encrypted chats
full screen mode
get Buddy info
Google Talk network
iChat Theater 2nd 3rd 4th
iTunes remote control
Jabber network
menulet
photo or video backdrops 2nd 3rd 4th 5th
preferences
screen sharing 2nd 3rd 4th 5th
sending files (best feature ever!)
setting up accounts 2nd 3rd 4th 5th
special effects 2nd 3rd
status message 2nd
text chats 2nd 3rd 4th
text formatting
transcripts
video chats 2nd 3rd 4th 5th 6th 7th
icon view 2nd 3rd 4th 5th 6th 7th 8th 9th 10th
always open in
color or photo backgrounds
grid spacing 2nd
icon sizes
label font size
Show Item Info option
sorting and aligning 2nd 3rd 4th 5th
icons
Copy and Paste 2nd 3rd
Cover Flow 2nd 3rd 4th
designing your own
disks
dragging into spring loaded folders 2nd 3rd 4th 5th
editing 2nd
Get Info 2nd 3rd 4th
icon view 2nd 3rd
labels 2nd 3rd 4th
list view 2nd 3rd 4th 5th 6th 7th
locked 2nd
Quick Look 2nd
renaming
replacing
selecting
size in icon view
size in list view
sorting
Spotlight 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th
toolbar 2nd 3rd 4th 5th 6th
Trash 2nd 3rd 4th 5th
iDisk 2nd 3rd 4th 5th
capacity graph
Connect to Server 2nd
Public folder
iDVD
Image Capture 2nd 3rd 4th 5th 6th 7th 8th
as spy cam 2nd
automatic slideshow/Web pages
downloading across the Internet
downloading across the network 2nd
downloading some photos
IMAP accounts
iMovie
Front Row
importing and exporting 2nd
Ink 2nd
menulet
input menu
at login 2nd
installing Mac OS X 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th
Archive and Install
basic installation 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th
Erase and Install
front an iPod
individual programs
Migration Assistant
reinstalling
Set Up Assistant 2nd 3rd 4th
upgrade installation
instant messaging 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th
Intel Macs 2nd 3rd 4th
running Windows 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th
International settings 2nd 3rd 4th 5th
Internet Explorer
Internet Options (Windows)
Internet see also Firewall; FTP; Mail; Safari; Web pages; etc.
.Mac services 2nd 3rd 4th
AirPort (wifi connections) 2nd 3rd 4th 5th 6th
broadband connections 2nd
cellular wireless
dial-up connections 2nd
Ethernet connections 2nd 3rd 4th
free phone calls 2nd
iChat 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd
Internet sharing 2nd 3rd
location switching 2nd
Mac as bridge
Mail 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd 24th 25th 26th 27th 28th 29th 30th 31st 32nd 33rd 34th 35th 36th 37th 38th 39th 40th 41st 42nd 43rd 44th 45th
port forwarding
Safari 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th
System Preferences setup 2nd 3rd 4th
VPN 2nd 3rd
Web sharing 2nd 3rd
Internet setup 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th
Internet sharing 2nd 3rd 4th
IP addresses
Bonjour
Connect to Server
Image Capture
Internet connections
port forwarding
public vs. private
ssh
VPN
Web sharing
iPhoto
recovering photos with Time Machine
saving PDF into
iPod 2nd
copying from
to transfer files 2nd
IrDA
menulet
IRQs (Windows)
iSync 2nd 3rd 4th
iTunes 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th
audio CDs
copy protection
Front Row
graphic equalizer
iChat remote control
iPod and iPhone
iPod as hard drive 2nd
MP3 files
Music Store
playback 2nd 3rd
playing across the network
playlists 2nd 3rd
podcasts
radio
smart playlists
Sound Check
visuals (music screensaver) 2nd 3rd 4th
widget


J.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

Jabber network
Japanese dictionary
Java
journaling 2nd
JPEG files
junk mail 2nd 3rd 4th


K.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

Keep Aligned command 2nd 3rd
kernel extensions
kernel panic 2nd
key 2nd
Key Caps 2nd 3rd
keyboard
1
aluminum
custom keyboard shortcuts 2nd
dead keys
disabling modifier keys
Dvorak layout
F1
repeat rate
typing assistance 2nd
Keyboard & Mouse settings 2nd 3rd 4th 5th 6th
keyboard shortcuts
a menu
adding to Sidebar
Cocoa text editing 2nd
column view 2nd
Copy and Paste 2nd
Cover Flow 2nd
cycling through windows
dialog boxes
Dock
duplicating icons
Finder 2nd 3rd 4th
flippy triangles
folders
for important folders
Front Row
Go to Folder command
hiding programs
Home folder
keyboard layouts
making up your own 2nd
master Mac OS X list 2nd 3rd 4th
master Safari list
menu 2nd 3rd 4th
menus
Old Finder mode
opening programs 2nd 3rd 4th
programs
results menu 2nd 3rd 4th 5th
Safari
shutting down
Sleep mode
Spotlight 2nd
Spotlight menu 2nd
Spotlight window
starting up 2nd
switching programs
tabbed browsing
Unix
VoiceOver 2nd 3rd 4th 5th
window navigation
windows
zoom in/zoom out
Keyboard Viewer 2nd
Keychain 2nd 3rd 4th 5th
locking and unlocking 2nd
menulet
multiple keychains
viewing passwords
Keynote
Quick Look 2nd
kill (quit)
via ssh 2nd
ksh shell


L.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

labels 2nd 3rd 4th
identifying drafts
searching for
sorting by
Languages
DVD soundtracks 2nd
removing to save disk space
laptops
auto-dimming to save power
launchd
LDAP directories
Library folder 2nd
ligatures
links
list view 2nd 3rd 4th 5th 6th 7th
adjusting column widths
as default view
calculate all sizes
columns 2nd 3rd 4th 5th
comments
hiding and showing columns 2nd 3rd 4th 5th 6th
icon previews 2nd
icons size
rearranging columns
relative dates
setting as default 2nd
show icon preview
sorting
text size 2nd 3rd
view options 2nd 3rd 4th 5th
Locations 2nd
locked files 2nd 3rd
Trash 2nd
logging in 2nd 3rd
accounts 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th
automatic 2nd 3rd
hide/show Restart and Shut Down buttons
input menu
login window style 2nd
password hints
settings and preferences 2nd 3rd 4th 5th 6th
logging out 2nd 3rd
login items
choosing and removing
ls (list)


M.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

.Mac 2nd 3rd 4th 5th 6th
Mac OS Extended formatting
Mac OS X 10.5 (Leopard)
accounts 2nd 3rd 4th 5th 6th 7th 8th 9th 10th
Address Book 2nd 3rd 4th 5th 6th 7th 8th 9th 10th
Automator 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd
Boot Camp 2nd 3rd 4th 5th 6th 7th
Cover Flow 2nd
Dashboard 2nd 3rd 4th 5th 6th 7th 8th
desktop 2nd 3rd
Dock 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th
help 2nd 3rd
iChat 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th
installing programs 2nd 3rd 4th
Intel Macs
logging in
Mail 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd 24th 25th 26th 27th 28th 29th 30th 31st 32nd 33rd 34th 35th 36th 37th 38th 39th 40th 41st 42nd 43rd 44th 45th
master keyboard shortcuts list 2nd
menu bar 2nd
printing 2nd 3rd 4th
programs included with 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th
Quick Look
screen sharing 2nd 3rd 4th 5th 6th 7th
Software Update 2nd 3rd 4th
Spotlight 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th
Stacks 2nd
System Preferences 2nd 3rd 4th 5th 6th 7th 8th 9th
system requirements 2nd
Time Machine 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th
Trash 2nd 3rd 4th 5th
troubleshooting 2nd 3rd 4th 5th
Unix 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd 24th 25th 26th 27th 28th 29th 30th 31st 32nd 33rd 34th 35th 36th
Utilities folder 2nd
window views 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd
windows in 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th
Mac OS X Server
Directory program
Wake for Access
WebDAV
MacPaint files
Mail 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd 24th 25th 26th 27th 28th 29th 30th 31st 32nd 33rd 34th 35th 36th 37th 38th 39th 40th 41st 42nd 43rd 44th 45th 46th
Address Book 2nd 3rd 4th 5th 6th 7th 8th 9th
adjusting panes
archiving 2nd
attaching files from the Desktop
checking 2nd
composing 2nd 3rd 4th
deleting messages 2nd 3rd 4th
email answering machine
file attachments (opening) 2nd
file attachments (sending)
filing messages 2nd 3rd 4th
finding 2nd
flagging messages
folders
forwarding
Inbox
message rules 2nd
Notes 2nd
reading and processing 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th
redirecting
replying 2nd
rich text vs. plain text 2nd
RSS feeds 2nd
setup 2nd 3rd
signatures 2nd 3rd
sorting
stationery 2nd 3rd 4th
subject line
symbols
syncing settings with other Macs 2nd
threading
To Do List 2nd 3rd 4th 5th
troubleshooting
man (manual pages) 2nd
master password 2nd 3rd 4th
maximize button
Mbox files
rebuilding
mdfind
memory
virtual memory
menulet
menulets 2nd 3rd
AirPort 2nd
menus
Application menu
clock 2nd
controlling by voice
differences from Windows
F (Action) menu
menulets 2nd
shortcut menus
message rules 2nd 3rd 4th
metadata 2nd 3rd
in Spotlight searches 2nd 3rd 4th 5th 6th
in Unix
Microsoft Word
in TextEdit
Mighty Mouse 2nd
Migration Assistant 2nd
Minimize button 2nd 3rd
adjusting animation speed
minimizing windows 2nd
title bar
mirroring (monitors)
mkdir (make directory)
monitors
auto brightness
brightness and contrast
color inversion
magnifying
refresh rate
resolution 2nd 3rd 4th
Spaces 2nd 3rd 4th
mouse
assigning secondary buttons
Movies folder
Movies widget 2nd
MP3 files
multihoming 2nd 3rd
multiple monitors 2nd
multiple views of
multisession discs
Music folder
mv (move)
My Computer (Windows)
My Documents (Windows)
My Music (Windows)
My Network Places (Windows)
My Pictures (Windows)


N.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

Network Neighborhood (Windows)
Network settings 2nd 3rd 4th
Network Utility 2nd
networking 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th
AirPort 2nd 3rd
AirPort networks 2nd 3rd 4th
Bonjour
Ethernet
file sharing 2nd 3rd 4th 5th 6th
FireWire networks 2nd
Internet sharing 2nd 3rd
Locations
Network Utility 2nd
printer sharing
Recent Servers menu
screen sharing 2nd 3rd 4th 5th
setting up a network 2nd 3rd 4th 5th 6th
System Profiler 2nd
Web sharing
NFS servers
Notepad (Windows)
Notes
Mail 2nd
Numbers
Quick Look


O.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

ODBC administrator
Old Finder mode 2nd
button
open 2nd
Open at Login
Open File dialog box
Open Firmware password
Open With command 2nd 3rd 4th
Outlook


P.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

packages
opening and editing 2nd
Page Setup
Pages
Quick Look
Parental Controls 2nd 3rd 4th 5th
chat limits 2nd
dictionary (smut filter) 2nd
email limits 2nd
limiting applications 2nd 3rd 4th 5th
remote management
Simple Finder 2nd 3rd
time limits
Web-site filter
partitioning drives 2nd 3rd
Boot Camp 2nd
passwords
accounts
different types
Firmware (Open Firmware password)
forgotten
Keychain 2nd 3rd 4th 5th
login
master password 2nd 3rd 4th
Password Assistant
VoiceOver
path bar
PC card menulet
PDF files 2nd 3rd 4th
advantages of 2nd
creating
in Cover Flow
in Safari
opening
PDF Web receipts
Quick Look
People (White Pages) widget
permissions
changing with Unix commands 2nd 3rd 4th 5th 6th 7th 8th 9th
editing for a folder 2nd
in Get Info box 2nd
in System Preferences 2nd 3rd 4th
Read & Write
Read Only 2nd
Write Only (Drop Box) 2nd
Personal Web Server (Windows)
Phone
syncing To Do List
Photo Booth 2nd 3rd 4th 5th 6th
4-up photos
animated iChat icons
exporting photos and movies
movies
special effects
still photos
video backdrops
photos
for accounts
Front Row
Photo Booth 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th
Quick Look
Spotlight menu
Photoshop files
PICT files
Pictures folder
ping command
Places (in Sidebar)
playlists 2nd 3rd
PNG files
Podcast Capture
podcasts
Front Row
POP accounts
ports (Internet)
viewing open ports
Power Options (Windows)
power settings 2nd 3rd 4th 5th
PPP menulet
PPPoE
preferences see also System Preferences
Dashboard
iChat
New Finder Window default
redefining home window
Sidebar items
Spotlight menu
Terminal 2nd 3rd 4th
title-bar window minimizing 2nd
Preview 2nd 3rd 4th 5th 6th 7th 8th 9th 10th
alpha channels 2nd 3rd 4th
as graphics editor 2nd 3rd 4th 5th 6th 7th 8th
as PDF reader 2nd 3rd 4th
converting file formats
cropping graphics
cutting people out of backgrounds 2nd
PDF notes
PDF table of contents
scaling and resampling images
slideshow
thumbnails sidebar 2nd
toolbar
zoom in/zoom out
printer sharing 2nd 3rd
printing 2nd 3rd 4th 5th 6th 7th 8th 9th
Address Book 2nd
choosing default printer 2nd
ColorSync
Desktop printer icons
managing printouts 2nd
number of copies
Page Setup
paper orientation
paper type
pausing
Print command 2nd 3rd 4th 5th
printer drivers
printer list 2nd
printer sharing
printing options 2nd
saving as PDF 2nd
setting up a printer 2nd 3rd 4th
private browsing
PrntScrn key (Windows)
Program Files folder (Windows)
programs
Address Book 2nd 3rd 4th 5th 6th 7th 8th 9th
Cocoa
Dashboard 2nd 3rd 4th 5th 6th
Dock 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th
force quitting
hiding 2nd 3rd 4th
included with Mac OS X 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd 24th 25th 26th 27th 28th 29th 30th 31st 32nd 33rd 34th 35th 36th 37th 38th 39th 40th 41st 42nd 43rd 44th 45th 46th 47th 48th 49th 50th 51st 52nd 53rd 54th
installing 2nd 3rd
Mail 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd 24th 25th 26th 27th 28th 29th 30th 31st 32nd 33rd 34th 35th 36th 37th 38th 39th 40th 41st 42nd 43rd
opening 2nd
packages
printing 2nd
quitting from Dock
reassigning documents to
Spaces 2nd 3rd 4th
System Profiler 2nd
uninstalling
Unix 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd 24th 25th 26th 27th 28th 29th
Properties dialog box (Windows)
Property List Editor
ps (process status)
Public folder 2nd
iDisk
pwd (print working directory)


Q.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

Quartz graphics engine 2nd 3rd 4th
Quick Look 2nd 3rd 4th
Full Screen mode 2nd
slideshow 2nd
tips and tricks 2nd
zoom in/zoom out
QuickTime movies 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th
editing
playing 2nd 3rd
playing backward
settings 2nd 3rd
streaming movies
QuickTime Player 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th
editing and exporting movies 2nd 3rd 4th 5th 6th 7th
pro version 2nd 3rd 4th 5th 6th
sounds
special effects 2nd
streaming from Web
versus pro version
QuickTime VR
quitting programs


R.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

radio
RAID arrays
RAID Utility
raw queries
Recent Items menu
Recycle Bin (Windows)
Registry (Windows)
remote access 2nd 3rd 4th 5th 6th 7th 8th 9th 10th
Connect to Server
port forwarding
VPN 2nd 3rd
with ssh 2nd 3rd 4th
remote control 2nd
Remote Desktop menulet
renaming icons 2nd 3rd
repairing permissions
Get Info box
Reply To address
Reset Password Utility
Resize handle
restarting
automatic
force restart
right-click button
right-clicking
using trackpad
when running Windows
with Mighty Mouse
rm (remove)
Rosetta
routers
port forwarding
RSS feeds 2nd 3rd 4th 5th
adding and bookmarking
as home page
as screensaver
Mail 2nd
personal clipping service
Run command (Windows)


S.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

Safari 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd
address bar 2nd
autofill
bookmarks
bookmarks bar
cookies
debug menu
designating home page
enlarging text forms
finding text
Google searches 2nd
history list
Internet Explorer simulator 2nd
PDF viewer
pop-up/pop-under windows
private browsing
RSS feeds
SnapBack
stop/reload
tabbed browsing 2nd 3rd
text size
tour of 2nd 3rd 4th 5th 6th 7th 8th
Web Clips 2nd 3rd
Safe Boot mode 2nd 3rd 4th
Safe Mode (Windows)
Save dialog box 2nd 3rd 4th 5th
format pop-up menu
ScanDisk (Windows)
scanning 2nd
Scheduled Tasks (Windows)
Scrap Files (Windows)
screen reader 2nd 3rd 4th 5th 6th 7th 8th
Screen Sharing 2nd 3rd 4th 5th 6th 7th 8th
iChat 2nd
preparing for
security considerations 2nd
taking control across the network 2nd 3rd 4th
toolbar 2nd
using Back to My Mac
using iChat
with older Macs 2nd
with Windows
screensaver
iTunes artwork
password protected 2nd 3rd
RSS feeds
timing and triggers
Word of the Day
your own photos 2nd 3rd 4th 5th
screenshots 2nd
Grab 2nd
Script menu 2nd 3rd 4th 5th 6th 7th
adding Automator scripts
Address Book import
AppleScript help
ColorSync
crazy email text
current temperature
date and time
Finder scripts
folder actions
Font Book
font sampler
FontSync scripts
iChat
Print Window
Script Editor scripts
stock quote
tour of 2nd 3rd 4th 5th 6th 7th
UI Element scripts
URL scripts
scroll bars 2nd
changing style of
jump to here
scrolling
laptop trackpads
Searches (in Sidebar)
security 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th
accounts 2nd 3rd 4th 5th
application warnings
cookies
download warnings
FileVault 2nd 3rd 4th
Firewall 2nd 3rd 4th
Keychain 2nd 3rd 4th 5th
open ports
Password Assistant
Private Browsing 2nd
Secure Empty Trash
settings 2nd 3rd 4th
Spotlight settings
Select New Original command
selecting
icons 2nd 3rd 4th 5th
Services menu 2nd 3rd 4th 5th 6th
Chinese Text Converter
Disk Utility
Finder
Font Book
Grab
Import Image
Lookup in Dictionary
Mail
Make New Sticky Note
Open URL
Script Editor
Search with Google
Send File to Bluetooth Device
Speech
Spotlight
Text Edit
Setup Assistant 2nd 3rd
Shared (in Sidebar)
Shared folder
Sharing Only accounts
shortcut menus 2nd
dock 2nd 3rd 4th 5th 6th
folder hierarchy
Show Original command
shutdown
shutting down 2nd
scheduled
Sidebar 2nd 3rd 4th 5th
add to Sidebar command
adjusting width
hiding or showing
hiding/showing elements of
installing new icons
Old Finder mode
rearranging icons
removing icons
tips and tricks
signatures 2nd 3rd
Silicon Graphics files
Simple Finder 2nd 3rd 4th
single-user mode
.sit files 2nd
Sites folder
Ski Report widget
Sleep mode
settings
slideshows
Image Capture
Preview
Slow Keys 2nd
smart folders 2nd
smart playlists 2nd 3rd
SMS text messages
Software Update 2nd 3rd 4th
storing for later
sorting
Address Book
Buddy List 2nd
by icon label
icons 2nd
Mail
System Preferences 2nd 3rd 4th
Sound settings 2nd 3rd 4th
sounds 2nd 3rd 4th
adding
Desktop sounds
error beeps 2nd 3rd 4th
Front Row
GarageBand
QuickTime Player
recording your own 2nd 3rd 4th
Sound settings 2nd 3rd 4th
sounds folders
speakers or headphones
Spaces 2nd 3rd 4th 5th 6th
adding or deleting screens
big-picture view
keyboard triggers 2nd
menu-bar triggers
moving windows among
switching screens
turning on
using Exposé with
spam (junk mail) 2nd 3rd 4th
sparse images
speaker volume 2nd 3rd 4th 5th
menulet
speakers (external)
Speech 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th
choosing a Mac voice
customizing speech recognition 2nd
feedback window
in Stickies
list of commands
Mac reads any text
menu control
settings 2nd 3rd
speech recognition 2nd 3rd 4th 5th 6th 7th 8th
text to speech 2nd 3rd 4th
things the Mac can say 2nd
spelling checker 2nd 3rd 4th
Spotlight 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd 24th 25th
advanced searches 2nd 3rd 4th 5th
basics of
compound searches 2nd 3rd
customizing 2nd
customizing keystrokes
dictionary definitions
file types recognized
finding by date
finding by metadata 2nd
finding by name
index file
limiting with quote marks
math calculations
mdfind
omitting categories
plugins
privacy settings
restricting search scope 2nd
saved searches
search by name
smart folders
Spotlight menu 2nd 3rd 4th
Spotlight window 2nd 3rd 4th 5th 6th 7th
Time Machine
working with results 2nd 3rd 4th
spring-loaded folders 2nd 3rd 4th 5th
srm (secure remove) 2nd
ssh (secure shell) 2nd 3rd 4th
Stacks 2nd 3rd 4th
creating and removing 2nd
Dock 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th
fan versus grid
favorite System Preferences
turning off
Standard accounts 2nd
Standby mode (Windows)
Start Menu (Windows)
starting up
console
startup disks 2nd
switching with Automator 2nd
StartUp folder (Windows)
startup items
stationery (Mail) 2nd 3rd 4th
status bar 2nd 3rd
Stickies 2nd 3rd 4th 5th
creating new notes 2nd
enlarging and shrinking notes 2nd
formatting notes
saving and exporting notes
widget
writing direction
Sticky Keys 2nd
Stocks
widget
Subject line
sudo (superuser do) 2nd
Summarize menu
symbols 2nd 3rd
sync (.Mac)
synchronization
among Macs 2nd 3rd
bookmarks
calendars and contacts
cellphones and Palms
iDisk 2nd
keychains
Mail settings
System folder
System Preferences 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd
.Mac 2nd 3rd
.Mac settings 2nd
Appearance 2nd
Bluetooth 2nd 3rd 4th 5th 6th 7th 8th 9th
CDs & DVDs
Date & Time
Displays 2nd 3rd
Dock 2nd 3rd 4th
Energy Saver 2nd 3rd 4th
favorites in the Dock
installing new panes
International 2nd
Parental Controls
Print & Fax 2nd 3rd 4th 5th 6th 7th 8th
QuickTime 2nd 3rd 4th
security 2nd 3rd 4th 5th 6th
Software Update 2nd
Sound 2nd 3rd 4th
sounds 2nd 3rd
Speech 2nd 3rd 4th 5th 6th 7th 8th
Spotlight
Startup Disk
Startup Disk settings 2nd
System Profiler 2nd
Time Machine 2nd
Universal Access 2nd
System Profiler 2nd 3rd 4th
your disc burner type 2nd 3rd 4th 5th 6th 7th
System Tray (Windows)


T.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

tar command
.tar files 2nd
Targ files
Target disk mode 2nd
Taskbar (Windows)
tcsh shell
.term files
Terminal 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd 24th 25th 26th 27th 28th 29th 30th 31st 32nd 33rd 34th 35th 36th 37th
Connect to Server
permissions 2nd 3rd 4th 5th 6th 7th 8th
preferences 2nd 3rd 4th 5th
stringing commands together 2nd 3rd
tips and tricks 2nd
window groups
text
auto complete
discontiguous text selection
ligatures
TextEdit 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th
text messages
TextEdit 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th
advanced typography
as Web design program 2nd
auto hyperlinks
autosave
embedded files
find and replace 2nd
formatting 2nd
hyphenation
Microsoft Word documents
page numbering
preferences
smart copy/paste
style sheets 2nd
tables
Thesaurus 2nd 3rd
thumb drives 2nd
TIFF files
Time Machine 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th
Aperture problems
back up drive full
deleting a file from all backups
disk requirements
full hard drive recovery 2nd
how it works 2nd 3rd 4th
networked drives
omitting files from backups
recovering lost or changed files
same Mac
setting up 2nd
settings
TinkerTool 2nd 3rd 4th
title bar 2nd 3rd 4th
basics of 2nd
Cocoa tricks
folder hierarchy 2nd
minimizing windows
To Do Lists
completing and deleting tasks
creating tasks
iCal
jumping to related email message
Mail 2nd 3rd
shared with iCal
syncing with iPod/iPhone
toolbars
adding your own icons 2nd
buttons explained
Finder windows 2nd 3rd 4th 5th
Old Finder mode
Preview
rearranging icons
removing icons
removing or shrinking
screen sharing
shrinking and enlarging
tooltips
top (table of processes) 2nd
touch (create file)
traceroute command
trackpad
clicking on trackpad
drag lock
dragging on trackpad
right-clicking on trackpad
settings
two-finger scrolling
Trash 2nd 3rd 4th 5th
defined
emptying
opening files directly from
rescuing files from
Secure Empty Trash
troubleshooting 2nd 3rd 4th 5th 6th 7th 8th 9th 10th
' eject key
application won't open
blue screen at startup
can't move or rename an icon
console
Disk Utility 2nd
Dock micro-icons
getting help
gray screen at startup
hard drive problems 2nd 3rd 4th
help by phone
kernel panic
minor eccentric behavior 2nd 3rd
preference files
reinstalling a program
repair permissions
restarting
screen sharing
submit to Apple box
Time Machine
Windows networking
TV shows
Front Row
TweakUI (Windows)
Type and Creator codes


U.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

U.S. Constitution
Unit Converter widget
Universal Access 2nd 3rd 4th
screen flashing
VoiceOver 2nd 3rd 4th 5th 6th 7th 8th 9th
Universal Binaries 2nd 3rd 4th
Unix
.. (back out) 2nd
aliases
cal
command prompt
console
crash course 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th
emacs
flags
help 2nd 3rd
hiding files
history
history of
launchd
mdfind
metadata
mkdir (make directory)
open 2nd
permissions 2nd 3rd 4th 5th 6th 7th 8th
shells
shortcuts 2nd
shutdown
tab completion
Terminal 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd 23rd 24th 25th 26th 27th 28th
uptime
wildcards
X11
~ (home directory)
Unix File System
Up To Date program
uptime
USB flash drives 2nd
Users folder
Utilities folder 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th


V.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

vCards
videoconferencing 2nd
View Options
column view
icon view
list view 2nd
virtual memory 2nd
encrypted
VirtualBox
virtualization software 2nd 3rd 4th
full-screen mode
viruses
gloating about
VoiceOver 2nd 3rd 4th 5th 6th 7th 8th 9th
basic commands
keyboard shortcuts 2nd
preferences
VPN 2nd 3rd
connecting
setting up


W.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

WAV files
Weather widget
Web clips 2nd 3rd 4th 5th
widget
Web pages 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th 18th 19th 20th 21st 22nd
about Mac OS X 2nd 3rd 4th
CGI scripts
HomePage
PDF files in
saving to disk
sending to a friend
specifying preferred browser
Web sharing 2nd 3rd 4th 5th 6th 7th
what's new
auto-answer iChat
Help search box
iChat 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th
iChat Theater 2nd
icon grid
icon view in Save dialog box
Keep Arranged By
Notes 2nd
screen sharing 2nd
Sidebar updated
Spaces 2nd 3rd 4th
Spotlight 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th
Stacks 2nd
Time Machine 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th
title bar shortcut menu
To Do List 2nd
whois command
Wikipedia
Windows (Microsoft Windows)
Boot Camp 2nd 3rd 4th 5th 6th
exporting address book
file formats 2nd
installing in Boot Camp 2nd
networking with Macs 2nd 3rd
running on Intel Macs 2nd 3rd 4th 5th 6th
switching to Mac 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th
virtualization (Parallels
Windows logo key (w)
Windows Media Player
windows see also column view; icon view; list view; Cover Flow view
close button 2nd 3rd
column view 2nd 3rd
Cover Flow 2nd
dragging from title bar 2nd
elements of 2nd 3rd 4th 5th 6th 7th 8th 9th 10th 11th 12th 13th 14th 15th 16th 17th
folder proxy icon
Get Info 2nd
hiding programs 2nd 3rd
hiding/showing from Dock
list view 2nd 3rd
minimize button 2nd
minimizing
navigating in place 2nd 3rd 4th
Old Finder mode
printing
scroll bars
selecting from Dock
Sidebar 2nd 3rd 4th 5th
Spaces 2nd
status bar
title bar 2nd 3rd
toolbar 2nd 3rd 4th 5th
views 2nd 3rd 4th 5th 6th
workgroups
World Clock widget


X.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

X11
xattr (extended attributes) 2nd
Xcode Tools


Y.html

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

Yahoo accounts


Z.html

Previous Page

Index

[SYMBOL] [A] [B] [C] [D] [E] [F] [G] [H] [I] [J] [K] [L] [M] [N] [O] [P] [Q] [R] [S] [T] [U] [V] [W] [X] [Y] [Z]

.zip files
zoom button 2nd
zoom in/zoom out
Preview
using keyboard
zsh shell

Previous Page